/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(418957),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36405),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50633),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53154),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53318),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61064),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72843), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(80035), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(87559), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(97535),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(98026),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(98517),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98785),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98935),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(99426), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(99459),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(108397),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(109447), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(112496), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(126022),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(127373),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(128365),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(129357),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(130849), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(132341),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(133333),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(134325),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(135317),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(136309),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(137301),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(138293), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138998),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(139703),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(140408),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(141113), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(141818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(141869),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(251605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(263121),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(263411),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(264848),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(264968), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(265209),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(267107),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(268761),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(271540),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(272365),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(272803), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(273628),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(273758), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(274300), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(282077), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(283122),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(283606),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(284090),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(284520),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(284950),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(285380), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(285810),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(287608),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(288346),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(292442), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(308715), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(309331),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(312838),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(313086),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(313274),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(314251),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(315228),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(319856),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(323862),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(324182),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(324502), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(325359),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(325641),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(326019),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(326397),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(326747),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(327097),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(327800), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(328503),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(328907),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(329311),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(329715),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(330119),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(330934),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(331100),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(331199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(331215),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(336587),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(365732), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(368650), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(370970), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(371122), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(371796),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(371956),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(372270),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(372424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(372915),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(373215),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(373706),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(374197), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(374688),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(375814),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(376430),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(380152), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(380768),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(396375), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(396675),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(396689),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(396710), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(396735), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(397045),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(397216),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(397387),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(397558),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(397729), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(398858),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(399061),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(399264),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(399467), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(399670), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(399810),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(400350),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(402173),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(402428),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(402683),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(402829),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(403008),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(404658),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(405217),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(406309),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(407401),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(407555),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(407731),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(408005),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(408211),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(408610),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(408980),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(409097),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(410330),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(411110),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(411890),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(412096),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(412963),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(413333),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(413450),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(414683),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(415463),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(416243),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(416941),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(417397),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(418177),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36404),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11616),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15224),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21126),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24624),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30802),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31652),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35954), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36326), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36352), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36378),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13227 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13227,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13654 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13654,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15508 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15508,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15520 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15520,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15532 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15532,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2656 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2656,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 9965 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 9965,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 9977 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 9977,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 9989 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 9989,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15551 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15551,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15552 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15552,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15553 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15553,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15554 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15554,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10081 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10081,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10082 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10082,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10083 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10083,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10084 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10084,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13231 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13231,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13794 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13794,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3921 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3921,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13229 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13229,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11615),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5377 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5377,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5376 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5376,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5386 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5386,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5375 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5375,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5374 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5374,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6917 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6917,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 13952 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 13952,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13228 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13228,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3973 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3973,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3971 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3971,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3972 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3972,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13804 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13804,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13802 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13802,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13803 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13803,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13239 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13239,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13240 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13240,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13649 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13649,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15503 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15503,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15515 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15515,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15527 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15527,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8445), // Rule ID 2653 //
     /*   8392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8419 */     // MIs[1] pattern
     /*   8419 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8422 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8429 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8443 */     GIR_RootConstrainSelectedInstOperands,
     /*   8444 */     // GIR_Coverage, 2653,
     /*   8444 */     GIR_EraseRootFromParent_Done,
     /*   8445 */   // Label 219: @8445
     /*   8445 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8503), // Rule ID 9962 //
     /*   8450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8477 */     // MIs[1] pattern
     /*   8477 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8480 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8487 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 9962,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 220: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8561), // Rule ID 9974 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8535 */     // MIs[1] pattern
     /*   8535 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8538 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8545 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8559 */     GIR_RootConstrainSelectedInstOperands,
     /*   8560 */     // GIR_Coverage, 9974,
     /*   8560 */     GIR_EraseRootFromParent_Done,
     /*   8561 */   // Label 221: @8561
     /*   8561 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8619), // Rule ID 9986 //
     /*   8566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8593 */     // MIs[1] pattern
     /*   8593 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8596 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8603 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8617 */     GIR_RootConstrainSelectedInstOperands,
     /*   8618 */     // GIR_Coverage, 9986,
     /*   8618 */     GIR_EraseRootFromParent_Done,
     /*   8619 */   // Label 222: @8619
     /*   8619 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8782), // Rule ID 13924 //
     /*   8624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8666 */     // MIs[1] Operand 2
     /*   8666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8683 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8781 */     // GIR_Coverage, 13924,
     /*   8781 */     GIR_EraseRootFromParent_Done,
     /*   8782 */   // Label 223: @8782
     /*   8782 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8945), // Rule ID 13921 //
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8829 */     // MIs[1] Operand 2
     /*   8829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8846 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8944 */     // GIR_Coverage, 13921,
     /*   8944 */     GIR_EraseRootFromParent_Done,
     /*   8945 */   // Label 224: @8945
     /*   8945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9095), // Rule ID 13930 //
     /*   8950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8983 */     // MIs[1] Operand 2
     /*   8983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9000 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9094 */     // GIR_Coverage, 13930,
     /*   9094 */     GIR_EraseRootFromParent_Done,
     /*   9095 */   // Label 225: @9095
     /*   9095 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9245), // Rule ID 13933 //
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9133 */     // MIs[1] Operand 2
     /*   9133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9150 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9244 */     // GIR_Coverage, 13933,
     /*   9244 */     GIR_EraseRootFromParent_Done,
     /*   9245 */   // Label 226: @9245
     /*   9245 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9395), // Rule ID 13929 //
     /*   9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9283 */     // MIs[1] Operand 2
     /*   9283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9300 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9326 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9394 */     // GIR_Coverage, 13929,
     /*   9394 */     GIR_EraseRootFromParent_Done,
     /*   9395 */   // Label 227: @9395
     /*   9395 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9558), // Rule ID 5359 //
     /*   9400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     // MIs[1] Operand 2
     /*   9446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9459 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9557 */     // GIR_Coverage, 5359,
     /*   9557 */     GIR_EraseRootFromParent_Done,
     /*   9558 */   // Label 228: @9558
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9721), // Rule ID 5356 //
     /*   9563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9609 */     // MIs[1] Operand 2
     /*   9609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9622 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9648 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9655 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9720 */     // GIR_Coverage, 5356,
     /*   9720 */     GIR_EraseRootFromParent_Done,
     /*   9721 */   // Label 229: @9721
     /*   9721 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9871), // Rule ID 5383 //
     /*   9726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9763 */     // MIs[1] Operand 2
     /*   9763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9776 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9870 */     // GIR_Coverage, 5383,
     /*   9870 */     GIR_EraseRootFromParent_Done,
     /*   9871 */   // Label 230: @9871
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10021), // Rule ID 5389 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9913 */     // MIs[1] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9926 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10020 */     // GIR_Coverage, 5389,
     /*  10020 */     GIR_EraseRootFromParent_Done,
     /*  10021 */   // Label 231: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10171), // Rule ID 5382 //
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10063 */     // MIs[1] Operand 2
     /*  10063 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10076 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10170 */     // GIR_Coverage, 5382,
     /*  10170 */     GIR_EraseRootFromParent_Done,
     /*  10171 */   // Label 232: @10171
     /*  10171 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10204), // Rule ID 13232 //
     /*  10176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10191 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10202 */     GIR_RootConstrainSelectedInstOperands,
     /*  10203 */     // GIR_Coverage, 13232,
     /*  10203 */     GIR_EraseRootFromParent_Done,
     /*  10204 */   // Label 233: @10204
     /*  10204 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10240), // Rule ID 13795 //
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10224 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10238 */     GIR_RootConstrainSelectedInstOperands,
     /*  10239 */     // GIR_Coverage, 13795,
     /*  10239 */     GIR_EraseRootFromParent_Done,
     /*  10240 */   // Label 234: @10240
     /*  10240 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10273), // Rule ID 98 //
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10260 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10271 */     GIR_RootConstrainSelectedInstOperands,
     /*  10272 */     // GIR_Coverage, 98,
     /*  10272 */     GIR_EraseRootFromParent_Done,
     /*  10273 */   // Label 235: @10273
     /*  10273 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10309), // Rule ID 3922 //
     /*  10278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10293 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10307 */     GIR_RootConstrainSelectedInstOperands,
     /*  10308 */     // GIR_Coverage, 3922,
     /*  10308 */     GIR_EraseRootFromParent_Done,
     /*  10309 */   // Label 236: @10309
     /*  10309 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10342), // Rule ID 13230 //
     /*  10314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10329 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10340 */     GIR_RootConstrainSelectedInstOperands,
     /*  10341 */     // GIR_Coverage, 13230,
     /*  10341 */     GIR_EraseRootFromParent_Done,
     /*  10342 */   // Label 237: @10342
     /*  10342 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10405), // Rule ID 15543 //
     /*  10347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10381 */     // MIs[1] pred
     /*  10381 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10392 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10403 */     GIR_RootConstrainSelectedInstOperands,
     /*  10404 */     // GIR_Coverage, 15543,
     /*  10404 */     GIR_EraseRootFromParent_Done,
     /*  10405 */   // Label 238: @10405
     /*  10405 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10468), // Rule ID 15544 //
     /*  10410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10444 */     // MIs[1] pred
     /*  10444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10455 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10466 */     GIR_RootConstrainSelectedInstOperands,
     /*  10467 */     // GIR_Coverage, 15544,
     /*  10467 */     GIR_EraseRootFromParent_Done,
     /*  10468 */   // Label 239: @10468
     /*  10468 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10531), // Rule ID 15545 //
     /*  10473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10507 */     // MIs[1] pred
     /*  10507 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10518 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10529 */     GIR_RootConstrainSelectedInstOperands,
     /*  10530 */     // GIR_Coverage, 15545,
     /*  10530 */     GIR_EraseRootFromParent_Done,
     /*  10531 */   // Label 240: @10531
     /*  10531 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10594), // Rule ID 15546 //
     /*  10536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10551 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10554 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10570 */     // MIs[1] pred
     /*  10570 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10581 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10592 */     GIR_RootConstrainSelectedInstOperands,
     /*  10593 */     // GIR_Coverage, 15546,
     /*  10593 */     GIR_EraseRootFromParent_Done,
     /*  10594 */   // Label 241: @10594
     /*  10594 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10627), // Rule ID 96 //
     /*  10599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10614 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10625 */     GIR_RootConstrainSelectedInstOperands,
     /*  10626 */     // GIR_Coverage, 96,
     /*  10626 */     GIR_EraseRootFromParent_Done,
     /*  10627 */   // Label 242: @10627
     /*  10627 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10690), // Rule ID 10073 //
     /*  10632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10651 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10654 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10670 */     // MIs[1] pred
     /*  10670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10677 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10688 */     GIR_RootConstrainSelectedInstOperands,
     /*  10689 */     // GIR_Coverage, 10073,
     /*  10689 */     GIR_EraseRootFromParent_Done,
     /*  10690 */   // Label 243: @10690
     /*  10690 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10753), // Rule ID 10074 //
     /*  10695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10733 */     // MIs[1] pred
     /*  10733 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10740 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10751 */     GIR_RootConstrainSelectedInstOperands,
     /*  10752 */     // GIR_Coverage, 10074,
     /*  10752 */     GIR_EraseRootFromParent_Done,
     /*  10753 */   // Label 244: @10753
     /*  10753 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10816), // Rule ID 10075 //
     /*  10758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10796 */     // MIs[1] pred
     /*  10796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10803 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 10075,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 245: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10879), // Rule ID 10076 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10859 */     // MIs[1] pred
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 10076,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 246: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10935), // Rule ID 13338 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13338,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 247: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10991), // Rule ID 13350 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10978 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10989 */     GIR_RootConstrainSelectedInstOperands,
     /*  10990 */     // GIR_Coverage, 13350,
     /*  10990 */     GIR_EraseRootFromParent_Done,
     /*  10991 */   // Label 248: @10991
     /*  10991 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11058), // Rule ID 13556 //
     /*  10996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     // MIs[1] imm
     /*  11020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11032 */     // MIs[2] Operand 1
     /*  11032 */     // No operand predicates
     /*  11032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11042 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11056 */     GIR_RootConstrainSelectedInstOperands,
     /*  11057 */     // GIR_Coverage, 13556,
     /*  11057 */     GIR_EraseRootFromParent_Done,
     /*  11058 */   // Label 249: @11058
     /*  11058 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11125), // Rule ID 13559 //
     /*  11063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     // MIs[1] imm
     /*  11087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11099 */     // MIs[2] Operand 1
     /*  11099 */     // No operand predicates
     /*  11099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11109 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 13559,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 250: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11181), // Rule ID 997 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 997,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 251: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11237), // Rule ID 1058 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11224 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11235 */     GIR_RootConstrainSelectedInstOperands,
     /*  11236 */     // GIR_Coverage, 1058,
     /*  11236 */     GIR_EraseRootFromParent_Done,
     /*  11237 */   // Label 252: @11237
     /*  11237 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11304), // Rule ID 2121 //
     /*  11242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11270 */     // MIs[1] imm
     /*  11270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11288 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11302 */     GIR_RootConstrainSelectedInstOperands,
     /*  11303 */     // GIR_Coverage, 2121,
     /*  11303 */     GIR_EraseRootFromParent_Done,
     /*  11304 */   // Label 253: @11304
     /*  11304 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11371), // Rule ID 2130 //
     /*  11309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11337 */     // MIs[1] imm
     /*  11337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11349 */     // MIs[2] Operand 1
     /*  11349 */     // No operand predicates
     /*  11349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11355 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11369 */     GIR_RootConstrainSelectedInstOperands,
     /*  11370 */     // GIR_Coverage, 2130,
     /*  11370 */     GIR_EraseRootFromParent_Done,
     /*  11371 */   // Label 254: @11371
     /*  11371 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11419), // Rule ID 13337 //
     /*  11376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11406 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11417 */     GIR_RootConstrainSelectedInstOperands,
     /*  11418 */     // GIR_Coverage, 13337,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 255: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11467), // Rule ID 13349 //
     /*  11424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11454 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11465 */     GIR_RootConstrainSelectedInstOperands,
     /*  11466 */     // GIR_Coverage, 13349,
     /*  11466 */     GIR_EraseRootFromParent_Done,
     /*  11467 */   // Label 256: @11467
     /*  11467 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11515), // Rule ID 996 //
     /*  11472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11502 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11513 */     GIR_RootConstrainSelectedInstOperands,
     /*  11514 */     // GIR_Coverage, 996,
     /*  11514 */     GIR_EraseRootFromParent_Done,
     /*  11515 */   // Label 257: @11515
     /*  11515 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11563), // Rule ID 1057 //
     /*  11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 1057,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 258: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11587), // Rule ID 94 //
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11580 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11585 */     GIR_RootConstrainSelectedInstOperands,
     /*  11586 */     // GIR_Coverage, 94,
     /*  11586 */     GIR_Done,
     /*  11587 */   // Label 259: @11587
     /*  11587 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11614), // Rule ID 1607 //
     /*  11592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11612 */     GIR_RootConstrainSelectedInstOperands,
     /*  11613 */     // GIR_Coverage, 1607,
     /*  11613 */     GIR_Done,
     /*  11614 */   // Label 260: @11614
     /*  11614 */   GIM_Reject,
     /*  11615 */ // Label 195: @11615
     /*  11615 */ GIM_Reject,
     /*  11616 */ // Label 157: @11616
     /*  11616 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15223),
     /*  11621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11627 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11815), // Rule ID 6938 //
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11669 */     // MIs[2] Operand 2
     /*  11669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11688 */     // MIs[3] Rn
     /*  11688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11693 */     // MIs[3] Operand 2
     /*  11693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11728 */     // MIs[5] Rn
     /*  11728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11733 */     // MIs[5] Operand 2
     /*  11733 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11752 */     // MIs[6] Rn
     /*  11752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11757 */     // MIs[6] Operand 2
     /*  11757 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11770 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11814 */     // GIR_Coverage, 6938,
     /*  11814 */     GIR_EraseRootFromParent_Done,
     /*  11815 */   // Label 262: @11815
     /*  11815 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12003), // Rule ID 13963 //
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11857 */     // MIs[2] Operand 2
     /*  11857 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11876 */     // MIs[3] Rn
     /*  11876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11881 */     // MIs[3] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11916 */     // MIs[5] Rn
     /*  11916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11921 */     // MIs[5] Operand 2
     /*  11921 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11936 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[6] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[6] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11956 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11958 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12002 */     // GIR_Coverage, 13963,
     /*  12002 */     GIR_EraseRootFromParent_Done,
     /*  12003 */   // Label 263: @12003
     /*  12003 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12139), // Rule ID 5373 //
     /*  12008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12041 */     // MIs[1] Operand 2
     /*  12041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12076 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12081 */     // MIs[3] Operand 2
     /*  12081 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12092 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12094 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12138 */     // GIR_Coverage, 5373,
     /*  12138 */     GIR_EraseRootFromParent_Done,
     /*  12139 */   // Label 264: @12139
     /*  12139 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12275), // Rule ID 5372 //
     /*  12144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12177 */     // MIs[1] Operand 2
     /*  12177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12212 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12217 */     // MIs[3] Operand 2
     /*  12217 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12230 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12274 */     // GIR_Coverage, 5372,
     /*  12274 */     GIR_EraseRootFromParent_Done,
     /*  12275 */   // Label 265: @12275
     /*  12275 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12411), // Rule ID 5385 //
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12313 */     // MIs[1] Operand 2
     /*  12313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12348 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12353 */     // MIs[3] Operand 2
     /*  12353 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12366 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12410 */     // GIR_Coverage, 5385,
     /*  12410 */     GIR_EraseRootFromParent_Done,
     /*  12411 */   // Label 266: @12411
     /*  12411 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12547), // Rule ID 5371 //
     /*  12416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12449 */     // MIs[1] Operand 2
     /*  12449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     // MIs[3] Operand 2
     /*  12489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12502 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12546 */     // GIR_Coverage, 5371,
     /*  12546 */     GIR_EraseRootFromParent_Done,
     /*  12547 */   // Label 267: @12547
     /*  12547 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12683), // Rule ID 5370 //
     /*  12552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12585 */     // MIs[1] Operand 2
     /*  12585 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12620 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     // MIs[3] Operand 2
     /*  12625 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12638 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12682 */     // GIR_Coverage, 5370,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 268: @12683
     /*  12683 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12846), // Rule ID 13923 //
     /*  12688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     // MIs[1] Operand 2
     /*  12730 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12747 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12845 */     // GIR_Coverage, 13923,
     /*  12845 */     GIR_EraseRootFromParent_Done,
     /*  12846 */   // Label 269: @12846
     /*  12846 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13009), // Rule ID 13920 //
     /*  12851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12893 */     // MIs[1] Operand 2
     /*  12893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12910 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13008 */     // GIR_Coverage, 13920,
     /*  13008 */     GIR_EraseRootFromParent_Done,
     /*  13009 */   // Label 270: @13009
     /*  13009 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13159), // Rule ID 13928 //
     /*  13014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13047 */     // MIs[1] Operand 2
     /*  13047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13064 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 13928,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 271: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13309), // Rule ID 13932 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13308 */     // GIR_Coverage, 13932,
     /*  13308 */     GIR_EraseRootFromParent_Done,
     /*  13309 */   // Label 272: @13309
     /*  13309 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13459), // Rule ID 13927 //
     /*  13314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13347 */     // MIs[1] Operand 2
     /*  13347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13364 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13458 */     // GIR_Coverage, 13927,
     /*  13458 */     GIR_EraseRootFromParent_Done,
     /*  13459 */   // Label 273: @13459
     /*  13459 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13622), // Rule ID 5358 //
     /*  13464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13510 */     // MIs[1] Operand 2
     /*  13510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13523 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13523 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13526 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13530 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13549 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13556 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13621 */     // GIR_Coverage, 5358,
     /*  13621 */     GIR_EraseRootFromParent_Done,
     /*  13622 */   // Label 274: @13622
     /*  13622 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13785), // Rule ID 5355 //
     /*  13627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13673 */     // MIs[1] Operand 2
     /*  13673 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13686 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13712 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13784 */     // GIR_Coverage, 5355,
     /*  13784 */     GIR_EraseRootFromParent_Done,
     /*  13785 */   // Label 275: @13785
     /*  13785 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13935), // Rule ID 5381 //
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13827 */     // MIs[1] Operand 2
     /*  13827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13934 */     // GIR_Coverage, 5381,
     /*  13934 */     GIR_EraseRootFromParent_Done,
     /*  13935 */   // Label 276: @13935
     /*  13935 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14085), // Rule ID 5388 //
     /*  13940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13977 */     // MIs[1] Operand 2
     /*  13977 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13990 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14084 */     // GIR_Coverage, 5388,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 277: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14235), // Rule ID 5380 //
     /*  14090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14127 */     // MIs[1] Operand 2
     /*  14127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14140 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14234 */     // GIR_Coverage, 5380,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 278: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14304), // Rule ID 13372 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14287 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14302 */     GIR_RootConstrainSelectedInstOperands,
     /*  14303 */     // GIR_Coverage, 13372,
     /*  14303 */     GIR_EraseRootFromParent_Done,
     /*  14304 */   // Label 279: @14304
     /*  14304 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14373), // Rule ID 13384 //
     /*  14309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14356 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13384,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 280: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14429), // Rule ID 13334 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13334,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 281: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14485), // Rule ID 13346 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14472 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14483 */     GIR_RootConstrainSelectedInstOperands,
     /*  14484 */     // GIR_Coverage, 13346,
     /*  14484 */     GIR_EraseRootFromParent_Done,
     /*  14485 */   // Label 282: @14485
     /*  14485 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14552), // Rule ID 13576 //
     /*  14490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     // MIs[1] imm
     /*  14514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14526 */     // MIs[2] Operand 1
     /*  14526 */     // No operand predicates
     /*  14526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14536 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 13576,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 283: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14619), // Rule ID 13597 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     // MIs[1] imm
     /*  14581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14593 */     // MIs[2] Operand 1
     /*  14593 */     // No operand predicates
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14603 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14617 */     GIR_RootConstrainSelectedInstOperands,
     /*  14618 */     // GIR_Coverage, 13597,
     /*  14618 */     GIR_EraseRootFromParent_Done,
     /*  14619 */   // Label 284: @14619
     /*  14619 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14688), // Rule ID 1365 //
     /*  14624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14671 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 1365,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 285: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14757), // Rule ID 1488 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14740 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 1488,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 286: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14813), // Rule ID 993 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 993,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 287: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14869), // Rule ID 1054 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14837 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14840 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14856 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14867 */     GIR_RootConstrainSelectedInstOperands,
     /*  14868 */     // GIR_Coverage, 1054,
     /*  14868 */     GIR_EraseRootFromParent_Done,
     /*  14869 */   // Label 288: @14869
     /*  14869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14936), // Rule ID 2238 //
     /*  14874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14902 */     // MIs[1] imm
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14914 */     // MIs[2] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14920 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14934 */     GIR_RootConstrainSelectedInstOperands,
     /*  14935 */     // GIR_Coverage, 2238,
     /*  14935 */     GIR_EraseRootFromParent_Done,
     /*  14936 */   // Label 289: @14936
     /*  14936 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15003), // Rule ID 2297 //
     /*  14941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14969 */     // MIs[1] imm
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14981 */     // MIs[2] Operand 1
     /*  14981 */     // No operand predicates
     /*  14981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14987 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15001 */     GIR_RootConstrainSelectedInstOperands,
     /*  15002 */     // GIR_Coverage, 2297,
     /*  15002 */     GIR_EraseRootFromParent_Done,
     /*  15003 */   // Label 290: @15003
     /*  15003 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15051), // Rule ID 13333 //
     /*  15008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15038 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15049 */     GIR_RootConstrainSelectedInstOperands,
     /*  15050 */     // GIR_Coverage, 13333,
     /*  15050 */     GIR_EraseRootFromParent_Done,
     /*  15051 */   // Label 291: @15051
     /*  15051 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15099), // Rule ID 13345 //
     /*  15056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15086 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 13345,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 292: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15147), // Rule ID 992 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15134 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15145 */     GIR_RootConstrainSelectedInstOperands,
     /*  15146 */     // GIR_Coverage, 992,
     /*  15146 */     GIR_EraseRootFromParent_Done,
     /*  15147 */   // Label 293: @15147
     /*  15147 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15195), // Rule ID 1053 //
     /*  15152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15182 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15193 */     GIR_RootConstrainSelectedInstOperands,
     /*  15194 */     // GIR_Coverage, 1053,
     /*  15194 */     GIR_EraseRootFromParent_Done,
     /*  15195 */   // Label 294: @15195
     /*  15195 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15222), // Rule ID 1104 //
     /*  15200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15215 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 1104,
     /*  15221 */     GIR_Done,
     /*  15222 */   // Label 295: @15222
     /*  15222 */   GIM_Reject,
     /*  15223 */ // Label 261: @15223
     /*  15223 */ GIM_Reject,
     /*  15224 */ // Label 158: @15224
     /*  15224 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21125),
     /*  15229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15235 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15353), // Rule ID 13511 //
     /*  15240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15308 */     // MIs[4] Operand 1
     /*  15308 */     // No operand predicates
     /*  15308 */     // MIs[2] Operand 2
     /*  15308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15332 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15351 */     GIR_RootConstrainSelectedInstOperands,
     /*  15352 */     // GIR_Coverage, 13511,
     /*  15352 */     GIR_EraseRootFromParent_Done,
     /*  15353 */   // Label 297: @15353
     /*  15353 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15471), // Rule ID 13512 //
     /*  15358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15422 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15426 */     // MIs[4] Operand 1
     /*  15426 */     // No operand predicates
     /*  15426 */     // MIs[2] Operand 2
     /*  15426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15450 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15469 */     GIR_RootConstrainSelectedInstOperands,
     /*  15470 */     // GIR_Coverage, 13512,
     /*  15470 */     GIR_EraseRootFromParent_Done,
     /*  15471 */   // Label 298: @15471
     /*  15471 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15589), // Rule ID 13541 //
     /*  15476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15544 */     // MIs[4] Operand 1
     /*  15544 */     // No operand predicates
     /*  15544 */     // MIs[2] Operand 2
     /*  15544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15587 */     GIR_RootConstrainSelectedInstOperands,
     /*  15588 */     // GIR_Coverage, 13541,
     /*  15588 */     GIR_EraseRootFromParent_Done,
     /*  15589 */   // Label 299: @15589
     /*  15589 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15707), // Rule ID 13542 //
     /*  15594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15662 */     // MIs[4] Operand 1
     /*  15662 */     // No operand predicates
     /*  15662 */     // MIs[2] Operand 2
     /*  15662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15686 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13542,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 300: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15825), // Rule ID 2042 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15784 */     // MIs[4] Operand 1
     /*  15784 */     // No operand predicates
     /*  15784 */     // MIs[2] Operand 2
     /*  15784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15804 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15823 */     GIR_RootConstrainSelectedInstOperands,
     /*  15824 */     // GIR_Coverage, 2042,
     /*  15824 */     GIR_EraseRootFromParent_Done,
     /*  15825 */   // Label 301: @15825
     /*  15825 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15943), // Rule ID 13510 //
     /*  15830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15902 */     // MIs[4] Operand 1
     /*  15902 */     // No operand predicates
     /*  15902 */     // MIs[2] Operand 2
     /*  15902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15941 */     GIR_RootConstrainSelectedInstOperands,
     /*  15942 */     // GIR_Coverage, 13510,
     /*  15942 */     GIR_EraseRootFromParent_Done,
     /*  15943 */   // Label 302: @15943
     /*  15943 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16061), // Rule ID 2094 //
     /*  15948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16016 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16020 */     // MIs[4] Operand 1
     /*  16020 */     // No operand predicates
     /*  16020 */     // MIs[2] Operand 2
     /*  16020 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16059 */     GIR_RootConstrainSelectedInstOperands,
     /*  16060 */     // GIR_Coverage, 2094,
     /*  16060 */     GIR_EraseRootFromParent_Done,
     /*  16061 */   // Label 303: @16061
     /*  16061 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16179), // Rule ID 13540 //
     /*  16066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16134 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16138 */     // MIs[4] Operand 1
     /*  16138 */     // No operand predicates
     /*  16138 */     // MIs[2] Operand 2
     /*  16138 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16149 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16158 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 13540,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 304: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16266), // Rule ID 13416 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16211 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16214 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16223 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16247 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 13416,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 305: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16353), // Rule ID 13440 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16298 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16301 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16351 */     GIR_RootConstrainSelectedInstOperands,
     /*  16352 */     // GIR_Coverage, 13440,
     /*  16352 */     GIR_EraseRootFromParent_Done,
     /*  16353 */   // Label 306: @16353
     /*  16353 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16440), // Rule ID 1699 //
     /*  16358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16389 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16392 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16401 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16421 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16438 */     GIR_RootConstrainSelectedInstOperands,
     /*  16439 */     // GIR_Coverage, 1699,
     /*  16439 */     GIR_EraseRootFromParent_Done,
     /*  16440 */   // Label 307: @16440
     /*  16440 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16527), // Rule ID 1777 //
     /*  16445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16508 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16525 */     GIR_RootConstrainSelectedInstOperands,
     /*  16526 */     // GIR_Coverage, 1777,
     /*  16526 */     GIR_EraseRootFromParent_Done,
     /*  16527 */   // Label 308: @16527
     /*  16527 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16642), // Rule ID 13506 //
     /*  16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16600 */     // MIs[4] Operand 1
     /*  16600 */     // No operand predicates
     /*  16600 */     // MIs[2] Operand 2
     /*  16600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16622 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16640 */     GIR_RootConstrainSelectedInstOperands,
     /*  16641 */     // GIR_Coverage, 13506,
     /*  16641 */     GIR_EraseRootFromParent_Done,
     /*  16642 */   // Label 309: @16642
     /*  16642 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16757), // Rule ID 13505 //
     /*  16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16716 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16720 */     // MIs[4] Operand 1
     /*  16720 */     // No operand predicates
     /*  16720 */     // MIs[2] Operand 2
     /*  16720 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16737 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16755 */     GIR_RootConstrainSelectedInstOperands,
     /*  16756 */     // GIR_Coverage, 13505,
     /*  16756 */     GIR_EraseRootFromParent_Done,
     /*  16757 */   // Label 310: @16757
     /*  16757 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16872), // Rule ID 13536 //
     /*  16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16826 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16830 */     // MIs[4] Operand 1
     /*  16830 */     // No operand predicates
     /*  16830 */     // MIs[2] Operand 2
     /*  16830 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16870 */     GIR_RootConstrainSelectedInstOperands,
     /*  16871 */     // GIR_Coverage, 13536,
     /*  16871 */     GIR_EraseRootFromParent_Done,
     /*  16872 */   // Label 311: @16872
     /*  16872 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16987), // Rule ID 13535 //
     /*  16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16950 */     // MIs[4] Operand 1
     /*  16950 */     // No operand predicates
     /*  16950 */     // MIs[2] Operand 2
     /*  16950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16965 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16967 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16985 */     GIR_RootConstrainSelectedInstOperands,
     /*  16986 */     // GIR_Coverage, 13535,
     /*  16986 */     GIR_EraseRootFromParent_Done,
     /*  16987 */   // Label 312: @16987
     /*  16987 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17056), // Rule ID 1801 //
     /*  16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17039 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17054 */     GIR_RootConstrainSelectedInstOperands,
     /*  17055 */     // GIR_Coverage, 1801,
     /*  17055 */     GIR_EraseRootFromParent_Done,
     /*  17056 */   // Label 313: @17056
     /*  17056 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17125), // Rule ID 1800 //
     /*  17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17108 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17123 */     GIR_RootConstrainSelectedInstOperands,
     /*  17124 */     // GIR_Coverage, 1800,
     /*  17124 */     GIR_EraseRootFromParent_Done,
     /*  17125 */   // Label 314: @17125
     /*  17125 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17194), // Rule ID 1717 //
     /*  17130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17177 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17192 */     GIR_RootConstrainSelectedInstOperands,
     /*  17193 */     // GIR_Coverage, 1717,
     /*  17193 */     GIR_EraseRootFromParent_Done,
     /*  17194 */   // Label 315: @17194
     /*  17194 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17263), // Rule ID 1799 //
     /*  17199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17246 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 1799,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 316: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17332), // Rule ID 1798 //
     /*  17268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17315 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17330 */     GIR_RootConstrainSelectedInstOperands,
     /*  17331 */     // GIR_Coverage, 1798,
     /*  17331 */     GIR_EraseRootFromParent_Done,
     /*  17332 */   // Label 317: @17332
     /*  17332 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17447), // Rule ID 13504 //
     /*  17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17409 */     // MIs[4] Operand 1
     /*  17409 */     // No operand predicates
     /*  17409 */     // MIs[2] Operand 2
     /*  17409 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17427 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17445 */     GIR_RootConstrainSelectedInstOperands,
     /*  17446 */     // GIR_Coverage, 13504,
     /*  17446 */     GIR_EraseRootFromParent_Done,
     /*  17447 */   // Label 318: @17447
     /*  17447 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17562), // Rule ID 2040 //
     /*  17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17525 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17529 */     // MIs[4] Operand 1
     /*  17529 */     // No operand predicates
     /*  17529 */     // MIs[2] Operand 2
     /*  17529 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17542 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17560 */     GIR_RootConstrainSelectedInstOperands,
     /*  17561 */     // GIR_Coverage, 2040,
     /*  17561 */     GIR_EraseRootFromParent_Done,
     /*  17562 */   // Label 319: @17562
     /*  17562 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17677), // Rule ID 13534 //
     /*  17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17639 */     // MIs[4] Operand 1
     /*  17639 */     // No operand predicates
     /*  17639 */     // MIs[2] Operand 2
     /*  17639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17657 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 13534,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 320: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17792), // Rule ID 2092 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17755 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17759 */     // MIs[4] Operand 1
     /*  17759 */     // No operand predicates
     /*  17759 */     // MIs[2] Operand 2
     /*  17759 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17772 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 2092,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 321: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17859), // Rule ID 13428 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17840 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17857 */     GIR_RootConstrainSelectedInstOperands,
     /*  17858 */     // GIR_Coverage, 13428,
     /*  17858 */     GIR_EraseRootFromParent_Done,
     /*  17859 */   // Label 322: @17859
     /*  17859 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17926), // Rule ID 13458 //
     /*  17864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17907 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17924 */     GIR_RootConstrainSelectedInstOperands,
     /*  17925 */     // GIR_Coverage, 13458,
     /*  17925 */     GIR_EraseRootFromParent_Done,
     /*  17926 */   // Label 323: @17926
     /*  17926 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17993), // Rule ID 1729 //
     /*  17931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17974 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17991 */     GIR_RootConstrainSelectedInstOperands,
     /*  17992 */     // GIR_Coverage, 1729,
     /*  17992 */     GIR_EraseRootFromParent_Done,
     /*  17993 */   // Label 324: @17993
     /*  17993 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18060), // Rule ID 1819 //
     /*  17998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18041 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 1819,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 325: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18141), // Rule ID 13414 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18124 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18139 */     GIR_RootConstrainSelectedInstOperands,
     /*  18140 */     // GIR_Coverage, 13414,
     /*  18140 */     GIR_EraseRootFromParent_Done,
     /*  18141 */   // Label 326: @18141
     /*  18141 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18222), // Rule ID 13438 //
     /*  18146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18173 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18176 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18205 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18220 */     GIR_RootConstrainSelectedInstOperands,
     /*  18221 */     // GIR_Coverage, 13438,
     /*  18221 */     GIR_EraseRootFromParent_Done,
     /*  18222 */   // Label 327: @18222
     /*  18222 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18303), // Rule ID 1697 //
     /*  18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18258 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18261 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18270 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18286 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 1697,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 328: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18384), // Rule ID 1775 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18339 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18342 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18351 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18367 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18382 */     GIR_RootConstrainSelectedInstOperands,
     /*  18383 */     // GIR_Coverage, 1775,
     /*  18383 */     GIR_EraseRootFromParent_Done,
     /*  18384 */   // Label 329: @18384
     /*  18384 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18476), // Rule ID 13509 //
     /*  18389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18445 */     // MIs[3] Operand 1
     /*  18445 */     // No operand predicates
     /*  18445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18456 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18474 */     GIR_RootConstrainSelectedInstOperands,
     /*  18475 */     // GIR_Coverage, 13509,
     /*  18475 */     GIR_EraseRootFromParent_Done,
     /*  18476 */   // Label 330: @18476
     /*  18476 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18568), // Rule ID 13508 //
     /*  18481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18542 */     // MIs[3] Operand 1
     /*  18542 */     // No operand predicates
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18548 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18566 */     GIR_RootConstrainSelectedInstOperands,
     /*  18567 */     // GIR_Coverage, 13508,
     /*  18567 */     GIR_EraseRootFromParent_Done,
     /*  18568 */   // Label 331: @18568
     /*  18568 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18660), // Rule ID 13539 //
     /*  18573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18629 */     // MIs[3] Operand 1
     /*  18629 */     // No operand predicates
     /*  18629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18640 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18658 */     GIR_RootConstrainSelectedInstOperands,
     /*  18659 */     // GIR_Coverage, 13539,
     /*  18659 */     GIR_EraseRootFromParent_Done,
     /*  18660 */   // Label 332: @18660
     /*  18660 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18752), // Rule ID 13538 //
     /*  18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18726 */     // MIs[3] Operand 1
     /*  18726 */     // No operand predicates
     /*  18726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18732 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18750 */     GIR_RootConstrainSelectedInstOperands,
     /*  18751 */     // GIR_Coverage, 13538,
     /*  18751 */     GIR_EraseRootFromParent_Done,
     /*  18752 */   // Label 333: @18752
     /*  18752 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18844), // Rule ID 13507 //
     /*  18757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18817 */     // MIs[3] Operand 1
     /*  18817 */     // No operand predicates
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18842 */     GIR_RootConstrainSelectedInstOperands,
     /*  18843 */     // GIR_Coverage, 13507,
     /*  18843 */     GIR_EraseRootFromParent_Done,
     /*  18844 */   // Label 334: @18844
     /*  18844 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18936), // Rule ID 2041 //
     /*  18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18914 */     // MIs[3] Operand 1
     /*  18914 */     // No operand predicates
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18916 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18934 */     GIR_RootConstrainSelectedInstOperands,
     /*  18935 */     // GIR_Coverage, 2041,
     /*  18935 */     GIR_EraseRootFromParent_Done,
     /*  18936 */   // Label 335: @18936
     /*  18936 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19028), // Rule ID 13537 //
     /*  18941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19001 */     // MIs[3] Operand 1
     /*  19001 */     // No operand predicates
     /*  19001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19026 */     GIR_RootConstrainSelectedInstOperands,
     /*  19027 */     // GIR_Coverage, 13537,
     /*  19027 */     GIR_EraseRootFromParent_Done,
     /*  19028 */   // Label 336: @19028
     /*  19028 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19120), // Rule ID 2093 //
     /*  19033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19098 */     // MIs[3] Operand 1
     /*  19098 */     // No operand predicates
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19118 */     GIR_RootConstrainSelectedInstOperands,
     /*  19119 */     // GIR_Coverage, 2093,
     /*  19119 */     GIR_EraseRootFromParent_Done,
     /*  19120 */   // Label 337: @19120
     /*  19120 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19171), // Rule ID 13452 //
     /*  19125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19157 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19169 */     GIR_RootConstrainSelectedInstOperands,
     /*  19170 */     // GIR_Coverage, 13452,
     /*  19170 */     GIR_EraseRootFromParent_Done,
     /*  19171 */   // Label 338: @19171
     /*  19171 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19222), // Rule ID 13422 //
     /*  19176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19208 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19220 */     GIR_RootConstrainSelectedInstOperands,
     /*  19221 */     // GIR_Coverage, 13422,
     /*  19221 */     GIR_EraseRootFromParent_Done,
     /*  19222 */   // Label 339: @19222
     /*  19222 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19273), // Rule ID 13451 //
     /*  19227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19271 */     GIR_RootConstrainSelectedInstOperands,
     /*  19272 */     // GIR_Coverage, 13451,
     /*  19272 */     GIR_EraseRootFromParent_Done,
     /*  19273 */   // Label 340: @19273
     /*  19273 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19324), // Rule ID 1813 //
     /*  19278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19310 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19322 */     GIR_RootConstrainSelectedInstOperands,
     /*  19323 */     // GIR_Coverage, 1813,
     /*  19323 */     GIR_EraseRootFromParent_Done,
     /*  19324 */   // Label 341: @19324
     /*  19324 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19375), // Rule ID 1723 //
     /*  19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19373 */     GIR_RootConstrainSelectedInstOperands,
     /*  19374 */     // GIR_Coverage, 1723,
     /*  19374 */     GIR_EraseRootFromParent_Done,
     /*  19375 */   // Label 342: @19375
     /*  19375 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19426), // Rule ID 1812 //
     /*  19380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19412 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 1812,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 343: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19482), // Rule ID 13340 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13340,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 344: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19538), // Rule ID 13352 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19525 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19536 */     GIR_RootConstrainSelectedInstOperands,
     /*  19537 */     // GIR_Coverage, 13352,
     /*  19537 */     GIR_EraseRootFromParent_Done,
     /*  19538 */   // Label 345: @19538
     /*  19538 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19605), // Rule ID 13580 //
     /*  19543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     // MIs[1] imm
     /*  19567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19579 */     // MIs[2] Operand 1
     /*  19579 */     // No operand predicates
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19589 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19603 */     GIR_RootConstrainSelectedInstOperands,
     /*  19604 */     // GIR_Coverage, 13580,
     /*  19604 */     GIR_EraseRootFromParent_Done,
     /*  19605 */   // Label 346: @19605
     /*  19605 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19672), // Rule ID 13601 //
     /*  19610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     // MIs[1] imm
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19646 */     // MIs[2] Operand 1
     /*  19646 */     // No operand predicates
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19656 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 13601,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 347: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19728), // Rule ID 999 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 999,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 348: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19784), // Rule ID 1060 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19782 */     GIR_RootConstrainSelectedInstOperands,
     /*  19783 */     // GIR_Coverage, 1060,
     /*  19783 */     GIR_EraseRootFromParent_Done,
     /*  19784 */   // Label 349: @19784
     /*  19784 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19851), // Rule ID 2242 //
     /*  19789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19817 */     // MIs[1] imm
     /*  19817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19829 */     // MIs[2] Operand 1
     /*  19829 */     // No operand predicates
     /*  19829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19835 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19849 */     GIR_RootConstrainSelectedInstOperands,
     /*  19850 */     // GIR_Coverage, 2242,
     /*  19850 */     GIR_EraseRootFromParent_Done,
     /*  19851 */   // Label 350: @19851
     /*  19851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19918), // Rule ID 2301 //
     /*  19856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19884 */     // MIs[1] imm
     /*  19884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19896 */     // MIs[2] Operand 1
     /*  19896 */     // No operand predicates
     /*  19896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19902 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19916 */     GIR_RootConstrainSelectedInstOperands,
     /*  19917 */     // GIR_Coverage, 2301,
     /*  19917 */     GIR_EraseRootFromParent_Done,
     /*  19918 */   // Label 351: @19918
     /*  19918 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19988), // Rule ID 6934 //
     /*  19923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19961 */     // MIs[2] Rn
     /*  19961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19966 */     // MIs[2] Rm
     /*  19966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19973 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19986 */     GIR_RootConstrainSelectedInstOperands,
     /*  19987 */     // GIR_Coverage, 6934,
     /*  19987 */     GIR_EraseRootFromParent_Done,
     /*  19988 */   // Label 352: @19988
     /*  19988 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20058), // Rule ID 13959 //
     /*  19993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20031 */     // MIs[2] Rn
     /*  20031 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20036 */     // MIs[2] Rm
     /*  20036 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20043 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20056 */     GIR_RootConstrainSelectedInstOperands,
     /*  20057 */     // GIR_Coverage, 13959,
     /*  20057 */     GIR_EraseRootFromParent_Done,
     /*  20058 */   // Label 353: @20058
     /*  20058 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20121), // Rule ID 1797 //
     /*  20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20106 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20119 */     GIR_RootConstrainSelectedInstOperands,
     /*  20120 */     // GIR_Coverage, 1797,
     /*  20120 */     GIR_EraseRootFromParent_Done,
     /*  20121 */   // Label 354: @20121
     /*  20121 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20184), // Rule ID 1796 //
     /*  20126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20169 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 1796,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 355: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20247), // Rule ID 1716 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20232 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20245 */     GIR_RootConstrainSelectedInstOperands,
     /*  20246 */     // GIR_Coverage, 1716,
     /*  20246 */     GIR_EraseRootFromParent_Done,
     /*  20247 */   // Label 356: @20247
     /*  20247 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20310), // Rule ID 1795 //
     /*  20252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20295 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20308 */     GIR_RootConstrainSelectedInstOperands,
     /*  20309 */     // GIR_Coverage, 1795,
     /*  20309 */     GIR_EraseRootFromParent_Done,
     /*  20310 */   // Label 357: @20310
     /*  20310 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20373), // Rule ID 1794 //
     /*  20315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20358 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20371 */     GIR_RootConstrainSelectedInstOperands,
     /*  20372 */     // GIR_Coverage, 1794,
     /*  20372 */     GIR_EraseRootFromParent_Done,
     /*  20373 */   // Label 358: @20373
     /*  20373 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20434), // Rule ID 13427 //
     /*  20378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20417 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 13427,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 359: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20495), // Rule ID 13457 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20478 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20493 */     GIR_RootConstrainSelectedInstOperands,
     /*  20494 */     // GIR_Coverage, 13457,
     /*  20494 */     GIR_EraseRootFromParent_Done,
     /*  20495 */   // Label 360: @20495
     /*  20495 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20543), // Rule ID 13450 //
     /*  20500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20530 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20541 */     GIR_RootConstrainSelectedInstOperands,
     /*  20542 */     // GIR_Coverage, 13450,
     /*  20542 */     GIR_EraseRootFromParent_Done,
     /*  20543 */   // Label 361: @20543
     /*  20543 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20591), // Rule ID 13339 //
     /*  20548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20578 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20589 */     GIR_RootConstrainSelectedInstOperands,
     /*  20590 */     // GIR_Coverage, 13339,
     /*  20590 */     GIR_EraseRootFromParent_Done,
     /*  20591 */   // Label 362: @20591
     /*  20591 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20639), // Rule ID 13421 //
     /*  20596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20626 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20637 */     GIR_RootConstrainSelectedInstOperands,
     /*  20638 */     // GIR_Coverage, 13421,
     /*  20638 */     GIR_EraseRootFromParent_Done,
     /*  20639 */   // Label 363: @20639
     /*  20639 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20687), // Rule ID 13351 //
     /*  20644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20674 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20685 */     GIR_RootConstrainSelectedInstOperands,
     /*  20686 */     // GIR_Coverage, 13351,
     /*  20686 */     GIR_EraseRootFromParent_Done,
     /*  20687 */   // Label 364: @20687
     /*  20687 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20735), // Rule ID 13449 //
     /*  20692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20722 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20733 */     GIR_RootConstrainSelectedInstOperands,
     /*  20734 */     // GIR_Coverage, 13449,
     /*  20734 */     GIR_EraseRootFromParent_Done,
     /*  20735 */   // Label 365: @20735
     /*  20735 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20796), // Rule ID 1728 //
     /*  20740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1728,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 366: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20857), // Rule ID 1818 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20840 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20855 */     GIR_RootConstrainSelectedInstOperands,
     /*  20856 */     // GIR_Coverage, 1818,
     /*  20856 */     GIR_EraseRootFromParent_Done,
     /*  20857 */   // Label 367: @20857
     /*  20857 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20905), // Rule ID 1811 //
     /*  20862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20892 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20903 */     GIR_RootConstrainSelectedInstOperands,
     /*  20904 */     // GIR_Coverage, 1811,
     /*  20904 */     GIR_EraseRootFromParent_Done,
     /*  20905 */   // Label 368: @20905
     /*  20905 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20953), // Rule ID 998 //
     /*  20910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20940 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 998,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 369: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21001), // Rule ID 1722 //
     /*  20958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20988 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1722,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 370: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21049), // Rule ID 1059 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21047 */     GIR_RootConstrainSelectedInstOperands,
     /*  21048 */     // GIR_Coverage, 1059,
     /*  21048 */     GIR_EraseRootFromParent_Done,
     /*  21049 */   // Label 371: @21049
     /*  21049 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21097), // Rule ID 1810 //
     /*  21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21095 */     GIR_RootConstrainSelectedInstOperands,
     /*  21096 */     // GIR_Coverage, 1810,
     /*  21096 */     GIR_EraseRootFromParent_Done,
     /*  21097 */   // Label 372: @21097
     /*  21097 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21124), // Rule ID 1106 //
     /*  21102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21117 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 1106,
     /*  21123 */     GIR_Done,
     /*  21124 */   // Label 373: @21124
     /*  21124 */   GIM_Reject,
     /*  21125 */ // Label 296: @21125
     /*  21125 */ GIM_Reject,
     /*  21126 */ // Label 159: @21126
     /*  21126 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24623),
     /*  21131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21137 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21273), // Rule ID 5369 //
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21175 */     // MIs[1] Operand 2
     /*  21175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21210 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21215 */     // MIs[3] Operand 2
     /*  21215 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21228 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21272 */     // GIR_Coverage, 5369,
     /*  21272 */     GIR_EraseRootFromParent_Done,
     /*  21273 */   // Label 375: @21273
     /*  21273 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21409), // Rule ID 5368 //
     /*  21278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21311 */     // MIs[1] Operand 2
     /*  21311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21346 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21351 */     // MIs[3] Operand 2
     /*  21351 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21362 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21364 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21408 */     // GIR_Coverage, 5368,
     /*  21408 */     GIR_EraseRootFromParent_Done,
     /*  21409 */   // Label 376: @21409
     /*  21409 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21545), // Rule ID 5384 //
     /*  21414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21447 */     // MIs[1] Operand 2
     /*  21447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[3] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21500 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21544 */     // GIR_Coverage, 5384,
     /*  21544 */     GIR_EraseRootFromParent_Done,
     /*  21545 */   // Label 377: @21545
     /*  21545 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21681), // Rule ID 5367 //
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21583 */     // MIs[1] Operand 2
     /*  21583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21618 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21623 */     // MIs[3] Operand 2
     /*  21623 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21636 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     // GIR_Coverage, 5367,
     /*  21680 */     GIR_EraseRootFromParent_Done,
     /*  21681 */   // Label 378: @21681
     /*  21681 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21817), // Rule ID 5366 //
     /*  21686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21719 */     // MIs[1] Operand 2
     /*  21719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21750 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21759 */     // MIs[3] Operand 2
     /*  21759 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21772 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21799 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21816 */     // GIR_Coverage, 5366,
     /*  21816 */     GIR_EraseRootFromParent_Done,
     /*  21817 */   // Label 379: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21950), // Rule ID 13964 //
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21867 */     // MIs[1] Operand 2
     /*  21867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21898 */     // MIs[5] Rn
     /*  21898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21903 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21905 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21949 */     // GIR_Coverage, 13964,
     /*  21949 */     GIR_EraseRootFromParent_Done,
     /*  21950 */   // Label 380: @21950
     /*  21950 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22083), // Rule ID 6939 //
     /*  21955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22012 */     // MIs[4] Rn
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22025 */     // MIs[3] Operand 2
     /*  22025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22036 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22038 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22082 */     // GIR_Coverage, 6939,
     /*  22082 */     GIR_EraseRootFromParent_Done,
     /*  22083 */   // Label 381: @22083
     /*  22083 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22246), // Rule ID 13922 //
     /*  22088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     // MIs[1] Operand 2
     /*  22130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22147 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22147 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22150 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22154 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22245 */     // GIR_Coverage, 13922,
     /*  22245 */     GIR_EraseRootFromParent_Done,
     /*  22246 */   // Label 382: @22246
     /*  22246 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22409), // Rule ID 13919 //
     /*  22251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22293 */     // MIs[1] Operand 2
     /*  22293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22310 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22408 */     // GIR_Coverage, 13919,
     /*  22408 */     GIR_EraseRootFromParent_Done,
     /*  22409 */   // Label 383: @22409
     /*  22409 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22559), // Rule ID 13926 //
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22447 */     // MIs[1] Operand 2
     /*  22447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22464 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22558 */     // GIR_Coverage, 13926,
     /*  22558 */     GIR_EraseRootFromParent_Done,
     /*  22559 */   // Label 384: @22559
     /*  22559 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22709), // Rule ID 13931 //
     /*  22564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22597 */     // MIs[1] Operand 2
     /*  22597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22614 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22691 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22708 */     // GIR_Coverage, 13931,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 385: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22859), // Rule ID 13925 //
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22747 */     // MIs[1] Operand 2
     /*  22747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22858 */     // GIR_Coverage, 13925,
     /*  22858 */     GIR_EraseRootFromParent_Done,
     /*  22859 */   // Label 386: @22859
     /*  22859 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23022), // Rule ID 5357 //
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22910 */     // MIs[1] Operand 2
     /*  22910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22923 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22923 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22926 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22930 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23021 */     // GIR_Coverage, 5357,
     /*  23021 */     GIR_EraseRootFromParent_Done,
     /*  23022 */   // Label 387: @23022
     /*  23022 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23185), // Rule ID 5354 //
     /*  23027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23073 */     // MIs[1] Operand 2
     /*  23073 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23086 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23112 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23184 */     // GIR_Coverage, 5354,
     /*  23184 */     GIR_EraseRootFromParent_Done,
     /*  23185 */   // Label 388: @23185
     /*  23185 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23335), // Rule ID 5379 //
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23227 */     // MIs[1] Operand 2
     /*  23227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23334 */     // GIR_Coverage, 5379,
     /*  23334 */     GIR_EraseRootFromParent_Done,
     /*  23335 */   // Label 389: @23335
     /*  23335 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23485), // Rule ID 5387 //
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23377 */     // MIs[1] Operand 2
     /*  23377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23390 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23416 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23484 */     // GIR_Coverage, 5387,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 390: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23635), // Rule ID 5378 //
     /*  23490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23527 */     // MIs[1] Operand 2
     /*  23527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23540 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23634 */     // GIR_Coverage, 5378,
     /*  23634 */     GIR_EraseRootFromParent_Done,
     /*  23635 */   // Label 391: @23635
     /*  23635 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23704), // Rule ID 13368 //
     /*  23640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23687 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23702 */     GIR_RootConstrainSelectedInstOperands,
     /*  23703 */     // GIR_Coverage, 13368,
     /*  23703 */     GIR_EraseRootFromParent_Done,
     /*  23704 */   // Label 392: @23704
     /*  23704 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23773), // Rule ID 13380 //
     /*  23709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23756 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13380,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 393: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23829), // Rule ID 13330 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13330,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 394: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23885), // Rule ID 13342 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23872 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23883 */     GIR_RootConstrainSelectedInstOperands,
     /*  23884 */     // GIR_Coverage, 13342,
     /*  23884 */     GIR_EraseRootFromParent_Done,
     /*  23885 */   // Label 395: @23885
     /*  23885 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23952), // Rule ID 13572 //
     /*  23890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     // MIs[1] imm
     /*  23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23926 */     // MIs[2] Operand 1
     /*  23926 */     // No operand predicates
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23936 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23950 */     GIR_RootConstrainSelectedInstOperands,
     /*  23951 */     // GIR_Coverage, 13572,
     /*  23951 */     GIR_EraseRootFromParent_Done,
     /*  23952 */   // Label 396: @23952
     /*  23952 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24019), // Rule ID 13593 //
     /*  23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     // MIs[1] imm
     /*  23981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23993 */     // MIs[2] Operand 1
     /*  23993 */     // No operand predicates
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24003 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24017 */     GIR_RootConstrainSelectedInstOperands,
     /*  24018 */     // GIR_Coverage, 13593,
     /*  24018 */     GIR_EraseRootFromParent_Done,
     /*  24019 */   // Label 397: @24019
     /*  24019 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24088), // Rule ID 1361 //
     /*  24024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24071 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24086 */     GIR_RootConstrainSelectedInstOperands,
     /*  24087 */     // GIR_Coverage, 1361,
     /*  24087 */     GIR_EraseRootFromParent_Done,
     /*  24088 */   // Label 398: @24088
     /*  24088 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24157), // Rule ID 1484 //
     /*  24093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24140 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 1484,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 399: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24213), // Rule ID 989 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 989,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 400: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24269), // Rule ID 1050 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24256 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24267 */     GIR_RootConstrainSelectedInstOperands,
     /*  24268 */     // GIR_Coverage, 1050,
     /*  24268 */     GIR_EraseRootFromParent_Done,
     /*  24269 */   // Label 401: @24269
     /*  24269 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24336), // Rule ID 2234 //
     /*  24274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24302 */     // MIs[1] imm
     /*  24302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24314 */     // MIs[2] Operand 1
     /*  24314 */     // No operand predicates
     /*  24314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24320 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24334 */     GIR_RootConstrainSelectedInstOperands,
     /*  24335 */     // GIR_Coverage, 2234,
     /*  24335 */     GIR_EraseRootFromParent_Done,
     /*  24336 */   // Label 402: @24336
     /*  24336 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24403), // Rule ID 2293 //
     /*  24341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24369 */     // MIs[1] imm
     /*  24369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24381 */     // MIs[2] Operand 1
     /*  24381 */     // No operand predicates
     /*  24381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24387 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24401 */     GIR_RootConstrainSelectedInstOperands,
     /*  24402 */     // GIR_Coverage, 2293,
     /*  24402 */     GIR_EraseRootFromParent_Done,
     /*  24403 */   // Label 403: @24403
     /*  24403 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24451), // Rule ID 13329 //
     /*  24408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24438 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24449 */     GIR_RootConstrainSelectedInstOperands,
     /*  24450 */     // GIR_Coverage, 13329,
     /*  24450 */     GIR_EraseRootFromParent_Done,
     /*  24451 */   // Label 404: @24451
     /*  24451 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24499), // Rule ID 13341 //
     /*  24456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24486 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24497 */     GIR_RootConstrainSelectedInstOperands,
     /*  24498 */     // GIR_Coverage, 13341,
     /*  24498 */     GIR_EraseRootFromParent_Done,
     /*  24499 */   // Label 405: @24499
     /*  24499 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24547), // Rule ID 988 //
     /*  24504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24534 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24545 */     GIR_RootConstrainSelectedInstOperands,
     /*  24546 */     // GIR_Coverage, 988,
     /*  24546 */     GIR_EraseRootFromParent_Done,
     /*  24547 */   // Label 406: @24547
     /*  24547 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24595), // Rule ID 1049 //
     /*  24552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24593 */     GIR_RootConstrainSelectedInstOperands,
     /*  24594 */     // GIR_Coverage, 1049,
     /*  24594 */     GIR_EraseRootFromParent_Done,
     /*  24595 */   // Label 407: @24595
     /*  24595 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24622), // Rule ID 1102 //
     /*  24600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24615 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24620 */     GIR_RootConstrainSelectedInstOperands,
     /*  24621 */     // GIR_Coverage, 1102,
     /*  24621 */     GIR_Done,
     /*  24622 */   // Label 408: @24622
     /*  24622 */   GIM_Reject,
     /*  24623 */ // Label 374: @24623
     /*  24623 */ GIM_Reject,
     /*  24624 */ // Label 160: @24624
     /*  24624 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30801),
     /*  24629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24753), // Rule ID 13502 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24708 */     // MIs[4] Operand 1
     /*  24708 */     // No operand predicates
     /*  24708 */     // MIs[2] Operand 2
     /*  24708 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24732 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24751 */     GIR_RootConstrainSelectedInstOperands,
     /*  24752 */     // GIR_Coverage, 13502,
     /*  24752 */     GIR_EraseRootFromParent_Done,
     /*  24753 */   // Label 410: @24753
     /*  24753 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24871), // Rule ID 13503 //
     /*  24758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24822 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24826 */     // MIs[4] Operand 1
     /*  24826 */     // No operand predicates
     /*  24826 */     // MIs[2] Operand 2
     /*  24826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24850 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24869 */     GIR_RootConstrainSelectedInstOperands,
     /*  24870 */     // GIR_Coverage, 13503,
     /*  24870 */     GIR_EraseRootFromParent_Done,
     /*  24871 */   // Label 411: @24871
     /*  24871 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24989), // Rule ID 13532 //
     /*  24876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24944 */     // MIs[4] Operand 1
     /*  24944 */     // No operand predicates
     /*  24944 */     // MIs[2] Operand 2
     /*  24944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24987 */     GIR_RootConstrainSelectedInstOperands,
     /*  24988 */     // GIR_Coverage, 13532,
     /*  24988 */     GIR_EraseRootFromParent_Done,
     /*  24989 */   // Label 412: @24989
     /*  24989 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25107), // Rule ID 13533 //
     /*  24994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25062 */     // MIs[4] Operand 1
     /*  25062 */     // No operand predicates
     /*  25062 */     // MIs[2] Operand 2
     /*  25062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25086 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13533,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 413: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25225), // Rule ID 2039 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25180 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25184 */     // MIs[4] Operand 1
     /*  25184 */     // No operand predicates
     /*  25184 */     // MIs[2] Operand 2
     /*  25184 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25204 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25223 */     GIR_RootConstrainSelectedInstOperands,
     /*  25224 */     // GIR_Coverage, 2039,
     /*  25224 */     GIR_EraseRootFromParent_Done,
     /*  25225 */   // Label 414: @25225
     /*  25225 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25343), // Rule ID 13501 //
     /*  25230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25298 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25302 */     // MIs[4] Operand 1
     /*  25302 */     // No operand predicates
     /*  25302 */     // MIs[2] Operand 2
     /*  25302 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25341 */     GIR_RootConstrainSelectedInstOperands,
     /*  25342 */     // GIR_Coverage, 13501,
     /*  25342 */     GIR_EraseRootFromParent_Done,
     /*  25343 */   // Label 415: @25343
     /*  25343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25461), // Rule ID 2091 //
     /*  25348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25416 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25420 */     // MIs[4] Operand 1
     /*  25420 */     // No operand predicates
     /*  25420 */     // MIs[2] Operand 2
     /*  25420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25431 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25459 */     GIR_RootConstrainSelectedInstOperands,
     /*  25460 */     // GIR_Coverage, 2091,
     /*  25460 */     GIR_EraseRootFromParent_Done,
     /*  25461 */   // Label 416: @25461
     /*  25461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25579), // Rule ID 13531 //
     /*  25466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25534 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25538 */     // MIs[4] Operand 1
     /*  25538 */     // No operand predicates
     /*  25538 */     // MIs[2] Operand 2
     /*  25538 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25558 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25577 */     GIR_RootConstrainSelectedInstOperands,
     /*  25578 */     // GIR_Coverage, 13531,
     /*  25578 */     GIR_EraseRootFromParent_Done,
     /*  25579 */   // Label 417: @25579
     /*  25579 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25666), // Rule ID 13412 //
     /*  25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25611 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25614 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25647 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 13412,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 418: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25753), // Rule ID 13436 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25698 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25701 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25710 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25734 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25751 */     GIR_RootConstrainSelectedInstOperands,
     /*  25752 */     // GIR_Coverage, 13436,
     /*  25752 */     GIR_EraseRootFromParent_Done,
     /*  25753 */   // Label 419: @25753
     /*  25753 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25840), // Rule ID 1695 //
     /*  25758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25789 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25792 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25801 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25821 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25838 */     GIR_RootConstrainSelectedInstOperands,
     /*  25839 */     // GIR_Coverage, 1695,
     /*  25839 */     GIR_EraseRootFromParent_Done,
     /*  25840 */   // Label 420: @25840
     /*  25840 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25927), // Rule ID 1773 //
     /*  25845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25876 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25879 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25888 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25925 */     GIR_RootConstrainSelectedInstOperands,
     /*  25926 */     // GIR_Coverage, 1773,
     /*  25926 */     GIR_EraseRootFromParent_Done,
     /*  25927 */   // Label 421: @25927
     /*  25927 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26042), // Rule ID 13497 //
     /*  25932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25996 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26000 */     // MIs[4] Operand 1
     /*  26000 */     // No operand predicates
     /*  26000 */     // MIs[2] Operand 2
     /*  26000 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26022 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26040 */     GIR_RootConstrainSelectedInstOperands,
     /*  26041 */     // GIR_Coverage, 13497,
     /*  26041 */     GIR_EraseRootFromParent_Done,
     /*  26042 */   // Label 422: @26042
     /*  26042 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26157), // Rule ID 13496 //
     /*  26047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26116 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26120 */     // MIs[4] Operand 1
     /*  26120 */     // No operand predicates
     /*  26120 */     // MIs[2] Operand 2
     /*  26120 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26137 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 13496,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 423: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26272), // Rule ID 13527 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26230 */     // MIs[4] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     // MIs[2] Operand 2
     /*  26230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26270 */     GIR_RootConstrainSelectedInstOperands,
     /*  26271 */     // GIR_Coverage, 13527,
     /*  26271 */     GIR_EraseRootFromParent_Done,
     /*  26272 */   // Label 424: @26272
     /*  26272 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26387), // Rule ID 13526 //
     /*  26277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26350 */     // MIs[4] Operand 1
     /*  26350 */     // No operand predicates
     /*  26350 */     // MIs[2] Operand 2
     /*  26350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26367 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26385 */     GIR_RootConstrainSelectedInstOperands,
     /*  26386 */     // GIR_Coverage, 13526,
     /*  26386 */     GIR_EraseRootFromParent_Done,
     /*  26387 */   // Label 425: @26387
     /*  26387 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26456), // Rule ID 1793 //
     /*  26392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26439 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26454 */     GIR_RootConstrainSelectedInstOperands,
     /*  26455 */     // GIR_Coverage, 1793,
     /*  26455 */     GIR_EraseRootFromParent_Done,
     /*  26456 */   // Label 426: @26456
     /*  26456 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26525), // Rule ID 1792 //
     /*  26461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26508 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 1792,
     /*  26524 */     GIR_EraseRootFromParent_Done,
     /*  26525 */   // Label 427: @26525
     /*  26525 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26594), // Rule ID 1715 //
     /*  26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26577 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26592 */     GIR_RootConstrainSelectedInstOperands,
     /*  26593 */     // GIR_Coverage, 1715,
     /*  26593 */     GIR_EraseRootFromParent_Done,
     /*  26594 */   // Label 428: @26594
     /*  26594 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26663), // Rule ID 1791 //
     /*  26599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 1791,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 429: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26732), // Rule ID 1790 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26715 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26730 */     GIR_RootConstrainSelectedInstOperands,
     /*  26731 */     // GIR_Coverage, 1790,
     /*  26731 */     GIR_EraseRootFromParent_Done,
     /*  26732 */   // Label 430: @26732
     /*  26732 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26847), // Rule ID 13495 //
     /*  26737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26809 */     // MIs[4] Operand 1
     /*  26809 */     // No operand predicates
     /*  26809 */     // MIs[2] Operand 2
     /*  26809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26827 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26845 */     GIR_RootConstrainSelectedInstOperands,
     /*  26846 */     // GIR_Coverage, 13495,
     /*  26846 */     GIR_EraseRootFromParent_Done,
     /*  26847 */   // Label 431: @26847
     /*  26847 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26962), // Rule ID 2037 //
     /*  26852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26925 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26929 */     // MIs[4] Operand 1
     /*  26929 */     // No operand predicates
     /*  26929 */     // MIs[2] Operand 2
     /*  26929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26942 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26960 */     GIR_RootConstrainSelectedInstOperands,
     /*  26961 */     // GIR_Coverage, 2037,
     /*  26961 */     GIR_EraseRootFromParent_Done,
     /*  26962 */   // Label 432: @26962
     /*  26962 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27077), // Rule ID 13525 //
     /*  26967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27035 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27039 */     // MIs[4] Operand 1
     /*  27039 */     // No operand predicates
     /*  27039 */     // MIs[2] Operand 2
     /*  27039 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27057 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27075 */     GIR_RootConstrainSelectedInstOperands,
     /*  27076 */     // GIR_Coverage, 13525,
     /*  27076 */     GIR_EraseRootFromParent_Done,
     /*  27077 */   // Label 433: @27077
     /*  27077 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27192), // Rule ID 2089 //
     /*  27082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27155 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27159 */     // MIs[4] Operand 1
     /*  27159 */     // No operand predicates
     /*  27159 */     // MIs[2] Operand 2
     /*  27159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27172 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27190 */     GIR_RootConstrainSelectedInstOperands,
     /*  27191 */     // GIR_Coverage, 2089,
     /*  27191 */     GIR_EraseRootFromParent_Done,
     /*  27192 */   // Label 434: @27192
     /*  27192 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27259), // Rule ID 13426 //
     /*  27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27240 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 13426,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 435: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27326), // Rule ID 13456 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27307 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27324 */     GIR_RootConstrainSelectedInstOperands,
     /*  27325 */     // GIR_Coverage, 13456,
     /*  27325 */     GIR_EraseRootFromParent_Done,
     /*  27326 */   // Label 436: @27326
     /*  27326 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27393), // Rule ID 1727 //
     /*  27331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27374 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27391 */     GIR_RootConstrainSelectedInstOperands,
     /*  27392 */     // GIR_Coverage, 1727,
     /*  27392 */     GIR_EraseRootFromParent_Done,
     /*  27393 */   // Label 437: @27393
     /*  27393 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27460), // Rule ID 1817 //
     /*  27398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27441 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 1817,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 438: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27541), // Rule ID 13410 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27492 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27495 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27524 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27539 */     GIR_RootConstrainSelectedInstOperands,
     /*  27540 */     // GIR_Coverage, 13410,
     /*  27540 */     GIR_EraseRootFromParent_Done,
     /*  27541 */   // Label 439: @27541
     /*  27541 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27622), // Rule ID 13434 //
     /*  27546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27605 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27620 */     GIR_RootConstrainSelectedInstOperands,
     /*  27621 */     // GIR_Coverage, 13434,
     /*  27621 */     GIR_EraseRootFromParent_Done,
     /*  27622 */   // Label 440: @27622
     /*  27622 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27703), // Rule ID 1693 //
     /*  27627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27670 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27686 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27701 */     GIR_RootConstrainSelectedInstOperands,
     /*  27702 */     // GIR_Coverage, 1693,
     /*  27702 */     GIR_EraseRootFromParent_Done,
     /*  27703 */   // Label 441: @27703
     /*  27703 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27784), // Rule ID 1771 //
     /*  27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27739 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27742 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27751 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27767 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27782 */     GIR_RootConstrainSelectedInstOperands,
     /*  27783 */     // GIR_Coverage, 1771,
     /*  27783 */     GIR_EraseRootFromParent_Done,
     /*  27784 */   // Label 442: @27784
     /*  27784 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27876), // Rule ID 13500 //
     /*  27789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27845 */     // MIs[3] Operand 1
     /*  27845 */     // No operand predicates
     /*  27845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27856 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27874 */     GIR_RootConstrainSelectedInstOperands,
     /*  27875 */     // GIR_Coverage, 13500,
     /*  27875 */     GIR_EraseRootFromParent_Done,
     /*  27876 */   // Label 443: @27876
     /*  27876 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27968), // Rule ID 13499 //
     /*  27881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27942 */     // MIs[3] Operand 1
     /*  27942 */     // No operand predicates
     /*  27942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27948 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27966 */     GIR_RootConstrainSelectedInstOperands,
     /*  27967 */     // GIR_Coverage, 13499,
     /*  27967 */     GIR_EraseRootFromParent_Done,
     /*  27968 */   // Label 444: @27968
     /*  27968 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28060), // Rule ID 13530 //
     /*  27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28029 */     // MIs[3] Operand 1
     /*  28029 */     // No operand predicates
     /*  28029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28040 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28058 */     GIR_RootConstrainSelectedInstOperands,
     /*  28059 */     // GIR_Coverage, 13530,
     /*  28059 */     GIR_EraseRootFromParent_Done,
     /*  28060 */   // Label 445: @28060
     /*  28060 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28152), // Rule ID 13529 //
     /*  28065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28126 */     // MIs[3] Operand 1
     /*  28126 */     // No operand predicates
     /*  28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28132 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28150 */     GIR_RootConstrainSelectedInstOperands,
     /*  28151 */     // GIR_Coverage, 13529,
     /*  28151 */     GIR_EraseRootFromParent_Done,
     /*  28152 */   // Label 446: @28152
     /*  28152 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28244), // Rule ID 13498 //
     /*  28157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28217 */     // MIs[3] Operand 1
     /*  28217 */     // No operand predicates
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28224 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28242 */     GIR_RootConstrainSelectedInstOperands,
     /*  28243 */     // GIR_Coverage, 13498,
     /*  28243 */     GIR_EraseRootFromParent_Done,
     /*  28244 */   // Label 447: @28244
     /*  28244 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28336), // Rule ID 2038 //
     /*  28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28314 */     // MIs[3] Operand 1
     /*  28314 */     // No operand predicates
     /*  28314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28316 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 2038,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 448: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28428), // Rule ID 13528 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28401 */     // MIs[3] Operand 1
     /*  28401 */     // No operand predicates
     /*  28401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28408 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28426 */     GIR_RootConstrainSelectedInstOperands,
     /*  28427 */     // GIR_Coverage, 13528,
     /*  28427 */     GIR_EraseRootFromParent_Done,
     /*  28428 */   // Label 449: @28428
     /*  28428 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28520), // Rule ID 2090 //
     /*  28433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28498 */     // MIs[3] Operand 1
     /*  28498 */     // No operand predicates
     /*  28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28518 */     GIR_RootConstrainSelectedInstOperands,
     /*  28519 */     // GIR_Coverage, 2090,
     /*  28519 */     GIR_EraseRootFromParent_Done,
     /*  28520 */   // Label 450: @28520
     /*  28520 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28571), // Rule ID 13448 //
     /*  28525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28557 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28569 */     GIR_RootConstrainSelectedInstOperands,
     /*  28570 */     // GIR_Coverage, 13448,
     /*  28570 */     GIR_EraseRootFromParent_Done,
     /*  28571 */   // Label 451: @28571
     /*  28571 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28622), // Rule ID 13420 //
     /*  28576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28608 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28620 */     GIR_RootConstrainSelectedInstOperands,
     /*  28621 */     // GIR_Coverage, 13420,
     /*  28621 */     GIR_EraseRootFromParent_Done,
     /*  28622 */   // Label 452: @28622
     /*  28622 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28673), // Rule ID 13447 //
     /*  28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28671 */     GIR_RootConstrainSelectedInstOperands,
     /*  28672 */     // GIR_Coverage, 13447,
     /*  28672 */     GIR_EraseRootFromParent_Done,
     /*  28673 */   // Label 453: @28673
     /*  28673 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28724), // Rule ID 1809 //
     /*  28678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28710 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28722 */     GIR_RootConstrainSelectedInstOperands,
     /*  28723 */     // GIR_Coverage, 1809,
     /*  28723 */     GIR_EraseRootFromParent_Done,
     /*  28724 */   // Label 454: @28724
     /*  28724 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28775), // Rule ID 1721 //
     /*  28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28761 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28773 */     GIR_RootConstrainSelectedInstOperands,
     /*  28774 */     // GIR_Coverage, 1721,
     /*  28774 */     GIR_EraseRootFromParent_Done,
     /*  28775 */   // Label 455: @28775
     /*  28775 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28826), // Rule ID 1808 //
     /*  28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28824 */     GIR_RootConstrainSelectedInstOperands,
     /*  28825 */     // GIR_Coverage, 1808,
     /*  28825 */     GIR_EraseRootFromParent_Done,
     /*  28826 */   // Label 456: @28826
     /*  28826 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28895), // Rule ID 13374 //
     /*  28831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28878 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28893 */     GIR_RootConstrainSelectedInstOperands,
     /*  28894 */     // GIR_Coverage, 13374,
     /*  28894 */     GIR_EraseRootFromParent_Done,
     /*  28895 */   // Label 457: @28895
     /*  28895 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28964), // Rule ID 13386 //
     /*  28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28947 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13386,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 458: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29020), // Rule ID 13336 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13336,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 459: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29076), // Rule ID 13348 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29063 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29074 */     GIR_RootConstrainSelectedInstOperands,
     /*  29075 */     // GIR_Coverage, 13348,
     /*  29075 */     GIR_EraseRootFromParent_Done,
     /*  29076 */   // Label 460: @29076
     /*  29076 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29143), // Rule ID 13578 //
     /*  29081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     // MIs[1] imm
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29117 */     // MIs[2] Operand 1
     /*  29117 */     // No operand predicates
     /*  29117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29127 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29141 */     GIR_RootConstrainSelectedInstOperands,
     /*  29142 */     // GIR_Coverage, 13578,
     /*  29142 */     GIR_EraseRootFromParent_Done,
     /*  29143 */   // Label 461: @29143
     /*  29143 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29210), // Rule ID 13599 //
     /*  29148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     // MIs[1] imm
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29184 */     // MIs[2] Operand 1
     /*  29184 */     // No operand predicates
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29194 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29208 */     GIR_RootConstrainSelectedInstOperands,
     /*  29209 */     // GIR_Coverage, 13599,
     /*  29209 */     GIR_EraseRootFromParent_Done,
     /*  29210 */   // Label 462: @29210
     /*  29210 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29279), // Rule ID 1367 //
     /*  29215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29262 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29277 */     GIR_RootConstrainSelectedInstOperands,
     /*  29278 */     // GIR_Coverage, 1367,
     /*  29278 */     GIR_EraseRootFromParent_Done,
     /*  29279 */   // Label 463: @29279
     /*  29279 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29348), // Rule ID 1490 //
     /*  29284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 1490,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 464: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29404), // Rule ID 995 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 995,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 465: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29460), // Rule ID 1056 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29458 */     GIR_RootConstrainSelectedInstOperands,
     /*  29459 */     // GIR_Coverage, 1056,
     /*  29459 */     GIR_EraseRootFromParent_Done,
     /*  29460 */   // Label 466: @29460
     /*  29460 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29527), // Rule ID 2240 //
     /*  29465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29493 */     // MIs[1] imm
     /*  29493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29505 */     // MIs[2] Operand 1
     /*  29505 */     // No operand predicates
     /*  29505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29511 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29525 */     GIR_RootConstrainSelectedInstOperands,
     /*  29526 */     // GIR_Coverage, 2240,
     /*  29526 */     GIR_EraseRootFromParent_Done,
     /*  29527 */   // Label 467: @29527
     /*  29527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29594), // Rule ID 2299 //
     /*  29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29560 */     // MIs[1] imm
     /*  29560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29572 */     // MIs[2] Operand 1
     /*  29572 */     // No operand predicates
     /*  29572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29578 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 2299,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 468: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29664), // Rule ID 6935 //
     /*  29599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29637 */     // MIs[2] Rn
     /*  29637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29642 */     // MIs[2] Rm
     /*  29642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29649 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 6935,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 469: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29734), // Rule ID 13960 //
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29707 */     // MIs[2] Rn
     /*  29707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29712 */     // MIs[2] Rm
     /*  29712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29719 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29732 */     GIR_RootConstrainSelectedInstOperands,
     /*  29733 */     // GIR_Coverage, 13960,
     /*  29733 */     GIR_EraseRootFromParent_Done,
     /*  29734 */   // Label 470: @29734
     /*  29734 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29797), // Rule ID 1789 //
     /*  29739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29782 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29795 */     GIR_RootConstrainSelectedInstOperands,
     /*  29796 */     // GIR_Coverage, 1789,
     /*  29796 */     GIR_EraseRootFromParent_Done,
     /*  29797 */   // Label 471: @29797
     /*  29797 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29860), // Rule ID 1788 //
     /*  29802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29845 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 1788,
     /*  29859 */     GIR_EraseRootFromParent_Done,
     /*  29860 */   // Label 472: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29923), // Rule ID 1714 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29908 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29921 */     GIR_RootConstrainSelectedInstOperands,
     /*  29922 */     // GIR_Coverage, 1714,
     /*  29922 */     GIR_EraseRootFromParent_Done,
     /*  29923 */   // Label 473: @29923
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29986), // Rule ID 1787 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29971 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29984 */     GIR_RootConstrainSelectedInstOperands,
     /*  29985 */     // GIR_Coverage, 1787,
     /*  29985 */     GIR_EraseRootFromParent_Done,
     /*  29986 */   // Label 474: @29986
     /*  29986 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30049), // Rule ID 1786 //
     /*  29991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30034 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30047 */     GIR_RootConstrainSelectedInstOperands,
     /*  30048 */     // GIR_Coverage, 1786,
     /*  30048 */     GIR_EraseRootFromParent_Done,
     /*  30049 */   // Label 475: @30049
     /*  30049 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30110), // Rule ID 13425 //
     /*  30054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30093 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30108 */     GIR_RootConstrainSelectedInstOperands,
     /*  30109 */     // GIR_Coverage, 13425,
     /*  30109 */     GIR_EraseRootFromParent_Done,
     /*  30110 */   // Label 476: @30110
     /*  30110 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30171), // Rule ID 13455 //
     /*  30115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30154 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30169 */     GIR_RootConstrainSelectedInstOperands,
     /*  30170 */     // GIR_Coverage, 13455,
     /*  30170 */     GIR_EraseRootFromParent_Done,
     /*  30171 */   // Label 477: @30171
     /*  30171 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30219), // Rule ID 13446 //
     /*  30176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30206 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30217 */     GIR_RootConstrainSelectedInstOperands,
     /*  30218 */     // GIR_Coverage, 13446,
     /*  30218 */     GIR_EraseRootFromParent_Done,
     /*  30219 */   // Label 478: @30219
     /*  30219 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30267), // Rule ID 13335 //
     /*  30224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30254 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 13335,
     /*  30266 */     GIR_EraseRootFromParent_Done,
     /*  30267 */   // Label 479: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30315), // Rule ID 13419 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30302 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30313 */     GIR_RootConstrainSelectedInstOperands,
     /*  30314 */     // GIR_Coverage, 13419,
     /*  30314 */     GIR_EraseRootFromParent_Done,
     /*  30315 */   // Label 480: @30315
     /*  30315 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30363), // Rule ID 13347 //
     /*  30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30350 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30361 */     GIR_RootConstrainSelectedInstOperands,
     /*  30362 */     // GIR_Coverage, 13347,
     /*  30362 */     GIR_EraseRootFromParent_Done,
     /*  30363 */   // Label 481: @30363
     /*  30363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30411), // Rule ID 13445 //
     /*  30368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30398 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30409 */     GIR_RootConstrainSelectedInstOperands,
     /*  30410 */     // GIR_Coverage, 13445,
     /*  30410 */     GIR_EraseRootFromParent_Done,
     /*  30411 */   // Label 482: @30411
     /*  30411 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30472), // Rule ID 1726 //
     /*  30416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1726,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 483: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30533), // Rule ID 1816 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30516 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30531 */     GIR_RootConstrainSelectedInstOperands,
     /*  30532 */     // GIR_Coverage, 1816,
     /*  30532 */     GIR_EraseRootFromParent_Done,
     /*  30533 */   // Label 484: @30533
     /*  30533 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30581), // Rule ID 1807 //
     /*  30538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30568 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30579 */     GIR_RootConstrainSelectedInstOperands,
     /*  30580 */     // GIR_Coverage, 1807,
     /*  30580 */     GIR_EraseRootFromParent_Done,
     /*  30581 */   // Label 485: @30581
     /*  30581 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30629), // Rule ID 994 //
     /*  30586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30616 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30627 */     GIR_RootConstrainSelectedInstOperands,
     /*  30628 */     // GIR_Coverage, 994,
     /*  30628 */     GIR_EraseRootFromParent_Done,
     /*  30629 */   // Label 486: @30629
     /*  30629 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30677), // Rule ID 1720 //
     /*  30634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30664 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1720,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 487: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30725), // Rule ID 1055 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30723 */     GIR_RootConstrainSelectedInstOperands,
     /*  30724 */     // GIR_Coverage, 1055,
     /*  30724 */     GIR_EraseRootFromParent_Done,
     /*  30725 */   // Label 488: @30725
     /*  30725 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30773), // Rule ID 1806 //
     /*  30730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30771 */     GIR_RootConstrainSelectedInstOperands,
     /*  30772 */     // GIR_Coverage, 1806,
     /*  30772 */     GIR_EraseRootFromParent_Done,
     /*  30773 */   // Label 489: @30773
     /*  30773 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30800), // Rule ID 1105 //
     /*  30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30798 */     GIR_RootConstrainSelectedInstOperands,
     /*  30799 */     // GIR_Coverage, 1105,
     /*  30799 */     GIR_Done,
     /*  30800 */   // Label 490: @30800
     /*  30800 */   GIM_Reject,
     /*  30801 */ // Label 409: @30801
     /*  30801 */ GIM_Reject,
     /*  30802 */ // Label 161: @30802
     /*  30802 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31651),
     /*  30807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30813 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30946), // Rule ID 13965 //
     /*  30818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30863 */     // MIs[1] Operand 2
     /*  30863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30894 */     // MIs[5] Rn
     /*  30894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30899 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30901 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30945 */     // GIR_Coverage, 13965,
     /*  30945 */     GIR_EraseRootFromParent_Done,
     /*  30946 */   // Label 492: @30946
     /*  30946 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31079), // Rule ID 6940 //
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31008 */     // MIs[4] Rn
     /*  31008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31021 */     // MIs[3] Operand 2
     /*  31021 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31032 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31034 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31078 */     // GIR_Coverage, 6940,
     /*  31078 */     GIR_EraseRootFromParent_Done,
     /*  31079 */   // Label 493: @31079
     /*  31079 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31148), // Rule ID 13364 //
     /*  31084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31131 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31146 */     GIR_RootConstrainSelectedInstOperands,
     /*  31147 */     // GIR_Coverage, 13364,
     /*  31147 */     GIR_EraseRootFromParent_Done,
     /*  31148 */   // Label 494: @31148
     /*  31148 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31217), // Rule ID 13376 //
     /*  31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31200 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31215 */     GIR_RootConstrainSelectedInstOperands,
     /*  31216 */     // GIR_Coverage, 13376,
     /*  31216 */     GIR_EraseRootFromParent_Done,
     /*  31217 */   // Label 495: @31217
     /*  31217 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31284), // Rule ID 13568 //
     /*  31222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     // MIs[1] imm
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31258 */     // MIs[2] Operand 1
     /*  31258 */     // No operand predicates
     /*  31258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31268 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31282 */     GIR_RootConstrainSelectedInstOperands,
     /*  31283 */     // GIR_Coverage, 13568,
     /*  31283 */     GIR_EraseRootFromParent_Done,
     /*  31284 */   // Label 496: @31284
     /*  31284 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31351), // Rule ID 13589 //
     /*  31289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     // MIs[1] imm
     /*  31313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31325 */     // MIs[2] Operand 1
     /*  31325 */     // No operand predicates
     /*  31325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31335 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31349 */     GIR_RootConstrainSelectedInstOperands,
     /*  31350 */     // GIR_Coverage, 13589,
     /*  31350 */     GIR_EraseRootFromParent_Done,
     /*  31351 */   // Label 497: @31351
     /*  31351 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31420), // Rule ID 1357 //
     /*  31356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31403 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31418 */     GIR_RootConstrainSelectedInstOperands,
     /*  31419 */     // GIR_Coverage, 1357,
     /*  31419 */     GIR_EraseRootFromParent_Done,
     /*  31420 */   // Label 498: @31420
     /*  31420 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31489), // Rule ID 1480 //
     /*  31425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31472 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31487 */     GIR_RootConstrainSelectedInstOperands,
     /*  31488 */     // GIR_Coverage, 1480,
     /*  31488 */     GIR_EraseRootFromParent_Done,
     /*  31489 */   // Label 499: @31489
     /*  31489 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31556), // Rule ID 2230 //
     /*  31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31522 */     // MIs[1] imm
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31534 */     // MIs[2] Operand 1
     /*  31534 */     // No operand predicates
     /*  31534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31540 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31554 */     GIR_RootConstrainSelectedInstOperands,
     /*  31555 */     // GIR_Coverage, 2230,
     /*  31555 */     GIR_EraseRootFromParent_Done,
     /*  31556 */   // Label 500: @31556
     /*  31556 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31623), // Rule ID 2289 //
     /*  31561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31589 */     // MIs[1] imm
     /*  31589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31601 */     // MIs[2] Operand 1
     /*  31601 */     // No operand predicates
     /*  31601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31607 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31621 */     GIR_RootConstrainSelectedInstOperands,
     /*  31622 */     // GIR_Coverage, 2289,
     /*  31622 */     GIR_EraseRootFromParent_Done,
     /*  31623 */   // Label 501: @31623
     /*  31623 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31650), // Rule ID 1100 //
     /*  31628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31643 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31648 */     GIR_RootConstrainSelectedInstOperands,
     /*  31649 */     // GIR_Coverage, 1100,
     /*  31649 */     GIR_Done,
     /*  31650 */   // Label 502: @31650
     /*  31650 */   GIM_Reject,
     /*  31651 */ // Label 491: @31651
     /*  31651 */ GIM_Reject,
     /*  31652 */ // Label 162: @31652
     /*  31652 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35229),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31663 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31750), // Rule ID 13408 //
     /*  31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31731 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 13408,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 504: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31837), // Rule ID 13432 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31782 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31785 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31794 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31835 */     GIR_RootConstrainSelectedInstOperands,
     /*  31836 */     // GIR_Coverage, 13432,
     /*  31836 */     GIR_EraseRootFromParent_Done,
     /*  31837 */   // Label 505: @31837
     /*  31837 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31924), // Rule ID 1691 //
     /*  31842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31885 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31905 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31922 */     GIR_RootConstrainSelectedInstOperands,
     /*  31923 */     // GIR_Coverage, 1691,
     /*  31923 */     GIR_EraseRootFromParent_Done,
     /*  31924 */   // Label 506: @31924
     /*  31924 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32011), // Rule ID 1769 //
     /*  31929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31963 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31972 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31992 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32009 */     GIR_RootConstrainSelectedInstOperands,
     /*  32010 */     // GIR_Coverage, 1769,
     /*  32010 */     GIR_EraseRootFromParent_Done,
     /*  32011 */   // Label 507: @32011
     /*  32011 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32080), // Rule ID 1785 //
     /*  32016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32063 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32078 */     GIR_RootConstrainSelectedInstOperands,
     /*  32079 */     // GIR_Coverage, 1785,
     /*  32079 */     GIR_EraseRootFromParent_Done,
     /*  32080 */   // Label 508: @32080
     /*  32080 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32149), // Rule ID 1784 //
     /*  32085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32132 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32147 */     GIR_RootConstrainSelectedInstOperands,
     /*  32148 */     // GIR_Coverage, 1784,
     /*  32148 */     GIR_EraseRootFromParent_Done,
     /*  32149 */   // Label 509: @32149
     /*  32149 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32218), // Rule ID 1713 //
     /*  32154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32201 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32216 */     GIR_RootConstrainSelectedInstOperands,
     /*  32217 */     // GIR_Coverage, 1713,
     /*  32217 */     GIR_EraseRootFromParent_Done,
     /*  32218 */   // Label 510: @32218
     /*  32218 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32287), // Rule ID 1783 //
     /*  32223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32270 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32285 */     GIR_RootConstrainSelectedInstOperands,
     /*  32286 */     // GIR_Coverage, 1783,
     /*  32286 */     GIR_EraseRootFromParent_Done,
     /*  32287 */   // Label 511: @32287
     /*  32287 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32356), // Rule ID 1782 //
     /*  32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32339 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32354 */     GIR_RootConstrainSelectedInstOperands,
     /*  32355 */     // GIR_Coverage, 1782,
     /*  32355 */     GIR_EraseRootFromParent_Done,
     /*  32356 */   // Label 512: @32356
     /*  32356 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32423), // Rule ID 13424 //
     /*  32361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32404 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32421 */     GIR_RootConstrainSelectedInstOperands,
     /*  32422 */     // GIR_Coverage, 13424,
     /*  32422 */     GIR_EraseRootFromParent_Done,
     /*  32423 */   // Label 513: @32423
     /*  32423 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32490), // Rule ID 13454 //
     /*  32428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32471 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32488 */     GIR_RootConstrainSelectedInstOperands,
     /*  32489 */     // GIR_Coverage, 13454,
     /*  32489 */     GIR_EraseRootFromParent_Done,
     /*  32490 */   // Label 514: @32490
     /*  32490 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32557), // Rule ID 1725 //
     /*  32495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32538 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32555 */     GIR_RootConstrainSelectedInstOperands,
     /*  32556 */     // GIR_Coverage, 1725,
     /*  32556 */     GIR_EraseRootFromParent_Done,
     /*  32557 */   // Label 515: @32557
     /*  32557 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32624), // Rule ID 1815 //
     /*  32562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32605 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 1815,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 516: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32705), // Rule ID 13406 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32656 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32659 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32688 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 13406,
     /*  32704 */     GIR_EraseRootFromParent_Done,
     /*  32705 */   // Label 517: @32705
     /*  32705 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32786), // Rule ID 13430 //
     /*  32710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32769 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32784 */     GIR_RootConstrainSelectedInstOperands,
     /*  32785 */     // GIR_Coverage, 13430,
     /*  32785 */     GIR_EraseRootFromParent_Done,
     /*  32786 */   // Label 518: @32786
     /*  32786 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32867), // Rule ID 1689 //
     /*  32791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32822 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32825 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32834 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32850 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32865 */     GIR_RootConstrainSelectedInstOperands,
     /*  32866 */     // GIR_Coverage, 1689,
     /*  32866 */     GIR_EraseRootFromParent_Done,
     /*  32867 */   // Label 519: @32867
     /*  32867 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32948), // Rule ID 1767 //
     /*  32872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32903 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32906 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32915 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 1767,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 520: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32999), // Rule ID 13444 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32985 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32997 */     GIR_RootConstrainSelectedInstOperands,
     /*  32998 */     // GIR_Coverage, 13444,
     /*  32998 */     GIR_EraseRootFromParent_Done,
     /*  32999 */   // Label 521: @32999
     /*  32999 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33050), // Rule ID 13418 //
     /*  33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33036 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33048 */     GIR_RootConstrainSelectedInstOperands,
     /*  33049 */     // GIR_Coverage, 13418,
     /*  33049 */     GIR_EraseRootFromParent_Done,
     /*  33050 */   // Label 522: @33050
     /*  33050 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33101), // Rule ID 13443 //
     /*  33055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33087 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33099 */     GIR_RootConstrainSelectedInstOperands,
     /*  33100 */     // GIR_Coverage, 13443,
     /*  33100 */     GIR_EraseRootFromParent_Done,
     /*  33101 */   // Label 523: @33101
     /*  33101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33152), // Rule ID 1805 //
     /*  33106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33138 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33150 */     GIR_RootConstrainSelectedInstOperands,
     /*  33151 */     // GIR_Coverage, 1805,
     /*  33151 */     GIR_EraseRootFromParent_Done,
     /*  33152 */   // Label 524: @33152
     /*  33152 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33203), // Rule ID 1719 //
     /*  33157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33189 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33201 */     GIR_RootConstrainSelectedInstOperands,
     /*  33202 */     // GIR_Coverage, 1719,
     /*  33202 */     GIR_EraseRootFromParent_Done,
     /*  33203 */   // Label 525: @33203
     /*  33203 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33254), // Rule ID 1804 //
     /*  33208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33252 */     GIR_RootConstrainSelectedInstOperands,
     /*  33253 */     // GIR_Coverage, 1804,
     /*  33253 */     GIR_EraseRootFromParent_Done,
     /*  33254 */   // Label 526: @33254
     /*  33254 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33323), // Rule ID 13370 //
     /*  33259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33306 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33321 */     GIR_RootConstrainSelectedInstOperands,
     /*  33322 */     // GIR_Coverage, 13370,
     /*  33322 */     GIR_EraseRootFromParent_Done,
     /*  33323 */   // Label 527: @33323
     /*  33323 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33392), // Rule ID 13382 //
     /*  33328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33375 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13382,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 528: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33448), // Rule ID 13332 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13332,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 529: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33504), // Rule ID 13344 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33491 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33502 */     GIR_RootConstrainSelectedInstOperands,
     /*  33503 */     // GIR_Coverage, 13344,
     /*  33503 */     GIR_EraseRootFromParent_Done,
     /*  33504 */   // Label 530: @33504
     /*  33504 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33571), // Rule ID 13574 //
     /*  33509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     // MIs[1] imm
     /*  33533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33545 */     // MIs[2] Operand 1
     /*  33545 */     // No operand predicates
     /*  33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33555 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33569 */     GIR_RootConstrainSelectedInstOperands,
     /*  33570 */     // GIR_Coverage, 13574,
     /*  33570 */     GIR_EraseRootFromParent_Done,
     /*  33571 */   // Label 531: @33571
     /*  33571 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33638), // Rule ID 13595 //
     /*  33576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     // MIs[1] imm
     /*  33600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33612 */     // MIs[2] Operand 1
     /*  33612 */     // No operand predicates
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33622 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 13595,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 532: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33707), // Rule ID 1363 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33662 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33665 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33690 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 1363,
     /*  33706 */     GIR_EraseRootFromParent_Done,
     /*  33707 */   // Label 533: @33707
     /*  33707 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33776), // Rule ID 1486 //
     /*  33712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 1486,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 534: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33832), // Rule ID 991 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 991,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 535: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33888), // Rule ID 1052 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33886 */     GIR_RootConstrainSelectedInstOperands,
     /*  33887 */     // GIR_Coverage, 1052,
     /*  33887 */     GIR_EraseRootFromParent_Done,
     /*  33888 */   // Label 536: @33888
     /*  33888 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33955), // Rule ID 2236 //
     /*  33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33921 */     // MIs[1] imm
     /*  33921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33933 */     // MIs[2] Operand 1
     /*  33933 */     // No operand predicates
     /*  33933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33939 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33953 */     GIR_RootConstrainSelectedInstOperands,
     /*  33954 */     // GIR_Coverage, 2236,
     /*  33954 */     GIR_EraseRootFromParent_Done,
     /*  33955 */   // Label 537: @33955
     /*  33955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34022), // Rule ID 2295 //
     /*  33960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33988 */     // MIs[1] imm
     /*  33988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34000 */     // MIs[2] Operand 1
     /*  34000 */     // No operand predicates
     /*  34000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34006 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34020 */     GIR_RootConstrainSelectedInstOperands,
     /*  34021 */     // GIR_Coverage, 2295,
     /*  34021 */     GIR_EraseRootFromParent_Done,
     /*  34022 */   // Label 538: @34022
     /*  34022 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34092), // Rule ID 6936 //
     /*  34027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34065 */     // MIs[2] Rn
     /*  34065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34070 */     // MIs[2] Rm
     /*  34070 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34077 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34090 */     GIR_RootConstrainSelectedInstOperands,
     /*  34091 */     // GIR_Coverage, 6936,
     /*  34091 */     GIR_EraseRootFromParent_Done,
     /*  34092 */   // Label 539: @34092
     /*  34092 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34162), // Rule ID 13961 //
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34135 */     // MIs[2] Rn
     /*  34135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34140 */     // MIs[2] Rm
     /*  34140 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34147 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34160 */     GIR_RootConstrainSelectedInstOperands,
     /*  34161 */     // GIR_Coverage, 13961,
     /*  34161 */     GIR_EraseRootFromParent_Done,
     /*  34162 */   // Label 540: @34162
     /*  34162 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34225), // Rule ID 1781 //
     /*  34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34210 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34223 */     GIR_RootConstrainSelectedInstOperands,
     /*  34224 */     // GIR_Coverage, 1781,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 541: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34288), // Rule ID 1780 //
     /*  34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34273 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34286 */     GIR_RootConstrainSelectedInstOperands,
     /*  34287 */     // GIR_Coverage, 1780,
     /*  34287 */     GIR_EraseRootFromParent_Done,
     /*  34288 */   // Label 542: @34288
     /*  34288 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34351), // Rule ID 1712 //
     /*  34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34336 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34349 */     GIR_RootConstrainSelectedInstOperands,
     /*  34350 */     // GIR_Coverage, 1712,
     /*  34350 */     GIR_EraseRootFromParent_Done,
     /*  34351 */   // Label 543: @34351
     /*  34351 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34414), // Rule ID 1779 //
     /*  34356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34399 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 1779,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 544: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34477), // Rule ID 1778 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34462 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 1778,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 545: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34538), // Rule ID 13423 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34521 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34536 */     GIR_RootConstrainSelectedInstOperands,
     /*  34537 */     // GIR_Coverage, 13423,
     /*  34537 */     GIR_EraseRootFromParent_Done,
     /*  34538 */   // Label 546: @34538
     /*  34538 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34599), // Rule ID 13453 //
     /*  34543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34582 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 13453,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 547: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34647), // Rule ID 13442 //
     /*  34604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34645 */     GIR_RootConstrainSelectedInstOperands,
     /*  34646 */     // GIR_Coverage, 13442,
     /*  34646 */     GIR_EraseRootFromParent_Done,
     /*  34647 */   // Label 548: @34647
     /*  34647 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34695), // Rule ID 13331 //
     /*  34652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34682 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34693 */     GIR_RootConstrainSelectedInstOperands,
     /*  34694 */     // GIR_Coverage, 13331,
     /*  34694 */     GIR_EraseRootFromParent_Done,
     /*  34695 */   // Label 549: @34695
     /*  34695 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34743), // Rule ID 13417 //
     /*  34700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34730 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34741 */     GIR_RootConstrainSelectedInstOperands,
     /*  34742 */     // GIR_Coverage, 13417,
     /*  34742 */     GIR_EraseRootFromParent_Done,
     /*  34743 */   // Label 550: @34743
     /*  34743 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34791), // Rule ID 13343 //
     /*  34748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34778 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34789 */     GIR_RootConstrainSelectedInstOperands,
     /*  34790 */     // GIR_Coverage, 13343,
     /*  34790 */     GIR_EraseRootFromParent_Done,
     /*  34791 */   // Label 551: @34791
     /*  34791 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34839), // Rule ID 13441 //
     /*  34796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34826 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34837 */     GIR_RootConstrainSelectedInstOperands,
     /*  34838 */     // GIR_Coverage, 13441,
     /*  34838 */     GIR_EraseRootFromParent_Done,
     /*  34839 */   // Label 552: @34839
     /*  34839 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34900), // Rule ID 1724 //
     /*  34844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1724,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 553: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34961), // Rule ID 1814 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34944 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34959 */     GIR_RootConstrainSelectedInstOperands,
     /*  34960 */     // GIR_Coverage, 1814,
     /*  34960 */     GIR_EraseRootFromParent_Done,
     /*  34961 */   // Label 554: @34961
     /*  34961 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35009), // Rule ID 1803 //
     /*  34966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34996 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35007 */     GIR_RootConstrainSelectedInstOperands,
     /*  35008 */     // GIR_Coverage, 1803,
     /*  35008 */     GIR_EraseRootFromParent_Done,
     /*  35009 */   // Label 555: @35009
     /*  35009 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35057), // Rule ID 990 //
     /*  35014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35044 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35055 */     GIR_RootConstrainSelectedInstOperands,
     /*  35056 */     // GIR_Coverage, 990,
     /*  35056 */     GIR_EraseRootFromParent_Done,
     /*  35057 */   // Label 556: @35057
     /*  35057 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35105), // Rule ID 1718 //
     /*  35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35092 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1718,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 557: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35153), // Rule ID 1051 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35140 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35151 */     GIR_RootConstrainSelectedInstOperands,
     /*  35152 */     // GIR_Coverage, 1051,
     /*  35152 */     GIR_EraseRootFromParent_Done,
     /*  35153 */   // Label 558: @35153
     /*  35153 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35201), // Rule ID 1802 //
     /*  35158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35199 */     GIR_RootConstrainSelectedInstOperands,
     /*  35200 */     // GIR_Coverage, 1802,
     /*  35200 */     GIR_EraseRootFromParent_Done,
     /*  35201 */   // Label 559: @35201
     /*  35201 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35228), // Rule ID 1103 //
     /*  35206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35221 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35226 */     GIR_RootConstrainSelectedInstOperands,
     /*  35227 */     // GIR_Coverage, 1103,
     /*  35227 */     GIR_Done,
     /*  35228 */   // Label 560: @35228
     /*  35228 */   GIM_Reject,
     /*  35229 */ // Label 503: @35229
     /*  35229 */ GIM_Reject,
     /*  35230 */ // Label 163: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35953),
     /*  35235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35310), // Rule ID 13366 //
     /*  35246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35293 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 13366,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 562: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35379), // Rule ID 13378 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35362 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35377 */     GIR_RootConstrainSelectedInstOperands,
     /*  35378 */     // GIR_Coverage, 13378,
     /*  35378 */     GIR_EraseRootFromParent_Done,
     /*  35379 */   // Label 563: @35379
     /*  35379 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35446), // Rule ID 13570 //
     /*  35384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     // MIs[1] imm
     /*  35408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35420 */     // MIs[2] Operand 1
     /*  35420 */     // No operand predicates
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35430 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35444 */     GIR_RootConstrainSelectedInstOperands,
     /*  35445 */     // GIR_Coverage, 13570,
     /*  35445 */     GIR_EraseRootFromParent_Done,
     /*  35446 */   // Label 564: @35446
     /*  35446 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35513), // Rule ID 13591 //
     /*  35451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     // MIs[1] imm
     /*  35475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35487 */     // MIs[2] Operand 1
     /*  35487 */     // No operand predicates
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35497 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35511 */     GIR_RootConstrainSelectedInstOperands,
     /*  35512 */     // GIR_Coverage, 13591,
     /*  35512 */     GIR_EraseRootFromParent_Done,
     /*  35513 */   // Label 565: @35513
     /*  35513 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35582), // Rule ID 1359 //
     /*  35518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35537 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35540 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35565 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 1359,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 566: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35651), // Rule ID 1482 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35634 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35649 */     GIR_RootConstrainSelectedInstOperands,
     /*  35650 */     // GIR_Coverage, 1482,
     /*  35650 */     GIR_EraseRootFromParent_Done,
     /*  35651 */   // Label 567: @35651
     /*  35651 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35718), // Rule ID 2232 //
     /*  35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35684 */     // MIs[1] imm
     /*  35684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35696 */     // MIs[2] Operand 1
     /*  35696 */     // No operand predicates
     /*  35696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35702 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 2232,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 568: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35785), // Rule ID 2291 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35751 */     // MIs[1] imm
     /*  35751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35763 */     // MIs[2] Operand 1
     /*  35763 */     // No operand predicates
     /*  35763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35769 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35783 */     GIR_RootConstrainSelectedInstOperands,
     /*  35784 */     // GIR_Coverage, 2291,
     /*  35784 */     GIR_EraseRootFromParent_Done,
     /*  35785 */   // Label 569: @35785
     /*  35785 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35855), // Rule ID 6937 //
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35828 */     // MIs[2] Rn
     /*  35828 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35833 */     // MIs[2] Rm
     /*  35833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35840 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35853 */     GIR_RootConstrainSelectedInstOperands,
     /*  35854 */     // GIR_Coverage, 6937,
     /*  35854 */     GIR_EraseRootFromParent_Done,
     /*  35855 */   // Label 570: @35855
     /*  35855 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35925), // Rule ID 13962 //
     /*  35860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35898 */     // MIs[2] Rn
     /*  35898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35903 */     // MIs[2] Rm
     /*  35903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35910 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35923 */     GIR_RootConstrainSelectedInstOperands,
     /*  35924 */     // GIR_Coverage, 13962,
     /*  35924 */     GIR_EraseRootFromParent_Done,
     /*  35925 */   // Label 571: @35925
     /*  35925 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35952), // Rule ID 1101 //
     /*  35930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35945 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35950 */     GIR_RootConstrainSelectedInstOperands,
     /*  35951 */     // GIR_Coverage, 1101,
     /*  35951 */     GIR_Done,
     /*  35952 */   // Label 572: @35952
     /*  35952 */   GIM_Reject,
     /*  35953 */ // Label 561: @35953
     /*  35953 */ GIM_Reject,
     /*  35954 */ // Label 164: @35954
     /*  35954 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36325),
     /*  35959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35969 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36031), // Rule ID 15146 //
     /*  35974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36005 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36018 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36029 */     GIR_RootConstrainSelectedInstOperands,
     /*  36030 */     // GIR_Coverage, 15146,
     /*  36030 */     GIR_EraseRootFromParent_Done,
     /*  36031 */   // Label 574: @36031
     /*  36031 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36093), // Rule ID 15145 //
     /*  36036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36067 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36080 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36091 */     GIR_RootConstrainSelectedInstOperands,
     /*  36092 */     // GIR_Coverage, 15145,
     /*  36092 */     GIR_EraseRootFromParent_Done,
     /*  36093 */   // Label 575: @36093
     /*  36093 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36155), // Rule ID 15144 //
     /*  36098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36129 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36142 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36153 */     GIR_RootConstrainSelectedInstOperands,
     /*  36154 */     // GIR_Coverage, 15144,
     /*  36154 */     GIR_EraseRootFromParent_Done,
     /*  36155 */   // Label 576: @36155
     /*  36155 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36217), // Rule ID 8912 //
     /*  36160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36191 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36204 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 8912,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 577: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36263), // Rule ID 15147 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36237 */     // MIs[1] Operand 2
     /*  36237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 15147,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 578: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36309), // Rule ID 8913 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36283 */     // MIs[1] Operand 2
     /*  36283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36296 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 8913,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 579: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36324), // Rule ID 2780 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36317 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36322 */     GIR_RootConstrainSelectedInstOperands,
     /*  36323 */     // GIR_Coverage, 2780,
     /*  36323 */     GIR_Done,
     /*  36324 */   // Label 580: @36324
     /*  36324 */   GIM_Reject,
     /*  36325 */ // Label 573: @36325
     /*  36325 */ GIM_Reject,
     /*  36326 */ // Label 165: @36326
     /*  36326 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36351), // Rule ID 2779 //
     /*  36331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36344 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36349 */   GIR_RootConstrainSelectedInstOperands,
     /*  36350 */   // GIR_Coverage, 2779,
     /*  36350 */   GIR_Done,
     /*  36351 */ // Label 581: @36351
     /*  36351 */ GIM_Reject,
     /*  36352 */ // Label 166: @36352
     /*  36352 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36377), // Rule ID 2778 //
     /*  36357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36370 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36375 */   GIR_RootConstrainSelectedInstOperands,
     /*  36376 */   // GIR_Coverage, 2778,
     /*  36376 */   GIR_Done,
     /*  36377 */ // Label 582: @36377
     /*  36377 */ GIM_Reject,
     /*  36378 */ // Label 167: @36378
     /*  36378 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36403), // Rule ID 2777 //
     /*  36383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36396 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36401 */   GIR_RootConstrainSelectedInstOperands,
     /*  36402 */   // GIR_Coverage, 2777,
     /*  36402 */   GIR_Done,
     /*  36403 */ // Label 583: @36403
     /*  36403 */ GIM_Reject,
     /*  36404 */ // Label 168: @36404
     /*  36404 */ GIM_Reject,
     /*  36405 */ // Label 1: @36405
     /*  36405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50632),
     /*  36416 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36504),
     /*  36420 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37986), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41268),
     /*  36432 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42759),
     /*  36436 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45219),
     /*  36440 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46710),
     /*  36444 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49170),
     /*  36448 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49245),
     /*  36452 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50554), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50580), GIMT_Encode4(0),
     /*  36500 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50606),
     /*  36504 */ // Label 584: @36504
     /*  36504 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37985),
     /*  36509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36515 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36667), // Rule ID 9959 //
     /*  36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36559 */     // MIs[2] pattern
     /*  36559 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36562 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36569 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36666 */     // GIR_Coverage, 9959,
     /*  36666 */     GIR_EraseRootFromParent_Done,
     /*  36667 */   // Label 599: @36667
     /*  36667 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36819), // Rule ID 9971 //
     /*  36672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36706 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36711 */     // MIs[2] pattern
     /*  36711 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36714 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36721 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36818 */     // GIR_Coverage, 9971,
     /*  36818 */     GIR_EraseRootFromParent_Done,
     /*  36819 */   // Label 600: @36819
     /*  36819 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36971), // Rule ID 9983 //
     /*  36824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36863 */     // MIs[2] pattern
     /*  36863 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36866 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36873 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36970 */     // GIR_Coverage, 9983,
     /*  36970 */     GIR_EraseRootFromParent_Done,
     /*  36971 */   // Label 601: @36971
     /*  36971 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37123), // Rule ID 9995 //
     /*  36976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37015 */     // MIs[2] pattern
     /*  37015 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37018 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37025 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37051 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37122 */     // GIR_Coverage, 9995,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 602: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37185), // Rule ID 3953 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37164 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37183 */     GIR_RootConstrainSelectedInstOperands,
     /*  37184 */     // GIR_Coverage, 3953,
     /*  37184 */     GIR_EraseRootFromParent_Done,
     /*  37185 */   // Label 603: @37185
     /*  37185 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37342), // Rule ID 10097 //
     /*  37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37221 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37224 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37240 */     // MIs[2] pred
     /*  37240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37247 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37341 */     // GIR_Coverage, 10097,
     /*  37341 */     GIR_EraseRootFromParent_Done,
     /*  37342 */   // Label 604: @37342
     /*  37342 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37499), // Rule ID 10098 //
     /*  37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37381 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37397 */     // MIs[2] pred
     /*  37397 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37404 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37498 */     // GIR_Coverage, 10098,
     /*  37498 */     GIR_EraseRootFromParent_Done,
     /*  37499 */   // Label 605: @37499
     /*  37499 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37656), // Rule ID 10099 //
     /*  37504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37554 */     // MIs[2] pred
     /*  37554 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37655 */     // GIR_Coverage, 10099,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 606: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37813), // Rule ID 10100 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37692 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37695 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37711 */     // MIs[2] pred
     /*  37711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37718 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37812 */     // GIR_Coverage, 10100,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 607: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37849), // Rule ID 3918 //
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37833 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37838 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37847 */     GIR_RootConstrainSelectedInstOperands,
     /*  37848 */     // GIR_Coverage, 3918,
     /*  37848 */     GIR_EraseRootFromParent_Done,
     /*  37849 */   // Label 608: @37849
     /*  37849 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37882), // Rule ID 3923 //
     /*  37854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37869 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37880 */     GIR_RootConstrainSelectedInstOperands,
     /*  37881 */     // GIR_Coverage, 3923,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 609: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37918), // Rule ID 3912 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37902 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37916 */     GIR_RootConstrainSelectedInstOperands,
     /*  37917 */     // GIR_Coverage, 3912,
     /*  37917 */     GIR_EraseRootFromParent_Done,
     /*  37918 */   // Label 610: @37918
     /*  37918 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 3916 //
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37938 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37952 */     GIR_RootConstrainSelectedInstOperands,
     /*  37953 */     // GIR_Coverage, 3916,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37984), // Rule ID 3914 //
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37971 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37976 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37982 */     GIR_RootConstrainSelectedInstOperands,
     /*  37983 */     // GIR_Coverage, 3914,
     /*  37983 */     GIR_Done,
     /*  37984 */   // Label 612: @37984
     /*  37984 */   GIM_Reject,
     /*  37985 */ // Label 598: @37985
     /*  37985 */ GIM_Reject,
     /*  37986 */ // Label 585: @37986
     /*  37986 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41267),
     /*  37991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38133), // Rule ID 5401 //
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38035 */     // MIs[1] Operand 2
     /*  38035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38070 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38075 */     // MIs[3] Operand 2
     /*  38075 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38088 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38132 */     // GIR_Coverage, 5401,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 614: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38269), // Rule ID 5400 //
     /*  38138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38171 */     // MIs[1] Operand 2
     /*  38171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38202 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38206 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38211 */     // MIs[3] Operand 2
     /*  38211 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38224 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38268 */     // GIR_Coverage, 5400,
     /*  38268 */     GIR_EraseRootFromParent_Done,
     /*  38269 */   // Label 615: @38269
     /*  38269 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38405), // Rule ID 5410 //
     /*  38274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38307 */     // MIs[1] Operand 2
     /*  38307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38342 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38347 */     // MIs[3] Operand 2
     /*  38347 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38360 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38404 */     // GIR_Coverage, 5410,
     /*  38404 */     GIR_EraseRootFromParent_Done,
     /*  38405 */   // Label 616: @38405
     /*  38405 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38541), // Rule ID 5399 //
     /*  38410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38443 */     // MIs[1] Operand 2
     /*  38443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38478 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38483 */     // MIs[3] Operand 2
     /*  38483 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38496 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38540 */     // GIR_Coverage, 5399,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 617: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38677), // Rule ID 5398 //
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38579 */     // MIs[1] Operand 2
     /*  38579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38614 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38619 */     // MIs[3] Operand 2
     /*  38619 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38632 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38676 */     // GIR_Coverage, 5398,
     /*  38676 */     GIR_EraseRootFromParent_Done,
     /*  38677 */   // Label 618: @38677
     /*  38677 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38814), // Rule ID 3970 //
     /*  38682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38723 */     // MIs[2] Operand 2
     /*  38723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38746 */     // MIs[3] Operand 1
     /*  38746 */     // No operand predicates
     /*  38746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38748 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 3970,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 619: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38913), // Rule ID 3968 //
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38872 */     // MIs[3] Operand 1
     /*  38872 */     // No operand predicates
     /*  38872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38874 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38886 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 3968,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 620: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39012), // Rule ID 3969 //
     /*  38918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38971 */     // MIs[3] Operand 1
     /*  38971 */     // No operand predicates
     /*  38971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38973 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38985 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39010 */     GIR_RootConstrainSelectedInstOperands,
     /*  39011 */     // GIR_Coverage, 3969,
     /*  39011 */     GIR_EraseRootFromParent_Done,
     /*  39012 */   // Label 621: @39012
     /*  39012 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39098), // Rule ID 3963 //
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39077 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39096 */     GIR_RootConstrainSelectedInstOperands,
     /*  39097 */     // GIR_Coverage, 3963,
     /*  39097 */     GIR_EraseRootFromParent_Done,
     /*  39098 */   // Label 622: @39098
     /*  39098 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39184), // Rule ID 3964 //
     /*  39103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39163 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39182 */     GIR_RootConstrainSelectedInstOperands,
     /*  39183 */     // GIR_Coverage, 3964,
     /*  39183 */     GIR_EraseRootFromParent_Done,
     /*  39184 */   // Label 623: @39184
     /*  39184 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39317), // Rule ID 3976 //
     /*  39189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39230 */     // MIs[2] Operand 2
     /*  39230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39253 */     // MIs[3] Operand 1
     /*  39253 */     // No operand predicates
     /*  39253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39255 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39267 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 3976,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 624: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39412), // Rule ID 3974 //
     /*  39322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39375 */     // MIs[3] Operand 1
     /*  39375 */     // No operand predicates
     /*  39375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39377 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39389 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39410 */     GIR_RootConstrainSelectedInstOperands,
     /*  39411 */     // GIR_Coverage, 3974,
     /*  39411 */     GIR_EraseRootFromParent_Done,
     /*  39412 */   // Label 625: @39412
     /*  39412 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39507), // Rule ID 3975 //
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39470 */     // MIs[3] Operand 1
     /*  39470 */     // No operand predicates
     /*  39470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39472 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39484 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39505 */     GIR_RootConstrainSelectedInstOperands,
     /*  39506 */     // GIR_Coverage, 3975,
     /*  39506 */     GIR_EraseRootFromParent_Done,
     /*  39507 */   // Label 626: @39507
     /*  39507 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39589), // Rule ID 124 //
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39572 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39587 */     GIR_RootConstrainSelectedInstOperands,
     /*  39588 */     // GIR_Coverage, 124,
     /*  39588 */     GIR_EraseRootFromParent_Done,
     /*  39589 */   // Label 627: @39589
     /*  39589 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39671), // Rule ID 126 //
     /*  39594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39654 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39669 */     GIR_RootConstrainSelectedInstOperands,
     /*  39670 */     // GIR_Coverage, 126,
     /*  39670 */     GIR_EraseRootFromParent_Done,
     /*  39671 */   // Label 628: @39671
     /*  39671 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39733), // Rule ID 3954 //
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39712 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 3954,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 629: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39791), // Rule ID 9956 //
     /*  39738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39765 */     // MIs[1] pattern
     /*  39765 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39768 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39775 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39789 */     GIR_RootConstrainSelectedInstOperands,
     /*  39790 */     // GIR_Coverage, 9956,
     /*  39790 */     GIR_EraseRootFromParent_Done,
     /*  39791 */   // Label 630: @39791
     /*  39791 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39849), // Rule ID 9968 //
     /*  39796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39815 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39818 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39823 */     // MIs[1] pattern
     /*  39823 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39826 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39833 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 9968,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 631: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39907), // Rule ID 9980 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39881 */     // MIs[1] pattern
     /*  39881 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39884 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39891 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 9980,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 632: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39965), // Rule ID 9992 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39939 */     // MIs[1] pattern
     /*  39939 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39942 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39949 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 9992,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 633: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40128), // Rule ID 5365 //
     /*  39970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40016 */     // MIs[1] Operand 2
     /*  40016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40029 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40127 */     // GIR_Coverage, 5365,
     /*  40127 */     GIR_EraseRootFromParent_Done,
     /*  40128 */   // Label 634: @40128
     /*  40128 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40291), // Rule ID 5362 //
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40179 */     // MIs[1] Operand 2
     /*  40179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40192 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40290 */     // GIR_Coverage, 5362,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 635: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40441), // Rule ID 5407 //
     /*  40296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40333 */     // MIs[1] Operand 2
     /*  40333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40346 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40440 */     // GIR_Coverage, 5407,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 636: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40591), // Rule ID 5413 //
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40483 */     // MIs[1] Operand 2
     /*  40483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40590 */     // GIR_Coverage, 5413,
     /*  40590 */     GIR_EraseRootFromParent_Done,
     /*  40591 */   // Label 637: @40591
     /*  40591 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40741), // Rule ID 5406 //
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40633 */     // MIs[1] Operand 2
     /*  40633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40646 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40740 */     // GIR_Coverage, 5406,
     /*  40740 */     GIR_EraseRootFromParent_Done,
     /*  40741 */   // Label 638: @40741
     /*  40741 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40777), // Rule ID 3919 //
     /*  40746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40761 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40775 */     GIR_RootConstrainSelectedInstOperands,
     /*  40776 */     // GIR_Coverage, 3919,
     /*  40776 */     GIR_EraseRootFromParent_Done,
     /*  40777 */   // Label 639: @40777
     /*  40777 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40810), // Rule ID 3924 //
     /*  40782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40797 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40808 */     GIR_RootConstrainSelectedInstOperands,
     /*  40809 */     // GIR_Coverage, 3924,
     /*  40809 */     GIR_EraseRootFromParent_Done,
     /*  40810 */   // Label 640: @40810
     /*  40810 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40846), // Rule ID 3913 //
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40830 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 3913,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 641: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40882), // Rule ID 3917 //
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40880 */     GIR_RootConstrainSelectedInstOperands,
     /*  40881 */     // GIR_Coverage, 3917,
     /*  40881 */     GIR_EraseRootFromParent_Done,
     /*  40882 */   // Label 642: @40882
     /*  40882 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40945), // Rule ID 10089 //
     /*  40887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40925 */     // MIs[1] pred
     /*  40925 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40932 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40943 */     GIR_RootConstrainSelectedInstOperands,
     /*  40944 */     // GIR_Coverage, 10089,
     /*  40944 */     GIR_EraseRootFromParent_Done,
     /*  40945 */   // Label 643: @40945
     /*  40945 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 10090 //
     /*  40950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40988 */     // MIs[1] pred
     /*  40988 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 10090,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41071), // Rule ID 10091 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41051 */     // MIs[1] pred
     /*  41051 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41058 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41069 */     GIR_RootConstrainSelectedInstOperands,
     /*  41070 */     // GIR_Coverage, 10091,
     /*  41070 */     GIR_EraseRootFromParent_Done,
     /*  41071 */   // Label 645: @41071
     /*  41071 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41134), // Rule ID 10092 //
     /*  41076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41114 */     // MIs[1] pred
     /*  41114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41121 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 10092,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 646: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41173), // Rule ID 1655 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41164 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41171 */     GIR_RootConstrainSelectedInstOperands,
     /*  41172 */     // GIR_Coverage, 1655,
     /*  41172 */     GIR_EraseRootFromParent_Done,
     /*  41173 */   // Label 647: @41173
     /*  41173 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41209), // Rule ID 5248 //
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41200 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41207 */     GIR_RootConstrainSelectedInstOperands,
     /*  41208 */     // GIR_Coverage, 5248,
     /*  41208 */     GIR_EraseRootFromParent_Done,
     /*  41209 */   // Label 648: @41209
     /*  41209 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41236), // Rule ID 1644 //
     /*  41214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41229 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1644,
     /*  41235 */     GIR_Done,
     /*  41236 */   // Label 649: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41266), // Rule ID 3915 //
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41253 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41264 */     GIR_RootConstrainSelectedInstOperands,
     /*  41265 */     // GIR_Coverage, 3915,
     /*  41265 */     GIR_Done,
     /*  41266 */   // Label 650: @41266
     /*  41266 */   GIM_Reject,
     /*  41267 */ // Label 613: @41267
     /*  41267 */ GIM_Reject,
     /*  41268 */ // Label 586: @41268
     /*  41268 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42758),
     /*  41273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41415), // Rule ID 5397 //
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41317 */     // MIs[1] Operand 2
     /*  41317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41348 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41352 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41357 */     // MIs[3] Operand 2
     /*  41357 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41370 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5397,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 652: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41547), // Rule ID 5396 //
     /*  41420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41449 */     // MIs[1] Operand 2
     /*  41449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41489 */     // MIs[3] Operand 2
     /*  41489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41502 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41546 */     // GIR_Coverage, 5396,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 653: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41679), // Rule ID 5409 //
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41581 */     // MIs[1] Operand 2
     /*  41581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     // MIs[3] Operand 2
     /*  41621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41634 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41678 */     // GIR_Coverage, 5409,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 654: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41811), // Rule ID 5395 //
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41713 */     // MIs[1] Operand 2
     /*  41713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     // MIs[3] Operand 2
     /*  41753 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41766 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41810 */     // GIR_Coverage, 5395,
     /*  41810 */     GIR_EraseRootFromParent_Done,
     /*  41811 */   // Label 655: @41811
     /*  41811 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41943), // Rule ID 5394 //
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41845 */     // MIs[1] Operand 2
     /*  41845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     // MIs[3] Operand 2
     /*  41885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41898 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41942 */     // GIR_Coverage, 5394,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 656: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42102), // Rule ID 5364 //
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41990 */     // MIs[1] Operand 2
     /*  41990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42003 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42101 */     // GIR_Coverage, 5364,
     /*  42101 */     GIR_EraseRootFromParent_Done,
     /*  42102 */   // Label 657: @42102
     /*  42102 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42261), // Rule ID 5361 //
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     // MIs[1] Operand 2
     /*  42149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42162 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42260 */     // GIR_Coverage, 5361,
     /*  42260 */     GIR_EraseRootFromParent_Done,
     /*  42261 */   // Label 658: @42261
     /*  42261 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42407), // Rule ID 5405 //
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42299 */     // MIs[1] Operand 2
     /*  42299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42312 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42338 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42406 */     // GIR_Coverage, 5405,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 659: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42553), // Rule ID 5412 //
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42445 */     // MIs[1] Operand 2
     /*  42445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42458 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42552 */     // GIR_Coverage, 5412,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 660: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42699), // Rule ID 5404 //
     /*  42558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42591 */     // MIs[1] Operand 2
     /*  42591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42604 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42604 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42607 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42611 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42630 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42698 */     // GIR_Coverage, 5404,
     /*  42698 */     GIR_EraseRootFromParent_Done,
     /*  42699 */   // Label 661: @42699
     /*  42699 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42734), // Rule ID 969 //
     /*  42704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42725 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 969,
     /*  42733 */     GIR_EraseRootFromParent_Done,
     /*  42734 */   // Label 662: @42734
     /*  42734 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42757), // Rule ID 1476 //
     /*  42739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42750 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 1476,
     /*  42756 */     GIR_Done,
     /*  42757 */   // Label 663: @42757
     /*  42757 */   GIM_Reject,
     /*  42758 */ // Label 651: @42758
     /*  42758 */ GIM_Reject,
     /*  42759 */ // Label 587: @42759
     /*  42759 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45218),
     /*  42764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42774 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42888), // Rule ID 2048 //
     /*  42779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42847 */     // MIs[4] Operand 1
     /*  42847 */     // No operand predicates
     /*  42847 */     // MIs[2] Operand 2
     /*  42847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42867 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42886 */     GIR_RootConstrainSelectedInstOperands,
     /*  42887 */     // GIR_Coverage, 2048,
     /*  42887 */     GIR_EraseRootFromParent_Done,
     /*  42888 */   // Label 665: @42888
     /*  42888 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43002), // Rule ID 13518 //
     /*  42893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42961 */     // MIs[4] Operand 1
     /*  42961 */     // No operand predicates
     /*  42961 */     // MIs[2] Operand 2
     /*  42961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42981 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43000 */     GIR_RootConstrainSelectedInstOperands,
     /*  43001 */     // GIR_Coverage, 13518,
     /*  43001 */     GIR_EraseRootFromParent_Done,
     /*  43002 */   // Label 666: @43002
     /*  43002 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43116), // Rule ID 2100 //
     /*  43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43075 */     // MIs[4] Operand 1
     /*  43075 */     // No operand predicates
     /*  43075 */     // MIs[2] Operand 2
     /*  43075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43095 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 2100,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 667: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43230), // Rule ID 13548 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43189 */     // MIs[4] Operand 1
     /*  43189 */     // No operand predicates
     /*  43189 */     // MIs[2] Operand 2
     /*  43189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43209 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43228 */     GIR_RootConstrainSelectedInstOperands,
     /*  43229 */     // GIR_Coverage, 13548,
     /*  43229 */     GIR_EraseRootFromParent_Done,
     /*  43230 */   // Label 668: @43230
     /*  43230 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43295), // Rule ID 1855 //
     /*  43235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43278 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43293 */     GIR_RootConstrainSelectedInstOperands,
     /*  43294 */     // GIR_Coverage, 1855,
     /*  43294 */     GIR_EraseRootFromParent_Done,
     /*  43295 */   // Label 669: @43295
     /*  43295 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43360), // Rule ID 1854 //
     /*  43300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43358 */     GIR_RootConstrainSelectedInstOperands,
     /*  43359 */     // GIR_Coverage, 1854,
     /*  43359 */     GIR_EraseRootFromParent_Done,
     /*  43360 */   // Label 670: @43360
     /*  43360 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43425), // Rule ID 1759 //
     /*  43365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43408 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43423 */     GIR_RootConstrainSelectedInstOperands,
     /*  43424 */     // GIR_Coverage, 1759,
     /*  43424 */     GIR_EraseRootFromParent_Done,
     /*  43425 */   // Label 671: @43425
     /*  43425 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43490), // Rule ID 1853 //
     /*  43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43473 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43488 */     GIR_RootConstrainSelectedInstOperands,
     /*  43489 */     // GIR_Coverage, 1853,
     /*  43489 */     GIR_EraseRootFromParent_Done,
     /*  43490 */   // Label 672: @43490
     /*  43490 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43555), // Rule ID 1852 //
     /*  43495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43538 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43553 */     GIR_RootConstrainSelectedInstOperands,
     /*  43554 */     // GIR_Coverage, 1852,
     /*  43554 */     GIR_EraseRootFromParent_Done,
     /*  43555 */   // Label 673: @43555
     /*  43555 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43666), // Rule ID 13516 //
     /*  43560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43628 */     // MIs[4] Operand 1
     /*  43628 */     // No operand predicates
     /*  43628 */     // MIs[2] Operand 2
     /*  43628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43646 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43664 */     GIR_RootConstrainSelectedInstOperands,
     /*  43665 */     // GIR_Coverage, 13516,
     /*  43665 */     GIR_EraseRootFromParent_Done,
     /*  43666 */   // Label 674: @43666
     /*  43666 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43777), // Rule ID 2046 //
     /*  43671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43744 */     // MIs[4] Operand 1
     /*  43744 */     // No operand predicates
     /*  43744 */     // MIs[2] Operand 2
     /*  43744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43757 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43775 */     GIR_RootConstrainSelectedInstOperands,
     /*  43776 */     // GIR_Coverage, 2046,
     /*  43776 */     GIR_EraseRootFromParent_Done,
     /*  43777 */   // Label 675: @43777
     /*  43777 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43888), // Rule ID 13546 //
     /*  43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43850 */     // MIs[4] Operand 1
     /*  43850 */     // No operand predicates
     /*  43850 */     // MIs[2] Operand 2
     /*  43850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43868 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43886 */     GIR_RootConstrainSelectedInstOperands,
     /*  43887 */     // GIR_Coverage, 13546,
     /*  43887 */     GIR_EraseRootFromParent_Done,
     /*  43888 */   // Label 676: @43888
     /*  43888 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43999), // Rule ID 2098 //
     /*  43893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43966 */     // MIs[4] Operand 1
     /*  43966 */     // No operand predicates
     /*  43966 */     // MIs[2] Operand 2
     /*  43966 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43979 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43997 */     GIR_RootConstrainSelectedInstOperands,
     /*  43998 */     // GIR_Coverage, 2098,
     /*  43998 */     GIR_EraseRootFromParent_Done,
     /*  43999 */   // Label 677: @43999
     /*  43999 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44062), // Rule ID 1735 //
     /*  44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44060 */     GIR_RootConstrainSelectedInstOperands,
     /*  44061 */     // GIR_Coverage, 1735,
     /*  44061 */     GIR_EraseRootFromParent_Done,
     /*  44062 */   // Label 678: @44062
     /*  44062 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44125), // Rule ID 1825 //
     /*  44067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44106 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44123 */     GIR_RootConstrainSelectedInstOperands,
     /*  44124 */     // GIR_Coverage, 1825,
     /*  44124 */     GIR_EraseRootFromParent_Done,
     /*  44125 */   // Label 679: @44125
     /*  44125 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44213), // Rule ID 13517 //
     /*  44130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44186 */     // MIs[3] Operand 1
     /*  44186 */     // No operand predicates
     /*  44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44211 */     GIR_RootConstrainSelectedInstOperands,
     /*  44212 */     // GIR_Coverage, 13517,
     /*  44212 */     GIR_EraseRootFromParent_Done,
     /*  44213 */   // Label 680: @44213
     /*  44213 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44301), // Rule ID 2047 //
     /*  44218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44279 */     // MIs[3] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44299 */     GIR_RootConstrainSelectedInstOperands,
     /*  44300 */     // GIR_Coverage, 2047,
     /*  44300 */     GIR_EraseRootFromParent_Done,
     /*  44301 */   // Label 681: @44301
     /*  44301 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44389), // Rule ID 13547 //
     /*  44306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44362 */     // MIs[3] Operand 1
     /*  44362 */     // No operand predicates
     /*  44362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44369 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44387 */     GIR_RootConstrainSelectedInstOperands,
     /*  44388 */     // GIR_Coverage, 13547,
     /*  44388 */     GIR_EraseRootFromParent_Done,
     /*  44389 */   // Label 682: @44389
     /*  44389 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44477), // Rule ID 2099 //
     /*  44394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44455 */     // MIs[3] Operand 1
     /*  44455 */     // No operand predicates
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2099,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 683: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44524), // Rule ID 1867 //
     /*  44482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44510 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44522 */     GIR_RootConstrainSelectedInstOperands,
     /*  44523 */     // GIR_Coverage, 1867,
     /*  44523 */     GIR_EraseRootFromParent_Done,
     /*  44524 */   // Label 684: @44524
     /*  44524 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44571), // Rule ID 1765 //
     /*  44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44569 */     GIR_RootConstrainSelectedInstOperands,
     /*  44570 */     // GIR_Coverage, 1765,
     /*  44570 */     GIR_EraseRootFromParent_Done,
     /*  44571 */   // Label 685: @44571
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44618), // Rule ID 1866 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44604 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44616 */     GIR_RootConstrainSelectedInstOperands,
     /*  44617 */     // GIR_Coverage, 1866,
     /*  44617 */     GIR_EraseRootFromParent_Done,
     /*  44618 */   // Label 686: @44618
     /*  44618 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44677), // Rule ID 1851 //
     /*  44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44662 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1851,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 687: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44736), // Rule ID 1850 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44721 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1850,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 688: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44795), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44780 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1758,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 689: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44854), // Rule ID 1849 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44852 */     GIR_RootConstrainSelectedInstOperands,
     /*  44853 */     // GIR_Coverage, 1849,
     /*  44853 */     GIR_EraseRootFromParent_Done,
     /*  44854 */   // Label 690: @44854
     /*  44854 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44913), // Rule ID 1848 //
     /*  44859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44898 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44911 */     GIR_RootConstrainSelectedInstOperands,
     /*  44912 */     // GIR_Coverage, 1848,
     /*  44912 */     GIR_EraseRootFromParent_Done,
     /*  44913 */   // Label 691: @44913
     /*  44913 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44948), // Rule ID 971 //
     /*  44918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44939 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 971,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 692: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45005), // Rule ID 1734 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44988 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45003 */     GIR_RootConstrainSelectedInstOperands,
     /*  45004 */     // GIR_Coverage, 1734,
     /*  45004 */     GIR_EraseRootFromParent_Done,
     /*  45005 */   // Label 693: @45005
     /*  45005 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45062), // Rule ID 1824 //
     /*  45010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45045 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1824,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 694: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45106), // Rule ID 1865 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45093 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45104 */     GIR_RootConstrainSelectedInstOperands,
     /*  45105 */     // GIR_Coverage, 1865,
     /*  45105 */     GIR_EraseRootFromParent_Done,
     /*  45106 */   // Label 695: @45106
     /*  45106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45150), // Rule ID 1764 //
     /*  45111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45148 */     GIR_RootConstrainSelectedInstOperands,
     /*  45149 */     // GIR_Coverage, 1764,
     /*  45149 */     GIR_EraseRootFromParent_Done,
     /*  45150 */   // Label 696: @45150
     /*  45150 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45194), // Rule ID 1864 //
     /*  45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45192 */     GIR_RootConstrainSelectedInstOperands,
     /*  45193 */     // GIR_Coverage, 1864,
     /*  45193 */     GIR_EraseRootFromParent_Done,
     /*  45194 */   // Label 697: @45194
     /*  45194 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45217), // Rule ID 1478 //
     /*  45199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45210 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1478,
     /*  45216 */     GIR_Done,
     /*  45217 */   // Label 698: @45217
     /*  45217 */   GIM_Reject,
     /*  45218 */ // Label 664: @45218
     /*  45218 */ GIM_Reject,
     /*  45219 */ // Label 588: @45219
     /*  45219 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46709),
     /*  45224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45234 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45366), // Rule ID 5393 //
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45268 */     // MIs[1] Operand 2
     /*  45268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45308 */     // MIs[3] Operand 2
     /*  45308 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45321 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45365 */     // GIR_Coverage, 5393,
     /*  45365 */     GIR_EraseRootFromParent_Done,
     /*  45366 */   // Label 700: @45366
     /*  45366 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45498), // Rule ID 5392 //
     /*  45371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45400 */     // MIs[1] Operand 2
     /*  45400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45440 */     // MIs[3] Operand 2
     /*  45440 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45453 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45497 */     // GIR_Coverage, 5392,
     /*  45497 */     GIR_EraseRootFromParent_Done,
     /*  45498 */   // Label 701: @45498
     /*  45498 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45630), // Rule ID 5408 //
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45532 */     // MIs[1] Operand 2
     /*  45532 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45567 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     // MIs[3] Operand 2
     /*  45572 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45585 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45629 */     // GIR_Coverage, 5408,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 702: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45762), // Rule ID 5391 //
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45664 */     // MIs[1] Operand 2
     /*  45664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     // MIs[3] Operand 2
     /*  45704 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45717 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45761 */     // GIR_Coverage, 5391,
     /*  45761 */     GIR_EraseRootFromParent_Done,
     /*  45762 */   // Label 703: @45762
     /*  45762 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45894), // Rule ID 5390 //
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45796 */     // MIs[1] Operand 2
     /*  45796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     // MIs[3] Operand 2
     /*  45836 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45849 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45893 */     // GIR_Coverage, 5390,
     /*  45893 */     GIR_EraseRootFromParent_Done,
     /*  45894 */   // Label 704: @45894
     /*  45894 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46053), // Rule ID 5363 //
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45941 */     // MIs[1] Operand 2
     /*  45941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45954 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45980 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45987 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46052 */     // GIR_Coverage, 5363,
     /*  46052 */     GIR_EraseRootFromParent_Done,
     /*  46053 */   // Label 705: @46053
     /*  46053 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46212), // Rule ID 5360 //
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     // MIs[1] Operand 2
     /*  46100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46113 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46146 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46194 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46211 */     // GIR_Coverage, 5360,
     /*  46211 */     GIR_EraseRootFromParent_Done,
     /*  46212 */   // Label 706: @46212
     /*  46212 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46358), // Rule ID 5403 //
     /*  46217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46250 */     // MIs[1] Operand 2
     /*  46250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46263 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46357 */     // GIR_Coverage, 5403,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 707: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46504), // Rule ID 5411 //
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46396 */     // MIs[1] Operand 2
     /*  46396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46409 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46435 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46503 */     // GIR_Coverage, 5411,
     /*  46503 */     GIR_EraseRootFromParent_Done,
     /*  46504 */   // Label 708: @46504
     /*  46504 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46650), // Rule ID 5402 //
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46542 */     // MIs[1] Operand 2
     /*  46542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46555 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46649 */     // GIR_Coverage, 5402,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 709: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46685), // Rule ID 967 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46676 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46683 */     GIR_RootConstrainSelectedInstOperands,
     /*  46684 */     // GIR_Coverage, 967,
     /*  46684 */     GIR_EraseRootFromParent_Done,
     /*  46685 */   // Label 710: @46685
     /*  46685 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46708), // Rule ID 1474 //
     /*  46690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46701 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46706 */     GIR_RootConstrainSelectedInstOperands,
     /*  46707 */     // GIR_Coverage, 1474,
     /*  46707 */     GIR_Done,
     /*  46708 */   // Label 711: @46708
     /*  46708 */   GIM_Reject,
     /*  46709 */ // Label 699: @46709
     /*  46709 */ GIM_Reject,
     /*  46710 */ // Label 589: @46710
     /*  46710 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49169),
     /*  46715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46725 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46839), // Rule ID 2045 //
     /*  46730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46798 */     // MIs[4] Operand 1
     /*  46798 */     // No operand predicates
     /*  46798 */     // MIs[2] Operand 2
     /*  46798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46818 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46837 */     GIR_RootConstrainSelectedInstOperands,
     /*  46838 */     // GIR_Coverage, 2045,
     /*  46838 */     GIR_EraseRootFromParent_Done,
     /*  46839 */   // Label 713: @46839
     /*  46839 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46953), // Rule ID 13515 //
     /*  46844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46908 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46912 */     // MIs[4] Operand 1
     /*  46912 */     // No operand predicates
     /*  46912 */     // MIs[2] Operand 2
     /*  46912 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46932 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 13515,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 714: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47067), // Rule ID 2097 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47022 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47026 */     // MIs[4] Operand 1
     /*  47026 */     // No operand predicates
     /*  47026 */     // MIs[2] Operand 2
     /*  47026 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47046 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47065 */     GIR_RootConstrainSelectedInstOperands,
     /*  47066 */     // GIR_Coverage, 2097,
     /*  47066 */     GIR_EraseRootFromParent_Done,
     /*  47067 */   // Label 715: @47067
     /*  47067 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47181), // Rule ID 13545 //
     /*  47072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47136 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47140 */     // MIs[4] Operand 1
     /*  47140 */     // No operand predicates
     /*  47140 */     // MIs[2] Operand 2
     /*  47140 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47160 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47179 */     GIR_RootConstrainSelectedInstOperands,
     /*  47180 */     // GIR_Coverage, 13545,
     /*  47180 */     GIR_EraseRootFromParent_Done,
     /*  47181 */   // Label 716: @47181
     /*  47181 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47246), // Rule ID 1847 //
     /*  47186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47229 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47244 */     GIR_RootConstrainSelectedInstOperands,
     /*  47245 */     // GIR_Coverage, 1847,
     /*  47245 */     GIR_EraseRootFromParent_Done,
     /*  47246 */   // Label 717: @47246
     /*  47246 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47311), // Rule ID 1846 //
     /*  47251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47294 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47309 */     GIR_RootConstrainSelectedInstOperands,
     /*  47310 */     // GIR_Coverage, 1846,
     /*  47310 */     GIR_EraseRootFromParent_Done,
     /*  47311 */   // Label 718: @47311
     /*  47311 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47376), // Rule ID 1757 //
     /*  47316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47359 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47374 */     GIR_RootConstrainSelectedInstOperands,
     /*  47375 */     // GIR_Coverage, 1757,
     /*  47375 */     GIR_EraseRootFromParent_Done,
     /*  47376 */   // Label 719: @47376
     /*  47376 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47441), // Rule ID 1845 //
     /*  47381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47424 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 1845,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 720: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47506), // Rule ID 1844 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47489 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47504 */     GIR_RootConstrainSelectedInstOperands,
     /*  47505 */     // GIR_Coverage, 1844,
     /*  47505 */     GIR_EraseRootFromParent_Done,
     /*  47506 */   // Label 721: @47506
     /*  47506 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47617), // Rule ID 13513 //
     /*  47511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47571 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47575 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47579 */     // MIs[4] Operand 1
     /*  47579 */     // No operand predicates
     /*  47579 */     // MIs[2] Operand 2
     /*  47579 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47597 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47615 */     GIR_RootConstrainSelectedInstOperands,
     /*  47616 */     // GIR_Coverage, 13513,
     /*  47616 */     GIR_EraseRootFromParent_Done,
     /*  47617 */   // Label 722: @47617
     /*  47617 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47728), // Rule ID 2043 //
     /*  47622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47695 */     // MIs[4] Operand 1
     /*  47695 */     // No operand predicates
     /*  47695 */     // MIs[2] Operand 2
     /*  47695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47708 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 2043,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 723: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47839), // Rule ID 13543 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47801 */     // MIs[4] Operand 1
     /*  47801 */     // No operand predicates
     /*  47801 */     // MIs[2] Operand 2
     /*  47801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47819 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 13543,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 724: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47950), // Rule ID 2095 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47913 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47917 */     // MIs[4] Operand 1
     /*  47917 */     // No operand predicates
     /*  47917 */     // MIs[2] Operand 2
     /*  47917 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47930 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47948 */     GIR_RootConstrainSelectedInstOperands,
     /*  47949 */     // GIR_Coverage, 2095,
     /*  47949 */     GIR_EraseRootFromParent_Done,
     /*  47950 */   // Label 725: @47950
     /*  47950 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48013), // Rule ID 1733 //
     /*  47955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48011 */     GIR_RootConstrainSelectedInstOperands,
     /*  48012 */     // GIR_Coverage, 1733,
     /*  48012 */     GIR_EraseRootFromParent_Done,
     /*  48013 */   // Label 726: @48013
     /*  48013 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48076), // Rule ID 1823 //
     /*  48018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48057 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48074 */     GIR_RootConstrainSelectedInstOperands,
     /*  48075 */     // GIR_Coverage, 1823,
     /*  48075 */     GIR_EraseRootFromParent_Done,
     /*  48076 */   // Label 727: @48076
     /*  48076 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48164), // Rule ID 13514 //
     /*  48081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48137 */     // MIs[3] Operand 1
     /*  48137 */     // No operand predicates
     /*  48137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48162 */     GIR_RootConstrainSelectedInstOperands,
     /*  48163 */     // GIR_Coverage, 13514,
     /*  48163 */     GIR_EraseRootFromParent_Done,
     /*  48164 */   // Label 728: @48164
     /*  48164 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48252), // Rule ID 2044 //
     /*  48169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48230 */     // MIs[3] Operand 1
     /*  48230 */     // No operand predicates
     /*  48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48250 */     GIR_RootConstrainSelectedInstOperands,
     /*  48251 */     // GIR_Coverage, 2044,
     /*  48251 */     GIR_EraseRootFromParent_Done,
     /*  48252 */   // Label 729: @48252
     /*  48252 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48340), // Rule ID 13544 //
     /*  48257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48313 */     // MIs[3] Operand 1
     /*  48313 */     // No operand predicates
     /*  48313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48320 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 13544,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 730: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48428), // Rule ID 2096 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48406 */     // MIs[3] Operand 1
     /*  48406 */     // No operand predicates
     /*  48406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48426 */     GIR_RootConstrainSelectedInstOperands,
     /*  48427 */     // GIR_Coverage, 2096,
     /*  48427 */     GIR_EraseRootFromParent_Done,
     /*  48428 */   // Label 731: @48428
     /*  48428 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48475), // Rule ID 1863 //
     /*  48433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48461 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48473 */     GIR_RootConstrainSelectedInstOperands,
     /*  48474 */     // GIR_Coverage, 1863,
     /*  48474 */     GIR_EraseRootFromParent_Done,
     /*  48475 */   // Label 732: @48475
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48522), // Rule ID 1763 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48520 */     GIR_RootConstrainSelectedInstOperands,
     /*  48521 */     // GIR_Coverage, 1763,
     /*  48521 */     GIR_EraseRootFromParent_Done,
     /*  48522 */   // Label 733: @48522
     /*  48522 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48569), // Rule ID 1862 //
     /*  48527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48555 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 1862,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 734: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48628), // Rule ID 1843 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1843,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 735: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48687), // Rule ID 1842 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48672 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1842,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 736: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48746), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48731 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 1756,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 737: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48805), // Rule ID 1841 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48790 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48803 */     GIR_RootConstrainSelectedInstOperands,
     /*  48804 */     // GIR_Coverage, 1841,
     /*  48804 */     GIR_EraseRootFromParent_Done,
     /*  48805 */   // Label 738: @48805
     /*  48805 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48864), // Rule ID 1840 //
     /*  48810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48849 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48862 */     GIR_RootConstrainSelectedInstOperands,
     /*  48863 */     // GIR_Coverage, 1840,
     /*  48863 */     GIR_EraseRootFromParent_Done,
     /*  48864 */   // Label 739: @48864
     /*  48864 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48899), // Rule ID 970 //
     /*  48869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48890 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 970,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 740: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48956), // Rule ID 1732 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48939 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48954 */     GIR_RootConstrainSelectedInstOperands,
     /*  48955 */     // GIR_Coverage, 1732,
     /*  48955 */     GIR_EraseRootFromParent_Done,
     /*  48956 */   // Label 741: @48956
     /*  48956 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49013), // Rule ID 1822 //
     /*  48961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48996 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 1822,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 742: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49057), // Rule ID 1861 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49044 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49055 */     GIR_RootConstrainSelectedInstOperands,
     /*  49056 */     // GIR_Coverage, 1861,
     /*  49056 */     GIR_EraseRootFromParent_Done,
     /*  49057 */   // Label 743: @49057
     /*  49057 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49101), // Rule ID 1762 //
     /*  49062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1762,
     /*  49100 */     GIR_EraseRootFromParent_Done,
     /*  49101 */   // Label 744: @49101
     /*  49101 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49145), // Rule ID 1860 //
     /*  49106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49143 */     GIR_RootConstrainSelectedInstOperands,
     /*  49144 */     // GIR_Coverage, 1860,
     /*  49144 */     GIR_EraseRootFromParent_Done,
     /*  49145 */   // Label 745: @49145
     /*  49145 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49168), // Rule ID 1477 //
     /*  49150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49161 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1477,
     /*  49167 */     GIR_Done,
     /*  49168 */   // Label 746: @49168
     /*  49168 */   GIM_Reject,
     /*  49169 */ // Label 712: @49169
     /*  49169 */ GIM_Reject,
     /*  49170 */ // Label 590: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49244),
     /*  49175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49185 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49220), // Rule ID 965 //
     /*  49190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49211 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49218 */     GIR_RootConstrainSelectedInstOperands,
     /*  49219 */     // GIR_Coverage, 965,
     /*  49219 */     GIR_EraseRootFromParent_Done,
     /*  49220 */   // Label 748: @49220
     /*  49220 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49243), // Rule ID 1472 //
     /*  49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49236 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49241 */     GIR_RootConstrainSelectedInstOperands,
     /*  49242 */     // GIR_Coverage, 1472,
     /*  49242 */     GIR_Done,
     /*  49243 */   // Label 749: @49243
     /*  49243 */   GIM_Reject,
     /*  49244 */ // Label 747: @49244
     /*  49244 */ GIM_Reject,
     /*  49245 */ // Label 591: @49245
     /*  49245 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50452),
     /*  49250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49260 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49325), // Rule ID 1839 //
     /*  49265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49308 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 1839,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 751: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49390), // Rule ID 1838 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49373 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49388 */     GIR_RootConstrainSelectedInstOperands,
     /*  49389 */     // GIR_Coverage, 1838,
     /*  49389 */     GIR_EraseRootFromParent_Done,
     /*  49390 */   // Label 752: @49390
     /*  49390 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49455), // Rule ID 1755 //
     /*  49395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49438 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1755,
     /*  49454 */     GIR_EraseRootFromParent_Done,
     /*  49455 */   // Label 753: @49455
     /*  49455 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49520), // Rule ID 1837 //
     /*  49460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49503 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49518 */     GIR_RootConstrainSelectedInstOperands,
     /*  49519 */     // GIR_Coverage, 1837,
     /*  49519 */     GIR_EraseRootFromParent_Done,
     /*  49520 */   // Label 754: @49520
     /*  49520 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49585), // Rule ID 1836 //
     /*  49525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49568 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49583 */     GIR_RootConstrainSelectedInstOperands,
     /*  49584 */     // GIR_Coverage, 1836,
     /*  49584 */     GIR_EraseRootFromParent_Done,
     /*  49585 */   // Label 755: @49585
     /*  49585 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49648), // Rule ID 1731 //
     /*  49590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49646 */     GIR_RootConstrainSelectedInstOperands,
     /*  49647 */     // GIR_Coverage, 1731,
     /*  49647 */     GIR_EraseRootFromParent_Done,
     /*  49648 */   // Label 756: @49648
     /*  49648 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49711), // Rule ID 1821 //
     /*  49653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49692 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1821,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 757: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49758), // Rule ID 1859 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49744 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1859,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 758: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49805), // Rule ID 1761 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49791 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1761,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 759: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49852), // Rule ID 1858 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49838 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49850 */     GIR_RootConstrainSelectedInstOperands,
     /*  49851 */     // GIR_Coverage, 1858,
     /*  49851 */     GIR_EraseRootFromParent_Done,
     /*  49852 */   // Label 760: @49852
     /*  49852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49911), // Rule ID 1835 //
     /*  49857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49896 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49909 */     GIR_RootConstrainSelectedInstOperands,
     /*  49910 */     // GIR_Coverage, 1835,
     /*  49910 */     GIR_EraseRootFromParent_Done,
     /*  49911 */   // Label 761: @49911
     /*  49911 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49970), // Rule ID 1834 //
     /*  49916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49955 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1834,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 762: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50029), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50014 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50027 */     GIR_RootConstrainSelectedInstOperands,
     /*  50028 */     // GIR_Coverage, 1754,
     /*  50028 */     GIR_EraseRootFromParent_Done,
     /*  50029 */   // Label 763: @50029
     /*  50029 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50088), // Rule ID 1833 //
     /*  50034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50073 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50086 */     GIR_RootConstrainSelectedInstOperands,
     /*  50087 */     // GIR_Coverage, 1833,
     /*  50087 */     GIR_EraseRootFromParent_Done,
     /*  50088 */   // Label 764: @50088
     /*  50088 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50147), // Rule ID 1832 //
     /*  50093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50132 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 1832,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 765: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50182), // Rule ID 968 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50173 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 968,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 766: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50239), // Rule ID 1730 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50222 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50237 */     GIR_RootConstrainSelectedInstOperands,
     /*  50238 */     // GIR_Coverage, 1730,
     /*  50238 */     GIR_EraseRootFromParent_Done,
     /*  50239 */   // Label 767: @50239
     /*  50239 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50296), // Rule ID 1820 //
     /*  50244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50279 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50294 */     GIR_RootConstrainSelectedInstOperands,
     /*  50295 */     // GIR_Coverage, 1820,
     /*  50295 */     GIR_EraseRootFromParent_Done,
     /*  50296 */   // Label 768: @50296
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50340), // Rule ID 1857 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50327 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50338 */     GIR_RootConstrainSelectedInstOperands,
     /*  50339 */     // GIR_Coverage, 1857,
     /*  50339 */     GIR_EraseRootFromParent_Done,
     /*  50340 */   // Label 769: @50340
     /*  50340 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50384), // Rule ID 1760 //
     /*  50345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50371 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50382 */     GIR_RootConstrainSelectedInstOperands,
     /*  50383 */     // GIR_Coverage, 1760,
     /*  50383 */     GIR_EraseRootFromParent_Done,
     /*  50384 */   // Label 770: @50384
     /*  50384 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50428), // Rule ID 1856 //
     /*  50389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50415 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 1856,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 771: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50451), // Rule ID 1475 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50444 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1475,
     /*  50450 */     GIR_Done,
     /*  50451 */   // Label 772: @50451
     /*  50451 */   GIM_Reject,
     /*  50452 */ // Label 750: @50452
     /*  50452 */ GIM_Reject,
     /*  50453 */ // Label 592: @50453
     /*  50453 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50527),
     /*  50458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50468 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50503), // Rule ID 966 //
     /*  50473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50501 */     GIR_RootConstrainSelectedInstOperands,
     /*  50502 */     // GIR_Coverage, 966,
     /*  50502 */     GIR_EraseRootFromParent_Done,
     /*  50503 */   // Label 774: @50503
     /*  50503 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50526), // Rule ID 1473 //
     /*  50508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50519 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50524 */     GIR_RootConstrainSelectedInstOperands,
     /*  50525 */     // GIR_Coverage, 1473,
     /*  50525 */     GIR_Done,
     /*  50526 */   // Label 775: @50526
     /*  50526 */   GIM_Reject,
     /*  50527 */ // Label 773: @50527
     /*  50527 */ GIM_Reject,
     /*  50528 */ // Label 593: @50528
     /*  50528 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50553), // Rule ID 7459 //
     /*  50533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50546 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50551 */   GIR_RootConstrainSelectedInstOperands,
     /*  50552 */   // GIR_Coverage, 7459,
     /*  50552 */   GIR_Done,
     /*  50553 */ // Label 776: @50553
     /*  50553 */ GIM_Reject,
     /*  50554 */ // Label 594: @50554
     /*  50554 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50579), // Rule ID 7458 //
     /*  50559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50572 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50577 */   GIR_RootConstrainSelectedInstOperands,
     /*  50578 */   // GIR_Coverage, 7458,
     /*  50578 */   GIR_Done,
     /*  50579 */ // Label 777: @50579
     /*  50579 */ GIM_Reject,
     /*  50580 */ // Label 595: @50580
     /*  50580 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50605), // Rule ID 7457 //
     /*  50585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50598 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50603 */   GIR_RootConstrainSelectedInstOperands,
     /*  50604 */   // GIR_Coverage, 7457,
     /*  50604 */   GIR_Done,
     /*  50605 */ // Label 778: @50605
     /*  50605 */ GIM_Reject,
     /*  50606 */ // Label 596: @50606
     /*  50606 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50631), // Rule ID 7456 //
     /*  50611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50624 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50629 */   GIR_RootConstrainSelectedInstOperands,
     /*  50630 */   // GIR_Coverage, 7456,
     /*  50630 */   GIR_Done,
     /*  50631 */ // Label 779: @50631
     /*  50631 */ GIM_Reject,
     /*  50632 */ // Label 597: @50632
     /*  50632 */ GIM_Reject,
     /*  50633 */ // Label 2: @50633
     /*  50633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53153),
     /*  50644 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50684),
     /*  50648 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50841), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  50664 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52415),
     /*  50668 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52753),
     /*  50672 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52919),
     /*  50676 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52953),
     /*  50680 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53119),
     /*  50684 */ // Label 780: @50684
     /*  50684 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50840),
     /*  50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50754), // Rule ID 3955 //
     /*  50704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50735 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50752 */     GIR_RootConstrainSelectedInstOperands,
     /*  50753 */     // GIR_Coverage, 3955,
     /*  50753 */     GIR_EraseRootFromParent_Done,
     /*  50754 */   // Label 790: @50754
     /*  50754 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50809), // Rule ID 13798 //
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50790 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 13798,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 791: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50839), // Rule ID 3951 //
     /*  50814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50822 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50837 */     GIR_RootConstrainSelectedInstOperands,
     /*  50838 */     // GIR_Coverage, 3951,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 792: @50839
     /*  50839 */   GIM_Reject,
     /*  50840 */ // Label 789: @50840
     /*  50840 */ GIM_Reject,
     /*  50841 */ // Label 781: @50841
     /*  50841 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52076),
     /*  50846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50856 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51002), // Rule ID 3960 //
     /*  50861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50882 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50927 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51000 */     GIR_RootConstrainSelectedInstOperands,
     /*  51001 */     // GIR_Coverage, 3960,
     /*  51001 */     GIR_EraseRootFromParent_Done,
     /*  51002 */   // Label 794: @51002
     /*  51002 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51106), // Rule ID 3961 //
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51058 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51104 */     GIR_RootConstrainSelectedInstOperands,
     /*  51105 */     // GIR_Coverage, 3961,
     /*  51105 */     GIR_EraseRootFromParent_Done,
     /*  51106 */   // Label 795: @51106
     /*  51106 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51210), // Rule ID 13801 //
     /*  51111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51149 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51208 */     GIR_RootConstrainSelectedInstOperands,
     /*  51209 */     // GIR_Coverage, 13801,
     /*  51209 */     GIR_EraseRootFromParent_Done,
     /*  51210 */   // Label 796: @51210
     /*  51210 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51265), // Rule ID 3956 //
     /*  51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 3956,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 797: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51320), // Rule ID 13799 //
     /*  51270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51301 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51318 */     GIR_RootConstrainSelectedInstOperands,
     /*  51319 */     // GIR_Coverage, 13799,
     /*  51319 */     GIR_EraseRootFromParent_Done,
     /*  51320 */   // Label 798: @51320
     /*  51320 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51433), // Rule ID 3967 //
     /*  51325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51342 */     // MIs[1] Operand 2
     /*  51342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51365 */     // MIs[2] Operand 1
     /*  51365 */     // No operand predicates
     /*  51365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51367 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51431 */     GIR_RootConstrainSelectedInstOperands,
     /*  51432 */     // GIR_Coverage, 3967,
     /*  51432 */     GIR_EraseRootFromParent_Done,
     /*  51433 */   // Label 799: @51433
     /*  51433 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51508), // Rule ID 3965 //
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51467 */     // MIs[2] Operand 1
     /*  51467 */     // No operand predicates
     /*  51467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51469 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51481 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 3965,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 800: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51583), // Rule ID 3966 //
     /*  51513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51542 */     // MIs[2] Operand 1
     /*  51542 */     // No operand predicates
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51556 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51581 */     GIR_RootConstrainSelectedInstOperands,
     /*  51582 */     // GIR_Coverage, 3966,
     /*  51582 */     GIR_EraseRootFromParent_Done,
     /*  51583 */   // Label 801: @51583
     /*  51583 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51721), // Rule ID 3957 //
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51605 */     // MIs[1] Operand 2
     /*  51605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51633 */     // MIs[2] Operand 2
     /*  51633 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51646 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51719 */     GIR_RootConstrainSelectedInstOperands,
     /*  51720 */     // GIR_Coverage, 3957,
     /*  51720 */     GIR_EraseRootFromParent_Done,
     /*  51721 */   // Label 802: @51721
     /*  51721 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51821), // Rule ID 3958 //
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51743 */     // MIs[1] Operand 2
     /*  51743 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51773 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51819 */     GIR_RootConstrainSelectedInstOperands,
     /*  51820 */     // GIR_Coverage, 3958,
     /*  51820 */     GIR_EraseRootFromParent_Done,
     /*  51821 */   // Label 803: @51821
     /*  51821 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51921), // Rule ID 13800 //
     /*  51826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51860 */     // MIs[2] Operand 2
     /*  51860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51873 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13800,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 804: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51983), // Rule ID 3959 //
     /*  51926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51962 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51981 */     GIR_RootConstrainSelectedInstOperands,
     /*  51982 */     // GIR_Coverage, 3959,
     /*  51982 */     GIR_EraseRootFromParent_Done,
     /*  51983 */   // Label 805: @51983
     /*  51983 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52045), // Rule ID 3962 //
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52024 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 3962,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 806: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52075), // Rule ID 3952 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52058 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3952,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 807: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 793: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 782: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52414),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52178), // Rule ID 13492 //
     /*  52097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52145 */     // MIs[3] Operand 1
     /*  52145 */     // No operand predicates
     /*  52145 */     // MIs[1] Operand 2
     /*  52145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52162 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 13492,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 809: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52264), // Rule ID 2034 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52235 */     // MIs[3] Operand 1
     /*  52235 */     // No operand predicates
     /*  52235 */     // MIs[1] Operand 2
     /*  52235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52248 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52262 */     GIR_RootConstrainSelectedInstOperands,
     /*  52263 */     // GIR_Coverage, 2034,
     /*  52263 */     GIR_EraseRootFromParent_Done,
     /*  52264 */   // Label 810: @52264
     /*  52264 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52327), // Rule ID 13493 //
     /*  52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52305 */     // MIs[2] Operand 1
     /*  52305 */     // No operand predicates
     /*  52305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52311 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52325 */     GIR_RootConstrainSelectedInstOperands,
     /*  52326 */     // GIR_Coverage, 13493,
     /*  52326 */     GIR_EraseRootFromParent_Done,
     /*  52327 */   // Label 811: @52327
     /*  52327 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52390), // Rule ID 2035 //
     /*  52332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52372 */     // MIs[2] Operand 1
     /*  52372 */     // No operand predicates
     /*  52372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52374 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52388 */     GIR_RootConstrainSelectedInstOperands,
     /*  52389 */     // GIR_Coverage, 2035,
     /*  52389 */     GIR_EraseRootFromParent_Done,
     /*  52390 */   // Label 812: @52390
     /*  52390 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52413), // Rule ID 1352 //
     /*  52395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52406 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52411 */     GIR_RootConstrainSelectedInstOperands,
     /*  52412 */     // GIR_Coverage, 1352,
     /*  52412 */     GIR_Done,
     /*  52413 */   // Label 813: @52413
     /*  52413 */   GIM_Reject,
     /*  52414 */ // Label 808: @52414
     /*  52414 */ GIM_Reject,
     /*  52415 */ // Label 783: @52415
     /*  52415 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52752),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52430 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52516), // Rule ID 13489 //
     /*  52435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52483 */     // MIs[3] Operand 1
     /*  52483 */     // No operand predicates
     /*  52483 */     // MIs[1] Operand 2
     /*  52483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52500 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 13489,
     /*  52515 */     GIR_EraseRootFromParent_Done,
     /*  52516 */   // Label 815: @52516
     /*  52516 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52602), // Rule ID 2031 //
     /*  52521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52573 */     // MIs[3] Operand 1
     /*  52573 */     // No operand predicates
     /*  52573 */     // MIs[1] Operand 2
     /*  52573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52586 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52600 */     GIR_RootConstrainSelectedInstOperands,
     /*  52601 */     // GIR_Coverage, 2031,
     /*  52601 */     GIR_EraseRootFromParent_Done,
     /*  52602 */   // Label 816: @52602
     /*  52602 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52665), // Rule ID 13490 //
     /*  52607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52643 */     // MIs[2] Operand 1
     /*  52643 */     // No operand predicates
     /*  52643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52649 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52663 */     GIR_RootConstrainSelectedInstOperands,
     /*  52664 */     // GIR_Coverage, 13490,
     /*  52664 */     GIR_EraseRootFromParent_Done,
     /*  52665 */   // Label 817: @52665
     /*  52665 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52728), // Rule ID 2032 //
     /*  52670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52710 */     // MIs[2] Operand 1
     /*  52710 */     // No operand predicates
     /*  52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52712 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52726 */     GIR_RootConstrainSelectedInstOperands,
     /*  52727 */     // GIR_Coverage, 2032,
     /*  52727 */     GIR_EraseRootFromParent_Done,
     /*  52728 */   // Label 818: @52728
     /*  52728 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52751), // Rule ID 1350 //
     /*  52733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52744 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52749 */     GIR_RootConstrainSelectedInstOperands,
     /*  52750 */     // GIR_Coverage, 1350,
     /*  52750 */     GIR_Done,
     /*  52751 */   // Label 819: @52751
     /*  52751 */   GIM_Reject,
     /*  52752 */ // Label 814: @52752
     /*  52752 */ GIM_Reject,
     /*  52753 */ // Label 784: @52753
     /*  52753 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52918),
     /*  52758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52768 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52831), // Rule ID 13494 //
     /*  52773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52809 */     // MIs[2] Operand 1
     /*  52809 */     // No operand predicates
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52815 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52829 */     GIR_RootConstrainSelectedInstOperands,
     /*  52830 */     // GIR_Coverage, 13494,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 821: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52894), // Rule ID 2036 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52876 */     // MIs[2] Operand 1
     /*  52876 */     // No operand predicates
     /*  52876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52878 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52892 */     GIR_RootConstrainSelectedInstOperands,
     /*  52893 */     // GIR_Coverage, 2036,
     /*  52893 */     GIR_EraseRootFromParent_Done,
     /*  52894 */   // Label 822: @52894
     /*  52894 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52917), // Rule ID 1353 //
     /*  52899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52910 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52915 */     GIR_RootConstrainSelectedInstOperands,
     /*  52916 */     // GIR_Coverage, 1353,
     /*  52916 */     GIR_Done,
     /*  52917 */   // Label 823: @52917
     /*  52917 */   GIM_Reject,
     /*  52918 */ // Label 820: @52918
     /*  52918 */ GIM_Reject,
     /*  52919 */ // Label 785: @52919
     /*  52919 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52952), // Rule ID 1348 //
     /*  52924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52945 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52950 */   GIR_RootConstrainSelectedInstOperands,
     /*  52951 */   // GIR_Coverage, 1348,
     /*  52951 */   GIR_Done,
     /*  52952 */ // Label 824: @52952
     /*  52952 */ GIM_Reject,
     /*  52953 */ // Label 786: @52953
     /*  52953 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53118),
     /*  52958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53031), // Rule ID 13491 //
     /*  52973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53009 */     // MIs[2] Operand 1
     /*  53009 */     // No operand predicates
     /*  53009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53015 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53029 */     GIR_RootConstrainSelectedInstOperands,
     /*  53030 */     // GIR_Coverage, 13491,
     /*  53030 */     GIR_EraseRootFromParent_Done,
     /*  53031 */   // Label 826: @53031
     /*  53031 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53094), // Rule ID 2033 //
     /*  53036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53076 */     // MIs[2] Operand 1
     /*  53076 */     // No operand predicates
     /*  53076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53078 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53092 */     GIR_RootConstrainSelectedInstOperands,
     /*  53093 */     // GIR_Coverage, 2033,
     /*  53093 */     GIR_EraseRootFromParent_Done,
     /*  53094 */   // Label 827: @53094
     /*  53094 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53117), // Rule ID 1351 //
     /*  53099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53110 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1351,
     /*  53116 */     GIR_Done,
     /*  53117 */   // Label 828: @53117
     /*  53117 */   GIM_Reject,
     /*  53118 */ // Label 825: @53118
     /*  53118 */ GIM_Reject,
     /*  53119 */ // Label 787: @53119
     /*  53119 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53152), // Rule ID 1349 //
     /*  53124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53150 */   GIR_RootConstrainSelectedInstOperands,
     /*  53151 */   // GIR_Coverage, 1349,
     /*  53151 */   GIR_Done,
     /*  53152 */ // Label 829: @53152
     /*  53152 */ GIM_Reject,
     /*  53153 */ // Label 788: @53153
     /*  53153 */ GIM_Reject,
     /*  53154 */ // Label 3: @53154
     /*  53154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53235),
     /*  53165 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53173),
     /*  53169 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53204),
     /*  53173 */ // Label 830: @53173
     /*  53173 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53203), // Rule ID 117 //
     /*  53178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53201 */   GIR_RootConstrainSelectedInstOperands,
     /*  53202 */   // GIR_Coverage, 117,
     /*  53202 */   GIR_Done,
     /*  53203 */ // Label 833: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 831: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53234), // Rule ID 118 //
     /*  53209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 118,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 834: @53234
     /*  53234 */ GIM_Reject,
     /*  53235 */ // Label 832: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 4: @53236
     /*  53236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53317),
     /*  53247 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53255),
     /*  53251 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53286),
     /*  53255 */ // Label 835: @53255
     /*  53255 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53285), // Rule ID 115 //
     /*  53260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53278 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 115,
     /*  53284 */   GIR_Done,
     /*  53285 */ // Label 838: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 836: @53286
     /*  53286 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53316), // Rule ID 116 //
     /*  53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53309 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53314 */   GIR_RootConstrainSelectedInstOperands,
     /*  53315 */   // GIR_Coverage, 116,
     /*  53315 */   GIR_Done,
     /*  53316 */ // Label 839: @53316
     /*  53316 */ GIM_Reject,
     /*  53317 */ // Label 837: @53317
     /*  53317 */ GIM_Reject,
     /*  53318 */ // Label 5: @53318
     /*  53318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61063),
     /*  53329 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53417),
     /*  53333 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53915), GIMT_Encode4(0),
     /*  53341 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55350),
     /*  53345 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55510),
     /*  53349 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55670),
     /*  53353 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55830),
     /*  53357 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55990),
     /*  53361 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56150),
     /*  53365 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56310),
     /*  53369 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56470),
     /*  53373 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53385 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57552),
     /*  53389 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*  53397 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58565),
     /*  53401 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59037),
     /*  53405 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59578),
     /*  53409 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60050),
     /*  53413 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60591),
     /*  53417 */ // Label 840: @53417
     /*  53417 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53914),
     /*  53422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53428 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53483), // Rule ID 13251 //
     /*  53433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53470 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53481 */     GIR_RootConstrainSelectedInstOperands,
     /*  53482 */     // GIR_Coverage, 13251,
     /*  53482 */     GIR_EraseRootFromParent_Done,
     /*  53483 */   // Label 860: @53483
     /*  53483 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53538), // Rule ID 162 //
     /*  53488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53525 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53536 */     GIR_RootConstrainSelectedInstOperands,
     /*  53537 */     // GIR_Coverage, 162,
     /*  53537 */     GIR_EraseRootFromParent_Done,
     /*  53538 */   // Label 861: @53538
     /*  53538 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53607), // Rule ID 5660 //
     /*  53543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53580 */     // MIs[2] Operand 1
     /*  53580 */     // No operand predicates
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53593 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53605 */     GIR_RootConstrainSelectedInstOperands,
     /*  53606 */     // GIR_Coverage, 5660,
     /*  53606 */     GIR_EraseRootFromParent_Done,
     /*  53607 */   // Label 862: @53607
     /*  53607 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53676), // Rule ID 5661 //
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53649 */     // MIs[2] Operand 1
     /*  53649 */     // No operand predicates
     /*  53649 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53662 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 5661,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 863: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53729), // Rule ID 13249 //
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53716 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53727 */     GIR_RootConstrainSelectedInstOperands,
     /*  53728 */     // GIR_Coverage, 13249,
     /*  53728 */     GIR_EraseRootFromParent_Done,
     /*  53729 */   // Label 864: @53729
     /*  53729 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53782), // Rule ID 160 //
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53769 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 160,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 865: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53823), // Rule ID 142 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53803 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53807 */     // MIs[1] Operand 1
     /*  53807 */     // No operand predicates
     /*  53807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53809 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53816 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 142,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 866: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53856), // Rule ID 13247 //
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53843 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 13247,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 867: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53889), // Rule ID 158 //
     /*  53861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53876 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53887 */     GIR_RootConstrainSelectedInstOperands,
     /*  53888 */     // GIR_Coverage, 158,
     /*  53888 */     GIR_EraseRootFromParent_Done,
     /*  53889 */   // Label 868: @53889
     /*  53889 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53913), // Rule ID 156 //
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53906 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53911 */     GIR_RootConstrainSelectedInstOperands,
     /*  53912 */     // GIR_Coverage, 156,
     /*  53912 */     GIR_Done,
     /*  53913 */   // Label 869: @53913
     /*  53913 */   GIM_Reject,
     /*  53914 */ // Label 859: @53914
     /*  53914 */ GIM_Reject,
     /*  53915 */ // Label 841: @53915
     /*  53915 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55349),
     /*  53920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53981), // Rule ID 13252 //
     /*  53931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53968 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53979 */     GIR_RootConstrainSelectedInstOperands,
     /*  53980 */     // GIR_Coverage, 13252,
     /*  53980 */     GIR_EraseRootFromParent_Done,
     /*  53981 */   // Label 871: @53981
     /*  53981 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54036), // Rule ID 163 //
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54023 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 163,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 872: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54149), // Rule ID 5662 //
     /*  54041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54090 */     // MIs[3] Operand 1
     /*  54090 */     // No operand predicates
     /*  54090 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54103 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54148 */     // GIR_Coverage, 5662,
     /*  54148 */     GIR_EraseRootFromParent_Done,
     /*  54149 */   // Label 873: @54149
     /*  54149 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54262), // Rule ID 5663 //
     /*  54154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54203 */     // MIs[3] Operand 1
     /*  54203 */     // No operand predicates
     /*  54203 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54216 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     // GIR_Coverage, 5663,
     /*  54261 */     GIR_EraseRootFromParent_Done,
     /*  54262 */   // Label 874: @54262
     /*  54262 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54361), // Rule ID 7108 //
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54287 */     // MIs[1] addr
     /*  54287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54296 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54300 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54313 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54360 */     // GIR_Coverage, 7108,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 875: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54460), // Rule ID 7109 //
     /*  54366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54386 */     // MIs[1] addr
     /*  54386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54399 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54412 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54459 */     // GIR_Coverage, 7109,
     /*  54459 */     GIR_EraseRootFromParent_Done,
     /*  54460 */   // Label 876: @54460
     /*  54460 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54559), // Rule ID 7110 //
     /*  54465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54485 */     // MIs[1] addr
     /*  54485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54511 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54558 */     // GIR_Coverage, 7110,
     /*  54558 */     GIR_EraseRootFromParent_Done,
     /*  54559 */   // Label 877: @54559
     /*  54559 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54658), // Rule ID 7115 //
     /*  54564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54584 */     // MIs[1] addr
     /*  54584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54593 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54597 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54610 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54657 */     // GIR_Coverage, 7115,
     /*  54657 */     GIR_EraseRootFromParent_Done,
     /*  54658 */   // Label 878: @54658
     /*  54658 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54757), // Rule ID 7116 //
     /*  54663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54683 */     // MIs[1] addr
     /*  54683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54696 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54709 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54756 */     // GIR_Coverage, 7116,
     /*  54756 */     GIR_EraseRootFromParent_Done,
     /*  54757 */   // Label 879: @54757
     /*  54757 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54856), // Rule ID 7117 //
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54782 */     // MIs[1] addr
     /*  54782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54795 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54808 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54855 */     // GIR_Coverage, 7117,
     /*  54855 */     GIR_EraseRootFromParent_Done,
     /*  54856 */   // Label 880: @54856
     /*  54856 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54909), // Rule ID 13250 //
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54896 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 13250,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 881: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54962), // Rule ID 161 //
     /*  54914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54949 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54960 */     GIR_RootConstrainSelectedInstOperands,
     /*  54961 */     // GIR_Coverage, 161,
     /*  54961 */     GIR_EraseRootFromParent_Done,
     /*  54962 */   // Label 882: @54962
     /*  54962 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55062), // Rule ID 4004 //
     /*  54967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54975 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  55004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55061 */     // GIR_Coverage, 4004,
     /*  55061 */     GIR_EraseRootFromParent_Done,
     /*  55062 */   // Label 883: @55062
     /*  55062 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55103), // Rule ID 143 //
     /*  55067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55087 */     // MIs[1] Operand 1
     /*  55087 */     // No operand predicates
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55089 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 143,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 884: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55136), // Rule ID 13248 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55123 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55134 */     GIR_RootConstrainSelectedInstOperands,
     /*  55135 */     // GIR_Coverage, 13248,
     /*  55135 */     GIR_EraseRootFromParent_Done,
     /*  55136 */   // Label 885: @55136
     /*  55136 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55169), // Rule ID 159 //
     /*  55141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55156 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55167 */     GIR_RootConstrainSelectedInstOperands,
     /*  55168 */     // GIR_Coverage, 159,
     /*  55168 */     GIR_EraseRootFromParent_Done,
     /*  55169 */   // Label 886: @55169
     /*  55169 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55233), // Rule ID 13906 //
     /*  55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55206 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55220 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 13906,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 887: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55297), // Rule ID 5044 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55284 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55289 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55295 */     GIR_RootConstrainSelectedInstOperands,
     /*  55296 */     // GIR_Coverage, 5044,
     /*  55296 */     GIR_EraseRootFromParent_Done,
     /*  55297 */   // Label 888: @55297
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55321), // Rule ID 157 //
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55314 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55319 */     GIR_RootConstrainSelectedInstOperands,
     /*  55320 */     // GIR_Coverage, 157,
     /*  55320 */     GIR_Done,
     /*  55321 */   // Label 889: @55321
     /*  55321 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55348), // Rule ID 2484 //
     /*  55326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2484,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 890: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 870: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 842: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55425), // Rule ID 13905 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13905,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 892: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55485), // Rule ID 5043 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5043,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 893: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55508), // Rule ID 2483 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55501 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2483,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 894: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 891: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 843: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55585), // Rule ID 13909 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13909,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 896: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55645), // Rule ID 5047 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 5047,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 897: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55668), // Rule ID 2487 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55661 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 2487,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 898: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 895: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 844: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55745), // Rule ID 13904 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13904,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 900: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55805), // Rule ID 5042 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5042,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 901: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55828), // Rule ID 2482 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55821 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2482,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 902: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 899: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 845: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55905), // Rule ID 13908 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13908,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 904: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55965), // Rule ID 5046 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 5046,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 905: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55988), // Rule ID 2486 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 2486,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 906: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 903: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 846: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56149),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56065), // Rule ID 13387 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56052 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56063 */     GIR_RootConstrainSelectedInstOperands,
     /*  56064 */     // GIR_Coverage, 13387,
     /*  56064 */     GIR_EraseRootFromParent_Done,
     /*  56065 */   // Label 908: @56065
     /*  56065 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56125), // Rule ID 1597 //
     /*  56070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56112 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56123 */     GIR_RootConstrainSelectedInstOperands,
     /*  56124 */     // GIR_Coverage, 1597,
     /*  56124 */     GIR_EraseRootFromParent_Done,
     /*  56125 */   // Label 909: @56125
     /*  56125 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56148), // Rule ID 1595 //
     /*  56130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56141 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1595,
     /*  56147 */     GIR_Done,
     /*  56148 */   // Label 910: @56148
     /*  56148 */   GIM_Reject,
     /*  56149 */ // Label 907: @56149
     /*  56149 */ GIM_Reject,
     /*  56150 */ // Label 847: @56150
     /*  56150 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56309),
     /*  56155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56165 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56225), // Rule ID 13907 //
     /*  56170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56212 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 13907,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 912: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56285), // Rule ID 5045 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56272 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56283 */     GIR_RootConstrainSelectedInstOperands,
     /*  56284 */     // GIR_Coverage, 5045,
     /*  56284 */     GIR_EraseRootFromParent_Done,
     /*  56285 */   // Label 913: @56285
     /*  56285 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56308), // Rule ID 2485 //
     /*  56290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56301 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 2485,
     /*  56307 */     GIR_Done,
     /*  56308 */   // Label 914: @56308
     /*  56308 */   GIM_Reject,
     /*  56309 */ // Label 911: @56309
     /*  56309 */ GIM_Reject,
     /*  56310 */ // Label 848: @56310
     /*  56310 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56469),
     /*  56315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56325 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56385), // Rule ID 13388 //
     /*  56330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56372 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56383 */     GIR_RootConstrainSelectedInstOperands,
     /*  56384 */     // GIR_Coverage, 13388,
     /*  56384 */     GIR_EraseRootFromParent_Done,
     /*  56385 */   // Label 916: @56385
     /*  56385 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56445), // Rule ID 1598 //
     /*  56390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56432 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56443 */     GIR_RootConstrainSelectedInstOperands,
     /*  56444 */     // GIR_Coverage, 1598,
     /*  56444 */     GIR_EraseRootFromParent_Done,
     /*  56445 */   // Label 917: @56445
     /*  56445 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56468), // Rule ID 1596 //
     /*  56450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56461 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1596,
     /*  56467 */     GIR_Done,
     /*  56468 */   // Label 918: @56468
     /*  56468 */   GIM_Reject,
     /*  56469 */ // Label 915: @56469
     /*  56469 */ GIM_Reject,
     /*  56470 */ // Label 849: @56470
     /*  56470 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57010),
     /*  56475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56542), // Rule ID 15101 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56540 */     GIR_RootConstrainSelectedInstOperands,
     /*  56541 */     // GIR_Coverage, 15101,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 920: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56599), // Rule ID 15104 //
     /*  56547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56584 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 15104,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 921: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56656), // Rule ID 15100 //
     /*  56604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56641 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56654 */     GIR_RootConstrainSelectedInstOperands,
     /*  56655 */     // GIR_Coverage, 15100,
     /*  56655 */     GIR_EraseRootFromParent_Done,
     /*  56656 */   // Label 922: @56656
     /*  56656 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56713), // Rule ID 15103 //
     /*  56661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56698 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 15103,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 923: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56770), // Rule ID 15099 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56755 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56768 */     GIR_RootConstrainSelectedInstOperands,
     /*  56769 */     // GIR_Coverage, 15099,
     /*  56769 */     GIR_EraseRootFromParent_Done,
     /*  56770 */   // Label 924: @56770
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56827), // Rule ID 15102 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56806 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56812 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56825 */     GIR_RootConstrainSelectedInstOperands,
     /*  56826 */     // GIR_Coverage, 15102,
     /*  56826 */     GIR_EraseRootFromParent_Done,
     /*  56827 */   // Label 925: @56827
     /*  56827 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56884), // Rule ID 8451 //
     /*  56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56869 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 8451,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 926: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56941), // Rule ID 8452 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56926 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56939 */     GIR_RootConstrainSelectedInstOperands,
     /*  56940 */     // GIR_Coverage, 8452,
     /*  56940 */     GIR_EraseRootFromParent_Done,
     /*  56941 */   // Label 927: @56941
     /*  56941 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56988), // Rule ID 10715 //
     /*  56946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56957 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 10715,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 928: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57009), // Rule ID 2753 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56996 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57007 */     GIR_RootConstrainSelectedInstOperands,
     /*  57008 */     // GIR_Coverage, 2753,
     /*  57008 */     GIR_EraseRootFromParent_Done,
     /*  57009 */   // Label 929: @57009
     /*  57009 */   GIM_Reject,
     /*  57010 */ // Label 919: @57010
     /*  57010 */ GIM_Reject,
     /*  57011 */ // Label 850: @57011
     /*  57011 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57551),
     /*  57016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57026 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57083), // Rule ID 15092 //
     /*  57031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57081 */     GIR_RootConstrainSelectedInstOperands,
     /*  57082 */     // GIR_Coverage, 15092,
     /*  57082 */     GIR_EraseRootFromParent_Done,
     /*  57083 */   // Label 931: @57083
     /*  57083 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57140), // Rule ID 15095 //
     /*  57088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57125 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57138 */     GIR_RootConstrainSelectedInstOperands,
     /*  57139 */     // GIR_Coverage, 15095,
     /*  57139 */     GIR_EraseRootFromParent_Done,
     /*  57140 */   // Label 932: @57140
     /*  57140 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57197), // Rule ID 15091 //
     /*  57145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57182 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 15091,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 933: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57254), // Rule ID 15094 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 15094,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 934: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57311), // Rule ID 15090 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57296 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57309 */     GIR_RootConstrainSelectedInstOperands,
     /*  57310 */     // GIR_Coverage, 15090,
     /*  57310 */     GIR_EraseRootFromParent_Done,
     /*  57311 */   // Label 935: @57311
     /*  57311 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57368), // Rule ID 15093 //
     /*  57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57353 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 15093,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 936: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57425), // Rule ID 8447 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57410 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57423 */     GIR_RootConstrainSelectedInstOperands,
     /*  57424 */     // GIR_Coverage, 8447,
     /*  57424 */     GIR_EraseRootFromParent_Done,
     /*  57425 */   // Label 937: @57425
     /*  57425 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57482), // Rule ID 8448 //
     /*  57430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57467 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 8448,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 938: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57529), // Rule ID 10714 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57498 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 10714,
     /*  57528 */     GIR_EraseRootFromParent_Done,
     /*  57529 */   // Label 939: @57529
     /*  57529 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57550), // Rule ID 2752 //
     /*  57534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57537 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 2752,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 940: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 930: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 851: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58023),
     /*  57557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57567 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57622), // Rule ID 15032 //
     /*  57572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57609 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57620 */     GIR_RootConstrainSelectedInstOperands,
     /*  57621 */     // GIR_Coverage, 15032,
     /*  57621 */     GIR_EraseRootFromParent_Done,
     /*  57622 */   // Label 942: @57622
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57677), // Rule ID 15035 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57664 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57675 */     GIR_RootConstrainSelectedInstOperands,
     /*  57676 */     // GIR_Coverage, 15035,
     /*  57676 */     GIR_EraseRootFromParent_Done,
     /*  57677 */   // Label 943: @57677
     /*  57677 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57732), // Rule ID 15031 //
     /*  57682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57719 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57730 */     GIR_RootConstrainSelectedInstOperands,
     /*  57731 */     // GIR_Coverage, 15031,
     /*  57731 */     GIR_EraseRootFromParent_Done,
     /*  57732 */   // Label 944: @57732
     /*  57732 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57787), // Rule ID 15034 //
     /*  57737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57774 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 15034,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 945: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57842), // Rule ID 15030 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57840 */     GIR_RootConstrainSelectedInstOperands,
     /*  57841 */     // GIR_Coverage, 15030,
     /*  57841 */     GIR_EraseRootFromParent_Done,
     /*  57842 */   // Label 946: @57842
     /*  57842 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57897), // Rule ID 15033 //
     /*  57847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57884 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 15033,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 947: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57952), // Rule ID 7496 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57939 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57950 */     GIR_RootConstrainSelectedInstOperands,
     /*  57951 */     // GIR_Coverage, 7496,
     /*  57951 */     GIR_EraseRootFromParent_Done,
     /*  57952 */   // Label 948: @57952
     /*  57952 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58007), // Rule ID 7497 //
     /*  57957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57994 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58005 */     GIR_RootConstrainSelectedInstOperands,
     /*  58006 */     // GIR_Coverage, 7497,
     /*  58006 */     GIR_EraseRootFromParent_Done,
     /*  58007 */   // Label 949: @58007
     /*  58007 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58022), // Rule ID 3146 //
     /*  58012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58015 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 3146,
     /*  58021 */     GIR_Done,
     /*  58022 */   // Label 950: @58022
     /*  58022 */   GIM_Reject,
     /*  58023 */ // Label 941: @58023
     /*  58023 */ GIM_Reject,
     /*  58024 */ // Label 852: @58024
     /*  58024 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58564),
     /*  58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58039 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58096), // Rule ID 15083 //
     /*  58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58081 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 15083,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 952: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58153), // Rule ID 15086 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58138 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58151 */     GIR_RootConstrainSelectedInstOperands,
     /*  58152 */     // GIR_Coverage, 15086,
     /*  58152 */     GIR_EraseRootFromParent_Done,
     /*  58153 */   // Label 953: @58153
     /*  58153 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58210), // Rule ID 15082 //
     /*  58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58195 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 15082,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 954: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58267), // Rule ID 15085 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58265 */     GIR_RootConstrainSelectedInstOperands,
     /*  58266 */     // GIR_Coverage, 15085,
     /*  58266 */     GIR_EraseRootFromParent_Done,
     /*  58267 */   // Label 955: @58267
     /*  58267 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58324), // Rule ID 15081 //
     /*  58272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58309 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58322 */     GIR_RootConstrainSelectedInstOperands,
     /*  58323 */     // GIR_Coverage, 15081,
     /*  58323 */     GIR_EraseRootFromParent_Done,
     /*  58324 */   // Label 956: @58324
     /*  58324 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58381), // Rule ID 15084 //
     /*  58329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58366 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58379 */     GIR_RootConstrainSelectedInstOperands,
     /*  58380 */     // GIR_Coverage, 15084,
     /*  58380 */     GIR_EraseRootFromParent_Done,
     /*  58381 */   // Label 957: @58381
     /*  58381 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58438), // Rule ID 8443 //
     /*  58386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58423 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58436 */     GIR_RootConstrainSelectedInstOperands,
     /*  58437 */     // GIR_Coverage, 8443,
     /*  58437 */     GIR_EraseRootFromParent_Done,
     /*  58438 */   // Label 958: @58438
     /*  58438 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58495), // Rule ID 8444 //
     /*  58443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58480 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58493 */     GIR_RootConstrainSelectedInstOperands,
     /*  58494 */     // GIR_Coverage, 8444,
     /*  58494 */     GIR_EraseRootFromParent_Done,
     /*  58495 */   // Label 959: @58495
     /*  58495 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58542), // Rule ID 10713 //
     /*  58500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58511 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58540 */     GIR_RootConstrainSelectedInstOperands,
     /*  58541 */     // GIR_Coverage, 10713,
     /*  58541 */     GIR_EraseRootFromParent_Done,
     /*  58542 */   // Label 960: @58542
     /*  58542 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58563), // Rule ID 2751 //
     /*  58547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58550 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 2751,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 961: @58563
     /*  58563 */   GIM_Reject,
     /*  58564 */ // Label 951: @58564
     /*  58564 */ GIM_Reject,
     /*  58565 */ // Label 853: @58565
     /*  58565 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59036),
     /*  58570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58635), // Rule ID 15023 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58622 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 15023,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 963: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58690), // Rule ID 15026 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58677 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 15026,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 964: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58745), // Rule ID 15022 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58732 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58743 */     GIR_RootConstrainSelectedInstOperands,
     /*  58744 */     // GIR_Coverage, 15022,
     /*  58744 */     GIR_EraseRootFromParent_Done,
     /*  58745 */   // Label 965: @58745
     /*  58745 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58800), // Rule ID 15025 //
     /*  58750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58787 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 15025,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 966: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58855), // Rule ID 15021 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58853 */     GIR_RootConstrainSelectedInstOperands,
     /*  58854 */     // GIR_Coverage, 15021,
     /*  58854 */     GIR_EraseRootFromParent_Done,
     /*  58855 */   // Label 967: @58855
     /*  58855 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58910), // Rule ID 15024 //
     /*  58860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58897 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 15024,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 968: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58965), // Rule ID 7492 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58952 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58963 */     GIR_RootConstrainSelectedInstOperands,
     /*  58964 */     // GIR_Coverage, 7492,
     /*  58964 */     GIR_EraseRootFromParent_Done,
     /*  58965 */   // Label 969: @58965
     /*  58965 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59020), // Rule ID 7493 //
     /*  58970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59007 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 7493,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 970: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59035), // Rule ID 3145 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59028 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59033 */     GIR_RootConstrainSelectedInstOperands,
     /*  59034 */     // GIR_Coverage, 3145,
     /*  59034 */     GIR_Done,
     /*  59035 */   // Label 971: @59035
     /*  59035 */   GIM_Reject,
     /*  59036 */ // Label 962: @59036
     /*  59036 */ GIM_Reject,
     /*  59037 */ // Label 854: @59037
     /*  59037 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59577),
     /*  59042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59052 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59109), // Rule ID 15074 //
     /*  59057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59094 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59107 */     GIR_RootConstrainSelectedInstOperands,
     /*  59108 */     // GIR_Coverage, 15074,
     /*  59108 */     GIR_EraseRootFromParent_Done,
     /*  59109 */   // Label 973: @59109
     /*  59109 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59166), // Rule ID 15077 //
     /*  59114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59151 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59164 */     GIR_RootConstrainSelectedInstOperands,
     /*  59165 */     // GIR_Coverage, 15077,
     /*  59165 */     GIR_EraseRootFromParent_Done,
     /*  59166 */   // Label 974: @59166
     /*  59166 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59223), // Rule ID 15073 //
     /*  59171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59202 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59208 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 15073,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 975: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59280), // Rule ID 15076 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 15076,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 976: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59337), // Rule ID 15072 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59322 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59335 */     GIR_RootConstrainSelectedInstOperands,
     /*  59336 */     // GIR_Coverage, 15072,
     /*  59336 */     GIR_EraseRootFromParent_Done,
     /*  59337 */   // Label 977: @59337
     /*  59337 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59394), // Rule ID 15075 //
     /*  59342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59379 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 15075,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 978: @59394
     /*  59394 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59451), // Rule ID 8439 //
     /*  59399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59436 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59449 */     GIR_RootConstrainSelectedInstOperands,
     /*  59450 */     // GIR_Coverage, 8439,
     /*  59450 */     GIR_EraseRootFromParent_Done,
     /*  59451 */   // Label 979: @59451
     /*  59451 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59508), // Rule ID 8440 //
     /*  59456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59493 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 8440,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 980: @59508
     /*  59508 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59555), // Rule ID 10712 //
     /*  59513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59524 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 10712,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 981: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59576), // Rule ID 2750 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59563 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 2750,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 982: @59576
     /*  59576 */   GIM_Reject,
     /*  59577 */ // Label 972: @59577
     /*  59577 */ GIM_Reject,
     /*  59578 */ // Label 855: @59578
     /*  59578 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60049),
     /*  59583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59593 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59648), // Rule ID 15014 //
     /*  59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59635 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59646 */     GIR_RootConstrainSelectedInstOperands,
     /*  59647 */     // GIR_Coverage, 15014,
     /*  59647 */     GIR_EraseRootFromParent_Done,
     /*  59648 */   // Label 984: @59648
     /*  59648 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59703), // Rule ID 15017 //
     /*  59653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59690 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59701 */     GIR_RootConstrainSelectedInstOperands,
     /*  59702 */     // GIR_Coverage, 15017,
     /*  59702 */     GIR_EraseRootFromParent_Done,
     /*  59703 */   // Label 985: @59703
     /*  59703 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59758), // Rule ID 15013 //
     /*  59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59745 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59756 */     GIR_RootConstrainSelectedInstOperands,
     /*  59757 */     // GIR_Coverage, 15013,
     /*  59757 */     GIR_EraseRootFromParent_Done,
     /*  59758 */   // Label 986: @59758
     /*  59758 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59813), // Rule ID 15016 //
     /*  59763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59800 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 15016,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 987: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59868), // Rule ID 15012 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59866 */     GIR_RootConstrainSelectedInstOperands,
     /*  59867 */     // GIR_Coverage, 15012,
     /*  59867 */     GIR_EraseRootFromParent_Done,
     /*  59868 */   // Label 988: @59868
     /*  59868 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59923), // Rule ID 15015 //
     /*  59873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59910 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59921 */     GIR_RootConstrainSelectedInstOperands,
     /*  59922 */     // GIR_Coverage, 15015,
     /*  59922 */     GIR_EraseRootFromParent_Done,
     /*  59923 */   // Label 989: @59923
     /*  59923 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59978), // Rule ID 7488 //
     /*  59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59965 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59976 */     GIR_RootConstrainSelectedInstOperands,
     /*  59977 */     // GIR_Coverage, 7488,
     /*  59977 */     GIR_EraseRootFromParent_Done,
     /*  59978 */   // Label 990: @59978
     /*  59978 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60033), // Rule ID 7489 //
     /*  59983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  60002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60020 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60031 */     GIR_RootConstrainSelectedInstOperands,
     /*  60032 */     // GIR_Coverage, 7489,
     /*  60032 */     GIR_EraseRootFromParent_Done,
     /*  60033 */   // Label 991: @60033
     /*  60033 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60048), // Rule ID 3144 //
     /*  60038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60041 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60046 */     GIR_RootConstrainSelectedInstOperands,
     /*  60047 */     // GIR_Coverage, 3144,
     /*  60047 */     GIR_Done,
     /*  60048 */   // Label 992: @60048
     /*  60048 */   GIM_Reject,
     /*  60049 */ // Label 983: @60049
     /*  60049 */ GIM_Reject,
     /*  60050 */ // Label 856: @60050
     /*  60050 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60590),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60122), // Rule ID 15065 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60107 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60120 */     GIR_RootConstrainSelectedInstOperands,
     /*  60121 */     // GIR_Coverage, 15065,
     /*  60121 */     GIR_EraseRootFromParent_Done,
     /*  60122 */   // Label 994: @60122
     /*  60122 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60179), // Rule ID 15068 //
     /*  60127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60164 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60177 */     GIR_RootConstrainSelectedInstOperands,
     /*  60178 */     // GIR_Coverage, 15068,
     /*  60178 */     GIR_EraseRootFromParent_Done,
     /*  60179 */   // Label 995: @60179
     /*  60179 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60236), // Rule ID 15064 //
     /*  60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60221 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 15064,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 996: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60293), // Rule ID 15067 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60291 */     GIR_RootConstrainSelectedInstOperands,
     /*  60292 */     // GIR_Coverage, 15067,
     /*  60292 */     GIR_EraseRootFromParent_Done,
     /*  60293 */   // Label 997: @60293
     /*  60293 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60350), // Rule ID 15063 //
     /*  60298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60335 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60348 */     GIR_RootConstrainSelectedInstOperands,
     /*  60349 */     // GIR_Coverage, 15063,
     /*  60349 */     GIR_EraseRootFromParent_Done,
     /*  60350 */   // Label 998: @60350
     /*  60350 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60407), // Rule ID 15066 //
     /*  60355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60392 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60405 */     GIR_RootConstrainSelectedInstOperands,
     /*  60406 */     // GIR_Coverage, 15066,
     /*  60406 */     GIR_EraseRootFromParent_Done,
     /*  60407 */   // Label 999: @60407
     /*  60407 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60464), // Rule ID 8435 //
     /*  60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60462 */     GIR_RootConstrainSelectedInstOperands,
     /*  60463 */     // GIR_Coverage, 8435,
     /*  60463 */     GIR_EraseRootFromParent_Done,
     /*  60464 */   // Label 1000: @60464
     /*  60464 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60521), // Rule ID 8436 //
     /*  60469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60506 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 8436,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1001: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60568), // Rule ID 10711 //
     /*  60526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60537 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60566 */     GIR_RootConstrainSelectedInstOperands,
     /*  60567 */     // GIR_Coverage, 10711,
     /*  60567 */     GIR_EraseRootFromParent_Done,
     /*  60568 */   // Label 1002: @60568
     /*  60568 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60589), // Rule ID 2749 //
     /*  60573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60576 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 2749,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 1003: @60589
     /*  60589 */   GIM_Reject,
     /*  60590 */ // Label 993: @60590
     /*  60590 */ GIM_Reject,
     /*  60591 */ // Label 857: @60591
     /*  60591 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61062),
     /*  60596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60606 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60661), // Rule ID 15005 //
     /*  60611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60648 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60659 */     GIR_RootConstrainSelectedInstOperands,
     /*  60660 */     // GIR_Coverage, 15005,
     /*  60660 */     GIR_EraseRootFromParent_Done,
     /*  60661 */   // Label 1005: @60661
     /*  60661 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60716), // Rule ID 15008 //
     /*  60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60703 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 15008,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1006: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60771), // Rule ID 15004 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60758 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 15004,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1007: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60826), // Rule ID 15007 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60813 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60824 */     GIR_RootConstrainSelectedInstOperands,
     /*  60825 */     // GIR_Coverage, 15007,
     /*  60825 */     GIR_EraseRootFromParent_Done,
     /*  60826 */   // Label 1008: @60826
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60881), // Rule ID 15003 //
     /*  60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60868 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60879 */     GIR_RootConstrainSelectedInstOperands,
     /*  60880 */     // GIR_Coverage, 15003,
     /*  60880 */     GIR_EraseRootFromParent_Done,
     /*  60881 */   // Label 1009: @60881
     /*  60881 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60936), // Rule ID 15006 //
     /*  60886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60923 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 15006,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1010: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60991), // Rule ID 7484 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60978 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60989 */     GIR_RootConstrainSelectedInstOperands,
     /*  60990 */     // GIR_Coverage, 7484,
     /*  60990 */     GIR_EraseRootFromParent_Done,
     /*  60991 */   // Label 1011: @60991
     /*  60991 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61046), // Rule ID 7485 //
     /*  60996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61033 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61044 */     GIR_RootConstrainSelectedInstOperands,
     /*  61045 */     // GIR_Coverage, 7485,
     /*  61045 */     GIR_EraseRootFromParent_Done,
     /*  61046 */   // Label 1012: @61046
     /*  61046 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61061), // Rule ID 3143 //
     /*  61051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61054 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3143,
     /*  61060 */     GIR_Done,
     /*  61061 */   // Label 1013: @61061
     /*  61061 */   GIM_Reject,
     /*  61062 */ // Label 1004: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 858: @61063
     /*  61063 */ GIM_Reject,
     /*  61064 */ // Label 6: @61064
     /*  61064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(72842),
     /*  61075 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61163),
     /*  61079 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61523), GIMT_Encode4(0),
     /*  61087 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63422),
     /*  61091 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64730),
     /*  61095 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66038),
     /*  61099 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67346),
     /*  61103 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68654),
     /*  61107 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69962),
     /*  61111 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71270),
     /*  61115 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72578),
     /*  61119 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61131 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72642),
     /*  61135 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(72668), GIMT_Encode4(0),
     /*  61143 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(72700),
     /*  61147 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(72726),
     /*  61151 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(72758),
     /*  61155 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(72784),
     /*  61159 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(72816),
     /*  61163 */ // Label 1014: @61163
     /*  61163 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61522),
     /*  61168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61174 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61229), // Rule ID 13271 //
     /*  61179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61216 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61227 */     GIR_RootConstrainSelectedInstOperands,
     /*  61228 */     // GIR_Coverage, 13271,
     /*  61228 */     GIR_EraseRootFromParent_Done,
     /*  61229 */   // Label 1034: @61229
     /*  61229 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61284), // Rule ID 174 //
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61271 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61282 */     GIR_RootConstrainSelectedInstOperands,
     /*  61283 */     // GIR_Coverage, 174,
     /*  61283 */     GIR_EraseRootFromParent_Done,
     /*  61284 */   // Label 1035: @61284
     /*  61284 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61325), // Rule ID 146 //
     /*  61289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61305 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61309 */     // MIs[1] Operand 1
     /*  61309 */     // No operand predicates
     /*  61309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61311 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61318 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61323 */     GIR_RootConstrainSelectedInstOperands,
     /*  61324 */     // GIR_Coverage, 146,
     /*  61324 */     GIR_EraseRootFromParent_Done,
     /*  61325 */   // Label 1036: @61325
     /*  61325 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61358), // Rule ID 13273 //
     /*  61330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61345 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13273,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1037: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61391), // Rule ID 178 //
     /*  61363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61378 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61389 */     GIR_RootConstrainSelectedInstOperands,
     /*  61390 */     // GIR_Coverage, 178,
     /*  61390 */     GIR_EraseRootFromParent_Done,
     /*  61391 */   // Label 1038: @61391
     /*  61391 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61444), // Rule ID 13269 //
     /*  61396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61431 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61442 */     GIR_RootConstrainSelectedInstOperands,
     /*  61443 */     // GIR_Coverage, 13269,
     /*  61443 */     GIR_EraseRootFromParent_Done,
     /*  61444 */   // Label 1039: @61444
     /*  61444 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61497), // Rule ID 172 //
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61484 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 172,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1040: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61521), // Rule ID 176 //
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61514 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 176,
     /*  61520 */     GIR_Done,
     /*  61521 */   // Label 1041: @61521
     /*  61521 */   GIM_Reject,
     /*  61522 */ // Label 1033: @61522
     /*  61522 */ GIM_Reject,
     /*  61523 */ // Label 1015: @61523
     /*  61523 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63421),
     /*  61528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61534 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61656), // Rule ID 4017 //
     /*  61539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61619 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61623 */     // MIs[4] Rn
     /*  61623 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61628 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61632 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61645 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61654 */     GIR_RootConstrainSelectedInstOperands,
     /*  61655 */     // GIR_Coverage, 4017,
     /*  61655 */     GIR_EraseRootFromParent_Done,
     /*  61656 */   // Label 1043: @61656
     /*  61656 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61778), // Rule ID 13821 //
     /*  61661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61706 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61745 */     // MIs[4] Rn
     /*  61745 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61750 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61754 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61765 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61767 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61776 */     GIR_RootConstrainSelectedInstOperands,
     /*  61777 */     // GIR_Coverage, 13821,
     /*  61777 */     GIR_EraseRootFromParent_Done,
     /*  61778 */   // Label 1044: @61778
     /*  61778 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61833), // Rule ID 13272 //
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61820 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 13272,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 1045: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61888), // Rule ID 175 //
     /*  61838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61875 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61886 */     GIR_RootConstrainSelectedInstOperands,
     /*  61887 */     // GIR_Coverage, 175,
     /*  61887 */     GIR_EraseRootFromParent_Done,
     /*  61888 */   // Label 1046: @61888
     /*  61888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61997), // Rule ID 13621 //
     /*  61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61971 */     // MIs[4] LHS
     /*  61971 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61978 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 13621,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1047: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62106), // Rule ID 13620 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62071 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62075 */     // MIs[4] LHS
     /*  62075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62080 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62087 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62104 */     GIR_RootConstrainSelectedInstOperands,
     /*  62105 */     // GIR_Coverage, 13620,
     /*  62105 */     GIR_EraseRootFromParent_Done,
     /*  62106 */   // Label 1048: @62106
     /*  62106 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62215), // Rule ID 13623 //
     /*  62111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62164 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62189 */     // MIs[4] LHS
     /*  62189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62196 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 13623,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 1049: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62324), // Rule ID 13622 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62293 */     // MIs[4] LHS
     /*  62293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62298 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62305 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62322 */     GIR_RootConstrainSelectedInstOperands,
     /*  62323 */     // GIR_Coverage, 13622,
     /*  62323 */     GIR_EraseRootFromParent_Done,
     /*  62324 */   // Label 1050: @62324
     /*  62324 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62433), // Rule ID 2471 //
     /*  62329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62390 */     // MIs[3] LHS
     /*  62390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62414 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62431 */     GIR_RootConstrainSelectedInstOperands,
     /*  62432 */     // GIR_Coverage, 2471,
     /*  62432 */     GIR_EraseRootFromParent_Done,
     /*  62433 */   // Label 1051: @62433
     /*  62433 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62542), // Rule ID 13618 //
     /*  62438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62499 */     // MIs[3] LHS
     /*  62499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62523 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 13618,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1052: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62651), // Rule ID 13617 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62613 */     // MIs[3] LHS
     /*  62613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62632 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62649 */     GIR_RootConstrainSelectedInstOperands,
     /*  62650 */     // GIR_Coverage, 13617,
     /*  62650 */     GIR_EraseRootFromParent_Done,
     /*  62651 */   // Label 1053: @62651
     /*  62651 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62760), // Rule ID 13619 //
     /*  62656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62722 */     // MIs[3] LHS
     /*  62722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62731 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62741 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62758 */     GIR_RootConstrainSelectedInstOperands,
     /*  62759 */     // GIR_Coverage, 13619,
     /*  62759 */     GIR_EraseRootFromParent_Done,
     /*  62760 */   // Label 1054: @62760
     /*  62760 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62801), // Rule ID 147 //
     /*  62765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62781 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62785 */     // MIs[1] Operand 1
     /*  62785 */     // No operand predicates
     /*  62785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62787 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62799 */     GIR_RootConstrainSelectedInstOperands,
     /*  62800 */     // GIR_Coverage, 147,
     /*  62800 */     GIR_EraseRootFromParent_Done,
     /*  62801 */   // Label 1055: @62801
     /*  62801 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62834), // Rule ID 13274 //
     /*  62806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62821 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13274,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1056: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62867), // Rule ID 179 //
     /*  62839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62854 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 179,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1057: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62934), // Rule ID 13557 //
     /*  62872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     // MIs[1] imm
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62908 */     // MIs[2] Operand 1
     /*  62908 */     // No operand predicates
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62918 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62932 */     GIR_RootConstrainSelectedInstOperands,
     /*  62933 */     // GIR_Coverage, 13557,
     /*  62933 */     GIR_EraseRootFromParent_Done,
     /*  62934 */   // Label 1058: @62934
     /*  62934 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63001), // Rule ID 13560 //
     /*  62939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     // MIs[1] imm
     /*  62963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62975 */     // MIs[2] Operand 1
     /*  62975 */     // No operand predicates
     /*  62975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62985 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 13560,
     /*  63000 */     GIR_EraseRootFromParent_Done,
     /*  63001 */   // Label 1059: @63001
     /*  63001 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63054), // Rule ID 13270 //
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63041 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63052 */     GIR_RootConstrainSelectedInstOperands,
     /*  63053 */     // GIR_Coverage, 13270,
     /*  63053 */     GIR_EraseRootFromParent_Done,
     /*  63054 */   // Label 1060: @63054
     /*  63054 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63121), // Rule ID 2122 //
     /*  63059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63087 */     // MIs[1] imm
     /*  63087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63099 */     // MIs[2] Operand 1
     /*  63099 */     // No operand predicates
     /*  63099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63105 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 2122,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1061: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63188), // Rule ID 2131 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     // MIs[1] imm
     /*  63154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63166 */     // MIs[2] Operand 1
     /*  63166 */     // No operand predicates
     /*  63166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63172 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63186 */     GIR_RootConstrainSelectedInstOperands,
     /*  63187 */     // GIR_Coverage, 2131,
     /*  63187 */     GIR_EraseRootFromParent_Done,
     /*  63188 */   // Label 1062: @63188
     /*  63188 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63241), // Rule ID 173 //
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63228 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 173,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 1063: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63305), // Rule ID 13912 //
     /*  63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63292 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63303 */     GIR_RootConstrainSelectedInstOperands,
     /*  63304 */     // GIR_Coverage, 13912,
     /*  63304 */     GIR_EraseRootFromParent_Done,
     /*  63305 */   // Label 1064: @63305
     /*  63305 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63369), // Rule ID 5056 //
     /*  63310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63356 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63361 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 5056,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 1065: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63393), // Rule ID 177 //
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63386 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 177,
     /*  63392 */     GIR_Done,
     /*  63393 */   // Label 1066: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63420), // Rule ID 5062 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63413 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 5062,
     /*  63419 */     GIR_Done,
     /*  63420 */   // Label 1067: @63420
     /*  63420 */   GIM_Reject,
     /*  63421 */ // Label 1042: @63421
     /*  63421 */ GIM_Reject,
     /*  63422 */ // Label 1016: @63422
     /*  63422 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64729),
     /*  63427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63542), // Rule ID 13614 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63516 */     // MIs[4] LHS
     /*  63516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63523 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 13614,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1069: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63651), // Rule ID 13613 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63620 */     // MIs[4] LHS
     /*  63620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63632 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63649 */     GIR_RootConstrainSelectedInstOperands,
     /*  63650 */     // GIR_Coverage, 13613,
     /*  63650 */     GIR_EraseRootFromParent_Done,
     /*  63651 */   // Label 1070: @63651
     /*  63651 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63760), // Rule ID 13616 //
     /*  63656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63709 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63725 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63729 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63734 */     // MIs[4] LHS
     /*  63734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63741 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63758 */     GIR_RootConstrainSelectedInstOperands,
     /*  63759 */     // GIR_Coverage, 13616,
     /*  63759 */     GIR_EraseRootFromParent_Done,
     /*  63760 */   // Label 1071: @63760
     /*  63760 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63869), // Rule ID 13615 //
     /*  63765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63838 */     // MIs[4] LHS
     /*  63838 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63850 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 13615,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1072: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63978), // Rule ID 2470 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63935 */     // MIs[3] LHS
     /*  63935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63959 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63976 */     GIR_RootConstrainSelectedInstOperands,
     /*  63977 */     // GIR_Coverage, 2470,
     /*  63977 */     GIR_EraseRootFromParent_Done,
     /*  63978 */   // Label 1073: @63978
     /*  63978 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64087), // Rule ID 13611 //
     /*  63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64044 */     // MIs[3] LHS
     /*  64044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64053 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64066 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64068 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64085 */     GIR_RootConstrainSelectedInstOperands,
     /*  64086 */     // GIR_Coverage, 13611,
     /*  64086 */     GIR_EraseRootFromParent_Done,
     /*  64087 */   // Label 1074: @64087
     /*  64087 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64196), // Rule ID 13610 //
     /*  64092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64158 */     // MIs[3] LHS
     /*  64158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64167 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64177 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64194 */     GIR_RootConstrainSelectedInstOperands,
     /*  64195 */     // GIR_Coverage, 13610,
     /*  64195 */     GIR_EraseRootFromParent_Done,
     /*  64196 */   // Label 1075: @64196
     /*  64196 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64305), // Rule ID 13612 //
     /*  64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64267 */     // MIs[3] LHS
     /*  64267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64286 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64303 */     GIR_RootConstrainSelectedInstOperands,
     /*  64304 */     // GIR_Coverage, 13612,
     /*  64304 */     GIR_EraseRootFromParent_Done,
     /*  64305 */   // Label 1076: @64305
     /*  64305 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64372), // Rule ID 13577 //
     /*  64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     // MIs[1] imm
     /*  64334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64346 */     // MIs[2] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64356 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64370 */     GIR_RootConstrainSelectedInstOperands,
     /*  64371 */     // GIR_Coverage, 13577,
     /*  64371 */     GIR_EraseRootFromParent_Done,
     /*  64372 */   // Label 1077: @64372
     /*  64372 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64439), // Rule ID 13598 //
     /*  64377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     // MIs[1] imm
     /*  64401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64413 */     // MIs[2] Operand 1
     /*  64413 */     // No operand predicates
     /*  64413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64423 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 13598,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 1078: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64506), // Rule ID 2239 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64472 */     // MIs[1] imm
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64484 */     // MIs[2] Operand 1
     /*  64484 */     // No operand predicates
     /*  64484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64490 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64504 */     GIR_RootConstrainSelectedInstOperands,
     /*  64505 */     // GIR_Coverage, 2239,
     /*  64505 */     GIR_EraseRootFromParent_Done,
     /*  64506 */   // Label 1079: @64506
     /*  64506 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64573), // Rule ID 2298 //
     /*  64511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64539 */     // MIs[1] imm
     /*  64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64551 */     // MIs[2] Operand 1
     /*  64551 */     // No operand predicates
     /*  64551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64557 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64571 */     GIR_RootConstrainSelectedInstOperands,
     /*  64572 */     // GIR_Coverage, 2298,
     /*  64572 */     GIR_EraseRootFromParent_Done,
     /*  64573 */   // Label 1080: @64573
     /*  64573 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64637), // Rule ID 13911 //
     /*  64578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64624 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64635 */     GIR_RootConstrainSelectedInstOperands,
     /*  64636 */     // GIR_Coverage, 13911,
     /*  64636 */     GIR_EraseRootFromParent_Done,
     /*  64637 */   // Label 1081: @64637
     /*  64637 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64701), // Rule ID 5055 //
     /*  64642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64688 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64693 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64699 */     GIR_RootConstrainSelectedInstOperands,
     /*  64700 */     // GIR_Coverage, 5055,
     /*  64700 */     GIR_EraseRootFromParent_Done,
     /*  64701 */   // Label 1082: @64701
     /*  64701 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64728), // Rule ID 5061 //
     /*  64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64721 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 5061,
     /*  64727 */     GIR_Done,
     /*  64728 */   // Label 1083: @64728
     /*  64728 */   GIM_Reject,
     /*  64729 */ // Label 1068: @64729
     /*  64729 */ GIM_Reject,
     /*  64730 */ // Label 1017: @64730
     /*  64730 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66037),
     /*  64735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64850), // Rule ID 13642 //
     /*  64746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64824 */     // MIs[4] LHS
     /*  64824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64829 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64831 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64848 */     GIR_RootConstrainSelectedInstOperands,
     /*  64849 */     // GIR_Coverage, 13642,
     /*  64849 */     GIR_EraseRootFromParent_Done,
     /*  64850 */   // Label 1085: @64850
     /*  64850 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64959), // Rule ID 13641 //
     /*  64855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64928 */     // MIs[4] LHS
     /*  64928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64940 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64957 */     GIR_RootConstrainSelectedInstOperands,
     /*  64958 */     // GIR_Coverage, 13641,
     /*  64958 */     GIR_EraseRootFromParent_Done,
     /*  64959 */   // Label 1086: @64959
     /*  64959 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65068), // Rule ID 13644 //
     /*  64964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65033 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65037 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65042 */     // MIs[4] LHS
     /*  65042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65049 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65066 */     GIR_RootConstrainSelectedInstOperands,
     /*  65067 */     // GIR_Coverage, 13644,
     /*  65067 */     GIR_EraseRootFromParent_Done,
     /*  65068 */   // Label 1087: @65068
     /*  65068 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65177), // Rule ID 13643 //
     /*  65073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65126 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65146 */     // MIs[4] LHS
     /*  65146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65158 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65175 */     GIR_RootConstrainSelectedInstOperands,
     /*  65176 */     // GIR_Coverage, 13643,
     /*  65176 */     GIR_EraseRootFromParent_Done,
     /*  65177 */   // Label 1088: @65177
     /*  65177 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65286), // Rule ID 2474 //
     /*  65182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65243 */     // MIs[3] LHS
     /*  65243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65267 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65284 */     GIR_RootConstrainSelectedInstOperands,
     /*  65285 */     // GIR_Coverage, 2474,
     /*  65285 */     GIR_EraseRootFromParent_Done,
     /*  65286 */   // Label 1089: @65286
     /*  65286 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65395), // Rule ID 13639 //
     /*  65291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65352 */     // MIs[3] LHS
     /*  65352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65361 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65376 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65393 */     GIR_RootConstrainSelectedInstOperands,
     /*  65394 */     // GIR_Coverage, 13639,
     /*  65394 */     GIR_EraseRootFromParent_Done,
     /*  65395 */   // Label 1090: @65395
     /*  65395 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65504), // Rule ID 13638 //
     /*  65400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65466 */     // MIs[3] LHS
     /*  65466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65485 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65502 */     GIR_RootConstrainSelectedInstOperands,
     /*  65503 */     // GIR_Coverage, 13638,
     /*  65503 */     GIR_EraseRootFromParent_Done,
     /*  65504 */   // Label 1091: @65504
     /*  65504 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65613), // Rule ID 13640 //
     /*  65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65575 */     // MIs[3] LHS
     /*  65575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65594 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65611 */     GIR_RootConstrainSelectedInstOperands,
     /*  65612 */     // GIR_Coverage, 13640,
     /*  65612 */     GIR_EraseRootFromParent_Done,
     /*  65613 */   // Label 1092: @65613
     /*  65613 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65680), // Rule ID 13581 //
     /*  65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     // MIs[1] imm
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65654 */     // MIs[2] Operand 1
     /*  65654 */     // No operand predicates
     /*  65654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65664 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65678 */     GIR_RootConstrainSelectedInstOperands,
     /*  65679 */     // GIR_Coverage, 13581,
     /*  65679 */     GIR_EraseRootFromParent_Done,
     /*  65680 */   // Label 1093: @65680
     /*  65680 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65747), // Rule ID 13602 //
     /*  65685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     // MIs[1] imm
     /*  65709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65721 */     // MIs[2] Operand 1
     /*  65721 */     // No operand predicates
     /*  65721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65731 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65745 */     GIR_RootConstrainSelectedInstOperands,
     /*  65746 */     // GIR_Coverage, 13602,
     /*  65746 */     GIR_EraseRootFromParent_Done,
     /*  65747 */   // Label 1094: @65747
     /*  65747 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65814), // Rule ID 2243 //
     /*  65752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65780 */     // MIs[1] imm
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65792 */     // MIs[2] Operand 1
     /*  65792 */     // No operand predicates
     /*  65792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65812 */     GIR_RootConstrainSelectedInstOperands,
     /*  65813 */     // GIR_Coverage, 2243,
     /*  65813 */     GIR_EraseRootFromParent_Done,
     /*  65814 */   // Label 1095: @65814
     /*  65814 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65881), // Rule ID 2302 //
     /*  65819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65847 */     // MIs[1] imm
     /*  65847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65859 */     // MIs[2] Operand 1
     /*  65859 */     // No operand predicates
     /*  65859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65865 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65879 */     GIR_RootConstrainSelectedInstOperands,
     /*  65880 */     // GIR_Coverage, 2302,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 1096: @65881
     /*  65881 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65945), // Rule ID 13915 //
     /*  65886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65932 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65943 */     GIR_RootConstrainSelectedInstOperands,
     /*  65944 */     // GIR_Coverage, 13915,
     /*  65944 */     GIR_EraseRootFromParent_Done,
     /*  65945 */   // Label 1097: @65945
     /*  65945 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66009), // Rule ID 5059 //
     /*  65950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65986 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65996 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66001 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 5059,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1098: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66036), // Rule ID 5065 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66029 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66034 */     GIR_RootConstrainSelectedInstOperands,
     /*  66035 */     // GIR_Coverage, 5065,
     /*  66035 */     GIR_Done,
     /*  66036 */   // Label 1099: @66036
     /*  66036 */   GIM_Reject,
     /*  66037 */ // Label 1084: @66037
     /*  66037 */ GIM_Reject,
     /*  66038 */ // Label 1018: @66038
     /*  66038 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67345),
     /*  66043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66158), // Rule ID 13607 //
     /*  66054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66115 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66119 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66123 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66127 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66132 */     // MIs[4] LHS
     /*  66132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66139 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 13607,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1101: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66267), // Rule ID 13606 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66232 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66236 */     // MIs[4] LHS
     /*  66236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66248 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 13606,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1102: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66376), // Rule ID 13609 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66341 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66345 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66350 */     // MIs[4] LHS
     /*  66350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66357 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66374 */     GIR_RootConstrainSelectedInstOperands,
     /*  66375 */     // GIR_Coverage, 13609,
     /*  66375 */     GIR_EraseRootFromParent_Done,
     /*  66376 */   // Label 1103: @66376
     /*  66376 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66485), // Rule ID 13608 //
     /*  66381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66454 */     // MIs[4] LHS
     /*  66454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66459 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66464 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66466 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66483 */     GIR_RootConstrainSelectedInstOperands,
     /*  66484 */     // GIR_Coverage, 13608,
     /*  66484 */     GIR_EraseRootFromParent_Done,
     /*  66485 */   // Label 1104: @66485
     /*  66485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66594), // Rule ID 2469 //
     /*  66490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66551 */     // MIs[3] LHS
     /*  66551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66575 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66592 */     GIR_RootConstrainSelectedInstOperands,
     /*  66593 */     // GIR_Coverage, 2469,
     /*  66593 */     GIR_EraseRootFromParent_Done,
     /*  66594 */   // Label 1105: @66594
     /*  66594 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66703), // Rule ID 13604 //
     /*  66599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66660 */     // MIs[3] LHS
     /*  66660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66669 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66684 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66701 */     GIR_RootConstrainSelectedInstOperands,
     /*  66702 */     // GIR_Coverage, 13604,
     /*  66702 */     GIR_EraseRootFromParent_Done,
     /*  66703 */   // Label 1106: @66703
     /*  66703 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66812), // Rule ID 13603 //
     /*  66708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66774 */     // MIs[3] LHS
     /*  66774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66783 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66793 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66810 */     GIR_RootConstrainSelectedInstOperands,
     /*  66811 */     // GIR_Coverage, 13603,
     /*  66811 */     GIR_EraseRootFromParent_Done,
     /*  66812 */   // Label 1107: @66812
     /*  66812 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66921), // Rule ID 13605 //
     /*  66817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66883 */     // MIs[3] LHS
     /*  66883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66902 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66919 */     GIR_RootConstrainSelectedInstOperands,
     /*  66920 */     // GIR_Coverage, 13605,
     /*  66920 */     GIR_EraseRootFromParent_Done,
     /*  66921 */   // Label 1108: @66921
     /*  66921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66988), // Rule ID 13573 //
     /*  66926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     // MIs[1] imm
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66962 */     // MIs[2] Operand 1
     /*  66962 */     // No operand predicates
     /*  66962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66972 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66986 */     GIR_RootConstrainSelectedInstOperands,
     /*  66987 */     // GIR_Coverage, 13573,
     /*  66987 */     GIR_EraseRootFromParent_Done,
     /*  66988 */   // Label 1109: @66988
     /*  66988 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67055), // Rule ID 13594 //
     /*  66993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     // MIs[1] imm
     /*  67017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67029 */     // MIs[2] Operand 1
     /*  67029 */     // No operand predicates
     /*  67029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67039 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 13594,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1110: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67122), // Rule ID 2235 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67088 */     // MIs[1] imm
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67100 */     // MIs[2] Operand 1
     /*  67100 */     // No operand predicates
     /*  67100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67106 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67120 */     GIR_RootConstrainSelectedInstOperands,
     /*  67121 */     // GIR_Coverage, 2235,
     /*  67121 */     GIR_EraseRootFromParent_Done,
     /*  67122 */   // Label 1111: @67122
     /*  67122 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67189), // Rule ID 2294 //
     /*  67127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67155 */     // MIs[1] imm
     /*  67155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67167 */     // MIs[2] Operand 1
     /*  67167 */     // No operand predicates
     /*  67167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67173 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 2294,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1112: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67253), // Rule ID 13910 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67240 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67245 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67251 */     GIR_RootConstrainSelectedInstOperands,
     /*  67252 */     // GIR_Coverage, 13910,
     /*  67252 */     GIR_EraseRootFromParent_Done,
     /*  67253 */   // Label 1113: @67253
     /*  67253 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67317), // Rule ID 5054 //
     /*  67258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67304 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67315 */     GIR_RootConstrainSelectedInstOperands,
     /*  67316 */     // GIR_Coverage, 5054,
     /*  67316 */     GIR_EraseRootFromParent_Done,
     /*  67317 */   // Label 1114: @67317
     /*  67317 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67344), // Rule ID 5060 //
     /*  67322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67337 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67342 */     GIR_RootConstrainSelectedInstOperands,
     /*  67343 */     // GIR_Coverage, 5060,
     /*  67343 */     GIR_Done,
     /*  67344 */   // Label 1115: @67344
     /*  67344 */   GIM_Reject,
     /*  67345 */ // Label 1100: @67345
     /*  67345 */ GIM_Reject,
     /*  67346 */ // Label 1019: @67346
     /*  67346 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68653),
     /*  67351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67466), // Rule ID 13635 //
     /*  67362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67410 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67440 */     // MIs[4] LHS
     /*  67440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67464 */     GIR_RootConstrainSelectedInstOperands,
     /*  67465 */     // GIR_Coverage, 13635,
     /*  67465 */     GIR_EraseRootFromParent_Done,
     /*  67466 */   // Label 1117: @67466
     /*  67466 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67575), // Rule ID 13634 //
     /*  67471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67544 */     // MIs[4] LHS
     /*  67544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67556 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67573 */     GIR_RootConstrainSelectedInstOperands,
     /*  67574 */     // GIR_Coverage, 13634,
     /*  67574 */     GIR_EraseRootFromParent_Done,
     /*  67575 */   // Label 1118: @67575
     /*  67575 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67684), // Rule ID 13637 //
     /*  67580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67653 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67658 */     // MIs[4] LHS
     /*  67658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67682 */     GIR_RootConstrainSelectedInstOperands,
     /*  67683 */     // GIR_Coverage, 13637,
     /*  67683 */     GIR_EraseRootFromParent_Done,
     /*  67684 */   // Label 1119: @67684
     /*  67684 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67793), // Rule ID 13636 //
     /*  67689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67762 */     // MIs[4] LHS
     /*  67762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67767 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67774 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 13636,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1120: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67902), // Rule ID 2473 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67855 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67859 */     // MIs[3] LHS
     /*  67859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67900 */     GIR_RootConstrainSelectedInstOperands,
     /*  67901 */     // GIR_Coverage, 2473,
     /*  67901 */     GIR_EraseRootFromParent_Done,
     /*  67902 */   // Label 1121: @67902
     /*  67902 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68011), // Rule ID 13632 //
     /*  67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67968 */     // MIs[3] LHS
     /*  67968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67977 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67992 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68009 */     GIR_RootConstrainSelectedInstOperands,
     /*  68010 */     // GIR_Coverage, 13632,
     /*  68010 */     GIR_EraseRootFromParent_Done,
     /*  68011 */   // Label 1122: @68011
     /*  68011 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68120), // Rule ID 13631 //
     /*  68016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68082 */     // MIs[3] LHS
     /*  68082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68091 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68118 */     GIR_RootConstrainSelectedInstOperands,
     /*  68119 */     // GIR_Coverage, 13631,
     /*  68119 */     GIR_EraseRootFromParent_Done,
     /*  68120 */   // Label 1123: @68120
     /*  68120 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68229), // Rule ID 13633 //
     /*  68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68191 */     // MIs[3] LHS
     /*  68191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68227 */     GIR_RootConstrainSelectedInstOperands,
     /*  68228 */     // GIR_Coverage, 13633,
     /*  68228 */     GIR_EraseRootFromParent_Done,
     /*  68229 */   // Label 1124: @68229
     /*  68229 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68296), // Rule ID 13579 //
     /*  68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     // MIs[1] imm
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68270 */     // MIs[2] Operand 1
     /*  68270 */     // No operand predicates
     /*  68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68280 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68294 */     GIR_RootConstrainSelectedInstOperands,
     /*  68295 */     // GIR_Coverage, 13579,
     /*  68295 */     GIR_EraseRootFromParent_Done,
     /*  68296 */   // Label 1125: @68296
     /*  68296 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68363), // Rule ID 13600 //
     /*  68301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     // MIs[1] imm
     /*  68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68337 */     // MIs[2] Operand 1
     /*  68337 */     // No operand predicates
     /*  68337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68347 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 13600,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1126: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68430), // Rule ID 2241 //
     /*  68368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     // MIs[1] imm
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68408 */     // MIs[2] Operand 1
     /*  68408 */     // No operand predicates
     /*  68408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68414 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68428 */     GIR_RootConstrainSelectedInstOperands,
     /*  68429 */     // GIR_Coverage, 2241,
     /*  68429 */     GIR_EraseRootFromParent_Done,
     /*  68430 */   // Label 1127: @68430
     /*  68430 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68497), // Rule ID 2300 //
     /*  68435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68463 */     // MIs[1] imm
     /*  68463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68475 */     // MIs[2] Operand 1
     /*  68475 */     // No operand predicates
     /*  68475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68495 */     GIR_RootConstrainSelectedInstOperands,
     /*  68496 */     // GIR_Coverage, 2300,
     /*  68496 */     GIR_EraseRootFromParent_Done,
     /*  68497 */   // Label 1128: @68497
     /*  68497 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68561), // Rule ID 13914 //
     /*  68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68548 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68553 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68559 */     GIR_RootConstrainSelectedInstOperands,
     /*  68560 */     // GIR_Coverage, 13914,
     /*  68560 */     GIR_EraseRootFromParent_Done,
     /*  68561 */   // Label 1129: @68561
     /*  68561 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68625), // Rule ID 5058 //
     /*  68566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68612 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 5058,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1130: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68652), // Rule ID 5064 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68645 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68650 */     GIR_RootConstrainSelectedInstOperands,
     /*  68651 */     // GIR_Coverage, 5064,
     /*  68651 */     GIR_Done,
     /*  68652 */   // Label 1131: @68652
     /*  68652 */   GIM_Reject,
     /*  68653 */ // Label 1116: @68653
     /*  68653 */ GIM_Reject,
     /*  68654 */ // Label 1020: @68654
     /*  68654 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69961),
     /*  68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68774), // Rule ID 13395 //
     /*  68670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68748 */     // MIs[4] Rd
     /*  68748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68755 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 13395,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1133: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68883), // Rule ID 13394 //
     /*  68779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68852 */     // MIs[4] Rd
     /*  68852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68864 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 13394,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1134: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68992), // Rule ID 13397 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68957 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68961 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68966 */     // MIs[4] Rd
     /*  68966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68973 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 13397,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1135: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69101), // Rule ID 13396 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69066 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69070 */     // MIs[4] Rd
     /*  69070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69075 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69082 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69099 */     GIR_RootConstrainSelectedInstOperands,
     /*  69100 */     // GIR_Coverage, 13396,
     /*  69100 */     GIR_EraseRootFromParent_Done,
     /*  69101 */   // Label 1136: @69101
     /*  69101 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69210), // Rule ID 1605 //
     /*  69106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69167 */     // MIs[3] Rd
     /*  69167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69191 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69208 */     GIR_RootConstrainSelectedInstOperands,
     /*  69209 */     // GIR_Coverage, 1605,
     /*  69209 */     GIR_EraseRootFromParent_Done,
     /*  69210 */   // Label 1137: @69210
     /*  69210 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69319), // Rule ID 13392 //
     /*  69215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69276 */     // MIs[3] Rd
     /*  69276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69285 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69300 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69317 */     GIR_RootConstrainSelectedInstOperands,
     /*  69318 */     // GIR_Coverage, 13392,
     /*  69318 */     GIR_EraseRootFromParent_Done,
     /*  69319 */   // Label 1138: @69319
     /*  69319 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69428), // Rule ID 13391 //
     /*  69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69390 */     // MIs[3] Rd
     /*  69390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69409 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69426 */     GIR_RootConstrainSelectedInstOperands,
     /*  69427 */     // GIR_Coverage, 13391,
     /*  69427 */     GIR_EraseRootFromParent_Done,
     /*  69428 */   // Label 1139: @69428
     /*  69428 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69537), // Rule ID 13393 //
     /*  69433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69499 */     // MIs[3] Rd
     /*  69499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69518 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69535 */     GIR_RootConstrainSelectedInstOperands,
     /*  69536 */     // GIR_Coverage, 13393,
     /*  69536 */     GIR_EraseRootFromParent_Done,
     /*  69537 */   // Label 1140: @69537
     /*  69537 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69604), // Rule ID 13569 //
     /*  69542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     // MIs[1] imm
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69578 */     // MIs[2] Operand 1
     /*  69578 */     // No operand predicates
     /*  69578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69588 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69602 */     GIR_RootConstrainSelectedInstOperands,
     /*  69603 */     // GIR_Coverage, 13569,
     /*  69603 */     GIR_EraseRootFromParent_Done,
     /*  69604 */   // Label 1141: @69604
     /*  69604 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69671), // Rule ID 13590 //
     /*  69609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     // MIs[1] imm
     /*  69633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69645 */     // MIs[2] Operand 1
     /*  69645 */     // No operand predicates
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69655 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69669 */     GIR_RootConstrainSelectedInstOperands,
     /*  69670 */     // GIR_Coverage, 13590,
     /*  69670 */     GIR_EraseRootFromParent_Done,
     /*  69671 */   // Label 1142: @69671
     /*  69671 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69738), // Rule ID 2231 //
     /*  69676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69704 */     // MIs[1] imm
     /*  69704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69716 */     // MIs[2] Operand 1
     /*  69716 */     // No operand predicates
     /*  69716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69722 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69736 */     GIR_RootConstrainSelectedInstOperands,
     /*  69737 */     // GIR_Coverage, 2231,
     /*  69737 */     GIR_EraseRootFromParent_Done,
     /*  69738 */   // Label 1143: @69738
     /*  69738 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69805), // Rule ID 2290 //
     /*  69743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69771 */     // MIs[1] imm
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69783 */     // MIs[2] Operand 1
     /*  69783 */     // No operand predicates
     /*  69783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69789 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69803 */     GIR_RootConstrainSelectedInstOperands,
     /*  69804 */     // GIR_Coverage, 2290,
     /*  69804 */     GIR_EraseRootFromParent_Done,
     /*  69805 */   // Label 1144: @69805
     /*  69805 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69869), // Rule ID 13389 //
     /*  69810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69856 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69867 */     GIR_RootConstrainSelectedInstOperands,
     /*  69868 */     // GIR_Coverage, 13389,
     /*  69868 */     GIR_EraseRootFromParent_Done,
     /*  69869 */   // Label 1145: @69869
     /*  69869 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69933), // Rule ID 1601 //
     /*  69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69920 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69931 */     GIR_RootConstrainSelectedInstOperands,
     /*  69932 */     // GIR_Coverage, 1601,
     /*  69932 */     GIR_EraseRootFromParent_Done,
     /*  69933 */   // Label 1146: @69933
     /*  69933 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69960), // Rule ID 1603 //
     /*  69938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69953 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69958 */     GIR_RootConstrainSelectedInstOperands,
     /*  69959 */     // GIR_Coverage, 1603,
     /*  69959 */     GIR_Done,
     /*  69960 */   // Label 1147: @69960
     /*  69960 */   GIM_Reject,
     /*  69961 */ // Label 1132: @69961
     /*  69961 */ GIM_Reject,
     /*  69962 */ // Label 1021: @69962
     /*  69962 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71269),
     /*  69967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70082), // Rule ID 13628 //
     /*  69978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70047 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70051 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70056 */     // MIs[4] LHS
     /*  70056 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70063 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 13628,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1149: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70191), // Rule ID 13627 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70160 */     // MIs[4] LHS
     /*  70160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70172 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70189 */     GIR_RootConstrainSelectedInstOperands,
     /*  70190 */     // GIR_Coverage, 13627,
     /*  70190 */     GIR_EraseRootFromParent_Done,
     /*  70191 */   // Label 1150: @70191
     /*  70191 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70300), // Rule ID 13630 //
     /*  70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70265 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70274 */     // MIs[4] LHS
     /*  70274 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70279 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70281 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70298 */     GIR_RootConstrainSelectedInstOperands,
     /*  70299 */     // GIR_Coverage, 13630,
     /*  70299 */     GIR_EraseRootFromParent_Done,
     /*  70300 */   // Label 1151: @70300
     /*  70300 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70409), // Rule ID 13629 //
     /*  70305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70378 */     // MIs[4] LHS
     /*  70378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70390 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 13629,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1152: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70518), // Rule ID 2472 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70475 */     // MIs[3] LHS
     /*  70475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70499 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70516 */     GIR_RootConstrainSelectedInstOperands,
     /*  70517 */     // GIR_Coverage, 2472,
     /*  70517 */     GIR_EraseRootFromParent_Done,
     /*  70518 */   // Label 1153: @70518
     /*  70518 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70627), // Rule ID 13625 //
     /*  70523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70584 */     // MIs[3] LHS
     /*  70584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70608 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70625 */     GIR_RootConstrainSelectedInstOperands,
     /*  70626 */     // GIR_Coverage, 13625,
     /*  70626 */     GIR_EraseRootFromParent_Done,
     /*  70627 */   // Label 1154: @70627
     /*  70627 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70736), // Rule ID 13624 //
     /*  70632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70698 */     // MIs[3] LHS
     /*  70698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70707 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70717 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 13624,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1155: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70845), // Rule ID 13626 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70807 */     // MIs[3] LHS
     /*  70807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70826 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70843 */     GIR_RootConstrainSelectedInstOperands,
     /*  70844 */     // GIR_Coverage, 13626,
     /*  70844 */     GIR_EraseRootFromParent_Done,
     /*  70845 */   // Label 1156: @70845
     /*  70845 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70912), // Rule ID 13575 //
     /*  70850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[1] imm
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70886 */     // MIs[2] Operand 1
     /*  70886 */     // No operand predicates
     /*  70886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70896 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70910 */     GIR_RootConstrainSelectedInstOperands,
     /*  70911 */     // GIR_Coverage, 13575,
     /*  70911 */     GIR_EraseRootFromParent_Done,
     /*  70912 */   // Label 1157: @70912
     /*  70912 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70979), // Rule ID 13596 //
     /*  70917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     // MIs[1] imm
     /*  70941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70953 */     // MIs[2] Operand 1
     /*  70953 */     // No operand predicates
     /*  70953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70963 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70977 */     GIR_RootConstrainSelectedInstOperands,
     /*  70978 */     // GIR_Coverage, 13596,
     /*  70978 */     GIR_EraseRootFromParent_Done,
     /*  70979 */   // Label 1158: @70979
     /*  70979 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71046), // Rule ID 2237 //
     /*  70984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71012 */     // MIs[1] imm
     /*  71012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71024 */     // MIs[2] Operand 1
     /*  71024 */     // No operand predicates
     /*  71024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71030 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71044 */     GIR_RootConstrainSelectedInstOperands,
     /*  71045 */     // GIR_Coverage, 2237,
     /*  71045 */     GIR_EraseRootFromParent_Done,
     /*  71046 */   // Label 1159: @71046
     /*  71046 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71113), // Rule ID 2296 //
     /*  71051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71079 */     // MIs[1] imm
     /*  71079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71091 */     // MIs[2] Operand 1
     /*  71091 */     // No operand predicates
     /*  71091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71097 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71111 */     GIR_RootConstrainSelectedInstOperands,
     /*  71112 */     // GIR_Coverage, 2296,
     /*  71112 */     GIR_EraseRootFromParent_Done,
     /*  71113 */   // Label 1160: @71113
     /*  71113 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71177), // Rule ID 13913 //
     /*  71118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 13913,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1161: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71241), // Rule ID 5057 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71228 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 5057,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1162: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71268), // Rule ID 5063 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71261 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 5063,
     /*  71267 */     GIR_Done,
     /*  71268 */   // Label 1163: @71268
     /*  71268 */   GIM_Reject,
     /*  71269 */ // Label 1148: @71269
     /*  71269 */ GIM_Reject,
     /*  71270 */ // Label 1022: @71270
     /*  71270 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72577),
     /*  71275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71390), // Rule ID 13402 //
     /*  71286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71359 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71364 */     // MIs[4] Rd
     /*  71364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71371 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71388 */     GIR_RootConstrainSelectedInstOperands,
     /*  71389 */     // GIR_Coverage, 13402,
     /*  71389 */     GIR_EraseRootFromParent_Done,
     /*  71390 */   // Label 1165: @71390
     /*  71390 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71499), // Rule ID 13401 //
     /*  71395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71468 */     // MIs[4] Rd
     /*  71468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71480 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71497 */     GIR_RootConstrainSelectedInstOperands,
     /*  71498 */     // GIR_Coverage, 13401,
     /*  71498 */     GIR_EraseRootFromParent_Done,
     /*  71499 */   // Label 1166: @71499
     /*  71499 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71608), // Rule ID 13404 //
     /*  71504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71573 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71582 */     // MIs[4] Rd
     /*  71582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71589 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71606 */     GIR_RootConstrainSelectedInstOperands,
     /*  71607 */     // GIR_Coverage, 13404,
     /*  71607 */     GIR_EraseRootFromParent_Done,
     /*  71608 */   // Label 1167: @71608
     /*  71608 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71717), // Rule ID 13403 //
     /*  71613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71686 */     // MIs[4] Rd
     /*  71686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71698 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71715 */     GIR_RootConstrainSelectedInstOperands,
     /*  71716 */     // GIR_Coverage, 13403,
     /*  71716 */     GIR_EraseRootFromParent_Done,
     /*  71717 */   // Label 1168: @71717
     /*  71717 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71826), // Rule ID 1606 //
     /*  71722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71783 */     // MIs[3] Rd
     /*  71783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71807 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 1606,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1169: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71935), // Rule ID 13399 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71892 */     // MIs[3] Rd
     /*  71892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71901 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71914 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71916 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71933 */     GIR_RootConstrainSelectedInstOperands,
     /*  71934 */     // GIR_Coverage, 13399,
     /*  71934 */     GIR_EraseRootFromParent_Done,
     /*  71935 */   // Label 1170: @71935
     /*  71935 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72044), // Rule ID 13398 //
     /*  71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72006 */     // MIs[3] Rd
     /*  72006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72015 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72025 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 13398,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1171: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72153), // Rule ID 13400 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72115 */     // MIs[3] Rd
     /*  72115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72134 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72151 */     GIR_RootConstrainSelectedInstOperands,
     /*  72152 */     // GIR_Coverage, 13400,
     /*  72152 */     GIR_EraseRootFromParent_Done,
     /*  72153 */   // Label 1172: @72153
     /*  72153 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72220), // Rule ID 13571 //
     /*  72158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     // MIs[1] imm
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72194 */     // MIs[2] Operand 1
     /*  72194 */     // No operand predicates
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72204 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72218 */     GIR_RootConstrainSelectedInstOperands,
     /*  72219 */     // GIR_Coverage, 13571,
     /*  72219 */     GIR_EraseRootFromParent_Done,
     /*  72220 */   // Label 1173: @72220
     /*  72220 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72287), // Rule ID 13592 //
     /*  72225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     // MIs[1] imm
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72261 */     // MIs[2] Operand 1
     /*  72261 */     // No operand predicates
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72271 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72285 */     GIR_RootConstrainSelectedInstOperands,
     /*  72286 */     // GIR_Coverage, 13592,
     /*  72286 */     GIR_EraseRootFromParent_Done,
     /*  72287 */   // Label 1174: @72287
     /*  72287 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72354), // Rule ID 2233 //
     /*  72292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72320 */     // MIs[1] imm
     /*  72320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72332 */     // MIs[2] Operand 1
     /*  72332 */     // No operand predicates
     /*  72332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72338 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2233,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1175: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72421), // Rule ID 2292 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72387 */     // MIs[1] imm
     /*  72387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72399 */     // MIs[2] Operand 1
     /*  72399 */     // No operand predicates
     /*  72399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72405 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72419 */     GIR_RootConstrainSelectedInstOperands,
     /*  72420 */     // GIR_Coverage, 2292,
     /*  72420 */     GIR_EraseRootFromParent_Done,
     /*  72421 */   // Label 1176: @72421
     /*  72421 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72485), // Rule ID 13390 //
     /*  72426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72472 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 13390,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1177: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72549), // Rule ID 1602 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72536 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72547 */     GIR_RootConstrainSelectedInstOperands,
     /*  72548 */     // GIR_Coverage, 1602,
     /*  72548 */     GIR_EraseRootFromParent_Done,
     /*  72549 */   // Label 1178: @72549
     /*  72549 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72576), // Rule ID 1604 //
     /*  72554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72569 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 1604,
     /*  72575 */     GIR_Done,
     /*  72576 */   // Label 1179: @72576
     /*  72576 */   GIM_Reject,
     /*  72577 */ // Label 1164: @72577
     /*  72577 */ GIM_Reject,
     /*  72578 */ // Label 1023: @72578
     /*  72578 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72609), // Rule ID 8474 //
     /*  72583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72596 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72605 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72607 */   GIR_RootConstrainSelectedInstOperands,
     /*  72608 */   // GIR_Coverage, 8474,
     /*  72608 */   GIR_EraseRootFromParent_Done,
     /*  72609 */ // Label 1180: @72609
     /*  72609 */ GIM_Reject,
     /*  72610 */ // Label 1024: @72610
     /*  72610 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72641), // Rule ID 8473 //
     /*  72615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72628 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72637 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72639 */   GIR_RootConstrainSelectedInstOperands,
     /*  72640 */   // GIR_Coverage, 8473,
     /*  72640 */   GIR_EraseRootFromParent_Done,
     /*  72641 */ // Label 1181: @72641
     /*  72641 */ GIM_Reject,
     /*  72642 */ // Label 1025: @72642
     /*  72642 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72667), // Rule ID 7479 //
     /*  72647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72660 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  72660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72665 */   GIR_RootConstrainSelectedInstOperands,
     /*  72666 */   // GIR_Coverage, 7479,
     /*  72666 */   GIR_Done,
     /*  72667 */ // Label 1182: @72667
     /*  72667 */ GIM_Reject,
     /*  72668 */ // Label 1026: @72668
     /*  72668 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72699), // Rule ID 8472 //
     /*  72673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  72679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  72682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72686 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  72686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72691 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72693 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72695 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72697 */   GIR_RootConstrainSelectedInstOperands,
     /*  72698 */   // GIR_Coverage, 8472,
     /*  72698 */   GIR_EraseRootFromParent_Done,
     /*  72699 */ // Label 1183: @72699
     /*  72699 */ GIM_Reject,
     /*  72700 */ // Label 1027: @72700
     /*  72700 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72725), // Rule ID 7478 //
     /*  72705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72718 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72723 */   GIR_RootConstrainSelectedInstOperands,
     /*  72724 */   // GIR_Coverage, 7478,
     /*  72724 */   GIR_Done,
     /*  72725 */ // Label 1184: @72725
     /*  72725 */ GIM_Reject,
     /*  72726 */ // Label 1028: @72726
     /*  72726 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72757), // Rule ID 8471 //
     /*  72731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72744 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72749 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72751 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72753 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72755 */   GIR_RootConstrainSelectedInstOperands,
     /*  72756 */   // GIR_Coverage, 8471,
     /*  72756 */   GIR_EraseRootFromParent_Done,
     /*  72757 */ // Label 1185: @72757
     /*  72757 */ GIM_Reject,
     /*  72758 */ // Label 1029: @72758
     /*  72758 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(72783), // Rule ID 7477 //
     /*  72763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72776 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72781 */   GIR_RootConstrainSelectedInstOperands,
     /*  72782 */   // GIR_Coverage, 7477,
     /*  72782 */   GIR_Done,
     /*  72783 */ // Label 1186: @72783
     /*  72783 */ GIM_Reject,
     /*  72784 */ // Label 1030: @72784
     /*  72784 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(72815), // Rule ID 8470 //
     /*  72789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72802 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72807 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72809 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72811 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72813 */   GIR_RootConstrainSelectedInstOperands,
     /*  72814 */   // GIR_Coverage, 8470,
     /*  72814 */   GIR_EraseRootFromParent_Done,
     /*  72815 */ // Label 1187: @72815
     /*  72815 */ GIM_Reject,
     /*  72816 */ // Label 1031: @72816
     /*  72816 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(72841), // Rule ID 7476 //
     /*  72821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72834 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72839 */   GIR_RootConstrainSelectedInstOperands,
     /*  72840 */   // GIR_Coverage, 7476,
     /*  72840 */   GIR_Done,
     /*  72841 */ // Label 1188: @72841
     /*  72841 */ GIM_Reject,
     /*  72842 */ // Label 1032: @72842
     /*  72842 */ GIM_Reject,
     /*  72843 */ // Label 7: @72843
     /*  72843 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1207*/ GIMT_Encode4(80034),
     /*  72854 */ /*GILLT_s32*//*Label 1189*/ GIMT_Encode4(72942),
     /*  72858 */ /*GILLT_s64*//*Label 1190*/ GIMT_Encode4(73622), GIMT_Encode4(0),
     /*  72866 */ /*GILLT_v2s32*//*Label 1191*/ GIMT_Encode4(74465),
     /*  72870 */ /*GILLT_v2s64*//*Label 1192*/ GIMT_Encode4(74700),
     /*  72874 */ /*GILLT_v4s16*//*Label 1193*/ GIMT_Encode4(75389),
     /*  72878 */ /*GILLT_v4s32*//*Label 1194*/ GIMT_Encode4(75624),
     /*  72882 */ /*GILLT_v8s8*//*Label 1195*/ GIMT_Encode4(76313),
     /*  72886 */ /*GILLT_v8s16*//*Label 1196*/ GIMT_Encode4(76551),
     /*  72890 */ /*GILLT_v16s8*//*Label 1197*/ GIMT_Encode4(77240),
     /*  72894 */ /*GILLT_nxv1s1*//*Label 1198*/ GIMT_Encode4(77932),
     /*  72898 */ /*GILLT_nxv2s1*//*Label 1199*/ GIMT_Encode4(77982), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72910 */ /*GILLT_nxv2s64*//*Label 1200*/ GIMT_Encode4(78032),
     /*  72914 */ /*GILLT_nxv4s1*//*Label 1201*/ GIMT_Encode4(78495), GIMT_Encode4(0),
     /*  72922 */ /*GILLT_nxv4s32*//*Label 1202*/ GIMT_Encode4(78545),
     /*  72926 */ /*GILLT_nxv8s1*//*Label 1203*/ GIMT_Encode4(79008),
     /*  72930 */ /*GILLT_nxv8s16*//*Label 1204*/ GIMT_Encode4(79058),
     /*  72934 */ /*GILLT_nxv16s1*//*Label 1205*/ GIMT_Encode4(79521),
     /*  72938 */ /*GILLT_nxv16s8*//*Label 1206*/ GIMT_Encode4(79571),
     /*  72942 */ // Label 1189: @72942
     /*  72942 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(73621),
     /*  72947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72953 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(73011), // Rule ID 13260 //
     /*  72958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72996 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73009 */     GIR_RootConstrainSelectedInstOperands,
     /*  73010 */     // GIR_Coverage, 13260,
     /*  73010 */     GIR_EraseRootFromParent_Done,
     /*  73011 */   // Label 1209: @73011
     /*  73011 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(73066), // Rule ID 13259 //
     /*  73016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73036 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73053 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73064 */     GIR_RootConstrainSelectedInstOperands,
     /*  73065 */     // GIR_Coverage, 13259,
     /*  73065 */     GIR_EraseRootFromParent_Done,
     /*  73066 */   // Label 1210: @73066
     /*  73066 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(73124), // Rule ID 13257 //
     /*  73071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73109 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73122 */     GIR_RootConstrainSelectedInstOperands,
     /*  73123 */     // GIR_Coverage, 13257,
     /*  73123 */     GIR_EraseRootFromParent_Done,
     /*  73124 */   // Label 1211: @73124
     /*  73124 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(73182), // Rule ID 166 //
     /*  73129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73167 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73180 */     GIR_RootConstrainSelectedInstOperands,
     /*  73181 */     // GIR_Coverage, 166,
     /*  73181 */     GIR_EraseRootFromParent_Done,
     /*  73182 */   // Label 1212: @73182
     /*  73182 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(73240), // Rule ID 13258 //
     /*  73187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73212 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73225 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73238 */     GIR_RootConstrainSelectedInstOperands,
     /*  73239 */     // GIR_Coverage, 13258,
     /*  73239 */     GIR_EraseRootFromParent_Done,
     /*  73240 */   // Label 1213: @73240
     /*  73240 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(73295), // Rule ID 13261 //
     /*  73245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73269 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73282 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73293 */     GIR_RootConstrainSelectedInstOperands,
     /*  73294 */     // GIR_Coverage, 13261,
     /*  73294 */     GIR_EraseRootFromParent_Done,
     /*  73295 */   // Label 1214: @73295
     /*  73295 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(73336), // Rule ID 144 //
     /*  73300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  73304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73316 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  73320 */     // MIs[1] Operand 1
     /*  73320 */     // No operand predicates
     /*  73320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73322 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  73322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  73325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73329 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  73334 */     GIR_RootConstrainSelectedInstOperands,
     /*  73335 */     // GIR_Coverage, 144,
     /*  73335 */     GIR_EraseRootFromParent_Done,
     /*  73336 */   // Label 1215: @73336
     /*  73336 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(73369), // Rule ID 13267 //
     /*  73341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73356 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73367 */     GIR_RootConstrainSelectedInstOperands,
     /*  73368 */     // GIR_Coverage, 13267,
     /*  73368 */     GIR_EraseRootFromParent_Done,
     /*  73369 */   // Label 1216: @73369
     /*  73369 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(73402), // Rule ID 170 //
     /*  73374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73389 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73400 */     GIR_RootConstrainSelectedInstOperands,
     /*  73401 */     // GIR_Coverage, 170,
     /*  73401 */     GIR_EraseRootFromParent_Done,
     /*  73402 */   // Label 1217: @73402
     /*  73402 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73455), // Rule ID 13253 //
     /*  73407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73442 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73453 */     GIR_RootConstrainSelectedInstOperands,
     /*  73454 */     // GIR_Coverage, 13253,
     /*  73454 */     GIR_EraseRootFromParent_Done,
     /*  73455 */   // Label 1218: @73455
     /*  73455 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73511), // Rule ID 164 //
     /*  73460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73496 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73509 */     GIR_RootConstrainSelectedInstOperands,
     /*  73510 */     // GIR_Coverage, 164,
     /*  73510 */     GIR_EraseRootFromParent_Done,
     /*  73511 */   // Label 1219: @73511
     /*  73511 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73564), // Rule ID 13254 //
     /*  73516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73545 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73551 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73562 */     GIR_RootConstrainSelectedInstOperands,
     /*  73563 */     // GIR_Coverage, 13254,
     /*  73563 */     GIR_EraseRootFromParent_Done,
     /*  73564 */   // Label 1220: @73564
     /*  73564 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(73596), // Rule ID 4002 //
     /*  73569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73581 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  73581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  73584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  73594 */     GIR_RootConstrainSelectedInstOperands,
     /*  73595 */     // GIR_Coverage, 4002,
     /*  73595 */     GIR_EraseRootFromParent_Done,
     /*  73596 */   // Label 1221: @73596
     /*  73596 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73620), // Rule ID 168 //
     /*  73601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73613 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  73618 */     GIR_RootConstrainSelectedInstOperands,
     /*  73619 */     // GIR_Coverage, 168,
     /*  73619 */     GIR_Done,
     /*  73620 */   // Label 1222: @73620
     /*  73620 */   GIM_Reject,
     /*  73621 */ // Label 1208: @73621
     /*  73621 */ GIM_Reject,
     /*  73622 */ // Label 1190: @73622
     /*  73622 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(74464),
     /*  73627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  73630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  73633 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73691), // Rule ID 13265 //
     /*  73638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73676 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73689 */     GIR_RootConstrainSelectedInstOperands,
     /*  73690 */     // GIR_Coverage, 13265,
     /*  73690 */     GIR_EraseRootFromParent_Done,
     /*  73691 */   // Label 1224: @73691
     /*  73691 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73746), // Rule ID 13264 //
     /*  73696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73733 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73744 */     GIR_RootConstrainSelectedInstOperands,
     /*  73745 */     // GIR_Coverage, 13264,
     /*  73745 */     GIR_EraseRootFromParent_Done,
     /*  73746 */   // Label 1225: @73746
     /*  73746 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73804), // Rule ID 13262 //
     /*  73751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73789 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73802 */     GIR_RootConstrainSelectedInstOperands,
     /*  73803 */     // GIR_Coverage, 13262,
     /*  73803 */     GIR_EraseRootFromParent_Done,
     /*  73804 */   // Label 1226: @73804
     /*  73804 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73862), // Rule ID 167 //
     /*  73809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73847 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73860 */     GIR_RootConstrainSelectedInstOperands,
     /*  73861 */     // GIR_Coverage, 167,
     /*  73861 */     GIR_EraseRootFromParent_Done,
     /*  73862 */   // Label 1227: @73862
     /*  73862 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(73920), // Rule ID 13263 //
     /*  73867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73905 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73918 */     GIR_RootConstrainSelectedInstOperands,
     /*  73919 */     // GIR_Coverage, 13263,
     /*  73919 */     GIR_EraseRootFromParent_Done,
     /*  73920 */   // Label 1228: @73920
     /*  73920 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73975), // Rule ID 13266 //
     /*  73925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73962 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73973 */     GIR_RootConstrainSelectedInstOperands,
     /*  73974 */     // GIR_Coverage, 13266,
     /*  73974 */     GIR_EraseRootFromParent_Done,
     /*  73975 */   // Label 1229: @73975
     /*  73975 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(74075), // Rule ID 1613 //
     /*  73980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  74003 */     // MIs[1] Operand 1
     /*  74003 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  74020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  74024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74038 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74044 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74060 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  74060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  74063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74073 */     GIR_RootConstrainSelectedInstOperands,
     /*  74074 */     // GIR_Coverage, 1613,
     /*  74074 */     GIR_EraseRootFromParent_Done,
     /*  74075 */   // Label 1230: @74075
     /*  74075 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(74116), // Rule ID 145 //
     /*  74080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  74084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74096 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  74100 */     // MIs[1] Operand 1
     /*  74100 */     // No operand predicates
     /*  74100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74102 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  74102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  74105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74109 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  74114 */     GIR_RootConstrainSelectedInstOperands,
     /*  74115 */     // GIR_Coverage, 145,
     /*  74115 */     GIR_EraseRootFromParent_Done,
     /*  74116 */   // Label 1231: @74116
     /*  74116 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(74149), // Rule ID 13268 //
     /*  74121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74136 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  74143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74147 */     GIR_RootConstrainSelectedInstOperands,
     /*  74148 */     // GIR_Coverage, 13268,
     /*  74148 */     GIR_EraseRootFromParent_Done,
     /*  74149 */   // Label 1232: @74149
     /*  74149 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(74182), // Rule ID 171 //
     /*  74154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74169 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74180 */     GIR_RootConstrainSelectedInstOperands,
     /*  74181 */     // GIR_Coverage, 171,
     /*  74181 */     GIR_EraseRootFromParent_Done,
     /*  74182 */   // Label 1233: @74182
     /*  74182 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(74235), // Rule ID 13255 //
     /*  74187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74212 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74222 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  74233 */     GIR_RootConstrainSelectedInstOperands,
     /*  74234 */     // GIR_Coverage, 13255,
     /*  74234 */     GIR_EraseRootFromParent_Done,
     /*  74235 */   // Label 1234: @74235
     /*  74235 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(74291), // Rule ID 165 //
     /*  74240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74276 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  74289 */     GIR_RootConstrainSelectedInstOperands,
     /*  74290 */     // GIR_Coverage, 165,
     /*  74290 */     GIR_EraseRootFromParent_Done,
     /*  74291 */   // Label 1235: @74291
     /*  74291 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(74344), // Rule ID 13256 //
     /*  74296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74331 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  74342 */     GIR_RootConstrainSelectedInstOperands,
     /*  74343 */     // GIR_Coverage, 13256,
     /*  74343 */     GIR_EraseRootFromParent_Done,
     /*  74344 */   // Label 1236: @74344
     /*  74344 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(74376), // Rule ID 4003 //
     /*  74349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74361 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  74361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  74364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  74374 */     GIR_RootConstrainSelectedInstOperands,
     /*  74375 */     // GIR_Coverage, 4003,
     /*  74375 */     GIR_EraseRootFromParent_Done,
     /*  74376 */   // Label 1237: @74376
     /*  74376 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(74412), // Rule ID 4951 //
     /*  74381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74393 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74403 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  74403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74410 */     GIR_RootConstrainSelectedInstOperands,
     /*  74411 */     // GIR_Coverage, 4951,
     /*  74411 */     GIR_EraseRootFromParent_Done,
     /*  74412 */   // Label 1238: @74412
     /*  74412 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(74436), // Rule ID 169 //
     /*  74417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74429 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  74434 */     GIR_RootConstrainSelectedInstOperands,
     /*  74435 */     // GIR_Coverage, 169,
     /*  74435 */     GIR_Done,
     /*  74436 */   // Label 1239: @74436
     /*  74436 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74463), // Rule ID 5050 //
     /*  74441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74456 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  74456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74461 */     GIR_RootConstrainSelectedInstOperands,
     /*  74462 */     // GIR_Coverage, 5050,
     /*  74462 */     GIR_Done,
     /*  74463 */   // Label 1240: @74463
     /*  74463 */   GIM_Reject,
     /*  74464 */ // Label 1223: @74464
     /*  74464 */ GIM_Reject,
     /*  74465 */ // Label 1191: @74465
     /*  74465 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74699),
     /*  74470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74480 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74576), // Rule ID 1160 //
     /*  74485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74504 */     // MIs[1] Operand 1
     /*  74504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74539 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74545 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74547 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74551 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74561 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  74561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74574 */     GIR_RootConstrainSelectedInstOperands,
     /*  74575 */     // GIR_Coverage, 1160,
     /*  74575 */     GIR_EraseRootFromParent_Done,
     /*  74576 */   // Label 1242: @74576
     /*  74576 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74643), // Rule ID 4998 //
     /*  74581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74593 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74597 */     // MIs[1] Operand 1
     /*  74597 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74606 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74618 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74624 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74628 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  74628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74641 */     GIR_RootConstrainSelectedInstOperands,
     /*  74642 */     // GIR_Coverage, 4998,
     /*  74642 */     GIR_EraseRootFromParent_Done,
     /*  74643 */   // Label 1243: @74643
     /*  74643 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74675), // Rule ID 4949 //
     /*  74648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74666 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  74666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74673 */     GIR_RootConstrainSelectedInstOperands,
     /*  74674 */     // GIR_Coverage, 4949,
     /*  74674 */     GIR_EraseRootFromParent_Done,
     /*  74675 */   // Label 1244: @74675
     /*  74675 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74698), // Rule ID 5049 //
     /*  74680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74691 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  74691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74696 */     GIR_RootConstrainSelectedInstOperands,
     /*  74697 */     // GIR_Coverage, 5049,
     /*  74697 */     GIR_Done,
     /*  74698 */   // Label 1245: @74698
     /*  74698 */   GIM_Reject,
     /*  74699 */ // Label 1241: @74699
     /*  74699 */ GIM_Reject,
     /*  74700 */ // Label 1192: @74700
     /*  74700 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(75388),
     /*  74705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74715 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74811), // Rule ID 1162 //
     /*  74720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74739 */     // MIs[1] Operand 1
     /*  74739 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74774 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74786 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74796 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74809 */     GIR_RootConstrainSelectedInstOperands,
     /*  74810 */     // GIR_Coverage, 1162,
     /*  74810 */     GIR_EraseRootFromParent_Done,
     /*  74811 */   // Label 1247: @74811
     /*  74811 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74878), // Rule ID 5000 //
     /*  74816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74832 */     // MIs[1] Operand 1
     /*  74832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74841 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74853 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74863 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74876 */     GIR_RootConstrainSelectedInstOperands,
     /*  74877 */     // GIR_Coverage, 5000,
     /*  74877 */     GIR_EraseRootFromParent_Done,
     /*  74878 */   // Label 1248: @74878
     /*  74878 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74963), // Rule ID 13790 //
     /*  74883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74927 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74946 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74961 */     GIR_RootConstrainSelectedInstOperands,
     /*  74962 */     // GIR_Coverage, 13790,
     /*  74962 */     GIR_EraseRootFromParent_Done,
     /*  74963 */   // Label 1249: @74963
     /*  74963 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(75048), // Rule ID 13789 //
     /*  74968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75031 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75046 */     GIR_RootConstrainSelectedInstOperands,
     /*  75047 */     // GIR_Coverage, 13789,
     /*  75047 */     GIR_EraseRootFromParent_Done,
     /*  75048 */   // Label 1250: @75048
     /*  75048 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(75133), // Rule ID 13788 //
     /*  75053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75101 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75116 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75131 */     GIR_RootConstrainSelectedInstOperands,
     /*  75132 */     // GIR_Coverage, 13788,
     /*  75132 */     GIR_EraseRootFromParent_Done,
     /*  75133 */   // Label 1251: @75133
     /*  75133 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(75218), // Rule ID 3830 //
     /*  75138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75191 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75197 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75201 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75216 */     GIR_RootConstrainSelectedInstOperands,
     /*  75217 */     // GIR_Coverage, 3830,
     /*  75217 */     GIR_EraseRootFromParent_Done,
     /*  75218 */   // Label 1252: @75218
     /*  75218 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(75250), // Rule ID 4952 //
     /*  75223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75231 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75241 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  75241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75248 */     GIR_RootConstrainSelectedInstOperands,
     /*  75249 */     // GIR_Coverage, 4952,
     /*  75249 */     GIR_EraseRootFromParent_Done,
     /*  75250 */   // Label 1253: @75250
     /*  75250 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(75307), // Rule ID 3826 //
     /*  75255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75290 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75305 */     GIR_RootConstrainSelectedInstOperands,
     /*  75306 */     // GIR_Coverage, 3826,
     /*  75306 */     GIR_EraseRootFromParent_Done,
     /*  75307 */   // Label 1254: @75307
     /*  75307 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(75364), // Rule ID 13778 //
     /*  75312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75347 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75362 */     GIR_RootConstrainSelectedInstOperands,
     /*  75363 */     // GIR_Coverage, 13778,
     /*  75363 */     GIR_EraseRootFromParent_Done,
     /*  75364 */   // Label 1255: @75364
     /*  75364 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(75387), // Rule ID 5053 //
     /*  75369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75380 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  75380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75385 */     GIR_RootConstrainSelectedInstOperands,
     /*  75386 */     // GIR_Coverage, 5053,
     /*  75386 */     GIR_Done,
     /*  75387 */   // Label 1256: @75387
     /*  75387 */   GIM_Reject,
     /*  75388 */ // Label 1246: @75388
     /*  75388 */ GIM_Reject,
     /*  75389 */ // Label 1193: @75389
     /*  75389 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(75623),
     /*  75394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75404 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(75500), // Rule ID 1158 //
     /*  75409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75428 */     // MIs[1] Operand 1
     /*  75428 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75485 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  75485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75498 */     GIR_RootConstrainSelectedInstOperands,
     /*  75499 */     // GIR_Coverage, 1158,
     /*  75499 */     GIR_EraseRootFromParent_Done,
     /*  75500 */   // Label 1258: @75500
     /*  75500 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75567), // Rule ID 4996 //
     /*  75505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75517 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75521 */     // MIs[1] Operand 1
     /*  75521 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75530 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75542 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75552 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  75552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75565 */     GIR_RootConstrainSelectedInstOperands,
     /*  75566 */     // GIR_Coverage, 4996,
     /*  75566 */     GIR_EraseRootFromParent_Done,
     /*  75567 */   // Label 1259: @75567
     /*  75567 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75599), // Rule ID 4947 //
     /*  75572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75580 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75590 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  75590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75597 */     GIR_RootConstrainSelectedInstOperands,
     /*  75598 */     // GIR_Coverage, 4947,
     /*  75598 */     GIR_EraseRootFromParent_Done,
     /*  75599 */   // Label 1260: @75599
     /*  75599 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75622), // Rule ID 5048 //
     /*  75604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75615 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  75615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75620 */     GIR_RootConstrainSelectedInstOperands,
     /*  75621 */     // GIR_Coverage, 5048,
     /*  75621 */     GIR_Done,
     /*  75622 */   // Label 1261: @75622
     /*  75622 */   GIM_Reject,
     /*  75623 */ // Label 1257: @75623
     /*  75623 */ GIM_Reject,
     /*  75624 */ // Label 1194: @75624
     /*  75624 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(76312),
     /*  75629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75639 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75735), // Rule ID 1161 //
     /*  75644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75663 */     // MIs[1] Operand 1
     /*  75663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75698 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75710 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75718 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75720 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75733 */     GIR_RootConstrainSelectedInstOperands,
     /*  75734 */     // GIR_Coverage, 1161,
     /*  75734 */     GIR_EraseRootFromParent_Done,
     /*  75735 */   // Label 1263: @75735
     /*  75735 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75802), // Rule ID 4999 //
     /*  75740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75756 */     // MIs[1] Operand 1
     /*  75756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75765 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75771 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75777 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75783 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75787 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75800 */     GIR_RootConstrainSelectedInstOperands,
     /*  75801 */     // GIR_Coverage, 4999,
     /*  75801 */     GIR_EraseRootFromParent_Done,
     /*  75802 */   // Label 1264: @75802
     /*  75802 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75887), // Rule ID 13787 //
     /*  75807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75851 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75870 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75885 */     GIR_RootConstrainSelectedInstOperands,
     /*  75886 */     // GIR_Coverage, 13787,
     /*  75886 */     GIR_EraseRootFromParent_Done,
     /*  75887 */   // Label 1265: @75887
     /*  75887 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75972), // Rule ID 13786 //
     /*  75892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75955 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75970 */     GIR_RootConstrainSelectedInstOperands,
     /*  75971 */     // GIR_Coverage, 13786,
     /*  75971 */     GIR_EraseRootFromParent_Done,
     /*  75972 */   // Label 1266: @75972
     /*  75972 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(76057), // Rule ID 13785 //
     /*  75977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76040 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76055 */     GIR_RootConstrainSelectedInstOperands,
     /*  76056 */     // GIR_Coverage, 13785,
     /*  76056 */     GIR_EraseRootFromParent_Done,
     /*  76057 */   // Label 1267: @76057
     /*  76057 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(76142), // Rule ID 3829 //
     /*  76062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76125 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76140 */     GIR_RootConstrainSelectedInstOperands,
     /*  76141 */     // GIR_Coverage, 3829,
     /*  76141 */     GIR_EraseRootFromParent_Done,
     /*  76142 */   // Label 1268: @76142
     /*  76142 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(76174), // Rule ID 4950 //
     /*  76147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76155 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76165 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  76165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76172 */     GIR_RootConstrainSelectedInstOperands,
     /*  76173 */     // GIR_Coverage, 4950,
     /*  76173 */     GIR_EraseRootFromParent_Done,
     /*  76174 */   // Label 1269: @76174
     /*  76174 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(76231), // Rule ID 3825 //
     /*  76179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76214 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76229 */     GIR_RootConstrainSelectedInstOperands,
     /*  76230 */     // GIR_Coverage, 3825,
     /*  76230 */     GIR_EraseRootFromParent_Done,
     /*  76231 */   // Label 1270: @76231
     /*  76231 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(76288), // Rule ID 13777 //
     /*  76236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76271 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76286 */     GIR_RootConstrainSelectedInstOperands,
     /*  76287 */     // GIR_Coverage, 13777,
     /*  76287 */     GIR_EraseRootFromParent_Done,
     /*  76288 */   // Label 1271: @76288
     /*  76288 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(76311), // Rule ID 5052 //
     /*  76293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76304 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  76304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76309 */     GIR_RootConstrainSelectedInstOperands,
     /*  76310 */     // GIR_Coverage, 5052,
     /*  76310 */     GIR_Done,
     /*  76311 */   // Label 1272: @76311
     /*  76311 */   GIM_Reject,
     /*  76312 */ // Label 1262: @76312
     /*  76312 */ GIM_Reject,
     /*  76313 */ // Label 1195: @76313
     /*  76313 */ GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(76550),
     /*  76318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76328 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(76424), // Rule ID 1156 //
     /*  76333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76352 */     // MIs[1] Operand 1
     /*  76352 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76387 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76409 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76422 */     GIR_RootConstrainSelectedInstOperands,
     /*  76423 */     // GIR_Coverage, 1156,
     /*  76423 */     GIR_EraseRootFromParent_Done,
     /*  76424 */   // Label 1274: @76424
     /*  76424 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76491), // Rule ID 4994 //
     /*  76429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76441 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76445 */     // MIs[1] Operand 1
     /*  76445 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76454 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76460 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76466 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76476 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  76476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76489 */     GIR_RootConstrainSelectedInstOperands,
     /*  76490 */     // GIR_Coverage, 4994,
     /*  76490 */     GIR_EraseRootFromParent_Done,
     /*  76491 */   // Label 1275: @76491
     /*  76491 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(76526), // Rule ID 972 //
     /*  76496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76517 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  76517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  76520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76524 */     GIR_RootConstrainSelectedInstOperands,
     /*  76525 */     // GIR_Coverage, 972,
     /*  76525 */     GIR_EraseRootFromParent_Done,
     /*  76526 */   // Label 1276: @76526
     /*  76526 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76549), // Rule ID 1599 //
     /*  76531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76542 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  76547 */     GIR_RootConstrainSelectedInstOperands,
     /*  76548 */     // GIR_Coverage, 1599,
     /*  76548 */     GIR_Done,
     /*  76549 */   // Label 1277: @76549
     /*  76549 */   GIM_Reject,
     /*  76550 */ // Label 1273: @76550
     /*  76550 */ GIM_Reject,
     /*  76551 */ // Label 1196: @76551
     /*  76551 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(77239),
     /*  76556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76566 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76662), // Rule ID 1159 //
     /*  76571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76590 */     // MIs[1] Operand 1
     /*  76590 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76625 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76633 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76637 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76645 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76647 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  76647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76660 */     GIR_RootConstrainSelectedInstOperands,
     /*  76661 */     // GIR_Coverage, 1159,
     /*  76661 */     GIR_EraseRootFromParent_Done,
     /*  76662 */   // Label 1279: @76662
     /*  76662 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76729), // Rule ID 4997 //
     /*  76667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76679 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76683 */     // MIs[1] Operand 1
     /*  76683 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76692 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76704 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76710 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76714 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  76714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76727 */     GIR_RootConstrainSelectedInstOperands,
     /*  76728 */     // GIR_Coverage, 4997,
     /*  76728 */     GIR_EraseRootFromParent_Done,
     /*  76729 */   // Label 1280: @76729
     /*  76729 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76814), // Rule ID 13784 //
     /*  76734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76778 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76797 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76812 */     GIR_RootConstrainSelectedInstOperands,
     /*  76813 */     // GIR_Coverage, 13784,
     /*  76813 */     GIR_EraseRootFromParent_Done,
     /*  76814 */   // Label 1281: @76814
     /*  76814 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76899), // Rule ID 13783 //
     /*  76819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76868 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76882 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76897 */     GIR_RootConstrainSelectedInstOperands,
     /*  76898 */     // GIR_Coverage, 13783,
     /*  76898 */     GIR_EraseRootFromParent_Done,
     /*  76899 */   // Label 1282: @76899
     /*  76899 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76984), // Rule ID 13782 //
     /*  76904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76952 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76967 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76982 */     GIR_RootConstrainSelectedInstOperands,
     /*  76983 */     // GIR_Coverage, 13782,
     /*  76983 */     GIR_EraseRootFromParent_Done,
     /*  76984 */   // Label 1283: @76984
     /*  76984 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(77069), // Rule ID 3828 //
     /*  76989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77042 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77052 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77067 */     GIR_RootConstrainSelectedInstOperands,
     /*  77068 */     // GIR_Coverage, 3828,
     /*  77068 */     GIR_EraseRootFromParent_Done,
     /*  77069 */   // Label 1284: @77069
     /*  77069 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(77101), // Rule ID 4948 //
     /*  77074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77082 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77092 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  77092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77099 */     GIR_RootConstrainSelectedInstOperands,
     /*  77100 */     // GIR_Coverage, 4948,
     /*  77100 */     GIR_EraseRootFromParent_Done,
     /*  77101 */   // Label 1285: @77101
     /*  77101 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(77158), // Rule ID 3824 //
     /*  77106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77141 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77156 */     GIR_RootConstrainSelectedInstOperands,
     /*  77157 */     // GIR_Coverage, 3824,
     /*  77157 */     GIR_EraseRootFromParent_Done,
     /*  77158 */   // Label 1286: @77158
     /*  77158 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(77215), // Rule ID 13776 //
     /*  77163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77198 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77213 */     GIR_RootConstrainSelectedInstOperands,
     /*  77214 */     // GIR_Coverage, 13776,
     /*  77214 */     GIR_EraseRootFromParent_Done,
     /*  77215 */   // Label 1287: @77215
     /*  77215 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(77238), // Rule ID 5051 //
     /*  77220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77231 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  77231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77236 */     GIR_RootConstrainSelectedInstOperands,
     /*  77237 */     // GIR_Coverage, 5051,
     /*  77237 */     GIR_Done,
     /*  77238 */   // Label 1288: @77238
     /*  77238 */   GIM_Reject,
     /*  77239 */ // Label 1278: @77239
     /*  77239 */ GIM_Reject,
     /*  77240 */ // Label 1197: @77240
     /*  77240 */ GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(77931),
     /*  77245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77255 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(77351), // Rule ID 1157 //
     /*  77260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77275 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77279 */     // MIs[1] Operand 1
     /*  77279 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77320 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  77322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77336 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  77349 */     GIR_RootConstrainSelectedInstOperands,
     /*  77350 */     // GIR_Coverage, 1157,
     /*  77350 */     GIR_EraseRootFromParent_Done,
     /*  77351 */   // Label 1290: @77351
     /*  77351 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(77418), // Rule ID 4995 //
     /*  77356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77372 */     // MIs[1] Operand 1
     /*  77372 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77381 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  77389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  77393 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77403 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  77403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77416 */     GIR_RootConstrainSelectedInstOperands,
     /*  77417 */     // GIR_Coverage, 4995,
     /*  77417 */     GIR_EraseRootFromParent_Done,
     /*  77418 */   // Label 1291: @77418
     /*  77418 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77503), // Rule ID 13781 //
     /*  77423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77467 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77486 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77501 */     GIR_RootConstrainSelectedInstOperands,
     /*  77502 */     // GIR_Coverage, 13781,
     /*  77502 */     GIR_EraseRootFromParent_Done,
     /*  77503 */   // Label 1292: @77503
     /*  77503 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77588), // Rule ID 13780 //
     /*  77508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77571 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77586 */     GIR_RootConstrainSelectedInstOperands,
     /*  77587 */     // GIR_Coverage, 13780,
     /*  77587 */     GIR_EraseRootFromParent_Done,
     /*  77588 */   // Label 1293: @77588
     /*  77588 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77673), // Rule ID 13779 //
     /*  77593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77656 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77671 */     GIR_RootConstrainSelectedInstOperands,
     /*  77672 */     // GIR_Coverage, 13779,
     /*  77672 */     GIR_EraseRootFromParent_Done,
     /*  77673 */   // Label 1294: @77673
     /*  77673 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77758), // Rule ID 3827 //
     /*  77678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77731 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77741 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77756 */     GIR_RootConstrainSelectedInstOperands,
     /*  77757 */     // GIR_Coverage, 3827,
     /*  77757 */     GIR_EraseRootFromParent_Done,
     /*  77758 */   // Label 1295: @77758
     /*  77758 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77793), // Rule ID 973 //
     /*  77763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77784 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77791 */     GIR_RootConstrainSelectedInstOperands,
     /*  77792 */     // GIR_Coverage, 973,
     /*  77792 */     GIR_EraseRootFromParent_Done,
     /*  77793 */   // Label 1296: @77793
     /*  77793 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77850), // Rule ID 3823 //
     /*  77798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77833 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77848 */     GIR_RootConstrainSelectedInstOperands,
     /*  77849 */     // GIR_Coverage, 3823,
     /*  77849 */     GIR_EraseRootFromParent_Done,
     /*  77850 */   // Label 1297: @77850
     /*  77850 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77907), // Rule ID 13775 //
     /*  77855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77890 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77905 */     GIR_RootConstrainSelectedInstOperands,
     /*  77906 */     // GIR_Coverage, 13775,
     /*  77906 */     GIR_EraseRootFromParent_Done,
     /*  77907 */   // Label 1298: @77907
     /*  77907 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77930), // Rule ID 1600 //
     /*  77912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77923 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77928 */     GIR_RootConstrainSelectedInstOperands,
     /*  77929 */     // GIR_Coverage, 1600,
     /*  77929 */     GIR_Done,
     /*  77930 */   // Label 1299: @77930
     /*  77930 */   GIM_Reject,
     /*  77931 */ // Label 1289: @77931
     /*  77931 */ GIM_Reject,
     /*  77932 */ // Label 1198: @77932
     /*  77932 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77981), // Rule ID 8464 //
     /*  77937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77950 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77962 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77975 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77977 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77979 */   GIR_RootConstrainSelectedInstOperands,
     /*  77980 */   // GIR_Coverage, 8464,
     /*  77980 */   GIR_EraseRootFromParent_Done,
     /*  77981 */ // Label 1300: @77981
     /*  77981 */ GIM_Reject,
     /*  77982 */ // Label 1199: @77982
     /*  77982 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(78031), // Rule ID 8463 //
     /*  77987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78000 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  78000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  78007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78012 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78027 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78029 */   GIR_RootConstrainSelectedInstOperands,
     /*  78030 */   // GIR_Coverage, 8463,
     /*  78030 */   GIR_EraseRootFromParent_Done,
     /*  78031 */ // Label 1301: @78031
     /*  78031 */ GIM_Reject,
     /*  78032 */ // Label 1200: @78032
     /*  78032 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(78494),
     /*  78037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78047 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(78118), // Rule ID 15642 //
     /*  78052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78091 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78101 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78116 */     GIR_RootConstrainSelectedInstOperands,
     /*  78117 */     // GIR_Coverage, 15642,
     /*  78117 */     GIR_EraseRootFromParent_Done,
     /*  78118 */   // Label 1303: @78118
     /*  78118 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(78189), // Rule ID 15641 //
     /*  78123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78162 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78172 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78187 */     GIR_RootConstrainSelectedInstOperands,
     /*  78188 */     // GIR_Coverage, 15641,
     /*  78188 */     GIR_EraseRootFromParent_Done,
     /*  78189 */   // Label 1304: @78189
     /*  78189 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(78260), // Rule ID 15640 //
     /*  78194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78243 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78258 */     GIR_RootConstrainSelectedInstOperands,
     /*  78259 */     // GIR_Coverage, 15640,
     /*  78259 */     GIR_EraseRootFromParent_Done,
     /*  78260 */   // Label 1305: @78260
     /*  78260 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(78331), // Rule ID 11894 //
     /*  78265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78304 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78310 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78314 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78329 */     GIR_RootConstrainSelectedInstOperands,
     /*  78330 */     // GIR_Coverage, 11894,
     /*  78330 */     GIR_EraseRootFromParent_Done,
     /*  78331 */   // Label 1306: @78331
     /*  78331 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(78392), // Rule ID 11918 //
     /*  78336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  78359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78363 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78373 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78390 */     GIR_RootConstrainSelectedInstOperands,
     /*  78391 */     // GIR_Coverage, 11918,
     /*  78391 */     GIR_EraseRootFromParent_Done,
     /*  78392 */   // Label 1307: @78392
     /*  78392 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(78435), // Rule ID 13742 //
     /*  78397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78418 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78433 */     GIR_RootConstrainSelectedInstOperands,
     /*  78434 */     // GIR_Coverage, 13742,
     /*  78434 */     GIR_EraseRootFromParent_Done,
     /*  78435 */   // Label 1308: @78435
     /*  78435 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78478), // Rule ID 3154 //
     /*  78440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78461 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78476 */     GIR_RootConstrainSelectedInstOperands,
     /*  78477 */     // GIR_Coverage, 3154,
     /*  78477 */     GIR_EraseRootFromParent_Done,
     /*  78478 */   // Label 1309: @78478
     /*  78478 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(78493), // Rule ID 7483 //
     /*  78483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78486 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  78486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78491 */     GIR_RootConstrainSelectedInstOperands,
     /*  78492 */     // GIR_Coverage, 7483,
     /*  78492 */     GIR_Done,
     /*  78493 */   // Label 1310: @78493
     /*  78493 */   GIM_Reject,
     /*  78494 */ // Label 1302: @78494
     /*  78494 */ GIM_Reject,
     /*  78495 */ // Label 1201: @78495
     /*  78495 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(78544), // Rule ID 8462 //
     /*  78500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  78506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  78509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78513 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  78513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  78520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78525 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78538 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78540 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78542 */   GIR_RootConstrainSelectedInstOperands,
     /*  78543 */   // GIR_Coverage, 8462,
     /*  78543 */   GIR_EraseRootFromParent_Done,
     /*  78544 */ // Label 1311: @78544
     /*  78544 */ GIM_Reject,
     /*  78545 */ // Label 1202: @78545
     /*  78545 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(79007),
     /*  78550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78560 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78631), // Rule ID 15639 //
     /*  78565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78604 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78614 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78629 */     GIR_RootConstrainSelectedInstOperands,
     /*  78630 */     // GIR_Coverage, 15639,
     /*  78630 */     GIR_EraseRootFromParent_Done,
     /*  78631 */   // Label 1313: @78631
     /*  78631 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78702), // Rule ID 15638 //
     /*  78636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78675 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78685 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78700 */     GIR_RootConstrainSelectedInstOperands,
     /*  78701 */     // GIR_Coverage, 15638,
     /*  78701 */     GIR_EraseRootFromParent_Done,
     /*  78702 */   // Label 1314: @78702
     /*  78702 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78773), // Rule ID 15637 //
     /*  78707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78746 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78752 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78756 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78771 */     GIR_RootConstrainSelectedInstOperands,
     /*  78772 */     // GIR_Coverage, 15637,
     /*  78772 */     GIR_EraseRootFromParent_Done,
     /*  78773 */   // Label 1315: @78773
     /*  78773 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78844), // Rule ID 11892 //
     /*  78778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78817 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78823 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78827 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78842 */     GIR_RootConstrainSelectedInstOperands,
     /*  78843 */     // GIR_Coverage, 11892,
     /*  78843 */     GIR_EraseRootFromParent_Done,
     /*  78844 */   // Label 1316: @78844
     /*  78844 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78905), // Rule ID 11916 //
     /*  78849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78876 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78886 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78903 */     GIR_RootConstrainSelectedInstOperands,
     /*  78904 */     // GIR_Coverage, 11916,
     /*  78904 */     GIR_EraseRootFromParent_Done,
     /*  78905 */   // Label 1317: @78905
     /*  78905 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78948), // Rule ID 13741 //
     /*  78910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78931 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78946 */     GIR_RootConstrainSelectedInstOperands,
     /*  78947 */     // GIR_Coverage, 13741,
     /*  78947 */     GIR_EraseRootFromParent_Done,
     /*  78948 */   // Label 1318: @78948
     /*  78948 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78991), // Rule ID 3152 //
     /*  78953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78974 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78989 */     GIR_RootConstrainSelectedInstOperands,
     /*  78990 */     // GIR_Coverage, 3152,
     /*  78990 */     GIR_EraseRootFromParent_Done,
     /*  78991 */   // Label 1319: @78991
     /*  78991 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(79006), // Rule ID 7482 //
     /*  78996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78999 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79004 */     GIR_RootConstrainSelectedInstOperands,
     /*  79005 */     // GIR_Coverage, 7482,
     /*  79005 */     GIR_Done,
     /*  79006 */   // Label 1320: @79006
     /*  79006 */   GIM_Reject,
     /*  79007 */ // Label 1312: @79007
     /*  79007 */ GIM_Reject,
     /*  79008 */ // Label 1203: @79008
     /*  79008 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(79057), // Rule ID 8461 //
     /*  79013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79026 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  79033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79038 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79051 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79053 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79055 */   GIR_RootConstrainSelectedInstOperands,
     /*  79056 */   // GIR_Coverage, 8461,
     /*  79056 */   GIR_EraseRootFromParent_Done,
     /*  79057 */ // Label 1321: @79057
     /*  79057 */ GIM_Reject,
     /*  79058 */ // Label 1204: @79058
     /*  79058 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(79520),
     /*  79063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79073 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(79144), // Rule ID 15636 //
     /*  79078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79117 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79127 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79142 */     GIR_RootConstrainSelectedInstOperands,
     /*  79143 */     // GIR_Coverage, 15636,
     /*  79143 */     GIR_EraseRootFromParent_Done,
     /*  79144 */   // Label 1323: @79144
     /*  79144 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(79215), // Rule ID 15635 //
     /*  79149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79188 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79198 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79213 */     GIR_RootConstrainSelectedInstOperands,
     /*  79214 */     // GIR_Coverage, 15635,
     /*  79214 */     GIR_EraseRootFromParent_Done,
     /*  79215 */   // Label 1324: @79215
     /*  79215 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(79286), // Rule ID 15634 //
     /*  79220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79259 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79269 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79284 */     GIR_RootConstrainSelectedInstOperands,
     /*  79285 */     // GIR_Coverage, 15634,
     /*  79285 */     GIR_EraseRootFromParent_Done,
     /*  79286 */   // Label 1325: @79286
     /*  79286 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(79357), // Rule ID 11890 //
     /*  79291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79330 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79340 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79355 */     GIR_RootConstrainSelectedInstOperands,
     /*  79356 */     // GIR_Coverage, 11890,
     /*  79356 */     GIR_EraseRootFromParent_Done,
     /*  79357 */   // Label 1326: @79357
     /*  79357 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(79418), // Rule ID 11914 //
     /*  79362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79381 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  79385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79389 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79399 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79416 */     GIR_RootConstrainSelectedInstOperands,
     /*  79417 */     // GIR_Coverage, 11914,
     /*  79417 */     GIR_EraseRootFromParent_Done,
     /*  79418 */   // Label 1327: @79418
     /*  79418 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(79461), // Rule ID 13740 //
     /*  79423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79444 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79459 */     GIR_RootConstrainSelectedInstOperands,
     /*  79460 */     // GIR_Coverage, 13740,
     /*  79460 */     GIR_EraseRootFromParent_Done,
     /*  79461 */   // Label 1328: @79461
     /*  79461 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79504), // Rule ID 3150 //
     /*  79466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79487 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79502 */     GIR_RootConstrainSelectedInstOperands,
     /*  79503 */     // GIR_Coverage, 3150,
     /*  79503 */     GIR_EraseRootFromParent_Done,
     /*  79504 */   // Label 1329: @79504
     /*  79504 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(79519), // Rule ID 7481 //
     /*  79509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79512 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  79512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79517 */     GIR_RootConstrainSelectedInstOperands,
     /*  79518 */     // GIR_Coverage, 7481,
     /*  79518 */     GIR_Done,
     /*  79519 */   // Label 1330: @79519
     /*  79519 */   GIM_Reject,
     /*  79520 */ // Label 1322: @79520
     /*  79520 */ GIM_Reject,
     /*  79521 */ // Label 1205: @79521
     /*  79521 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79570), // Rule ID 8460 //
     /*  79526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  79532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  79535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79539 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  79539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  79546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79551 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79564 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79566 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79568 */   GIR_RootConstrainSelectedInstOperands,
     /*  79569 */   // GIR_Coverage, 8460,
     /*  79569 */   GIR_EraseRootFromParent_Done,
     /*  79570 */ // Label 1331: @79570
     /*  79570 */ GIM_Reject,
     /*  79571 */ // Label 1206: @79571
     /*  79571 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(80033),
     /*  79576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79586 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79657), // Rule ID 15633 //
     /*  79591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79630 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79640 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79655 */     GIR_RootConstrainSelectedInstOperands,
     /*  79656 */     // GIR_Coverage, 15633,
     /*  79656 */     GIR_EraseRootFromParent_Done,
     /*  79657 */   // Label 1333: @79657
     /*  79657 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79728), // Rule ID 15632 //
     /*  79662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79711 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79726 */     GIR_RootConstrainSelectedInstOperands,
     /*  79727 */     // GIR_Coverage, 15632,
     /*  79727 */     GIR_EraseRootFromParent_Done,
     /*  79728 */   // Label 1334: @79728
     /*  79728 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79799), // Rule ID 15631 //
     /*  79733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79772 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79782 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79797 */     GIR_RootConstrainSelectedInstOperands,
     /*  79798 */     // GIR_Coverage, 15631,
     /*  79798 */     GIR_EraseRootFromParent_Done,
     /*  79799 */   // Label 1335: @79799
     /*  79799 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79870), // Rule ID 11888 //
     /*  79804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79843 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79853 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79868 */     GIR_RootConstrainSelectedInstOperands,
     /*  79869 */     // GIR_Coverage, 11888,
     /*  79869 */     GIR_EraseRootFromParent_Done,
     /*  79870 */   // Label 1336: @79870
     /*  79870 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(79931), // Rule ID 11912 //
     /*  79875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79894 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79912 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79929 */     GIR_RootConstrainSelectedInstOperands,
     /*  79930 */     // GIR_Coverage, 11912,
     /*  79930 */     GIR_EraseRootFromParent_Done,
     /*  79931 */   // Label 1337: @79931
     /*  79931 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(79974), // Rule ID 13739 //
     /*  79936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79957 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79972 */     GIR_RootConstrainSelectedInstOperands,
     /*  79973 */     // GIR_Coverage, 13739,
     /*  79973 */     GIR_EraseRootFromParent_Done,
     /*  79974 */   // Label 1338: @79974
     /*  79974 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(80017), // Rule ID 3148 //
     /*  79979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80000 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  80000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  80003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80015 */     GIR_RootConstrainSelectedInstOperands,
     /*  80016 */     // GIR_Coverage, 3148,
     /*  80016 */     GIR_EraseRootFromParent_Done,
     /*  80017 */   // Label 1339: @80017
     /*  80017 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(80032), // Rule ID 7480 //
     /*  80022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80025 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  80025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  80030 */     GIR_RootConstrainSelectedInstOperands,
     /*  80031 */     // GIR_Coverage, 7480,
     /*  80031 */     GIR_Done,
     /*  80032 */   // Label 1340: @80032
     /*  80032 */   GIM_Reject,
     /*  80033 */ // Label 1332: @80033
     /*  80033 */ GIM_Reject,
     /*  80034 */ // Label 1207: @80034
     /*  80034 */ GIM_Reject,
     /*  80035 */ // Label 8: @80035
     /*  80035 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(87558),
     /*  80040 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  80043 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1353*/ GIMT_Encode4(87557),
     /*  80054 */   /*GILLT_v2s64*//*Label 1342*/ GIMT_Encode4(80122), GIMT_Encode4(0),
     /*  80062 */   /*GILLT_v4s32*//*Label 1343*/ GIMT_Encode4(80643), GIMT_Encode4(0),
     /*  80070 */   /*GILLT_v8s16*//*Label 1344*/ GIMT_Encode4(83055),
     /*  80074 */   /*GILLT_v16s8*//*Label 1345*/ GIMT_Encode4(85464), GIMT_Encode4(0),
     /*  80082 */   /*GILLT_nxv2s1*//*Label 1346*/ GIMT_Encode4(87375), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  80098 */   /*GILLT_nxv4s1*//*Label 1347*/ GIMT_Encode4(87401),
     /*  80102 */   /*GILLT_nxv4s16*//*Label 1348*/ GIMT_Encode4(87427),
     /*  80106 */   /*GILLT_nxv4s32*//*Label 1349*/ GIMT_Encode4(87453),
     /*  80110 */   /*GILLT_nxv8s1*//*Label 1350*/ GIMT_Encode4(87479),
     /*  80114 */   /*GILLT_nxv8s16*//*Label 1351*/ GIMT_Encode4(87505),
     /*  80118 */   /*GILLT_nxv16s1*//*Label 1352*/ GIMT_Encode4(87531),
     /*  80122 */   // Label 1342: @80122
     /*  80122 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(80642),
     /*  80127 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  80130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  80133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80141 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(80203), // Rule ID 5794 //
     /*  80146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80150 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80156 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80158 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80160 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  80160 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80163 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80167 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80172 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80176 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80183 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80186 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80189 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80192 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80197 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80202 */       // GIR_Coverage, 5794,
     /*  80202 */       GIR_EraseRootFromParent_Done,
     /*  80203 */     // Label 1355: @80203
     /*  80203 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(80265), // Rule ID 5798 //
     /*  80208 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80212 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80218 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80220 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80222 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  80222 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80225 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80229 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80234 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80240 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80243 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80245 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80248 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80251 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80254 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80259 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80264 */       // GIR_Coverage, 5798,
     /*  80264 */       GIR_EraseRootFromParent_Done,
     /*  80265 */     // Label 1356: @80265
     /*  80265 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(80323), // Rule ID 5795 //
     /*  80270 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80274 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80278 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80280 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  80280 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80283 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80287 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80292 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80294 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80297 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80299 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80302 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80304 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80307 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80312 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80317 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80322 */       // GIR_Coverage, 5795,
     /*  80322 */       GIR_EraseRootFromParent_Done,
     /*  80323 */     // Label 1357: @80323
     /*  80323 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(80381), // Rule ID 5799 //
     /*  80328 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80332 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80336 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80338 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  80338 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80341 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80345 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80357 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80360 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80362 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80365 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80370 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80375 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80380 */       // GIR_Coverage, 5799,
     /*  80380 */       GIR_EraseRootFromParent_Done,
     /*  80381 */     // Label 1358: @80381
     /*  80381 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80511), // Rule ID 5793 //
     /*  80386 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80390 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80390 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80393 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80397 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80404 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80407 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80411 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80416 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80419 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80423 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80426 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80431 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80436 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80441 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80444 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80448 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80453 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80455 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80458 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80462 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80467 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80474 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80497 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80500 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80503 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80506 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80509 */       GIR_RootConstrainSelectedInstOperands,
     /*  80510 */       // GIR_Coverage, 5793,
     /*  80510 */       GIR_EraseRootFromParent_Done,
     /*  80511 */     // Label 1359: @80511
     /*  80511 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80641), // Rule ID 5797 //
     /*  80516 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80520 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80520 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80523 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80527 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80532 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80534 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80537 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80541 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80546 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80549 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80553 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80556 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80561 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80566 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80571 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80574 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80578 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80583 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80585 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80588 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80592 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80597 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80600 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80604 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80607 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80612 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80617 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80627 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80630 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80633 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80636 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80639 */       GIR_RootConstrainSelectedInstOperands,
     /*  80640 */       // GIR_Coverage, 5797,
     /*  80640 */       GIR_EraseRootFromParent_Done,
     /*  80641 */     // Label 1360: @80641
     /*  80641 */     GIM_Reject,
     /*  80642 */   // Label 1354: @80642
     /*  80642 */   GIM_Reject,
     /*  80643 */   // Label 1343: @80643
     /*  80643 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(83054),
     /*  80648 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  80651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  80654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80658 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80787), // Rule ID 5431 //
     /*  80663 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80675 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80679 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80683 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80687 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80691 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80695 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80699 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80703 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80707 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80712 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80716 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80722 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80724 */       // MIs[2] Operand 2
     /*  80724 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80735 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80737 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80737 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80740 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80744 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80749 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80752 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80756 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80781 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80785 */       GIR_RootConstrainSelectedInstOperands,
     /*  80786 */       // GIR_Coverage, 5431,
     /*  80786 */       GIR_EraseRootFromParent_Done,
     /*  80787 */     // Label 1362: @80787
     /*  80787 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80909), // Rule ID 5427 //
     /*  80792 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80796 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80800 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80804 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80808 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80812 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80816 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80820 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80824 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80828 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80832 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80836 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80841 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80846 */       // MIs[2] Operand 2
     /*  80846 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80857 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80859 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80859 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80862 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80866 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80874 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80878 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80881 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80886 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80891 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80894 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80896 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80899 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80903 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80907 */       GIR_RootConstrainSelectedInstOperands,
     /*  80908 */       // GIR_Coverage, 5427,
     /*  80908 */       GIR_EraseRootFromParent_Done,
     /*  80909 */     // Label 1363: @80909
     /*  80909 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(81031), // Rule ID 5429 //
     /*  80914 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80918 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80922 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80926 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80930 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80934 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80938 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80942 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80946 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80950 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80954 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80958 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80963 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80968 */       // MIs[2] Operand 2
     /*  80968 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80979 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80981 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80981 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80984 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80988 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80993 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80996 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81000 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81003 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81008 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81013 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81016 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81018 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81021 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81025 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81029 */       GIR_RootConstrainSelectedInstOperands,
     /*  81030 */       // GIR_Coverage, 5429,
     /*  81030 */       GIR_EraseRootFromParent_Done,
     /*  81031 */     // Label 1364: @81031
     /*  81031 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(81133), // Rule ID 5577 //
     /*  81036 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81040 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81044 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81048 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81052 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81056 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81060 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81065 */       // MIs[2] Operand 2
     /*  81065 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  81076 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81080 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81084 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81088 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81092 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81096 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81100 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81105 */       // MIs[4] Operand 2
     /*  81105 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  81116 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81118 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81118 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  81121 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81123 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81127 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81131 */       GIR_RootConstrainSelectedInstOperands,
     /*  81132 */       // GIR_Coverage, 5577,
     /*  81132 */       GIR_EraseRootFromParent_Done,
     /*  81133 */     // Label 1365: @81133
     /*  81133 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(81262), // Rule ID 6349 //
     /*  81138 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81142 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81146 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81150 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81153 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81158 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81162 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81166 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81171 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  81175 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81177 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  81177 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  81180 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81184 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81189 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81192 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81194 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81197 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81201 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81206 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81208 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81211 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81215 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81220 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81223 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81227 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81230 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81235 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81240 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81245 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81248 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81250 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81253 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81257 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81260 */       GIR_RootConstrainSelectedInstOperands,
     /*  81261 */       // GIR_Coverage, 6349,
     /*  81261 */       GIR_EraseRootFromParent_Done,
     /*  81262 */     // Label 1366: @81262
     /*  81262 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(81304), // Rule ID 5804 //
     /*  81267 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81274 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81281 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  81281 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81284 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81286 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81291 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81294 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81299 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81302 */       GIR_RootConstrainSelectedInstOperands,
     /*  81303 */       // GIR_Coverage, 5804,
     /*  81303 */       GIR_EraseRootFromParent_Done,
     /*  81304 */     // Label 1367: @81304
     /*  81304 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(81346), // Rule ID 5808 //
     /*  81309 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81316 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81323 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  81323 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81326 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81328 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81336 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81341 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81344 */       GIR_RootConstrainSelectedInstOperands,
     /*  81345 */       // GIR_Coverage, 5808,
     /*  81345 */       GIR_EraseRootFromParent_Done,
     /*  81346 */     // Label 1368: @81346
     /*  81346 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81469), // Rule ID 2578 //
     /*  81351 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81354 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81358 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81362 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81366 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81369 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81374 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81378 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81382 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81387 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81391 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81395 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81399 */       // MIs[2] Operand 1
     /*  81399 */       // No operand predicates
     /*  81399 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81401 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81401 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81404 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81408 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81413 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81427 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81434 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  81455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81464 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81467 */       GIR_RootConstrainSelectedInstOperands,
     /*  81468 */       // GIR_Coverage, 2578,
     /*  81468 */       GIR_EraseRootFromParent_Done,
     /*  81469 */     // Label 1369: @81469
     /*  81469 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81592), // Rule ID 6319 //
     /*  81474 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81477 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81481 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81485 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81489 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81493 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81497 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81501 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81505 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81510 */       // MIs[2] imm
     /*  81510 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81514 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81518 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81522 */       // MIs[3] Operand 1
     /*  81522 */       // No operand predicates
     /*  81522 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81524 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81524 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81527 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81531 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81536 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81538 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81541 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81545 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81550 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81557 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81560 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81565 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81570 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81575 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81578 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81580 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81583 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81587 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81590 */       GIR_RootConstrainSelectedInstOperands,
     /*  81591 */       // GIR_Coverage, 6319,
     /*  81591 */       GIR_EraseRootFromParent_Done,
     /*  81592 */     // Label 1370: @81592
     /*  81592 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81712), // Rule ID 6355 //
     /*  81597 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81601 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81605 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81609 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81613 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81617 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81621 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81625 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81630 */       // MIs[2] imm
     /*  81630 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81634 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81638 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81642 */       // MIs[3] Operand 1
     /*  81642 */       // No operand predicates
     /*  81642 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81644 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  81644 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81647 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81651 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81656 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81658 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81661 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81665 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81670 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81673 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81677 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81690 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81703 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81707 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81710 */       GIR_RootConstrainSelectedInstOperands,
     /*  81711 */       // GIR_Coverage, 6355,
     /*  81711 */       GIR_EraseRootFromParent_Done,
     /*  81712 */     // Label 1371: @81712
     /*  81712 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81829), // Rule ID 2501 //
     /*  81717 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81720 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81724 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81728 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81732 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81735 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81740 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81744 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81748 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81753 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81758 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81760 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81760 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81763 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81767 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81772 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81774 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81777 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81781 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81786 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81789 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81793 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81796 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81801 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81806 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81811 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81814 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81816 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81819 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81823 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81827 */       GIR_RootConstrainSelectedInstOperands,
     /*  81828 */       // GIR_Coverage, 2501,
     /*  81828 */       GIR_EraseRootFromParent_Done,
     /*  81829 */     // Label 1372: @81829
     /*  81829 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81946), // Rule ID 5347 //
     /*  81834 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81837 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81841 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81845 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81849 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81852 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81857 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81861 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81865 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81870 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81875 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81877 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81877 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81880 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81884 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81889 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81891 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81894 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81898 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81903 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81906 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81910 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81923 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81928 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81931 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81933 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81936 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81944 */       GIR_RootConstrainSelectedInstOperands,
     /*  81945 */       // GIR_Coverage, 5347,
     /*  81945 */       GIR_EraseRootFromParent_Done,
     /*  81946 */     // Label 1373: @81946
     /*  81946 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(82063), // Rule ID 5350 //
     /*  81951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81954 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81958 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81962 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81966 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81969 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81974 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81978 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81987 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81992 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81994 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81994 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81997 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82001 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82006 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82008 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82011 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82015 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82020 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82023 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82027 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82040 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82045 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  82048 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82050 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82053 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82057 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82061 */       GIR_RootConstrainSelectedInstOperands,
     /*  82062 */       // GIR_Coverage, 5350,
     /*  82062 */       GIR_EraseRootFromParent_Done,
     /*  82063 */     // Label 1374: @82063
     /*  82063 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(82180), // Rule ID 5353 //
     /*  82068 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82075 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82079 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82083 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82086 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82091 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82095 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82104 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82109 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82111 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  82111 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82114 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82118 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82123 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82125 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82128 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82132 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82137 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82140 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82144 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82157 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82162 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  82165 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82167 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82170 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82174 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82178 */       GIR_RootConstrainSelectedInstOperands,
     /*  82179 */       // GIR_Coverage, 5353,
     /*  82179 */       GIR_EraseRootFromParent_Done,
     /*  82180 */     // Label 1375: @82180
     /*  82180 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(82284), // Rule ID 2497 //
     /*  82185 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82188 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82192 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82196 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82200 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  82203 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  82208 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82212 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82217 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82219 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82219 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82222 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82226 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82231 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82233 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82236 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82240 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82245 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82248 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82252 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82255 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82270 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  82273 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82275 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82278 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82282 */       GIR_RootConstrainSelectedInstOperands,
     /*  82283 */       // GIR_Coverage, 2497,
     /*  82283 */       GIR_EraseRootFromParent_Done,
     /*  82284 */     // Label 1376: @82284
     /*  82284 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(82340), // Rule ID 5510 //
     /*  82289 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82293 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82297 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82301 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82306 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82310 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82314 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82318 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82323 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82325 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  82325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  82328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82330 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82334 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82338 */       GIR_RootConstrainSelectedInstOperands,
     /*  82339 */       // GIR_Coverage, 5510,
     /*  82339 */       GIR_EraseRootFromParent_Done,
     /*  82340 */     // Label 1377: @82340
     /*  82340 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(82406), // Rule ID 5802 //
     /*  82345 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82349 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82353 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82359 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82361 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82363 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  82363 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82366 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82370 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82375 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82379 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82381 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82384 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82386 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82389 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82392 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82395 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82400 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82405 */       // GIR_Coverage, 5802,
     /*  82405 */       GIR_EraseRootFromParent_Done,
     /*  82406 */     // Label 1378: @82406
     /*  82406 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(82472), // Rule ID 5806 //
     /*  82411 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82415 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82419 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82425 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82427 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82429 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  82429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82441 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82445 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82447 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82450 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82452 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82455 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82458 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82466 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82471 */       // GIR_Coverage, 5806,
     /*  82471 */       GIR_EraseRootFromParent_Done,
     /*  82472 */     // Label 1379: @82472
     /*  82472 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82565), // Rule ID 4914 //
     /*  82477 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82481 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82485 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  82489 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82493 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82498 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82500 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82500 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82503 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82507 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82512 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82514 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82517 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82521 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82526 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82529 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82533 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82536 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82541 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82551 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  82554 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82556 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82559 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82563 */       GIR_RootConstrainSelectedInstOperands,
     /*  82564 */       // GIR_Coverage, 4914,
     /*  82564 */       GIR_EraseRootFromParent_Done,
     /*  82565 */     // Label 1380: @82565
     /*  82565 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82661), // Rule ID 4961 //
     /*  82570 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82573 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82577 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82581 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82585 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82589 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82594 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82596 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  82596 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82599 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82603 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82608 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82610 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82613 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82617 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82622 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82625 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82629 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82642 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82647 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  82650 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82652 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82655 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82659 */       GIR_RootConstrainSelectedInstOperands,
     /*  82660 */       // GIR_Coverage, 4961,
     /*  82660 */       GIR_EraseRootFromParent_Done,
     /*  82661 */     // Label 1381: @82661
     /*  82661 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82723), // Rule ID 5803 //
     /*  82666 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82670 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82674 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82678 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82680 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  82680 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82683 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82687 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82692 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82694 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82697 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82699 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82702 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82704 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82707 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82712 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82717 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82722 */       // GIR_Coverage, 5803,
     /*  82722 */       GIR_EraseRootFromParent_Done,
     /*  82723 */     // Label 1382: @82723
     /*  82723 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82785), // Rule ID 5807 //
     /*  82728 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82732 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82736 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82740 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82742 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82742 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82745 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82749 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82754 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82756 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82759 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82761 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82764 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82766 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82769 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82774 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82779 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82784 */       // GIR_Coverage, 5807,
     /*  82784 */       GIR_EraseRootFromParent_Done,
     /*  82785 */     // Label 1383: @82785
     /*  82785 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82919), // Rule ID 5801 //
     /*  82790 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82794 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82798 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82798 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82801 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82805 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82810 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82812 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82815 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82819 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82824 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82827 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82831 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82834 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82839 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82844 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82849 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82852 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82856 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82861 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82875 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82878 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82882 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82890 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82895 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82900 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82903 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82905 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82908 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82911 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82914 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82917 */       GIR_RootConstrainSelectedInstOperands,
     /*  82918 */       // GIR_Coverage, 5801,
     /*  82918 */       GIR_EraseRootFromParent_Done,
     /*  82919 */     // Label 1384: @82919
     /*  82919 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(83053), // Rule ID 5805 //
     /*  82924 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82928 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82932 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82932 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82935 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82939 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82944 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82946 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82949 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82953 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82958 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82961 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82965 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82968 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82973 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82978 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82983 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82986 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82990 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82997 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83000 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83004 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83009 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83012 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83016 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83019 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83024 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83029 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83034 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83037 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83039 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83042 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83048 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83051 */       GIR_RootConstrainSelectedInstOperands,
     /*  83052 */       // GIR_Coverage, 5805,
     /*  83052 */       GIR_EraseRootFromParent_Done,
     /*  83053 */     // Label 1385: @83053
     /*  83053 */     GIM_Reject,
     /*  83054 */   // Label 1361: @83054
     /*  83054 */   GIM_Reject,
     /*  83055 */   // Label 1344: @83055
     /*  83055 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(85463),
     /*  83060 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  83063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  83066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83070 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(83199), // Rule ID 5425 //
     /*  83075 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83079 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83083 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83087 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83091 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83095 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83099 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83103 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83107 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83111 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83115 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83119 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83124 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83128 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83134 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83136 */       // MIs[2] Operand 2
     /*  83136 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83147 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83149 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  83149 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83152 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83156 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83161 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83164 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83168 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83171 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83176 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83181 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83184 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83186 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83189 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83193 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83197 */       GIR_RootConstrainSelectedInstOperands,
     /*  83198 */       // GIR_Coverage, 5425,
     /*  83198 */       GIR_EraseRootFromParent_Done,
     /*  83199 */     // Label 1387: @83199
     /*  83199 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(83321), // Rule ID 5421 //
     /*  83204 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83208 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83212 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83216 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83220 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83224 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83228 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83232 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83236 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  83240 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83244 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83248 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83253 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83258 */       // MIs[2] Operand 2
     /*  83258 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83269 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83271 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83271 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83274 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83278 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83283 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83286 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83290 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83293 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83298 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83303 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83306 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83308 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83311 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83315 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83319 */       GIR_RootConstrainSelectedInstOperands,
     /*  83320 */       // GIR_Coverage, 5421,
     /*  83320 */       GIR_EraseRootFromParent_Done,
     /*  83321 */     // Label 1388: @83321
     /*  83321 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(83443), // Rule ID 5423 //
     /*  83326 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83330 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83334 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83338 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83342 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83346 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83350 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83354 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83358 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  83362 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83366 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83370 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83375 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83380 */       // MIs[2] Operand 2
     /*  83380 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83391 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83393 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83393 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83396 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83400 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83405 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83408 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83412 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83415 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83420 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83425 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83428 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83430 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83433 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83437 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83441 */       GIR_RootConstrainSelectedInstOperands,
     /*  83442 */       // GIR_Coverage, 5423,
     /*  83442 */       GIR_EraseRootFromParent_Done,
     /*  83443 */     // Label 1389: @83443
     /*  83443 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83545), // Rule ID 5576 //
     /*  83448 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83452 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83456 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83460 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83464 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83468 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83472 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83477 */       // MIs[2] Operand 2
     /*  83477 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83488 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  83492 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83496 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83500 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  83504 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83508 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83512 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83517 */       // MIs[4] Operand 2
     /*  83517 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  83528 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83530 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83530 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  83533 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83535 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  83539 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  83543 */       GIR_RootConstrainSelectedInstOperands,
     /*  83544 */       // GIR_Coverage, 5576,
     /*  83544 */       GIR_EraseRootFromParent_Done,
     /*  83545 */     // Label 1390: @83545
     /*  83545 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83674), // Rule ID 6348 //
     /*  83550 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83554 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83558 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83562 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83565 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83570 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83574 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83578 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83583 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  83587 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83589 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  83589 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  83592 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  83596 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83601 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  83604 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  83606 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83609 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83613 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83618 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83620 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83623 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83627 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83632 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83635 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  83639 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83642 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83647 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83652 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83657 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83660 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83662 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83665 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  83669 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83672 */       GIR_RootConstrainSelectedInstOperands,
     /*  83673 */       // GIR_Coverage, 6348,
     /*  83673 */       GIR_EraseRootFromParent_Done,
     /*  83674 */     // Label 1391: @83674
     /*  83674 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83716), // Rule ID 5812 //
     /*  83679 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83686 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83693 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  83693 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83696 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83698 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83703 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83706 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83711 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83714 */       GIR_RootConstrainSelectedInstOperands,
     /*  83715 */       // GIR_Coverage, 5812,
     /*  83715 */       GIR_EraseRootFromParent_Done,
     /*  83716 */     // Label 1392: @83716
     /*  83716 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83758), // Rule ID 5816 //
     /*  83721 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83728 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83735 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83735 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83738 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83740 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83745 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83748 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83753 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83756 */       GIR_RootConstrainSelectedInstOperands,
     /*  83757 */       // GIR_Coverage, 5816,
     /*  83757 */       GIR_EraseRootFromParent_Done,
     /*  83758 */     // Label 1393: @83758
     /*  83758 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83881), // Rule ID 2576 //
     /*  83763 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83766 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83770 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83774 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83778 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83781 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83786 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83790 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83794 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83799 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83803 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83807 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83811 */       // MIs[2] Operand 1
     /*  83811 */       // No operand predicates
     /*  83811 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83813 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83813 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83816 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83820 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83825 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83827 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83830 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83834 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83839 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83842 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83846 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83849 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83854 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83859 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83864 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83867 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83869 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83872 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83876 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83879 */       GIR_RootConstrainSelectedInstOperands,
     /*  83880 */       // GIR_Coverage, 2576,
     /*  83880 */       GIR_EraseRootFromParent_Done,
     /*  83881 */     // Label 1394: @83881
     /*  83881 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(84004), // Rule ID 6318 //
     /*  83886 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83889 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83893 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83897 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83901 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83905 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83909 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83913 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83917 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83922 */       // MIs[2] imm
     /*  83922 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83926 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83930 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83934 */       // MIs[3] Operand 1
     /*  83934 */       // No operand predicates
     /*  83934 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83936 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83936 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83939 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83943 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83948 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83962 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83969 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83972 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83995 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83999 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  84002 */       GIR_RootConstrainSelectedInstOperands,
     /*  84003 */       // GIR_Coverage, 6318,
     /*  84003 */       GIR_EraseRootFromParent_Done,
     /*  84004 */     // Label 1395: @84004
     /*  84004 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(84124), // Rule ID 6354 //
     /*  84009 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84013 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84017 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84021 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84025 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84029 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84033 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84037 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84042 */       // MIs[2] imm
     /*  84042 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84046 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84050 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  84054 */       // MIs[3] Operand 1
     /*  84054 */       // No operand predicates
     /*  84054 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84056 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  84056 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84059 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84063 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84068 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84070 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84073 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84077 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84082 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84085 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84089 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84092 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84097 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84107 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  84110 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84112 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84115 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  84119 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  84122 */       GIR_RootConstrainSelectedInstOperands,
     /*  84123 */       // GIR_Coverage, 6354,
     /*  84123 */       GIR_EraseRootFromParent_Done,
     /*  84124 */     // Label 1396: @84124
     /*  84124 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(84241), // Rule ID 2500 //
     /*  84129 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84140 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84144 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84147 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  84152 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84156 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84160 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84165 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84170 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84172 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84172 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84175 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84179 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84184 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84186 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84189 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84193 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84198 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84201 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84205 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84208 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84213 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84218 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84223 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  84226 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84228 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84231 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84235 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84239 */       GIR_RootConstrainSelectedInstOperands,
     /*  84240 */       // GIR_Coverage, 2500,
     /*  84240 */       GIR_EraseRootFromParent_Done,
     /*  84241 */     // Label 1397: @84241
     /*  84241 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(84358), // Rule ID 5346 //
     /*  84246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84253 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84257 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84261 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84264 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  84269 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84273 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84282 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84287 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84289 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84289 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84292 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84296 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84301 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84303 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84306 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84310 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84315 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84318 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84322 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84330 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84335 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84340 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  84343 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84345 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84348 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84352 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84356 */       GIR_RootConstrainSelectedInstOperands,
     /*  84357 */       // GIR_Coverage, 5346,
     /*  84357 */       GIR_EraseRootFromParent_Done,
     /*  84358 */     // Label 1398: @84358
     /*  84358 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84475), // Rule ID 5349 //
     /*  84363 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84366 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84370 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84374 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84378 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84381 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  84386 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84390 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84394 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84399 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84404 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84406 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84406 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84409 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84413 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84418 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84420 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84423 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84427 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84432 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84435 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84439 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84452 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84457 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  84460 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84462 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84465 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84469 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84473 */       GIR_RootConstrainSelectedInstOperands,
     /*  84474 */       // GIR_Coverage, 5349,
     /*  84474 */       GIR_EraseRootFromParent_Done,
     /*  84475 */     // Label 1399: @84475
     /*  84475 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84592), // Rule ID 5352 //
     /*  84480 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84483 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84487 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84491 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84495 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84498 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  84503 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84507 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84516 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84521 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84523 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84523 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84526 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84530 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84535 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84537 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84540 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84544 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84549 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84552 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84556 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84574 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  84577 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84579 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84582 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84590 */       GIR_RootConstrainSelectedInstOperands,
     /*  84591 */       // GIR_Coverage, 5352,
     /*  84591 */       GIR_EraseRootFromParent_Done,
     /*  84592 */     // Label 1400: @84592
     /*  84592 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84693), // Rule ID 4908 //
     /*  84597 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84601 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84605 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84609 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  84612 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  84617 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84621 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84626 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84628 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84628 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84631 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84635 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84640 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84642 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84645 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84649 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84654 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84657 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84661 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84664 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84674 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84679 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84682 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84684 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84687 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84691 */       GIR_RootConstrainSelectedInstOperands,
     /*  84692 */       // GIR_Coverage, 4908,
     /*  84692 */       GIR_EraseRootFromParent_Done,
     /*  84693 */     // Label 1401: @84693
     /*  84693 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84749), // Rule ID 5501 //
     /*  84698 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84702 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84706 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84710 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84715 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84719 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84723 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84727 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84732 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84734 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84739 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84743 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84747 */       GIR_RootConstrainSelectedInstOperands,
     /*  84748 */       // GIR_Coverage, 5501,
     /*  84748 */       GIR_EraseRootFromParent_Done,
     /*  84749 */     // Label 1402: @84749
     /*  84749 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84815), // Rule ID 5810 //
     /*  84754 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84758 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84762 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84768 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84770 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84772 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84772 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84775 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84779 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84784 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84788 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84790 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84793 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84795 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84798 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84801 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84804 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84809 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84814 */       // GIR_Coverage, 5810,
     /*  84814 */       GIR_EraseRootFromParent_Done,
     /*  84815 */     // Label 1403: @84815
     /*  84815 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84881), // Rule ID 5814 //
     /*  84820 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84824 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84828 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84834 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84836 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84838 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84838 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84841 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84845 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84850 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84854 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84856 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84859 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84861 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84864 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84867 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84870 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84875 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84880 */       // GIR_Coverage, 5814,
     /*  84880 */       GIR_EraseRootFromParent_Done,
     /*  84881 */     // Label 1404: @84881
     /*  84881 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84974), // Rule ID 4916 //
     /*  84886 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84890 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84894 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84898 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84902 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84907 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84909 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84909 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84912 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84916 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84921 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84923 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84926 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84930 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84935 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84938 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84942 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84945 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84950 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84955 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84965 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84968 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84972 */       GIR_RootConstrainSelectedInstOperands,
     /*  84973 */       // GIR_Coverage, 4916,
     /*  84973 */       GIR_EraseRootFromParent_Done,
     /*  84974 */     // Label 1405: @84974
     /*  84974 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(85070), // Rule ID 4960 //
     /*  84979 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84982 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84986 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84990 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84994 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84998 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85003 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85005 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  85005 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85008 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85012 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85017 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85019 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85022 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85026 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85031 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85034 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85038 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85041 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85046 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85056 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  85059 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85061 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85064 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  85068 */       GIR_RootConstrainSelectedInstOperands,
     /*  85069 */       // GIR_Coverage, 4960,
     /*  85069 */       GIR_EraseRootFromParent_Done,
     /*  85070 */     // Label 1406: @85070
     /*  85070 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(85132), // Rule ID 5811 //
     /*  85075 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85079 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85083 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85087 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85089 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  85089 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85092 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85096 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85101 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85103 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85106 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85108 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85111 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85113 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85116 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85121 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85126 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85131 */       // GIR_Coverage, 5811,
     /*  85131 */       GIR_EraseRootFromParent_Done,
     /*  85132 */     // Label 1407: @85132
     /*  85132 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(85194), // Rule ID 5815 //
     /*  85137 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85141 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85145 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85149 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85151 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  85151 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85154 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85158 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85163 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85165 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85168 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85170 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85173 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85175 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85178 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85183 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85188 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85193 */       // GIR_Coverage, 5815,
     /*  85193 */       GIR_EraseRootFromParent_Done,
     /*  85194 */     // Label 1408: @85194
     /*  85194 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(85328), // Rule ID 5809 //
     /*  85199 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85203 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85207 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85207 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85210 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85214 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85219 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85221 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85224 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85228 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85233 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85236 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85240 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85243 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85248 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85253 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85258 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85261 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85265 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85270 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85284 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85304 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85309 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85312 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85314 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85317 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85320 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85323 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85326 */       GIR_RootConstrainSelectedInstOperands,
     /*  85327 */       // GIR_Coverage, 5809,
     /*  85327 */       GIR_EraseRootFromParent_Done,
     /*  85328 */     // Label 1409: @85328
     /*  85328 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85462), // Rule ID 5813 //
     /*  85333 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85337 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85341 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85341 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85344 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85348 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85353 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85355 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85358 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85362 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85367 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85370 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85374 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85377 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85382 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85387 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85392 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85395 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85399 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85406 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85409 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85413 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85418 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85421 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85425 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85428 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85433 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85438 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85443 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85446 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85448 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85451 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85454 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85457 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85460 */       GIR_RootConstrainSelectedInstOperands,
     /*  85461 */       // GIR_Coverage, 5813,
     /*  85461 */       GIR_EraseRootFromParent_Done,
     /*  85462 */     // Label 1410: @85462
     /*  85462 */     GIM_Reject,
     /*  85463 */   // Label 1386: @85463
     /*  85463 */   GIM_Reject,
     /*  85464 */   // Label 1345: @85464
     /*  85464 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87374),
     /*  85469 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  85475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85479 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85608), // Rule ID 5419 //
     /*  85484 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85488 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85492 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85496 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85500 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85504 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85508 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85512 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85516 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85520 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85524 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85528 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85533 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85537 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85543 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85545 */       // MIs[2] Operand 2
     /*  85545 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85556 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85558 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  85558 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85561 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85565 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85570 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85573 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85577 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85580 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85585 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85590 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85593 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85595 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85598 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85606 */       GIR_RootConstrainSelectedInstOperands,
     /*  85607 */       // GIR_Coverage, 5419,
     /*  85607 */       GIR_EraseRootFromParent_Done,
     /*  85608 */     // Label 1412: @85608
     /*  85608 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85730), // Rule ID 5415 //
     /*  85613 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85617 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85621 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85625 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85629 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85633 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85637 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85641 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85645 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  85649 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85653 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85657 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85662 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85667 */       // MIs[2] Operand 2
     /*  85667 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85678 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85680 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85680 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85683 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85687 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85692 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85695 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85699 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85702 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85707 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85712 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85715 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85717 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85720 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85728 */       GIR_RootConstrainSelectedInstOperands,
     /*  85729 */       // GIR_Coverage, 5415,
     /*  85729 */       GIR_EraseRootFromParent_Done,
     /*  85730 */     // Label 1413: @85730
     /*  85730 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85852), // Rule ID 5417 //
     /*  85735 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85739 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85743 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85747 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85751 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85755 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85759 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85763 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85767 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85771 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85775 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85779 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85784 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85789 */       // MIs[2] Operand 2
     /*  85789 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85800 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85802 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85802 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85805 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85809 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85814 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85817 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85821 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85824 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85829 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85834 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85837 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85839 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85842 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85846 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85850 */       GIR_RootConstrainSelectedInstOperands,
     /*  85851 */       // GIR_Coverage, 5417,
     /*  85851 */       GIR_EraseRootFromParent_Done,
     /*  85852 */     // Label 1414: @85852
     /*  85852 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85954), // Rule ID 5575 //
     /*  85857 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85861 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85865 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85869 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85873 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85877 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85881 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85886 */       // MIs[2] Operand 2
     /*  85886 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85897 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85901 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85905 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85909 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85913 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85917 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85921 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85926 */       // MIs[4] Operand 2
     /*  85926 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85937 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85939 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85948 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85952 */       GIR_RootConstrainSelectedInstOperands,
     /*  85953 */       // GIR_Coverage, 5575,
     /*  85953 */       GIR_EraseRootFromParent_Done,
     /*  85954 */     // Label 1415: @85954
     /*  85954 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(86083), // Rule ID 6347 //
     /*  85959 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85963 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85967 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85971 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85974 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85979 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85983 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85987 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85992 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85996 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85998 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85998 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  86001 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  86005 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86010 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  86013 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  86015 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86018 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86022 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86027 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86041 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86044 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  86048 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86061 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86071 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  86078 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86081 */       GIR_RootConstrainSelectedInstOperands,
     /*  86082 */       // GIR_Coverage, 6347,
     /*  86082 */       GIR_EraseRootFromParent_Done,
     /*  86083 */     // Label 1416: @86083
     /*  86083 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(86125), // Rule ID 5820 //
     /*  86088 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86095 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86102 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  86102 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86105 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86107 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  86112 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86115 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86120 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86123 */       GIR_RootConstrainSelectedInstOperands,
     /*  86124 */       // GIR_Coverage, 5820,
     /*  86124 */       GIR_EraseRootFromParent_Done,
     /*  86125 */     // Label 1417: @86125
     /*  86125 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(86248), // Rule ID 2574 //
     /*  86130 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86133 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86137 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86141 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86145 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86148 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  86153 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86157 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  86161 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86166 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  86170 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86174 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86178 */       // MIs[2] Operand 1
     /*  86178 */       // No operand predicates
     /*  86178 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86180 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86180 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86183 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86187 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86192 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86194 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86197 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86201 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86206 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86209 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86213 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86216 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86221 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86226 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86231 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  86234 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86236 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86239 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86243 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  86246 */       GIR_RootConstrainSelectedInstOperands,
     /*  86247 */       // GIR_Coverage, 2574,
     /*  86247 */       GIR_EraseRootFromParent_Done,
     /*  86248 */     // Label 1418: @86248
     /*  86248 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(86371), // Rule ID 6317 //
     /*  86253 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86256 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86260 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86264 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86268 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86272 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86276 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  86280 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86284 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86289 */       // MIs[2] imm
     /*  86289 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86293 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86297 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86301 */       // MIs[3] Operand 1
     /*  86301 */       // No operand predicates
     /*  86301 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86303 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86303 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86306 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86310 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86315 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86317 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86320 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86324 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86329 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86332 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86336 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86339 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86344 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86349 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86359 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86362 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86366 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86369 */       GIR_RootConstrainSelectedInstOperands,
     /*  86370 */       // GIR_Coverage, 6317,
     /*  86370 */       GIR_EraseRootFromParent_Done,
     /*  86371 */     // Label 1419: @86371
     /*  86371 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86491), // Rule ID 6353 //
     /*  86376 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86380 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86384 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86388 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86392 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86396 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  86400 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86404 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86409 */       // MIs[2] imm
     /*  86409 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86413 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86417 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86421 */       // MIs[3] Operand 1
     /*  86421 */       // No operand predicates
     /*  86421 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86423 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86423 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86426 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86430 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86435 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86437 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86440 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86444 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86449 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86452 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86456 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86459 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86464 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86469 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86479 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86482 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86486 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86489 */       GIR_RootConstrainSelectedInstOperands,
     /*  86490 */       // GIR_Coverage, 6353,
     /*  86490 */       GIR_EraseRootFromParent_Done,
     /*  86491 */     // Label 1420: @86491
     /*  86491 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86608), // Rule ID 2499 //
     /*  86496 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86499 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86503 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86507 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86511 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86514 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  86519 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86523 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86527 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86532 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86537 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86539 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86539 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86542 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86546 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86551 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86553 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86556 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86560 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86565 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86568 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86572 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86575 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86580 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86585 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86590 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  86593 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86595 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86598 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86606 */       GIR_RootConstrainSelectedInstOperands,
     /*  86607 */       // GIR_Coverage, 2499,
     /*  86607 */       GIR_EraseRootFromParent_Done,
     /*  86608 */     // Label 1421: @86608
     /*  86608 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86725), // Rule ID 5345 //
     /*  86613 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86616 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86620 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86624 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86628 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86631 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  86636 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86640 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86644 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86649 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86654 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86656 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86656 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86659 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86663 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86668 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86682 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86689 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86702 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86707 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  86710 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86712 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86715 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86719 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86723 */       GIR_RootConstrainSelectedInstOperands,
     /*  86724 */       // GIR_Coverage, 5345,
     /*  86724 */       GIR_EraseRootFromParent_Done,
     /*  86725 */     // Label 1422: @86725
     /*  86725 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86842), // Rule ID 5348 //
     /*  86730 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86733 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86737 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86741 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86745 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86748 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86753 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86757 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86766 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86771 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86773 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86773 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86776 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86780 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86785 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86787 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86790 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86794 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86799 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86802 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86806 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86809 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86832 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86836 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86840 */       GIR_RootConstrainSelectedInstOperands,
     /*  86841 */       // GIR_Coverage, 5348,
     /*  86841 */       GIR_EraseRootFromParent_Done,
     /*  86842 */     // Label 1423: @86842
     /*  86842 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86959), // Rule ID 5351 //
     /*  86847 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86850 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86854 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86858 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86862 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86865 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86870 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86874 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86883 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86888 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86890 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86890 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86893 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86897 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86902 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86904 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86907 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86911 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86916 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86919 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86923 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86941 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86944 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86946 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86949 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86953 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86957 */       GIR_RootConstrainSelectedInstOperands,
     /*  86958 */       // GIR_Coverage, 5351,
     /*  86958 */       GIR_EraseRootFromParent_Done,
     /*  86959 */     // Label 1424: @86959
     /*  86959 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(87015), // Rule ID 5492 //
     /*  86964 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86968 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86972 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86976 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86981 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86985 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86989 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86993 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86998 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  87000 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  87000 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  87003 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87005 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  87009 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  87013 */       GIR_RootConstrainSelectedInstOperands,
     /*  87014 */       // GIR_Coverage, 5492,
     /*  87014 */       GIR_EraseRootFromParent_Done,
     /*  87015 */     // Label 1425: @87015
     /*  87015 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(87081), // Rule ID 5818 //
     /*  87020 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87024 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87028 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87034 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  87036 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87038 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  87038 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87041 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  87045 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  87054 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87056 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  87059 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87061 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87064 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87067 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87070 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87075 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87080 */       // GIR_Coverage, 5818,
     /*  87080 */       GIR_EraseRootFromParent_Done,
     /*  87081 */     // Label 1426: @87081
     /*  87081 */     GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(87177), // Rule ID 4959 //
     /*  87086 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87089 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87093 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87097 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  87101 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87105 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87110 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87112 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  87112 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87115 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87119 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87124 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87126 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87129 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87133 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87138 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87141 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87145 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87148 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87153 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87163 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  87166 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87168 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87171 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87175 */       GIR_RootConstrainSelectedInstOperands,
     /*  87176 */       // GIR_Coverage, 4959,
     /*  87176 */       GIR_EraseRootFromParent_Done,
     /*  87177 */     // Label 1427: @87177
     /*  87177 */     GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(87239), // Rule ID 5819 //
     /*  87182 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87186 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87190 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  87194 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87196 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  87196 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  87199 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87203 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87208 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87210 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87213 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87215 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87218 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87220 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87223 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87238 */       // GIR_Coverage, 5819,
     /*  87238 */       GIR_EraseRootFromParent_Done,
     /*  87239 */     // Label 1428: @87239
     /*  87239 */     GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(87373), // Rule ID 5817 //
     /*  87244 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87248 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87252 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  87252 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  87255 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87259 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87264 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  87266 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  87269 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87273 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87278 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  87281 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  87285 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  87288 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87293 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87298 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87303 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87306 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87310 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87315 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87317 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87320 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87324 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87329 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87332 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87336 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87339 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87344 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87349 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  87357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87359 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87362 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  87365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  87368 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87371 */       GIR_RootConstrainSelectedInstOperands,
     /*  87372 */       // GIR_Coverage, 5817,
     /*  87372 */       GIR_EraseRootFromParent_Done,
     /*  87373 */     // Label 1429: @87373
     /*  87373 */     GIM_Reject,
     /*  87374 */   // Label 1411: @87374
     /*  87374 */   GIM_Reject,
     /*  87375 */   // Label 1346: @87375
     /*  87375 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(87400), // Rule ID 9091 //
     /*  87380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87383 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  87386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  87389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87393 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  87393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  87398 */     GIR_RootConstrainSelectedInstOperands,
     /*  87399 */     // GIR_Coverage, 9091,
     /*  87399 */     GIR_Done,
     /*  87400 */   // Label 1430: @87400
     /*  87400 */   GIM_Reject,
     /*  87401 */   // Label 1347: @87401
     /*  87401 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(87426), // Rule ID 9092 //
     /*  87406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87409 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  87412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  87415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87419 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  87419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  87424 */     GIR_RootConstrainSelectedInstOperands,
     /*  87425 */     // GIR_Coverage, 9092,
     /*  87425 */     GIR_Done,
     /*  87426 */   // Label 1431: @87426
     /*  87426 */   GIM_Reject,
     /*  87427 */   // Label 1348: @87427
     /*  87427 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(87452), // Rule ID 9095 //
     /*  87432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  87438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  87441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87445 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  87445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 9095,
     /*  87451 */     GIR_Done,
     /*  87452 */   // Label 1432: @87452
     /*  87452 */   GIM_Reject,
     /*  87453 */   // Label 1349: @87453
     /*  87453 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(87478), // Rule ID 9097 //
     /*  87458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87461 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  87464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  87467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87471 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  87471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87476 */     GIR_RootConstrainSelectedInstOperands,
     /*  87477 */     // GIR_Coverage, 9097,
     /*  87477 */     GIR_Done,
     /*  87478 */   // Label 1433: @87478
     /*  87478 */   GIM_Reject,
     /*  87479 */   // Label 1350: @87479
     /*  87479 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(87504), // Rule ID 9093 //
     /*  87484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87487 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  87490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  87493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87497 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  87497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  87502 */     GIR_RootConstrainSelectedInstOperands,
     /*  87503 */     // GIR_Coverage, 9093,
     /*  87503 */     GIR_Done,
     /*  87504 */   // Label 1434: @87504
     /*  87504 */   GIM_Reject,
     /*  87505 */   // Label 1351: @87505
     /*  87505 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(87530), // Rule ID 9096 //
     /*  87510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87513 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  87516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  87519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87523 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  87523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  87528 */     GIR_RootConstrainSelectedInstOperands,
     /*  87529 */     // GIR_Coverage, 9096,
     /*  87529 */     GIR_Done,
     /*  87530 */   // Label 1435: @87530
     /*  87530 */   GIM_Reject,
     /*  87531 */   // Label 1352: @87531
     /*  87531 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(87556), // Rule ID 9094 //
     /*  87536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87539 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  87542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  87545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87549 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  87549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  87554 */     GIR_RootConstrainSelectedInstOperands,
     /*  87555 */     // GIR_Coverage, 9094,
     /*  87555 */     GIR_Done,
     /*  87556 */   // Label 1436: @87556
     /*  87556 */   GIM_Reject,
     /*  87557 */   // Label 1353: @87557
     /*  87557 */   GIM_Reject,
     /*  87558 */ // Label 1341: @87558
     /*  87558 */ GIM_Reject,
     /*  87559 */ // Label 9: @87559
     /*  87559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1451*/ GIMT_Encode4(97534),
     /*  87570 */ /*GILLT_s32*//*Label 1437*/ GIMT_Encode4(87658),
     /*  87574 */ /*GILLT_s64*//*Label 1438*/ GIMT_Encode4(88055),
     /*  87578 */ /*GILLT_s128*//*Label 1439*/ GIMT_Encode4(90046),
     /*  87582 */ /*GILLT_v2s32*//*Label 1440*/ GIMT_Encode4(90692),
     /*  87586 */ /*GILLT_v2s64*//*Label 1441*/ GIMT_Encode4(91607),
     /*  87590 */ /*GILLT_v4s16*//*Label 1442*/ GIMT_Encode4(92376),
     /*  87594 */ /*GILLT_v4s32*//*Label 1443*/ GIMT_Encode4(93291),
     /*  87598 */ /*GILLT_v8s8*//*Label 1444*/ GIMT_Encode4(94136),
     /*  87602 */ /*GILLT_v8s16*//*Label 1445*/ GIMT_Encode4(94697),
     /*  87606 */ /*GILLT_v16s8*//*Label 1446*/ GIMT_Encode4(95542), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87626 */ /*GILLT_nxv2s64*//*Label 1447*/ GIMT_Encode4(95994), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87638 */ /*GILLT_nxv4s32*//*Label 1448*/ GIMT_Encode4(96443), GIMT_Encode4(0),
     /*  87646 */ /*GILLT_nxv8s16*//*Label 1449*/ GIMT_Encode4(96892), GIMT_Encode4(0),
     /*  87654 */ /*GILLT_nxv16s8*//*Label 1450*/ GIMT_Encode4(97341),
     /*  87658 */ // Label 1437: @87658
     /*  87658 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(88054),
     /*  87663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87666 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87740), // Rule ID 7068 //
     /*  87671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87683 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87690 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87697 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  87713 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  87713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  87716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87738 */     GIR_RootConstrainSelectedInstOperands,
     /*  87739 */     // GIR_Coverage, 7068,
     /*  87739 */     GIR_EraseRootFromParent_Done,
     /*  87740 */   // Label 1453: @87740
     /*  87740 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87814), // Rule ID 7069 //
     /*  87745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87757 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87764 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87771 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87787 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87812 */     GIR_RootConstrainSelectedInstOperands,
     /*  87813 */     // GIR_Coverage, 7069,
     /*  87813 */     GIR_EraseRootFromParent_Done,
     /*  87814 */   // Label 1454: @87814
     /*  87814 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87883), // Rule ID 7070 //
     /*  87819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87831 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87838 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87845 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87861 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87881 */     GIR_RootConstrainSelectedInstOperands,
     /*  87882 */     // GIR_Coverage, 7070,
     /*  87882 */     GIR_EraseRootFromParent_Done,
     /*  87883 */   // Label 1455: @87883
     /*  87883 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87952), // Rule ID 7071 //
     /*  87888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87900 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87907 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87914 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87930 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87950 */     GIR_RootConstrainSelectedInstOperands,
     /*  87951 */     // GIR_Coverage, 7071,
     /*  87951 */     GIR_EraseRootFromParent_Done,
     /*  87952 */   // Label 1456: @87952
     /*  87952 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(88005), // Rule ID 5784 //
     /*  87957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87977 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87983 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87988 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88004 */     // GIR_Coverage, 5784,
     /*  88004 */     GIR_EraseRootFromParent_Done,
     /*  88005 */   // Label 1457: @88005
     /*  88005 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(88029), // Rule ID 6679 //
     /*  88010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88018 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  88018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88028 */     // GIR_Coverage, 6679,
     /*  88028 */     GIR_Done,
     /*  88029 */   // Label 1458: @88029
     /*  88029 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(88053), // Rule ID 6680 //
     /*  88034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88042 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  88042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88052 */     // GIR_Coverage, 6680,
     /*  88052 */     GIR_Done,
     /*  88053 */   // Label 1459: @88053
     /*  88053 */   GIM_Reject,
     /*  88054 */ // Label 1452: @88054
     /*  88054 */ GIM_Reject,
     /*  88055 */ // Label 1438: @88055
     /*  88055 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(88132), // Rule ID 7072 //
     /*  88060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88075 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88082 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88089 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88092 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88098 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  88105 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  88105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  88108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88130 */   GIR_RootConstrainSelectedInstOperands,
     /*  88131 */   // GIR_Coverage, 7072,
     /*  88131 */   GIR_EraseRootFromParent_Done,
     /*  88132 */ // Label 1460: @88132
     /*  88132 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(88209), // Rule ID 7073 //
     /*  88137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88155 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88159 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88166 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88169 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88175 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  88182 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  88182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  88185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88207 */   GIR_RootConstrainSelectedInstOperands,
     /*  88208 */   // GIR_Coverage, 7073,
     /*  88208 */   GIR_EraseRootFromParent_Done,
     /*  88209 */ // Label 1461: @88209
     /*  88209 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(88281), // Rule ID 7074 //
     /*  88214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88232 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88236 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88243 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88246 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88252 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  88259 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  88259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  88262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88279 */   GIR_RootConstrainSelectedInstOperands,
     /*  88280 */   // GIR_Coverage, 7074,
     /*  88280 */   GIR_EraseRootFromParent_Done,
     /*  88281 */ // Label 1462: @88281
     /*  88281 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(88353), // Rule ID 7075 //
     /*  88286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88308 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88315 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88318 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88324 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  88331 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  88331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  88334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88351 */   GIR_RootConstrainSelectedInstOperands,
     /*  88352 */   // GIR_Coverage, 7075,
     /*  88352 */   GIR_EraseRootFromParent_Done,
     /*  88353 */ // Label 1463: @88353
     /*  88353 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(88409), // Rule ID 5786 //
     /*  88358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  88373 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88377 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88381 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  88385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88387 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  88387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88392 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  88398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88408 */   // GIR_Coverage, 5786,
     /*  88408 */   GIR_EraseRootFromParent_Done,
     /*  88409 */ // Label 1464: @88409
     /*  88409 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(88439), // Rule ID 6654 //
     /*  88414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88428 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  88428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88438 */   // GIR_Coverage, 6654,
     /*  88438 */   GIR_Done,
     /*  88439 */ // Label 1465: @88439
     /*  88439 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(88469), // Rule ID 6655 //
     /*  88444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88458 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  88458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88468 */   // GIR_Coverage, 6655,
     /*  88468 */   GIR_Done,
     /*  88469 */ // Label 1466: @88469
     /*  88469 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(88499), // Rule ID 6656 //
     /*  88474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88488 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  88488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88498 */   // GIR_Coverage, 6656,
     /*  88498 */   GIR_Done,
     /*  88499 */ // Label 1467: @88499
     /*  88499 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(88529), // Rule ID 6657 //
     /*  88504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  88518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88528 */   // GIR_Coverage, 6657,
     /*  88528 */   GIR_Done,
     /*  88529 */ // Label 1468: @88529
     /*  88529 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(88559), // Rule ID 6658 //
     /*  88534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88548 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  88548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88558 */   // GIR_Coverage, 6658,
     /*  88558 */   GIR_Done,
     /*  88559 */ // Label 1469: @88559
     /*  88559 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(88589), // Rule ID 6659 //
     /*  88564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88578 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88588 */   // GIR_Coverage, 6659,
     /*  88588 */   GIR_Done,
     /*  88589 */ // Label 1470: @88589
     /*  88589 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88639), // Rule ID 6665 //
     /*  88594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88608 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  88608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88620 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88624 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88637 */   GIR_RootConstrainSelectedInstOperands,
     /*  88638 */   // GIR_Coverage, 6665,
     /*  88638 */   GIR_EraseRootFromParent_Done,
     /*  88639 */ // Label 1471: @88639
     /*  88639 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88689), // Rule ID 6666 //
     /*  88644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88658 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88670 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88687 */   GIR_RootConstrainSelectedInstOperands,
     /*  88688 */   // GIR_Coverage, 6666,
     /*  88688 */   GIR_EraseRootFromParent_Done,
     /*  88689 */ // Label 1472: @88689
     /*  88689 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88739), // Rule ID 6667 //
     /*  88694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88708 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88737 */   GIR_RootConstrainSelectedInstOperands,
     /*  88738 */   // GIR_Coverage, 6667,
     /*  88738 */   GIR_EraseRootFromParent_Done,
     /*  88739 */ // Label 1473: @88739
     /*  88739 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88789), // Rule ID 6668 //
     /*  88744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88758 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88770 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88787 */   GIR_RootConstrainSelectedInstOperands,
     /*  88788 */   // GIR_Coverage, 6668,
     /*  88788 */   GIR_EraseRootFromParent_Done,
     /*  88789 */ // Label 1474: @88789
     /*  88789 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88839), // Rule ID 6669 //
     /*  88794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88808 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88820 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88837 */   GIR_RootConstrainSelectedInstOperands,
     /*  88838 */   // GIR_Coverage, 6669,
     /*  88838 */   GIR_EraseRootFromParent_Done,
     /*  88839 */ // Label 1475: @88839
     /*  88839 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88866), // Rule ID 6670 //
     /*  88844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88855 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88865 */   // GIR_Coverage, 6670,
     /*  88865 */   GIR_Done,
     /*  88866 */ // Label 1476: @88866
     /*  88866 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88893), // Rule ID 6671 //
     /*  88871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88882 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88892 */   // GIR_Coverage, 6671,
     /*  88892 */   GIR_Done,
     /*  88893 */ // Label 1477: @88893
     /*  88893 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88920), // Rule ID 6672 //
     /*  88898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88909 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88919 */   // GIR_Coverage, 6672,
     /*  88919 */   GIR_Done,
     /*  88920 */ // Label 1478: @88920
     /*  88920 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88947), // Rule ID 6681 //
     /*  88925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88936 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88946 */   // GIR_Coverage, 6681,
     /*  88946 */   GIR_Done,
     /*  88947 */ // Label 1479: @88947
     /*  88947 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88974), // Rule ID 6682 //
     /*  88952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88963 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88973 */   // GIR_Coverage, 6682,
     /*  88973 */   GIR_Done,
     /*  88974 */ // Label 1480: @88974
     /*  88974 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(89001), // Rule ID 6683 //
     /*  88979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88990 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89000 */   // GIR_Coverage, 6683,
     /*  89000 */   GIR_Done,
     /*  89001 */ // Label 1481: @89001
     /*  89001 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(89033), // Rule ID 6684 //
     /*  89006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89020 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89032 */   // GIR_Coverage, 6684,
     /*  89032 */   GIR_EraseRootFromParent_Done,
     /*  89033 */ // Label 1482: @89033
     /*  89033 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(89065), // Rule ID 6685 //
     /*  89038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89052 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89064 */   // GIR_Coverage, 6685,
     /*  89064 */   GIR_EraseRootFromParent_Done,
     /*  89065 */ // Label 1483: @89065
     /*  89065 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(89097), // Rule ID 6686 //
     /*  89070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89084 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89096 */   // GIR_Coverage, 6686,
     /*  89096 */   GIR_EraseRootFromParent_Done,
     /*  89097 */ // Label 1484: @89097
     /*  89097 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(89129), // Rule ID 6687 //
     /*  89102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89116 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89128 */   // GIR_Coverage, 6687,
     /*  89128 */   GIR_EraseRootFromParent_Done,
     /*  89129 */ // Label 1485: @89129
     /*  89129 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(89161), // Rule ID 6688 //
     /*  89134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89148 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89160 */   // GIR_Coverage, 6688,
     /*  89160 */   GIR_EraseRootFromParent_Done,
     /*  89161 */ // Label 1486: @89161
     /*  89161 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(89187), // Rule ID 6689 //
     /*  89166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89180 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  89180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89185 */   GIR_RootConstrainSelectedInstOperands,
     /*  89186 */   // GIR_Coverage, 6689,
     /*  89186 */   GIR_Done,
     /*  89187 */ // Label 1487: @89187
     /*  89187 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(89213), // Rule ID 6690 //
     /*  89192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89206 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  89206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89211 */   GIR_RootConstrainSelectedInstOperands,
     /*  89212 */   // GIR_Coverage, 6690,
     /*  89212 */   GIR_Done,
     /*  89213 */ // Label 1488: @89213
     /*  89213 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(89239), // Rule ID 6691 //
     /*  89218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89232 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  89232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89237 */   GIR_RootConstrainSelectedInstOperands,
     /*  89238 */   // GIR_Coverage, 6691,
     /*  89238 */   GIR_Done,
     /*  89239 */ // Label 1489: @89239
     /*  89239 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(89265), // Rule ID 6692 //
     /*  89244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89258 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  89258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89263 */   GIR_RootConstrainSelectedInstOperands,
     /*  89264 */   // GIR_Coverage, 6692,
     /*  89264 */   GIR_Done,
     /*  89265 */ // Label 1490: @89265
     /*  89265 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(89291), // Rule ID 6693 //
     /*  89270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89284 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  89284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89289 */   GIR_RootConstrainSelectedInstOperands,
     /*  89290 */   // GIR_Coverage, 6693,
     /*  89290 */   GIR_Done,
     /*  89291 */ // Label 1491: @89291
     /*  89291 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(89320), // Rule ID 6694 //
     /*  89296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89307 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89310 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89312 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89319 */   // GIR_Coverage, 6694,
     /*  89319 */   GIR_EraseRootFromParent_Done,
     /*  89320 */ // Label 1492: @89320
     /*  89320 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(89349), // Rule ID 6695 //
     /*  89325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89336 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89339 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89348 */   // GIR_Coverage, 6695,
     /*  89348 */   GIR_EraseRootFromParent_Done,
     /*  89349 */ // Label 1493: @89349
     /*  89349 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(89381), // Rule ID 6749 //
     /*  89354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89368 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89371 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89373 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89380 */   // GIR_Coverage, 6749,
     /*  89380 */   GIR_EraseRootFromParent_Done,
     /*  89381 */ // Label 1494: @89381
     /*  89381 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(89413), // Rule ID 6750 //
     /*  89386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89400 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89403 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89405 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89407 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89412 */   // GIR_Coverage, 6750,
     /*  89412 */   GIR_EraseRootFromParent_Done,
     /*  89413 */ // Label 1495: @89413
     /*  89413 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(89445), // Rule ID 6751 //
     /*  89418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89432 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89435 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89437 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89444 */   // GIR_Coverage, 6751,
     /*  89444 */   GIR_EraseRootFromParent_Done,
     /*  89445 */ // Label 1496: @89445
     /*  89445 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(89477), // Rule ID 6752 //
     /*  89450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89464 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89467 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89469 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89476 */   // GIR_Coverage, 6752,
     /*  89476 */   GIR_EraseRootFromParent_Done,
     /*  89477 */ // Label 1497: @89477
     /*  89477 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(89509), // Rule ID 6753 //
     /*  89482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89496 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89499 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89501 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89508 */   // GIR_Coverage, 6753,
     /*  89508 */   GIR_EraseRootFromParent_Done,
     /*  89509 */ // Label 1498: @89509
     /*  89509 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(89535), // Rule ID 6754 //
     /*  89514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89528 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89533 */   GIR_RootConstrainSelectedInstOperands,
     /*  89534 */   // GIR_Coverage, 6754,
     /*  89534 */   GIR_Done,
     /*  89535 */ // Label 1499: @89535
     /*  89535 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(89561), // Rule ID 6755 //
     /*  89540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89554 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89559 */   GIR_RootConstrainSelectedInstOperands,
     /*  89560 */   // GIR_Coverage, 6755,
     /*  89560 */   GIR_Done,
     /*  89561 */ // Label 1500: @89561
     /*  89561 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(89587), // Rule ID 6756 //
     /*  89566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89580 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89585 */   GIR_RootConstrainSelectedInstOperands,
     /*  89586 */   // GIR_Coverage, 6756,
     /*  89586 */   GIR_Done,
     /*  89587 */ // Label 1501: @89587
     /*  89587 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(89613), // Rule ID 6757 //
     /*  89592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89606 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89611 */   GIR_RootConstrainSelectedInstOperands,
     /*  89612 */   // GIR_Coverage, 6757,
     /*  89612 */   GIR_Done,
     /*  89613 */ // Label 1502: @89613
     /*  89613 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(89639), // Rule ID 6758 //
     /*  89618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89632 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89637 */   GIR_RootConstrainSelectedInstOperands,
     /*  89638 */   // GIR_Coverage, 6758,
     /*  89638 */   GIR_Done,
     /*  89639 */ // Label 1503: @89639
     /*  89639 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89668), // Rule ID 6759 //
     /*  89644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89655 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89667 */   // GIR_Coverage, 6759,
     /*  89667 */   GIR_EraseRootFromParent_Done,
     /*  89668 */ // Label 1504: @89668
     /*  89668 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89697), // Rule ID 6760 //
     /*  89673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89684 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89696 */   // GIR_Coverage, 6760,
     /*  89696 */   GIR_EraseRootFromParent_Done,
     /*  89697 */ // Label 1505: @89697
     /*  89697 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89729), // Rule ID 6761 //
     /*  89702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89716 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89728 */   // GIR_Coverage, 6761,
     /*  89728 */   GIR_EraseRootFromParent_Done,
     /*  89729 */ // Label 1506: @89729
     /*  89729 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89761), // Rule ID 6762 //
     /*  89734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89748 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89760 */   // GIR_Coverage, 6762,
     /*  89760 */   GIR_EraseRootFromParent_Done,
     /*  89761 */ // Label 1507: @89761
     /*  89761 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89793), // Rule ID 6763 //
     /*  89766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89780 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89792 */   // GIR_Coverage, 6763,
     /*  89792 */   GIR_EraseRootFromParent_Done,
     /*  89793 */ // Label 1508: @89793
     /*  89793 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89825), // Rule ID 6764 //
     /*  89798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89812 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89824 */   // GIR_Coverage, 6764,
     /*  89824 */   GIR_EraseRootFromParent_Done,
     /*  89825 */ // Label 1509: @89825
     /*  89825 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89857), // Rule ID 6765 //
     /*  89830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89844 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89856 */   // GIR_Coverage, 6765,
     /*  89856 */   GIR_EraseRootFromParent_Done,
     /*  89857 */ // Label 1510: @89857
     /*  89857 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89883), // Rule ID 6766 //
     /*  89862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89876 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89881 */   GIR_RootConstrainSelectedInstOperands,
     /*  89882 */   // GIR_Coverage, 6766,
     /*  89882 */   GIR_Done,
     /*  89883 */ // Label 1511: @89883
     /*  89883 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89909), // Rule ID 6767 //
     /*  89888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89902 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89907 */   GIR_RootConstrainSelectedInstOperands,
     /*  89908 */   // GIR_Coverage, 6767,
     /*  89908 */   GIR_Done,
     /*  89909 */ // Label 1512: @89909
     /*  89909 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89935), // Rule ID 6768 //
     /*  89914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89928 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89933 */   GIR_RootConstrainSelectedInstOperands,
     /*  89934 */   // GIR_Coverage, 6768,
     /*  89934 */   GIR_Done,
     /*  89935 */ // Label 1513: @89935
     /*  89935 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89961), // Rule ID 6769 //
     /*  89940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89954 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89959 */   GIR_RootConstrainSelectedInstOperands,
     /*  89960 */   // GIR_Coverage, 6769,
     /*  89960 */   GIR_Done,
     /*  89961 */ // Label 1514: @89961
     /*  89961 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89987), // Rule ID 6770 //
     /*  89966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89980 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89985 */   GIR_RootConstrainSelectedInstOperands,
     /*  89986 */   // GIR_Coverage, 6770,
     /*  89986 */   GIR_Done,
     /*  89987 */ // Label 1515: @89987
     /*  89987 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(90016), // Rule ID 6771 //
     /*  89992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90003 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  90003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90006 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90008 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90015 */   // GIR_Coverage, 6771,
     /*  90015 */   GIR_EraseRootFromParent_Done,
     /*  90016 */ // Label 1516: @90016
     /*  90016 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(90045), // Rule ID 6772 //
     /*  90021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90032 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  90032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90044 */   // GIR_Coverage, 6772,
     /*  90044 */   GIR_EraseRootFromParent_Done,
     /*  90045 */ // Label 1517: @90045
     /*  90045 */ GIM_Reject,
     /*  90046 */ // Label 1439: @90046
     /*  90046 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(90078), // Rule ID 6786 //
     /*  90051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90065 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90068 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90070 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90072 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90077 */   // GIR_Coverage, 6786,
     /*  90077 */   GIR_EraseRootFromParent_Done,
     /*  90078 */ // Label 1518: @90078
     /*  90078 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(90110), // Rule ID 6787 //
     /*  90083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90097 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90100 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90102 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90109 */   // GIR_Coverage, 6787,
     /*  90109 */   GIR_EraseRootFromParent_Done,
     /*  90110 */ // Label 1519: @90110
     /*  90110 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(90142), // Rule ID 6788 //
     /*  90115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90129 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90141 */   // GIR_Coverage, 6788,
     /*  90141 */   GIR_EraseRootFromParent_Done,
     /*  90142 */ // Label 1520: @90142
     /*  90142 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(90174), // Rule ID 6789 //
     /*  90147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90161 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90173 */   // GIR_Coverage, 6789,
     /*  90173 */   GIR_EraseRootFromParent_Done,
     /*  90174 */ // Label 1521: @90174
     /*  90174 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(90206), // Rule ID 6790 //
     /*  90179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90193 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90205 */   // GIR_Coverage, 6790,
     /*  90205 */   GIR_EraseRootFromParent_Done,
     /*  90206 */ // Label 1522: @90206
     /*  90206 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(90238), // Rule ID 6791 //
     /*  90211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90225 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90237 */   // GIR_Coverage, 6791,
     /*  90237 */   GIR_EraseRootFromParent_Done,
     /*  90238 */ // Label 1523: @90238
     /*  90238 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(90270), // Rule ID 6792 //
     /*  90243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90257 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90269 */   // GIR_Coverage, 6792,
     /*  90269 */   GIR_EraseRootFromParent_Done,
     /*  90270 */ // Label 1524: @90270
     /*  90270 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(90303), // Rule ID 6793 //
     /*  90275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90289 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  90289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90301 */   GIR_RootConstrainSelectedInstOperands,
     /*  90302 */   // GIR_Coverage, 6793,
     /*  90302 */   GIR_EraseRootFromParent_Done,
     /*  90303 */ // Label 1525: @90303
     /*  90303 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(90374), // Rule ID 6794 //
     /*  90308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90322 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  90322 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90325 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90329 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90334 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90372 */   GIR_RootConstrainSelectedInstOperands,
     /*  90373 */   // GIR_Coverage, 6794,
     /*  90373 */   GIR_EraseRootFromParent_Done,
     /*  90374 */ // Label 1526: @90374
     /*  90374 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(90445), // Rule ID 6795 //
     /*  90379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90393 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  90393 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90396 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90400 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90405 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90423 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90443 */   GIR_RootConstrainSelectedInstOperands,
     /*  90444 */   // GIR_Coverage, 6795,
     /*  90444 */   GIR_EraseRootFromParent_Done,
     /*  90445 */ // Label 1527: @90445
     /*  90445 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(90516), // Rule ID 6796 //
     /*  90450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90464 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  90464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90514 */   GIR_RootConstrainSelectedInstOperands,
     /*  90515 */   // GIR_Coverage, 6796,
     /*  90515 */   GIR_EraseRootFromParent_Done,
     /*  90516 */ // Label 1528: @90516
     /*  90516 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(90549), // Rule ID 6797 //
     /*  90521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90535 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  90535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90540 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90547 */   GIR_RootConstrainSelectedInstOperands,
     /*  90548 */   // GIR_Coverage, 6797,
     /*  90548 */   GIR_EraseRootFromParent_Done,
     /*  90549 */ // Label 1529: @90549
     /*  90549 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90620), // Rule ID 6798 //
     /*  90554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90568 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  90568 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90571 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90575 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90580 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90598 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90618 */   GIR_RootConstrainSelectedInstOperands,
     /*  90619 */   // GIR_Coverage, 6798,
     /*  90619 */   GIR_EraseRootFromParent_Done,
     /*  90620 */ // Label 1530: @90620
     /*  90620 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90691), // Rule ID 6799 //
     /*  90625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90639 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  90639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90651 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90689 */   GIR_RootConstrainSelectedInstOperands,
     /*  90690 */   // GIR_Coverage, 6799,
     /*  90690 */   GIR_EraseRootFromParent_Done,
     /*  90691 */ // Label 1531: @90691
     /*  90691 */ GIM_Reject,
     /*  90692 */ // Label 1440: @90692
     /*  90692 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90722), // Rule ID 6651 //
     /*  90697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90711 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90721 */   // GIR_Coverage, 6651,
     /*  90721 */   GIR_Done,
     /*  90722 */ // Label 1532: @90722
     /*  90722 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90752), // Rule ID 6653 //
     /*  90727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90741 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90751 */   // GIR_Coverage, 6653,
     /*  90751 */   GIR_Done,
     /*  90752 */ // Label 1533: @90752
     /*  90752 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90802), // Rule ID 6662 //
     /*  90757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90771 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90783 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90800 */   GIR_RootConstrainSelectedInstOperands,
     /*  90801 */   // GIR_Coverage, 6662,
     /*  90801 */   GIR_EraseRootFromParent_Done,
     /*  90802 */ // Label 1534: @90802
     /*  90802 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90852), // Rule ID 6664 //
     /*  90807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90821 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90833 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90837 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90850 */   GIR_RootConstrainSelectedInstOperands,
     /*  90851 */   // GIR_Coverage, 6664,
     /*  90851 */   GIR_EraseRootFromParent_Done,
     /*  90852 */ // Label 1535: @90852
     /*  90852 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90884), // Rule ID 6696 //
     /*  90857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90871 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90883 */   // GIR_Coverage, 6696,
     /*  90883 */   GIR_EraseRootFromParent_Done,
     /*  90884 */ // Label 1536: @90884
     /*  90884 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90916), // Rule ID 6697 //
     /*  90889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90903 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90915 */   // GIR_Coverage, 6697,
     /*  90915 */   GIR_EraseRootFromParent_Done,
     /*  90916 */ // Label 1537: @90916
     /*  90916 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90948), // Rule ID 6698 //
     /*  90921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90935 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90947 */   // GIR_Coverage, 6698,
     /*  90947 */   GIR_EraseRootFromParent_Done,
     /*  90948 */ // Label 1538: @90948
     /*  90948 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90980), // Rule ID 6699 //
     /*  90953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90967 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90979 */   // GIR_Coverage, 6699,
     /*  90979 */   GIR_EraseRootFromParent_Done,
     /*  90980 */ // Label 1539: @90980
     /*  90980 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(91012), // Rule ID 6700 //
     /*  90985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90999 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91011 */   // GIR_Coverage, 6700,
     /*  91011 */   GIR_EraseRootFromParent_Done,
     /*  91012 */ // Label 1540: @91012
     /*  91012 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(91044), // Rule ID 6701 //
     /*  91017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91031 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  91031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91043 */   // GIR_Coverage, 6701,
     /*  91043 */   GIR_EraseRootFromParent_Done,
     /*  91044 */ // Label 1541: @91044
     /*  91044 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(91070), // Rule ID 6702 //
     /*  91049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91063 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  91063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91068 */   GIR_RootConstrainSelectedInstOperands,
     /*  91069 */   // GIR_Coverage, 6702,
     /*  91069 */   GIR_Done,
     /*  91070 */ // Label 1542: @91070
     /*  91070 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(91096), // Rule ID 6703 //
     /*  91075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91089 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  91089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91094 */   GIR_RootConstrainSelectedInstOperands,
     /*  91095 */   // GIR_Coverage, 6703,
     /*  91095 */   GIR_Done,
     /*  91096 */ // Label 1543: @91096
     /*  91096 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(91122), // Rule ID 6704 //
     /*  91101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91115 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  91115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91120 */   GIR_RootConstrainSelectedInstOperands,
     /*  91121 */   // GIR_Coverage, 6704,
     /*  91121 */   GIR_Done,
     /*  91122 */ // Label 1544: @91122
     /*  91122 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(91148), // Rule ID 6705 //
     /*  91127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91141 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  91141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91146 */   GIR_RootConstrainSelectedInstOperands,
     /*  91147 */   // GIR_Coverage, 6705,
     /*  91147 */   GIR_Done,
     /*  91148 */ // Label 1545: @91148
     /*  91148 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(91174), // Rule ID 6706 //
     /*  91153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91167 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  91167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91172 */   GIR_RootConstrainSelectedInstOperands,
     /*  91173 */   // GIR_Coverage, 6706,
     /*  91173 */   GIR_Done,
     /*  91174 */ // Label 1546: @91174
     /*  91174 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(91200), // Rule ID 6707 //
     /*  91179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91193 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  91193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91198 */   GIR_RootConstrainSelectedInstOperands,
     /*  91199 */   // GIR_Coverage, 6707,
     /*  91199 */   GIR_Done,
     /*  91200 */ // Label 1547: @91200
     /*  91200 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(91229), // Rule ID 6708 //
     /*  91205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91216 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  91216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91219 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91221 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91228 */   // GIR_Coverage, 6708,
     /*  91228 */   GIR_EraseRootFromParent_Done,
     /*  91229 */ // Label 1548: @91229
     /*  91229 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(91261), // Rule ID 6773 //
     /*  91234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91248 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91251 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91260 */   // GIR_Coverage, 6773,
     /*  91260 */   GIR_EraseRootFromParent_Done,
     /*  91261 */ // Label 1549: @91261
     /*  91261 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(91293), // Rule ID 6774 //
     /*  91266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91280 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91292 */   // GIR_Coverage, 6774,
     /*  91292 */   GIR_EraseRootFromParent_Done,
     /*  91293 */ // Label 1550: @91293
     /*  91293 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(91325), // Rule ID 6775 //
     /*  91298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91312 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91315 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91324 */   // GIR_Coverage, 6775,
     /*  91324 */   GIR_EraseRootFromParent_Done,
     /*  91325 */ // Label 1551: @91325
     /*  91325 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(91357), // Rule ID 6776 //
     /*  91330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91344 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91347 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91356 */   // GIR_Coverage, 6776,
     /*  91356 */   GIR_EraseRootFromParent_Done,
     /*  91357 */ // Label 1552: @91357
     /*  91357 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(91389), // Rule ID 6777 //
     /*  91362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91376 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91379 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91381 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91388 */   // GIR_Coverage, 6777,
     /*  91388 */   GIR_EraseRootFromParent_Done,
     /*  91389 */ // Label 1553: @91389
     /*  91389 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(91421), // Rule ID 6778 //
     /*  91394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91408 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91411 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91420 */   // GIR_Coverage, 6778,
     /*  91420 */   GIR_EraseRootFromParent_Done,
     /*  91421 */ // Label 1554: @91421
     /*  91421 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(91447), // Rule ID 6779 //
     /*  91426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91440 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  91440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91445 */   GIR_RootConstrainSelectedInstOperands,
     /*  91446 */   // GIR_Coverage, 6779,
     /*  91446 */   GIR_Done,
     /*  91447 */ // Label 1555: @91447
     /*  91447 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(91473), // Rule ID 6780 //
     /*  91452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91466 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  91466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91471 */   GIR_RootConstrainSelectedInstOperands,
     /*  91472 */   // GIR_Coverage, 6780,
     /*  91472 */   GIR_Done,
     /*  91473 */ // Label 1556: @91473
     /*  91473 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(91499), // Rule ID 6781 //
     /*  91478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91492 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  91492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91497 */   GIR_RootConstrainSelectedInstOperands,
     /*  91498 */   // GIR_Coverage, 6781,
     /*  91498 */   GIR_Done,
     /*  91499 */ // Label 1557: @91499
     /*  91499 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(91525), // Rule ID 6782 //
     /*  91504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91518 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  91518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91523 */   GIR_RootConstrainSelectedInstOperands,
     /*  91524 */   // GIR_Coverage, 6782,
     /*  91524 */   GIR_Done,
     /*  91525 */ // Label 1558: @91525
     /*  91525 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(91551), // Rule ID 6783 //
     /*  91530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91544 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  91544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91549 */   GIR_RootConstrainSelectedInstOperands,
     /*  91550 */   // GIR_Coverage, 6783,
     /*  91550 */   GIR_Done,
     /*  91551 */ // Label 1559: @91551
     /*  91551 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(91577), // Rule ID 6784 //
     /*  91556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91570 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  91570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91575 */   GIR_RootConstrainSelectedInstOperands,
     /*  91576 */   // GIR_Coverage, 6784,
     /*  91576 */   GIR_Done,
     /*  91577 */ // Label 1560: @91577
     /*  91577 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(91606), // Rule ID 6785 //
     /*  91582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91593 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91605 */   // GIR_Coverage, 6785,
     /*  91605 */   GIR_EraseRootFromParent_Done,
     /*  91606 */ // Label 1561: @91606
     /*  91606 */ GIM_Reject,
     /*  91607 */ // Label 1441: @91607
     /*  91607 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(91639), // Rule ID 6800 //
     /*  91612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91626 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91638 */   // GIR_Coverage, 6800,
     /*  91638 */   GIR_EraseRootFromParent_Done,
     /*  91639 */ // Label 1562: @91639
     /*  91639 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91671), // Rule ID 6801 //
     /*  91644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91658 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91661 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91663 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91670 */   // GIR_Coverage, 6801,
     /*  91670 */   GIR_EraseRootFromParent_Done,
     /*  91671 */ // Label 1563: @91671
     /*  91671 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91703), // Rule ID 6802 //
     /*  91676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91690 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91693 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91702 */   // GIR_Coverage, 6802,
     /*  91702 */   GIR_EraseRootFromParent_Done,
     /*  91703 */ // Label 1564: @91703
     /*  91703 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91735), // Rule ID 6803 //
     /*  91708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91722 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91725 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91727 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91734 */   // GIR_Coverage, 6803,
     /*  91734 */   GIR_EraseRootFromParent_Done,
     /*  91735 */ // Label 1565: @91735
     /*  91735 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91767), // Rule ID 6804 //
     /*  91740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91754 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91757 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91759 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91766 */   // GIR_Coverage, 6804,
     /*  91766 */   GIR_EraseRootFromParent_Done,
     /*  91767 */ // Label 1566: @91767
     /*  91767 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91799), // Rule ID 6805 //
     /*  91772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91786 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91789 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91791 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91798 */   // GIR_Coverage, 6805,
     /*  91798 */   GIR_EraseRootFromParent_Done,
     /*  91799 */ // Label 1567: @91799
     /*  91799 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91832), // Rule ID 6806 //
     /*  91804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91818 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91823 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91830 */   GIR_RootConstrainSelectedInstOperands,
     /*  91831 */   // GIR_Coverage, 6806,
     /*  91831 */   GIR_EraseRootFromParent_Done,
     /*  91832 */ // Label 1568: @91832
     /*  91832 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91858), // Rule ID 6807 //
     /*  91837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91851 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91856 */   GIR_RootConstrainSelectedInstOperands,
     /*  91857 */   // GIR_Coverage, 6807,
     /*  91857 */   GIR_Done,
     /*  91858 */ // Label 1569: @91858
     /*  91858 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91884), // Rule ID 6808 //
     /*  91863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91877 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91882 */   GIR_RootConstrainSelectedInstOperands,
     /*  91883 */   // GIR_Coverage, 6808,
     /*  91883 */   GIR_Done,
     /*  91884 */ // Label 1570: @91884
     /*  91884 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91910), // Rule ID 6809 //
     /*  91889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91903 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91908 */   GIR_RootConstrainSelectedInstOperands,
     /*  91909 */   // GIR_Coverage, 6809,
     /*  91909 */   GIR_Done,
     /*  91910 */ // Label 1571: @91910
     /*  91910 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91936), // Rule ID 6810 //
     /*  91915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91929 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91934 */   GIR_RootConstrainSelectedInstOperands,
     /*  91935 */   // GIR_Coverage, 6810,
     /*  91935 */   GIR_Done,
     /*  91936 */ // Label 1572: @91936
     /*  91936 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91962), // Rule ID 6811 //
     /*  91941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91955 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91960 */   GIR_RootConstrainSelectedInstOperands,
     /*  91961 */   // GIR_Coverage, 6811,
     /*  91961 */   GIR_Done,
     /*  91962 */ // Label 1573: @91962
     /*  91962 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91991), // Rule ID 6812 //
     /*  91967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91978 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91990 */   // GIR_Coverage, 6812,
     /*  91990 */   GIR_EraseRootFromParent_Done,
     /*  91991 */ // Label 1574: @91991
     /*  91991 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(92023), // Rule ID 6826 //
     /*  91996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92010 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92022 */   // GIR_Coverage, 6826,
     /*  92022 */   GIR_EraseRootFromParent_Done,
     /*  92023 */ // Label 1575: @92023
     /*  92023 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(92055), // Rule ID 6827 //
     /*  92028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92042 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92054 */   // GIR_Coverage, 6827,
     /*  92054 */   GIR_EraseRootFromParent_Done,
     /*  92055 */ // Label 1576: @92055
     /*  92055 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(92087), // Rule ID 6828 //
     /*  92060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92074 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92086 */   // GIR_Coverage, 6828,
     /*  92086 */   GIR_EraseRootFromParent_Done,
     /*  92087 */ // Label 1577: @92087
     /*  92087 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(92119), // Rule ID 6829 //
     /*  92092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92106 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92118 */   // GIR_Coverage, 6829,
     /*  92118 */   GIR_EraseRootFromParent_Done,
     /*  92119 */ // Label 1578: @92119
     /*  92119 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(92151), // Rule ID 6830 //
     /*  92124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92138 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92141 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92143 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92150 */   // GIR_Coverage, 6830,
     /*  92150 */   GIR_EraseRootFromParent_Done,
     /*  92151 */ // Label 1579: @92151
     /*  92151 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(92183), // Rule ID 6831 //
     /*  92156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92170 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92173 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92175 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92182 */   // GIR_Coverage, 6831,
     /*  92182 */   GIR_EraseRootFromParent_Done,
     /*  92183 */ // Label 1580: @92183
     /*  92183 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(92216), // Rule ID 6832 //
     /*  92188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92202 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  92202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92207 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92214 */   GIR_RootConstrainSelectedInstOperands,
     /*  92215 */   // GIR_Coverage, 6832,
     /*  92215 */   GIR_EraseRootFromParent_Done,
     /*  92216 */ // Label 1581: @92216
     /*  92216 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(92242), // Rule ID 6833 //
     /*  92221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92235 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  92235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92240 */   GIR_RootConstrainSelectedInstOperands,
     /*  92241 */   // GIR_Coverage, 6833,
     /*  92241 */   GIR_Done,
     /*  92242 */ // Label 1582: @92242
     /*  92242 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(92268), // Rule ID 6834 //
     /*  92247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92261 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  92261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92266 */   GIR_RootConstrainSelectedInstOperands,
     /*  92267 */   // GIR_Coverage, 6834,
     /*  92267 */   GIR_Done,
     /*  92268 */ // Label 1583: @92268
     /*  92268 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(92294), // Rule ID 6835 //
     /*  92273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92287 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  92287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  92292 */   GIR_RootConstrainSelectedInstOperands,
     /*  92293 */   // GIR_Coverage, 6835,
     /*  92293 */   GIR_Done,
     /*  92294 */ // Label 1584: @92294
     /*  92294 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(92320), // Rule ID 6836 //
     /*  92299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92313 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  92313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92318 */   GIR_RootConstrainSelectedInstOperands,
     /*  92319 */   // GIR_Coverage, 6836,
     /*  92319 */   GIR_Done,
     /*  92320 */ // Label 1585: @92320
     /*  92320 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(92346), // Rule ID 6837 //
     /*  92325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92339 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  92339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92344 */   GIR_RootConstrainSelectedInstOperands,
     /*  92345 */   // GIR_Coverage, 6837,
     /*  92345 */   GIR_Done,
     /*  92346 */ // Label 1586: @92346
     /*  92346 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(92375), // Rule ID 6838 //
     /*  92351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92362 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92365 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92367 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92374 */   // GIR_Coverage, 6838,
     /*  92374 */   GIR_EraseRootFromParent_Done,
     /*  92375 */ // Label 1587: @92375
     /*  92375 */ GIM_Reject,
     /*  92376 */ // Label 1442: @92376
     /*  92376 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(92406), // Rule ID 6650 //
     /*  92381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92395 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92405 */   // GIR_Coverage, 6650,
     /*  92405 */   GIR_Done,
     /*  92406 */ // Label 1588: @92406
     /*  92406 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(92436), // Rule ID 6652 //
     /*  92411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92425 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92435 */   // GIR_Coverage, 6652,
     /*  92435 */   GIR_Done,
     /*  92436 */ // Label 1589: @92436
     /*  92436 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(92486), // Rule ID 6661 //
     /*  92441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92455 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92467 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92484 */   GIR_RootConstrainSelectedInstOperands,
     /*  92485 */   // GIR_Coverage, 6661,
     /*  92485 */   GIR_EraseRootFromParent_Done,
     /*  92486 */ // Label 1590: @92486
     /*  92486 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(92536), // Rule ID 6663 //
     /*  92491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92505 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92521 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92534 */   GIR_RootConstrainSelectedInstOperands,
     /*  92535 */   // GIR_Coverage, 6663,
     /*  92535 */   GIR_EraseRootFromParent_Done,
     /*  92536 */ // Label 1591: @92536
     /*  92536 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(92568), // Rule ID 6709 //
     /*  92541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92555 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92567 */   // GIR_Coverage, 6709,
     /*  92567 */   GIR_EraseRootFromParent_Done,
     /*  92568 */ // Label 1592: @92568
     /*  92568 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(92600), // Rule ID 6710 //
     /*  92573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92587 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92599 */   // GIR_Coverage, 6710,
     /*  92599 */   GIR_EraseRootFromParent_Done,
     /*  92600 */ // Label 1593: @92600
     /*  92600 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(92632), // Rule ID 6711 //
     /*  92605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92619 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92622 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92624 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92631 */   // GIR_Coverage, 6711,
     /*  92631 */   GIR_EraseRootFromParent_Done,
     /*  92632 */ // Label 1594: @92632
     /*  92632 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92664), // Rule ID 6712 //
     /*  92637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92651 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92654 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92656 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92663 */   // GIR_Coverage, 6712,
     /*  92663 */   GIR_EraseRootFromParent_Done,
     /*  92664 */ // Label 1595: @92664
     /*  92664 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92696), // Rule ID 6713 //
     /*  92669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92683 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92686 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92688 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92695 */   // GIR_Coverage, 6713,
     /*  92695 */   GIR_EraseRootFromParent_Done,
     /*  92696 */ // Label 1596: @92696
     /*  92696 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92728), // Rule ID 6714 //
     /*  92701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92715 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92727 */   // GIR_Coverage, 6714,
     /*  92727 */   GIR_EraseRootFromParent_Done,
     /*  92728 */ // Label 1597: @92728
     /*  92728 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92754), // Rule ID 6715 //
     /*  92733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92747 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  92747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92752 */   GIR_RootConstrainSelectedInstOperands,
     /*  92753 */   // GIR_Coverage, 6715,
     /*  92753 */   GIR_Done,
     /*  92754 */ // Label 1598: @92754
     /*  92754 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92780), // Rule ID 6716 //
     /*  92759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92773 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92778 */   GIR_RootConstrainSelectedInstOperands,
     /*  92779 */   // GIR_Coverage, 6716,
     /*  92779 */   GIR_Done,
     /*  92780 */ // Label 1599: @92780
     /*  92780 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92806), // Rule ID 6717 //
     /*  92785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92799 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92804 */   GIR_RootConstrainSelectedInstOperands,
     /*  92805 */   // GIR_Coverage, 6717,
     /*  92805 */   GIR_Done,
     /*  92806 */ // Label 1600: @92806
     /*  92806 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92832), // Rule ID 6718 //
     /*  92811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92825 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92830 */   GIR_RootConstrainSelectedInstOperands,
     /*  92831 */   // GIR_Coverage, 6718,
     /*  92831 */   GIR_Done,
     /*  92832 */ // Label 1601: @92832
     /*  92832 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92858), // Rule ID 6719 //
     /*  92837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92851 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92856 */   GIR_RootConstrainSelectedInstOperands,
     /*  92857 */   // GIR_Coverage, 6719,
     /*  92857 */   GIR_Done,
     /*  92858 */ // Label 1602: @92858
     /*  92858 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92884), // Rule ID 6720 //
     /*  92863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92877 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92882 */   GIR_RootConstrainSelectedInstOperands,
     /*  92883 */   // GIR_Coverage, 6720,
     /*  92883 */   GIR_Done,
     /*  92884 */ // Label 1603: @92884
     /*  92884 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92913), // Rule ID 6721 //
     /*  92889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92900 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92912 */   // GIR_Coverage, 6721,
     /*  92912 */   GIR_EraseRootFromParent_Done,
     /*  92913 */ // Label 1604: @92913
     /*  92913 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92945), // Rule ID 6722 //
     /*  92918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92932 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92944 */   // GIR_Coverage, 6722,
     /*  92944 */   GIR_EraseRootFromParent_Done,
     /*  92945 */ // Label 1605: @92945
     /*  92945 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92977), // Rule ID 6723 //
     /*  92950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92964 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92976 */   // GIR_Coverage, 6723,
     /*  92976 */   GIR_EraseRootFromParent_Done,
     /*  92977 */ // Label 1606: @92977
     /*  92977 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(93009), // Rule ID 6724 //
     /*  92982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92996 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93008 */   // GIR_Coverage, 6724,
     /*  93008 */   GIR_EraseRootFromParent_Done,
     /*  93009 */ // Label 1607: @93009
     /*  93009 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(93041), // Rule ID 6725 //
     /*  93014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93028 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93031 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93033 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93035 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93040 */   // GIR_Coverage, 6725,
     /*  93040 */   GIR_EraseRootFromParent_Done,
     /*  93041 */ // Label 1608: @93041
     /*  93041 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(93073), // Rule ID 6726 //
     /*  93046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93060 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93072 */   // GIR_Coverage, 6726,
     /*  93072 */   GIR_EraseRootFromParent_Done,
     /*  93073 */ // Label 1609: @93073
     /*  93073 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(93105), // Rule ID 6727 //
     /*  93078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93092 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93104 */   // GIR_Coverage, 6727,
     /*  93104 */   GIR_EraseRootFromParent_Done,
     /*  93105 */ // Label 1610: @93105
     /*  93105 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(93131), // Rule ID 6728 //
     /*  93110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93124 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  93124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93129 */   GIR_RootConstrainSelectedInstOperands,
     /*  93130 */   // GIR_Coverage, 6728,
     /*  93130 */   GIR_Done,
     /*  93131 */ // Label 1611: @93131
     /*  93131 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(93157), // Rule ID 6729 //
     /*  93136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93150 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  93150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93155 */   GIR_RootConstrainSelectedInstOperands,
     /*  93156 */   // GIR_Coverage, 6729,
     /*  93156 */   GIR_Done,
     /*  93157 */ // Label 1612: @93157
     /*  93157 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(93183), // Rule ID 6730 //
     /*  93162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  93168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93176 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  93176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93181 */   GIR_RootConstrainSelectedInstOperands,
     /*  93182 */   // GIR_Coverage, 6730,
     /*  93182 */   GIR_Done,
     /*  93183 */ // Label 1613: @93183
     /*  93183 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(93209), // Rule ID 6731 //
     /*  93188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93202 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  93202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93207 */   GIR_RootConstrainSelectedInstOperands,
     /*  93208 */   // GIR_Coverage, 6731,
     /*  93208 */   GIR_Done,
     /*  93209 */ // Label 1614: @93209
     /*  93209 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(93235), // Rule ID 6732 //
     /*  93214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93228 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  93228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93233 */   GIR_RootConstrainSelectedInstOperands,
     /*  93234 */   // GIR_Coverage, 6732,
     /*  93234 */   GIR_Done,
     /*  93235 */ // Label 1615: @93235
     /*  93235 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(93261), // Rule ID 6733 //
     /*  93240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93254 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  93254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93259 */   GIR_RootConstrainSelectedInstOperands,
     /*  93260 */   // GIR_Coverage, 6733,
     /*  93260 */   GIR_Done,
     /*  93261 */ // Label 1616: @93261
     /*  93261 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(93290), // Rule ID 6734 //
     /*  93266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93277 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93280 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93282 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93289 */   // GIR_Coverage, 6734,
     /*  93289 */   GIR_EraseRootFromParent_Done,
     /*  93290 */ // Label 1617: @93290
     /*  93290 */ GIM_Reject,
     /*  93291 */ // Label 1443: @93291
     /*  93291 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(93323), // Rule ID 6813 //
     /*  93296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93310 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93322 */   // GIR_Coverage, 6813,
     /*  93322 */   GIR_EraseRootFromParent_Done,
     /*  93323 */ // Label 1618: @93323
     /*  93323 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(93355), // Rule ID 6814 //
     /*  93328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93342 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93345 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93347 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93354 */   // GIR_Coverage, 6814,
     /*  93354 */   GIR_EraseRootFromParent_Done,
     /*  93355 */ // Label 1619: @93355
     /*  93355 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(93387), // Rule ID 6815 //
     /*  93360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93374 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93377 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93379 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93386 */   // GIR_Coverage, 6815,
     /*  93386 */   GIR_EraseRootFromParent_Done,
     /*  93387 */ // Label 1620: @93387
     /*  93387 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(93419), // Rule ID 6816 //
     /*  93392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93406 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93409 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93418 */   // GIR_Coverage, 6816,
     /*  93418 */   GIR_EraseRootFromParent_Done,
     /*  93419 */ // Label 1621: @93419
     /*  93419 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(93451), // Rule ID 6817 //
     /*  93424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93438 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93441 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93443 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93450 */   // GIR_Coverage, 6817,
     /*  93450 */   GIR_EraseRootFromParent_Done,
     /*  93451 */ // Label 1622: @93451
     /*  93451 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(93483), // Rule ID 6818 //
     /*  93456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93470 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93473 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93482 */   // GIR_Coverage, 6818,
     /*  93482 */   GIR_EraseRootFromParent_Done,
     /*  93483 */ // Label 1623: @93483
     /*  93483 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(93554), // Rule ID 6819 //
     /*  93488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93502 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93502 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93505 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93509 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93514 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93532 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93552 */   GIR_RootConstrainSelectedInstOperands,
     /*  93553 */   // GIR_Coverage, 6819,
     /*  93553 */   GIR_EraseRootFromParent_Done,
     /*  93554 */ // Label 1624: @93554
     /*  93554 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(93580), // Rule ID 6820 //
     /*  93559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93573 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  93573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93578 */   GIR_RootConstrainSelectedInstOperands,
     /*  93579 */   // GIR_Coverage, 6820,
     /*  93579 */   GIR_Done,
     /*  93580 */ // Label 1625: @93580
     /*  93580 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(93606), // Rule ID 6821 //
     /*  93585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93599 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  93599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93604 */   GIR_RootConstrainSelectedInstOperands,
     /*  93605 */   // GIR_Coverage, 6821,
     /*  93605 */   GIR_Done,
     /*  93606 */ // Label 1626: @93606
     /*  93606 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(93632), // Rule ID 6822 //
     /*  93611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93625 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  93625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93630 */   GIR_RootConstrainSelectedInstOperands,
     /*  93631 */   // GIR_Coverage, 6822,
     /*  93631 */   GIR_Done,
     /*  93632 */ // Label 1627: @93632
     /*  93632 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(93658), // Rule ID 6823 //
     /*  93637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93651 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  93651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93656 */   GIR_RootConstrainSelectedInstOperands,
     /*  93657 */   // GIR_Coverage, 6823,
     /*  93657 */   GIR_Done,
     /*  93658 */ // Label 1628: @93658
     /*  93658 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93684), // Rule ID 6824 //
     /*  93663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93677 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  93677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93682 */   GIR_RootConstrainSelectedInstOperands,
     /*  93683 */   // GIR_Coverage, 6824,
     /*  93683 */   GIR_Done,
     /*  93684 */ // Label 1629: @93684
     /*  93684 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93713), // Rule ID 6825 //
     /*  93689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93700 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93712 */   // GIR_Coverage, 6825,
     /*  93712 */   GIR_EraseRootFromParent_Done,
     /*  93713 */ // Label 1630: @93713
     /*  93713 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93745), // Rule ID 6839 //
     /*  93718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93732 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93744 */   // GIR_Coverage, 6839,
     /*  93744 */   GIR_EraseRootFromParent_Done,
     /*  93745 */ // Label 1631: @93745
     /*  93745 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93777), // Rule ID 6840 //
     /*  93750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93764 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93767 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93769 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93776 */   // GIR_Coverage, 6840,
     /*  93776 */   GIR_EraseRootFromParent_Done,
     /*  93777 */ // Label 1632: @93777
     /*  93777 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93809), // Rule ID 6841 //
     /*  93782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93796 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93799 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93808 */   // GIR_Coverage, 6841,
     /*  93808 */   GIR_EraseRootFromParent_Done,
     /*  93809 */ // Label 1633: @93809
     /*  93809 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93841), // Rule ID 6842 //
     /*  93814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93828 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93840 */   // GIR_Coverage, 6842,
     /*  93840 */   GIR_EraseRootFromParent_Done,
     /*  93841 */ // Label 1634: @93841
     /*  93841 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93873), // Rule ID 6843 //
     /*  93846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93860 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93872 */   // GIR_Coverage, 6843,
     /*  93872 */   GIR_EraseRootFromParent_Done,
     /*  93873 */ // Label 1635: @93873
     /*  93873 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93905), // Rule ID 6844 //
     /*  93878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93892 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93895 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93897 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93904 */   // GIR_Coverage, 6844,
     /*  93904 */   GIR_EraseRootFromParent_Done,
     /*  93905 */ // Label 1636: @93905
     /*  93905 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93976), // Rule ID 6845 //
     /*  93910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93924 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93924 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93927 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93931 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93936 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93954 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93974 */   GIR_RootConstrainSelectedInstOperands,
     /*  93975 */   // GIR_Coverage, 6845,
     /*  93975 */   GIR_EraseRootFromParent_Done,
     /*  93976 */ // Label 1637: @93976
     /*  93976 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(94002), // Rule ID 6846 //
     /*  93981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93995 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  94000 */   GIR_RootConstrainSelectedInstOperands,
     /*  94001 */   // GIR_Coverage, 6846,
     /*  94001 */   GIR_Done,
     /*  94002 */ // Label 1638: @94002
     /*  94002 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(94028), // Rule ID 6847 //
     /*  94007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94021 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  94021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94026 */   GIR_RootConstrainSelectedInstOperands,
     /*  94027 */   // GIR_Coverage, 6847,
     /*  94027 */   GIR_Done,
     /*  94028 */ // Label 1639: @94028
     /*  94028 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(94054), // Rule ID 6848 //
     /*  94033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94047 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  94047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  94052 */   GIR_RootConstrainSelectedInstOperands,
     /*  94053 */   // GIR_Coverage, 6848,
     /*  94053 */   GIR_Done,
     /*  94054 */ // Label 1640: @94054
     /*  94054 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(94080), // Rule ID 6849 //
     /*  94059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94073 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  94073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  94078 */   GIR_RootConstrainSelectedInstOperands,
     /*  94079 */   // GIR_Coverage, 6849,
     /*  94079 */   GIR_Done,
     /*  94080 */ // Label 1641: @94080
     /*  94080 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(94106), // Rule ID 6850 //
     /*  94085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94099 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  94099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94104 */   GIR_RootConstrainSelectedInstOperands,
     /*  94105 */   // GIR_Coverage, 6850,
     /*  94105 */   GIR_Done,
     /*  94106 */ // Label 1642: @94106
     /*  94106 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(94135), // Rule ID 6851 //
     /*  94111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94122 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  94122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94134 */   // GIR_Coverage, 6851,
     /*  94134 */   GIR_EraseRootFromParent_Done,
     /*  94135 */ // Label 1643: @94135
     /*  94135 */ GIM_Reject,
     /*  94136 */ // Label 1444: @94136
     /*  94136 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(94210), // Rule ID 5668 //
     /*  94141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  94156 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  94160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94167 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  94167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  94174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94179 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  94183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  94188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  94199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94209 */   // GIR_Coverage, 5668,
     /*  94209 */   GIR_EraseRootFromParent_Done,
     /*  94210 */ // Label 1644: @94210
     /*  94210 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(94240), // Rule ID 6649 //
     /*  94215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94229 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  94229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94239 */   // GIR_Coverage, 6649,
     /*  94239 */   GIR_Done,
     /*  94240 */ // Label 1645: @94240
     /*  94240 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(94290), // Rule ID 6660 //
     /*  94245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94259 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  94259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94271 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  94275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94288 */   GIR_RootConstrainSelectedInstOperands,
     /*  94289 */   // GIR_Coverage, 6660,
     /*  94289 */   GIR_EraseRootFromParent_Done,
     /*  94290 */ // Label 1646: @94290
     /*  94290 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(94322), // Rule ID 6735 //
     /*  94295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94309 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94312 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94314 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94321 */   // GIR_Coverage, 6735,
     /*  94321 */   GIR_EraseRootFromParent_Done,
     /*  94322 */ // Label 1647: @94322
     /*  94322 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(94354), // Rule ID 6736 //
     /*  94327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94341 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94344 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94346 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94353 */   // GIR_Coverage, 6736,
     /*  94353 */   GIR_EraseRootFromParent_Done,
     /*  94354 */ // Label 1648: @94354
     /*  94354 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(94386), // Rule ID 6737 //
     /*  94359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94373 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94376 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94378 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94385 */   // GIR_Coverage, 6737,
     /*  94385 */   GIR_EraseRootFromParent_Done,
     /*  94386 */ // Label 1649: @94386
     /*  94386 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(94418), // Rule ID 6738 //
     /*  94391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94405 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94408 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94410 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94417 */   // GIR_Coverage, 6738,
     /*  94417 */   GIR_EraseRootFromParent_Done,
     /*  94418 */ // Label 1650: @94418
     /*  94418 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(94450), // Rule ID 6739 //
     /*  94423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94437 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94440 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94442 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94449 */   // GIR_Coverage, 6739,
     /*  94449 */   GIR_EraseRootFromParent_Done,
     /*  94450 */ // Label 1651: @94450
     /*  94450 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(94482), // Rule ID 6740 //
     /*  94455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94469 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94472 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94474 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94481 */   // GIR_Coverage, 6740,
     /*  94481 */   GIR_EraseRootFromParent_Done,
     /*  94482 */ // Label 1652: @94482
     /*  94482 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(94514), // Rule ID 6741 //
     /*  94487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94501 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94504 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94506 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94513 */   // GIR_Coverage, 6741,
     /*  94513 */   GIR_EraseRootFromParent_Done,
     /*  94514 */ // Label 1653: @94514
     /*  94514 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(94540), // Rule ID 6742 //
     /*  94519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94533 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  94533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94538 */   GIR_RootConstrainSelectedInstOperands,
     /*  94539 */   // GIR_Coverage, 6742,
     /*  94539 */   GIR_Done,
     /*  94540 */ // Label 1654: @94540
     /*  94540 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(94566), // Rule ID 6743 //
     /*  94545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94559 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  94559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94564 */   GIR_RootConstrainSelectedInstOperands,
     /*  94565 */   // GIR_Coverage, 6743,
     /*  94565 */   GIR_Done,
     /*  94566 */ // Label 1655: @94566
     /*  94566 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(94592), // Rule ID 6744 //
     /*  94571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94585 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  94585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94590 */   GIR_RootConstrainSelectedInstOperands,
     /*  94591 */   // GIR_Coverage, 6744,
     /*  94591 */   GIR_Done,
     /*  94592 */ // Label 1656: @94592
     /*  94592 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(94618), // Rule ID 6745 //
     /*  94597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94611 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  94611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94616 */   GIR_RootConstrainSelectedInstOperands,
     /*  94617 */   // GIR_Coverage, 6745,
     /*  94617 */   GIR_Done,
     /*  94618 */ // Label 1657: @94618
     /*  94618 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(94644), // Rule ID 6746 //
     /*  94623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94637 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  94637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94642 */   GIR_RootConstrainSelectedInstOperands,
     /*  94643 */   // GIR_Coverage, 6746,
     /*  94643 */   GIR_Done,
     /*  94644 */ // Label 1658: @94644
     /*  94644 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94670), // Rule ID 6747 //
     /*  94649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94663 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  94663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94668 */   GIR_RootConstrainSelectedInstOperands,
     /*  94669 */   // GIR_Coverage, 6747,
     /*  94669 */   GIR_Done,
     /*  94670 */ // Label 1659: @94670
     /*  94670 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94696), // Rule ID 6748 //
     /*  94675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94689 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  94689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94694 */   GIR_RootConstrainSelectedInstOperands,
     /*  94695 */   // GIR_Coverage, 6748,
     /*  94695 */   GIR_Done,
     /*  94696 */ // Label 1660: @94696
     /*  94696 */ GIM_Reject,
     /*  94697 */ // Label 1445: @94697
     /*  94697 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94729), // Rule ID 6852 //
     /*  94702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94716 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94728 */   // GIR_Coverage, 6852,
     /*  94728 */   GIR_EraseRootFromParent_Done,
     /*  94729 */ // Label 1661: @94729
     /*  94729 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94761), // Rule ID 6853 //
     /*  94734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94748 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94760 */   // GIR_Coverage, 6853,
     /*  94760 */   GIR_EraseRootFromParent_Done,
     /*  94761 */ // Label 1662: @94761
     /*  94761 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94793), // Rule ID 6854 //
     /*  94766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94780 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94792 */   // GIR_Coverage, 6854,
     /*  94792 */   GIR_EraseRootFromParent_Done,
     /*  94793 */ // Label 1663: @94793
     /*  94793 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94825), // Rule ID 6855 //
     /*  94798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94812 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94824 */   // GIR_Coverage, 6855,
     /*  94824 */   GIR_EraseRootFromParent_Done,
     /*  94825 */ // Label 1664: @94825
     /*  94825 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94857), // Rule ID 6856 //
     /*  94830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94844 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94856 */   // GIR_Coverage, 6856,
     /*  94856 */   GIR_EraseRootFromParent_Done,
     /*  94857 */ // Label 1665: @94857
     /*  94857 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94889), // Rule ID 6857 //
     /*  94862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94876 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94888 */   // GIR_Coverage, 6857,
     /*  94888 */   GIR_EraseRootFromParent_Done,
     /*  94889 */ // Label 1666: @94889
     /*  94889 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94960), // Rule ID 6858 //
     /*  94894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94908 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94908 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94911 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94915 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94920 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94938 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94958 */   GIR_RootConstrainSelectedInstOperands,
     /*  94959 */   // GIR_Coverage, 6858,
     /*  94959 */   GIR_EraseRootFromParent_Done,
     /*  94960 */ // Label 1667: @94960
     /*  94960 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94986), // Rule ID 6859 //
     /*  94965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94979 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94984 */   GIR_RootConstrainSelectedInstOperands,
     /*  94985 */   // GIR_Coverage, 6859,
     /*  94985 */   GIR_Done,
     /*  94986 */ // Label 1668: @94986
     /*  94986 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(95012), // Rule ID 6860 //
     /*  94991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95005 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  95005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95010 */   GIR_RootConstrainSelectedInstOperands,
     /*  95011 */   // GIR_Coverage, 6860,
     /*  95011 */   GIR_Done,
     /*  95012 */ // Label 1669: @95012
     /*  95012 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(95038), // Rule ID 6861 //
     /*  95017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95031 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  95031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95036 */   GIR_RootConstrainSelectedInstOperands,
     /*  95037 */   // GIR_Coverage, 6861,
     /*  95037 */   GIR_Done,
     /*  95038 */ // Label 1670: @95038
     /*  95038 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(95064), // Rule ID 6862 //
     /*  95043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95057 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  95057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95062 */   GIR_RootConstrainSelectedInstOperands,
     /*  95063 */   // GIR_Coverage, 6862,
     /*  95063 */   GIR_Done,
     /*  95064 */ // Label 1671: @95064
     /*  95064 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(95090), // Rule ID 6863 //
     /*  95069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95083 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  95083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95088 */   GIR_RootConstrainSelectedInstOperands,
     /*  95089 */   // GIR_Coverage, 6863,
     /*  95089 */   GIR_Done,
     /*  95090 */ // Label 1672: @95090
     /*  95090 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(95119), // Rule ID 6864 //
     /*  95095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95106 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  95106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95118 */   // GIR_Coverage, 6864,
     /*  95118 */   GIR_EraseRootFromParent_Done,
     /*  95119 */ // Label 1673: @95119
     /*  95119 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(95151), // Rule ID 6865 //
     /*  95124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95138 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95141 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95143 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95150 */   // GIR_Coverage, 6865,
     /*  95150 */   GIR_EraseRootFromParent_Done,
     /*  95151 */ // Label 1674: @95151
     /*  95151 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(95183), // Rule ID 6866 //
     /*  95156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95170 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95173 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95175 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95182 */   // GIR_Coverage, 6866,
     /*  95182 */   GIR_EraseRootFromParent_Done,
     /*  95183 */ // Label 1675: @95183
     /*  95183 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(95215), // Rule ID 6867 //
     /*  95188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95202 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95205 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95207 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95209 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95214 */   // GIR_Coverage, 6867,
     /*  95214 */   GIR_EraseRootFromParent_Done,
     /*  95215 */ // Label 1676: @95215
     /*  95215 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(95247), // Rule ID 6868 //
     /*  95220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95234 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95237 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95239 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95246 */   // GIR_Coverage, 6868,
     /*  95246 */   GIR_EraseRootFromParent_Done,
     /*  95247 */ // Label 1677: @95247
     /*  95247 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(95279), // Rule ID 6869 //
     /*  95252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95266 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95269 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95271 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95278 */   // GIR_Coverage, 6869,
     /*  95278 */   GIR_EraseRootFromParent_Done,
     /*  95279 */ // Label 1678: @95279
     /*  95279 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(95311), // Rule ID 6870 //
     /*  95284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95298 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95301 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95303 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95310 */   // GIR_Coverage, 6870,
     /*  95310 */   GIR_EraseRootFromParent_Done,
     /*  95311 */ // Label 1679: @95311
     /*  95311 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(95382), // Rule ID 6871 //
     /*  95316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95330 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95330 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95333 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95337 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95342 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95380 */   GIR_RootConstrainSelectedInstOperands,
     /*  95381 */   // GIR_Coverage, 6871,
     /*  95381 */   GIR_EraseRootFromParent_Done,
     /*  95382 */ // Label 1680: @95382
     /*  95382 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(95408), // Rule ID 6872 //
     /*  95387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95401 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  95401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95406 */   GIR_RootConstrainSelectedInstOperands,
     /*  95407 */   // GIR_Coverage, 6872,
     /*  95407 */   GIR_Done,
     /*  95408 */ // Label 1681: @95408
     /*  95408 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(95434), // Rule ID 6873 //
     /*  95413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95427 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  95427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95432 */   GIR_RootConstrainSelectedInstOperands,
     /*  95433 */   // GIR_Coverage, 6873,
     /*  95433 */   GIR_Done,
     /*  95434 */ // Label 1682: @95434
     /*  95434 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(95460), // Rule ID 6874 //
     /*  95439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95453 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  95453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95458 */   GIR_RootConstrainSelectedInstOperands,
     /*  95459 */   // GIR_Coverage, 6874,
     /*  95459 */   GIR_Done,
     /*  95460 */ // Label 1683: @95460
     /*  95460 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(95486), // Rule ID 6875 //
     /*  95465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95479 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  95479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95484 */   GIR_RootConstrainSelectedInstOperands,
     /*  95485 */   // GIR_Coverage, 6875,
     /*  95485 */   GIR_Done,
     /*  95486 */ // Label 1684: @95486
     /*  95486 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(95512), // Rule ID 6876 //
     /*  95491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95505 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  95505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95510 */   GIR_RootConstrainSelectedInstOperands,
     /*  95511 */   // GIR_Coverage, 6876,
     /*  95511 */   GIR_Done,
     /*  95512 */ // Label 1685: @95512
     /*  95512 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(95541), // Rule ID 6877 //
     /*  95517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95528 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95540 */   // GIR_Coverage, 6877,
     /*  95540 */   GIR_EraseRootFromParent_Done,
     /*  95541 */ // Label 1686: @95541
     /*  95541 */ GIM_Reject,
     /*  95542 */ // Label 1446: @95542
     /*  95542 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(95574), // Rule ID 6878 //
     /*  95547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95561 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95573 */   // GIR_Coverage, 6878,
     /*  95573 */   GIR_EraseRootFromParent_Done,
     /*  95574 */ // Label 1687: @95574
     /*  95574 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(95606), // Rule ID 6879 //
     /*  95579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95593 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95605 */   // GIR_Coverage, 6879,
     /*  95605 */   GIR_EraseRootFromParent_Done,
     /*  95606 */ // Label 1688: @95606
     /*  95606 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(95638), // Rule ID 6880 //
     /*  95611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95625 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95637 */   // GIR_Coverage, 6880,
     /*  95637 */   GIR_EraseRootFromParent_Done,
     /*  95638 */ // Label 1689: @95638
     /*  95638 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95670), // Rule ID 6881 //
     /*  95643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95657 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95669 */   // GIR_Coverage, 6881,
     /*  95669 */   GIR_EraseRootFromParent_Done,
     /*  95670 */ // Label 1690: @95670
     /*  95670 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95702), // Rule ID 6882 //
     /*  95675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95689 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95701 */   // GIR_Coverage, 6882,
     /*  95701 */   GIR_EraseRootFromParent_Done,
     /*  95702 */ // Label 1691: @95702
     /*  95702 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95734), // Rule ID 6883 //
     /*  95707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95721 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95733 */   // GIR_Coverage, 6883,
     /*  95733 */   GIR_EraseRootFromParent_Done,
     /*  95734 */ // Label 1692: @95734
     /*  95734 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95766), // Rule ID 6884 //
     /*  95739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95753 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95765 */   // GIR_Coverage, 6884,
     /*  95765 */   GIR_EraseRootFromParent_Done,
     /*  95766 */ // Label 1693: @95766
     /*  95766 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95837), // Rule ID 6885 //
     /*  95771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95785 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95835 */   GIR_RootConstrainSelectedInstOperands,
     /*  95836 */   // GIR_Coverage, 6885,
     /*  95836 */   GIR_EraseRootFromParent_Done,
     /*  95837 */ // Label 1694: @95837
     /*  95837 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95863), // Rule ID 6886 //
     /*  95842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95856 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95861 */   GIR_RootConstrainSelectedInstOperands,
     /*  95862 */   // GIR_Coverage, 6886,
     /*  95862 */   GIR_Done,
     /*  95863 */ // Label 1695: @95863
     /*  95863 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95889), // Rule ID 6887 //
     /*  95868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95882 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95887 */   GIR_RootConstrainSelectedInstOperands,
     /*  95888 */   // GIR_Coverage, 6887,
     /*  95888 */   GIR_Done,
     /*  95889 */ // Label 1696: @95889
     /*  95889 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95915), // Rule ID 6888 //
     /*  95894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95908 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95913 */   GIR_RootConstrainSelectedInstOperands,
     /*  95914 */   // GIR_Coverage, 6888,
     /*  95914 */   GIR_Done,
     /*  95915 */ // Label 1697: @95915
     /*  95915 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95941), // Rule ID 6889 //
     /*  95920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95934 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95939 */   GIR_RootConstrainSelectedInstOperands,
     /*  95940 */   // GIR_Coverage, 6889,
     /*  95940 */   GIR_Done,
     /*  95941 */ // Label 1698: @95941
     /*  95941 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95967), // Rule ID 6890 //
     /*  95946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95960 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95965 */   GIR_RootConstrainSelectedInstOperands,
     /*  95966 */   // GIR_Coverage, 6890,
     /*  95966 */   GIR_Done,
     /*  95967 */ // Label 1699: @95967
     /*  95967 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95993), // Rule ID 6891 //
     /*  95972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95986 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95991 */   GIR_RootConstrainSelectedInstOperands,
     /*  95992 */   // GIR_Coverage, 6891,
     /*  95992 */   GIR_Done,
     /*  95993 */ // Label 1700: @95993
     /*  95993 */ GIM_Reject,
     /*  95994 */ // Label 1447: @95994
     /*  95994 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(96026), // Rule ID 10592 //
     /*  95999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96013 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96025 */   // GIR_Coverage, 10592,
     /*  96025 */   GIR_EraseRootFromParent_Done,
     /*  96026 */ // Label 1701: @96026
     /*  96026 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(96058), // Rule ID 10593 //
     /*  96031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96045 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96057 */   // GIR_Coverage, 10593,
     /*  96057 */   GIR_EraseRootFromParent_Done,
     /*  96058 */ // Label 1702: @96058
     /*  96058 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(96090), // Rule ID 10594 //
     /*  96063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96077 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96080 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96089 */   // GIR_Coverage, 10594,
     /*  96089 */   GIR_EraseRootFromParent_Done,
     /*  96090 */ // Label 1703: @96090
     /*  96090 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(96122), // Rule ID 10595 //
     /*  96095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96109 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96112 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96114 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96121 */   // GIR_Coverage, 10595,
     /*  96121 */   GIR_EraseRootFromParent_Done,
     /*  96122 */ // Label 1704: @96122
     /*  96122 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(96154), // Rule ID 10596 //
     /*  96127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96141 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96144 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96146 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96153 */   // GIR_Coverage, 10596,
     /*  96153 */   GIR_EraseRootFromParent_Done,
     /*  96154 */ // Label 1705: @96154
     /*  96154 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(96186), // Rule ID 10597 //
     /*  96159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96173 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96176 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96178 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96180 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96185 */   // GIR_Coverage, 10597,
     /*  96185 */   GIR_EraseRootFromParent_Done,
     /*  96186 */ // Label 1706: @96186
     /*  96186 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(96218), // Rule ID 10610 //
     /*  96191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96205 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96208 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96210 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96217 */   // GIR_Coverage, 10610,
     /*  96217 */   GIR_EraseRootFromParent_Done,
     /*  96218 */ // Label 1707: @96218
     /*  96218 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(96250), // Rule ID 10611 //
     /*  96223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96237 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96240 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96249 */   // GIR_Coverage, 10611,
     /*  96249 */   GIR_EraseRootFromParent_Done,
     /*  96250 */ // Label 1708: @96250
     /*  96250 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(96282), // Rule ID 10612 //
     /*  96255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96269 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96272 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96274 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96281 */   // GIR_Coverage, 10612,
     /*  96281 */   GIR_EraseRootFromParent_Done,
     /*  96282 */ // Label 1709: @96282
     /*  96282 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(96314), // Rule ID 10613 //
     /*  96287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96301 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96304 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96313 */   // GIR_Coverage, 10613,
     /*  96313 */   GIR_EraseRootFromParent_Done,
     /*  96314 */ // Label 1710: @96314
     /*  96314 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(96346), // Rule ID 10614 //
     /*  96319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96333 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96336 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96338 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96340 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96345 */   // GIR_Coverage, 10614,
     /*  96345 */   GIR_EraseRootFromParent_Done,
     /*  96346 */ // Label 1711: @96346
     /*  96346 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(96378), // Rule ID 10615 //
     /*  96351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96365 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96368 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96370 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96372 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96377 */   // GIR_Coverage, 10615,
     /*  96377 */   GIR_EraseRootFromParent_Done,
     /*  96378 */ // Label 1712: @96378
     /*  96378 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(96410), // Rule ID 10620 //
     /*  96383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96397 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96400 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96402 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96409 */   // GIR_Coverage, 10620,
     /*  96409 */   GIR_EraseRootFromParent_Done,
     /*  96410 */ // Label 1713: @96410
     /*  96410 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(96442), // Rule ID 10621 //
     /*  96415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96429 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96432 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96434 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96441 */   // GIR_Coverage, 10621,
     /*  96441 */   GIR_EraseRootFromParent_Done,
     /*  96442 */ // Label 1714: @96442
     /*  96442 */ GIM_Reject,
     /*  96443 */ // Label 1448: @96443
     /*  96443 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(96475), // Rule ID 10586 //
     /*  96448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96462 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96474 */   // GIR_Coverage, 10586,
     /*  96474 */   GIR_EraseRootFromParent_Done,
     /*  96475 */ // Label 1715: @96475
     /*  96475 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(96507), // Rule ID 10587 //
     /*  96480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96494 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96497 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96499 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96506 */   // GIR_Coverage, 10587,
     /*  96506 */   GIR_EraseRootFromParent_Done,
     /*  96507 */ // Label 1716: @96507
     /*  96507 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(96539), // Rule ID 10588 //
     /*  96512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96526 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96538 */   // GIR_Coverage, 10588,
     /*  96538 */   GIR_EraseRootFromParent_Done,
     /*  96539 */ // Label 1717: @96539
     /*  96539 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(96571), // Rule ID 10589 //
     /*  96544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96558 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96570 */   // GIR_Coverage, 10589,
     /*  96570 */   GIR_EraseRootFromParent_Done,
     /*  96571 */ // Label 1718: @96571
     /*  96571 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(96603), // Rule ID 10590 //
     /*  96576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96590 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96602 */   // GIR_Coverage, 10590,
     /*  96602 */   GIR_EraseRootFromParent_Done,
     /*  96603 */ // Label 1719: @96603
     /*  96603 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(96635), // Rule ID 10591 //
     /*  96608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96622 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96625 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96634 */   // GIR_Coverage, 10591,
     /*  96634 */   GIR_EraseRootFromParent_Done,
     /*  96635 */ // Label 1720: @96635
     /*  96635 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96667), // Rule ID 10604 //
     /*  96640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96654 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96657 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96666 */   // GIR_Coverage, 10604,
     /*  96666 */   GIR_EraseRootFromParent_Done,
     /*  96667 */ // Label 1721: @96667
     /*  96667 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96699), // Rule ID 10605 //
     /*  96672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96686 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96698 */   // GIR_Coverage, 10605,
     /*  96698 */   GIR_EraseRootFromParent_Done,
     /*  96699 */ // Label 1722: @96699
     /*  96699 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96731), // Rule ID 10606 //
     /*  96704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96718 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96721 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96723 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96730 */   // GIR_Coverage, 10606,
     /*  96730 */   GIR_EraseRootFromParent_Done,
     /*  96731 */ // Label 1723: @96731
     /*  96731 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96763), // Rule ID 10607 //
     /*  96736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96750 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96753 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96755 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96762 */   // GIR_Coverage, 10607,
     /*  96762 */   GIR_EraseRootFromParent_Done,
     /*  96763 */ // Label 1724: @96763
     /*  96763 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96795), // Rule ID 10608 //
     /*  96768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96782 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96794 */   // GIR_Coverage, 10608,
     /*  96794 */   GIR_EraseRootFromParent_Done,
     /*  96795 */ // Label 1725: @96795
     /*  96795 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96827), // Rule ID 10609 //
     /*  96800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96814 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96826 */   // GIR_Coverage, 10609,
     /*  96826 */   GIR_EraseRootFromParent_Done,
     /*  96827 */ // Label 1726: @96827
     /*  96827 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96859), // Rule ID 10618 //
     /*  96832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96846 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96858 */   // GIR_Coverage, 10618,
     /*  96858 */   GIR_EraseRootFromParent_Done,
     /*  96859 */ // Label 1727: @96859
     /*  96859 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96891), // Rule ID 10619 //
     /*  96864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96878 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96881 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96890 */   // GIR_Coverage, 10619,
     /*  96890 */   GIR_EraseRootFromParent_Done,
     /*  96891 */ // Label 1728: @96891
     /*  96891 */ GIM_Reject,
     /*  96892 */ // Label 1449: @96892
     /*  96892 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96924), // Rule ID 10580 //
     /*  96897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96911 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96914 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96916 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96923 */   // GIR_Coverage, 10580,
     /*  96923 */   GIR_EraseRootFromParent_Done,
     /*  96924 */ // Label 1729: @96924
     /*  96924 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96956), // Rule ID 10581 //
     /*  96929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96943 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96946 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96948 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96955 */   // GIR_Coverage, 10581,
     /*  96955 */   GIR_EraseRootFromParent_Done,
     /*  96956 */ // Label 1730: @96956
     /*  96956 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96988), // Rule ID 10582 //
     /*  96961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96975 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96987 */   // GIR_Coverage, 10582,
     /*  96987 */   GIR_EraseRootFromParent_Done,
     /*  96988 */ // Label 1731: @96988
     /*  96988 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(97020), // Rule ID 10583 //
     /*  96993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97007 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97019 */   // GIR_Coverage, 10583,
     /*  97019 */   GIR_EraseRootFromParent_Done,
     /*  97020 */ // Label 1732: @97020
     /*  97020 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(97052), // Rule ID 10584 //
     /*  97025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97039 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97051 */   // GIR_Coverage, 10584,
     /*  97051 */   GIR_EraseRootFromParent_Done,
     /*  97052 */ // Label 1733: @97052
     /*  97052 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(97084), // Rule ID 10585 //
     /*  97057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97071 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97083 */   // GIR_Coverage, 10585,
     /*  97083 */   GIR_EraseRootFromParent_Done,
     /*  97084 */ // Label 1734: @97084
     /*  97084 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(97116), // Rule ID 10598 //
     /*  97089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97103 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97115 */   // GIR_Coverage, 10598,
     /*  97115 */   GIR_EraseRootFromParent_Done,
     /*  97116 */ // Label 1735: @97116
     /*  97116 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(97148), // Rule ID 10599 //
     /*  97121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97135 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97147 */   // GIR_Coverage, 10599,
     /*  97147 */   GIR_EraseRootFromParent_Done,
     /*  97148 */ // Label 1736: @97148
     /*  97148 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(97180), // Rule ID 10600 //
     /*  97153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97167 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97179 */   // GIR_Coverage, 10600,
     /*  97179 */   GIR_EraseRootFromParent_Done,
     /*  97180 */ // Label 1737: @97180
     /*  97180 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(97212), // Rule ID 10601 //
     /*  97185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97199 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97211 */   // GIR_Coverage, 10601,
     /*  97211 */   GIR_EraseRootFromParent_Done,
     /*  97212 */ // Label 1738: @97212
     /*  97212 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(97244), // Rule ID 10602 //
     /*  97217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97231 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97234 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97236 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97243 */   // GIR_Coverage, 10602,
     /*  97243 */   GIR_EraseRootFromParent_Done,
     /*  97244 */ // Label 1739: @97244
     /*  97244 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(97276), // Rule ID 10603 //
     /*  97249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97263 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97275 */   // GIR_Coverage, 10603,
     /*  97275 */   GIR_EraseRootFromParent_Done,
     /*  97276 */ // Label 1740: @97276
     /*  97276 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(97308), // Rule ID 10616 //
     /*  97281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97295 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97298 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97300 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97307 */   // GIR_Coverage, 10616,
     /*  97307 */   GIR_EraseRootFromParent_Done,
     /*  97308 */ // Label 1741: @97308
     /*  97308 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(97340), // Rule ID 10617 //
     /*  97313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97327 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97330 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97332 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97339 */   // GIR_Coverage, 10617,
     /*  97339 */   GIR_EraseRootFromParent_Done,
     /*  97340 */ // Label 1742: @97340
     /*  97340 */ GIM_Reject,
     /*  97341 */ // Label 1450: @97341
     /*  97341 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(97373), // Rule ID 10574 //
     /*  97346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97360 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97372 */   // GIR_Coverage, 10574,
     /*  97372 */   GIR_EraseRootFromParent_Done,
     /*  97373 */ // Label 1743: @97373
     /*  97373 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(97405), // Rule ID 10575 //
     /*  97378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97392 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97404 */   // GIR_Coverage, 10575,
     /*  97404 */   GIR_EraseRootFromParent_Done,
     /*  97405 */ // Label 1744: @97405
     /*  97405 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(97437), // Rule ID 10576 //
     /*  97410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97424 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97436 */   // GIR_Coverage, 10576,
     /*  97436 */   GIR_EraseRootFromParent_Done,
     /*  97437 */ // Label 1745: @97437
     /*  97437 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(97469), // Rule ID 10577 //
     /*  97442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97456 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97468 */   // GIR_Coverage, 10577,
     /*  97468 */   GIR_EraseRootFromParent_Done,
     /*  97469 */ // Label 1746: @97469
     /*  97469 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(97501), // Rule ID 10578 //
     /*  97474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97488 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97500 */   // GIR_Coverage, 10578,
     /*  97500 */   GIR_EraseRootFromParent_Done,
     /*  97501 */ // Label 1747: @97501
     /*  97501 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(97533), // Rule ID 10579 //
     /*  97506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97520 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97532 */   // GIR_Coverage, 10579,
     /*  97532 */   GIR_EraseRootFromParent_Done,
     /*  97533 */ // Label 1748: @97533
     /*  97533 */ GIM_Reject,
     /*  97534 */ // Label 1451: @97534
     /*  97534 */ GIM_Reject,
     /*  97535 */ // Label 10: @97535
     /*  97535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1757*/ GIMT_Encode4(98025),
     /*  97546 */ /*GILLT_s16*//*Label 1749*/ GIMT_Encode4(97586),
     /*  97550 */ /*GILLT_s32*//*Label 1750*/ GIMT_Encode4(97617),
     /*  97554 */ /*GILLT_s64*//*Label 1751*/ GIMT_Encode4(97648), GIMT_Encode4(0),
     /*  97562 */ /*GILLT_v2s32*//*Label 1752*/ GIMT_Encode4(97679),
     /*  97566 */ /*GILLT_v2s64*//*Label 1753*/ GIMT_Encode4(97710),
     /*  97570 */ /*GILLT_v4s16*//*Label 1754*/ GIMT_Encode4(97741),
     /*  97574 */ /*GILLT_v4s32*//*Label 1755*/ GIMT_Encode4(97772), GIMT_Encode4(0),
     /*  97582 */ /*GILLT_v8s16*//*Label 1756*/ GIMT_Encode4(97803),
     /*  97586 */ // Label 1749: @97586
     /*  97586 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97616), // Rule ID 564 //
     /*  97591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97605 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  97610 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97614 */   GIR_RootConstrainSelectedInstOperands,
     /*  97615 */   // GIR_Coverage, 564,
     /*  97615 */   GIR_Done,
     /*  97616 */ // Label 1758: @97616
     /*  97616 */ GIM_Reject,
     /*  97617 */ // Label 1750: @97617
     /*  97617 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97647), // Rule ID 566 //
     /*  97622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97636 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  97641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97645 */   GIR_RootConstrainSelectedInstOperands,
     /*  97646 */   // GIR_Coverage, 566,
     /*  97646 */   GIR_Done,
     /*  97647 */ // Label 1759: @97647
     /*  97647 */ GIM_Reject,
     /*  97648 */ // Label 1751: @97648
     /*  97648 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97678), // Rule ID 568 //
     /*  97653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97667 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  97672 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97676 */   GIR_RootConstrainSelectedInstOperands,
     /*  97677 */   // GIR_Coverage, 568,
     /*  97677 */   GIR_Done,
     /*  97678 */ // Label 1760: @97678
     /*  97678 */ GIM_Reject,
     /*  97679 */ // Label 1752: @97679
     /*  97679 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97709), // Rule ID 933 //
     /*  97684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97698 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  97703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97707 */   GIR_RootConstrainSelectedInstOperands,
     /*  97708 */   // GIR_Coverage, 933,
     /*  97708 */   GIR_Done,
     /*  97709 */ // Label 1761: @97709
     /*  97709 */ GIM_Reject,
     /*  97710 */ // Label 1753: @97710
     /*  97710 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97740), // Rule ID 937 //
     /*  97715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97729 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  97734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97738 */   GIR_RootConstrainSelectedInstOperands,
     /*  97739 */   // GIR_Coverage, 937,
     /*  97739 */   GIR_Done,
     /*  97740 */ // Label 1762: @97740
     /*  97740 */ GIM_Reject,
     /*  97741 */ // Label 1754: @97741
     /*  97741 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97771), // Rule ID 929 //
     /*  97746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97760 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97765 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97769 */   GIR_RootConstrainSelectedInstOperands,
     /*  97770 */   // GIR_Coverage, 929,
     /*  97770 */   GIR_Done,
     /*  97771 */ // Label 1763: @97771
     /*  97771 */ GIM_Reject,
     /*  97772 */ // Label 1755: @97772
     /*  97772 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97802), // Rule ID 935 //
     /*  97777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97791 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97800 */   GIR_RootConstrainSelectedInstOperands,
     /*  97801 */   // GIR_Coverage, 935,
     /*  97801 */   GIR_Done,
     /*  97802 */ // Label 1764: @97802
     /*  97802 */ GIM_Reject,
     /*  97803 */ // Label 1756: @97803
     /*  97803 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(98024),
     /*  97808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97819 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97838), // Rule ID 931 //
     /*  97824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97827 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97832 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97836 */     GIR_RootConstrainSelectedInstOperands,
     /*  97837 */     // GIR_Coverage, 931,
     /*  97837 */     GIR_Done,
     /*  97838 */   // Label 1766: @97838
     /*  97838 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(98023), // Rule ID 7010 //
     /*  97843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97846 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97846 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97849 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97853 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97858 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97864 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97867 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97871 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97876 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97881 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97884 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97888 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97893 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97899 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97904 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97909 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97912 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97916 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97921 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97926 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97929 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97933 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97938 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97943 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97946 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97950 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97955 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97992 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98021 */     GIR_RootConstrainSelectedInstOperands,
     /*  98022 */     // GIR_Coverage, 7010,
     /*  98022 */     GIR_EraseRootFromParent_Done,
     /*  98023 */   // Label 1767: @98023
     /*  98023 */   GIM_Reject,
     /*  98024 */ // Label 1765: @98024
     /*  98024 */ GIM_Reject,
     /*  98025 */ // Label 1757: @98025
     /*  98025 */ GIM_Reject,
     /*  98026 */ // Label 11: @98026
     /*  98026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1776*/ GIMT_Encode4(98516),
     /*  98037 */ /*GILLT_s16*//*Label 1768*/ GIMT_Encode4(98077),
     /*  98041 */ /*GILLT_s32*//*Label 1769*/ GIMT_Encode4(98108),
     /*  98045 */ /*GILLT_s64*//*Label 1770*/ GIMT_Encode4(98139), GIMT_Encode4(0),
     /*  98053 */ /*GILLT_v2s32*//*Label 1771*/ GIMT_Encode4(98170),
     /*  98057 */ /*GILLT_v2s64*//*Label 1772*/ GIMT_Encode4(98201),
     /*  98061 */ /*GILLT_v4s16*//*Label 1773*/ GIMT_Encode4(98232),
     /*  98065 */ /*GILLT_v4s32*//*Label 1774*/ GIMT_Encode4(98263), GIMT_Encode4(0),
     /*  98073 */ /*GILLT_v8s16*//*Label 1775*/ GIMT_Encode4(98294),
     /*  98077 */ // Label 1768: @98077
     /*  98077 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98107), // Rule ID 528 //
     /*  98082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98096 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  98101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98105 */   GIR_RootConstrainSelectedInstOperands,
     /*  98106 */   // GIR_Coverage, 528,
     /*  98106 */   GIR_Done,
     /*  98107 */ // Label 1777: @98107
     /*  98107 */ GIM_Reject,
     /*  98108 */ // Label 1769: @98108
     /*  98108 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98138), // Rule ID 530 //
     /*  98113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98127 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  98132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98136 */   GIR_RootConstrainSelectedInstOperands,
     /*  98137 */   // GIR_Coverage, 530,
     /*  98137 */   GIR_Done,
     /*  98138 */ // Label 1778: @98138
     /*  98138 */ GIM_Reject,
     /*  98139 */ // Label 1770: @98139
     /*  98139 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98169), // Rule ID 532 //
     /*  98144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98158 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  98163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98167 */   GIR_RootConstrainSelectedInstOperands,
     /*  98168 */   // GIR_Coverage, 532,
     /*  98168 */   GIR_Done,
     /*  98169 */ // Label 1779: @98169
     /*  98169 */ GIM_Reject,
     /*  98170 */ // Label 1771: @98170
     /*  98170 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98200), // Rule ID 873 //
     /*  98175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98189 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  98194 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98198 */   GIR_RootConstrainSelectedInstOperands,
     /*  98199 */   // GIR_Coverage, 873,
     /*  98199 */   GIR_Done,
     /*  98200 */ // Label 1780: @98200
     /*  98200 */ GIM_Reject,
     /*  98201 */ // Label 1772: @98201
     /*  98201 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98231), // Rule ID 877 //
     /*  98206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98220 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  98225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98229 */   GIR_RootConstrainSelectedInstOperands,
     /*  98230 */   // GIR_Coverage, 877,
     /*  98230 */   GIR_Done,
     /*  98231 */ // Label 1781: @98231
     /*  98231 */ GIM_Reject,
     /*  98232 */ // Label 1773: @98232
     /*  98232 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98262), // Rule ID 869 //
     /*  98237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98251 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  98256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98260 */   GIR_RootConstrainSelectedInstOperands,
     /*  98261 */   // GIR_Coverage, 869,
     /*  98261 */   GIR_Done,
     /*  98262 */ // Label 1782: @98262
     /*  98262 */ GIM_Reject,
     /*  98263 */ // Label 1774: @98263
     /*  98263 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98293), // Rule ID 875 //
     /*  98268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98282 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98291 */   GIR_RootConstrainSelectedInstOperands,
     /*  98292 */   // GIR_Coverage, 875,
     /*  98292 */   GIR_Done,
     /*  98293 */ // Label 1783: @98293
     /*  98293 */ GIM_Reject,
     /*  98294 */ // Label 1775: @98294
     /*  98294 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98515),
     /*  98299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98310 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98329), // Rule ID 871 //
     /*  98315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98318 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  98323 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98327 */     GIR_RootConstrainSelectedInstOperands,
     /*  98328 */     // GIR_Coverage, 871,
     /*  98328 */     GIR_Done,
     /*  98329 */   // Label 1785: @98329
     /*  98329 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98514), // Rule ID 7004 //
     /*  98334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98337 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98337 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98340 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98344 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98349 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98355 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98358 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98362 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98367 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98372 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98375 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98379 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98384 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98390 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98395 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98400 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98403 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98407 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98412 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98417 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98420 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98424 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98429 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98446 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98480 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98512 */     GIR_RootConstrainSelectedInstOperands,
     /*  98513 */     // GIR_Coverage, 7004,
     /*  98513 */     GIR_EraseRootFromParent_Done,
     /*  98514 */   // Label 1786: @98514
     /*  98514 */   GIM_Reject,
     /*  98515 */ // Label 1784: @98515
     /*  98515 */ GIM_Reject,
     /*  98516 */ // Label 1776: @98516
     /*  98516 */ GIM_Reject,
     /*  98517 */ // Label 12: @98517
     /*  98517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1789*/ GIMT_Encode4(98784),
     /*  98528 */ /*GILLT_s32*//*Label 1787*/ GIMT_Encode4(98536),
     /*  98532 */ /*GILLT_s64*//*Label 1788*/ GIMT_Encode4(98660),
     /*  98536 */ // Label 1787: @98536
     /*  98536 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98579), // Rule ID 4785 //
     /*  98541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98551 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98563 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  98572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98577 */   GIR_RootConstrainSelectedInstOperands,
     /*  98578 */   // GIR_Coverage, 4785,
     /*  98578 */   GIR_EraseRootFromParent_Done,
     /*  98579 */ // Label 1790: @98579
     /*  98579 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98619), // Rule ID 4791 //
     /*  98584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98591 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  98612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98617 */   GIR_RootConstrainSelectedInstOperands,
     /*  98618 */   // GIR_Coverage, 4791,
     /*  98618 */   GIR_EraseRootFromParent_Done,
     /*  98619 */ // Label 1791: @98619
     /*  98619 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98659), // Rule ID 4793 //
     /*  98624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98631 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98643 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  98652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98657 */   GIR_RootConstrainSelectedInstOperands,
     /*  98658 */   // GIR_Coverage, 4793,
     /*  98658 */   GIR_EraseRootFromParent_Done,
     /*  98659 */ // Label 1792: @98659
     /*  98659 */ GIM_Reject,
     /*  98660 */ // Label 1788: @98660
     /*  98660 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98703), // Rule ID 4787 //
     /*  98665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98675 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98701 */   GIR_RootConstrainSelectedInstOperands,
     /*  98702 */   // GIR_Coverage, 4787,
     /*  98702 */   GIR_EraseRootFromParent_Done,
     /*  98703 */ // Label 1793: @98703
     /*  98703 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98743), // Rule ID 4795 //
     /*  98708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98715 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98741 */   GIR_RootConstrainSelectedInstOperands,
     /*  98742 */   // GIR_Coverage, 4795,
     /*  98742 */   GIR_EraseRootFromParent_Done,
     /*  98743 */ // Label 1794: @98743
     /*  98743 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(98783), // Rule ID 4797 //
     /*  98748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98755 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98767 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98781 */   GIR_RootConstrainSelectedInstOperands,
     /*  98782 */   // GIR_Coverage, 4797,
     /*  98782 */   GIR_EraseRootFromParent_Done,
     /*  98783 */ // Label 1795: @98783
     /*  98783 */ GIM_Reject,
     /*  98784 */ // Label 1789: @98784
     /*  98784 */ GIM_Reject,
     /*  98785 */ // Label 13: @98785
     /*  98785 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(98934),
     /*  98790 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98793 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1800*/ GIMT_Encode4(98933),
     /*  98804 */   /*GILLT_s16*//*Label 1797*/ GIMT_Encode4(98816),
     /*  98808 */   /*GILLT_s32*//*Label 1798*/ GIMT_Encode4(98857),
     /*  98812 */   /*GILLT_s64*//*Label 1799*/ GIMT_Encode4(98895),
     /*  98816 */   // Label 1797: @98816
     /*  98816 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(98856), // Rule ID 4789 //
     /*  98821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98828 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98854 */     GIR_RootConstrainSelectedInstOperands,
     /*  98855 */     // GIR_Coverage, 4789,
     /*  98855 */     GIR_EraseRootFromParent_Done,
     /*  98856 */   // Label 1801: @98856
     /*  98856 */   GIM_Reject,
     /*  98857 */   // Label 1798: @98857
     /*  98857 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(98894), // Rule ID 4799 //
     /*  98862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98866 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98892 */     GIR_RootConstrainSelectedInstOperands,
     /*  98893 */     // GIR_Coverage, 4799,
     /*  98893 */     GIR_EraseRootFromParent_Done,
     /*  98894 */   // Label 1802: @98894
     /*  98894 */   GIM_Reject,
     /*  98895 */   // Label 1799: @98895
     /*  98895 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(98932), // Rule ID 4801 //
     /*  98900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98904 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98930 */     GIR_RootConstrainSelectedInstOperands,
     /*  98931 */     // GIR_Coverage, 4801,
     /*  98931 */     GIR_EraseRootFromParent_Done,
     /*  98932 */   // Label 1803: @98932
     /*  98932 */   GIM_Reject,
     /*  98933 */   // Label 1800: @98933
     /*  98933 */   GIM_Reject,
     /*  98934 */ // Label 1796: @98934
     /*  98934 */ GIM_Reject,
     /*  98935 */ // Label 14: @98935
     /*  98935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1812*/ GIMT_Encode4(99425),
     /*  98946 */ /*GILLT_s16*//*Label 1804*/ GIMT_Encode4(98986),
     /*  98950 */ /*GILLT_s32*//*Label 1805*/ GIMT_Encode4(99017),
     /*  98954 */ /*GILLT_s64*//*Label 1806*/ GIMT_Encode4(99048), GIMT_Encode4(0),
     /*  98962 */ /*GILLT_v2s32*//*Label 1807*/ GIMT_Encode4(99079),
     /*  98966 */ /*GILLT_v2s64*//*Label 1808*/ GIMT_Encode4(99110),
     /*  98970 */ /*GILLT_v4s16*//*Label 1809*/ GIMT_Encode4(99141),
     /*  98974 */ /*GILLT_v4s32*//*Label 1810*/ GIMT_Encode4(99172), GIMT_Encode4(0),
     /*  98982 */ /*GILLT_v8s16*//*Label 1811*/ GIMT_Encode4(99203),
     /*  98986 */ // Label 1804: @98986
     /*  98986 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99016), // Rule ID 546 //
     /*  98991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99005 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  99005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  99010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99014 */   GIR_RootConstrainSelectedInstOperands,
     /*  99015 */   // GIR_Coverage, 546,
     /*  99015 */   GIR_Done,
     /*  99016 */ // Label 1813: @99016
     /*  99016 */ GIM_Reject,
     /*  99017 */ // Label 1805: @99017
     /*  99017 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99047), // Rule ID 548 //
     /*  99022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99036 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  99036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  99041 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99045 */   GIR_RootConstrainSelectedInstOperands,
     /*  99046 */   // GIR_Coverage, 548,
     /*  99046 */   GIR_Done,
     /*  99047 */ // Label 1814: @99047
     /*  99047 */ GIM_Reject,
     /*  99048 */ // Label 1806: @99048
     /*  99048 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99078), // Rule ID 550 //
     /*  99053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  99059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99067 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  99067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  99072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99076 */   GIR_RootConstrainSelectedInstOperands,
     /*  99077 */   // GIR_Coverage, 550,
     /*  99077 */   GIR_Done,
     /*  99078 */ // Label 1815: @99078
     /*  99078 */ GIM_Reject,
     /*  99079 */ // Label 1807: @99079
     /*  99079 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99109), // Rule ID 903 //
     /*  99084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99098 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  99098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  99103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99107 */   GIR_RootConstrainSelectedInstOperands,
     /*  99108 */   // GIR_Coverage, 903,
     /*  99108 */   GIR_Done,
     /*  99109 */ // Label 1816: @99109
     /*  99109 */ GIM_Reject,
     /*  99110 */ // Label 1808: @99110
     /*  99110 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99140), // Rule ID 907 //
     /*  99115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99129 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  99129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  99134 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99138 */   GIR_RootConstrainSelectedInstOperands,
     /*  99139 */   // GIR_Coverage, 907,
     /*  99139 */   GIR_Done,
     /*  99140 */ // Label 1817: @99140
     /*  99140 */ GIM_Reject,
     /*  99141 */ // Label 1809: @99141
     /*  99141 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99171), // Rule ID 899 //
     /*  99146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99160 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  99160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  99165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99169 */   GIR_RootConstrainSelectedInstOperands,
     /*  99170 */   // GIR_Coverage, 899,
     /*  99170 */   GIR_Done,
     /*  99171 */ // Label 1818: @99171
     /*  99171 */ GIM_Reject,
     /*  99172 */ // Label 1810: @99172
     /*  99172 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99202), // Rule ID 905 //
     /*  99177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99191 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  99191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99196 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99200 */   GIR_RootConstrainSelectedInstOperands,
     /*  99201 */   // GIR_Coverage, 905,
     /*  99201 */   GIR_Done,
     /*  99202 */ // Label 1819: @99202
     /*  99202 */ GIM_Reject,
     /*  99203 */ // Label 1811: @99203
     /*  99203 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99424),
     /*  99208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99219 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99238), // Rule ID 901 //
     /*  99224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99227 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  99227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  99232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99236 */     GIR_RootConstrainSelectedInstOperands,
     /*  99237 */     // GIR_Coverage, 901,
     /*  99237 */     GIR_Done,
     /*  99238 */   // Label 1821: @99238
     /*  99238 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99423), // Rule ID 7006 //
     /*  99243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  99246 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  99246 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  99249 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  99253 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99258 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  99264 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  99267 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99271 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99276 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  99279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  99281 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  99284 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99288 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99293 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  99299 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99304 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99309 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  99312 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  99316 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99321 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  99324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  99326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  99329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99338 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  99341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  99346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  99350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99355 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  99392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  99413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  99421 */     GIR_RootConstrainSelectedInstOperands,
     /*  99422 */     // GIR_Coverage, 7006,
     /*  99422 */     GIR_EraseRootFromParent_Done,
     /*  99423 */   // Label 1822: @99423
     /*  99423 */   GIM_Reject,
     /*  99424 */ // Label 1820: @99424
     /*  99424 */ GIM_Reject,
     /*  99425 */ // Label 1812: @99425
     /*  99425 */ GIM_Reject,
     /*  99426 */ // Label 15: @99426
     /*  99426 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(99458), // Rule ID 3904 //
     /*  99431 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  99434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99438 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  99438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  99441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99443 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  99453 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  99456 */   GIR_RootConstrainSelectedInstOperands,
     /*  99457 */   // GIR_Coverage, 3904,
     /*  99457 */   GIR_EraseRootFromParent_Done,
     /*  99458 */ // Label 1823: @99458
     /*  99458 */ GIM_Reject,
     /*  99459 */ // Label 16: @99459
     /*  99459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1844*/ GIMT_Encode4(108396),
     /*  99470 */ /*GILLT_s8*//*Label 1824*/ GIMT_Encode4(99566),
     /*  99474 */ /*GILLT_s16*//*Label 1825*/ GIMT_Encode4(99742),
     /*  99478 */ /*GILLT_s32*//*Label 1826*/ GIMT_Encode4(99918),
     /*  99482 */ /*GILLT_s64*//*Label 1827*/ GIMT_Encode4(102312),
     /*  99486 */ /*GILLT_s128*//*Label 1828*/ GIMT_Encode4(105025),
     /*  99490 */ /*GILLT_v2s32*//*Label 1829*/ GIMT_Encode4(105234),
     /*  99494 */ /*GILLT_v2s64*//*Label 1830*/ GIMT_Encode4(105612),
     /*  99498 */ /*GILLT_v4s16*//*Label 1831*/ GIMT_Encode4(105990),
     /*  99502 */ /*GILLT_v4s32*//*Label 1832*/ GIMT_Encode4(106368),
     /*  99506 */ /*GILLT_v8s8*//*Label 1833*/ GIMT_Encode4(106746),
     /*  99510 */ /*GILLT_v8s16*//*Label 1834*/ GIMT_Encode4(106954),
     /*  99514 */ /*GILLT_v16s8*//*Label 1835*/ GIMT_Encode4(107332), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99526 */ /*GILLT_nxv2s16*//*Label 1836*/ GIMT_Encode4(107540),
     /*  99530 */ /*GILLT_nxv2s32*//*Label 1837*/ GIMT_Encode4(107604),
     /*  99534 */ /*GILLT_nxv2s64*//*Label 1838*/ GIMT_Encode4(107668), GIMT_Encode4(0),
     /*  99542 */ /*GILLT_nxv4s16*//*Label 1839*/ GIMT_Encode4(107842),
     /*  99546 */ /*GILLT_nxv4s32*//*Label 1840*/ GIMT_Encode4(107906), GIMT_Encode4(0),
     /*  99554 */ /*GILLT_nxv8s16*//*Label 1841*/ GIMT_Encode4(108080),
     /*  99558 */ /*GILLT_nxv16s1*//*Label 1842*/ GIMT_Encode4(108254),
     /*  99562 */ /*GILLT_nxv16s8*//*Label 1843*/ GIMT_Encode4(108298),
     /*  99566 */ // Label 1824: @99566
     /*  99566 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(99741),
     /*  99571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  99582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99586 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(99627), // Rule ID 237 //
     /*  99591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99601 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  99604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99625 */     GIR_RootConstrainSelectedInstOperands,
     /*  99626 */     // GIR_Coverage, 237,
     /*  99626 */     GIR_EraseRootFromParent_Done,
     /*  99627 */   // Label 1846: @99627
     /*  99627 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99668), // Rule ID 238 //
     /*  99632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99642 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  99645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99666 */     GIR_RootConstrainSelectedInstOperands,
     /*  99667 */     // GIR_Coverage, 238,
     /*  99667 */     GIR_EraseRootFromParent_Done,
     /*  99668 */   // Label 1847: @99668
     /*  99668 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99704), // Rule ID 261 //
     /*  99673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99683 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  99683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  99686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99702 */     GIR_RootConstrainSelectedInstOperands,
     /*  99703 */     // GIR_Coverage, 261,
     /*  99703 */     GIR_EraseRootFromParent_Done,
     /*  99704 */   // Label 1848: @99704
     /*  99704 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99740), // Rule ID 282 //
     /*  99709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99719 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  99722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99738 */     GIR_RootConstrainSelectedInstOperands,
     /*  99739 */     // GIR_Coverage, 282,
     /*  99739 */     GIR_EraseRootFromParent_Done,
     /*  99740 */   // Label 1849: @99740
     /*  99740 */   GIM_Reject,
     /*  99741 */ // Label 1845: @99741
     /*  99741 */ GIM_Reject,
     /*  99742 */ // Label 1825: @99742
     /*  99742 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99917),
     /*  99747 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99758 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99762 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99803), // Rule ID 239 //
     /*  99767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99777 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99801 */     GIR_RootConstrainSelectedInstOperands,
     /*  99802 */     // GIR_Coverage, 239,
     /*  99802 */     GIR_EraseRootFromParent_Done,
     /*  99803 */   // Label 1851: @99803
     /*  99803 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99844), // Rule ID 240 //
     /*  99808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99818 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99842 */     GIR_RootConstrainSelectedInstOperands,
     /*  99843 */     // GIR_Coverage, 240,
     /*  99843 */     GIR_EraseRootFromParent_Done,
     /*  99844 */   // Label 1852: @99844
     /*  99844 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99880), // Rule ID 262 //
     /*  99849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99859 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99878 */     GIR_RootConstrainSelectedInstOperands,
     /*  99879 */     // GIR_Coverage, 262,
     /*  99879 */     GIR_EraseRootFromParent_Done,
     /*  99880 */   // Label 1853: @99880
     /*  99880 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99916), // Rule ID 283 //
     /*  99885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99895 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99914 */     GIR_RootConstrainSelectedInstOperands,
     /*  99915 */     // GIR_Coverage, 283,
     /*  99915 */     GIR_EraseRootFromParent_Done,
     /*  99916 */   // Label 1854: @99916
     /*  99916 */   GIM_Reject,
     /*  99917 */ // Label 1850: @99917
     /*  99917 */ GIM_Reject,
     /*  99918 */ // Label 1826: @99918
     /*  99918 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99971), // Rule ID 233 //
     /*  99923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99926 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99945 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99969 */   GIR_RootConstrainSelectedInstOperands,
     /*  99970 */   // GIR_Coverage, 233,
     /*  99970 */   GIR_EraseRootFromParent_Done,
     /*  99971 */ // Label 1855: @99971
     /*  99971 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100024), // Rule ID 234 //
     /*  99976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99979 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99987 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99998 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100022 */   GIR_RootConstrainSelectedInstOperands,
     /* 100023 */   // GIR_Coverage, 234,
     /* 100023 */   GIR_EraseRootFromParent_Done,
     /* 100024 */ // Label 1856: @100024
     /* 100024 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100080), // Rule ID 241 //
     /* 100029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100032 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100043 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100047 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100054 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 100057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100078 */   GIR_RootConstrainSelectedInstOperands,
     /* 100079 */   // GIR_Coverage, 241,
     /* 100079 */   GIR_EraseRootFromParent_Done,
     /* 100080 */ // Label 1857: @100080
     /* 100080 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100136), // Rule ID 242 //
     /* 100085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100110 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 100113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100134 */   GIR_RootConstrainSelectedInstOperands,
     /* 100135 */   // GIR_Coverage, 242,
     /* 100135 */   GIR_EraseRootFromParent_Done,
     /* 100136 */ // Label 1858: @100136
     /* 100136 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100196), // Rule ID 4120 //
     /* 100141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100144 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100170 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 100170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100194 */   GIR_RootConstrainSelectedInstOperands,
     /* 100195 */   // GIR_Coverage, 4120,
     /* 100195 */   GIR_EraseRootFromParent_Done,
     /* 100196 */ // Label 1859: @100196
     /* 100196 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100256), // Rule ID 4121 //
     /* 100201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100204 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100230 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 100230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100254 */   GIR_RootConstrainSelectedInstOperands,
     /* 100255 */   // GIR_Coverage, 4121,
     /* 100255 */   GIR_EraseRootFromParent_Done,
     /* 100256 */ // Label 1860: @100256
     /* 100256 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100316), // Rule ID 4122 //
     /* 100261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100290 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100314 */   GIR_RootConstrainSelectedInstOperands,
     /* 100315 */   // GIR_Coverage, 4122,
     /* 100315 */   GIR_EraseRootFromParent_Done,
     /* 100316 */ // Label 1861: @100316
     /* 100316 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100376), // Rule ID 4123 //
     /* 100321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100324 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100350 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100374 */   GIR_RootConstrainSelectedInstOperands,
     /* 100375 */   // GIR_Coverage, 4123,
     /* 100375 */   GIR_EraseRootFromParent_Done,
     /* 100376 */ // Label 1862: @100376
     /* 100376 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100436), // Rule ID 4124 //
     /* 100381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100384 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100388 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100410 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100434 */   GIR_RootConstrainSelectedInstOperands,
     /* 100435 */   // GIR_Coverage, 4124,
     /* 100435 */   GIR_EraseRootFromParent_Done,
     /* 100436 */ // Label 1863: @100436
     /* 100436 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100496), // Rule ID 4125 //
     /* 100441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100444 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100448 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100459 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100463 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100470 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100494 */   GIR_RootConstrainSelectedInstOperands,
     /* 100495 */   // GIR_Coverage, 4125,
     /* 100495 */   GIR_EraseRootFromParent_Done,
     /* 100496 */ // Label 1864: @100496
     /* 100496 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100544), // Rule ID 260 //
     /* 100501 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100504 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100523 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100542 */   GIR_RootConstrainSelectedInstOperands,
     /* 100543 */   // GIR_Coverage, 260,
     /* 100543 */   GIR_EraseRootFromParent_Done,
     /* 100544 */ // Label 1865: @100544
     /* 100544 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100595), // Rule ID 263 //
     /* 100549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100574 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 100577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100593 */   GIR_RootConstrainSelectedInstOperands,
     /* 100594 */   // GIR_Coverage, 263,
     /* 100594 */   GIR_EraseRootFromParent_Done,
     /* 100595 */ // Label 1866: @100595
     /* 100595 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100658), // Rule ID 7036 //
     /* 100600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100603 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100607 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100614 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100632 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 100632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100656 */   GIR_RootConstrainSelectedInstOperands,
     /* 100657 */   // GIR_Coverage, 7036,
     /* 100657 */   GIR_EraseRootFromParent_Done,
     /* 100658 */ // Label 1867: @100658
     /* 100658 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100721), // Rule ID 7038 //
     /* 100663 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100666 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100670 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100677 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100695 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 100695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100719 */   GIR_RootConstrainSelectedInstOperands,
     /* 100720 */   // GIR_Coverage, 7038,
     /* 100720 */   GIR_EraseRootFromParent_Done,
     /* 100721 */ // Label 1868: @100721
     /* 100721 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100784), // Rule ID 7048 //
     /* 100726 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100729 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100740 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100747 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100758 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100782 */   GIR_RootConstrainSelectedInstOperands,
     /* 100783 */   // GIR_Coverage, 7048,
     /* 100783 */   GIR_EraseRootFromParent_Done,
     /* 100784 */ // Label 1869: @100784
     /* 100784 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100847), // Rule ID 7050 //
     /* 100789 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100792 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100796 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100803 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100821 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100845 */   GIR_RootConstrainSelectedInstOperands,
     /* 100846 */   // GIR_Coverage, 7050,
     /* 100846 */   GIR_EraseRootFromParent_Done,
     /* 100847 */ // Label 1870: @100847
     /* 100847 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100910), // Rule ID 7058 //
     /* 100852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100866 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100884 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100908 */   GIR_RootConstrainSelectedInstOperands,
     /* 100909 */   // GIR_Coverage, 7058,
     /* 100909 */   GIR_EraseRootFromParent_Done,
     /* 100910 */ // Label 1871: @100910
     /* 100910 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100973), // Rule ID 7059 //
     /* 100915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100929 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100947 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100971 */   GIR_RootConstrainSelectedInstOperands,
     /* 100972 */   // GIR_Coverage, 7059,
     /* 100972 */   GIR_EraseRootFromParent_Done,
     /* 100973 */ // Label 1872: @100973
     /* 100973 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101021), // Rule ID 281 //
     /* 100978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100993 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101000 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 101000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 101003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101019 */   GIR_RootConstrainSelectedInstOperands,
     /* 101020 */   // GIR_Coverage, 281,
     /* 101020 */   GIR_EraseRootFromParent_Done,
     /* 101021 */ // Label 1873: @101021
     /* 101021 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101072), // Rule ID 284 //
     /* 101026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 101040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101051 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 101051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 101054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101070 */   GIR_RootConstrainSelectedInstOperands,
     /* 101071 */   // GIR_Coverage, 284,
     /* 101071 */   GIR_EraseRootFromParent_Done,
     /* 101072 */ // Label 1874: @101072
     /* 101072 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101127), // Rule ID 4147 //
     /* 101077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101080 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101106 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101125 */   GIR_RootConstrainSelectedInstOperands,
     /* 101126 */   // GIR_Coverage, 4147,
     /* 101126 */   GIR_EraseRootFromParent_Done,
     /* 101127 */ // Label 1875: @101127
     /* 101127 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101182), // Rule ID 4148 //
     /* 101132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101135 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101161 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101180 */   GIR_RootConstrainSelectedInstOperands,
     /* 101181 */   // GIR_Coverage, 4148,
     /* 101181 */   GIR_EraseRootFromParent_Done,
     /* 101182 */ // Label 1876: @101182
     /* 101182 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101237), // Rule ID 4149 //
     /* 101187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101190 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101216 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101235 */   GIR_RootConstrainSelectedInstOperands,
     /* 101236 */   // GIR_Coverage, 4149,
     /* 101236 */   GIR_EraseRootFromParent_Done,
     /* 101237 */ // Label 1877: @101237
     /* 101237 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101292), // Rule ID 4170 //
     /* 101242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101245 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101271 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101290 */   GIR_RootConstrainSelectedInstOperands,
     /* 101291 */   // GIR_Coverage, 4170,
     /* 101291 */   GIR_EraseRootFromParent_Done,
     /* 101292 */ // Label 1878: @101292
     /* 101292 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101347), // Rule ID 4171 //
     /* 101297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101300 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101326 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101345 */   GIR_RootConstrainSelectedInstOperands,
     /* 101346 */   // GIR_Coverage, 4171,
     /* 101346 */   GIR_EraseRootFromParent_Done,
     /* 101347 */ // Label 1879: @101347
     /* 101347 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101402), // Rule ID 4172 //
     /* 101352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101355 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101359 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101374 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101381 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101400 */   GIR_RootConstrainSelectedInstOperands,
     /* 101401 */   // GIR_Coverage, 4172,
     /* 101401 */   GIR_EraseRootFromParent_Done,
     /* 101402 */ // Label 1880: @101402
     /* 101402 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101460), // Rule ID 7040 //
     /* 101407 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101410 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101421 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101439 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101458 */   GIR_RootConstrainSelectedInstOperands,
     /* 101459 */   // GIR_Coverage, 7040,
     /* 101459 */   GIR_EraseRootFromParent_Done,
     /* 101460 */ // Label 1881: @101460
     /* 101460 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101518), // Rule ID 7042 //
     /* 101465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101468 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101479 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101497 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15876>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101516 */   GIR_RootConstrainSelectedInstOperands,
     /* 101517 */   // GIR_Coverage, 7042,
     /* 101517 */   GIR_EraseRootFromParent_Done,
     /* 101518 */ // Label 1882: @101518
     /* 101518 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101576), // Rule ID 7052 //
     /* 101523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101526 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101537 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101555 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101574 */   GIR_RootConstrainSelectedInstOperands,
     /* 101575 */   // GIR_Coverage, 7052,
     /* 101575 */   GIR_EraseRootFromParent_Done,
     /* 101576 */ // Label 1883: @101576
     /* 101576 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101634), // Rule ID 7054 //
     /* 101581 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101584 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101595 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101613 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15884>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101632 */   GIR_RootConstrainSelectedInstOperands,
     /* 101633 */   // GIR_Coverage, 7054,
     /* 101633 */   GIR_EraseRootFromParent_Done,
     /* 101634 */ // Label 1884: @101634
     /* 101634 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101692), // Rule ID 7060 //
     /* 101639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101653 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 101671 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 101671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 101674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101690 */   GIR_RootConstrainSelectedInstOperands,
     /* 101691 */   // GIR_Coverage, 7060,
     /* 101691 */   GIR_EraseRootFromParent_Done,
     /* 101692 */ // Label 1885: @101692
     /* 101692 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101750), // Rule ID 7061 //
     /* 101697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101711 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101729 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15892>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 101732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101748 */   GIR_RootConstrainSelectedInstOperands,
     /* 101749 */   // GIR_Coverage, 7061,
     /* 101749 */   GIR_EraseRootFromParent_Done,
     /* 101750 */ // Label 1886: @101750
     /* 101750 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101811), // Rule ID 7446 //
     /* 101755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101758 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101761 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101765 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101790 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15865>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 101793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101809 */   GIR_RootConstrainSelectedInstOperands,
     /* 101810 */   // GIR_Coverage, 7446,
     /* 101810 */   GIR_EraseRootFromParent_Done,
     /* 101811 */ // Label 1887: @101811
     /* 101811 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101872), // Rule ID 7448 //
     /* 101816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101819 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101822 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101826 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101851 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15867>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 101854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101870 */   GIR_RootConstrainSelectedInstOperands,
     /* 101871 */   // GIR_Coverage, 7448,
     /* 101871 */   GIR_EraseRootFromParent_Done,
     /* 101872 */ // Label 1888: @101872
     /* 101872 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101933), // Rule ID 7450 //
     /* 101877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101880 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101912 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15869>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 101915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101931 */   GIR_RootConstrainSelectedInstOperands,
     /* 101932 */   // GIR_Coverage, 7450,
     /* 101932 */   GIR_EraseRootFromParent_Done,
     /* 101933 */ // Label 1889: @101933
     /* 101933 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101977), // Rule ID 7026 //
     /* 101938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101941 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101944 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101962 */   // MIs[0] ptr
     /* 101962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101970 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15865>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101975 */   GIR_RootConstrainSelectedInstOperands,
     /* 101976 */   // GIR_Coverage, 7026,
     /* 101976 */   GIR_Done,
     /* 101977 */ // Label 1890: @101977
     /* 101977 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102021), // Rule ID 7028 //
     /* 101982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101985 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101988 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101992 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101999 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102006 */   // MIs[0] ptr
     /* 102006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102014 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15867>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 102019 */   GIR_RootConstrainSelectedInstOperands,
     /* 102020 */   // GIR_Coverage, 7028,
     /* 102020 */   GIR_Done,
     /* 102021 */ // Label 1891: @102021
     /* 102021 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102065), // Rule ID 7030 //
     /* 102026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 102029 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102036 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102050 */   // MIs[0] ptr
     /* 102050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102058 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15869>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 102063 */   GIR_RootConstrainSelectedInstOperands,
     /* 102064 */   // GIR_Coverage, 7030,
     /* 102064 */   GIR_Done,
     /* 102065 */ // Label 1892: @102065
     /* 102065 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102106), // Rule ID 7032 //
     /* 102070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102073 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102091 */   // MIs[0] ptr
     /* 102091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102099 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15873>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102104 */   GIR_RootConstrainSelectedInstOperands,
     /* 102105 */   // GIR_Coverage, 7032,
     /* 102105 */   GIR_Done,
     /* 102106 */ // Label 1893: @102106
     /* 102106 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102147), // Rule ID 7034 //
     /* 102111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102114 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102132 */   // MIs[0] ptr
     /* 102132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102140 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15865>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102145 */   GIR_RootConstrainSelectedInstOperands,
     /* 102146 */   // GIR_Coverage, 7034,
     /* 102146 */   GIR_Done,
     /* 102147 */ // Label 1894: @102147
     /* 102147 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102188), // Rule ID 7044 //
     /* 102152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102173 */   // MIs[0] ptr
     /* 102173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102181 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15881>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102186 */   GIR_RootConstrainSelectedInstOperands,
     /* 102187 */   // GIR_Coverage, 7044,
     /* 102187 */   GIR_Done,
     /* 102188 */ // Label 1895: @102188
     /* 102188 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102229), // Rule ID 7046 //
     /* 102193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102214 */   // MIs[0] ptr
     /* 102214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102222 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15867>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102227 */   GIR_RootConstrainSelectedInstOperands,
     /* 102228 */   // GIR_Coverage, 7046,
     /* 102228 */   GIR_Done,
     /* 102229 */ // Label 1896: @102229
     /* 102229 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102270), // Rule ID 7056 //
     /* 102234 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102237 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102255 */   // MIs[0] ptr
     /* 102255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102263 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15889>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 102268 */   GIR_RootConstrainSelectedInstOperands,
     /* 102269 */   // GIR_Coverage, 7056,
     /* 102269 */   GIR_Done,
     /* 102270 */ // Label 1897: @102270
     /* 102270 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102311), // Rule ID 7057 //
     /* 102275 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102296 */   // MIs[0] ptr
     /* 102296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102304 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15869>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 102309 */   GIR_RootConstrainSelectedInstOperands,
     /* 102310 */   // GIR_Coverage, 7057,
     /* 102310 */   GIR_Done,
     /* 102311 */ // Label 1898: @102311
     /* 102311 */ GIM_Reject,
     /* 102312 */ // Label 1827: @102312
     /* 102312 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102365), // Rule ID 235 //
     /* 102317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102339 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102363 */   GIR_RootConstrainSelectedInstOperands,
     /* 102364 */   // GIR_Coverage, 235,
     /* 102364 */   GIR_EraseRootFromParent_Done,
     /* 102365 */ // Label 1899: @102365
     /* 102365 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102418), // Rule ID 236 //
     /* 102370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102392 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102416 */   GIR_RootConstrainSelectedInstOperands,
     /* 102417 */   // GIR_Coverage, 236,
     /* 102417 */   GIR_EraseRootFromParent_Done,
     /* 102418 */ // Label 1900: @102418
     /* 102418 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102474), // Rule ID 243 //
     /* 102423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102448 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102472 */   GIR_RootConstrainSelectedInstOperands,
     /* 102473 */   // GIR_Coverage, 243,
     /* 102473 */   GIR_EraseRootFromParent_Done,
     /* 102474 */ // Label 1901: @102474
     /* 102474 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102530), // Rule ID 244 //
     /* 102479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102485 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102504 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102528 */   GIR_RootConstrainSelectedInstOperands,
     /* 102529 */   // GIR_Coverage, 244,
     /* 102529 */   GIR_EraseRootFromParent_Done,
     /* 102530 */ // Label 1902: @102530
     /* 102530 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102583), // Rule ID 4086 //
     /* 102535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102557 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102581 */   GIR_RootConstrainSelectedInstOperands,
     /* 102582 */   // GIR_Coverage, 4086,
     /* 102582 */   GIR_EraseRootFromParent_Done,
     /* 102583 */ // Label 1903: @102583
     /* 102583 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102636), // Rule ID 4087 //
     /* 102588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102610 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102634 */   GIR_RootConstrainSelectedInstOperands,
     /* 102635 */   // GIR_Coverage, 4087,
     /* 102635 */   GIR_EraseRootFromParent_Done,
     /* 102636 */ // Label 1904: @102636
     /* 102636 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102689), // Rule ID 4088 //
     /* 102641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102644 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102663 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102687 */   GIR_RootConstrainSelectedInstOperands,
     /* 102688 */   // GIR_Coverage, 4088,
     /* 102688 */   GIR_EraseRootFromParent_Done,
     /* 102689 */ // Label 1905: @102689
     /* 102689 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102742), // Rule ID 4089 //
     /* 102694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102697 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102705 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102709 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102716 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102740 */   GIR_RootConstrainSelectedInstOperands,
     /* 102741 */   // GIR_Coverage, 4089,
     /* 102741 */   GIR_EraseRootFromParent_Done,
     /* 102742 */ // Label 1906: @102742
     /* 102742 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102834), // Rule ID 4112 //
     /* 102747 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102750 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102776 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102803 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102833 */   // GIR_Coverage, 4112,
     /* 102833 */   GIR_EraseRootFromParent_Done,
     /* 102834 */ // Label 1907: @102834
     /* 102834 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102926), // Rule ID 4113 //
     /* 102839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102868 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102895 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102925 */   // GIR_Coverage, 4113,
     /* 102925 */   GIR_EraseRootFromParent_Done,
     /* 102926 */ // Label 1908: @102926
     /* 102926 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(103018), // Rule ID 4114 //
     /* 102931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102934 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102960 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102987 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103017 */   // GIR_Coverage, 4114,
     /* 103017 */   GIR_EraseRootFromParent_Done,
     /* 103018 */ // Label 1909: @103018
     /* 103018 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(103110), // Rule ID 4115 //
     /* 103023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103026 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103045 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 103052 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 103059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103079 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103109 */   // GIR_Coverage, 4115,
     /* 103109 */   GIR_EraseRootFromParent_Done,
     /* 103110 */ // Label 1910: @103110
     /* 103110 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(103202), // Rule ID 4116 //
     /* 103115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103137 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 103144 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 103151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103171 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103201 */   // GIR_Coverage, 4116,
     /* 103201 */   GIR_EraseRootFromParent_Done,
     /* 103202 */ // Label 1911: @103202
     /* 103202 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(103294), // Rule ID 4117 //
     /* 103207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103210 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 103236 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 103243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103263 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103293 */   // GIR_Coverage, 4117,
     /* 103293 */   GIR_EraseRootFromParent_Done,
     /* 103294 */ // Label 1912: @103294
     /* 103294 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(103386), // Rule ID 4118 //
     /* 103299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103302 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103306 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 103328 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 103335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103355 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103385 */   // GIR_Coverage, 4118,
     /* 103385 */   GIR_EraseRootFromParent_Done,
     /* 103386 */ // Label 1913: @103386
     /* 103386 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(103478), // Rule ID 4119 //
     /* 103391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103394 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103409 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103420 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 103427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103447 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103477 */   // GIR_Coverage, 4119,
     /* 103477 */   GIR_EraseRootFromParent_Done,
     /* 103478 */ // Label 1914: @103478
     /* 103478 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(103526), // Rule ID 259 //
     /* 103483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103505 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103524 */   GIR_RootConstrainSelectedInstOperands,
     /* 103525 */   // GIR_Coverage, 259,
     /* 103525 */   GIR_EraseRootFromParent_Done,
     /* 103526 */ // Label 1915: @103526
     /* 103526 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103577), // Rule ID 264 //
     /* 103531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103556 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103575 */   GIR_RootConstrainSelectedInstOperands,
     /* 103576 */   // GIR_Coverage, 264,
     /* 103576 */   GIR_EraseRootFromParent_Done,
     /* 103577 */ // Label 1916: @103577
     /* 103577 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103640), // Rule ID 7064 //
     /* 103582 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103585 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103596 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103603 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103607 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103614 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 103617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103638 */   GIR_RootConstrainSelectedInstOperands,
     /* 103639 */   // GIR_Coverage, 7064,
     /* 103639 */   GIR_EraseRootFromParent_Done,
     /* 103640 */ // Label 1917: @103640
     /* 103640 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103703), // Rule ID 7065 //
     /* 103645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103659 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103670 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103677 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 103680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103697 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103701 */   GIR_RootConstrainSelectedInstOperands,
     /* 103702 */   // GIR_Coverage, 7065,
     /* 103702 */   GIR_EraseRootFromParent_Done,
     /* 103703 */ // Label 1918: @103703
     /* 103703 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103751), // Rule ID 280 //
     /* 103708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103719 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103723 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103730 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103749 */   GIR_RootConstrainSelectedInstOperands,
     /* 103750 */   // GIR_Coverage, 280,
     /* 103750 */   GIR_EraseRootFromParent_Done,
     /* 103751 */ // Label 1919: @103751
     /* 103751 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103802), // Rule ID 285 //
     /* 103756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103781 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103796 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103800 */   GIR_RootConstrainSelectedInstOperands,
     /* 103801 */   // GIR_Coverage, 285,
     /* 103801 */   GIR_EraseRootFromParent_Done,
     /* 103802 */ // Label 1920: @103802
     /* 103802 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103850), // Rule ID 4133 //
     /* 103807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103822 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103829 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103848 */   GIR_RootConstrainSelectedInstOperands,
     /* 103849 */   // GIR_Coverage, 4133,
     /* 103849 */   GIR_EraseRootFromParent_Done,
     /* 103850 */ // Label 1921: @103850
     /* 103850 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103898), // Rule ID 4134 //
     /* 103855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103870 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103877 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103896 */   GIR_RootConstrainSelectedInstOperands,
     /* 103897 */   // GIR_Coverage, 4134,
     /* 103897 */   GIR_EraseRootFromParent_Done,
     /* 103898 */ // Label 1922: @103898
     /* 103898 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103985), // Rule ID 4150 //
     /* 103903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103906 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103932 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103954 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103984 */   // GIR_Coverage, 4150,
     /* 103984 */   GIR_EraseRootFromParent_Done,
     /* 103985 */ // Label 1923: @103985
     /* 103985 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(104072), // Rule ID 4151 //
     /* 103990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103993 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104019 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 104026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104041 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104071 */   // GIR_Coverage, 4151,
     /* 104071 */   GIR_EraseRootFromParent_Done,
     /* 104072 */ // Label 1924: @104072
     /* 104072 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(104159), // Rule ID 4152 //
     /* 104077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104080 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104106 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104128 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104158 */   // GIR_Coverage, 4152,
     /* 104158 */   GIR_EraseRootFromParent_Done,
     /* 104159 */ // Label 1925: @104159
     /* 104159 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(104246), // Rule ID 4153 //
     /* 104164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104193 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104215 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104245 */   // GIR_Coverage, 4153,
     /* 104245 */   GIR_EraseRootFromParent_Done,
     /* 104246 */ // Label 1926: @104246
     /* 104246 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(104294), // Rule ID 4161 //
     /* 104251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104273 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104292 */   GIR_RootConstrainSelectedInstOperands,
     /* 104293 */   // GIR_Coverage, 4161,
     /* 104293 */   GIR_EraseRootFromParent_Done,
     /* 104294 */ // Label 1927: @104294
     /* 104294 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(104342), // Rule ID 4162 //
     /* 104299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104302 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104321 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104340 */   GIR_RootConstrainSelectedInstOperands,
     /* 104341 */   // GIR_Coverage, 4162,
     /* 104341 */   GIR_EraseRootFromParent_Done,
     /* 104342 */ // Label 1928: @104342
     /* 104342 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(104429), // Rule ID 4173 //
     /* 104347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104350 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104376 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 104383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104398 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104428 */   // GIR_Coverage, 4173,
     /* 104428 */   GIR_EraseRootFromParent_Done,
     /* 104429 */ // Label 1929: @104429
     /* 104429 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(104516), // Rule ID 4174 //
     /* 104434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104437 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104463 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 104470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104485 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104515 */   // GIR_Coverage, 4174,
     /* 104515 */   GIR_EraseRootFromParent_Done,
     /* 104516 */ // Label 1930: @104516
     /* 104516 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(104603), // Rule ID 4175 //
     /* 104521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104524 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104550 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104572 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104602 */   // GIR_Coverage, 4175,
     /* 104602 */   GIR_EraseRootFromParent_Done,
     /* 104603 */ // Label 1931: @104603
     /* 104603 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(104690), // Rule ID 4176 //
     /* 104608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104611 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104637 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104659 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104689 */   // GIR_Coverage, 4176,
     /* 104689 */   GIR_EraseRootFromParent_Done,
     /* 104690 */ // Label 1932: @104690
     /* 104690 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104748), // Rule ID 7066 //
     /* 104695 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104709 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104727 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 104730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104746 */   GIR_RootConstrainSelectedInstOperands,
     /* 104747 */   // GIR_Coverage, 7066,
     /* 104747 */   GIR_EraseRootFromParent_Done,
     /* 104748 */ // Label 1933: @104748
     /* 104748 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104806), // Rule ID 7067 //
     /* 104753 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104760 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104767 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104785 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15900>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 104788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104804 */   GIR_RootConstrainSelectedInstOperands,
     /* 104805 */   // GIR_Coverage, 7067,
     /* 104805 */   GIR_EraseRootFromParent_Done,
     /* 104806 */ // Label 1934: @104806
     /* 104806 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104867), // Rule ID 7451 //
     /* 104811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 104814 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104846 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15871>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 104849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104865 */   GIR_RootConstrainSelectedInstOperands,
     /* 104866 */   // GIR_Coverage, 7451,
     /* 104866 */   GIR_EraseRootFromParent_Done,
     /* 104867 */ // Label 1935: @104867
     /* 104867 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104898), // Rule ID 6409 //
     /* 104872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104883 */   // MIs[0] Rn
     /* 104883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104891 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104896 */   GIR_RootConstrainSelectedInstOperands,
     /* 104897 */   // GIR_Coverage, 6409,
     /* 104897 */   GIR_Done,
     /* 104898 */ // Label 1936: @104898
     /* 104898 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104942), // Rule ID 7031 //
     /* 104903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104906 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104909 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104927 */   // MIs[0] ptr
     /* 104927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104935 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15871>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104940 */   GIR_RootConstrainSelectedInstOperands,
     /* 104941 */   // GIR_Coverage, 7031,
     /* 104941 */   GIR_Done,
     /* 104942 */ // Label 1937: @104942
     /* 104942 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104983), // Rule ID 7062 //
     /* 104947 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104961 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104968 */   // MIs[0] ptr
     /* 104968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104976 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15897>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104981 */   GIR_RootConstrainSelectedInstOperands,
     /* 104982 */   // GIR_Coverage, 7062,
     /* 104982 */   GIR_Done,
     /* 104983 */ // Label 1938: @104983
     /* 104983 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(105024), // Rule ID 7063 //
     /* 104988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104995 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105009 */   // MIs[0] ptr
     /* 105009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105017 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15871>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 105017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 105022 */   GIR_RootConstrainSelectedInstOperands,
     /* 105023 */   // GIR_Coverage, 7063,
     /* 105023 */   GIR_Done,
     /* 105024 */ // Label 1939: @105024
     /* 105024 */ GIM_Reject,
     /* 105025 */ // Label 1828: @105025
     /* 105025 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(105233),
     /* 105030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105045 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(105086), // Rule ID 245 //
     /* 105050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105060 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105084 */     GIR_RootConstrainSelectedInstOperands,
     /* 105085 */     // GIR_Coverage, 245,
     /* 105085 */     GIR_EraseRootFromParent_Done,
     /* 105086 */   // Label 1941: @105086
     /* 105086 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(105127), // Rule ID 246 //
     /* 105091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105101 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105125 */     GIR_RootConstrainSelectedInstOperands,
     /* 105126 */     // GIR_Coverage, 246,
     /* 105126 */     GIR_EraseRootFromParent_Done,
     /* 105127 */   // Label 1942: @105127
     /* 105127 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(105163), // Rule ID 265 //
     /* 105132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105142 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105161 */     GIR_RootConstrainSelectedInstOperands,
     /* 105162 */     // GIR_Coverage, 265,
     /* 105162 */     GIR_EraseRootFromParent_Done,
     /* 105163 */   // Label 1943: @105163
     /* 105163 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(105199), // Rule ID 286 //
     /* 105168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105178 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105197 */     GIR_RootConstrainSelectedInstOperands,
     /* 105198 */     // GIR_Coverage, 286,
     /* 105198 */     GIR_EraseRootFromParent_Done,
     /* 105199 */   // Label 1944: @105199
     /* 105199 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(105232), // Rule ID 4142 //
     /* 105204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105211 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105230 */     GIR_RootConstrainSelectedInstOperands,
     /* 105231 */     // GIR_Coverage, 4142,
     /* 105231 */     GIR_EraseRootFromParent_Done,
     /* 105232 */   // Label 1945: @105232
     /* 105232 */   GIM_Reject,
     /* 105233 */ // Label 1940: @105233
     /* 105233 */ GIM_Reject,
     /* 105234 */ // Label 1829: @105234
     /* 105234 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(105611),
     /* 105239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105250 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(105295), // Rule ID 4076 //
     /* 105255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105269 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105293 */     GIR_RootConstrainSelectedInstOperands,
     /* 105294 */     // GIR_Coverage, 4076,
     /* 105294 */     GIR_EraseRootFromParent_Done,
     /* 105295 */   // Label 1947: @105295
     /* 105295 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(105340), // Rule ID 4077 //
     /* 105300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105314 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105338 */     GIR_RootConstrainSelectedInstOperands,
     /* 105339 */     // GIR_Coverage, 4077,
     /* 105339 */     GIR_EraseRootFromParent_Done,
     /* 105340 */   // Label 1948: @105340
     /* 105340 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(105385), // Rule ID 4078 //
     /* 105345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105359 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105383 */     GIR_RootConstrainSelectedInstOperands,
     /* 105384 */     // GIR_Coverage, 4078,
     /* 105384 */     GIR_EraseRootFromParent_Done,
     /* 105385 */   // Label 1949: @105385
     /* 105385 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(105430), // Rule ID 4079 //
     /* 105390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105404 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105428 */     GIR_RootConstrainSelectedInstOperands,
     /* 105429 */     // GIR_Coverage, 4079,
     /* 105429 */     GIR_EraseRootFromParent_Done,
     /* 105430 */   // Label 1950: @105430
     /* 105430 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(105470), // Rule ID 4128 //
     /* 105435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105449 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105468 */     GIR_RootConstrainSelectedInstOperands,
     /* 105469 */     // GIR_Coverage, 4128,
     /* 105469 */     GIR_EraseRootFromParent_Done,
     /* 105470 */   // Label 1951: @105470
     /* 105470 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(105510), // Rule ID 4131 //
     /* 105475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105489 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105508 */     GIR_RootConstrainSelectedInstOperands,
     /* 105509 */     // GIR_Coverage, 4131,
     /* 105509 */     GIR_EraseRootFromParent_Done,
     /* 105510 */   // Label 1952: @105510
     /* 105510 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(105550), // Rule ID 4156 //
     /* 105515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105529 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105548 */     GIR_RootConstrainSelectedInstOperands,
     /* 105549 */     // GIR_Coverage, 4156,
     /* 105549 */     GIR_EraseRootFromParent_Done,
     /* 105550 */   // Label 1953: @105550
     /* 105550 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(105590), // Rule ID 4157 //
     /* 105555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105569 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105588 */     GIR_RootConstrainSelectedInstOperands,
     /* 105589 */     // GIR_Coverage, 4157,
     /* 105589 */     GIR_EraseRootFromParent_Done,
     /* 105590 */   // Label 1954: @105590
     /* 105590 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(105610), // Rule ID 6408 //
     /* 105595 */     // MIs[0] Rn
     /* 105595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105603 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 105608 */     GIR_RootConstrainSelectedInstOperands,
     /* 105609 */     // GIR_Coverage, 6408,
     /* 105609 */     GIR_Done,
     /* 105610 */   // Label 1955: @105610
     /* 105610 */   GIM_Reject,
     /* 105611 */ // Label 1946: @105611
     /* 105611 */ GIM_Reject,
     /* 105612 */ // Label 1830: @105612
     /* 105612 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(105989),
     /* 105617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105620 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105628 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(105673), // Rule ID 4090 //
     /* 105633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105647 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105671 */     GIR_RootConstrainSelectedInstOperands,
     /* 105672 */     // GIR_Coverage, 4090,
     /* 105672 */     GIR_EraseRootFromParent_Done,
     /* 105673 */   // Label 1957: @105673
     /* 105673 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(105718), // Rule ID 4091 //
     /* 105678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105692 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105716 */     GIR_RootConstrainSelectedInstOperands,
     /* 105717 */     // GIR_Coverage, 4091,
     /* 105717 */     GIR_EraseRootFromParent_Done,
     /* 105718 */   // Label 1958: @105718
     /* 105718 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105763), // Rule ID 4092 //
     /* 105723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105737 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105761 */     GIR_RootConstrainSelectedInstOperands,
     /* 105762 */     // GIR_Coverage, 4092,
     /* 105762 */     GIR_EraseRootFromParent_Done,
     /* 105763 */   // Label 1959: @105763
     /* 105763 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105808), // Rule ID 4093 //
     /* 105768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105782 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105806 */     GIR_RootConstrainSelectedInstOperands,
     /* 105807 */     // GIR_Coverage, 4093,
     /* 105807 */     GIR_EraseRootFromParent_Done,
     /* 105808 */   // Label 1960: @105808
     /* 105808 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105848), // Rule ID 4136 //
     /* 105813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105827 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105846 */     GIR_RootConstrainSelectedInstOperands,
     /* 105847 */     // GIR_Coverage, 4136,
     /* 105847 */     GIR_EraseRootFromParent_Done,
     /* 105848 */   // Label 1961: @105848
     /* 105848 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105888), // Rule ID 4140 //
     /* 105853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105867 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105886 */     GIR_RootConstrainSelectedInstOperands,
     /* 105887 */     // GIR_Coverage, 4140,
     /* 105887 */     GIR_EraseRootFromParent_Done,
     /* 105888 */   // Label 1962: @105888
     /* 105888 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105928), // Rule ID 4163 //
     /* 105893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105907 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105926 */     GIR_RootConstrainSelectedInstOperands,
     /* 105927 */     // GIR_Coverage, 4163,
     /* 105927 */     GIR_EraseRootFromParent_Done,
     /* 105928 */   // Label 1963: @105928
     /* 105928 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105968), // Rule ID 4164 //
     /* 105933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105947 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105966 */     GIR_RootConstrainSelectedInstOperands,
     /* 105967 */     // GIR_Coverage, 4164,
     /* 105967 */     GIR_EraseRootFromParent_Done,
     /* 105968 */   // Label 1964: @105968
     /* 105968 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105988), // Rule ID 6405 //
     /* 105973 */     // MIs[0] Rn
     /* 105973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105981 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105986 */     GIR_RootConstrainSelectedInstOperands,
     /* 105987 */     // GIR_Coverage, 6405,
     /* 105987 */     GIR_Done,
     /* 105988 */   // Label 1965: @105988
     /* 105988 */   GIM_Reject,
     /* 105989 */ // Label 1956: @105989
     /* 105989 */ GIM_Reject,
     /* 105990 */ // Label 1831: @105990
     /* 105990 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(106367),
     /* 105995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106006 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(106051), // Rule ID 4082 //
     /* 106011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106025 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106049 */     GIR_RootConstrainSelectedInstOperands,
     /* 106050 */     // GIR_Coverage, 4082,
     /* 106050 */     GIR_EraseRootFromParent_Done,
     /* 106051 */   // Label 1967: @106051
     /* 106051 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(106096), // Rule ID 4083 //
     /* 106056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106070 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106094 */     GIR_RootConstrainSelectedInstOperands,
     /* 106095 */     // GIR_Coverage, 4083,
     /* 106095 */     GIR_EraseRootFromParent_Done,
     /* 106096 */   // Label 1968: @106096
     /* 106096 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(106141), // Rule ID 4084 //
     /* 106101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106115 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106139 */     GIR_RootConstrainSelectedInstOperands,
     /* 106140 */     // GIR_Coverage, 4084,
     /* 106140 */     GIR_EraseRootFromParent_Done,
     /* 106141 */   // Label 1969: @106141
     /* 106141 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(106186), // Rule ID 4085 //
     /* 106146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106160 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106184 */     GIR_RootConstrainSelectedInstOperands,
     /* 106185 */     // GIR_Coverage, 4085,
     /* 106185 */     GIR_EraseRootFromParent_Done,
     /* 106186 */   // Label 1970: @106186
     /* 106186 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(106226), // Rule ID 4130 //
     /* 106191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106205 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106224 */     GIR_RootConstrainSelectedInstOperands,
     /* 106225 */     // GIR_Coverage, 4130,
     /* 106225 */     GIR_EraseRootFromParent_Done,
     /* 106226 */   // Label 1971: @106226
     /* 106226 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(106266), // Rule ID 4132 //
     /* 106231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106245 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106264 */     GIR_RootConstrainSelectedInstOperands,
     /* 106265 */     // GIR_Coverage, 4132,
     /* 106265 */     GIR_EraseRootFromParent_Done,
     /* 106266 */   // Label 1972: @106266
     /* 106266 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(106306), // Rule ID 4158 //
     /* 106271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106285 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106304 */     GIR_RootConstrainSelectedInstOperands,
     /* 106305 */     // GIR_Coverage, 4158,
     /* 106305 */     GIR_EraseRootFromParent_Done,
     /* 106306 */   // Label 1973: @106306
     /* 106306 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(106346), // Rule ID 4160 //
     /* 106311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106325 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106344 */     GIR_RootConstrainSelectedInstOperands,
     /* 106345 */     // GIR_Coverage, 4160,
     /* 106345 */     GIR_EraseRootFromParent_Done,
     /* 106346 */   // Label 1974: @106346
     /* 106346 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(106366), // Rule ID 6407 //
     /* 106351 */     // MIs[0] Rn
     /* 106351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106359 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 106364 */     GIR_RootConstrainSelectedInstOperands,
     /* 106365 */     // GIR_Coverage, 6407,
     /* 106365 */     GIR_Done,
     /* 106366 */   // Label 1975: @106366
     /* 106366 */   GIM_Reject,
     /* 106367 */ // Label 1966: @106367
     /* 106367 */ GIM_Reject,
     /* 106368 */ // Label 1832: @106368
     /* 106368 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(106745),
     /* 106373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106384 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(106429), // Rule ID 4094 //
     /* 106389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106403 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106427 */     GIR_RootConstrainSelectedInstOperands,
     /* 106428 */     // GIR_Coverage, 4094,
     /* 106428 */     GIR_EraseRootFromParent_Done,
     /* 106429 */   // Label 1977: @106429
     /* 106429 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(106474), // Rule ID 4095 //
     /* 106434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106448 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106472 */     GIR_RootConstrainSelectedInstOperands,
     /* 106473 */     // GIR_Coverage, 4095,
     /* 106473 */     GIR_EraseRootFromParent_Done,
     /* 106474 */   // Label 1978: @106474
     /* 106474 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(106519), // Rule ID 4096 //
     /* 106479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106493 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106517 */     GIR_RootConstrainSelectedInstOperands,
     /* 106518 */     // GIR_Coverage, 4096,
     /* 106518 */     GIR_EraseRootFromParent_Done,
     /* 106519 */   // Label 1979: @106519
     /* 106519 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(106564), // Rule ID 4097 //
     /* 106524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106538 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106562 */     GIR_RootConstrainSelectedInstOperands,
     /* 106563 */     // GIR_Coverage, 4097,
     /* 106563 */     GIR_EraseRootFromParent_Done,
     /* 106564 */   // Label 1980: @106564
     /* 106564 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(106604), // Rule ID 4135 //
     /* 106569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106583 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106602 */     GIR_RootConstrainSelectedInstOperands,
     /* 106603 */     // GIR_Coverage, 4135,
     /* 106603 */     GIR_EraseRootFromParent_Done,
     /* 106604 */   // Label 1981: @106604
     /* 106604 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(106644), // Rule ID 4139 //
     /* 106609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106623 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106642 */     GIR_RootConstrainSelectedInstOperands,
     /* 106643 */     // GIR_Coverage, 4139,
     /* 106643 */     GIR_EraseRootFromParent_Done,
     /* 106644 */   // Label 1982: @106644
     /* 106644 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106684), // Rule ID 4165 //
     /* 106649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106663 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106682 */     GIR_RootConstrainSelectedInstOperands,
     /* 106683 */     // GIR_Coverage, 4165,
     /* 106683 */     GIR_EraseRootFromParent_Done,
     /* 106684 */   // Label 1983: @106684
     /* 106684 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(106724), // Rule ID 4166 //
     /* 106689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106703 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106722 */     GIR_RootConstrainSelectedInstOperands,
     /* 106723 */     // GIR_Coverage, 4166,
     /* 106723 */     GIR_EraseRootFromParent_Done,
     /* 106724 */   // Label 1984: @106724
     /* 106724 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(106744), // Rule ID 6404 //
     /* 106729 */     // MIs[0] Rn
     /* 106729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106737 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 106742 */     GIR_RootConstrainSelectedInstOperands,
     /* 106743 */     // GIR_Coverage, 6404,
     /* 106743 */     GIR_Done,
     /* 106744 */   // Label 1985: @106744
     /* 106744 */   GIM_Reject,
     /* 106745 */ // Label 1976: @106745
     /* 106745 */ GIM_Reject,
     /* 106746 */ // Label 1833: @106746
     /* 106746 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106953),
     /* 106751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106762 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106807), // Rule ID 4080 //
     /* 106767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106781 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106805 */     GIR_RootConstrainSelectedInstOperands,
     /* 106806 */     // GIR_Coverage, 4080,
     /* 106806 */     GIR_EraseRootFromParent_Done,
     /* 106807 */   // Label 1987: @106807
     /* 106807 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106852), // Rule ID 4081 //
     /* 106812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106826 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106850 */     GIR_RootConstrainSelectedInstOperands,
     /* 106851 */     // GIR_Coverage, 4081,
     /* 106851 */     GIR_EraseRootFromParent_Done,
     /* 106852 */   // Label 1988: @106852
     /* 106852 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106892), // Rule ID 4129 //
     /* 106857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106871 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106890 */     GIR_RootConstrainSelectedInstOperands,
     /* 106891 */     // GIR_Coverage, 4129,
     /* 106891 */     GIR_EraseRootFromParent_Done,
     /* 106892 */   // Label 1989: @106892
     /* 106892 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106932), // Rule ID 4159 //
     /* 106897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106911 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106930 */     GIR_RootConstrainSelectedInstOperands,
     /* 106931 */     // GIR_Coverage, 4159,
     /* 106931 */     GIR_EraseRootFromParent_Done,
     /* 106932 */   // Label 1990: @106932
     /* 106932 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106952), // Rule ID 6406 //
     /* 106937 */     // MIs[0] Rn
     /* 106937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106945 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106950 */     GIR_RootConstrainSelectedInstOperands,
     /* 106951 */     // GIR_Coverage, 6406,
     /* 106951 */     GIR_Done,
     /* 106952 */   // Label 1991: @106952
     /* 106952 */   GIM_Reject,
     /* 106953 */ // Label 1986: @106953
     /* 106953 */ GIM_Reject,
     /* 106954 */ // Label 1834: @106954
     /* 106954 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(107331),
     /* 106959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106962 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106970 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(107015), // Rule ID 4098 //
     /* 106975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106989 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107013 */     GIR_RootConstrainSelectedInstOperands,
     /* 107014 */     // GIR_Coverage, 4098,
     /* 107014 */     GIR_EraseRootFromParent_Done,
     /* 107015 */   // Label 1993: @107015
     /* 107015 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(107060), // Rule ID 4099 //
     /* 107020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107034 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107058 */     GIR_RootConstrainSelectedInstOperands,
     /* 107059 */     // GIR_Coverage, 4099,
     /* 107059 */     GIR_EraseRootFromParent_Done,
     /* 107060 */   // Label 1994: @107060
     /* 107060 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(107105), // Rule ID 4100 //
     /* 107065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 107079 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 107079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 107082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107103 */     GIR_RootConstrainSelectedInstOperands,
     /* 107104 */     // GIR_Coverage, 4100,
     /* 107104 */     GIR_EraseRootFromParent_Done,
     /* 107105 */   // Label 1995: @107105
     /* 107105 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(107150), // Rule ID 4101 //
     /* 107110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107124 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107148 */     GIR_RootConstrainSelectedInstOperands,
     /* 107149 */     // GIR_Coverage, 4101,
     /* 107149 */     GIR_EraseRootFromParent_Done,
     /* 107150 */   // Label 1996: @107150
     /* 107150 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(107190), // Rule ID 4138 //
     /* 107155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107169 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107188 */     GIR_RootConstrainSelectedInstOperands,
     /* 107189 */     // GIR_Coverage, 4138,
     /* 107189 */     GIR_EraseRootFromParent_Done,
     /* 107190 */   // Label 1997: @107190
     /* 107190 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(107230), // Rule ID 4141 //
     /* 107195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107209 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107228 */     GIR_RootConstrainSelectedInstOperands,
     /* 107229 */     // GIR_Coverage, 4141,
     /* 107229 */     GIR_EraseRootFromParent_Done,
     /* 107230 */   // Label 1998: @107230
     /* 107230 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(107270), // Rule ID 4167 //
     /* 107235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107249 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107268 */     GIR_RootConstrainSelectedInstOperands,
     /* 107269 */     // GIR_Coverage, 4167,
     /* 107269 */     GIR_EraseRootFromParent_Done,
     /* 107270 */   // Label 1999: @107270
     /* 107270 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(107310), // Rule ID 4169 //
     /* 107275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107289 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107308 */     GIR_RootConstrainSelectedInstOperands,
     /* 107309 */     // GIR_Coverage, 4169,
     /* 107309 */     GIR_EraseRootFromParent_Done,
     /* 107310 */   // Label 2000: @107310
     /* 107310 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(107330), // Rule ID 6403 //
     /* 107315 */     // MIs[0] Rn
     /* 107315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107323 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 107328 */     GIR_RootConstrainSelectedInstOperands,
     /* 107329 */     // GIR_Coverage, 6403,
     /* 107329 */     GIR_Done,
     /* 107330 */   // Label 2001: @107330
     /* 107330 */   GIM_Reject,
     /* 107331 */ // Label 1992: @107331
     /* 107331 */ GIM_Reject,
     /* 107332 */ // Label 1835: @107332
     /* 107332 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(107539),
     /* 107337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107348 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(107393), // Rule ID 4102 //
     /* 107353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 107367 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 107367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 107370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107391 */     GIR_RootConstrainSelectedInstOperands,
     /* 107392 */     // GIR_Coverage, 4102,
     /* 107392 */     GIR_EraseRootFromParent_Done,
     /* 107393 */   // Label 2003: @107393
     /* 107393 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(107438), // Rule ID 4103 //
     /* 107398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107412 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107436 */     GIR_RootConstrainSelectedInstOperands,
     /* 107437 */     // GIR_Coverage, 4103,
     /* 107437 */     GIR_EraseRootFromParent_Done,
     /* 107438 */   // Label 2004: @107438
     /* 107438 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(107478), // Rule ID 4137 //
     /* 107443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107457 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107476 */     GIR_RootConstrainSelectedInstOperands,
     /* 107477 */     // GIR_Coverage, 4137,
     /* 107477 */     GIR_EraseRootFromParent_Done,
     /* 107478 */   // Label 2005: @107478
     /* 107478 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(107518), // Rule ID 4168 //
     /* 107483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107497 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107516 */     GIR_RootConstrainSelectedInstOperands,
     /* 107517 */     // GIR_Coverage, 4168,
     /* 107517 */     GIR_EraseRootFromParent_Done,
     /* 107518 */   // Label 2006: @107518
     /* 107518 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(107538), // Rule ID 6402 //
     /* 107523 */     // MIs[0] Rn
     /* 107523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107531 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 107536 */     GIR_RootConstrainSelectedInstOperands,
     /* 107537 */     // GIR_Coverage, 6402,
     /* 107537 */     GIR_Done,
     /* 107538 */   // Label 2007: @107538
     /* 107538 */   GIM_Reject,
     /* 107539 */ // Label 2002: @107539
     /* 107539 */ GIM_Reject,
     /* 107540 */ // Label 1836: @107540
     /* 107540 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(107603), // Rule ID 10976 //
     /* 107545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107559 */   // MIs[0] base
     /* 107559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107567 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 107587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107592 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107601 */   GIR_RootConstrainSelectedInstOperands,
     /* 107602 */   // GIR_Coverage, 10976,
     /* 107602 */   GIR_EraseRootFromParent_Done,
     /* 107603 */ // Label 2008: @107603
     /* 107603 */ GIM_Reject,
     /* 107604 */ // Label 1837: @107604
     /* 107604 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(107667), // Rule ID 10982 //
     /* 107609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107623 */   // MIs[0] base
     /* 107623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107631 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107643 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 107651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107656 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107665 */   GIR_RootConstrainSelectedInstOperands,
     /* 107666 */   // GIR_Coverage, 10982,
     /* 107666 */   GIR_EraseRootFromParent_Done,
     /* 107667 */ // Label 2009: @107667
     /* 107667 */ GIM_Reject,
     /* 107668 */ // Label 1838: @107668
     /* 107668 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107841),
     /* 107673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107688 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(107736), // Rule ID 10967 //
     /* 107693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107700 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107725 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107734 */     GIR_RootConstrainSelectedInstOperands,
     /* 107735 */     // GIR_Coverage, 10967,
     /* 107735 */     GIR_EraseRootFromParent_Done,
     /* 107736 */   // Label 2011: @107736
     /* 107736 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107784), // Rule ID 10985 //
     /* 107741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107748 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107773 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107782 */     GIR_RootConstrainSelectedInstOperands,
     /* 107783 */     // GIR_Coverage, 10985,
     /* 107783 */     GIR_EraseRootFromParent_Done,
     /* 107784 */   // Label 2012: @107784
     /* 107784 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107812), // Rule ID 11012 //
     /* 107789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107796 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107801 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107810 */     GIR_RootConstrainSelectedInstOperands,
     /* 107811 */     // GIR_Coverage, 11012,
     /* 107811 */     GIR_EraseRootFromParent_Done,
     /* 107812 */   // Label 2013: @107812
     /* 107812 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107840), // Rule ID 11024 //
     /* 107817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107824 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107829 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107838 */     GIR_RootConstrainSelectedInstOperands,
     /* 107839 */     // GIR_Coverage, 11024,
     /* 107839 */     GIR_EraseRootFromParent_Done,
     /* 107840 */   // Label 2014: @107840
     /* 107840 */   GIM_Reject,
     /* 107841 */ // Label 2010: @107841
     /* 107841 */ GIM_Reject,
     /* 107842 */ // Label 1839: @107842
     /* 107842 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107905), // Rule ID 10973 //
     /* 107847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107861 */   // MIs[0] base
     /* 107861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107869 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107881 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107894 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107903 */   GIR_RootConstrainSelectedInstOperands,
     /* 107904 */   // GIR_Coverage, 10973,
     /* 107904 */   GIR_EraseRootFromParent_Done,
     /* 107905 */ // Label 2015: @107905
     /* 107905 */ GIM_Reject,
     /* 107906 */ // Label 1840: @107906
     /* 107906 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(108079),
     /* 107911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107926 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107974), // Rule ID 10955 //
     /* 107931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107938 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107963 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107972 */     GIR_RootConstrainSelectedInstOperands,
     /* 107973 */     // GIR_Coverage, 10955,
     /* 107973 */     GIR_EraseRootFromParent_Done,
     /* 107974 */   // Label 2017: @107974
     /* 107974 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(108022), // Rule ID 10979 //
     /* 107979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107986 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 108006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108011 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108020 */     GIR_RootConstrainSelectedInstOperands,
     /* 108021 */     // GIR_Coverage, 10979,
     /* 108021 */     GIR_EraseRootFromParent_Done,
     /* 108022 */   // Label 2018: @108022
     /* 108022 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(108050), // Rule ID 11008 //
     /* 108027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108034 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108039 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108048 */     GIR_RootConstrainSelectedInstOperands,
     /* 108049 */     // GIR_Coverage, 11008,
     /* 108049 */     GIR_EraseRootFromParent_Done,
     /* 108050 */   // Label 2019: @108050
     /* 108050 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(108078), // Rule ID 11020 //
     /* 108055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108062 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108067 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108076 */     GIR_RootConstrainSelectedInstOperands,
     /* 108077 */     // GIR_Coverage, 11020,
     /* 108077 */     GIR_EraseRootFromParent_Done,
     /* 108078 */   // Label 2020: @108078
     /* 108078 */   GIM_Reject,
     /* 108079 */ // Label 2016: @108079
     /* 108079 */ GIM_Reject,
     /* 108080 */ // Label 1841: @108080
     /* 108080 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(108253),
     /* 108085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 108096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108100 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(108148), // Rule ID 10934 //
     /* 108105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108112 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108137 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108146 */     GIR_RootConstrainSelectedInstOperands,
     /* 108147 */     // GIR_Coverage, 10934,
     /* 108147 */     GIR_EraseRootFromParent_Done,
     /* 108148 */   // Label 2022: @108148
     /* 108148 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108196), // Rule ID 10970 //
     /* 108153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108160 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108185 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108194 */     GIR_RootConstrainSelectedInstOperands,
     /* 108195 */     // GIR_Coverage, 10970,
     /* 108195 */     GIR_EraseRootFromParent_Done,
     /* 108196 */   // Label 2023: @108196
     /* 108196 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(108224), // Rule ID 11004 //
     /* 108201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108208 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108213 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108222 */     GIR_RootConstrainSelectedInstOperands,
     /* 108223 */     // GIR_Coverage, 11004,
     /* 108223 */     GIR_EraseRootFromParent_Done,
     /* 108224 */   // Label 2024: @108224
     /* 108224 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108252), // Rule ID 11016 //
     /* 108229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108236 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108241 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108250 */     GIR_RootConstrainSelectedInstOperands,
     /* 108251 */     // GIR_Coverage, 11016,
     /* 108251 */     GIR_EraseRootFromParent_Done,
     /* 108252 */   // Label 2025: @108252
     /* 108252 */   GIM_Reject,
     /* 108253 */ // Label 2021: @108253
     /* 108253 */ GIM_Reject,
     /* 108254 */ // Label 1842: @108254
     /* 108254 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108297), // Rule ID 2428 //
     /* 108259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108262 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108265 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 108273 */   // MIs[0] base
     /* 108273 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108281 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 108284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 108286 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108295 */   GIR_RootConstrainSelectedInstOperands,
     /* 108296 */   // GIR_Coverage, 2428,
     /* 108296 */   GIR_EraseRootFromParent_Done,
     /* 108297 */ // Label 2026: @108297
     /* 108297 */ GIM_Reject,
     /* 108298 */ // Label 1843: @108298
     /* 108298 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108395),
     /* 108303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 108314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108318 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(108366), // Rule ID 10902 //
     /* 108323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108330 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 108337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 108350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108355 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108364 */     GIR_RootConstrainSelectedInstOperands,
     /* 108365 */     // GIR_Coverage, 10902,
     /* 108365 */     GIR_EraseRootFromParent_Done,
     /* 108366 */   // Label 2028: @108366
     /* 108366 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108394), // Rule ID 11000 //
     /* 108371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108378 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108383 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108392 */     GIR_RootConstrainSelectedInstOperands,
     /* 108393 */     // GIR_Coverage, 11000,
     /* 108393 */     GIR_EraseRootFromParent_Done,
     /* 108394 */   // Label 2029: @108394
     /* 108394 */   GIM_Reject,
     /* 108395 */ // Label 2027: @108395
     /* 108395 */ GIM_Reject,
     /* 108396 */ // Label 1844: @108396
     /* 108396 */ GIM_Reject,
     /* 108397 */ // Label 17: @108397
     /* 108397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2032*/ GIMT_Encode4(109446),
     /* 108408 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(108416),
     /* 108412 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(108830),
     /* 108416 */ // Label 2030: @108416
     /* 108416 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108829),
     /* 108421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108424 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108477), // Rule ID 247 //
     /* 108429 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108451 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 108454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108475 */     GIR_RootConstrainSelectedInstOperands,
     /* 108476 */     // GIR_Coverage, 247,
     /* 108476 */     GIR_EraseRootFromParent_Done,
     /* 108477 */   // Label 2034: @108477
     /* 108477 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108530), // Rule ID 248 //
     /* 108482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108504 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 108507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108528 */     GIR_RootConstrainSelectedInstOperands,
     /* 108529 */     // GIR_Coverage, 248,
     /* 108529 */     GIR_EraseRootFromParent_Done,
     /* 108530 */   // Label 2035: @108530
     /* 108530 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108583), // Rule ID 251 //
     /* 108535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108557 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 108560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108581 */     GIR_RootConstrainSelectedInstOperands,
     /* 108582 */     // GIR_Coverage, 251,
     /* 108582 */     GIR_EraseRootFromParent_Done,
     /* 108583 */   // Label 2036: @108583
     /* 108583 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108636), // Rule ID 252 //
     /* 108588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108610 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 108613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108634 */     GIR_RootConstrainSelectedInstOperands,
     /* 108635 */     // GIR_Coverage, 252,
     /* 108635 */     GIR_EraseRootFromParent_Done,
     /* 108636 */   // Label 2037: @108636
     /* 108636 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108684), // Rule ID 268 //
     /* 108641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108663 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 108666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108682 */     GIR_RootConstrainSelectedInstOperands,
     /* 108683 */     // GIR_Coverage, 268,
     /* 108683 */     GIR_EraseRootFromParent_Done,
     /* 108684 */   // Label 2038: @108684
     /* 108684 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108732), // Rule ID 270 //
     /* 108689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108711 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 108714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108730 */     GIR_RootConstrainSelectedInstOperands,
     /* 108731 */     // GIR_Coverage, 270,
     /* 108731 */     GIR_EraseRootFromParent_Done,
     /* 108732 */   // Label 2039: @108732
     /* 108732 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108780), // Rule ID 289 //
     /* 108737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108759 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 108762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108778 */     GIR_RootConstrainSelectedInstOperands,
     /* 108779 */     // GIR_Coverage, 289,
     /* 108779 */     GIR_EraseRootFromParent_Done,
     /* 108780 */   // Label 2040: @108780
     /* 108780 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108828), // Rule ID 291 //
     /* 108785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108807 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 108810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108826 */     GIR_RootConstrainSelectedInstOperands,
     /* 108827 */     // GIR_Coverage, 291,
     /* 108827 */     GIR_EraseRootFromParent_Done,
     /* 108828 */   // Label 2041: @108828
     /* 108828 */   GIM_Reject,
     /* 108829 */ // Label 2033: @108829
     /* 108829 */ GIM_Reject,
     /* 108830 */ // Label 2031: @108830
     /* 108830 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(109445),
     /* 108835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108838 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108891), // Rule ID 249 //
     /* 108843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108865 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 108868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108889 */     GIR_RootConstrainSelectedInstOperands,
     /* 108890 */     // GIR_Coverage, 249,
     /* 108890 */     GIR_EraseRootFromParent_Done,
     /* 108891 */   // Label 2043: @108891
     /* 108891 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108944), // Rule ID 250 //
     /* 108896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108918 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108942 */     GIR_RootConstrainSelectedInstOperands,
     /* 108943 */     // GIR_Coverage, 250,
     /* 108943 */     GIR_EraseRootFromParent_Done,
     /* 108944 */   // Label 2044: @108944
     /* 108944 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108997), // Rule ID 253 //
     /* 108949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108971 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108995 */     GIR_RootConstrainSelectedInstOperands,
     /* 108996 */     // GIR_Coverage, 253,
     /* 108996 */     GIR_EraseRootFromParent_Done,
     /* 108997 */   // Label 2045: @108997
     /* 108997 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109050), // Rule ID 254 //
     /* 109002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109024 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 109027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109048 */     GIR_RootConstrainSelectedInstOperands,
     /* 109049 */     // GIR_Coverage, 254,
     /* 109049 */     GIR_EraseRootFromParent_Done,
     /* 109050 */   // Label 2046: @109050
     /* 109050 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109103), // Rule ID 255 //
     /* 109055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109077 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 109080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109101 */     GIR_RootConstrainSelectedInstOperands,
     /* 109102 */     // GIR_Coverage, 255,
     /* 109102 */     GIR_EraseRootFromParent_Done,
     /* 109103 */   // Label 2047: @109103
     /* 109103 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109156), // Rule ID 256 //
     /* 109108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109130 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 109133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109154 */     GIR_RootConstrainSelectedInstOperands,
     /* 109155 */     // GIR_Coverage, 256,
     /* 109155 */     GIR_EraseRootFromParent_Done,
     /* 109156 */   // Label 2048: @109156
     /* 109156 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109204), // Rule ID 269 //
     /* 109161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109183 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 109186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109202 */     GIR_RootConstrainSelectedInstOperands,
     /* 109203 */     // GIR_Coverage, 269,
     /* 109203 */     GIR_EraseRootFromParent_Done,
     /* 109204 */   // Label 2049: @109204
     /* 109204 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109252), // Rule ID 271 //
     /* 109209 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109231 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 109234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109250 */     GIR_RootConstrainSelectedInstOperands,
     /* 109251 */     // GIR_Coverage, 271,
     /* 109251 */     GIR_EraseRootFromParent_Done,
     /* 109252 */   // Label 2050: @109252
     /* 109252 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109300), // Rule ID 272 //
     /* 109257 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 109279 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 109279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 109282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109298 */     GIR_RootConstrainSelectedInstOperands,
     /* 109299 */     // GIR_Coverage, 272,
     /* 109299 */     GIR_EraseRootFromParent_Done,
     /* 109300 */   // Label 2051: @109300
     /* 109300 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109348), // Rule ID 290 //
     /* 109305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109327 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 109330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109346 */     GIR_RootConstrainSelectedInstOperands,
     /* 109347 */     // GIR_Coverage, 290,
     /* 109347 */     GIR_EraseRootFromParent_Done,
     /* 109348 */   // Label 2052: @109348
     /* 109348 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109396), // Rule ID 292 //
     /* 109353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109375 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 109378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109394 */     GIR_RootConstrainSelectedInstOperands,
     /* 109395 */     // GIR_Coverage, 292,
     /* 109395 */     GIR_EraseRootFromParent_Done,
     /* 109396 */   // Label 2053: @109396
     /* 109396 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109444), // Rule ID 293 //
     /* 109401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 109423 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 109426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109442 */     GIR_RootConstrainSelectedInstOperands,
     /* 109443 */     // GIR_Coverage, 293,
     /* 109443 */     GIR_EraseRootFromParent_Done,
     /* 109444 */   // Label 2054: @109444
     /* 109444 */   GIM_Reject,
     /* 109445 */ // Label 2042: @109445
     /* 109445 */ GIM_Reject,
     /* 109446 */ // Label 2032: @109446
     /* 109446 */ GIM_Reject,
     /* 109447 */ // Label 18: @109447
     /* 109447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2057*/ GIMT_Encode4(112495),
     /* 109458 */ /*GILLT_s32*//*Label 2055*/ GIMT_Encode4(109466),
     /* 109462 */ /*GILLT_s64*//*Label 2056*/ GIMT_Encode4(111005),
     /* 109466 */ // Label 2055: @109466
     /* 109466 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109522), // Rule ID 229 //
     /* 109471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109496 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109520 */   GIR_RootConstrainSelectedInstOperands,
     /* 109521 */   // GIR_Coverage, 229,
     /* 109521 */   GIR_EraseRootFromParent_Done,
     /* 109522 */ // Label 2058: @109522
     /* 109522 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109578), // Rule ID 230 //
     /* 109527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109552 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109576 */   GIR_RootConstrainSelectedInstOperands,
     /* 109577 */   // GIR_Coverage, 230,
     /* 109577 */   GIR_EraseRootFromParent_Done,
     /* 109578 */ // Label 2059: @109578
     /* 109578 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109634), // Rule ID 231 //
     /* 109583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109608 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109632 */   GIR_RootConstrainSelectedInstOperands,
     /* 109633 */   // GIR_Coverage, 231,
     /* 109633 */   GIR_EraseRootFromParent_Done,
     /* 109634 */ // Label 2060: @109634
     /* 109634 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109690), // Rule ID 232 //
     /* 109639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109664 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109688 */   GIR_RootConstrainSelectedInstOperands,
     /* 109689 */   // GIR_Coverage, 232,
     /* 109689 */   GIR_EraseRootFromParent_Done,
     /* 109690 */ // Label 2061: @109690
     /* 109690 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109746), // Rule ID 4126 //
     /* 109695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109720 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109744 */   GIR_RootConstrainSelectedInstOperands,
     /* 109745 */   // GIR_Coverage, 4126,
     /* 109745 */   GIR_EraseRootFromParent_Done,
     /* 109746 */ // Label 2062: @109746
     /* 109746 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109802), // Rule ID 4127 //
     /* 109751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109776 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109796 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109800 */   GIR_RootConstrainSelectedInstOperands,
     /* 109801 */   // GIR_Coverage, 4127,
     /* 109801 */   GIR_EraseRootFromParent_Done,
     /* 109802 */ // Label 2063: @109802
     /* 109802 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109853), // Rule ID 266 //
     /* 109807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109832 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109851 */   GIR_RootConstrainSelectedInstOperands,
     /* 109852 */   // GIR_Coverage, 266,
     /* 109852 */   GIR_EraseRootFromParent_Done,
     /* 109853 */ // Label 2064: @109853
     /* 109853 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109904), // Rule ID 267 //
     /* 109858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109861 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109883 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109902 */   GIR_RootConstrainSelectedInstOperands,
     /* 109903 */   // GIR_Coverage, 267,
     /* 109903 */   GIR_EraseRootFromParent_Done,
     /* 109904 */ // Label 2065: @109904
     /* 109904 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109963), // Rule ID 7037 //
     /* 109909 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109919 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109937 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109961 */   GIR_RootConstrainSelectedInstOperands,
     /* 109962 */   // GIR_Coverage, 7037,
     /* 109962 */   GIR_EraseRootFromParent_Done,
     /* 109963 */ // Label 2066: @109963
     /* 109963 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110022), // Rule ID 7039 //
     /* 109968 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109971 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109978 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109989 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109996 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110020 */   GIR_RootConstrainSelectedInstOperands,
     /* 110021 */   // GIR_Coverage, 7039,
     /* 110021 */   GIR_EraseRootFromParent_Done,
     /* 110022 */ // Label 2067: @110022
     /* 110022 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110081), // Rule ID 7049 //
     /* 110027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110037 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110055 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 110055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110079 */   GIR_RootConstrainSelectedInstOperands,
     /* 110080 */   // GIR_Coverage, 7049,
     /* 110080 */   GIR_EraseRootFromParent_Done,
     /* 110081 */ // Label 2068: @110081
     /* 110081 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110140), // Rule ID 7051 //
     /* 110086 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110096 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110103 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110114 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 110114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110138 */   GIR_RootConstrainSelectedInstOperands,
     /* 110139 */   // GIR_Coverage, 7051,
     /* 110139 */   GIR_EraseRootFromParent_Done,
     /* 110140 */ // Label 2069: @110140
     /* 110140 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110191), // Rule ID 287 //
     /* 110145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110170 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110189 */   GIR_RootConstrainSelectedInstOperands,
     /* 110190 */   // GIR_Coverage, 287,
     /* 110190 */   GIR_EraseRootFromParent_Done,
     /* 110191 */ // Label 2070: @110191
     /* 110191 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110242), // Rule ID 288 //
     /* 110196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110199 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110221 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110240 */   GIR_RootConstrainSelectedInstOperands,
     /* 110241 */   // GIR_Coverage, 288,
     /* 110241 */   GIR_EraseRootFromParent_Done,
     /* 110242 */ // Label 2071: @110242
     /* 110242 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110293), // Rule ID 4145 //
     /* 110247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110250 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110272 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110291 */   GIR_RootConstrainSelectedInstOperands,
     /* 110292 */   // GIR_Coverage, 4145,
     /* 110292 */   GIR_EraseRootFromParent_Done,
     /* 110293 */ // Label 2072: @110293
     /* 110293 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110344), // Rule ID 4177 //
     /* 110298 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110323 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110342 */   GIR_RootConstrainSelectedInstOperands,
     /* 110343 */   // GIR_Coverage, 4177,
     /* 110343 */   GIR_EraseRootFromParent_Done,
     /* 110344 */ // Label 2073: @110344
     /* 110344 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110395), // Rule ID 4178 //
     /* 110349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110352 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110367 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110374 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110393 */   GIR_RootConstrainSelectedInstOperands,
     /* 110394 */   // GIR_Coverage, 4178,
     /* 110394 */   GIR_EraseRootFromParent_Done,
     /* 110395 */ // Label 2074: @110395
     /* 110395 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110446), // Rule ID 4179 //
     /* 110400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110425 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110444 */   GIR_RootConstrainSelectedInstOperands,
     /* 110445 */   // GIR_Coverage, 4179,
     /* 110445 */   GIR_EraseRootFromParent_Done,
     /* 110446 */ // Label 2075: @110446
     /* 110446 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110500), // Rule ID 7041 //
     /* 110451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110461 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110479 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15876>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110498 */   GIR_RootConstrainSelectedInstOperands,
     /* 110499 */   // GIR_Coverage, 7041,
     /* 110499 */   GIR_EraseRootFromParent_Done,
     /* 110500 */ // Label 2076: @110500
     /* 110500 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110554), // Rule ID 7043 //
     /* 110505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110515 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110533 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15876>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110552 */   GIR_RootConstrainSelectedInstOperands,
     /* 110553 */   // GIR_Coverage, 7043,
     /* 110553 */   GIR_EraseRootFromParent_Done,
     /* 110554 */ // Label 2077: @110554
     /* 110554 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110608), // Rule ID 7053 //
     /* 110559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110569 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110587 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15884>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110606 */   GIR_RootConstrainSelectedInstOperands,
     /* 110607 */   // GIR_Coverage, 7053,
     /* 110607 */   GIR_EraseRootFromParent_Done,
     /* 110608 */ // Label 2078: @110608
     /* 110608 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110662), // Rule ID 7055 //
     /* 110613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110623 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110641 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15884>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110660 */   GIR_RootConstrainSelectedInstOperands,
     /* 110661 */   // GIR_Coverage, 7055,
     /* 110661 */   GIR_EraseRootFromParent_Done,
     /* 110662 */ // Label 2079: @110662
     /* 110662 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110719), // Rule ID 7447 //
     /* 110667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110698 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15865>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 110701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110717 */   GIR_RootConstrainSelectedInstOperands,
     /* 110718 */   // GIR_Coverage, 7447,
     /* 110718 */   GIR_EraseRootFromParent_Done,
     /* 110719 */ // Label 2080: @110719
     /* 110719 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110776), // Rule ID 7449 //
     /* 110724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110755 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15867>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 110758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110774 */   GIR_RootConstrainSelectedInstOperands,
     /* 110775 */   // GIR_Coverage, 7449,
     /* 110775 */   GIR_EraseRootFromParent_Done,
     /* 110776 */ // Label 2081: @110776
     /* 110776 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110816), // Rule ID 7027 //
     /* 110781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110801 */   // MIs[0] ptr
     /* 110801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110809 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15865>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 110814 */   GIR_RootConstrainSelectedInstOperands,
     /* 110815 */   // GIR_Coverage, 7027,
     /* 110815 */   GIR_Done,
     /* 110816 */ // Label 2082: @110816
     /* 110816 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110856), // Rule ID 7029 //
     /* 110821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110834 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110841 */   // MIs[0] ptr
     /* 110841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110849 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15867>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 110854 */   GIR_RootConstrainSelectedInstOperands,
     /* 110855 */   // GIR_Coverage, 7029,
     /* 110855 */   GIR_Done,
     /* 110856 */ // Label 2083: @110856
     /* 110856 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110893), // Rule ID 7033 //
     /* 110861 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110878 */   // MIs[0] ptr
     /* 110878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110886 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15873>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110891 */   GIR_RootConstrainSelectedInstOperands,
     /* 110892 */   // GIR_Coverage, 7033,
     /* 110892 */   GIR_Done,
     /* 110893 */ // Label 2084: @110893
     /* 110893 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110930), // Rule ID 7035 //
     /* 110898 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110901 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110908 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110915 */   // MIs[0] ptr
     /* 110915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110923 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15865>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110928 */   GIR_RootConstrainSelectedInstOperands,
     /* 110929 */   // GIR_Coverage, 7035,
     /* 110929 */   GIR_Done,
     /* 110930 */ // Label 2085: @110930
     /* 110930 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110967), // Rule ID 7045 //
     /* 110935 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110952 */   // MIs[0] ptr
     /* 110952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110960 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15881>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110965 */   GIR_RootConstrainSelectedInstOperands,
     /* 110966 */   // GIR_Coverage, 7045,
     /* 110966 */   GIR_Done,
     /* 110967 */ // Label 2086: @110967
     /* 110967 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(111004), // Rule ID 7047 //
     /* 110972 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110989 */   // MIs[0] ptr
     /* 110989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110997 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15867>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 111002 */   GIR_RootConstrainSelectedInstOperands,
     /* 111003 */   // GIR_Coverage, 7047,
     /* 111003 */   GIR_Done,
     /* 111004 */ // Label 2087: @111004
     /* 111004 */ GIM_Reject,
     /* 111005 */ // Label 2056: @111005
     /* 111005 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(112494),
     /* 111010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111013 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(111098), // Rule ID 4104 //
     /* 111018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111040 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111067 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111097 */     // GIR_Coverage, 4104,
     /* 111097 */     GIR_EraseRootFromParent_Done,
     /* 111098 */   // Label 2089: @111098
     /* 111098 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(111183), // Rule ID 4105 //
     /* 111103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111125 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111182 */     // GIR_Coverage, 4105,
     /* 111182 */     GIR_EraseRootFromParent_Done,
     /* 111183 */   // Label 2090: @111183
     /* 111183 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(111268), // Rule ID 4106 //
     /* 111188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111210 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 111217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111267 */     // GIR_Coverage, 4106,
     /* 111267 */     GIR_EraseRootFromParent_Done,
     /* 111268 */   // Label 2091: @111268
     /* 111268 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111353), // Rule ID 4107 //
     /* 111273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111295 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 111302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111322 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111352 */     // GIR_Coverage, 4107,
     /* 111352 */     GIR_EraseRootFromParent_Done,
     /* 111353 */   // Label 2092: @111353
     /* 111353 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111438), // Rule ID 4108 //
     /* 111358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 111380 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 111387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111407 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111437 */     // GIR_Coverage, 4108,
     /* 111437 */     GIR_EraseRootFromParent_Done,
     /* 111438 */   // Label 2093: @111438
     /* 111438 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111523), // Rule ID 4109 //
     /* 111443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 111465 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 111472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111522 */     // GIR_Coverage, 4109,
     /* 111522 */     GIR_EraseRootFromParent_Done,
     /* 111523 */   // Label 2094: @111523
     /* 111523 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111608), // Rule ID 4110 //
     /* 111528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111550 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111607 */     // GIR_Coverage, 4110,
     /* 111607 */     GIR_EraseRootFromParent_Done,
     /* 111608 */   // Label 2095: @111608
     /* 111608 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111693), // Rule ID 4111 //
     /* 111613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111635 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111662 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111692 */     // GIR_Coverage, 4111,
     /* 111692 */     GIR_EraseRootFromParent_Done,
     /* 111693 */   // Label 2096: @111693
     /* 111693 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111773), // Rule ID 4143 //
     /* 111698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111720 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111742 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111772 */     // GIR_Coverage, 4143,
     /* 111772 */     GIR_EraseRootFromParent_Done,
     /* 111773 */   // Label 2097: @111773
     /* 111773 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111853), // Rule ID 4144 //
     /* 111778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111800 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 111807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111822 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111852 */     // GIR_Coverage, 4144,
     /* 111852 */     GIR_EraseRootFromParent_Done,
     /* 111853 */   // Label 2098: @111853
     /* 111853 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111933), // Rule ID 4146 //
     /* 111858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111880 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111932 */     // GIR_Coverage, 4146,
     /* 111932 */     GIR_EraseRootFromParent_Done,
     /* 111933 */   // Label 2099: @111933
     /* 111933 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(112013), // Rule ID 4154 //
     /* 111938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111960 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111982 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112012 */     // GIR_Coverage, 4154,
     /* 112012 */     GIR_EraseRootFromParent_Done,
     /* 112013 */   // Label 2100: @112013
     /* 112013 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(112093), // Rule ID 4180 //
     /* 112018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 112040 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 112047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112062 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112092 */     // GIR_Coverage, 4180,
     /* 112092 */     GIR_EraseRootFromParent_Done,
     /* 112093 */   // Label 2101: @112093
     /* 112093 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(112173), // Rule ID 4181 //
     /* 112098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112120 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112142 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112172 */     // GIR_Coverage, 4181,
     /* 112172 */     GIR_EraseRootFromParent_Done,
     /* 112173 */   // Label 2102: @112173
     /* 112173 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(112253), // Rule ID 4182 //
     /* 112178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112200 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112222 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112252 */     // GIR_Coverage, 4182,
     /* 112252 */     GIR_EraseRootFromParent_Done,
     /* 112253 */   // Label 2103: @112253
     /* 112253 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(112333), // Rule ID 4183 //
     /* 112258 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112280 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112302 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112332 */     // GIR_Coverage, 4183,
     /* 112332 */     GIR_EraseRootFromParent_Done,
     /* 112333 */   // Label 2104: @112333
     /* 112333 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(112413), // Rule ID 4184 //
     /* 112338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112360 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112382 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112412 */     // GIR_Coverage, 4184,
     /* 112412 */     GIR_EraseRootFromParent_Done,
     /* 112413 */   // Label 2105: @112413
     /* 112413 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(112493), // Rule ID 4185 //
     /* 112418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112440 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112492 */     // GIR_Coverage, 4185,
     /* 112492 */     GIR_EraseRootFromParent_Done,
     /* 112493 */   // Label 2106: @112493
     /* 112493 */   GIM_Reject,
     /* 112494 */ // Label 2088: @112494
     /* 112494 */ GIM_Reject,
     /* 112495 */ // Label 2057: @112495
     /* 112495 */ GIM_Reject,
     /* 112496 */ // Label 19: @112496
     /* 112496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2127*/ GIMT_Encode4(126021),
     /* 112507 */ /*GILLT_s8*//*Label 2107*/ GIMT_Encode4(112603),
     /* 112511 */ /*GILLT_s16*//*Label 2108*/ GIMT_Encode4(112970),
     /* 112515 */ /*GILLT_s32*//*Label 2109*/ GIMT_Encode4(114109),
     /* 112519 */ /*GILLT_s64*//*Label 2110*/ GIMT_Encode4(118704),
     /* 112523 */ /*GILLT_s128*//*Label 2111*/ GIMT_Encode4(122473),
     /* 112527 */ /*GILLT_v2s32*//*Label 2112*/ GIMT_Encode4(122679),
     /* 112531 */ /*GILLT_v2s64*//*Label 2113*/ GIMT_Encode4(123085),
     /* 112535 */ /*GILLT_v4s16*//*Label 2114*/ GIMT_Encode4(123535),
     /* 112539 */ /*GILLT_v4s32*//*Label 2115*/ GIMT_Encode4(123941),
     /* 112543 */ /*GILLT_v8s8*//*Label 2116*/ GIMT_Encode4(124347),
     /* 112547 */ /*GILLT_v8s16*//*Label 2117*/ GIMT_Encode4(124567),
     /* 112551 */ /*GILLT_v16s8*//*Label 2118*/ GIMT_Encode4(124973), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112563 */ /*GILLT_nxv2s16*//*Label 2119*/ GIMT_Encode4(125193),
     /* 112567 */ /*GILLT_nxv2s32*//*Label 2120*/ GIMT_Encode4(125253),
     /* 112571 */ /*GILLT_nxv2s64*//*Label 2121*/ GIMT_Encode4(125313), GIMT_Encode4(0),
     /* 112579 */ /*GILLT_nxv4s16*//*Label 2122*/ GIMT_Encode4(125483),
     /* 112583 */ /*GILLT_nxv4s32*//*Label 2123*/ GIMT_Encode4(125543), GIMT_Encode4(0),
     /* 112591 */ /*GILLT_nxv8s16*//*Label 2124*/ GIMT_Encode4(125713),
     /* 112595 */ /*GILLT_nxv16s1*//*Label 2125*/ GIMT_Encode4(125883),
     /* 112599 */ /*GILLT_nxv16s8*//*Label 2126*/ GIMT_Encode4(125927),
     /* 112603 */ // Label 2107: @112603
     /* 112603 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112969),
     /* 112608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112615 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112683), // Rule ID 13212 //
     /* 112620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112649 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112653 */     // MIs[2] Operand 1
     /* 112653 */     // No operand predicates
     /* 112653 */     // MIs[0] Rn
     /* 112653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112663 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112681 */     GIR_RootConstrainSelectedInstOperands,
     /* 112682 */     // GIR_Coverage, 13212,
     /* 112682 */     GIR_EraseRootFromParent_Done,
     /* 112683 */   // Label 2129: @112683
     /* 112683 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112782), // Rule ID 13213 //
     /* 112688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112721 */     // MIs[2] Operand 1
     /* 112721 */     // No operand predicates
     /* 112721 */     // MIs[0] Rn
     /* 112721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112731 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112780 */     GIR_RootConstrainSelectedInstOperands,
     /* 112781 */     // GIR_Coverage, 13213,
     /* 112781 */     GIR_EraseRootFromParent_Done,
     /* 112782 */   // Label 2130: @112782
     /* 112782 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112831), // Rule ID 303 //
     /* 112787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112805 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 112808 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112829 */     GIR_RootConstrainSelectedInstOperands,
     /* 112830 */     // GIR_Coverage, 303,
     /* 112830 */     GIR_EraseRootFromParent_Done,
     /* 112831 */   // Label 2131: @112831
     /* 112831 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112880), // Rule ID 304 //
     /* 112836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112854 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 112857 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112878 */     GIR_RootConstrainSelectedInstOperands,
     /* 112879 */     // GIR_Coverage, 304,
     /* 112879 */     GIR_EraseRootFromParent_Done,
     /* 112880 */   // Label 2132: @112880
     /* 112880 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112924), // Rule ID 313 //
     /* 112885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112903 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 112906 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112922 */     GIR_RootConstrainSelectedInstOperands,
     /* 112923 */     // GIR_Coverage, 313,
     /* 112923 */     GIR_EraseRootFromParent_Done,
     /* 112924 */   // Label 2133: @112924
     /* 112924 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112968), // Rule ID 321 //
     /* 112929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112947 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 112947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 112950 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112966 */     GIR_RootConstrainSelectedInstOperands,
     /* 112967 */     // GIR_Coverage, 321,
     /* 112967 */     GIR_EraseRootFromParent_Done,
     /* 112968 */   // Label 2134: @112968
     /* 112968 */   GIM_Reject,
     /* 112969 */ // Label 2128: @112969
     /* 112969 */ GIM_Reject,
     /* 112970 */ // Label 2108: @112970
     /* 112970 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(114108),
     /* 112975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112982 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113081), // Rule ID 4482 //
     /* 112987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113025 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113079 */     GIR_RootConstrainSelectedInstOperands,
     /* 113080 */     // GIR_Coverage, 4482,
     /* 113080 */     GIR_EraseRootFromParent_Done,
     /* 113081 */   // Label 2136: @113081
     /* 113081 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113180), // Rule ID 4483 //
     /* 113086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113107 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113124 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113178 */     GIR_RootConstrainSelectedInstOperands,
     /* 113179 */     // GIR_Coverage, 4483,
     /* 113179 */     GIR_EraseRootFromParent_Done,
     /* 113180 */   // Label 2137: @113180
     /* 113180 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113279), // Rule ID 13210 //
     /* 113185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113223 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113277 */     GIR_RootConstrainSelectedInstOperands,
     /* 113278 */     // GIR_Coverage, 13210,
     /* 113278 */     GIR_EraseRootFromParent_Done,
     /* 113279 */   // Label 2138: @113279
     /* 113279 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(113378), // Rule ID 13211 //
     /* 113284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113322 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113376 */     GIR_RootConstrainSelectedInstOperands,
     /* 113377 */     // GIR_Coverage, 13211,
     /* 113377 */     GIR_EraseRootFromParent_Done,
     /* 113378 */   // Label 2139: @113378
     /* 113378 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113472), // Rule ID 4511 //
     /* 113383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113404 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113421 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113433 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113470 */     GIR_RootConstrainSelectedInstOperands,
     /* 113471 */     // GIR_Coverage, 4511,
     /* 113471 */     GIR_EraseRootFromParent_Done,
     /* 113472 */   // Label 2140: @113472
     /* 113472 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113566), // Rule ID 4538 //
     /* 113477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113498 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113515 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113527 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113564 */     GIR_RootConstrainSelectedInstOperands,
     /* 113565 */     // GIR_Coverage, 4538,
     /* 113565 */     GIR_EraseRootFromParent_Done,
     /* 113566 */   // Label 2141: @113566
     /* 113566 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113660), // Rule ID 13209 //
     /* 113571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113592 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113609 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113621 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113658 */     GIR_RootConstrainSelectedInstOperands,
     /* 113659 */     // GIR_Coverage, 13209,
     /* 113659 */     GIR_EraseRootFromParent_Done,
     /* 113660 */   // Label 2142: @113660
     /* 113660 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113754), // Rule ID 13215 //
     /* 113665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 113703 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113715 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113752 */     GIR_RootConstrainSelectedInstOperands,
     /* 113753 */     // GIR_Coverage, 13215,
     /* 113753 */     GIR_EraseRootFromParent_Done,
     /* 113754 */   // Label 2143: @113754
     /* 113754 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113822), // Rule ID 6469 //
     /* 113759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113792 */     // MIs[2] Operand 1
     /* 113792 */     // No operand predicates
     /* 113792 */     // MIs[0] Rn
     /* 113792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113802 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113820 */     GIR_RootConstrainSelectedInstOperands,
     /* 113821 */     // GIR_Coverage, 6469,
     /* 113821 */     GIR_EraseRootFromParent_Done,
     /* 113822 */   // Label 2144: @113822
     /* 113822 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113921), // Rule ID 6474 //
     /* 113827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113860 */     // MIs[2] Operand 1
     /* 113860 */     // No operand predicates
     /* 113860 */     // MIs[0] Rn
     /* 113860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113870 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 113885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 113892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113919 */     GIR_RootConstrainSelectedInstOperands,
     /* 113920 */     // GIR_Coverage, 6474,
     /* 113920 */     GIR_EraseRootFromParent_Done,
     /* 113921 */   // Label 2145: @113921
     /* 113921 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113970), // Rule ID 305 //
     /* 113926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113944 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113947 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113968 */     GIR_RootConstrainSelectedInstOperands,
     /* 113969 */     // GIR_Coverage, 305,
     /* 113969 */     GIR_EraseRootFromParent_Done,
     /* 113970 */   // Label 2146: @113970
     /* 113970 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(114019), // Rule ID 306 //
     /* 113975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113993 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113996 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114017 */     GIR_RootConstrainSelectedInstOperands,
     /* 114018 */     // GIR_Coverage, 306,
     /* 114018 */     GIR_EraseRootFromParent_Done,
     /* 114019 */   // Label 2147: @114019
     /* 114019 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(114063), // Rule ID 314 //
     /* 114024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114042 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114045 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114061 */     GIR_RootConstrainSelectedInstOperands,
     /* 114062 */     // GIR_Coverage, 314,
     /* 114062 */     GIR_EraseRootFromParent_Done,
     /* 114063 */   // Label 2148: @114063
     /* 114063 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(114107), // Rule ID 322 //
     /* 114068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 114086 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 114086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114089 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114105 */     GIR_RootConstrainSelectedInstOperands,
     /* 114106 */     // GIR_Coverage, 322,
     /* 114106 */     GIR_EraseRootFromParent_Done,
     /* 114107 */   // Label 2149: @114107
     /* 114107 */   GIM_Reject,
     /* 114108 */ // Label 2135: @114108
     /* 114108 */ GIM_Reject,
     /* 114109 */ // Label 2109: @114109
     /* 114109 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(114222), // Rule ID 4480 //
     /* 114114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114117 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114140 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114144 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114149 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 114166 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 114166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114178 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 114197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114220 */   GIR_RootConstrainSelectedInstOperands,
     /* 114221 */   // GIR_Coverage, 4480,
     /* 114221 */   GIR_EraseRootFromParent_Done,
     /* 114222 */ // Label 2150: @114222
     /* 114222 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(114335), // Rule ID 4481 //
     /* 114227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114230 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114249 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114257 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114262 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 114279 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 114279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114291 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 114310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114333 */   GIR_RootConstrainSelectedInstOperands,
     /* 114334 */   // GIR_Coverage, 4481,
     /* 114334 */   GIR_EraseRootFromParent_Done,
     /* 114335 */ // Label 2151: @114335
     /* 114335 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114441), // Rule ID 4484 //
     /* 114340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114343 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114355 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114359 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114363 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114368 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114385 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114397 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114403 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114439 */   GIR_RootConstrainSelectedInstOperands,
     /* 114440 */   // GIR_Coverage, 4484,
     /* 114440 */   GIR_EraseRootFromParent_Done,
     /* 114441 */ // Label 2152: @114441
     /* 114441 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114547), // Rule ID 4485 //
     /* 114446 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114449 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114461 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114474 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114491 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114503 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114545 */   GIR_RootConstrainSelectedInstOperands,
     /* 114546 */   // GIR_Coverage, 4485,
     /* 114546 */   GIR_EraseRootFromParent_Done,
     /* 114547 */ // Label 2153: @114547
     /* 114547 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114653), // Rule ID 4486 //
     /* 114552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114571 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114580 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114588 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114597 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114609 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114651 */   GIR_RootConstrainSelectedInstOperands,
     /* 114652 */   // GIR_Coverage, 4486,
     /* 114652 */   GIR_EraseRootFromParent_Done,
     /* 114653 */ // Label 2154: @114653
     /* 114653 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114759), // Rule ID 4487 //
     /* 114658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114673 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114677 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114681 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114686 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114703 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114715 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114757 */   GIR_RootConstrainSelectedInstOperands,
     /* 114758 */   // GIR_Coverage, 4487,
     /* 114758 */   GIR_EraseRootFromParent_Done,
     /* 114759 */ // Label 2155: @114759
     /* 114759 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114865), // Rule ID 13217 //
     /* 114764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114767 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114779 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114783 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114787 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114792 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114809 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114821 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114832 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114863 */   GIR_RootConstrainSelectedInstOperands,
     /* 114864 */   // GIR_Coverage, 13217,
     /* 114864 */   GIR_EraseRootFromParent_Done,
     /* 114865 */ // Label 2156: @114865
     /* 114865 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114971), // Rule ID 13218 //
     /* 114870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114873 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114885 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114889 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114893 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114898 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114915 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114927 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114933 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114938 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114964 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114969 */   GIR_RootConstrainSelectedInstOperands,
     /* 114970 */   // GIR_Coverage, 13218,
     /* 114970 */   GIR_EraseRootFromParent_Done,
     /* 114971 */ // Label 2157: @114971
     /* 114971 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(115079), // Rule ID 4510 //
     /* 114976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114998 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115002 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115006 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115011 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 115028 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 115028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115040 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 115046 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115051 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 115059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115077 */   GIR_RootConstrainSelectedInstOperands,
     /* 115078 */   // GIR_Coverage, 4510,
     /* 115078 */   GIR_EraseRootFromParent_Done,
     /* 115079 */ // Label 2158: @115079
     /* 115079 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(115180), // Rule ID 4512 //
     /* 115084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115103 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115107 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115112 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115129 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115141 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115178 */   GIR_RootConstrainSelectedInstOperands,
     /* 115179 */   // GIR_Coverage, 4512,
     /* 115179 */   GIR_EraseRootFromParent_Done,
     /* 115180 */ // Label 2159: @115180
     /* 115180 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(115281), // Rule ID 4513 //
     /* 115185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115200 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115204 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115213 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115230 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115242 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115279 */   GIR_RootConstrainSelectedInstOperands,
     /* 115280 */   // GIR_Coverage, 4513,
     /* 115280 */   GIR_EraseRootFromParent_Done,
     /* 115281 */ // Label 2160: @115281
     /* 115281 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(115389), // Rule ID 4537 //
     /* 115286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115289 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115308 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115312 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115321 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115338 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115350 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 115356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 115369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115387 */   GIR_RootConstrainSelectedInstOperands,
     /* 115388 */   // GIR_Coverage, 4537,
     /* 115388 */   GIR_EraseRootFromParent_Done,
     /* 115389 */ // Label 2161: @115389
     /* 115389 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(115490), // Rule ID 4539 //
     /* 115394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115409 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115413 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115417 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115422 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115439 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115451 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115488 */   GIR_RootConstrainSelectedInstOperands,
     /* 115489 */   // GIR_Coverage, 4539,
     /* 115489 */   GIR_EraseRootFromParent_Done,
     /* 115490 */ // Label 2162: @115490
     /* 115490 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115591), // Rule ID 4540 //
     /* 115495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115510 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115523 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115527 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115533 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115540 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115552 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115563 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115589 */   GIR_RootConstrainSelectedInstOperands,
     /* 115590 */   // GIR_Coverage, 4540,
     /* 115590 */   GIR_EraseRootFromParent_Done,
     /* 115591 */ // Label 2163: @115591
     /* 115591 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115692), // Rule ID 13214 //
     /* 115596 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115611 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115615 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115624 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115641 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115653 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115690 */   GIR_RootConstrainSelectedInstOperands,
     /* 115691 */   // GIR_Coverage, 13214,
     /* 115691 */   GIR_EraseRootFromParent_Done,
     /* 115692 */ // Label 2164: @115692
     /* 115692 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115793), // Rule ID 13216 //
     /* 115697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 115742 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115754 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115791 */   GIR_RootConstrainSelectedInstOperands,
     /* 115792 */   // GIR_Coverage, 13216,
     /* 115792 */   GIR_EraseRootFromParent_Done,
     /* 115793 */ // Label 2165: @115793
     /* 115793 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115875), // Rule ID 6463 //
     /* 115798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115801 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115805 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115824 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115828 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115833 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115837 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115841 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115845 */   // MIs[2] Operand 1
     /* 115845 */   // No operand predicates
     /* 115845 */   // MIs[0] Rn
     /* 115845 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115853 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115855 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115858 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115862 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115865 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115873 */   GIR_RootConstrainSelectedInstOperands,
     /* 115874 */   // GIR_Coverage, 6463,
     /* 115874 */   GIR_EraseRootFromParent_Done,
     /* 115875 */ // Label 2166: @115875
     /* 115875 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115957), // Rule ID 6464 //
     /* 115880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115883 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115902 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115906 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115915 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115919 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115923 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115927 */   // MIs[2] Operand 1
     /* 115927 */   // No operand predicates
     /* 115927 */   // MIs[0] Rn
     /* 115927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115935 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115937 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115940 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115944 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115947 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115955 */   GIR_RootConstrainSelectedInstOperands,
     /* 115956 */   // GIR_Coverage, 6464,
     /* 115956 */   GIR_EraseRootFromParent_Done,
     /* 115957 */ // Label 2167: @115957
     /* 115957 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(116032), // Rule ID 6465 //
     /* 115962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115965 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115977 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115981 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115985 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115990 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115994 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115998 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116002 */   // MIs[2] Operand 1
     /* 116002 */   // No operand predicates
     /* 116002 */   // MIs[0] Rn
     /* 116002 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116010 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116012 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116019 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116022 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116030 */   GIR_RootConstrainSelectedInstOperands,
     /* 116031 */   // GIR_Coverage, 6465,
     /* 116031 */   GIR_EraseRootFromParent_Done,
     /* 116032 */ // Label 2168: @116032
     /* 116032 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(116107), // Rule ID 6466 //
     /* 116037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116040 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116052 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116060 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116065 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116069 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116073 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116077 */   // MIs[2] Operand 1
     /* 116077 */   // No operand predicates
     /* 116077 */   // MIs[0] Rn
     /* 116077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116085 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116087 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116090 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116094 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116105 */   GIR_RootConstrainSelectedInstOperands,
     /* 116106 */   // GIR_Coverage, 6466,
     /* 116106 */   GIR_EraseRootFromParent_Done,
     /* 116107 */ // Label 2169: @116107
     /* 116107 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(116220), // Rule ID 6470 //
     /* 116112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116115 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 116138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116155 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 116159 */   // MIs[2] Operand 1
     /* 116159 */   // No operand predicates
     /* 116159 */   // MIs[0] Rn
     /* 116159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116169 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116181 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116184 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116188 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 116204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116207 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116210 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116218 */   GIR_RootConstrainSelectedInstOperands,
     /* 116219 */   // GIR_Coverage, 6470,
     /* 116219 */   GIR_EraseRootFromParent_Done,
     /* 116220 */ // Label 2170: @116220
     /* 116220 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(116333), // Rule ID 6471 //
     /* 116225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116255 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116260 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116264 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116268 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 116272 */   // MIs[2] Operand 1
     /* 116272 */   // No operand predicates
     /* 116272 */   // MIs[0] Rn
     /* 116272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116280 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116282 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116294 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116297 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116301 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116304 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 116317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116320 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116323 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116331 */   GIR_RootConstrainSelectedInstOperands,
     /* 116332 */   // GIR_Coverage, 6471,
     /* 116332 */   GIR_EraseRootFromParent_Done,
     /* 116333 */ // Label 2171: @116333
     /* 116333 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(116439), // Rule ID 6472 //
     /* 116338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116353 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116361 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116366 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116370 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116374 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116378 */   // MIs[2] Operand 1
     /* 116378 */   // No operand predicates
     /* 116378 */   // MIs[0] Rn
     /* 116378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116386 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116388 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116400 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116407 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116426 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116429 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116437 */   GIR_RootConstrainSelectedInstOperands,
     /* 116438 */   // GIR_Coverage, 6472,
     /* 116438 */   GIR_EraseRootFromParent_Done,
     /* 116439 */ // Label 2172: @116439
     /* 116439 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(116545), // Rule ID 6473 //
     /* 116444 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116447 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116459 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116463 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116467 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116472 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116476 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116480 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116484 */   // MIs[2] Operand 1
     /* 116484 */   // No operand predicates
     /* 116484 */   // MIs[0] Rn
     /* 116484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116492 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116494 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116513 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116521 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116532 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116535 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116543 */   GIR_RootConstrainSelectedInstOperands,
     /* 116544 */   // GIR_Coverage, 6473,
     /* 116544 */   GIR_EraseRootFromParent_Done,
     /* 116545 */ // Label 2173: @116545
     /* 116545 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(116605), // Rule ID 295 //
     /* 116550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116553 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116579 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116582 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116603 */   GIR_RootConstrainSelectedInstOperands,
     /* 116604 */   // GIR_Coverage, 295,
     /* 116604 */   GIR_EraseRootFromParent_Done,
     /* 116605 */ // Label 2174: @116605
     /* 116605 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(116665), // Rule ID 296 //
     /* 116610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116613 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116639 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116642 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116663 */   GIR_RootConstrainSelectedInstOperands,
     /* 116664 */   // GIR_Coverage, 296,
     /* 116664 */   GIR_EraseRootFromParent_Done,
     /* 116665 */ // Label 2175: @116665
     /* 116665 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116725), // Rule ID 297 //
     /* 116670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116673 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116699 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116702 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116723 */   GIR_RootConstrainSelectedInstOperands,
     /* 116724 */   // GIR_Coverage, 297,
     /* 116724 */   GIR_EraseRootFromParent_Done,
     /* 116725 */ // Label 2176: @116725
     /* 116725 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116785), // Rule ID 298 //
     /* 116730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116733 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116752 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116759 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116762 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116783 */   GIR_RootConstrainSelectedInstOperands,
     /* 116784 */   // GIR_Coverage, 298,
     /* 116784 */   GIR_EraseRootFromParent_Done,
     /* 116785 */ // Label 2177: @116785
     /* 116785 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116838), // Rule ID 299 //
     /* 116790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116812 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116815 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116836 */   GIR_RootConstrainSelectedInstOperands,
     /* 116837 */   // GIR_Coverage, 299,
     /* 116837 */   GIR_EraseRootFromParent_Done,
     /* 116838 */ // Label 2178: @116838
     /* 116838 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116891), // Rule ID 300 //
     /* 116843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116865 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116868 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116889 */   GIR_RootConstrainSelectedInstOperands,
     /* 116890 */   // GIR_Coverage, 300,
     /* 116890 */   GIR_EraseRootFromParent_Done,
     /* 116891 */ // Label 2179: @116891
     /* 116891 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116947), // Rule ID 307 //
     /* 116896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116921 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116924 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116945 */   GIR_RootConstrainSelectedInstOperands,
     /* 116946 */   // GIR_Coverage, 307,
     /* 116946 */   GIR_EraseRootFromParent_Done,
     /* 116947 */ // Label 2180: @116947
     /* 116947 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(117003), // Rule ID 308 //
     /* 116952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116977 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117001 */   GIR_RootConstrainSelectedInstOperands,
     /* 117002 */   // GIR_Coverage, 308,
     /* 117002 */   GIR_EraseRootFromParent_Done,
     /* 117003 */ // Label 2181: @117003
     /* 117003 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(117055), // Rule ID 312 //
     /* 117008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117030 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117033 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117053 */   GIR_RootConstrainSelectedInstOperands,
     /* 117054 */   // GIR_Coverage, 312,
     /* 117054 */   GIR_EraseRootFromParent_Done,
     /* 117055 */ // Label 2182: @117055
     /* 117055 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(117106), // Rule ID 315 //
     /* 117060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117085 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117088 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117104 */   GIR_RootConstrainSelectedInstOperands,
     /* 117105 */   // GIR_Coverage, 315,
     /* 117105 */   GIR_EraseRootFromParent_Done,
     /* 117106 */ // Label 2183: @117106
     /* 117106 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(117165), // Rule ID 317 //
     /* 117111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117114 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117133 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117140 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117143 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117163 */   GIR_RootConstrainSelectedInstOperands,
     /* 117164 */   // GIR_Coverage, 317,
     /* 117164 */   GIR_EraseRootFromParent_Done,
     /* 117165 */ // Label 2184: @117165
     /* 117165 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(117224), // Rule ID 318 //
     /* 117170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117173 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117177 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117199 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117202 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117222 */   GIR_RootConstrainSelectedInstOperands,
     /* 117223 */   // GIR_Coverage, 318,
     /* 117223 */   GIR_EraseRootFromParent_Done,
     /* 117224 */ // Label 2185: @117224
     /* 117224 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(117301), // Rule ID 7096 //
     /* 117229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117239 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117254 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117272 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 117275 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117299 */   GIR_RootConstrainSelectedInstOperands,
     /* 117300 */   // GIR_Coverage, 7096,
     /* 117300 */   GIR_EraseRootFromParent_Done,
     /* 117301 */ // Label 2186: @117301
     /* 117301 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(117378), // Rule ID 7097 //
     /* 117306 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117309 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117316 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117327 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117331 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117340 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117349 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 117352 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117376 */   GIR_RootConstrainSelectedInstOperands,
     /* 117377 */   // GIR_Coverage, 7097,
     /* 117377 */   GIR_EraseRootFromParent_Done,
     /* 117378 */ // Label 2187: @117378
     /* 117378 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(117437), // Rule ID 7077 //
     /* 117383 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117393 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117411 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15915>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 117414 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117435 */   GIR_RootConstrainSelectedInstOperands,
     /* 117436 */   // GIR_Coverage, 7077,
     /* 117436 */   GIR_EraseRootFromParent_Done,
     /* 117437 */ // Label 2188: @117437
     /* 117437 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(117496), // Rule ID 7078 //
     /* 117442 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117445 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117452 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117459 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117463 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117470 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15915>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 117473 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117494 */   GIR_RootConstrainSelectedInstOperands,
     /* 117495 */   // GIR_Coverage, 7078,
     /* 117495 */   GIR_EraseRootFromParent_Done,
     /* 117496 */ // Label 2189: @117496
     /* 117496 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(117555), // Rule ID 7082 //
     /* 117501 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117511 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117529 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15922>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 117532 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117553 */   GIR_RootConstrainSelectedInstOperands,
     /* 117554 */   // GIR_Coverage, 7082,
     /* 117554 */   GIR_EraseRootFromParent_Done,
     /* 117555 */ // Label 2190: @117555
     /* 117555 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(117614), // Rule ID 7083 //
     /* 117560 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117570 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117588 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15922>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 117591 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117612 */   GIR_RootConstrainSelectedInstOperands,
     /* 117613 */   // GIR_Coverage, 7083,
     /* 117613 */   GIR_EraseRootFromParent_Done,
     /* 117614 */ // Label 2191: @117614
     /* 117614 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117673), // Rule ID 7087 //
     /* 117619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117629 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117647 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 117650 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117671 */   GIR_RootConstrainSelectedInstOperands,
     /* 117672 */   // GIR_Coverage, 7087,
     /* 117672 */   GIR_EraseRootFromParent_Done,
     /* 117673 */ // Label 2192: @117673
     /* 117673 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117732), // Rule ID 7088 //
     /* 117678 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117688 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117706 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 117709 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117730 */   GIR_RootConstrainSelectedInstOperands,
     /* 117731 */   // GIR_Coverage, 7088,
     /* 117731 */   GIR_EraseRootFromParent_Done,
     /* 117732 */ // Label 2193: @117732
     /* 117732 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117804), // Rule ID 7098 //
     /* 117737 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117740 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117747 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117758 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117762 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117767 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117780 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117802 */   GIR_RootConstrainSelectedInstOperands,
     /* 117803 */   // GIR_Coverage, 7098,
     /* 117803 */   GIR_EraseRootFromParent_Done,
     /* 117804 */ // Label 2194: @117804
     /* 117804 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117876), // Rule ID 7099 //
     /* 117809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117812 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117819 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117830 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117834 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117852 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117874 */   GIR_RootConstrainSelectedInstOperands,
     /* 117875 */   // GIR_Coverage, 7099,
     /* 117875 */   GIR_EraseRootFromParent_Done,
     /* 117876 */ // Label 2195: @117876
     /* 117876 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117928), // Rule ID 320 //
     /* 117881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117884 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117903 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117906 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117926 */   GIR_RootConstrainSelectedInstOperands,
     /* 117927 */   // GIR_Coverage, 320,
     /* 117927 */   GIR_EraseRootFromParent_Done,
     /* 117928 */ // Label 2196: @117928
     /* 117928 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117979), // Rule ID 323 //
     /* 117933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117958 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117961 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117977 */   GIR_RootConstrainSelectedInstOperands,
     /* 117978 */   // GIR_Coverage, 323,
     /* 117978 */   GIR_EraseRootFromParent_Done,
     /* 117979 */ // Label 2197: @117979
     /* 117979 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(118038), // Rule ID 326 //
     /* 117984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117987 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118002 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118013 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 118016 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 118022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118036 */   GIR_RootConstrainSelectedInstOperands,
     /* 118037 */   // GIR_Coverage, 326,
     /* 118037 */   GIR_EraseRootFromParent_Done,
     /* 118038 */ // Label 2198: @118038
     /* 118038 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(118097), // Rule ID 327 //
     /* 118043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118046 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118072 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 118075 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 118081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118095 */   GIR_RootConstrainSelectedInstOperands,
     /* 118096 */   // GIR_Coverage, 327,
     /* 118096 */   GIR_EraseRootFromParent_Done,
     /* 118097 */ // Label 2199: @118097
     /* 118097 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(118151), // Rule ID 7079 //
     /* 118102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118112 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118130 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15915>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 118133 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118149 */   GIR_RootConstrainSelectedInstOperands,
     /* 118150 */   // GIR_Coverage, 7079,
     /* 118150 */   GIR_EraseRootFromParent_Done,
     /* 118151 */ // Label 2200: @118151
     /* 118151 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(118205), // Rule ID 7080 //
     /* 118156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118166 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118184 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15915>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 118187 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118203 */   GIR_RootConstrainSelectedInstOperands,
     /* 118204 */   // GIR_Coverage, 7080,
     /* 118204 */   GIR_EraseRootFromParent_Done,
     /* 118205 */ // Label 2201: @118205
     /* 118205 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(118259), // Rule ID 7084 //
     /* 118210 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118220 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118238 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15922>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 118241 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118257 */   GIR_RootConstrainSelectedInstOperands,
     /* 118258 */   // GIR_Coverage, 7084,
     /* 118258 */   GIR_EraseRootFromParent_Done,
     /* 118259 */ // Label 2202: @118259
     /* 118259 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(118313), // Rule ID 7085 //
     /* 118264 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118267 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118274 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118285 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118292 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15922>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 118295 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118311 */   GIR_RootConstrainSelectedInstOperands,
     /* 118312 */   // GIR_Coverage, 7085,
     /* 118312 */   GIR_EraseRootFromParent_Done,
     /* 118313 */ // Label 2203: @118313
     /* 118313 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(118367), // Rule ID 7089 //
     /* 118318 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118328 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118335 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118346 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 118349 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118365 */   GIR_RootConstrainSelectedInstOperands,
     /* 118366 */   // GIR_Coverage, 7089,
     /* 118366 */   GIR_EraseRootFromParent_Done,
     /* 118367 */ // Label 2204: @118367
     /* 118367 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(118421), // Rule ID 7090 //
     /* 118372 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118382 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118400 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15929>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 118403 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118419 */   GIR_RootConstrainSelectedInstOperands,
     /* 118420 */   // GIR_Coverage, 7090,
     /* 118420 */   GIR_EraseRootFromParent_Done,
     /* 118421 */ // Label 2205: @118421
     /* 118421 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(118478), // Rule ID 7452 //
     /* 118426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118429 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118439 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118457 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15913>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 118460 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118476 */   GIR_RootConstrainSelectedInstOperands,
     /* 118477 */   // GIR_Coverage, 7452,
     /* 118477 */   GIR_EraseRootFromParent_Done,
     /* 118478 */ // Label 2206: @118478
     /* 118478 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(118535), // Rule ID 7453 //
     /* 118483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118486 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118496 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118514 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15920>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 118517 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118533 */   GIR_RootConstrainSelectedInstOperands,
     /* 118534 */   // GIR_Coverage, 7453,
     /* 118534 */   GIR_EraseRootFromParent_Done,
     /* 118535 */ // Label 2207: @118535
     /* 118535 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(118592), // Rule ID 7454 //
     /* 118540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118553 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118571 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15927>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 118574 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118590 */   GIR_RootConstrainSelectedInstOperands,
     /* 118591 */   // GIR_Coverage, 7454,
     /* 118591 */   GIR_EraseRootFromParent_Done,
     /* 118592 */ // Label 2208: @118592
     /* 118592 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118629), // Rule ID 7076 //
     /* 118597 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118614 */   // MIs[0] ptr
     /* 118614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118622 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15913>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 118627 */   GIR_RootConstrainSelectedInstOperands,
     /* 118628 */   // GIR_Coverage, 7076,
     /* 118628 */   GIR_Done,
     /* 118629 */ // Label 2209: @118629
     /* 118629 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118666), // Rule ID 7081 //
     /* 118634 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118651 */   // MIs[0] ptr
     /* 118651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118659 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15920>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 118664 */   GIR_RootConstrainSelectedInstOperands,
     /* 118665 */   // GIR_Coverage, 7081,
     /* 118665 */   GIR_Done,
     /* 118666 */ // Label 2210: @118666
     /* 118666 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118703), // Rule ID 7086 //
     /* 118671 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118688 */   // MIs[0] ptr
     /* 118688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118696 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15927>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 118701 */   GIR_RootConstrainSelectedInstOperands,
     /* 118702 */   // GIR_Coverage, 7086,
     /* 118702 */   GIR_Done,
     /* 118703 */ // Label 2211: @118703
     /* 118703 */ GIM_Reject,
     /* 118704 */ // Label 2110: @118704
     /* 118704 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118810), // Rule ID 4488 //
     /* 118709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118737 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118754 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118766 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118803 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118808 */   GIR_RootConstrainSelectedInstOperands,
     /* 118809 */   // GIR_Coverage, 4488,
     /* 118809 */   GIR_EraseRootFromParent_Done,
     /* 118810 */ // Label 2212: @118810
     /* 118810 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118916), // Rule ID 4489 //
     /* 118815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118830 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118834 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118843 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118860 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118872 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118883 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118914 */   GIR_RootConstrainSelectedInstOperands,
     /* 118915 */   // GIR_Coverage, 4489,
     /* 118915 */   GIR_EraseRootFromParent_Done,
     /* 118916 */ // Label 2213: @118916
     /* 118916 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(119022), // Rule ID 4490 //
     /* 118921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118936 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118940 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118949 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118966 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118978 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118989 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119020 */   GIR_RootConstrainSelectedInstOperands,
     /* 119021 */   // GIR_Coverage, 4490,
     /* 119021 */   GIR_EraseRootFromParent_Done,
     /* 119022 */ // Label 2214: @119022
     /* 119022 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(119128), // Rule ID 4491 //
     /* 119027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119042 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119046 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119055 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119072 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119084 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119126 */   GIR_RootConstrainSelectedInstOperands,
     /* 119127 */   // GIR_Coverage, 4491,
     /* 119127 */   GIR_EraseRootFromParent_Done,
     /* 119128 */ // Label 2215: @119128
     /* 119128 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(119229), // Rule ID 4514 //
     /* 119133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119148 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119161 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119178 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119190 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119227 */   GIR_RootConstrainSelectedInstOperands,
     /* 119228 */   // GIR_Coverage, 4514,
     /* 119228 */   GIR_EraseRootFromParent_Done,
     /* 119229 */ // Label 2216: @119229
     /* 119229 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(119330), // Rule ID 4515 //
     /* 119234 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119237 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119249 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119257 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119262 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119279 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119291 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119323 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119328 */   GIR_RootConstrainSelectedInstOperands,
     /* 119329 */   // GIR_Coverage, 4515,
     /* 119329 */   GIR_EraseRootFromParent_Done,
     /* 119330 */ // Label 2217: @119330
     /* 119330 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(119431), // Rule ID 4541 //
     /* 119335 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119338 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119342 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119346 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119350 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119354 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119358 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119363 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119367 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119380 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119392 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119398 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119403 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119429 */   GIR_RootConstrainSelectedInstOperands,
     /* 119430 */   // GIR_Coverage, 4541,
     /* 119430 */   GIR_EraseRootFromParent_Done,
     /* 119431 */ // Label 2218: @119431
     /* 119431 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(119532), // Rule ID 4542 //
     /* 119436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119455 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119464 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119474 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119481 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119493 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119499 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119530 */   GIR_RootConstrainSelectedInstOperands,
     /* 119531 */   // GIR_Coverage, 4542,
     /* 119531 */   GIR_EraseRootFromParent_Done,
     /* 119532 */ // Label 2219: @119532
     /* 119532 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(119607), // Rule ID 6467 //
     /* 119537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119552 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119556 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119560 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119565 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119569 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119573 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119577 */   // MIs[2] Operand 1
     /* 119577 */   // No operand predicates
     /* 119577 */   // MIs[0] Rn
     /* 119577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119585 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119587 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119590 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119594 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119597 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119605 */   GIR_RootConstrainSelectedInstOperands,
     /* 119606 */   // GIR_Coverage, 6467,
     /* 119606 */   GIR_EraseRootFromParent_Done,
     /* 119607 */ // Label 2220: @119607
     /* 119607 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119682), // Rule ID 6468 //
     /* 119612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119640 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119644 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119648 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119652 */   // MIs[2] Operand 1
     /* 119652 */   // No operand predicates
     /* 119652 */   // MIs[0] Rn
     /* 119652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119660 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119662 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119669 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119672 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119680 */   GIR_RootConstrainSelectedInstOperands,
     /* 119681 */   // GIR_Coverage, 6468,
     /* 119681 */   GIR_EraseRootFromParent_Done,
     /* 119682 */ // Label 2221: @119682
     /* 119682 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119735), // Rule ID 301 //
     /* 119687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119698 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119709 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 119712 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119733 */   GIR_RootConstrainSelectedInstOperands,
     /* 119734 */   // GIR_Coverage, 301,
     /* 119734 */   GIR_EraseRootFromParent_Done,
     /* 119735 */ // Label 2222: @119735
     /* 119735 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119788), // Rule ID 302 //
     /* 119740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119762 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 119765 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119786 */   GIR_RootConstrainSelectedInstOperands,
     /* 119787 */   // GIR_Coverage, 302,
     /* 119787 */   GIR_EraseRootFromParent_Done,
     /* 119788 */ // Label 2223: @119788
     /* 119788 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119844), // Rule ID 309 //
     /* 119793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119818 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119821 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119842 */   GIR_RootConstrainSelectedInstOperands,
     /* 119843 */   // GIR_Coverage, 309,
     /* 119843 */   GIR_EraseRootFromParent_Done,
     /* 119844 */ // Label 2224: @119844
     /* 119844 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119900), // Rule ID 310 //
     /* 119849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119874 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119877 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119898 */   GIR_RootConstrainSelectedInstOperands,
     /* 119899 */   // GIR_Coverage, 310,
     /* 119899 */   GIR_EraseRootFromParent_Done,
     /* 119900 */ // Label 2225: @119900
     /* 119900 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119989), // Rule ID 4446 //
     /* 119905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119908 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119934 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 119934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119946 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119952 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119957 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119987 */   GIR_RootConstrainSelectedInstOperands,
     /* 119988 */   // GIR_Coverage, 4446,
     /* 119988 */   GIR_EraseRootFromParent_Done,
     /* 119989 */ // Label 2226: @119989
     /* 119989 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(120078), // Rule ID 4447 //
     /* 119994 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119997 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120001 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120023 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 120023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120035 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120046 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 120054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120076 */   GIR_RootConstrainSelectedInstOperands,
     /* 120077 */   // GIR_Coverage, 4447,
     /* 120077 */   GIR_EraseRootFromParent_Done,
     /* 120078 */ // Label 2227: @120078
     /* 120078 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(120167), // Rule ID 4448 //
     /* 120083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120112 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 120112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120124 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 120143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120165 */   GIR_RootConstrainSelectedInstOperands,
     /* 120166 */   // GIR_Coverage, 4448,
     /* 120166 */   GIR_EraseRootFromParent_Done,
     /* 120167 */ // Label 2228: @120167
     /* 120167 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(120256), // Rule ID 4449 //
     /* 120172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120175 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120190 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120194 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120201 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 120201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120213 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120224 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 120232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120254 */   GIR_RootConstrainSelectedInstOperands,
     /* 120255 */   // GIR_Coverage, 4449,
     /* 120255 */   GIR_EraseRootFromParent_Done,
     /* 120256 */ // Label 2229: @120256
     /* 120256 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(120345), // Rule ID 4450 //
     /* 120261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120290 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 120290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 120321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120343 */   GIR_RootConstrainSelectedInstOperands,
     /* 120344 */   // GIR_Coverage, 4450,
     /* 120344 */   GIR_EraseRootFromParent_Done,
     /* 120345 */ // Label 2230: @120345
     /* 120345 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(120434), // Rule ID 4451 //
     /* 120350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120353 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120357 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120379 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 120379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120391 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 120410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120432 */   GIR_RootConstrainSelectedInstOperands,
     /* 120433 */   // GIR_Coverage, 4451,
     /* 120433 */   GIR_EraseRootFromParent_Done,
     /* 120434 */ // Label 2231: @120434
     /* 120434 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(120487), // Rule ID 4462 //
     /* 120439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120461 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120464 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120485 */   GIR_RootConstrainSelectedInstOperands,
     /* 120486 */   // GIR_Coverage, 4462,
     /* 120486 */   GIR_EraseRootFromParent_Done,
     /* 120487 */ // Label 2232: @120487
     /* 120487 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(120540), // Rule ID 4463 //
     /* 120492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120514 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120517 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120538 */   GIR_RootConstrainSelectedInstOperands,
     /* 120539 */   // GIR_Coverage, 4463,
     /* 120539 */   GIR_EraseRootFromParent_Done,
     /* 120540 */ // Label 2233: @120540
     /* 120540 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(120593), // Rule ID 4464 //
     /* 120545 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120548 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120556 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120567 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120570 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120591 */   GIR_RootConstrainSelectedInstOperands,
     /* 120592 */   // GIR_Coverage, 4464,
     /* 120592 */   GIR_EraseRootFromParent_Done,
     /* 120593 */ // Label 2234: @120593
     /* 120593 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(120646), // Rule ID 4465 //
     /* 120598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120601 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120620 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120623 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120644 */   GIR_RootConstrainSelectedInstOperands,
     /* 120645 */   // GIR_Coverage, 4465,
     /* 120645 */   GIR_EraseRootFromParent_Done,
     /* 120646 */ // Label 2235: @120646
     /* 120646 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120698), // Rule ID 311 //
     /* 120651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120654 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120666 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120673 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120676 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120696 */   GIR_RootConstrainSelectedInstOperands,
     /* 120697 */   // GIR_Coverage, 311,
     /* 120697 */   GIR_EraseRootFromParent_Done,
     /* 120698 */ // Label 2236: @120698
     /* 120698 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120749), // Rule ID 316 //
     /* 120703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120709 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120728 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120731 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120747 */   GIR_RootConstrainSelectedInstOperands,
     /* 120748 */   // GIR_Coverage, 316,
     /* 120748 */   GIR_EraseRootFromParent_Done,
     /* 120749 */ // Label 2237: @120749
     /* 120749 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120797), // Rule ID 4492 //
     /* 120754 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120757 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120776 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120779 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120795 */   GIR_RootConstrainSelectedInstOperands,
     /* 120796 */   // GIR_Coverage, 4492,
     /* 120796 */   GIR_EraseRootFromParent_Done,
     /* 120797 */ // Label 2238: @120797
     /* 120797 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120845), // Rule ID 4493 //
     /* 120802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120824 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120827 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120843 */   GIR_RootConstrainSelectedInstOperands,
     /* 120844 */   // GIR_Coverage, 4493,
     /* 120844 */   GIR_EraseRootFromParent_Done,
     /* 120845 */ // Label 2239: @120845
     /* 120845 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120929), // Rule ID 4507 //
     /* 120850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120879 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120891 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120902 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 120910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120927 */   GIR_RootConstrainSelectedInstOperands,
     /* 120928 */   // GIR_Coverage, 4507,
     /* 120928 */   GIR_EraseRootFromParent_Done,
     /* 120929 */ // Label 2240: @120929
     /* 120929 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(121013), // Rule ID 4508 //
     /* 120934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120937 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120963 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120975 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120986 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121011 */   GIR_RootConstrainSelectedInstOperands,
     /* 121012 */   // GIR_Coverage, 4508,
     /* 121012 */   GIR_EraseRootFromParent_Done,
     /* 121013 */ // Label 2241: @121013
     /* 121013 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(121097), // Rule ID 4509 //
     /* 121018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121021 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121047 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 121047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121059 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 121078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121095 */   GIR_RootConstrainSelectedInstOperands,
     /* 121096 */   // GIR_Coverage, 4509,
     /* 121096 */   GIR_EraseRootFromParent_Done,
     /* 121097 */ // Label 2242: @121097
     /* 121097 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(121174), // Rule ID 7100 //
     /* 121102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121112 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121123 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121127 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121136 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121145 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121148 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121172 */   GIR_RootConstrainSelectedInstOperands,
     /* 121173 */   // GIR_Coverage, 7100,
     /* 121173 */   GIR_EraseRootFromParent_Done,
     /* 121174 */ // Label 2243: @121174
     /* 121174 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(121251), // Rule ID 7101 //
     /* 121179 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121189 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121200 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121209 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121222 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121249 */   GIR_RootConstrainSelectedInstOperands,
     /* 121250 */   // GIR_Coverage, 7101,
     /* 121250 */   GIR_EraseRootFromParent_Done,
     /* 121251 */ // Label 2244: @121251
     /* 121251 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(121310), // Rule ID 7092 //
     /* 121256 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121259 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121266 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121273 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121277 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121284 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 121287 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121304 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121308 */   GIR_RootConstrainSelectedInstOperands,
     /* 121309 */   // GIR_Coverage, 7092,
     /* 121309 */   GIR_EraseRootFromParent_Done,
     /* 121310 */ // Label 2245: @121310
     /* 121310 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(121369), // Rule ID 7093 //
     /* 121315 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121325 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121332 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121336 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121343 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 121346 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121367 */   GIR_RootConstrainSelectedInstOperands,
     /* 121368 */   // GIR_Coverage, 7093,
     /* 121368 */   GIR_EraseRootFromParent_Done,
     /* 121369 */ // Label 2246: @121369
     /* 121369 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(121441), // Rule ID 7102 //
     /* 121374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121395 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121417 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 121417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121420 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121439 */   GIR_RootConstrainSelectedInstOperands,
     /* 121440 */   // GIR_Coverage, 7102,
     /* 121440 */   GIR_EraseRootFromParent_Done,
     /* 121441 */ // Label 2247: @121441
     /* 121441 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(121513), // Rule ID 7103 //
     /* 121446 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121456 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121471 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121489 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121492 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121511 */   GIR_RootConstrainSelectedInstOperands,
     /* 121512 */   // GIR_Coverage, 7103,
     /* 121512 */   GIR_EraseRootFromParent_Done,
     /* 121513 */ // Label 2248: @121513
     /* 121513 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(121610), // Rule ID 7444 //
     /* 121518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121531 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121542 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121546 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 121550 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121554 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121558 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 121562 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121567 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 121571 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121575 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121579 */   // MIs[3] Operand 1
     /* 121579 */   // No operand predicates
     /* 121579 */   // MIs[0] Rn
     /* 121579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121587 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 121589 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15934>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121592 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 121596 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 121599 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 121608 */   GIR_RootConstrainSelectedInstOperands,
     /* 121609 */   // GIR_Coverage, 7444,
     /* 121609 */   GIR_EraseRootFromParent_Done,
     /* 121610 */ // Label 2249: @121610
     /* 121610 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(121662), // Rule ID 319 //
     /* 121615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121637 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121640 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 121646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121660 */   GIR_RootConstrainSelectedInstOperands,
     /* 121661 */   // GIR_Coverage, 319,
     /* 121661 */   GIR_EraseRootFromParent_Done,
     /* 121662 */ // Label 2250: @121662
     /* 121662 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121713), // Rule ID 324 //
     /* 121667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121673 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121692 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121695 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121711 */   GIR_RootConstrainSelectedInstOperands,
     /* 121712 */   // GIR_Coverage, 324,
     /* 121712 */   GIR_EraseRootFromParent_Done,
     /* 121713 */ // Label 2251: @121713
     /* 121713 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121767), // Rule ID 7094 //
     /* 121718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121728 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121746 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 121749 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121765 */   GIR_RootConstrainSelectedInstOperands,
     /* 121766 */   // GIR_Coverage, 7094,
     /* 121766 */   GIR_EraseRootFromParent_Done,
     /* 121767 */ // Label 2252: @121767
     /* 121767 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121821), // Rule ID 7095 //
     /* 121772 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121782 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121800 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15936>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121803 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121819 */   GIR_RootConstrainSelectedInstOperands,
     /* 121820 */   // GIR_Coverage, 7095,
     /* 121820 */   GIR_EraseRootFromParent_Done,
     /* 121821 */ // Label 2253: @121821
     /* 121821 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121878), // Rule ID 7455 //
     /* 121826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 121829 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121832 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121839 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121857 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15934>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 121860 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121876 */   GIR_RootConstrainSelectedInstOperands,
     /* 121877 */   // GIR_Coverage, 7455,
     /* 121877 */   GIR_EraseRootFromParent_Done,
     /* 121878 */ // Label 2254: @121878
     /* 121878 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121926), // Rule ID 4516 //
     /* 121883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121905 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121908 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121924 */   GIR_RootConstrainSelectedInstOperands,
     /* 121925 */   // GIR_Coverage, 4516,
     /* 121925 */   GIR_EraseRootFromParent_Done,
     /* 121926 */ // Label 2255: @121926
     /* 121926 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121974), // Rule ID 4517 //
     /* 121931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121953 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121956 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121972 */   GIR_RootConstrainSelectedInstOperands,
     /* 121973 */   // GIR_Coverage, 4517,
     /* 121973 */   GIR_EraseRootFromParent_Done,
     /* 121974 */ // Label 2256: @121974
     /* 121974 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(122058), // Rule ID 4532 //
     /* 121979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121982 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121986 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 122008 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122020 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 122039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122056 */   GIR_RootConstrainSelectedInstOperands,
     /* 122057 */   // GIR_Coverage, 4532,
     /* 122057 */   GIR_EraseRootFromParent_Done,
     /* 122058 */ // Label 2257: @122058
     /* 122058 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(122142), // Rule ID 4533 //
     /* 122063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122066 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 122092 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122104 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122110 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 122123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122140 */   GIR_RootConstrainSelectedInstOperands,
     /* 122141 */   // GIR_Coverage, 4533,
     /* 122141 */   GIR_EraseRootFromParent_Done,
     /* 122142 */ // Label 2258: @122142
     /* 122142 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(122226), // Rule ID 4534 //
     /* 122147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122150 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 122176 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122188 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122194 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 122207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122220 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122224 */   GIR_RootConstrainSelectedInstOperands,
     /* 122225 */   // GIR_Coverage, 4534,
     /* 122225 */   GIR_EraseRootFromParent_Done,
     /* 122226 */ // Label 2259: @122226
     /* 122226 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(122310), // Rule ID 7443 //
     /* 122231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122234 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122237 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122244 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122247 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 122255 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 122259 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122263 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122268 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 122272 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122276 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 122280 */   // MIs[2] Operand 1
     /* 122280 */   // No operand predicates
     /* 122280 */   // MIs[0] Rn
     /* 122280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122288 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122290 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15934>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 122290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122293 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122297 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 122300 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122308 */   GIR_RootConstrainSelectedInstOperands,
     /* 122309 */   // GIR_Coverage, 7443,
     /* 122309 */   GIR_EraseRootFromParent_Done,
     /* 122310 */ // Label 2260: @122310
     /* 122310 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(122408), // Rule ID 7445 //
     /* 122315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122318 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122328 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 122339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 122343 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122348 */   // MIs[0] Rn
     /* 122348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122358 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15934>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 122358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 122361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122370 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122373 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122377 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 122380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122399 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122406 */   GIR_RootConstrainSelectedInstOperands,
     /* 122407 */   // GIR_Coverage, 7445,
     /* 122407 */   GIR_EraseRootFromParent_Done,
     /* 122408 */ // Label 2261: @122408
     /* 122408 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(122445), // Rule ID 7091 //
     /* 122413 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122423 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122430 */   // MIs[0] ptr
     /* 122430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122438 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15934>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 122438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 122443 */   GIR_RootConstrainSelectedInstOperands,
     /* 122444 */   // GIR_Coverage, 7091,
     /* 122444 */   GIR_Done,
     /* 122445 */ // Label 2262: @122445
     /* 122445 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(122472), // Rule ID 6417 //
     /* 122450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122453 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122457 */   // MIs[0] Rn
     /* 122457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122465 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 122470 */   GIR_RootConstrainSelectedInstOperands,
     /* 122471 */   // GIR_Coverage, 6417,
     /* 122471 */   GIR_Done,
     /* 122472 */ // Label 2263: @122472
     /* 122472 */ GIM_Reject,
     /* 122473 */ // Label 2111: @122473
     /* 122473 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(122678),
     /* 122478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122481 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122489 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122493 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(122534), // Rule ID 4444 //
     /* 122498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122508 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122511 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122532 */     GIR_RootConstrainSelectedInstOperands,
     /* 122533 */     // GIR_Coverage, 4444,
     /* 122533 */     GIR_EraseRootFromParent_Done,
     /* 122534 */   // Label 2265: @122534
     /* 122534 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(122575), // Rule ID 4445 //
     /* 122539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122549 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122552 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122573 */     GIR_RootConstrainSelectedInstOperands,
     /* 122574 */     // GIR_Coverage, 4445,
     /* 122574 */     GIR_EraseRootFromParent_Done,
     /* 122575 */   // Label 2266: @122575
     /* 122575 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(122608), // Rule ID 4499 //
     /* 122580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122587 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122590 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122606 */     GIR_RootConstrainSelectedInstOperands,
     /* 122607 */     // GIR_Coverage, 4499,
     /* 122607 */     GIR_EraseRootFromParent_Done,
     /* 122608 */   // Label 2267: @122608
     /* 122608 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(122641), // Rule ID 4523 //
     /* 122613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122620 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122623 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122639 */     GIR_RootConstrainSelectedInstOperands,
     /* 122640 */     // GIR_Coverage, 4523,
     /* 122640 */     GIR_EraseRootFromParent_Done,
     /* 122641 */   // Label 2268: @122641
     /* 122641 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(122677), // Rule ID 325 //
     /* 122646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122656 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122659 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122675 */     GIR_RootConstrainSelectedInstOperands,
     /* 122676 */     // GIR_Coverage, 325,
     /* 122676 */     GIR_EraseRootFromParent_Done,
     /* 122677 */   // Label 2269: @122677
     /* 122677 */   GIM_Reject,
     /* 122678 */ // Label 2264: @122678
     /* 122678 */ GIM_Reject,
     /* 122679 */ // Label 2112: @122679
     /* 122679 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(123084),
     /* 122684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122691 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122740), // Rule ID 4452 //
     /* 122696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122714 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122717 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122738 */     GIR_RootConstrainSelectedInstOperands,
     /* 122739 */     // GIR_Coverage, 4452,
     /* 122739 */     GIR_EraseRootFromParent_Done,
     /* 122740 */   // Label 2271: @122740
     /* 122740 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122789), // Rule ID 4453 //
     /* 122745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122763 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122766 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122787 */     GIR_RootConstrainSelectedInstOperands,
     /* 122788 */     // GIR_Coverage, 4453,
     /* 122788 */     GIR_EraseRootFromParent_Done,
     /* 122789 */   // Label 2272: @122789
     /* 122789 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122838), // Rule ID 4454 //
     /* 122794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122812 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122815 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122836 */     GIR_RootConstrainSelectedInstOperands,
     /* 122837 */     // GIR_Coverage, 4454,
     /* 122837 */     GIR_EraseRootFromParent_Done,
     /* 122838 */   // Label 2273: @122838
     /* 122838 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122887), // Rule ID 4455 //
     /* 122843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122861 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122864 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122885 */     GIR_RootConstrainSelectedInstOperands,
     /* 122886 */     // GIR_Coverage, 4455,
     /* 122886 */     GIR_EraseRootFromParent_Done,
     /* 122887 */   // Label 2274: @122887
     /* 122887 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122931), // Rule ID 4494 //
     /* 122892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122910 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122929 */     GIR_RootConstrainSelectedInstOperands,
     /* 122930 */     // GIR_Coverage, 4494,
     /* 122930 */     GIR_EraseRootFromParent_Done,
     /* 122931 */   // Label 2275: @122931
     /* 122931 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122975), // Rule ID 4497 //
     /* 122936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122954 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122957 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122973 */     GIR_RootConstrainSelectedInstOperands,
     /* 122974 */     // GIR_Coverage, 4497,
     /* 122974 */     GIR_EraseRootFromParent_Done,
     /* 122975 */   // Label 2276: @122975
     /* 122975 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(123019), // Rule ID 4518 //
     /* 122980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122998 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123001 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123017 */     GIR_RootConstrainSelectedInstOperands,
     /* 123018 */     // GIR_Coverage, 4518,
     /* 123018 */     GIR_EraseRootFromParent_Done,
     /* 123019 */   // Label 2277: @123019
     /* 123019 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(123063), // Rule ID 4521 //
     /* 123024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123042 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123045 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123061 */     GIR_RootConstrainSelectedInstOperands,
     /* 123062 */     // GIR_Coverage, 4521,
     /* 123062 */     GIR_EraseRootFromParent_Done,
     /* 123063 */   // Label 2278: @123063
     /* 123063 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(123083), // Rule ID 6416 //
     /* 123068 */     // MIs[0] Rn
     /* 123068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123076 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 123081 */     GIR_RootConstrainSelectedInstOperands,
     /* 123082 */     // GIR_Coverage, 6416,
     /* 123082 */     GIR_Done,
     /* 123083 */   // Label 2279: @123083
     /* 123083 */   GIM_Reject,
     /* 123084 */ // Label 2270: @123084
     /* 123084 */ GIM_Reject,
     /* 123085 */ // Label 2113: @123085
     /* 123085 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(123534),
     /* 123090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123097 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(123146), // Rule ID 4466 //
     /* 123102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123120 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123123 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123144 */     GIR_RootConstrainSelectedInstOperands,
     /* 123145 */     // GIR_Coverage, 4466,
     /* 123145 */     GIR_EraseRootFromParent_Done,
     /* 123146 */   // Label 2281: @123146
     /* 123146 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(123195), // Rule ID 4467 //
     /* 123151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123169 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123172 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123193 */     GIR_RootConstrainSelectedInstOperands,
     /* 123194 */     // GIR_Coverage, 4467,
     /* 123194 */     GIR_EraseRootFromParent_Done,
     /* 123195 */   // Label 2282: @123195
     /* 123195 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(123244), // Rule ID 4468 //
     /* 123200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123218 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123221 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123242 */     GIR_RootConstrainSelectedInstOperands,
     /* 123243 */     // GIR_Coverage, 4468,
     /* 123243 */     GIR_EraseRootFromParent_Done,
     /* 123244 */   // Label 2283: @123244
     /* 123244 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(123293), // Rule ID 4469 //
     /* 123249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123267 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123270 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123291 */     GIR_RootConstrainSelectedInstOperands,
     /* 123292 */     // GIR_Coverage, 4469,
     /* 123292 */     GIR_EraseRootFromParent_Done,
     /* 123293 */   // Label 2284: @123293
     /* 123293 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(123337), // Rule ID 4501 //
     /* 123298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123316 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123319 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123335 */     GIR_RootConstrainSelectedInstOperands,
     /* 123336 */     // GIR_Coverage, 4501,
     /* 123336 */     GIR_EraseRootFromParent_Done,
     /* 123337 */   // Label 2285: @123337
     /* 123337 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(123381), // Rule ID 4505 //
     /* 123342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123360 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123363 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123379 */     GIR_RootConstrainSelectedInstOperands,
     /* 123380 */     // GIR_Coverage, 4505,
     /* 123380 */     GIR_EraseRootFromParent_Done,
     /* 123381 */   // Label 2286: @123381
     /* 123381 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(123425), // Rule ID 4525 //
     /* 123386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123404 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123407 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123423 */     GIR_RootConstrainSelectedInstOperands,
     /* 123424 */     // GIR_Coverage, 4525,
     /* 123424 */     GIR_EraseRootFromParent_Done,
     /* 123425 */   // Label 2287: @123425
     /* 123425 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(123469), // Rule ID 4529 //
     /* 123430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123448 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123451 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123467 */     GIR_RootConstrainSelectedInstOperands,
     /* 123468 */     // GIR_Coverage, 4529,
     /* 123468 */     GIR_EraseRootFromParent_Done,
     /* 123469 */   // Label 2288: @123469
     /* 123469 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(123513), // Rule ID 4530 //
     /* 123474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123492 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123495 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123511 */     GIR_RootConstrainSelectedInstOperands,
     /* 123512 */     // GIR_Coverage, 4530,
     /* 123512 */     GIR_EraseRootFromParent_Done,
     /* 123513 */   // Label 2289: @123513
     /* 123513 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(123533), // Rule ID 6413 //
     /* 123518 */     // MIs[0] Rn
     /* 123518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123526 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 123531 */     GIR_RootConstrainSelectedInstOperands,
     /* 123532 */     // GIR_Coverage, 6413,
     /* 123532 */     GIR_Done,
     /* 123533 */   // Label 2290: @123533
     /* 123533 */   GIM_Reject,
     /* 123534 */ // Label 2280: @123534
     /* 123534 */ GIM_Reject,
     /* 123535 */ // Label 2114: @123535
     /* 123535 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(123940),
     /* 123540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123543 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123547 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(123596), // Rule ID 4456 //
     /* 123552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123570 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123573 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123594 */     GIR_RootConstrainSelectedInstOperands,
     /* 123595 */     // GIR_Coverage, 4456,
     /* 123595 */     GIR_EraseRootFromParent_Done,
     /* 123596 */   // Label 2292: @123596
     /* 123596 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(123645), // Rule ID 4457 //
     /* 123601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123619 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123622 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123643 */     GIR_RootConstrainSelectedInstOperands,
     /* 123644 */     // GIR_Coverage, 4457,
     /* 123644 */     GIR_EraseRootFromParent_Done,
     /* 123645 */   // Label 2293: @123645
     /* 123645 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(123694), // Rule ID 4460 //
     /* 123650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123668 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123671 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123692 */     GIR_RootConstrainSelectedInstOperands,
     /* 123693 */     // GIR_Coverage, 4460,
     /* 123693 */     GIR_EraseRootFromParent_Done,
     /* 123694 */   // Label 2294: @123694
     /* 123694 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(123743), // Rule ID 4461 //
     /* 123699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123717 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123720 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123741 */     GIR_RootConstrainSelectedInstOperands,
     /* 123742 */     // GIR_Coverage, 4461,
     /* 123742 */     GIR_EraseRootFromParent_Done,
     /* 123743 */   // Label 2295: @123743
     /* 123743 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123787), // Rule ID 4496 //
     /* 123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123766 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123769 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123785 */     GIR_RootConstrainSelectedInstOperands,
     /* 123786 */     // GIR_Coverage, 4496,
     /* 123786 */     GIR_EraseRootFromParent_Done,
     /* 123787 */   // Label 2296: @123787
     /* 123787 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123831), // Rule ID 4498 //
     /* 123792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123810 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123813 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123829 */     GIR_RootConstrainSelectedInstOperands,
     /* 123830 */     // GIR_Coverage, 4498,
     /* 123830 */     GIR_EraseRootFromParent_Done,
     /* 123831 */   // Label 2297: @123831
     /* 123831 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123875), // Rule ID 4520 //
     /* 123836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123854 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123857 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123873 */     GIR_RootConstrainSelectedInstOperands,
     /* 123874 */     // GIR_Coverage, 4520,
     /* 123874 */     GIR_EraseRootFromParent_Done,
     /* 123875 */   // Label 2298: @123875
     /* 123875 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123919), // Rule ID 4522 //
     /* 123880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123898 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123901 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123917 */     GIR_RootConstrainSelectedInstOperands,
     /* 123918 */     // GIR_Coverage, 4522,
     /* 123918 */     GIR_EraseRootFromParent_Done,
     /* 123919 */   // Label 2299: @123919
     /* 123919 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123939), // Rule ID 6415 //
     /* 123924 */     // MIs[0] Rn
     /* 123924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123932 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 123937 */     GIR_RootConstrainSelectedInstOperands,
     /* 123938 */     // GIR_Coverage, 6415,
     /* 123938 */     GIR_Done,
     /* 123939 */   // Label 2300: @123939
     /* 123939 */   GIM_Reject,
     /* 123940 */ // Label 2291: @123940
     /* 123940 */ GIM_Reject,
     /* 123941 */ // Label 2115: @123941
     /* 123941 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(124346),
     /* 123946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123953 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(124002), // Rule ID 4470 //
     /* 123958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123976 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123979 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124000 */     GIR_RootConstrainSelectedInstOperands,
     /* 124001 */     // GIR_Coverage, 4470,
     /* 124001 */     GIR_EraseRootFromParent_Done,
     /* 124002 */   // Label 2302: @124002
     /* 124002 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(124051), // Rule ID 4471 //
     /* 124007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124025 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124028 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124049 */     GIR_RootConstrainSelectedInstOperands,
     /* 124050 */     // GIR_Coverage, 4471,
     /* 124050 */     GIR_EraseRootFromParent_Done,
     /* 124051 */   // Label 2303: @124051
     /* 124051 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(124100), // Rule ID 4472 //
     /* 124056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124074 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124077 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124098 */     GIR_RootConstrainSelectedInstOperands,
     /* 124099 */     // GIR_Coverage, 4472,
     /* 124099 */     GIR_EraseRootFromParent_Done,
     /* 124100 */   // Label 2304: @124100
     /* 124100 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(124149), // Rule ID 4473 //
     /* 124105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124123 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124126 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124147 */     GIR_RootConstrainSelectedInstOperands,
     /* 124148 */     // GIR_Coverage, 4473,
     /* 124148 */     GIR_EraseRootFromParent_Done,
     /* 124149 */   // Label 2305: @124149
     /* 124149 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(124193), // Rule ID 4500 //
     /* 124154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124172 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124175 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124191 */     GIR_RootConstrainSelectedInstOperands,
     /* 124192 */     // GIR_Coverage, 4500,
     /* 124192 */     GIR_EraseRootFromParent_Done,
     /* 124193 */   // Label 2306: @124193
     /* 124193 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(124237), // Rule ID 4504 //
     /* 124198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124216 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124219 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124235 */     GIR_RootConstrainSelectedInstOperands,
     /* 124236 */     // GIR_Coverage, 4504,
     /* 124236 */     GIR_EraseRootFromParent_Done,
     /* 124237 */   // Label 2307: @124237
     /* 124237 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(124281), // Rule ID 4524 //
     /* 124242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124260 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124279 */     GIR_RootConstrainSelectedInstOperands,
     /* 124280 */     // GIR_Coverage, 4524,
     /* 124280 */     GIR_EraseRootFromParent_Done,
     /* 124281 */   // Label 2308: @124281
     /* 124281 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(124325), // Rule ID 4528 //
     /* 124286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124304 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124307 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124323 */     GIR_RootConstrainSelectedInstOperands,
     /* 124324 */     // GIR_Coverage, 4528,
     /* 124324 */     GIR_EraseRootFromParent_Done,
     /* 124325 */   // Label 2309: @124325
     /* 124325 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(124345), // Rule ID 6412 //
     /* 124330 */     // MIs[0] Rn
     /* 124330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124338 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 124343 */     GIR_RootConstrainSelectedInstOperands,
     /* 124344 */     // GIR_Coverage, 6412,
     /* 124344 */     GIR_Done,
     /* 124345 */   // Label 2310: @124345
     /* 124345 */   GIM_Reject,
     /* 124346 */ // Label 2301: @124346
     /* 124346 */ GIM_Reject,
     /* 124347 */ // Label 2116: @124347
     /* 124347 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(124566),
     /* 124352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124359 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(124408), // Rule ID 4458 //
     /* 124364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124382 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 124385 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 4458,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 2312: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(124457), // Rule ID 4459 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124431 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124455 */     GIR_RootConstrainSelectedInstOperands,
     /* 124456 */     // GIR_Coverage, 4459,
     /* 124456 */     GIR_EraseRootFromParent_Done,
     /* 124457 */   // Label 2313: @124457
     /* 124457 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(124501), // Rule ID 4495 //
     /* 124462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124480 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 124483 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124499 */     GIR_RootConstrainSelectedInstOperands,
     /* 124500 */     // GIR_Coverage, 4495,
     /* 124500 */     GIR_EraseRootFromParent_Done,
     /* 124501 */   // Label 2314: @124501
     /* 124501 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(124545), // Rule ID 4519 //
     /* 124506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124524 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 124527 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124543 */     GIR_RootConstrainSelectedInstOperands,
     /* 124544 */     // GIR_Coverage, 4519,
     /* 124544 */     GIR_EraseRootFromParent_Done,
     /* 124545 */   // Label 2315: @124545
     /* 124545 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(124565), // Rule ID 6414 //
     /* 124550 */     // MIs[0] Rn
     /* 124550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124558 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 124563 */     GIR_RootConstrainSelectedInstOperands,
     /* 124564 */     // GIR_Coverage, 6414,
     /* 124564 */     GIR_Done,
     /* 124565 */   // Label 2316: @124565
     /* 124565 */   GIM_Reject,
     /* 124566 */ // Label 2311: @124566
     /* 124566 */ GIM_Reject,
     /* 124567 */ // Label 2117: @124567
     /* 124567 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(124972),
     /* 124572 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124575 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124579 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(124628), // Rule ID 4474 //
     /* 124584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124602 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124605 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124626 */     GIR_RootConstrainSelectedInstOperands,
     /* 124627 */     // GIR_Coverage, 4474,
     /* 124627 */     GIR_EraseRootFromParent_Done,
     /* 124628 */   // Label 2318: @124628
     /* 124628 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(124677), // Rule ID 4475 //
     /* 124633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124651 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124654 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124675 */     GIR_RootConstrainSelectedInstOperands,
     /* 124676 */     // GIR_Coverage, 4475,
     /* 124676 */     GIR_EraseRootFromParent_Done,
     /* 124677 */   // Label 2319: @124677
     /* 124677 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(124726), // Rule ID 4478 //
     /* 124682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124700 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124703 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124724 */     GIR_RootConstrainSelectedInstOperands,
     /* 124725 */     // GIR_Coverage, 4478,
     /* 124725 */     GIR_EraseRootFromParent_Done,
     /* 124726 */   // Label 2320: @124726
     /* 124726 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124775), // Rule ID 4479 //
     /* 124731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124749 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124752 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124773 */     GIR_RootConstrainSelectedInstOperands,
     /* 124774 */     // GIR_Coverage, 4479,
     /* 124774 */     GIR_EraseRootFromParent_Done,
     /* 124775 */   // Label 2321: @124775
     /* 124775 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124819), // Rule ID 4503 //
     /* 124780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124798 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124817 */     GIR_RootConstrainSelectedInstOperands,
     /* 124818 */     // GIR_Coverage, 4503,
     /* 124818 */     GIR_EraseRootFromParent_Done,
     /* 124819 */   // Label 2322: @124819
     /* 124819 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124863), // Rule ID 4506 //
     /* 124824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124842 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124845 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124861 */     GIR_RootConstrainSelectedInstOperands,
     /* 124862 */     // GIR_Coverage, 4506,
     /* 124862 */     GIR_EraseRootFromParent_Done,
     /* 124863 */   // Label 2323: @124863
     /* 124863 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124907), // Rule ID 4527 //
     /* 124868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124886 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124889 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124905 */     GIR_RootConstrainSelectedInstOperands,
     /* 124906 */     // GIR_Coverage, 4527,
     /* 124906 */     GIR_EraseRootFromParent_Done,
     /* 124907 */   // Label 2324: @124907
     /* 124907 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124951), // Rule ID 4531 //
     /* 124912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124930 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124933 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124949 */     GIR_RootConstrainSelectedInstOperands,
     /* 124950 */     // GIR_Coverage, 4531,
     /* 124950 */     GIR_EraseRootFromParent_Done,
     /* 124951 */   // Label 2325: @124951
     /* 124951 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124971), // Rule ID 6411 //
     /* 124956 */     // MIs[0] Rn
     /* 124956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124964 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124969 */     GIR_RootConstrainSelectedInstOperands,
     /* 124970 */     // GIR_Coverage, 6411,
     /* 124970 */     GIR_Done,
     /* 124971 */   // Label 2326: @124971
     /* 124971 */   GIM_Reject,
     /* 124972 */ // Label 2317: @124972
     /* 124972 */ GIM_Reject,
     /* 124973 */ // Label 2118: @124973
     /* 124973 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(125192),
     /* 124978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124985 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(125034), // Rule ID 4476 //
     /* 124990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125008 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 125011 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125032 */     GIR_RootConstrainSelectedInstOperands,
     /* 125033 */     // GIR_Coverage, 4476,
     /* 125033 */     GIR_EraseRootFromParent_Done,
     /* 125034 */   // Label 2328: @125034
     /* 125034 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(125083), // Rule ID 4477 //
     /* 125039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 125042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125057 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 125060 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125081 */     GIR_RootConstrainSelectedInstOperands,
     /* 125082 */     // GIR_Coverage, 4477,
     /* 125082 */     GIR_EraseRootFromParent_Done,
     /* 125083 */   // Label 2329: @125083
     /* 125083 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(125127), // Rule ID 4502 //
     /* 125088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125106 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 125109 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125125 */     GIR_RootConstrainSelectedInstOperands,
     /* 125126 */     // GIR_Coverage, 4502,
     /* 125126 */     GIR_EraseRootFromParent_Done,
     /* 125127 */   // Label 2330: @125127
     /* 125127 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(125171), // Rule ID 4526 //
     /* 125132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125150 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 125153 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125169 */     GIR_RootConstrainSelectedInstOperands,
     /* 125170 */     // GIR_Coverage, 4526,
     /* 125170 */     GIR_EraseRootFromParent_Done,
     /* 125171 */   // Label 2331: @125171
     /* 125171 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(125191), // Rule ID 6410 //
     /* 125176 */     // MIs[0] Rn
     /* 125176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125184 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 125184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 125189 */     GIR_RootConstrainSelectedInstOperands,
     /* 125190 */     // GIR_Coverage, 6410,
     /* 125190 */     GIR_Done,
     /* 125191 */   // Label 2332: @125191
     /* 125191 */   GIM_Reject,
     /* 125192 */ // Label 2327: @125192
     /* 125192 */ GIM_Reject,
     /* 125193 */ // Label 2119: @125193
     /* 125193 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(125252), // Rule ID 10892 //
     /* 125198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125204 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125208 */   // MIs[0] base
     /* 125208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125216 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 125236 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125241 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125250 */   GIR_RootConstrainSelectedInstOperands,
     /* 125251 */   // GIR_Coverage, 10892,
     /* 125251 */   GIR_EraseRootFromParent_Done,
     /* 125252 */ // Label 2333: @125252
     /* 125252 */ GIM_Reject,
     /* 125253 */ // Label 2120: @125253
     /* 125253 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(125312), // Rule ID 10898 //
     /* 125258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125268 */   // MIs[0] base
     /* 125268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125276 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125288 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 125296 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125301 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125310 */   GIR_RootConstrainSelectedInstOperands,
     /* 125311 */   // GIR_Coverage, 10898,
     /* 125311 */   GIR_EraseRootFromParent_Done,
     /* 125312 */ // Label 2334: @125312
     /* 125312 */ GIM_Reject,
     /* 125313 */ // Label 2121: @125313
     /* 125313 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(125482),
     /* 125318 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125321 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125329 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(125377), // Rule ID 10883 //
     /* 125334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125341 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125361 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125366 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125375 */     GIR_RootConstrainSelectedInstOperands,
     /* 125376 */     // GIR_Coverage, 10883,
     /* 125376 */     GIR_EraseRootFromParent_Done,
     /* 125377 */   // Label 2336: @125377
     /* 125377 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(125425), // Rule ID 10901 //
     /* 125382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125389 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125409 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125414 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125423 */     GIR_RootConstrainSelectedInstOperands,
     /* 125424 */     // GIR_Coverage, 10901,
     /* 125424 */     GIR_EraseRootFromParent_Done,
     /* 125425 */   // Label 2337: @125425
     /* 125425 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(125453), // Rule ID 11013 //
     /* 125430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125437 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125440 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125442 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125451 */     GIR_RootConstrainSelectedInstOperands,
     /* 125452 */     // GIR_Coverage, 11013,
     /* 125452 */     GIR_EraseRootFromParent_Done,
     /* 125453 */   // Label 2338: @125453
     /* 125453 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(125481), // Rule ID 11025 //
     /* 125458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125465 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125468 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125470 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125479 */     GIR_RootConstrainSelectedInstOperands,
     /* 125480 */     // GIR_Coverage, 11025,
     /* 125480 */     GIR_EraseRootFromParent_Done,
     /* 125481 */   // Label 2339: @125481
     /* 125481 */   GIM_Reject,
     /* 125482 */ // Label 2335: @125482
     /* 125482 */ GIM_Reject,
     /* 125483 */ // Label 2122: @125483
     /* 125483 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(125542), // Rule ID 10889 //
     /* 125488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125491 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125498 */   // MIs[0] base
     /* 125498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125506 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125518 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 125526 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125531 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125540 */   GIR_RootConstrainSelectedInstOperands,
     /* 125541 */   // GIR_Coverage, 10889,
     /* 125541 */   GIR_EraseRootFromParent_Done,
     /* 125542 */ // Label 2340: @125542
     /* 125542 */ GIM_Reject,
     /* 125543 */ // Label 2123: @125543
     /* 125543 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(125712),
     /* 125548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125559 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(125607), // Rule ID 10877 //
     /* 125564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125571 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125591 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125596 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125605 */     GIR_RootConstrainSelectedInstOperands,
     /* 125606 */     // GIR_Coverage, 10877,
     /* 125606 */     GIR_EraseRootFromParent_Done,
     /* 125607 */   // Label 2342: @125607
     /* 125607 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(125655), // Rule ID 10895 //
     /* 125612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125619 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125639 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125644 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125653 */     GIR_RootConstrainSelectedInstOperands,
     /* 125654 */     // GIR_Coverage, 10895,
     /* 125654 */     GIR_EraseRootFromParent_Done,
     /* 125655 */   // Label 2343: @125655
     /* 125655 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(125683), // Rule ID 11009 //
     /* 125660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125667 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125670 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125681 */     GIR_RootConstrainSelectedInstOperands,
     /* 125682 */     // GIR_Coverage, 11009,
     /* 125682 */     GIR_EraseRootFromParent_Done,
     /* 125683 */   // Label 2344: @125683
     /* 125683 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(125711), // Rule ID 11021 //
     /* 125688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125695 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125698 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125700 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125709 */     GIR_RootConstrainSelectedInstOperands,
     /* 125710 */     // GIR_Coverage, 11021,
     /* 125710 */     GIR_EraseRootFromParent_Done,
     /* 125711 */   // Label 2345: @125711
     /* 125711 */   GIM_Reject,
     /* 125712 */ // Label 2341: @125712
     /* 125712 */ GIM_Reject,
     /* 125713 */ // Label 2124: @125713
     /* 125713 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(125882),
     /* 125718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125721 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125725 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125729 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125777), // Rule ID 10868 //
     /* 125734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125741 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125753 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125761 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125766 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125775 */     GIR_RootConstrainSelectedInstOperands,
     /* 125776 */     // GIR_Coverage, 10868,
     /* 125776 */     GIR_EraseRootFromParent_Done,
     /* 125777 */   // Label 2347: @125777
     /* 125777 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125825), // Rule ID 10886 //
     /* 125782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125789 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125809 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125814 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125823 */     GIR_RootConstrainSelectedInstOperands,
     /* 125824 */     // GIR_Coverage, 10886,
     /* 125824 */     GIR_EraseRootFromParent_Done,
     /* 125825 */   // Label 2348: @125825
     /* 125825 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125853), // Rule ID 11005 //
     /* 125830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125837 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125840 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125842 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125851 */     GIR_RootConstrainSelectedInstOperands,
     /* 125852 */     // GIR_Coverage, 11005,
     /* 125852 */     GIR_EraseRootFromParent_Done,
     /* 125853 */   // Label 2349: @125853
     /* 125853 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(125881), // Rule ID 11017 //
     /* 125858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125865 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125868 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125879 */     GIR_RootConstrainSelectedInstOperands,
     /* 125880 */     // GIR_Coverage, 11017,
     /* 125880 */     GIR_EraseRootFromParent_Done,
     /* 125881 */   // Label 2350: @125881
     /* 125881 */   GIM_Reject,
     /* 125882 */ // Label 2346: @125882
     /* 125882 */ GIM_Reject,
     /* 125883 */ // Label 2125: @125883
     /* 125883 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(125926), // Rule ID 2430 //
     /* 125888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 125902 */   // MIs[0] base
     /* 125902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125910 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 125913 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 125915 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125924 */   GIR_RootConstrainSelectedInstOperands,
     /* 125925 */   // GIR_Coverage, 2430,
     /* 125925 */   GIR_EraseRootFromParent_Done,
     /* 125926 */ // Label 2351: @125926
     /* 125926 */ GIM_Reject,
     /* 125927 */ // Label 2126: @125927
     /* 125927 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(126020),
     /* 125932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125943 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(125991), // Rule ID 10854 //
     /* 125948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125955 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125975 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125989 */     GIR_RootConstrainSelectedInstOperands,
     /* 125990 */     // GIR_Coverage, 10854,
     /* 125990 */     GIR_EraseRootFromParent_Done,
     /* 125991 */   // Label 2353: @125991
     /* 125991 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(126019), // Rule ID 11001 //
     /* 125996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126003 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 126006 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 126008 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126017 */     GIR_RootConstrainSelectedInstOperands,
     /* 126018 */     // GIR_Coverage, 11001,
     /* 126018 */     GIR_EraseRootFromParent_Done,
     /* 126019 */   // Label 2354: @126019
     /* 126019 */   GIM_Reject,
     /* 126020 */ // Label 2352: @126020
     /* 126020 */ GIM_Reject,
     /* 126021 */ // Label 2127: @126021
     /* 126021 */ GIM_Reject,
     /* 126022 */ // Label 20: @126022
     /* 126022 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2357*/ GIMT_Encode4(127372),
     /* 126033 */ /*GILLT_s32*//*Label 2355*/ GIMT_Encode4(126041),
     /* 126037 */ /*GILLT_s64*//*Label 2356*/ GIMT_Encode4(127059),
     /* 126041 */ // Label 2355: @126041
     /* 126041 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(127058),
     /* 126046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126052 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(126107), // Rule ID 7314 //
     /* 126057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126074 */     // MIs[0] Rn
     /* 126074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126090 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 126093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126105 */     GIR_RootConstrainSelectedInstOperands,
     /* 126106 */     // GIR_Coverage, 7314,
     /* 126106 */     GIR_EraseRootFromParent_Done,
     /* 126107 */   // Label 2359: @126107
     /* 126107 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(126162), // Rule ID 7315 //
     /* 126112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126129 */     // MIs[0] Rn
     /* 126129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126145 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 126148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126160 */     GIR_RootConstrainSelectedInstOperands,
     /* 126161 */     // GIR_Coverage, 7315,
     /* 126161 */     GIR_EraseRootFromParent_Done,
     /* 126162 */   // Label 2360: @126162
     /* 126162 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(126217), // Rule ID 7316 //
     /* 126167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126184 */     // MIs[0] Rn
     /* 126184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126200 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 126203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126215 */     GIR_RootConstrainSelectedInstOperands,
     /* 126216 */     // GIR_Coverage, 7316,
     /* 126216 */     GIR_EraseRootFromParent_Done,
     /* 126217 */   // Label 2361: @126217
     /* 126217 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(126272), // Rule ID 7317 //
     /* 126222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126239 */     // MIs[0] Rn
     /* 126239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126255 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126270 */     GIR_RootConstrainSelectedInstOperands,
     /* 126271 */     // GIR_Coverage, 7317,
     /* 126271 */     GIR_EraseRootFromParent_Done,
     /* 126272 */   // Label 2362: @126272
     /* 126272 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(126327), // Rule ID 7318 //
     /* 126277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126294 */     // MIs[0] Rn
     /* 126294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126310 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126325 */     GIR_RootConstrainSelectedInstOperands,
     /* 126326 */     // GIR_Coverage, 7318,
     /* 126326 */     GIR_EraseRootFromParent_Done,
     /* 126327 */   // Label 2363: @126327
     /* 126327 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(126382), // Rule ID 7319 //
     /* 126332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126349 */     // MIs[0] Rn
     /* 126349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126365 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 126368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126380 */     GIR_RootConstrainSelectedInstOperands,
     /* 126381 */     // GIR_Coverage, 7319,
     /* 126381 */     GIR_EraseRootFromParent_Done,
     /* 126382 */   // Label 2364: @126382
     /* 126382 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(126437), // Rule ID 7320 //
     /* 126387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126404 */     // MIs[0] Rn
     /* 126404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126420 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 126423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126435 */     GIR_RootConstrainSelectedInstOperands,
     /* 126436 */     // GIR_Coverage, 7320,
     /* 126436 */     GIR_EraseRootFromParent_Done,
     /* 126437 */   // Label 2365: @126437
     /* 126437 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(126492), // Rule ID 7321 //
     /* 126442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126459 */     // MIs[0] Rn
     /* 126459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126475 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 126478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126490 */     GIR_RootConstrainSelectedInstOperands,
     /* 126491 */     // GIR_Coverage, 7321,
     /* 126491 */     GIR_EraseRootFromParent_Done,
     /* 126492 */   // Label 2366: @126492
     /* 126492 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(126547), // Rule ID 7322 //
     /* 126497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126514 */     // MIs[0] Rn
     /* 126514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126530 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126545 */     GIR_RootConstrainSelectedInstOperands,
     /* 126546 */     // GIR_Coverage, 7322,
     /* 126546 */     GIR_EraseRootFromParent_Done,
     /* 126547 */   // Label 2367: @126547
     /* 126547 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(126602), // Rule ID 7323 //
     /* 126552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126569 */     // MIs[0] Rn
     /* 126569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126585 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126600 */     GIR_RootConstrainSelectedInstOperands,
     /* 126601 */     // GIR_Coverage, 7323,
     /* 126601 */     GIR_EraseRootFromParent_Done,
     /* 126602 */   // Label 2368: @126602
     /* 126602 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(126657), // Rule ID 7324 //
     /* 126607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126624 */     // MIs[0] Rn
     /* 126624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126640 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 126643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126655 */     GIR_RootConstrainSelectedInstOperands,
     /* 126656 */     // GIR_Coverage, 7324,
     /* 126656 */     GIR_EraseRootFromParent_Done,
     /* 126657 */   // Label 2369: @126657
     /* 126657 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126712), // Rule ID 7325 //
     /* 126662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126679 */     // MIs[0] Rn
     /* 126679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126695 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 126698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126710 */     GIR_RootConstrainSelectedInstOperands,
     /* 126711 */     // GIR_Coverage, 7325,
     /* 126711 */     GIR_EraseRootFromParent_Done,
     /* 126712 */   // Label 2370: @126712
     /* 126712 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126767), // Rule ID 7326 //
     /* 126717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126734 */     // MIs[0] Rn
     /* 126734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126750 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 126753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126765 */     GIR_RootConstrainSelectedInstOperands,
     /* 126766 */     // GIR_Coverage, 7326,
     /* 126766 */     GIR_EraseRootFromParent_Done,
     /* 126767 */   // Label 2371: @126767
     /* 126767 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126822), // Rule ID 7327 //
     /* 126772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126782 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126789 */     // MIs[0] Rn
     /* 126789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126805 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126820 */     GIR_RootConstrainSelectedInstOperands,
     /* 126821 */     // GIR_Coverage, 7327,
     /* 126821 */     GIR_EraseRootFromParent_Done,
     /* 126822 */   // Label 2372: @126822
     /* 126822 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126877), // Rule ID 7328 //
     /* 126827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126844 */     // MIs[0] Rn
     /* 126844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126860 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126875 */     GIR_RootConstrainSelectedInstOperands,
     /* 126876 */     // GIR_Coverage, 7328,
     /* 126876 */     GIR_EraseRootFromParent_Done,
     /* 126877 */   // Label 2373: @126877
     /* 126877 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126937), // Rule ID 13141 //
     /* 126882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126896 */     // MIs[0] addr
     /* 126896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126912 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 126918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126920 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126925 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126927 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126929 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126935 */     GIR_RootConstrainSelectedInstOperands,
     /* 126936 */     // GIR_Coverage, 13141,
     /* 126936 */     GIR_EraseRootFromParent_Done,
     /* 126937 */   // Label 2374: @126937
     /* 126937 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126997), // Rule ID 13142 //
     /* 126942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126956 */     // MIs[0] addr
     /* 126956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126972 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126980 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126985 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126987 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126989 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126995 */     GIR_RootConstrainSelectedInstOperands,
     /* 126996 */     // GIR_Coverage, 13142,
     /* 126996 */     GIR_EraseRootFromParent_Done,
     /* 126997 */   // Label 2375: @126997
     /* 126997 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(127057), // Rule ID 13143 //
     /* 127002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 127005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127016 */     // MIs[0] addr
     /* 127016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127032 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 127032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 127038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127040 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 127045 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 127047 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 127049 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 127051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127055 */     GIR_RootConstrainSelectedInstOperands,
     /* 127056 */     // GIR_Coverage, 13143,
     /* 127056 */     GIR_EraseRootFromParent_Done,
     /* 127057 */   // Label 2376: @127057
     /* 127057 */   GIM_Reject,
     /* 127058 */ // Label 2358: @127058
     /* 127058 */ GIM_Reject,
     /* 127059 */ // Label 2356: @127059
     /* 127059 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(127371),
     /* 127064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 127070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127077 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(127125), // Rule ID 2589 //
     /* 127082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127092 */     // MIs[0] Rn
     /* 127092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127108 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 127111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127123 */     GIR_RootConstrainSelectedInstOperands,
     /* 127124 */     // GIR_Coverage, 2589,
     /* 127124 */     GIR_EraseRootFromParent_Done,
     /* 127125 */   // Label 2378: @127125
     /* 127125 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(127173), // Rule ID 2590 //
     /* 127130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127140 */     // MIs[0] Rn
     /* 127140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127156 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 127159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127171 */     GIR_RootConstrainSelectedInstOperands,
     /* 127172 */     // GIR_Coverage, 2590,
     /* 127172 */     GIR_EraseRootFromParent_Done,
     /* 127173 */   // Label 2379: @127173
     /* 127173 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(127221), // Rule ID 2591 //
     /* 127178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127188 */     // MIs[0] Rn
     /* 127188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127204 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 127207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127219 */     GIR_RootConstrainSelectedInstOperands,
     /* 127220 */     // GIR_Coverage, 2591,
     /* 127220 */     GIR_EraseRootFromParent_Done,
     /* 127221 */   // Label 2380: @127221
     /* 127221 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(127269), // Rule ID 2592 //
     /* 127226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127236 */     // MIs[0] Rn
     /* 127236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127252 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127267 */     GIR_RootConstrainSelectedInstOperands,
     /* 127268 */     // GIR_Coverage, 2592,
     /* 127268 */     GIR_EraseRootFromParent_Done,
     /* 127269 */   // Label 2381: @127269
     /* 127269 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(127317), // Rule ID 2593 //
     /* 127274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127284 */     // MIs[0] Rn
     /* 127284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127300 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127315 */     GIR_RootConstrainSelectedInstOperands,
     /* 127316 */     // GIR_Coverage, 2593,
     /* 127316 */     GIR_EraseRootFromParent_Done,
     /* 127317 */   // Label 2382: @127317
     /* 127317 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(127370), // Rule ID 13144 //
     /* 127322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 127325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127329 */     // MIs[0] addr
     /* 127329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127345 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 127345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 127351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127353 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 127358 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 127360 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 127362 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 127364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127368 */     GIR_RootConstrainSelectedInstOperands,
     /* 127369 */     // GIR_Coverage, 13144,
     /* 127369 */     GIR_EraseRootFromParent_Done,
     /* 127370 */   // Label 2383: @127370
     /* 127370 */   GIM_Reject,
     /* 127371 */ // Label 2377: @127371
     /* 127371 */ GIM_Reject,
     /* 127372 */ // Label 2357: @127372
     /* 127372 */ GIM_Reject,
     /* 127373 */ // Label 21: @127373
     /* 127373 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2386*/ GIMT_Encode4(128364),
     /* 127384 */ /*GILLT_s32*//*Label 2384*/ GIMT_Encode4(127392),
     /* 127388 */ /*GILLT_s64*//*Label 2385*/ GIMT_Encode4(128137),
     /* 127392 */ // Label 2384: @127392
     /* 127392 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(128136),
     /* 127397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127400 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(127449), // Rule ID 7299 //
     /* 127405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127422 */     // MIs[0] Rn
     /* 127422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127434 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 127437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127447 */     GIR_RootConstrainSelectedInstOperands,
     /* 127448 */     // GIR_Coverage, 7299,
     /* 127448 */     GIR_EraseRootFromParent_Done,
     /* 127449 */   // Label 2388: @127449
     /* 127449 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(127498), // Rule ID 7300 //
     /* 127454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127471 */     // MIs[0] Rn
     /* 127471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127483 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 127486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127496 */     GIR_RootConstrainSelectedInstOperands,
     /* 127497 */     // GIR_Coverage, 7300,
     /* 127497 */     GIR_EraseRootFromParent_Done,
     /* 127498 */   // Label 2389: @127498
     /* 127498 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(127547), // Rule ID 7301 //
     /* 127503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127520 */     // MIs[0] Rn
     /* 127520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127532 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 127535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127545 */     GIR_RootConstrainSelectedInstOperands,
     /* 127546 */     // GIR_Coverage, 7301,
     /* 127546 */     GIR_EraseRootFromParent_Done,
     /* 127547 */   // Label 2390: @127547
     /* 127547 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(127596), // Rule ID 7302 //
     /* 127552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127569 */     // MIs[0] Rn
     /* 127569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127581 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127594 */     GIR_RootConstrainSelectedInstOperands,
     /* 127595 */     // GIR_Coverage, 7302,
     /* 127595 */     GIR_EraseRootFromParent_Done,
     /* 127596 */   // Label 2391: @127596
     /* 127596 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(127645), // Rule ID 7303 //
     /* 127601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127618 */     // MIs[0] Rn
     /* 127618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127630 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127643 */     GIR_RootConstrainSelectedInstOperands,
     /* 127644 */     // GIR_Coverage, 7303,
     /* 127644 */     GIR_EraseRootFromParent_Done,
     /* 127645 */   // Label 2392: @127645
     /* 127645 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(127694), // Rule ID 7304 //
     /* 127650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127667 */     // MIs[0] Rn
     /* 127667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127679 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 127682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127692 */     GIR_RootConstrainSelectedInstOperands,
     /* 127693 */     // GIR_Coverage, 7304,
     /* 127693 */     GIR_EraseRootFromParent_Done,
     /* 127694 */   // Label 2393: @127694
     /* 127694 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127743), // Rule ID 7305 //
     /* 127699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127716 */     // MIs[0] Rn
     /* 127716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127728 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 127731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127741 */     GIR_RootConstrainSelectedInstOperands,
     /* 127742 */     // GIR_Coverage, 7305,
     /* 127742 */     GIR_EraseRootFromParent_Done,
     /* 127743 */   // Label 2394: @127743
     /* 127743 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127792), // Rule ID 7306 //
     /* 127748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127765 */     // MIs[0] Rn
     /* 127765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127777 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 127780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127790 */     GIR_RootConstrainSelectedInstOperands,
     /* 127791 */     // GIR_Coverage, 7306,
     /* 127791 */     GIR_EraseRootFromParent_Done,
     /* 127792 */   // Label 2395: @127792
     /* 127792 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127841), // Rule ID 7307 //
     /* 127797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127814 */     // MIs[0] Rn
     /* 127814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127826 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127839 */     GIR_RootConstrainSelectedInstOperands,
     /* 127840 */     // GIR_Coverage, 7307,
     /* 127840 */     GIR_EraseRootFromParent_Done,
     /* 127841 */   // Label 2396: @127841
     /* 127841 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127890), // Rule ID 7308 //
     /* 127846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127863 */     // MIs[0] Rn
     /* 127863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127875 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127888 */     GIR_RootConstrainSelectedInstOperands,
     /* 127889 */     // GIR_Coverage, 7308,
     /* 127889 */     GIR_EraseRootFromParent_Done,
     /* 127890 */   // Label 2397: @127890
     /* 127890 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127939), // Rule ID 7309 //
     /* 127895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127912 */     // MIs[0] Rn
     /* 127912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127924 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 127927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127937 */     GIR_RootConstrainSelectedInstOperands,
     /* 127938 */     // GIR_Coverage, 7309,
     /* 127938 */     GIR_EraseRootFromParent_Done,
     /* 127939 */   // Label 2398: @127939
     /* 127939 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127988), // Rule ID 7310 //
     /* 127944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127961 */     // MIs[0] Rn
     /* 127961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127973 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127986 */     GIR_RootConstrainSelectedInstOperands,
     /* 127987 */     // GIR_Coverage, 7310,
     /* 127987 */     GIR_EraseRootFromParent_Done,
     /* 127988 */   // Label 2399: @127988
     /* 127988 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(128037), // Rule ID 7311 //
     /* 127993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128010 */     // MIs[0] Rn
     /* 128010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128022 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 128025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128035 */     GIR_RootConstrainSelectedInstOperands,
     /* 128036 */     // GIR_Coverage, 7311,
     /* 128036 */     GIR_EraseRootFromParent_Done,
     /* 128037 */   // Label 2400: @128037
     /* 128037 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(128086), // Rule ID 7312 //
     /* 128042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128045 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128052 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128059 */     // MIs[0] Rn
     /* 128059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128071 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 128074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128084 */     GIR_RootConstrainSelectedInstOperands,
     /* 128085 */     // GIR_Coverage, 7312,
     /* 128085 */     GIR_EraseRootFromParent_Done,
     /* 128086 */   // Label 2401: @128086
     /* 128086 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(128135), // Rule ID 7313 //
     /* 128091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128094 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128101 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128108 */     // MIs[0] Rn
     /* 128108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128120 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 128123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128133 */     GIR_RootConstrainSelectedInstOperands,
     /* 128134 */     // GIR_Coverage, 7313,
     /* 128134 */     GIR_EraseRootFromParent_Done,
     /* 128135 */   // Label 2402: @128135
     /* 128135 */   GIM_Reject,
     /* 128136 */ // Label 2387: @128136
     /* 128136 */ GIM_Reject,
     /* 128137 */ // Label 2385: @128137
     /* 128137 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(128363),
     /* 128142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128152 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(128194), // Rule ID 7294 //
     /* 128157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128167 */     // MIs[0] Rn
     /* 128167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128179 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 128182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128192 */     GIR_RootConstrainSelectedInstOperands,
     /* 128193 */     // GIR_Coverage, 7294,
     /* 128193 */     GIR_EraseRootFromParent_Done,
     /* 128194 */   // Label 2404: @128194
     /* 128194 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(128236), // Rule ID 7295 //
     /* 128199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128209 */     // MIs[0] Rn
     /* 128209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128221 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 128224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128234 */     GIR_RootConstrainSelectedInstOperands,
     /* 128235 */     // GIR_Coverage, 7295,
     /* 128235 */     GIR_EraseRootFromParent_Done,
     /* 128236 */   // Label 2405: @128236
     /* 128236 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(128278), // Rule ID 7296 //
     /* 128241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128251 */     // MIs[0] Rn
     /* 128251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128263 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 128266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128276 */     GIR_RootConstrainSelectedInstOperands,
     /* 128277 */     // GIR_Coverage, 7296,
     /* 128277 */     GIR_EraseRootFromParent_Done,
     /* 128278 */   // Label 2406: @128278
     /* 128278 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(128320), // Rule ID 7297 //
     /* 128283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128293 */     // MIs[0] Rn
     /* 128293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128305 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128318 */     GIR_RootConstrainSelectedInstOperands,
     /* 128319 */     // GIR_Coverage, 7297,
     /* 128319 */     GIR_EraseRootFromParent_Done,
     /* 128320 */   // Label 2407: @128320
     /* 128320 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(128362), // Rule ID 7298 //
     /* 128325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128335 */     // MIs[0] Rn
     /* 128335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128347 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128360 */     GIR_RootConstrainSelectedInstOperands,
     /* 128361 */     // GIR_Coverage, 7298,
     /* 128361 */     GIR_EraseRootFromParent_Done,
     /* 128362 */   // Label 2408: @128362
     /* 128362 */   GIM_Reject,
     /* 128363 */ // Label 2403: @128363
     /* 128363 */ GIM_Reject,
     /* 128364 */ // Label 2386: @128364
     /* 128364 */ GIM_Reject,
     /* 128365 */ // Label 22: @128365
     /* 128365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2411*/ GIMT_Encode4(129356),
     /* 128376 */ /*GILLT_s32*//*Label 2409*/ GIMT_Encode4(128384),
     /* 128380 */ /*GILLT_s64*//*Label 2410*/ GIMT_Encode4(129129),
     /* 128384 */ // Label 2409: @128384
     /* 128384 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(129128),
     /* 128389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128392 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(128441), // Rule ID 7139 //
     /* 128397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128414 */     // MIs[0] Rn
     /* 128414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128426 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128439 */     GIR_RootConstrainSelectedInstOperands,
     /* 128440 */     // GIR_Coverage, 7139,
     /* 128440 */     GIR_EraseRootFromParent_Done,
     /* 128441 */   // Label 2413: @128441
     /* 128441 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(128490), // Rule ID 7140 //
     /* 128446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128463 */     // MIs[0] Rn
     /* 128463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128475 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128488 */     GIR_RootConstrainSelectedInstOperands,
     /* 128489 */     // GIR_Coverage, 7140,
     /* 128489 */     GIR_EraseRootFromParent_Done,
     /* 128490 */   // Label 2414: @128490
     /* 128490 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(128539), // Rule ID 7141 //
     /* 128495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128512 */     // MIs[0] Rn
     /* 128512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128524 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128537 */     GIR_RootConstrainSelectedInstOperands,
     /* 128538 */     // GIR_Coverage, 7141,
     /* 128538 */     GIR_EraseRootFromParent_Done,
     /* 128539 */   // Label 2415: @128539
     /* 128539 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(128588), // Rule ID 7142 //
     /* 128544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128561 */     // MIs[0] Rn
     /* 128561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128573 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128586 */     GIR_RootConstrainSelectedInstOperands,
     /* 128587 */     // GIR_Coverage, 7142,
     /* 128587 */     GIR_EraseRootFromParent_Done,
     /* 128588 */   // Label 2416: @128588
     /* 128588 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(128637), // Rule ID 7143 //
     /* 128593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128610 */     // MIs[0] Rn
     /* 128610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128622 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128635 */     GIR_RootConstrainSelectedInstOperands,
     /* 128636 */     // GIR_Coverage, 7143,
     /* 128636 */     GIR_EraseRootFromParent_Done,
     /* 128637 */   // Label 2417: @128637
     /* 128637 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(128686), // Rule ID 7144 //
     /* 128642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128659 */     // MIs[0] Rn
     /* 128659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128671 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128684 */     GIR_RootConstrainSelectedInstOperands,
     /* 128685 */     // GIR_Coverage, 7144,
     /* 128685 */     GIR_EraseRootFromParent_Done,
     /* 128686 */   // Label 2418: @128686
     /* 128686 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128735), // Rule ID 7145 //
     /* 128691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128708 */     // MIs[0] Rn
     /* 128708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128720 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128733 */     GIR_RootConstrainSelectedInstOperands,
     /* 128734 */     // GIR_Coverage, 7145,
     /* 128734 */     GIR_EraseRootFromParent_Done,
     /* 128735 */   // Label 2419: @128735
     /* 128735 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128784), // Rule ID 7146 //
     /* 128740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128757 */     // MIs[0] Rn
     /* 128757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128769 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128782 */     GIR_RootConstrainSelectedInstOperands,
     /* 128783 */     // GIR_Coverage, 7146,
     /* 128783 */     GIR_EraseRootFromParent_Done,
     /* 128784 */   // Label 2420: @128784
     /* 128784 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128833), // Rule ID 7147 //
     /* 128789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128806 */     // MIs[0] Rn
     /* 128806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128818 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128831 */     GIR_RootConstrainSelectedInstOperands,
     /* 128832 */     // GIR_Coverage, 7147,
     /* 128832 */     GIR_EraseRootFromParent_Done,
     /* 128833 */   // Label 2421: @128833
     /* 128833 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128882), // Rule ID 7148 //
     /* 128838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128855 */     // MIs[0] Rn
     /* 128855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128867 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128880 */     GIR_RootConstrainSelectedInstOperands,
     /* 128881 */     // GIR_Coverage, 7148,
     /* 128881 */     GIR_EraseRootFromParent_Done,
     /* 128882 */   // Label 2422: @128882
     /* 128882 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128931), // Rule ID 7149 //
     /* 128887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128904 */     // MIs[0] Rn
     /* 128904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128916 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 128919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128929 */     GIR_RootConstrainSelectedInstOperands,
     /* 128930 */     // GIR_Coverage, 7149,
     /* 128930 */     GIR_EraseRootFromParent_Done,
     /* 128931 */   // Label 2423: @128931
     /* 128931 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128980), // Rule ID 7150 //
     /* 128936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128953 */     // MIs[0] Rn
     /* 128953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128965 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128978 */     GIR_RootConstrainSelectedInstOperands,
     /* 128979 */     // GIR_Coverage, 7150,
     /* 128979 */     GIR_EraseRootFromParent_Done,
     /* 128980 */   // Label 2424: @128980
     /* 128980 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(129029), // Rule ID 7151 //
     /* 128985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129002 */     // MIs[0] Rn
     /* 129002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129014 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129027 */     GIR_RootConstrainSelectedInstOperands,
     /* 129028 */     // GIR_Coverage, 7151,
     /* 129028 */     GIR_EraseRootFromParent_Done,
     /* 129029 */   // Label 2425: @129029
     /* 129029 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(129078), // Rule ID 7152 //
     /* 129034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129051 */     // MIs[0] Rn
     /* 129051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129063 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129076 */     GIR_RootConstrainSelectedInstOperands,
     /* 129077 */     // GIR_Coverage, 7152,
     /* 129077 */     GIR_EraseRootFromParent_Done,
     /* 129078 */   // Label 2426: @129078
     /* 129078 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(129127), // Rule ID 7153 //
     /* 129083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129086 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129100 */     // MIs[0] Rn
     /* 129100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129112 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129125 */     GIR_RootConstrainSelectedInstOperands,
     /* 129126 */     // GIR_Coverage, 7153,
     /* 129126 */     GIR_EraseRootFromParent_Done,
     /* 129127 */   // Label 2427: @129127
     /* 129127 */   GIM_Reject,
     /* 129128 */ // Label 2412: @129128
     /* 129128 */ GIM_Reject,
     /* 129129 */ // Label 2410: @129129
     /* 129129 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(129355),
     /* 129134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129144 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(129186), // Rule ID 2579 //
     /* 129149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129159 */     // MIs[0] Rn
     /* 129159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129171 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129184 */     GIR_RootConstrainSelectedInstOperands,
     /* 129185 */     // GIR_Coverage, 2579,
     /* 129185 */     GIR_EraseRootFromParent_Done,
     /* 129186 */   // Label 2429: @129186
     /* 129186 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(129228), // Rule ID 2580 //
     /* 129191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129201 */     // MIs[0] Rn
     /* 129201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129213 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129226 */     GIR_RootConstrainSelectedInstOperands,
     /* 129227 */     // GIR_Coverage, 2580,
     /* 129227 */     GIR_EraseRootFromParent_Done,
     /* 129228 */   // Label 2430: @129228
     /* 129228 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(129270), // Rule ID 2581 //
     /* 129233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129243 */     // MIs[0] Rn
     /* 129243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129255 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129268 */     GIR_RootConstrainSelectedInstOperands,
     /* 129269 */     // GIR_Coverage, 2581,
     /* 129269 */     GIR_EraseRootFromParent_Done,
     /* 129270 */   // Label 2431: @129270
     /* 129270 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(129312), // Rule ID 2582 //
     /* 129275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129285 */     // MIs[0] Rn
     /* 129285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129297 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129310 */     GIR_RootConstrainSelectedInstOperands,
     /* 129311 */     // GIR_Coverage, 2582,
     /* 129311 */     GIR_EraseRootFromParent_Done,
     /* 129312 */   // Label 2432: @129312
     /* 129312 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(129354), // Rule ID 2583 //
     /* 129317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129327 */     // MIs[0] Rn
     /* 129327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129339 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129352 */     GIR_RootConstrainSelectedInstOperands,
     /* 129353 */     // GIR_Coverage, 2583,
     /* 129353 */     GIR_EraseRootFromParent_Done,
     /* 129354 */   // Label 2433: @129354
     /* 129354 */   GIM_Reject,
     /* 129355 */ // Label 2428: @129355
     /* 129355 */ GIM_Reject,
     /* 129356 */ // Label 2411: @129356
     /* 129356 */ GIM_Reject,
     /* 129357 */ // Label 23: @129357
     /* 129357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2436*/ GIMT_Encode4(130848),
     /* 129368 */ /*GILLT_s32*//*Label 2434*/ GIMT_Encode4(129376),
     /* 129372 */ /*GILLT_s64*//*Label 2435*/ GIMT_Encode4(130496),
     /* 129376 */ // Label 2434: @129376
     /* 129376 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(130495),
     /* 129381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129384 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(129458), // Rule ID 7334 //
     /* 129389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129406 */     // MIs[0] Rn
     /* 129406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129418 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129430 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 129445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129456 */     GIR_RootConstrainSelectedInstOperands,
     /* 129457 */     // GIR_Coverage, 7334,
     /* 129457 */     GIR_EraseRootFromParent_Done,
     /* 129458 */   // Label 2438: @129458
     /* 129458 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(129532), // Rule ID 7335 //
     /* 129463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129480 */     // MIs[0] Rn
     /* 129480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129492 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129504 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 129519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129530 */     GIR_RootConstrainSelectedInstOperands,
     /* 129531 */     // GIR_Coverage, 7335,
     /* 129531 */     GIR_EraseRootFromParent_Done,
     /* 129532 */   // Label 2439: @129532
     /* 129532 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(129606), // Rule ID 7336 //
     /* 129537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129554 */     // MIs[0] Rn
     /* 129554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129566 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129578 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 129593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129604 */     GIR_RootConstrainSelectedInstOperands,
     /* 129605 */     // GIR_Coverage, 7336,
     /* 129605 */     GIR_EraseRootFromParent_Done,
     /* 129606 */   // Label 2440: @129606
     /* 129606 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129680), // Rule ID 7337 //
     /* 129611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129628 */     // MIs[0] Rn
     /* 129628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129640 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129652 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129678 */     GIR_RootConstrainSelectedInstOperands,
     /* 129679 */     // GIR_Coverage, 7337,
     /* 129679 */     GIR_EraseRootFromParent_Done,
     /* 129680 */   // Label 2441: @129680
     /* 129680 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129754), // Rule ID 7338 //
     /* 129685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129702 */     // MIs[0] Rn
     /* 129702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129714 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129726 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129752 */     GIR_RootConstrainSelectedInstOperands,
     /* 129753 */     // GIR_Coverage, 7338,
     /* 129753 */     GIR_EraseRootFromParent_Done,
     /* 129754 */   // Label 2442: @129754
     /* 129754 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129828), // Rule ID 7339 //
     /* 129759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129776 */     // MIs[0] Rn
     /* 129776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129788 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129800 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 129815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129826 */     GIR_RootConstrainSelectedInstOperands,
     /* 129827 */     // GIR_Coverage, 7339,
     /* 129827 */     GIR_EraseRootFromParent_Done,
     /* 129828 */   // Label 2443: @129828
     /* 129828 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129902), // Rule ID 7340 //
     /* 129833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129850 */     // MIs[0] Rn
     /* 129850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129862 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 129889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129900 */     GIR_RootConstrainSelectedInstOperands,
     /* 129901 */     // GIR_Coverage, 7340,
     /* 129901 */     GIR_EraseRootFromParent_Done,
     /* 129902 */   // Label 2444: @129902
     /* 129902 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129976), // Rule ID 7341 //
     /* 129907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129924 */     // MIs[0] Rn
     /* 129924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129936 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129948 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129974 */     GIR_RootConstrainSelectedInstOperands,
     /* 129975 */     // GIR_Coverage, 7341,
     /* 129975 */     GIR_EraseRootFromParent_Done,
     /* 129976 */   // Label 2445: @129976
     /* 129976 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(130050), // Rule ID 7342 //
     /* 129981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129998 */     // MIs[0] Rn
     /* 129998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130010 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130022 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 130037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130048 */     GIR_RootConstrainSelectedInstOperands,
     /* 130049 */     // GIR_Coverage, 7342,
     /* 130049 */     GIR_EraseRootFromParent_Done,
     /* 130050 */   // Label 2446: @130050
     /* 130050 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(130124), // Rule ID 7343 //
     /* 130055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130072 */     // MIs[0] Rn
     /* 130072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130084 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130096 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 130111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130122 */     GIR_RootConstrainSelectedInstOperands,
     /* 130123 */     // GIR_Coverage, 7343,
     /* 130123 */     GIR_EraseRootFromParent_Done,
     /* 130124 */   // Label 2447: @130124
     /* 130124 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(130198), // Rule ID 7344 //
     /* 130129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130146 */     // MIs[0] Rn
     /* 130146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130158 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130170 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 130185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130196 */     GIR_RootConstrainSelectedInstOperands,
     /* 130197 */     // GIR_Coverage, 7344,
     /* 130197 */     GIR_EraseRootFromParent_Done,
     /* 130198 */   // Label 2448: @130198
     /* 130198 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(130272), // Rule ID 7345 //
     /* 130203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130220 */     // MIs[0] Rn
     /* 130220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130232 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130244 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 130259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130270 */     GIR_RootConstrainSelectedInstOperands,
     /* 130271 */     // GIR_Coverage, 7345,
     /* 130271 */     GIR_EraseRootFromParent_Done,
     /* 130272 */   // Label 2449: @130272
     /* 130272 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(130346), // Rule ID 7346 //
     /* 130277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130294 */     // MIs[0] Rn
     /* 130294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130306 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130318 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 130333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130344 */     GIR_RootConstrainSelectedInstOperands,
     /* 130345 */     // GIR_Coverage, 7346,
     /* 130345 */     GIR_EraseRootFromParent_Done,
     /* 130346 */   // Label 2450: @130346
     /* 130346 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(130420), // Rule ID 7347 //
     /* 130351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130368 */     // MIs[0] Rn
     /* 130368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130380 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130392 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130418 */     GIR_RootConstrainSelectedInstOperands,
     /* 130419 */     // GIR_Coverage, 7347,
     /* 130419 */     GIR_EraseRootFromParent_Done,
     /* 130420 */   // Label 2451: @130420
     /* 130420 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(130494), // Rule ID 7348 //
     /* 130425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130442 */     // MIs[0] Rn
     /* 130442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130454 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130466 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130492 */     GIR_RootConstrainSelectedInstOperands,
     /* 130493 */     // GIR_Coverage, 7348,
     /* 130493 */     GIR_EraseRootFromParent_Done,
     /* 130494 */   // Label 2452: @130494
     /* 130494 */   GIM_Reject,
     /* 130495 */ // Label 2437: @130495
     /* 130495 */ GIM_Reject,
     /* 130496 */ // Label 2435: @130496
     /* 130496 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(130847),
     /* 130501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130511 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(130578), // Rule ID 7329 //
     /* 130516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130526 */     // MIs[0] Rn
     /* 130526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130538 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130550 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 130565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130576 */     GIR_RootConstrainSelectedInstOperands,
     /* 130577 */     // GIR_Coverage, 7329,
     /* 130577 */     GIR_EraseRootFromParent_Done,
     /* 130578 */   // Label 2454: @130578
     /* 130578 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(130645), // Rule ID 7330 //
     /* 130583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130586 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130593 */     // MIs[0] Rn
     /* 130593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130605 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130617 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 130632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130643 */     GIR_RootConstrainSelectedInstOperands,
     /* 130644 */     // GIR_Coverage, 7330,
     /* 130644 */     GIR_EraseRootFromParent_Done,
     /* 130645 */   // Label 2455: @130645
     /* 130645 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(130712), // Rule ID 7331 //
     /* 130650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130660 */     // MIs[0] Rn
     /* 130660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130672 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130684 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 130699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130710 */     GIR_RootConstrainSelectedInstOperands,
     /* 130711 */     // GIR_Coverage, 7331,
     /* 130711 */     GIR_EraseRootFromParent_Done,
     /* 130712 */   // Label 2456: @130712
     /* 130712 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(130779), // Rule ID 7332 //
     /* 130717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130727 */     // MIs[0] Rn
     /* 130727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130739 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130751 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130777 */     GIR_RootConstrainSelectedInstOperands,
     /* 130778 */     // GIR_Coverage, 7332,
     /* 130778 */     GIR_EraseRootFromParent_Done,
     /* 130779 */   // Label 2457: @130779
     /* 130779 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(130846), // Rule ID 7333 //
     /* 130784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130794 */     // MIs[0] Rn
     /* 130794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130806 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130818 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130844 */     GIR_RootConstrainSelectedInstOperands,
     /* 130845 */     // GIR_Coverage, 7333,
     /* 130845 */     GIR_EraseRootFromParent_Done,
     /* 130846 */   // Label 2458: @130846
     /* 130846 */   GIM_Reject,
     /* 130847 */ // Label 2453: @130847
     /* 130847 */ GIM_Reject,
     /* 130848 */ // Label 2436: @130848
     /* 130848 */ GIM_Reject,
     /* 130849 */ // Label 24: @130849
     /* 130849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2461*/ GIMT_Encode4(132340),
     /* 130860 */ /*GILLT_s32*//*Label 2459*/ GIMT_Encode4(130868),
     /* 130864 */ /*GILLT_s64*//*Label 2460*/ GIMT_Encode4(131988),
     /* 130868 */ // Label 2459: @130868
     /* 130868 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(131987),
     /* 130873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130876 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130950), // Rule ID 7354 //
     /* 130881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130898 */     // MIs[0] Rn
     /* 130898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130910 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130922 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 130937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130948 */     GIR_RootConstrainSelectedInstOperands,
     /* 130949 */     // GIR_Coverage, 7354,
     /* 130949 */     GIR_EraseRootFromParent_Done,
     /* 130950 */   // Label 2463: @130950
     /* 130950 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(131024), // Rule ID 7355 //
     /* 130955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130972 */     // MIs[0] Rn
     /* 130972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130984 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130996 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 131011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131022 */     GIR_RootConstrainSelectedInstOperands,
     /* 131023 */     // GIR_Coverage, 7355,
     /* 131023 */     GIR_EraseRootFromParent_Done,
     /* 131024 */   // Label 2464: @131024
     /* 131024 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(131098), // Rule ID 7356 //
     /* 131029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131046 */     // MIs[0] Rn
     /* 131046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131058 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131070 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 131085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131096 */     GIR_RootConstrainSelectedInstOperands,
     /* 131097 */     // GIR_Coverage, 7356,
     /* 131097 */     GIR_EraseRootFromParent_Done,
     /* 131098 */   // Label 2465: @131098
     /* 131098 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(131172), // Rule ID 7357 //
     /* 131103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131120 */     // MIs[0] Rn
     /* 131120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131132 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131144 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131170 */     GIR_RootConstrainSelectedInstOperands,
     /* 131171 */     // GIR_Coverage, 7357,
     /* 131171 */     GIR_EraseRootFromParent_Done,
     /* 131172 */   // Label 2466: @131172
     /* 131172 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(131246), // Rule ID 7358 //
     /* 131177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131194 */     // MIs[0] Rn
     /* 131194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131206 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131218 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131244 */     GIR_RootConstrainSelectedInstOperands,
     /* 131245 */     // GIR_Coverage, 7358,
     /* 131245 */     GIR_EraseRootFromParent_Done,
     /* 131246 */   // Label 2467: @131246
     /* 131246 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(131320), // Rule ID 7359 //
     /* 131251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131268 */     // MIs[0] Rn
     /* 131268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131280 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131292 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 131307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131318 */     GIR_RootConstrainSelectedInstOperands,
     /* 131319 */     // GIR_Coverage, 7359,
     /* 131319 */     GIR_EraseRootFromParent_Done,
     /* 131320 */   // Label 2468: @131320
     /* 131320 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(131394), // Rule ID 7360 //
     /* 131325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131342 */     // MIs[0] Rn
     /* 131342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131354 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 131381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131392 */     GIR_RootConstrainSelectedInstOperands,
     /* 131393 */     // GIR_Coverage, 7360,
     /* 131393 */     GIR_EraseRootFromParent_Done,
     /* 131394 */   // Label 2469: @131394
     /* 131394 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(131468), // Rule ID 7361 //
     /* 131399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131416 */     // MIs[0] Rn
     /* 131416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131428 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131440 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 131455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131466 */     GIR_RootConstrainSelectedInstOperands,
     /* 131467 */     // GIR_Coverage, 7361,
     /* 131467 */     GIR_EraseRootFromParent_Done,
     /* 131468 */   // Label 2470: @131468
     /* 131468 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(131542), // Rule ID 7362 //
     /* 131473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131490 */     // MIs[0] Rn
     /* 131490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131502 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131514 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131540 */     GIR_RootConstrainSelectedInstOperands,
     /* 131541 */     // GIR_Coverage, 7362,
     /* 131541 */     GIR_EraseRootFromParent_Done,
     /* 131542 */   // Label 2471: @131542
     /* 131542 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(131616), // Rule ID 7363 //
     /* 131547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131564 */     // MIs[0] Rn
     /* 131564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131576 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131588 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131614 */     GIR_RootConstrainSelectedInstOperands,
     /* 131615 */     // GIR_Coverage, 7363,
     /* 131615 */     GIR_EraseRootFromParent_Done,
     /* 131616 */   // Label 2472: @131616
     /* 131616 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131690), // Rule ID 7364 //
     /* 131621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131638 */     // MIs[0] Rn
     /* 131638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131650 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131662 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 131677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131688 */     GIR_RootConstrainSelectedInstOperands,
     /* 131689 */     // GIR_Coverage, 7364,
     /* 131689 */     GIR_EraseRootFromParent_Done,
     /* 131690 */   // Label 2473: @131690
     /* 131690 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131764), // Rule ID 7365 //
     /* 131695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131712 */     // MIs[0] Rn
     /* 131712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131724 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131736 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 131751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131762 */     GIR_RootConstrainSelectedInstOperands,
     /* 131763 */     // GIR_Coverage, 7365,
     /* 131763 */     GIR_EraseRootFromParent_Done,
     /* 131764 */   // Label 2474: @131764
     /* 131764 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131838), // Rule ID 7366 //
     /* 131769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131786 */     // MIs[0] Rn
     /* 131786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131798 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131810 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 131825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131836 */     GIR_RootConstrainSelectedInstOperands,
     /* 131837 */     // GIR_Coverage, 7366,
     /* 131837 */     GIR_EraseRootFromParent_Done,
     /* 131838 */   // Label 2475: @131838
     /* 131838 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(131912), // Rule ID 7367 //
     /* 131843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131860 */     // MIs[0] Rn
     /* 131860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131872 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131884 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131910 */     GIR_RootConstrainSelectedInstOperands,
     /* 131911 */     // GIR_Coverage, 7367,
     /* 131911 */     GIR_EraseRootFromParent_Done,
     /* 131912 */   // Label 2476: @131912
     /* 131912 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131986), // Rule ID 7368 //
     /* 131917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131934 */     // MIs[0] Rn
     /* 131934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131946 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131958 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131984 */     GIR_RootConstrainSelectedInstOperands,
     /* 131985 */     // GIR_Coverage, 7368,
     /* 131985 */     GIR_EraseRootFromParent_Done,
     /* 131986 */   // Label 2477: @131986
     /* 131986 */   GIM_Reject,
     /* 131987 */ // Label 2462: @131987
     /* 131987 */ GIM_Reject,
     /* 131988 */ // Label 2460: @131988
     /* 131988 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(132339),
     /* 131993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132003 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(132070), // Rule ID 7349 //
     /* 132008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132018 */     // MIs[0] Rn
     /* 132018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132030 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 132057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132068 */     GIR_RootConstrainSelectedInstOperands,
     /* 132069 */     // GIR_Coverage, 7349,
     /* 132069 */     GIR_EraseRootFromParent_Done,
     /* 132070 */   // Label 2479: @132070
     /* 132070 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(132137), // Rule ID 7350 //
     /* 132075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132085 */     // MIs[0] Rn
     /* 132085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132097 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132109 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 132124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132135 */     GIR_RootConstrainSelectedInstOperands,
     /* 132136 */     // GIR_Coverage, 7350,
     /* 132136 */     GIR_EraseRootFromParent_Done,
     /* 132137 */   // Label 2480: @132137
     /* 132137 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(132204), // Rule ID 7351 //
     /* 132142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132152 */     // MIs[0] Rn
     /* 132152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132164 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132176 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 132191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132202 */     GIR_RootConstrainSelectedInstOperands,
     /* 132203 */     // GIR_Coverage, 7351,
     /* 132203 */     GIR_EraseRootFromParent_Done,
     /* 132204 */   // Label 2481: @132204
     /* 132204 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(132271), // Rule ID 7352 //
     /* 132209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132219 */     // MIs[0] Rn
     /* 132219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132231 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132243 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132269 */     GIR_RootConstrainSelectedInstOperands,
     /* 132270 */     // GIR_Coverage, 7352,
     /* 132270 */     GIR_EraseRootFromParent_Done,
     /* 132271 */   // Label 2482: @132271
     /* 132271 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(132338), // Rule ID 7353 //
     /* 132276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132286 */     // MIs[0] Rn
     /* 132286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132298 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132310 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132336 */     GIR_RootConstrainSelectedInstOperands,
     /* 132337 */     // GIR_Coverage, 7353,
     /* 132337 */     GIR_EraseRootFromParent_Done,
     /* 132338 */   // Label 2483: @132338
     /* 132338 */   GIM_Reject,
     /* 132339 */ // Label 2478: @132339
     /* 132339 */ GIM_Reject,
     /* 132340 */ // Label 2461: @132340
     /* 132340 */ GIM_Reject,
     /* 132341 */ // Label 25: @132341
     /* 132341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2486*/ GIMT_Encode4(133332),
     /* 132352 */ /*GILLT_s32*//*Label 2484*/ GIMT_Encode4(132360),
     /* 132356 */ /*GILLT_s64*//*Label 2485*/ GIMT_Encode4(133105),
     /* 132360 */ // Label 2484: @132360
     /* 132360 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(133104),
     /* 132365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132368 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(132417), // Rule ID 7159 //
     /* 132373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132390 */     // MIs[0] Rn
     /* 132390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132402 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 132405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132415 */     GIR_RootConstrainSelectedInstOperands,
     /* 132416 */     // GIR_Coverage, 7159,
     /* 132416 */     GIR_EraseRootFromParent_Done,
     /* 132417 */   // Label 2488: @132417
     /* 132417 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(132466), // Rule ID 7160 //
     /* 132422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132439 */     // MIs[0] Rn
     /* 132439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132451 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 132454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132464 */     GIR_RootConstrainSelectedInstOperands,
     /* 132465 */     // GIR_Coverage, 7160,
     /* 132465 */     GIR_EraseRootFromParent_Done,
     /* 132466 */   // Label 2489: @132466
     /* 132466 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(132515), // Rule ID 7161 //
     /* 132471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132488 */     // MIs[0] Rn
     /* 132488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132500 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 132503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132513 */     GIR_RootConstrainSelectedInstOperands,
     /* 132514 */     // GIR_Coverage, 7161,
     /* 132514 */     GIR_EraseRootFromParent_Done,
     /* 132515 */   // Label 2490: @132515
     /* 132515 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(132564), // Rule ID 7162 //
     /* 132520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132537 */     // MIs[0] Rn
     /* 132537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132549 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132562 */     GIR_RootConstrainSelectedInstOperands,
     /* 132563 */     // GIR_Coverage, 7162,
     /* 132563 */     GIR_EraseRootFromParent_Done,
     /* 132564 */   // Label 2491: @132564
     /* 132564 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(132613), // Rule ID 7163 //
     /* 132569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132586 */     // MIs[0] Rn
     /* 132586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132598 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132611 */     GIR_RootConstrainSelectedInstOperands,
     /* 132612 */     // GIR_Coverage, 7163,
     /* 132612 */     GIR_EraseRootFromParent_Done,
     /* 132613 */   // Label 2492: @132613
     /* 132613 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(132662), // Rule ID 7164 //
     /* 132618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132635 */     // MIs[0] Rn
     /* 132635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132647 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 132650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132660 */     GIR_RootConstrainSelectedInstOperands,
     /* 132661 */     // GIR_Coverage, 7164,
     /* 132661 */     GIR_EraseRootFromParent_Done,
     /* 132662 */   // Label 2493: @132662
     /* 132662 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(132711), // Rule ID 7165 //
     /* 132667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132684 */     // MIs[0] Rn
     /* 132684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132696 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 132699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132709 */     GIR_RootConstrainSelectedInstOperands,
     /* 132710 */     // GIR_Coverage, 7165,
     /* 132710 */     GIR_EraseRootFromParent_Done,
     /* 132711 */   // Label 2494: @132711
     /* 132711 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132760), // Rule ID 7166 //
     /* 132716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132733 */     // MIs[0] Rn
     /* 132733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132745 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 132748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132758 */     GIR_RootConstrainSelectedInstOperands,
     /* 132759 */     // GIR_Coverage, 7166,
     /* 132759 */     GIR_EraseRootFromParent_Done,
     /* 132760 */   // Label 2495: @132760
     /* 132760 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132809), // Rule ID 7167 //
     /* 132765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132782 */     // MIs[0] Rn
     /* 132782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132794 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132807 */     GIR_RootConstrainSelectedInstOperands,
     /* 132808 */     // GIR_Coverage, 7167,
     /* 132808 */     GIR_EraseRootFromParent_Done,
     /* 132809 */   // Label 2496: @132809
     /* 132809 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132858), // Rule ID 7168 //
     /* 132814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132831 */     // MIs[0] Rn
     /* 132831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132843 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132856 */     GIR_RootConstrainSelectedInstOperands,
     /* 132857 */     // GIR_Coverage, 7168,
     /* 132857 */     GIR_EraseRootFromParent_Done,
     /* 132858 */   // Label 2497: @132858
     /* 132858 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132907), // Rule ID 7169 //
     /* 132863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132880 */     // MIs[0] Rn
     /* 132880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132892 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 132895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132905 */     GIR_RootConstrainSelectedInstOperands,
     /* 132906 */     // GIR_Coverage, 7169,
     /* 132906 */     GIR_EraseRootFromParent_Done,
     /* 132907 */   // Label 2498: @132907
     /* 132907 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132956), // Rule ID 7170 //
     /* 132912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132929 */     // MIs[0] Rn
     /* 132929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132941 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 132944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132954 */     GIR_RootConstrainSelectedInstOperands,
     /* 132955 */     // GIR_Coverage, 7170,
     /* 132955 */     GIR_EraseRootFromParent_Done,
     /* 132956 */   // Label 2499: @132956
     /* 132956 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(133005), // Rule ID 7171 //
     /* 132961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132978 */     // MIs[0] Rn
     /* 132978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132990 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133003 */     GIR_RootConstrainSelectedInstOperands,
     /* 133004 */     // GIR_Coverage, 7171,
     /* 133004 */     GIR_EraseRootFromParent_Done,
     /* 133005 */   // Label 2500: @133005
     /* 133005 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(133054), // Rule ID 7172 //
     /* 133010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133027 */     // MIs[0] Rn
     /* 133027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133039 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 133042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133052 */     GIR_RootConstrainSelectedInstOperands,
     /* 133053 */     // GIR_Coverage, 7172,
     /* 133053 */     GIR_EraseRootFromParent_Done,
     /* 133054 */   // Label 2501: @133054
     /* 133054 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(133103), // Rule ID 7173 //
     /* 133059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133076 */     // MIs[0] Rn
     /* 133076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133088 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 133091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133101 */     GIR_RootConstrainSelectedInstOperands,
     /* 133102 */     // GIR_Coverage, 7173,
     /* 133102 */     GIR_EraseRootFromParent_Done,
     /* 133103 */   // Label 2502: @133103
     /* 133103 */   GIM_Reject,
     /* 133104 */ // Label 2487: @133104
     /* 133104 */ GIM_Reject,
     /* 133105 */ // Label 2485: @133105
     /* 133105 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(133331),
     /* 133110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133120 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(133162), // Rule ID 7154 //
     /* 133125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133135 */     // MIs[0] Rn
     /* 133135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133147 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 133150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133160 */     GIR_RootConstrainSelectedInstOperands,
     /* 133161 */     // GIR_Coverage, 7154,
     /* 133161 */     GIR_EraseRootFromParent_Done,
     /* 133162 */   // Label 2504: @133162
     /* 133162 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(133204), // Rule ID 7155 //
     /* 133167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133177 */     // MIs[0] Rn
     /* 133177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133189 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 133192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133202 */     GIR_RootConstrainSelectedInstOperands,
     /* 133203 */     // GIR_Coverage, 7155,
     /* 133203 */     GIR_EraseRootFromParent_Done,
     /* 133204 */   // Label 2505: @133204
     /* 133204 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(133246), // Rule ID 7156 //
     /* 133209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133219 */     // MIs[0] Rn
     /* 133219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133231 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 133234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133244 */     GIR_RootConstrainSelectedInstOperands,
     /* 133245 */     // GIR_Coverage, 7156,
     /* 133245 */     GIR_EraseRootFromParent_Done,
     /* 133246 */   // Label 2506: @133246
     /* 133246 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(133288), // Rule ID 7157 //
     /* 133251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133261 */     // MIs[0] Rn
     /* 133261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133273 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133286 */     GIR_RootConstrainSelectedInstOperands,
     /* 133287 */     // GIR_Coverage, 7157,
     /* 133287 */     GIR_EraseRootFromParent_Done,
     /* 133288 */   // Label 2507: @133288
     /* 133288 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(133330), // Rule ID 7158 //
     /* 133293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133303 */     // MIs[0] Rn
     /* 133303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133315 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133328 */     GIR_RootConstrainSelectedInstOperands,
     /* 133329 */     // GIR_Coverage, 7158,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 2508: @133330
     /* 133330 */   GIM_Reject,
     /* 133331 */ // Label 2503: @133331
     /* 133331 */ GIM_Reject,
     /* 133332 */ // Label 2486: @133332
     /* 133332 */ GIM_Reject,
     /* 133333 */ // Label 26: @133333
     /* 133333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2511*/ GIMT_Encode4(134324),
     /* 133344 */ /*GILLT_s32*//*Label 2509*/ GIMT_Encode4(133352),
     /* 133348 */ /*GILLT_s64*//*Label 2510*/ GIMT_Encode4(134097),
     /* 133352 */ // Label 2509: @133352
     /* 133352 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(134096),
     /* 133357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133360 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(133409), // Rule ID 7179 //
     /* 133365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133382 */     // MIs[0] Rn
     /* 133382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133394 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 133397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133407 */     GIR_RootConstrainSelectedInstOperands,
     /* 133408 */     // GIR_Coverage, 7179,
     /* 133408 */     GIR_EraseRootFromParent_Done,
     /* 133409 */   // Label 2513: @133409
     /* 133409 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(133458), // Rule ID 7180 //
     /* 133414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133431 */     // MIs[0] Rn
     /* 133431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133443 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 133446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133456 */     GIR_RootConstrainSelectedInstOperands,
     /* 133457 */     // GIR_Coverage, 7180,
     /* 133457 */     GIR_EraseRootFromParent_Done,
     /* 133458 */   // Label 2514: @133458
     /* 133458 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(133507), // Rule ID 7181 //
     /* 133463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133480 */     // MIs[0] Rn
     /* 133480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133492 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 133495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133505 */     GIR_RootConstrainSelectedInstOperands,
     /* 133506 */     // GIR_Coverage, 7181,
     /* 133506 */     GIR_EraseRootFromParent_Done,
     /* 133507 */   // Label 2515: @133507
     /* 133507 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(133556), // Rule ID 7182 //
     /* 133512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133529 */     // MIs[0] Rn
     /* 133529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133541 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133554 */     GIR_RootConstrainSelectedInstOperands,
     /* 133555 */     // GIR_Coverage, 7182,
     /* 133555 */     GIR_EraseRootFromParent_Done,
     /* 133556 */   // Label 2516: @133556
     /* 133556 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(133605), // Rule ID 7183 //
     /* 133561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133578 */     // MIs[0] Rn
     /* 133578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133590 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133603 */     GIR_RootConstrainSelectedInstOperands,
     /* 133604 */     // GIR_Coverage, 7183,
     /* 133604 */     GIR_EraseRootFromParent_Done,
     /* 133605 */   // Label 2517: @133605
     /* 133605 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(133654), // Rule ID 7184 //
     /* 133610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133627 */     // MIs[0] Rn
     /* 133627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133639 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 133642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133652 */     GIR_RootConstrainSelectedInstOperands,
     /* 133653 */     // GIR_Coverage, 7184,
     /* 133653 */     GIR_EraseRootFromParent_Done,
     /* 133654 */   // Label 2518: @133654
     /* 133654 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(133703), // Rule ID 7185 //
     /* 133659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133676 */     // MIs[0] Rn
     /* 133676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133688 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 133691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133701 */     GIR_RootConstrainSelectedInstOperands,
     /* 133702 */     // GIR_Coverage, 7185,
     /* 133702 */     GIR_EraseRootFromParent_Done,
     /* 133703 */   // Label 2519: @133703
     /* 133703 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133752), // Rule ID 7186 //
     /* 133708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133725 */     // MIs[0] Rn
     /* 133725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133737 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 133740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133750 */     GIR_RootConstrainSelectedInstOperands,
     /* 133751 */     // GIR_Coverage, 7186,
     /* 133751 */     GIR_EraseRootFromParent_Done,
     /* 133752 */   // Label 2520: @133752
     /* 133752 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133801), // Rule ID 7187 //
     /* 133757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133774 */     // MIs[0] Rn
     /* 133774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133786 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133799 */     GIR_RootConstrainSelectedInstOperands,
     /* 133800 */     // GIR_Coverage, 7187,
     /* 133800 */     GIR_EraseRootFromParent_Done,
     /* 133801 */   // Label 2521: @133801
     /* 133801 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133850), // Rule ID 7188 //
     /* 133806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133823 */     // MIs[0] Rn
     /* 133823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133835 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133848 */     GIR_RootConstrainSelectedInstOperands,
     /* 133849 */     // GIR_Coverage, 7188,
     /* 133849 */     GIR_EraseRootFromParent_Done,
     /* 133850 */   // Label 2522: @133850
     /* 133850 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133899), // Rule ID 7189 //
     /* 133855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133872 */     // MIs[0] Rn
     /* 133872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133884 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 133887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133897 */     GIR_RootConstrainSelectedInstOperands,
     /* 133898 */     // GIR_Coverage, 7189,
     /* 133898 */     GIR_EraseRootFromParent_Done,
     /* 133899 */   // Label 2523: @133899
     /* 133899 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133948), // Rule ID 7190 //
     /* 133904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133921 */     // MIs[0] Rn
     /* 133921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133933 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 133936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133946 */     GIR_RootConstrainSelectedInstOperands,
     /* 133947 */     // GIR_Coverage, 7190,
     /* 133947 */     GIR_EraseRootFromParent_Done,
     /* 133948 */   // Label 2524: @133948
     /* 133948 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133997), // Rule ID 7191 //
     /* 133953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133970 */     // MIs[0] Rn
     /* 133970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133982 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133995 */     GIR_RootConstrainSelectedInstOperands,
     /* 133996 */     // GIR_Coverage, 7191,
     /* 133996 */     GIR_EraseRootFromParent_Done,
     /* 133997 */   // Label 2525: @133997
     /* 133997 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(134046), // Rule ID 7192 //
     /* 134002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134019 */     // MIs[0] Rn
     /* 134019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134031 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 134034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134044 */     GIR_RootConstrainSelectedInstOperands,
     /* 134045 */     // GIR_Coverage, 7192,
     /* 134045 */     GIR_EraseRootFromParent_Done,
     /* 134046 */   // Label 2526: @134046
     /* 134046 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(134095), // Rule ID 7193 //
     /* 134051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134068 */     // MIs[0] Rn
     /* 134068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134080 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 134083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134093 */     GIR_RootConstrainSelectedInstOperands,
     /* 134094 */     // GIR_Coverage, 7193,
     /* 134094 */     GIR_EraseRootFromParent_Done,
     /* 134095 */   // Label 2527: @134095
     /* 134095 */   GIM_Reject,
     /* 134096 */ // Label 2512: @134096
     /* 134096 */ GIM_Reject,
     /* 134097 */ // Label 2510: @134097
     /* 134097 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(134323),
     /* 134102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134112 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(134154), // Rule ID 7174 //
     /* 134117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134127 */     // MIs[0] Rn
     /* 134127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134139 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 134142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134152 */     GIR_RootConstrainSelectedInstOperands,
     /* 134153 */     // GIR_Coverage, 7174,
     /* 134153 */     GIR_EraseRootFromParent_Done,
     /* 134154 */   // Label 2529: @134154
     /* 134154 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(134196), // Rule ID 7175 //
     /* 134159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134169 */     // MIs[0] Rn
     /* 134169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134181 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 134184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134194 */     GIR_RootConstrainSelectedInstOperands,
     /* 134195 */     // GIR_Coverage, 7175,
     /* 134195 */     GIR_EraseRootFromParent_Done,
     /* 134196 */   // Label 2530: @134196
     /* 134196 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(134238), // Rule ID 7176 //
     /* 134201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134211 */     // MIs[0] Rn
     /* 134211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134223 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 134226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134236 */     GIR_RootConstrainSelectedInstOperands,
     /* 134237 */     // GIR_Coverage, 7176,
     /* 134237 */     GIR_EraseRootFromParent_Done,
     /* 134238 */   // Label 2531: @134238
     /* 134238 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(134280), // Rule ID 7177 //
     /* 134243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134253 */     // MIs[0] Rn
     /* 134253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134265 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134278 */     GIR_RootConstrainSelectedInstOperands,
     /* 134279 */     // GIR_Coverage, 7177,
     /* 134279 */     GIR_EraseRootFromParent_Done,
     /* 134280 */   // Label 2532: @134280
     /* 134280 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(134322), // Rule ID 7178 //
     /* 134285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134295 */     // MIs[0] Rn
     /* 134295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134307 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134320 */     GIR_RootConstrainSelectedInstOperands,
     /* 134321 */     // GIR_Coverage, 7178,
     /* 134321 */     GIR_EraseRootFromParent_Done,
     /* 134322 */   // Label 2533: @134322
     /* 134322 */   GIM_Reject,
     /* 134323 */ // Label 2528: @134323
     /* 134323 */ GIM_Reject,
     /* 134324 */ // Label 2511: @134324
     /* 134324 */ GIM_Reject,
     /* 134325 */ // Label 27: @134325
     /* 134325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2536*/ GIMT_Encode4(135316),
     /* 134336 */ /*GILLT_s32*//*Label 2534*/ GIMT_Encode4(134344),
     /* 134340 */ /*GILLT_s64*//*Label 2535*/ GIMT_Encode4(135089),
     /* 134344 */ // Label 2534: @134344
     /* 134344 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(135088),
     /* 134349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134352 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(134401), // Rule ID 7219 //
     /* 134357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134374 */     // MIs[0] Rn
     /* 134374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134386 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 134389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134399 */     GIR_RootConstrainSelectedInstOperands,
     /* 134400 */     // GIR_Coverage, 7219,
     /* 134400 */     GIR_EraseRootFromParent_Done,
     /* 134401 */   // Label 2538: @134401
     /* 134401 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(134450), // Rule ID 7220 //
     /* 134406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134423 */     // MIs[0] Rn
     /* 134423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134435 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 134438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134448 */     GIR_RootConstrainSelectedInstOperands,
     /* 134449 */     // GIR_Coverage, 7220,
     /* 134449 */     GIR_EraseRootFromParent_Done,
     /* 134450 */   // Label 2539: @134450
     /* 134450 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(134499), // Rule ID 7221 //
     /* 134455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134472 */     // MIs[0] Rn
     /* 134472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134484 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 134487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134497 */     GIR_RootConstrainSelectedInstOperands,
     /* 134498 */     // GIR_Coverage, 7221,
     /* 134498 */     GIR_EraseRootFromParent_Done,
     /* 134499 */   // Label 2540: @134499
     /* 134499 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(134548), // Rule ID 7222 //
     /* 134504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134521 */     // MIs[0] Rn
     /* 134521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134533 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134546 */     GIR_RootConstrainSelectedInstOperands,
     /* 134547 */     // GIR_Coverage, 7222,
     /* 134547 */     GIR_EraseRootFromParent_Done,
     /* 134548 */   // Label 2541: @134548
     /* 134548 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(134597), // Rule ID 7223 //
     /* 134553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134570 */     // MIs[0] Rn
     /* 134570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134582 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134595 */     GIR_RootConstrainSelectedInstOperands,
     /* 134596 */     // GIR_Coverage, 7223,
     /* 134596 */     GIR_EraseRootFromParent_Done,
     /* 134597 */   // Label 2542: @134597
     /* 134597 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(134646), // Rule ID 7224 //
     /* 134602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134619 */     // MIs[0] Rn
     /* 134619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134631 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 134634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134644 */     GIR_RootConstrainSelectedInstOperands,
     /* 134645 */     // GIR_Coverage, 7224,
     /* 134645 */     GIR_EraseRootFromParent_Done,
     /* 134646 */   // Label 2543: @134646
     /* 134646 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(134695), // Rule ID 7225 //
     /* 134651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134668 */     // MIs[0] Rn
     /* 134668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134680 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 134683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134693 */     GIR_RootConstrainSelectedInstOperands,
     /* 134694 */     // GIR_Coverage, 7225,
     /* 134694 */     GIR_EraseRootFromParent_Done,
     /* 134695 */   // Label 2544: @134695
     /* 134695 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134744), // Rule ID 7226 //
     /* 134700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134717 */     // MIs[0] Rn
     /* 134717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134729 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 134732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134742 */     GIR_RootConstrainSelectedInstOperands,
     /* 134743 */     // GIR_Coverage, 7226,
     /* 134743 */     GIR_EraseRootFromParent_Done,
     /* 134744 */   // Label 2545: @134744
     /* 134744 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134793), // Rule ID 7227 //
     /* 134749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134766 */     // MIs[0] Rn
     /* 134766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134778 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134791 */     GIR_RootConstrainSelectedInstOperands,
     /* 134792 */     // GIR_Coverage, 7227,
     /* 134792 */     GIR_EraseRootFromParent_Done,
     /* 134793 */   // Label 2546: @134793
     /* 134793 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134842), // Rule ID 7228 //
     /* 134798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134815 */     // MIs[0] Rn
     /* 134815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134827 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134840 */     GIR_RootConstrainSelectedInstOperands,
     /* 134841 */     // GIR_Coverage, 7228,
     /* 134841 */     GIR_EraseRootFromParent_Done,
     /* 134842 */   // Label 2547: @134842
     /* 134842 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134891), // Rule ID 7229 //
     /* 134847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134864 */     // MIs[0] Rn
     /* 134864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134876 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 134879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134889 */     GIR_RootConstrainSelectedInstOperands,
     /* 134890 */     // GIR_Coverage, 7229,
     /* 134890 */     GIR_EraseRootFromParent_Done,
     /* 134891 */   // Label 2548: @134891
     /* 134891 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134940), // Rule ID 7230 //
     /* 134896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134913 */     // MIs[0] Rn
     /* 134913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134925 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 134928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134938 */     GIR_RootConstrainSelectedInstOperands,
     /* 134939 */     // GIR_Coverage, 7230,
     /* 134939 */     GIR_EraseRootFromParent_Done,
     /* 134940 */   // Label 2549: @134940
     /* 134940 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134989), // Rule ID 7231 //
     /* 134945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134962 */     // MIs[0] Rn
     /* 134962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134974 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134987 */     GIR_RootConstrainSelectedInstOperands,
     /* 134988 */     // GIR_Coverage, 7231,
     /* 134988 */     GIR_EraseRootFromParent_Done,
     /* 134989 */   // Label 2550: @134989
     /* 134989 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(135038), // Rule ID 7232 //
     /* 134994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135011 */     // MIs[0] Rn
     /* 135011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135023 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 135026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135036 */     GIR_RootConstrainSelectedInstOperands,
     /* 135037 */     // GIR_Coverage, 7232,
     /* 135037 */     GIR_EraseRootFromParent_Done,
     /* 135038 */   // Label 2551: @135038
     /* 135038 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(135087), // Rule ID 7233 //
     /* 135043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135060 */     // MIs[0] Rn
     /* 135060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135072 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 135075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135085 */     GIR_RootConstrainSelectedInstOperands,
     /* 135086 */     // GIR_Coverage, 7233,
     /* 135086 */     GIR_EraseRootFromParent_Done,
     /* 135087 */   // Label 2552: @135087
     /* 135087 */   GIM_Reject,
     /* 135088 */ // Label 2537: @135088
     /* 135088 */ GIM_Reject,
     /* 135089 */ // Label 2535: @135089
     /* 135089 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(135315),
     /* 135094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135104 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(135146), // Rule ID 7214 //
     /* 135109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135119 */     // MIs[0] Rn
     /* 135119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135131 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 135134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135144 */     GIR_RootConstrainSelectedInstOperands,
     /* 135145 */     // GIR_Coverage, 7214,
     /* 135145 */     GIR_EraseRootFromParent_Done,
     /* 135146 */   // Label 2554: @135146
     /* 135146 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(135188), // Rule ID 7215 //
     /* 135151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135161 */     // MIs[0] Rn
     /* 135161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135173 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 135176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135186 */     GIR_RootConstrainSelectedInstOperands,
     /* 135187 */     // GIR_Coverage, 7215,
     /* 135187 */     GIR_EraseRootFromParent_Done,
     /* 135188 */   // Label 2555: @135188
     /* 135188 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(135230), // Rule ID 7216 //
     /* 135193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135203 */     // MIs[0] Rn
     /* 135203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135215 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 135218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135228 */     GIR_RootConstrainSelectedInstOperands,
     /* 135229 */     // GIR_Coverage, 7216,
     /* 135229 */     GIR_EraseRootFromParent_Done,
     /* 135230 */   // Label 2556: @135230
     /* 135230 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(135272), // Rule ID 7217 //
     /* 135235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135245 */     // MIs[0] Rn
     /* 135245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135257 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135270 */     GIR_RootConstrainSelectedInstOperands,
     /* 135271 */     // GIR_Coverage, 7217,
     /* 135271 */     GIR_EraseRootFromParent_Done,
     /* 135272 */   // Label 2557: @135272
     /* 135272 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(135314), // Rule ID 7218 //
     /* 135277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135287 */     // MIs[0] Rn
     /* 135287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135299 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135312 */     GIR_RootConstrainSelectedInstOperands,
     /* 135313 */     // GIR_Coverage, 7218,
     /* 135313 */     GIR_EraseRootFromParent_Done,
     /* 135314 */   // Label 2558: @135314
     /* 135314 */   GIM_Reject,
     /* 135315 */ // Label 2553: @135315
     /* 135315 */ GIM_Reject,
     /* 135316 */ // Label 2536: @135316
     /* 135316 */ GIM_Reject,
     /* 135317 */ // Label 28: @135317
     /* 135317 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2561*/ GIMT_Encode4(136308),
     /* 135328 */ /*GILLT_s32*//*Label 2559*/ GIMT_Encode4(135336),
     /* 135332 */ /*GILLT_s64*//*Label 2560*/ GIMT_Encode4(136081),
     /* 135336 */ // Label 2559: @135336
     /* 135336 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(136080),
     /* 135341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135344 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(135393), // Rule ID 7239 //
     /* 135349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135366 */     // MIs[0] Rn
     /* 135366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135378 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 135381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135391 */     GIR_RootConstrainSelectedInstOperands,
     /* 135392 */     // GIR_Coverage, 7239,
     /* 135392 */     GIR_EraseRootFromParent_Done,
     /* 135393 */   // Label 2563: @135393
     /* 135393 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(135442), // Rule ID 7240 //
     /* 135398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135415 */     // MIs[0] Rn
     /* 135415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135427 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 135430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135440 */     GIR_RootConstrainSelectedInstOperands,
     /* 135441 */     // GIR_Coverage, 7240,
     /* 135441 */     GIR_EraseRootFromParent_Done,
     /* 135442 */   // Label 2564: @135442
     /* 135442 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(135491), // Rule ID 7241 //
     /* 135447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135464 */     // MIs[0] Rn
     /* 135464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135476 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135489 */     GIR_RootConstrainSelectedInstOperands,
     /* 135490 */     // GIR_Coverage, 7241,
     /* 135490 */     GIR_EraseRootFromParent_Done,
     /* 135491 */   // Label 2565: @135491
     /* 135491 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(135540), // Rule ID 7242 //
     /* 135496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135513 */     // MIs[0] Rn
     /* 135513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135525 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135538 */     GIR_RootConstrainSelectedInstOperands,
     /* 135539 */     // GIR_Coverage, 7242,
     /* 135539 */     GIR_EraseRootFromParent_Done,
     /* 135540 */   // Label 2566: @135540
     /* 135540 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(135589), // Rule ID 7243 //
     /* 135545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135562 */     // MIs[0] Rn
     /* 135562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135574 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135587 */     GIR_RootConstrainSelectedInstOperands,
     /* 135588 */     // GIR_Coverage, 7243,
     /* 135588 */     GIR_EraseRootFromParent_Done,
     /* 135589 */   // Label 2567: @135589
     /* 135589 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(135638), // Rule ID 7244 //
     /* 135594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135611 */     // MIs[0] Rn
     /* 135611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135623 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 135626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135636 */     GIR_RootConstrainSelectedInstOperands,
     /* 135637 */     // GIR_Coverage, 7244,
     /* 135637 */     GIR_EraseRootFromParent_Done,
     /* 135638 */   // Label 2568: @135638
     /* 135638 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(135687), // Rule ID 7245 //
     /* 135643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135660 */     // MIs[0] Rn
     /* 135660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135672 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 135675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135685 */     GIR_RootConstrainSelectedInstOperands,
     /* 135686 */     // GIR_Coverage, 7245,
     /* 135686 */     GIR_EraseRootFromParent_Done,
     /* 135687 */   // Label 2569: @135687
     /* 135687 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135736), // Rule ID 7246 //
     /* 135692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135709 */     // MIs[0] Rn
     /* 135709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135721 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 135724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135734 */     GIR_RootConstrainSelectedInstOperands,
     /* 135735 */     // GIR_Coverage, 7246,
     /* 135735 */     GIR_EraseRootFromParent_Done,
     /* 135736 */   // Label 2570: @135736
     /* 135736 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135785), // Rule ID 7247 //
     /* 135741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135758 */     // MIs[0] Rn
     /* 135758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135770 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135783 */     GIR_RootConstrainSelectedInstOperands,
     /* 135784 */     // GIR_Coverage, 7247,
     /* 135784 */     GIR_EraseRootFromParent_Done,
     /* 135785 */   // Label 2571: @135785
     /* 135785 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135834), // Rule ID 7248 //
     /* 135790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135807 */     // MIs[0] Rn
     /* 135807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135819 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135832 */     GIR_RootConstrainSelectedInstOperands,
     /* 135833 */     // GIR_Coverage, 7248,
     /* 135833 */     GIR_EraseRootFromParent_Done,
     /* 135834 */   // Label 2572: @135834
     /* 135834 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135883), // Rule ID 7249 //
     /* 135839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135856 */     // MIs[0] Rn
     /* 135856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135868 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 135871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135881 */     GIR_RootConstrainSelectedInstOperands,
     /* 135882 */     // GIR_Coverage, 7249,
     /* 135882 */     GIR_EraseRootFromParent_Done,
     /* 135883 */   // Label 2573: @135883
     /* 135883 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135932), // Rule ID 7250 //
     /* 135888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135905 */     // MIs[0] Rn
     /* 135905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135917 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 135920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135930 */     GIR_RootConstrainSelectedInstOperands,
     /* 135931 */     // GIR_Coverage, 7250,
     /* 135931 */     GIR_EraseRootFromParent_Done,
     /* 135932 */   // Label 2574: @135932
     /* 135932 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135981), // Rule ID 7251 //
     /* 135937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135954 */     // MIs[0] Rn
     /* 135954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135966 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135979 */     GIR_RootConstrainSelectedInstOperands,
     /* 135980 */     // GIR_Coverage, 7251,
     /* 135980 */     GIR_EraseRootFromParent_Done,
     /* 135981 */   // Label 2575: @135981
     /* 135981 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(136030), // Rule ID 7252 //
     /* 135986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136003 */     // MIs[0] Rn
     /* 136003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136015 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 136018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136028 */     GIR_RootConstrainSelectedInstOperands,
     /* 136029 */     // GIR_Coverage, 7252,
     /* 136029 */     GIR_EraseRootFromParent_Done,
     /* 136030 */   // Label 2576: @136030
     /* 136030 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(136079), // Rule ID 7253 //
     /* 136035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136052 */     // MIs[0] Rn
     /* 136052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136064 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 136067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136077 */     GIR_RootConstrainSelectedInstOperands,
     /* 136078 */     // GIR_Coverage, 7253,
     /* 136078 */     GIR_EraseRootFromParent_Done,
     /* 136079 */   // Label 2577: @136079
     /* 136079 */   GIM_Reject,
     /* 136080 */ // Label 2562: @136080
     /* 136080 */ GIM_Reject,
     /* 136081 */ // Label 2560: @136081
     /* 136081 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(136307),
     /* 136086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136096 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(136138), // Rule ID 7234 //
     /* 136101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136111 */     // MIs[0] Rn
     /* 136111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136123 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 136126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136136 */     GIR_RootConstrainSelectedInstOperands,
     /* 136137 */     // GIR_Coverage, 7234,
     /* 136137 */     GIR_EraseRootFromParent_Done,
     /* 136138 */   // Label 2579: @136138
     /* 136138 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(136180), // Rule ID 7235 //
     /* 136143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136153 */     // MIs[0] Rn
     /* 136153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136165 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 136168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136178 */     GIR_RootConstrainSelectedInstOperands,
     /* 136179 */     // GIR_Coverage, 7235,
     /* 136179 */     GIR_EraseRootFromParent_Done,
     /* 136180 */   // Label 2580: @136180
     /* 136180 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(136222), // Rule ID 7236 //
     /* 136185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136195 */     // MIs[0] Rn
     /* 136195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136207 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 136210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136220 */     GIR_RootConstrainSelectedInstOperands,
     /* 136221 */     // GIR_Coverage, 7236,
     /* 136221 */     GIR_EraseRootFromParent_Done,
     /* 136222 */   // Label 2581: @136222
     /* 136222 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(136264), // Rule ID 7237 //
     /* 136227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136237 */     // MIs[0] Rn
     /* 136237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136249 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136262 */     GIR_RootConstrainSelectedInstOperands,
     /* 136263 */     // GIR_Coverage, 7237,
     /* 136263 */     GIR_EraseRootFromParent_Done,
     /* 136264 */   // Label 2582: @136264
     /* 136264 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(136306), // Rule ID 7238 //
     /* 136269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136279 */     // MIs[0] Rn
     /* 136279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136291 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136304 */     GIR_RootConstrainSelectedInstOperands,
     /* 136305 */     // GIR_Coverage, 7238,
     /* 136305 */     GIR_EraseRootFromParent_Done,
     /* 136306 */   // Label 2583: @136306
     /* 136306 */   GIM_Reject,
     /* 136307 */ // Label 2578: @136307
     /* 136307 */ GIM_Reject,
     /* 136308 */ // Label 2561: @136308
     /* 136308 */ GIM_Reject,
     /* 136309 */ // Label 29: @136309
     /* 136309 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2586*/ GIMT_Encode4(137300),
     /* 136320 */ /*GILLT_s32*//*Label 2584*/ GIMT_Encode4(136328),
     /* 136324 */ /*GILLT_s64*//*Label 2585*/ GIMT_Encode4(137073),
     /* 136328 */ // Label 2584: @136328
     /* 136328 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(137072),
     /* 136333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136336 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(136385), // Rule ID 7259 //
     /* 136341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136358 */     // MIs[0] Rn
     /* 136358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136370 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 136373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136383 */     GIR_RootConstrainSelectedInstOperands,
     /* 136384 */     // GIR_Coverage, 7259,
     /* 136384 */     GIR_EraseRootFromParent_Done,
     /* 136385 */   // Label 2588: @136385
     /* 136385 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(136434), // Rule ID 7260 //
     /* 136390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136407 */     // MIs[0] Rn
     /* 136407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136419 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 136422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136432 */     GIR_RootConstrainSelectedInstOperands,
     /* 136433 */     // GIR_Coverage, 7260,
     /* 136433 */     GIR_EraseRootFromParent_Done,
     /* 136434 */   // Label 2589: @136434
     /* 136434 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(136483), // Rule ID 7261 //
     /* 136439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136456 */     // MIs[0] Rn
     /* 136456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136468 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 136471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136481 */     GIR_RootConstrainSelectedInstOperands,
     /* 136482 */     // GIR_Coverage, 7261,
     /* 136482 */     GIR_EraseRootFromParent_Done,
     /* 136483 */   // Label 2590: @136483
     /* 136483 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(136532), // Rule ID 7262 //
     /* 136488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136505 */     // MIs[0] Rn
     /* 136505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136517 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136530 */     GIR_RootConstrainSelectedInstOperands,
     /* 136531 */     // GIR_Coverage, 7262,
     /* 136531 */     GIR_EraseRootFromParent_Done,
     /* 136532 */   // Label 2591: @136532
     /* 136532 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(136581), // Rule ID 7263 //
     /* 136537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136554 */     // MIs[0] Rn
     /* 136554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136566 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136579 */     GIR_RootConstrainSelectedInstOperands,
     /* 136580 */     // GIR_Coverage, 7263,
     /* 136580 */     GIR_EraseRootFromParent_Done,
     /* 136581 */   // Label 2592: @136581
     /* 136581 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(136630), // Rule ID 7264 //
     /* 136586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136603 */     // MIs[0] Rn
     /* 136603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136615 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 136618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136628 */     GIR_RootConstrainSelectedInstOperands,
     /* 136629 */     // GIR_Coverage, 7264,
     /* 136629 */     GIR_EraseRootFromParent_Done,
     /* 136630 */   // Label 2593: @136630
     /* 136630 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(136679), // Rule ID 7265 //
     /* 136635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136652 */     // MIs[0] Rn
     /* 136652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136664 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 136667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136677 */     GIR_RootConstrainSelectedInstOperands,
     /* 136678 */     // GIR_Coverage, 7265,
     /* 136678 */     GIR_EraseRootFromParent_Done,
     /* 136679 */   // Label 2594: @136679
     /* 136679 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136728), // Rule ID 7266 //
     /* 136684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136701 */     // MIs[0] Rn
     /* 136701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136713 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 136716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136726 */     GIR_RootConstrainSelectedInstOperands,
     /* 136727 */     // GIR_Coverage, 7266,
     /* 136727 */     GIR_EraseRootFromParent_Done,
     /* 136728 */   // Label 2595: @136728
     /* 136728 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136777), // Rule ID 7267 //
     /* 136733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136750 */     // MIs[0] Rn
     /* 136750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136762 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136775 */     GIR_RootConstrainSelectedInstOperands,
     /* 136776 */     // GIR_Coverage, 7267,
     /* 136776 */     GIR_EraseRootFromParent_Done,
     /* 136777 */   // Label 2596: @136777
     /* 136777 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136826), // Rule ID 7268 //
     /* 136782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136799 */     // MIs[0] Rn
     /* 136799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136811 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136824 */     GIR_RootConstrainSelectedInstOperands,
     /* 136825 */     // GIR_Coverage, 7268,
     /* 136825 */     GIR_EraseRootFromParent_Done,
     /* 136826 */   // Label 2597: @136826
     /* 136826 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136875), // Rule ID 7269 //
     /* 136831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136848 */     // MIs[0] Rn
     /* 136848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136860 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 136863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136873 */     GIR_RootConstrainSelectedInstOperands,
     /* 136874 */     // GIR_Coverage, 7269,
     /* 136874 */     GIR_EraseRootFromParent_Done,
     /* 136875 */   // Label 2598: @136875
     /* 136875 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136924), // Rule ID 7270 //
     /* 136880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136897 */     // MIs[0] Rn
     /* 136897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136909 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 136912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136922 */     GIR_RootConstrainSelectedInstOperands,
     /* 136923 */     // GIR_Coverage, 7270,
     /* 136923 */     GIR_EraseRootFromParent_Done,
     /* 136924 */   // Label 2599: @136924
     /* 136924 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136973), // Rule ID 7271 //
     /* 136929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136946 */     // MIs[0] Rn
     /* 136946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136958 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136971 */     GIR_RootConstrainSelectedInstOperands,
     /* 136972 */     // GIR_Coverage, 7271,
     /* 136972 */     GIR_EraseRootFromParent_Done,
     /* 136973 */   // Label 2600: @136973
     /* 136973 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(137022), // Rule ID 7272 //
     /* 136978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136995 */     // MIs[0] Rn
     /* 136995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137007 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 137010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137020 */     GIR_RootConstrainSelectedInstOperands,
     /* 137021 */     // GIR_Coverage, 7272,
     /* 137021 */     GIR_EraseRootFromParent_Done,
     /* 137022 */   // Label 2601: @137022
     /* 137022 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(137071), // Rule ID 7273 //
     /* 137027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137044 */     // MIs[0] Rn
     /* 137044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137056 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 137059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137069 */     GIR_RootConstrainSelectedInstOperands,
     /* 137070 */     // GIR_Coverage, 7273,
     /* 137070 */     GIR_EraseRootFromParent_Done,
     /* 137071 */   // Label 2602: @137071
     /* 137071 */   GIM_Reject,
     /* 137072 */ // Label 2587: @137072
     /* 137072 */ GIM_Reject,
     /* 137073 */ // Label 2585: @137073
     /* 137073 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(137299),
     /* 137078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137088 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(137130), // Rule ID 7254 //
     /* 137093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137103 */     // MIs[0] Rn
     /* 137103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137115 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 137118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137128 */     GIR_RootConstrainSelectedInstOperands,
     /* 137129 */     // GIR_Coverage, 7254,
     /* 137129 */     GIR_EraseRootFromParent_Done,
     /* 137130 */   // Label 2604: @137130
     /* 137130 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(137172), // Rule ID 7255 //
     /* 137135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137145 */     // MIs[0] Rn
     /* 137145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137157 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 137160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137170 */     GIR_RootConstrainSelectedInstOperands,
     /* 137171 */     // GIR_Coverage, 7255,
     /* 137171 */     GIR_EraseRootFromParent_Done,
     /* 137172 */   // Label 2605: @137172
     /* 137172 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(137214), // Rule ID 7256 //
     /* 137177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137187 */     // MIs[0] Rn
     /* 137187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137199 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 137202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137212 */     GIR_RootConstrainSelectedInstOperands,
     /* 137213 */     // GIR_Coverage, 7256,
     /* 137213 */     GIR_EraseRootFromParent_Done,
     /* 137214 */   // Label 2606: @137214
     /* 137214 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(137256), // Rule ID 7257 //
     /* 137219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137229 */     // MIs[0] Rn
     /* 137229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137241 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137254 */     GIR_RootConstrainSelectedInstOperands,
     /* 137255 */     // GIR_Coverage, 7257,
     /* 137255 */     GIR_EraseRootFromParent_Done,
     /* 137256 */   // Label 2607: @137256
     /* 137256 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(137298), // Rule ID 7258 //
     /* 137261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137271 */     // MIs[0] Rn
     /* 137271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137283 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137296 */     GIR_RootConstrainSelectedInstOperands,
     /* 137297 */     // GIR_Coverage, 7258,
     /* 137297 */     GIR_EraseRootFromParent_Done,
     /* 137298 */   // Label 2608: @137298
     /* 137298 */   GIM_Reject,
     /* 137299 */ // Label 2603: @137299
     /* 137299 */ GIM_Reject,
     /* 137300 */ // Label 2586: @137300
     /* 137300 */ GIM_Reject,
     /* 137301 */ // Label 30: @137301
     /* 137301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2611*/ GIMT_Encode4(138292),
     /* 137312 */ /*GILLT_s32*//*Label 2609*/ GIMT_Encode4(137320),
     /* 137316 */ /*GILLT_s64*//*Label 2610*/ GIMT_Encode4(138065),
     /* 137320 */ // Label 2609: @137320
     /* 137320 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(138064),
     /* 137325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137328 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(137377), // Rule ID 7279 //
     /* 137333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137350 */     // MIs[0] Rn
     /* 137350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137362 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 137365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137375 */     GIR_RootConstrainSelectedInstOperands,
     /* 137376 */     // GIR_Coverage, 7279,
     /* 137376 */     GIR_EraseRootFromParent_Done,
     /* 137377 */   // Label 2613: @137377
     /* 137377 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(137426), // Rule ID 7280 //
     /* 137382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137399 */     // MIs[0] Rn
     /* 137399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137411 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 137414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137424 */     GIR_RootConstrainSelectedInstOperands,
     /* 137425 */     // GIR_Coverage, 7280,
     /* 137425 */     GIR_EraseRootFromParent_Done,
     /* 137426 */   // Label 2614: @137426
     /* 137426 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(137475), // Rule ID 7281 //
     /* 137431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137448 */     // MIs[0] Rn
     /* 137448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137460 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 137463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137473 */     GIR_RootConstrainSelectedInstOperands,
     /* 137474 */     // GIR_Coverage, 7281,
     /* 137474 */     GIR_EraseRootFromParent_Done,
     /* 137475 */   // Label 2615: @137475
     /* 137475 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(137524), // Rule ID 7282 //
     /* 137480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137497 */     // MIs[0] Rn
     /* 137497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137509 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137522 */     GIR_RootConstrainSelectedInstOperands,
     /* 137523 */     // GIR_Coverage, 7282,
     /* 137523 */     GIR_EraseRootFromParent_Done,
     /* 137524 */   // Label 2616: @137524
     /* 137524 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(137573), // Rule ID 7283 //
     /* 137529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137546 */     // MIs[0] Rn
     /* 137546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137558 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137571 */     GIR_RootConstrainSelectedInstOperands,
     /* 137572 */     // GIR_Coverage, 7283,
     /* 137572 */     GIR_EraseRootFromParent_Done,
     /* 137573 */   // Label 2617: @137573
     /* 137573 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(137622), // Rule ID 7284 //
     /* 137578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137595 */     // MIs[0] Rn
     /* 137595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137607 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 137610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137620 */     GIR_RootConstrainSelectedInstOperands,
     /* 137621 */     // GIR_Coverage, 7284,
     /* 137621 */     GIR_EraseRootFromParent_Done,
     /* 137622 */   // Label 2618: @137622
     /* 137622 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(137671), // Rule ID 7285 //
     /* 137627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137644 */     // MIs[0] Rn
     /* 137644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137656 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 137659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137669 */     GIR_RootConstrainSelectedInstOperands,
     /* 137670 */     // GIR_Coverage, 7285,
     /* 137670 */     GIR_EraseRootFromParent_Done,
     /* 137671 */   // Label 2619: @137671
     /* 137671 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137720), // Rule ID 7286 //
     /* 137676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137693 */     // MIs[0] Rn
     /* 137693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137705 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 137708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137718 */     GIR_RootConstrainSelectedInstOperands,
     /* 137719 */     // GIR_Coverage, 7286,
     /* 137719 */     GIR_EraseRootFromParent_Done,
     /* 137720 */   // Label 2620: @137720
     /* 137720 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137769), // Rule ID 7287 //
     /* 137725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137742 */     // MIs[0] Rn
     /* 137742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137754 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137767 */     GIR_RootConstrainSelectedInstOperands,
     /* 137768 */     // GIR_Coverage, 7287,
     /* 137768 */     GIR_EraseRootFromParent_Done,
     /* 137769 */   // Label 2621: @137769
     /* 137769 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137818), // Rule ID 7288 //
     /* 137774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137791 */     // MIs[0] Rn
     /* 137791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137803 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137816 */     GIR_RootConstrainSelectedInstOperands,
     /* 137817 */     // GIR_Coverage, 7288,
     /* 137817 */     GIR_EraseRootFromParent_Done,
     /* 137818 */   // Label 2622: @137818
     /* 137818 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137867), // Rule ID 7289 //
     /* 137823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137840 */     // MIs[0] Rn
     /* 137840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137852 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 137855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137865 */     GIR_RootConstrainSelectedInstOperands,
     /* 137866 */     // GIR_Coverage, 7289,
     /* 137866 */     GIR_EraseRootFromParent_Done,
     /* 137867 */   // Label 2623: @137867
     /* 137867 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137916), // Rule ID 7290 //
     /* 137872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137889 */     // MIs[0] Rn
     /* 137889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137901 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 137904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137914 */     GIR_RootConstrainSelectedInstOperands,
     /* 137915 */     // GIR_Coverage, 7290,
     /* 137915 */     GIR_EraseRootFromParent_Done,
     /* 137916 */   // Label 2624: @137916
     /* 137916 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137965), // Rule ID 7291 //
     /* 137921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137938 */     // MIs[0] Rn
     /* 137938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137950 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 137953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137963 */     GIR_RootConstrainSelectedInstOperands,
     /* 137964 */     // GIR_Coverage, 7291,
     /* 137964 */     GIR_EraseRootFromParent_Done,
     /* 137965 */   // Label 2625: @137965
     /* 137965 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(138014), // Rule ID 7292 //
     /* 137970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137987 */     // MIs[0] Rn
     /* 137987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137999 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 138002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138012 */     GIR_RootConstrainSelectedInstOperands,
     /* 138013 */     // GIR_Coverage, 7292,
     /* 138013 */     GIR_EraseRootFromParent_Done,
     /* 138014 */   // Label 2626: @138014
     /* 138014 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(138063), // Rule ID 7293 //
     /* 138019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138036 */     // MIs[0] Rn
     /* 138036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138048 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 138051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138061 */     GIR_RootConstrainSelectedInstOperands,
     /* 138062 */     // GIR_Coverage, 7293,
     /* 138062 */     GIR_EraseRootFromParent_Done,
     /* 138063 */   // Label 2627: @138063
     /* 138063 */   GIM_Reject,
     /* 138064 */ // Label 2612: @138064
     /* 138064 */ GIM_Reject,
     /* 138065 */ // Label 2610: @138065
     /* 138065 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(138291),
     /* 138070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138080 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(138122), // Rule ID 7274 //
     /* 138085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138095 */     // MIs[0] Rn
     /* 138095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138107 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 138110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138120 */     GIR_RootConstrainSelectedInstOperands,
     /* 138121 */     // GIR_Coverage, 7274,
     /* 138121 */     GIR_EraseRootFromParent_Done,
     /* 138122 */   // Label 2629: @138122
     /* 138122 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(138164), // Rule ID 7275 //
     /* 138127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138137 */     // MIs[0] Rn
     /* 138137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138149 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 138152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138162 */     GIR_RootConstrainSelectedInstOperands,
     /* 138163 */     // GIR_Coverage, 7275,
     /* 138163 */     GIR_EraseRootFromParent_Done,
     /* 138164 */   // Label 2630: @138164
     /* 138164 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(138206), // Rule ID 7276 //
     /* 138169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138179 */     // MIs[0] Rn
     /* 138179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138191 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 138194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138204 */     GIR_RootConstrainSelectedInstOperands,
     /* 138205 */     // GIR_Coverage, 7276,
     /* 138205 */     GIR_EraseRootFromParent_Done,
     /* 138206 */   // Label 2631: @138206
     /* 138206 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(138248), // Rule ID 7277 //
     /* 138211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138221 */     // MIs[0] Rn
     /* 138221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138233 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138246 */     GIR_RootConstrainSelectedInstOperands,
     /* 138247 */     // GIR_Coverage, 7277,
     /* 138247 */     GIR_EraseRootFromParent_Done,
     /* 138248 */   // Label 2632: @138248
     /* 138248 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(138290), // Rule ID 7278 //
     /* 138253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138263 */     // MIs[0] Rn
     /* 138263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138275 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138288 */     GIR_RootConstrainSelectedInstOperands,
     /* 138289 */     // GIR_Coverage, 7278,
     /* 138289 */     GIR_EraseRootFromParent_Done,
     /* 138290 */   // Label 2633: @138290
     /* 138290 */   GIM_Reject,
     /* 138291 */ // Label 2628: @138291
     /* 138291 */ GIM_Reject,
     /* 138292 */ // Label 2611: @138292
     /* 138292 */ GIM_Reject,
     /* 138293 */ // Label 31: @138293
     /* 138293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2637*/ GIMT_Encode4(138997),
     /* 138304 */ /*GILLT_s16*//*Label 2634*/ GIMT_Encode4(138316),
     /* 138308 */ /*GILLT_s32*//*Label 2635*/ GIMT_Encode4(138543),
     /* 138312 */ /*GILLT_s64*//*Label 2636*/ GIMT_Encode4(138770),
     /* 138316 */ // Label 2634: @138316
     /* 138316 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(138542),
     /* 138321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138324 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138331 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(138373), // Rule ID 2584 //
     /* 138336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138346 */     // MIs[0] Rn
     /* 138346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138358 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 138361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138371 */     GIR_RootConstrainSelectedInstOperands,
     /* 138372 */     // GIR_Coverage, 2584,
     /* 138372 */     GIR_EraseRootFromParent_Done,
     /* 138373 */   // Label 2639: @138373
     /* 138373 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(138415), // Rule ID 2585 //
     /* 138378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138388 */     // MIs[0] Rn
     /* 138388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138400 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 138403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138413 */     GIR_RootConstrainSelectedInstOperands,
     /* 138414 */     // GIR_Coverage, 2585,
     /* 138414 */     GIR_EraseRootFromParent_Done,
     /* 138415 */   // Label 2640: @138415
     /* 138415 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(138457), // Rule ID 2586 //
     /* 138420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138430 */     // MIs[0] Rn
     /* 138430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138442 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 138445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138455 */     GIR_RootConstrainSelectedInstOperands,
     /* 138456 */     // GIR_Coverage, 2586,
     /* 138456 */     GIR_EraseRootFromParent_Done,
     /* 138457 */   // Label 2641: @138457
     /* 138457 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(138499), // Rule ID 2587 //
     /* 138462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138472 */     // MIs[0] Rn
     /* 138472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138484 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138497 */     GIR_RootConstrainSelectedInstOperands,
     /* 138498 */     // GIR_Coverage, 2587,
     /* 138498 */     GIR_EraseRootFromParent_Done,
     /* 138499 */   // Label 2642: @138499
     /* 138499 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(138541), // Rule ID 2588 //
     /* 138504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138514 */     // MIs[0] Rn
     /* 138514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138526 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138539 */     GIR_RootConstrainSelectedInstOperands,
     /* 138540 */     // GIR_Coverage, 2588,
     /* 138540 */     GIR_EraseRootFromParent_Done,
     /* 138541 */   // Label 2643: @138541
     /* 138541 */   GIM_Reject,
     /* 138542 */ // Label 2638: @138542
     /* 138542 */ GIM_Reject,
     /* 138543 */ // Label 2635: @138543
     /* 138543 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(138769),
     /* 138548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138551 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138558 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138600), // Rule ID 7369 //
     /* 138563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138573 */     // MIs[0] Rn
     /* 138573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138585 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 138588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138598 */     GIR_RootConstrainSelectedInstOperands,
     /* 138599 */     // GIR_Coverage, 7369,
     /* 138599 */     GIR_EraseRootFromParent_Done,
     /* 138600 */   // Label 2645: @138600
     /* 138600 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(138642), // Rule ID 7370 //
     /* 138605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138615 */     // MIs[0] Rn
     /* 138615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138627 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 138630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138640 */     GIR_RootConstrainSelectedInstOperands,
     /* 138641 */     // GIR_Coverage, 7370,
     /* 138641 */     GIR_EraseRootFromParent_Done,
     /* 138642 */   // Label 2646: @138642
     /* 138642 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(138684), // Rule ID 7371 //
     /* 138647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138657 */     // MIs[0] Rn
     /* 138657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138669 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 138672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138682 */     GIR_RootConstrainSelectedInstOperands,
     /* 138683 */     // GIR_Coverage, 7371,
     /* 138683 */     GIR_EraseRootFromParent_Done,
     /* 138684 */   // Label 2647: @138684
     /* 138684 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(138726), // Rule ID 7372 //
     /* 138689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138699 */     // MIs[0] Rn
     /* 138699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138711 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138724 */     GIR_RootConstrainSelectedInstOperands,
     /* 138725 */     // GIR_Coverage, 7372,
     /* 138725 */     GIR_EraseRootFromParent_Done,
     /* 138726 */   // Label 2648: @138726
     /* 138726 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(138768), // Rule ID 7373 //
     /* 138731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138741 */     // MIs[0] Rn
     /* 138741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138753 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138766 */     GIR_RootConstrainSelectedInstOperands,
     /* 138767 */     // GIR_Coverage, 7373,
     /* 138767 */     GIR_EraseRootFromParent_Done,
     /* 138768 */   // Label 2649: @138768
     /* 138768 */   GIM_Reject,
     /* 138769 */ // Label 2644: @138769
     /* 138769 */ GIM_Reject,
     /* 138770 */ // Label 2636: @138770
     /* 138770 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138996),
     /* 138775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138785 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(138827), // Rule ID 7374 //
     /* 138790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138800 */     // MIs[0] Rn
     /* 138800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138812 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 138815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138825 */     GIR_RootConstrainSelectedInstOperands,
     /* 138826 */     // GIR_Coverage, 7374,
     /* 138826 */     GIR_EraseRootFromParent_Done,
     /* 138827 */   // Label 2651: @138827
     /* 138827 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(138869), // Rule ID 7375 //
     /* 138832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138842 */     // MIs[0] Rn
     /* 138842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138854 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 138857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138867 */     GIR_RootConstrainSelectedInstOperands,
     /* 138868 */     // GIR_Coverage, 7375,
     /* 138868 */     GIR_EraseRootFromParent_Done,
     /* 138869 */   // Label 2652: @138869
     /* 138869 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(138911), // Rule ID 7376 //
     /* 138874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138884 */     // MIs[0] Rn
     /* 138884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138896 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 138899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138909 */     GIR_RootConstrainSelectedInstOperands,
     /* 138910 */     // GIR_Coverage, 7376,
     /* 138910 */     GIR_EraseRootFromParent_Done,
     /* 138911 */   // Label 2653: @138911
     /* 138911 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(138953), // Rule ID 7377 //
     /* 138916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138926 */     // MIs[0] Rn
     /* 138926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138938 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138951 */     GIR_RootConstrainSelectedInstOperands,
     /* 138952 */     // GIR_Coverage, 7377,
     /* 138952 */     GIR_EraseRootFromParent_Done,
     /* 138953 */   // Label 2654: @138953
     /* 138953 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138995), // Rule ID 7378 //
     /* 138958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138968 */     // MIs[0] Rn
     /* 138968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138980 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138993 */     GIR_RootConstrainSelectedInstOperands,
     /* 138994 */     // GIR_Coverage, 7378,
     /* 138994 */     GIR_EraseRootFromParent_Done,
     /* 138995 */   // Label 2655: @138995
     /* 138995 */   GIM_Reject,
     /* 138996 */ // Label 2650: @138996
     /* 138996 */ GIM_Reject,
     /* 138997 */ // Label 2637: @138997
     /* 138997 */ GIM_Reject,
     /* 138998 */ // Label 32: @138998
     /* 138998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2659*/ GIMT_Encode4(139702),
     /* 139009 */ /*GILLT_s16*//*Label 2656*/ GIMT_Encode4(139021),
     /* 139013 */ /*GILLT_s32*//*Label 2657*/ GIMT_Encode4(139248),
     /* 139017 */ /*GILLT_s64*//*Label 2658*/ GIMT_Encode4(139475),
     /* 139021 */ // Label 2656: @139021
     /* 139021 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(139247),
     /* 139026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139029 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139036 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(139078), // Rule ID 7379 //
     /* 139041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139051 */     // MIs[0] Rn
     /* 139051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139063 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 139066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139076 */     GIR_RootConstrainSelectedInstOperands,
     /* 139077 */     // GIR_Coverage, 7379,
     /* 139077 */     GIR_EraseRootFromParent_Done,
     /* 139078 */   // Label 2661: @139078
     /* 139078 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(139120), // Rule ID 7380 //
     /* 139083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139093 */     // MIs[0] Rn
     /* 139093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139105 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 139108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139118 */     GIR_RootConstrainSelectedInstOperands,
     /* 139119 */     // GIR_Coverage, 7380,
     /* 139119 */     GIR_EraseRootFromParent_Done,
     /* 139120 */   // Label 2662: @139120
     /* 139120 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(139162), // Rule ID 7381 //
     /* 139125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139135 */     // MIs[0] Rn
     /* 139135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139147 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 139150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139160 */     GIR_RootConstrainSelectedInstOperands,
     /* 139161 */     // GIR_Coverage, 7381,
     /* 139161 */     GIR_EraseRootFromParent_Done,
     /* 139162 */   // Label 2663: @139162
     /* 139162 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(139204), // Rule ID 7382 //
     /* 139167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139177 */     // MIs[0] Rn
     /* 139177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139189 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139202 */     GIR_RootConstrainSelectedInstOperands,
     /* 139203 */     // GIR_Coverage, 7382,
     /* 139203 */     GIR_EraseRootFromParent_Done,
     /* 139204 */   // Label 2664: @139204
     /* 139204 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(139246), // Rule ID 7383 //
     /* 139209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139219 */     // MIs[0] Rn
     /* 139219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139231 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139244 */     GIR_RootConstrainSelectedInstOperands,
     /* 139245 */     // GIR_Coverage, 7383,
     /* 139245 */     GIR_EraseRootFromParent_Done,
     /* 139246 */   // Label 2665: @139246
     /* 139246 */   GIM_Reject,
     /* 139247 */ // Label 2660: @139247
     /* 139247 */ GIM_Reject,
     /* 139248 */ // Label 2657: @139248
     /* 139248 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(139474),
     /* 139253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139263 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(139305), // Rule ID 7384 //
     /* 139268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139278 */     // MIs[0] Rn
     /* 139278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139290 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 139293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139303 */     GIR_RootConstrainSelectedInstOperands,
     /* 139304 */     // GIR_Coverage, 7384,
     /* 139304 */     GIR_EraseRootFromParent_Done,
     /* 139305 */   // Label 2667: @139305
     /* 139305 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(139347), // Rule ID 7385 //
     /* 139310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139320 */     // MIs[0] Rn
     /* 139320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139332 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 139335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139345 */     GIR_RootConstrainSelectedInstOperands,
     /* 139346 */     // GIR_Coverage, 7385,
     /* 139346 */     GIR_EraseRootFromParent_Done,
     /* 139347 */   // Label 2668: @139347
     /* 139347 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(139389), // Rule ID 7386 //
     /* 139352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139362 */     // MIs[0] Rn
     /* 139362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139374 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 139377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139387 */     GIR_RootConstrainSelectedInstOperands,
     /* 139388 */     // GIR_Coverage, 7386,
     /* 139388 */     GIR_EraseRootFromParent_Done,
     /* 139389 */   // Label 2669: @139389
     /* 139389 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(139431), // Rule ID 7387 //
     /* 139394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139404 */     // MIs[0] Rn
     /* 139404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139416 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139429 */     GIR_RootConstrainSelectedInstOperands,
     /* 139430 */     // GIR_Coverage, 7387,
     /* 139430 */     GIR_EraseRootFromParent_Done,
     /* 139431 */   // Label 2670: @139431
     /* 139431 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(139473), // Rule ID 7388 //
     /* 139436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139446 */     // MIs[0] Rn
     /* 139446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139458 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139471 */     GIR_RootConstrainSelectedInstOperands,
     /* 139472 */     // GIR_Coverage, 7388,
     /* 139472 */     GIR_EraseRootFromParent_Done,
     /* 139473 */   // Label 2671: @139473
     /* 139473 */   GIM_Reject,
     /* 139474 */ // Label 2666: @139474
     /* 139474 */ GIM_Reject,
     /* 139475 */ // Label 2658: @139475
     /* 139475 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(139701),
     /* 139480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139490 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(139532), // Rule ID 7389 //
     /* 139495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139505 */     // MIs[0] Rn
     /* 139505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139517 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 139520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139530 */     GIR_RootConstrainSelectedInstOperands,
     /* 139531 */     // GIR_Coverage, 7389,
     /* 139531 */     GIR_EraseRootFromParent_Done,
     /* 139532 */   // Label 2673: @139532
     /* 139532 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(139574), // Rule ID 7390 //
     /* 139537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139547 */     // MIs[0] Rn
     /* 139547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139559 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 139562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139572 */     GIR_RootConstrainSelectedInstOperands,
     /* 139573 */     // GIR_Coverage, 7390,
     /* 139573 */     GIR_EraseRootFromParent_Done,
     /* 139574 */   // Label 2674: @139574
     /* 139574 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(139616), // Rule ID 7391 //
     /* 139579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139589 */     // MIs[0] Rn
     /* 139589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139601 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 139604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139614 */     GIR_RootConstrainSelectedInstOperands,
     /* 139615 */     // GIR_Coverage, 7391,
     /* 139615 */     GIR_EraseRootFromParent_Done,
     /* 139616 */   // Label 2675: @139616
     /* 139616 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(139658), // Rule ID 7392 //
     /* 139621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139631 */     // MIs[0] Rn
     /* 139631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139643 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139656 */     GIR_RootConstrainSelectedInstOperands,
     /* 139657 */     // GIR_Coverage, 7392,
     /* 139657 */     GIR_EraseRootFromParent_Done,
     /* 139658 */   // Label 2676: @139658
     /* 139658 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(139700), // Rule ID 7393 //
     /* 139663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139673 */     // MIs[0] Rn
     /* 139673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139685 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139698 */     GIR_RootConstrainSelectedInstOperands,
     /* 139699 */     // GIR_Coverage, 7393,
     /* 139699 */     GIR_EraseRootFromParent_Done,
     /* 139700 */   // Label 2677: @139700
     /* 139700 */   GIM_Reject,
     /* 139701 */ // Label 2672: @139701
     /* 139701 */ GIM_Reject,
     /* 139702 */ // Label 2659: @139702
     /* 139702 */ GIM_Reject,
     /* 139703 */ // Label 33: @139703
     /* 139703 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2681*/ GIMT_Encode4(140407),
     /* 139714 */ /*GILLT_s16*//*Label 2678*/ GIMT_Encode4(139726),
     /* 139718 */ /*GILLT_s32*//*Label 2679*/ GIMT_Encode4(139953),
     /* 139722 */ /*GILLT_s64*//*Label 2680*/ GIMT_Encode4(140180),
     /* 139726 */ // Label 2678: @139726
     /* 139726 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(139952),
     /* 139731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139741 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139783), // Rule ID 7394 //
     /* 139746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139756 */     // MIs[0] Rn
     /* 139756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139768 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 139771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139781 */     GIR_RootConstrainSelectedInstOperands,
     /* 139782 */     // GIR_Coverage, 7394,
     /* 139782 */     GIR_EraseRootFromParent_Done,
     /* 139783 */   // Label 2683: @139783
     /* 139783 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139825), // Rule ID 7395 //
     /* 139788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139798 */     // MIs[0] Rn
     /* 139798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139810 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 139813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139823 */     GIR_RootConstrainSelectedInstOperands,
     /* 139824 */     // GIR_Coverage, 7395,
     /* 139824 */     GIR_EraseRootFromParent_Done,
     /* 139825 */   // Label 2684: @139825
     /* 139825 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139867), // Rule ID 7396 //
     /* 139830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139840 */     // MIs[0] Rn
     /* 139840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139852 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 139855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139865 */     GIR_RootConstrainSelectedInstOperands,
     /* 139866 */     // GIR_Coverage, 7396,
     /* 139866 */     GIR_EraseRootFromParent_Done,
     /* 139867 */   // Label 2685: @139867
     /* 139867 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139909), // Rule ID 7397 //
     /* 139872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139882 */     // MIs[0] Rn
     /* 139882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139894 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139907 */     GIR_RootConstrainSelectedInstOperands,
     /* 139908 */     // GIR_Coverage, 7397,
     /* 139908 */     GIR_EraseRootFromParent_Done,
     /* 139909 */   // Label 2686: @139909
     /* 139909 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139951), // Rule ID 7398 //
     /* 139914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139924 */     // MIs[0] Rn
     /* 139924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139936 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139949 */     GIR_RootConstrainSelectedInstOperands,
     /* 139950 */     // GIR_Coverage, 7398,
     /* 139950 */     GIR_EraseRootFromParent_Done,
     /* 139951 */   // Label 2687: @139951
     /* 139951 */   GIM_Reject,
     /* 139952 */ // Label 2682: @139952
     /* 139952 */ GIM_Reject,
     /* 139953 */ // Label 2679: @139953
     /* 139953 */ GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(140179),
     /* 139958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139961 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139968 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(140010), // Rule ID 7399 //
     /* 139973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139983 */     // MIs[0] Rn
     /* 139983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139995 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140008 */     GIR_RootConstrainSelectedInstOperands,
     /* 140009 */     // GIR_Coverage, 7399,
     /* 140009 */     GIR_EraseRootFromParent_Done,
     /* 140010 */   // Label 2689: @140010
     /* 140010 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(140052), // Rule ID 7400 //
     /* 140015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140025 */     // MIs[0] Rn
     /* 140025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140037 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 140040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140050 */     GIR_RootConstrainSelectedInstOperands,
     /* 140051 */     // GIR_Coverage, 7400,
     /* 140051 */     GIR_EraseRootFromParent_Done,
     /* 140052 */   // Label 2690: @140052
     /* 140052 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(140094), // Rule ID 7401 //
     /* 140057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140060 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140067 */     // MIs[0] Rn
     /* 140067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140079 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 140082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140092 */     GIR_RootConstrainSelectedInstOperands,
     /* 140093 */     // GIR_Coverage, 7401,
     /* 140093 */     GIR_EraseRootFromParent_Done,
     /* 140094 */   // Label 2691: @140094
     /* 140094 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(140136), // Rule ID 7402 //
     /* 140099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140109 */     // MIs[0] Rn
     /* 140109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140121 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140134 */     GIR_RootConstrainSelectedInstOperands,
     /* 140135 */     // GIR_Coverage, 7402,
     /* 140135 */     GIR_EraseRootFromParent_Done,
     /* 140136 */   // Label 2692: @140136
     /* 140136 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(140178), // Rule ID 7403 //
     /* 140141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140151 */     // MIs[0] Rn
     /* 140151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140163 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140176 */     GIR_RootConstrainSelectedInstOperands,
     /* 140177 */     // GIR_Coverage, 7403,
     /* 140177 */     GIR_EraseRootFromParent_Done,
     /* 140178 */   // Label 2693: @140178
     /* 140178 */   GIM_Reject,
     /* 140179 */ // Label 2688: @140179
     /* 140179 */ GIM_Reject,
     /* 140180 */ // Label 2680: @140180
     /* 140180 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(140406),
     /* 140185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140188 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140195 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(140237), // Rule ID 7404 //
     /* 140200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140210 */     // MIs[0] Rn
     /* 140210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140222 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 140225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 7404,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2695: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(140279), // Rule ID 7405 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140252 */     // MIs[0] Rn
     /* 140252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140264 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 140267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140277 */     GIR_RootConstrainSelectedInstOperands,
     /* 140278 */     // GIR_Coverage, 7405,
     /* 140278 */     GIR_EraseRootFromParent_Done,
     /* 140279 */   // Label 2696: @140279
     /* 140279 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(140321), // Rule ID 7406 //
     /* 140284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140294 */     // MIs[0] Rn
     /* 140294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140306 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 140309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140319 */     GIR_RootConstrainSelectedInstOperands,
     /* 140320 */     // GIR_Coverage, 7406,
     /* 140320 */     GIR_EraseRootFromParent_Done,
     /* 140321 */   // Label 2697: @140321
     /* 140321 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(140363), // Rule ID 7407 //
     /* 140326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140336 */     // MIs[0] Rn
     /* 140336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140348 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140361 */     GIR_RootConstrainSelectedInstOperands,
     /* 140362 */     // GIR_Coverage, 7407,
     /* 140362 */     GIR_EraseRootFromParent_Done,
     /* 140363 */   // Label 2698: @140363
     /* 140363 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(140405), // Rule ID 7408 //
     /* 140368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140378 */     // MIs[0] Rn
     /* 140378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140390 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140403 */     GIR_RootConstrainSelectedInstOperands,
     /* 140404 */     // GIR_Coverage, 7408,
     /* 140404 */     GIR_EraseRootFromParent_Done,
     /* 140405 */   // Label 2699: @140405
     /* 140405 */   GIM_Reject,
     /* 140406 */ // Label 2694: @140406
     /* 140406 */ GIM_Reject,
     /* 140407 */ // Label 2681: @140407
     /* 140407 */ GIM_Reject,
     /* 140408 */ // Label 34: @140408
     /* 140408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2703*/ GIMT_Encode4(141112),
     /* 140419 */ /*GILLT_s16*//*Label 2700*/ GIMT_Encode4(140431),
     /* 140423 */ /*GILLT_s32*//*Label 2701*/ GIMT_Encode4(140658),
     /* 140427 */ /*GILLT_s64*//*Label 2702*/ GIMT_Encode4(140885),
     /* 140431 */ // Label 2700: @140431
     /* 140431 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(140657),
     /* 140436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140439 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140446 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(140488), // Rule ID 7409 //
     /* 140451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140461 */     // MIs[0] Rn
     /* 140461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140473 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 140476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140486 */     GIR_RootConstrainSelectedInstOperands,
     /* 140487 */     // GIR_Coverage, 7409,
     /* 140487 */     GIR_EraseRootFromParent_Done,
     /* 140488 */   // Label 2705: @140488
     /* 140488 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140530), // Rule ID 7410 //
     /* 140493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140503 */     // MIs[0] Rn
     /* 140503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140515 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 140518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140528 */     GIR_RootConstrainSelectedInstOperands,
     /* 140529 */     // GIR_Coverage, 7410,
     /* 140529 */     GIR_EraseRootFromParent_Done,
     /* 140530 */   // Label 2706: @140530
     /* 140530 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140572), // Rule ID 7411 //
     /* 140535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140545 */     // MIs[0] Rn
     /* 140545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140557 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 140560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140570 */     GIR_RootConstrainSelectedInstOperands,
     /* 140571 */     // GIR_Coverage, 7411,
     /* 140571 */     GIR_EraseRootFromParent_Done,
     /* 140572 */   // Label 2707: @140572
     /* 140572 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140614), // Rule ID 7412 //
     /* 140577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140587 */     // MIs[0] Rn
     /* 140587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140599 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 140602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140612 */     GIR_RootConstrainSelectedInstOperands,
     /* 140613 */     // GIR_Coverage, 7412,
     /* 140613 */     GIR_EraseRootFromParent_Done,
     /* 140614 */   // Label 2708: @140614
     /* 140614 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140656), // Rule ID 7413 //
     /* 140619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140629 */     // MIs[0] Rn
     /* 140629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140641 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 140644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140654 */     GIR_RootConstrainSelectedInstOperands,
     /* 140655 */     // GIR_Coverage, 7413,
     /* 140655 */     GIR_EraseRootFromParent_Done,
     /* 140656 */   // Label 2709: @140656
     /* 140656 */   GIM_Reject,
     /* 140657 */ // Label 2704: @140657
     /* 140657 */ GIM_Reject,
     /* 140658 */ // Label 2701: @140658
     /* 140658 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140884),
     /* 140663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 140673 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140715), // Rule ID 7414 //
     /* 140678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140688 */     // MIs[0] Rn
     /* 140688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140700 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 140703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140713 */     GIR_RootConstrainSelectedInstOperands,
     /* 140714 */     // GIR_Coverage, 7414,
     /* 140714 */     GIR_EraseRootFromParent_Done,
     /* 140715 */   // Label 2711: @140715
     /* 140715 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140757), // Rule ID 7415 //
     /* 140720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140730 */     // MIs[0] Rn
     /* 140730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140742 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 140745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140755 */     GIR_RootConstrainSelectedInstOperands,
     /* 140756 */     // GIR_Coverage, 7415,
     /* 140756 */     GIR_EraseRootFromParent_Done,
     /* 140757 */   // Label 2712: @140757
     /* 140757 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140799), // Rule ID 7416 //
     /* 140762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140772 */     // MIs[0] Rn
     /* 140772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140784 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 140787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140797 */     GIR_RootConstrainSelectedInstOperands,
     /* 140798 */     // GIR_Coverage, 7416,
     /* 140798 */     GIR_EraseRootFromParent_Done,
     /* 140799 */   // Label 2713: @140799
     /* 140799 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140841), // Rule ID 7417 //
     /* 140804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140814 */     // MIs[0] Rn
     /* 140814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140826 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 140829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140839 */     GIR_RootConstrainSelectedInstOperands,
     /* 140840 */     // GIR_Coverage, 7417,
     /* 140840 */     GIR_EraseRootFromParent_Done,
     /* 140841 */   // Label 2714: @140841
     /* 140841 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140883), // Rule ID 7418 //
     /* 140846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140856 */     // MIs[0] Rn
     /* 140856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140868 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 140871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140881 */     GIR_RootConstrainSelectedInstOperands,
     /* 140882 */     // GIR_Coverage, 7418,
     /* 140882 */     GIR_EraseRootFromParent_Done,
     /* 140883 */   // Label 2715: @140883
     /* 140883 */   GIM_Reject,
     /* 140884 */ // Label 2710: @140884
     /* 140884 */ GIM_Reject,
     /* 140885 */ // Label 2702: @140885
     /* 140885 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(141111),
     /* 140890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140900 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140942), // Rule ID 7419 //
     /* 140905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140915 */     // MIs[0] Rn
     /* 140915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140927 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 140930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140940 */     GIR_RootConstrainSelectedInstOperands,
     /* 140941 */     // GIR_Coverage, 7419,
     /* 140941 */     GIR_EraseRootFromParent_Done,
     /* 140942 */   // Label 2717: @140942
     /* 140942 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140984), // Rule ID 7420 //
     /* 140947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140957 */     // MIs[0] Rn
     /* 140957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140969 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 140972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140982 */     GIR_RootConstrainSelectedInstOperands,
     /* 140983 */     // GIR_Coverage, 7420,
     /* 140983 */     GIR_EraseRootFromParent_Done,
     /* 140984 */   // Label 2718: @140984
     /* 140984 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(141026), // Rule ID 7421 //
     /* 140989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140999 */     // MIs[0] Rn
     /* 140999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141011 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 141014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141024 */     GIR_RootConstrainSelectedInstOperands,
     /* 141025 */     // GIR_Coverage, 7421,
     /* 141025 */     GIR_EraseRootFromParent_Done,
     /* 141026 */   // Label 2719: @141026
     /* 141026 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(141068), // Rule ID 7422 //
     /* 141031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141041 */     // MIs[0] Rn
     /* 141041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141053 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 141056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141066 */     GIR_RootConstrainSelectedInstOperands,
     /* 141067 */     // GIR_Coverage, 7422,
     /* 141067 */     GIR_EraseRootFromParent_Done,
     /* 141068 */   // Label 2720: @141068
     /* 141068 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(141110), // Rule ID 7423 //
     /* 141073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141076 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141083 */     // MIs[0] Rn
     /* 141083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141095 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 141098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141108 */     GIR_RootConstrainSelectedInstOperands,
     /* 141109 */     // GIR_Coverage, 7423,
     /* 141109 */     GIR_EraseRootFromParent_Done,
     /* 141110 */   // Label 2721: @141110
     /* 141110 */   GIM_Reject,
     /* 141111 */ // Label 2716: @141111
     /* 141111 */ GIM_Reject,
     /* 141112 */ // Label 2703: @141112
     /* 141112 */ GIM_Reject,
     /* 141113 */ // Label 35: @141113
     /* 141113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2725*/ GIMT_Encode4(141817),
     /* 141124 */ /*GILLT_s16*//*Label 2722*/ GIMT_Encode4(141136),
     /* 141128 */ /*GILLT_s32*//*Label 2723*/ GIMT_Encode4(141363),
     /* 141132 */ /*GILLT_s64*//*Label 2724*/ GIMT_Encode4(141590),
     /* 141136 */ // Label 2722: @141136
     /* 141136 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(141362),
     /* 141141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 141151 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(141193), // Rule ID 7424 //
     /* 141156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141166 */     // MIs[0] Rn
     /* 141166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141178 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 141181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141191 */     GIR_RootConstrainSelectedInstOperands,
     /* 141192 */     // GIR_Coverage, 7424,
     /* 141192 */     GIR_EraseRootFromParent_Done,
     /* 141193 */   // Label 2727: @141193
     /* 141193 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(141235), // Rule ID 7425 //
     /* 141198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141208 */     // MIs[0] Rn
     /* 141208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141220 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 141223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141233 */     GIR_RootConstrainSelectedInstOperands,
     /* 141234 */     // GIR_Coverage, 7425,
     /* 141234 */     GIR_EraseRootFromParent_Done,
     /* 141235 */   // Label 2728: @141235
     /* 141235 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(141277), // Rule ID 7426 //
     /* 141240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141250 */     // MIs[0] Rn
     /* 141250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141262 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 141265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141275 */     GIR_RootConstrainSelectedInstOperands,
     /* 141276 */     // GIR_Coverage, 7426,
     /* 141276 */     GIR_EraseRootFromParent_Done,
     /* 141277 */   // Label 2729: @141277
     /* 141277 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141319), // Rule ID 7427 //
     /* 141282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141292 */     // MIs[0] Rn
     /* 141292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141304 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 141307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141317 */     GIR_RootConstrainSelectedInstOperands,
     /* 141318 */     // GIR_Coverage, 7427,
     /* 141318 */     GIR_EraseRootFromParent_Done,
     /* 141319 */   // Label 2730: @141319
     /* 141319 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141361), // Rule ID 7428 //
     /* 141324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141334 */     // MIs[0] Rn
     /* 141334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141346 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 141349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141359 */     GIR_RootConstrainSelectedInstOperands,
     /* 141360 */     // GIR_Coverage, 7428,
     /* 141360 */     GIR_EraseRootFromParent_Done,
     /* 141361 */   // Label 2731: @141361
     /* 141361 */   GIM_Reject,
     /* 141362 */ // Label 2726: @141362
     /* 141362 */ GIM_Reject,
     /* 141363 */ // Label 2723: @141363
     /* 141363 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141589),
     /* 141368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 141378 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141420), // Rule ID 7429 //
     /* 141383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141393 */     // MIs[0] Rn
     /* 141393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141405 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 141408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141418 */     GIR_RootConstrainSelectedInstOperands,
     /* 141419 */     // GIR_Coverage, 7429,
     /* 141419 */     GIR_EraseRootFromParent_Done,
     /* 141420 */   // Label 2733: @141420
     /* 141420 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141462), // Rule ID 7430 //
     /* 141425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141435 */     // MIs[0] Rn
     /* 141435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141447 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 141450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141460 */     GIR_RootConstrainSelectedInstOperands,
     /* 141461 */     // GIR_Coverage, 7430,
     /* 141461 */     GIR_EraseRootFromParent_Done,
     /* 141462 */   // Label 2734: @141462
     /* 141462 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141504), // Rule ID 7431 //
     /* 141467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141477 */     // MIs[0] Rn
     /* 141477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141489 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 141492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141502 */     GIR_RootConstrainSelectedInstOperands,
     /* 141503 */     // GIR_Coverage, 7431,
     /* 141503 */     GIR_EraseRootFromParent_Done,
     /* 141504 */   // Label 2735: @141504
     /* 141504 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141546), // Rule ID 7432 //
     /* 141509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141519 */     // MIs[0] Rn
     /* 141519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141531 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 141534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141544 */     GIR_RootConstrainSelectedInstOperands,
     /* 141545 */     // GIR_Coverage, 7432,
     /* 141545 */     GIR_EraseRootFromParent_Done,
     /* 141546 */   // Label 2736: @141546
     /* 141546 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141588), // Rule ID 7433 //
     /* 141551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141561 */     // MIs[0] Rn
     /* 141561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141573 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 141576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141586 */     GIR_RootConstrainSelectedInstOperands,
     /* 141587 */     // GIR_Coverage, 7433,
     /* 141587 */     GIR_EraseRootFromParent_Done,
     /* 141588 */   // Label 2737: @141588
     /* 141588 */   GIM_Reject,
     /* 141589 */ // Label 2732: @141589
     /* 141589 */ GIM_Reject,
     /* 141590 */ // Label 2724: @141590
     /* 141590 */ GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141816),
     /* 141595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141605 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141647), // Rule ID 7434 //
     /* 141610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141620 */     // MIs[0] Rn
     /* 141620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141632 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 141635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141645 */     GIR_RootConstrainSelectedInstOperands,
     /* 141646 */     // GIR_Coverage, 7434,
     /* 141646 */     GIR_EraseRootFromParent_Done,
     /* 141647 */   // Label 2739: @141647
     /* 141647 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141689), // Rule ID 7435 //
     /* 141652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141662 */     // MIs[0] Rn
     /* 141662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141674 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 141677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141687 */     GIR_RootConstrainSelectedInstOperands,
     /* 141688 */     // GIR_Coverage, 7435,
     /* 141688 */     GIR_EraseRootFromParent_Done,
     /* 141689 */   // Label 2740: @141689
     /* 141689 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141731), // Rule ID 7436 //
     /* 141694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141704 */     // MIs[0] Rn
     /* 141704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141716 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 141719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141729 */     GIR_RootConstrainSelectedInstOperands,
     /* 141730 */     // GIR_Coverage, 7436,
     /* 141730 */     GIR_EraseRootFromParent_Done,
     /* 141731 */   // Label 2741: @141731
     /* 141731 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141773), // Rule ID 7437 //
     /* 141736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141746 */     // MIs[0] Rn
     /* 141746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141758 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 141761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141771 */     GIR_RootConstrainSelectedInstOperands,
     /* 141772 */     // GIR_Coverage, 7437,
     /* 141772 */     GIR_EraseRootFromParent_Done,
     /* 141773 */   // Label 2742: @141773
     /* 141773 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141815), // Rule ID 7438 //
     /* 141778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141788 */     // MIs[0] Rn
     /* 141788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141800 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 141803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141813 */     GIR_RootConstrainSelectedInstOperands,
     /* 141814 */     // GIR_Coverage, 7438,
     /* 141814 */     GIR_EraseRootFromParent_Done,
     /* 141815 */   // Label 2743: @141815
     /* 141815 */   GIM_Reject,
     /* 141816 */ // Label 2738: @141816
     /* 141816 */ GIM_Reject,
     /* 141817 */ // Label 2725: @141817
     /* 141817 */ GIM_Reject,
     /* 141818 */ // Label 36: @141818
     /* 141818 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141845), // Rule ID 7024 //
     /* 141823 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141826 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 141830 */   // MIs[0] Operand 1
     /* 141830 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 141833 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 141833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 141836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 141839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141843 */   GIR_RootConstrainSelectedInstOperands,
     /* 141844 */   // GIR_Coverage, 7024,
     /* 141844 */   GIR_EraseRootFromParent_Done,
     /* 141845 */ // Label 2744: @141845
     /* 141845 */ GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141868), // Rule ID 7025 //
     /* 141850 */   // MIs[0] Operand 0
     /* 141850 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 141853 */   // MIs[0] Operand 1
     /* 141853 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 141856 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 141856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 141859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 141862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141866 */   GIR_RootConstrainSelectedInstOperands,
     /* 141867 */   // GIR_Coverage, 7025,
     /* 141867 */   GIR_EraseRootFromParent_Done,
     /* 141868 */ // Label 2745: @141868
     /* 141868 */ GIM_Reject,
     /* 141869 */ // Label 37: @141869
     /* 141869 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154396),
     /* 141874 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 141877 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141968), // Rule ID 6503 //
     /* 141882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 141885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 141890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 141908 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 141911 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 141916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141920 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 141924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141936 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 141936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 141939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 141943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 141952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 141956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 141961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141966 */     GIR_RootConstrainSelectedInstOperands,
     /* 141967 */     // GIR_Coverage, 6503,
     /* 141967 */     GIR_EraseRootFromParent_Done,
     /* 141968 */   // Label 2747: @141968
     /* 141968 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(142059), // Rule ID 6504 //
     /* 141973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 141976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 141981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 141999 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 142002 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 142007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142011 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 142015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142027 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 142027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 142034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 142043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 142047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 142052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142057 */     GIR_RootConstrainSelectedInstOperands,
     /* 142058 */     // GIR_Coverage, 6504,
     /* 142058 */     GIR_EraseRootFromParent_Done,
     /* 142059 */   // Label 2748: @142059
     /* 142059 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(142120), // Rule ID 4898 //
     /* 142064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 142069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 142087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142096 */     // MIs[1] Operand 2
     /* 142096 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 142107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142109 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 142109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 142112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 142118 */     GIR_RootConstrainSelectedInstOperands,
     /* 142119 */     // GIR_Coverage, 4898,
     /* 142119 */     GIR_EraseRootFromParent_Done,
     /* 142120 */   // Label 2749: @142120
     /* 142120 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(142160), // Rule ID 2651 //
     /* 142125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 142133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142140 */     // MIs[0] pattern
     /* 142140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142148 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 142151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142153 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142158 */     GIR_RootConstrainSelectedInstOperands,
     /* 142159 */     // GIR_Coverage, 2651,
     /* 142159 */     GIR_EraseRootFromParent_Done,
     /* 142160 */   // Label 2750: @142160
     /* 142160 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(142200), // Rule ID 9945 //
     /* 142165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 142173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142180 */     // MIs[0] pattern
     /* 142180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142188 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 142191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142193 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142198 */     GIR_RootConstrainSelectedInstOperands,
     /* 142199 */     // GIR_Coverage, 9945,
     /* 142199 */     GIR_EraseRootFromParent_Done,
     /* 142200 */   // Label 2751: @142200
     /* 142200 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(142240), // Rule ID 9948 //
     /* 142205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 142213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142220 */     // MIs[0] pattern
     /* 142220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142228 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 142231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142233 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142238 */     GIR_RootConstrainSelectedInstOperands,
     /* 142239 */     // GIR_Coverage, 9948,
     /* 142239 */     GIR_EraseRootFromParent_Done,
     /* 142240 */   // Label 2752: @142240
     /* 142240 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(142280), // Rule ID 9951 //
     /* 142245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 142253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142260 */     // MIs[0] pattern
     /* 142260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142268 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 142271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142273 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142278 */     GIR_RootConstrainSelectedInstOperands,
     /* 142279 */     // GIR_Coverage, 9951,
     /* 142279 */     GIR_EraseRootFromParent_Done,
     /* 142280 */   // Label 2753: @142280
     /* 142280 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(142319), // Rule ID 66 //
     /* 142285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 142288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 142293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142307 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 142310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 142317 */     GIR_RootConstrainSelectedInstOperands,
     /* 142318 */     // GIR_Coverage, 66,
     /* 142318 */     GIR_EraseRootFromParent_Done,
     /* 142319 */   // Label 2754: @142319
     /* 142319 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(142355), // Rule ID 346 //
     /* 142324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142346 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 142349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142353 */     GIR_RootConstrainSelectedInstOperands,
     /* 142354 */     // GIR_Coverage, 346,
     /* 142354 */     GIR_EraseRootFromParent_Done,
     /* 142355 */   // Label 2755: @142355
     /* 142355 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(142391), // Rule ID 347 //
     /* 142360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142382 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 142385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142389 */     GIR_RootConstrainSelectedInstOperands,
     /* 142390 */     // GIR_Coverage, 347,
     /* 142390 */     GIR_EraseRootFromParent_Done,
     /* 142391 */   // Label 2756: @142391
     /* 142391 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(142427), // Rule ID 348 //
     /* 142396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142418 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 142421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142425 */     GIR_RootConstrainSelectedInstOperands,
     /* 142426 */     // GIR_Coverage, 348,
     /* 142426 */     GIR_EraseRootFromParent_Done,
     /* 142427 */   // Label 2757: @142427
     /* 142427 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142463), // Rule ID 349 //
     /* 142432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142454 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 142457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142461 */     GIR_RootConstrainSelectedInstOperands,
     /* 142462 */     // GIR_Coverage, 349,
     /* 142462 */     GIR_EraseRootFromParent_Done,
     /* 142463 */   // Label 2758: @142463
     /* 142463 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142499), // Rule ID 350 //
     /* 142468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142490 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 142493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142497 */     GIR_RootConstrainSelectedInstOperands,
     /* 142498 */     // GIR_Coverage, 350,
     /* 142498 */     GIR_EraseRootFromParent_Done,
     /* 142499 */   // Label 2759: @142499
     /* 142499 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142535), // Rule ID 351 //
     /* 142504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142526 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 142529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142533 */     GIR_RootConstrainSelectedInstOperands,
     /* 142534 */     // GIR_Coverage, 351,
     /* 142534 */     GIR_EraseRootFromParent_Done,
     /* 142535 */   // Label 2760: @142535
     /* 142535 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142571), // Rule ID 352 //
     /* 142540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142562 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 142565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142569 */     GIR_RootConstrainSelectedInstOperands,
     /* 142570 */     // GIR_Coverage, 352,
     /* 142570 */     GIR_EraseRootFromParent_Done,
     /* 142571 */   // Label 2761: @142571
     /* 142571 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142607), // Rule ID 353 //
     /* 142576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142598 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 142601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142605 */     GIR_RootConstrainSelectedInstOperands,
     /* 142606 */     // GIR_Coverage, 353,
     /* 142606 */     GIR_EraseRootFromParent_Done,
     /* 142607 */   // Label 2762: @142607
     /* 142607 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142643), // Rule ID 354 //
     /* 142612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142634 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 142637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142641 */     GIR_RootConstrainSelectedInstOperands,
     /* 142642 */     // GIR_Coverage, 354,
     /* 142642 */     GIR_EraseRootFromParent_Done,
     /* 142643 */   // Label 2763: @142643
     /* 142643 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142679), // Rule ID 355 //
     /* 142648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142670 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 142673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142677 */     GIR_RootConstrainSelectedInstOperands,
     /* 142678 */     // GIR_Coverage, 355,
     /* 142678 */     GIR_EraseRootFromParent_Done,
     /* 142679 */   // Label 2764: @142679
     /* 142679 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142715), // Rule ID 356 //
     /* 142684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142706 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 142709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142713 */     GIR_RootConstrainSelectedInstOperands,
     /* 142714 */     // GIR_Coverage, 356,
     /* 142714 */     GIR_EraseRootFromParent_Done,
     /* 142715 */   // Label 2765: @142715
     /* 142715 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142751), // Rule ID 357 //
     /* 142720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142742 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 142745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142749 */     GIR_RootConstrainSelectedInstOperands,
     /* 142750 */     // GIR_Coverage, 357,
     /* 142750 */     GIR_EraseRootFromParent_Done,
     /* 142751 */   // Label 2766: @142751
     /* 142751 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142787), // Rule ID 358 //
     /* 142756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142778 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 142781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142785 */     GIR_RootConstrainSelectedInstOperands,
     /* 142786 */     // GIR_Coverage, 358,
     /* 142786 */     GIR_EraseRootFromParent_Done,
     /* 142787 */   // Label 2767: @142787
     /* 142787 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142823), // Rule ID 359 //
     /* 142792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142814 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 142817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142821 */     GIR_RootConstrainSelectedInstOperands,
     /* 142822 */     // GIR_Coverage, 359,
     /* 142822 */     GIR_EraseRootFromParent_Done,
     /* 142823 */   // Label 2768: @142823
     /* 142823 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142859), // Rule ID 360 //
     /* 142828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142850 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 142853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142857 */     GIR_RootConstrainSelectedInstOperands,
     /* 142858 */     // GIR_Coverage, 360,
     /* 142858 */     GIR_EraseRootFromParent_Done,
     /* 142859 */   // Label 2769: @142859
     /* 142859 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142895), // Rule ID 361 //
     /* 142864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142886 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 142889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142893 */     GIR_RootConstrainSelectedInstOperands,
     /* 142894 */     // GIR_Coverage, 361,
     /* 142894 */     GIR_EraseRootFromParent_Done,
     /* 142895 */   // Label 2770: @142895
     /* 142895 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142931), // Rule ID 362 //
     /* 142900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142922 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 142925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142929 */     GIR_RootConstrainSelectedInstOperands,
     /* 142930 */     // GIR_Coverage, 362,
     /* 142930 */     GIR_EraseRootFromParent_Done,
     /* 142931 */   // Label 2771: @142931
     /* 142931 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142967), // Rule ID 363 //
     /* 142936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142958 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 142961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142965 */     GIR_RootConstrainSelectedInstOperands,
     /* 142966 */     // GIR_Coverage, 363,
     /* 142966 */     GIR_EraseRootFromParent_Done,
     /* 142967 */   // Label 2772: @142967
     /* 142967 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(143003), // Rule ID 364 //
     /* 142972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142994 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 142997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143001 */     GIR_RootConstrainSelectedInstOperands,
     /* 143002 */     // GIR_Coverage, 364,
     /* 143002 */     GIR_EraseRootFromParent_Done,
     /* 143003 */   // Label 2773: @143003
     /* 143003 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(143039), // Rule ID 365 //
     /* 143008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143030 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 143033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143037 */     GIR_RootConstrainSelectedInstOperands,
     /* 143038 */     // GIR_Coverage, 365,
     /* 143038 */     GIR_EraseRootFromParent_Done,
     /* 143039 */   // Label 2774: @143039
     /* 143039 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(143075), // Rule ID 366 //
     /* 143044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143066 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 143069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143073 */     GIR_RootConstrainSelectedInstOperands,
     /* 143074 */     // GIR_Coverage, 366,
     /* 143074 */     GIR_EraseRootFromParent_Done,
     /* 143075 */   // Label 2775: @143075
     /* 143075 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(143111), // Rule ID 367 //
     /* 143080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143102 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 143105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143109 */     GIR_RootConstrainSelectedInstOperands,
     /* 143110 */     // GIR_Coverage, 367,
     /* 143110 */     GIR_EraseRootFromParent_Done,
     /* 143111 */   // Label 2776: @143111
     /* 143111 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(143147), // Rule ID 368 //
     /* 143116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143138 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 143141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143145 */     GIR_RootConstrainSelectedInstOperands,
     /* 143146 */     // GIR_Coverage, 368,
     /* 143146 */     GIR_EraseRootFromParent_Done,
     /* 143147 */   // Label 2777: @143147
     /* 143147 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(143183), // Rule ID 369 //
     /* 143152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143174 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 143177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143181 */     GIR_RootConstrainSelectedInstOperands,
     /* 143182 */     // GIR_Coverage, 369,
     /* 143182 */     GIR_EraseRootFromParent_Done,
     /* 143183 */   // Label 2778: @143183
     /* 143183 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(143219), // Rule ID 370 //
     /* 143188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143210 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 143213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143217 */     GIR_RootConstrainSelectedInstOperands,
     /* 143218 */     // GIR_Coverage, 370,
     /* 143218 */     GIR_EraseRootFromParent_Done,
     /* 143219 */   // Label 2779: @143219
     /* 143219 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(143255), // Rule ID 371 //
     /* 143224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143246 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 143249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143253 */     GIR_RootConstrainSelectedInstOperands,
     /* 143254 */     // GIR_Coverage, 371,
     /* 143254 */     GIR_EraseRootFromParent_Done,
     /* 143255 */   // Label 2780: @143255
     /* 143255 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(143291), // Rule ID 372 //
     /* 143260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143282 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 143285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143289 */     GIR_RootConstrainSelectedInstOperands,
     /* 143290 */     // GIR_Coverage, 372,
     /* 143290 */     GIR_EraseRootFromParent_Done,
     /* 143291 */   // Label 2781: @143291
     /* 143291 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(143327), // Rule ID 373 //
     /* 143296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143318 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 143321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143325 */     GIR_RootConstrainSelectedInstOperands,
     /* 143326 */     // GIR_Coverage, 373,
     /* 143326 */     GIR_EraseRootFromParent_Done,
     /* 143327 */   // Label 2782: @143327
     /* 143327 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(143363), // Rule ID 374 //
     /* 143332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143354 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 143357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143361 */     GIR_RootConstrainSelectedInstOperands,
     /* 143362 */     // GIR_Coverage, 374,
     /* 143362 */     GIR_EraseRootFromParent_Done,
     /* 143363 */   // Label 2783: @143363
     /* 143363 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(143399), // Rule ID 375 //
     /* 143368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143390 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 143393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143397 */     GIR_RootConstrainSelectedInstOperands,
     /* 143398 */     // GIR_Coverage, 375,
     /* 143398 */     GIR_EraseRootFromParent_Done,
     /* 143399 */   // Label 2784: @143399
     /* 143399 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(143435), // Rule ID 376 //
     /* 143404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143426 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 143429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143433 */     GIR_RootConstrainSelectedInstOperands,
     /* 143434 */     // GIR_Coverage, 376,
     /* 143434 */     GIR_EraseRootFromParent_Done,
     /* 143435 */   // Label 2785: @143435
     /* 143435 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143471), // Rule ID 377 //
     /* 143440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143462 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 143465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143469 */     GIR_RootConstrainSelectedInstOperands,
     /* 143470 */     // GIR_Coverage, 377,
     /* 143470 */     GIR_EraseRootFromParent_Done,
     /* 143471 */   // Label 2786: @143471
     /* 143471 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143507), // Rule ID 378 //
     /* 143476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143498 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 143501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143505 */     GIR_RootConstrainSelectedInstOperands,
     /* 143506 */     // GIR_Coverage, 378,
     /* 143506 */     GIR_EraseRootFromParent_Done,
     /* 143507 */   // Label 2787: @143507
     /* 143507 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143543), // Rule ID 379 //
     /* 143512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143534 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 143537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143541 */     GIR_RootConstrainSelectedInstOperands,
     /* 143542 */     // GIR_Coverage, 379,
     /* 143542 */     GIR_EraseRootFromParent_Done,
     /* 143543 */   // Label 2788: @143543
     /* 143543 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143579), // Rule ID 380 //
     /* 143548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143570 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 143573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143577 */     GIR_RootConstrainSelectedInstOperands,
     /* 143578 */     // GIR_Coverage, 380,
     /* 143578 */     GIR_EraseRootFromParent_Done,
     /* 143579 */   // Label 2789: @143579
     /* 143579 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143615), // Rule ID 381 //
     /* 143584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143606 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 143609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143613 */     GIR_RootConstrainSelectedInstOperands,
     /* 143614 */     // GIR_Coverage, 381,
     /* 143614 */     GIR_EraseRootFromParent_Done,
     /* 143615 */   // Label 2790: @143615
     /* 143615 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143651), // Rule ID 382 //
     /* 143620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143642 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 143645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143649 */     GIR_RootConstrainSelectedInstOperands,
     /* 143650 */     // GIR_Coverage, 382,
     /* 143650 */     GIR_EraseRootFromParent_Done,
     /* 143651 */   // Label 2791: @143651
     /* 143651 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143687), // Rule ID 383 //
     /* 143656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143678 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 143681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143685 */     GIR_RootConstrainSelectedInstOperands,
     /* 143686 */     // GIR_Coverage, 383,
     /* 143686 */     GIR_EraseRootFromParent_Done,
     /* 143687 */   // Label 2792: @143687
     /* 143687 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143723), // Rule ID 384 //
     /* 143692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143714 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 143717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143721 */     GIR_RootConstrainSelectedInstOperands,
     /* 143722 */     // GIR_Coverage, 384,
     /* 143722 */     GIR_EraseRootFromParent_Done,
     /* 143723 */   // Label 2793: @143723
     /* 143723 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143759), // Rule ID 385 //
     /* 143728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143750 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 143753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143757 */     GIR_RootConstrainSelectedInstOperands,
     /* 143758 */     // GIR_Coverage, 385,
     /* 143758 */     GIR_EraseRootFromParent_Done,
     /* 143759 */   // Label 2794: @143759
     /* 143759 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143795), // Rule ID 386 //
     /* 143764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143786 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 143789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143793 */     GIR_RootConstrainSelectedInstOperands,
     /* 143794 */     // GIR_Coverage, 386,
     /* 143794 */     GIR_EraseRootFromParent_Done,
     /* 143795 */   // Label 2795: @143795
     /* 143795 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143831), // Rule ID 387 //
     /* 143800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143822 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 143825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143829 */     GIR_RootConstrainSelectedInstOperands,
     /* 143830 */     // GIR_Coverage, 387,
     /* 143830 */     GIR_EraseRootFromParent_Done,
     /* 143831 */   // Label 2796: @143831
     /* 143831 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143867), // Rule ID 388 //
     /* 143836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143858 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 143861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143865 */     GIR_RootConstrainSelectedInstOperands,
     /* 143866 */     // GIR_Coverage, 388,
     /* 143866 */     GIR_EraseRootFromParent_Done,
     /* 143867 */   // Label 2797: @143867
     /* 143867 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143903), // Rule ID 389 //
     /* 143872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143894 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 143897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143901 */     GIR_RootConstrainSelectedInstOperands,
     /* 143902 */     // GIR_Coverage, 389,
     /* 143902 */     GIR_EraseRootFromParent_Done,
     /* 143903 */   // Label 2798: @143903
     /* 143903 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143939), // Rule ID 390 //
     /* 143908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143930 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 143933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143937 */     GIR_RootConstrainSelectedInstOperands,
     /* 143938 */     // GIR_Coverage, 390,
     /* 143938 */     GIR_EraseRootFromParent_Done,
     /* 143939 */   // Label 2799: @143939
     /* 143939 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143975), // Rule ID 391 //
     /* 143944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143966 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 143969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143973 */     GIR_RootConstrainSelectedInstOperands,
     /* 143974 */     // GIR_Coverage, 391,
     /* 143974 */     GIR_EraseRootFromParent_Done,
     /* 143975 */   // Label 2800: @143975
     /* 143975 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(144011), // Rule ID 392 //
     /* 143980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144002 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 144002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 144005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144009 */     GIR_RootConstrainSelectedInstOperands,
     /* 144010 */     // GIR_Coverage, 392,
     /* 144010 */     GIR_EraseRootFromParent_Done,
     /* 144011 */   // Label 2801: @144011
     /* 144011 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(144047), // Rule ID 393 //
     /* 144016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 144019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144038 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 144038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 144041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144045 */     GIR_RootConstrainSelectedInstOperands,
     /* 144046 */     // GIR_Coverage, 393,
     /* 144046 */     GIR_EraseRootFromParent_Done,
     /* 144047 */   // Label 2802: @144047
     /* 144047 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(144083), // Rule ID 575 //
     /* 144052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 144060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144074 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 144077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144081 */     GIR_RootConstrainSelectedInstOperands,
     /* 144082 */     // GIR_Coverage, 575,
     /* 144082 */     GIR_EraseRootFromParent_Done,
     /* 144083 */   // Label 2803: @144083
     /* 144083 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(144119), // Rule ID 576 //
     /* 144088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 144096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144110 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 144113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144117 */     GIR_RootConstrainSelectedInstOperands,
     /* 144118 */     // GIR_Coverage, 576,
     /* 144118 */     GIR_EraseRootFromParent_Done,
     /* 144119 */   // Label 2804: @144119
     /* 144119 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(144155), // Rule ID 577 //
     /* 144124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 144132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144146 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 144149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144153 */     GIR_RootConstrainSelectedInstOperands,
     /* 144154 */     // GIR_Coverage, 577,
     /* 144154 */     GIR_EraseRootFromParent_Done,
     /* 144155 */   // Label 2805: @144155
     /* 144155 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(144191), // Rule ID 578 //
     /* 144160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 144168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144182 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 144185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144189 */     GIR_RootConstrainSelectedInstOperands,
     /* 144190 */     // GIR_Coverage, 578,
     /* 144190 */     GIR_EraseRootFromParent_Done,
     /* 144191 */   // Label 2806: @144191
     /* 144191 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(144227), // Rule ID 579 //
     /* 144196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 144204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144218 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 144221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144225 */     GIR_RootConstrainSelectedInstOperands,
     /* 144226 */     // GIR_Coverage, 579,
     /* 144226 */     GIR_EraseRootFromParent_Done,
     /* 144227 */   // Label 2807: @144227
     /* 144227 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(144263), // Rule ID 580 //
     /* 144232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 144240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144254 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 144257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144261 */     GIR_RootConstrainSelectedInstOperands,
     /* 144262 */     // GIR_Coverage, 580,
     /* 144262 */     GIR_EraseRootFromParent_Done,
     /* 144263 */   // Label 2808: @144263
     /* 144263 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(144299), // Rule ID 581 //
     /* 144268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 144276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144290 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 144293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144297 */     GIR_RootConstrainSelectedInstOperands,
     /* 144298 */     // GIR_Coverage, 581,
     /* 144298 */     GIR_EraseRootFromParent_Done,
     /* 144299 */   // Label 2809: @144299
     /* 144299 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(144335), // Rule ID 582 //
     /* 144304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 144312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144326 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 144329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144333 */     GIR_RootConstrainSelectedInstOperands,
     /* 144334 */     // GIR_Coverage, 582,
     /* 144334 */     GIR_EraseRootFromParent_Done,
     /* 144335 */   // Label 2810: @144335
     /* 144335 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(144371), // Rule ID 710 //
     /* 144340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144362 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 144365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144369 */     GIR_RootConstrainSelectedInstOperands,
     /* 144370 */     // GIR_Coverage, 710,
     /* 144370 */     GIR_EraseRootFromParent_Done,
     /* 144371 */   // Label 2811: @144371
     /* 144371 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(144407), // Rule ID 711 //
     /* 144376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144398 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 144401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144405 */     GIR_RootConstrainSelectedInstOperands,
     /* 144406 */     // GIR_Coverage, 711,
     /* 144406 */     GIR_EraseRootFromParent_Done,
     /* 144407 */   // Label 2812: @144407
     /* 144407 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(144443), // Rule ID 712 //
     /* 144412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144434 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 144437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144441 */     GIR_RootConstrainSelectedInstOperands,
     /* 144442 */     // GIR_Coverage, 712,
     /* 144442 */     GIR_EraseRootFromParent_Done,
     /* 144443 */   // Label 2813: @144443
     /* 144443 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144479), // Rule ID 713 //
     /* 144448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144470 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 144473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144477 */     GIR_RootConstrainSelectedInstOperands,
     /* 144478 */     // GIR_Coverage, 713,
     /* 144478 */     GIR_EraseRootFromParent_Done,
     /* 144479 */   // Label 2814: @144479
     /* 144479 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144515), // Rule ID 714 //
     /* 144484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144506 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 144509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144513 */     GIR_RootConstrainSelectedInstOperands,
     /* 144514 */     // GIR_Coverage, 714,
     /* 144514 */     GIR_EraseRootFromParent_Done,
     /* 144515 */   // Label 2815: @144515
     /* 144515 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144551), // Rule ID 715 //
     /* 144520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 144545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144549 */     GIR_RootConstrainSelectedInstOperands,
     /* 144550 */     // GIR_Coverage, 715,
     /* 144550 */     GIR_EraseRootFromParent_Done,
     /* 144551 */   // Label 2816: @144551
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144587), // Rule ID 796 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144578 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 144581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144585 */     GIR_RootConstrainSelectedInstOperands,
     /* 144586 */     // GIR_Coverage, 796,
     /* 144586 */     GIR_EraseRootFromParent_Done,
     /* 144587 */   // Label 2817: @144587
     /* 144587 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144623), // Rule ID 797 //
     /* 144592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144614 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 144617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144621 */     GIR_RootConstrainSelectedInstOperands,
     /* 144622 */     // GIR_Coverage, 797,
     /* 144622 */     GIR_EraseRootFromParent_Done,
     /* 144623 */   // Label 2818: @144623
     /* 144623 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144659), // Rule ID 798 //
     /* 144628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144650 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 144653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144657 */     GIR_RootConstrainSelectedInstOperands,
     /* 144658 */     // GIR_Coverage, 798,
     /* 144658 */     GIR_EraseRootFromParent_Done,
     /* 144659 */   // Label 2819: @144659
     /* 144659 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144695), // Rule ID 799 //
     /* 144664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 144689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144693 */     GIR_RootConstrainSelectedInstOperands,
     /* 144694 */     // GIR_Coverage, 799,
     /* 144694 */     GIR_EraseRootFromParent_Done,
     /* 144695 */   // Label 2820: @144695
     /* 144695 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144731), // Rule ID 800 //
     /* 144700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144722 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 144725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144729 */     GIR_RootConstrainSelectedInstOperands,
     /* 144730 */     // GIR_Coverage, 800,
     /* 144730 */     GIR_EraseRootFromParent_Done,
     /* 144731 */   // Label 2821: @144731
     /* 144731 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144767), // Rule ID 801 //
     /* 144736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144758 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 144761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144765 */     GIR_RootConstrainSelectedInstOperands,
     /* 144766 */     // GIR_Coverage, 801,
     /* 144766 */     GIR_EraseRootFromParent_Done,
     /* 144767 */   // Label 2822: @144767
     /* 144767 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144803), // Rule ID 802 //
     /* 144772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144794 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 144797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144801 */     GIR_RootConstrainSelectedInstOperands,
     /* 144802 */     // GIR_Coverage, 802,
     /* 144802 */     GIR_EraseRootFromParent_Done,
     /* 144803 */   // Label 2823: @144803
     /* 144803 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144839), // Rule ID 803 //
     /* 144808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144830 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 144833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144837 */     GIR_RootConstrainSelectedInstOperands,
     /* 144838 */     // GIR_Coverage, 803,
     /* 144838 */     GIR_EraseRootFromParent_Done,
     /* 144839 */   // Label 2824: @144839
     /* 144839 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144875), // Rule ID 804 //
     /* 144844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 144869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144873 */     GIR_RootConstrainSelectedInstOperands,
     /* 144874 */     // GIR_Coverage, 804,
     /* 144874 */     GIR_EraseRootFromParent_Done,
     /* 144875 */   // Label 2825: @144875
     /* 144875 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144911), // Rule ID 805 //
     /* 144880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144902 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 144905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144909 */     GIR_RootConstrainSelectedInstOperands,
     /* 144910 */     // GIR_Coverage, 805,
     /* 144910 */     GIR_EraseRootFromParent_Done,
     /* 144911 */   // Label 2826: @144911
     /* 144911 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144947), // Rule ID 806 //
     /* 144916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144938 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 144941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144945 */     GIR_RootConstrainSelectedInstOperands,
     /* 144946 */     // GIR_Coverage, 806,
     /* 144946 */     GIR_EraseRootFromParent_Done,
     /* 144947 */   // Label 2827: @144947
     /* 144947 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144983), // Rule ID 807 //
     /* 144952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144974 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 144977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144981 */     GIR_RootConstrainSelectedInstOperands,
     /* 144982 */     // GIR_Coverage, 807,
     /* 144982 */     GIR_EraseRootFromParent_Done,
     /* 144983 */   // Label 2828: @144983
     /* 144983 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(145019), // Rule ID 808 //
     /* 144988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145010 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 145013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145017 */     GIR_RootConstrainSelectedInstOperands,
     /* 145018 */     // GIR_Coverage, 808,
     /* 145018 */     GIR_EraseRootFromParent_Done,
     /* 145019 */   // Label 2829: @145019
     /* 145019 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(145055), // Rule ID 809 //
     /* 145024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 145032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145046 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 145049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145053 */     GIR_RootConstrainSelectedInstOperands,
     /* 145054 */     // GIR_Coverage, 809,
     /* 145054 */     GIR_EraseRootFromParent_Done,
     /* 145055 */   // Label 2830: @145055
     /* 145055 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(145091), // Rule ID 810 //
     /* 145060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 145068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145082 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 145085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145089 */     GIR_RootConstrainSelectedInstOperands,
     /* 145090 */     // GIR_Coverage, 810,
     /* 145090 */     GIR_EraseRootFromParent_Done,
     /* 145091 */   // Label 2831: @145091
     /* 145091 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(145127), // Rule ID 811 //
     /* 145096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145118 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 145121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145125 */     GIR_RootConstrainSelectedInstOperands,
     /* 145126 */     // GIR_Coverage, 811,
     /* 145126 */     GIR_EraseRootFromParent_Done,
     /* 145127 */   // Label 2832: @145127
     /* 145127 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(145163), // Rule ID 812 //
     /* 145132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 145157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145161 */     GIR_RootConstrainSelectedInstOperands,
     /* 145162 */     // GIR_Coverage, 812,
     /* 145162 */     GIR_EraseRootFromParent_Done,
     /* 145163 */   // Label 2833: @145163
     /* 145163 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(145199), // Rule ID 813 //
     /* 145168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145190 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 145193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145197 */     GIR_RootConstrainSelectedInstOperands,
     /* 145198 */     // GIR_Coverage, 813,
     /* 145198 */     GIR_EraseRootFromParent_Done,
     /* 145199 */   // Label 2834: @145199
     /* 145199 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(145235), // Rule ID 814 //
     /* 145204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 145229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145233 */     GIR_RootConstrainSelectedInstOperands,
     /* 145234 */     // GIR_Coverage, 814,
     /* 145234 */     GIR_EraseRootFromParent_Done,
     /* 145235 */   // Label 2835: @145235
     /* 145235 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(145271), // Rule ID 815 //
     /* 145240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145262 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 145265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145269 */     GIR_RootConstrainSelectedInstOperands,
     /* 145270 */     // GIR_Coverage, 815,
     /* 145270 */     GIR_EraseRootFromParent_Done,
     /* 145271 */   // Label 2836: @145271
     /* 145271 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(145307), // Rule ID 816 //
     /* 145276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145298 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 145301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145305 */     GIR_RootConstrainSelectedInstOperands,
     /* 145306 */     // GIR_Coverage, 816,
     /* 145306 */     GIR_EraseRootFromParent_Done,
     /* 145307 */   // Label 2837: @145307
     /* 145307 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(145343), // Rule ID 817 //
     /* 145312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145334 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 145337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145341 */     GIR_RootConstrainSelectedInstOperands,
     /* 145342 */     // GIR_Coverage, 817,
     /* 145342 */     GIR_EraseRootFromParent_Done,
     /* 145343 */   // Label 2838: @145343
     /* 145343 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(145379), // Rule ID 818 //
     /* 145348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145370 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 145373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145377 */     GIR_RootConstrainSelectedInstOperands,
     /* 145378 */     // GIR_Coverage, 818,
     /* 145378 */     GIR_EraseRootFromParent_Done,
     /* 145379 */   // Label 2839: @145379
     /* 145379 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(145415), // Rule ID 819 //
     /* 145384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 145409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145413 */     GIR_RootConstrainSelectedInstOperands,
     /* 145414 */     // GIR_Coverage, 819,
     /* 145414 */     GIR_EraseRootFromParent_Done,
     /* 145415 */   // Label 2840: @145415
     /* 145415 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145451), // Rule ID 820 //
     /* 145420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145442 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 145445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145449 */     GIR_RootConstrainSelectedInstOperands,
     /* 145450 */     // GIR_Coverage, 820,
     /* 145450 */     GIR_EraseRootFromParent_Done,
     /* 145451 */   // Label 2841: @145451
     /* 145451 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145487), // Rule ID 821 //
     /* 145456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145478 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 145481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145485 */     GIR_RootConstrainSelectedInstOperands,
     /* 145486 */     // GIR_Coverage, 821,
     /* 145486 */     GIR_EraseRootFromParent_Done,
     /* 145487 */   // Label 2842: @145487
     /* 145487 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145523), // Rule ID 822 //
     /* 145492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145514 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 145517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145521 */     GIR_RootConstrainSelectedInstOperands,
     /* 145522 */     // GIR_Coverage, 822,
     /* 145522 */     GIR_EraseRootFromParent_Done,
     /* 145523 */   // Label 2843: @145523
     /* 145523 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145559), // Rule ID 823 //
     /* 145528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145550 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 145553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145557 */     GIR_RootConstrainSelectedInstOperands,
     /* 145558 */     // GIR_Coverage, 823,
     /* 145558 */     GIR_EraseRootFromParent_Done,
     /* 145559 */   // Label 2844: @145559
     /* 145559 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145595), // Rule ID 824 //
     /* 145564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 145589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145593 */     GIR_RootConstrainSelectedInstOperands,
     /* 145594 */     // GIR_Coverage, 824,
     /* 145594 */     GIR_EraseRootFromParent_Done,
     /* 145595 */   // Label 2845: @145595
     /* 145595 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145631), // Rule ID 825 //
     /* 145600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145622 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 145625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145629 */     GIR_RootConstrainSelectedInstOperands,
     /* 145630 */     // GIR_Coverage, 825,
     /* 145630 */     GIR_EraseRootFromParent_Done,
     /* 145631 */   // Label 2846: @145631
     /* 145631 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145667), // Rule ID 826 //
     /* 145636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145658 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 145661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145665 */     GIR_RootConstrainSelectedInstOperands,
     /* 145666 */     // GIR_Coverage, 826,
     /* 145666 */     GIR_EraseRootFromParent_Done,
     /* 145667 */   // Label 2847: @145667
     /* 145667 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145703), // Rule ID 827 //
     /* 145672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145694 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 145697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145701 */     GIR_RootConstrainSelectedInstOperands,
     /* 145702 */     // GIR_Coverage, 827,
     /* 145702 */     GIR_EraseRootFromParent_Done,
     /* 145703 */   // Label 2848: @145703
     /* 145703 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145739), // Rule ID 828 //
     /* 145708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145730 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 145733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145737 */     GIR_RootConstrainSelectedInstOperands,
     /* 145738 */     // GIR_Coverage, 828,
     /* 145738 */     GIR_EraseRootFromParent_Done,
     /* 145739 */   // Label 2849: @145739
     /* 145739 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145775), // Rule ID 829 //
     /* 145744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145766 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 145769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145773 */     GIR_RootConstrainSelectedInstOperands,
     /* 145774 */     // GIR_Coverage, 829,
     /* 145774 */     GIR_EraseRootFromParent_Done,
     /* 145775 */   // Label 2850: @145775
     /* 145775 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145811), // Rule ID 830 //
     /* 145780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145802 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 145805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145809 */     GIR_RootConstrainSelectedInstOperands,
     /* 145810 */     // GIR_Coverage, 830,
     /* 145810 */     GIR_EraseRootFromParent_Done,
     /* 145811 */   // Label 2851: @145811
     /* 145811 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145847), // Rule ID 831 //
     /* 145816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145838 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 145841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145845 */     GIR_RootConstrainSelectedInstOperands,
     /* 145846 */     // GIR_Coverage, 831,
     /* 145846 */     GIR_EraseRootFromParent_Done,
     /* 145847 */   // Label 2852: @145847
     /* 145847 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145883), // Rule ID 832 //
     /* 145852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145874 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 145877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145881 */     GIR_RootConstrainSelectedInstOperands,
     /* 145882 */     // GIR_Coverage, 832,
     /* 145882 */     GIR_EraseRootFromParent_Done,
     /* 145883 */   // Label 2853: @145883
     /* 145883 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145919), // Rule ID 833 //
     /* 145888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145910 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 145913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145917 */     GIR_RootConstrainSelectedInstOperands,
     /* 145918 */     // GIR_Coverage, 833,
     /* 145918 */     GIR_EraseRootFromParent_Done,
     /* 145919 */   // Label 2854: @145919
     /* 145919 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145955), // Rule ID 834 //
     /* 145924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 145949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145953 */     GIR_RootConstrainSelectedInstOperands,
     /* 145954 */     // GIR_Coverage, 834,
     /* 145954 */     GIR_EraseRootFromParent_Done,
     /* 145955 */   // Label 2855: @145955
     /* 145955 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145991), // Rule ID 835 //
     /* 145960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145982 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 145985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145989 */     GIR_RootConstrainSelectedInstOperands,
     /* 145990 */     // GIR_Coverage, 835,
     /* 145990 */     GIR_EraseRootFromParent_Done,
     /* 145991 */   // Label 2856: @145991
     /* 145991 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(146027), // Rule ID 836 //
     /* 145996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 146004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146018 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 146018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 146021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146025 */     GIR_RootConstrainSelectedInstOperands,
     /* 146026 */     // GIR_Coverage, 836,
     /* 146026 */     GIR_EraseRootFromParent_Done,
     /* 146027 */   // Label 2857: @146027
     /* 146027 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(146063), // Rule ID 863 //
     /* 146032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146054 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 146057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146061 */     GIR_RootConstrainSelectedInstOperands,
     /* 146062 */     // GIR_Coverage, 863,
     /* 146062 */     GIR_EraseRootFromParent_Done,
     /* 146063 */   // Label 2858: @146063
     /* 146063 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(146099), // Rule ID 864 //
     /* 146068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146090 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 146093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146097 */     GIR_RootConstrainSelectedInstOperands,
     /* 146098 */     // GIR_Coverage, 864,
     /* 146098 */     GIR_EraseRootFromParent_Done,
     /* 146099 */   // Label 2859: @146099
     /* 146099 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(146135), // Rule ID 865 //
     /* 146104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146126 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 146129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146133 */     GIR_RootConstrainSelectedInstOperands,
     /* 146134 */     // GIR_Coverage, 865,
     /* 146134 */     GIR_EraseRootFromParent_Done,
     /* 146135 */   // Label 2860: @146135
     /* 146135 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(146171), // Rule ID 866 //
     /* 146140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146162 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 146165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146169 */     GIR_RootConstrainSelectedInstOperands,
     /* 146170 */     // GIR_Coverage, 866,
     /* 146170 */     GIR_EraseRootFromParent_Done,
     /* 146171 */   // Label 2861: @146171
     /* 146171 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(146207), // Rule ID 867 //
     /* 146176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146198 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 146201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146205 */     GIR_RootConstrainSelectedInstOperands,
     /* 146206 */     // GIR_Coverage, 867,
     /* 146206 */     GIR_EraseRootFromParent_Done,
     /* 146207 */   // Label 2862: @146207
     /* 146207 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(146243), // Rule ID 938 //
     /* 146212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146234 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146241 */     GIR_RootConstrainSelectedInstOperands,
     /* 146242 */     // GIR_Coverage, 938,
     /* 146242 */     GIR_EraseRootFromParent_Done,
     /* 146243 */   // Label 2863: @146243
     /* 146243 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(146279), // Rule ID 939 //
     /* 146248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146270 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 146273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146277 */     GIR_RootConstrainSelectedInstOperands,
     /* 146278 */     // GIR_Coverage, 939,
     /* 146278 */     GIR_EraseRootFromParent_Done,
     /* 146279 */   // Label 2864: @146279
     /* 146279 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(146315), // Rule ID 940 //
     /* 146284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146306 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 146309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146313 */     GIR_RootConstrainSelectedInstOperands,
     /* 146314 */     // GIR_Coverage, 940,
     /* 146314 */     GIR_EraseRootFromParent_Done,
     /* 146315 */   // Label 2865: @146315
     /* 146315 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(146351), // Rule ID 941 //
     /* 146320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146342 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 146345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146349 */     GIR_RootConstrainSelectedInstOperands,
     /* 146350 */     // GIR_Coverage, 941,
     /* 146350 */     GIR_EraseRootFromParent_Done,
     /* 146351 */   // Label 2866: @146351
     /* 146351 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(146387), // Rule ID 942 //
     /* 146356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146378 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 146381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146385 */     GIR_RootConstrainSelectedInstOperands,
     /* 146386 */     // GIR_Coverage, 942,
     /* 146386 */     GIR_EraseRootFromParent_Done,
     /* 146387 */   // Label 2867: @146387
     /* 146387 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(146423), // Rule ID 943 //
     /* 146392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146414 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 146417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146421 */     GIR_RootConstrainSelectedInstOperands,
     /* 146422 */     // GIR_Coverage, 943,
     /* 146422 */     GIR_EraseRootFromParent_Done,
     /* 146423 */   // Label 2868: @146423
     /* 146423 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146459), // Rule ID 944 //
     /* 146428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146450 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 146453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146457 */     GIR_RootConstrainSelectedInstOperands,
     /* 146458 */     // GIR_Coverage, 944,
     /* 146458 */     GIR_EraseRootFromParent_Done,
     /* 146459 */   // Label 2869: @146459
     /* 146459 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146495), // Rule ID 945 //
     /* 146464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146486 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 146489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146493 */     GIR_RootConstrainSelectedInstOperands,
     /* 146494 */     // GIR_Coverage, 945,
     /* 146494 */     GIR_EraseRootFromParent_Done,
     /* 146495 */   // Label 2870: @146495
     /* 146495 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146531), // Rule ID 946 //
     /* 146500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146522 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 146525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146529 */     GIR_RootConstrainSelectedInstOperands,
     /* 146530 */     // GIR_Coverage, 946,
     /* 146530 */     GIR_EraseRootFromParent_Done,
     /* 146531 */   // Label 2871: @146531
     /* 146531 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146567), // Rule ID 947 //
     /* 146536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146558 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 146561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146565 */     GIR_RootConstrainSelectedInstOperands,
     /* 146566 */     // GIR_Coverage, 947,
     /* 146566 */     GIR_EraseRootFromParent_Done,
     /* 146567 */   // Label 2872: @146567
     /* 146567 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146603), // Rule ID 948 //
     /* 146572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146594 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 146597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146601 */     GIR_RootConstrainSelectedInstOperands,
     /* 146602 */     // GIR_Coverage, 948,
     /* 146602 */     GIR_EraseRootFromParent_Done,
     /* 146603 */   // Label 2873: @146603
     /* 146603 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146639), // Rule ID 949 //
     /* 146608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146630 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 146633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146637 */     GIR_RootConstrainSelectedInstOperands,
     /* 146638 */     // GIR_Coverage, 949,
     /* 146638 */     GIR_EraseRootFromParent_Done,
     /* 146639 */   // Label 2874: @146639
     /* 146639 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146675), // Rule ID 950 //
     /* 146644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146666 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 146669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146673 */     GIR_RootConstrainSelectedInstOperands,
     /* 146674 */     // GIR_Coverage, 950,
     /* 146674 */     GIR_EraseRootFromParent_Done,
     /* 146675 */   // Label 2875: @146675
     /* 146675 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146711), // Rule ID 951 //
     /* 146680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146702 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 146705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146709 */     GIR_RootConstrainSelectedInstOperands,
     /* 146710 */     // GIR_Coverage, 951,
     /* 146710 */     GIR_EraseRootFromParent_Done,
     /* 146711 */   // Label 2876: @146711
     /* 146711 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146747), // Rule ID 952 //
     /* 146716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146738 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 146741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146745 */     GIR_RootConstrainSelectedInstOperands,
     /* 146746 */     // GIR_Coverage, 952,
     /* 146746 */     GIR_EraseRootFromParent_Done,
     /* 146747 */   // Label 2877: @146747
     /* 146747 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146783), // Rule ID 953 //
     /* 146752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146774 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 146777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146781 */     GIR_RootConstrainSelectedInstOperands,
     /* 146782 */     // GIR_Coverage, 953,
     /* 146782 */     GIR_EraseRootFromParent_Done,
     /* 146783 */   // Label 2878: @146783
     /* 146783 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146819), // Rule ID 954 //
     /* 146788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146810 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 146813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146817 */     GIR_RootConstrainSelectedInstOperands,
     /* 146818 */     // GIR_Coverage, 954,
     /* 146818 */     GIR_EraseRootFromParent_Done,
     /* 146819 */   // Label 2879: @146819
     /* 146819 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146855), // Rule ID 1001 //
     /* 146824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 146838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146846 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 146846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 146849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146853 */     GIR_RootConstrainSelectedInstOperands,
     /* 146854 */     // GIR_Coverage, 1001,
     /* 146854 */     GIR_EraseRootFromParent_Done,
     /* 146855 */   // Label 2880: @146855
     /* 146855 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146891), // Rule ID 1003 //
     /* 146860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 146882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 146885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146889 */     GIR_RootConstrainSelectedInstOperands,
     /* 146890 */     // GIR_Coverage, 1003,
     /* 146890 */     GIR_EraseRootFromParent_Done,
     /* 146891 */   // Label 2881: @146891
     /* 146891 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146927), // Rule ID 1005 //
     /* 146896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146918 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 146918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 146921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146925 */     GIR_RootConstrainSelectedInstOperands,
     /* 146926 */     // GIR_Coverage, 1005,
     /* 146926 */     GIR_EraseRootFromParent_Done,
     /* 146927 */   // Label 2882: @146927
     /* 146927 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146963), // Rule ID 1007 //
     /* 146932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146954 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 146954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 146957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146961 */     GIR_RootConstrainSelectedInstOperands,
     /* 146962 */     // GIR_Coverage, 1007,
     /* 146962 */     GIR_EraseRootFromParent_Done,
     /* 146963 */   // Label 2883: @146963
     /* 146963 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146999), // Rule ID 1009 //
     /* 146968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146990 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 146990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 146993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146997 */     GIR_RootConstrainSelectedInstOperands,
     /* 146998 */     // GIR_Coverage, 1009,
     /* 146998 */     GIR_EraseRootFromParent_Done,
     /* 146999 */   // Label 2884: @146999
     /* 146999 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(147035), // Rule ID 1011 //
     /* 147004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 147012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147026 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 147026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 147029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147033 */     GIR_RootConstrainSelectedInstOperands,
     /* 147034 */     // GIR_Coverage, 1011,
     /* 147034 */     GIR_EraseRootFromParent_Done,
     /* 147035 */   // Label 2885: @147035
     /* 147035 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(147071), // Rule ID 1022 //
     /* 147040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 147051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147062 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 147065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147069 */     GIR_RootConstrainSelectedInstOperands,
     /* 147070 */     // GIR_Coverage, 1022,
     /* 147070 */     GIR_EraseRootFromParent_Done,
     /* 147071 */   // Label 2886: @147071
     /* 147071 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(147107), // Rule ID 1023 //
     /* 147076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147098 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 147101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147105 */     GIR_RootConstrainSelectedInstOperands,
     /* 147106 */     // GIR_Coverage, 1023,
     /* 147106 */     GIR_EraseRootFromParent_Done,
     /* 147107 */   // Label 2887: @147107
     /* 147107 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(147143), // Rule ID 1024 //
     /* 147112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147134 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 147137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147141 */     GIR_RootConstrainSelectedInstOperands,
     /* 147142 */     // GIR_Coverage, 1024,
     /* 147142 */     GIR_EraseRootFromParent_Done,
     /* 147143 */   // Label 2888: @147143
     /* 147143 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(147179), // Rule ID 1025 //
     /* 147148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147170 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 147173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147177 */     GIR_RootConstrainSelectedInstOperands,
     /* 147178 */     // GIR_Coverage, 1025,
     /* 147178 */     GIR_EraseRootFromParent_Done,
     /* 147179 */   // Label 2889: @147179
     /* 147179 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(147215), // Rule ID 1026 //
     /* 147184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147206 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 147209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147213 */     GIR_RootConstrainSelectedInstOperands,
     /* 147214 */     // GIR_Coverage, 1026,
     /* 147214 */     GIR_EraseRootFromParent_Done,
     /* 147215 */   // Label 2890: @147215
     /* 147215 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(147251), // Rule ID 1027 //
     /* 147220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147242 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 147245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147249 */     GIR_RootConstrainSelectedInstOperands,
     /* 147250 */     // GIR_Coverage, 1027,
     /* 147250 */     GIR_EraseRootFromParent_Done,
     /* 147251 */   // Label 2891: @147251
     /* 147251 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(147287), // Rule ID 1028 //
     /* 147256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147278 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 147278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 147281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147285 */     GIR_RootConstrainSelectedInstOperands,
     /* 147286 */     // GIR_Coverage, 1028,
     /* 147286 */     GIR_EraseRootFromParent_Done,
     /* 147287 */   // Label 2892: @147287
     /* 147287 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(147323), // Rule ID 1029 //
     /* 147292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 147303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147314 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 147317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147321 */     GIR_RootConstrainSelectedInstOperands,
     /* 147322 */     // GIR_Coverage, 1029,
     /* 147322 */     GIR_EraseRootFromParent_Done,
     /* 147323 */   // Label 2893: @147323
     /* 147323 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(147359), // Rule ID 1030 //
     /* 147328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147350 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 147353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147357 */     GIR_RootConstrainSelectedInstOperands,
     /* 147358 */     // GIR_Coverage, 1030,
     /* 147358 */     GIR_EraseRootFromParent_Done,
     /* 147359 */   // Label 2894: @147359
     /* 147359 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(147395), // Rule ID 1031 //
     /* 147364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147386 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 147389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147393 */     GIR_RootConstrainSelectedInstOperands,
     /* 147394 */     // GIR_Coverage, 1031,
     /* 147394 */     GIR_EraseRootFromParent_Done,
     /* 147395 */   // Label 2895: @147395
     /* 147395 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(147431), // Rule ID 1032 //
     /* 147400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147422 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 147425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147429 */     GIR_RootConstrainSelectedInstOperands,
     /* 147430 */     // GIR_Coverage, 1032,
     /* 147430 */     GIR_EraseRootFromParent_Done,
     /* 147431 */   // Label 2896: @147431
     /* 147431 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147467), // Rule ID 1033 //
     /* 147436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147458 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 147461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147465 */     GIR_RootConstrainSelectedInstOperands,
     /* 147466 */     // GIR_Coverage, 1033,
     /* 147466 */     GIR_EraseRootFromParent_Done,
     /* 147467 */   // Label 2897: @147467
     /* 147467 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147503), // Rule ID 1034 //
     /* 147472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147494 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 147497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147501 */     GIR_RootConstrainSelectedInstOperands,
     /* 147502 */     // GIR_Coverage, 1034,
     /* 147502 */     GIR_EraseRootFromParent_Done,
     /* 147503 */   // Label 2898: @147503
     /* 147503 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147539), // Rule ID 1035 //
     /* 147508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147530 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 147530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 147533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147537 */     GIR_RootConstrainSelectedInstOperands,
     /* 147538 */     // GIR_Coverage, 1035,
     /* 147538 */     GIR_EraseRootFromParent_Done,
     /* 147539 */   // Label 2899: @147539
     /* 147539 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147575), // Rule ID 1062 //
     /* 147544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147566 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 147566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 147569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147573 */     GIR_RootConstrainSelectedInstOperands,
     /* 147574 */     // GIR_Coverage, 1062,
     /* 147574 */     GIR_EraseRootFromParent_Done,
     /* 147575 */   // Label 2900: @147575
     /* 147575 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147611), // Rule ID 1064 //
     /* 147580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147602 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 147602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 147605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147609 */     GIR_RootConstrainSelectedInstOperands,
     /* 147610 */     // GIR_Coverage, 1064,
     /* 147610 */     GIR_EraseRootFromParent_Done,
     /* 147611 */   // Label 2901: @147611
     /* 147611 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147647), // Rule ID 1066 //
     /* 147616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147638 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 147638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 147641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147645 */     GIR_RootConstrainSelectedInstOperands,
     /* 147646 */     // GIR_Coverage, 1066,
     /* 147646 */     GIR_EraseRootFromParent_Done,
     /* 147647 */   // Label 2902: @147647
     /* 147647 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147683), // Rule ID 1068 //
     /* 147652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147674 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 147674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 147677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147681 */     GIR_RootConstrainSelectedInstOperands,
     /* 147682 */     // GIR_Coverage, 1068,
     /* 147682 */     GIR_EraseRootFromParent_Done,
     /* 147683 */   // Label 2903: @147683
     /* 147683 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147719), // Rule ID 1070 //
     /* 147688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147710 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 147710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 147713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147717 */     GIR_RootConstrainSelectedInstOperands,
     /* 147718 */     // GIR_Coverage, 1070,
     /* 147718 */     GIR_EraseRootFromParent_Done,
     /* 147719 */   // Label 2904: @147719
     /* 147719 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147755), // Rule ID 1072 //
     /* 147724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147746 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 147746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 147749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147753 */     GIR_RootConstrainSelectedInstOperands,
     /* 147754 */     // GIR_Coverage, 1072,
     /* 147754 */     GIR_EraseRootFromParent_Done,
     /* 147755 */   // Label 2905: @147755
     /* 147755 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147791), // Rule ID 1086 //
     /* 147760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 147768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147782 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 147785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147789 */     GIR_RootConstrainSelectedInstOperands,
     /* 147790 */     // GIR_Coverage, 1086,
     /* 147790 */     GIR_EraseRootFromParent_Done,
     /* 147791 */   // Label 2906: @147791
     /* 147791 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147827), // Rule ID 1087 //
     /* 147796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 147804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147818 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 147821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147825 */     GIR_RootConstrainSelectedInstOperands,
     /* 147826 */     // GIR_Coverage, 1087,
     /* 147826 */     GIR_EraseRootFromParent_Done,
     /* 147827 */   // Label 2907: @147827
     /* 147827 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147863), // Rule ID 1088 //
     /* 147832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 147840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147854 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 147857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147861 */     GIR_RootConstrainSelectedInstOperands,
     /* 147862 */     // GIR_Coverage, 1088,
     /* 147862 */     GIR_EraseRootFromParent_Done,
     /* 147863 */   // Label 2908: @147863
     /* 147863 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147899), // Rule ID 1089 //
     /* 147868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 147876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147890 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 147893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147897 */     GIR_RootConstrainSelectedInstOperands,
     /* 147898 */     // GIR_Coverage, 1089,
     /* 147898 */     GIR_EraseRootFromParent_Done,
     /* 147899 */   // Label 2909: @147899
     /* 147899 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147935), // Rule ID 1653 //
     /* 147904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 147912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147926 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 147926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 147929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147933 */     GIR_RootConstrainSelectedInstOperands,
     /* 147934 */     // GIR_Coverage, 1653,
     /* 147934 */     GIR_EraseRootFromParent_Done,
     /* 147935 */   // Label 2910: @147935
     /* 147935 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147971), // Rule ID 1659 //
     /* 147940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147962 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 147962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 147965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147969 */     GIR_RootConstrainSelectedInstOperands,
     /* 147970 */     // GIR_Coverage, 1659,
     /* 147970 */     GIR_EraseRootFromParent_Done,
     /* 147971 */   // Label 2911: @147971
     /* 147971 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(148007), // Rule ID 1660 //
     /* 147976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147998 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 147998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 148001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148005 */     GIR_RootConstrainSelectedInstOperands,
     /* 148006 */     // GIR_Coverage, 1660,
     /* 148006 */     GIR_EraseRootFromParent_Done,
     /* 148007 */   // Label 2912: @148007
     /* 148007 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(148043), // Rule ID 1661 //
     /* 148012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 148020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148034 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 148034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 148037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148041 */     GIR_RootConstrainSelectedInstOperands,
     /* 148042 */     // GIR_Coverage, 1661,
     /* 148042 */     GIR_EraseRootFromParent_Done,
     /* 148043 */   // Label 2913: @148043
     /* 148043 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(148079), // Rule ID 1662 //
     /* 148048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 148056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148070 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 148070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 148073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148077 */     GIR_RootConstrainSelectedInstOperands,
     /* 148078 */     // GIR_Coverage, 1662,
     /* 148078 */     GIR_EraseRootFromParent_Done,
     /* 148079 */   // Label 2914: @148079
     /* 148079 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(148115), // Rule ID 1663 //
     /* 148084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 148092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148106 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 148109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148113 */     GIR_RootConstrainSelectedInstOperands,
     /* 148114 */     // GIR_Coverage, 1663,
     /* 148114 */     GIR_EraseRootFromParent_Done,
     /* 148115 */   // Label 2915: @148115
     /* 148115 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(148151), // Rule ID 1664 //
     /* 148120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 148128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148142 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 148145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148149 */     GIR_RootConstrainSelectedInstOperands,
     /* 148150 */     // GIR_Coverage, 1664,
     /* 148150 */     GIR_EraseRootFromParent_Done,
     /* 148151 */   // Label 2916: @148151
     /* 148151 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(148187), // Rule ID 1670 //
     /* 148156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 148164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148178 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 148181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148185 */     GIR_RootConstrainSelectedInstOperands,
     /* 148186 */     // GIR_Coverage, 1670,
     /* 148186 */     GIR_EraseRootFromParent_Done,
     /* 148187 */   // Label 2917: @148187
     /* 148187 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(148223), // Rule ID 1943 //
     /* 148192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148214 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 148217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148221 */     GIR_RootConstrainSelectedInstOperands,
     /* 148222 */     // GIR_Coverage, 1943,
     /* 148222 */     GIR_EraseRootFromParent_Done,
     /* 148223 */   // Label 2918: @148223
     /* 148223 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(148259), // Rule ID 1945 //
     /* 148228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148250 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 148253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148257 */     GIR_RootConstrainSelectedInstOperands,
     /* 148258 */     // GIR_Coverage, 1945,
     /* 148258 */     GIR_EraseRootFromParent_Done,
     /* 148259 */   // Label 2919: @148259
     /* 148259 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(148295), // Rule ID 1947 //
     /* 148264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148286 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 148289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148293 */     GIR_RootConstrainSelectedInstOperands,
     /* 148294 */     // GIR_Coverage, 1947,
     /* 148294 */     GIR_EraseRootFromParent_Done,
     /* 148295 */   // Label 2920: @148295
     /* 148295 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148331), // Rule ID 1949 //
     /* 148300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148322 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 148325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148329 */     GIR_RootConstrainSelectedInstOperands,
     /* 148330 */     // GIR_Coverage, 1949,
     /* 148330 */     GIR_EraseRootFromParent_Done,
     /* 148331 */   // Label 2921: @148331
     /* 148331 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148367), // Rule ID 1951 //
     /* 148336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148358 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 148361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148365 */     GIR_RootConstrainSelectedInstOperands,
     /* 148366 */     // GIR_Coverage, 1951,
     /* 148366 */     GIR_EraseRootFromParent_Done,
     /* 148367 */   // Label 2922: @148367
     /* 148367 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148403), // Rule ID 1953 //
     /* 148372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148394 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 148397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148401 */     GIR_RootConstrainSelectedInstOperands,
     /* 148402 */     // GIR_Coverage, 1953,
     /* 148402 */     GIR_EraseRootFromParent_Done,
     /* 148403 */   // Label 2923: @148403
     /* 148403 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148439), // Rule ID 1955 //
     /* 148408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148430 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 148433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148437 */     GIR_RootConstrainSelectedInstOperands,
     /* 148438 */     // GIR_Coverage, 1955,
     /* 148438 */     GIR_EraseRootFromParent_Done,
     /* 148439 */   // Label 2924: @148439
     /* 148439 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148475), // Rule ID 1957 //
     /* 148444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148466 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 148469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148473 */     GIR_RootConstrainSelectedInstOperands,
     /* 148474 */     // GIR_Coverage, 1957,
     /* 148474 */     GIR_EraseRootFromParent_Done,
     /* 148475 */   // Label 2925: @148475
     /* 148475 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148511), // Rule ID 1959 //
     /* 148480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148502 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 148505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148509 */     GIR_RootConstrainSelectedInstOperands,
     /* 148510 */     // GIR_Coverage, 1959,
     /* 148510 */     GIR_EraseRootFromParent_Done,
     /* 148511 */   // Label 2926: @148511
     /* 148511 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148547), // Rule ID 1961 //
     /* 148516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148538 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 148541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148545 */     GIR_RootConstrainSelectedInstOperands,
     /* 148546 */     // GIR_Coverage, 1961,
     /* 148546 */     GIR_EraseRootFromParent_Done,
     /* 148547 */   // Label 2927: @148547
     /* 148547 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148583), // Rule ID 1963 //
     /* 148552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148574 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 148577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148581 */     GIR_RootConstrainSelectedInstOperands,
     /* 148582 */     // GIR_Coverage, 1963,
     /* 148582 */     GIR_EraseRootFromParent_Done,
     /* 148583 */   // Label 2928: @148583
     /* 148583 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148619), // Rule ID 1965 //
     /* 148588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148610 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 148613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148617 */     GIR_RootConstrainSelectedInstOperands,
     /* 148618 */     // GIR_Coverage, 1965,
     /* 148618 */     GIR_EraseRootFromParent_Done,
     /* 148619 */   // Label 2929: @148619
     /* 148619 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148655), // Rule ID 2305 //
     /* 148624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 148627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 148632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 148635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148646 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 148649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148653 */     GIR_RootConstrainSelectedInstOperands,
     /* 148654 */     // GIR_Coverage, 2305,
     /* 148654 */     GIR_EraseRootFromParent_Done,
     /* 148655 */   // Label 2930: @148655
     /* 148655 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148691), // Rule ID 2306 //
     /* 148660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 148663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 148668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 148671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148682 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 148685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148689 */     GIR_RootConstrainSelectedInstOperands,
     /* 148690 */     // GIR_Coverage, 2306,
     /* 148690 */     GIR_EraseRootFromParent_Done,
     /* 148691 */   // Label 2931: @148691
     /* 148691 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148727), // Rule ID 2314 //
     /* 148696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 148699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 148704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148718 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 148718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 148721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148725 */     GIR_RootConstrainSelectedInstOperands,
     /* 148726 */     // GIR_Coverage, 2314,
     /* 148726 */     GIR_EraseRootFromParent_Done,
     /* 148727 */   // Label 2932: @148727
     /* 148727 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148763), // Rule ID 2515 //
     /* 148732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 148740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148754 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 148754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 148757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148761 */     GIR_RootConstrainSelectedInstOperands,
     /* 148762 */     // GIR_Coverage, 2515,
     /* 148762 */     GIR_EraseRootFromParent_Done,
     /* 148763 */   // Label 2933: @148763
     /* 148763 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148802), // Rule ID 3548 //
     /* 148768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 148779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 148782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 148790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 148793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148800 */     GIR_RootConstrainSelectedInstOperands,
     /* 148801 */     // GIR_Coverage, 3548,
     /* 148801 */     GIR_EraseRootFromParent_Done,
     /* 148802 */   // Label 2934: @148802
     /* 148802 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148841), // Rule ID 3549 //
     /* 148807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 148818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 148821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148829 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 148829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 148832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148839 */     GIR_RootConstrainSelectedInstOperands,
     /* 148840 */     // GIR_Coverage, 3549,
     /* 148840 */     GIR_EraseRootFromParent_Done,
     /* 148841 */   // Label 2935: @148841
     /* 148841 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148880), // Rule ID 3550 //
     /* 148846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 148857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 148860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 148868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 148871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148878 */     GIR_RootConstrainSelectedInstOperands,
     /* 148879 */     // GIR_Coverage, 3550,
     /* 148879 */     GIR_EraseRootFromParent_Done,
     /* 148880 */   // Label 2936: @148880
     /* 148880 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148919), // Rule ID 3551 //
     /* 148885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 148896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 148899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148907 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 148907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 148910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148917 */     GIR_RootConstrainSelectedInstOperands,
     /* 148918 */     // GIR_Coverage, 3551,
     /* 148918 */     GIR_EraseRootFromParent_Done,
     /* 148919 */   // Label 2937: @148919
     /* 148919 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148975), // Rule ID 3555 //
     /* 148924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 148932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 148935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 148938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1629:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 148946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 148949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 148963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 148973 */     GIR_RootConstrainSelectedInstOperands,
     /* 148974 */     // GIR_Coverage, 3555,
     /* 148974 */     GIR_EraseRootFromParent_Done,
     /* 148975 */   // Label 2938: @148975
     /* 148975 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(149031), // Rule ID 3556 //
     /* 148980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 148988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 148991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 148994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 149002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 149005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 149019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149029 */     GIR_RootConstrainSelectedInstOperands,
     /* 149030 */     // GIR_Coverage, 3556,
     /* 149030 */     GIR_EraseRootFromParent_Done,
     /* 149031 */   // Label 2939: @149031
     /* 149031 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(149087), // Rule ID 3557 //
     /* 149036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 149039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 149044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 149047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 149050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 149054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 149058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 149061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 149075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149085 */     GIR_RootConstrainSelectedInstOperands,
     /* 149086 */     // GIR_Coverage, 3557,
     /* 149086 */     GIR_EraseRootFromParent_Done,
     /* 149087 */   // Label 2940: @149087
     /* 149087 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(149143), // Rule ID 3558 //
     /* 149092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 149095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 149100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 149103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 149106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 149110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 149114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 149117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 149131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149141 */     GIR_RootConstrainSelectedInstOperands,
     /* 149142 */     // GIR_Coverage, 3558,
     /* 149142 */     GIR_EraseRootFromParent_Done,
     /* 149143 */   // Label 2941: @149143
     /* 149143 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(149176), // Rule ID 4009 //
     /* 149148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 149153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149167 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 149167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 149170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149174 */     GIR_RootConstrainSelectedInstOperands,
     /* 149175 */     // GIR_Coverage, 4009,
     /* 149175 */     GIR_EraseRootFromParent_Done,
     /* 149176 */   // Label 2942: @149176
     /* 149176 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(149241), // Rule ID 4010 //
     /* 149181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 149186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149200 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 149200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 149207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149223 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 149230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149240 */     // GIR_Coverage, 4010,
     /* 149240 */     GIR_EraseRootFromParent_Done,
     /* 149241 */   // Label 2943: @149241
     /* 149241 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(149274), // Rule ID 4780 //
     /* 149246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 149251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149265 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 149268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149272 */     GIR_RootConstrainSelectedInstOperands,
     /* 149273 */     // GIR_Coverage, 4780,
     /* 149273 */     GIR_EraseRootFromParent_Done,
     /* 149274 */   // Label 2944: @149274
     /* 149274 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(149307), // Rule ID 4781 //
     /* 149279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 149284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149298 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 149301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149305 */     GIR_RootConstrainSelectedInstOperands,
     /* 149306 */     // GIR_Coverage, 4781,
     /* 149306 */     GIR_EraseRootFromParent_Done,
     /* 149307 */   // Label 2945: @149307
     /* 149307 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149340), // Rule ID 4782 //
     /* 149312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 149317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149331 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 149334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149338 */     GIR_RootConstrainSelectedInstOperands,
     /* 149339 */     // GIR_Coverage, 4782,
     /* 149339 */     GIR_EraseRootFromParent_Done,
     /* 149340 */   // Label 2946: @149340
     /* 149340 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149373), // Rule ID 4783 //
     /* 149345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 149350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149364 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 149367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149371 */     GIR_RootConstrainSelectedInstOperands,
     /* 149372 */     // GIR_Coverage, 4783,
     /* 149372 */     GIR_EraseRootFromParent_Done,
     /* 149373 */   // Label 2947: @149373
     /* 149373 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149406), // Rule ID 4897 //
     /* 149378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 149383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 149386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149397 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 149397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 149400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149404 */     GIR_RootConstrainSelectedInstOperands,
     /* 149405 */     // GIR_Coverage, 4897,
     /* 149405 */     GIR_EraseRootFromParent_Done,
     /* 149406 */   // Label 2948: @149406
     /* 149406 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149439), // Rule ID 4907 //
     /* 149411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 149416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149430 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 149430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 149433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149437 */     GIR_RootConstrainSelectedInstOperands,
     /* 149438 */     // GIR_Coverage, 4907,
     /* 149438 */     GIR_EraseRootFromParent_Done,
     /* 149439 */   // Label 2949: @149439
     /* 149439 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149475), // Rule ID 5249 //
     /* 149444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 149452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149466 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 149466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 149469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149473 */     GIR_RootConstrainSelectedInstOperands,
     /* 149474 */     // GIR_Coverage, 5249,
     /* 149474 */     GIR_EraseRootFromParent_Done,
     /* 149475 */   // Label 2950: @149475
     /* 149475 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149508), // Rule ID 5252 //
     /* 149480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 149485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149499 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 149502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149506 */     GIR_RootConstrainSelectedInstOperands,
     /* 149507 */     // GIR_Coverage, 5252,
     /* 149507 */     GIR_EraseRootFromParent_Done,
     /* 149508 */   // Label 2951: @149508
     /* 149508 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149541), // Rule ID 5253 //
     /* 149513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 149518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149532 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 149535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149539 */     GIR_RootConstrainSelectedInstOperands,
     /* 149540 */     // GIR_Coverage, 5253,
     /* 149540 */     GIR_EraseRootFromParent_Done,
     /* 149541 */   // Label 2952: @149541
     /* 149541 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149574), // Rule ID 5254 //
     /* 149546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 149551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149565 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 149568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149572 */     GIR_RootConstrainSelectedInstOperands,
     /* 149573 */     // GIR_Coverage, 5254,
     /* 149573 */     GIR_EraseRootFromParent_Done,
     /* 149574 */   // Label 2953: @149574
     /* 149574 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149607), // Rule ID 5255 //
     /* 149579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 149584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149598 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 149601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149605 */     GIR_RootConstrainSelectedInstOperands,
     /* 149606 */     // GIR_Coverage, 5255,
     /* 149606 */     GIR_EraseRootFromParent_Done,
     /* 149607 */   // Label 2954: @149607
     /* 149607 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149640), // Rule ID 5256 //
     /* 149612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 149617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149631 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 149634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149638 */     GIR_RootConstrainSelectedInstOperands,
     /* 149639 */     // GIR_Coverage, 5256,
     /* 149639 */     GIR_EraseRootFromParent_Done,
     /* 149640 */   // Label 2955: @149640
     /* 149640 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149673), // Rule ID 5257 //
     /* 149645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 149650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149664 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 149667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149671 */     GIR_RootConstrainSelectedInstOperands,
     /* 149672 */     // GIR_Coverage, 5257,
     /* 149672 */     GIR_EraseRootFromParent_Done,
     /* 149673 */   // Label 2956: @149673
     /* 149673 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149706), // Rule ID 5258 //
     /* 149678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 149683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149697 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 149700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149704 */     GIR_RootConstrainSelectedInstOperands,
     /* 149705 */     // GIR_Coverage, 5258,
     /* 149705 */     GIR_EraseRootFromParent_Done,
     /* 149706 */   // Label 2957: @149706
     /* 149706 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149739), // Rule ID 5259 //
     /* 149711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 149716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149730 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 149733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149737 */     GIR_RootConstrainSelectedInstOperands,
     /* 149738 */     // GIR_Coverage, 5259,
     /* 149738 */     GIR_EraseRootFromParent_Done,
     /* 149739 */   // Label 2958: @149739
     /* 149739 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149772), // Rule ID 5260 //
     /* 149744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 149749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149763 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 149766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149770 */     GIR_RootConstrainSelectedInstOperands,
     /* 149771 */     // GIR_Coverage, 5260,
     /* 149771 */     GIR_EraseRootFromParent_Done,
     /* 149772 */   // Label 2959: @149772
     /* 149772 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149805), // Rule ID 5261 //
     /* 149777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 149782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149796 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 149799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149803 */     GIR_RootConstrainSelectedInstOperands,
     /* 149804 */     // GIR_Coverage, 5261,
     /* 149804 */     GIR_EraseRootFromParent_Done,
     /* 149805 */   // Label 2960: @149805
     /* 149805 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149838), // Rule ID 5262 //
     /* 149810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149829 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 149829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 149832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149836 */     GIR_RootConstrainSelectedInstOperands,
     /* 149837 */     // GIR_Coverage, 5262,
     /* 149837 */     GIR_EraseRootFromParent_Done,
     /* 149838 */   // Label 2961: @149838
     /* 149838 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(149871), // Rule ID 5263 //
     /* 149843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149862 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 149862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 149865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149869 */     GIR_RootConstrainSelectedInstOperands,
     /* 149870 */     // GIR_Coverage, 5263,
     /* 149870 */     GIR_EraseRootFromParent_Done,
     /* 149871 */   // Label 2962: @149871
     /* 149871 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(149904), // Rule ID 5264 //
     /* 149876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149895 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 149895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 149898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149902 */     GIR_RootConstrainSelectedInstOperands,
     /* 149903 */     // GIR_Coverage, 5264,
     /* 149903 */     GIR_EraseRootFromParent_Done,
     /* 149904 */   // Label 2963: @149904
     /* 149904 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(149937), // Rule ID 5265 //
     /* 149909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149928 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 149931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149935 */     GIR_RootConstrainSelectedInstOperands,
     /* 149936 */     // GIR_Coverage, 5265,
     /* 149936 */     GIR_EraseRootFromParent_Done,
     /* 149937 */   // Label 2964: @149937
     /* 149937 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(149970), // Rule ID 5277 //
     /* 149942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 149947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149961 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 149961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 149964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149968 */     GIR_RootConstrainSelectedInstOperands,
     /* 149969 */     // GIR_Coverage, 5277,
     /* 149969 */     GIR_EraseRootFromParent_Done,
     /* 149970 */   // Label 2965: @149970
     /* 149970 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150003), // Rule ID 5278 //
     /* 149975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 149980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149994 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 149994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 149997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150001 */     GIR_RootConstrainSelectedInstOperands,
     /* 150002 */     // GIR_Coverage, 5278,
     /* 150002 */     GIR_EraseRootFromParent_Done,
     /* 150003 */   // Label 2966: @150003
     /* 150003 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150036), // Rule ID 5279 //
     /* 150008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 150013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150027 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 150027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 150030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150034 */     GIR_RootConstrainSelectedInstOperands,
     /* 150035 */     // GIR_Coverage, 5279,
     /* 150035 */     GIR_EraseRootFromParent_Done,
     /* 150036 */   // Label 2967: @150036
     /* 150036 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150069), // Rule ID 5280 //
     /* 150041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150060 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 150060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 150063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150067 */     GIR_RootConstrainSelectedInstOperands,
     /* 150068 */     // GIR_Coverage, 5280,
     /* 150068 */     GIR_EraseRootFromParent_Done,
     /* 150069 */   // Label 2968: @150069
     /* 150069 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150102), // Rule ID 5281 //
     /* 150074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150093 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 150093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 150096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150100 */     GIR_RootConstrainSelectedInstOperands,
     /* 150101 */     // GIR_Coverage, 5281,
     /* 150101 */     GIR_EraseRootFromParent_Done,
     /* 150102 */   // Label 2969: @150102
     /* 150102 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150135), // Rule ID 5282 //
     /* 150107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150126 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 150126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 150129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150133 */     GIR_RootConstrainSelectedInstOperands,
     /* 150134 */     // GIR_Coverage, 5282,
     /* 150134 */     GIR_EraseRootFromParent_Done,
     /* 150135 */   // Label 2970: @150135
     /* 150135 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150168), // Rule ID 5283 //
     /* 150140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150159 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 150159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 150162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150166 */     GIR_RootConstrainSelectedInstOperands,
     /* 150167 */     // GIR_Coverage, 5283,
     /* 150167 */     GIR_EraseRootFromParent_Done,
     /* 150168 */   // Label 2971: @150168
     /* 150168 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150201), // Rule ID 5613 //
     /* 150173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150192 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 150195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150199 */     GIR_RootConstrainSelectedInstOperands,
     /* 150200 */     // GIR_Coverage, 5613,
     /* 150200 */     GIR_EraseRootFromParent_Done,
     /* 150201 */   // Label 2972: @150201
     /* 150201 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150286), // Rule ID 5614 //
     /* 150206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150225 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 150225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 150228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 150232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150237 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150241 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150259 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 150266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 150279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150284 */     GIR_RootConstrainSelectedInstOperands,
     /* 150285 */     // GIR_Coverage, 5614,
     /* 150285 */     GIR_EraseRootFromParent_Done,
     /* 150286 */   // Label 2973: @150286
     /* 150286 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150319), // Rule ID 5615 //
     /* 150291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150310 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 150313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150317 */     GIR_RootConstrainSelectedInstOperands,
     /* 150318 */     // GIR_Coverage, 5615,
     /* 150318 */     GIR_EraseRootFromParent_Done,
     /* 150319 */   // Label 2974: @150319
     /* 150319 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150352), // Rule ID 5617 //
     /* 150324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 150329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150343 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 150346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150350 */     GIR_RootConstrainSelectedInstOperands,
     /* 150351 */     // GIR_Coverage, 5617,
     /* 150351 */     GIR_EraseRootFromParent_Done,
     /* 150352 */   // Label 2975: @150352
     /* 150352 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150385), // Rule ID 5619 //
     /* 150357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 150362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150376 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 150379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150383 */     GIR_RootConstrainSelectedInstOperands,
     /* 150384 */     // GIR_Coverage, 5619,
     /* 150384 */     GIR_EraseRootFromParent_Done,
     /* 150385 */   // Label 2976: @150385
     /* 150385 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150418), // Rule ID 5621 //
     /* 150390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 150395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150409 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 150412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150416 */     GIR_RootConstrainSelectedInstOperands,
     /* 150417 */     // GIR_Coverage, 5621,
     /* 150417 */     GIR_EraseRootFromParent_Done,
     /* 150418 */   // Label 2977: @150418
     /* 150418 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150451), // Rule ID 5623 //
     /* 150423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 150428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150442 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 150445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150449 */     GIR_RootConstrainSelectedInstOperands,
     /* 150450 */     // GIR_Coverage, 5623,
     /* 150450 */     GIR_EraseRootFromParent_Done,
     /* 150451 */   // Label 2978: @150451
     /* 150451 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150484), // Rule ID 5625 //
     /* 150456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 150461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150475 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 150478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150482 */     GIR_RootConstrainSelectedInstOperands,
     /* 150483 */     // GIR_Coverage, 5625,
     /* 150483 */     GIR_EraseRootFromParent_Done,
     /* 150484 */   // Label 2979: @150484
     /* 150484 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(150517), // Rule ID 5627 //
     /* 150489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 150494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150508 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 150511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150515 */     GIR_RootConstrainSelectedInstOperands,
     /* 150516 */     // GIR_Coverage, 5627,
     /* 150516 */     GIR_EraseRootFromParent_Done,
     /* 150517 */   // Label 2980: @150517
     /* 150517 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(150550), // Rule ID 5629 //
     /* 150522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 150527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150541 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 150544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150548 */     GIR_RootConstrainSelectedInstOperands,
     /* 150549 */     // GIR_Coverage, 5629,
     /* 150549 */     GIR_EraseRootFromParent_Done,
     /* 150550 */   // Label 2981: @150550
     /* 150550 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(150583), // Rule ID 5631 //
     /* 150555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 150560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150574 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 150577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150581 */     GIR_RootConstrainSelectedInstOperands,
     /* 150582 */     // GIR_Coverage, 5631,
     /* 150582 */     GIR_EraseRootFromParent_Done,
     /* 150583 */   // Label 2982: @150583
     /* 150583 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(150616), // Rule ID 13148 //
     /* 150588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150607 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 150610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150614 */     GIR_RootConstrainSelectedInstOperands,
     /* 150615 */     // GIR_Coverage, 13148,
     /* 150615 */     GIR_EraseRootFromParent_Done,
     /* 150616 */   // Label 2983: @150616
     /* 150616 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(150649), // Rule ID 13150 //
     /* 150621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150640 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 150643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150647 */     GIR_RootConstrainSelectedInstOperands,
     /* 150648 */     // GIR_Coverage, 13150,
     /* 150648 */     GIR_EraseRootFromParent_Done,
     /* 150649 */   // Label 2984: @150649
     /* 150649 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(150682), // Rule ID 13152 //
     /* 150654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150673 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 150676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150680 */     GIR_RootConstrainSelectedInstOperands,
     /* 150681 */     // GIR_Coverage, 13152,
     /* 150681 */     GIR_EraseRootFromParent_Done,
     /* 150682 */   // Label 2985: @150682
     /* 150682 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(150715), // Rule ID 13154 //
     /* 150687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150706 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 150709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150713 */     GIR_RootConstrainSelectedInstOperands,
     /* 150714 */     // GIR_Coverage, 13154,
     /* 150714 */     GIR_EraseRootFromParent_Done,
     /* 150715 */   // Label 2986: @150715
     /* 150715 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(150830), // Rule ID 13155 //
     /* 150720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150739 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150739 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150742 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 150746 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150751 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150757 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150760 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150764 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150786 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150812 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150829 */     // GIR_Coverage, 13155,
     /* 150829 */     GIR_EraseRootFromParent_Done,
     /* 150830 */   // Label 2987: @150830
     /* 150830 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(150863), // Rule ID 13157 //
     /* 150835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150854 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 150857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150861 */     GIR_RootConstrainSelectedInstOperands,
     /* 150862 */     // GIR_Coverage, 13157,
     /* 150862 */     GIR_EraseRootFromParent_Done,
     /* 150863 */   // Label 2988: @150863
     /* 150863 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(150896), // Rule ID 13159 //
     /* 150868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150887 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 150890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150894 */     GIR_RootConstrainSelectedInstOperands,
     /* 150895 */     // GIR_Coverage, 13159,
     /* 150895 */     GIR_EraseRootFromParent_Done,
     /* 150896 */   // Label 2989: @150896
     /* 150896 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(150929), // Rule ID 13161 //
     /* 150901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150920 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 150923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150927 */     GIR_RootConstrainSelectedInstOperands,
     /* 150928 */     // GIR_Coverage, 13161,
     /* 150928 */     GIR_EraseRootFromParent_Done,
     /* 150929 */   // Label 2990: @150929
     /* 150929 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(150962), // Rule ID 13163 //
     /* 150934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150953 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 150956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150960 */     GIR_RootConstrainSelectedInstOperands,
     /* 150961 */     // GIR_Coverage, 13163,
     /* 150961 */     GIR_EraseRootFromParent_Done,
     /* 150962 */   // Label 2991: @150962
     /* 150962 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151077), // Rule ID 13164 //
     /* 150967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150986 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 150993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150998 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151033 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 151039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151076 */     // GIR_Coverage, 13164,
     /* 151076 */     GIR_EraseRootFromParent_Done,
     /* 151077 */   // Label 2992: @151077
     /* 151077 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151196), // Rule ID 13165 //
     /* 151082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 151087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151101 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151101 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151104 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 151108 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151113 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151117 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151178 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151195 */     // GIR_Coverage, 13165,
     /* 151195 */     GIR_EraseRootFromParent_Done,
     /* 151196 */   // Label 2993: @151196
     /* 151196 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151311), // Rule ID 13166 //
     /* 151201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 151206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151220 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 151220 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151223 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 151227 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151232 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 151241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 151255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151267 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151293 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151310 */     // GIR_Coverage, 13166,
     /* 151310 */     GIR_EraseRootFromParent_Done,
     /* 151311 */   // Label 2994: @151311
     /* 151311 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151430), // Rule ID 13167 //
     /* 151316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 151321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151335 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 151342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151347 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151351 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151429 */     // GIR_Coverage, 13167,
     /* 151429 */     GIR_EraseRootFromParent_Done,
     /* 151430 */   // Label 2995: @151430
     /* 151430 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151545), // Rule ID 13168 //
     /* 151435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 151440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151454 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 151454 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151457 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 151461 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151466 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 151475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 151489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151498 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151544 */     // GIR_Coverage, 13168,
     /* 151544 */     GIR_EraseRootFromParent_Done,
     /* 151545 */   // Label 2996: @151545
     /* 151545 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151578), // Rule ID 13170 //
     /* 151550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151569 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 151569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 151572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151576 */     GIR_RootConstrainSelectedInstOperands,
     /* 151577 */     // GIR_Coverage, 13170,
     /* 151577 */     GIR_EraseRootFromParent_Done,
     /* 151578 */   // Label 2997: @151578
     /* 151578 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151611), // Rule ID 13172 //
     /* 151583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 151594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151602 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 151602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 151605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151609 */     GIR_RootConstrainSelectedInstOperands,
     /* 151610 */     // GIR_Coverage, 13172,
     /* 151610 */     GIR_EraseRootFromParent_Done,
     /* 151611 */   // Label 2998: @151611
     /* 151611 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151644), // Rule ID 13174 //
     /* 151616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151635 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 151635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 151638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151642 */     GIR_RootConstrainSelectedInstOperands,
     /* 151643 */     // GIR_Coverage, 13174,
     /* 151643 */     GIR_EraseRootFromParent_Done,
     /* 151644 */   // Label 2999: @151644
     /* 151644 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151677), // Rule ID 13176 //
     /* 151649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151668 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 151668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 151671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151675 */     GIR_RootConstrainSelectedInstOperands,
     /* 151676 */     // GIR_Coverage, 13176,
     /* 151676 */     GIR_EraseRootFromParent_Done,
     /* 151677 */   // Label 3000: @151677
     /* 151677 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151792), // Rule ID 13177 //
     /* 151682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151701 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 151704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 151708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151713 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 151754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151774 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151791 */     // GIR_Coverage, 13177,
     /* 151791 */     GIR_EraseRootFromParent_Done,
     /* 151792 */   // Label 3001: @151792
     /* 151792 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151911), // Rule ID 13178 //
     /* 151797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151816 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151816 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151819 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 151823 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151828 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151832 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151910 */     // GIR_Coverage, 13178,
     /* 151910 */     GIR_EraseRootFromParent_Done,
     /* 151911 */   // Label 3002: @151911
     /* 151911 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151944), // Rule ID 13180 //
     /* 151916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151935 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 151935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 151938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151942 */     GIR_RootConstrainSelectedInstOperands,
     /* 151943 */     // GIR_Coverage, 13180,
     /* 151943 */     GIR_EraseRootFromParent_Done,
     /* 151944 */   // Label 3003: @151944
     /* 151944 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151977), // Rule ID 13182 //
     /* 151949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 151960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151968 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 151968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 151971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151975 */     GIR_RootConstrainSelectedInstOperands,
     /* 151976 */     // GIR_Coverage, 13182,
     /* 151976 */     GIR_EraseRootFromParent_Done,
     /* 151977 */   // Label 3004: @151977
     /* 151977 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(152010), // Rule ID 13184 //
     /* 151982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152001 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 152001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 152004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152008 */     GIR_RootConstrainSelectedInstOperands,
     /* 152009 */     // GIR_Coverage, 13184,
     /* 152009 */     GIR_EraseRootFromParent_Done,
     /* 152010 */   // Label 3005: @152010
     /* 152010 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(152043), // Rule ID 13186 //
     /* 152015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152034 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 152037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152041 */     GIR_RootConstrainSelectedInstOperands,
     /* 152042 */     // GIR_Coverage, 13186,
     /* 152042 */     GIR_EraseRootFromParent_Done,
     /* 152043 */   // Label 3006: @152043
     /* 152043 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(152158), // Rule ID 13187 //
     /* 152048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152067 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152067 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152070 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 152074 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152079 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152140 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152157 */     // GIR_Coverage, 13187,
     /* 152157 */     GIR_EraseRootFromParent_Done,
     /* 152158 */   // Label 3007: @152158
     /* 152158 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(152277), // Rule ID 13188 //
     /* 152163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152182 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152182 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152185 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 152189 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152194 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152198 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152204 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152207 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152211 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152259 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152276 */     // GIR_Coverage, 13188,
     /* 152276 */     GIR_EraseRootFromParent_Done,
     /* 152277 */   // Label 3008: @152277
     /* 152277 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(152310), // Rule ID 13190 //
     /* 152282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 152293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152301 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 152301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 152304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152308 */     GIR_RootConstrainSelectedInstOperands,
     /* 152309 */     // GIR_Coverage, 13190,
     /* 152309 */     GIR_EraseRootFromParent_Done,
     /* 152310 */   // Label 3009: @152310
     /* 152310 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152343), // Rule ID 13192 //
     /* 152315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152334 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 152334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 152337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152341 */     GIR_RootConstrainSelectedInstOperands,
     /* 152342 */     // GIR_Coverage, 13192,
     /* 152342 */     GIR_EraseRootFromParent_Done,
     /* 152343 */   // Label 3010: @152343
     /* 152343 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152376), // Rule ID 13194 //
     /* 152348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152367 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 152367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 152370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152374 */     GIR_RootConstrainSelectedInstOperands,
     /* 152375 */     // GIR_Coverage, 13194,
     /* 152375 */     GIR_EraseRootFromParent_Done,
     /* 152376 */   // Label 3011: @152376
     /* 152376 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(152409), // Rule ID 13196 //
     /* 152381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152400 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 152403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152407 */     GIR_RootConstrainSelectedInstOperands,
     /* 152408 */     // GIR_Coverage, 13196,
     /* 152408 */     GIR_EraseRootFromParent_Done,
     /* 152409 */   // Label 3012: @152409
     /* 152409 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152524), // Rule ID 13197 //
     /* 152414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152433 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152433 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152436 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 152440 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152445 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152480 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152506 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152523 */     // GIR_Coverage, 13197,
     /* 152523 */     GIR_EraseRootFromParent_Done,
     /* 152524 */   // Label 3013: @152524
     /* 152524 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152643), // Rule ID 13198 //
     /* 152529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152548 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 152555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152560 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152564 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152642 */     // GIR_Coverage, 13198,
     /* 152642 */     GIR_EraseRootFromParent_Done,
     /* 152643 */   // Label 3014: @152643
     /* 152643 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152676), // Rule ID 13200 //
     /* 152648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 152659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152667 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 152667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 152670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152674 */     GIR_RootConstrainSelectedInstOperands,
     /* 152675 */     // GIR_Coverage, 13200,
     /* 152675 */     GIR_EraseRootFromParent_Done,
     /* 152676 */   // Label 3015: @152676
     /* 152676 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152709), // Rule ID 13202 //
     /* 152681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152700 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 152700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 152703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152707 */     GIR_RootConstrainSelectedInstOperands,
     /* 152708 */     // GIR_Coverage, 13202,
     /* 152708 */     GIR_EraseRootFromParent_Done,
     /* 152709 */   // Label 3016: @152709
     /* 152709 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152742), // Rule ID 13204 //
     /* 152714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152733 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 152733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 152736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152740 */     GIR_RootConstrainSelectedInstOperands,
     /* 152741 */     // GIR_Coverage, 13204,
     /* 152741 */     GIR_EraseRootFromParent_Done,
     /* 152742 */   // Label 3017: @152742
     /* 152742 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152775), // Rule ID 13206 //
     /* 152747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152766 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 152769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152773 */     GIR_RootConstrainSelectedInstOperands,
     /* 152774 */     // GIR_Coverage, 13206,
     /* 152774 */     GIR_EraseRootFromParent_Done,
     /* 152775 */   // Label 3018: @152775
     /* 152775 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152890), // Rule ID 13207 //
     /* 152780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152799 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 152806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152817 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152820 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152824 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152872 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152889 */     // GIR_Coverage, 13207,
     /* 152889 */     GIR_EraseRootFromParent_Done,
     /* 152890 */   // Label 3019: @152890
     /* 152890 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(153009), // Rule ID 13208 //
     /* 152895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152914 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152914 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152917 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 152921 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152926 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152930 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153008 */     // GIR_Coverage, 13208,
     /* 153008 */     GIR_EraseRootFromParent_Done,
     /* 153009 */   // Label 3020: @153009
     /* 153009 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(153041), // Rule ID 2393 //
     /* 153014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 153022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 153035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153039 */     GIR_RootConstrainSelectedInstOperands,
     /* 153040 */     // GIR_Coverage, 2393,
     /* 153040 */     GIR_EraseRootFromParent_Done,
     /* 153041 */   // Label 3021: @153041
     /* 153041 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153073), // Rule ID 2394 //
     /* 153046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 153054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153064 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 153067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153071 */     GIR_RootConstrainSelectedInstOperands,
     /* 153072 */     // GIR_Coverage, 2394,
     /* 153072 */     GIR_EraseRootFromParent_Done,
     /* 153073 */   // Label 3022: @153073
     /* 153073 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153105), // Rule ID 2395 //
     /* 153078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 153086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 153099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153103 */     GIR_RootConstrainSelectedInstOperands,
     /* 153104 */     // GIR_Coverage, 2395,
     /* 153104 */     GIR_EraseRootFromParent_Done,
     /* 153105 */   // Label 3023: @153105
     /* 153105 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153137), // Rule ID 3093 //
     /* 153110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 153121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 153124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 153128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 153131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153135 */     GIR_RootConstrainSelectedInstOperands,
     /* 153136 */     // GIR_Coverage, 3093,
     /* 153136 */     GIR_EraseRootFromParent_Done,
     /* 153137 */   // Label 3024: @153137
     /* 153137 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153169), // Rule ID 3094 //
     /* 153142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 153153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 153156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 153160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 153163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153167 */     GIR_RootConstrainSelectedInstOperands,
     /* 153168 */     // GIR_Coverage, 3094,
     /* 153168 */     GIR_EraseRootFromParent_Done,
     /* 153169 */   // Label 3025: @153169
     /* 153169 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153201), // Rule ID 3095 //
     /* 153174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 153185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 153188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 153192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 153195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153199 */     GIR_RootConstrainSelectedInstOperands,
     /* 153200 */     // GIR_Coverage, 3095,
     /* 153200 */     GIR_EraseRootFromParent_Done,
     /* 153201 */   // Label 3026: @153201
     /* 153201 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153233), // Rule ID 3349 //
     /* 153206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 153217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 153224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153231 */     GIR_RootConstrainSelectedInstOperands,
     /* 153232 */     // GIR_Coverage, 3349,
     /* 153232 */     GIR_EraseRootFromParent_Done,
     /* 153233 */   // Label 3027: @153233
     /* 153233 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153265), // Rule ID 3350 //
     /* 153238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 153249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 153252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 153256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153263 */     GIR_RootConstrainSelectedInstOperands,
     /* 153264 */     // GIR_Coverage, 3350,
     /* 153264 */     GIR_EraseRootFromParent_Done,
     /* 153265 */   // Label 3028: @153265
     /* 153265 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153297), // Rule ID 3351 //
     /* 153270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 153281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 153284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 153288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153295 */     GIR_RootConstrainSelectedInstOperands,
     /* 153296 */     // GIR_Coverage, 3351,
     /* 153296 */     GIR_EraseRootFromParent_Done,
     /* 153297 */   // Label 3029: @153297
     /* 153297 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153329), // Rule ID 3430 //
     /* 153302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 153313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 153316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 153320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 153323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153327 */     GIR_RootConstrainSelectedInstOperands,
     /* 153328 */     // GIR_Coverage, 3430,
     /* 153328 */     GIR_EraseRootFromParent_Done,
     /* 153329 */   // Label 3030: @153329
     /* 153329 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(153361), // Rule ID 3431 //
     /* 153334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 153345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 153348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153352 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 153352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 153355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153359 */     GIR_RootConstrainSelectedInstOperands,
     /* 153360 */     // GIR_Coverage, 3431,
     /* 153360 */     GIR_EraseRootFromParent_Done,
     /* 153361 */   // Label 3031: @153361
     /* 153361 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(153393), // Rule ID 3432 //
     /* 153366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 153377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 153380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 153384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 153387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153391 */     GIR_RootConstrainSelectedInstOperands,
     /* 153392 */     // GIR_Coverage, 3432,
     /* 153392 */     GIR_EraseRootFromParent_Done,
     /* 153393 */   // Label 3032: @153393
     /* 153393 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(153425), // Rule ID 3458 //
     /* 153398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 153401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 153406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 153409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 153412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 153416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 153419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 153421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153423 */     GIR_RootConstrainSelectedInstOperands,
     /* 153424 */     // GIR_Coverage, 3458,
     /* 153424 */     GIR_EraseRootFromParent_Done,
     /* 153425 */   // Label 3033: @153425
     /* 153425 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(153457), // Rule ID 4625 //
     /* 153430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153448 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 153448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 153451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153455 */     GIR_RootConstrainSelectedInstOperands,
     /* 153456 */     // GIR_Coverage, 4625,
     /* 153456 */     GIR_EraseRootFromParent_Done,
     /* 153457 */   // Label 3034: @153457
     /* 153457 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(153489), // Rule ID 4626 //
     /* 153462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153480 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 153480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 153483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153487 */     GIR_RootConstrainSelectedInstOperands,
     /* 153488 */     // GIR_Coverage, 4626,
     /* 153488 */     GIR_EraseRootFromParent_Done,
     /* 153489 */   // Label 3035: @153489
     /* 153489 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(153518), // Rule ID 4627 //
     /* 153494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153509 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 153509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 153512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153516 */     GIR_RootConstrainSelectedInstOperands,
     /* 153517 */     // GIR_Coverage, 4627,
     /* 153517 */     GIR_EraseRootFromParent_Done,
     /* 153518 */   // Label 3036: @153518
     /* 153518 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(153547), // Rule ID 4628 //
     /* 153523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153538 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 153538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 153541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153545 */     GIR_RootConstrainSelectedInstOperands,
     /* 153546 */     // GIR_Coverage, 4628,
     /* 153546 */     GIR_EraseRootFromParent_Done,
     /* 153547 */   // Label 3037: @153547
     /* 153547 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(153576), // Rule ID 4629 //
     /* 153552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153567 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 153567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 153570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153574 */     GIR_RootConstrainSelectedInstOperands,
     /* 153575 */     // GIR_Coverage, 4629,
     /* 153575 */     GIR_EraseRootFromParent_Done,
     /* 153576 */   // Label 3038: @153576
     /* 153576 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(153605), // Rule ID 4630 //
     /* 153581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153596 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 153596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 153599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153603 */     GIR_RootConstrainSelectedInstOperands,
     /* 153604 */     // GIR_Coverage, 4630,
     /* 153604 */     GIR_EraseRootFromParent_Done,
     /* 153605 */   // Label 3039: @153605
     /* 153605 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(153637), // Rule ID 4637 //
     /* 153610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153628 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 153628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 153631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153635 */     GIR_RootConstrainSelectedInstOperands,
     /* 153636 */     // GIR_Coverage, 4637,
     /* 153636 */     GIR_EraseRootFromParent_Done,
     /* 153637 */   // Label 3040: @153637
     /* 153637 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(153669), // Rule ID 4638 //
     /* 153642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153660 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 153660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 153663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153667 */     GIR_RootConstrainSelectedInstOperands,
     /* 153668 */     // GIR_Coverage, 4638,
     /* 153668 */     GIR_EraseRootFromParent_Done,
     /* 153669 */   // Label 3041: @153669
     /* 153669 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(153698), // Rule ID 4639 //
     /* 153674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153689 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 153689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 153692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153696 */     GIR_RootConstrainSelectedInstOperands,
     /* 153697 */     // GIR_Coverage, 4639,
     /* 153697 */     GIR_EraseRootFromParent_Done,
     /* 153698 */   // Label 3042: @153698
     /* 153698 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(153727), // Rule ID 4640 //
     /* 153703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153718 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 153718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 153721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153725 */     GIR_RootConstrainSelectedInstOperands,
     /* 153726 */     // GIR_Coverage, 4640,
     /* 153726 */     GIR_EraseRootFromParent_Done,
     /* 153727 */   // Label 3043: @153727
     /* 153727 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(153756), // Rule ID 4641 //
     /* 153732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153747 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 153747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 153750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153754 */     GIR_RootConstrainSelectedInstOperands,
     /* 153755 */     // GIR_Coverage, 4641,
     /* 153755 */     GIR_EraseRootFromParent_Done,
     /* 153756 */   // Label 3044: @153756
     /* 153756 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(153785), // Rule ID 4642 //
     /* 153761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153776 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 153776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 153779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153783 */     GIR_RootConstrainSelectedInstOperands,
     /* 153784 */     // GIR_Coverage, 4642,
     /* 153784 */     GIR_EraseRootFromParent_Done,
     /* 153785 */   // Label 3045: @153785
     /* 153785 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(153814), // Rule ID 4937 //
     /* 153790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153805 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 153805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 153808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153812 */     GIR_RootConstrainSelectedInstOperands,
     /* 153813 */     // GIR_Coverage, 4937,
     /* 153813 */     GIR_EraseRootFromParent_Done,
     /* 153814 */   // Label 3046: @153814
     /* 153814 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(153843), // Rule ID 4938 //
     /* 153819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153834 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 153834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 153837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153841 */     GIR_RootConstrainSelectedInstOperands,
     /* 153842 */     // GIR_Coverage, 4938,
     /* 153842 */     GIR_EraseRootFromParent_Done,
     /* 153843 */   // Label 3047: @153843
     /* 153843 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(153872), // Rule ID 4939 //
     /* 153848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153863 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 153863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 153866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153870 */     GIR_RootConstrainSelectedInstOperands,
     /* 153871 */     // GIR_Coverage, 4939,
     /* 153871 */     GIR_EraseRootFromParent_Done,
     /* 153872 */   // Label 3048: @153872
     /* 153872 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(153901), // Rule ID 4940 //
     /* 153877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 153892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 153895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153899 */     GIR_RootConstrainSelectedInstOperands,
     /* 153900 */     // GIR_Coverage, 4940,
     /* 153900 */     GIR_EraseRootFromParent_Done,
     /* 153901 */   // Label 3049: @153901
     /* 153901 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(153930), // Rule ID 4941 //
     /* 153906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153921 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 153921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 153924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153928 */     GIR_RootConstrainSelectedInstOperands,
     /* 153929 */     // GIR_Coverage, 4941,
     /* 153929 */     GIR_EraseRootFromParent_Done,
     /* 153930 */   // Label 3050: @153930
     /* 153930 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(153959), // Rule ID 4942 //
     /* 153935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153950 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 153950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 153953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153957 */     GIR_RootConstrainSelectedInstOperands,
     /* 153958 */     // GIR_Coverage, 4942,
     /* 153958 */     GIR_EraseRootFromParent_Done,
     /* 153959 */   // Label 3051: @153959
     /* 153959 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(153988), // Rule ID 4943 //
     /* 153964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153979 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 153979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 153982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153986 */     GIR_RootConstrainSelectedInstOperands,
     /* 153987 */     // GIR_Coverage, 4943,
     /* 153987 */     GIR_EraseRootFromParent_Done,
     /* 153988 */   // Label 3052: @153988
     /* 153988 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(154017), // Rule ID 4944 //
     /* 153993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154008 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 154008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 154011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154015 */     GIR_RootConstrainSelectedInstOperands,
     /* 154016 */     // GIR_Coverage, 4944,
     /* 154016 */     GIR_EraseRootFromParent_Done,
     /* 154017 */   // Label 3053: @154017
     /* 154017 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(154046), // Rule ID 4945 //
     /* 154022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 154027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154037 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 154037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 154040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154044 */     GIR_RootConstrainSelectedInstOperands,
     /* 154045 */     // GIR_Coverage, 4945,
     /* 154045 */     GIR_EraseRootFromParent_Done,
     /* 154046 */   // Label 3054: @154046
     /* 154046 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(154075), // Rule ID 4946 //
     /* 154051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 154056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 154066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 154069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154073 */     GIR_RootConstrainSelectedInstOperands,
     /* 154074 */     // GIR_Coverage, 4946,
     /* 154074 */     GIR_EraseRootFromParent_Done,
     /* 154075 */   // Label 3055: @154075
     /* 154075 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(154107), // Rule ID 8423 //
     /* 154080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 154091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 154094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1660:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 154098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154105 */     GIR_RootConstrainSelectedInstOperands,
     /* 154106 */     // GIR_Coverage, 8423,
     /* 154106 */     GIR_EraseRootFromParent_Done,
     /* 154107 */   // Label 3056: @154107
     /* 154107 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(154139), // Rule ID 8424 //
     /* 154112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 154123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 154126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1660:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 154130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154137 */     GIR_RootConstrainSelectedInstOperands,
     /* 154138 */     // GIR_Coverage, 8424,
     /* 154138 */     GIR_EraseRootFromParent_Done,
     /* 154139 */   // Label 3057: @154139
     /* 154139 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(154171), // Rule ID 8425 //
     /* 154144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 154155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 154158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1660:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 154162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154169 */     GIR_RootConstrainSelectedInstOperands,
     /* 154170 */     // GIR_Coverage, 8425,
     /* 154170 */     GIR_EraseRootFromParent_Done,
     /* 154171 */   // Label 3058: @154171
     /* 154171 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(154203), // Rule ID 11834 //
     /* 154176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 154190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 154194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 154197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154201 */     GIR_RootConstrainSelectedInstOperands,
     /* 154202 */     // GIR_Coverage, 11834,
     /* 154202 */     GIR_EraseRootFromParent_Done,
     /* 154203 */   // Label 3059: @154203
     /* 154203 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(154235), // Rule ID 11835 //
     /* 154208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 154219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 154222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 154226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 154229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154233 */     GIR_RootConstrainSelectedInstOperands,
     /* 154234 */     // GIR_Coverage, 11835,
     /* 154234 */     GIR_EraseRootFromParent_Done,
     /* 154235 */   // Label 3060: @154235
     /* 154235 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(154267), // Rule ID 11836 //
     /* 154240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 154251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 154254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 154258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 154261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154265 */     GIR_RootConstrainSelectedInstOperands,
     /* 154266 */     // GIR_Coverage, 11836,
     /* 154266 */     GIR_EraseRootFromParent_Done,
     /* 154267 */   // Label 3061: @154267
     /* 154267 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(154299), // Rule ID 11837 //
     /* 154272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 154286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 154290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 154293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154297 */     GIR_RootConstrainSelectedInstOperands,
     /* 154298 */     // GIR_Coverage, 11837,
     /* 154298 */     GIR_EraseRootFromParent_Done,
     /* 154299 */   // Label 3062: @154299
     /* 154299 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(154331), // Rule ID 11838 //
     /* 154304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 154315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 154318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 154322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 154325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154329 */     GIR_RootConstrainSelectedInstOperands,
     /* 154330 */     // GIR_Coverage, 11838,
     /* 154330 */     GIR_EraseRootFromParent_Done,
     /* 154331 */   // Label 3063: @154331
     /* 154331 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(154363), // Rule ID 11839 //
     /* 154336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 154347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 154350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 154354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 154357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154361 */     GIR_RootConstrainSelectedInstOperands,
     /* 154362 */     // GIR_Coverage, 11839,
     /* 154362 */     GIR_EraseRootFromParent_Done,
     /* 154363 */   // Label 3064: @154363
     /* 154363 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(154395), // Rule ID 11994 //
     /* 154368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 154371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 154376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 154382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 154386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 154389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 154391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154393 */     GIR_RootConstrainSelectedInstOperands,
     /* 154394 */     // GIR_Coverage, 11994,
     /* 154394 */     GIR_EraseRootFromParent_Done,
     /* 154395 */   // Label 3065: @154395
     /* 154395 */   GIM_Reject,
     /* 154396 */ // Label 2746: @154396
     /* 154396 */ GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(200710),
     /* 154401 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 154404 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(154588), // Rule ID 2568 //
     /* 154409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154458 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154461 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154470 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154487 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 154495 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154499 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154503 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 154507 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154512 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 154516 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154520 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154524 */     // MIs[5] Operand 1
     /* 154524 */     // No operand predicates
     /* 154524 */     // MIs[3] Operand 2
     /* 154524 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 154535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154539 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 154541 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154553 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 154572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 154583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 154586 */     GIR_RootConstrainSelectedInstOperands,
     /* 154587 */     // GIR_Coverage, 2568,
     /* 154587 */     GIR_EraseRootFromParent_Done,
     /* 154588 */   // Label 3067: @154588
     /* 154588 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(154772), // Rule ID 6273 //
     /* 154593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154642 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154645 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154654 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 154679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154683 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154687 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 154691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154696 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 154700 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154704 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154708 */     // MIs[5] Operand 1
     /* 154708 */     // No operand predicates
     /* 154708 */     // MIs[3] Operand 2
     /* 154708 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 154719 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154723 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 154725 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154737 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 154756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 154767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 154770 */     GIR_RootConstrainSelectedInstOperands,
     /* 154771 */     // GIR_Coverage, 6273,
     /* 154771 */     GIR_EraseRootFromParent_Done,
     /* 154772 */   // Label 3068: @154772
     /* 154772 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(154912), // Rule ID 2057 //
     /* 154777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154810 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154813 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154822 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154850 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154859 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154863 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154867 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154871 */     // MIs[4] Operand 1
     /* 154871 */     // No operand predicates
     /* 154871 */     // MIs[2] Operand 2
     /* 154871 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 154894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154910 */     GIR_RootConstrainSelectedInstOperands,
     /* 154911 */     // GIR_Coverage, 2057,
     /* 154911 */     GIR_EraseRootFromParent_Done,
     /* 154912 */   // Label 3069: @154912
     /* 154912 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(155052), // Rule ID 2064 //
     /* 154917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154950 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154953 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154962 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154999 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155003 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155007 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155011 */     // MIs[4] Operand 1
     /* 155011 */     // No operand predicates
     /* 155011 */     // MIs[2] Operand 2
     /* 155011 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155022 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 155031 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 155034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155050 */     GIR_RootConstrainSelectedInstOperands,
     /* 155051 */     // GIR_Coverage, 2064,
     /* 155051 */     GIR_EraseRootFromParent_Done,
     /* 155052 */   // Label 3070: @155052
     /* 155052 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(155192), // Rule ID 2060 //
     /* 155057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155090 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155093 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155102 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155143 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155147 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155151 */     // MIs[4] Operand 1
     /* 155151 */     // No operand predicates
     /* 155151 */     // MIs[2] Operand 2
     /* 155151 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155171 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 155174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155190 */     GIR_RootConstrainSelectedInstOperands,
     /* 155191 */     // GIR_Coverage, 2060,
     /* 155191 */     GIR_EraseRootFromParent_Done,
     /* 155192 */   // Label 3071: @155192
     /* 155192 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(155332), // Rule ID 2067 //
     /* 155197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155230 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155233 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155242 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155291 */     // MIs[4] Operand 1
     /* 155291 */     // No operand predicates
     /* 155291 */     // MIs[2] Operand 2
     /* 155291 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155311 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 155314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155330 */     GIR_RootConstrainSelectedInstOperands,
     /* 155331 */     // GIR_Coverage, 2067,
     /* 155331 */     GIR_EraseRootFromParent_Done,
     /* 155332 */   // Label 3072: @155332
     /* 155332 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(155469), // Rule ID 2055 //
     /* 155337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155370 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155373 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155382 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155419 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155428 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155432 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155436 */     // MIs[4] Operand 1
     /* 155436 */     // No operand predicates
     /* 155436 */     // MIs[2] Operand 2
     /* 155436 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155447 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155449 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 155452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155467 */     GIR_RootConstrainSelectedInstOperands,
     /* 155468 */     // GIR_Coverage, 2055,
     /* 155468 */     GIR_EraseRootFromParent_Done,
     /* 155469 */   // Label 3073: @155469
     /* 155469 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(155606), // Rule ID 2062 //
     /* 155474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155507 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155510 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155519 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155556 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155569 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155573 */     // MIs[4] Operand 1
     /* 155573 */     // No operand predicates
     /* 155573 */     // MIs[2] Operand 2
     /* 155573 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155584 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 155589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155604 */     GIR_RootConstrainSelectedInstOperands,
     /* 155605 */     // GIR_Coverage, 2062,
     /* 155605 */     GIR_EraseRootFromParent_Done,
     /* 155606 */   // Label 3074: @155606
     /* 155606 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(155743), // Rule ID 2058 //
     /* 155611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155644 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155647 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155689 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155693 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155702 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155706 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155710 */     // MIs[4] Operand 1
     /* 155710 */     // No operand predicates
     /* 155710 */     // MIs[2] Operand 2
     /* 155710 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155721 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155723 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 155726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155741 */     GIR_RootConstrainSelectedInstOperands,
     /* 155742 */     // GIR_Coverage, 2058,
     /* 155742 */     GIR_EraseRootFromParent_Done,
     /* 155743 */   // Label 3075: @155743
     /* 155743 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(155880), // Rule ID 2065 //
     /* 155748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155793 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155847 */     // MIs[4] Operand 1
     /* 155847 */     // No operand predicates
     /* 155847 */     // MIs[2] Operand 2
     /* 155847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155860 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 155863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155878 */     GIR_RootConstrainSelectedInstOperands,
     /* 155879 */     // GIR_Coverage, 2065,
     /* 155879 */     GIR_EraseRootFromParent_Done,
     /* 155880 */   // Label 3076: @155880
     /* 155880 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(156041), // Rule ID 2569 //
     /* 155885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155934 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155937 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155946 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 155959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155963 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155967 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155971 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155984 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155988 */     // MIs[4] Operand 1
     /* 155988 */     // No operand predicates
     /* 155988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155992 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155994 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156006 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 156025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 156036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 156039 */     GIR_RootConstrainSelectedInstOperands,
     /* 156040 */     // GIR_Coverage, 2569,
     /* 156040 */     GIR_EraseRootFromParent_Done,
     /* 156041 */   // Label 3077: @156041
     /* 156041 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(156202), // Rule ID 6274 //
     /* 156046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156095 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 156098 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156107 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 156120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156132 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156137 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 156141 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156145 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156149 */     // MIs[4] Operand 1
     /* 156149 */     // No operand predicates
     /* 156149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156153 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 156155 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156167 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 156186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 156197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 156200 */     GIR_RootConstrainSelectedInstOperands,
     /* 156201 */     // GIR_Coverage, 6274,
     /* 156201 */     GIR_EraseRootFromParent_Done,
     /* 156202 */   // Label 3078: @156202
     /* 156202 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(156312), // Rule ID 2085 //
     /* 156207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156269 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156273 */     // MIs[3] Operand 1
     /* 156273 */     // No operand predicates
     /* 156273 */     // MIs[1] Operand 2
     /* 156273 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 156284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156293 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 156296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156310 */     GIR_RootConstrainSelectedInstOperands,
     /* 156311 */     // GIR_Coverage, 2085,
     /* 156311 */     GIR_EraseRootFromParent_Done,
     /* 156312 */   // Label 3079: @156312
     /* 156312 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(156422), // Rule ID 2088 //
     /* 156317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156383 */     // MIs[3] Operand 1
     /* 156383 */     // No operand predicates
     /* 156383 */     // MIs[1] Operand 2
     /* 156383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 156394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156403 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 156421 */     // GIR_Coverage, 2088,
     /* 156421 */     GIR_EraseRootFromParent_Done,
     /* 156422 */   // Label 3080: @156422
     /* 156422 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(156511), // Rule ID 1743 //
     /* 156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156460 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156463 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156472 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 156492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 156495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156509 */     GIR_RootConstrainSelectedInstOperands,
     /* 156510 */     // GIR_Coverage, 1743,
     /* 156510 */     GIR_EraseRootFromParent_Done,
     /* 156511 */   // Label 3081: @156511
     /* 156511 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(156600), // Rule ID 1745 //
     /* 156516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156549 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156552 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156561 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156581 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 156581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 156584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156598 */     GIR_RootConstrainSelectedInstOperands,
     /* 156599 */     // GIR_Coverage, 1745,
     /* 156599 */     GIR_EraseRootFromParent_Done,
     /* 156600 */   // Label 3082: @156600
     /* 156600 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(156689), // Rule ID 1747 //
     /* 156605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156638 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156641 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156650 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 156670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 156673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156687 */     GIR_RootConstrainSelectedInstOperands,
     /* 156688 */     // GIR_Coverage, 1747,
     /* 156688 */     GIR_EraseRootFromParent_Done,
     /* 156689 */   // Label 3083: @156689
     /* 156689 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(156778), // Rule ID 1749 //
     /* 156694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156727 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156730 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156759 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 156759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 156762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156776 */     GIR_RootConstrainSelectedInstOperands,
     /* 156777 */     // GIR_Coverage, 1749,
     /* 156777 */     GIR_EraseRootFromParent_Done,
     /* 156778 */   // Label 3084: @156778
     /* 156778 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(156900), // Rule ID 6925 //
     /* 156783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 156788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156818 */     // MIs[1] Operand 2
     /* 156818 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156837 */     // MIs[2] Rn
     /* 156837 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 156842 */     // MIs[2] Operand 2
     /* 156842 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 156853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156855 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 156855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 156858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 156862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156882 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 156889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156899 */     // GIR_Coverage, 6925,
     /* 156899 */     GIR_EraseRootFromParent_Done,
     /* 156900 */   // Label 3085: @156900
     /* 156900 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(157022), // Rule ID 6927 //
     /* 156905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 156910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156940 */     // MIs[1] Operand 2
     /* 156940 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156959 */     // MIs[2] Rn
     /* 156959 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 156964 */     // MIs[2] Operand 2
     /* 156964 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 156975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156977 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 156977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 156980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 156984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157021 */     // GIR_Coverage, 6927,
     /* 157021 */     GIR_EraseRootFromParent_Done,
     /* 157022 */   // Label 3086: @157022
     /* 157022 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(157144), // Rule ID 6929 //
     /* 157027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 157032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 157035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 157038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 157041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 157057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157062 */     // MIs[1] Operand 2
     /* 157062 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157081 */     // MIs[2] Rn
     /* 157081 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157086 */     // MIs[2] Operand 2
     /* 157086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 157097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157099 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 157099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 157106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157126 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157143 */     // GIR_Coverage, 6929,
     /* 157143 */     GIR_EraseRootFromParent_Done,
     /* 157144 */   // Label 3087: @157144
     /* 157144 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(157266), // Rule ID 6931 //
     /* 157149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 157154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157184 */     // MIs[1] Operand 2
     /* 157184 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157203 */     // MIs[2] Rn
     /* 157203 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157208 */     // MIs[2] Operand 2
     /* 157208 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 157219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157221 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 157221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 157228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157248 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157265 */     // GIR_Coverage, 6931,
     /* 157265 */     GIR_EraseRootFromParent_Done,
     /* 157266 */   // Label 3088: @157266
     /* 157266 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(157388), // Rule ID 6933 //
     /* 157271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 157276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157306 */     // MIs[1] Operand 2
     /* 157306 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157325 */     // MIs[2] Rn
     /* 157325 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157330 */     // MIs[2] Operand 2
     /* 157330 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 157341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157343 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 157343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 157350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157370 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157387 */     // GIR_Coverage, 6933,
     /* 157387 */     GIR_EraseRootFromParent_Done,
     /* 157388 */   // Label 3089: @157388
     /* 157388 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(157571), // Rule ID 2567 //
     /* 157393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157442 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 157445 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157454 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157474 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 157474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 157477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 157488 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 157491 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157495 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157500 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 157503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 157507 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 157510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157537 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 157556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157569 */     GIR_RootConstrainSelectedInstOperands,
     /* 157570 */     // GIR_Coverage, 2567,
     /* 157570 */     GIR_EraseRootFromParent_Done,
     /* 157571 */   // Label 3090: @157571
     /* 157571 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(157754), // Rule ID 6272 //
     /* 157576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157625 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 157628 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157637 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157657 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 157657 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 157660 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157664 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 157671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 157674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157683 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 157686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 157690 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 157693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 157739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157752 */     GIR_RootConstrainSelectedInstOperands,
     /* 157753 */     // GIR_Coverage, 6272,
     /* 157753 */     GIR_EraseRootFromParent_Done,
     /* 157754 */   // Label 3091: @157754
     /* 157754 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(157858), // Rule ID 13459 //
     /* 157759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157821 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157825 */     // MIs[3] Operand 1
     /* 157825 */     // No operand predicates
     /* 157825 */     // MIs[1] Operand 2
     /* 157825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157842 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157856 */     GIR_RootConstrainSelectedInstOperands,
     /* 157857 */     // GIR_Coverage, 13459,
     /* 157857 */     GIR_EraseRootFromParent_Done,
     /* 157858 */   // Label 3092: @157858
     /* 157858 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(157962), // Rule ID 13462 //
     /* 157863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157925 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157929 */     // MIs[3] Operand 1
     /* 157929 */     // No operand predicates
     /* 157929 */     // MIs[1] Operand 2
     /* 157929 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157946 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157960 */     GIR_RootConstrainSelectedInstOperands,
     /* 157961 */     // GIR_Coverage, 13462,
     /* 157961 */     GIR_EraseRootFromParent_Done,
     /* 157962 */   // Label 3093: @157962
     /* 157962 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(158093), // Rule ID 2524 //
     /* 157967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 157984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158042 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158046 */     // MIs[3] Operand 1
     /* 158046 */     // No operand predicates
     /* 158046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158048 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 158048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 158079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158091 */     GIR_RootConstrainSelectedInstOperands,
     /* 158092 */     // GIR_Coverage, 2524,
     /* 158092 */     GIR_EraseRootFromParent_Done,
     /* 158093 */   // Label 3094: @158093
     /* 158093 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(158224), // Rule ID 2525 //
     /* 158098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158140 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158173 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158177 */     // MIs[3] Operand 1
     /* 158177 */     // No operand predicates
     /* 158177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158179 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 158179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158191 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 158197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 158210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158222 */     GIR_RootConstrainSelectedInstOperands,
     /* 158223 */     // GIR_Coverage, 2525,
     /* 158223 */     GIR_EraseRootFromParent_Done,
     /* 158224 */   // Label 3095: @158224
     /* 158224 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(158355), // Rule ID 2526 //
     /* 158229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 158308 */     // MIs[3] Operand 1
     /* 158308 */     // No operand predicates
     /* 158308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158310 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 158310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 158328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 158341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158353 */     GIR_RootConstrainSelectedInstOperands,
     /* 158354 */     // GIR_Coverage, 2526,
     /* 158354 */     GIR_EraseRootFromParent_Done,
     /* 158355 */   // Label 3096: @158355
     /* 158355 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(158486), // Rule ID 13645 //
     /* 158360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 158363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158414 */     // MIs[2] Operand 1
     /* 158414 */     // No operand predicates
     /* 158414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158435 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158441 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 158441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 158472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158484 */     GIR_RootConstrainSelectedInstOperands,
     /* 158485 */     // GIR_Coverage, 13645,
     /* 158485 */     GIR_EraseRootFromParent_Done,
     /* 158486 */   // Label 3097: @158486
     /* 158486 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(158617), // Rule ID 13646 //
     /* 158491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158545 */     // MIs[2] Operand 1
     /* 158545 */     // No operand predicates
     /* 158545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158557 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158566 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158572 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 158572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158584 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 158590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 158603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158615 */     GIR_RootConstrainSelectedInstOperands,
     /* 158616 */     // GIR_Coverage, 13646,
     /* 158616 */     GIR_EraseRootFromParent_Done,
     /* 158617 */   // Label 3098: @158617
     /* 158617 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(158748), // Rule ID 13647 //
     /* 158622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158672 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 158676 */     // MIs[2] Operand 1
     /* 158676 */     // No operand predicates
     /* 158676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158688 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158692 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158697 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158703 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 158703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158715 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 158721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 158734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158746 */     GIR_RootConstrainSelectedInstOperands,
     /* 158747 */     // GIR_Coverage, 13647,
     /* 158747 */     GIR_EraseRootFromParent_Done,
     /* 158748 */   // Label 3099: @158748
     /* 158748 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(158862), // Rule ID 2056 //
     /* 158753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158786 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158789 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 158811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158836 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158840 */     // MIs[3] Operand 1
     /* 158840 */     // No operand predicates
     /* 158840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158842 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 158845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158860 */     GIR_RootConstrainSelectedInstOperands,
     /* 158861 */     // GIR_Coverage, 2056,
     /* 158861 */     GIR_EraseRootFromParent_Done,
     /* 158862 */   // Label 3100: @158862
     /* 158862 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(158976), // Rule ID 2063 //
     /* 158867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158900 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158903 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158912 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 158925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158950 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158954 */     // MIs[3] Operand 1
     /* 158954 */     // No operand predicates
     /* 158954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 158959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158974 */     GIR_RootConstrainSelectedInstOperands,
     /* 158975 */     // GIR_Coverage, 2063,
     /* 158975 */     GIR_EraseRootFromParent_Done,
     /* 158976 */   // Label 3101: @158976
     /* 158976 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(159090), // Rule ID 2059 //
     /* 158981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159014 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159017 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159064 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159068 */     // MIs[3] Operand 1
     /* 159068 */     // No operand predicates
     /* 159068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159070 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 159073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159088 */     GIR_RootConstrainSelectedInstOperands,
     /* 159089 */     // GIR_Coverage, 2059,
     /* 159089 */     GIR_EraseRootFromParent_Done,
     /* 159090 */   // Label 3102: @159090
     /* 159090 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(159204), // Rule ID 2066 //
     /* 159095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159128 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159131 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159178 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159182 */     // MIs[3] Operand 1
     /* 159182 */     // No operand predicates
     /* 159182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 159187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159202 */     GIR_RootConstrainSelectedInstOperands,
     /* 159203 */     // GIR_Coverage, 2066,
     /* 159203 */     GIR_EraseRootFromParent_Done,
     /* 159204 */   // Label 3103: @159204
     /* 159204 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(159318), // Rule ID 2061 //
     /* 159209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159242 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159245 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159254 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159296 */     // MIs[3] Operand 1
     /* 159296 */     // No operand predicates
     /* 159296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159298 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 159301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159316 */     GIR_RootConstrainSelectedInstOperands,
     /* 159317 */     // GIR_Coverage, 2061,
     /* 159317 */     GIR_EraseRootFromParent_Done,
     /* 159318 */   // Label 3104: @159318
     /* 159318 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(159432), // Rule ID 2068 //
     /* 159323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159406 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159410 */     // MIs[3] Operand 1
     /* 159410 */     // No operand predicates
     /* 159410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159412 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 159415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159430 */     GIR_RootConstrainSelectedInstOperands,
     /* 159431 */     // GIR_Coverage, 2068,
     /* 159431 */     GIR_EraseRootFromParent_Done,
     /* 159432 */   // Label 3105: @159432
     /* 159432 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(159536), // Rule ID 1987 //
     /* 159437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159503 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159507 */     // MIs[3] Operand 1
     /* 159507 */     // No operand predicates
     /* 159507 */     // MIs[1] Operand 2
     /* 159507 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159520 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159534 */     GIR_RootConstrainSelectedInstOperands,
     /* 159535 */     // GIR_Coverage, 1987,
     /* 159535 */     GIR_EraseRootFromParent_Done,
     /* 159536 */   // Label 3106: @159536
     /* 159536 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(159640), // Rule ID 2017 //
     /* 159541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159607 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159611 */     // MIs[3] Operand 1
     /* 159611 */     // No operand predicates
     /* 159611 */     // MIs[1] Operand 2
     /* 159611 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159624 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 159627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159638 */     GIR_RootConstrainSelectedInstOperands,
     /* 159639 */     // GIR_Coverage, 2017,
     /* 159639 */     GIR_EraseRootFromParent_Done,
     /* 159640 */   // Label 3107: @159640
     /* 159640 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(159744), // Rule ID 2024 //
     /* 159645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 159653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159715 */     // MIs[3] Operand 1
     /* 159715 */     // No operand predicates
     /* 159715 */     // MIs[1] Operand 2
     /* 159715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159728 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 159731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159742 */     GIR_RootConstrainSelectedInstOperands,
     /* 159743 */     // GIR_Coverage, 2024,
     /* 159743 */     GIR_EraseRootFromParent_Done,
     /* 159744 */   // Label 3108: @159744
     /* 159744 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(159848), // Rule ID 2083 //
     /* 159749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159819 */     // MIs[3] Operand 1
     /* 159819 */     // No operand predicates
     /* 159819 */     // MIs[1] Operand 2
     /* 159819 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159832 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 159835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159846 */     GIR_RootConstrainSelectedInstOperands,
     /* 159847 */     // GIR_Coverage, 2083,
     /* 159847 */     GIR_EraseRootFromParent_Done,
     /* 159848 */   // Label 3109: @159848
     /* 159848 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(159952), // Rule ID 1990 //
     /* 159853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159923 */     // MIs[3] Operand 1
     /* 159923 */     // No operand predicates
     /* 159923 */     // MIs[1] Operand 2
     /* 159923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159936 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159950 */     GIR_RootConstrainSelectedInstOperands,
     /* 159951 */     // GIR_Coverage, 1990,
     /* 159951 */     GIR_EraseRootFromParent_Done,
     /* 159952 */   // Label 3110: @159952
     /* 159952 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(160056), // Rule ID 2020 //
     /* 159957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160023 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160027 */     // MIs[3] Operand 1
     /* 160027 */     // No operand predicates
     /* 160027 */     // MIs[1] Operand 2
     /* 160027 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160040 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 160043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160054 */     GIR_RootConstrainSelectedInstOperands,
     /* 160055 */     // GIR_Coverage, 2020,
     /* 160055 */     GIR_EraseRootFromParent_Done,
     /* 160056 */   // Label 3111: @160056
     /* 160056 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(160160), // Rule ID 2027 //
     /* 160061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 160102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160127 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160131 */     // MIs[3] Operand 1
     /* 160131 */     // No operand predicates
     /* 160131 */     // MIs[1] Operand 2
     /* 160131 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160144 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160158 */     GIR_RootConstrainSelectedInstOperands,
     /* 160159 */     // GIR_Coverage, 2027,
     /* 160159 */     GIR_EraseRootFromParent_Done,
     /* 160160 */   // Label 3112: @160160
     /* 160160 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(160264), // Rule ID 2086 //
     /* 160165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 160206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160235 */     // MIs[3] Operand 1
     /* 160235 */     // No operand predicates
     /* 160235 */     // MIs[1] Operand 2
     /* 160235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160248 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 160251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160262 */     GIR_RootConstrainSelectedInstOperands,
     /* 160263 */     // GIR_Coverage, 2086,
     /* 160263 */     GIR_EraseRootFromParent_Done,
     /* 160264 */   // Label 3113: @160264
     /* 160264 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(160321), // Rule ID 1751 //
     /* 160269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 160297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 160304 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 160304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 160307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 160314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 160319 */     GIR_RootConstrainSelectedInstOperands,
     /* 160320 */     // GIR_Coverage, 1751,
     /* 160320 */     GIR_EraseRootFromParent_Done,
     /* 160321 */   // Label 3114: @160321
     /* 160321 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(160378), // Rule ID 1753 //
     /* 160326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 160354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 160361 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 160361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 160364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 160371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 160376 */     GIR_RootConstrainSelectedInstOperands,
     /* 160377 */     // GIR_Coverage, 1753,
     /* 160377 */     GIR_EraseRootFromParent_Done,
     /* 160378 */   // Label 3115: @160378
     /* 160378 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(160488), // Rule ID 6291 //
     /* 160383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 160409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 160413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 160417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 160433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 160437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 160445 */     // MIs[2] Operand 1
     /* 160445 */     // No operand predicates
     /* 160445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160447 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 160447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160459 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 160465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 160478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 160486 */     GIR_RootConstrainSelectedInstOperands,
     /* 160487 */     // GIR_Coverage, 6291,
     /* 160487 */     GIR_EraseRootFromParent_Done,
     /* 160488 */   // Label 3116: @160488
     /* 160488 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(160585), // Rule ID 13916 //
     /* 160493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 160496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160545 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 160545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 160563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 160576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160583 */     GIR_RootConstrainSelectedInstOperands,
     /* 160584 */     // GIR_Coverage, 13916,
     /* 160584 */     GIR_EraseRootFromParent_Done,
     /* 160585 */   // Label 3117: @160585
     /* 160585 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(160682), // Rule ID 13917 //
     /* 160590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 160593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160642 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 160642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160654 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 160660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 160673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160680 */     GIR_RootConstrainSelectedInstOperands,
     /* 160681 */     // GIR_Coverage, 13917,
     /* 160681 */     GIR_EraseRootFromParent_Done,
     /* 160682 */   // Label 3118: @160682
     /* 160682 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(160779), // Rule ID 13918 //
     /* 160687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 160690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160739 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 160739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 160742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160751 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 160757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 160770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160777 */     GIR_RootConstrainSelectedInstOperands,
     /* 160778 */     // GIR_Coverage, 13918,
     /* 160778 */     GIR_EraseRootFromParent_Done,
     /* 160779 */   // Label 3119: @160779
     /* 160779 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(160862), // Rule ID 1742 //
     /* 160784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 160792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160817 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160820 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160829 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 160845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 160848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 160852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 160856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 160860 */     GIR_RootConstrainSelectedInstOperands,
     /* 160861 */     // GIR_Coverage, 1742,
     /* 160861 */     GIR_EraseRootFromParent_Done,
     /* 160862 */   // Label 3120: @160862
     /* 160862 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(160945), // Rule ID 1744 //
     /* 160867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 160875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 160884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160900 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160903 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160912 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 160928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 160931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 160935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 160939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 160943 */     GIR_RootConstrainSelectedInstOperands,
     /* 160944 */     // GIR_Coverage, 1744,
     /* 160944 */     GIR_EraseRootFromParent_Done,
     /* 160945 */   // Label 3121: @160945
     /* 160945 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161028), // Rule ID 1746 //
     /* 160950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 160958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160983 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160986 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161011 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 161011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 161014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161026 */     GIR_RootConstrainSelectedInstOperands,
     /* 161027 */     // GIR_Coverage, 1746,
     /* 161027 */     GIR_EraseRootFromParent_Done,
     /* 161028 */   // Label 3122: @161028
     /* 161028 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(161111), // Rule ID 1748 //
     /* 161033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 161041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161078 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161094 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 161094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 161097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161109 */     GIR_RootConstrainSelectedInstOperands,
     /* 161110 */     // GIR_Coverage, 1748,
     /* 161110 */     GIR_EraseRootFromParent_Done,
     /* 161111 */   // Label 3123: @161111
     /* 161111 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(161191), // Rule ID 5237 //
     /* 161116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 161121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161146 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161149 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161158 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161174 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 161174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 161177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161189 */     GIR_RootConstrainSelectedInstOperands,
     /* 161190 */     // GIR_Coverage, 5237,
     /* 161190 */     GIR_EraseRootFromParent_Done,
     /* 161191 */   // Label 3124: @161191
     /* 161191 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(161271), // Rule ID 5238 //
     /* 161196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 161201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161226 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161229 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161254 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 161254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 161257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161269 */     GIR_RootConstrainSelectedInstOperands,
     /* 161270 */     // GIR_Coverage, 5238,
     /* 161270 */     GIR_EraseRootFromParent_Done,
     /* 161271 */   // Label 3125: @161271
     /* 161271 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(161368), // Rule ID 5234 //
     /* 161276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 161279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161322 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161328 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 161328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 161331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161340 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 161346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 161359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161366 */     GIR_RootConstrainSelectedInstOperands,
     /* 161367 */     // GIR_Coverage, 5234,
     /* 161367 */     GIR_EraseRootFromParent_Done,
     /* 161368 */   // Label 3126: @161368
     /* 161368 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(161465), // Rule ID 5235 //
     /* 161373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 161376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161419 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161425 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 161425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 161428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 161443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 161456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161463 */     GIR_RootConstrainSelectedInstOperands,
     /* 161464 */     // GIR_Coverage, 5235,
     /* 161464 */     GIR_EraseRootFromParent_Done,
     /* 161465 */   // Label 3127: @161465
     /* 161465 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(161562), // Rule ID 5236 //
     /* 161470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 161473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161522 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 161522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 161525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161534 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 161540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 161553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161560 */     GIR_RootConstrainSelectedInstOperands,
     /* 161561 */     // GIR_Coverage, 5236,
     /* 161561 */     GIR_EraseRootFromParent_Done,
     /* 161562 */   // Label 3128: @161562
     /* 161562 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(161643), // Rule ID 13460 //
     /* 161567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161621 */     // MIs[2] Operand 1
     /* 161621 */     // No operand predicates
     /* 161621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161627 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 161630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161641 */     GIR_RootConstrainSelectedInstOperands,
     /* 161642 */     // GIR_Coverage, 13460,
     /* 161642 */     GIR_EraseRootFromParent_Done,
     /* 161643 */   // Label 3129: @161643
     /* 161643 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(161724), // Rule ID 13461 //
     /* 161648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161702 */     // MIs[2] Operand 1
     /* 161702 */     // No operand predicates
     /* 161702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161708 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 161711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161722 */     GIR_RootConstrainSelectedInstOperands,
     /* 161723 */     // GIR_Coverage, 13461,
     /* 161723 */     GIR_EraseRootFromParent_Done,
     /* 161724 */   // Label 3130: @161724
     /* 161724 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(161805), // Rule ID 13463 //
     /* 161729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161783 */     // MIs[2] Operand 1
     /* 161783 */     // No operand predicates
     /* 161783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161789 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 161792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161803 */     GIR_RootConstrainSelectedInstOperands,
     /* 161804 */     // GIR_Coverage, 13463,
     /* 161804 */     GIR_EraseRootFromParent_Done,
     /* 161805 */   // Label 3131: @161805
     /* 161805 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(161886), // Rule ID 13464 //
     /* 161810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161864 */     // MIs[2] Operand 1
     /* 161864 */     // No operand predicates
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161870 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 161873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161884 */     GIR_RootConstrainSelectedInstOperands,
     /* 161885 */     // GIR_Coverage, 13464,
     /* 161885 */     GIR_EraseRootFromParent_Done,
     /* 161886 */   // Label 3132: @161886
     /* 161886 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(161967), // Rule ID 13465 //
     /* 161891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161941 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161945 */     // MIs[2] Operand 1
     /* 161945 */     // No operand predicates
     /* 161945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161951 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161965 */     GIR_RootConstrainSelectedInstOperands,
     /* 161966 */     // GIR_Coverage, 13465,
     /* 161966 */     GIR_EraseRootFromParent_Done,
     /* 161967 */   // Label 3133: @161967
     /* 161967 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162048), // Rule ID 13466 //
     /* 161972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162022 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162026 */     // MIs[2] Operand 1
     /* 162026 */     // No operand predicates
     /* 162026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162032 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 162035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162046 */     GIR_RootConstrainSelectedInstOperands,
     /* 162047 */     // GIR_Coverage, 13466,
     /* 162047 */     GIR_EraseRootFromParent_Done,
     /* 162048 */   // Label 3134: @162048
     /* 162048 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162129), // Rule ID 13467 //
     /* 162053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162107 */     // MIs[2] Operand 1
     /* 162107 */     // No operand predicates
     /* 162107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162113 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 162116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162127 */     GIR_RootConstrainSelectedInstOperands,
     /* 162128 */     // GIR_Coverage, 13467,
     /* 162128 */     GIR_EraseRootFromParent_Done,
     /* 162129 */   // Label 3135: @162129
     /* 162129 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162210), // Rule ID 13468 //
     /* 162134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 162151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162184 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 162188 */     // MIs[2] Operand 1
     /* 162188 */     // No operand predicates
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162194 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162208 */     GIR_RootConstrainSelectedInstOperands,
     /* 162209 */     // GIR_Coverage, 13468,
     /* 162209 */     GIR_EraseRootFromParent_Done,
     /* 162210 */   // Label 3136: @162210
     /* 162210 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162316), // Rule ID 6288 //
     /* 162215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 162241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162250 */     // MIs[1] Operand 2
     /* 162250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 162261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 162265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162269 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162273 */     // MIs[2] Operand 1
     /* 162273 */     // No operand predicates
     /* 162273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162275 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 162306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 162314 */     GIR_RootConstrainSelectedInstOperands,
     /* 162315 */     // GIR_Coverage, 6288,
     /* 162315 */     GIR_EraseRootFromParent_Done,
     /* 162316 */   // Label 3137: @162316
     /* 162316 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162397), // Rule ID 1988 //
     /* 162321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162375 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162379 */     // MIs[2] Operand 1
     /* 162379 */     // No operand predicates
     /* 162379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162381 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 162384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162395 */     GIR_RootConstrainSelectedInstOperands,
     /* 162396 */     // GIR_Coverage, 1988,
     /* 162396 */     GIR_EraseRootFromParent_Done,
     /* 162397 */   // Label 3138: @162397
     /* 162397 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(162478), // Rule ID 1989 //
     /* 162402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162456 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162460 */     // MIs[2] Operand 1
     /* 162460 */     // No operand predicates
     /* 162460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162462 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 162465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162476 */     GIR_RootConstrainSelectedInstOperands,
     /* 162477 */     // GIR_Coverage, 1989,
     /* 162477 */     GIR_EraseRootFromParent_Done,
     /* 162478 */   // Label 3139: @162478
     /* 162478 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(162559), // Rule ID 2018 //
     /* 162483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 162491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162541 */     // MIs[2] Operand 1
     /* 162541 */     // No operand predicates
     /* 162541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162543 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 162546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162557 */     GIR_RootConstrainSelectedInstOperands,
     /* 162558 */     // GIR_Coverage, 2018,
     /* 162558 */     GIR_EraseRootFromParent_Done,
     /* 162559 */   // Label 3140: @162559
     /* 162559 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(162640), // Rule ID 2019 //
     /* 162564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 162572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162618 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162622 */     // MIs[2] Operand 1
     /* 162622 */     // No operand predicates
     /* 162622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162624 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 162627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162638 */     GIR_RootConstrainSelectedInstOperands,
     /* 162639 */     // GIR_Coverage, 2019,
     /* 162639 */     GIR_EraseRootFromParent_Done,
     /* 162640 */   // Label 3141: @162640
     /* 162640 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(162721), // Rule ID 2025 //
     /* 162645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162703 */     // MIs[2] Operand 1
     /* 162703 */     // No operand predicates
     /* 162703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162705 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 162708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162719 */     GIR_RootConstrainSelectedInstOperands,
     /* 162720 */     // GIR_Coverage, 2025,
     /* 162720 */     GIR_EraseRootFromParent_Done,
     /* 162721 */   // Label 3142: @162721
     /* 162721 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(162802), // Rule ID 2026 //
     /* 162726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162784 */     // MIs[2] Operand 1
     /* 162784 */     // No operand predicates
     /* 162784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162786 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 162789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162800 */     GIR_RootConstrainSelectedInstOperands,
     /* 162801 */     // GIR_Coverage, 2026,
     /* 162801 */     GIR_EraseRootFromParent_Done,
     /* 162802 */   // Label 3143: @162802
     /* 162802 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(162883), // Rule ID 2084 //
     /* 162807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 162815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162865 */     // MIs[2] Operand 1
     /* 162865 */     // No operand predicates
     /* 162865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162867 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 162870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162881 */     GIR_RootConstrainSelectedInstOperands,
     /* 162882 */     // GIR_Coverage, 2084,
     /* 162882 */     GIR_EraseRootFromParent_Done,
     /* 162883 */   // Label 3144: @162883
     /* 162883 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(162964), // Rule ID 1991 //
     /* 162888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 162921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162946 */     // MIs[2] Operand 1
     /* 162946 */     // No operand predicates
     /* 162946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162948 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 162951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162962 */     GIR_RootConstrainSelectedInstOperands,
     /* 162963 */     // GIR_Coverage, 1991,
     /* 162963 */     GIR_EraseRootFromParent_Done,
     /* 162964 */   // Label 3145: @162964
     /* 162964 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163045), // Rule ID 1992 //
     /* 162969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163027 */     // MIs[2] Operand 1
     /* 163027 */     // No operand predicates
     /* 163027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163029 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 163032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163043 */     GIR_RootConstrainSelectedInstOperands,
     /* 163044 */     // GIR_Coverage, 1992,
     /* 163044 */     GIR_EraseRootFromParent_Done,
     /* 163045 */   // Label 3146: @163045
     /* 163045 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163126), // Rule ID 2021 //
     /* 163050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163108 */     // MIs[2] Operand 1
     /* 163108 */     // No operand predicates
     /* 163108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163110 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 163113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163124 */     GIR_RootConstrainSelectedInstOperands,
     /* 163125 */     // GIR_Coverage, 2021,
     /* 163125 */     GIR_EraseRootFromParent_Done,
     /* 163126 */   // Label 3147: @163126
     /* 163126 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163207), // Rule ID 2022 //
     /* 163131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163185 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163189 */     // MIs[2] Operand 1
     /* 163189 */     // No operand predicates
     /* 163189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163191 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 163194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163205 */     GIR_RootConstrainSelectedInstOperands,
     /* 163206 */     // GIR_Coverage, 2022,
     /* 163206 */     GIR_EraseRootFromParent_Done,
     /* 163207 */   // Label 3148: @163207
     /* 163207 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163288), // Rule ID 2028 //
     /* 163212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163270 */     // MIs[2] Operand 1
     /* 163270 */     // No operand predicates
     /* 163270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163272 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 163275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163286 */     GIR_RootConstrainSelectedInstOperands,
     /* 163287 */     // GIR_Coverage, 2028,
     /* 163287 */     GIR_EraseRootFromParent_Done,
     /* 163288 */   // Label 3149: @163288
     /* 163288 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163369), // Rule ID 2029 //
     /* 163293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163351 */     // MIs[2] Operand 1
     /* 163351 */     // No operand predicates
     /* 163351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163353 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 163356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163367 */     GIR_RootConstrainSelectedInstOperands,
     /* 163368 */     // GIR_Coverage, 2029,
     /* 163368 */     GIR_EraseRootFromParent_Done,
     /* 163369 */   // Label 3150: @163369
     /* 163369 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163450), // Rule ID 2087 //
     /* 163374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 163382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163428 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163432 */     // MIs[2] Operand 1
     /* 163432 */     // No operand predicates
     /* 163432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163434 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 163437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163448 */     GIR_RootConstrainSelectedInstOperands,
     /* 163449 */     // GIR_Coverage, 2087,
     /* 163449 */     GIR_EraseRootFromParent_Done,
     /* 163450 */   // Label 3151: @163450
     /* 163450 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163531), // Rule ID 1993 //
     /* 163455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 163488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 163513 */     // MIs[2] Operand 1
     /* 163513 */     // No operand predicates
     /* 163513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163515 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 163518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163529 */     GIR_RootConstrainSelectedInstOperands,
     /* 163530 */     // GIR_Coverage, 1993,
     /* 163530 */     GIR_EraseRootFromParent_Done,
     /* 163531 */   // Label 3152: @163531
     /* 163531 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163612), // Rule ID 1994 //
     /* 163536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 163553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 163573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 163582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 163594 */     // MIs[2] Operand 1
     /* 163594 */     // No operand predicates
     /* 163594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163596 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163610 */     GIR_RootConstrainSelectedInstOperands,
     /* 163611 */     // GIR_Coverage, 1994,
     /* 163611 */     GIR_EraseRootFromParent_Done,
     /* 163612 */   // Label 3153: @163612
     /* 163612 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163693), // Rule ID 1995 //
     /* 163617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163671 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163675 */     // MIs[2] Operand 1
     /* 163675 */     // No operand predicates
     /* 163675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163677 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 163680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163691 */     GIR_RootConstrainSelectedInstOperands,
     /* 163692 */     // GIR_Coverage, 1995,
     /* 163692 */     GIR_EraseRootFromParent_Done,
     /* 163693 */   // Label 3154: @163693
     /* 163693 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163774), // Rule ID 1996 //
     /* 163698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 163756 */     // MIs[2] Operand 1
     /* 163756 */     // No operand predicates
     /* 163756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163758 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 163761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163772 */     GIR_RootConstrainSelectedInstOperands,
     /* 163773 */     // GIR_Coverage, 1996,
     /* 163773 */     GIR_EraseRootFromParent_Done,
     /* 163774 */   // Label 3155: @163774
     /* 163774 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163855), // Rule ID 2023 //
     /* 163779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163837 */     // MIs[2] Operand 1
     /* 163837 */     // No operand predicates
     /* 163837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163839 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 163842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163853 */     GIR_RootConstrainSelectedInstOperands,
     /* 163854 */     // GIR_Coverage, 2023,
     /* 163854 */     GIR_EraseRootFromParent_Done,
     /* 163855 */   // Label 3156: @163855
     /* 163855 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163936), // Rule ID 2030 //
     /* 163860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163918 */     // MIs[2] Operand 1
     /* 163918 */     // No operand predicates
     /* 163918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163920 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 163923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163934 */     GIR_RootConstrainSelectedInstOperands,
     /* 163935 */     // GIR_Coverage, 2030,
     /* 163935 */     GIR_EraseRootFromParent_Done,
     /* 163936 */   // Label 3157: @163936
     /* 163936 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164014), // Rule ID 6275 //
     /* 163941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 163946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163996 */     // MIs[2] Operand 1
     /* 163996 */     // No operand predicates
     /* 163996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163998 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 163998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 164001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 164009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 164012 */     GIR_RootConstrainSelectedInstOperands,
     /* 164013 */     // GIR_Coverage, 6275,
     /* 164013 */     GIR_EraseRootFromParent_Done,
     /* 164014 */   // Label 3158: @164014
     /* 164014 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164074), // Rule ID 6341 //
     /* 164019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 164045 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 164045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 164048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164057 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 164065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164072 */     GIR_RootConstrainSelectedInstOperands,
     /* 164073 */     // GIR_Coverage, 6341,
     /* 164073 */     GIR_EraseRootFromParent_Done,
     /* 164074 */   // Label 3159: @164074
     /* 164074 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164134), // Rule ID 6342 //
     /* 164079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 164105 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 164105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 164108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 164125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164132 */     GIR_RootConstrainSelectedInstOperands,
     /* 164133 */     // GIR_Coverage, 6342,
     /* 164133 */     GIR_EraseRootFromParent_Done,
     /* 164134 */   // Label 3160: @164134
     /* 164134 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164194), // Rule ID 6343 //
     /* 164139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 164165 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 164165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 164168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 164185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164192 */     GIR_RootConstrainSelectedInstOperands,
     /* 164193 */     // GIR_Coverage, 6343,
     /* 164193 */     GIR_EraseRootFromParent_Done,
     /* 164194 */   // Label 3161: @164194
     /* 164194 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164241), // Rule ID 3897 //
     /* 164199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164221 */     // MIs[0] Operand 3
     /* 164221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 164232 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 164235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164239 */     GIR_RootConstrainSelectedInstOperands,
     /* 164240 */     // GIR_Coverage, 3897,
     /* 164240 */     GIR_EraseRootFromParent_Done,
     /* 164241 */   // Label 3162: @164241
     /* 164241 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164288), // Rule ID 3898 //
     /* 164246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164268 */     // MIs[0] Operand 3
     /* 164268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 164279 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 164282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164286 */     GIR_RootConstrainSelectedInstOperands,
     /* 164287 */     // GIR_Coverage, 3898,
     /* 164287 */     GIR_EraseRootFromParent_Done,
     /* 164288 */   // Label 3163: @164288
     /* 164288 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164335), // Rule ID 3899 //
     /* 164293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164315 */     // MIs[0] Operand 3
     /* 164315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 164326 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 164329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164333 */     GIR_RootConstrainSelectedInstOperands,
     /* 164334 */     // GIR_Coverage, 3899,
     /* 164334 */     GIR_EraseRootFromParent_Done,
     /* 164335 */   // Label 3164: @164335
     /* 164335 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164382), // Rule ID 3900 //
     /* 164340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164362 */     // MIs[0] Operand 3
     /* 164362 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 164373 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 164376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164380 */     GIR_RootConstrainSelectedInstOperands,
     /* 164381 */     // GIR_Coverage, 3900,
     /* 164381 */     GIR_EraseRootFromParent_Done,
     /* 164382 */   // Label 3165: @164382
     /* 164382 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164428), // Rule ID 3544 //
     /* 164387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 164398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164409 */     // MIs[0] Idx
     /* 164409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 164417 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 164417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 164420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164426 */     GIR_RootConstrainSelectedInstOperands,
     /* 164427 */     // GIR_Coverage, 3544,
     /* 164427 */     GIR_EraseRootFromParent_Done,
     /* 164428 */   // Label 3166: @164428
     /* 164428 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164474), // Rule ID 3545 //
     /* 164433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 164444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164455 */     // MIs[0] Idx
     /* 164455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 164463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 164463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 164466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164472 */     GIR_RootConstrainSelectedInstOperands,
     /* 164473 */     // GIR_Coverage, 3545,
     /* 164473 */     GIR_EraseRootFromParent_Done,
     /* 164474 */   // Label 3167: @164474
     /* 164474 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164520), // Rule ID 3546 //
     /* 164479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 164490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164501 */     // MIs[0] Idx
     /* 164501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 164509 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 164509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 164512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164518 */     GIR_RootConstrainSelectedInstOperands,
     /* 164519 */     // GIR_Coverage, 3546,
     /* 164519 */     GIR_EraseRootFromParent_Done,
     /* 164520 */   // Label 3168: @164520
     /* 164520 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164566), // Rule ID 3547 //
     /* 164525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 164536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164547 */     // MIs[0] Idx
     /* 164547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 164555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 164555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 164558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164564 */     GIR_RootConstrainSelectedInstOperands,
     /* 164565 */     // GIR_Coverage, 3547,
     /* 164565 */     GIR_EraseRootFromParent_Done,
     /* 164566 */   // Label 3169: @164566
     /* 164566 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164622), // Rule ID 2109 //
     /* 164571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 164579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164608 */     // MIs[1] Operand 1
     /* 164608 */     // No operand predicates
     /* 164608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164610 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 164613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164620 */     GIR_RootConstrainSelectedInstOperands,
     /* 164621 */     // GIR_Coverage, 2109,
     /* 164621 */     GIR_EraseRootFromParent_Done,
     /* 164622 */   // Label 3170: @164622
     /* 164622 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164678), // Rule ID 2110 //
     /* 164627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 164635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164664 */     // MIs[1] Operand 1
     /* 164664 */     // No operand predicates
     /* 164664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164666 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 164669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164676 */     GIR_RootConstrainSelectedInstOperands,
     /* 164677 */     // GIR_Coverage, 2110,
     /* 164677 */     GIR_EraseRootFromParent_Done,
     /* 164678 */   // Label 3171: @164678
     /* 164678 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(164734), // Rule ID 2115 //
     /* 164683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 164691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164720 */     // MIs[1] Operand 1
     /* 164720 */     // No operand predicates
     /* 164720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164722 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 164725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164732 */     GIR_RootConstrainSelectedInstOperands,
     /* 164733 */     // GIR_Coverage, 2115,
     /* 164733 */     GIR_EraseRootFromParent_Done,
     /* 164734 */   // Label 3172: @164734
     /* 164734 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(164790), // Rule ID 2116 //
     /* 164739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 164747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164776 */     // MIs[1] Operand 1
     /* 164776 */     // No operand predicates
     /* 164776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164778 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 164781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164788 */     GIR_RootConstrainSelectedInstOperands,
     /* 164789 */     // GIR_Coverage, 2116,
     /* 164789 */     GIR_EraseRootFromParent_Done,
     /* 164790 */   // Label 3173: @164790
     /* 164790 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164846), // Rule ID 2123 //
     /* 164795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 164803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164832 */     // MIs[1] Operand 1
     /* 164832 */     // No operand predicates
     /* 164832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164834 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 164837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164844 */     GIR_RootConstrainSelectedInstOperands,
     /* 164845 */     // GIR_Coverage, 2123,
     /* 164845 */     GIR_EraseRootFromParent_Done,
     /* 164846 */   // Label 3174: @164846
     /* 164846 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164902), // Rule ID 2126 //
     /* 164851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 164859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164888 */     // MIs[1] Operand 1
     /* 164888 */     // No operand predicates
     /* 164888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164890 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 164893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164900 */     GIR_RootConstrainSelectedInstOperands,
     /* 164901 */     // GIR_Coverage, 2126,
     /* 164901 */     GIR_EraseRootFromParent_Done,
     /* 164902 */   // Label 3175: @164902
     /* 164902 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164958), // Rule ID 2148 //
     /* 164907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 164944 */     // MIs[1] Operand 1
     /* 164944 */     // No operand predicates
     /* 164944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164946 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 164949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164956 */     GIR_RootConstrainSelectedInstOperands,
     /* 164957 */     // GIR_Coverage, 2148,
     /* 164957 */     GIR_EraseRootFromParent_Done,
     /* 164958 */   // Label 3176: @164958
     /* 164958 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165014), // Rule ID 2150 //
     /* 164963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 165000 */     // MIs[1] Operand 1
     /* 165000 */     // No operand predicates
     /* 165000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165002 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165012 */     GIR_RootConstrainSelectedInstOperands,
     /* 165013 */     // GIR_Coverage, 2150,
     /* 165013 */     GIR_EraseRootFromParent_Done,
     /* 165014 */   // Label 3177: @165014
     /* 165014 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165070), // Rule ID 2152 //
     /* 165019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 165027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 165056 */     // MIs[1] Operand 1
     /* 165056 */     // No operand predicates
     /* 165056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165058 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 165061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165068 */     GIR_RootConstrainSelectedInstOperands,
     /* 165069 */     // GIR_Coverage, 2152,
     /* 165069 */     GIR_EraseRootFromParent_Done,
     /* 165070 */   // Label 3178: @165070
     /* 165070 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165123), // Rule ID 6276 //
     /* 165075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165109 */     // MIs[1] Operand 1
     /* 165109 */     // No operand predicates
     /* 165109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165111 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165121 */     GIR_RootConstrainSelectedInstOperands,
     /* 165122 */     // GIR_Coverage, 6276,
     /* 165122 */     GIR_EraseRootFromParent_Done,
     /* 165123 */   // Label 3179: @165123
     /* 165123 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165176), // Rule ID 6277 //
     /* 165128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165162 */     // MIs[1] Operand 1
     /* 165162 */     // No operand predicates
     /* 165162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165164 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 165167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165174 */     GIR_RootConstrainSelectedInstOperands,
     /* 165175 */     // GIR_Coverage, 6277,
     /* 165175 */     GIR_EraseRootFromParent_Done,
     /* 165176 */   // Label 3180: @165176
     /* 165176 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165229), // Rule ID 6278 //
     /* 165181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165215 */     // MIs[1] Operand 1
     /* 165215 */     // No operand predicates
     /* 165215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165217 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 165220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165227 */     GIR_RootConstrainSelectedInstOperands,
     /* 165228 */     // GIR_Coverage, 6278,
     /* 165228 */     GIR_EraseRootFromParent_Done,
     /* 165229 */   // Label 3181: @165229
     /* 165229 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165282), // Rule ID 6279 //
     /* 165234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165268 */     // MIs[1] Operand 1
     /* 165268 */     // No operand predicates
     /* 165268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165270 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 165273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165280 */     GIR_RootConstrainSelectedInstOperands,
     /* 165281 */     // GIR_Coverage, 6279,
     /* 165281 */     GIR_EraseRootFromParent_Done,
     /* 165282 */   // Label 3182: @165282
     /* 165282 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165335), // Rule ID 6280 //
     /* 165287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165321 */     // MIs[1] Operand 1
     /* 165321 */     // No operand predicates
     /* 165321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165323 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 165326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165333 */     GIR_RootConstrainSelectedInstOperands,
     /* 165334 */     // GIR_Coverage, 6280,
     /* 165334 */     GIR_EraseRootFromParent_Done,
     /* 165335 */   // Label 3183: @165335
     /* 165335 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165388), // Rule ID 6281 //
     /* 165340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165374 */     // MIs[1] Operand 1
     /* 165374 */     // No operand predicates
     /* 165374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165376 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 165379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165386 */     GIR_RootConstrainSelectedInstOperands,
     /* 165387 */     // GIR_Coverage, 6281,
     /* 165387 */     GIR_EraseRootFromParent_Done,
     /* 165388 */   // Label 3184: @165388
     /* 165388 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165441), // Rule ID 6282 //
     /* 165393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165427 */     // MIs[1] Operand 1
     /* 165427 */     // No operand predicates
     /* 165427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165429 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 165432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165439 */     GIR_RootConstrainSelectedInstOperands,
     /* 165440 */     // GIR_Coverage, 6282,
     /* 165440 */     GIR_EraseRootFromParent_Done,
     /* 165441 */   // Label 3185: @165441
     /* 165441 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165494), // Rule ID 6283 //
     /* 165446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165480 */     // MIs[1] Operand 1
     /* 165480 */     // No operand predicates
     /* 165480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165482 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 165485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165492 */     GIR_RootConstrainSelectedInstOperands,
     /* 165493 */     // GIR_Coverage, 6283,
     /* 165493 */     GIR_EraseRootFromParent_Done,
     /* 165494 */   // Label 3186: @165494
     /* 165494 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165547), // Rule ID 6284 //
     /* 165499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165533 */     // MIs[1] Operand 1
     /* 165533 */     // No operand predicates
     /* 165533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165535 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 165538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165545 */     GIR_RootConstrainSelectedInstOperands,
     /* 165546 */     // GIR_Coverage, 6284,
     /* 165546 */     GIR_EraseRootFromParent_Done,
     /* 165547 */   // Label 3187: @165547
     /* 165547 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165600), // Rule ID 6285 //
     /* 165552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165586 */     // MIs[1] Operand 1
     /* 165586 */     // No operand predicates
     /* 165586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165588 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 165591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165598 */     GIR_RootConstrainSelectedInstOperands,
     /* 165599 */     // GIR_Coverage, 6285,
     /* 165599 */     GIR_EraseRootFromParent_Done,
     /* 165600 */   // Label 3188: @165600
     /* 165600 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165653), // Rule ID 6286 //
     /* 165605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165639 */     // MIs[1] Operand 1
     /* 165639 */     // No operand predicates
     /* 165639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165641 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 165644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165651 */     GIR_RootConstrainSelectedInstOperands,
     /* 165652 */     // GIR_Coverage, 6286,
     /* 165652 */     GIR_EraseRootFromParent_Done,
     /* 165653 */   // Label 3189: @165653
     /* 165653 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165706), // Rule ID 6287 //
     /* 165658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165692 */     // MIs[1] Operand 1
     /* 165692 */     // No operand predicates
     /* 165692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165694 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 165697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165704 */     GIR_RootConstrainSelectedInstOperands,
     /* 165705 */     // GIR_Coverage, 6287,
     /* 165705 */     GIR_EraseRootFromParent_Done,
     /* 165706 */   // Label 3190: @165706
     /* 165706 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165788), // Rule ID 6289 //
     /* 165711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165745 */     // MIs[1] Operand 1
     /* 165745 */     // No operand predicates
     /* 165745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165747 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165759 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 165778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165786 */     GIR_RootConstrainSelectedInstOperands,
     /* 165787 */     // GIR_Coverage, 6289,
     /* 165787 */     GIR_EraseRootFromParent_Done,
     /* 165788 */   // Label 3191: @165788
     /* 165788 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165870), // Rule ID 6290 //
     /* 165793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165827 */     // MIs[1] Operand 1
     /* 165827 */     // No operand predicates
     /* 165827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165829 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 165860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165868 */     GIR_RootConstrainSelectedInstOperands,
     /* 165869 */     // GIR_Coverage, 6290,
     /* 165869 */     GIR_EraseRootFromParent_Done,
     /* 165870 */   // Label 3192: @165870
     /* 165870 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165952), // Rule ID 6292 //
     /* 165875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165909 */     // MIs[1] Operand 1
     /* 165909 */     // No operand predicates
     /* 165909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165911 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 165942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165950 */     GIR_RootConstrainSelectedInstOperands,
     /* 165951 */     // GIR_Coverage, 6292,
     /* 165951 */     GIR_EraseRootFromParent_Done,
     /* 165952 */   // Label 3193: @165952
     /* 165952 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166034), // Rule ID 6293 //
     /* 165957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165991 */     // MIs[1] Operand 1
     /* 165991 */     // No operand predicates
     /* 165991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165993 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166005 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 166011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 166024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166032 */     GIR_RootConstrainSelectedInstOperands,
     /* 166033 */     // GIR_Coverage, 6293,
     /* 166033 */     GIR_EraseRootFromParent_Done,
     /* 166034 */   // Label 3194: @166034
     /* 166034 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166140), // Rule ID 6294 //
     /* 166039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 166073 */     // MIs[1] Operand 1
     /* 166073 */     // No operand predicates
     /* 166073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166075 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 166075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 166082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 166099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166139 */     // GIR_Coverage, 6294,
     /* 166139 */     GIR_EraseRootFromParent_Done,
     /* 166140 */   // Label 3195: @166140
     /* 166140 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166246), // Rule ID 6295 //
     /* 166145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 166179 */     // MIs[1] Operand 1
     /* 166179 */     // No operand predicates
     /* 166179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166181 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 166181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 166188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166245 */     // GIR_Coverage, 6295,
     /* 166245 */     GIR_EraseRootFromParent_Done,
     /* 166246 */   // Label 3196: @166246
     /* 166246 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166352), // Rule ID 6296 //
     /* 166251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 166285 */     // MIs[1] Operand 1
     /* 166285 */     // No operand predicates
     /* 166285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166287 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 166287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 166294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 166311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166351 */     // GIR_Coverage, 6296,
     /* 166351 */     GIR_EraseRootFromParent_Done,
     /* 166352 */   // Label 3197: @166352
     /* 166352 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166458), // Rule ID 6297 //
     /* 166357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 166391 */     // MIs[1] Operand 1
     /* 166391 */     // No operand predicates
     /* 166391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166393 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 166393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 166400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166457 */     // GIR_Coverage, 6297,
     /* 166457 */     GIR_EraseRootFromParent_Done,
     /* 166458 */   // Label 3198: @166458
     /* 166458 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166516), // Rule ID 6986 //
     /* 166463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 166468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 166497 */     // MIs[1] Operand 1
     /* 166497 */     // No operand predicates
     /* 166497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166499 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 166499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 166502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166506 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 166511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 166514 */     GIR_RootConstrainSelectedInstOperands,
     /* 166515 */     // GIR_Coverage, 6986,
     /* 166515 */     GIR_EraseRootFromParent_Done,
     /* 166516 */   // Label 3199: @166516
     /* 166516 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166558), // Rule ID 3045 //
     /* 166521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166539 */     // MIs[0] Op2
     /* 166539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 166550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166556 */     GIR_RootConstrainSelectedInstOperands,
     /* 166557 */     // GIR_Coverage, 3045,
     /* 166557 */     GIR_EraseRootFromParent_Done,
     /* 166558 */   // Label 3200: @166558
     /* 166558 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166600), // Rule ID 3046 //
     /* 166563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166581 */     // MIs[0] Op2
     /* 166581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 166592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166598 */     GIR_RootConstrainSelectedInstOperands,
     /* 166599 */     // GIR_Coverage, 3046,
     /* 166599 */     GIR_EraseRootFromParent_Done,
     /* 166600 */   // Label 3201: @166600
     /* 166600 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166642), // Rule ID 3047 //
     /* 166605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166623 */     // MIs[0] Op2
     /* 166623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 166634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166640 */     GIR_RootConstrainSelectedInstOperands,
     /* 166641 */     // GIR_Coverage, 3047,
     /* 166641 */     GIR_EraseRootFromParent_Done,
     /* 166642 */   // Label 3202: @166642
     /* 166642 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166684), // Rule ID 3081 //
     /* 166647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166665 */     // MIs[0] Op2
     /* 166665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 166673 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166682 */     GIR_RootConstrainSelectedInstOperands,
     /* 166683 */     // GIR_Coverage, 3081,
     /* 166683 */     GIR_EraseRootFromParent_Done,
     /* 166684 */   // Label 3203: @166684
     /* 166684 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166726), // Rule ID 3082 //
     /* 166689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166707 */     // MIs[0] Op2
     /* 166707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 166718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166724 */     GIR_RootConstrainSelectedInstOperands,
     /* 166725 */     // GIR_Coverage, 3082,
     /* 166725 */     GIR_EraseRootFromParent_Done,
     /* 166726 */   // Label 3204: @166726
     /* 166726 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166768), // Rule ID 3083 //
     /* 166731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166749 */     // MIs[0] Op2
     /* 166749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 166760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166766 */     GIR_RootConstrainSelectedInstOperands,
     /* 166767 */     // GIR_Coverage, 3083,
     /* 166767 */     GIR_EraseRootFromParent_Done,
     /* 166768 */   // Label 3205: @166768
     /* 166768 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166810), // Rule ID 3530 //
     /* 166773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166791 */     // MIs[0] Op2
     /* 166791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 166799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1345:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 166799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 166802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166808 */     GIR_RootConstrainSelectedInstOperands,
     /* 166809 */     // GIR_Coverage, 3530,
     /* 166809 */     GIR_EraseRootFromParent_Done,
     /* 166810 */   // Label 3206: @166810
     /* 166810 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166852), // Rule ID 3531 //
     /* 166815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166833 */     // MIs[0] Op2
     /* 166833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 166841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1345:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 166841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 166844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166850 */     GIR_RootConstrainSelectedInstOperands,
     /* 166851 */     // GIR_Coverage, 3531,
     /* 166851 */     GIR_EraseRootFromParent_Done,
     /* 166852 */   // Label 3207: @166852
     /* 166852 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166894), // Rule ID 3532 //
     /* 166857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166875 */     // MIs[0] Op2
     /* 166875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 166883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1345:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 166883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 166886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166892 */     GIR_RootConstrainSelectedInstOperands,
     /* 166893 */     // GIR_Coverage, 3532,
     /* 166893 */     GIR_EraseRootFromParent_Done,
     /* 166894 */   // Label 3208: @166894
     /* 166894 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166936), // Rule ID 3533 //
     /* 166899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166917 */     // MIs[0] Op2
     /* 166917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 166925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1345:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 166925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 166928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166934 */     GIR_RootConstrainSelectedInstOperands,
     /* 166935 */     // GIR_Coverage, 3533,
     /* 166935 */     GIR_EraseRootFromParent_Done,
     /* 166936 */   // Label 3209: @166936
     /* 166936 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166978), // Rule ID 3534 //
     /* 166941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166959 */     // MIs[0] Op2
     /* 166959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 166967 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 166967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 166970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166976 */     GIR_RootConstrainSelectedInstOperands,
     /* 166977 */     // GIR_Coverage, 3534,
     /* 166977 */     GIR_EraseRootFromParent_Done,
     /* 166978 */   // Label 3210: @166978
     /* 166978 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(167020), // Rule ID 3535 //
     /* 166983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167001 */     // MIs[0] Op2
     /* 167001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 167009 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 167009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 167012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167018 */     GIR_RootConstrainSelectedInstOperands,
     /* 167019 */     // GIR_Coverage, 3535,
     /* 167019 */     GIR_EraseRootFromParent_Done,
     /* 167020 */   // Label 3211: @167020
     /* 167020 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(167062), // Rule ID 3536 //
     /* 167025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 167033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 167036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167043 */     // MIs[0] Op2
     /* 167043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 167051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 167051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 167054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167060 */     GIR_RootConstrainSelectedInstOperands,
     /* 167061 */     // GIR_Coverage, 3536,
     /* 167061 */     GIR_EraseRootFromParent_Done,
     /* 167062 */   // Label 3212: @167062
     /* 167062 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(167104), // Rule ID 11771 //
     /* 167067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167085 */     // MIs[0] Op2
     /* 167085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 167096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167102 */     GIR_RootConstrainSelectedInstOperands,
     /* 167103 */     // GIR_Coverage, 11771,
     /* 167103 */     GIR_EraseRootFromParent_Done,
     /* 167104 */   // Label 3213: @167104
     /* 167104 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167146), // Rule ID 11772 //
     /* 167109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167127 */     // MIs[0] Op2
     /* 167127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 167138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167144 */     GIR_RootConstrainSelectedInstOperands,
     /* 167145 */     // GIR_Coverage, 11772,
     /* 167145 */     GIR_EraseRootFromParent_Done,
     /* 167146 */   // Label 3214: @167146
     /* 167146 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167188), // Rule ID 11773 //
     /* 167151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167169 */     // MIs[0] Op2
     /* 167169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 167180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167186 */     GIR_RootConstrainSelectedInstOperands,
     /* 167187 */     // GIR_Coverage, 11773,
     /* 167187 */     GIR_EraseRootFromParent_Done,
     /* 167188 */   // Label 3215: @167188
     /* 167188 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167230), // Rule ID 11774 //
     /* 167193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167211 */     // MIs[0] Op2
     /* 167211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 167222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167228 */     GIR_RootConstrainSelectedInstOperands,
     /* 167229 */     // GIR_Coverage, 11774,
     /* 167229 */     GIR_EraseRootFromParent_Done,
     /* 167230 */   // Label 3216: @167230
     /* 167230 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167272), // Rule ID 11775 //
     /* 167235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167253 */     // MIs[0] Op2
     /* 167253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 167264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167270 */     GIR_RootConstrainSelectedInstOperands,
     /* 167271 */     // GIR_Coverage, 11775,
     /* 167271 */     GIR_EraseRootFromParent_Done,
     /* 167272 */   // Label 3217: @167272
     /* 167272 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167314), // Rule ID 11776 //
     /* 167277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167295 */     // MIs[0] Op2
     /* 167295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 167306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167312 */     GIR_RootConstrainSelectedInstOperands,
     /* 167313 */     // GIR_Coverage, 11776,
     /* 167313 */     GIR_EraseRootFromParent_Done,
     /* 167314 */   // Label 3218: @167314
     /* 167314 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167356), // Rule ID 11778 //
     /* 167319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167337 */     // MIs[0] Op2
     /* 167337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 167348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167354 */     GIR_RootConstrainSelectedInstOperands,
     /* 167355 */     // GIR_Coverage, 11778,
     /* 167355 */     GIR_EraseRootFromParent_Done,
     /* 167356 */   // Label 3219: @167356
     /* 167356 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167398), // Rule ID 11780 //
     /* 167361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167379 */     // MIs[0] Op2
     /* 167379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167387 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 167390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167396 */     GIR_RootConstrainSelectedInstOperands,
     /* 167397 */     // GIR_Coverage, 11780,
     /* 167397 */     GIR_EraseRootFromParent_Done,
     /* 167398 */   // Label 3220: @167398
     /* 167398 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167440), // Rule ID 11782 //
     /* 167403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167421 */     // MIs[0] Op2
     /* 167421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 167432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167438 */     GIR_RootConstrainSelectedInstOperands,
     /* 167439 */     // GIR_Coverage, 11782,
     /* 167439 */     GIR_EraseRootFromParent_Done,
     /* 167440 */   // Label 3221: @167440
     /* 167440 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167482), // Rule ID 11783 //
     /* 167445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167463 */     // MIs[0] Op2
     /* 167463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 167474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167480 */     GIR_RootConstrainSelectedInstOperands,
     /* 167481 */     // GIR_Coverage, 11783,
     /* 167481 */     GIR_EraseRootFromParent_Done,
     /* 167482 */   // Label 3222: @167482
     /* 167482 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167524), // Rule ID 11784 //
     /* 167487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167505 */     // MIs[0] Op2
     /* 167505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 167516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167522 */     GIR_RootConstrainSelectedInstOperands,
     /* 167523 */     // GIR_Coverage, 11784,
     /* 167523 */     GIR_EraseRootFromParent_Done,
     /* 167524 */   // Label 3223: @167524
     /* 167524 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167566), // Rule ID 11785 //
     /* 167529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167547 */     // MIs[0] Op2
     /* 167547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 167558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167564 */     GIR_RootConstrainSelectedInstOperands,
     /* 167565 */     // GIR_Coverage, 11785,
     /* 167565 */     GIR_EraseRootFromParent_Done,
     /* 167566 */   // Label 3224: @167566
     /* 167566 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167608), // Rule ID 11786 //
     /* 167571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167589 */     // MIs[0] Op2
     /* 167589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 167600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167606 */     GIR_RootConstrainSelectedInstOperands,
     /* 167607 */     // GIR_Coverage, 11786,
     /* 167607 */     GIR_EraseRootFromParent_Done,
     /* 167608 */   // Label 3225: @167608
     /* 167608 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167650), // Rule ID 11787 //
     /* 167613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167631 */     // MIs[0] Op2
     /* 167631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 167642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167648 */     GIR_RootConstrainSelectedInstOperands,
     /* 167649 */     // GIR_Coverage, 11787,
     /* 167649 */     GIR_EraseRootFromParent_Done,
     /* 167650 */   // Label 3226: @167650
     /* 167650 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167692), // Rule ID 11788 //
     /* 167655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167673 */     // MIs[0] Op2
     /* 167673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 167684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167690 */     GIR_RootConstrainSelectedInstOperands,
     /* 167691 */     // GIR_Coverage, 11788,
     /* 167691 */     GIR_EraseRootFromParent_Done,
     /* 167692 */   // Label 3227: @167692
     /* 167692 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167734), // Rule ID 11789 //
     /* 167697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167715 */     // MIs[0] Op2
     /* 167715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 167726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167732 */     GIR_RootConstrainSelectedInstOperands,
     /* 167733 */     // GIR_Coverage, 11789,
     /* 167733 */     GIR_EraseRootFromParent_Done,
     /* 167734 */   // Label 3228: @167734
     /* 167734 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167776), // Rule ID 11790 //
     /* 167739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167757 */     // MIs[0] Op2
     /* 167757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 167768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167774 */     GIR_RootConstrainSelectedInstOperands,
     /* 167775 */     // GIR_Coverage, 11790,
     /* 167775 */     GIR_EraseRootFromParent_Done,
     /* 167776 */   // Label 3229: @167776
     /* 167776 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167818), // Rule ID 11791 //
     /* 167781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167799 */     // MIs[0] Op2
     /* 167799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 167810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167816 */     GIR_RootConstrainSelectedInstOperands,
     /* 167817 */     // GIR_Coverage, 11791,
     /* 167817 */     GIR_EraseRootFromParent_Done,
     /* 167818 */   // Label 3230: @167818
     /* 167818 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167860), // Rule ID 11792 //
     /* 167823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167841 */     // MIs[0] Op2
     /* 167841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 167852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167858 */     GIR_RootConstrainSelectedInstOperands,
     /* 167859 */     // GIR_Coverage, 11792,
     /* 167859 */     GIR_EraseRootFromParent_Done,
     /* 167860 */   // Label 3231: @167860
     /* 167860 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167902), // Rule ID 11793 //
     /* 167865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167883 */     // MIs[0] Op2
     /* 167883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167900 */     GIR_RootConstrainSelectedInstOperands,
     /* 167901 */     // GIR_Coverage, 11793,
     /* 167901 */     GIR_EraseRootFromParent_Done,
     /* 167902 */   // Label 3232: @167902
     /* 167902 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167944), // Rule ID 11794 //
     /* 167907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167925 */     // MIs[0] Op2
     /* 167925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 167936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167942 */     GIR_RootConstrainSelectedInstOperands,
     /* 167943 */     // GIR_Coverage, 11794,
     /* 167943 */     GIR_EraseRootFromParent_Done,
     /* 167944 */   // Label 3233: @167944
     /* 167944 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167986), // Rule ID 11852 //
     /* 167949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 167957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167967 */     // MIs[0] Op2
     /* 167967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 167975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 167975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 167978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167984 */     GIR_RootConstrainSelectedInstOperands,
     /* 167985 */     // GIR_Coverage, 11852,
     /* 167985 */     GIR_EraseRootFromParent_Done,
     /* 167986 */   // Label 3234: @167986
     /* 167986 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168028), // Rule ID 11853 //
     /* 167991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 167999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 168005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168009 */     // MIs[0] Op2
     /* 168009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 168020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168026 */     GIR_RootConstrainSelectedInstOperands,
     /* 168027 */     // GIR_Coverage, 11853,
     /* 168027 */     GIR_EraseRootFromParent_Done,
     /* 168028 */   // Label 3235: @168028
     /* 168028 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168070), // Rule ID 11854 //
     /* 168033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 168041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168051 */     // MIs[0] Op2
     /* 168051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 168062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168068 */     GIR_RootConstrainSelectedInstOperands,
     /* 168069 */     // GIR_Coverage, 11854,
     /* 168069 */     GIR_EraseRootFromParent_Done,
     /* 168070 */   // Label 3236: @168070
     /* 168070 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168112), // Rule ID 11855 //
     /* 168075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 168086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 168089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168093 */     // MIs[0] Op2
     /* 168093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 168101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 168101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 168104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168110 */     GIR_RootConstrainSelectedInstOperands,
     /* 168111 */     // GIR_Coverage, 11855,
     /* 168111 */     GIR_EraseRootFromParent_Done,
     /* 168112 */   // Label 3237: @168112
     /* 168112 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168154), // Rule ID 11856 //
     /* 168117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 168131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168135 */     // MIs[0] Op2
     /* 168135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 168146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168152 */     GIR_RootConstrainSelectedInstOperands,
     /* 168153 */     // GIR_Coverage, 11856,
     /* 168153 */     GIR_EraseRootFromParent_Done,
     /* 168154 */   // Label 3238: @168154
     /* 168154 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168196), // Rule ID 11857 //
     /* 168159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168177 */     // MIs[0] Op2
     /* 168177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 168188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168194 */     GIR_RootConstrainSelectedInstOperands,
     /* 168195 */     // GIR_Coverage, 11857,
     /* 168195 */     GIR_EraseRootFromParent_Done,
     /* 168196 */   // Label 3239: @168196
     /* 168196 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168238), // Rule ID 11858 //
     /* 168201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 168212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 168215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168219 */     // MIs[0] Op2
     /* 168219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 168227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 168227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 168230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168236 */     GIR_RootConstrainSelectedInstOperands,
     /* 168237 */     // GIR_Coverage, 11858,
     /* 168237 */     GIR_EraseRootFromParent_Done,
     /* 168238 */   // Label 3240: @168238
     /* 168238 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168280), // Rule ID 11859 //
     /* 168243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 168257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168261 */     // MIs[0] Op2
     /* 168261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 168272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168278 */     GIR_RootConstrainSelectedInstOperands,
     /* 168279 */     // GIR_Coverage, 11859,
     /* 168279 */     GIR_EraseRootFromParent_Done,
     /* 168280 */   // Label 3241: @168280
     /* 168280 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168322), // Rule ID 11860 //
     /* 168285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168303 */     // MIs[0] Op2
     /* 168303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 168314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168320 */     GIR_RootConstrainSelectedInstOperands,
     /* 168321 */     // GIR_Coverage, 11860,
     /* 168321 */     GIR_EraseRootFromParent_Done,
     /* 168322 */   // Label 3242: @168322
     /* 168322 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168374), // Rule ID 2132 //
     /* 168327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168360 */     // MIs[1] Operand 1
     /* 168360 */     // No operand predicates
     /* 168360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168362 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 168365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168372 */     GIR_RootConstrainSelectedInstOperands,
     /* 168373 */     // GIR_Coverage, 2132,
     /* 168373 */     GIR_EraseRootFromParent_Done,
     /* 168374 */   // Label 3243: @168374
     /* 168374 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168426), // Rule ID 2133 //
     /* 168379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168412 */     // MIs[1] Operand 1
     /* 168412 */     // No operand predicates
     /* 168412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168414 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 168417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168424 */     GIR_RootConstrainSelectedInstOperands,
     /* 168425 */     // GIR_Coverage, 2133,
     /* 168425 */     GIR_EraseRootFromParent_Done,
     /* 168426 */   // Label 3244: @168426
     /* 168426 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168478), // Rule ID 2134 //
     /* 168431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168464 */     // MIs[1] Operand 1
     /* 168464 */     // No operand predicates
     /* 168464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168466 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 168469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168476 */     GIR_RootConstrainSelectedInstOperands,
     /* 168477 */     // GIR_Coverage, 2134,
     /* 168477 */     GIR_EraseRootFromParent_Done,
     /* 168478 */   // Label 3245: @168478
     /* 168478 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168530), // Rule ID 2135 //
     /* 168483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168516 */     // MIs[1] Operand 1
     /* 168516 */     // No operand predicates
     /* 168516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 168521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168528 */     GIR_RootConstrainSelectedInstOperands,
     /* 168529 */     // GIR_Coverage, 2135,
     /* 168529 */     GIR_EraseRootFromParent_Done,
     /* 168530 */   // Label 3246: @168530
     /* 168530 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168582), // Rule ID 2136 //
     /* 168535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168568 */     // MIs[1] Operand 1
     /* 168568 */     // No operand predicates
     /* 168568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168570 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 168573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168580 */     GIR_RootConstrainSelectedInstOperands,
     /* 168581 */     // GIR_Coverage, 2136,
     /* 168581 */     GIR_EraseRootFromParent_Done,
     /* 168582 */   // Label 3247: @168582
     /* 168582 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168634), // Rule ID 2137 //
     /* 168587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168620 */     // MIs[1] Operand 1
     /* 168620 */     // No operand predicates
     /* 168620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168622 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 168625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168632 */     GIR_RootConstrainSelectedInstOperands,
     /* 168633 */     // GIR_Coverage, 2137,
     /* 168633 */     GIR_EraseRootFromParent_Done,
     /* 168634 */   // Label 3248: @168634
     /* 168634 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168686), // Rule ID 2138 //
     /* 168639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168672 */     // MIs[1] Operand 1
     /* 168672 */     // No operand predicates
     /* 168672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168674 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 168677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168684 */     GIR_RootConstrainSelectedInstOperands,
     /* 168685 */     // GIR_Coverage, 2138,
     /* 168685 */     GIR_EraseRootFromParent_Done,
     /* 168686 */   // Label 3249: @168686
     /* 168686 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168738), // Rule ID 2139 //
     /* 168691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168724 */     // MIs[1] Operand 1
     /* 168724 */     // No operand predicates
     /* 168724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168726 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 168729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168736 */     GIR_RootConstrainSelectedInstOperands,
     /* 168737 */     // GIR_Coverage, 2139,
     /* 168737 */     GIR_EraseRootFromParent_Done,
     /* 168738 */   // Label 3250: @168738
     /* 168738 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168790), // Rule ID 2140 //
     /* 168743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168776 */     // MIs[1] Operand 1
     /* 168776 */     // No operand predicates
     /* 168776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168778 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 168781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168788 */     GIR_RootConstrainSelectedInstOperands,
     /* 168789 */     // GIR_Coverage, 2140,
     /* 168789 */     GIR_EraseRootFromParent_Done,
     /* 168790 */   // Label 3251: @168790
     /* 168790 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168842), // Rule ID 2141 //
     /* 168795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168828 */     // MIs[1] Operand 1
     /* 168828 */     // No operand predicates
     /* 168828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168830 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 168833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168840 */     GIR_RootConstrainSelectedInstOperands,
     /* 168841 */     // GIR_Coverage, 2141,
     /* 168841 */     GIR_EraseRootFromParent_Done,
     /* 168842 */   // Label 3252: @168842
     /* 168842 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168894), // Rule ID 2142 //
     /* 168847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168880 */     // MIs[1] Operand 1
     /* 168880 */     // No operand predicates
     /* 168880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168882 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 168885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168892 */     GIR_RootConstrainSelectedInstOperands,
     /* 168893 */     // GIR_Coverage, 2142,
     /* 168893 */     GIR_EraseRootFromParent_Done,
     /* 168894 */   // Label 3253: @168894
     /* 168894 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168946), // Rule ID 2143 //
     /* 168899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168932 */     // MIs[1] Operand 1
     /* 168932 */     // No operand predicates
     /* 168932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168934 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 168937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168944 */     GIR_RootConstrainSelectedInstOperands,
     /* 168945 */     // GIR_Coverage, 2143,
     /* 168945 */     GIR_EraseRootFromParent_Done,
     /* 168946 */   // Label 3254: @168946
     /* 168946 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168998), // Rule ID 2144 //
     /* 168951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168984 */     // MIs[1] Operand 1
     /* 168984 */     // No operand predicates
     /* 168984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168986 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 168989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168996 */     GIR_RootConstrainSelectedInstOperands,
     /* 168997 */     // GIR_Coverage, 2144,
     /* 168997 */     GIR_EraseRootFromParent_Done,
     /* 168998 */   // Label 3255: @168998
     /* 168998 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(169050), // Rule ID 2145 //
     /* 169003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 169011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169036 */     // MIs[1] Operand 1
     /* 169036 */     // No operand predicates
     /* 169036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169038 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 169041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169048 */     GIR_RootConstrainSelectedInstOperands,
     /* 169049 */     // GIR_Coverage, 2145,
     /* 169049 */     GIR_EraseRootFromParent_Done,
     /* 169050 */   // Label 3256: @169050
     /* 169050 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169102), // Rule ID 2146 //
     /* 169055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 169063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169088 */     // MIs[1] Operand 1
     /* 169088 */     // No operand predicates
     /* 169088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169090 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 169093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169100 */     GIR_RootConstrainSelectedInstOperands,
     /* 169101 */     // GIR_Coverage, 2146,
     /* 169101 */     GIR_EraseRootFromParent_Done,
     /* 169102 */   // Label 3257: @169102
     /* 169102 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169154), // Rule ID 2244 //
     /* 169107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169140 */     // MIs[1] Operand 1
     /* 169140 */     // No operand predicates
     /* 169140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169142 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169152 */     GIR_RootConstrainSelectedInstOperands,
     /* 169153 */     // GIR_Coverage, 2244,
     /* 169153 */     GIR_EraseRootFromParent_Done,
     /* 169154 */   // Label 3258: @169154
     /* 169154 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169206), // Rule ID 2245 //
     /* 169159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169192 */     // MIs[1] Operand 1
     /* 169192 */     // No operand predicates
     /* 169192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169194 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 169197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169204 */     GIR_RootConstrainSelectedInstOperands,
     /* 169205 */     // GIR_Coverage, 2245,
     /* 169205 */     GIR_EraseRootFromParent_Done,
     /* 169206 */   // Label 3259: @169206
     /* 169206 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169258), // Rule ID 2246 //
     /* 169211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169244 */     // MIs[1] Operand 1
     /* 169244 */     // No operand predicates
     /* 169244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169246 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 169249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169256 */     GIR_RootConstrainSelectedInstOperands,
     /* 169257 */     // GIR_Coverage, 2246,
     /* 169257 */     GIR_EraseRootFromParent_Done,
     /* 169258 */   // Label 3260: @169258
     /* 169258 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169310), // Rule ID 2247 //
     /* 169263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169296 */     // MIs[1] Operand 1
     /* 169296 */     // No operand predicates
     /* 169296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169298 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 169301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169308 */     GIR_RootConstrainSelectedInstOperands,
     /* 169309 */     // GIR_Coverage, 2247,
     /* 169309 */     GIR_EraseRootFromParent_Done,
     /* 169310 */   // Label 3261: @169310
     /* 169310 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169362), // Rule ID 2248 //
     /* 169315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169348 */     // MIs[1] Operand 1
     /* 169348 */     // No operand predicates
     /* 169348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169350 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 169353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169360 */     GIR_RootConstrainSelectedInstOperands,
     /* 169361 */     // GIR_Coverage, 2248,
     /* 169361 */     GIR_EraseRootFromParent_Done,
     /* 169362 */   // Label 3262: @169362
     /* 169362 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169407), // Rule ID 63 //
     /* 169367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 169370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 169375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 169396 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 169396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 169399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169405 */     GIR_RootConstrainSelectedInstOperands,
     /* 169406 */     // GIR_Coverage, 63,
     /* 169406 */     GIR_EraseRootFromParent_Done,
     /* 169407 */   // Label 3263: @169407
     /* 169407 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169452), // Rule ID 129 //
     /* 169412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 169420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169441 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 169444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169450 */     GIR_RootConstrainSelectedInstOperands,
     /* 169451 */     // GIR_Coverage, 129,
     /* 169451 */     GIR_EraseRootFromParent_Done,
     /* 169452 */   // Label 3264: @169452
     /* 169452 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169497), // Rule ID 130 //
     /* 169457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 169465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169486 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 169489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169495 */     GIR_RootConstrainSelectedInstOperands,
     /* 169496 */     // GIR_Coverage, 130,
     /* 169496 */     GIR_EraseRootFromParent_Done,
     /* 169497 */   // Label 3265: @169497
     /* 169497 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169542), // Rule ID 131 //
     /* 169502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 169510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169531 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 169534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169540 */     GIR_RootConstrainSelectedInstOperands,
     /* 169541 */     // GIR_Coverage, 131,
     /* 169541 */     GIR_EraseRootFromParent_Done,
     /* 169542 */   // Label 3266: @169542
     /* 169542 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169587), // Rule ID 132 //
     /* 169547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 169555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169576 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 169576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 169579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169585 */     GIR_RootConstrainSelectedInstOperands,
     /* 169586 */     // GIR_Coverage, 132,
     /* 169586 */     GIR_EraseRootFromParent_Done,
     /* 169587 */   // Label 3267: @169587
     /* 169587 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169632), // Rule ID 133 //
     /* 169592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 169600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169621 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 169624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169630 */     GIR_RootConstrainSelectedInstOperands,
     /* 169631 */     // GIR_Coverage, 133,
     /* 169631 */     GIR_EraseRootFromParent_Done,
     /* 169632 */   // Label 3268: @169632
     /* 169632 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169677), // Rule ID 134 //
     /* 169637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 169645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169666 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 169669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169675 */     GIR_RootConstrainSelectedInstOperands,
     /* 169676 */     // GIR_Coverage, 134,
     /* 169676 */     GIR_EraseRootFromParent_Done,
     /* 169677 */   // Label 3269: @169677
     /* 169677 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169722), // Rule ID 135 //
     /* 169682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 169690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169711 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 169714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169720 */     GIR_RootConstrainSelectedInstOperands,
     /* 169721 */     // GIR_Coverage, 135,
     /* 169721 */     GIR_EraseRootFromParent_Done,
     /* 169722 */   // Label 3270: @169722
     /* 169722 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169767), // Rule ID 136 //
     /* 169727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 169735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169756 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 169756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 169759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169765 */     GIR_RootConstrainSelectedInstOperands,
     /* 169766 */     // GIR_Coverage, 136,
     /* 169766 */     GIR_EraseRootFromParent_Done,
     /* 169767 */   // Label 3271: @169767
     /* 169767 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169812), // Rule ID 1042 //
     /* 169772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169801 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 169801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 169804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169810 */     GIR_RootConstrainSelectedInstOperands,
     /* 169811 */     // GIR_Coverage, 1042,
     /* 169811 */     GIR_EraseRootFromParent_Done,
     /* 169812 */   // Label 3272: @169812
     /* 169812 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169857), // Rule ID 1043 //
     /* 169817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 169846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 169849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169855 */     GIR_RootConstrainSelectedInstOperands,
     /* 169856 */     // GIR_Coverage, 1043,
     /* 169856 */     GIR_EraseRootFromParent_Done,
     /* 169857 */   // Label 3273: @169857
     /* 169857 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169902), // Rule ID 1044 //
     /* 169862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169891 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 169891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 169894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169900 */     GIR_RootConstrainSelectedInstOperands,
     /* 169901 */     // GIR_Coverage, 1044,
     /* 169901 */     GIR_EraseRootFromParent_Done,
     /* 169902 */   // Label 3274: @169902
     /* 169902 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169947), // Rule ID 1045 //
     /* 169907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169936 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 169936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 169939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169945 */     GIR_RootConstrainSelectedInstOperands,
     /* 169946 */     // GIR_Coverage, 1045,
     /* 169946 */     GIR_EraseRootFromParent_Done,
     /* 169947 */   // Label 3275: @169947
     /* 169947 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169992), // Rule ID 1046 //
     /* 169952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169981 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 169981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 169984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169990 */     GIR_RootConstrainSelectedInstOperands,
     /* 169991 */     // GIR_Coverage, 1046,
     /* 169991 */     GIR_EraseRootFromParent_Done,
     /* 169992 */   // Label 3276: @169992
     /* 169992 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(170037), // Rule ID 1047 //
     /* 169997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 170005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 170026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 170029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170035 */     GIR_RootConstrainSelectedInstOperands,
     /* 170036 */     // GIR_Coverage, 1047,
     /* 170036 */     GIR_EraseRootFromParent_Done,
     /* 170037 */   // Label 3277: @170037
     /* 170037 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(170082), // Rule ID 1048 //
     /* 170042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 170050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170071 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 170071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 170074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170080 */     GIR_RootConstrainSelectedInstOperands,
     /* 170081 */     // GIR_Coverage, 1048,
     /* 170081 */     GIR_EraseRootFromParent_Done,
     /* 170082 */   // Label 3278: @170082
     /* 170082 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170127), // Rule ID 1090 //
     /* 170087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170116 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 170116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 170119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170125 */     GIR_RootConstrainSelectedInstOperands,
     /* 170126 */     // GIR_Coverage, 1090,
     /* 170126 */     GIR_EraseRootFromParent_Done,
     /* 170127 */   // Label 3279: @170127
     /* 170127 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170172), // Rule ID 1091 //
     /* 170132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 170161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 170164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170170 */     GIR_RootConstrainSelectedInstOperands,
     /* 170171 */     // GIR_Coverage, 1091,
     /* 170171 */     GIR_EraseRootFromParent_Done,
     /* 170172 */   // Label 3280: @170172
     /* 170172 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170217), // Rule ID 1092 //
     /* 170177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 170206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 170209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170215 */     GIR_RootConstrainSelectedInstOperands,
     /* 170216 */     // GIR_Coverage, 1092,
     /* 170216 */     GIR_EraseRootFromParent_Done,
     /* 170217 */   // Label 3281: @170217
     /* 170217 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170262), // Rule ID 1093 //
     /* 170222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170251 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 170251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 170254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170260 */     GIR_RootConstrainSelectedInstOperands,
     /* 170261 */     // GIR_Coverage, 1093,
     /* 170261 */     GIR_EraseRootFromParent_Done,
     /* 170262 */   // Label 3282: @170262
     /* 170262 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170307), // Rule ID 1094 //
     /* 170267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170296 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 170296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 170299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170305 */     GIR_RootConstrainSelectedInstOperands,
     /* 170306 */     // GIR_Coverage, 1094,
     /* 170306 */     GIR_EraseRootFromParent_Done,
     /* 170307 */   // Label 3283: @170307
     /* 170307 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170352), // Rule ID 1095 //
     /* 170312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 170341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 170344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170350 */     GIR_RootConstrainSelectedInstOperands,
     /* 170351 */     // GIR_Coverage, 1095,
     /* 170351 */     GIR_EraseRootFromParent_Done,
     /* 170352 */   // Label 3284: @170352
     /* 170352 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170397), // Rule ID 1096 //
     /* 170357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 170386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 170389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170395 */     GIR_RootConstrainSelectedInstOperands,
     /* 170396 */     // GIR_Coverage, 1096,
     /* 170396 */     GIR_EraseRootFromParent_Done,
     /* 170397 */   // Label 3285: @170397
     /* 170397 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170442), // Rule ID 1108 //
     /* 170402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170431 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 170434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170440 */     GIR_RootConstrainSelectedInstOperands,
     /* 170441 */     // GIR_Coverage, 1108,
     /* 170441 */     GIR_EraseRootFromParent_Done,
     /* 170442 */   // Label 3286: @170442
     /* 170442 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170487), // Rule ID 1110 //
     /* 170447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 170479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170485 */     GIR_RootConstrainSelectedInstOperands,
     /* 170486 */     // GIR_Coverage, 1110,
     /* 170486 */     GIR_EraseRootFromParent_Done,
     /* 170487 */   // Label 3287: @170487
     /* 170487 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170532), // Rule ID 1112 //
     /* 170492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170521 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 170524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170530 */     GIR_RootConstrainSelectedInstOperands,
     /* 170531 */     // GIR_Coverage, 1112,
     /* 170531 */     GIR_EraseRootFromParent_Done,
     /* 170532 */   // Label 3288: @170532
     /* 170532 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170577), // Rule ID 1114 //
     /* 170537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 170569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170575 */     GIR_RootConstrainSelectedInstOperands,
     /* 170576 */     // GIR_Coverage, 1114,
     /* 170576 */     GIR_EraseRootFromParent_Done,
     /* 170577 */   // Label 3289: @170577
     /* 170577 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170622), // Rule ID 1116 //
     /* 170582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170620 */     GIR_RootConstrainSelectedInstOperands,
     /* 170621 */     // GIR_Coverage, 1116,
     /* 170621 */     GIR_EraseRootFromParent_Done,
     /* 170622 */   // Label 3290: @170622
     /* 170622 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170667), // Rule ID 1118 //
     /* 170627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 170659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170665 */     GIR_RootConstrainSelectedInstOperands,
     /* 170666 */     // GIR_Coverage, 1118,
     /* 170666 */     GIR_EraseRootFromParent_Done,
     /* 170667 */   // Label 3291: @170667
     /* 170667 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170712), // Rule ID 1120 //
     /* 170672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 170704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170710 */     GIR_RootConstrainSelectedInstOperands,
     /* 170711 */     // GIR_Coverage, 1120,
     /* 170711 */     GIR_EraseRootFromParent_Done,
     /* 170712 */   // Label 3292: @170712
     /* 170712 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170757), // Rule ID 1163 //
     /* 170717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170746 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 170749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170755 */     GIR_RootConstrainSelectedInstOperands,
     /* 170756 */     // GIR_Coverage, 1163,
     /* 170756 */     GIR_EraseRootFromParent_Done,
     /* 170757 */   // Label 3293: @170757
     /* 170757 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170802), // Rule ID 1164 //
     /* 170762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170791 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 170794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170800 */     GIR_RootConstrainSelectedInstOperands,
     /* 170801 */     // GIR_Coverage, 1164,
     /* 170801 */     GIR_EraseRootFromParent_Done,
     /* 170802 */   // Label 3294: @170802
     /* 170802 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170847), // Rule ID 1165 //
     /* 170807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170836 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 170839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170845 */     GIR_RootConstrainSelectedInstOperands,
     /* 170846 */     // GIR_Coverage, 1165,
     /* 170846 */     GIR_EraseRootFromParent_Done,
     /* 170847 */   // Label 3295: @170847
     /* 170847 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170892), // Rule ID 1166 //
     /* 170852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170881 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 170884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170890 */     GIR_RootConstrainSelectedInstOperands,
     /* 170891 */     // GIR_Coverage, 1166,
     /* 170891 */     GIR_EraseRootFromParent_Done,
     /* 170892 */   // Label 3296: @170892
     /* 170892 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170937), // Rule ID 1167 //
     /* 170897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170926 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 170929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170935 */     GIR_RootConstrainSelectedInstOperands,
     /* 170936 */     // GIR_Coverage, 1167,
     /* 170936 */     GIR_EraseRootFromParent_Done,
     /* 170937 */   // Label 3297: @170937
     /* 170937 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170982), // Rule ID 1169 //
     /* 170942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 170950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170971 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 170974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170980 */     GIR_RootConstrainSelectedInstOperands,
     /* 170981 */     // GIR_Coverage, 1169,
     /* 170981 */     GIR_EraseRootFromParent_Done,
     /* 170982 */   // Label 3298: @170982
     /* 170982 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(171027), // Rule ID 1171 //
     /* 170987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 170995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171016 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 171019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171025 */     GIR_RootConstrainSelectedInstOperands,
     /* 171026 */     // GIR_Coverage, 1171,
     /* 171026 */     GIR_EraseRootFromParent_Done,
     /* 171027 */   // Label 3299: @171027
     /* 171027 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(171072), // Rule ID 1173 //
     /* 171032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171061 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 171064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171070 */     GIR_RootConstrainSelectedInstOperands,
     /* 171071 */     // GIR_Coverage, 1173,
     /* 171071 */     GIR_EraseRootFromParent_Done,
     /* 171072 */   // Label 3300: @171072
     /* 171072 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171117), // Rule ID 1175 //
     /* 171077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171106 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 171109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171115 */     GIR_RootConstrainSelectedInstOperands,
     /* 171116 */     // GIR_Coverage, 1175,
     /* 171116 */     GIR_EraseRootFromParent_Done,
     /* 171117 */   // Label 3301: @171117
     /* 171117 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171162), // Rule ID 1177 //
     /* 171122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171151 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 171154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171160 */     GIR_RootConstrainSelectedInstOperands,
     /* 171161 */     // GIR_Coverage, 1177,
     /* 171161 */     GIR_EraseRootFromParent_Done,
     /* 171162 */   // Label 3302: @171162
     /* 171162 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171207), // Rule ID 1179 //
     /* 171167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171196 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 171199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171205 */     GIR_RootConstrainSelectedInstOperands,
     /* 171206 */     // GIR_Coverage, 1179,
     /* 171206 */     GIR_EraseRootFromParent_Done,
     /* 171207 */   // Label 3303: @171207
     /* 171207 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171252), // Rule ID 1181 //
     /* 171212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171241 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 171244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171250 */     GIR_RootConstrainSelectedInstOperands,
     /* 171251 */     // GIR_Coverage, 1181,
     /* 171251 */     GIR_EraseRootFromParent_Done,
     /* 171252 */   // Label 3304: @171252
     /* 171252 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171297), // Rule ID 1183 //
     /* 171257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171286 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 171289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171295 */     GIR_RootConstrainSelectedInstOperands,
     /* 171296 */     // GIR_Coverage, 1183,
     /* 171296 */     GIR_EraseRootFromParent_Done,
     /* 171297 */   // Label 3305: @171297
     /* 171297 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171342), // Rule ID 1185 //
     /* 171302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171331 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 171334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171340 */     GIR_RootConstrainSelectedInstOperands,
     /* 171341 */     // GIR_Coverage, 1185,
     /* 171341 */     GIR_EraseRootFromParent_Done,
     /* 171342 */   // Label 3306: @171342
     /* 171342 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171387), // Rule ID 1187 //
     /* 171347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171376 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 171379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171385 */     GIR_RootConstrainSelectedInstOperands,
     /* 171386 */     // GIR_Coverage, 1187,
     /* 171386 */     GIR_EraseRootFromParent_Done,
     /* 171387 */   // Label 3307: @171387
     /* 171387 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171432), // Rule ID 1189 //
     /* 171392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171421 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 171424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171430 */     GIR_RootConstrainSelectedInstOperands,
     /* 171431 */     // GIR_Coverage, 1189,
     /* 171431 */     GIR_EraseRootFromParent_Done,
     /* 171432 */   // Label 3308: @171432
     /* 171432 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171477), // Rule ID 1191 //
     /* 171437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171466 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171475 */     GIR_RootConstrainSelectedInstOperands,
     /* 171476 */     // GIR_Coverage, 1191,
     /* 171476 */     GIR_EraseRootFromParent_Done,
     /* 171477 */   // Label 3309: @171477
     /* 171477 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171522), // Rule ID 1193 //
     /* 171482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171511 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 171514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171520 */     GIR_RootConstrainSelectedInstOperands,
     /* 171521 */     // GIR_Coverage, 1193,
     /* 171521 */     GIR_EraseRootFromParent_Done,
     /* 171522 */   // Label 3310: @171522
     /* 171522 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171567), // Rule ID 1195 //
     /* 171527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171556 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 171559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171565 */     GIR_RootConstrainSelectedInstOperands,
     /* 171566 */     // GIR_Coverage, 1195,
     /* 171566 */     GIR_EraseRootFromParent_Done,
     /* 171567 */   // Label 3311: @171567
     /* 171567 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171612), // Rule ID 1197 //
     /* 171572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171601 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 171604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171610 */     GIR_RootConstrainSelectedInstOperands,
     /* 171611 */     // GIR_Coverage, 1197,
     /* 171611 */     GIR_EraseRootFromParent_Done,
     /* 171612 */   // Label 3312: @171612
     /* 171612 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171657), // Rule ID 1233 //
     /* 171617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171646 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 171649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171655 */     GIR_RootConstrainSelectedInstOperands,
     /* 171656 */     // GIR_Coverage, 1233,
     /* 171656 */     GIR_EraseRootFromParent_Done,
     /* 171657 */   // Label 3313: @171657
     /* 171657 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171702), // Rule ID 1234 //
     /* 171662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171691 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 171694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171700 */     GIR_RootConstrainSelectedInstOperands,
     /* 171701 */     // GIR_Coverage, 1234,
     /* 171701 */     GIR_EraseRootFromParent_Done,
     /* 171702 */   // Label 3314: @171702
     /* 171702 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171747), // Rule ID 1235 //
     /* 171707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171736 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 171739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171745 */     GIR_RootConstrainSelectedInstOperands,
     /* 171746 */     // GIR_Coverage, 1235,
     /* 171746 */     GIR_EraseRootFromParent_Done,
     /* 171747 */   // Label 3315: @171747
     /* 171747 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171792), // Rule ID 1236 //
     /* 171752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171781 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 171784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171790 */     GIR_RootConstrainSelectedInstOperands,
     /* 171791 */     // GIR_Coverage, 1236,
     /* 171791 */     GIR_EraseRootFromParent_Done,
     /* 171792 */   // Label 3316: @171792
     /* 171792 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171837), // Rule ID 1237 //
     /* 171797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171826 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 171829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171835 */     GIR_RootConstrainSelectedInstOperands,
     /* 171836 */     // GIR_Coverage, 1237,
     /* 171836 */     GIR_EraseRootFromParent_Done,
     /* 171837 */   // Label 3317: @171837
     /* 171837 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171882), // Rule ID 1248 //
     /* 171842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171871 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 171874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171880 */     GIR_RootConstrainSelectedInstOperands,
     /* 171881 */     // GIR_Coverage, 1248,
     /* 171881 */     GIR_EraseRootFromParent_Done,
     /* 171882 */   // Label 3318: @171882
     /* 171882 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171927), // Rule ID 1249 //
     /* 171887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171916 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 171919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171925 */     GIR_RootConstrainSelectedInstOperands,
     /* 171926 */     // GIR_Coverage, 1249,
     /* 171926 */     GIR_EraseRootFromParent_Done,
     /* 171927 */   // Label 3319: @171927
     /* 171927 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171972), // Rule ID 1250 //
     /* 171932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171961 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 171964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171970 */     GIR_RootConstrainSelectedInstOperands,
     /* 171971 */     // GIR_Coverage, 1250,
     /* 171971 */     GIR_EraseRootFromParent_Done,
     /* 171972 */   // Label 3320: @171972
     /* 171972 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(172017), // Rule ID 1251 //
     /* 171977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 172009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172015 */     GIR_RootConstrainSelectedInstOperands,
     /* 172016 */     // GIR_Coverage, 1251,
     /* 172016 */     GIR_EraseRootFromParent_Done,
     /* 172017 */   // Label 3321: @172017
     /* 172017 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(172062), // Rule ID 1252 //
     /* 172022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 172030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172051 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 172054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172060 */     GIR_RootConstrainSelectedInstOperands,
     /* 172061 */     // GIR_Coverage, 1252,
     /* 172061 */     GIR_EraseRootFromParent_Done,
     /* 172062 */   // Label 3322: @172062
     /* 172062 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172107), // Rule ID 1263 //
     /* 172067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172096 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 172099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172105 */     GIR_RootConstrainSelectedInstOperands,
     /* 172106 */     // GIR_Coverage, 1263,
     /* 172106 */     GIR_EraseRootFromParent_Done,
     /* 172107 */   // Label 3323: @172107
     /* 172107 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172152), // Rule ID 1264 //
     /* 172112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172141 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 172144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172150 */     GIR_RootConstrainSelectedInstOperands,
     /* 172151 */     // GIR_Coverage, 1264,
     /* 172151 */     GIR_EraseRootFromParent_Done,
     /* 172152 */   // Label 3324: @172152
     /* 172152 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172197), // Rule ID 1265 //
     /* 172157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172186 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 172189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172195 */     GIR_RootConstrainSelectedInstOperands,
     /* 172196 */     // GIR_Coverage, 1265,
     /* 172196 */     GIR_EraseRootFromParent_Done,
     /* 172197 */   // Label 3325: @172197
     /* 172197 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172242), // Rule ID 1266 //
     /* 172202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172231 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 172234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172240 */     GIR_RootConstrainSelectedInstOperands,
     /* 172241 */     // GIR_Coverage, 1266,
     /* 172241 */     GIR_EraseRootFromParent_Done,
     /* 172242 */   // Label 3326: @172242
     /* 172242 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172287), // Rule ID 1267 //
     /* 172247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172276 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 172279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172285 */     GIR_RootConstrainSelectedInstOperands,
     /* 172286 */     // GIR_Coverage, 1267,
     /* 172286 */     GIR_EraseRootFromParent_Done,
     /* 172287 */   // Label 3327: @172287
     /* 172287 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172332), // Rule ID 1278 //
     /* 172292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172321 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 172324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172330 */     GIR_RootConstrainSelectedInstOperands,
     /* 172331 */     // GIR_Coverage, 1278,
     /* 172331 */     GIR_EraseRootFromParent_Done,
     /* 172332 */   // Label 3328: @172332
     /* 172332 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172377), // Rule ID 1279 //
     /* 172337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172366 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 172369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172375 */     GIR_RootConstrainSelectedInstOperands,
     /* 172376 */     // GIR_Coverage, 1279,
     /* 172376 */     GIR_EraseRootFromParent_Done,
     /* 172377 */   // Label 3329: @172377
     /* 172377 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172422), // Rule ID 1280 //
     /* 172382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172411 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 172414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172420 */     GIR_RootConstrainSelectedInstOperands,
     /* 172421 */     // GIR_Coverage, 1280,
     /* 172421 */     GIR_EraseRootFromParent_Done,
     /* 172422 */   // Label 3330: @172422
     /* 172422 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172467), // Rule ID 1281 //
     /* 172427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172456 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 172459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172465 */     GIR_RootConstrainSelectedInstOperands,
     /* 172466 */     // GIR_Coverage, 1281,
     /* 172466 */     GIR_EraseRootFromParent_Done,
     /* 172467 */   // Label 3331: @172467
     /* 172467 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172512), // Rule ID 1282 //
     /* 172472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172501 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 172504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172510 */     GIR_RootConstrainSelectedInstOperands,
     /* 172511 */     // GIR_Coverage, 1282,
     /* 172511 */     GIR_EraseRootFromParent_Done,
     /* 172512 */   // Label 3332: @172512
     /* 172512 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172557), // Rule ID 1313 //
     /* 172517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172546 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 172549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172555 */     GIR_RootConstrainSelectedInstOperands,
     /* 172556 */     // GIR_Coverage, 1313,
     /* 172556 */     GIR_EraseRootFromParent_Done,
     /* 172557 */   // Label 3333: @172557
     /* 172557 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172602), // Rule ID 1314 //
     /* 172562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172591 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 172594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172600 */     GIR_RootConstrainSelectedInstOperands,
     /* 172601 */     // GIR_Coverage, 1314,
     /* 172601 */     GIR_EraseRootFromParent_Done,
     /* 172602 */   // Label 3334: @172602
     /* 172602 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172647), // Rule ID 1315 //
     /* 172607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172636 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 172639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172645 */     GIR_RootConstrainSelectedInstOperands,
     /* 172646 */     // GIR_Coverage, 1315,
     /* 172646 */     GIR_EraseRootFromParent_Done,
     /* 172647 */   // Label 3335: @172647
     /* 172647 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172692), // Rule ID 1316 //
     /* 172652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172681 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 172684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172690 */     GIR_RootConstrainSelectedInstOperands,
     /* 172691 */     // GIR_Coverage, 1316,
     /* 172691 */     GIR_EraseRootFromParent_Done,
     /* 172692 */   // Label 3336: @172692
     /* 172692 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172737), // Rule ID 1317 //
     /* 172697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172726 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 172729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172735 */     GIR_RootConstrainSelectedInstOperands,
     /* 172736 */     // GIR_Coverage, 1317,
     /* 172736 */     GIR_EraseRootFromParent_Done,
     /* 172737 */   // Label 3337: @172737
     /* 172737 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172782), // Rule ID 1328 //
     /* 172742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172771 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 172774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172780 */     GIR_RootConstrainSelectedInstOperands,
     /* 172781 */     // GIR_Coverage, 1328,
     /* 172781 */     GIR_EraseRootFromParent_Done,
     /* 172782 */   // Label 3338: @172782
     /* 172782 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172827), // Rule ID 1329 //
     /* 172787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172816 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 172819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172825 */     GIR_RootConstrainSelectedInstOperands,
     /* 172826 */     // GIR_Coverage, 1329,
     /* 172826 */     GIR_EraseRootFromParent_Done,
     /* 172827 */   // Label 3339: @172827
     /* 172827 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172872), // Rule ID 1330 //
     /* 172832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172861 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 172864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172870 */     GIR_RootConstrainSelectedInstOperands,
     /* 172871 */     // GIR_Coverage, 1330,
     /* 172871 */     GIR_EraseRootFromParent_Done,
     /* 172872 */   // Label 3340: @172872
     /* 172872 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172917), // Rule ID 1331 //
     /* 172877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172906 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 172909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172915 */     GIR_RootConstrainSelectedInstOperands,
     /* 172916 */     // GIR_Coverage, 1331,
     /* 172916 */     GIR_EraseRootFromParent_Done,
     /* 172917 */   // Label 3341: @172917
     /* 172917 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172962), // Rule ID 1332 //
     /* 172922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172951 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 172954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172960 */     GIR_RootConstrainSelectedInstOperands,
     /* 172961 */     // GIR_Coverage, 1332,
     /* 172961 */     GIR_EraseRootFromParent_Done,
     /* 172962 */   // Label 3342: @172962
     /* 172962 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(173007), // Rule ID 1333 //
     /* 172967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 172975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172996 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 172999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173005 */     GIR_RootConstrainSelectedInstOperands,
     /* 173006 */     // GIR_Coverage, 1333,
     /* 173006 */     GIR_EraseRootFromParent_Done,
     /* 173007 */   // Label 3343: @173007
     /* 173007 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(173052), // Rule ID 1334 //
     /* 173012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173041 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 173044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173050 */     GIR_RootConstrainSelectedInstOperands,
     /* 173051 */     // GIR_Coverage, 1334,
     /* 173051 */     GIR_EraseRootFromParent_Done,
     /* 173052 */   // Label 3344: @173052
     /* 173052 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173097), // Rule ID 1335 //
     /* 173057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173086 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 173086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 173089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173095 */     GIR_RootConstrainSelectedInstOperands,
     /* 173096 */     // GIR_Coverage, 1335,
     /* 173096 */     GIR_EraseRootFromParent_Done,
     /* 173097 */   // Label 3345: @173097
     /* 173097 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173142), // Rule ID 1336 //
     /* 173102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173131 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 173131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 173134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173140 */     GIR_RootConstrainSelectedInstOperands,
     /* 173141 */     // GIR_Coverage, 1336,
     /* 173141 */     GIR_EraseRootFromParent_Done,
     /* 173142 */   // Label 3346: @173142
     /* 173142 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173187), // Rule ID 1337 //
     /* 173147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173176 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 173176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 173179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173185 */     GIR_RootConstrainSelectedInstOperands,
     /* 173186 */     // GIR_Coverage, 1337,
     /* 173186 */     GIR_EraseRootFromParent_Done,
     /* 173187 */   // Label 3347: @173187
     /* 173187 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173232), // Rule ID 1354 //
     /* 173192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 173200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173221 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 173224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173230 */     GIR_RootConstrainSelectedInstOperands,
     /* 173231 */     // GIR_Coverage, 1354,
     /* 173231 */     GIR_EraseRootFromParent_Done,
     /* 173232 */   // Label 3348: @173232
     /* 173232 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173277), // Rule ID 1355 //
     /* 173237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 173245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173266 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 173269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173275 */     GIR_RootConstrainSelectedInstOperands,
     /* 173276 */     // GIR_Coverage, 1355,
     /* 173276 */     GIR_EraseRootFromParent_Done,
     /* 173277 */   // Label 3349: @173277
     /* 173277 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173322), // Rule ID 1369 //
     /* 173282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173311 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 173314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173320 */     GIR_RootConstrainSelectedInstOperands,
     /* 173321 */     // GIR_Coverage, 1369,
     /* 173321 */     GIR_EraseRootFromParent_Done,
     /* 173322 */   // Label 3350: @173322
     /* 173322 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173367), // Rule ID 1371 //
     /* 173327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173356 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 173359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173365 */     GIR_RootConstrainSelectedInstOperands,
     /* 173366 */     // GIR_Coverage, 1371,
     /* 173366 */     GIR_EraseRootFromParent_Done,
     /* 173367 */   // Label 3351: @173367
     /* 173367 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173412), // Rule ID 1373 //
     /* 173372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173401 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 173404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173410 */     GIR_RootConstrainSelectedInstOperands,
     /* 173411 */     // GIR_Coverage, 1373,
     /* 173411 */     GIR_EraseRootFromParent_Done,
     /* 173412 */   // Label 3352: @173412
     /* 173412 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173457), // Rule ID 1375 //
     /* 173417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173446 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 173449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173455 */     GIR_RootConstrainSelectedInstOperands,
     /* 173456 */     // GIR_Coverage, 1375,
     /* 173456 */     GIR_EraseRootFromParent_Done,
     /* 173457 */   // Label 3353: @173457
     /* 173457 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173502), // Rule ID 1377 //
     /* 173462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173491 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 173494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173500 */     GIR_RootConstrainSelectedInstOperands,
     /* 173501 */     // GIR_Coverage, 1377,
     /* 173501 */     GIR_EraseRootFromParent_Done,
     /* 173502 */   // Label 3354: @173502
     /* 173502 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173547), // Rule ID 1379 //
     /* 173507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 173539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173545 */     GIR_RootConstrainSelectedInstOperands,
     /* 173546 */     // GIR_Coverage, 1379,
     /* 173546 */     GIR_EraseRootFromParent_Done,
     /* 173547 */   // Label 3355: @173547
     /* 173547 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173592), // Rule ID 1386 //
     /* 173552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173581 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 173584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173590 */     GIR_RootConstrainSelectedInstOperands,
     /* 173591 */     // GIR_Coverage, 1386,
     /* 173591 */     GIR_EraseRootFromParent_Done,
     /* 173592 */   // Label 3356: @173592
     /* 173592 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173637), // Rule ID 1387 //
     /* 173597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173626 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 173629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173635 */     GIR_RootConstrainSelectedInstOperands,
     /* 173636 */     // GIR_Coverage, 1387,
     /* 173636 */     GIR_EraseRootFromParent_Done,
     /* 173637 */   // Label 3357: @173637
     /* 173637 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173682), // Rule ID 1388 //
     /* 173642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173671 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 173674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173680 */     GIR_RootConstrainSelectedInstOperands,
     /* 173681 */     // GIR_Coverage, 1388,
     /* 173681 */     GIR_EraseRootFromParent_Done,
     /* 173682 */   // Label 3358: @173682
     /* 173682 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173727), // Rule ID 1389 //
     /* 173687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 173719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173725 */     GIR_RootConstrainSelectedInstOperands,
     /* 173726 */     // GIR_Coverage, 1389,
     /* 173726 */     GIR_EraseRootFromParent_Done,
     /* 173727 */   // Label 3359: @173727
     /* 173727 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173772), // Rule ID 1390 //
     /* 173732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173761 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 173764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173770 */     GIR_RootConstrainSelectedInstOperands,
     /* 173771 */     // GIR_Coverage, 1390,
     /* 173771 */     GIR_EraseRootFromParent_Done,
     /* 173772 */   // Label 3360: @173772
     /* 173772 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173817), // Rule ID 1391 //
     /* 173777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 173809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173815 */     GIR_RootConstrainSelectedInstOperands,
     /* 173816 */     // GIR_Coverage, 1391,
     /* 173816 */     GIR_EraseRootFromParent_Done,
     /* 173817 */   // Label 3361: @173817
     /* 173817 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173862), // Rule ID 1392 //
     /* 173822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173851 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 173854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173860 */     GIR_RootConstrainSelectedInstOperands,
     /* 173861 */     // GIR_Coverage, 1392,
     /* 173861 */     GIR_EraseRootFromParent_Done,
     /* 173862 */   // Label 3362: @173862
     /* 173862 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173907), // Rule ID 1393 //
     /* 173867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173896 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 173899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173905 */     GIR_RootConstrainSelectedInstOperands,
     /* 173906 */     // GIR_Coverage, 1393,
     /* 173906 */     GIR_EraseRootFromParent_Done,
     /* 173907 */   // Label 3363: @173907
     /* 173907 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173952), // Rule ID 1394 //
     /* 173912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173941 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 173944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173950 */     GIR_RootConstrainSelectedInstOperands,
     /* 173951 */     // GIR_Coverage, 1394,
     /* 173951 */     GIR_EraseRootFromParent_Done,
     /* 173952 */   // Label 3364: @173952
     /* 173952 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173997), // Rule ID 1395 //
     /* 173957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173986 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 173989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173995 */     GIR_RootConstrainSelectedInstOperands,
     /* 173996 */     // GIR_Coverage, 1395,
     /* 173996 */     GIR_EraseRootFromParent_Done,
     /* 173997 */   // Label 3365: @173997
     /* 173997 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174042), // Rule ID 1396 //
     /* 174002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 174010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174031 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 174034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174040 */     GIR_RootConstrainSelectedInstOperands,
     /* 174041 */     // GIR_Coverage, 1396,
     /* 174041 */     GIR_EraseRootFromParent_Done,
     /* 174042 */   // Label 3366: @174042
     /* 174042 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(174087), // Rule ID 1397 //
     /* 174047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 174055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174076 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 174079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174085 */     GIR_RootConstrainSelectedInstOperands,
     /* 174086 */     // GIR_Coverage, 1397,
     /* 174086 */     GIR_EraseRootFromParent_Done,
     /* 174087 */   // Label 3367: @174087
     /* 174087 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174132), // Rule ID 1404 //
     /* 174092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174121 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 174124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174130 */     GIR_RootConstrainSelectedInstOperands,
     /* 174131 */     // GIR_Coverage, 1404,
     /* 174131 */     GIR_EraseRootFromParent_Done,
     /* 174132 */   // Label 3368: @174132
     /* 174132 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174177), // Rule ID 1405 //
     /* 174137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174166 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 174169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174175 */     GIR_RootConstrainSelectedInstOperands,
     /* 174176 */     // GIR_Coverage, 1405,
     /* 174176 */     GIR_EraseRootFromParent_Done,
     /* 174177 */   // Label 3369: @174177
     /* 174177 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174222), // Rule ID 1406 //
     /* 174182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174211 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 174214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174220 */     GIR_RootConstrainSelectedInstOperands,
     /* 174221 */     // GIR_Coverage, 1406,
     /* 174221 */     GIR_EraseRootFromParent_Done,
     /* 174222 */   // Label 3370: @174222
     /* 174222 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174267), // Rule ID 1407 //
     /* 174227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 174259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174265 */     GIR_RootConstrainSelectedInstOperands,
     /* 174266 */     // GIR_Coverage, 1407,
     /* 174266 */     GIR_EraseRootFromParent_Done,
     /* 174267 */   // Label 3371: @174267
     /* 174267 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174312), // Rule ID 1408 //
     /* 174272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174301 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 174304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174310 */     GIR_RootConstrainSelectedInstOperands,
     /* 174311 */     // GIR_Coverage, 1408,
     /* 174311 */     GIR_EraseRootFromParent_Done,
     /* 174312 */   // Label 3372: @174312
     /* 174312 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174357), // Rule ID 1409 //
     /* 174317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 174349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174355 */     GIR_RootConstrainSelectedInstOperands,
     /* 174356 */     // GIR_Coverage, 1409,
     /* 174356 */     GIR_EraseRootFromParent_Done,
     /* 174357 */   // Label 3373: @174357
     /* 174357 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174402), // Rule ID 1416 //
     /* 174362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174391 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 174394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174400 */     GIR_RootConstrainSelectedInstOperands,
     /* 174401 */     // GIR_Coverage, 1416,
     /* 174401 */     GIR_EraseRootFromParent_Done,
     /* 174402 */   // Label 3374: @174402
     /* 174402 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174447), // Rule ID 1417 //
     /* 174407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 174439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174445 */     GIR_RootConstrainSelectedInstOperands,
     /* 174446 */     // GIR_Coverage, 1417,
     /* 174446 */     GIR_EraseRootFromParent_Done,
     /* 174447 */   // Label 3375: @174447
     /* 174447 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174492), // Rule ID 1418 //
     /* 174452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174481 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 174484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174490 */     GIR_RootConstrainSelectedInstOperands,
     /* 174491 */     // GIR_Coverage, 1418,
     /* 174491 */     GIR_EraseRootFromParent_Done,
     /* 174492 */   // Label 3376: @174492
     /* 174492 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174537), // Rule ID 1419 //
     /* 174497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174526 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 174529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174535 */     GIR_RootConstrainSelectedInstOperands,
     /* 174536 */     // GIR_Coverage, 1419,
     /* 174536 */     GIR_EraseRootFromParent_Done,
     /* 174537 */   // Label 3377: @174537
     /* 174537 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174582), // Rule ID 1420 //
     /* 174542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174571 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 174574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174580 */     GIR_RootConstrainSelectedInstOperands,
     /* 174581 */     // GIR_Coverage, 1420,
     /* 174581 */     GIR_EraseRootFromParent_Done,
     /* 174582 */   // Label 3378: @174582
     /* 174582 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174627), // Rule ID 1421 //
     /* 174587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174616 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 174619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174625 */     GIR_RootConstrainSelectedInstOperands,
     /* 174626 */     // GIR_Coverage, 1421,
     /* 174626 */     GIR_EraseRootFromParent_Done,
     /* 174627 */   // Label 3379: @174627
     /* 174627 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174672), // Rule ID 1422 //
     /* 174632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174661 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 174664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174670 */     GIR_RootConstrainSelectedInstOperands,
     /* 174671 */     // GIR_Coverage, 1422,
     /* 174671 */     GIR_EraseRootFromParent_Done,
     /* 174672 */   // Label 3380: @174672
     /* 174672 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174717), // Rule ID 1423 //
     /* 174677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174706 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 174709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174715 */     GIR_RootConstrainSelectedInstOperands,
     /* 174716 */     // GIR_Coverage, 1423,
     /* 174716 */     GIR_EraseRootFromParent_Done,
     /* 174717 */   // Label 3381: @174717
     /* 174717 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174762), // Rule ID 1424 //
     /* 174722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174751 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 174754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174760 */     GIR_RootConstrainSelectedInstOperands,
     /* 174761 */     // GIR_Coverage, 1424,
     /* 174761 */     GIR_EraseRootFromParent_Done,
     /* 174762 */   // Label 3382: @174762
     /* 174762 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174807), // Rule ID 1425 //
     /* 174767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174796 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 174799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174805 */     GIR_RootConstrainSelectedInstOperands,
     /* 174806 */     // GIR_Coverage, 1425,
     /* 174806 */     GIR_EraseRootFromParent_Done,
     /* 174807 */   // Label 3383: @174807
     /* 174807 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174852), // Rule ID 1426 //
     /* 174812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174841 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 174844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174850 */     GIR_RootConstrainSelectedInstOperands,
     /* 174851 */     // GIR_Coverage, 1426,
     /* 174851 */     GIR_EraseRootFromParent_Done,
     /* 174852 */   // Label 3384: @174852
     /* 174852 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174897), // Rule ID 1427 //
     /* 174857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174886 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 174889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174895 */     GIR_RootConstrainSelectedInstOperands,
     /* 174896 */     // GIR_Coverage, 1427,
     /* 174896 */     GIR_EraseRootFromParent_Done,
     /* 174897 */   // Label 3385: @174897
     /* 174897 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174942), // Rule ID 1428 //
     /* 174902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174931 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 174934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174940 */     GIR_RootConstrainSelectedInstOperands,
     /* 174941 */     // GIR_Coverage, 1428,
     /* 174941 */     GIR_EraseRootFromParent_Done,
     /* 174942 */   // Label 3386: @174942
     /* 174942 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174987), // Rule ID 1429 //
     /* 174947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174976 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 174979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174985 */     GIR_RootConstrainSelectedInstOperands,
     /* 174986 */     // GIR_Coverage, 1429,
     /* 174986 */     GIR_EraseRootFromParent_Done,
     /* 174987 */   // Label 3387: @174987
     /* 174987 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175032), // Rule ID 1430 //
     /* 174992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 175000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 175024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175030 */     GIR_RootConstrainSelectedInstOperands,
     /* 175031 */     // GIR_Coverage, 1430,
     /* 175031 */     GIR_EraseRootFromParent_Done,
     /* 175032 */   // Label 3388: @175032
     /* 175032 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175077), // Rule ID 1431 //
     /* 175037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175066 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 175069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175075 */     GIR_RootConstrainSelectedInstOperands,
     /* 175076 */     // GIR_Coverage, 1431,
     /* 175076 */     GIR_EraseRootFromParent_Done,
     /* 175077 */   // Label 3389: @175077
     /* 175077 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175122), // Rule ID 1432 //
     /* 175082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175111 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 175114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175120 */     GIR_RootConstrainSelectedInstOperands,
     /* 175121 */     // GIR_Coverage, 1432,
     /* 175121 */     GIR_EraseRootFromParent_Done,
     /* 175122 */   // Label 3390: @175122
     /* 175122 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175167), // Rule ID 1433 //
     /* 175127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175156 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 175159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175165 */     GIR_RootConstrainSelectedInstOperands,
     /* 175166 */     // GIR_Coverage, 1433,
     /* 175166 */     GIR_EraseRootFromParent_Done,
     /* 175167 */   // Label 3391: @175167
     /* 175167 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175212), // Rule ID 1434 //
     /* 175172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175201 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 175204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175210 */     GIR_RootConstrainSelectedInstOperands,
     /* 175211 */     // GIR_Coverage, 1434,
     /* 175211 */     GIR_EraseRootFromParent_Done,
     /* 175212 */   // Label 3392: @175212
     /* 175212 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175257), // Rule ID 1435 //
     /* 175217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175246 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 175249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175255 */     GIR_RootConstrainSelectedInstOperands,
     /* 175256 */     // GIR_Coverage, 1435,
     /* 175256 */     GIR_EraseRootFromParent_Done,
     /* 175257 */   // Label 3393: @175257
     /* 175257 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175302), // Rule ID 1436 //
     /* 175262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 175294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175300 */     GIR_RootConstrainSelectedInstOperands,
     /* 175301 */     // GIR_Coverage, 1436,
     /* 175301 */     GIR_EraseRootFromParent_Done,
     /* 175302 */   // Label 3394: @175302
     /* 175302 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175347), // Rule ID 1437 //
     /* 175307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175336 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 175339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175345 */     GIR_RootConstrainSelectedInstOperands,
     /* 175346 */     // GIR_Coverage, 1437,
     /* 175346 */     GIR_EraseRootFromParent_Done,
     /* 175347 */   // Label 3395: @175347
     /* 175347 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175392), // Rule ID 1438 //
     /* 175352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175381 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 175384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175390 */     GIR_RootConstrainSelectedInstOperands,
     /* 175391 */     // GIR_Coverage, 1438,
     /* 175391 */     GIR_EraseRootFromParent_Done,
     /* 175392 */   // Label 3396: @175392
     /* 175392 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175437), // Rule ID 1439 //
     /* 175397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175426 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 175429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175435 */     GIR_RootConstrainSelectedInstOperands,
     /* 175436 */     // GIR_Coverage, 1439,
     /* 175436 */     GIR_EraseRootFromParent_Done,
     /* 175437 */   // Label 3397: @175437
     /* 175437 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175482), // Rule ID 1440 //
     /* 175442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175471 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 175474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175480 */     GIR_RootConstrainSelectedInstOperands,
     /* 175481 */     // GIR_Coverage, 1440,
     /* 175481 */     GIR_EraseRootFromParent_Done,
     /* 175482 */   // Label 3398: @175482
     /* 175482 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175527), // Rule ID 1441 //
     /* 175487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175516 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 175519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175525 */     GIR_RootConstrainSelectedInstOperands,
     /* 175526 */     // GIR_Coverage, 1441,
     /* 175526 */     GIR_EraseRootFromParent_Done,
     /* 175527 */   // Label 3399: @175527
     /* 175527 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175572), // Rule ID 1442 //
     /* 175532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 175564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175570 */     GIR_RootConstrainSelectedInstOperands,
     /* 175571 */     // GIR_Coverage, 1442,
     /* 175571 */     GIR_EraseRootFromParent_Done,
     /* 175572 */   // Label 3400: @175572
     /* 175572 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175617), // Rule ID 1443 //
     /* 175577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 175609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175615 */     GIR_RootConstrainSelectedInstOperands,
     /* 175616 */     // GIR_Coverage, 1443,
     /* 175616 */     GIR_EraseRootFromParent_Done,
     /* 175617 */   // Label 3401: @175617
     /* 175617 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175662), // Rule ID 1444 //
     /* 175622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175651 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 175654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175660 */     GIR_RootConstrainSelectedInstOperands,
     /* 175661 */     // GIR_Coverage, 1444,
     /* 175661 */     GIR_EraseRootFromParent_Done,
     /* 175662 */   // Label 3402: @175662
     /* 175662 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175707), // Rule ID 1445 //
     /* 175667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175696 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 175699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175705 */     GIR_RootConstrainSelectedInstOperands,
     /* 175706 */     // GIR_Coverage, 1445,
     /* 175706 */     GIR_EraseRootFromParent_Done,
     /* 175707 */   // Label 3403: @175707
     /* 175707 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175752), // Rule ID 1446 //
     /* 175712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175741 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 175744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175750 */     GIR_RootConstrainSelectedInstOperands,
     /* 175751 */     // GIR_Coverage, 1446,
     /* 175751 */     GIR_EraseRootFromParent_Done,
     /* 175752 */   // Label 3404: @175752
     /* 175752 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175797), // Rule ID 1447 //
     /* 175757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175786 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 175789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175795 */     GIR_RootConstrainSelectedInstOperands,
     /* 175796 */     // GIR_Coverage, 1447,
     /* 175796 */     GIR_EraseRootFromParent_Done,
     /* 175797 */   // Label 3405: @175797
     /* 175797 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175842), // Rule ID 1448 //
     /* 175802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175831 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 175834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175840 */     GIR_RootConstrainSelectedInstOperands,
     /* 175841 */     // GIR_Coverage, 1448,
     /* 175841 */     GIR_EraseRootFromParent_Done,
     /* 175842 */   // Label 3406: @175842
     /* 175842 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175887), // Rule ID 1449 //
     /* 175847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175876 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 175879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175885 */     GIR_RootConstrainSelectedInstOperands,
     /* 175886 */     // GIR_Coverage, 1449,
     /* 175886 */     GIR_EraseRootFromParent_Done,
     /* 175887 */   // Label 3407: @175887
     /* 175887 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175932), // Rule ID 1450 //
     /* 175892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175921 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 175924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175930 */     GIR_RootConstrainSelectedInstOperands,
     /* 175931 */     // GIR_Coverage, 1450,
     /* 175931 */     GIR_EraseRootFromParent_Done,
     /* 175932 */   // Label 3408: @175932
     /* 175932 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175977), // Rule ID 1451 //
     /* 175937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175966 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 175969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175975 */     GIR_RootConstrainSelectedInstOperands,
     /* 175976 */     // GIR_Coverage, 1451,
     /* 175976 */     GIR_EraseRootFromParent_Done,
     /* 175977 */   // Label 3409: @175977
     /* 175977 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176022), // Rule ID 1458 //
     /* 175982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 175990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176011 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 176014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176020 */     GIR_RootConstrainSelectedInstOperands,
     /* 176021 */     // GIR_Coverage, 1458,
     /* 176021 */     GIR_EraseRootFromParent_Done,
     /* 176022 */   // Label 3410: @176022
     /* 176022 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176067), // Rule ID 1459 //
     /* 176027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176056 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 176059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176065 */     GIR_RootConstrainSelectedInstOperands,
     /* 176066 */     // GIR_Coverage, 1459,
     /* 176066 */     GIR_EraseRootFromParent_Done,
     /* 176067 */   // Label 3411: @176067
     /* 176067 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176112), // Rule ID 1460 //
     /* 176072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176101 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 176104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176110 */     GIR_RootConstrainSelectedInstOperands,
     /* 176111 */     // GIR_Coverage, 1460,
     /* 176111 */     GIR_EraseRootFromParent_Done,
     /* 176112 */   // Label 3412: @176112
     /* 176112 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176157), // Rule ID 1461 //
     /* 176117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176146 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 176149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176155 */     GIR_RootConstrainSelectedInstOperands,
     /* 176156 */     // GIR_Coverage, 1461,
     /* 176156 */     GIR_EraseRootFromParent_Done,
     /* 176157 */   // Label 3413: @176157
     /* 176157 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176202), // Rule ID 1462 //
     /* 176162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176191 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 176194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176200 */     GIR_RootConstrainSelectedInstOperands,
     /* 176201 */     // GIR_Coverage, 1462,
     /* 176201 */     GIR_EraseRootFromParent_Done,
     /* 176202 */   // Label 3414: @176202
     /* 176202 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176247), // Rule ID 1463 //
     /* 176207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176236 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 176239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176245 */     GIR_RootConstrainSelectedInstOperands,
     /* 176246 */     // GIR_Coverage, 1463,
     /* 176246 */     GIR_EraseRootFromParent_Done,
     /* 176247 */   // Label 3415: @176247
     /* 176247 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176292), // Rule ID 1464 //
     /* 176252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176281 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 176284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176290 */     GIR_RootConstrainSelectedInstOperands,
     /* 176291 */     // GIR_Coverage, 1464,
     /* 176291 */     GIR_EraseRootFromParent_Done,
     /* 176292 */   // Label 3416: @176292
     /* 176292 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176337), // Rule ID 1465 //
     /* 176297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176326 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 176329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176335 */     GIR_RootConstrainSelectedInstOperands,
     /* 176336 */     // GIR_Coverage, 1465,
     /* 176336 */     GIR_EraseRootFromParent_Done,
     /* 176337 */   // Label 3417: @176337
     /* 176337 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176382), // Rule ID 1466 //
     /* 176342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176371 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 176374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176380 */     GIR_RootConstrainSelectedInstOperands,
     /* 176381 */     // GIR_Coverage, 1466,
     /* 176381 */     GIR_EraseRootFromParent_Done,
     /* 176382 */   // Label 3418: @176382
     /* 176382 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176427), // Rule ID 1467 //
     /* 176387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 176419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176425 */     GIR_RootConstrainSelectedInstOperands,
     /* 176426 */     // GIR_Coverage, 1467,
     /* 176426 */     GIR_EraseRootFromParent_Done,
     /* 176427 */   // Label 3419: @176427
     /* 176427 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176472), // Rule ID 1468 //
     /* 176432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 176464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176470 */     GIR_RootConstrainSelectedInstOperands,
     /* 176471 */     // GIR_Coverage, 1468,
     /* 176471 */     GIR_EraseRootFromParent_Done,
     /* 176472 */   // Label 3420: @176472
     /* 176472 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176517), // Rule ID 1469 //
     /* 176477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176506 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 176509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176515 */     GIR_RootConstrainSelectedInstOperands,
     /* 176516 */     // GIR_Coverage, 1469,
     /* 176516 */     GIR_EraseRootFromParent_Done,
     /* 176517 */   // Label 3421: @176517
     /* 176517 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176562), // Rule ID 1470 //
     /* 176522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176551 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 176554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176560 */     GIR_RootConstrainSelectedInstOperands,
     /* 176561 */     // GIR_Coverage, 1470,
     /* 176561 */     GIR_EraseRootFromParent_Done,
     /* 176562 */   // Label 3422: @176562
     /* 176562 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176607), // Rule ID 1471 //
     /* 176567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 176599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176605 */     GIR_RootConstrainSelectedInstOperands,
     /* 176606 */     // GIR_Coverage, 1471,
     /* 176606 */     GIR_EraseRootFromParent_Done,
     /* 176607 */   // Label 3423: @176607
     /* 176607 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176652), // Rule ID 1492 //
     /* 176612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176641 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 176644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176650 */     GIR_RootConstrainSelectedInstOperands,
     /* 176651 */     // GIR_Coverage, 1492,
     /* 176651 */     GIR_EraseRootFromParent_Done,
     /* 176652 */   // Label 3424: @176652
     /* 176652 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176697), // Rule ID 1494 //
     /* 176657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176686 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 176689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176695 */     GIR_RootConstrainSelectedInstOperands,
     /* 176696 */     // GIR_Coverage, 1494,
     /* 176696 */     GIR_EraseRootFromParent_Done,
     /* 176697 */   // Label 3425: @176697
     /* 176697 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176742), // Rule ID 1496 //
     /* 176702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176731 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 176734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176740 */     GIR_RootConstrainSelectedInstOperands,
     /* 176741 */     // GIR_Coverage, 1496,
     /* 176741 */     GIR_EraseRootFromParent_Done,
     /* 176742 */   // Label 3426: @176742
     /* 176742 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176787), // Rule ID 1498 //
     /* 176747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 176779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176785 */     GIR_RootConstrainSelectedInstOperands,
     /* 176786 */     // GIR_Coverage, 1498,
     /* 176786 */     GIR_EraseRootFromParent_Done,
     /* 176787 */   // Label 3427: @176787
     /* 176787 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176832), // Rule ID 1500 //
     /* 176792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176821 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 176824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176830 */     GIR_RootConstrainSelectedInstOperands,
     /* 176831 */     // GIR_Coverage, 1500,
     /* 176831 */     GIR_EraseRootFromParent_Done,
     /* 176832 */   // Label 3428: @176832
     /* 176832 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176877), // Rule ID 1502 //
     /* 176837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 176869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176875 */     GIR_RootConstrainSelectedInstOperands,
     /* 176876 */     // GIR_Coverage, 1502,
     /* 176876 */     GIR_EraseRootFromParent_Done,
     /* 176877 */   // Label 3429: @176877
     /* 176877 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176922), // Rule ID 1509 //
     /* 176882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176911 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 176914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176920 */     GIR_RootConstrainSelectedInstOperands,
     /* 176921 */     // GIR_Coverage, 1509,
     /* 176921 */     GIR_EraseRootFromParent_Done,
     /* 176922 */   // Label 3430: @176922
     /* 176922 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176967), // Rule ID 1510 //
     /* 176927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176956 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 176959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176965 */     GIR_RootConstrainSelectedInstOperands,
     /* 176966 */     // GIR_Coverage, 1510,
     /* 176966 */     GIR_EraseRootFromParent_Done,
     /* 176967 */   // Label 3431: @176967
     /* 176967 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(177012), // Rule ID 1511 //
     /* 176972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177001 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 177004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177010 */     GIR_RootConstrainSelectedInstOperands,
     /* 177011 */     // GIR_Coverage, 1511,
     /* 177011 */     GIR_EraseRootFromParent_Done,
     /* 177012 */   // Label 3432: @177012
     /* 177012 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(177057), // Rule ID 1512 //
     /* 177017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177046 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 177049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177055 */     GIR_RootConstrainSelectedInstOperands,
     /* 177056 */     // GIR_Coverage, 1512,
     /* 177056 */     GIR_EraseRootFromParent_Done,
     /* 177057 */   // Label 3433: @177057
     /* 177057 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177102), // Rule ID 1513 //
     /* 177062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177091 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 177094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177100 */     GIR_RootConstrainSelectedInstOperands,
     /* 177101 */     // GIR_Coverage, 1513,
     /* 177101 */     GIR_EraseRootFromParent_Done,
     /* 177102 */   // Label 3434: @177102
     /* 177102 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177147), // Rule ID 1514 //
     /* 177107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177136 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 177139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177145 */     GIR_RootConstrainSelectedInstOperands,
     /* 177146 */     // GIR_Coverage, 1514,
     /* 177146 */     GIR_EraseRootFromParent_Done,
     /* 177147 */   // Label 3435: @177147
     /* 177147 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177192), // Rule ID 1515 //
     /* 177152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177181 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 177184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177190 */     GIR_RootConstrainSelectedInstOperands,
     /* 177191 */     // GIR_Coverage, 1515,
     /* 177191 */     GIR_EraseRootFromParent_Done,
     /* 177192 */   // Label 3436: @177192
     /* 177192 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177237), // Rule ID 1516 //
     /* 177197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177226 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 177229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177235 */     GIR_RootConstrainSelectedInstOperands,
     /* 177236 */     // GIR_Coverage, 1516,
     /* 177236 */     GIR_EraseRootFromParent_Done,
     /* 177237 */   // Label 3437: @177237
     /* 177237 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177282), // Rule ID 1517 //
     /* 177242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177271 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 177274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177280 */     GIR_RootConstrainSelectedInstOperands,
     /* 177281 */     // GIR_Coverage, 1517,
     /* 177281 */     GIR_EraseRootFromParent_Done,
     /* 177282 */   // Label 3438: @177282
     /* 177282 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177327), // Rule ID 1518 //
     /* 177287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 177319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177325 */     GIR_RootConstrainSelectedInstOperands,
     /* 177326 */     // GIR_Coverage, 1518,
     /* 177326 */     GIR_EraseRootFromParent_Done,
     /* 177327 */   // Label 3439: @177327
     /* 177327 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177372), // Rule ID 1519 //
     /* 177332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177361 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 177364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177370 */     GIR_RootConstrainSelectedInstOperands,
     /* 177371 */     // GIR_Coverage, 1519,
     /* 177371 */     GIR_EraseRootFromParent_Done,
     /* 177372 */   // Label 3440: @177372
     /* 177372 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177417), // Rule ID 1520 //
     /* 177377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 177409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177415 */     GIR_RootConstrainSelectedInstOperands,
     /* 177416 */     // GIR_Coverage, 1520,
     /* 177416 */     GIR_EraseRootFromParent_Done,
     /* 177417 */   // Label 3441: @177417
     /* 177417 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177462), // Rule ID 1527 //
     /* 177422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177451 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 177454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177460 */     GIR_RootConstrainSelectedInstOperands,
     /* 177461 */     // GIR_Coverage, 1527,
     /* 177461 */     GIR_EraseRootFromParent_Done,
     /* 177462 */   // Label 3442: @177462
     /* 177462 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177507), // Rule ID 1528 //
     /* 177467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177496 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 177499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177505 */     GIR_RootConstrainSelectedInstOperands,
     /* 177506 */     // GIR_Coverage, 1528,
     /* 177506 */     GIR_EraseRootFromParent_Done,
     /* 177507 */   // Label 3443: @177507
     /* 177507 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177552), // Rule ID 1529 //
     /* 177512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177541 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 177544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177550 */     GIR_RootConstrainSelectedInstOperands,
     /* 177551 */     // GIR_Coverage, 1529,
     /* 177551 */     GIR_EraseRootFromParent_Done,
     /* 177552 */   // Label 3444: @177552
     /* 177552 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177597), // Rule ID 1530 //
     /* 177557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177586 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 177589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177595 */     GIR_RootConstrainSelectedInstOperands,
     /* 177596 */     // GIR_Coverage, 1530,
     /* 177596 */     GIR_EraseRootFromParent_Done,
     /* 177597 */   // Label 3445: @177597
     /* 177597 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177642), // Rule ID 1531 //
     /* 177602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177631 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 177634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177640 */     GIR_RootConstrainSelectedInstOperands,
     /* 177641 */     // GIR_Coverage, 1531,
     /* 177641 */     GIR_EraseRootFromParent_Done,
     /* 177642 */   // Label 3446: @177642
     /* 177642 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177687), // Rule ID 1532 //
     /* 177647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 177679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177685 */     GIR_RootConstrainSelectedInstOperands,
     /* 177686 */     // GIR_Coverage, 1532,
     /* 177686 */     GIR_EraseRootFromParent_Done,
     /* 177687 */   // Label 3447: @177687
     /* 177687 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177732), // Rule ID 1539 //
     /* 177692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177721 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 177724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177730 */     GIR_RootConstrainSelectedInstOperands,
     /* 177731 */     // GIR_Coverage, 1539,
     /* 177731 */     GIR_EraseRootFromParent_Done,
     /* 177732 */   // Label 3448: @177732
     /* 177732 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177777), // Rule ID 1540 //
     /* 177737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177766 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 177769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177775 */     GIR_RootConstrainSelectedInstOperands,
     /* 177776 */     // GIR_Coverage, 1540,
     /* 177776 */     GIR_EraseRootFromParent_Done,
     /* 177777 */   // Label 3449: @177777
     /* 177777 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177822), // Rule ID 1541 //
     /* 177782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177811 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 177814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177820 */     GIR_RootConstrainSelectedInstOperands,
     /* 177821 */     // GIR_Coverage, 1541,
     /* 177821 */     GIR_EraseRootFromParent_Done,
     /* 177822 */   // Label 3450: @177822
     /* 177822 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177867), // Rule ID 1542 //
     /* 177827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177856 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 177859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177865 */     GIR_RootConstrainSelectedInstOperands,
     /* 177866 */     // GIR_Coverage, 1542,
     /* 177866 */     GIR_EraseRootFromParent_Done,
     /* 177867 */   // Label 3451: @177867
     /* 177867 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177912), // Rule ID 1543 //
     /* 177872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177901 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 177904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177910 */     GIR_RootConstrainSelectedInstOperands,
     /* 177911 */     // GIR_Coverage, 1543,
     /* 177911 */     GIR_EraseRootFromParent_Done,
     /* 177912 */   // Label 3452: @177912
     /* 177912 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177957), // Rule ID 1544 //
     /* 177917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 177949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177955 */     GIR_RootConstrainSelectedInstOperands,
     /* 177956 */     // GIR_Coverage, 1544,
     /* 177956 */     GIR_EraseRootFromParent_Done,
     /* 177957 */   // Label 3453: @177957
     /* 177957 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(178002), // Rule ID 1545 //
     /* 177962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177991 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 177994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178000 */     GIR_RootConstrainSelectedInstOperands,
     /* 178001 */     // GIR_Coverage, 1545,
     /* 178001 */     GIR_EraseRootFromParent_Done,
     /* 178002 */   // Label 3454: @178002
     /* 178002 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(178047), // Rule ID 1546 //
     /* 178007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178036 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 178039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178045 */     GIR_RootConstrainSelectedInstOperands,
     /* 178046 */     // GIR_Coverage, 1546,
     /* 178046 */     GIR_EraseRootFromParent_Done,
     /* 178047 */   // Label 3455: @178047
     /* 178047 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(178092), // Rule ID 1547 //
     /* 178052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178081 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 178084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178090 */     GIR_RootConstrainSelectedInstOperands,
     /* 178091 */     // GIR_Coverage, 1547,
     /* 178091 */     GIR_EraseRootFromParent_Done,
     /* 178092 */   // Label 3456: @178092
     /* 178092 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178137), // Rule ID 1548 //
     /* 178097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178126 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 178129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178135 */     GIR_RootConstrainSelectedInstOperands,
     /* 178136 */     // GIR_Coverage, 1548,
     /* 178136 */     GIR_EraseRootFromParent_Done,
     /* 178137 */   // Label 3457: @178137
     /* 178137 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178182), // Rule ID 1549 //
     /* 178142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178171 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 178174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178180 */     GIR_RootConstrainSelectedInstOperands,
     /* 178181 */     // GIR_Coverage, 1549,
     /* 178181 */     GIR_EraseRootFromParent_Done,
     /* 178182 */   // Label 3458: @178182
     /* 178182 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178227), // Rule ID 1550 //
     /* 178187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178216 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 178219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178225 */     GIR_RootConstrainSelectedInstOperands,
     /* 178226 */     // GIR_Coverage, 1550,
     /* 178226 */     GIR_EraseRootFromParent_Done,
     /* 178227 */   // Label 3459: @178227
     /* 178227 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178272), // Rule ID 1551 //
     /* 178232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178261 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 178264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178270 */     GIR_RootConstrainSelectedInstOperands,
     /* 178271 */     // GIR_Coverage, 1551,
     /* 178271 */     GIR_EraseRootFromParent_Done,
     /* 178272 */   // Label 3460: @178272
     /* 178272 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178317), // Rule ID 1552 //
     /* 178277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178306 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 178309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178315 */     GIR_RootConstrainSelectedInstOperands,
     /* 178316 */     // GIR_Coverage, 1552,
     /* 178316 */     GIR_EraseRootFromParent_Done,
     /* 178317 */   // Label 3461: @178317
     /* 178317 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178362), // Rule ID 1553 //
     /* 178322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178351 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 178354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178360 */     GIR_RootConstrainSelectedInstOperands,
     /* 178361 */     // GIR_Coverage, 1553,
     /* 178361 */     GIR_EraseRootFromParent_Done,
     /* 178362 */   // Label 3462: @178362
     /* 178362 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178407), // Rule ID 1554 //
     /* 178367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178396 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 178399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178405 */     GIR_RootConstrainSelectedInstOperands,
     /* 178406 */     // GIR_Coverage, 1554,
     /* 178406 */     GIR_EraseRootFromParent_Done,
     /* 178407 */   // Label 3463: @178407
     /* 178407 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178452), // Rule ID 1555 //
     /* 178412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178441 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 178444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178450 */     GIR_RootConstrainSelectedInstOperands,
     /* 178451 */     // GIR_Coverage, 1555,
     /* 178451 */     GIR_EraseRootFromParent_Done,
     /* 178452 */   // Label 3464: @178452
     /* 178452 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178497), // Rule ID 1556 //
     /* 178457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178486 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 178489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178495 */     GIR_RootConstrainSelectedInstOperands,
     /* 178496 */     // GIR_Coverage, 1556,
     /* 178496 */     GIR_EraseRootFromParent_Done,
     /* 178497 */   // Label 3465: @178497
     /* 178497 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178542), // Rule ID 1557 //
     /* 178502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178531 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 178534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178540 */     GIR_RootConstrainSelectedInstOperands,
     /* 178541 */     // GIR_Coverage, 1557,
     /* 178541 */     GIR_EraseRootFromParent_Done,
     /* 178542 */   // Label 3466: @178542
     /* 178542 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178587), // Rule ID 1558 //
     /* 178547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 178579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178585 */     GIR_RootConstrainSelectedInstOperands,
     /* 178586 */     // GIR_Coverage, 1558,
     /* 178586 */     GIR_EraseRootFromParent_Done,
     /* 178587 */   // Label 3467: @178587
     /* 178587 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178632), // Rule ID 1559 //
     /* 178592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178621 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 178624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178630 */     GIR_RootConstrainSelectedInstOperands,
     /* 178631 */     // GIR_Coverage, 1559,
     /* 178631 */     GIR_EraseRootFromParent_Done,
     /* 178632 */   // Label 3468: @178632
     /* 178632 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178677), // Rule ID 1560 //
     /* 178637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178666 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 178669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178675 */     GIR_RootConstrainSelectedInstOperands,
     /* 178676 */     // GIR_Coverage, 1560,
     /* 178676 */     GIR_EraseRootFromParent_Done,
     /* 178677 */   // Label 3469: @178677
     /* 178677 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178722), // Rule ID 1561 //
     /* 178682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178711 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 178714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178720 */     GIR_RootConstrainSelectedInstOperands,
     /* 178721 */     // GIR_Coverage, 1561,
     /* 178721 */     GIR_EraseRootFromParent_Done,
     /* 178722 */   // Label 3470: @178722
     /* 178722 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178767), // Rule ID 1562 //
     /* 178727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178756 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 178759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178765 */     GIR_RootConstrainSelectedInstOperands,
     /* 178766 */     // GIR_Coverage, 1562,
     /* 178766 */     GIR_EraseRootFromParent_Done,
     /* 178767 */   // Label 3471: @178767
     /* 178767 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178812), // Rule ID 1563 //
     /* 178772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178801 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 178804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178810 */     GIR_RootConstrainSelectedInstOperands,
     /* 178811 */     // GIR_Coverage, 1563,
     /* 178811 */     GIR_EraseRootFromParent_Done,
     /* 178812 */   // Label 3472: @178812
     /* 178812 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178857), // Rule ID 1564 //
     /* 178817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178846 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 178849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178855 */     GIR_RootConstrainSelectedInstOperands,
     /* 178856 */     // GIR_Coverage, 1564,
     /* 178856 */     GIR_EraseRootFromParent_Done,
     /* 178857 */   // Label 3473: @178857
     /* 178857 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178902), // Rule ID 1565 //
     /* 178862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 178894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178900 */     GIR_RootConstrainSelectedInstOperands,
     /* 178901 */     // GIR_Coverage, 1565,
     /* 178901 */     GIR_EraseRootFromParent_Done,
     /* 178902 */   // Label 3474: @178902
     /* 178902 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178947), // Rule ID 1566 //
     /* 178907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 178939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178945 */     GIR_RootConstrainSelectedInstOperands,
     /* 178946 */     // GIR_Coverage, 1566,
     /* 178946 */     GIR_EraseRootFromParent_Done,
     /* 178947 */   // Label 3475: @178947
     /* 178947 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178992), // Rule ID 1573 //
     /* 178952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178981 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 178984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178990 */     GIR_RootConstrainSelectedInstOperands,
     /* 178991 */     // GIR_Coverage, 1573,
     /* 178991 */     GIR_EraseRootFromParent_Done,
     /* 178992 */   // Label 3476: @178992
     /* 178992 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(179037), // Rule ID 1574 //
     /* 178997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179026 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 179026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 179029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179035 */     GIR_RootConstrainSelectedInstOperands,
     /* 179036 */     // GIR_Coverage, 1574,
     /* 179036 */     GIR_EraseRootFromParent_Done,
     /* 179037 */   // Label 3477: @179037
     /* 179037 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(179082), // Rule ID 1575 //
     /* 179042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179071 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 179074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179080 */     GIR_RootConstrainSelectedInstOperands,
     /* 179081 */     // GIR_Coverage, 1575,
     /* 179081 */     GIR_EraseRootFromParent_Done,
     /* 179082 */   // Label 3478: @179082
     /* 179082 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179127), // Rule ID 1576 //
     /* 179087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179116 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 179119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179125 */     GIR_RootConstrainSelectedInstOperands,
     /* 179126 */     // GIR_Coverage, 1576,
     /* 179126 */     GIR_EraseRootFromParent_Done,
     /* 179127 */   // Label 3479: @179127
     /* 179127 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179172), // Rule ID 1577 //
     /* 179132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179161 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 179164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179170 */     GIR_RootConstrainSelectedInstOperands,
     /* 179171 */     // GIR_Coverage, 1577,
     /* 179171 */     GIR_EraseRootFromParent_Done,
     /* 179172 */   // Label 3480: @179172
     /* 179172 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179217), // Rule ID 1578 //
     /* 179177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 179209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179215 */     GIR_RootConstrainSelectedInstOperands,
     /* 179216 */     // GIR_Coverage, 1578,
     /* 179216 */     GIR_EraseRootFromParent_Done,
     /* 179217 */   // Label 3481: @179217
     /* 179217 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179262), // Rule ID 1579 //
     /* 179222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179251 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 179254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179260 */     GIR_RootConstrainSelectedInstOperands,
     /* 179261 */     // GIR_Coverage, 1579,
     /* 179261 */     GIR_EraseRootFromParent_Done,
     /* 179262 */   // Label 3482: @179262
     /* 179262 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179307), // Rule ID 1580 //
     /* 179267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 179281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 179284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179296 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 179296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 179299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179305 */     GIR_RootConstrainSelectedInstOperands,
     /* 179306 */     // GIR_Coverage, 1580,
     /* 179306 */     GIR_EraseRootFromParent_Done,
     /* 179307 */   // Label 3483: @179307
     /* 179307 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179352), // Rule ID 1581 //
     /* 179312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179341 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 179341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 179344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179350 */     GIR_RootConstrainSelectedInstOperands,
     /* 179351 */     // GIR_Coverage, 1581,
     /* 179351 */     GIR_EraseRootFromParent_Done,
     /* 179352 */   // Label 3484: @179352
     /* 179352 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179397), // Rule ID 1582 //
     /* 179357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179386 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 179389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179395 */     GIR_RootConstrainSelectedInstOperands,
     /* 179396 */     // GIR_Coverage, 1582,
     /* 179396 */     GIR_EraseRootFromParent_Done,
     /* 179397 */   // Label 3485: @179397
     /* 179397 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179442), // Rule ID 1583 //
     /* 179402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179431 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 179434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179440 */     GIR_RootConstrainSelectedInstOperands,
     /* 179441 */     // GIR_Coverage, 1583,
     /* 179441 */     GIR_EraseRootFromParent_Done,
     /* 179442 */   // Label 3486: @179442
     /* 179442 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179487), // Rule ID 1584 //
     /* 179447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179476 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 179479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179485 */     GIR_RootConstrainSelectedInstOperands,
     /* 179486 */     // GIR_Coverage, 1584,
     /* 179486 */     GIR_EraseRootFromParent_Done,
     /* 179487 */   // Label 3487: @179487
     /* 179487 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179532), // Rule ID 1585 //
     /* 179492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 179524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179530 */     GIR_RootConstrainSelectedInstOperands,
     /* 179531 */     // GIR_Coverage, 1585,
     /* 179531 */     GIR_EraseRootFromParent_Done,
     /* 179532 */   // Label 3488: @179532
     /* 179532 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179577), // Rule ID 1586 //
     /* 179537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179566 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 179569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179575 */     GIR_RootConstrainSelectedInstOperands,
     /* 179576 */     // GIR_Coverage, 1586,
     /* 179576 */     GIR_EraseRootFromParent_Done,
     /* 179577 */   // Label 3489: @179577
     /* 179577 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179622), // Rule ID 1614 //
     /* 179582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179611 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 179614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179620 */     GIR_RootConstrainSelectedInstOperands,
     /* 179621 */     // GIR_Coverage, 1614,
     /* 179621 */     GIR_EraseRootFromParent_Done,
     /* 179622 */   // Label 3490: @179622
     /* 179622 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179667), // Rule ID 1615 //
     /* 179627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179656 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 179659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179665 */     GIR_RootConstrainSelectedInstOperands,
     /* 179666 */     // GIR_Coverage, 1615,
     /* 179666 */     GIR_EraseRootFromParent_Done,
     /* 179667 */   // Label 3491: @179667
     /* 179667 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179712), // Rule ID 1616 //
     /* 179672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179701 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 179701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 179704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179710 */     GIR_RootConstrainSelectedInstOperands,
     /* 179711 */     // GIR_Coverage, 1616,
     /* 179711 */     GIR_EraseRootFromParent_Done,
     /* 179712 */   // Label 3492: @179712
     /* 179712 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179757), // Rule ID 1617 //
     /* 179717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179746 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 179749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179755 */     GIR_RootConstrainSelectedInstOperands,
     /* 179756 */     // GIR_Coverage, 1617,
     /* 179756 */     GIR_EraseRootFromParent_Done,
     /* 179757 */   // Label 3493: @179757
     /* 179757 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179802), // Rule ID 1618 //
     /* 179762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179791 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 179794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179800 */     GIR_RootConstrainSelectedInstOperands,
     /* 179801 */     // GIR_Coverage, 1618,
     /* 179801 */     GIR_EraseRootFromParent_Done,
     /* 179802 */   // Label 3494: @179802
     /* 179802 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179847), // Rule ID 1619 //
     /* 179807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 179815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179836 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 179839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179845 */     GIR_RootConstrainSelectedInstOperands,
     /* 179846 */     // GIR_Coverage, 1619,
     /* 179846 */     GIR_EraseRootFromParent_Done,
     /* 179847 */   // Label 3495: @179847
     /* 179847 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179892), // Rule ID 1620 //
     /* 179852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 179860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179881 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 179884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179890 */     GIR_RootConstrainSelectedInstOperands,
     /* 179891 */     // GIR_Coverage, 1620,
     /* 179891 */     GIR_EraseRootFromParent_Done,
     /* 179892 */   // Label 3496: @179892
     /* 179892 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179937), // Rule ID 1627 //
     /* 179897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 179900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179926 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 179929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179935 */     GIR_RootConstrainSelectedInstOperands,
     /* 179936 */     // GIR_Coverage, 1627,
     /* 179936 */     GIR_EraseRootFromParent_Done,
     /* 179937 */   // Label 3497: @179937
     /* 179937 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179982), // Rule ID 1628 //
     /* 179942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 179945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179971 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 179974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179980 */     GIR_RootConstrainSelectedInstOperands,
     /* 179981 */     // GIR_Coverage, 1628,
     /* 179981 */     GIR_EraseRootFromParent_Done,
     /* 179982 */   // Label 3498: @179982
     /* 179982 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(180027), // Rule ID 1629 //
     /* 179987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 179990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180016 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 180019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180025 */     GIR_RootConstrainSelectedInstOperands,
     /* 180026 */     // GIR_Coverage, 1629,
     /* 180026 */     GIR_EraseRootFromParent_Done,
     /* 180027 */   // Label 3499: @180027
     /* 180027 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(180072), // Rule ID 1630 //
     /* 180032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180061 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 180061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 180064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180070 */     GIR_RootConstrainSelectedInstOperands,
     /* 180071 */     // GIR_Coverage, 1630,
     /* 180071 */     GIR_EraseRootFromParent_Done,
     /* 180072 */   // Label 3500: @180072
     /* 180072 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180117), // Rule ID 1631 //
     /* 180077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180106 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 180106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 180109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180115 */     GIR_RootConstrainSelectedInstOperands,
     /* 180116 */     // GIR_Coverage, 1631,
     /* 180116 */     GIR_EraseRootFromParent_Done,
     /* 180117 */   // Label 3501: @180117
     /* 180117 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180162), // Rule ID 1632 //
     /* 180122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 180125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180151 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 180154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180160 */     GIR_RootConstrainSelectedInstOperands,
     /* 180161 */     // GIR_Coverage, 1632,
     /* 180161 */     GIR_EraseRootFromParent_Done,
     /* 180162 */   // Label 3502: @180162
     /* 180162 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180207), // Rule ID 1633 //
     /* 180167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180196 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 180196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 180199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180205 */     GIR_RootConstrainSelectedInstOperands,
     /* 180206 */     // GIR_Coverage, 1633,
     /* 180206 */     GIR_EraseRootFromParent_Done,
     /* 180207 */   // Label 3503: @180207
     /* 180207 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180252), // Rule ID 1634 //
     /* 180212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180241 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 180241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 180244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180250 */     GIR_RootConstrainSelectedInstOperands,
     /* 180251 */     // GIR_Coverage, 1634,
     /* 180251 */     GIR_EraseRootFromParent_Done,
     /* 180252 */   // Label 3504: @180252
     /* 180252 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180297), // Rule ID 1635 //
     /* 180257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 180260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180286 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 180289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180295 */     GIR_RootConstrainSelectedInstOperands,
     /* 180296 */     // GIR_Coverage, 1635,
     /* 180296 */     GIR_EraseRootFromParent_Done,
     /* 180297 */   // Label 3505: @180297
     /* 180297 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180342), // Rule ID 1636 //
     /* 180302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180331 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180340 */     GIR_RootConstrainSelectedInstOperands,
     /* 180341 */     // GIR_Coverage, 1636,
     /* 180341 */     GIR_EraseRootFromParent_Done,
     /* 180342 */   // Label 3506: @180342
     /* 180342 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180387), // Rule ID 1637 //
     /* 180347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180376 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 180379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180385 */     GIR_RootConstrainSelectedInstOperands,
     /* 180386 */     // GIR_Coverage, 1637,
     /* 180386 */     GIR_EraseRootFromParent_Done,
     /* 180387 */   // Label 3507: @180387
     /* 180387 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180432), // Rule ID 1638 //
     /* 180392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180421 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 180424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180430 */     GIR_RootConstrainSelectedInstOperands,
     /* 180431 */     // GIR_Coverage, 1638,
     /* 180431 */     GIR_EraseRootFromParent_Done,
     /* 180432 */   // Label 3508: @180432
     /* 180432 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180477), // Rule ID 1639 //
     /* 180437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 180445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180466 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 180469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180475 */     GIR_RootConstrainSelectedInstOperands,
     /* 180476 */     // GIR_Coverage, 1639,
     /* 180476 */     GIR_EraseRootFromParent_Done,
     /* 180477 */   // Label 3509: @180477
     /* 180477 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180522), // Rule ID 1640 //
     /* 180482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 180490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180511 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 180514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180520 */     GIR_RootConstrainSelectedInstOperands,
     /* 180521 */     // GIR_Coverage, 1640,
     /* 180521 */     GIR_EraseRootFromParent_Done,
     /* 180522 */   // Label 3510: @180522
     /* 180522 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180567), // Rule ID 1641 //
     /* 180527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 180535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180556 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 180559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180565 */     GIR_RootConstrainSelectedInstOperands,
     /* 180566 */     // GIR_Coverage, 1641,
     /* 180566 */     GIR_EraseRootFromParent_Done,
     /* 180567 */   // Label 3511: @180567
     /* 180567 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180612), // Rule ID 1642 //
     /* 180572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 180580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180601 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 180604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180610 */     GIR_RootConstrainSelectedInstOperands,
     /* 180611 */     // GIR_Coverage, 1642,
     /* 180611 */     GIR_EraseRootFromParent_Done,
     /* 180612 */   // Label 3512: @180612
     /* 180612 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180657), // Rule ID 1643 //
     /* 180617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 180625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180646 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 180649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180655 */     GIR_RootConstrainSelectedInstOperands,
     /* 180656 */     // GIR_Coverage, 1643,
     /* 180656 */     GIR_EraseRootFromParent_Done,
     /* 180657 */   // Label 3513: @180657
     /* 180657 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180702), // Rule ID 1645 //
     /* 180662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 180670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180691 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 180694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180700 */     GIR_RootConstrainSelectedInstOperands,
     /* 180701 */     // GIR_Coverage, 1645,
     /* 180701 */     GIR_EraseRootFromParent_Done,
     /* 180702 */   // Label 3514: @180702
     /* 180702 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180747), // Rule ID 1646 //
     /* 180707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 180715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180736 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 180739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180745 */     GIR_RootConstrainSelectedInstOperands,
     /* 180746 */     // GIR_Coverage, 1646,
     /* 180746 */     GIR_EraseRootFromParent_Done,
     /* 180747 */   // Label 3515: @180747
     /* 180747 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180792), // Rule ID 1647 //
     /* 180752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 180760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180781 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 180784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180790 */     GIR_RootConstrainSelectedInstOperands,
     /* 180791 */     // GIR_Coverage, 1647,
     /* 180791 */     GIR_EraseRootFromParent_Done,
     /* 180792 */   // Label 3516: @180792
     /* 180792 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180837), // Rule ID 1648 //
     /* 180797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 180805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180826 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 180829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180835 */     GIR_RootConstrainSelectedInstOperands,
     /* 180836 */     // GIR_Coverage, 1648,
     /* 180836 */     GIR_EraseRootFromParent_Done,
     /* 180837 */   // Label 3517: @180837
     /* 180837 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180882), // Rule ID 1649 //
     /* 180842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 180850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180871 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 180874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180880 */     GIR_RootConstrainSelectedInstOperands,
     /* 180881 */     // GIR_Coverage, 1649,
     /* 180881 */     GIR_EraseRootFromParent_Done,
     /* 180882 */   // Label 3518: @180882
     /* 180882 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180927), // Rule ID 1650 //
     /* 180887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 180895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180916 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 180919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180925 */     GIR_RootConstrainSelectedInstOperands,
     /* 180926 */     // GIR_Coverage, 1650,
     /* 180926 */     GIR_EraseRootFromParent_Done,
     /* 180927 */   // Label 3519: @180927
     /* 180927 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180972), // Rule ID 1651 //
     /* 180932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180961 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 180964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180970 */     GIR_RootConstrainSelectedInstOperands,
     /* 180971 */     // GIR_Coverage, 1651,
     /* 180971 */     GIR_EraseRootFromParent_Done,
     /* 180972 */   // Label 3520: @180972
     /* 180972 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(181017), // Rule ID 1665 //
     /* 180977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181006 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 181006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 181009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181015 */     GIR_RootConstrainSelectedInstOperands,
     /* 181016 */     // GIR_Coverage, 1665,
     /* 181016 */     GIR_EraseRootFromParent_Done,
     /* 181017 */   // Label 3521: @181017
     /* 181017 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(181062), // Rule ID 1666 //
     /* 181022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 181030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181051 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 181051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 181054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181060 */     GIR_RootConstrainSelectedInstOperands,
     /* 181061 */     // GIR_Coverage, 1666,
     /* 181061 */     GIR_EraseRootFromParent_Done,
     /* 181062 */   // Label 3522: @181062
     /* 181062 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181107), // Rule ID 1671 //
     /* 181067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 181075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181096 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 181096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 181099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181105 */     GIR_RootConstrainSelectedInstOperands,
     /* 181106 */     // GIR_Coverage, 1671,
     /* 181106 */     GIR_EraseRootFromParent_Done,
     /* 181107 */   // Label 3523: @181107
     /* 181107 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181152), // Rule ID 1672 //
     /* 181112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 181120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181141 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 181141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 181144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181150 */     GIR_RootConstrainSelectedInstOperands,
     /* 181151 */     // GIR_Coverage, 1672,
     /* 181151 */     GIR_EraseRootFromParent_Done,
     /* 181152 */   // Label 3524: @181152
     /* 181152 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181197), // Rule ID 1673 //
     /* 181157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181186 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 181189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181195 */     GIR_RootConstrainSelectedInstOperands,
     /* 181196 */     // GIR_Coverage, 1673,
     /* 181196 */     GIR_EraseRootFromParent_Done,
     /* 181197 */   // Label 3525: @181197
     /* 181197 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181242), // Rule ID 1674 //
     /* 181202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181231 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 181234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181240 */     GIR_RootConstrainSelectedInstOperands,
     /* 181241 */     // GIR_Coverage, 1674,
     /* 181241 */     GIR_EraseRootFromParent_Done,
     /* 181242 */   // Label 3526: @181242
     /* 181242 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181287), // Rule ID 1675 //
     /* 181247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181276 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 181279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181285 */     GIR_RootConstrainSelectedInstOperands,
     /* 181286 */     // GIR_Coverage, 1675,
     /* 181286 */     GIR_EraseRootFromParent_Done,
     /* 181287 */   // Label 3527: @181287
     /* 181287 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181332), // Rule ID 1676 //
     /* 181292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181321 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 181324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181330 */     GIR_RootConstrainSelectedInstOperands,
     /* 181331 */     // GIR_Coverage, 1676,
     /* 181331 */     GIR_EraseRootFromParent_Done,
     /* 181332 */   // Label 3528: @181332
     /* 181332 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181377), // Rule ID 1677 //
     /* 181337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181366 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 181369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181375 */     GIR_RootConstrainSelectedInstOperands,
     /* 181376 */     // GIR_Coverage, 1677,
     /* 181376 */     GIR_EraseRootFromParent_Done,
     /* 181377 */   // Label 3529: @181377
     /* 181377 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181422), // Rule ID 1678 //
     /* 181382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181411 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 181414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181420 */     GIR_RootConstrainSelectedInstOperands,
     /* 181421 */     // GIR_Coverage, 1678,
     /* 181421 */     GIR_EraseRootFromParent_Done,
     /* 181422 */   // Label 3530: @181422
     /* 181422 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181467), // Rule ID 1679 //
     /* 181427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181456 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 181459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181465 */     GIR_RootConstrainSelectedInstOperands,
     /* 181466 */     // GIR_Coverage, 1679,
     /* 181466 */     GIR_EraseRootFromParent_Done,
     /* 181467 */   // Label 3531: @181467
     /* 181467 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181512), // Rule ID 1680 //
     /* 181472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181501 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 181504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181510 */     GIR_RootConstrainSelectedInstOperands,
     /* 181511 */     // GIR_Coverage, 1680,
     /* 181511 */     GIR_EraseRootFromParent_Done,
     /* 181512 */   // Label 3532: @181512
     /* 181512 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181557), // Rule ID 1681 //
     /* 181517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181546 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 181549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181555 */     GIR_RootConstrainSelectedInstOperands,
     /* 181556 */     // GIR_Coverage, 1681,
     /* 181556 */     GIR_EraseRootFromParent_Done,
     /* 181557 */   // Label 3533: @181557
     /* 181557 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181602), // Rule ID 1682 //
     /* 181562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181591 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 181594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181600 */     GIR_RootConstrainSelectedInstOperands,
     /* 181601 */     // GIR_Coverage, 1682,
     /* 181601 */     GIR_EraseRootFromParent_Done,
     /* 181602 */   // Label 3534: @181602
     /* 181602 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181647), // Rule ID 1683 //
     /* 181607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 181639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181645 */     GIR_RootConstrainSelectedInstOperands,
     /* 181646 */     // GIR_Coverage, 1683,
     /* 181646 */     GIR_EraseRootFromParent_Done,
     /* 181647 */   // Label 3535: @181647
     /* 181647 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181692), // Rule ID 1684 //
     /* 181652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181681 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181690 */     GIR_RootConstrainSelectedInstOperands,
     /* 181691 */     // GIR_Coverage, 1684,
     /* 181691 */     GIR_EraseRootFromParent_Done,
     /* 181692 */   // Label 3536: @181692
     /* 181692 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181737), // Rule ID 1750 //
     /* 181697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 181705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 181726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 181729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181735 */     GIR_RootConstrainSelectedInstOperands,
     /* 181736 */     // GIR_Coverage, 1750,
     /* 181736 */     GIR_EraseRootFromParent_Done,
     /* 181737 */   // Label 3537: @181737
     /* 181737 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181782), // Rule ID 1752 //
     /* 181742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 181750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181771 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 181771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181780 */     GIR_RootConstrainSelectedInstOperands,
     /* 181781 */     // GIR_Coverage, 1752,
     /* 181781 */     GIR_EraseRootFromParent_Done,
     /* 181782 */   // Label 3538: @181782
     /* 181782 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181827), // Rule ID 2303 //
     /* 181787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 181790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 181795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 181804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181816 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 181816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 181819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181825 */     GIR_RootConstrainSelectedInstOperands,
     /* 181826 */     // GIR_Coverage, 2303,
     /* 181826 */     GIR_EraseRootFromParent_Done,
     /* 181827 */   // Label 3539: @181827
     /* 181827 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181872), // Rule ID 2304 //
     /* 181832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 181835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 181840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 181849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181861 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 181861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 181864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181870 */     GIR_RootConstrainSelectedInstOperands,
     /* 181871 */     // GIR_Coverage, 2304,
     /* 181871 */     GIR_EraseRootFromParent_Done,
     /* 181872 */   // Label 3540: @181872
     /* 181872 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181917), // Rule ID 2315 //
     /* 181877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 181880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 181885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 181906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 181909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181915 */     GIR_RootConstrainSelectedInstOperands,
     /* 181916 */     // GIR_Coverage, 2315,
     /* 181916 */     GIR_EraseRootFromParent_Done,
     /* 181917 */   // Label 3541: @181917
     /* 181917 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181962), // Rule ID 2316 //
     /* 181922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 181925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 181930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181951 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 181951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 181954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181960 */     GIR_RootConstrainSelectedInstOperands,
     /* 181961 */     // GIR_Coverage, 2316,
     /* 181961 */     GIR_EraseRootFromParent_Done,
     /* 181962 */   // Label 3542: @181962
     /* 181962 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(182007), // Rule ID 2339 //
     /* 181967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 181970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 181975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181996 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 181996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 181999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182005 */     GIR_RootConstrainSelectedInstOperands,
     /* 182006 */     // GIR_Coverage, 2339,
     /* 182006 */     GIR_EraseRootFromParent_Done,
     /* 182007 */   // Label 3543: @182007
     /* 182007 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(182052), // Rule ID 2340 //
     /* 182012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182041 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 182041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 182044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182050 */     GIR_RootConstrainSelectedInstOperands,
     /* 182051 */     // GIR_Coverage, 2340,
     /* 182051 */     GIR_EraseRootFromParent_Done,
     /* 182052 */   // Label 3544: @182052
     /* 182052 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182097), // Rule ID 2341 //
     /* 182057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182086 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 182086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 182089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182095 */     GIR_RootConstrainSelectedInstOperands,
     /* 182096 */     // GIR_Coverage, 2341,
     /* 182096 */     GIR_EraseRootFromParent_Done,
     /* 182097 */   // Label 3545: @182097
     /* 182097 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182142), // Rule ID 2342 //
     /* 182102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182131 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 182131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 182134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182140 */     GIR_RootConstrainSelectedInstOperands,
     /* 182141 */     // GIR_Coverage, 2342,
     /* 182141 */     GIR_EraseRootFromParent_Done,
     /* 182142 */   // Label 3546: @182142
     /* 182142 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182187), // Rule ID 2343 //
     /* 182147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182176 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 182176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 182179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182185 */     GIR_RootConstrainSelectedInstOperands,
     /* 182186 */     // GIR_Coverage, 2343,
     /* 182186 */     GIR_EraseRootFromParent_Done,
     /* 182187 */   // Label 3547: @182187
     /* 182187 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182232), // Rule ID 2344 //
     /* 182192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 182206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 182209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182221 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 182221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 182224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182230 */     GIR_RootConstrainSelectedInstOperands,
     /* 182231 */     // GIR_Coverage, 2344,
     /* 182231 */     GIR_EraseRootFromParent_Done,
     /* 182232 */   // Label 3548: @182232
     /* 182232 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182277), // Rule ID 2347 //
     /* 182237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182266 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 182266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 182269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182275 */     GIR_RootConstrainSelectedInstOperands,
     /* 182276 */     // GIR_Coverage, 2347,
     /* 182276 */     GIR_EraseRootFromParent_Done,
     /* 182277 */   // Label 3549: @182277
     /* 182277 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182322), // Rule ID 2350 //
     /* 182282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182311 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 182311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 182314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182320 */     GIR_RootConstrainSelectedInstOperands,
     /* 182321 */     // GIR_Coverage, 2350,
     /* 182321 */     GIR_EraseRootFromParent_Done,
     /* 182322 */   // Label 3550: @182322
     /* 182322 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182367), // Rule ID 2353 //
     /* 182327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182356 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 182356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 182359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182365 */     GIR_RootConstrainSelectedInstOperands,
     /* 182366 */     // GIR_Coverage, 2353,
     /* 182366 */     GIR_EraseRootFromParent_Done,
     /* 182367 */   // Label 3551: @182367
     /* 182367 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182412), // Rule ID 2356 //
     /* 182372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182401 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 182401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 182404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182410 */     GIR_RootConstrainSelectedInstOperands,
     /* 182411 */     // GIR_Coverage, 2356,
     /* 182411 */     GIR_EraseRootFromParent_Done,
     /* 182412 */   // Label 3552: @182412
     /* 182412 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182457), // Rule ID 2359 //
     /* 182417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 182431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 182434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182446 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 182446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 182449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182455 */     GIR_RootConstrainSelectedInstOperands,
     /* 182456 */     // GIR_Coverage, 2359,
     /* 182456 */     GIR_EraseRootFromParent_Done,
     /* 182457 */   // Label 3553: @182457
     /* 182457 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182502), // Rule ID 2362 //
     /* 182462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182491 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 182491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 182494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182500 */     GIR_RootConstrainSelectedInstOperands,
     /* 182501 */     // GIR_Coverage, 2362,
     /* 182501 */     GIR_EraseRootFromParent_Done,
     /* 182502 */   // Label 3554: @182502
     /* 182502 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182547), // Rule ID 2365 //
     /* 182507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182536 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 182536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 182539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182545 */     GIR_RootConstrainSelectedInstOperands,
     /* 182546 */     // GIR_Coverage, 2365,
     /* 182546 */     GIR_EraseRootFromParent_Done,
     /* 182547 */   // Label 3555: @182547
     /* 182547 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182592), // Rule ID 2368 //
     /* 182552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182581 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 182581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 182584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182590 */     GIR_RootConstrainSelectedInstOperands,
     /* 182591 */     // GIR_Coverage, 2368,
     /* 182591 */     GIR_EraseRootFromParent_Done,
     /* 182592 */   // Label 3556: @182592
     /* 182592 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182637), // Rule ID 2371 //
     /* 182597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182626 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 182626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 182629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182635 */     GIR_RootConstrainSelectedInstOperands,
     /* 182636 */     // GIR_Coverage, 2371,
     /* 182636 */     GIR_EraseRootFromParent_Done,
     /* 182637 */   // Label 3557: @182637
     /* 182637 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182682), // Rule ID 2508 //
     /* 182642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 182650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182671 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 182674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182680 */     GIR_RootConstrainSelectedInstOperands,
     /* 182681 */     // GIR_Coverage, 2508,
     /* 182681 */     GIR_EraseRootFromParent_Done,
     /* 182682 */   // Label 3558: @182682
     /* 182682 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182727), // Rule ID 2509 //
     /* 182687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 182695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182716 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 182719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182725 */     GIR_RootConstrainSelectedInstOperands,
     /* 182726 */     // GIR_Coverage, 2509,
     /* 182726 */     GIR_EraseRootFromParent_Done,
     /* 182727 */   // Label 3559: @182727
     /* 182727 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182772), // Rule ID 2510 //
     /* 182732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 182740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182761 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 182764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182770 */     GIR_RootConstrainSelectedInstOperands,
     /* 182771 */     // GIR_Coverage, 2510,
     /* 182771 */     GIR_EraseRootFromParent_Done,
     /* 182772 */   // Label 3560: @182772
     /* 182772 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182817), // Rule ID 2511 //
     /* 182777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 182785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182806 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 182809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182815 */     GIR_RootConstrainSelectedInstOperands,
     /* 182816 */     // GIR_Coverage, 2511,
     /* 182816 */     GIR_EraseRootFromParent_Done,
     /* 182817 */   // Label 3561: @182817
     /* 182817 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182862), // Rule ID 2516 //
     /* 182822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 182830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182851 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 182851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 182854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182860 */     GIR_RootConstrainSelectedInstOperands,
     /* 182861 */     // GIR_Coverage, 2516,
     /* 182861 */     GIR_EraseRootFromParent_Done,
     /* 182862 */   // Label 3562: @182862
     /* 182862 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182907), // Rule ID 2634 //
     /* 182867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182896 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 182899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182905 */     GIR_RootConstrainSelectedInstOperands,
     /* 182906 */     // GIR_Coverage, 2634,
     /* 182906 */     GIR_EraseRootFromParent_Done,
     /* 182907 */   // Label 3563: @182907
     /* 182907 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182952), // Rule ID 2635 //
     /* 182912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182941 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 182944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182950 */     GIR_RootConstrainSelectedInstOperands,
     /* 182951 */     // GIR_Coverage, 2635,
     /* 182951 */     GIR_EraseRootFromParent_Done,
     /* 182952 */   // Label 3564: @182952
     /* 182952 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182997), // Rule ID 2636 //
     /* 182957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182986 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 182989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182995 */     GIR_RootConstrainSelectedInstOperands,
     /* 182996 */     // GIR_Coverage, 2636,
     /* 182996 */     GIR_EraseRootFromParent_Done,
     /* 182997 */   // Label 3565: @182997
     /* 182997 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183042), // Rule ID 2637 //
     /* 183002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 183010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183031 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 183034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183040 */     GIR_RootConstrainSelectedInstOperands,
     /* 183041 */     // GIR_Coverage, 2637,
     /* 183041 */     GIR_EraseRootFromParent_Done,
     /* 183042 */   // Label 3566: @183042
     /* 183042 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183087), // Rule ID 2638 //
     /* 183047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183076 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 183079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183085 */     GIR_RootConstrainSelectedInstOperands,
     /* 183086 */     // GIR_Coverage, 2638,
     /* 183086 */     GIR_EraseRootFromParent_Done,
     /* 183087 */   // Label 3567: @183087
     /* 183087 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183132), // Rule ID 2639 //
     /* 183092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183121 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183130 */     GIR_RootConstrainSelectedInstOperands,
     /* 183131 */     // GIR_Coverage, 2639,
     /* 183131 */     GIR_EraseRootFromParent_Done,
     /* 183132 */   // Label 3568: @183132
     /* 183132 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183177), // Rule ID 2640 //
     /* 183137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183166 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 183169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183175 */     GIR_RootConstrainSelectedInstOperands,
     /* 183176 */     // GIR_Coverage, 2640,
     /* 183176 */     GIR_EraseRootFromParent_Done,
     /* 183177 */   // Label 3569: @183177
     /* 183177 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183222), // Rule ID 2641 //
     /* 183182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183211 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 183214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183220 */     GIR_RootConstrainSelectedInstOperands,
     /* 183221 */     // GIR_Coverage, 2641,
     /* 183221 */     GIR_EraseRootFromParent_Done,
     /* 183222 */   // Label 3570: @183222
     /* 183222 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183267), // Rule ID 3815 //
     /* 183227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 183230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 183235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183256 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 183256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 183259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 183261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183265 */     GIR_RootConstrainSelectedInstOperands,
     /* 183266 */     // GIR_Coverage, 3815,
     /* 183266 */     GIR_EraseRootFromParent_Done,
     /* 183267 */   // Label 3571: @183267
     /* 183267 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183312), // Rule ID 3843 //
     /* 183272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 183275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 183280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 183301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 183304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183310 */     GIR_RootConstrainSelectedInstOperands,
     /* 183311 */     // GIR_Coverage, 3843,
     /* 183311 */     GIR_EraseRootFromParent_Done,
     /* 183312 */   // Label 3572: @183312
     /* 183312 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183357), // Rule ID 3853 //
     /* 183317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 183320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 183325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 183346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 183349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183355 */     GIR_RootConstrainSelectedInstOperands,
     /* 183356 */     // GIR_Coverage, 3853,
     /* 183356 */     GIR_EraseRootFromParent_Done,
     /* 183357 */   // Label 3573: @183357
     /* 183357 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183402), // Rule ID 3854 //
     /* 183362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 183365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 183370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183391 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 183391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 183394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 183396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183400 */     GIR_RootConstrainSelectedInstOperands,
     /* 183401 */     // GIR_Coverage, 3854,
     /* 183401 */     GIR_EraseRootFromParent_Done,
     /* 183402 */   // Label 3574: @183402
     /* 183402 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183450), // Rule ID 3855 //
     /* 183407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 183424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183436 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 183436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 183439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183448 */     GIR_RootConstrainSelectedInstOperands,
     /* 183449 */     // GIR_Coverage, 3855,
     /* 183449 */     GIR_EraseRootFromParent_Done,
     /* 183450 */   // Label 3575: @183450
     /* 183450 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183498), // Rule ID 3856 //
     /* 183455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 183472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183484 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 183484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 183487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183496 */     GIR_RootConstrainSelectedInstOperands,
     /* 183497 */     // GIR_Coverage, 3856,
     /* 183497 */     GIR_EraseRootFromParent_Done,
     /* 183498 */   // Label 3576: @183498
     /* 183498 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183546), // Rule ID 3857 //
     /* 183503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 183520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183532 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 183532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 183535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183544 */     GIR_RootConstrainSelectedInstOperands,
     /* 183545 */     // GIR_Coverage, 3857,
     /* 183545 */     GIR_EraseRootFromParent_Done,
     /* 183546 */   // Label 3577: @183546
     /* 183546 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183594), // Rule ID 3858 //
     /* 183551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 183568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183580 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 183580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 183583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183592 */     GIR_RootConstrainSelectedInstOperands,
     /* 183593 */     // GIR_Coverage, 3858,
     /* 183593 */     GIR_EraseRootFromParent_Done,
     /* 183594 */   // Label 3578: @183594
     /* 183594 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183642), // Rule ID 3859 //
     /* 183599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 183616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183628 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 183628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 183631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183640 */     GIR_RootConstrainSelectedInstOperands,
     /* 183641 */     // GIR_Coverage, 3859,
     /* 183641 */     GIR_EraseRootFromParent_Done,
     /* 183642 */   // Label 3579: @183642
     /* 183642 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183690), // Rule ID 3860 //
     /* 183647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 183664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183676 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 183676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 183679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183688 */     GIR_RootConstrainSelectedInstOperands,
     /* 183689 */     // GIR_Coverage, 3860,
     /* 183689 */     GIR_EraseRootFromParent_Done,
     /* 183690 */   // Label 3580: @183690
     /* 183690 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183738), // Rule ID 3861 //
     /* 183695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183724 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 183724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 183727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183736 */     GIR_RootConstrainSelectedInstOperands,
     /* 183737 */     // GIR_Coverage, 3861,
     /* 183737 */     GIR_EraseRootFromParent_Done,
     /* 183738 */   // Label 3581: @183738
     /* 183738 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183786), // Rule ID 3862 //
     /* 183743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183772 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 183772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 183775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183784 */     GIR_RootConstrainSelectedInstOperands,
     /* 183785 */     // GIR_Coverage, 3862,
     /* 183785 */     GIR_EraseRootFromParent_Done,
     /* 183786 */   // Label 3582: @183786
     /* 183786 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183834), // Rule ID 3863 //
     /* 183791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183820 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 183820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 183823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183832 */     GIR_RootConstrainSelectedInstOperands,
     /* 183833 */     // GIR_Coverage, 3863,
     /* 183833 */     GIR_EraseRootFromParent_Done,
     /* 183834 */   // Label 3583: @183834
     /* 183834 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183882), // Rule ID 3864 //
     /* 183839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183868 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 183868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 183871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183880 */     GIR_RootConstrainSelectedInstOperands,
     /* 183881 */     // GIR_Coverage, 3864,
     /* 183881 */     GIR_EraseRootFromParent_Done,
     /* 183882 */   // Label 3584: @183882
     /* 183882 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183924), // Rule ID 3929 //
     /* 183887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 183892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183913 */     // (intrinsic_wo_chain:{ *:[i32] } 2169:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 183913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 183916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183922 */     GIR_RootConstrainSelectedInstOperands,
     /* 183923 */     // GIR_Coverage, 3929,
     /* 183923 */     GIR_EraseRootFromParent_Done,
     /* 183924 */   // Label 3585: @183924
     /* 183924 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183966), // Rule ID 3930 //
     /* 183929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 183934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183955 */     // (intrinsic_wo_chain:{ *:[i64] } 2169:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 183958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183964 */     GIR_RootConstrainSelectedInstOperands,
     /* 183965 */     // GIR_Coverage, 3930,
     /* 183965 */     GIR_EraseRootFromParent_Done,
     /* 183966 */   // Label 3586: @183966
     /* 183966 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184008), // Rule ID 3931 //
     /* 183971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 183976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183997 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 183997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 184000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184006 */     GIR_RootConstrainSelectedInstOperands,
     /* 184007 */     // GIR_Coverage, 3931,
     /* 184007 */     GIR_EraseRootFromParent_Done,
     /* 184008 */   // Label 3587: @184008
     /* 184008 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184050), // Rule ID 3932 //
     /* 184013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 184018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184039 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 184042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184048 */     GIR_RootConstrainSelectedInstOperands,
     /* 184049 */     // GIR_Coverage, 3932,
     /* 184049 */     GIR_EraseRootFromParent_Done,
     /* 184050 */   // Label 3588: @184050
     /* 184050 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184092), // Rule ID 5207 //
     /* 184055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 184060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184081 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 184084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184090 */     GIR_RootConstrainSelectedInstOperands,
     /* 184091 */     // GIR_Coverage, 5207,
     /* 184091 */     GIR_EraseRootFromParent_Done,
     /* 184092 */   // Label 3589: @184092
     /* 184092 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184137), // Rule ID 5211 //
     /* 184097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 184105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184126 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 184129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184135 */     GIR_RootConstrainSelectedInstOperands,
     /* 184136 */     // GIR_Coverage, 5211,
     /* 184136 */     GIR_EraseRootFromParent_Done,
     /* 184137 */   // Label 3590: @184137
     /* 184137 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184182), // Rule ID 5215 //
     /* 184142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 184150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184171 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 184174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184180 */     GIR_RootConstrainSelectedInstOperands,
     /* 184181 */     // GIR_Coverage, 5215,
     /* 184181 */     GIR_EraseRootFromParent_Done,
     /* 184182 */   // Label 3591: @184182
     /* 184182 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184227), // Rule ID 5216 //
     /* 184187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 184195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184216 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 184219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184225 */     GIR_RootConstrainSelectedInstOperands,
     /* 184226 */     // GIR_Coverage, 5216,
     /* 184226 */     GIR_EraseRootFromParent_Done,
     /* 184227 */   // Label 3592: @184227
     /* 184227 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184272), // Rule ID 5217 //
     /* 184232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 184240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184261 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 184264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184270 */     GIR_RootConstrainSelectedInstOperands,
     /* 184271 */     // GIR_Coverage, 5217,
     /* 184271 */     GIR_EraseRootFromParent_Done,
     /* 184272 */   // Label 3593: @184272
     /* 184272 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184317), // Rule ID 5218 //
     /* 184277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 184285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184306 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 184309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184315 */     GIR_RootConstrainSelectedInstOperands,
     /* 184316 */     // GIR_Coverage, 5218,
     /* 184316 */     GIR_EraseRootFromParent_Done,
     /* 184317 */   // Label 3594: @184317
     /* 184317 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184362), // Rule ID 5219 //
     /* 184322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 184330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184351 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 184354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184360 */     GIR_RootConstrainSelectedInstOperands,
     /* 184361 */     // GIR_Coverage, 5219,
     /* 184361 */     GIR_EraseRootFromParent_Done,
     /* 184362 */   // Label 3595: @184362
     /* 184362 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184407), // Rule ID 5220 //
     /* 184367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 184375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184396 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 184399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184405 */     GIR_RootConstrainSelectedInstOperands,
     /* 184406 */     // GIR_Coverage, 5220,
     /* 184406 */     GIR_EraseRootFromParent_Done,
     /* 184407 */   // Label 3596: @184407
     /* 184407 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184452), // Rule ID 5221 //
     /* 184412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 184420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184441 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 184444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184450 */     GIR_RootConstrainSelectedInstOperands,
     /* 184451 */     // GIR_Coverage, 5221,
     /* 184451 */     GIR_EraseRootFromParent_Done,
     /* 184452 */   // Label 3597: @184452
     /* 184452 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184497), // Rule ID 5222 //
     /* 184457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 184465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184486 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 184489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184495 */     GIR_RootConstrainSelectedInstOperands,
     /* 184496 */     // GIR_Coverage, 5222,
     /* 184496 */     GIR_EraseRootFromParent_Done,
     /* 184497 */   // Label 3598: @184497
     /* 184497 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184542), // Rule ID 5223 //
     /* 184502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 184510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184531 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 184534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184540 */     GIR_RootConstrainSelectedInstOperands,
     /* 184541 */     // GIR_Coverage, 5223,
     /* 184541 */     GIR_EraseRootFromParent_Done,
     /* 184542 */   // Label 3599: @184542
     /* 184542 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184587), // Rule ID 5224 //
     /* 184547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 184555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184576 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 184579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184585 */     GIR_RootConstrainSelectedInstOperands,
     /* 184586 */     // GIR_Coverage, 5224,
     /* 184586 */     GIR_EraseRootFromParent_Done,
     /* 184587 */   // Label 3600: @184587
     /* 184587 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184632), // Rule ID 5225 //
     /* 184592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 184600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184621 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 184624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184630 */     GIR_RootConstrainSelectedInstOperands,
     /* 184631 */     // GIR_Coverage, 5225,
     /* 184631 */     GIR_EraseRootFromParent_Done,
     /* 184632 */   // Label 3601: @184632
     /* 184632 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184677), // Rule ID 5226 //
     /* 184637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 184645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184666 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 184669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184675 */     GIR_RootConstrainSelectedInstOperands,
     /* 184676 */     // GIR_Coverage, 5226,
     /* 184676 */     GIR_EraseRootFromParent_Done,
     /* 184677 */   // Label 3602: @184677
     /* 184677 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184722), // Rule ID 5227 //
     /* 184682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 184690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184711 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 184714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184720 */     GIR_RootConstrainSelectedInstOperands,
     /* 184721 */     // GIR_Coverage, 5227,
     /* 184721 */     GIR_EraseRootFromParent_Done,
     /* 184722 */   // Label 3603: @184722
     /* 184722 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184767), // Rule ID 5228 //
     /* 184727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 184735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184756 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 184759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184765 */     GIR_RootConstrainSelectedInstOperands,
     /* 184766 */     // GIR_Coverage, 5228,
     /* 184766 */     GIR_EraseRootFromParent_Done,
     /* 184767 */   // Label 3604: @184767
     /* 184767 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184812), // Rule ID 5229 //
     /* 184772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 184780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184801 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 184804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184810 */     GIR_RootConstrainSelectedInstOperands,
     /* 184811 */     // GIR_Coverage, 5229,
     /* 184811 */     GIR_EraseRootFromParent_Done,
     /* 184812 */   // Label 3605: @184812
     /* 184812 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184857), // Rule ID 5230 //
     /* 184817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 184825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184846 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 184849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184855 */     GIR_RootConstrainSelectedInstOperands,
     /* 184856 */     // GIR_Coverage, 5230,
     /* 184856 */     GIR_EraseRootFromParent_Done,
     /* 184857 */   // Label 3606: @184857
     /* 184857 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184902), // Rule ID 5231 //
     /* 184862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 184870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184891 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 184894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184900 */     GIR_RootConstrainSelectedInstOperands,
     /* 184901 */     // GIR_Coverage, 5231,
     /* 184901 */     GIR_EraseRootFromParent_Done,
     /* 184902 */   // Label 3607: @184902
     /* 184902 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184947), // Rule ID 5250 //
     /* 184907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 184915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184936 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 184936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 184939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184945 */     GIR_RootConstrainSelectedInstOperands,
     /* 184946 */     // GIR_Coverage, 5250,
     /* 184946 */     GIR_EraseRootFromParent_Done,
     /* 184947 */   // Label 3608: @184947
     /* 184947 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184989), // Rule ID 5584 //
     /* 184952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 184957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 184960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 184966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184978 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 184978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 184981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 184983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 184987 */     GIR_RootConstrainSelectedInstOperands,
     /* 184988 */     // GIR_Coverage, 5584,
     /* 184988 */     GIR_EraseRootFromParent_Done,
     /* 184989 */   // Label 3609: @184989
     /* 184989 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185031), // Rule ID 5585 //
     /* 184994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 184999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 185002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 185005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185020 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 185020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 185023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 185025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 185027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185029 */     GIR_RootConstrainSelectedInstOperands,
     /* 185030 */     // GIR_Coverage, 5585,
     /* 185030 */     GIR_EraseRootFromParent_Done,
     /* 185031 */   // Label 3610: @185031
     /* 185031 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185128), // Rule ID 6298 //
     /* 185036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 185047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185062 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 185062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 185065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 185069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 185078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 185082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 185084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 185087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 185098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 185112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185127 */     // GIR_Coverage, 6298,
     /* 185127 */     GIR_EraseRootFromParent_Done,
     /* 185128 */   // Label 3611: @185128
     /* 185128 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185225), // Rule ID 6299 //
     /* 185133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 185138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 185144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 185147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185159 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 185159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 185162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 185166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 185175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 185179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 185181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 185184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 185195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 185209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185224 */     // GIR_Coverage, 6299,
     /* 185224 */     GIR_EraseRootFromParent_Done,
     /* 185225 */   // Label 3612: @185225
     /* 185225 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185267), // Rule ID 6944 //
     /* 185230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 185235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185256 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 185259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185265 */     GIR_RootConstrainSelectedInstOperands,
     /* 185266 */     // GIR_Coverage, 6944,
     /* 185266 */     GIR_EraseRootFromParent_Done,
     /* 185267 */   // Label 3613: @185267
     /* 185267 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185309), // Rule ID 6945 //
     /* 185272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 185277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185298 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 185301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185307 */     GIR_RootConstrainSelectedInstOperands,
     /* 185308 */     // GIR_Coverage, 6945,
     /* 185308 */     GIR_EraseRootFromParent_Done,
     /* 185309 */   // Label 3614: @185309
     /* 185309 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185351), // Rule ID 6946 //
     /* 185314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 185319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185340 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 185343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185349 */     GIR_RootConstrainSelectedInstOperands,
     /* 185350 */     // GIR_Coverage, 6946,
     /* 185350 */     GIR_EraseRootFromParent_Done,
     /* 185351 */   // Label 3615: @185351
     /* 185351 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185393), // Rule ID 6947 //
     /* 185356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 185361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185382 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 185385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185391 */     GIR_RootConstrainSelectedInstOperands,
     /* 185392 */     // GIR_Coverage, 6947,
     /* 185392 */     GIR_EraseRootFromParent_Done,
     /* 185393 */   // Label 3616: @185393
     /* 185393 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185441), // Rule ID 6987 //
     /* 185398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 185403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185424 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 185424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 185427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 185436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 185439 */     GIR_RootConstrainSelectedInstOperands,
     /* 185440 */     // GIR_Coverage, 6987,
     /* 185440 */     GIR_EraseRootFromParent_Done,
     /* 185441 */   // Label 3617: @185441
     /* 185441 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185486), // Rule ID 10045 //
     /* 185446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185475 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 185478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185484 */     GIR_RootConstrainSelectedInstOperands,
     /* 185485 */     // GIR_Coverage, 10045,
     /* 185485 */     GIR_EraseRootFromParent_Done,
     /* 185486 */   // Label 3618: @185486
     /* 185486 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185531), // Rule ID 10046 //
     /* 185491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185520 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 185523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185529 */     GIR_RootConstrainSelectedInstOperands,
     /* 185530 */     // GIR_Coverage, 10046,
     /* 185530 */     GIR_EraseRootFromParent_Done,
     /* 185531 */   // Label 3619: @185531
     /* 185531 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185576), // Rule ID 10047 //
     /* 185536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185565 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 185568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185574 */     GIR_RootConstrainSelectedInstOperands,
     /* 185575 */     // GIR_Coverage, 10047,
     /* 185575 */     GIR_EraseRootFromParent_Done,
     /* 185576 */   // Label 3620: @185576
     /* 185576 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185621), // Rule ID 10048 //
     /* 185581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185610 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 185613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185619 */     GIR_RootConstrainSelectedInstOperands,
     /* 185620 */     // GIR_Coverage, 10048,
     /* 185620 */     GIR_EraseRootFromParent_Done,
     /* 185621 */   // Label 3621: @185621
     /* 185621 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185666), // Rule ID 10057 //
     /* 185626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185655 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 185658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185664 */     GIR_RootConstrainSelectedInstOperands,
     /* 185665 */     // GIR_Coverage, 10057,
     /* 185665 */     GIR_EraseRootFromParent_Done,
     /* 185666 */   // Label 3622: @185666
     /* 185666 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185711), // Rule ID 10058 //
     /* 185671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185700 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 185703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185709 */     GIR_RootConstrainSelectedInstOperands,
     /* 185710 */     // GIR_Coverage, 10058,
     /* 185710 */     GIR_EraseRootFromParent_Done,
     /* 185711 */   // Label 3623: @185711
     /* 185711 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185756), // Rule ID 10059 //
     /* 185716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185745 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 185748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185754 */     GIR_RootConstrainSelectedInstOperands,
     /* 185755 */     // GIR_Coverage, 10059,
     /* 185755 */     GIR_EraseRootFromParent_Done,
     /* 185756 */   // Label 3624: @185756
     /* 185756 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185801), // Rule ID 10060 //
     /* 185761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185790 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 185793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185799 */     GIR_RootConstrainSelectedInstOperands,
     /* 185800 */     // GIR_Coverage, 10060,
     /* 185800 */     GIR_EraseRootFromParent_Done,
     /* 185801 */   // Label 3625: @185801
     /* 185801 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185846), // Rule ID 10061 //
     /* 185806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185835 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 185838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185844 */     GIR_RootConstrainSelectedInstOperands,
     /* 185845 */     // GIR_Coverage, 10061,
     /* 185845 */     GIR_EraseRootFromParent_Done,
     /* 185846 */   // Label 3626: @185846
     /* 185846 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185891), // Rule ID 10062 //
     /* 185851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185880 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 185883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185889 */     GIR_RootConstrainSelectedInstOperands,
     /* 185890 */     // GIR_Coverage, 10062,
     /* 185890 */     GIR_EraseRootFromParent_Done,
     /* 185891 */   // Label 3627: @185891
     /* 185891 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185936), // Rule ID 10063 //
     /* 185896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185925 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 185928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185934 */     GIR_RootConstrainSelectedInstOperands,
     /* 185935 */     // GIR_Coverage, 10063,
     /* 185935 */     GIR_EraseRootFromParent_Done,
     /* 185936 */   // Label 3628: @185936
     /* 185936 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185981), // Rule ID 10064 //
     /* 185941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185970 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 185973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185979 */     GIR_RootConstrainSelectedInstOperands,
     /* 185980 */     // GIR_Coverage, 10064,
     /* 185980 */     GIR_EraseRootFromParent_Done,
     /* 185981 */   // Label 3629: @185981
     /* 185981 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(186026), // Rule ID 10065 //
     /* 185986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 185994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186015 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 186018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186024 */     GIR_RootConstrainSelectedInstOperands,
     /* 186025 */     // GIR_Coverage, 10065,
     /* 186025 */     GIR_EraseRootFromParent_Done,
     /* 186026 */   // Label 3630: @186026
     /* 186026 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(186071), // Rule ID 10066 //
     /* 186031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 186048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186060 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 186063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186069 */     GIR_RootConstrainSelectedInstOperands,
     /* 186070 */     // GIR_Coverage, 10066,
     /* 186070 */     GIR_EraseRootFromParent_Done,
     /* 186071 */   // Label 3631: @186071
     /* 186071 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(186116), // Rule ID 10067 //
     /* 186076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 186093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186105 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 186108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186114 */     GIR_RootConstrainSelectedInstOperands,
     /* 186115 */     // GIR_Coverage, 10067,
     /* 186115 */     GIR_EraseRootFromParent_Done,
     /* 186116 */   // Label 3632: @186116
     /* 186116 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(186161), // Rule ID 10068 //
     /* 186121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 186138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186150 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 186153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186159 */     GIR_RootConstrainSelectedInstOperands,
     /* 186160 */     // GIR_Coverage, 10068,
     /* 186160 */     GIR_EraseRootFromParent_Done,
     /* 186161 */   // Label 3633: @186161
     /* 186161 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186207), // Rule ID 138 //
     /* 186166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 186169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 186174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186184 */     // MIs[0] Rn
     /* 186184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 186188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186196 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 186199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186205 */     GIR_RootConstrainSelectedInstOperands,
     /* 186206 */     // GIR_Coverage, 138,
     /* 186206 */     GIR_EraseRootFromParent_Done,
     /* 186207 */   // Label 3634: @186207
     /* 186207 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186254), // Rule ID 139 //
     /* 186212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 186215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 186220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186227 */     // MIs[0] Rn
     /* 186227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 186231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186235 */     // MIs[0] Rm
     /* 186235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186243 */     // (intrinsic_wo_chain:{ *:[i64] } 1242:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 186243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 186246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186252 */     GIR_RootConstrainSelectedInstOperands,
     /* 186253 */     // GIR_Coverage, 139,
     /* 186253 */     GIR_EraseRootFromParent_Done,
     /* 186254 */   // Label 3635: @186254
     /* 186254 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186291), // Rule ID 2399 //
     /* 186259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 186267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186280 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2151:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 186283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186289 */     GIR_RootConstrainSelectedInstOperands,
     /* 186290 */     // GIR_Coverage, 2399,
     /* 186290 */     GIR_EraseRootFromParent_Done,
     /* 186291 */   // Label 3636: @186291
     /* 186291 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186328), // Rule ID 2400 //
     /* 186296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 186304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186317 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 186320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186326 */     GIR_RootConstrainSelectedInstOperands,
     /* 186327 */     // GIR_Coverage, 2400,
     /* 186327 */     GIR_EraseRootFromParent_Done,
     /* 186328 */   // Label 3637: @186328
     /* 186328 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186365), // Rule ID 2401 //
     /* 186333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 186341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186354 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 186357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186363 */     GIR_RootConstrainSelectedInstOperands,
     /* 186364 */     // GIR_Coverage, 2401,
     /* 186364 */     GIR_EraseRootFromParent_Done,
     /* 186365 */   // Label 3638: @186365
     /* 186365 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186402), // Rule ID 2403 //
     /* 186370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 186378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2156:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 186394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186400 */     GIR_RootConstrainSelectedInstOperands,
     /* 186401 */     // GIR_Coverage, 2403,
     /* 186401 */     GIR_EraseRootFromParent_Done,
     /* 186402 */   // Label 3639: @186402
     /* 186402 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186439), // Rule ID 2404 //
     /* 186407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 186415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 186431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186437 */     GIR_RootConstrainSelectedInstOperands,
     /* 186438 */     // GIR_Coverage, 2404,
     /* 186438 */     GIR_EraseRootFromParent_Done,
     /* 186439 */   // Label 3640: @186439
     /* 186439 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186476), // Rule ID 2405 //
     /* 186444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 186452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 186468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186474 */     GIR_RootConstrainSelectedInstOperands,
     /* 186475 */     // GIR_Coverage, 2405,
     /* 186475 */     GIR_EraseRootFromParent_Done,
     /* 186476 */   // Label 3641: @186476
     /* 186476 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186513), // Rule ID 2407 //
     /* 186481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 186489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2077:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 186505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186511 */     GIR_RootConstrainSelectedInstOperands,
     /* 186512 */     // GIR_Coverage, 2407,
     /* 186512 */     GIR_EraseRootFromParent_Done,
     /* 186513 */   // Label 3642: @186513
     /* 186513 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186550), // Rule ID 2408 //
     /* 186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 186526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 186542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186548 */     GIR_RootConstrainSelectedInstOperands,
     /* 186549 */     // GIR_Coverage, 2408,
     /* 186549 */     GIR_EraseRootFromParent_Done,
     /* 186550 */   // Label 3643: @186550
     /* 186550 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186587), // Rule ID 2409 //
     /* 186555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 186563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 186579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186585 */     GIR_RootConstrainSelectedInstOperands,
     /* 186586 */     // GIR_Coverage, 2409,
     /* 186586 */     GIR_EraseRootFromParent_Done,
     /* 186587 */   // Label 3644: @186587
     /* 186587 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186624), // Rule ID 2411 //
     /* 186592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 186600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 186616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186622 */     GIR_RootConstrainSelectedInstOperands,
     /* 186623 */     // GIR_Coverage, 2411,
     /* 186623 */     GIR_EraseRootFromParent_Done,
     /* 186624 */   // Label 3645: @186624
     /* 186624 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186661), // Rule ID 2412 //
     /* 186629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 186637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 186653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186659 */     GIR_RootConstrainSelectedInstOperands,
     /* 186660 */     // GIR_Coverage, 2412,
     /* 186660 */     GIR_EraseRootFromParent_Done,
     /* 186661 */   // Label 3646: @186661
     /* 186661 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186698), // Rule ID 2413 //
     /* 186666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 186674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186687 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 186690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186696 */     GIR_RootConstrainSelectedInstOperands,
     /* 186697 */     // GIR_Coverage, 2413,
     /* 186697 */     GIR_EraseRootFromParent_Done,
     /* 186698 */   // Label 3647: @186698
     /* 186698 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186735), // Rule ID 2415 //
     /* 186703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 186711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186724 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 186727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186733 */     GIR_RootConstrainSelectedInstOperands,
     /* 186734 */     // GIR_Coverage, 2415,
     /* 186734 */     GIR_EraseRootFromParent_Done,
     /* 186735 */   // Label 3648: @186735
     /* 186735 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186772), // Rule ID 2416 //
     /* 186740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 186748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186761 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 186764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186770 */     GIR_RootConstrainSelectedInstOperands,
     /* 186771 */     // GIR_Coverage, 2416,
     /* 186771 */     GIR_EraseRootFromParent_Done,
     /* 186772 */   // Label 3649: @186772
     /* 186772 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186809), // Rule ID 2417 //
     /* 186777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 186785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 186801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186807 */     GIR_RootConstrainSelectedInstOperands,
     /* 186808 */     // GIR_Coverage, 2417,
     /* 186808 */     GIR_EraseRootFromParent_Done,
     /* 186809 */   // Label 3650: @186809
     /* 186809 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186846), // Rule ID 2419 //
     /* 186814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 186822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186835 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1926:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 186838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186844 */     GIR_RootConstrainSelectedInstOperands,
     /* 186845 */     // GIR_Coverage, 2419,
     /* 186845 */     GIR_EraseRootFromParent_Done,
     /* 186846 */   // Label 3651: @186846
     /* 186846 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186883), // Rule ID 2420 //
     /* 186851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 186859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 186875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186881 */     GIR_RootConstrainSelectedInstOperands,
     /* 186882 */     // GIR_Coverage, 2420,
     /* 186882 */     GIR_EraseRootFromParent_Done,
     /* 186883 */   // Label 3652: @186883
     /* 186883 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186920), // Rule ID 2421 //
     /* 186888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 186896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186909 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 186912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186918 */     GIR_RootConstrainSelectedInstOperands,
     /* 186919 */     // GIR_Coverage, 2421,
     /* 186919 */     GIR_EraseRootFromParent_Done,
     /* 186920 */   // Label 3653: @186920
     /* 186920 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186957), // Rule ID 2422 //
     /* 186925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 186928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 186933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1546:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 186946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 186949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 186953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 186955 */     GIR_RootConstrainSelectedInstOperands,
     /* 186956 */     // GIR_Coverage, 2422,
     /* 186956 */     GIR_EraseRootFromParent_Done,
     /* 186957 */   // Label 3654: @186957
     /* 186957 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186997), // Rule ID 2621 //
     /* 186962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 186970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 186983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 186986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 186988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186995 */     GIR_RootConstrainSelectedInstOperands,
     /* 186996 */     // GIR_Coverage, 2621,
     /* 186996 */     GIR_EraseRootFromParent_Done,
     /* 186997 */   // Label 3655: @186997
     /* 186997 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187037), // Rule ID 2622 //
     /* 187002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187023 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 187026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187035 */     GIR_RootConstrainSelectedInstOperands,
     /* 187036 */     // GIR_Coverage, 2622,
     /* 187036 */     GIR_EraseRootFromParent_Done,
     /* 187037 */   // Label 3656: @187037
     /* 187037 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187077), // Rule ID 2623 //
     /* 187042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187063 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 187066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187075 */     GIR_RootConstrainSelectedInstOperands,
     /* 187076 */     // GIR_Coverage, 2623,
     /* 187076 */     GIR_EraseRootFromParent_Done,
     /* 187077 */   // Label 3657: @187077
     /* 187077 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(187117), // Rule ID 2624 //
     /* 187082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187103 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 187106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187115 */     GIR_RootConstrainSelectedInstOperands,
     /* 187116 */     // GIR_Coverage, 2624,
     /* 187116 */     GIR_EraseRootFromParent_Done,
     /* 187117 */   // Label 3658: @187117
     /* 187117 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187157), // Rule ID 2625 //
     /* 187122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187143 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 187146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187155 */     GIR_RootConstrainSelectedInstOperands,
     /* 187156 */     // GIR_Coverage, 2625,
     /* 187156 */     GIR_EraseRootFromParent_Done,
     /* 187157 */   // Label 3659: @187157
     /* 187157 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187194), // Rule ID 2642 //
     /* 187162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187183 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 187186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187192 */     GIR_RootConstrainSelectedInstOperands,
     /* 187193 */     // GIR_Coverage, 2642,
     /* 187193 */     GIR_EraseRootFromParent_Done,
     /* 187194 */   // Label 3660: @187194
     /* 187194 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187231), // Rule ID 2643 //
     /* 187199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 187223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187229 */     GIR_RootConstrainSelectedInstOperands,
     /* 187230 */     // GIR_Coverage, 2643,
     /* 187230 */     GIR_EraseRootFromParent_Done,
     /* 187231 */   // Label 3661: @187231
     /* 187231 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187268), // Rule ID 2644 //
     /* 187236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 187260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187266 */     GIR_RootConstrainSelectedInstOperands,
     /* 187267 */     // GIR_Coverage, 2644,
     /* 187267 */     GIR_EraseRootFromParent_Done,
     /* 187268 */   // Label 3662: @187268
     /* 187268 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187305), // Rule ID 2645 //
     /* 187273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187294 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 187297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187303 */     GIR_RootConstrainSelectedInstOperands,
     /* 187304 */     // GIR_Coverage, 2645,
     /* 187304 */     GIR_EraseRootFromParent_Done,
     /* 187305 */   // Label 3663: @187305
     /* 187305 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187342), // Rule ID 2646 //
     /* 187310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187331 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 187334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187340 */     GIR_RootConstrainSelectedInstOperands,
     /* 187341 */     // GIR_Coverage, 2646,
     /* 187341 */     GIR_EraseRootFromParent_Done,
     /* 187342 */   // Label 3664: @187342
     /* 187342 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187379), // Rule ID 2647 //
     /* 187347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187368 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 187371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187377 */     GIR_RootConstrainSelectedInstOperands,
     /* 187378 */     // GIR_Coverage, 2647,
     /* 187378 */     GIR_EraseRootFromParent_Done,
     /* 187379 */   // Label 3665: @187379
     /* 187379 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187416), // Rule ID 2648 //
     /* 187384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187405 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 187408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187414 */     GIR_RootConstrainSelectedInstOperands,
     /* 187415 */     // GIR_Coverage, 2648,
     /* 187415 */     GIR_EraseRootFromParent_Done,
     /* 187416 */   // Label 3666: @187416
     /* 187416 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187453), // Rule ID 2826 //
     /* 187421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 187445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187451 */     GIR_RootConstrainSelectedInstOperands,
     /* 187452 */     // GIR_Coverage, 2826,
     /* 187452 */     GIR_EraseRootFromParent_Done,
     /* 187453 */   // Label 3667: @187453
     /* 187453 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187490), // Rule ID 2827 //
     /* 187458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187479 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 187482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187488 */     GIR_RootConstrainSelectedInstOperands,
     /* 187489 */     // GIR_Coverage, 2827,
     /* 187489 */     GIR_EraseRootFromParent_Done,
     /* 187490 */   // Label 3668: @187490
     /* 187490 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187527), // Rule ID 2828 //
     /* 187495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 187519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187525 */     GIR_RootConstrainSelectedInstOperands,
     /* 187526 */     // GIR_Coverage, 2828,
     /* 187526 */     GIR_EraseRootFromParent_Done,
     /* 187527 */   // Label 3669: @187527
     /* 187527 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187564), // Rule ID 2999 //
     /* 187532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 187556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187562 */     GIR_RootConstrainSelectedInstOperands,
     /* 187563 */     // GIR_Coverage, 2999,
     /* 187563 */     GIR_EraseRootFromParent_Done,
     /* 187564 */   // Label 3670: @187564
     /* 187564 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187601), // Rule ID 3000 //
     /* 187569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 187593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187599 */     GIR_RootConstrainSelectedInstOperands,
     /* 187600 */     // GIR_Coverage, 3000,
     /* 187600 */     GIR_EraseRootFromParent_Done,
     /* 187601 */   // Label 3671: @187601
     /* 187601 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187638), // Rule ID 3001 //
     /* 187606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 187630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187636 */     GIR_RootConstrainSelectedInstOperands,
     /* 187637 */     // GIR_Coverage, 3001,
     /* 187637 */     GIR_EraseRootFromParent_Done,
     /* 187638 */   // Label 3672: @187638
     /* 187638 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187675), // Rule ID 3002 //
     /* 187643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 187667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187673 */     GIR_RootConstrainSelectedInstOperands,
     /* 187674 */     // GIR_Coverage, 3002,
     /* 187674 */     GIR_EraseRootFromParent_Done,
     /* 187675 */   // Label 3673: @187675
     /* 187675 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187712), // Rule ID 3003 //
     /* 187680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 187688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 187704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187710 */     GIR_RootConstrainSelectedInstOperands,
     /* 187711 */     // GIR_Coverage, 3003,
     /* 187711 */     GIR_EraseRootFromParent_Done,
     /* 187712 */   // Label 3674: @187712
     /* 187712 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187749), // Rule ID 3025 //
     /* 187717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 187741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187747 */     GIR_RootConstrainSelectedInstOperands,
     /* 187748 */     // GIR_Coverage, 3025,
     /* 187748 */     GIR_EraseRootFromParent_Done,
     /* 187749 */   // Label 3675: @187749
     /* 187749 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187786), // Rule ID 3026 //
     /* 187754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 187778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187784 */     GIR_RootConstrainSelectedInstOperands,
     /* 187785 */     // GIR_Coverage, 3026,
     /* 187785 */     GIR_EraseRootFromParent_Done,
     /* 187786 */   // Label 3676: @187786
     /* 187786 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187823), // Rule ID 3027 //
     /* 187791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 187815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187821 */     GIR_RootConstrainSelectedInstOperands,
     /* 187822 */     // GIR_Coverage, 3027,
     /* 187822 */     GIR_EraseRootFromParent_Done,
     /* 187823 */   // Label 3677: @187823
     /* 187823 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187860), // Rule ID 3031 //
     /* 187828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 187831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1631:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 187852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187858 */     GIR_RootConstrainSelectedInstOperands,
     /* 187859 */     // GIR_Coverage, 3031,
     /* 187859 */     GIR_EraseRootFromParent_Done,
     /* 187860 */   // Label 3678: @187860
     /* 187860 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187897), // Rule ID 3032 //
     /* 187865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 187889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187895 */     GIR_RootConstrainSelectedInstOperands,
     /* 187896 */     // GIR_Coverage, 3032,
     /* 187896 */     GIR_EraseRootFromParent_Done,
     /* 187897 */   // Label 3679: @187897
     /* 187897 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187934), // Rule ID 3033 //
     /* 187902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 187926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187932 */     GIR_RootConstrainSelectedInstOperands,
     /* 187933 */     // GIR_Coverage, 3033,
     /* 187933 */     GIR_EraseRootFromParent_Done,
     /* 187934 */   // Label 3680: @187934
     /* 187934 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187971), // Rule ID 3034 //
     /* 187939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 187942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 187947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 187963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187969 */     GIR_RootConstrainSelectedInstOperands,
     /* 187970 */     // GIR_Coverage, 3034,
     /* 187970 */     GIR_EraseRootFromParent_Done,
     /* 187971 */   // Label 3681: @187971
     /* 187971 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188008), // Rule ID 3035 //
     /* 187976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 187979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 187984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 188000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188006 */     GIR_RootConstrainSelectedInstOperands,
     /* 188007 */     // GIR_Coverage, 3035,
     /* 188007 */     GIR_EraseRootFromParent_Done,
     /* 188008 */   // Label 3682: @188008
     /* 188008 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188045), // Rule ID 3036 //
     /* 188013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 188016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 188021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 188037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188043 */     GIR_RootConstrainSelectedInstOperands,
     /* 188044 */     // GIR_Coverage, 3036,
     /* 188044 */     GIR_EraseRootFromParent_Done,
     /* 188045 */   // Label 3683: @188045
     /* 188045 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188082), // Rule ID 3037 //
     /* 188050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 188053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 188058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 188074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188080 */     GIR_RootConstrainSelectedInstOperands,
     /* 188081 */     // GIR_Coverage, 3037,
     /* 188081 */     GIR_EraseRootFromParent_Done,
     /* 188082 */   // Label 3684: @188082
     /* 188082 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188119), // Rule ID 3038 //
     /* 188087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 188111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188117 */     GIR_RootConstrainSelectedInstOperands,
     /* 188118 */     // GIR_Coverage, 3038,
     /* 188118 */     GIR_EraseRootFromParent_Done,
     /* 188119 */   // Label 3685: @188119
     /* 188119 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188156), // Rule ID 3039 //
     /* 188124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 188148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188154 */     GIR_RootConstrainSelectedInstOperands,
     /* 188155 */     // GIR_Coverage, 3039,
     /* 188155 */     GIR_EraseRootFromParent_Done,
     /* 188156 */   // Label 3686: @188156
     /* 188156 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188193), // Rule ID 3040 //
     /* 188161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 3040,
     /* 188192 */     GIR_EraseRootFromParent_Done,
     /* 188193 */   // Label 3687: @188193
     /* 188193 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188230), // Rule ID 3087 //
     /* 188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 188222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188228 */     GIR_RootConstrainSelectedInstOperands,
     /* 188229 */     // GIR_Coverage, 3087,
     /* 188229 */     GIR_EraseRootFromParent_Done,
     /* 188230 */   // Label 3688: @188230
     /* 188230 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188267), // Rule ID 3088 //
     /* 188235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1250:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 188259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188265 */     GIR_RootConstrainSelectedInstOperands,
     /* 188266 */     // GIR_Coverage, 3088,
     /* 188266 */     GIR_EraseRootFromParent_Done,
     /* 188267 */   // Label 3689: @188267
     /* 188267 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188304), // Rule ID 3089 //
     /* 188272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1250:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 188296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188302 */     GIR_RootConstrainSelectedInstOperands,
     /* 188303 */     // GIR_Coverage, 3089,
     /* 188303 */     GIR_EraseRootFromParent_Done,
     /* 188304 */   // Label 3690: @188304
     /* 188304 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188341), // Rule ID 3096 //
     /* 188309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188330 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 188333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188339 */     GIR_RootConstrainSelectedInstOperands,
     /* 188340 */     // GIR_Coverage, 3096,
     /* 188340 */     GIR_EraseRootFromParent_Done,
     /* 188341 */   // Label 3691: @188341
     /* 188341 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188378), // Rule ID 3097 //
     /* 188346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 188370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188376 */     GIR_RootConstrainSelectedInstOperands,
     /* 188377 */     // GIR_Coverage, 3097,
     /* 188377 */     GIR_EraseRootFromParent_Done,
     /* 188378 */   // Label 3692: @188378
     /* 188378 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188415), // Rule ID 3098 //
     /* 188383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 188407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188413 */     GIR_RootConstrainSelectedInstOperands,
     /* 188414 */     // GIR_Coverage, 3098,
     /* 188414 */     GIR_EraseRootFromParent_Done,
     /* 188415 */   // Label 3693: @188415
     /* 188415 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188455), // Rule ID 3202 //
     /* 188420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 188444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188453 */     GIR_RootConstrainSelectedInstOperands,
     /* 188454 */     // GIR_Coverage, 3202,
     /* 188454 */     GIR_EraseRootFromParent_Done,
     /* 188455 */   // Label 3694: @188455
     /* 188455 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188495), // Rule ID 3203 //
     /* 188460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 188484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188493 */     GIR_RootConstrainSelectedInstOperands,
     /* 188494 */     // GIR_Coverage, 3203,
     /* 188494 */     GIR_EraseRootFromParent_Done,
     /* 188495 */   // Label 3695: @188495
     /* 188495 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188535), // Rule ID 3204 //
     /* 188500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188521 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 188524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188533 */     GIR_RootConstrainSelectedInstOperands,
     /* 188534 */     // GIR_Coverage, 3204,
     /* 188534 */     GIR_EraseRootFromParent_Done,
     /* 188535 */   // Label 3696: @188535
     /* 188535 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188575), // Rule ID 3205 //
     /* 188540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188561 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 188564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188573 */     GIR_RootConstrainSelectedInstOperands,
     /* 188574 */     // GIR_Coverage, 3205,
     /* 188574 */     GIR_EraseRootFromParent_Done,
     /* 188575 */   // Label 3697: @188575
     /* 188575 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188615), // Rule ID 3210 //
     /* 188580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188601 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 188604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188613 */     GIR_RootConstrainSelectedInstOperands,
     /* 188614 */     // GIR_Coverage, 3210,
     /* 188614 */     GIR_EraseRootFromParent_Done,
     /* 188615 */   // Label 3698: @188615
     /* 188615 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188655), // Rule ID 3211 //
     /* 188620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188641 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 188644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188653 */     GIR_RootConstrainSelectedInstOperands,
     /* 188654 */     // GIR_Coverage, 3211,
     /* 188654 */     GIR_EraseRootFromParent_Done,
     /* 188655 */   // Label 3699: @188655
     /* 188655 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188695), // Rule ID 3212 //
     /* 188660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188681 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 188684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188693 */     GIR_RootConstrainSelectedInstOperands,
     /* 188694 */     // GIR_Coverage, 3212,
     /* 188694 */     GIR_EraseRootFromParent_Done,
     /* 188695 */   // Label 3700: @188695
     /* 188695 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188735), // Rule ID 3213 //
     /* 188700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 188724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188733 */     GIR_RootConstrainSelectedInstOperands,
     /* 188734 */     // GIR_Coverage, 3213,
     /* 188734 */     GIR_EraseRootFromParent_Done,
     /* 188735 */   // Label 3701: @188735
     /* 188735 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188772), // Rule ID 3402 //
     /* 188740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 188754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 188764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188770 */     GIR_RootConstrainSelectedInstOperands,
     /* 188771 */     // GIR_Coverage, 3402,
     /* 188771 */     GIR_EraseRootFromParent_Done,
     /* 188772 */   // Label 3702: @188772
     /* 188772 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188809), // Rule ID 3403 //
     /* 188777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 188791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188798 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 188798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 188801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188807 */     GIR_RootConstrainSelectedInstOperands,
     /* 188808 */     // GIR_Coverage, 3403,
     /* 188808 */     GIR_EraseRootFromParent_Done,
     /* 188809 */   // Label 3703: @188809
     /* 188809 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188846), // Rule ID 3404 //
     /* 188814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 188828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 188838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188844 */     GIR_RootConstrainSelectedInstOperands,
     /* 188845 */     // GIR_Coverage, 3404,
     /* 188845 */     GIR_EraseRootFromParent_Done,
     /* 188846 */   // Label 3704: @188846
     /* 188846 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188883), // Rule ID 3405 //
     /* 188851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 188865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 188872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 188875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188881 */     GIR_RootConstrainSelectedInstOperands,
     /* 188882 */     // GIR_Coverage, 3405,
     /* 188882 */     GIR_EraseRootFromParent_Done,
     /* 188883 */   // Label 3705: @188883
     /* 188883 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188920), // Rule ID 3427 //
     /* 188888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188909 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188918 */     GIR_RootConstrainSelectedInstOperands,
     /* 188919 */     // GIR_Coverage, 3427,
     /* 188919 */     GIR_EraseRootFromParent_Done,
     /* 188920 */   // Label 3706: @188920
     /* 188920 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188957), // Rule ID 3428 //
     /* 188925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 188949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188955 */     GIR_RootConstrainSelectedInstOperands,
     /* 188956 */     // GIR_Coverage, 3428,
     /* 188956 */     GIR_EraseRootFromParent_Done,
     /* 188957 */   // Label 3707: @188957
     /* 188957 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188994), // Rule ID 3429 //
     /* 188962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188983 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 188986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188992 */     GIR_RootConstrainSelectedInstOperands,
     /* 188993 */     // GIR_Coverage, 3429,
     /* 188993 */     GIR_EraseRootFromParent_Done,
     /* 188994 */   // Label 3708: @188994
     /* 188994 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189031), // Rule ID 3451 //
     /* 188999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 189007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 189013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 189016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 189020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 189023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189029 */     GIR_RootConstrainSelectedInstOperands,
     /* 189030 */     // GIR_Coverage, 3451,
     /* 189030 */     GIR_EraseRootFromParent_Done,
     /* 189031 */   // Label 3709: @189031
     /* 189031 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189068), // Rule ID 3456 //
     /* 189036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 189039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 189044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 189060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189066 */     GIR_RootConstrainSelectedInstOperands,
     /* 189067 */     // GIR_Coverage, 3456,
     /* 189067 */     GIR_EraseRootFromParent_Done,
     /* 189068 */   // Label 3710: @189068
     /* 189068 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189105), // Rule ID 3457 //
     /* 189073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 189081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 189097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189103 */     GIR_RootConstrainSelectedInstOperands,
     /* 189104 */     // GIR_Coverage, 3457,
     /* 189104 */     GIR_EraseRootFromParent_Done,
     /* 189105 */   // Label 3711: @189105
     /* 189105 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189142), // Rule ID 3466 //
     /* 189110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189140 */     GIR_RootConstrainSelectedInstOperands,
     /* 189141 */     // GIR_Coverage, 3466,
     /* 189141 */     GIR_EraseRootFromParent_Done,
     /* 189142 */   // Label 3712: @189142
     /* 189142 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189179), // Rule ID 3467 //
     /* 189147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189177 */     GIR_RootConstrainSelectedInstOperands,
     /* 189178 */     // GIR_Coverage, 3467,
     /* 189178 */     GIR_EraseRootFromParent_Done,
     /* 189179 */   // Label 3713: @189179
     /* 189179 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(189216), // Rule ID 3468 //
     /* 189184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189214 */     GIR_RootConstrainSelectedInstOperands,
     /* 189215 */     // GIR_Coverage, 3468,
     /* 189215 */     GIR_EraseRootFromParent_Done,
     /* 189216 */   // Label 3714: @189216
     /* 189216 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189253), // Rule ID 3469 //
     /* 189221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189251 */     GIR_RootConstrainSelectedInstOperands,
     /* 189252 */     // GIR_Coverage, 3469,
     /* 189252 */     GIR_EraseRootFromParent_Done,
     /* 189253 */   // Label 3715: @189253
     /* 189253 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(189290), // Rule ID 3470 //
     /* 189258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189279 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189288 */     GIR_RootConstrainSelectedInstOperands,
     /* 189289 */     // GIR_Coverage, 3470,
     /* 189289 */     GIR_EraseRootFromParent_Done,
     /* 189290 */   // Label 3716: @189290
     /* 189290 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189327), // Rule ID 3471 //
     /* 189295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189325 */     GIR_RootConstrainSelectedInstOperands,
     /* 189326 */     // GIR_Coverage, 3471,
     /* 189326 */     GIR_EraseRootFromParent_Done,
     /* 189327 */   // Label 3717: @189327
     /* 189327 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(189364), // Rule ID 3472 //
     /* 189332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189353 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189362 */     GIR_RootConstrainSelectedInstOperands,
     /* 189363 */     // GIR_Coverage, 3472,
     /* 189363 */     GIR_EraseRootFromParent_Done,
     /* 189364 */   // Label 3718: @189364
     /* 189364 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189401), // Rule ID 3527 //
     /* 189369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189390 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 189393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189399 */     GIR_RootConstrainSelectedInstOperands,
     /* 189400 */     // GIR_Coverage, 3527,
     /* 189400 */     GIR_EraseRootFromParent_Done,
     /* 189401 */   // Label 3719: @189401
     /* 189401 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189438), // Rule ID 3528 //
     /* 189406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189427 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 189430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189436 */     GIR_RootConstrainSelectedInstOperands,
     /* 189437 */     // GIR_Coverage, 3528,
     /* 189437 */     GIR_EraseRootFromParent_Done,
     /* 189438 */   // Label 3720: @189438
     /* 189438 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189475), // Rule ID 3529 //
     /* 189443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189464 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 189467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189473 */     GIR_RootConstrainSelectedInstOperands,
     /* 189474 */     // GIR_Coverage, 3529,
     /* 189474 */     GIR_EraseRootFromParent_Done,
     /* 189475 */   // Label 3721: @189475
     /* 189475 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189512), // Rule ID 3559 //
     /* 189480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 189494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189501 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 189504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189510 */     GIR_RootConstrainSelectedInstOperands,
     /* 189511 */     // GIR_Coverage, 3559,
     /* 189511 */     GIR_EraseRootFromParent_Done,
     /* 189512 */   // Label 3722: @189512
     /* 189512 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189549), // Rule ID 3560 //
     /* 189517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189538 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 189541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189547 */     GIR_RootConstrainSelectedInstOperands,
     /* 189548 */     // GIR_Coverage, 3560,
     /* 189548 */     GIR_EraseRootFromParent_Done,
     /* 189549 */   // Label 3723: @189549
     /* 189549 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189586), // Rule ID 3561 //
     /* 189554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189575 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 189578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189584 */     GIR_RootConstrainSelectedInstOperands,
     /* 189585 */     // GIR_Coverage, 3561,
     /* 189585 */     GIR_EraseRootFromParent_Done,
     /* 189586 */   // Label 3724: @189586
     /* 189586 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189623), // Rule ID 3562 //
     /* 189591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189612 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 189615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189621 */     GIR_RootConstrainSelectedInstOperands,
     /* 189622 */     // GIR_Coverage, 3562,
     /* 189622 */     GIR_EraseRootFromParent_Done,
     /* 189623 */   // Label 3725: @189623
     /* 189623 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189660), // Rule ID 3563 //
     /* 189628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2162:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 189652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189658 */     GIR_RootConstrainSelectedInstOperands,
     /* 189659 */     // GIR_Coverage, 3563,
     /* 189659 */     GIR_EraseRootFromParent_Done,
     /* 189660 */   // Label 3726: @189660
     /* 189660 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189697), // Rule ID 3564 //
     /* 189665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2162:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 189689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189695 */     GIR_RootConstrainSelectedInstOperands,
     /* 189696 */     // GIR_Coverage, 3564,
     /* 189696 */     GIR_EraseRootFromParent_Done,
     /* 189697 */   // Label 3727: @189697
     /* 189697 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189734), // Rule ID 3565 //
     /* 189702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 189726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189732 */     GIR_RootConstrainSelectedInstOperands,
     /* 189733 */     // GIR_Coverage, 3565,
     /* 189733 */     GIR_EraseRootFromParent_Done,
     /* 189734 */   // Label 3728: @189734
     /* 189734 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189771), // Rule ID 3566 //
     /* 189739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 189763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189769 */     GIR_RootConstrainSelectedInstOperands,
     /* 189770 */     // GIR_Coverage, 3566,
     /* 189770 */     GIR_EraseRootFromParent_Done,
     /* 189771 */   // Label 3729: @189771
     /* 189771 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189808), // Rule ID 3567 //
     /* 189776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2162:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 189800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189806 */     GIR_RootConstrainSelectedInstOperands,
     /* 189807 */     // GIR_Coverage, 3567,
     /* 189807 */     GIR_EraseRootFromParent_Done,
     /* 189808 */   // Label 3730: @189808
     /* 189808 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189845), // Rule ID 3568 //
     /* 189813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189834 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 189837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189843 */     GIR_RootConstrainSelectedInstOperands,
     /* 189844 */     // GIR_Coverage, 3568,
     /* 189844 */     GIR_EraseRootFromParent_Done,
     /* 189845 */   // Label 3731: @189845
     /* 189845 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189882), // Rule ID 3569 //
     /* 189850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189871 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2162:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 189874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189880 */     GIR_RootConstrainSelectedInstOperands,
     /* 189881 */     // GIR_Coverage, 3569,
     /* 189881 */     GIR_EraseRootFromParent_Done,
     /* 189882 */   // Label 3732: @189882
     /* 189882 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189919), // Rule ID 3570 //
     /* 189887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 189911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189917 */     GIR_RootConstrainSelectedInstOperands,
     /* 189918 */     // GIR_Coverage, 3570,
     /* 189918 */     GIR_EraseRootFromParent_Done,
     /* 189919 */   // Label 3733: @189919
     /* 189919 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189956), // Rule ID 3571 //
     /* 189924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 189948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189954 */     GIR_RootConstrainSelectedInstOperands,
     /* 189955 */     // GIR_Coverage, 3571,
     /* 189955 */     GIR_EraseRootFromParent_Done,
     /* 189956 */   // Label 3734: @189956
     /* 189956 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189993), // Rule ID 3572 //
     /* 189961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 189992 */     // GIR_Coverage, 3572,
     /* 189992 */     GIR_EraseRootFromParent_Done,
     /* 189993 */   // Label 3735: @189993
     /* 189993 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190030), // Rule ID 3573 //
     /* 189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 190022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190028 */     GIR_RootConstrainSelectedInstOperands,
     /* 190029 */     // GIR_Coverage, 3573,
     /* 190029 */     GIR_EraseRootFromParent_Done,
     /* 190030 */   // Label 3736: @190030
     /* 190030 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190067), // Rule ID 3574 //
     /* 190035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190056 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1917:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 190059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190065 */     GIR_RootConstrainSelectedInstOperands,
     /* 190066 */     // GIR_Coverage, 3574,
     /* 190066 */     GIR_EraseRootFromParent_Done,
     /* 190067 */   // Label 3737: @190067
     /* 190067 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190104), // Rule ID 3575 //
     /* 190072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190093 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1917:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 190096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190102 */     GIR_RootConstrainSelectedInstOperands,
     /* 190103 */     // GIR_Coverage, 3575,
     /* 190103 */     GIR_EraseRootFromParent_Done,
     /* 190104 */   // Label 3738: @190104
     /* 190104 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190141), // Rule ID 3576 //
     /* 190109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1917:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 190133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190139 */     GIR_RootConstrainSelectedInstOperands,
     /* 190140 */     // GIR_Coverage, 3576,
     /* 190140 */     GIR_EraseRootFromParent_Done,
     /* 190141 */   // Label 3739: @190141
     /* 190141 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(190178), // Rule ID 8428 //
     /* 190146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 190154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 190163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190167 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 190167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 190170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190176 */     GIR_RootConstrainSelectedInstOperands,
     /* 190177 */     // GIR_Coverage, 8428,
     /* 190177 */     GIR_EraseRootFromParent_Done,
     /* 190178 */   // Label 3740: @190178
     /* 190178 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(190215), // Rule ID 8904 //
     /* 190183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 190191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 190207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190213 */     GIR_RootConstrainSelectedInstOperands,
     /* 190214 */     // GIR_Coverage, 8904,
     /* 190214 */     GIR_EraseRootFromParent_Done,
     /* 190215 */   // Label 3741: @190215
     /* 190215 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(190252), // Rule ID 8905 //
     /* 190220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 190228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 190244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190250 */     GIR_RootConstrainSelectedInstOperands,
     /* 190251 */     // GIR_Coverage, 8905,
     /* 190251 */     GIR_EraseRootFromParent_Done,
     /* 190252 */   // Label 3742: @190252
     /* 190252 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190289), // Rule ID 8906 //
     /* 190257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 190265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 190281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190287 */     GIR_RootConstrainSelectedInstOperands,
     /* 190288 */     // GIR_Coverage, 8906,
     /* 190288 */     GIR_EraseRootFromParent_Done,
     /* 190289 */   // Label 3743: @190289
     /* 190289 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190326), // Rule ID 8907 //
     /* 190294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 190302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 190318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190324 */     GIR_RootConstrainSelectedInstOperands,
     /* 190325 */     // GIR_Coverage, 8907,
     /* 190325 */     GIR_EraseRootFromParent_Done,
     /* 190326 */   // Label 3744: @190326
     /* 190326 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190363), // Rule ID 8908 //
     /* 190331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 190339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 190355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190361 */     GIR_RootConstrainSelectedInstOperands,
     /* 190362 */     // GIR_Coverage, 8908,
     /* 190362 */     GIR_EraseRootFromParent_Done,
     /* 190363 */   // Label 3745: @190363
     /* 190363 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190400), // Rule ID 8909 //
     /* 190368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 190376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190398 */     GIR_RootConstrainSelectedInstOperands,
     /* 190399 */     // GIR_Coverage, 8909,
     /* 190399 */     GIR_EraseRootFromParent_Done,
     /* 190400 */   // Label 3746: @190400
     /* 190400 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190437), // Rule ID 8910 //
     /* 190405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 190413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 190429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190435 */     GIR_RootConstrainSelectedInstOperands,
     /* 190436 */     // GIR_Coverage, 8910,
     /* 190436 */     GIR_EraseRootFromParent_Done,
     /* 190437 */   // Label 3747: @190437
     /* 190437 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190474), // Rule ID 8911 //
     /* 190442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 190450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 190466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190472 */     GIR_RootConstrainSelectedInstOperands,
     /* 190473 */     // GIR_Coverage, 8911,
     /* 190473 */     GIR_EraseRootFromParent_Done,
     /* 190474 */   // Label 3748: @190474
     /* 190474 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190514), // Rule ID 9911 //
     /* 190479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 190503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190512 */     GIR_RootConstrainSelectedInstOperands,
     /* 190513 */     // GIR_Coverage, 9911,
     /* 190513 */     GIR_EraseRootFromParent_Done,
     /* 190514 */   // Label 3749: @190514
     /* 190514 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190554), // Rule ID 9912 //
     /* 190519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 190543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190552 */     GIR_RootConstrainSelectedInstOperands,
     /* 190553 */     // GIR_Coverage, 9912,
     /* 190553 */     GIR_EraseRootFromParent_Done,
     /* 190554 */   // Label 3750: @190554
     /* 190554 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190594), // Rule ID 9913 //
     /* 190559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 190583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190592 */     GIR_RootConstrainSelectedInstOperands,
     /* 190593 */     // GIR_Coverage, 9913,
     /* 190593 */     GIR_EraseRootFromParent_Done,
     /* 190594 */   // Label 3751: @190594
     /* 190594 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190634), // Rule ID 9914 //
     /* 190599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 190623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190632 */     GIR_RootConstrainSelectedInstOperands,
     /* 190633 */     // GIR_Coverage, 9914,
     /* 190633 */     GIR_EraseRootFromParent_Done,
     /* 190634 */   // Label 3752: @190634
     /* 190634 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190674), // Rule ID 9915 //
     /* 190639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 190663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190672 */     GIR_RootConstrainSelectedInstOperands,
     /* 190673 */     // GIR_Coverage, 9915,
     /* 190673 */     GIR_EraseRootFromParent_Done,
     /* 190674 */   // Label 3753: @190674
     /* 190674 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190714), // Rule ID 9916 //
     /* 190679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 190703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190712 */     GIR_RootConstrainSelectedInstOperands,
     /* 190713 */     // GIR_Coverage, 9916,
     /* 190713 */     GIR_EraseRootFromParent_Done,
     /* 190714 */   // Label 3754: @190714
     /* 190714 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190754), // Rule ID 9917 //
     /* 190719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 190743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190752 */     GIR_RootConstrainSelectedInstOperands,
     /* 190753 */     // GIR_Coverage, 9917,
     /* 190753 */     GIR_EraseRootFromParent_Done,
     /* 190754 */   // Label 3755: @190754
     /* 190754 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190794), // Rule ID 9918 //
     /* 190759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 190783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190792 */     GIR_RootConstrainSelectedInstOperands,
     /* 190793 */     // GIR_Coverage, 9918,
     /* 190793 */     GIR_EraseRootFromParent_Done,
     /* 190794 */   // Label 3756: @190794
     /* 190794 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190834), // Rule ID 9923 //
     /* 190799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190820 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 190823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190832 */     GIR_RootConstrainSelectedInstOperands,
     /* 190833 */     // GIR_Coverage, 9923,
     /* 190833 */     GIR_EraseRootFromParent_Done,
     /* 190834 */   // Label 3757: @190834
     /* 190834 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190874), // Rule ID 9924 //
     /* 190839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190860 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 190863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190872 */     GIR_RootConstrainSelectedInstOperands,
     /* 190873 */     // GIR_Coverage, 9924,
     /* 190873 */     GIR_EraseRootFromParent_Done,
     /* 190874 */   // Label 3758: @190874
     /* 190874 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190914), // Rule ID 9925 //
     /* 190879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 190903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190912 */     GIR_RootConstrainSelectedInstOperands,
     /* 190913 */     // GIR_Coverage, 9925,
     /* 190913 */     GIR_EraseRootFromParent_Done,
     /* 190914 */   // Label 3759: @190914
     /* 190914 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190954), // Rule ID 9926 //
     /* 190919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 190943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190952 */     GIR_RootConstrainSelectedInstOperands,
     /* 190953 */     // GIR_Coverage, 9926,
     /* 190953 */     GIR_EraseRootFromParent_Done,
     /* 190954 */   // Label 3760: @190954
     /* 190954 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190994), // Rule ID 9927 //
     /* 190959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 190973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 190976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 190980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 190983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190992 */     GIR_RootConstrainSelectedInstOperands,
     /* 190993 */     // GIR_Coverage, 9927,
     /* 190993 */     GIR_EraseRootFromParent_Done,
     /* 190994 */   // Label 3761: @190994
     /* 190994 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191034), // Rule ID 9928 //
     /* 190999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 191007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 191023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191032 */     GIR_RootConstrainSelectedInstOperands,
     /* 191033 */     // GIR_Coverage, 9928,
     /* 191033 */     GIR_EraseRootFromParent_Done,
     /* 191034 */   // Label 3762: @191034
     /* 191034 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191074), // Rule ID 9929 //
     /* 191039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 191047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 191063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191072 */     GIR_RootConstrainSelectedInstOperands,
     /* 191073 */     // GIR_Coverage, 9929,
     /* 191073 */     GIR_EraseRootFromParent_Done,
     /* 191074 */   // Label 3763: @191074
     /* 191074 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191114), // Rule ID 9930 //
     /* 191079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 191087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 191103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191112 */     GIR_RootConstrainSelectedInstOperands,
     /* 191113 */     // GIR_Coverage, 9930,
     /* 191113 */     GIR_EraseRootFromParent_Done,
     /* 191114 */   // Label 3764: @191114
     /* 191114 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(191154), // Rule ID 9931 //
     /* 191119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 191143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191152 */     GIR_RootConstrainSelectedInstOperands,
     /* 191153 */     // GIR_Coverage, 9931,
     /* 191153 */     GIR_EraseRootFromParent_Done,
     /* 191154 */   // Label 3765: @191154
     /* 191154 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(191194), // Rule ID 9932 //
     /* 191159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 191183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191192 */     GIR_RootConstrainSelectedInstOperands,
     /* 191193 */     // GIR_Coverage, 9932,
     /* 191193 */     GIR_EraseRootFromParent_Done,
     /* 191194 */   // Label 3766: @191194
     /* 191194 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(191234), // Rule ID 9933 //
     /* 191199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 191223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191232 */     GIR_RootConstrainSelectedInstOperands,
     /* 191233 */     // GIR_Coverage, 9933,
     /* 191233 */     GIR_EraseRootFromParent_Done,
     /* 191234 */   // Label 3767: @191234
     /* 191234 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(191274), // Rule ID 9934 //
     /* 191239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 191263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191272 */     GIR_RootConstrainSelectedInstOperands,
     /* 191273 */     // GIR_Coverage, 9934,
     /* 191273 */     GIR_EraseRootFromParent_Done,
     /* 191274 */   // Label 3768: @191274
     /* 191274 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(191314), // Rule ID 9939 //
     /* 191279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 191303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191312 */     GIR_RootConstrainSelectedInstOperands,
     /* 191313 */     // GIR_Coverage, 9939,
     /* 191313 */     GIR_EraseRootFromParent_Done,
     /* 191314 */   // Label 3769: @191314
     /* 191314 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191354), // Rule ID 9940 //
     /* 191319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 191343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191352 */     GIR_RootConstrainSelectedInstOperands,
     /* 191353 */     // GIR_Coverage, 9940,
     /* 191353 */     GIR_EraseRootFromParent_Done,
     /* 191354 */   // Label 3770: @191354
     /* 191354 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(191394), // Rule ID 9941 //
     /* 191359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 191383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191392 */     GIR_RootConstrainSelectedInstOperands,
     /* 191393 */     // GIR_Coverage, 9941,
     /* 191393 */     GIR_EraseRootFromParent_Done,
     /* 191394 */   // Label 3771: @191394
     /* 191394 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191434), // Rule ID 9942 //
     /* 191399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 191423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191432 */     GIR_RootConstrainSelectedInstOperands,
     /* 191433 */     // GIR_Coverage, 9942,
     /* 191433 */     GIR_EraseRootFromParent_Done,
     /* 191434 */   // Label 3772: @191434
     /* 191434 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191471), // Rule ID 10101 //
     /* 191439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 191463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191469 */     GIR_RootConstrainSelectedInstOperands,
     /* 191470 */     // GIR_Coverage, 10101,
     /* 191470 */     GIR_EraseRootFromParent_Done,
     /* 191471 */   // Label 3773: @191471
     /* 191471 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191508), // Rule ID 10102 //
     /* 191476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 191500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191506 */     GIR_RootConstrainSelectedInstOperands,
     /* 191507 */     // GIR_Coverage, 10102,
     /* 191507 */     GIR_EraseRootFromParent_Done,
     /* 191508 */   // Label 3774: @191508
     /* 191508 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191545), // Rule ID 10103 //
     /* 191513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 191537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191543 */     GIR_RootConstrainSelectedInstOperands,
     /* 191544 */     // GIR_Coverage, 10103,
     /* 191544 */     GIR_EraseRootFromParent_Done,
     /* 191545 */   // Label 3775: @191545
     /* 191545 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191582), // Rule ID 10104 //
     /* 191550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191571 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 191574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191580 */     GIR_RootConstrainSelectedInstOperands,
     /* 191581 */     // GIR_Coverage, 10104,
     /* 191581 */     GIR_EraseRootFromParent_Done,
     /* 191582 */   // Label 3776: @191582
     /* 191582 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191619), // Rule ID 10105 //
     /* 191587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 191611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191617 */     GIR_RootConstrainSelectedInstOperands,
     /* 191618 */     // GIR_Coverage, 10105,
     /* 191618 */     GIR_EraseRootFromParent_Done,
     /* 191619 */   // Label 3777: @191619
     /* 191619 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191656), // Rule ID 10106 //
     /* 191624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 191648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191654 */     GIR_RootConstrainSelectedInstOperands,
     /* 191655 */     // GIR_Coverage, 10106,
     /* 191655 */     GIR_EraseRootFromParent_Done,
     /* 191656 */   // Label 3778: @191656
     /* 191656 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191693), // Rule ID 10107 //
     /* 191661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 191685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191691 */     GIR_RootConstrainSelectedInstOperands,
     /* 191692 */     // GIR_Coverage, 10107,
     /* 191692 */     GIR_EraseRootFromParent_Done,
     /* 191693 */   // Label 3779: @191693
     /* 191693 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191730), // Rule ID 10108 //
     /* 191698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 191722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191728 */     GIR_RootConstrainSelectedInstOperands,
     /* 191729 */     // GIR_Coverage, 10108,
     /* 191729 */     GIR_EraseRootFromParent_Done,
     /* 191730 */   // Label 3780: @191730
     /* 191730 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191767), // Rule ID 10109 //
     /* 191735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 191759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191765 */     GIR_RootConstrainSelectedInstOperands,
     /* 191766 */     // GIR_Coverage, 10109,
     /* 191766 */     GIR_EraseRootFromParent_Done,
     /* 191767 */   // Label 3781: @191767
     /* 191767 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191804), // Rule ID 11297 //
     /* 191772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2159:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191802 */     GIR_RootConstrainSelectedInstOperands,
     /* 191803 */     // GIR_Coverage, 11297,
     /* 191803 */     GIR_EraseRootFromParent_Done,
     /* 191804 */   // Label 3782: @191804
     /* 191804 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191841), // Rule ID 11298 //
     /* 191809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2159:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191839 */     GIR_RootConstrainSelectedInstOperands,
     /* 191840 */     // GIR_Coverage, 11298,
     /* 191840 */     GIR_EraseRootFromParent_Done,
     /* 191841 */   // Label 3783: @191841
     /* 191841 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191878), // Rule ID 11299 //
     /* 191846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191867 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2159:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191876 */     GIR_RootConstrainSelectedInstOperands,
     /* 191877 */     // GIR_Coverage, 11299,
     /* 191877 */     GIR_EraseRootFromParent_Done,
     /* 191878 */   // Label 3784: @191878
     /* 191878 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191915), // Rule ID 11300 //
     /* 191883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2159:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191913 */     GIR_RootConstrainSelectedInstOperands,
     /* 191914 */     // GIR_Coverage, 11300,
     /* 191914 */     GIR_EraseRootFromParent_Done,
     /* 191915 */   // Label 3785: @191915
     /* 191915 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191952), // Rule ID 11301 //
     /* 191920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191941 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191950 */     GIR_RootConstrainSelectedInstOperands,
     /* 191951 */     // GIR_Coverage, 11301,
     /* 191951 */     GIR_EraseRootFromParent_Done,
     /* 191952 */   // Label 3786: @191952
     /* 191952 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191989), // Rule ID 11302 //
     /* 191957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2159:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191987 */     GIR_RootConstrainSelectedInstOperands,
     /* 191988 */     // GIR_Coverage, 11302,
     /* 191988 */     GIR_EraseRootFromParent_Done,
     /* 191989 */   // Label 3787: @191989
     /* 191989 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192026), // Rule ID 11303 //
     /* 191994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 192002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192015 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2159:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 192018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192024 */     GIR_RootConstrainSelectedInstOperands,
     /* 192025 */     // GIR_Coverage, 11303,
     /* 192025 */     GIR_EraseRootFromParent_Done,
     /* 192026 */   // Label 3788: @192026
     /* 192026 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192063), // Rule ID 11304 //
     /* 192031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192061 */     GIR_RootConstrainSelectedInstOperands,
     /* 192062 */     // GIR_Coverage, 11304,
     /* 192062 */     GIR_EraseRootFromParent_Done,
     /* 192063 */   // Label 3789: @192063
     /* 192063 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(192100), // Rule ID 11305 //
     /* 192068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192098 */     GIR_RootConstrainSelectedInstOperands,
     /* 192099 */     // GIR_Coverage, 11305,
     /* 192099 */     GIR_EraseRootFromParent_Done,
     /* 192100 */   // Label 3790: @192100
     /* 192100 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(192137), // Rule ID 11306 //
     /* 192105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192126 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192135 */     GIR_RootConstrainSelectedInstOperands,
     /* 192136 */     // GIR_Coverage, 11306,
     /* 192136 */     GIR_EraseRootFromParent_Done,
     /* 192137 */   // Label 3791: @192137
     /* 192137 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(192174), // Rule ID 11307 //
     /* 192142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192172 */     GIR_RootConstrainSelectedInstOperands,
     /* 192173 */     // GIR_Coverage, 11307,
     /* 192173 */     GIR_EraseRootFromParent_Done,
     /* 192174 */   // Label 3792: @192174
     /* 192174 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(192211), // Rule ID 11308 //
     /* 192179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192200 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192209 */     GIR_RootConstrainSelectedInstOperands,
     /* 192210 */     // GIR_Coverage, 11308,
     /* 192210 */     GIR_EraseRootFromParent_Done,
     /* 192211 */   // Label 3793: @192211
     /* 192211 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(192248), // Rule ID 11309 //
     /* 192216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192237 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192246 */     GIR_RootConstrainSelectedInstOperands,
     /* 192247 */     // GIR_Coverage, 11309,
     /* 192247 */     GIR_EraseRootFromParent_Done,
     /* 192248 */   // Label 3794: @192248
     /* 192248 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(192285), // Rule ID 11310 //
     /* 192253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192274 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192283 */     GIR_RootConstrainSelectedInstOperands,
     /* 192284 */     // GIR_Coverage, 11310,
     /* 192284 */     GIR_EraseRootFromParent_Done,
     /* 192285 */   // Label 3795: @192285
     /* 192285 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(192322), // Rule ID 11311 //
     /* 192290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2085:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192320 */     GIR_RootConstrainSelectedInstOperands,
     /* 192321 */     // GIR_Coverage, 11311,
     /* 192321 */     GIR_EraseRootFromParent_Done,
     /* 192322 */   // Label 3796: @192322
     /* 192322 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(192359), // Rule ID 11312 //
     /* 192327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2085:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192357 */     GIR_RootConstrainSelectedInstOperands,
     /* 192358 */     // GIR_Coverage, 11312,
     /* 192358 */     GIR_EraseRootFromParent_Done,
     /* 192359 */   // Label 3797: @192359
     /* 192359 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192396), // Rule ID 11313 //
     /* 192364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192385 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2085:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192394 */     GIR_RootConstrainSelectedInstOperands,
     /* 192395 */     // GIR_Coverage, 11313,
     /* 192395 */     GIR_EraseRootFromParent_Done,
     /* 192396 */   // Label 3798: @192396
     /* 192396 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192433), // Rule ID 11314 //
     /* 192401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2085:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192431 */     GIR_RootConstrainSelectedInstOperands,
     /* 192432 */     // GIR_Coverage, 11314,
     /* 192432 */     GIR_EraseRootFromParent_Done,
     /* 192433 */   // Label 3799: @192433
     /* 192433 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192470), // Rule ID 11315 //
     /* 192438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2085:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192468 */     GIR_RootConstrainSelectedInstOperands,
     /* 192469 */     // GIR_Coverage, 11315,
     /* 192469 */     GIR_EraseRootFromParent_Done,
     /* 192470 */   // Label 3800: @192470
     /* 192470 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192507), // Rule ID 11316 //
     /* 192475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2085:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192505 */     GIR_RootConstrainSelectedInstOperands,
     /* 192506 */     // GIR_Coverage, 11316,
     /* 192506 */     GIR_EraseRootFromParent_Done,
     /* 192507 */   // Label 3801: @192507
     /* 192507 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192544), // Rule ID 11317 //
     /* 192512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192533 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2085:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192542 */     GIR_RootConstrainSelectedInstOperands,
     /* 192543 */     // GIR_Coverage, 11317,
     /* 192543 */     GIR_EraseRootFromParent_Done,
     /* 192544 */   // Label 3802: @192544
     /* 192544 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192581), // Rule ID 11318 //
     /* 192549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192579 */     GIR_RootConstrainSelectedInstOperands,
     /* 192580 */     // GIR_Coverage, 11318,
     /* 192580 */     GIR_EraseRootFromParent_Done,
     /* 192581 */   // Label 3803: @192581
     /* 192581 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192618), // Rule ID 11319 //
     /* 192586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192616 */     GIR_RootConstrainSelectedInstOperands,
     /* 192617 */     // GIR_Coverage, 11319,
     /* 192617 */     GIR_EraseRootFromParent_Done,
     /* 192618 */   // Label 3804: @192618
     /* 192618 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192655), // Rule ID 11320 //
     /* 192623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192644 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192653 */     GIR_RootConstrainSelectedInstOperands,
     /* 192654 */     // GIR_Coverage, 11320,
     /* 192654 */     GIR_EraseRootFromParent_Done,
     /* 192655 */   // Label 3805: @192655
     /* 192655 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192692), // Rule ID 11321 //
     /* 192660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192690 */     GIR_RootConstrainSelectedInstOperands,
     /* 192691 */     // GIR_Coverage, 11321,
     /* 192691 */     GIR_EraseRootFromParent_Done,
     /* 192692 */   // Label 3806: @192692
     /* 192692 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192729), // Rule ID 11322 //
     /* 192697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192718 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192727 */     GIR_RootConstrainSelectedInstOperands,
     /* 192728 */     // GIR_Coverage, 11322,
     /* 192728 */     GIR_EraseRootFromParent_Done,
     /* 192729 */   // Label 3807: @192729
     /* 192729 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192766), // Rule ID 11323 //
     /* 192734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192764 */     GIR_RootConstrainSelectedInstOperands,
     /* 192765 */     // GIR_Coverage, 11323,
     /* 192765 */     GIR_EraseRootFromParent_Done,
     /* 192766 */   // Label 3808: @192766
     /* 192766 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192803), // Rule ID 11324 //
     /* 192771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192792 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192801 */     GIR_RootConstrainSelectedInstOperands,
     /* 192802 */     // GIR_Coverage, 11324,
     /* 192802 */     GIR_EraseRootFromParent_Done,
     /* 192803 */   // Label 3809: @192803
     /* 192803 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192840), // Rule ID 11325 //
     /* 192808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192829 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192838 */     GIR_RootConstrainSelectedInstOperands,
     /* 192839 */     // GIR_Coverage, 11325,
     /* 192839 */     GIR_EraseRootFromParent_Done,
     /* 192840 */   // Label 3810: @192840
     /* 192840 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192877), // Rule ID 11326 //
     /* 192845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192875 */     GIR_RootConstrainSelectedInstOperands,
     /* 192876 */     // GIR_Coverage, 11326,
     /* 192876 */     GIR_EraseRootFromParent_Done,
     /* 192877 */   // Label 3811: @192877
     /* 192877 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192914), // Rule ID 11327 //
     /* 192882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192912 */     GIR_RootConstrainSelectedInstOperands,
     /* 192913 */     // GIR_Coverage, 11327,
     /* 192913 */     GIR_EraseRootFromParent_Done,
     /* 192914 */   // Label 3812: @192914
     /* 192914 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192951), // Rule ID 11328 //
     /* 192919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192949 */     GIR_RootConstrainSelectedInstOperands,
     /* 192950 */     // GIR_Coverage, 11328,
     /* 192950 */     GIR_EraseRootFromParent_Done,
     /* 192951 */   // Label 3813: @192951
     /* 192951 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192988), // Rule ID 11329 //
     /* 192956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192977 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192986 */     GIR_RootConstrainSelectedInstOperands,
     /* 192987 */     // GIR_Coverage, 11329,
     /* 192987 */     GIR_EraseRootFromParent_Done,
     /* 192988 */   // Label 3814: @192988
     /* 192988 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193025), // Rule ID 11330 //
     /* 192993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 193001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 193017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193023 */     GIR_RootConstrainSelectedInstOperands,
     /* 193024 */     // GIR_Coverage, 11330,
     /* 193024 */     GIR_EraseRootFromParent_Done,
     /* 193025 */   // Label 3815: @193025
     /* 193025 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193062), // Rule ID 11331 //
     /* 193030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 193033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 193038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 193051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 193054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193060 */     GIR_RootConstrainSelectedInstOperands,
     /* 193061 */     // GIR_Coverage, 11331,
     /* 193061 */     GIR_EraseRootFromParent_Done,
     /* 193062 */   // Label 3816: @193062
     /* 193062 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193099), // Rule ID 11351 //
     /* 193067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 193091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193097 */     GIR_RootConstrainSelectedInstOperands,
     /* 193098 */     // GIR_Coverage, 11351,
     /* 193098 */     GIR_EraseRootFromParent_Done,
     /* 193099 */   // Label 3817: @193099
     /* 193099 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(193136), // Rule ID 11352 //
     /* 193104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193125 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 193128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193134 */     GIR_RootConstrainSelectedInstOperands,
     /* 193135 */     // GIR_Coverage, 11352,
     /* 193135 */     GIR_EraseRootFromParent_Done,
     /* 193136 */   // Label 3818: @193136
     /* 193136 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(193173), // Rule ID 11353 //
     /* 193141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 193165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193171 */     GIR_RootConstrainSelectedInstOperands,
     /* 193172 */     // GIR_Coverage, 11353,
     /* 193172 */     GIR_EraseRootFromParent_Done,
     /* 193173 */   // Label 3819: @193173
     /* 193173 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(193210), // Rule ID 11354 //
     /* 193178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 193202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193208 */     GIR_RootConstrainSelectedInstOperands,
     /* 193209 */     // GIR_Coverage, 11354,
     /* 193209 */     GIR_EraseRootFromParent_Done,
     /* 193210 */   // Label 3820: @193210
     /* 193210 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(193247), // Rule ID 11642 //
     /* 193215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 193239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193245 */     GIR_RootConstrainSelectedInstOperands,
     /* 193246 */     // GIR_Coverage, 11642,
     /* 193246 */     GIR_EraseRootFromParent_Done,
     /* 193247 */   // Label 3821: @193247
     /* 193247 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(193284), // Rule ID 11643 //
     /* 193252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 193276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193282 */     GIR_RootConstrainSelectedInstOperands,
     /* 193283 */     // GIR_Coverage, 11643,
     /* 193283 */     GIR_EraseRootFromParent_Done,
     /* 193284 */   // Label 3822: @193284
     /* 193284 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(193321), // Rule ID 11644 //
     /* 193289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 193313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193319 */     GIR_RootConstrainSelectedInstOperands,
     /* 193320 */     // GIR_Coverage, 11644,
     /* 193320 */     GIR_EraseRootFromParent_Done,
     /* 193321 */   // Label 3823: @193321
     /* 193321 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(193358), // Rule ID 11645 //
     /* 193326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 193350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193356 */     GIR_RootConstrainSelectedInstOperands,
     /* 193357 */     // GIR_Coverage, 11645,
     /* 193357 */     GIR_EraseRootFromParent_Done,
     /* 193358 */   // Label 3824: @193358
     /* 193358 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(193395), // Rule ID 11646 //
     /* 193363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 193387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193393 */     GIR_RootConstrainSelectedInstOperands,
     /* 193394 */     // GIR_Coverage, 11646,
     /* 193394 */     GIR_EraseRootFromParent_Done,
     /* 193395 */   // Label 3825: @193395
     /* 193395 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193432), // Rule ID 11647 //
     /* 193400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 193424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193430 */     GIR_RootConstrainSelectedInstOperands,
     /* 193431 */     // GIR_Coverage, 11647,
     /* 193431 */     GIR_EraseRootFromParent_Done,
     /* 193432 */   // Label 3826: @193432
     /* 193432 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193469), // Rule ID 11648 //
     /* 193437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 193461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193467 */     GIR_RootConstrainSelectedInstOperands,
     /* 193468 */     // GIR_Coverage, 11648,
     /* 193468 */     GIR_EraseRootFromParent_Done,
     /* 193469 */   // Label 3827: @193469
     /* 193469 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193506), // Rule ID 11649 //
     /* 193474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 193498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193504 */     GIR_RootConstrainSelectedInstOperands,
     /* 193505 */     // GIR_Coverage, 11649,
     /* 193505 */     GIR_EraseRootFromParent_Done,
     /* 193506 */   // Label 3828: @193506
     /* 193506 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193543), // Rule ID 11650 //
     /* 193511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 193535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193541 */     GIR_RootConstrainSelectedInstOperands,
     /* 193542 */     // GIR_Coverage, 11650,
     /* 193542 */     GIR_EraseRootFromParent_Done,
     /* 193543 */   // Label 3829: @193543
     /* 193543 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193580), // Rule ID 11651 //
     /* 193548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 193572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193578 */     GIR_RootConstrainSelectedInstOperands,
     /* 193579 */     // GIR_Coverage, 11651,
     /* 193579 */     GIR_EraseRootFromParent_Done,
     /* 193580 */   // Label 3830: @193580
     /* 193580 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193617), // Rule ID 11652 //
     /* 193585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 193609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193615 */     GIR_RootConstrainSelectedInstOperands,
     /* 193616 */     // GIR_Coverage, 11652,
     /* 193616 */     GIR_EraseRootFromParent_Done,
     /* 193617 */   // Label 3831: @193617
     /* 193617 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193654), // Rule ID 11653 //
     /* 193622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 193646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193652 */     GIR_RootConstrainSelectedInstOperands,
     /* 193653 */     // GIR_Coverage, 11653,
     /* 193653 */     GIR_EraseRootFromParent_Done,
     /* 193654 */   // Label 3832: @193654
     /* 193654 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193691), // Rule ID 11654 //
     /* 193659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 193683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193689 */     GIR_RootConstrainSelectedInstOperands,
     /* 193690 */     // GIR_Coverage, 11654,
     /* 193690 */     GIR_EraseRootFromParent_Done,
     /* 193691 */   // Label 3833: @193691
     /* 193691 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193728), // Rule ID 11655 //
     /* 193696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 193720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193726 */     GIR_RootConstrainSelectedInstOperands,
     /* 193727 */     // GIR_Coverage, 11655,
     /* 193727 */     GIR_EraseRootFromParent_Done,
     /* 193728 */   // Label 3834: @193728
     /* 193728 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193765), // Rule ID 11656 //
     /* 193733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 193757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193763 */     GIR_RootConstrainSelectedInstOperands,
     /* 193764 */     // GIR_Coverage, 11656,
     /* 193764 */     GIR_EraseRootFromParent_Done,
     /* 193765 */   // Label 3835: @193765
     /* 193765 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193802), // Rule ID 11657 //
     /* 193770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 193794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193800 */     GIR_RootConstrainSelectedInstOperands,
     /* 193801 */     // GIR_Coverage, 11657,
     /* 193801 */     GIR_EraseRootFromParent_Done,
     /* 193802 */   // Label 3836: @193802
     /* 193802 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193839), // Rule ID 11658 //
     /* 193807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 193831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193837 */     GIR_RootConstrainSelectedInstOperands,
     /* 193838 */     // GIR_Coverage, 11658,
     /* 193838 */     GIR_EraseRootFromParent_Done,
     /* 193839 */   // Label 3837: @193839
     /* 193839 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193876), // Rule ID 11659 //
     /* 193844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 193868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193874 */     GIR_RootConstrainSelectedInstOperands,
     /* 193875 */     // GIR_Coverage, 11659,
     /* 193875 */     GIR_EraseRootFromParent_Done,
     /* 193876 */   // Label 3838: @193876
     /* 193876 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193913), // Rule ID 11660 //
     /* 193881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193911 */     GIR_RootConstrainSelectedInstOperands,
     /* 193912 */     // GIR_Coverage, 11660,
     /* 193912 */     GIR_EraseRootFromParent_Done,
     /* 193913 */   // Label 3839: @193913
     /* 193913 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193950), // Rule ID 11661 //
     /* 193918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 193942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193948 */     GIR_RootConstrainSelectedInstOperands,
     /* 193949 */     // GIR_Coverage, 11661,
     /* 193949 */     GIR_EraseRootFromParent_Done,
     /* 193950 */   // Label 3840: @193950
     /* 193950 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193987), // Rule ID 11662 //
     /* 193955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 193979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193985 */     GIR_RootConstrainSelectedInstOperands,
     /* 193986 */     // GIR_Coverage, 11662,
     /* 193986 */     GIR_EraseRootFromParent_Done,
     /* 193987 */   // Label 3841: @193987
     /* 193987 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194024), // Rule ID 11663 //
     /* 193992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 194000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 194016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194022 */     GIR_RootConstrainSelectedInstOperands,
     /* 194023 */     // GIR_Coverage, 11663,
     /* 194023 */     GIR_EraseRootFromParent_Done,
     /* 194024 */   // Label 3842: @194024
     /* 194024 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(194061), // Rule ID 11664 //
     /* 194029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 194037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 194053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194059 */     GIR_RootConstrainSelectedInstOperands,
     /* 194060 */     // GIR_Coverage, 11664,
     /* 194060 */     GIR_EraseRootFromParent_Done,
     /* 194061 */   // Label 3843: @194061
     /* 194061 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(194098), // Rule ID 11665 //
     /* 194066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 194074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 194090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194096 */     GIR_RootConstrainSelectedInstOperands,
     /* 194097 */     // GIR_Coverage, 11665,
     /* 194097 */     GIR_EraseRootFromParent_Done,
     /* 194098 */   // Label 3844: @194098
     /* 194098 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(194135), // Rule ID 11666 //
     /* 194103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 194127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194133 */     GIR_RootConstrainSelectedInstOperands,
     /* 194134 */     // GIR_Coverage, 11666,
     /* 194134 */     GIR_EraseRootFromParent_Done,
     /* 194135 */   // Label 3845: @194135
     /* 194135 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(194172), // Rule ID 11667 //
     /* 194140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 194164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194170 */     GIR_RootConstrainSelectedInstOperands,
     /* 194171 */     // GIR_Coverage, 11667,
     /* 194171 */     GIR_EraseRootFromParent_Done,
     /* 194172 */   // Label 3846: @194172
     /* 194172 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(194209), // Rule ID 11668 //
     /* 194177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 194201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194207 */     GIR_RootConstrainSelectedInstOperands,
     /* 194208 */     // GIR_Coverage, 11668,
     /* 194208 */     GIR_EraseRootFromParent_Done,
     /* 194209 */   // Label 3847: @194209
     /* 194209 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(194246), // Rule ID 11669 //
     /* 194214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 194238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194244 */     GIR_RootConstrainSelectedInstOperands,
     /* 194245 */     // GIR_Coverage, 11669,
     /* 194245 */     GIR_EraseRootFromParent_Done,
     /* 194246 */   // Label 3848: @194246
     /* 194246 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(194283), // Rule ID 11670 //
     /* 194251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 194275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194281 */     GIR_RootConstrainSelectedInstOperands,
     /* 194282 */     // GIR_Coverage, 11670,
     /* 194282 */     GIR_EraseRootFromParent_Done,
     /* 194283 */   // Label 3849: @194283
     /* 194283 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(194320), // Rule ID 11671 //
     /* 194288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 194312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194318 */     GIR_RootConstrainSelectedInstOperands,
     /* 194319 */     // GIR_Coverage, 11671,
     /* 194319 */     GIR_EraseRootFromParent_Done,
     /* 194320 */   // Label 3850: @194320
     /* 194320 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(194357), // Rule ID 11672 //
     /* 194325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 194349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194355 */     GIR_RootConstrainSelectedInstOperands,
     /* 194356 */     // GIR_Coverage, 11672,
     /* 194356 */     GIR_EraseRootFromParent_Done,
     /* 194357 */   // Label 3851: @194357
     /* 194357 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(194394), // Rule ID 11673 //
     /* 194362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 194386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194392 */     GIR_RootConstrainSelectedInstOperands,
     /* 194393 */     // GIR_Coverage, 11673,
     /* 194393 */     GIR_EraseRootFromParent_Done,
     /* 194394 */   // Label 3852: @194394
     /* 194394 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194431), // Rule ID 11674 //
     /* 194399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 194423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194429 */     GIR_RootConstrainSelectedInstOperands,
     /* 194430 */     // GIR_Coverage, 11674,
     /* 194430 */     GIR_EraseRootFromParent_Done,
     /* 194431 */   // Label 3853: @194431
     /* 194431 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194468), // Rule ID 11684 //
     /* 194436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 194460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194466 */     GIR_RootConstrainSelectedInstOperands,
     /* 194467 */     // GIR_Coverage, 11684,
     /* 194467 */     GIR_EraseRootFromParent_Done,
     /* 194468 */   // Label 3854: @194468
     /* 194468 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194505), // Rule ID 11685 //
     /* 194473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 194497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194503 */     GIR_RootConstrainSelectedInstOperands,
     /* 194504 */     // GIR_Coverage, 11685,
     /* 194504 */     GIR_EraseRootFromParent_Done,
     /* 194505 */   // Label 3855: @194505
     /* 194505 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194542), // Rule ID 11686 //
     /* 194510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 194534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194540 */     GIR_RootConstrainSelectedInstOperands,
     /* 194541 */     // GIR_Coverage, 11686,
     /* 194541 */     GIR_EraseRootFromParent_Done,
     /* 194542 */   // Label 3856: @194542
     /* 194542 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194579), // Rule ID 11687 //
     /* 194547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 194571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194577 */     GIR_RootConstrainSelectedInstOperands,
     /* 194578 */     // GIR_Coverage, 11687,
     /* 194578 */     GIR_EraseRootFromParent_Done,
     /* 194579 */   // Label 3857: @194579
     /* 194579 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194616), // Rule ID 11688 //
     /* 194584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 194608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194614 */     GIR_RootConstrainSelectedInstOperands,
     /* 194615 */     // GIR_Coverage, 11688,
     /* 194615 */     GIR_EraseRootFromParent_Done,
     /* 194616 */   // Label 3858: @194616
     /* 194616 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194653), // Rule ID 11689 //
     /* 194621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 194645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194651 */     GIR_RootConstrainSelectedInstOperands,
     /* 194652 */     // GIR_Coverage, 11689,
     /* 194652 */     GIR_EraseRootFromParent_Done,
     /* 194653 */   // Label 3859: @194653
     /* 194653 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194690), // Rule ID 11690 //
     /* 194658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 194682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194688 */     GIR_RootConstrainSelectedInstOperands,
     /* 194689 */     // GIR_Coverage, 11690,
     /* 194689 */     GIR_EraseRootFromParent_Done,
     /* 194690 */   // Label 3860: @194690
     /* 194690 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194727), // Rule ID 11691 //
     /* 194695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 194719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194725 */     GIR_RootConstrainSelectedInstOperands,
     /* 194726 */     // GIR_Coverage, 11691,
     /* 194726 */     GIR_EraseRootFromParent_Done,
     /* 194727 */   // Label 3861: @194727
     /* 194727 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194764), // Rule ID 11692 //
     /* 194732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 194756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194762 */     GIR_RootConstrainSelectedInstOperands,
     /* 194763 */     // GIR_Coverage, 11692,
     /* 194763 */     GIR_EraseRootFromParent_Done,
     /* 194764 */   // Label 3862: @194764
     /* 194764 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194801), // Rule ID 11693 //
     /* 194769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 194793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194799 */     GIR_RootConstrainSelectedInstOperands,
     /* 194800 */     // GIR_Coverage, 11693,
     /* 194800 */     GIR_EraseRootFromParent_Done,
     /* 194801 */   // Label 3863: @194801
     /* 194801 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194838), // Rule ID 11694 //
     /* 194806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 194830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194836 */     GIR_RootConstrainSelectedInstOperands,
     /* 194837 */     // GIR_Coverage, 11694,
     /* 194837 */     GIR_EraseRootFromParent_Done,
     /* 194838 */   // Label 3864: @194838
     /* 194838 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194875), // Rule ID 11695 //
     /* 194843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 194867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194873 */     GIR_RootConstrainSelectedInstOperands,
     /* 194874 */     // GIR_Coverage, 11695,
     /* 194874 */     GIR_EraseRootFromParent_Done,
     /* 194875 */   // Label 3865: @194875
     /* 194875 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194912), // Rule ID 11696 //
     /* 194880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1801:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 194904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194910 */     GIR_RootConstrainSelectedInstOperands,
     /* 194911 */     // GIR_Coverage, 11696,
     /* 194911 */     GIR_EraseRootFromParent_Done,
     /* 194912 */   // Label 3866: @194912
     /* 194912 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194949), // Rule ID 11697 //
     /* 194917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 194941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194947 */     GIR_RootConstrainSelectedInstOperands,
     /* 194948 */     // GIR_Coverage, 11697,
     /* 194948 */     GIR_EraseRootFromParent_Done,
     /* 194949 */   // Label 3867: @194949
     /* 194949 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194986), // Rule ID 11698 //
     /* 194954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 194978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194984 */     GIR_RootConstrainSelectedInstOperands,
     /* 194985 */     // GIR_Coverage, 11698,
     /* 194985 */     GIR_EraseRootFromParent_Done,
     /* 194986 */   // Label 3868: @194986
     /* 194986 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(195023), // Rule ID 11699 //
     /* 194991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 194999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 195015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195021 */     GIR_RootConstrainSelectedInstOperands,
     /* 195022 */     // GIR_Coverage, 11699,
     /* 195022 */     GIR_EraseRootFromParent_Done,
     /* 195023 */   // Label 3869: @195023
     /* 195023 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(195060), // Rule ID 11700 //
     /* 195028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 195036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 195052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195058 */     GIR_RootConstrainSelectedInstOperands,
     /* 195059 */     // GIR_Coverage, 11700,
     /* 195059 */     GIR_EraseRootFromParent_Done,
     /* 195060 */   // Label 3870: @195060
     /* 195060 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(195097), // Rule ID 11701 //
     /* 195065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 195073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 195089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195095 */     GIR_RootConstrainSelectedInstOperands,
     /* 195096 */     // GIR_Coverage, 11701,
     /* 195096 */     GIR_EraseRootFromParent_Done,
     /* 195097 */   // Label 3871: @195097
     /* 195097 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(195134), // Rule ID 11702 //
     /* 195102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 195126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195132 */     GIR_RootConstrainSelectedInstOperands,
     /* 195133 */     // GIR_Coverage, 11702,
     /* 195133 */     GIR_EraseRootFromParent_Done,
     /* 195134 */   // Label 3872: @195134
     /* 195134 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(195171), // Rule ID 11703 //
     /* 195139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 195163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195169 */     GIR_RootConstrainSelectedInstOperands,
     /* 195170 */     // GIR_Coverage, 11703,
     /* 195170 */     GIR_EraseRootFromParent_Done,
     /* 195171 */   // Label 3873: @195171
     /* 195171 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(195208), // Rule ID 11704 //
     /* 195176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 195200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195206 */     GIR_RootConstrainSelectedInstOperands,
     /* 195207 */     // GIR_Coverage, 11704,
     /* 195207 */     GIR_EraseRootFromParent_Done,
     /* 195208 */   // Label 3874: @195208
     /* 195208 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(195245), // Rule ID 11705 //
     /* 195213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 195237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195243 */     GIR_RootConstrainSelectedInstOperands,
     /* 195244 */     // GIR_Coverage, 11705,
     /* 195244 */     GIR_EraseRootFromParent_Done,
     /* 195245 */   // Label 3875: @195245
     /* 195245 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(195282), // Rule ID 11706 //
     /* 195250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 195274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195280 */     GIR_RootConstrainSelectedInstOperands,
     /* 195281 */     // GIR_Coverage, 11706,
     /* 195281 */     GIR_EraseRootFromParent_Done,
     /* 195282 */   // Label 3876: @195282
     /* 195282 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(195319), // Rule ID 11707 //
     /* 195287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 195311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195317 */     GIR_RootConstrainSelectedInstOperands,
     /* 195318 */     // GIR_Coverage, 11707,
     /* 195318 */     GIR_EraseRootFromParent_Done,
     /* 195319 */   // Label 3877: @195319
     /* 195319 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(195356), // Rule ID 11708 //
     /* 195324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 195348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195354 */     GIR_RootConstrainSelectedInstOperands,
     /* 195355 */     // GIR_Coverage, 11708,
     /* 195355 */     GIR_EraseRootFromParent_Done,
     /* 195356 */   // Label 3878: @195356
     /* 195356 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195393), // Rule ID 11709 //
     /* 195361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 195385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195391 */     GIR_RootConstrainSelectedInstOperands,
     /* 195392 */     // GIR_Coverage, 11709,
     /* 195392 */     GIR_EraseRootFromParent_Done,
     /* 195393 */   // Label 3879: @195393
     /* 195393 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195430), // Rule ID 11710 //
     /* 195398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195419 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 195422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195428 */     GIR_RootConstrainSelectedInstOperands,
     /* 195429 */     // GIR_Coverage, 11710,
     /* 195429 */     GIR_EraseRootFromParent_Done,
     /* 195430 */   // Label 3880: @195430
     /* 195430 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195467), // Rule ID 11711 //
     /* 195435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 195459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195465 */     GIR_RootConstrainSelectedInstOperands,
     /* 195466 */     // GIR_Coverage, 11711,
     /* 195466 */     GIR_EraseRootFromParent_Done,
     /* 195467 */   // Label 3881: @195467
     /* 195467 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195504), // Rule ID 11712 //
     /* 195472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 195496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195502 */     GIR_RootConstrainSelectedInstOperands,
     /* 195503 */     // GIR_Coverage, 11712,
     /* 195503 */     GIR_EraseRootFromParent_Done,
     /* 195504 */   // Label 3882: @195504
     /* 195504 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195541), // Rule ID 11713 //
     /* 195509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 195533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195539 */     GIR_RootConstrainSelectedInstOperands,
     /* 195540 */     // GIR_Coverage, 11713,
     /* 195540 */     GIR_EraseRootFromParent_Done,
     /* 195541 */   // Label 3883: @195541
     /* 195541 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195578), // Rule ID 11714 //
     /* 195546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195567 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 195570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195576 */     GIR_RootConstrainSelectedInstOperands,
     /* 195577 */     // GIR_Coverage, 11714,
     /* 195577 */     GIR_EraseRootFromParent_Done,
     /* 195578 */   // Label 3884: @195578
     /* 195578 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195615), // Rule ID 11715 //
     /* 195583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 195607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195613 */     GIR_RootConstrainSelectedInstOperands,
     /* 195614 */     // GIR_Coverage, 11715,
     /* 195614 */     GIR_EraseRootFromParent_Done,
     /* 195615 */   // Label 3885: @195615
     /* 195615 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195652), // Rule ID 11816 //
     /* 195620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 195644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195650 */     GIR_RootConstrainSelectedInstOperands,
     /* 195651 */     // GIR_Coverage, 11816,
     /* 195651 */     GIR_EraseRootFromParent_Done,
     /* 195652 */   // Label 3886: @195652
     /* 195652 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195689), // Rule ID 11817 //
     /* 195657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 195681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195687 */     GIR_RootConstrainSelectedInstOperands,
     /* 195688 */     // GIR_Coverage, 11817,
     /* 195688 */     GIR_EraseRootFromParent_Done,
     /* 195689 */   // Label 3887: @195689
     /* 195689 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195726), // Rule ID 11818 //
     /* 195694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 195718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195724 */     GIR_RootConstrainSelectedInstOperands,
     /* 195725 */     // GIR_Coverage, 11818,
     /* 195725 */     GIR_EraseRootFromParent_Done,
     /* 195726 */   // Label 3888: @195726
     /* 195726 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195763), // Rule ID 11819 //
     /* 195731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 195755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195761 */     GIR_RootConstrainSelectedInstOperands,
     /* 195762 */     // GIR_Coverage, 11819,
     /* 195762 */     GIR_EraseRootFromParent_Done,
     /* 195763 */   // Label 3889: @195763
     /* 195763 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195800), // Rule ID 11820 //
     /* 195768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 195792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195798 */     GIR_RootConstrainSelectedInstOperands,
     /* 195799 */     // GIR_Coverage, 11820,
     /* 195799 */     GIR_EraseRootFromParent_Done,
     /* 195800 */   // Label 3890: @195800
     /* 195800 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195837), // Rule ID 11821 //
     /* 195805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 195829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195835 */     GIR_RootConstrainSelectedInstOperands,
     /* 195836 */     // GIR_Coverage, 11821,
     /* 195836 */     GIR_EraseRootFromParent_Done,
     /* 195837 */   // Label 3891: @195837
     /* 195837 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195874), // Rule ID 11822 //
     /* 195842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 195866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195872 */     GIR_RootConstrainSelectedInstOperands,
     /* 195873 */     // GIR_Coverage, 11822,
     /* 195873 */     GIR_EraseRootFromParent_Done,
     /* 195874 */   // Label 3892: @195874
     /* 195874 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195911), // Rule ID 11823 //
     /* 195879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 195903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195909 */     GIR_RootConstrainSelectedInstOperands,
     /* 195910 */     // GIR_Coverage, 11823,
     /* 195910 */     GIR_EraseRootFromParent_Done,
     /* 195911 */   // Label 3893: @195911
     /* 195911 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195948), // Rule ID 11824 //
     /* 195916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 195940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195946 */     GIR_RootConstrainSelectedInstOperands,
     /* 195947 */     // GIR_Coverage, 11824,
     /* 195947 */     GIR_EraseRootFromParent_Done,
     /* 195948 */   // Label 3894: @195948
     /* 195948 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195985), // Rule ID 11840 //
     /* 195953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 195961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195983 */     GIR_RootConstrainSelectedInstOperands,
     /* 195984 */     // GIR_Coverage, 11840,
     /* 195984 */     GIR_EraseRootFromParent_Done,
     /* 195985 */   // Label 3895: @195985
     /* 195985 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(196022), // Rule ID 11841 //
     /* 195990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 195998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 196014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196020 */     GIR_RootConstrainSelectedInstOperands,
     /* 196021 */     // GIR_Coverage, 11841,
     /* 196021 */     GIR_EraseRootFromParent_Done,
     /* 196022 */   // Label 3896: @196022
     /* 196022 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(196059), // Rule ID 11842 //
     /* 196027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 196035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 196051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196057 */     GIR_RootConstrainSelectedInstOperands,
     /* 196058 */     // GIR_Coverage, 11842,
     /* 196058 */     GIR_EraseRootFromParent_Done,
     /* 196059 */   // Label 3897: @196059
     /* 196059 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(196096), // Rule ID 11843 //
     /* 196064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 196088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196094 */     GIR_RootConstrainSelectedInstOperands,
     /* 196095 */     // GIR_Coverage, 11843,
     /* 196095 */     GIR_EraseRootFromParent_Done,
     /* 196096 */   // Label 3898: @196096
     /* 196096 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(196133), // Rule ID 11844 //
     /* 196101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 196125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196131 */     GIR_RootConstrainSelectedInstOperands,
     /* 196132 */     // GIR_Coverage, 11844,
     /* 196132 */     GIR_EraseRootFromParent_Done,
     /* 196133 */   // Label 3899: @196133
     /* 196133 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(196170), // Rule ID 11845 //
     /* 196138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 196162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196168 */     GIR_RootConstrainSelectedInstOperands,
     /* 196169 */     // GIR_Coverage, 11845,
     /* 196169 */     GIR_EraseRootFromParent_Done,
     /* 196170 */   // Label 3900: @196170
     /* 196170 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(196207), // Rule ID 11861 //
     /* 196175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196205 */     GIR_RootConstrainSelectedInstOperands,
     /* 196206 */     // GIR_Coverage, 11861,
     /* 196206 */     GIR_EraseRootFromParent_Done,
     /* 196207 */   // Label 3901: @196207
     /* 196207 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(196244), // Rule ID 11862 //
     /* 196212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 196236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196242 */     GIR_RootConstrainSelectedInstOperands,
     /* 196243 */     // GIR_Coverage, 11862,
     /* 196243 */     GIR_EraseRootFromParent_Done,
     /* 196244 */   // Label 3902: @196244
     /* 196244 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(196281), // Rule ID 11863 //
     /* 196249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 196273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196279 */     GIR_RootConstrainSelectedInstOperands,
     /* 196280 */     // GIR_Coverage, 11863,
     /* 196280 */     GIR_EraseRootFromParent_Done,
     /* 196281 */   // Label 3903: @196281
     /* 196281 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196318), // Rule ID 11864 //
     /* 196286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 196310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196316 */     GIR_RootConstrainSelectedInstOperands,
     /* 196317 */     // GIR_Coverage, 11864,
     /* 196317 */     GIR_EraseRootFromParent_Done,
     /* 196318 */   // Label 3904: @196318
     /* 196318 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196355), // Rule ID 11865 //
     /* 196323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 196347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196353 */     GIR_RootConstrainSelectedInstOperands,
     /* 196354 */     // GIR_Coverage, 11865,
     /* 196354 */     GIR_EraseRootFromParent_Done,
     /* 196355 */   // Label 3905: @196355
     /* 196355 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196392), // Rule ID 11866 //
     /* 196360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 196384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196390 */     GIR_RootConstrainSelectedInstOperands,
     /* 196391 */     // GIR_Coverage, 11866,
     /* 196391 */     GIR_EraseRootFromParent_Done,
     /* 196392 */   // Label 3906: @196392
     /* 196392 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196432), // Rule ID 11941 //
     /* 196397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196418 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 196421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196430 */     GIR_RootConstrainSelectedInstOperands,
     /* 196431 */     // GIR_Coverage, 11941,
     /* 196431 */     GIR_EraseRootFromParent_Done,
     /* 196432 */   // Label 3907: @196432
     /* 196432 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196472), // Rule ID 11942 //
     /* 196437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 196461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196470 */     GIR_RootConstrainSelectedInstOperands,
     /* 196471 */     // GIR_Coverage, 11942,
     /* 196471 */     GIR_EraseRootFromParent_Done,
     /* 196472 */   // Label 3908: @196472
     /* 196472 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196512), // Rule ID 11943 //
     /* 196477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 196501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196510 */     GIR_RootConstrainSelectedInstOperands,
     /* 196511 */     // GIR_Coverage, 11943,
     /* 196511 */     GIR_EraseRootFromParent_Done,
     /* 196512 */   // Label 3909: @196512
     /* 196512 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196552), // Rule ID 11944 //
     /* 196517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 196541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196550 */     GIR_RootConstrainSelectedInstOperands,
     /* 196551 */     // GIR_Coverage, 11944,
     /* 196551 */     GIR_EraseRootFromParent_Done,
     /* 196552 */   // Label 3910: @196552
     /* 196552 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196592), // Rule ID 11945 //
     /* 196557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 196581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196590 */     GIR_RootConstrainSelectedInstOperands,
     /* 196591 */     // GIR_Coverage, 11945,
     /* 196591 */     GIR_EraseRootFromParent_Done,
     /* 196592 */   // Label 3911: @196592
     /* 196592 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196632), // Rule ID 11946 //
     /* 196597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 196621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196630 */     GIR_RootConstrainSelectedInstOperands,
     /* 196631 */     // GIR_Coverage, 11946,
     /* 196631 */     GIR_EraseRootFromParent_Done,
     /* 196632 */   // Label 3912: @196632
     /* 196632 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196672), // Rule ID 11947 //
     /* 196637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 196661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196670 */     GIR_RootConstrainSelectedInstOperands,
     /* 196671 */     // GIR_Coverage, 11947,
     /* 196671 */     GIR_EraseRootFromParent_Done,
     /* 196672 */   // Label 3913: @196672
     /* 196672 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196712), // Rule ID 11948 //
     /* 196677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 196701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196710 */     GIR_RootConstrainSelectedInstOperands,
     /* 196711 */     // GIR_Coverage, 11948,
     /* 196711 */     GIR_EraseRootFromParent_Done,
     /* 196712 */   // Label 3914: @196712
     /* 196712 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196752), // Rule ID 11953 //
     /* 196717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196738 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 196741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196750 */     GIR_RootConstrainSelectedInstOperands,
     /* 196751 */     // GIR_Coverage, 11953,
     /* 196751 */     GIR_EraseRootFromParent_Done,
     /* 196752 */   // Label 3915: @196752
     /* 196752 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196792), // Rule ID 11954 //
     /* 196757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 196781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196790 */     GIR_RootConstrainSelectedInstOperands,
     /* 196791 */     // GIR_Coverage, 11954,
     /* 196791 */     GIR_EraseRootFromParent_Done,
     /* 196792 */   // Label 3916: @196792
     /* 196792 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196832), // Rule ID 11955 //
     /* 196797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 196821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196830 */     GIR_RootConstrainSelectedInstOperands,
     /* 196831 */     // GIR_Coverage, 11955,
     /* 196831 */     GIR_EraseRootFromParent_Done,
     /* 196832 */   // Label 3917: @196832
     /* 196832 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196872), // Rule ID 11956 //
     /* 196837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 196861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196870 */     GIR_RootConstrainSelectedInstOperands,
     /* 196871 */     // GIR_Coverage, 11956,
     /* 196871 */     GIR_EraseRootFromParent_Done,
     /* 196872 */   // Label 3918: @196872
     /* 196872 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196912), // Rule ID 11957 //
     /* 196877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 196901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196910 */     GIR_RootConstrainSelectedInstOperands,
     /* 196911 */     // GIR_Coverage, 11957,
     /* 196911 */     GIR_EraseRootFromParent_Done,
     /* 196912 */   // Label 3919: @196912
     /* 196912 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196952), // Rule ID 11958 //
     /* 196917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196938 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 196941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196950 */     GIR_RootConstrainSelectedInstOperands,
     /* 196951 */     // GIR_Coverage, 11958,
     /* 196951 */     GIR_EraseRootFromParent_Done,
     /* 196952 */   // Label 3920: @196952
     /* 196952 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196992), // Rule ID 11959 //
     /* 196957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 196981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196990 */     GIR_RootConstrainSelectedInstOperands,
     /* 196991 */     // GIR_Coverage, 11959,
     /* 196991 */     GIR_EraseRootFromParent_Done,
     /* 196992 */   // Label 3921: @196992
     /* 196992 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197032), // Rule ID 11960 //
     /* 196997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197018 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 197018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 197021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197030 */     GIR_RootConstrainSelectedInstOperands,
     /* 197031 */     // GIR_Coverage, 11960,
     /* 197031 */     GIR_EraseRootFromParent_Done,
     /* 197032 */   // Label 3922: @197032
     /* 197032 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197072), // Rule ID 11965 //
     /* 197037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 197061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197070 */     GIR_RootConstrainSelectedInstOperands,
     /* 197071 */     // GIR_Coverage, 11965,
     /* 197071 */     GIR_EraseRootFromParent_Done,
     /* 197072 */   // Label 3923: @197072
     /* 197072 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197112), // Rule ID 11966 //
     /* 197077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 197101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197110 */     GIR_RootConstrainSelectedInstOperands,
     /* 197111 */     // GIR_Coverage, 11966,
     /* 197111 */     GIR_EraseRootFromParent_Done,
     /* 197112 */   // Label 3924: @197112
     /* 197112 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(197152), // Rule ID 11967 //
     /* 197117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197138 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 197141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197150 */     GIR_RootConstrainSelectedInstOperands,
     /* 197151 */     // GIR_Coverage, 11967,
     /* 197151 */     GIR_EraseRootFromParent_Done,
     /* 197152 */   // Label 3925: @197152
     /* 197152 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(197192), // Rule ID 11968 //
     /* 197157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 197181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197190 */     GIR_RootConstrainSelectedInstOperands,
     /* 197191 */     // GIR_Coverage, 11968,
     /* 197191 */     GIR_EraseRootFromParent_Done,
     /* 197192 */   // Label 3926: @197192
     /* 197192 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(197232), // Rule ID 11969 //
     /* 197197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 197221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197230 */     GIR_RootConstrainSelectedInstOperands,
     /* 197231 */     // GIR_Coverage, 11969,
     /* 197231 */     GIR_EraseRootFromParent_Done,
     /* 197232 */   // Label 3927: @197232
     /* 197232 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(197272), // Rule ID 11970 //
     /* 197237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 197261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197270 */     GIR_RootConstrainSelectedInstOperands,
     /* 197271 */     // GIR_Coverage, 11970,
     /* 197271 */     GIR_EraseRootFromParent_Done,
     /* 197272 */   // Label 3928: @197272
     /* 197272 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(197312), // Rule ID 11971 //
     /* 197277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 197301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197310 */     GIR_RootConstrainSelectedInstOperands,
     /* 197311 */     // GIR_Coverage, 11971,
     /* 197311 */     GIR_EraseRootFromParent_Done,
     /* 197312 */   // Label 3929: @197312
     /* 197312 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197352), // Rule ID 11972 //
     /* 197317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 197341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197350 */     GIR_RootConstrainSelectedInstOperands,
     /* 197351 */     // GIR_Coverage, 11972,
     /* 197351 */     GIR_EraseRootFromParent_Done,
     /* 197352 */   // Label 3930: @197352
     /* 197352 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197392), // Rule ID 11977 //
     /* 197357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 197381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197390 */     GIR_RootConstrainSelectedInstOperands,
     /* 197391 */     // GIR_Coverage, 11977,
     /* 197391 */     GIR_EraseRootFromParent_Done,
     /* 197392 */   // Label 3931: @197392
     /* 197392 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197432), // Rule ID 11978 //
     /* 197397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 197421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197430 */     GIR_RootConstrainSelectedInstOperands,
     /* 197431 */     // GIR_Coverage, 11978,
     /* 197431 */     GIR_EraseRootFromParent_Done,
     /* 197432 */   // Label 3932: @197432
     /* 197432 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197472), // Rule ID 11979 //
     /* 197437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197458 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 197461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197470 */     GIR_RootConstrainSelectedInstOperands,
     /* 197471 */     // GIR_Coverage, 11979,
     /* 197471 */     GIR_EraseRootFromParent_Done,
     /* 197472 */   // Label 3933: @197472
     /* 197472 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197512), // Rule ID 11980 //
     /* 197477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197498 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 197501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197510 */     GIR_RootConstrainSelectedInstOperands,
     /* 197511 */     // GIR_Coverage, 11980,
     /* 197511 */     GIR_EraseRootFromParent_Done,
     /* 197512 */   // Label 3934: @197512
     /* 197512 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197552), // Rule ID 11981 //
     /* 197517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 197541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197550 */     GIR_RootConstrainSelectedInstOperands,
     /* 197551 */     // GIR_Coverage, 11981,
     /* 197551 */     GIR_EraseRootFromParent_Done,
     /* 197552 */   // Label 3935: @197552
     /* 197552 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197592), // Rule ID 11982 //
     /* 197557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 197581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197590 */     GIR_RootConstrainSelectedInstOperands,
     /* 197591 */     // GIR_Coverage, 11982,
     /* 197591 */     GIR_EraseRootFromParent_Done,
     /* 197592 */   // Label 3936: @197592
     /* 197592 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197632), // Rule ID 11983 //
     /* 197597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 197621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197630 */     GIR_RootConstrainSelectedInstOperands,
     /* 197631 */     // GIR_Coverage, 11983,
     /* 197631 */     GIR_EraseRootFromParent_Done,
     /* 197632 */   // Label 3937: @197632
     /* 197632 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197672), // Rule ID 11984 //
     /* 197637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 197661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197670 */     GIR_RootConstrainSelectedInstOperands,
     /* 197671 */     // GIR_Coverage, 11984,
     /* 197671 */     GIR_EraseRootFromParent_Done,
     /* 197672 */   // Label 3938: @197672
     /* 197672 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197709), // Rule ID 11993 //
     /* 197677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 197685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 197701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197707 */     GIR_RootConstrainSelectedInstOperands,
     /* 197708 */     // GIR_Coverage, 11993,
     /* 197708 */     GIR_EraseRootFromParent_Done,
     /* 197709 */   // Label 3939: @197709
     /* 197709 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197746), // Rule ID 11995 //
     /* 197714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 197722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 197738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197744 */     GIR_RootConstrainSelectedInstOperands,
     /* 197745 */     // GIR_Coverage, 11995,
     /* 197745 */     GIR_EraseRootFromParent_Done,
     /* 197746 */   // Label 3940: @197746
     /* 197746 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197783), // Rule ID 11996 //
     /* 197751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 197754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 197759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 197775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197781 */     GIR_RootConstrainSelectedInstOperands,
     /* 197782 */     // GIR_Coverage, 11996,
     /* 197782 */     GIR_EraseRootFromParent_Done,
     /* 197783 */   // Label 3941: @197783
     /* 197783 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197820), // Rule ID 11997 //
     /* 197788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 197791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 197796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 197812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197818 */     GIR_RootConstrainSelectedInstOperands,
     /* 197819 */     // GIR_Coverage, 11997,
     /* 197819 */     GIR_EraseRootFromParent_Done,
     /* 197820 */   // Label 3942: @197820
     /* 197820 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197857), // Rule ID 11998 //
     /* 197825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 197849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197855 */     GIR_RootConstrainSelectedInstOperands,
     /* 197856 */     // GIR_Coverage, 11998,
     /* 197856 */     GIR_EraseRootFromParent_Done,
     /* 197857 */   // Label 3943: @197857
     /* 197857 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197894), // Rule ID 11999 //
     /* 197862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 197886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197892 */     GIR_RootConstrainSelectedInstOperands,
     /* 197893 */     // GIR_Coverage, 11999,
     /* 197893 */     GIR_EraseRootFromParent_Done,
     /* 197894 */   // Label 3944: @197894
     /* 197894 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197931), // Rule ID 12000 //
     /* 197899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 197923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197929 */     GIR_RootConstrainSelectedInstOperands,
     /* 197930 */     // GIR_Coverage, 12000,
     /* 197930 */     GIR_EraseRootFromParent_Done,
     /* 197931 */   // Label 3945: @197931
     /* 197931 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197968), // Rule ID 12001 //
     /* 197936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197957 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 197960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197966 */     GIR_RootConstrainSelectedInstOperands,
     /* 197967 */     // GIR_Coverage, 12001,
     /* 197967 */     GIR_EraseRootFromParent_Done,
     /* 197968 */   // Label 3946: @197968
     /* 197968 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(198005), // Rule ID 12002 //
     /* 197973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 197981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1289:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198003 */     GIR_RootConstrainSelectedInstOperands,
     /* 198004 */     // GIR_Coverage, 12002,
     /* 198004 */     GIR_EraseRootFromParent_Done,
     /* 198005 */   // Label 3947: @198005
     /* 198005 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198042), // Rule ID 12003 //
     /* 198010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1289:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 198034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198040 */     GIR_RootConstrainSelectedInstOperands,
     /* 198041 */     // GIR_Coverage, 12003,
     /* 198041 */     GIR_EraseRootFromParent_Done,
     /* 198042 */   // Label 3948: @198042
     /* 198042 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198079), // Rule ID 12004 //
     /* 198047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1289:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 198071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198077 */     GIR_RootConstrainSelectedInstOperands,
     /* 198078 */     // GIR_Coverage, 12004,
     /* 198078 */     GIR_EraseRootFromParent_Done,
     /* 198079 */   // Label 3949: @198079
     /* 198079 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198116), // Rule ID 12005 //
     /* 198084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1289:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 198108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198114 */     GIR_RootConstrainSelectedInstOperands,
     /* 198115 */     // GIR_Coverage, 12005,
     /* 198115 */     GIR_EraseRootFromParent_Done,
     /* 198116 */   // Label 3950: @198116
     /* 198116 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198153), // Rule ID 12118 //
     /* 198121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198142 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 198145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198151 */     GIR_RootConstrainSelectedInstOperands,
     /* 198152 */     // GIR_Coverage, 12118,
     /* 198152 */     GIR_EraseRootFromParent_Done,
     /* 198153 */   // Label 3951: @198153
     /* 198153 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198190), // Rule ID 12119 //
     /* 198158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198179 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 198182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198188 */     GIR_RootConstrainSelectedInstOperands,
     /* 198189 */     // GIR_Coverage, 12119,
     /* 198189 */     GIR_EraseRootFromParent_Done,
     /* 198190 */   // Label 3952: @198190
     /* 198190 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(198227), // Rule ID 12120 //
     /* 198195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198216 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 198219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198225 */     GIR_RootConstrainSelectedInstOperands,
     /* 198226 */     // GIR_Coverage, 12120,
     /* 198226 */     GIR_EraseRootFromParent_Done,
     /* 198227 */   // Label 3953: @198227
     /* 198227 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(198264), // Rule ID 12121 //
     /* 198232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198253 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 198256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198262 */     GIR_RootConstrainSelectedInstOperands,
     /* 198263 */     // GIR_Coverage, 12121,
     /* 198263 */     GIR_EraseRootFromParent_Done,
     /* 198264 */   // Label 3954: @198264
     /* 198264 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(198301), // Rule ID 12122 //
     /* 198269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198290 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 198293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198299 */     GIR_RootConstrainSelectedInstOperands,
     /* 198300 */     // GIR_Coverage, 12122,
     /* 198300 */     GIR_EraseRootFromParent_Done,
     /* 198301 */   // Label 3955: @198301
     /* 198301 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(198338), // Rule ID 12123 //
     /* 198306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198327 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 198330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198336 */     GIR_RootConstrainSelectedInstOperands,
     /* 198337 */     // GIR_Coverage, 12123,
     /* 198337 */     GIR_EraseRootFromParent_Done,
     /* 198338 */   // Label 3956: @198338
     /* 198338 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198375), // Rule ID 12124 //
     /* 198343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198364 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 198367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198373 */     GIR_RootConstrainSelectedInstOperands,
     /* 198374 */     // GIR_Coverage, 12124,
     /* 198374 */     GIR_EraseRootFromParent_Done,
     /* 198375 */   // Label 3957: @198375
     /* 198375 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198412), // Rule ID 12125 //
     /* 198380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198401 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 198404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198410 */     GIR_RootConstrainSelectedInstOperands,
     /* 198411 */     // GIR_Coverage, 12125,
     /* 198411 */     GIR_EraseRootFromParent_Done,
     /* 198412 */   // Label 3958: @198412
     /* 198412 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198449), // Rule ID 12126 //
     /* 198417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198438 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 198441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198447 */     GIR_RootConstrainSelectedInstOperands,
     /* 198448 */     // GIR_Coverage, 12126,
     /* 198448 */     GIR_EraseRootFromParent_Done,
     /* 198449 */   // Label 3959: @198449
     /* 198449 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198486), // Rule ID 12127 //
     /* 198454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198475 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 198478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198484 */     GIR_RootConstrainSelectedInstOperands,
     /* 198485 */     // GIR_Coverage, 12127,
     /* 198485 */     GIR_EraseRootFromParent_Done,
     /* 198486 */   // Label 3960: @198486
     /* 198486 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198523), // Rule ID 12128 //
     /* 198491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198512 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 198515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198521 */     GIR_RootConstrainSelectedInstOperands,
     /* 198522 */     // GIR_Coverage, 12128,
     /* 198522 */     GIR_EraseRootFromParent_Done,
     /* 198523 */   // Label 3961: @198523
     /* 198523 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198560), // Rule ID 12129 //
     /* 198528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198549 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 198552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198558 */     GIR_RootConstrainSelectedInstOperands,
     /* 198559 */     // GIR_Coverage, 12129,
     /* 198559 */     GIR_EraseRootFromParent_Done,
     /* 198560 */   // Label 3962: @198560
     /* 198560 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198597), // Rule ID 12130 //
     /* 198565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198586 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1353:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 198589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198595 */     GIR_RootConstrainSelectedInstOperands,
     /* 198596 */     // GIR_Coverage, 12130,
     /* 198596 */     GIR_EraseRootFromParent_Done,
     /* 198597 */   // Label 3963: @198597
     /* 198597 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198634), // Rule ID 12131 //
     /* 198602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198623 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 198626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198632 */     GIR_RootConstrainSelectedInstOperands,
     /* 198633 */     // GIR_Coverage, 12131,
     /* 198633 */     GIR_EraseRootFromParent_Done,
     /* 198634 */   // Label 3964: @198634
     /* 198634 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198671), // Rule ID 12132 //
     /* 198639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198660 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 198663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198669 */     GIR_RootConstrainSelectedInstOperands,
     /* 198670 */     // GIR_Coverage, 12132,
     /* 198670 */     GIR_EraseRootFromParent_Done,
     /* 198671 */   // Label 3965: @198671
     /* 198671 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198708), // Rule ID 12133 //
     /* 198676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198697 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 198700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198706 */     GIR_RootConstrainSelectedInstOperands,
     /* 198707 */     // GIR_Coverage, 12133,
     /* 198707 */     GIR_EraseRootFromParent_Done,
     /* 198708 */   // Label 3966: @198708
     /* 198708 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198745), // Rule ID 12134 //
     /* 198713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198734 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 198737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198743 */     GIR_RootConstrainSelectedInstOperands,
     /* 198744 */     // GIR_Coverage, 12134,
     /* 198744 */     GIR_EraseRootFromParent_Done,
     /* 198745 */   // Label 3967: @198745
     /* 198745 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198782), // Rule ID 12135 //
     /* 198750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198771 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 198774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198780 */     GIR_RootConstrainSelectedInstOperands,
     /* 198781 */     // GIR_Coverage, 12135,
     /* 198781 */     GIR_EraseRootFromParent_Done,
     /* 198782 */   // Label 3968: @198782
     /* 198782 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198819), // Rule ID 12136 //
     /* 198787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 198811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198817 */     GIR_RootConstrainSelectedInstOperands,
     /* 198818 */     // GIR_Coverage, 12136,
     /* 198818 */     GIR_EraseRootFromParent_Done,
     /* 198819 */   // Label 3969: @198819
     /* 198819 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198856), // Rule ID 12137 //
     /* 198824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198845 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 198848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198854 */     GIR_RootConstrainSelectedInstOperands,
     /* 198855 */     // GIR_Coverage, 12137,
     /* 198855 */     GIR_EraseRootFromParent_Done,
     /* 198856 */   // Label 3970: @198856
     /* 198856 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198893), // Rule ID 12138 //
     /* 198861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198882 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 198885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198891 */     GIR_RootConstrainSelectedInstOperands,
     /* 198892 */     // GIR_Coverage, 12138,
     /* 198892 */     GIR_EraseRootFromParent_Done,
     /* 198893 */   // Label 3971: @198893
     /* 198893 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198930), // Rule ID 12139 //
     /* 198898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198919 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 198922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198928 */     GIR_RootConstrainSelectedInstOperands,
     /* 198929 */     // GIR_Coverage, 12139,
     /* 198929 */     GIR_EraseRootFromParent_Done,
     /* 198930 */   // Label 3972: @198930
     /* 198930 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198967), // Rule ID 12140 //
     /* 198935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 198959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198965 */     GIR_RootConstrainSelectedInstOperands,
     /* 198966 */     // GIR_Coverage, 12140,
     /* 198966 */     GIR_EraseRootFromParent_Done,
     /* 198967 */   // Label 3973: @198967
     /* 198967 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(199004), // Rule ID 12141 //
     /* 198972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 198996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199002 */     GIR_RootConstrainSelectedInstOperands,
     /* 199003 */     // GIR_Coverage, 12141,
     /* 199003 */     GIR_EraseRootFromParent_Done,
     /* 199004 */   // Label 3974: @199004
     /* 199004 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199041), // Rule ID 12142 //
     /* 199009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199030 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 199033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199039 */     GIR_RootConstrainSelectedInstOperands,
     /* 199040 */     // GIR_Coverage, 12142,
     /* 199040 */     GIR_EraseRootFromParent_Done,
     /* 199041 */   // Label 3975: @199041
     /* 199041 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199078), // Rule ID 12143 //
     /* 199046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199067 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 199070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199076 */     GIR_RootConstrainSelectedInstOperands,
     /* 199077 */     // GIR_Coverage, 12143,
     /* 199077 */     GIR_EraseRootFromParent_Done,
     /* 199078 */   // Label 3976: @199078
     /* 199078 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199115), // Rule ID 12144 //
     /* 199083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199104 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 199107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199113 */     GIR_RootConstrainSelectedInstOperands,
     /* 199114 */     // GIR_Coverage, 12144,
     /* 199114 */     GIR_EraseRootFromParent_Done,
     /* 199115 */   // Label 3977: @199115
     /* 199115 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199152), // Rule ID 12145 //
     /* 199120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199141 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 199144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199150 */     GIR_RootConstrainSelectedInstOperands,
     /* 199151 */     // GIR_Coverage, 12145,
     /* 199151 */     GIR_EraseRootFromParent_Done,
     /* 199152 */   // Label 3978: @199152
     /* 199152 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199189), // Rule ID 12146 //
     /* 199157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199178 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 199181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199187 */     GIR_RootConstrainSelectedInstOperands,
     /* 199188 */     // GIR_Coverage, 12146,
     /* 199188 */     GIR_EraseRootFromParent_Done,
     /* 199189 */   // Label 3979: @199189
     /* 199189 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199226), // Rule ID 12147 //
     /* 199194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 199218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199224 */     GIR_RootConstrainSelectedInstOperands,
     /* 199225 */     // GIR_Coverage, 12147,
     /* 199225 */     GIR_EraseRootFromParent_Done,
     /* 199226 */   // Label 3980: @199226
     /* 199226 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199263), // Rule ID 12148 //
     /* 199231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 199255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199261 */     GIR_RootConstrainSelectedInstOperands,
     /* 199262 */     // GIR_Coverage, 12148,
     /* 199262 */     GIR_EraseRootFromParent_Done,
     /* 199263 */   // Label 3981: @199263
     /* 199263 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199300), // Rule ID 12149 //
     /* 199268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199289 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 199292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199298 */     GIR_RootConstrainSelectedInstOperands,
     /* 199299 */     // GIR_Coverage, 12149,
     /* 199299 */     GIR_EraseRootFromParent_Done,
     /* 199300 */   // Label 3982: @199300
     /* 199300 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199337), // Rule ID 12150 //
     /* 199305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199326 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 199329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199335 */     GIR_RootConstrainSelectedInstOperands,
     /* 199336 */     // GIR_Coverage, 12150,
     /* 199336 */     GIR_EraseRootFromParent_Done,
     /* 199337 */   // Label 3983: @199337
     /* 199337 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199374), // Rule ID 12151 //
     /* 199342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 199366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199372 */     GIR_RootConstrainSelectedInstOperands,
     /* 199373 */     // GIR_Coverage, 12151,
     /* 199373 */     GIR_EraseRootFromParent_Done,
     /* 199374 */   // Label 3984: @199374
     /* 199374 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199411), // Rule ID 12152 //
     /* 199379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199400 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 199403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199409 */     GIR_RootConstrainSelectedInstOperands,
     /* 199410 */     // GIR_Coverage, 12152,
     /* 199410 */     GIR_EraseRootFromParent_Done,
     /* 199411 */   // Label 3985: @199411
     /* 199411 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199448), // Rule ID 12153 //
     /* 199416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199437 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 199440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199446 */     GIR_RootConstrainSelectedInstOperands,
     /* 199447 */     // GIR_Coverage, 12153,
     /* 199447 */     GIR_EraseRootFromParent_Done,
     /* 199448 */   // Label 3986: @199448
     /* 199448 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(199485), // Rule ID 12154 //
     /* 199453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199474 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 199477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199483 */     GIR_RootConstrainSelectedInstOperands,
     /* 199484 */     // GIR_Coverage, 12154,
     /* 199484 */     GIR_EraseRootFromParent_Done,
     /* 199485 */   // Label 3987: @199485
     /* 199485 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(199522), // Rule ID 12155 //
     /* 199490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199511 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 199514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199520 */     GIR_RootConstrainSelectedInstOperands,
     /* 199521 */     // GIR_Coverage, 12155,
     /* 199521 */     GIR_EraseRootFromParent_Done,
     /* 199522 */   // Label 3988: @199522
     /* 199522 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(199559), // Rule ID 12156 //
     /* 199527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199548 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 199551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199557 */     GIR_RootConstrainSelectedInstOperands,
     /* 199558 */     // GIR_Coverage, 12156,
     /* 199558 */     GIR_EraseRootFromParent_Done,
     /* 199559 */   // Label 3989: @199559
     /* 199559 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(199596), // Rule ID 12157 //
     /* 199564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199585 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 199588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199594 */     GIR_RootConstrainSelectedInstOperands,
     /* 199595 */     // GIR_Coverage, 12157,
     /* 199595 */     GIR_EraseRootFromParent_Done,
     /* 199596 */   // Label 3990: @199596
     /* 199596 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(199633), // Rule ID 12158 //
     /* 199601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 199612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 199615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 199625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199631 */     GIR_RootConstrainSelectedInstOperands,
     /* 199632 */     // GIR_Coverage, 12158,
     /* 199632 */     GIR_EraseRootFromParent_Done,
     /* 199633 */   // Label 3991: @199633
     /* 199633 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(199670), // Rule ID 12159 //
     /* 199638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 199662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199668 */     GIR_RootConstrainSelectedInstOperands,
     /* 199669 */     // GIR_Coverage, 12159,
     /* 199669 */     GIR_EraseRootFromParent_Done,
     /* 199670 */   // Label 3992: @199670
     /* 199670 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(199707), // Rule ID 12160 //
     /* 199675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 199699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199705 */     GIR_RootConstrainSelectedInstOperands,
     /* 199706 */     // GIR_Coverage, 12160,
     /* 199706 */     GIR_EraseRootFromParent_Done,
     /* 199707 */   // Label 3993: @199707
     /* 199707 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(199744), // Rule ID 12161 //
     /* 199712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199733 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 199736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199742 */     GIR_RootConstrainSelectedInstOperands,
     /* 199743 */     // GIR_Coverage, 12161,
     /* 199743 */     GIR_EraseRootFromParent_Done,
     /* 199744 */   // Label 3994: @199744
     /* 199744 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(199781), // Rule ID 12162 //
     /* 199749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199770 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 199770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 199773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199779 */     GIR_RootConstrainSelectedInstOperands,
     /* 199780 */     // GIR_Coverage, 12162,
     /* 199780 */     GIR_EraseRootFromParent_Done,
     /* 199781 */   // Label 3995: @199781
     /* 199781 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(199818), // Rule ID 12163 //
     /* 199786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199807 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199816 */     GIR_RootConstrainSelectedInstOperands,
     /* 199817 */     // GIR_Coverage, 12163,
     /* 199817 */     GIR_EraseRootFromParent_Done,
     /* 199818 */   // Label 3996: @199818
     /* 199818 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(199855), // Rule ID 12164 //
     /* 199823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199844 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 199844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 199847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199853 */     GIR_RootConstrainSelectedInstOperands,
     /* 199854 */     // GIR_Coverage, 12164,
     /* 199854 */     GIR_EraseRootFromParent_Done,
     /* 199855 */   // Label 3997: @199855
     /* 199855 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(199892), // Rule ID 12165 //
     /* 199860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 199871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 199874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2088:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 199884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199890 */     GIR_RootConstrainSelectedInstOperands,
     /* 199891 */     // GIR_Coverage, 12165,
     /* 199891 */     GIR_EraseRootFromParent_Done,
     /* 199892 */   // Label 3998: @199892
     /* 199892 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(199929), // Rule ID 12166 //
     /* 199897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2088:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 199921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199927 */     GIR_RootConstrainSelectedInstOperands,
     /* 199928 */     // GIR_Coverage, 12166,
     /* 199928 */     GIR_EraseRootFromParent_Done,
     /* 199929 */   // Label 3999: @199929
     /* 199929 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(199966), // Rule ID 12167 //
     /* 199934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2088:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 199958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199964 */     GIR_RootConstrainSelectedInstOperands,
     /* 199965 */     // GIR_Coverage, 12167,
     /* 199965 */     GIR_EraseRootFromParent_Done,
     /* 199966 */   // Label 4000: @199966
     /* 199966 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200003), // Rule ID 12168 //
     /* 199971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2088:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 199995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200001 */     GIR_RootConstrainSelectedInstOperands,
     /* 200002 */     // GIR_Coverage, 12168,
     /* 200002 */     GIR_EraseRootFromParent_Done,
     /* 200003 */   // Label 4001: @200003
     /* 200003 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200040), // Rule ID 12169 //
     /* 200008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200029 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2088:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 200029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 200032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200038 */     GIR_RootConstrainSelectedInstOperands,
     /* 200039 */     // GIR_Coverage, 12169,
     /* 200039 */     GIR_EraseRootFromParent_Done,
     /* 200040 */   // Label 4002: @200040
     /* 200040 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200077), // Rule ID 12170 //
     /* 200045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2088:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 200066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 200069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200075 */     GIR_RootConstrainSelectedInstOperands,
     /* 200076 */     // GIR_Coverage, 12170,
     /* 200076 */     GIR_EraseRootFromParent_Done,
     /* 200077 */   // Label 4003: @200077
     /* 200077 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(200114), // Rule ID 12171 //
     /* 200082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200103 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2088:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 200103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 200106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200112 */     GIR_RootConstrainSelectedInstOperands,
     /* 200113 */     // GIR_Coverage, 12171,
     /* 200113 */     GIR_EraseRootFromParent_Done,
     /* 200114 */   // Label 4004: @200114
     /* 200114 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(200151), // Rule ID 12172 //
     /* 200119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 200130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 200133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 200136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 200140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 200143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200149 */     GIR_RootConstrainSelectedInstOperands,
     /* 200150 */     // GIR_Coverage, 12172,
     /* 200150 */     GIR_EraseRootFromParent_Done,
     /* 200151 */   // Label 4005: @200151
     /* 200151 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(200188), // Rule ID 12173 //
     /* 200156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 200177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 200180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200186 */     GIR_RootConstrainSelectedInstOperands,
     /* 200187 */     // GIR_Coverage, 12173,
     /* 200187 */     GIR_EraseRootFromParent_Done,
     /* 200188 */   // Label 4006: @200188
     /* 200188 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(200225), // Rule ID 12174 //
     /* 200193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 200214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 200217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200223 */     GIR_RootConstrainSelectedInstOperands,
     /* 200224 */     // GIR_Coverage, 12174,
     /* 200224 */     GIR_EraseRootFromParent_Done,
     /* 200225 */   // Label 4007: @200225
     /* 200225 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(200262), // Rule ID 12175 //
     /* 200230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 200251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 200254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200260 */     GIR_RootConstrainSelectedInstOperands,
     /* 200261 */     // GIR_Coverage, 12175,
     /* 200261 */     GIR_EraseRootFromParent_Done,
     /* 200262 */   // Label 4008: @200262
     /* 200262 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(200299), // Rule ID 12176 //
     /* 200267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200288 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 200288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 200291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200297 */     GIR_RootConstrainSelectedInstOperands,
     /* 200298 */     // GIR_Coverage, 12176,
     /* 200298 */     GIR_EraseRootFromParent_Done,
     /* 200299 */   // Label 4009: @200299
     /* 200299 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(200336), // Rule ID 12177 //
     /* 200304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200325 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 200325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 200328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200334 */     GIR_RootConstrainSelectedInstOperands,
     /* 200335 */     // GIR_Coverage, 12177,
     /* 200335 */     GIR_EraseRootFromParent_Done,
     /* 200336 */   // Label 4010: @200336
     /* 200336 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(200373), // Rule ID 12178 //
     /* 200341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200362 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 200362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 200365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200371 */     GIR_RootConstrainSelectedInstOperands,
     /* 200372 */     // GIR_Coverage, 12178,
     /* 200372 */     GIR_EraseRootFromParent_Done,
     /* 200373 */   // Label 4011: @200373
     /* 200373 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(200415), // Rule ID 3218 //
     /* 200378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 200386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200393 */     // MIs[0] Op1
     /* 200393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200397 */     // MIs[0] Op2
     /* 200397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200401 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 200404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200413 */     GIR_RootConstrainSelectedInstOperands,
     /* 200414 */     // GIR_Coverage, 3218,
     /* 200414 */     GIR_EraseRootFromParent_Done,
     /* 200415 */   // Label 4012: @200415
     /* 200415 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(200457), // Rule ID 3219 //
     /* 200420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 200428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200435 */     // MIs[0] Op1
     /* 200435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200439 */     // MIs[0] Op2
     /* 200439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200455 */     GIR_RootConstrainSelectedInstOperands,
     /* 200456 */     // GIR_Coverage, 3219,
     /* 200456 */     GIR_EraseRootFromParent_Done,
     /* 200457 */   // Label 4013: @200457
     /* 200457 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(200499), // Rule ID 3220 //
     /* 200462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 200470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200477 */     // MIs[0] Op1
     /* 200477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200481 */     // MIs[0] Op2
     /* 200481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 200488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200497 */     GIR_RootConstrainSelectedInstOperands,
     /* 200498 */     // GIR_Coverage, 3220,
     /* 200498 */     GIR_EraseRootFromParent_Done,
     /* 200499 */   // Label 4014: @200499
     /* 200499 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(200541), // Rule ID 3221 //
     /* 200504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 200512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200519 */     // MIs[0] Op1
     /* 200519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200523 */     // MIs[0] Op2
     /* 200523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200527 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 200530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200539 */     GIR_RootConstrainSelectedInstOperands,
     /* 200540 */     // GIR_Coverage, 3221,
     /* 200540 */     GIR_EraseRootFromParent_Done,
     /* 200541 */   // Label 4015: @200541
     /* 200541 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(200583), // Rule ID 11989 //
     /* 200546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 200554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200561 */     // MIs[0] Op1
     /* 200561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200565 */     // MIs[0] Op2
     /* 200565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 200572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200581 */     GIR_RootConstrainSelectedInstOperands,
     /* 200582 */     // GIR_Coverage, 11989,
     /* 200582 */     GIR_EraseRootFromParent_Done,
     /* 200583 */   // Label 4016: @200583
     /* 200583 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(200625), // Rule ID 11990 //
     /* 200588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 200596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200603 */     // MIs[0] Op1
     /* 200603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200607 */     // MIs[0] Op2
     /* 200607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 200614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200623 */     GIR_RootConstrainSelectedInstOperands,
     /* 200624 */     // GIR_Coverage, 11990,
     /* 200624 */     GIR_EraseRootFromParent_Done,
     /* 200625 */   // Label 4017: @200625
     /* 200625 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(200667), // Rule ID 11991 //
     /* 200630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 200638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200645 */     // MIs[0] Op1
     /* 200645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200649 */     // MIs[0] Op2
     /* 200649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200653 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 200656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200665 */     GIR_RootConstrainSelectedInstOperands,
     /* 200666 */     // GIR_Coverage, 11991,
     /* 200666 */     GIR_EraseRootFromParent_Done,
     /* 200667 */   // Label 4018: @200667
     /* 200667 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(200709), // Rule ID 11992 //
     /* 200672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 200680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200687 */     // MIs[0] Op1
     /* 200687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200691 */     // MIs[0] Op2
     /* 200691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 200698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200707 */     GIR_RootConstrainSelectedInstOperands,
     /* 200708 */     // GIR_Coverage, 11992,
     /* 200708 */     GIR_EraseRootFromParent_Done,
     /* 200709 */   // Label 4019: @200709
     /* 200709 */   GIM_Reject,
     /* 200710 */ // Label 3066: @200710
     /* 200710 */ GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(244493),
     /* 200715 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 200718 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(200831), // Rule ID 2069 //
     /* 200723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 200731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 200775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 200788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 200800 */     // MIs[3] Operand 1
     /* 200800 */     // No operand predicates
     /* 200800 */     // MIs[1] Operand 2
     /* 200800 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 200811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200813 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 200816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200829 */     GIR_RootConstrainSelectedInstOperands,
     /* 200830 */     // GIR_Coverage, 2069,
     /* 200830 */     GIR_EraseRootFromParent_Done,
     /* 200831 */   // Label 4021: @200831
     /* 200831 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(200944), // Rule ID 2076 //
     /* 200836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 200844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 200856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 200888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 200901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 200913 */     // MIs[3] Operand 1
     /* 200913 */     // No operand predicates
     /* 200913 */     // MIs[1] Operand 2
     /* 200913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 200924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200926 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 200929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200942 */     GIR_RootConstrainSelectedInstOperands,
     /* 200943 */     // GIR_Coverage, 2076,
     /* 200943 */     GIR_EraseRootFromParent_Done,
     /* 200944 */   // Label 4022: @200944
     /* 200944 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201057), // Rule ID 2072 //
     /* 200949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 200957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 200969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201022 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201026 */     // MIs[3] Operand 1
     /* 201026 */     // No operand predicates
     /* 201026 */     // MIs[1] Operand 2
     /* 201026 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 201037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201039 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 201042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201055 */     GIR_RootConstrainSelectedInstOperands,
     /* 201056 */     // GIR_Coverage, 2072,
     /* 201056 */     GIR_EraseRootFromParent_Done,
     /* 201057 */   // Label 4023: @201057
     /* 201057 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201170), // Rule ID 2079 //
     /* 201062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 201065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 201070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 201073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 201076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 201079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 201082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 201102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201135 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201139 */     // MIs[3] Operand 1
     /* 201139 */     // No operand predicates
     /* 201139 */     // MIs[1] Operand 2
     /* 201139 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 201150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201152 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 201155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201168 */     GIR_RootConstrainSelectedInstOperands,
     /* 201169 */     // GIR_Coverage, 2079,
     /* 201169 */     GIR_EraseRootFromParent_Done,
     /* 201170 */   // Label 4024: @201170
     /* 201170 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201275), // Rule ID 3869 //
     /* 201175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 201183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201252 */     // MIs[3] Operand 1
     /* 201252 */     // No operand predicates
     /* 201252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201254 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 201254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201273 */     GIR_RootConstrainSelectedInstOperands,
     /* 201274 */     // GIR_Coverage, 3869,
     /* 201274 */     GIR_EraseRootFromParent_Done,
     /* 201275 */   // Label 4025: @201275
     /* 201275 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(201380), // Rule ID 3870 //
     /* 201280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 201288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201357 */     // MIs[3] Operand 1
     /* 201357 */     // No operand predicates
     /* 201357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201359 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 201359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201378 */     GIR_RootConstrainSelectedInstOperands,
     /* 201379 */     // GIR_Coverage, 3870,
     /* 201379 */     GIR_EraseRootFromParent_Done,
     /* 201380 */   // Label 4026: @201380
     /* 201380 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(201485), // Rule ID 3871 //
     /* 201385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 201393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201458 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201462 */     // MIs[3] Operand 1
     /* 201462 */     // No operand predicates
     /* 201462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201464 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 201464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 201483 */     GIR_RootConstrainSelectedInstOperands,
     /* 201484 */     // GIR_Coverage, 3871,
     /* 201484 */     GIR_EraseRootFromParent_Done,
     /* 201485 */   // Label 4027: @201485
     /* 201485 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(201590), // Rule ID 3872 //
     /* 201490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 201498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201563 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201567 */     // MIs[3] Operand 1
     /* 201567 */     // No operand predicates
     /* 201567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201569 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 201569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 201588 */     GIR_RootConstrainSelectedInstOperands,
     /* 201589 */     // GIR_Coverage, 3872,
     /* 201589 */     GIR_EraseRootFromParent_Done,
     /* 201590 */   // Label 4028: @201590
     /* 201590 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(201695), // Rule ID 3877 //
     /* 201595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 201603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201672 */     // MIs[3] Operand 1
     /* 201672 */     // No operand predicates
     /* 201672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201674 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 201674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201693 */     GIR_RootConstrainSelectedInstOperands,
     /* 201694 */     // GIR_Coverage, 3877,
     /* 201694 */     GIR_EraseRootFromParent_Done,
     /* 201695 */   // Label 4029: @201695
     /* 201695 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(201800), // Rule ID 3878 //
     /* 201700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 201708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201777 */     // MIs[3] Operand 1
     /* 201777 */     // No operand predicates
     /* 201777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201779 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 201779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201798 */     GIR_RootConstrainSelectedInstOperands,
     /* 201799 */     // GIR_Coverage, 3878,
     /* 201799 */     GIR_EraseRootFromParent_Done,
     /* 201800 */   // Label 4030: @201800
     /* 201800 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(201905), // Rule ID 3879 //
     /* 201805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 201813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201878 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201882 */     // MIs[3] Operand 1
     /* 201882 */     // No operand predicates
     /* 201882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201884 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 201884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 201903 */     GIR_RootConstrainSelectedInstOperands,
     /* 201904 */     // GIR_Coverage, 3879,
     /* 201904 */     GIR_EraseRootFromParent_Done,
     /* 201905 */   // Label 4031: @201905
     /* 201905 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202010), // Rule ID 3880 //
     /* 201910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 201918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201987 */     // MIs[3] Operand 1
     /* 201987 */     // No operand predicates
     /* 201987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201989 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 201989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 202008 */     GIR_RootConstrainSelectedInstOperands,
     /* 202009 */     // GIR_Coverage, 3880,
     /* 202009 */     GIR_EraseRootFromParent_Done,
     /* 202010 */   // Label 4032: @202010
     /* 202010 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202115), // Rule ID 3893 //
     /* 202015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 202023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202088 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202092 */     // MIs[3] Operand 1
     /* 202092 */     // No operand predicates
     /* 202092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202094 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 202094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202113 */     GIR_RootConstrainSelectedInstOperands,
     /* 202114 */     // GIR_Coverage, 3893,
     /* 202114 */     GIR_EraseRootFromParent_Done,
     /* 202115 */   // Label 4033: @202115
     /* 202115 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202220), // Rule ID 3894 //
     /* 202120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 202128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202197 */     // MIs[3] Operand 1
     /* 202197 */     // No operand predicates
     /* 202197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202199 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 202199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202218 */     GIR_RootConstrainSelectedInstOperands,
     /* 202219 */     // GIR_Coverage, 3894,
     /* 202219 */     GIR_EraseRootFromParent_Done,
     /* 202220 */   // Label 4034: @202220
     /* 202220 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202325), // Rule ID 3895 //
     /* 202225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 202233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202298 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202302 */     // MIs[3] Operand 1
     /* 202302 */     // No operand predicates
     /* 202302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202304 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 202304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 202323 */     GIR_RootConstrainSelectedInstOperands,
     /* 202324 */     // GIR_Coverage, 3895,
     /* 202324 */     GIR_EraseRootFromParent_Done,
     /* 202325 */   // Label 4035: @202325
     /* 202325 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202430), // Rule ID 3896 //
     /* 202330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 202338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202407 */     // MIs[3] Operand 1
     /* 202407 */     // No operand predicates
     /* 202407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202409 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 202409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 202428 */     GIR_RootConstrainSelectedInstOperands,
     /* 202429 */     // GIR_Coverage, 3896,
     /* 202429 */     GIR_EraseRootFromParent_Done,
     /* 202430 */   // Label 4036: @202430
     /* 202430 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202484), // Rule ID 59 //
     /* 202435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202460 */     // MIs[0] Operand 3
     /* 202460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 202471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202475 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 202478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202482 */     GIR_RootConstrainSelectedInstOperands,
     /* 202483 */     // GIR_Coverage, 59,
     /* 202483 */     GIR_EraseRootFromParent_Done,
     /* 202484 */   // Label 4037: @202484
     /* 202484 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202538), // Rule ID 60 //
     /* 202489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202514 */     // MIs[0] Operand 3
     /* 202514 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 202525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202529 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 202532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202536 */     GIR_RootConstrainSelectedInstOperands,
     /* 202537 */     // GIR_Coverage, 60,
     /* 202537 */     GIR_EraseRootFromParent_Done,
     /* 202538 */   // Label 4038: @202538
     /* 202538 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202592), // Rule ID 61 //
     /* 202543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202568 */     // MIs[0] Operand 3
     /* 202568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 202579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202583 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 202586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202590 */     GIR_RootConstrainSelectedInstOperands,
     /* 202591 */     // GIR_Coverage, 61,
     /* 202591 */     GIR_EraseRootFromParent_Done,
     /* 202592 */   // Label 4039: @202592
     /* 202592 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202646), // Rule ID 62 //
     /* 202597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202622 */     // MIs[0] Operand 3
     /* 202622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 202633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202637 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 202640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202644 */     GIR_RootConstrainSelectedInstOperands,
     /* 202645 */     // GIR_Coverage, 62,
     /* 202645 */     GIR_EraseRootFromParent_Done,
     /* 202646 */   // Label 4040: @202646
     /* 202646 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202702), // Rule ID 2652 //
     /* 202651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 202659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202673 */     // MIs[0] pattern
     /* 202673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202681 */     // MIs[0] imm4
     /* 202681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 202692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202696 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202698 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202700 */     GIR_RootConstrainSelectedInstOperands,
     /* 202701 */     // GIR_Coverage, 2652,
     /* 202701 */     GIR_EraseRootFromParent_Done,
     /* 202702 */   // Label 4041: @202702
     /* 202702 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202758), // Rule ID 2661 //
     /* 202707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 202715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202729 */     // MIs[0] pattern
     /* 202729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202737 */     // MIs[0] imm4
     /* 202737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202745 */     // (intrinsic_wo_chain:{ *:[i32] } 2016:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 202748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202752 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202754 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202756 */     GIR_RootConstrainSelectedInstOperands,
     /* 202757 */     // GIR_Coverage, 2661,
     /* 202757 */     GIR_EraseRootFromParent_Done,
     /* 202758 */   // Label 4042: @202758
     /* 202758 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202814), // Rule ID 2662 //
     /* 202763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 202771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202785 */     // MIs[0] pattern
     /* 202785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202793 */     // MIs[0] imm4
     /* 202793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202801 */     // (intrinsic_wo_chain:{ *:[i64] } 1806:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 202804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202808 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202810 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202812 */     GIR_RootConstrainSelectedInstOperands,
     /* 202813 */     // GIR_Coverage, 2662,
     /* 202813 */     GIR_EraseRootFromParent_Done,
     /* 202814 */   // Label 4043: @202814
     /* 202814 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202870), // Rule ID 10000 //
     /* 202819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 202827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202841 */     // MIs[0] pattern
     /* 202841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202849 */     // MIs[0] imm4
     /* 202849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202857 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 202860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202864 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202866 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202868 */     GIR_RootConstrainSelectedInstOperands,
     /* 202869 */     // GIR_Coverage, 10000,
     /* 202869 */     GIR_EraseRootFromParent_Done,
     /* 202870 */   // Label 4044: @202870
     /* 202870 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202926), // Rule ID 10001 //
     /* 202875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 202883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202897 */     // MIs[0] pattern
     /* 202897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202905 */     // MIs[0] imm4
     /* 202905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202913 */     // (intrinsic_wo_chain:{ *:[i64] } 2017:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 202916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202920 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202922 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202924 */     GIR_RootConstrainSelectedInstOperands,
     /* 202925 */     // GIR_Coverage, 10001,
     /* 202925 */     GIR_EraseRootFromParent_Done,
     /* 202926 */   // Label 4045: @202926
     /* 202926 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202982), // Rule ID 10002 //
     /* 202931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 202939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202953 */     // MIs[0] pattern
     /* 202953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202961 */     // MIs[0] imm4
     /* 202961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202969 */     // (intrinsic_wo_chain:{ *:[i64] } 1772:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 202972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202976 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202978 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202980 */     GIR_RootConstrainSelectedInstOperands,
     /* 202981 */     // GIR_Coverage, 10002,
     /* 202981 */     GIR_EraseRootFromParent_Done,
     /* 202982 */   // Label 4046: @202982
     /* 202982 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203038), // Rule ID 10003 //
     /* 202987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 202995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203009 */     // MIs[0] pattern
     /* 203009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203017 */     // MIs[0] imm4
     /* 203017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203025 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 203028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203034 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203036 */     GIR_RootConstrainSelectedInstOperands,
     /* 203037 */     // GIR_Coverage, 10003,
     /* 203037 */     GIR_EraseRootFromParent_Done,
     /* 203038 */   // Label 4047: @203038
     /* 203038 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203094), // Rule ID 10006 //
     /* 203043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 203051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203065 */     // MIs[0] pattern
     /* 203065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203073 */     // MIs[0] imm4
     /* 203073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203081 */     // (intrinsic_wo_chain:{ *:[i32] } 2022:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 203084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203088 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203090 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203092 */     GIR_RootConstrainSelectedInstOperands,
     /* 203093 */     // GIR_Coverage, 10006,
     /* 203093 */     GIR_EraseRootFromParent_Done,
     /* 203094 */   // Label 4048: @203094
     /* 203094 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203150), // Rule ID 10009 //
     /* 203099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 203107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203121 */     // MIs[0] pattern
     /* 203121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203129 */     // MIs[0] imm4
     /* 203129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203137 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 203140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203144 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203146 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203148 */     GIR_RootConstrainSelectedInstOperands,
     /* 203149 */     // GIR_Coverage, 10009,
     /* 203149 */     GIR_EraseRootFromParent_Done,
     /* 203150 */   // Label 4049: @203150
     /* 203150 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203206), // Rule ID 10010 //
     /* 203155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 203163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203177 */     // MIs[0] pattern
     /* 203177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203185 */     // MIs[0] imm4
     /* 203185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203193 */     // (intrinsic_wo_chain:{ *:[i64] } 1812:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 203196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203200 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203202 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203204 */     GIR_RootConstrainSelectedInstOperands,
     /* 203205 */     // GIR_Coverage, 10010,
     /* 203205 */     GIR_EraseRootFromParent_Done,
     /* 203206 */   // Label 4050: @203206
     /* 203206 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203262), // Rule ID 10011 //
     /* 203211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 203219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203233 */     // MIs[0] pattern
     /* 203233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203241 */     // MIs[0] imm4
     /* 203241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203249 */     // (intrinsic_wo_chain:{ *:[i64] } 2023:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 203252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203256 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203258 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203260 */     GIR_RootConstrainSelectedInstOperands,
     /* 203261 */     // GIR_Coverage, 10011,
     /* 203261 */     GIR_EraseRootFromParent_Done,
     /* 203262 */   // Label 4051: @203262
     /* 203262 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203318), // Rule ID 10012 //
     /* 203267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 203275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203289 */     // MIs[0] pattern
     /* 203289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203297 */     // MIs[0] imm4
     /* 203297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203305 */     // (intrinsic_wo_chain:{ *:[i64] } 1778:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 203308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203312 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203314 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203316 */     GIR_RootConstrainSelectedInstOperands,
     /* 203317 */     // GIR_Coverage, 10012,
     /* 203317 */     GIR_EraseRootFromParent_Done,
     /* 203318 */   // Label 4052: @203318
     /* 203318 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203374), // Rule ID 10013 //
     /* 203323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 203331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203345 */     // MIs[0] pattern
     /* 203345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203353 */     // MIs[0] imm4
     /* 203353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203361 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 203364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203368 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203370 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203372 */     GIR_RootConstrainSelectedInstOperands,
     /* 203373 */     // GIR_Coverage, 10013,
     /* 203373 */     GIR_EraseRootFromParent_Done,
     /* 203374 */   // Label 4053: @203374
     /* 203374 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203430), // Rule ID 10016 //
     /* 203379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 203387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203401 */     // MIs[0] pattern
     /* 203401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203409 */     // MIs[0] imm4
     /* 203409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203417 */     // (intrinsic_wo_chain:{ *:[i32] } 2028:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 203420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203424 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203426 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203428 */     GIR_RootConstrainSelectedInstOperands,
     /* 203429 */     // GIR_Coverage, 10016,
     /* 203429 */     GIR_EraseRootFromParent_Done,
     /* 203430 */   // Label 4054: @203430
     /* 203430 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203486), // Rule ID 10019 //
     /* 203435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 203443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203457 */     // MIs[0] pattern
     /* 203457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203465 */     // MIs[0] imm4
     /* 203465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203473 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 203476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203480 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203482 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203484 */     GIR_RootConstrainSelectedInstOperands,
     /* 203485 */     // GIR_Coverage, 10019,
     /* 203485 */     GIR_EraseRootFromParent_Done,
     /* 203486 */   // Label 4055: @203486
     /* 203486 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203542), // Rule ID 10020 //
     /* 203491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 203499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203513 */     // MIs[0] pattern
     /* 203513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203521 */     // MIs[0] imm4
     /* 203521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203529 */     // (intrinsic_wo_chain:{ *:[i64] } 1818:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 203532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203536 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203538 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203540 */     GIR_RootConstrainSelectedInstOperands,
     /* 203541 */     // GIR_Coverage, 10020,
     /* 203541 */     GIR_EraseRootFromParent_Done,
     /* 203542 */   // Label 4056: @203542
     /* 203542 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203598), // Rule ID 10021 //
     /* 203547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 203555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203569 */     // MIs[0] pattern
     /* 203569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203577 */     // MIs[0] imm4
     /* 203577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203585 */     // (intrinsic_wo_chain:{ *:[i64] } 2029:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 203588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203592 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203594 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203596 */     GIR_RootConstrainSelectedInstOperands,
     /* 203597 */     // GIR_Coverage, 10021,
     /* 203597 */     GIR_EraseRootFromParent_Done,
     /* 203598 */   // Label 4057: @203598
     /* 203598 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203654), // Rule ID 10022 //
     /* 203603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 203611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203625 */     // MIs[0] pattern
     /* 203625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203633 */     // MIs[0] imm4
     /* 203633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203641 */     // (intrinsic_wo_chain:{ *:[i64] } 1784:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 203644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203648 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203650 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203652 */     GIR_RootConstrainSelectedInstOperands,
     /* 203653 */     // GIR_Coverage, 10022,
     /* 203653 */     GIR_EraseRootFromParent_Done,
     /* 203654 */   // Label 4058: @203654
     /* 203654 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203710), // Rule ID 10023 //
     /* 203659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 203667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203681 */     // MIs[0] pattern
     /* 203681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203689 */     // MIs[0] imm4
     /* 203689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203697 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 203700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203704 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203706 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203708 */     GIR_RootConstrainSelectedInstOperands,
     /* 203709 */     // GIR_Coverage, 10023,
     /* 203709 */     GIR_EraseRootFromParent_Done,
     /* 203710 */   // Label 4059: @203710
     /* 203710 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203766), // Rule ID 10026 //
     /* 203715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 203723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203737 */     // MIs[0] pattern
     /* 203737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203745 */     // MIs[0] imm4
     /* 203745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203753 */     // (intrinsic_wo_chain:{ *:[i32] } 2019:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 203756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203760 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203762 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203764 */     GIR_RootConstrainSelectedInstOperands,
     /* 203765 */     // GIR_Coverage, 10026,
     /* 203765 */     GIR_EraseRootFromParent_Done,
     /* 203766 */   // Label 4060: @203766
     /* 203766 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203822), // Rule ID 10029 //
     /* 203771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 203779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203793 */     // MIs[0] pattern
     /* 203793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203801 */     // MIs[0] imm4
     /* 203801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203809 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 203812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203816 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203818 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203820 */     GIR_RootConstrainSelectedInstOperands,
     /* 203821 */     // GIR_Coverage, 10029,
     /* 203821 */     GIR_EraseRootFromParent_Done,
     /* 203822 */   // Label 4061: @203822
     /* 203822 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203878), // Rule ID 10030 //
     /* 203827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 203835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203849 */     // MIs[0] pattern
     /* 203849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203857 */     // MIs[0] imm4
     /* 203857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203865 */     // (intrinsic_wo_chain:{ *:[i64] } 1809:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 203868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203872 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203874 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203876 */     GIR_RootConstrainSelectedInstOperands,
     /* 203877 */     // GIR_Coverage, 10030,
     /* 203877 */     GIR_EraseRootFromParent_Done,
     /* 203878 */   // Label 4062: @203878
     /* 203878 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203934), // Rule ID 10031 //
     /* 203883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 203891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203905 */     // MIs[0] pattern
     /* 203905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203913 */     // MIs[0] imm4
     /* 203913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203921 */     // (intrinsic_wo_chain:{ *:[i64] } 2020:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 203924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203928 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203930 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203932 */     GIR_RootConstrainSelectedInstOperands,
     /* 203933 */     // GIR_Coverage, 10031,
     /* 203933 */     GIR_EraseRootFromParent_Done,
     /* 203934 */   // Label 4063: @203934
     /* 203934 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203990), // Rule ID 10032 //
     /* 203939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 203947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203961 */     // MIs[0] pattern
     /* 203961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203969 */     // MIs[0] imm4
     /* 203969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203977 */     // (intrinsic_wo_chain:{ *:[i64] } 1775:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 203980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203984 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203986 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203988 */     GIR_RootConstrainSelectedInstOperands,
     /* 203989 */     // GIR_Coverage, 10032,
     /* 203989 */     GIR_EraseRootFromParent_Done,
     /* 203990 */   // Label 4064: @203990
     /* 203990 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(204046), // Rule ID 10033 //
     /* 203995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 204003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204017 */     // MIs[0] pattern
     /* 204017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204025 */     // MIs[0] imm4
     /* 204025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204033 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 204036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 204038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 204040 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204042 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204044 */     GIR_RootConstrainSelectedInstOperands,
     /* 204045 */     // GIR_Coverage, 10033,
     /* 204045 */     GIR_EraseRootFromParent_Done,
     /* 204046 */   // Label 4065: @204046
     /* 204046 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(204102), // Rule ID 10034 //
     /* 204051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 204059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204073 */     // MIs[0] pattern
     /* 204073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204081 */     // MIs[0] imm4
     /* 204081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 204092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204096 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204098 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204100 */     GIR_RootConstrainSelectedInstOperands,
     /* 204101 */     // GIR_Coverage, 10034,
     /* 204101 */     GIR_EraseRootFromParent_Done,
     /* 204102 */   // Label 4066: @204102
     /* 204102 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(204158), // Rule ID 10035 //
     /* 204107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 204115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204129 */     // MIs[0] pattern
     /* 204129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204137 */     // MIs[0] imm4
     /* 204137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204145 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 204148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204152 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204154 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204156 */     GIR_RootConstrainSelectedInstOperands,
     /* 204157 */     // GIR_Coverage, 10035,
     /* 204157 */     GIR_EraseRootFromParent_Done,
     /* 204158 */   // Label 4067: @204158
     /* 204158 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204214), // Rule ID 10036 //
     /* 204163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 204171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204185 */     // MIs[0] pattern
     /* 204185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204193 */     // MIs[0] imm4
     /* 204193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204201 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 204204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204208 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204210 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204212 */     GIR_RootConstrainSelectedInstOperands,
     /* 204213 */     // GIR_Coverage, 10036,
     /* 204213 */     GIR_EraseRootFromParent_Done,
     /* 204214 */   // Label 4068: @204214
     /* 204214 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(204270), // Rule ID 10037 //
     /* 204219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 204227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204241 */     // MIs[0] pattern
     /* 204241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204249 */     // MIs[0] imm4
     /* 204249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 204260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204264 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204266 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204268 */     GIR_RootConstrainSelectedInstOperands,
     /* 204269 */     // GIR_Coverage, 10037,
     /* 204269 */     GIR_EraseRootFromParent_Done,
     /* 204270 */   // Label 4069: @204270
     /* 204270 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(204326), // Rule ID 10038 //
     /* 204275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 204283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204297 */     // MIs[0] pattern
     /* 204297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204305 */     // MIs[0] imm4
     /* 204305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 204316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204320 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204322 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204324 */     GIR_RootConstrainSelectedInstOperands,
     /* 204325 */     // GIR_Coverage, 10038,
     /* 204325 */     GIR_EraseRootFromParent_Done,
     /* 204326 */   // Label 4070: @204326
     /* 204326 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(204382), // Rule ID 10039 //
     /* 204331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 204339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204353 */     // MIs[0] pattern
     /* 204353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204361 */     // MIs[0] imm4
     /* 204361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 204372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204376 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204378 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204380 */     GIR_RootConstrainSelectedInstOperands,
     /* 204381 */     // GIR_Coverage, 10039,
     /* 204381 */     GIR_EraseRootFromParent_Done,
     /* 204382 */   // Label 4071: @204382
     /* 204382 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(204438), // Rule ID 10040 //
     /* 204387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 204395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204409 */     // MIs[0] pattern
     /* 204409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204417 */     // MIs[0] imm4
     /* 204417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 204428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204432 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204434 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204436 */     GIR_RootConstrainSelectedInstOperands,
     /* 204437 */     // GIR_Coverage, 10040,
     /* 204437 */     GIR_EraseRootFromParent_Done,
     /* 204438 */   // Label 4072: @204438
     /* 204438 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(204494), // Rule ID 10041 //
     /* 204443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 204451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204465 */     // MIs[0] pattern
     /* 204465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204473 */     // MIs[0] imm4
     /* 204473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 204484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204488 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204490 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204492 */     GIR_RootConstrainSelectedInstOperands,
     /* 204493 */     // GIR_Coverage, 10041,
     /* 204493 */     GIR_EraseRootFromParent_Done,
     /* 204494 */   // Label 4073: @204494
     /* 204494 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204550), // Rule ID 10042 //
     /* 204499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 204507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204521 */     // MIs[0] pattern
     /* 204521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204529 */     // MIs[0] imm4
     /* 204529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2018:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 204540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204544 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204546 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204548 */     GIR_RootConstrainSelectedInstOperands,
     /* 204549 */     // GIR_Coverage, 10042,
     /* 204549 */     GIR_EraseRootFromParent_Done,
     /* 204550 */   // Label 4074: @204550
     /* 204550 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204606), // Rule ID 10043 //
     /* 204555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 204563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204577 */     // MIs[0] pattern
     /* 204577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204585 */     // MIs[0] imm4
     /* 204585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 204596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204600 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204602 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204604 */     GIR_RootConstrainSelectedInstOperands,
     /* 204605 */     // GIR_Coverage, 10043,
     /* 204605 */     GIR_EraseRootFromParent_Done,
     /* 204606 */   // Label 4075: @204606
     /* 204606 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204662), // Rule ID 10044 //
     /* 204611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 204619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204633 */     // MIs[0] pattern
     /* 204633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204641 */     // MIs[0] imm4
     /* 204641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 204652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204656 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204658 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204660 */     GIR_RootConstrainSelectedInstOperands,
     /* 204661 */     // GIR_Coverage, 10044,
     /* 204661 */     GIR_EraseRootFromParent_Done,
     /* 204662 */   // Label 4076: @204662
     /* 204662 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204752), // Rule ID 47 //
     /* 204667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 204675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 204684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 204687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204732 */     // MIs[2] Operand 1
     /* 204732 */     // No operand predicates
     /* 204732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204734 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 204737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204750 */     GIR_RootConstrainSelectedInstOperands,
     /* 204751 */     // GIR_Coverage, 47,
     /* 204751 */     GIR_EraseRootFromParent_Done,
     /* 204752 */   // Label 4077: @204752
     /* 204752 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204842), // Rule ID 48 //
     /* 204757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 204765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 204774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 204777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204822 */     // MIs[2] Operand 1
     /* 204822 */     // No operand predicates
     /* 204822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204824 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 204827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204840 */     GIR_RootConstrainSelectedInstOperands,
     /* 204841 */     // GIR_Coverage, 48,
     /* 204841 */     GIR_EraseRootFromParent_Done,
     /* 204842 */   // Label 4078: @204842
     /* 204842 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204932), // Rule ID 49 //
     /* 204847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 204855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 204864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 204867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204912 */     // MIs[2] Operand 1
     /* 204912 */     // No operand predicates
     /* 204912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204914 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 204917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204930 */     GIR_RootConstrainSelectedInstOperands,
     /* 204931 */     // GIR_Coverage, 49,
     /* 204931 */     GIR_EraseRootFromParent_Done,
     /* 204932 */   // Label 4079: @204932
     /* 204932 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(205022), // Rule ID 50 //
     /* 204937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 204945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 204954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 204957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204998 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205002 */     // MIs[2] Operand 1
     /* 205002 */     // No operand predicates
     /* 205002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205004 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 205007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205020 */     GIR_RootConstrainSelectedInstOperands,
     /* 205021 */     // GIR_Coverage, 50,
     /* 205021 */     GIR_EraseRootFromParent_Done,
     /* 205022 */   // Label 4080: @205022
     /* 205022 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(205112), // Rule ID 51 //
     /* 205027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 205035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205092 */     // MIs[2] Operand 1
     /* 205092 */     // No operand predicates
     /* 205092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205094 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 205097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205110 */     GIR_RootConstrainSelectedInstOperands,
     /* 205111 */     // GIR_Coverage, 51,
     /* 205111 */     GIR_EraseRootFromParent_Done,
     /* 205112 */   // Label 4081: @205112
     /* 205112 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(205202), // Rule ID 52 //
     /* 205117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 205125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205178 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205182 */     // MIs[2] Operand 1
     /* 205182 */     // No operand predicates
     /* 205182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 205187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205200 */     GIR_RootConstrainSelectedInstOperands,
     /* 205201 */     // GIR_Coverage, 52,
     /* 205201 */     GIR_EraseRootFromParent_Done,
     /* 205202 */   // Label 4082: @205202
     /* 205202 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(205292), // Rule ID 53 //
     /* 205207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 205215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205272 */     // MIs[2] Operand 1
     /* 205272 */     // No operand predicates
     /* 205272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205274 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 205277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205290 */     GIR_RootConstrainSelectedInstOperands,
     /* 205291 */     // GIR_Coverage, 53,
     /* 205291 */     GIR_EraseRootFromParent_Done,
     /* 205292 */   // Label 4083: @205292
     /* 205292 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(205382), // Rule ID 54 //
     /* 205297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 205305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205362 */     // MIs[2] Operand 1
     /* 205362 */     // No operand predicates
     /* 205362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205364 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 205367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205380 */     GIR_RootConstrainSelectedInstOperands,
     /* 205381 */     // GIR_Coverage, 54,
     /* 205381 */     GIR_EraseRootFromParent_Done,
     /* 205382 */   // Label 4084: @205382
     /* 205382 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(205472), // Rule ID 2070 //
     /* 205387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 205398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 205401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205452 */     // MIs[2] Operand 1
     /* 205452 */     // No operand predicates
     /* 205452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205454 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 205457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205470 */     GIR_RootConstrainSelectedInstOperands,
     /* 205471 */     // GIR_Coverage, 2070,
     /* 205471 */     GIR_EraseRootFromParent_Done,
     /* 205472 */   // Label 4085: @205472
     /* 205472 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(205562), // Rule ID 2071 //
     /* 205477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 205488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 205491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205542 */     // MIs[2] Operand 1
     /* 205542 */     // No operand predicates
     /* 205542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205544 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 205547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205560 */     GIR_RootConstrainSelectedInstOperands,
     /* 205561 */     // GIR_Coverage, 2071,
     /* 205561 */     GIR_EraseRootFromParent_Done,
     /* 205562 */   // Label 4086: @205562
     /* 205562 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(205652), // Rule ID 2077 //
     /* 205567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 205578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 205581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205632 */     // MIs[2] Operand 1
     /* 205632 */     // No operand predicates
     /* 205632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205634 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 205637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205650 */     GIR_RootConstrainSelectedInstOperands,
     /* 205651 */     // GIR_Coverage, 2077,
     /* 205651 */     GIR_EraseRootFromParent_Done,
     /* 205652 */   // Label 4087: @205652
     /* 205652 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(205742), // Rule ID 2078 //
     /* 205657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 205668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 205671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205722 */     // MIs[2] Operand 1
     /* 205722 */     // No operand predicates
     /* 205722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 205727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205740 */     GIR_RootConstrainSelectedInstOperands,
     /* 205741 */     // GIR_Coverage, 2078,
     /* 205741 */     GIR_EraseRootFromParent_Done,
     /* 205742 */   // Label 4088: @205742
     /* 205742 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(205832), // Rule ID 2073 //
     /* 205747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 205764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 205767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205812 */     // MIs[2] Operand 1
     /* 205812 */     // No operand predicates
     /* 205812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205814 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 205817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205830 */     GIR_RootConstrainSelectedInstOperands,
     /* 205831 */     // GIR_Coverage, 2073,
     /* 205831 */     GIR_EraseRootFromParent_Done,
     /* 205832 */   // Label 4089: @205832
     /* 205832 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(205922), // Rule ID 2074 //
     /* 205837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 205854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 205857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205902 */     // MIs[2] Operand 1
     /* 205902 */     // No operand predicates
     /* 205902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 205907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205920 */     GIR_RootConstrainSelectedInstOperands,
     /* 205921 */     // GIR_Coverage, 2074,
     /* 205921 */     GIR_EraseRootFromParent_Done,
     /* 205922 */   // Label 4090: @205922
     /* 205922 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(206012), // Rule ID 2080 //
     /* 205927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 205944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 205947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205992 */     // MIs[2] Operand 1
     /* 205992 */     // No operand predicates
     /* 205992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205994 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 205997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206010 */     GIR_RootConstrainSelectedInstOperands,
     /* 206011 */     // GIR_Coverage, 2080,
     /* 206011 */     GIR_EraseRootFromParent_Done,
     /* 206012 */   // Label 4091: @206012
     /* 206012 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(206102), // Rule ID 2081 //
     /* 206017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 206025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 206031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 206034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 206037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 206057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206078 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206082 */     // MIs[2] Operand 1
     /* 206082 */     // No operand predicates
     /* 206082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 206087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206100 */     GIR_RootConstrainSelectedInstOperands,
     /* 206101 */     // GIR_Coverage, 2081,
     /* 206101 */     GIR_EraseRootFromParent_Done,
     /* 206102 */   // Label 4092: @206102
     /* 206102 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(206192), // Rule ID 2075 //
     /* 206107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 206115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 206118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 206127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 206147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206172 */     // MIs[2] Operand 1
     /* 206172 */     // No operand predicates
     /* 206172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206174 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 206177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206190 */     GIR_RootConstrainSelectedInstOperands,
     /* 206191 */     // GIR_Coverage, 2075,
     /* 206191 */     GIR_EraseRootFromParent_Done,
     /* 206192 */   // Label 4093: @206192
     /* 206192 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(206282), // Rule ID 2082 //
     /* 206197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 206205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 206208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 206217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 206237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206262 */     // MIs[2] Operand 1
     /* 206262 */     // No operand predicates
     /* 206262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206264 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 206267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 206281 */     // GIR_Coverage, 2082,
     /* 206281 */     GIR_EraseRootFromParent_Done,
     /* 206282 */   // Label 4094: @206282
     /* 206282 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(206359), // Rule ID 2781 //
     /* 206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206339 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206343 */     // MIs[2] Operand 1
     /* 206343 */     // No operand predicates
     /* 206343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206345 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 206348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206357 */     GIR_RootConstrainSelectedInstOperands,
     /* 206358 */     // GIR_Coverage, 2781,
     /* 206358 */     GIR_EraseRootFromParent_Done,
     /* 206359 */   // Label 4095: @206359
     /* 206359 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(206436), // Rule ID 2782 //
     /* 206364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206416 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206420 */     // MIs[2] Operand 1
     /* 206420 */     // No operand predicates
     /* 206420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206422 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 206425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206434 */     GIR_RootConstrainSelectedInstOperands,
     /* 206435 */     // GIR_Coverage, 2782,
     /* 206435 */     GIR_EraseRootFromParent_Done,
     /* 206436 */   // Label 4096: @206436
     /* 206436 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(206513), // Rule ID 2783 //
     /* 206441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206493 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206497 */     // MIs[2] Operand 1
     /* 206497 */     // No operand predicates
     /* 206497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 206502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206511 */     GIR_RootConstrainSelectedInstOperands,
     /* 206512 */     // GIR_Coverage, 2783,
     /* 206512 */     GIR_EraseRootFromParent_Done,
     /* 206513 */   // Label 4097: @206513
     /* 206513 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(206590), // Rule ID 2784 //
     /* 206518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206570 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206574 */     // MIs[2] Operand 1
     /* 206574 */     // No operand predicates
     /* 206574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 206579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206588 */     GIR_RootConstrainSelectedInstOperands,
     /* 206589 */     // GIR_Coverage, 2784,
     /* 206589 */     GIR_EraseRootFromParent_Done,
     /* 206590 */   // Label 4098: @206590
     /* 206590 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(206667), // Rule ID 2785 //
     /* 206595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206647 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206651 */     // MIs[2] Operand 1
     /* 206651 */     // No operand predicates
     /* 206651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206653 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 206656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206665 */     GIR_RootConstrainSelectedInstOperands,
     /* 206666 */     // GIR_Coverage, 2785,
     /* 206666 */     GIR_EraseRootFromParent_Done,
     /* 206667 */   // Label 4099: @206667
     /* 206667 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(206744), // Rule ID 2786 //
     /* 206672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206724 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206728 */     // MIs[2] Operand 1
     /* 206728 */     // No operand predicates
     /* 206728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206730 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 206733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206742 */     GIR_RootConstrainSelectedInstOperands,
     /* 206743 */     // GIR_Coverage, 2786,
     /* 206743 */     GIR_EraseRootFromParent_Done,
     /* 206744 */   // Label 4100: @206744
     /* 206744 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(206821), // Rule ID 7887 //
     /* 206749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206801 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206805 */     // MIs[2] Operand 1
     /* 206805 */     // No operand predicates
     /* 206805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206807 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 206810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206819 */     GIR_RootConstrainSelectedInstOperands,
     /* 206820 */     // GIR_Coverage, 7887,
     /* 206820 */     GIR_EraseRootFromParent_Done,
     /* 206821 */   // Label 4101: @206821
     /* 206821 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(206898), // Rule ID 7888 //
     /* 206826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206878 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206882 */     // MIs[2] Operand 1
     /* 206882 */     // No operand predicates
     /* 206882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206884 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 206887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206896 */     GIR_RootConstrainSelectedInstOperands,
     /* 206897 */     // GIR_Coverage, 7888,
     /* 206897 */     GIR_EraseRootFromParent_Done,
     /* 206898 */   // Label 4102: @206898
     /* 206898 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206975), // Rule ID 7889 //
     /* 206903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206955 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206959 */     // MIs[2] Operand 1
     /* 206959 */     // No operand predicates
     /* 206959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206961 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 206964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206973 */     GIR_RootConstrainSelectedInstOperands,
     /* 206974 */     // GIR_Coverage, 7889,
     /* 206974 */     GIR_EraseRootFromParent_Done,
     /* 206975 */   // Label 4103: @206975
     /* 206975 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207052), // Rule ID 7890 //
     /* 206980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207032 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207036 */     // MIs[2] Operand 1
     /* 207036 */     // No operand predicates
     /* 207036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207038 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 207041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207050 */     GIR_RootConstrainSelectedInstOperands,
     /* 207051 */     // GIR_Coverage, 7890,
     /* 207051 */     GIR_EraseRootFromParent_Done,
     /* 207052 */   // Label 4104: @207052
     /* 207052 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207129), // Rule ID 7891 //
     /* 207057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 207065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207109 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207113 */     // MIs[2] Operand 1
     /* 207113 */     // No operand predicates
     /* 207113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207115 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 207118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207127 */     GIR_RootConstrainSelectedInstOperands,
     /* 207128 */     // GIR_Coverage, 7891,
     /* 207128 */     GIR_EraseRootFromParent_Done,
     /* 207129 */   // Label 4105: @207129
     /* 207129 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207206), // Rule ID 7892 //
     /* 207134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 207142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207186 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207190 */     // MIs[2] Operand 1
     /* 207190 */     // No operand predicates
     /* 207190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207192 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 207195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207204 */     GIR_RootConstrainSelectedInstOperands,
     /* 207205 */     // GIR_Coverage, 7892,
     /* 207205 */     GIR_EraseRootFromParent_Done,
     /* 207206 */   // Label 4106: @207206
     /* 207206 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207283), // Rule ID 7893 //
     /* 207211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207263 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207267 */     // MIs[2] Operand 1
     /* 207267 */     // No operand predicates
     /* 207267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207269 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 207272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207281 */     GIR_RootConstrainSelectedInstOperands,
     /* 207282 */     // GIR_Coverage, 7893,
     /* 207282 */     GIR_EraseRootFromParent_Done,
     /* 207283 */   // Label 4107: @207283
     /* 207283 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207360), // Rule ID 7894 //
     /* 207288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207340 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207344 */     // MIs[2] Operand 1
     /* 207344 */     // No operand predicates
     /* 207344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207346 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 207349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207358 */     GIR_RootConstrainSelectedInstOperands,
     /* 207359 */     // GIR_Coverage, 7894,
     /* 207359 */     GIR_EraseRootFromParent_Done,
     /* 207360 */   // Label 4108: @207360
     /* 207360 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(207437), // Rule ID 7895 //
     /* 207365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207417 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207421 */     // MIs[2] Operand 1
     /* 207421 */     // No operand predicates
     /* 207421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207423 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 207426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207435 */     GIR_RootConstrainSelectedInstOperands,
     /* 207436 */     // GIR_Coverage, 7895,
     /* 207436 */     GIR_EraseRootFromParent_Done,
     /* 207437 */   // Label 4109: @207437
     /* 207437 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(207514), // Rule ID 7896 //
     /* 207442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207494 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207498 */     // MIs[2] Operand 1
     /* 207498 */     // No operand predicates
     /* 207498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 207503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207512 */     GIR_RootConstrainSelectedInstOperands,
     /* 207513 */     // GIR_Coverage, 7896,
     /* 207513 */     GIR_EraseRootFromParent_Done,
     /* 207514 */   // Label 4110: @207514
     /* 207514 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(207591), // Rule ID 7897 //
     /* 207519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207571 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207575 */     // MIs[2] Operand 1
     /* 207575 */     // No operand predicates
     /* 207575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 207580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207589 */     GIR_RootConstrainSelectedInstOperands,
     /* 207590 */     // GIR_Coverage, 7897,
     /* 207590 */     GIR_EraseRootFromParent_Done,
     /* 207591 */   // Label 4111: @207591
     /* 207591 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(207668), // Rule ID 7898 //
     /* 207596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207648 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207652 */     // MIs[2] Operand 1
     /* 207652 */     // No operand predicates
     /* 207652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 207657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207666 */     GIR_RootConstrainSelectedInstOperands,
     /* 207667 */     // GIR_Coverage, 7898,
     /* 207667 */     GIR_EraseRootFromParent_Done,
     /* 207668 */   // Label 4112: @207668
     /* 207668 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(207745), // Rule ID 7899 //
     /* 207673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207725 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207729 */     // MIs[2] Operand 1
     /* 207729 */     // No operand predicates
     /* 207729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 207734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207743 */     GIR_RootConstrainSelectedInstOperands,
     /* 207744 */     // GIR_Coverage, 7899,
     /* 207744 */     GIR_EraseRootFromParent_Done,
     /* 207745 */   // Label 4113: @207745
     /* 207745 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(207822), // Rule ID 7900 //
     /* 207750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207802 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207806 */     // MIs[2] Operand 1
     /* 207806 */     // No operand predicates
     /* 207806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207808 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 207811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207820 */     GIR_RootConstrainSelectedInstOperands,
     /* 207821 */     // GIR_Coverage, 7900,
     /* 207821 */     GIR_EraseRootFromParent_Done,
     /* 207822 */   // Label 4114: @207822
     /* 207822 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(207899), // Rule ID 7901 //
     /* 207827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207879 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207883 */     // MIs[2] Operand 1
     /* 207883 */     // No operand predicates
     /* 207883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207885 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 207888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207897 */     GIR_RootConstrainSelectedInstOperands,
     /* 207898 */     // GIR_Coverage, 7901,
     /* 207898 */     GIR_EraseRootFromParent_Done,
     /* 207899 */   // Label 4115: @207899
     /* 207899 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(207976), // Rule ID 7902 //
     /* 207904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207956 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207960 */     // MIs[2] Operand 1
     /* 207960 */     // No operand predicates
     /* 207960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 207965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207974 */     GIR_RootConstrainSelectedInstOperands,
     /* 207975 */     // GIR_Coverage, 7902,
     /* 207975 */     GIR_EraseRootFromParent_Done,
     /* 207976 */   // Label 4116: @207976
     /* 207976 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208053), // Rule ID 7903 //
     /* 207981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208033 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 208037 */     // MIs[2] Operand 1
     /* 208037 */     // No operand predicates
     /* 208037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208039 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 208042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208051 */     GIR_RootConstrainSelectedInstOperands,
     /* 208052 */     // GIR_Coverage, 7903,
     /* 208052 */     GIR_EraseRootFromParent_Done,
     /* 208053 */   // Label 4117: @208053
     /* 208053 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208130), // Rule ID 7904 //
     /* 208058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 208066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208110 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208114 */     // MIs[2] Operand 1
     /* 208114 */     // No operand predicates
     /* 208114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 208119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208128 */     GIR_RootConstrainSelectedInstOperands,
     /* 208129 */     // GIR_Coverage, 7904,
     /* 208129 */     GIR_EraseRootFromParent_Done,
     /* 208130 */   // Label 4118: @208130
     /* 208130 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208207), // Rule ID 7905 //
     /* 208135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208187 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208191 */     // MIs[2] Operand 1
     /* 208191 */     // No operand predicates
     /* 208191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208193 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 208193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 208196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208205 */     GIR_RootConstrainSelectedInstOperands,
     /* 208206 */     // GIR_Coverage, 7905,
     /* 208206 */     GIR_EraseRootFromParent_Done,
     /* 208207 */   // Label 4119: @208207
     /* 208207 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208284), // Rule ID 7906 //
     /* 208212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208264 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208268 */     // MIs[2] Operand 1
     /* 208268 */     // No operand predicates
     /* 208268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 208270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 208273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208282 */     GIR_RootConstrainSelectedInstOperands,
     /* 208283 */     // GIR_Coverage, 7906,
     /* 208283 */     GIR_EraseRootFromParent_Done,
     /* 208284 */   // Label 4120: @208284
     /* 208284 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208361), // Rule ID 7907 //
     /* 208289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208341 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208345 */     // MIs[2] Operand 1
     /* 208345 */     // No operand predicates
     /* 208345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208347 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 208347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 208350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208359 */     GIR_RootConstrainSelectedInstOperands,
     /* 208360 */     // GIR_Coverage, 7907,
     /* 208360 */     GIR_EraseRootFromParent_Done,
     /* 208361 */   // Label 4121: @208361
     /* 208361 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(208438), // Rule ID 7908 //
     /* 208366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208418 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208422 */     // MIs[2] Operand 1
     /* 208422 */     // No operand predicates
     /* 208422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 208424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 208427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208436 */     GIR_RootConstrainSelectedInstOperands,
     /* 208437 */     // GIR_Coverage, 7908,
     /* 208437 */     GIR_EraseRootFromParent_Done,
     /* 208438 */   // Label 4122: @208438
     /* 208438 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(208515), // Rule ID 7909 //
     /* 208443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208495 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208499 */     // MIs[2] Operand 1
     /* 208499 */     // No operand predicates
     /* 208499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208501 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208513 */     GIR_RootConstrainSelectedInstOperands,
     /* 208514 */     // GIR_Coverage, 7909,
     /* 208514 */     GIR_EraseRootFromParent_Done,
     /* 208515 */   // Label 4123: @208515
     /* 208515 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(208592), // Rule ID 7910 //
     /* 208520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208572 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208576 */     // MIs[2] Operand 1
     /* 208576 */     // No operand predicates
     /* 208576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208578 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 208581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208590 */     GIR_RootConstrainSelectedInstOperands,
     /* 208591 */     // GIR_Coverage, 7910,
     /* 208591 */     GIR_EraseRootFromParent_Done,
     /* 208592 */   // Label 4124: @208592
     /* 208592 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(208669), // Rule ID 7911 //
     /* 208597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208649 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208653 */     // MIs[2] Operand 1
     /* 208653 */     // No operand predicates
     /* 208653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 208655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 208658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208667 */     GIR_RootConstrainSelectedInstOperands,
     /* 208668 */     // GIR_Coverage, 7911,
     /* 208668 */     GIR_EraseRootFromParent_Done,
     /* 208669 */   // Label 4125: @208669
     /* 208669 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208746), // Rule ID 7912 //
     /* 208674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208726 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208730 */     // MIs[2] Operand 1
     /* 208730 */     // No operand predicates
     /* 208730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 208732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 208735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208744 */     GIR_RootConstrainSelectedInstOperands,
     /* 208745 */     // GIR_Coverage, 7912,
     /* 208745 */     GIR_EraseRootFromParent_Done,
     /* 208746 */   // Label 4126: @208746
     /* 208746 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208823), // Rule ID 7913 //
     /* 208751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208803 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208807 */     // MIs[2] Operand 1
     /* 208807 */     // No operand predicates
     /* 208807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208809 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 208809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 208812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208821 */     GIR_RootConstrainSelectedInstOperands,
     /* 208822 */     // GIR_Coverage, 7913,
     /* 208822 */     GIR_EraseRootFromParent_Done,
     /* 208823 */   // Label 4127: @208823
     /* 208823 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208900), // Rule ID 7914 //
     /* 208828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208880 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208884 */     // MIs[2] Operand 1
     /* 208884 */     // No operand predicates
     /* 208884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208886 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 208886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 208889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208898 */     GIR_RootConstrainSelectedInstOperands,
     /* 208899 */     // GIR_Coverage, 7914,
     /* 208899 */     GIR_EraseRootFromParent_Done,
     /* 208900 */   // Label 4128: @208900
     /* 208900 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208977), // Rule ID 7915 //
     /* 208905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208957 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208961 */     // MIs[2] Operand 1
     /* 208961 */     // No operand predicates
     /* 208961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208963 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 208966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208975 */     GIR_RootConstrainSelectedInstOperands,
     /* 208976 */     // GIR_Coverage, 7915,
     /* 208976 */     GIR_EraseRootFromParent_Done,
     /* 208977 */   // Label 4129: @208977
     /* 208977 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209054), // Rule ID 7916 //
     /* 208982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209034 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209038 */     // MIs[2] Operand 1
     /* 209038 */     // No operand predicates
     /* 209038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 209043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209052 */     GIR_RootConstrainSelectedInstOperands,
     /* 209053 */     // GIR_Coverage, 7916,
     /* 209053 */     GIR_EraseRootFromParent_Done,
     /* 209054 */   // Label 4130: @209054
     /* 209054 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209131), // Rule ID 7917 //
     /* 209059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209111 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209115 */     // MIs[2] Operand 1
     /* 209115 */     // No operand predicates
     /* 209115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 209117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 209120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209129 */     GIR_RootConstrainSelectedInstOperands,
     /* 209130 */     // GIR_Coverage, 7917,
     /* 209130 */     GIR_EraseRootFromParent_Done,
     /* 209131 */   // Label 4131: @209131
     /* 209131 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209208), // Rule ID 7918 //
     /* 209136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209188 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209192 */     // MIs[2] Operand 1
     /* 209192 */     // No operand predicates
     /* 209192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 209194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 209197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209206 */     GIR_RootConstrainSelectedInstOperands,
     /* 209207 */     // GIR_Coverage, 7918,
     /* 209207 */     GIR_EraseRootFromParent_Done,
     /* 209208 */   // Label 4132: @209208
     /* 209208 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209285), // Rule ID 7919 //
     /* 209213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209265 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209269 */     // MIs[2] Operand 1
     /* 209269 */     // No operand predicates
     /* 209269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209271 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 209271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 209274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209283 */     GIR_RootConstrainSelectedInstOperands,
     /* 209284 */     // GIR_Coverage, 7919,
     /* 209284 */     GIR_EraseRootFromParent_Done,
     /* 209285 */   // Label 4133: @209285
     /* 209285 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209362), // Rule ID 7920 //
     /* 209290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209342 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209346 */     // MIs[2] Operand 1
     /* 209346 */     // No operand predicates
     /* 209346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 209348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 209351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209360 */     GIR_RootConstrainSelectedInstOperands,
     /* 209361 */     // GIR_Coverage, 7920,
     /* 209361 */     GIR_EraseRootFromParent_Done,
     /* 209362 */   // Label 4134: @209362
     /* 209362 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209439), // Rule ID 7921 //
     /* 209367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209419 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209423 */     // MIs[2] Operand 1
     /* 209423 */     // No operand predicates
     /* 209423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 209425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 209428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209437 */     GIR_RootConstrainSelectedInstOperands,
     /* 209438 */     // GIR_Coverage, 7921,
     /* 209438 */     GIR_EraseRootFromParent_Done,
     /* 209439 */   // Label 4135: @209439
     /* 209439 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209516), // Rule ID 7922 //
     /* 209444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209496 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209500 */     // MIs[2] Operand 1
     /* 209500 */     // No operand predicates
     /* 209500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 209505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209514 */     GIR_RootConstrainSelectedInstOperands,
     /* 209515 */     // GIR_Coverage, 7922,
     /* 209515 */     GIR_EraseRootFromParent_Done,
     /* 209516 */   // Label 4136: @209516
     /* 209516 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209593), // Rule ID 7923 //
     /* 209521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209573 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209577 */     // MIs[2] Operand 1
     /* 209577 */     // No operand predicates
     /* 209577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 209579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 209582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209591 */     GIR_RootConstrainSelectedInstOperands,
     /* 209592 */     // GIR_Coverage, 7923,
     /* 209592 */     GIR_EraseRootFromParent_Done,
     /* 209593 */   // Label 4137: @209593
     /* 209593 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209670), // Rule ID 7924 //
     /* 209598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209650 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209654 */     // MIs[2] Operand 1
     /* 209654 */     // No operand predicates
     /* 209654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 209656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 209659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209668 */     GIR_RootConstrainSelectedInstOperands,
     /* 209669 */     // GIR_Coverage, 7924,
     /* 209669 */     GIR_EraseRootFromParent_Done,
     /* 209670 */   // Label 4138: @209670
     /* 209670 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209747), // Rule ID 7925 //
     /* 209675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209727 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209731 */     // MIs[2] Operand 1
     /* 209731 */     // No operand predicates
     /* 209731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 209733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 209736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209745 */     GIR_RootConstrainSelectedInstOperands,
     /* 209746 */     // GIR_Coverage, 7925,
     /* 209746 */     GIR_EraseRootFromParent_Done,
     /* 209747 */   // Label 4139: @209747
     /* 209747 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209824), // Rule ID 7926 //
     /* 209752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209804 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209808 */     // MIs[2] Operand 1
     /* 209808 */     // No operand predicates
     /* 209808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 209810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 209813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209822 */     GIR_RootConstrainSelectedInstOperands,
     /* 209823 */     // GIR_Coverage, 7926,
     /* 209823 */     GIR_EraseRootFromParent_Done,
     /* 209824 */   // Label 4140: @209824
     /* 209824 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209901), // Rule ID 7927 //
     /* 209829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209881 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209885 */     // MIs[2] Operand 1
     /* 209885 */     // No operand predicates
     /* 209885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 209887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 209890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209899 */     GIR_RootConstrainSelectedInstOperands,
     /* 209900 */     // GIR_Coverage, 7927,
     /* 209900 */     GIR_EraseRootFromParent_Done,
     /* 209901 */   // Label 4141: @209901
     /* 209901 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209978), // Rule ID 7928 //
     /* 209906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209958 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209962 */     // MIs[2] Operand 1
     /* 209962 */     // No operand predicates
     /* 209962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 209967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209976 */     GIR_RootConstrainSelectedInstOperands,
     /* 209977 */     // GIR_Coverage, 7928,
     /* 209977 */     GIR_EraseRootFromParent_Done,
     /* 209978 */   // Label 4142: @209978
     /* 209978 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210034), // Rule ID 55 //
     /* 209983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 209986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 209991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 209994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210008 */     // MIs[0] Operand 3
     /* 210008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 210019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210023 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 210026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210032 */     GIR_RootConstrainSelectedInstOperands,
     /* 210033 */     // GIR_Coverage, 55,
     /* 210033 */     GIR_EraseRootFromParent_Done,
     /* 210034 */   // Label 4143: @210034
     /* 210034 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210090), // Rule ID 56 //
     /* 210039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210064 */     // MIs[0] Operand 3
     /* 210064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 210075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210079 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 210082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210088 */     GIR_RootConstrainSelectedInstOperands,
     /* 210089 */     // GIR_Coverage, 56,
     /* 210089 */     GIR_EraseRootFromParent_Done,
     /* 210090 */   // Label 4144: @210090
     /* 210090 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210146), // Rule ID 57 //
     /* 210095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210120 */     // MIs[0] Operand 3
     /* 210120 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 210131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210135 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 210138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210144 */     GIR_RootConstrainSelectedInstOperands,
     /* 210145 */     // GIR_Coverage, 57,
     /* 210145 */     GIR_EraseRootFromParent_Done,
     /* 210146 */   // Label 4145: @210146
     /* 210146 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210202), // Rule ID 58 //
     /* 210151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210176 */     // MIs[0] Operand 3
     /* 210176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 210187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210191 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 210194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210200 */     GIR_RootConstrainSelectedInstOperands,
     /* 210201 */     // GIR_Coverage, 58,
     /* 210201 */     GIR_EraseRootFromParent_Done,
     /* 210202 */   // Label 4146: @210202
     /* 210202 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210257), // Rule ID 2799 //
     /* 210207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210236 */     // MIs[0] imm
     /* 210236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210253 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210255 */     GIR_RootConstrainSelectedInstOperands,
     /* 210256 */     // GIR_Coverage, 2799,
     /* 210256 */     GIR_EraseRootFromParent_Done,
     /* 210257 */   // Label 4147: @210257
     /* 210257 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210312), // Rule ID 2800 //
     /* 210262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210291 */     // MIs[0] imm
     /* 210291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 210302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210308 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210310 */     GIR_RootConstrainSelectedInstOperands,
     /* 210311 */     // GIR_Coverage, 2800,
     /* 210311 */     GIR_EraseRootFromParent_Done,
     /* 210312 */   // Label 4148: @210312
     /* 210312 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210367), // Rule ID 2801 //
     /* 210317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210346 */     // MIs[0] imm
     /* 210346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 210357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210363 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210365 */     GIR_RootConstrainSelectedInstOperands,
     /* 210366 */     // GIR_Coverage, 2801,
     /* 210366 */     GIR_EraseRootFromParent_Done,
     /* 210367 */   // Label 4149: @210367
     /* 210367 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210422), // Rule ID 3552 //
     /* 210372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 210389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210401 */     // MIs[0] Idx
     /* 210401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 210409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 210409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 210412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210420 */     GIR_RootConstrainSelectedInstOperands,
     /* 210421 */     // GIR_Coverage, 3552,
     /* 210421 */     GIR_EraseRootFromParent_Done,
     /* 210422 */   // Label 4150: @210422
     /* 210422 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210477), // Rule ID 3553 //
     /* 210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 210444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210456 */     // MIs[0] Idx
     /* 210456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 210464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 210464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210475 */     GIR_RootConstrainSelectedInstOperands,
     /* 210476 */     // GIR_Coverage, 3553,
     /* 210476 */     GIR_EraseRootFromParent_Done,
     /* 210477 */   // Label 4151: @210477
     /* 210477 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210532), // Rule ID 3554 //
     /* 210482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 210499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210511 */     // MIs[0] Idx
     /* 210511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 210519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 210519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 210522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210530 */     GIR_RootConstrainSelectedInstOperands,
     /* 210531 */     // GIR_Coverage, 3554,
     /* 210531 */     GIR_EraseRootFromParent_Done,
     /* 210532 */   // Label 4152: @210532
     /* 210532 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210587), // Rule ID 3844 //
     /* 210537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 210545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210566 */     // MIs[0] imm
     /* 210566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 210574 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 210574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 210577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 210581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 210583 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210585 */     GIR_RootConstrainSelectedInstOperands,
     /* 210586 */     // GIR_Coverage, 3844,
     /* 210586 */     GIR_EraseRootFromParent_Done,
     /* 210587 */   // Label 4153: @210587
     /* 210587 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210634), // Rule ID 2853 //
     /* 210592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210613 */     // MIs[0] idx
     /* 210613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210621 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 210621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 210624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210630 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210632 */     GIR_RootConstrainSelectedInstOperands,
     /* 210633 */     // GIR_Coverage, 2853,
     /* 210633 */     GIR_EraseRootFromParent_Done,
     /* 210634 */   // Label 4154: @210634
     /* 210634 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210681), // Rule ID 2854 //
     /* 210639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210660 */     // MIs[0] idx
     /* 210660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210668 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 210668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 210671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210677 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210679 */     GIR_RootConstrainSelectedInstOperands,
     /* 210680 */     // GIR_Coverage, 2854,
     /* 210680 */     GIR_EraseRootFromParent_Done,
     /* 210681 */   // Label 4155: @210681
     /* 210681 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210728), // Rule ID 2855 //
     /* 210686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210707 */     // MIs[0] idx
     /* 210707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 210715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 210718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210724 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210726 */     GIR_RootConstrainSelectedInstOperands,
     /* 210727 */     // GIR_Coverage, 2855,
     /* 210727 */     GIR_EraseRootFromParent_Done,
     /* 210728 */   // Label 4156: @210728
     /* 210728 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210775), // Rule ID 3004 //
     /* 210733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210754 */     // MIs[0] Op3
     /* 210754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210773 */     GIR_RootConstrainSelectedInstOperands,
     /* 210774 */     // GIR_Coverage, 3004,
     /* 210774 */     GIR_EraseRootFromParent_Done,
     /* 210775 */   // Label 4157: @210775
     /* 210775 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210822), // Rule ID 3005 //
     /* 210780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210801 */     // MIs[0] Op3
     /* 210801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 210812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210820 */     GIR_RootConstrainSelectedInstOperands,
     /* 210821 */     // GIR_Coverage, 3005,
     /* 210821 */     GIR_EraseRootFromParent_Done,
     /* 210822 */   // Label 4158: @210822
     /* 210822 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210869), // Rule ID 3006 //
     /* 210827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210848 */     // MIs[0] Op3
     /* 210848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 210859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210867 */     GIR_RootConstrainSelectedInstOperands,
     /* 210868 */     // GIR_Coverage, 3006,
     /* 210868 */     GIR_EraseRootFromParent_Done,
     /* 210869 */   // Label 4159: @210869
     /* 210869 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210916), // Rule ID 3007 //
     /* 210874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 210882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210895 */     // MIs[0] Op3
     /* 210895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 210906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210914 */     GIR_RootConstrainSelectedInstOperands,
     /* 210915 */     // GIR_Coverage, 3007,
     /* 210915 */     GIR_EraseRootFromParent_Done,
     /* 210916 */   // Label 4160: @210916
     /* 210916 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210963), // Rule ID 3008 //
     /* 210921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 210929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210942 */     // MIs[0] Op3
     /* 210942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 210953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210961 */     GIR_RootConstrainSelectedInstOperands,
     /* 210962 */     // GIR_Coverage, 3008,
     /* 210962 */     GIR_EraseRootFromParent_Done,
     /* 210963 */   // Label 4161: @210963
     /* 210963 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211010), // Rule ID 3056 //
     /* 210968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 210976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210989 */     // MIs[0] Op3
     /* 210989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 211000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211008 */     GIR_RootConstrainSelectedInstOperands,
     /* 211009 */     // GIR_Coverage, 3056,
     /* 211009 */     GIR_EraseRootFromParent_Done,
     /* 211010 */   // Label 4162: @211010
     /* 211010 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211057), // Rule ID 3058 //
     /* 211015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211036 */     // MIs[0] Op3
     /* 211036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 211047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211055 */     GIR_RootConstrainSelectedInstOperands,
     /* 211056 */     // GIR_Coverage, 3058,
     /* 211056 */     GIR_EraseRootFromParent_Done,
     /* 211057 */   // Label 4163: @211057
     /* 211057 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211104), // Rule ID 3060 //
     /* 211062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211083 */     // MIs[0] Op3
     /* 211083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211102 */     GIR_RootConstrainSelectedInstOperands,
     /* 211103 */     // GIR_Coverage, 3060,
     /* 211103 */     GIR_EraseRootFromParent_Done,
     /* 211104 */   // Label 4164: @211104
     /* 211104 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211151), // Rule ID 3062 //
     /* 211109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211130 */     // MIs[0] Op3
     /* 211130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 211141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211149 */     GIR_RootConstrainSelectedInstOperands,
     /* 211150 */     // GIR_Coverage, 3062,
     /* 211150 */     GIR_EraseRootFromParent_Done,
     /* 211151 */   // Label 4165: @211151
     /* 211151 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211198), // Rule ID 3084 //
     /* 211156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211177 */     // MIs[0] Op3
     /* 211177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 211188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211196 */     GIR_RootConstrainSelectedInstOperands,
     /* 211197 */     // GIR_Coverage, 3084,
     /* 211197 */     GIR_EraseRootFromParent_Done,
     /* 211198 */   // Label 4166: @211198
     /* 211198 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211245), // Rule ID 3085 //
     /* 211203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211224 */     // MIs[0] Op3
     /* 211224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 211235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211243 */     GIR_RootConstrainSelectedInstOperands,
     /* 211244 */     // GIR_Coverage, 3085,
     /* 211244 */     GIR_EraseRootFromParent_Done,
     /* 211245 */   // Label 4167: @211245
     /* 211245 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211292), // Rule ID 3086 //
     /* 211250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211271 */     // MIs[0] Op3
     /* 211271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 211282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211290 */     GIR_RootConstrainSelectedInstOperands,
     /* 211291 */     // GIR_Coverage, 3086,
     /* 211291 */     GIR_EraseRootFromParent_Done,
     /* 211292 */   // Label 4168: @211292
     /* 211292 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211339), // Rule ID 3155 //
     /* 211297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211318 */     // MIs[0] Op3
     /* 211318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 211329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211337 */     GIR_RootConstrainSelectedInstOperands,
     /* 211338 */     // GIR_Coverage, 3155,
     /* 211338 */     GIR_EraseRootFromParent_Done,
     /* 211339 */   // Label 4169: @211339
     /* 211339 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211386), // Rule ID 3156 //
     /* 211344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211365 */     // MIs[0] Op3
     /* 211365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 211376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211384 */     GIR_RootConstrainSelectedInstOperands,
     /* 211385 */     // GIR_Coverage, 3156,
     /* 211385 */     GIR_EraseRootFromParent_Done,
     /* 211386 */   // Label 4170: @211386
     /* 211386 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211433), // Rule ID 3157 //
     /* 211391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211412 */     // MIs[0] Op3
     /* 211412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 211423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211431 */     GIR_RootConstrainSelectedInstOperands,
     /* 211432 */     // GIR_Coverage, 3157,
     /* 211432 */     GIR_EraseRootFromParent_Done,
     /* 211433 */   // Label 4171: @211433
     /* 211433 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211480), // Rule ID 3158 //
     /* 211438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211459 */     // MIs[0] Op3
     /* 211459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 211470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211478 */     GIR_RootConstrainSelectedInstOperands,
     /* 211479 */     // GIR_Coverage, 3158,
     /* 211479 */     GIR_EraseRootFromParent_Done,
     /* 211480 */   // Label 4172: @211480
     /* 211480 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211527), // Rule ID 3537 //
     /* 211485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 211493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211506 */     // MIs[0] Op3
     /* 211506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 211514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1357:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 211514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 211517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211525 */     GIR_RootConstrainSelectedInstOperands,
     /* 211526 */     // GIR_Coverage, 3537,
     /* 211526 */     GIR_EraseRootFromParent_Done,
     /* 211527 */   // Label 4173: @211527
     /* 211527 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211574), // Rule ID 3585 //
     /* 211532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211553 */     // MIs[0] Op3
     /* 211553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211561 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 211564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211572 */     GIR_RootConstrainSelectedInstOperands,
     /* 211573 */     // GIR_Coverage, 3585,
     /* 211573 */     GIR_EraseRootFromParent_Done,
     /* 211574 */   // Label 4174: @211574
     /* 211574 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211621), // Rule ID 3586 //
     /* 211579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211600 */     // MIs[0] Op3
     /* 211600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 211608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 211608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 211611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211619 */     GIR_RootConstrainSelectedInstOperands,
     /* 211620 */     // GIR_Coverage, 3586,
     /* 211620 */     GIR_EraseRootFromParent_Done,
     /* 211621 */   // Label 4175: @211621
     /* 211621 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211668), // Rule ID 3587 //
     /* 211626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211647 */     // MIs[0] Op3
     /* 211647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 211655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1596:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 211655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 211658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211666 */     GIR_RootConstrainSelectedInstOperands,
     /* 211667 */     // GIR_Coverage, 3587,
     /* 211667 */     GIR_EraseRootFromParent_Done,
     /* 211668 */   // Label 4176: @211668
     /* 211668 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211715), // Rule ID 3588 //
     /* 211673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211694 */     // MIs[0] Op3
     /* 211694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 211702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 211702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 211705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211713 */     GIR_RootConstrainSelectedInstOperands,
     /* 211714 */     // GIR_Coverage, 3588,
     /* 211714 */     GIR_EraseRootFromParent_Done,
     /* 211715 */   // Label 4177: @211715
     /* 211715 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211762), // Rule ID 3589 //
     /* 211720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211741 */     // MIs[0] Op3
     /* 211741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 211752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211760 */     GIR_RootConstrainSelectedInstOperands,
     /* 211761 */     // GIR_Coverage, 3589,
     /* 211761 */     GIR_EraseRootFromParent_Done,
     /* 211762 */   // Label 4178: @211762
     /* 211762 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211809), // Rule ID 3590 //
     /* 211767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211788 */     // MIs[0] Op3
     /* 211788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211796 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 211799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211807 */     GIR_RootConstrainSelectedInstOperands,
     /* 211808 */     // GIR_Coverage, 3590,
     /* 211808 */     GIR_EraseRootFromParent_Done,
     /* 211809 */   // Label 4179: @211809
     /* 211809 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211856), // Rule ID 11345 //
     /* 211814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211835 */     // MIs[0] Op3
     /* 211835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 211843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 211843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 211846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211854 */     GIR_RootConstrainSelectedInstOperands,
     /* 211855 */     // GIR_Coverage, 11345,
     /* 211855 */     GIR_EraseRootFromParent_Done,
     /* 211856 */   // Label 4180: @211856
     /* 211856 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211903), // Rule ID 11346 //
     /* 211861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211882 */     // MIs[0] Op3
     /* 211882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 211890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 211890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 211893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211901 */     GIR_RootConstrainSelectedInstOperands,
     /* 211902 */     // GIR_Coverage, 11346,
     /* 211902 */     GIR_EraseRootFromParent_Done,
     /* 211903 */   // Label 4181: @211903
     /* 211903 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211950), // Rule ID 11347 //
     /* 211908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211929 */     // MIs[0] Op3
     /* 211929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211932 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 211937 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 211937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 211940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211948 */     GIR_RootConstrainSelectedInstOperands,
     /* 211949 */     // GIR_Coverage, 11347,
     /* 211949 */     GIR_EraseRootFromParent_Done,
     /* 211950 */   // Label 4182: @211950
     /* 211950 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211997), // Rule ID 11348 //
     /* 211955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 211963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211976 */     // MIs[0] Op3
     /* 211976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 211984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 211984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 211987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211995 */     GIR_RootConstrainSelectedInstOperands,
     /* 211996 */     // GIR_Coverage, 11348,
     /* 211996 */     GIR_EraseRootFromParent_Done,
     /* 211997 */   // Label 4183: @211997
     /* 211997 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212044), // Rule ID 11349 //
     /* 212002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 212010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212023 */     // MIs[0] Op3
     /* 212023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212042 */     GIR_RootConstrainSelectedInstOperands,
     /* 212043 */     // GIR_Coverage, 11349,
     /* 212043 */     GIR_EraseRootFromParent_Done,
     /* 212044 */   // Label 4184: @212044
     /* 212044 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212091), // Rule ID 11350 //
     /* 212049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 212057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212070 */     // MIs[0] Op3
     /* 212070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 212078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 212078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 212081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212089 */     GIR_RootConstrainSelectedInstOperands,
     /* 212090 */     // GIR_Coverage, 11350,
     /* 212090 */     GIR_EraseRootFromParent_Done,
     /* 212091 */   // Label 4185: @212091
     /* 212091 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212138), // Rule ID 11373 //
     /* 212096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 212104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212117 */     // MIs[0] Op3
     /* 212117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 212128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212136 */     GIR_RootConstrainSelectedInstOperands,
     /* 212137 */     // GIR_Coverage, 11373,
     /* 212137 */     GIR_EraseRootFromParent_Done,
     /* 212138 */   // Label 4186: @212138
     /* 212138 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212185), // Rule ID 11374 //
     /* 212143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 212151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212164 */     // MIs[0] Op3
     /* 212164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 212175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212183 */     GIR_RootConstrainSelectedInstOperands,
     /* 212184 */     // GIR_Coverage, 11374,
     /* 212184 */     GIR_EraseRootFromParent_Done,
     /* 212185 */   // Label 4187: @212185
     /* 212185 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212232), // Rule ID 11375 //
     /* 212190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 212198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212211 */     // MIs[0] Op3
     /* 212211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 212222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212230 */     GIR_RootConstrainSelectedInstOperands,
     /* 212231 */     // GIR_Coverage, 11375,
     /* 212231 */     GIR_EraseRootFromParent_Done,
     /* 212232 */   // Label 4188: @212232
     /* 212232 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212279), // Rule ID 11376 //
     /* 212237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 212245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212258 */     // MIs[0] Op3
     /* 212258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 212269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212277 */     GIR_RootConstrainSelectedInstOperands,
     /* 212278 */     // GIR_Coverage, 11376,
     /* 212278 */     GIR_EraseRootFromParent_Done,
     /* 212279 */   // Label 4189: @212279
     /* 212279 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212326), // Rule ID 11377 //
     /* 212284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 212292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212305 */     // MIs[0] Op3
     /* 212305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 212316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212324 */     GIR_RootConstrainSelectedInstOperands,
     /* 212325 */     // GIR_Coverage, 11377,
     /* 212325 */     GIR_EraseRootFromParent_Done,
     /* 212326 */   // Label 4190: @212326
     /* 212326 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212373), // Rule ID 11378 //
     /* 212331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 212339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212352 */     // MIs[0] Op3
     /* 212352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 212363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212371 */     GIR_RootConstrainSelectedInstOperands,
     /* 212372 */     // GIR_Coverage, 11378,
     /* 212372 */     GIR_EraseRootFromParent_Done,
     /* 212373 */   // Label 4191: @212373
     /* 212373 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212420), // Rule ID 11379 //
     /* 212378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 212386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212399 */     // MIs[0] Op3
     /* 212399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 212410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212418 */     GIR_RootConstrainSelectedInstOperands,
     /* 212419 */     // GIR_Coverage, 11379,
     /* 212419 */     GIR_EraseRootFromParent_Done,
     /* 212420 */   // Label 4192: @212420
     /* 212420 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212467), // Rule ID 11380 //
     /* 212425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 212433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212446 */     // MIs[0] Op3
     /* 212446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 212457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212465 */     GIR_RootConstrainSelectedInstOperands,
     /* 212466 */     // GIR_Coverage, 11380,
     /* 212466 */     GIR_EraseRootFromParent_Done,
     /* 212467 */   // Label 4193: @212467
     /* 212467 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212514), // Rule ID 11381 //
     /* 212472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 212480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212493 */     // MIs[0] Op3
     /* 212493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 212504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212512 */     GIR_RootConstrainSelectedInstOperands,
     /* 212513 */     // GIR_Coverage, 11381,
     /* 212513 */     GIR_EraseRootFromParent_Done,
     /* 212514 */   // Label 4194: @212514
     /* 212514 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212561), // Rule ID 11382 //
     /* 212519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 212527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212540 */     // MIs[0] Op3
     /* 212540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 212551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212559 */     GIR_RootConstrainSelectedInstOperands,
     /* 212560 */     // GIR_Coverage, 11382,
     /* 212560 */     GIR_EraseRootFromParent_Done,
     /* 212561 */   // Label 4195: @212561
     /* 212561 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212608), // Rule ID 11626 //
     /* 212566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212587 */     // MIs[0] Op3
     /* 212587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212595 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 212598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212606 */     GIR_RootConstrainSelectedInstOperands,
     /* 212607 */     // GIR_Coverage, 11626,
     /* 212607 */     GIR_EraseRootFromParent_Done,
     /* 212608 */   // Label 4196: @212608
     /* 212608 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212655), // Rule ID 11627 //
     /* 212613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212634 */     // MIs[0] Op3
     /* 212634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 212645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212653 */     GIR_RootConstrainSelectedInstOperands,
     /* 212654 */     // GIR_Coverage, 11627,
     /* 212654 */     GIR_EraseRootFromParent_Done,
     /* 212655 */   // Label 4197: @212655
     /* 212655 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212702), // Rule ID 11628 //
     /* 212660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212681 */     // MIs[0] Op3
     /* 212681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 212692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212700 */     GIR_RootConstrainSelectedInstOperands,
     /* 212701 */     // GIR_Coverage, 11628,
     /* 212701 */     GIR_EraseRootFromParent_Done,
     /* 212702 */   // Label 4198: @212702
     /* 212702 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212749), // Rule ID 11629 //
     /* 212707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212728 */     // MIs[0] Op3
     /* 212728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 212736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 212736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 212739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212747 */     GIR_RootConstrainSelectedInstOperands,
     /* 212748 */     // GIR_Coverage, 11629,
     /* 212748 */     GIR_EraseRootFromParent_Done,
     /* 212749 */   // Label 4199: @212749
     /* 212749 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212796), // Rule ID 11630 //
     /* 212754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212775 */     // MIs[0] Op3
     /* 212775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 212786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212794 */     GIR_RootConstrainSelectedInstOperands,
     /* 212795 */     // GIR_Coverage, 11630,
     /* 212795 */     GIR_EraseRootFromParent_Done,
     /* 212796 */   // Label 4200: @212796
     /* 212796 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212843), // Rule ID 11632 //
     /* 212801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212822 */     // MIs[0] Op3
     /* 212822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 212833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212841 */     GIR_RootConstrainSelectedInstOperands,
     /* 212842 */     // GIR_Coverage, 11632,
     /* 212842 */     GIR_EraseRootFromParent_Done,
     /* 212843 */   // Label 4201: @212843
     /* 212843 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(212890), // Rule ID 11634 //
     /* 212848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212869 */     // MIs[0] Op3
     /* 212869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 212880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212888 */     GIR_RootConstrainSelectedInstOperands,
     /* 212889 */     // GIR_Coverage, 11634,
     /* 212889 */     GIR_EraseRootFromParent_Done,
     /* 212890 */   // Label 4202: @212890
     /* 212890 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(212937), // Rule ID 11636 //
     /* 212895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212916 */     // MIs[0] Op3
     /* 212916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 212924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 212924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 212927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212935 */     GIR_RootConstrainSelectedInstOperands,
     /* 212936 */     // GIR_Coverage, 11636,
     /* 212936 */     GIR_EraseRootFromParent_Done,
     /* 212937 */   // Label 4203: @212937
     /* 212937 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(212984), // Rule ID 11638 //
     /* 212942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 212950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212963 */     // MIs[0] Op3
     /* 212963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 212971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 212971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 212974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212982 */     GIR_RootConstrainSelectedInstOperands,
     /* 212983 */     // GIR_Coverage, 11638,
     /* 212983 */     GIR_EraseRootFromParent_Done,
     /* 212984 */   // Label 4204: @212984
     /* 212984 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213031), // Rule ID 11639 //
     /* 212989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 212997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213010 */     // MIs[0] Op3
     /* 213010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 213018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 213018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 213021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213029 */     GIR_RootConstrainSelectedInstOperands,
     /* 213030 */     // GIR_Coverage, 11639,
     /* 213030 */     GIR_EraseRootFromParent_Done,
     /* 213031 */   // Label 4205: @213031
     /* 213031 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213078), // Rule ID 11640 //
     /* 213036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 213044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213057 */     // MIs[0] Op3
     /* 213057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 213065 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 213065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 213068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213076 */     GIR_RootConstrainSelectedInstOperands,
     /* 213077 */     // GIR_Coverage, 11640,
     /* 213077 */     GIR_EraseRootFromParent_Done,
     /* 213078 */   // Label 4206: @213078
     /* 213078 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213125), // Rule ID 11641 //
     /* 213083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 213091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213104 */     // MIs[0] Op3
     /* 213104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 213112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 213112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 213115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213123 */     GIR_RootConstrainSelectedInstOperands,
     /* 213124 */     // GIR_Coverage, 11641,
     /* 213124 */     GIR_EraseRootFromParent_Done,
     /* 213125 */   // Label 4207: @213125
     /* 213125 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213172), // Rule ID 11716 //
     /* 213130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213151 */     // MIs[0] Op3
     /* 213151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213159 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 213162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213170 */     GIR_RootConstrainSelectedInstOperands,
     /* 213171 */     // GIR_Coverage, 11716,
     /* 213171 */     GIR_EraseRootFromParent_Done,
     /* 213172 */   // Label 4208: @213172
     /* 213172 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213219), // Rule ID 11718 //
     /* 213177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213198 */     // MIs[0] Op3
     /* 213198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 213209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213217 */     GIR_RootConstrainSelectedInstOperands,
     /* 213218 */     // GIR_Coverage, 11718,
     /* 213218 */     GIR_EraseRootFromParent_Done,
     /* 213219 */   // Label 4209: @213219
     /* 213219 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213266), // Rule ID 11720 //
     /* 213224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213245 */     // MIs[0] Op3
     /* 213245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 213256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213264 */     GIR_RootConstrainSelectedInstOperands,
     /* 213265 */     // GIR_Coverage, 11720,
     /* 213265 */     GIR_EraseRootFromParent_Done,
     /* 213266 */   // Label 4210: @213266
     /* 213266 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213313), // Rule ID 11722 //
     /* 213271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213292 */     // MIs[0] Op3
     /* 213292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 213303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213311 */     GIR_RootConstrainSelectedInstOperands,
     /* 213312 */     // GIR_Coverage, 11722,
     /* 213312 */     GIR_EraseRootFromParent_Done,
     /* 213313 */   // Label 4211: @213313
     /* 213313 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213360), // Rule ID 11724 //
     /* 213318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213339 */     // MIs[0] Op3
     /* 213339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 213350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213358 */     GIR_RootConstrainSelectedInstOperands,
     /* 213359 */     // GIR_Coverage, 11724,
     /* 213359 */     GIR_EraseRootFromParent_Done,
     /* 213360 */   // Label 4212: @213360
     /* 213360 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213407), // Rule ID 11725 //
     /* 213365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213386 */     // MIs[0] Op3
     /* 213386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 213397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213405 */     GIR_RootConstrainSelectedInstOperands,
     /* 213406 */     // GIR_Coverage, 11725,
     /* 213406 */     GIR_EraseRootFromParent_Done,
     /* 213407 */   // Label 4213: @213407
     /* 213407 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213454), // Rule ID 11726 //
     /* 213412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213433 */     // MIs[0] Op3
     /* 213433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 213444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213452 */     GIR_RootConstrainSelectedInstOperands,
     /* 213453 */     // GIR_Coverage, 11726,
     /* 213453 */     GIR_EraseRootFromParent_Done,
     /* 213454 */   // Label 4214: @213454
     /* 213454 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213501), // Rule ID 11727 //
     /* 213459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213480 */     // MIs[0] Op3
     /* 213480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 213491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213499 */     GIR_RootConstrainSelectedInstOperands,
     /* 213500 */     // GIR_Coverage, 11727,
     /* 213500 */     GIR_EraseRootFromParent_Done,
     /* 213501 */   // Label 4215: @213501
     /* 213501 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213548), // Rule ID 11732 //
     /* 213506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213527 */     // MIs[0] Op3
     /* 213527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213535 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 213538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213546 */     GIR_RootConstrainSelectedInstOperands,
     /* 213547 */     // GIR_Coverage, 11732,
     /* 213547 */     GIR_EraseRootFromParent_Done,
     /* 213548 */   // Label 4216: @213548
     /* 213548 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213595), // Rule ID 11733 //
     /* 213553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213574 */     // MIs[0] Op3
     /* 213574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 213585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213593 */     GIR_RootConstrainSelectedInstOperands,
     /* 213594 */     // GIR_Coverage, 11733,
     /* 213594 */     GIR_EraseRootFromParent_Done,
     /* 213595 */   // Label 4217: @213595
     /* 213595 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213642), // Rule ID 11734 //
     /* 213600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213621 */     // MIs[0] Op3
     /* 213621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 213632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213640 */     GIR_RootConstrainSelectedInstOperands,
     /* 213641 */     // GIR_Coverage, 11734,
     /* 213641 */     GIR_EraseRootFromParent_Done,
     /* 213642 */   // Label 4218: @213642
     /* 213642 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213689), // Rule ID 11735 //
     /* 213647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213668 */     // MIs[0] Op3
     /* 213668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213687 */     GIR_RootConstrainSelectedInstOperands,
     /* 213688 */     // GIR_Coverage, 11735,
     /* 213688 */     GIR_EraseRootFromParent_Done,
     /* 213689 */   // Label 4219: @213689
     /* 213689 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213736), // Rule ID 11795 //
     /* 213694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213715 */     // MIs[0] Op3
     /* 213715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 213726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213734 */     GIR_RootConstrainSelectedInstOperands,
     /* 213735 */     // GIR_Coverage, 11795,
     /* 213735 */     GIR_EraseRootFromParent_Done,
     /* 213736 */   // Label 4220: @213736
     /* 213736 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213783), // Rule ID 11796 //
     /* 213741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213762 */     // MIs[0] Op3
     /* 213762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 213773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213781 */     GIR_RootConstrainSelectedInstOperands,
     /* 213782 */     // GIR_Coverage, 11796,
     /* 213782 */     GIR_EraseRootFromParent_Done,
     /* 213783 */   // Label 4221: @213783
     /* 213783 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213830), // Rule ID 11797 //
     /* 213788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213809 */     // MIs[0] Op3
     /* 213809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 213820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213828 */     GIR_RootConstrainSelectedInstOperands,
     /* 213829 */     // GIR_Coverage, 11797,
     /* 213829 */     GIR_EraseRootFromParent_Done,
     /* 213830 */   // Label 4222: @213830
     /* 213830 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213877), // Rule ID 11798 //
     /* 213835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213856 */     // MIs[0] Op3
     /* 213856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 213867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213875 */     GIR_RootConstrainSelectedInstOperands,
     /* 213876 */     // GIR_Coverage, 11798,
     /* 213876 */     GIR_EraseRootFromParent_Done,
     /* 213877 */   // Label 4223: @213877
     /* 213877 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(213924), // Rule ID 11799 //
     /* 213882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213903 */     // MIs[0] Op3
     /* 213903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 213914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213922 */     GIR_RootConstrainSelectedInstOperands,
     /* 213923 */     // GIR_Coverage, 11799,
     /* 213923 */     GIR_EraseRootFromParent_Done,
     /* 213924 */   // Label 4224: @213924
     /* 213924 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(213971), // Rule ID 11800 //
     /* 213929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213950 */     // MIs[0] Op3
     /* 213950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 213961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213969 */     GIR_RootConstrainSelectedInstOperands,
     /* 213970 */     // GIR_Coverage, 11800,
     /* 213970 */     GIR_EraseRootFromParent_Done,
     /* 213971 */   // Label 4225: @213971
     /* 213971 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214018), // Rule ID 11801 //
     /* 213976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 213984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213997 */     // MIs[0] Op3
     /* 213997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214005 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 214008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214016 */     GIR_RootConstrainSelectedInstOperands,
     /* 214017 */     // GIR_Coverage, 11801,
     /* 214017 */     GIR_EraseRootFromParent_Done,
     /* 214018 */   // Label 4226: @214018
     /* 214018 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214065), // Rule ID 11802 //
     /* 214023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 214031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214044 */     // MIs[0] Op3
     /* 214044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 214055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214063 */     GIR_RootConstrainSelectedInstOperands,
     /* 214064 */     // GIR_Coverage, 11802,
     /* 214064 */     GIR_EraseRootFromParent_Done,
     /* 214065 */   // Label 4227: @214065
     /* 214065 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214112), // Rule ID 11803 //
     /* 214070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 214078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214091 */     // MIs[0] Op3
     /* 214091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 214102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214110 */     GIR_RootConstrainSelectedInstOperands,
     /* 214111 */     // GIR_Coverage, 11803,
     /* 214111 */     GIR_EraseRootFromParent_Done,
     /* 214112 */   // Label 4228: @214112
     /* 214112 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214159), // Rule ID 11804 //
     /* 214117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214138 */     // MIs[0] Op3
     /* 214138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 214149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214157 */     GIR_RootConstrainSelectedInstOperands,
     /* 214158 */     // GIR_Coverage, 11804,
     /* 214158 */     GIR_EraseRootFromParent_Done,
     /* 214159 */   // Label 4229: @214159
     /* 214159 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214206), // Rule ID 11805 //
     /* 214164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214185 */     // MIs[0] Op3
     /* 214185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 214196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214204 */     GIR_RootConstrainSelectedInstOperands,
     /* 214205 */     // GIR_Coverage, 11805,
     /* 214205 */     GIR_EraseRootFromParent_Done,
     /* 214206 */   // Label 4230: @214206
     /* 214206 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214253), // Rule ID 11806 //
     /* 214211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214232 */     // MIs[0] Op3
     /* 214232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 214243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214251 */     GIR_RootConstrainSelectedInstOperands,
     /* 214252 */     // GIR_Coverage, 11806,
     /* 214252 */     GIR_EraseRootFromParent_Done,
     /* 214253 */   // Label 4231: @214253
     /* 214253 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214300), // Rule ID 11807 //
     /* 214258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214279 */     // MIs[0] Op3
     /* 214279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214287 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 214290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214298 */     GIR_RootConstrainSelectedInstOperands,
     /* 214299 */     // GIR_Coverage, 11807,
     /* 214299 */     GIR_EraseRootFromParent_Done,
     /* 214300 */   // Label 4232: @214300
     /* 214300 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214347), // Rule ID 11808 //
     /* 214305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214326 */     // MIs[0] Op3
     /* 214326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214345 */     GIR_RootConstrainSelectedInstOperands,
     /* 214346 */     // GIR_Coverage, 11808,
     /* 214346 */     GIR_EraseRootFromParent_Done,
     /* 214347 */   // Label 4233: @214347
     /* 214347 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214394), // Rule ID 11809 //
     /* 214352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214373 */     // MIs[0] Op3
     /* 214373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 214384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214392 */     GIR_RootConstrainSelectedInstOperands,
     /* 214393 */     // GIR_Coverage, 11809,
     /* 214393 */     GIR_EraseRootFromParent_Done,
     /* 214394 */   // Label 4234: @214394
     /* 214394 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214441), // Rule ID 11810 //
     /* 214399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214420 */     // MIs[0] Op3
     /* 214420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 214431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214439 */     GIR_RootConstrainSelectedInstOperands,
     /* 214440 */     // GIR_Coverage, 11810,
     /* 214440 */     GIR_EraseRootFromParent_Done,
     /* 214441 */   // Label 4235: @214441
     /* 214441 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214488), // Rule ID 11811 //
     /* 214446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214467 */     // MIs[0] Op3
     /* 214467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 214478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214486 */     GIR_RootConstrainSelectedInstOperands,
     /* 214487 */     // GIR_Coverage, 11811,
     /* 214487 */     GIR_EraseRootFromParent_Done,
     /* 214488 */   // Label 4236: @214488
     /* 214488 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214535), // Rule ID 11812 //
     /* 214493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214514 */     // MIs[0] Op3
     /* 214514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 214525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214533 */     GIR_RootConstrainSelectedInstOperands,
     /* 214534 */     // GIR_Coverage, 11812,
     /* 214534 */     GIR_EraseRootFromParent_Done,
     /* 214535 */   // Label 4237: @214535
     /* 214535 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214582), // Rule ID 11813 //
     /* 214540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214561 */     // MIs[0] Op3
     /* 214561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214569 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 214572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214580 */     GIR_RootConstrainSelectedInstOperands,
     /* 214581 */     // GIR_Coverage, 11813,
     /* 214581 */     GIR_EraseRootFromParent_Done,
     /* 214582 */   // Label 4238: @214582
     /* 214582 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214629), // Rule ID 11814 //
     /* 214587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214608 */     // MIs[0] Op3
     /* 214608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 214619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214627 */     GIR_RootConstrainSelectedInstOperands,
     /* 214628 */     // GIR_Coverage, 11814,
     /* 214628 */     GIR_EraseRootFromParent_Done,
     /* 214629 */   // Label 4239: @214629
     /* 214629 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214676), // Rule ID 11815 //
     /* 214634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214655 */     // MIs[0] Op3
     /* 214655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214663 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 214666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214674 */     GIR_RootConstrainSelectedInstOperands,
     /* 214675 */     // GIR_Coverage, 11815,
     /* 214675 */     GIR_EraseRootFromParent_Done,
     /* 214676 */   // Label 4240: @214676
     /* 214676 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214743), // Rule ID 2604 //
     /* 214681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 214689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 214732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214741 */     GIR_RootConstrainSelectedInstOperands,
     /* 214742 */     // GIR_Coverage, 2604,
     /* 214742 */     GIR_EraseRootFromParent_Done,
     /* 214743 */   // Label 4241: @214743
     /* 214743 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214810), // Rule ID 7726 //
     /* 214748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 214799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214808 */     GIR_RootConstrainSelectedInstOperands,
     /* 214809 */     // GIR_Coverage, 7726,
     /* 214809 */     GIR_EraseRootFromParent_Done,
     /* 214810 */   // Label 4242: @214810
     /* 214810 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(214877), // Rule ID 7728 //
     /* 214815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214849 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 214866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214875 */     GIR_RootConstrainSelectedInstOperands,
     /* 214876 */     // GIR_Coverage, 7728,
     /* 214876 */     GIR_EraseRootFromParent_Done,
     /* 214877 */   // Label 4243: @214877
     /* 214877 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(214944), // Rule ID 7730 //
     /* 214882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 214933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214942 */     GIR_RootConstrainSelectedInstOperands,
     /* 214943 */     // GIR_Coverage, 7730,
     /* 214943 */     GIR_EraseRootFromParent_Done,
     /* 214944 */   // Label 4244: @214944
     /* 214944 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215011), // Rule ID 7732 //
     /* 214949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 215000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215009 */     GIR_RootConstrainSelectedInstOperands,
     /* 215010 */     // GIR_Coverage, 7732,
     /* 215010 */     GIR_EraseRootFromParent_Done,
     /* 215011 */   // Label 4245: @215011
     /* 215011 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215078), // Rule ID 7762 //
     /* 215016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 215067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215076 */     GIR_RootConstrainSelectedInstOperands,
     /* 215077 */     // GIR_Coverage, 7762,
     /* 215077 */     GIR_EraseRootFromParent_Done,
     /* 215078 */   // Label 4246: @215078
     /* 215078 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215145), // Rule ID 7764 //
     /* 215083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 215134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215143 */     GIR_RootConstrainSelectedInstOperands,
     /* 215144 */     // GIR_Coverage, 7764,
     /* 215144 */     GIR_EraseRootFromParent_Done,
     /* 215145 */   // Label 4247: @215145
     /* 215145 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215212), // Rule ID 7766 //
     /* 215150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 215201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215210 */     GIR_RootConstrainSelectedInstOperands,
     /* 215211 */     // GIR_Coverage, 7766,
     /* 215211 */     GIR_EraseRootFromParent_Done,
     /* 215212 */   // Label 4248: @215212
     /* 215212 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215279), // Rule ID 7768 //
     /* 215217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 215268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215277 */     GIR_RootConstrainSelectedInstOperands,
     /* 215278 */     // GIR_Coverage, 7768,
     /* 215278 */     GIR_EraseRootFromParent_Done,
     /* 215279 */   // Label 4249: @215279
     /* 215279 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215346), // Rule ID 7774 //
     /* 215284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 215335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215344 */     GIR_RootConstrainSelectedInstOperands,
     /* 215345 */     // GIR_Coverage, 7774,
     /* 215345 */     GIR_EraseRootFromParent_Done,
     /* 215346 */   // Label 4250: @215346
     /* 215346 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215413), // Rule ID 7776 //
     /* 215351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215385 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 215402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215411 */     GIR_RootConstrainSelectedInstOperands,
     /* 215412 */     // GIR_Coverage, 7776,
     /* 215412 */     GIR_EraseRootFromParent_Done,
     /* 215413 */   // Label 4251: @215413
     /* 215413 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215480), // Rule ID 7778 //
     /* 215418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 215469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215478 */     GIR_RootConstrainSelectedInstOperands,
     /* 215479 */     // GIR_Coverage, 7778,
     /* 215479 */     GIR_EraseRootFromParent_Done,
     /* 215480 */   // Label 4252: @215480
     /* 215480 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215547), // Rule ID 7780 //
     /* 215485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 215536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215545 */     GIR_RootConstrainSelectedInstOperands,
     /* 215546 */     // GIR_Coverage, 7780,
     /* 215546 */     GIR_EraseRootFromParent_Done,
     /* 215547 */   // Label 4253: @215547
     /* 215547 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215614), // Rule ID 11508 //
     /* 215552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 215560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 215603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215612 */     GIR_RootConstrainSelectedInstOperands,
     /* 215613 */     // GIR_Coverage, 11508,
     /* 215613 */     GIR_EraseRootFromParent_Done,
     /* 215614 */   // Label 4254: @215614
     /* 215614 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215681), // Rule ID 11510 //
     /* 215619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 215670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215679 */     GIR_RootConstrainSelectedInstOperands,
     /* 215680 */     // GIR_Coverage, 11510,
     /* 215680 */     GIR_EraseRootFromParent_Done,
     /* 215681 */   // Label 4255: @215681
     /* 215681 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215748), // Rule ID 11512 //
     /* 215686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 215737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215746 */     GIR_RootConstrainSelectedInstOperands,
     /* 215747 */     // GIR_Coverage, 11512,
     /* 215747 */     GIR_EraseRootFromParent_Done,
     /* 215748 */   // Label 4256: @215748
     /* 215748 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215815), // Rule ID 11514 //
     /* 215753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 215804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215813 */     GIR_RootConstrainSelectedInstOperands,
     /* 215814 */     // GIR_Coverage, 11514,
     /* 215814 */     GIR_EraseRootFromParent_Done,
     /* 215815 */   // Label 4257: @215815
     /* 215815 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215882), // Rule ID 11516 //
     /* 215820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 215871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215880 */     GIR_RootConstrainSelectedInstOperands,
     /* 215881 */     // GIR_Coverage, 11516,
     /* 215881 */     GIR_EraseRootFromParent_Done,
     /* 215882 */   // Label 4258: @215882
     /* 215882 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215949), // Rule ID 11522 //
     /* 215887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 215895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 215938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215947 */     GIR_RootConstrainSelectedInstOperands,
     /* 215948 */     // GIR_Coverage, 11522,
     /* 215948 */     GIR_EraseRootFromParent_Done,
     /* 215949 */   // Label 4259: @215949
     /* 215949 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216016), // Rule ID 11524 //
     /* 215954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 215962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 216000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 216002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 216005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216014 */     GIR_RootConstrainSelectedInstOperands,
     /* 216015 */     // GIR_Coverage, 11524,
     /* 216015 */     GIR_EraseRootFromParent_Done,
     /* 216016 */   // Label 4260: @216016
     /* 216016 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216083), // Rule ID 11526 //
     /* 216021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 216029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 216038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 216053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 216058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 216062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 216067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 216069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 216072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216081 */     GIR_RootConstrainSelectedInstOperands,
     /* 216082 */     // GIR_Coverage, 11526,
     /* 216082 */     GIR_EraseRootFromParent_Done,
     /* 216083 */   // Label 4261: @216083
     /* 216083 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216150), // Rule ID 11528 //
     /* 216088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 216096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 216105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 216120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 216125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 216129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 216134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 216136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 216139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216148 */     GIR_RootConstrainSelectedInstOperands,
     /* 216149 */     // GIR_Coverage, 11528,
     /* 216149 */     GIR_EraseRootFromParent_Done,
     /* 216150 */   // Label 4262: @216150
     /* 216150 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216204), // Rule ID 30 //
     /* 216155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 216163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216191 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 216194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216202 */     GIR_RootConstrainSelectedInstOperands,
     /* 216203 */     // GIR_Coverage, 30,
     /* 216203 */     GIR_EraseRootFromParent_Done,
     /* 216204 */   // Label 4263: @216204
     /* 216204 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216258), // Rule ID 31 //
     /* 216209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 216217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216245 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 216248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216256 */     GIR_RootConstrainSelectedInstOperands,
     /* 216257 */     // GIR_Coverage, 31,
     /* 216257 */     GIR_EraseRootFromParent_Done,
     /* 216258 */   // Label 4264: @216258
     /* 216258 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216312), // Rule ID 32 //
     /* 216263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 216271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 216302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216310 */     GIR_RootConstrainSelectedInstOperands,
     /* 216311 */     // GIR_Coverage, 32,
     /* 216311 */     GIR_EraseRootFromParent_Done,
     /* 216312 */   // Label 4265: @216312
     /* 216312 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216366), // Rule ID 39 //
     /* 216317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 216325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216353 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 216356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216364 */     GIR_RootConstrainSelectedInstOperands,
     /* 216365 */     // GIR_Coverage, 39,
     /* 216365 */     GIR_EraseRootFromParent_Done,
     /* 216366 */   // Label 4266: @216366
     /* 216366 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216420), // Rule ID 40 //
     /* 216371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 216379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216407 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 216410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216418 */     GIR_RootConstrainSelectedInstOperands,
     /* 216419 */     // GIR_Coverage, 40,
     /* 216419 */     GIR_EraseRootFromParent_Done,
     /* 216420 */   // Label 4267: @216420
     /* 216420 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216474), // Rule ID 41 //
     /* 216425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 216433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216461 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 216464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216472 */     GIR_RootConstrainSelectedInstOperands,
     /* 216473 */     // GIR_Coverage, 41,
     /* 216473 */     GIR_EraseRootFromParent_Done,
     /* 216474 */   // Label 4268: @216474
     /* 216474 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216528), // Rule ID 42 //
     /* 216479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 216487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216515 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 216518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216526 */     GIR_RootConstrainSelectedInstOperands,
     /* 216527 */     // GIR_Coverage, 42,
     /* 216527 */     GIR_EraseRootFromParent_Done,
     /* 216528 */   // Label 4269: @216528
     /* 216528 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216582), // Rule ID 43 //
     /* 216533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 216541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216569 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 216572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216580 */     GIR_RootConstrainSelectedInstOperands,
     /* 216581 */     // GIR_Coverage, 43,
     /* 216581 */     GIR_EraseRootFromParent_Done,
     /* 216582 */   // Label 4270: @216582
     /* 216582 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216636), // Rule ID 44 //
     /* 216587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 216595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216623 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 216626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216634 */     GIR_RootConstrainSelectedInstOperands,
     /* 216635 */     // GIR_Coverage, 44,
     /* 216635 */     GIR_EraseRootFromParent_Done,
     /* 216636 */   // Label 4271: @216636
     /* 216636 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216690), // Rule ID 45 //
     /* 216641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 216649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216677 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 216680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216688 */     GIR_RootConstrainSelectedInstOperands,
     /* 216689 */     // GIR_Coverage, 45,
     /* 216689 */     GIR_EraseRootFromParent_Done,
     /* 216690 */   // Label 4272: @216690
     /* 216690 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216744), // Rule ID 46 //
     /* 216695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 216703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216731 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 216734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216742 */     GIR_RootConstrainSelectedInstOperands,
     /* 216743 */     // GIR_Coverage, 46,
     /* 216743 */     GIR_EraseRootFromParent_Done,
     /* 216744 */   // Label 4273: @216744
     /* 216744 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(216798), // Rule ID 1587 //
     /* 216749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216785 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 216785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 216788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216796 */     GIR_RootConstrainSelectedInstOperands,
     /* 216797 */     // GIR_Coverage, 1587,
     /* 216797 */     GIR_EraseRootFromParent_Done,
     /* 216798 */   // Label 4274: @216798
     /* 216798 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(216852), // Rule ID 1588 //
     /* 216803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216839 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 216839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 216842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216850 */     GIR_RootConstrainSelectedInstOperands,
     /* 216851 */     // GIR_Coverage, 1588,
     /* 216851 */     GIR_EraseRootFromParent_Done,
     /* 216852 */   // Label 4275: @216852
     /* 216852 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(216906), // Rule ID 1589 //
     /* 216857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216893 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 216893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 216896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216904 */     GIR_RootConstrainSelectedInstOperands,
     /* 216905 */     // GIR_Coverage, 1589,
     /* 216905 */     GIR_EraseRootFromParent_Done,
     /* 216906 */   // Label 4276: @216906
     /* 216906 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(216960), // Rule ID 1590 //
     /* 216911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216947 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 216947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 216950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216958 */     GIR_RootConstrainSelectedInstOperands,
     /* 216959 */     // GIR_Coverage, 1590,
     /* 216959 */     GIR_EraseRootFromParent_Done,
     /* 216960 */   // Label 4277: @216960
     /* 216960 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217014), // Rule ID 1591 //
     /* 216965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 216973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217001 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 217001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 217004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217012 */     GIR_RootConstrainSelectedInstOperands,
     /* 217013 */     // GIR_Coverage, 1591,
     /* 217013 */     GIR_EraseRootFromParent_Done,
     /* 217014 */   // Label 4278: @217014
     /* 217014 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217068), // Rule ID 1592 //
     /* 217019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217055 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 217055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 217058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217066 */     GIR_RootConstrainSelectedInstOperands,
     /* 217067 */     // GIR_Coverage, 1592,
     /* 217067 */     GIR_EraseRootFromParent_Done,
     /* 217068 */   // Label 4279: @217068
     /* 217068 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217122), // Rule ID 1593 //
     /* 217073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217109 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 217109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 217112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217120 */     GIR_RootConstrainSelectedInstOperands,
     /* 217121 */     // GIR_Coverage, 1593,
     /* 217121 */     GIR_EraseRootFromParent_Done,
     /* 217122 */   // Label 4280: @217122
     /* 217122 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217176), // Rule ID 1594 //
     /* 217127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217163 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 217166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217174 */     GIR_RootConstrainSelectedInstOperands,
     /* 217175 */     // GIR_Coverage, 1594,
     /* 217175 */     GIR_EraseRootFromParent_Done,
     /* 217176 */   // Label 4281: @217176
     /* 217176 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217230), // Rule ID 2307 //
     /* 217181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 217189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 217220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217228 */     GIR_RootConstrainSelectedInstOperands,
     /* 217229 */     // GIR_Coverage, 2307,
     /* 217229 */     GIR_EraseRootFromParent_Done,
     /* 217230 */   // Label 4282: @217230
     /* 217230 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217284), // Rule ID 2308 //
     /* 217235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 217243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217271 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 217274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217282 */     GIR_RootConstrainSelectedInstOperands,
     /* 217283 */     // GIR_Coverage, 2308,
     /* 217283 */     GIR_EraseRootFromParent_Done,
     /* 217284 */   // Label 4283: @217284
     /* 217284 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217338), // Rule ID 2309 //
     /* 217289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 217297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217325 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 217328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217336 */     GIR_RootConstrainSelectedInstOperands,
     /* 217337 */     // GIR_Coverage, 2309,
     /* 217337 */     GIR_EraseRootFromParent_Done,
     /* 217338 */   // Label 4284: @217338
     /* 217338 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217392), // Rule ID 2310 //
     /* 217343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 217351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217379 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 217382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217390 */     GIR_RootConstrainSelectedInstOperands,
     /* 217391 */     // GIR_Coverage, 2310,
     /* 217391 */     GIR_EraseRootFromParent_Done,
     /* 217392 */   // Label 4285: @217392
     /* 217392 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217446), // Rule ID 2311 //
     /* 217397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 217405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217433 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 217436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217444 */     GIR_RootConstrainSelectedInstOperands,
     /* 217445 */     // GIR_Coverage, 2311,
     /* 217445 */     GIR_EraseRootFromParent_Done,
     /* 217446 */   // Label 4286: @217446
     /* 217446 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217500), // Rule ID 2312 //
     /* 217451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 217459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 217490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217498 */     GIR_RootConstrainSelectedInstOperands,
     /* 217499 */     // GIR_Coverage, 2312,
     /* 217499 */     GIR_EraseRootFromParent_Done,
     /* 217500 */   // Label 4287: @217500
     /* 217500 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217554), // Rule ID 2313 //
     /* 217505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 217513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217541 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 217544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217552 */     GIR_RootConstrainSelectedInstOperands,
     /* 217553 */     // GIR_Coverage, 2313,
     /* 217553 */     GIR_EraseRootFromParent_Done,
     /* 217554 */   // Label 4288: @217554
     /* 217554 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217611), // Rule ID 3640 //
     /* 217559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217595 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 217598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217604 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217609 */     GIR_RootConstrainSelectedInstOperands,
     /* 217610 */     // GIR_Coverage, 3640,
     /* 217610 */     GIR_EraseRootFromParent_Done,
     /* 217611 */   // Label 4289: @217611
     /* 217611 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217668), // Rule ID 3641 //
     /* 217616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 217655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217661 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217666 */     GIR_RootConstrainSelectedInstOperands,
     /* 217667 */     // GIR_Coverage, 3641,
     /* 217667 */     GIR_EraseRootFromParent_Done,
     /* 217668 */   // Label 4290: @217668
     /* 217668 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(217725), // Rule ID 3642 //
     /* 217673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217709 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 217712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217718 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217723 */     GIR_RootConstrainSelectedInstOperands,
     /* 217724 */     // GIR_Coverage, 3642,
     /* 217724 */     GIR_EraseRootFromParent_Done,
     /* 217725 */   // Label 4291: @217725
     /* 217725 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(217782), // Rule ID 3643 //
     /* 217730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 217769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217775 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217780 */     GIR_RootConstrainSelectedInstOperands,
     /* 217781 */     // GIR_Coverage, 3643,
     /* 217781 */     GIR_EraseRootFromParent_Done,
     /* 217782 */   // Label 4292: @217782
     /* 217782 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(217836), // Rule ID 3816 //
     /* 217787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 217795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217823 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 217826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217834 */     GIR_RootConstrainSelectedInstOperands,
     /* 217835 */     // GIR_Coverage, 3816,
     /* 217835 */     GIR_EraseRootFromParent_Done,
     /* 217836 */   // Label 4293: @217836
     /* 217836 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(217890), // Rule ID 3817 //
     /* 217841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 217849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217877 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 217880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217888 */     GIR_RootConstrainSelectedInstOperands,
     /* 217889 */     // GIR_Coverage, 3817,
     /* 217889 */     GIR_EraseRootFromParent_Done,
     /* 217890 */   // Label 4294: @217890
     /* 217890 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(217944), // Rule ID 3818 //
     /* 217895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 217903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217931 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 217934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217942 */     GIR_RootConstrainSelectedInstOperands,
     /* 217943 */     // GIR_Coverage, 3818,
     /* 217943 */     GIR_EraseRootFromParent_Done,
     /* 217944 */   // Label 4295: @217944
     /* 217944 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(217998), // Rule ID 3819 //
     /* 217949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 217957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217985 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 217985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 217988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217996 */     GIR_RootConstrainSelectedInstOperands,
     /* 217997 */     // GIR_Coverage, 3819,
     /* 217997 */     GIR_EraseRootFromParent_Done,
     /* 217998 */   // Label 4296: @217998
     /* 217998 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218052), // Rule ID 3820 //
     /* 218003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218039 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218050 */     GIR_RootConstrainSelectedInstOperands,
     /* 218051 */     // GIR_Coverage, 3820,
     /* 218051 */     GIR_EraseRootFromParent_Done,
     /* 218052 */   // Label 4297: @218052
     /* 218052 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218106), // Rule ID 3821 //
     /* 218057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218093 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218104 */     GIR_RootConstrainSelectedInstOperands,
     /* 218105 */     // GIR_Coverage, 3821,
     /* 218105 */     GIR_EraseRootFromParent_Done,
     /* 218106 */   // Label 4298: @218106
     /* 218106 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218160), // Rule ID 3822 //
     /* 218111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218158 */     GIR_RootConstrainSelectedInstOperands,
     /* 218159 */     // GIR_Coverage, 3822,
     /* 218159 */     GIR_EraseRootFromParent_Done,
     /* 218160 */   // Label 4299: @218160
     /* 218160 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218214), // Rule ID 3831 //
     /* 218165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218201 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218212 */     GIR_RootConstrainSelectedInstOperands,
     /* 218213 */     // GIR_Coverage, 3831,
     /* 218213 */     GIR_EraseRootFromParent_Done,
     /* 218214 */   // Label 4300: @218214
     /* 218214 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218268), // Rule ID 3832 //
     /* 218219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218255 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218266 */     GIR_RootConstrainSelectedInstOperands,
     /* 218267 */     // GIR_Coverage, 3832,
     /* 218267 */     GIR_EraseRootFromParent_Done,
     /* 218268 */   // Label 4301: @218268
     /* 218268 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218322), // Rule ID 3833 //
     /* 218273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218320 */     GIR_RootConstrainSelectedInstOperands,
     /* 218321 */     // GIR_Coverage, 3833,
     /* 218321 */     GIR_EraseRootFromParent_Done,
     /* 218322 */   // Label 4302: @218322
     /* 218322 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218376), // Rule ID 3834 //
     /* 218327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218363 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218374 */     GIR_RootConstrainSelectedInstOperands,
     /* 218375 */     // GIR_Coverage, 3834,
     /* 218375 */     GIR_EraseRootFromParent_Done,
     /* 218376 */   // Label 4303: @218376
     /* 218376 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218430), // Rule ID 3835 //
     /* 218381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218417 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218428 */     GIR_RootConstrainSelectedInstOperands,
     /* 218429 */     // GIR_Coverage, 3835,
     /* 218429 */     GIR_EraseRootFromParent_Done,
     /* 218430 */   // Label 4304: @218430
     /* 218430 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218484), // Rule ID 3836 //
     /* 218435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218471 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218482 */     GIR_RootConstrainSelectedInstOperands,
     /* 218483 */     // GIR_Coverage, 3836,
     /* 218483 */     GIR_EraseRootFromParent_Done,
     /* 218484 */   // Label 4305: @218484
     /* 218484 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218538), // Rule ID 3837 //
     /* 218489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218525 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218536 */     GIR_RootConstrainSelectedInstOperands,
     /* 218537 */     // GIR_Coverage, 3837,
     /* 218537 */     GIR_EraseRootFromParent_Done,
     /* 218538 */   // Label 4306: @218538
     /* 218538 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218592), // Rule ID 3838 //
     /* 218543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218579 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218590 */     GIR_RootConstrainSelectedInstOperands,
     /* 218591 */     // GIR_Coverage, 3838,
     /* 218591 */     GIR_EraseRootFromParent_Done,
     /* 218592 */   // Label 4307: @218592
     /* 218592 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218646), // Rule ID 3839 //
     /* 218597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218633 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218644 */     GIR_RootConstrainSelectedInstOperands,
     /* 218645 */     // GIR_Coverage, 3839,
     /* 218645 */     GIR_EraseRootFromParent_Done,
     /* 218646 */   // Label 4308: @218646
     /* 218646 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218700), // Rule ID 3840 //
     /* 218651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218698 */     GIR_RootConstrainSelectedInstOperands,
     /* 218699 */     // GIR_Coverage, 3840,
     /* 218699 */     GIR_EraseRootFromParent_Done,
     /* 218700 */   // Label 4309: @218700
     /* 218700 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218754), // Rule ID 3841 //
     /* 218705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218741 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218752 */     GIR_RootConstrainSelectedInstOperands,
     /* 218753 */     // GIR_Coverage, 3841,
     /* 218753 */     GIR_EraseRootFromParent_Done,
     /* 218754 */   // Label 4310: @218754
     /* 218754 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(218808), // Rule ID 3842 //
     /* 218759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218795 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218806 */     GIR_RootConstrainSelectedInstOperands,
     /* 218807 */     // GIR_Coverage, 3842,
     /* 218807 */     GIR_EraseRootFromParent_Done,
     /* 218808 */   // Label 4311: @218808
     /* 218808 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(218862), // Rule ID 3846 //
     /* 218813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 218821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218849 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 218849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 218852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 218856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 218858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 218860 */     GIR_RootConstrainSelectedInstOperands,
     /* 218861 */     // GIR_Coverage, 3846,
     /* 218861 */     GIR_EraseRootFromParent_Done,
     /* 218862 */   // Label 4312: @218862
     /* 218862 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(218916), // Rule ID 3847 //
     /* 218867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 218875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218903 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 218906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 218908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218914 */     GIR_RootConstrainSelectedInstOperands,
     /* 218915 */     // GIR_Coverage, 3847,
     /* 218915 */     GIR_EraseRootFromParent_Done,
     /* 218916 */   // Label 4313: @218916
     /* 218916 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(218970), // Rule ID 3848 //
     /* 218921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 218929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 218960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 218962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218968 */     GIR_RootConstrainSelectedInstOperands,
     /* 218969 */     // GIR_Coverage, 3848,
     /* 218969 */     GIR_EraseRootFromParent_Done,
     /* 218970 */   // Label 4314: @218970
     /* 218970 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219027), // Rule ID 3865 //
     /* 218975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219011 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 219011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219025 */     GIR_RootConstrainSelectedInstOperands,
     /* 219026 */     // GIR_Coverage, 3865,
     /* 219026 */     GIR_EraseRootFromParent_Done,
     /* 219027 */   // Label 4315: @219027
     /* 219027 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219084), // Rule ID 3866 //
     /* 219032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219068 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 219068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219082 */     GIR_RootConstrainSelectedInstOperands,
     /* 219083 */     // GIR_Coverage, 3866,
     /* 219083 */     GIR_EraseRootFromParent_Done,
     /* 219084 */   // Label 4316: @219084
     /* 219084 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219141), // Rule ID 3867 //
     /* 219089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219125 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 219125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219139 */     GIR_RootConstrainSelectedInstOperands,
     /* 219140 */     // GIR_Coverage, 3867,
     /* 219140 */     GIR_EraseRootFromParent_Done,
     /* 219141 */   // Label 4317: @219141
     /* 219141 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219198), // Rule ID 3868 //
     /* 219146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219182 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 219182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219196 */     GIR_RootConstrainSelectedInstOperands,
     /* 219197 */     // GIR_Coverage, 3868,
     /* 219197 */     GIR_EraseRootFromParent_Done,
     /* 219198 */   // Label 4318: @219198
     /* 219198 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219255), // Rule ID 3873 //
     /* 219203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219239 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 219239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219253 */     GIR_RootConstrainSelectedInstOperands,
     /* 219254 */     // GIR_Coverage, 3873,
     /* 219254 */     GIR_EraseRootFromParent_Done,
     /* 219255 */   // Label 4319: @219255
     /* 219255 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219312), // Rule ID 3874 //
     /* 219260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219296 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 219296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219310 */     GIR_RootConstrainSelectedInstOperands,
     /* 219311 */     // GIR_Coverage, 3874,
     /* 219311 */     GIR_EraseRootFromParent_Done,
     /* 219312 */   // Label 4320: @219312
     /* 219312 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219369), // Rule ID 3875 //
     /* 219317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219353 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 219353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219367 */     GIR_RootConstrainSelectedInstOperands,
     /* 219368 */     // GIR_Coverage, 3875,
     /* 219368 */     GIR_EraseRootFromParent_Done,
     /* 219369 */   // Label 4321: @219369
     /* 219369 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219426), // Rule ID 3876 //
     /* 219374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219410 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 219410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219424 */     GIR_RootConstrainSelectedInstOperands,
     /* 219425 */     // GIR_Coverage, 3876,
     /* 219425 */     GIR_EraseRootFromParent_Done,
     /* 219426 */   // Label 4322: @219426
     /* 219426 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219483), // Rule ID 3881 //
     /* 219431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219467 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 219467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219481 */     GIR_RootConstrainSelectedInstOperands,
     /* 219482 */     // GIR_Coverage, 3881,
     /* 219482 */     GIR_EraseRootFromParent_Done,
     /* 219483 */   // Label 4323: @219483
     /* 219483 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219540), // Rule ID 3882 //
     /* 219488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219524 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 219524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219538 */     GIR_RootConstrainSelectedInstOperands,
     /* 219539 */     // GIR_Coverage, 3882,
     /* 219539 */     GIR_EraseRootFromParent_Done,
     /* 219540 */   // Label 4324: @219540
     /* 219540 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219597), // Rule ID 3883 //
     /* 219545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219581 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 219581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219595 */     GIR_RootConstrainSelectedInstOperands,
     /* 219596 */     // GIR_Coverage, 3883,
     /* 219596 */     GIR_EraseRootFromParent_Done,
     /* 219597 */   // Label 4325: @219597
     /* 219597 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219654), // Rule ID 3884 //
     /* 219602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219638 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 219638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219652 */     GIR_RootConstrainSelectedInstOperands,
     /* 219653 */     // GIR_Coverage, 3884,
     /* 219653 */     GIR_EraseRootFromParent_Done,
     /* 219654 */   // Label 4326: @219654
     /* 219654 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219711), // Rule ID 3885 //
     /* 219659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219695 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 219695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219709 */     GIR_RootConstrainSelectedInstOperands,
     /* 219710 */     // GIR_Coverage, 3885,
     /* 219710 */     GIR_EraseRootFromParent_Done,
     /* 219711 */   // Label 4327: @219711
     /* 219711 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219768), // Rule ID 3886 //
     /* 219716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219752 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 219752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219766 */     GIR_RootConstrainSelectedInstOperands,
     /* 219767 */     // GIR_Coverage, 3886,
     /* 219767 */     GIR_EraseRootFromParent_Done,
     /* 219768 */   // Label 4328: @219768
     /* 219768 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219825), // Rule ID 3887 //
     /* 219773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219809 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 219809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219823 */     GIR_RootConstrainSelectedInstOperands,
     /* 219824 */     // GIR_Coverage, 3887,
     /* 219824 */     GIR_EraseRootFromParent_Done,
     /* 219825 */   // Label 4329: @219825
     /* 219825 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219882), // Rule ID 3888 //
     /* 219830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219866 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 219866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219880 */     GIR_RootConstrainSelectedInstOperands,
     /* 219881 */     // GIR_Coverage, 3888,
     /* 219881 */     GIR_EraseRootFromParent_Done,
     /* 219882 */   // Label 4330: @219882
     /* 219882 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219939), // Rule ID 3889 //
     /* 219887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 219898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 219904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 219907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219923 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 219923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219937 */     GIR_RootConstrainSelectedInstOperands,
     /* 219938 */     // GIR_Coverage, 3889,
     /* 219938 */     GIR_EraseRootFromParent_Done,
     /* 219939 */   // Label 4331: @219939
     /* 219939 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219996), // Rule ID 3890 //
     /* 219944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 219955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 219961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 219964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219980 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 219980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 219983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219994 */     GIR_RootConstrainSelectedInstOperands,
     /* 219995 */     // GIR_Coverage, 3890,
     /* 219995 */     GIR_EraseRootFromParent_Done,
     /* 219996 */   // Label 4332: @219996
     /* 219996 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(220053), // Rule ID 3891 //
     /* 220001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 220004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 220009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 220012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 220015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 220018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 220021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220037 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 220037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 220040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 220051 */     GIR_RootConstrainSelectedInstOperands,
     /* 220052 */     // GIR_Coverage, 3891,
     /* 220052 */     GIR_EraseRootFromParent_Done,
     /* 220053 */   // Label 4333: @220053
     /* 220053 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220110), // Rule ID 3892 //
     /* 220058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 220061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 220066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 220069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 220072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 220075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 220078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220094 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 220094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 220097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 220108 */     GIR_RootConstrainSelectedInstOperands,
     /* 220109 */     // GIR_Coverage, 3892,
     /* 220109 */     GIR_EraseRootFromParent_Done,
     /* 220110 */   // Label 4334: @220110
     /* 220110 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220164), // Rule ID 5232 //
     /* 220115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 220118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220151 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 220151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 220154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220162 */     GIR_RootConstrainSelectedInstOperands,
     /* 220163 */     // GIR_Coverage, 5232,
     /* 220163 */     GIR_EraseRootFromParent_Done,
     /* 220164 */   // Label 4335: @220164
     /* 220164 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220218), // Rule ID 5233 //
     /* 220169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 220172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220205 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 220205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 220208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220216 */     GIR_RootConstrainSelectedInstOperands,
     /* 220217 */     // GIR_Coverage, 5233,
     /* 220217 */     GIR_EraseRootFromParent_Done,
     /* 220218 */   // Label 4336: @220218
     /* 220218 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220269), // Rule ID 5586 //
     /* 220223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 220228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 220231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 220234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 220237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 220240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220256 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 220256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 220259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 220267 */     GIR_RootConstrainSelectedInstOperands,
     /* 220268 */     // GIR_Coverage, 5586,
     /* 220268 */     GIR_EraseRootFromParent_Done,
     /* 220269 */   // Label 4337: @220269
     /* 220269 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220320), // Rule ID 5587 //
     /* 220274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 220279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 220282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 220285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 220288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 220291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220307 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 220307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 220310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 220316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 220318 */     GIR_RootConstrainSelectedInstOperands,
     /* 220319 */     // GIR_Coverage, 5587,
     /* 220319 */     GIR_EraseRootFromParent_Done,
     /* 220320 */   // Label 4338: @220320
     /* 220320 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220362), // Rule ID 2699 //
     /* 220325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220349 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 220352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220360 */     GIR_RootConstrainSelectedInstOperands,
     /* 220361 */     // GIR_Coverage, 2699,
     /* 220361 */     GIR_EraseRootFromParent_Done,
     /* 220362 */   // Label 4339: @220362
     /* 220362 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220404), // Rule ID 2700 //
     /* 220367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 220394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220402 */     GIR_RootConstrainSelectedInstOperands,
     /* 220403 */     // GIR_Coverage, 2700,
     /* 220403 */     GIR_EraseRootFromParent_Done,
     /* 220404 */   // Label 4340: @220404
     /* 220404 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220446), // Rule ID 2701 //
     /* 220409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 220436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220444 */     GIR_RootConstrainSelectedInstOperands,
     /* 220445 */     // GIR_Coverage, 2701,
     /* 220445 */     GIR_EraseRootFromParent_Done,
     /* 220446 */   // Label 4341: @220446
     /* 220446 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220488), // Rule ID 2702 //
     /* 220451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 220478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220486 */     GIR_RootConstrainSelectedInstOperands,
     /* 220487 */     // GIR_Coverage, 2702,
     /* 220487 */     GIR_EraseRootFromParent_Done,
     /* 220488 */   // Label 4342: @220488
     /* 220488 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220530), // Rule ID 2703 //
     /* 220493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220517 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 220520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220528 */     GIR_RootConstrainSelectedInstOperands,
     /* 220529 */     // GIR_Coverage, 2703,
     /* 220529 */     GIR_EraseRootFromParent_Done,
     /* 220530 */   // Label 4343: @220530
     /* 220530 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220572), // Rule ID 2704 //
     /* 220535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220559 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 220562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220570 */     GIR_RootConstrainSelectedInstOperands,
     /* 220571 */     // GIR_Coverage, 2704,
     /* 220571 */     GIR_EraseRootFromParent_Done,
     /* 220572 */   // Label 4344: @220572
     /* 220572 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220614), // Rule ID 2705 //
     /* 220577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220601 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 220604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220612 */     GIR_RootConstrainSelectedInstOperands,
     /* 220613 */     // GIR_Coverage, 2705,
     /* 220613 */     GIR_EraseRootFromParent_Done,
     /* 220614 */   // Label 4345: @220614
     /* 220614 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220656), // Rule ID 2744 //
     /* 220619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1264:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220654 */     GIR_RootConstrainSelectedInstOperands,
     /* 220655 */     // GIR_Coverage, 2744,
     /* 220655 */     GIR_EraseRootFromParent_Done,
     /* 220656 */   // Label 4346: @220656
     /* 220656 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220698), // Rule ID 2745 //
     /* 220661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220685 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220696 */     GIR_RootConstrainSelectedInstOperands,
     /* 220697 */     // GIR_Coverage, 2745,
     /* 220697 */     GIR_EraseRootFromParent_Done,
     /* 220698 */   // Label 4347: @220698
     /* 220698 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220740), // Rule ID 2746 //
     /* 220703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220738 */     GIR_RootConstrainSelectedInstOperands,
     /* 220739 */     // GIR_Coverage, 2746,
     /* 220739 */     GIR_EraseRootFromParent_Done,
     /* 220740 */   // Label 4348: @220740
     /* 220740 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220782), // Rule ID 2747 //
     /* 220745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220769 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220780 */     GIR_RootConstrainSelectedInstOperands,
     /* 220781 */     // GIR_Coverage, 2747,
     /* 220781 */     GIR_EraseRootFromParent_Done,
     /* 220782 */   // Label 4349: @220782
     /* 220782 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220824), // Rule ID 2748 //
     /* 220787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1264:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220822 */     GIR_RootConstrainSelectedInstOperands,
     /* 220823 */     // GIR_Coverage, 2748,
     /* 220823 */     GIR_EraseRootFromParent_Done,
     /* 220824 */   // Label 4350: @220824
     /* 220824 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220866), // Rule ID 2787 //
     /* 220829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220853 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 220853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 220856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220864 */     GIR_RootConstrainSelectedInstOperands,
     /* 220865 */     // GIR_Coverage, 2787,
     /* 220865 */     GIR_EraseRootFromParent_Done,
     /* 220866 */   // Label 4351: @220866
     /* 220866 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220908), // Rule ID 2789 //
     /* 220871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220895 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 220895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 220898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220906 */     GIR_RootConstrainSelectedInstOperands,
     /* 220907 */     // GIR_Coverage, 2789,
     /* 220907 */     GIR_EraseRootFromParent_Done,
     /* 220908 */   // Label 4352: @220908
     /* 220908 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220950), // Rule ID 2791 //
     /* 220913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 220940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220948 */     GIR_RootConstrainSelectedInstOperands,
     /* 220949 */     // GIR_Coverage, 2791,
     /* 220949 */     GIR_EraseRootFromParent_Done,
     /* 220950 */   // Label 4353: @220950
     /* 220950 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220992), // Rule ID 2793 //
     /* 220955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 220963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1537:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 220982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220990 */     GIR_RootConstrainSelectedInstOperands,
     /* 220991 */     // GIR_Coverage, 2793,
     /* 220991 */     GIR_EraseRootFromParent_Done,
     /* 220992 */   // Label 4354: @220992
     /* 220992 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(221034), // Rule ID 2794 //
     /* 220997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 221005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221021 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 221024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221032 */     GIR_RootConstrainSelectedInstOperands,
     /* 221033 */     // GIR_Coverage, 2794,
     /* 221033 */     GIR_EraseRootFromParent_Done,
     /* 221034 */   // Label 4355: @221034
     /* 221034 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(221076), // Rule ID 2795 //
     /* 221039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 221047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221063 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 221066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221074 */     GIR_RootConstrainSelectedInstOperands,
     /* 221075 */     // GIR_Coverage, 2795,
     /* 221075 */     GIR_EraseRootFromParent_Done,
     /* 221076 */   // Label 4356: @221076
     /* 221076 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(221118), // Rule ID 2864 //
     /* 221081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 221089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221105 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 221108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221116 */     GIR_RootConstrainSelectedInstOperands,
     /* 221117 */     // GIR_Coverage, 2864,
     /* 221117 */     GIR_EraseRootFromParent_Done,
     /* 221118 */   // Label 4357: @221118
     /* 221118 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221160), // Rule ID 2865 //
     /* 221123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 221131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1400:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 221150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221158 */     GIR_RootConstrainSelectedInstOperands,
     /* 221159 */     // GIR_Coverage, 2865,
     /* 221159 */     GIR_EraseRootFromParent_Done,
     /* 221160 */   // Label 4358: @221160
     /* 221160 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221202), // Rule ID 2866 //
     /* 221165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 221173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221189 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 221192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221200 */     GIR_RootConstrainSelectedInstOperands,
     /* 221201 */     // GIR_Coverage, 2866,
     /* 221201 */     GIR_EraseRootFromParent_Done,
     /* 221202 */   // Label 4359: @221202
     /* 221202 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221244), // Rule ID 2867 //
     /* 221207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 221215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1396:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221242 */     GIR_RootConstrainSelectedInstOperands,
     /* 221243 */     // GIR_Coverage, 2867,
     /* 221243 */     GIR_EraseRootFromParent_Done,
     /* 221244 */   // Label 4360: @221244
     /* 221244 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221286), // Rule ID 2868 //
     /* 221249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 221257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221273 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 221276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221284 */     GIR_RootConstrainSelectedInstOperands,
     /* 221285 */     // GIR_Coverage, 2868,
     /* 221285 */     GIR_EraseRootFromParent_Done,
     /* 221286 */   // Label 4361: @221286
     /* 221286 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221328), // Rule ID 2869 //
     /* 221291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 221318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221326 */     GIR_RootConstrainSelectedInstOperands,
     /* 221327 */     // GIR_Coverage, 2869,
     /* 221327 */     GIR_EraseRootFromParent_Done,
     /* 221328 */   // Label 4362: @221328
     /* 221328 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221370), // Rule ID 2870 //
     /* 221333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221357 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 221360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221368 */     GIR_RootConstrainSelectedInstOperands,
     /* 221369 */     // GIR_Coverage, 2870,
     /* 221369 */     GIR_EraseRootFromParent_Done,
     /* 221370 */   // Label 4363: @221370
     /* 221370 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221412), // Rule ID 2871 //
     /* 221375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221410 */     GIR_RootConstrainSelectedInstOperands,
     /* 221411 */     // GIR_Coverage, 2871,
     /* 221411 */     GIR_EraseRootFromParent_Done,
     /* 221412 */   // Label 4364: @221412
     /* 221412 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221454), // Rule ID 2882 //
     /* 221417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 221425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221441 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 221444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221452 */     GIR_RootConstrainSelectedInstOperands,
     /* 221453 */     // GIR_Coverage, 2882,
     /* 221453 */     GIR_EraseRootFromParent_Done,
     /* 221454 */   // Label 4365: @221454
     /* 221454 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221496), // Rule ID 2884 //
     /* 221459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 221467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221483 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 221486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221494 */     GIR_RootConstrainSelectedInstOperands,
     /* 221495 */     // GIR_Coverage, 2884,
     /* 221495 */     GIR_EraseRootFromParent_Done,
     /* 221496 */   // Label 4366: @221496
     /* 221496 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221538), // Rule ID 2892 //
     /* 221501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 221518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 221528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221536 */     GIR_RootConstrainSelectedInstOperands,
     /* 221537 */     // GIR_Coverage, 2892,
     /* 221537 */     GIR_EraseRootFromParent_Done,
     /* 221538 */   // Label 4367: @221538
     /* 221538 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221580), // Rule ID 2893 //
     /* 221543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 221570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221578 */     GIR_RootConstrainSelectedInstOperands,
     /* 221579 */     // GIR_Coverage, 2893,
     /* 221579 */     GIR_EraseRootFromParent_Done,
     /* 221580 */   // Label 4368: @221580
     /* 221580 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221622), // Rule ID 2894 //
     /* 221585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 221612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 221621 */     // GIR_Coverage, 2894,
     /* 221621 */     GIR_EraseRootFromParent_Done,
     /* 221622 */   // Label 4369: @221622
     /* 221622 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221664), // Rule ID 2898 //
     /* 221627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 221635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 221654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221662 */     GIR_RootConstrainSelectedInstOperands,
     /* 221663 */     // GIR_Coverage, 2898,
     /* 221663 */     GIR_EraseRootFromParent_Done,
     /* 221664 */   // Label 4370: @221664
     /* 221664 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221706), // Rule ID 2943 //
     /* 221669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 221677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 221696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221704 */     GIR_RootConstrainSelectedInstOperands,
     /* 221705 */     // GIR_Coverage, 2943,
     /* 221705 */     GIR_EraseRootFromParent_Done,
     /* 221706 */   // Label 4371: @221706
     /* 221706 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221748), // Rule ID 2944 //
     /* 221711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 221719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 221738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221746 */     GIR_RootConstrainSelectedInstOperands,
     /* 221747 */     // GIR_Coverage, 2944,
     /* 221747 */     GIR_EraseRootFromParent_Done,
     /* 221748 */   // Label 4372: @221748
     /* 221748 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221790), // Rule ID 2973 //
     /* 221753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1822:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 221780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221788 */     GIR_RootConstrainSelectedInstOperands,
     /* 221789 */     // GIR_Coverage, 2973,
     /* 221789 */     GIR_EraseRootFromParent_Done,
     /* 221790 */   // Label 4373: @221790
     /* 221790 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221832), // Rule ID 2974 //
     /* 221795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1822:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 221822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221830 */     GIR_RootConstrainSelectedInstOperands,
     /* 221831 */     // GIR_Coverage, 2974,
     /* 221831 */     GIR_EraseRootFromParent_Done,
     /* 221832 */   // Label 4374: @221832
     /* 221832 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221874), // Rule ID 2975 //
     /* 221837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1822:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221872 */     GIR_RootConstrainSelectedInstOperands,
     /* 221873 */     // GIR_Coverage, 2975,
     /* 221873 */     GIR_EraseRootFromParent_Done,
     /* 221874 */   // Label 4375: @221874
     /* 221874 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221916), // Rule ID 2976 //
     /* 221879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221903 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1822:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 221906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221914 */     GIR_RootConstrainSelectedInstOperands,
     /* 221915 */     // GIR_Coverage, 2976,
     /* 221915 */     GIR_EraseRootFromParent_Done,
     /* 221916 */   // Label 4376: @221916
     /* 221916 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221958), // Rule ID 2977 //
     /* 221921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 221929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 221948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221956 */     GIR_RootConstrainSelectedInstOperands,
     /* 221957 */     // GIR_Coverage, 2977,
     /* 221957 */     GIR_EraseRootFromParent_Done,
     /* 221958 */   // Label 4377: @221958
     /* 221958 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(222000), // Rule ID 2978 //
     /* 221963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 221971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221987 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 221990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221998 */     GIR_RootConstrainSelectedInstOperands,
     /* 221999 */     // GIR_Coverage, 2978,
     /* 221999 */     GIR_EraseRootFromParent_Done,
     /* 222000 */   // Label 4378: @222000
     /* 222000 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(222042), // Rule ID 2979 //
     /* 222005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 222013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222029 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 222032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222040 */     GIR_RootConstrainSelectedInstOperands,
     /* 222041 */     // GIR_Coverage, 2979,
     /* 222041 */     GIR_EraseRootFromParent_Done,
     /* 222042 */   // Label 4379: @222042
     /* 222042 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(222084), // Rule ID 3009 //
     /* 222047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 222074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222082 */     GIR_RootConstrainSelectedInstOperands,
     /* 222083 */     // GIR_Coverage, 3009,
     /* 222083 */     GIR_EraseRootFromParent_Done,
     /* 222084 */   // Label 4380: @222084
     /* 222084 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222126), // Rule ID 3011 //
     /* 222089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 222116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222124 */     GIR_RootConstrainSelectedInstOperands,
     /* 222125 */     // GIR_Coverage, 3011,
     /* 222125 */     GIR_EraseRootFromParent_Done,
     /* 222126 */   // Label 4381: @222126
     /* 222126 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222168), // Rule ID 3013 //
     /* 222131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 222158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222166 */     GIR_RootConstrainSelectedInstOperands,
     /* 222167 */     // GIR_Coverage, 3013,
     /* 222167 */     GIR_EraseRootFromParent_Done,
     /* 222168 */   // Label 4382: @222168
     /* 222168 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222210), // Rule ID 3015 //
     /* 222173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 222200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222208 */     GIR_RootConstrainSelectedInstOperands,
     /* 222209 */     // GIR_Coverage, 3015,
     /* 222209 */     GIR_EraseRootFromParent_Done,
     /* 222210 */   // Label 4383: @222210
     /* 222210 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222252), // Rule ID 3017 //
     /* 222215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222239 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 222242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222250 */     GIR_RootConstrainSelectedInstOperands,
     /* 222251 */     // GIR_Coverage, 3017,
     /* 222251 */     GIR_EraseRootFromParent_Done,
     /* 222252 */   // Label 4384: @222252
     /* 222252 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222294), // Rule ID 3018 //
     /* 222257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222281 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 222284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222292 */     GIR_RootConstrainSelectedInstOperands,
     /* 222293 */     // GIR_Coverage, 3018,
     /* 222293 */     GIR_EraseRootFromParent_Done,
     /* 222294 */   // Label 4385: @222294
     /* 222294 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222336), // Rule ID 3019 //
     /* 222299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222334 */     GIR_RootConstrainSelectedInstOperands,
     /* 222335 */     // GIR_Coverage, 3019,
     /* 222335 */     GIR_EraseRootFromParent_Done,
     /* 222336 */   // Label 4386: @222336
     /* 222336 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222378), // Rule ID 3020 //
     /* 222341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 222349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 222368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222376 */     GIR_RootConstrainSelectedInstOperands,
     /* 222377 */     // GIR_Coverage, 3020,
     /* 222377 */     GIR_EraseRootFromParent_Done,
     /* 222378 */   // Label 4387: @222378
     /* 222378 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222420), // Rule ID 3021 //
     /* 222383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 222410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222418 */     GIR_RootConstrainSelectedInstOperands,
     /* 222419 */     // GIR_Coverage, 3021,
     /* 222419 */     GIR_EraseRootFromParent_Done,
     /* 222420 */   // Label 4388: @222420
     /* 222420 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222462), // Rule ID 3022 //
     /* 222425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 222452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222460 */     GIR_RootConstrainSelectedInstOperands,
     /* 222461 */     // GIR_Coverage, 3022,
     /* 222461 */     GIR_EraseRootFromParent_Done,
     /* 222462 */   // Label 4389: @222462
     /* 222462 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222504), // Rule ID 3023 //
     /* 222467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 222494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222502 */     GIR_RootConstrainSelectedInstOperands,
     /* 222503 */     // GIR_Coverage, 3023,
     /* 222503 */     GIR_EraseRootFromParent_Done,
     /* 222504 */   // Label 4390: @222504
     /* 222504 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222546), // Rule ID 3024 //
     /* 222509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222533 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 222536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222544 */     GIR_RootConstrainSelectedInstOperands,
     /* 222545 */     // GIR_Coverage, 3024,
     /* 222545 */     GIR_EraseRootFromParent_Done,
     /* 222546 */   // Label 4391: @222546
     /* 222546 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222588), // Rule ID 3041 //
     /* 222551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222575 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 222578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222586 */     GIR_RootConstrainSelectedInstOperands,
     /* 222587 */     // GIR_Coverage, 3041,
     /* 222587 */     GIR_EraseRootFromParent_Done,
     /* 222588 */   // Label 4392: @222588
     /* 222588 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222630), // Rule ID 3042 //
     /* 222593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 222620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222628 */     GIR_RootConstrainSelectedInstOperands,
     /* 222629 */     // GIR_Coverage, 3042,
     /* 222629 */     GIR_EraseRootFromParent_Done,
     /* 222630 */   // Label 4393: @222630
     /* 222630 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222672), // Rule ID 3043 //
     /* 222635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 222662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222670 */     GIR_RootConstrainSelectedInstOperands,
     /* 222671 */     // GIR_Coverage, 3043,
     /* 222671 */     GIR_EraseRootFromParent_Done,
     /* 222672 */   // Label 4394: @222672
     /* 222672 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222714), // Rule ID 3044 //
     /* 222677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 222704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222712 */     GIR_RootConstrainSelectedInstOperands,
     /* 222713 */     // GIR_Coverage, 3044,
     /* 222713 */     GIR_EraseRootFromParent_Done,
     /* 222714 */   // Label 4395: @222714
     /* 222714 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222756), // Rule ID 3068 //
     /* 222719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 222746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222754 */     GIR_RootConstrainSelectedInstOperands,
     /* 222755 */     // GIR_Coverage, 3068,
     /* 222755 */     GIR_EraseRootFromParent_Done,
     /* 222756 */   // Label 4396: @222756
     /* 222756 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222798), // Rule ID 3070 //
     /* 222761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 222788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222796 */     GIR_RootConstrainSelectedInstOperands,
     /* 222797 */     // GIR_Coverage, 3070,
     /* 222797 */     GIR_EraseRootFromParent_Done,
     /* 222798 */   // Label 4397: @222798
     /* 222798 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222840), // Rule ID 3072 //
     /* 222803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 222830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222838 */     GIR_RootConstrainSelectedInstOperands,
     /* 222839 */     // GIR_Coverage, 3072,
     /* 222839 */     GIR_EraseRootFromParent_Done,
     /* 222840 */   // Label 4398: @222840
     /* 222840 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222882), // Rule ID 3074 //
     /* 222845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 222872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222880 */     GIR_RootConstrainSelectedInstOperands,
     /* 222881 */     // GIR_Coverage, 3074,
     /* 222881 */     GIR_EraseRootFromParent_Done,
     /* 222882 */   // Label 4399: @222882
     /* 222882 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222924), // Rule ID 3076 //
     /* 222887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 222914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222922 */     GIR_RootConstrainSelectedInstOperands,
     /* 222923 */     // GIR_Coverage, 3076,
     /* 222923 */     GIR_EraseRootFromParent_Done,
     /* 222924 */   // Label 4400: @222924
     /* 222924 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222966), // Rule ID 3077 //
     /* 222929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 222956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222964 */     GIR_RootConstrainSelectedInstOperands,
     /* 222965 */     // GIR_Coverage, 3077,
     /* 222965 */     GIR_EraseRootFromParent_Done,
     /* 222966 */   // Label 4401: @222966
     /* 222966 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(223008), // Rule ID 3078 //
     /* 222971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222995 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 222998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223006 */     GIR_RootConstrainSelectedInstOperands,
     /* 223007 */     // GIR_Coverage, 3078,
     /* 223007 */     GIR_EraseRootFromParent_Done,
     /* 223008 */   // Label 4402: @223008
     /* 223008 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(223050), // Rule ID 3079 //
     /* 223013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 223021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 223040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223048 */     GIR_RootConstrainSelectedInstOperands,
     /* 223049 */     // GIR_Coverage, 3079,
     /* 223049 */     GIR_EraseRootFromParent_Done,
     /* 223050 */   // Label 4403: @223050
     /* 223050 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(223092), // Rule ID 3080 //
     /* 223055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 223063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223079 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 223082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223090 */     GIR_RootConstrainSelectedInstOperands,
     /* 223091 */     // GIR_Coverage, 3080,
     /* 223091 */     GIR_EraseRootFromParent_Done,
     /* 223092 */   // Label 4404: @223092
     /* 223092 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223134), // Rule ID 3090 //
     /* 223097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223121 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 223124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223132 */     GIR_RootConstrainSelectedInstOperands,
     /* 223133 */     // GIR_Coverage, 3090,
     /* 223133 */     GIR_EraseRootFromParent_Done,
     /* 223134 */   // Label 4405: @223134
     /* 223134 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223176), // Rule ID 3091 //
     /* 223139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 223166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223174 */     GIR_RootConstrainSelectedInstOperands,
     /* 223175 */     // GIR_Coverage, 3091,
     /* 223175 */     GIR_EraseRootFromParent_Done,
     /* 223176 */   // Label 4406: @223176
     /* 223176 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223218), // Rule ID 3092 //
     /* 223181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 223208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223216 */     GIR_RootConstrainSelectedInstOperands,
     /* 223217 */     // GIR_Coverage, 3092,
     /* 223217 */     GIR_EraseRootFromParent_Done,
     /* 223218 */   // Label 4407: @223218
     /* 223218 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223260), // Rule ID 3109 //
     /* 223223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 223250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223258 */     GIR_RootConstrainSelectedInstOperands,
     /* 223259 */     // GIR_Coverage, 3109,
     /* 223259 */     GIR_EraseRootFromParent_Done,
     /* 223260 */   // Label 4408: @223260
     /* 223260 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223302), // Rule ID 3110 //
     /* 223265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 223292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223300 */     GIR_RootConstrainSelectedInstOperands,
     /* 223301 */     // GIR_Coverage, 3110,
     /* 223301 */     GIR_EraseRootFromParent_Done,
     /* 223302 */   // Label 4409: @223302
     /* 223302 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223344), // Rule ID 3111 //
     /* 223307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 223334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223342 */     GIR_RootConstrainSelectedInstOperands,
     /* 223343 */     // GIR_Coverage, 3111,
     /* 223343 */     GIR_EraseRootFromParent_Done,
     /* 223344 */   // Label 4410: @223344
     /* 223344 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223386), // Rule ID 3112 //
     /* 223349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 223376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223384 */     GIR_RootConstrainSelectedInstOperands,
     /* 223385 */     // GIR_Coverage, 3112,
     /* 223385 */     GIR_EraseRootFromParent_Done,
     /* 223386 */   // Label 4411: @223386
     /* 223386 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223428), // Rule ID 3147 //
     /* 223391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223426 */     GIR_RootConstrainSelectedInstOperands,
     /* 223427 */     // GIR_Coverage, 3147,
     /* 223427 */     GIR_EraseRootFromParent_Done,
     /* 223428 */   // Label 4412: @223428
     /* 223428 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223470), // Rule ID 3149 //
     /* 223433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223468 */     GIR_RootConstrainSelectedInstOperands,
     /* 223469 */     // GIR_Coverage, 3149,
     /* 223469 */     GIR_EraseRootFromParent_Done,
     /* 223470 */   // Label 4413: @223470
     /* 223470 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223512), // Rule ID 3151 //
     /* 223475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223510 */     GIR_RootConstrainSelectedInstOperands,
     /* 223511 */     // GIR_Coverage, 3151,
     /* 223511 */     GIR_EraseRootFromParent_Done,
     /* 223512 */   // Label 4414: @223512
     /* 223512 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223554), // Rule ID 3153 //
     /* 223517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223552 */     GIR_RootConstrainSelectedInstOperands,
     /* 223553 */     // GIR_Coverage, 3153,
     /* 223553 */     GIR_EraseRootFromParent_Done,
     /* 223554 */   // Label 4415: @223554
     /* 223554 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223599), // Rule ID 3192 //
     /* 223559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223583 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 223586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223597 */     GIR_RootConstrainSelectedInstOperands,
     /* 223598 */     // GIR_Coverage, 3192,
     /* 223598 */     GIR_EraseRootFromParent_Done,
     /* 223599 */   // Label 4416: @223599
     /* 223599 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223644), // Rule ID 3193 //
     /* 223604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 223631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223642 */     GIR_RootConstrainSelectedInstOperands,
     /* 223643 */     // GIR_Coverage, 3193,
     /* 223643 */     GIR_EraseRootFromParent_Done,
     /* 223644 */   // Label 4417: @223644
     /* 223644 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223689), // Rule ID 3194 //
     /* 223649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 223676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223687 */     GIR_RootConstrainSelectedInstOperands,
     /* 223688 */     // GIR_Coverage, 3194,
     /* 223688 */     GIR_EraseRootFromParent_Done,
     /* 223689 */   // Label 4418: @223689
     /* 223689 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223734), // Rule ID 3195 //
     /* 223694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 223721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223732 */     GIR_RootConstrainSelectedInstOperands,
     /* 223733 */     // GIR_Coverage, 3195,
     /* 223733 */     GIR_EraseRootFromParent_Done,
     /* 223734 */   // Label 4419: @223734
     /* 223734 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223779), // Rule ID 3196 //
     /* 223739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223763 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 223766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223777 */     GIR_RootConstrainSelectedInstOperands,
     /* 223778 */     // GIR_Coverage, 3196,
     /* 223778 */     GIR_EraseRootFromParent_Done,
     /* 223779 */   // Label 4420: @223779
     /* 223779 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223824), // Rule ID 3197 //
     /* 223784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 223811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223822 */     GIR_RootConstrainSelectedInstOperands,
     /* 223823 */     // GIR_Coverage, 3197,
     /* 223823 */     GIR_EraseRootFromParent_Done,
     /* 223824 */   // Label 4421: @223824
     /* 223824 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223866), // Rule ID 3252 //
     /* 223829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223853 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 223856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223864 */     GIR_RootConstrainSelectedInstOperands,
     /* 223865 */     // GIR_Coverage, 3252,
     /* 223865 */     GIR_EraseRootFromParent_Done,
     /* 223866 */   // Label 4422: @223866
     /* 223866 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223908), // Rule ID 3253 //
     /* 223871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 223898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223906 */     GIR_RootConstrainSelectedInstOperands,
     /* 223907 */     // GIR_Coverage, 3253,
     /* 223907 */     GIR_EraseRootFromParent_Done,
     /* 223908 */   // Label 4423: @223908
     /* 223908 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223950), // Rule ID 3254 //
     /* 223913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 223924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223937 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 223940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223948 */     GIR_RootConstrainSelectedInstOperands,
     /* 223949 */     // GIR_Coverage, 3254,
     /* 223949 */     GIR_EraseRootFromParent_Done,
     /* 223950 */   // Label 4424: @223950
     /* 223950 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223992), // Rule ID 3306 //
     /* 223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223979 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 223982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223990 */     GIR_RootConstrainSelectedInstOperands,
     /* 223991 */     // GIR_Coverage, 3306,
     /* 223991 */     GIR_EraseRootFromParent_Done,
     /* 223992 */   // Label 4425: @223992
     /* 223992 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(224034), // Rule ID 3307 //
     /* 223997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 224005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224032 */     GIR_RootConstrainSelectedInstOperands,
     /* 224033 */     // GIR_Coverage, 3307,
     /* 224033 */     GIR_EraseRootFromParent_Done,
     /* 224034 */   // Label 4426: @224034
     /* 224034 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(224076), // Rule ID 3308 //
     /* 224039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 224047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 224066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224074 */     GIR_RootConstrainSelectedInstOperands,
     /* 224075 */     // GIR_Coverage, 3308,
     /* 224075 */     GIR_EraseRootFromParent_Done,
     /* 224076 */   // Label 4427: @224076
     /* 224076 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224118), // Rule ID 3309 //
     /* 224081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 224089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 224108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224116 */     GIR_RootConstrainSelectedInstOperands,
     /* 224117 */     // GIR_Coverage, 3309,
     /* 224117 */     GIR_EraseRootFromParent_Done,
     /* 224118 */   // Label 4428: @224118
     /* 224118 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224160), // Rule ID 3318 //
     /* 224123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 224150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224158 */     GIR_RootConstrainSelectedInstOperands,
     /* 224159 */     // GIR_Coverage, 3318,
     /* 224159 */     GIR_EraseRootFromParent_Done,
     /* 224160 */   // Label 4429: @224160
     /* 224160 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224202), // Rule ID 3319 //
     /* 224165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 224192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224200 */     GIR_RootConstrainSelectedInstOperands,
     /* 224201 */     // GIR_Coverage, 3319,
     /* 224201 */     GIR_EraseRootFromParent_Done,
     /* 224202 */   // Label 4430: @224202
     /* 224202 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224244), // Rule ID 3320 //
     /* 224207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224242 */     GIR_RootConstrainSelectedInstOperands,
     /* 224243 */     // GIR_Coverage, 3320,
     /* 224243 */     GIR_EraseRootFromParent_Done,
     /* 224244 */   // Label 4431: @224244
     /* 224244 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224286), // Rule ID 3359 //
     /* 224249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 224276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224284 */     GIR_RootConstrainSelectedInstOperands,
     /* 224285 */     // GIR_Coverage, 3359,
     /* 224285 */     GIR_EraseRootFromParent_Done,
     /* 224286 */   // Label 4432: @224286
     /* 224286 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224328), // Rule ID 3360 //
     /* 224291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 224318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224326 */     GIR_RootConstrainSelectedInstOperands,
     /* 224327 */     // GIR_Coverage, 3360,
     /* 224327 */     GIR_EraseRootFromParent_Done,
     /* 224328 */   // Label 4433: @224328
     /* 224328 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224370), // Rule ID 3361 //
     /* 224333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 224360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224368 */     GIR_RootConstrainSelectedInstOperands,
     /* 224369 */     // GIR_Coverage, 3361,
     /* 224369 */     GIR_EraseRootFromParent_Done,
     /* 224370 */   // Label 4434: @224370
     /* 224370 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224412), // Rule ID 3362 //
     /* 224375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 224402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224410 */     GIR_RootConstrainSelectedInstOperands,
     /* 224411 */     // GIR_Coverage, 3362,
     /* 224411 */     GIR_EraseRootFromParent_Done,
     /* 224412 */   // Label 4435: @224412
     /* 224412 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224454), // Rule ID 3363 //
     /* 224417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224441 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 224444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224452 */     GIR_RootConstrainSelectedInstOperands,
     /* 224453 */     // GIR_Coverage, 3363,
     /* 224453 */     GIR_EraseRootFromParent_Done,
     /* 224454 */   // Label 4436: @224454
     /* 224454 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224496), // Rule ID 3364 //
     /* 224459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 224486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224494 */     GIR_RootConstrainSelectedInstOperands,
     /* 224495 */     // GIR_Coverage, 3364,
     /* 224495 */     GIR_EraseRootFromParent_Done,
     /* 224496 */   // Label 4437: @224496
     /* 224496 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224538), // Rule ID 3365 //
     /* 224501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224525 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 224528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224536 */     GIR_RootConstrainSelectedInstOperands,
     /* 224537 */     // GIR_Coverage, 3365,
     /* 224537 */     GIR_EraseRootFromParent_Done,
     /* 224538 */   // Label 4438: @224538
     /* 224538 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224580), // Rule ID 3448 //
     /* 224543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 224551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224567 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 224570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224578 */     GIR_RootConstrainSelectedInstOperands,
     /* 224579 */     // GIR_Coverage, 3448,
     /* 224579 */     GIR_EraseRootFromParent_Done,
     /* 224580 */   // Label 4439: @224580
     /* 224580 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224622), // Rule ID 3449 //
     /* 224585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 224593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224609 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 224612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 224614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224620 */     GIR_RootConstrainSelectedInstOperands,
     /* 224621 */     // GIR_Coverage, 3449,
     /* 224621 */     GIR_EraseRootFromParent_Done,
     /* 224622 */   // Label 4440: @224622
     /* 224622 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224664), // Rule ID 3450 //
     /* 224627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 224635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 224654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224662 */     GIR_RootConstrainSelectedInstOperands,
     /* 224663 */     // GIR_Coverage, 3450,
     /* 224663 */     GIR_EraseRootFromParent_Done,
     /* 224664 */   // Label 4441: @224664
     /* 224664 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224709), // Rule ID 3452 //
     /* 224669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 224677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224693 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224707 */     GIR_RootConstrainSelectedInstOperands,
     /* 224708 */     // GIR_Coverage, 3452,
     /* 224708 */     GIR_EraseRootFromParent_Done,
     /* 224709 */   // Label 4442: @224709
     /* 224709 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224754), // Rule ID 3453 //
     /* 224714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 224722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 224741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224752 */     GIR_RootConstrainSelectedInstOperands,
     /* 224753 */     // GIR_Coverage, 3453,
     /* 224753 */     GIR_EraseRootFromParent_Done,
     /* 224754 */   // Label 4443: @224754
     /* 224754 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224796), // Rule ID 3454 //
     /* 224759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 224767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 224786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224794 */     GIR_RootConstrainSelectedInstOperands,
     /* 224795 */     // GIR_Coverage, 3454,
     /* 224795 */     GIR_EraseRootFromParent_Done,
     /* 224796 */   // Label 4444: @224796
     /* 224796 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224838), // Rule ID 3455 //
     /* 224801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 224809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1545:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 224828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224836 */     GIR_RootConstrainSelectedInstOperands,
     /* 224837 */     // GIR_Coverage, 3455,
     /* 224837 */     GIR_EraseRootFromParent_Done,
     /* 224838 */   // Label 4445: @224838
     /* 224838 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224880), // Rule ID 3460 //
     /* 224843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 224846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 224851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 224870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224878 */     GIR_RootConstrainSelectedInstOperands,
     /* 224879 */     // GIR_Coverage, 3460,
     /* 224879 */     GIR_EraseRootFromParent_Done,
     /* 224880 */   // Label 4446: @224880
     /* 224880 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224922), // Rule ID 3499 //
     /* 224885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224909 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 224912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224920 */     GIR_RootConstrainSelectedInstOperands,
     /* 224921 */     // GIR_Coverage, 3499,
     /* 224921 */     GIR_EraseRootFromParent_Done,
     /* 224922 */   // Label 4447: @224922
     /* 224922 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224964), // Rule ID 3501 //
     /* 224927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224951 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 224954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224962 */     GIR_RootConstrainSelectedInstOperands,
     /* 224963 */     // GIR_Coverage, 3501,
     /* 224963 */     GIR_EraseRootFromParent_Done,
     /* 224964 */   // Label 4448: @224964
     /* 224964 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225006), // Rule ID 3503 //
     /* 224969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 224996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225004 */     GIR_RootConstrainSelectedInstOperands,
     /* 225005 */     // GIR_Coverage, 3503,
     /* 225005 */     GIR_EraseRootFromParent_Done,
     /* 225006 */   // Label 4449: @225006
     /* 225006 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225048), // Rule ID 3505 //
     /* 225011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 225014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 225019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 225038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225046 */     GIR_RootConstrainSelectedInstOperands,
     /* 225047 */     // GIR_Coverage, 3505,
     /* 225047 */     GIR_EraseRootFromParent_Done,
     /* 225048 */   // Label 4450: @225048
     /* 225048 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225090), // Rule ID 3632 //
     /* 225053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 225080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225088 */     GIR_RootConstrainSelectedInstOperands,
     /* 225089 */     // GIR_Coverage, 3632,
     /* 225089 */     GIR_EraseRootFromParent_Done,
     /* 225090 */   // Label 4451: @225090
     /* 225090 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225132), // Rule ID 3634 //
     /* 225095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 225122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225130 */     GIR_RootConstrainSelectedInstOperands,
     /* 225131 */     // GIR_Coverage, 3634,
     /* 225131 */     GIR_EraseRootFromParent_Done,
     /* 225132 */   // Label 4452: @225132
     /* 225132 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225174), // Rule ID 3636 //
     /* 225137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 225164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225172 */     GIR_RootConstrainSelectedInstOperands,
     /* 225173 */     // GIR_Coverage, 3636,
     /* 225173 */     GIR_EraseRootFromParent_Done,
     /* 225174 */   // Label 4453: @225174
     /* 225174 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225216), // Rule ID 3638 //
     /* 225179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 225206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225214 */     GIR_RootConstrainSelectedInstOperands,
     /* 225215 */     // GIR_Coverage, 3638,
     /* 225215 */     GIR_EraseRootFromParent_Done,
     /* 225216 */   // Label 4454: @225216
     /* 225216 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225258), // Rule ID 7508 //
     /* 225221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 225248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225256 */     GIR_RootConstrainSelectedInstOperands,
     /* 225257 */     // GIR_Coverage, 7508,
     /* 225257 */     GIR_EraseRootFromParent_Done,
     /* 225258 */   // Label 4455: @225258
     /* 225258 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225300), // Rule ID 7510 //
     /* 225263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 225290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225298 */     GIR_RootConstrainSelectedInstOperands,
     /* 225299 */     // GIR_Coverage, 7510,
     /* 225299 */     GIR_EraseRootFromParent_Done,
     /* 225300 */   // Label 4456: @225300
     /* 225300 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225342), // Rule ID 7512 //
     /* 225305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 225332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225340 */     GIR_RootConstrainSelectedInstOperands,
     /* 225341 */     // GIR_Coverage, 7512,
     /* 225341 */     GIR_EraseRootFromParent_Done,
     /* 225342 */   // Label 4457: @225342
     /* 225342 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225384), // Rule ID 7514 //
     /* 225347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 225374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225382 */     GIR_RootConstrainSelectedInstOperands,
     /* 225383 */     // GIR_Coverage, 7514,
     /* 225383 */     GIR_EraseRootFromParent_Done,
     /* 225384 */   // Label 4458: @225384
     /* 225384 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225426), // Rule ID 7532 //
     /* 225389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 225416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225424 */     GIR_RootConstrainSelectedInstOperands,
     /* 225425 */     // GIR_Coverage, 7532,
     /* 225425 */     GIR_EraseRootFromParent_Done,
     /* 225426 */   // Label 4459: @225426
     /* 225426 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225468), // Rule ID 7533 //
     /* 225431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 225458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225466 */     GIR_RootConstrainSelectedInstOperands,
     /* 225467 */     // GIR_Coverage, 7533,
     /* 225467 */     GIR_EraseRootFromParent_Done,
     /* 225468 */   // Label 4460: @225468
     /* 225468 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225510), // Rule ID 7534 //
     /* 225473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 225500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225508 */     GIR_RootConstrainSelectedInstOperands,
     /* 225509 */     // GIR_Coverage, 7534,
     /* 225509 */     GIR_EraseRootFromParent_Done,
     /* 225510 */   // Label 4461: @225510
     /* 225510 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225552), // Rule ID 7535 //
     /* 225515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 225542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225550 */     GIR_RootConstrainSelectedInstOperands,
     /* 225551 */     // GIR_Coverage, 7535,
     /* 225551 */     GIR_EraseRootFromParent_Done,
     /* 225552 */   // Label 4462: @225552
     /* 225552 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225594), // Rule ID 7648 //
     /* 225557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 225584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225592 */     GIR_RootConstrainSelectedInstOperands,
     /* 225593 */     // GIR_Coverage, 7648,
     /* 225593 */     GIR_EraseRootFromParent_Done,
     /* 225594 */   // Label 4463: @225594
     /* 225594 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225636), // Rule ID 7649 //
     /* 225599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 225626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225634 */     GIR_RootConstrainSelectedInstOperands,
     /* 225635 */     // GIR_Coverage, 7649,
     /* 225635 */     GIR_EraseRootFromParent_Done,
     /* 225636 */   // Label 4464: @225636
     /* 225636 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225678), // Rule ID 7650 //
     /* 225641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 225668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225676 */     GIR_RootConstrainSelectedInstOperands,
     /* 225677 */     // GIR_Coverage, 7650,
     /* 225677 */     GIR_EraseRootFromParent_Done,
     /* 225678 */   // Label 4465: @225678
     /* 225678 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225720), // Rule ID 7651 //
     /* 225683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 225710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225718 */     GIR_RootConstrainSelectedInstOperands,
     /* 225719 */     // GIR_Coverage, 7651,
     /* 225719 */     GIR_EraseRootFromParent_Done,
     /* 225720 */   // Label 4466: @225720
     /* 225720 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225762), // Rule ID 7652 //
     /* 225725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225749 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 225752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225760 */     GIR_RootConstrainSelectedInstOperands,
     /* 225761 */     // GIR_Coverage, 7652,
     /* 225761 */     GIR_EraseRootFromParent_Done,
     /* 225762 */   // Label 4467: @225762
     /* 225762 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225804), // Rule ID 7653 //
     /* 225767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 225794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225802 */     GIR_RootConstrainSelectedInstOperands,
     /* 225803 */     // GIR_Coverage, 7653,
     /* 225803 */     GIR_EraseRootFromParent_Done,
     /* 225804 */   // Label 4468: @225804
     /* 225804 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225846), // Rule ID 7654 //
     /* 225809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 225836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225844 */     GIR_RootConstrainSelectedInstOperands,
     /* 225845 */     // GIR_Coverage, 7654,
     /* 225845 */     GIR_EraseRootFromParent_Done,
     /* 225846 */   // Label 4469: @225846
     /* 225846 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225888), // Rule ID 7655 //
     /* 225851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 225878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225886 */     GIR_RootConstrainSelectedInstOperands,
     /* 225887 */     // GIR_Coverage, 7655,
     /* 225887 */     GIR_EraseRootFromParent_Done,
     /* 225888 */   // Label 4470: @225888
     /* 225888 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225930), // Rule ID 7664 //
     /* 225893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 225901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 225920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225928 */     GIR_RootConstrainSelectedInstOperands,
     /* 225929 */     // GIR_Coverage, 7664,
     /* 225929 */     GIR_EraseRootFromParent_Done,
     /* 225930 */   // Label 4471: @225930
     /* 225930 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225972), // Rule ID 7665 //
     /* 225935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 225943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 225962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225970 */     GIR_RootConstrainSelectedInstOperands,
     /* 225971 */     // GIR_Coverage, 7665,
     /* 225971 */     GIR_EraseRootFromParent_Done,
     /* 225972 */   // Label 4472: @225972
     /* 225972 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(226014), // Rule ID 7666 //
     /* 225977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 225985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 226004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226012 */     GIR_RootConstrainSelectedInstOperands,
     /* 226013 */     // GIR_Coverage, 7666,
     /* 226013 */     GIR_EraseRootFromParent_Done,
     /* 226014 */   // Label 4473: @226014
     /* 226014 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(226056), // Rule ID 7667 //
     /* 226019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 226027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 226046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226054 */     GIR_RootConstrainSelectedInstOperands,
     /* 226055 */     // GIR_Coverage, 7667,
     /* 226055 */     GIR_EraseRootFromParent_Done,
     /* 226056 */   // Label 4474: @226056
     /* 226056 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(226098), // Rule ID 7668 //
     /* 226061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 226069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226085 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 226088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226096 */     GIR_RootConstrainSelectedInstOperands,
     /* 226097 */     // GIR_Coverage, 7668,
     /* 226097 */     GIR_EraseRootFromParent_Done,
     /* 226098 */   // Label 4475: @226098
     /* 226098 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(226140), // Rule ID 7669 //
     /* 226103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 226111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 226130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226138 */     GIR_RootConstrainSelectedInstOperands,
     /* 226139 */     // GIR_Coverage, 7669,
     /* 226139 */     GIR_EraseRootFromParent_Done,
     /* 226140 */   // Label 4476: @226140
     /* 226140 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226182), // Rule ID 7758 //
     /* 226145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 226169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 226172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226180 */     GIR_RootConstrainSelectedInstOperands,
     /* 226181 */     // GIR_Coverage, 7758,
     /* 226181 */     GIR_EraseRootFromParent_Done,
     /* 226182 */   // Label 4477: @226182
     /* 226182 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226224), // Rule ID 7759 //
     /* 226187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 226211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 226214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226222 */     GIR_RootConstrainSelectedInstOperands,
     /* 226223 */     // GIR_Coverage, 7759,
     /* 226223 */     GIR_EraseRootFromParent_Done,
     /* 226224 */   // Label 4478: @226224
     /* 226224 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226266), // Rule ID 7760 //
     /* 226229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 226253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 226256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226264 */     GIR_RootConstrainSelectedInstOperands,
     /* 226265 */     // GIR_Coverage, 7760,
     /* 226265 */     GIR_EraseRootFromParent_Done,
     /* 226266 */   // Label 4479: @226266
     /* 226266 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226308), // Rule ID 7761 //
     /* 226271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 226295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 226298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226306 */     GIR_RootConstrainSelectedInstOperands,
     /* 226307 */     // GIR_Coverage, 7761,
     /* 226307 */     GIR_EraseRootFromParent_Done,
     /* 226308 */   // Label 4480: @226308
     /* 226308 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226350), // Rule ID 7770 //
     /* 226313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 226337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 226340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226348 */     GIR_RootConstrainSelectedInstOperands,
     /* 226349 */     // GIR_Coverage, 7770,
     /* 226349 */     GIR_EraseRootFromParent_Done,
     /* 226350 */   // Label 4481: @226350
     /* 226350 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226392), // Rule ID 7771 //
     /* 226355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 226379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 226382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226390 */     GIR_RootConstrainSelectedInstOperands,
     /* 226391 */     // GIR_Coverage, 7771,
     /* 226391 */     GIR_EraseRootFromParent_Done,
     /* 226392 */   // Label 4482: @226392
     /* 226392 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226434), // Rule ID 7772 //
     /* 226397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 226421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 226424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226432 */     GIR_RootConstrainSelectedInstOperands,
     /* 226433 */     // GIR_Coverage, 7772,
     /* 226433 */     GIR_EraseRootFromParent_Done,
     /* 226434 */   // Label 4483: @226434
     /* 226434 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226476), // Rule ID 7773 //
     /* 226439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 226463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 226466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226474 */     GIR_RootConstrainSelectedInstOperands,
     /* 226475 */     // GIR_Coverage, 7773,
     /* 226475 */     GIR_EraseRootFromParent_Done,
     /* 226476 */   // Label 4484: @226476
     /* 226476 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226518), // Rule ID 7852 //
     /* 226481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226505 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 226508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226516 */     GIR_RootConstrainSelectedInstOperands,
     /* 226517 */     // GIR_Coverage, 7852,
     /* 226517 */     GIR_EraseRootFromParent_Done,
     /* 226518 */   // Label 4485: @226518
     /* 226518 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226560), // Rule ID 7853 //
     /* 226523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 226550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226558 */     GIR_RootConstrainSelectedInstOperands,
     /* 226559 */     // GIR_Coverage, 7853,
     /* 226559 */     GIR_EraseRootFromParent_Done,
     /* 226560 */   // Label 4486: @226560
     /* 226560 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226602), // Rule ID 7854 //
     /* 226565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 226592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226600 */     GIR_RootConstrainSelectedInstOperands,
     /* 226601 */     // GIR_Coverage, 7854,
     /* 226601 */     GIR_EraseRootFromParent_Done,
     /* 226602 */   // Label 4487: @226602
     /* 226602 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226644), // Rule ID 7855 //
     /* 226607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226642 */     GIR_RootConstrainSelectedInstOperands,
     /* 226643 */     // GIR_Coverage, 7855,
     /* 226643 */     GIR_EraseRootFromParent_Done,
     /* 226644 */   // Label 4488: @226644
     /* 226644 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226686), // Rule ID 7856 //
     /* 226649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226673 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 226676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226684 */     GIR_RootConstrainSelectedInstOperands,
     /* 226685 */     // GIR_Coverage, 7856,
     /* 226685 */     GIR_EraseRootFromParent_Done,
     /* 226686 */   // Label 4489: @226686
     /* 226686 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226728), // Rule ID 7857 //
     /* 226691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 226718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226726 */     GIR_RootConstrainSelectedInstOperands,
     /* 226727 */     // GIR_Coverage, 7857,
     /* 226727 */     GIR_EraseRootFromParent_Done,
     /* 226728 */   // Label 4490: @226728
     /* 226728 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226770), // Rule ID 7858 //
     /* 226733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 226760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226768 */     GIR_RootConstrainSelectedInstOperands,
     /* 226769 */     // GIR_Coverage, 7858,
     /* 226769 */     GIR_EraseRootFromParent_Done,
     /* 226770 */   // Label 4491: @226770
     /* 226770 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226812), // Rule ID 7859 //
     /* 226775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 226802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226810 */     GIR_RootConstrainSelectedInstOperands,
     /* 226811 */     // GIR_Coverage, 7859,
     /* 226811 */     GIR_EraseRootFromParent_Done,
     /* 226812 */   // Label 4492: @226812
     /* 226812 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226854), // Rule ID 8055 //
     /* 226817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226841 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 226844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226852 */     GIR_RootConstrainSelectedInstOperands,
     /* 226853 */     // GIR_Coverage, 8055,
     /* 226853 */     GIR_EraseRootFromParent_Done,
     /* 226854 */   // Label 4493: @226854
     /* 226854 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226896), // Rule ID 8057 //
     /* 226859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226883 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 226886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226894 */     GIR_RootConstrainSelectedInstOperands,
     /* 226895 */     // GIR_Coverage, 8057,
     /* 226895 */     GIR_EraseRootFromParent_Done,
     /* 226896 */   // Label 4494: @226896
     /* 226896 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226938), // Rule ID 8059 //
     /* 226901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226925 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 226928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226936 */     GIR_RootConstrainSelectedInstOperands,
     /* 226937 */     // GIR_Coverage, 8059,
     /* 226937 */     GIR_EraseRootFromParent_Done,
     /* 226938 */   // Label 4495: @226938
     /* 226938 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226980), // Rule ID 8067 //
     /* 226943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 226951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226967 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 226970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226978 */     GIR_RootConstrainSelectedInstOperands,
     /* 226979 */     // GIR_Coverage, 8067,
     /* 226979 */     GIR_EraseRootFromParent_Done,
     /* 226980 */   // Label 4496: @226980
     /* 226980 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227022), // Rule ID 8069 //
     /* 226985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 226993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227009 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 227012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227020 */     GIR_RootConstrainSelectedInstOperands,
     /* 227021 */     // GIR_Coverage, 8069,
     /* 227021 */     GIR_EraseRootFromParent_Done,
     /* 227022 */   // Label 4497: @227022
     /* 227022 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227064), // Rule ID 8071 //
     /* 227027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 227035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 227054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227062 */     GIR_RootConstrainSelectedInstOperands,
     /* 227063 */     // GIR_Coverage, 8071,
     /* 227063 */     GIR_EraseRootFromParent_Done,
     /* 227064 */   // Label 4498: @227064
     /* 227064 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227106), // Rule ID 8109 //
     /* 227069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227093 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 227096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227104 */     GIR_RootConstrainSelectedInstOperands,
     /* 227105 */     // GIR_Coverage, 8109,
     /* 227105 */     GIR_EraseRootFromParent_Done,
     /* 227106 */   // Label 4499: @227106
     /* 227106 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227148), // Rule ID 8110 //
     /* 227111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227135 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 227138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227146 */     GIR_RootConstrainSelectedInstOperands,
     /* 227147 */     // GIR_Coverage, 8110,
     /* 227147 */     GIR_EraseRootFromParent_Done,
     /* 227148 */   // Label 4500: @227148
     /* 227148 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227190), // Rule ID 8111 //
     /* 227153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227177 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 227180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227188 */     GIR_RootConstrainSelectedInstOperands,
     /* 227189 */     // GIR_Coverage, 8111,
     /* 227189 */     GIR_EraseRootFromParent_Done,
     /* 227190 */   // Label 4501: @227190
     /* 227190 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227232), // Rule ID 8112 //
     /* 227195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227219 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 227222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227230 */     GIR_RootConstrainSelectedInstOperands,
     /* 227231 */     // GIR_Coverage, 8112,
     /* 227231 */     GIR_EraseRootFromParent_Done,
     /* 227232 */   // Label 4502: @227232
     /* 227232 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227274), // Rule ID 8113 //
     /* 227237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227261 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 227264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227272 */     GIR_RootConstrainSelectedInstOperands,
     /* 227273 */     // GIR_Coverage, 8113,
     /* 227273 */     GIR_EraseRootFromParent_Done,
     /* 227274 */   // Label 4503: @227274
     /* 227274 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227316), // Rule ID 8114 //
     /* 227279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227303 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 227306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227314 */     GIR_RootConstrainSelectedInstOperands,
     /* 227315 */     // GIR_Coverage, 8114,
     /* 227315 */     GIR_EraseRootFromParent_Done,
     /* 227316 */   // Label 4504: @227316
     /* 227316 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227358), // Rule ID 8115 //
     /* 227321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227345 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 227348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227356 */     GIR_RootConstrainSelectedInstOperands,
     /* 227357 */     // GIR_Coverage, 8115,
     /* 227357 */     GIR_EraseRootFromParent_Done,
     /* 227358 */   // Label 4505: @227358
     /* 227358 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227400), // Rule ID 8116 //
     /* 227363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227387 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 227390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227398 */     GIR_RootConstrainSelectedInstOperands,
     /* 227399 */     // GIR_Coverage, 8116,
     /* 227399 */     GIR_EraseRootFromParent_Done,
     /* 227400 */   // Label 4506: @227400
     /* 227400 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227442), // Rule ID 8117 //
     /* 227405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227429 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 227432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227440 */     GIR_RootConstrainSelectedInstOperands,
     /* 227441 */     // GIR_Coverage, 8117,
     /* 227441 */     GIR_EraseRootFromParent_Done,
     /* 227442 */   // Label 4507: @227442
     /* 227442 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227484), // Rule ID 8118 //
     /* 227447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227471 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 227474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227482 */     GIR_RootConstrainSelectedInstOperands,
     /* 227483 */     // GIR_Coverage, 8118,
     /* 227483 */     GIR_EraseRootFromParent_Done,
     /* 227484 */   // Label 4508: @227484
     /* 227484 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227526), // Rule ID 8119 //
     /* 227489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227513 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 227516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227524 */     GIR_RootConstrainSelectedInstOperands,
     /* 227525 */     // GIR_Coverage, 8119,
     /* 227525 */     GIR_EraseRootFromParent_Done,
     /* 227526 */   // Label 4509: @227526
     /* 227526 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227568), // Rule ID 8120 //
     /* 227531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227555 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 227558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227566 */     GIR_RootConstrainSelectedInstOperands,
     /* 227567 */     // GIR_Coverage, 8120,
     /* 227567 */     GIR_EraseRootFromParent_Done,
     /* 227568 */   // Label 4510: @227568
     /* 227568 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227610), // Rule ID 8157 //
     /* 227573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227608 */     GIR_RootConstrainSelectedInstOperands,
     /* 227609 */     // GIR_Coverage, 8157,
     /* 227609 */     GIR_EraseRootFromParent_Done,
     /* 227610 */   // Label 4511: @227610
     /* 227610 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227652), // Rule ID 8159 //
     /* 227615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 227626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 227632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 227635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227639 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 227639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227650 */     GIR_RootConstrainSelectedInstOperands,
     /* 227651 */     // GIR_Coverage, 8159,
     /* 227651 */     GIR_EraseRootFromParent_Done,
     /* 227652 */   // Label 4512: @227652
     /* 227652 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227694), // Rule ID 8161 //
     /* 227657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 227668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 227674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 227677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227681 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 227681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227692 */     GIR_RootConstrainSelectedInstOperands,
     /* 227693 */     // GIR_Coverage, 8161,
     /* 227693 */     GIR_EraseRootFromParent_Done,
     /* 227694 */   // Label 4513: @227694
     /* 227694 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227736), // Rule ID 8163 //
     /* 227699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227723 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 227726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227734 */     GIR_RootConstrainSelectedInstOperands,
     /* 227735 */     // GIR_Coverage, 8163,
     /* 227735 */     GIR_EraseRootFromParent_Done,
     /* 227736 */   // Label 4514: @227736
     /* 227736 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227778), // Rule ID 8165 //
     /* 227741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 227752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 227758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 227761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227765 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 227765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 227768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227776 */     GIR_RootConstrainSelectedInstOperands,
     /* 227777 */     // GIR_Coverage, 8165,
     /* 227777 */     GIR_EraseRootFromParent_Done,
     /* 227778 */   // Label 4515: @227778
     /* 227778 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227820), // Rule ID 8167 //
     /* 227783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 227810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227818 */     GIR_RootConstrainSelectedInstOperands,
     /* 227819 */     // GIR_Coverage, 8167,
     /* 227819 */     GIR_EraseRootFromParent_Done,
     /* 227820 */   // Label 4516: @227820
     /* 227820 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227862), // Rule ID 8169 //
     /* 227825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227849 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227860 */     GIR_RootConstrainSelectedInstOperands,
     /* 227861 */     // GIR_Coverage, 8169,
     /* 227861 */     GIR_EraseRootFromParent_Done,
     /* 227862 */   // Label 4517: @227862
     /* 227862 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227904), // Rule ID 8170 //
     /* 227867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 227878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 227884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 227887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 227891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227902 */     GIR_RootConstrainSelectedInstOperands,
     /* 227903 */     // GIR_Coverage, 8170,
     /* 227903 */     GIR_EraseRootFromParent_Done,
     /* 227904 */   // Label 4518: @227904
     /* 227904 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227946), // Rule ID 8171 //
     /* 227909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 227920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 227926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 227929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227933 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 227933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227944 */     GIR_RootConstrainSelectedInstOperands,
     /* 227945 */     // GIR_Coverage, 8171,
     /* 227945 */     GIR_EraseRootFromParent_Done,
     /* 227946 */   // Label 4519: @227946
     /* 227946 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227988), // Rule ID 8172 //
     /* 227951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 227978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227986 */     GIR_RootConstrainSelectedInstOperands,
     /* 227987 */     // GIR_Coverage, 8172,
     /* 227987 */     GIR_EraseRootFromParent_Done,
     /* 227988 */   // Label 4520: @227988
     /* 227988 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228030), // Rule ID 8173 //
     /* 227993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 228001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 228004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 228010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 228013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228017 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 228017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 228020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228028 */     GIR_RootConstrainSelectedInstOperands,
     /* 228029 */     // GIR_Coverage, 8173,
     /* 228029 */     GIR_EraseRootFromParent_Done,
     /* 228030 */   // Label 4521: @228030
     /* 228030 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(228072), // Rule ID 8174 //
     /* 228035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 228043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 228062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228070 */     GIR_RootConstrainSelectedInstOperands,
     /* 228071 */     // GIR_Coverage, 8174,
     /* 228071 */     GIR_EraseRootFromParent_Done,
     /* 228072 */   // Label 4522: @228072
     /* 228072 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(228114), // Rule ID 8427 //
     /* 228077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 228085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228101 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 228104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228112 */     GIR_RootConstrainSelectedInstOperands,
     /* 228113 */     // GIR_Coverage, 8427,
     /* 228113 */     GIR_EraseRootFromParent_Done,
     /* 228114 */   // Label 4523: @228114
     /* 228114 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228156), // Rule ID 8429 //
     /* 228119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 228127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228143 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 228146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228154 */     GIR_RootConstrainSelectedInstOperands,
     /* 228155 */     // GIR_Coverage, 8429,
     /* 228155 */     GIR_EraseRootFromParent_Done,
     /* 228156 */   // Label 4524: @228156
     /* 228156 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228198), // Rule ID 8430 //
     /* 228161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228185 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228196 */     GIR_RootConstrainSelectedInstOperands,
     /* 228197 */     // GIR_Coverage, 8430,
     /* 228197 */     GIR_EraseRootFromParent_Done,
     /* 228198 */   // Label 4525: @228198
     /* 228198 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228240), // Rule ID 8431 //
     /* 228203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228227 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228238 */     GIR_RootConstrainSelectedInstOperands,
     /* 228239 */     // GIR_Coverage, 8431,
     /* 228239 */     GIR_EraseRootFromParent_Done,
     /* 228240 */   // Label 4526: @228240
     /* 228240 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228282), // Rule ID 8432 //
     /* 228245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228269 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228280 */     GIR_RootConstrainSelectedInstOperands,
     /* 228281 */     // GIR_Coverage, 8432,
     /* 228281 */     GIR_EraseRootFromParent_Done,
     /* 228282 */   // Label 4527: @228282
     /* 228282 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228324), // Rule ID 8433 //
     /* 228287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228311 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228322 */     GIR_RootConstrainSelectedInstOperands,
     /* 228323 */     // GIR_Coverage, 8433,
     /* 228323 */     GIR_EraseRootFromParent_Done,
     /* 228324 */   // Label 4528: @228324
     /* 228324 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228366), // Rule ID 8434 //
     /* 228329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228353 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1292:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228364 */     GIR_RootConstrainSelectedInstOperands,
     /* 228365 */     // GIR_Coverage, 8434,
     /* 228365 */     GIR_EraseRootFromParent_Done,
     /* 228366 */   // Label 4529: @228366
     /* 228366 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228408), // Rule ID 8455 //
     /* 228371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228395 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1350:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228406 */     GIR_RootConstrainSelectedInstOperands,
     /* 228407 */     // GIR_Coverage, 8455,
     /* 228407 */     GIR_EraseRootFromParent_Done,
     /* 228408 */   // Label 4530: @228408
     /* 228408 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228450), // Rule ID 8456 //
     /* 228413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228437 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228448 */     GIR_RootConstrainSelectedInstOperands,
     /* 228449 */     // GIR_Coverage, 8456,
     /* 228449 */     GIR_EraseRootFromParent_Done,
     /* 228450 */   // Label 4531: @228450
     /* 228450 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228492), // Rule ID 8457 //
     /* 228455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228479 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228490 */     GIR_RootConstrainSelectedInstOperands,
     /* 228491 */     // GIR_Coverage, 8457,
     /* 228491 */     GIR_EraseRootFromParent_Done,
     /* 228492 */   // Label 4532: @228492
     /* 228492 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228534), // Rule ID 8458 //
     /* 228497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228521 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228532 */     GIR_RootConstrainSelectedInstOperands,
     /* 228533 */     // GIR_Coverage, 8458,
     /* 228533 */     GIR_EraseRootFromParent_Done,
     /* 228534 */   // Label 4533: @228534
     /* 228534 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228576), // Rule ID 8459 //
     /* 228539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1350:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228574 */     GIR_RootConstrainSelectedInstOperands,
     /* 228575 */     // GIR_Coverage, 8459,
     /* 228575 */     GIR_EraseRootFromParent_Done,
     /* 228576 */   // Label 4534: @228576
     /* 228576 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228618), // Rule ID 8475 //
     /* 228581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228605 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228616 */     GIR_RootConstrainSelectedInstOperands,
     /* 228617 */     // GIR_Coverage, 8475,
     /* 228617 */     GIR_EraseRootFromParent_Done,
     /* 228618 */   // Label 4535: @228618
     /* 228618 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228660), // Rule ID 8476 //
     /* 228623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228647 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228658 */     GIR_RootConstrainSelectedInstOperands,
     /* 228659 */     // GIR_Coverage, 8476,
     /* 228659 */     GIR_EraseRootFromParent_Done,
     /* 228660 */   // Label 4536: @228660
     /* 228660 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228702), // Rule ID 8477 //
     /* 228665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228700 */     GIR_RootConstrainSelectedInstOperands,
     /* 228701 */     // GIR_Coverage, 8477,
     /* 228701 */     GIR_EraseRootFromParent_Done,
     /* 228702 */   // Label 4537: @228702
     /* 228702 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228744), // Rule ID 8478 //
     /* 228707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228731 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228742 */     GIR_RootConstrainSelectedInstOperands,
     /* 228743 */     // GIR_Coverage, 8478,
     /* 228743 */     GIR_EraseRootFromParent_Done,
     /* 228744 */   // Label 4538: @228744
     /* 228744 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228786), // Rule ID 8479 //
     /* 228749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228773 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228784 */     GIR_RootConstrainSelectedInstOperands,
     /* 228785 */     // GIR_Coverage, 8479,
     /* 228785 */     GIR_EraseRootFromParent_Done,
     /* 228786 */   // Label 4539: @228786
     /* 228786 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228828), // Rule ID 8480 //
     /* 228791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228826 */     GIR_RootConstrainSelectedInstOperands,
     /* 228827 */     // GIR_Coverage, 8480,
     /* 228827 */     GIR_EraseRootFromParent_Done,
     /* 228828 */   // Label 4540: @228828
     /* 228828 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228870), // Rule ID 8481 //
     /* 228833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228868 */     GIR_RootConstrainSelectedInstOperands,
     /* 228869 */     // GIR_Coverage, 8481,
     /* 228869 */     GIR_EraseRootFromParent_Done,
     /* 228870 */   // Label 4541: @228870
     /* 228870 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228912), // Rule ID 8482 //
     /* 228875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228910 */     GIR_RootConstrainSelectedInstOperands,
     /* 228911 */     // GIR_Coverage, 8482,
     /* 228911 */     GIR_EraseRootFromParent_Done,
     /* 228912 */   // Label 4542: @228912
     /* 228912 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228954), // Rule ID 8483 //
     /* 228917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228952 */     GIR_RootConstrainSelectedInstOperands,
     /* 228953 */     // GIR_Coverage, 8483,
     /* 228953 */     GIR_EraseRootFromParent_Done,
     /* 228954 */   // Label 4543: @228954
     /* 228954 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228996), // Rule ID 8484 //
     /* 228959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1617:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228994 */     GIR_RootConstrainSelectedInstOperands,
     /* 228995 */     // GIR_Coverage, 8484,
     /* 228995 */     GIR_EraseRootFromParent_Done,
     /* 228996 */   // Label 4544: @228996
     /* 228996 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(229038), // Rule ID 8485 //
     /* 229001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 229021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229025 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 229025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229036 */     GIR_RootConstrainSelectedInstOperands,
     /* 229037 */     // GIR_Coverage, 8485,
     /* 229037 */     GIR_EraseRootFromParent_Done,
     /* 229038 */   // Label 4545: @229038
     /* 229038 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229080), // Rule ID 8486 //
     /* 229043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 229063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229067 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 229067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229078 */     GIR_RootConstrainSelectedInstOperands,
     /* 229079 */     // GIR_Coverage, 8486,
     /* 229079 */     GIR_EraseRootFromParent_Done,
     /* 229080 */   // Label 4546: @229080
     /* 229080 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229122), // Rule ID 8487 //
     /* 229085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 229105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1615:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 229109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229120 */     GIR_RootConstrainSelectedInstOperands,
     /* 229121 */     // GIR_Coverage, 8487,
     /* 229121 */     GIR_EraseRootFromParent_Done,
     /* 229122 */   // Label 4547: @229122
     /* 229122 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229164), // Rule ID 8488 //
     /* 229127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 229147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1615:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 229151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229162 */     GIR_RootConstrainSelectedInstOperands,
     /* 229163 */     // GIR_Coverage, 8488,
     /* 229163 */     GIR_EraseRootFromParent_Done,
     /* 229164 */   // Label 4548: @229164
     /* 229164 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229206), // Rule ID 8489 //
     /* 229169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 229180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 229183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 229186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 229189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229193 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1615:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 229193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229204 */     GIR_RootConstrainSelectedInstOperands,
     /* 229205 */     // GIR_Coverage, 8489,
     /* 229205 */     GIR_EraseRootFromParent_Done,
     /* 229206 */   // Label 4549: @229206
     /* 229206 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229248), // Rule ID 8490 //
     /* 229211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 229231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 229235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229246 */     GIR_RootConstrainSelectedInstOperands,
     /* 229247 */     // GIR_Coverage, 8490,
     /* 229247 */     GIR_EraseRootFromParent_Done,
     /* 229248 */   // Label 4550: @229248
     /* 229248 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229290), // Rule ID 8491 //
     /* 229253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 229273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 229277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229288 */     GIR_RootConstrainSelectedInstOperands,
     /* 229289 */     // GIR_Coverage, 8491,
     /* 229289 */     GIR_EraseRootFromParent_Done,
     /* 229290 */   // Label 4551: @229290
     /* 229290 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229332), // Rule ID 8492 //
     /* 229295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 229315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229319 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 229319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229330 */     GIR_RootConstrainSelectedInstOperands,
     /* 229331 */     // GIR_Coverage, 8492,
     /* 229331 */     GIR_EraseRootFromParent_Done,
     /* 229332 */   // Label 4552: @229332
     /* 229332 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229374), // Rule ID 8493 //
     /* 229337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 229357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229361 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 229361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229372 */     GIR_RootConstrainSelectedInstOperands,
     /* 229373 */     // GIR_Coverage, 8493,
     /* 229373 */     GIR_EraseRootFromParent_Done,
     /* 229374 */   // Label 4553: @229374
     /* 229374 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229416), // Rule ID 8494 //
     /* 229379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 229390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 229393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 229396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 229399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1611:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 229403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229414 */     GIR_RootConstrainSelectedInstOperands,
     /* 229415 */     // GIR_Coverage, 8494,
     /* 229415 */     GIR_EraseRootFromParent_Done,
     /* 229416 */   // Label 4554: @229416
     /* 229416 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229458), // Rule ID 8502 //
     /* 229421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 229448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229456 */     GIR_RootConstrainSelectedInstOperands,
     /* 229457 */     // GIR_Coverage, 8502,
     /* 229457 */     GIR_EraseRootFromParent_Done,
     /* 229458 */   // Label 4555: @229458
     /* 229458 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229500), // Rule ID 8503 //
     /* 229463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229487 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 229490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229498 */     GIR_RootConstrainSelectedInstOperands,
     /* 229499 */     // GIR_Coverage, 8503,
     /* 229499 */     GIR_EraseRootFromParent_Done,
     /* 229500 */   // Label 4556: @229500
     /* 229500 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229542), // Rule ID 8504 //
     /* 229505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 229532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229540 */     GIR_RootConstrainSelectedInstOperands,
     /* 229541 */     // GIR_Coverage, 8504,
     /* 229541 */     GIR_EraseRootFromParent_Done,
     /* 229542 */   // Label 4557: @229542
     /* 229542 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229584), // Rule ID 8505 //
     /* 229547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 229574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229582 */     GIR_RootConstrainSelectedInstOperands,
     /* 229583 */     // GIR_Coverage, 8505,
     /* 229583 */     GIR_EraseRootFromParent_Done,
     /* 229584 */   // Label 4558: @229584
     /* 229584 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229626), // Rule ID 8506 //
     /* 229589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229613 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 229616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229624 */     GIR_RootConstrainSelectedInstOperands,
     /* 229625 */     // GIR_Coverage, 8506,
     /* 229625 */     GIR_EraseRootFromParent_Done,
     /* 229626 */   // Label 4559: @229626
     /* 229626 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229668), // Rule ID 8507 //
     /* 229631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229655 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 229658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229666 */     GIR_RootConstrainSelectedInstOperands,
     /* 229667 */     // GIR_Coverage, 8507,
     /* 229667 */     GIR_EraseRootFromParent_Done,
     /* 229668 */   // Label 4560: @229668
     /* 229668 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229710), // Rule ID 8508 //
     /* 229673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229697 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 229700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229708 */     GIR_RootConstrainSelectedInstOperands,
     /* 229709 */     // GIR_Coverage, 8508,
     /* 229709 */     GIR_EraseRootFromParent_Done,
     /* 229710 */   // Label 4561: @229710
     /* 229710 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229755), // Rule ID 9204 //
     /* 229715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 229742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229753 */     GIR_RootConstrainSelectedInstOperands,
     /* 229754 */     // GIR_Coverage, 9204,
     /* 229754 */     GIR_EraseRootFromParent_Done,
     /* 229755 */   // Label 4562: @229755
     /* 229755 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229800), // Rule ID 9205 //
     /* 229760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 229787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229798 */     GIR_RootConstrainSelectedInstOperands,
     /* 229799 */     // GIR_Coverage, 9205,
     /* 229799 */     GIR_EraseRootFromParent_Done,
     /* 229800 */   // Label 4563: @229800
     /* 229800 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229845), // Rule ID 9206 //
     /* 229805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229829 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 229832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229843 */     GIR_RootConstrainSelectedInstOperands,
     /* 229844 */     // GIR_Coverage, 9206,
     /* 229844 */     GIR_EraseRootFromParent_Done,
     /* 229845 */   // Label 4564: @229845
     /* 229845 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229890), // Rule ID 9207 //
     /* 229850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 229877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229888 */     GIR_RootConstrainSelectedInstOperands,
     /* 229889 */     // GIR_Coverage, 9207,
     /* 229889 */     GIR_EraseRootFromParent_Done,
     /* 229890 */   // Label 4565: @229890
     /* 229890 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229935), // Rule ID 9208 //
     /* 229895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 229922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229933 */     GIR_RootConstrainSelectedInstOperands,
     /* 229934 */     // GIR_Coverage, 9208,
     /* 229934 */     GIR_EraseRootFromParent_Done,
     /* 229935 */   // Label 4566: @229935
     /* 229935 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229980), // Rule ID 9209 //
     /* 229940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 229967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229978 */     GIR_RootConstrainSelectedInstOperands,
     /* 229979 */     // GIR_Coverage, 9209,
     /* 229979 */     GIR_EraseRootFromParent_Done,
     /* 229980 */   // Label 4567: @229980
     /* 229980 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(230025), // Rule ID 9210 //
     /* 229985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 229993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230009 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 230012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230023 */     GIR_RootConstrainSelectedInstOperands,
     /* 230024 */     // GIR_Coverage, 9210,
     /* 230024 */     GIR_EraseRootFromParent_Done,
     /* 230025 */   // Label 4568: @230025
     /* 230025 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(230070), // Rule ID 9211 //
     /* 230030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 230038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 230057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230068 */     GIR_RootConstrainSelectedInstOperands,
     /* 230069 */     // GIR_Coverage, 9211,
     /* 230069 */     GIR_EraseRootFromParent_Done,
     /* 230070 */   // Label 4569: @230070
     /* 230070 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230115), // Rule ID 9212 //
     /* 230075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 230083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230099 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 230102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230113 */     GIR_RootConstrainSelectedInstOperands,
     /* 230114 */     // GIR_Coverage, 9212,
     /* 230114 */     GIR_EraseRootFromParent_Done,
     /* 230115 */   // Label 4570: @230115
     /* 230115 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230160), // Rule ID 9213 //
     /* 230120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 230147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230158 */     GIR_RootConstrainSelectedInstOperands,
     /* 230159 */     // GIR_Coverage, 9213,
     /* 230159 */     GIR_EraseRootFromParent_Done,
     /* 230160 */   // Label 4571: @230160
     /* 230160 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230205), // Rule ID 9214 //
     /* 230165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230189 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 230192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230203 */     GIR_RootConstrainSelectedInstOperands,
     /* 230204 */     // GIR_Coverage, 9214,
     /* 230204 */     GIR_EraseRootFromParent_Done,
     /* 230205 */   // Label 4572: @230205
     /* 230205 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230250), // Rule ID 9215 //
     /* 230210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230234 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 230237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230248 */     GIR_RootConstrainSelectedInstOperands,
     /* 230249 */     // GIR_Coverage, 9215,
     /* 230249 */     GIR_EraseRootFromParent_Done,
     /* 230250 */   // Label 4573: @230250
     /* 230250 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230295), // Rule ID 9216 //
     /* 230255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230279 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1323:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 230282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230293 */     GIR_RootConstrainSelectedInstOperands,
     /* 230294 */     // GIR_Coverage, 9216,
     /* 230294 */     GIR_EraseRootFromParent_Done,
     /* 230295 */   // Label 4574: @230295
     /* 230295 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230340), // Rule ID 9217 //
     /* 230300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 230327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230338 */     GIR_RootConstrainSelectedInstOperands,
     /* 230339 */     // GIR_Coverage, 9217,
     /* 230339 */     GIR_EraseRootFromParent_Done,
     /* 230340 */   // Label 4575: @230340
     /* 230340 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230385), // Rule ID 9218 //
     /* 230345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 230372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230383 */     GIR_RootConstrainSelectedInstOperands,
     /* 230384 */     // GIR_Coverage, 9218,
     /* 230384 */     GIR_EraseRootFromParent_Done,
     /* 230385 */   // Label 4576: @230385
     /* 230385 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230430), // Rule ID 9219 //
     /* 230390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 230417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230428 */     GIR_RootConstrainSelectedInstOperands,
     /* 230429 */     // GIR_Coverage, 9219,
     /* 230429 */     GIR_EraseRootFromParent_Done,
     /* 230430 */   // Label 4577: @230430
     /* 230430 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230475), // Rule ID 9220 //
     /* 230435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 230462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230473 */     GIR_RootConstrainSelectedInstOperands,
     /* 230474 */     // GIR_Coverage, 9220,
     /* 230474 */     GIR_EraseRootFromParent_Done,
     /* 230475 */   // Label 4578: @230475
     /* 230475 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230520), // Rule ID 9221 //
     /* 230480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 230507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230518 */     GIR_RootConstrainSelectedInstOperands,
     /* 230519 */     // GIR_Coverage, 9221,
     /* 230519 */     GIR_EraseRootFromParent_Done,
     /* 230520 */   // Label 4579: @230520
     /* 230520 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230565), // Rule ID 9222 //
     /* 230525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 230552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230563 */     GIR_RootConstrainSelectedInstOperands,
     /* 230564 */     // GIR_Coverage, 9222,
     /* 230564 */     GIR_EraseRootFromParent_Done,
     /* 230565 */   // Label 4580: @230565
     /* 230565 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230610), // Rule ID 9223 //
     /* 230570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230594 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 230597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230608 */     GIR_RootConstrainSelectedInstOperands,
     /* 230609 */     // GIR_Coverage, 9223,
     /* 230609 */     GIR_EraseRootFromParent_Done,
     /* 230610 */   // Label 4581: @230610
     /* 230610 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230655), // Rule ID 9224 //
     /* 230615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230639 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 230642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230653 */     GIR_RootConstrainSelectedInstOperands,
     /* 230654 */     // GIR_Coverage, 9224,
     /* 230654 */     GIR_EraseRootFromParent_Done,
     /* 230655 */   // Label 4582: @230655
     /* 230655 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230700), // Rule ID 9225 //
     /* 230660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 230687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230698 */     GIR_RootConstrainSelectedInstOperands,
     /* 230699 */     // GIR_Coverage, 9225,
     /* 230699 */     GIR_EraseRootFromParent_Done,
     /* 230700 */   // Label 4583: @230700
     /* 230700 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230745), // Rule ID 9226 //
     /* 230705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 230732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230743 */     GIR_RootConstrainSelectedInstOperands,
     /* 230744 */     // GIR_Coverage, 9226,
     /* 230744 */     GIR_EraseRootFromParent_Done,
     /* 230745 */   // Label 4584: @230745
     /* 230745 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230790), // Rule ID 9227 //
     /* 230750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 230777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230788 */     GIR_RootConstrainSelectedInstOperands,
     /* 230789 */     // GIR_Coverage, 9227,
     /* 230789 */     GIR_EraseRootFromParent_Done,
     /* 230790 */   // Label 4585: @230790
     /* 230790 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230832), // Rule ID 9624 //
     /* 230795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 230822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230830 */     GIR_RootConstrainSelectedInstOperands,
     /* 230831 */     // GIR_Coverage, 9624,
     /* 230831 */     GIR_EraseRootFromParent_Done,
     /* 230832 */   // Label 4586: @230832
     /* 230832 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230874), // Rule ID 9625 //
     /* 230837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230861 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 230864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230872 */     GIR_RootConstrainSelectedInstOperands,
     /* 230873 */     // GIR_Coverage, 9625,
     /* 230873 */     GIR_EraseRootFromParent_Done,
     /* 230874 */   // Label 4587: @230874
     /* 230874 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230916), // Rule ID 9626 //
     /* 230879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 230890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 230906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230914 */     GIR_RootConstrainSelectedInstOperands,
     /* 230915 */     // GIR_Coverage, 9626,
     /* 230915 */     GIR_EraseRootFromParent_Done,
     /* 230916 */   // Label 4588: @230916
     /* 230916 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230958), // Rule ID 10164 //
     /* 230921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 230929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230945 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 230948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230956 */     GIR_RootConstrainSelectedInstOperands,
     /* 230957 */     // GIR_Coverage, 10164,
     /* 230957 */     GIR_EraseRootFromParent_Done,
     /* 230958 */   // Label 4589: @230958
     /* 230958 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(231000), // Rule ID 10165 //
     /* 230963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 230971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 230990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230998 */     GIR_RootConstrainSelectedInstOperands,
     /* 230999 */     // GIR_Coverage, 10165,
     /* 230999 */     GIR_EraseRootFromParent_Done,
     /* 231000 */   // Label 4590: @231000
     /* 231000 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(231042), // Rule ID 10166 //
     /* 231005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 231013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 231032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231040 */     GIR_RootConstrainSelectedInstOperands,
     /* 231041 */     // GIR_Coverage, 10166,
     /* 231041 */     GIR_EraseRootFromParent_Done,
     /* 231042 */   // Label 4591: @231042
     /* 231042 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(231084), // Rule ID 10167 //
     /* 231047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 231055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 231074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231082 */     GIR_RootConstrainSelectedInstOperands,
     /* 231083 */     // GIR_Coverage, 10167,
     /* 231083 */     GIR_EraseRootFromParent_Done,
     /* 231084 */   // Label 4592: @231084
     /* 231084 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(231126), // Rule ID 10168 //
     /* 231089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 231116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231124 */     GIR_RootConstrainSelectedInstOperands,
     /* 231125 */     // GIR_Coverage, 10168,
     /* 231125 */     GIR_EraseRootFromParent_Done,
     /* 231126 */   // Label 4593: @231126
     /* 231126 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231168), // Rule ID 10169 //
     /* 231131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 231158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231166 */     GIR_RootConstrainSelectedInstOperands,
     /* 231167 */     // GIR_Coverage, 10169,
     /* 231167 */     GIR_EraseRootFromParent_Done,
     /* 231168 */   // Label 4594: @231168
     /* 231168 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231210), // Rule ID 10170 //
     /* 231173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 231200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231208 */     GIR_RootConstrainSelectedInstOperands,
     /* 231209 */     // GIR_Coverage, 10170,
     /* 231209 */     GIR_EraseRootFromParent_Done,
     /* 231210 */   // Label 4595: @231210
     /* 231210 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231252), // Rule ID 10171 //
     /* 231215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 231242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231250 */     GIR_RootConstrainSelectedInstOperands,
     /* 231251 */     // GIR_Coverage, 10171,
     /* 231251 */     GIR_EraseRootFromParent_Done,
     /* 231252 */   // Label 4596: @231252
     /* 231252 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231294), // Rule ID 10184 //
     /* 231257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 231284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231292 */     GIR_RootConstrainSelectedInstOperands,
     /* 231293 */     // GIR_Coverage, 10184,
     /* 231293 */     GIR_EraseRootFromParent_Done,
     /* 231294 */   // Label 4597: @231294
     /* 231294 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231336), // Rule ID 10185 //
     /* 231299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 231326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231334 */     GIR_RootConstrainSelectedInstOperands,
     /* 231335 */     // GIR_Coverage, 10185,
     /* 231335 */     GIR_EraseRootFromParent_Done,
     /* 231336 */   // Label 4598: @231336
     /* 231336 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231378), // Rule ID 10186 //
     /* 231341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 231368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231376 */     GIR_RootConstrainSelectedInstOperands,
     /* 231377 */     // GIR_Coverage, 10186,
     /* 231377 */     GIR_EraseRootFromParent_Done,
     /* 231378 */   // Label 4599: @231378
     /* 231378 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231420), // Rule ID 10187 //
     /* 231383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 231410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231418 */     GIR_RootConstrainSelectedInstOperands,
     /* 231419 */     // GIR_Coverage, 10187,
     /* 231419 */     GIR_EraseRootFromParent_Done,
     /* 231420 */   // Label 4600: @231420
     /* 231420 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231462), // Rule ID 10188 //
     /* 231425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 231452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231460 */     GIR_RootConstrainSelectedInstOperands,
     /* 231461 */     // GIR_Coverage, 10188,
     /* 231461 */     GIR_EraseRootFromParent_Done,
     /* 231462 */   // Label 4601: @231462
     /* 231462 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231504), // Rule ID 10189 //
     /* 231467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 231494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231502 */     GIR_RootConstrainSelectedInstOperands,
     /* 231503 */     // GIR_Coverage, 10189,
     /* 231503 */     GIR_EraseRootFromParent_Done,
     /* 231504 */   // Label 4602: @231504
     /* 231504 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231546), // Rule ID 10216 //
     /* 231509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 231517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 231533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 231536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231544 */     GIR_RootConstrainSelectedInstOperands,
     /* 231545 */     // GIR_Coverage, 10216,
     /* 231545 */     GIR_EraseRootFromParent_Done,
     /* 231546 */   // Label 4603: @231546
     /* 231546 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231588), // Rule ID 10220 //
     /* 231551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 231559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231575 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 231575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 231578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231586 */     GIR_RootConstrainSelectedInstOperands,
     /* 231587 */     // GIR_Coverage, 10220,
     /* 231587 */     GIR_EraseRootFromParent_Done,
     /* 231588 */   // Label 4604: @231588
     /* 231588 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231630), // Rule ID 10224 //
     /* 231593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 231601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231617 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 231617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 231620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231628 */     GIR_RootConstrainSelectedInstOperands,
     /* 231629 */     // GIR_Coverage, 10224,
     /* 231629 */     GIR_EraseRootFromParent_Done,
     /* 231630 */   // Label 4605: @231630
     /* 231630 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231672), // Rule ID 10228 //
     /* 231635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 231643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231659 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 231659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 231662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231670 */     GIR_RootConstrainSelectedInstOperands,
     /* 231671 */     // GIR_Coverage, 10228,
     /* 231671 */     GIR_EraseRootFromParent_Done,
     /* 231672 */   // Label 4606: @231672
     /* 231672 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231714), // Rule ID 10232 //
     /* 231677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 231685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231701 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1703:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 231704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231712 */     GIR_RootConstrainSelectedInstOperands,
     /* 231713 */     // GIR_Coverage, 10232,
     /* 231713 */     GIR_EraseRootFromParent_Done,
     /* 231714 */   // Label 4607: @231714
     /* 231714 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231756), // Rule ID 10233 //
     /* 231719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 231727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231743 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1950:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 231746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231754 */     GIR_RootConstrainSelectedInstOperands,
     /* 231755 */     // GIR_Coverage, 10233,
     /* 231755 */     GIR_EraseRootFromParent_Done,
     /* 231756 */   // Label 4608: @231756
     /* 231756 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231798), // Rule ID 10234 //
     /* 231761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 231769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231785 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1947:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 231788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231796 */     GIR_RootConstrainSelectedInstOperands,
     /* 231797 */     // GIR_Coverage, 10234,
     /* 231797 */     GIR_EraseRootFromParent_Done,
     /* 231798 */   // Label 4609: @231798
     /* 231798 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231840), // Rule ID 10238 //
     /* 231803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 231811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1702:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 231830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231838 */     GIR_RootConstrainSelectedInstOperands,
     /* 231839 */     // GIR_Coverage, 10238,
     /* 231839 */     GIR_EraseRootFromParent_Done,
     /* 231840 */   // Label 4610: @231840
     /* 231840 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231882), // Rule ID 10242 //
     /* 231845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 231853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231869 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1700:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 231872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231880 */     GIR_RootConstrainSelectedInstOperands,
     /* 231881 */     // GIR_Coverage, 10242,
     /* 231881 */     GIR_EraseRootFromParent_Done,
     /* 231882 */   // Label 4611: @231882
     /* 231882 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231924), // Rule ID 10246 //
     /* 231887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 231895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231911 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 231914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231922 */     GIR_RootConstrainSelectedInstOperands,
     /* 231923 */     // GIR_Coverage, 10246,
     /* 231923 */     GIR_EraseRootFromParent_Done,
     /* 231924 */   // Label 4612: @231924
     /* 231924 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231966), // Rule ID 10250 //
     /* 231929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 231937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231953 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1949:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 231956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231964 */     GIR_RootConstrainSelectedInstOperands,
     /* 231965 */     // GIR_Coverage, 10250,
     /* 231965 */     GIR_EraseRootFromParent_Done,
     /* 231966 */   // Label 4613: @231966
     /* 231966 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(232008), // Rule ID 10254 //
     /* 231971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 231979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 231998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232006 */     GIR_RootConstrainSelectedInstOperands,
     /* 232007 */     // GIR_Coverage, 10254,
     /* 232007 */     GIR_EraseRootFromParent_Done,
     /* 232008 */   // Label 4614: @232008
     /* 232008 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(232050), // Rule ID 10264 //
     /* 232013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 232021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 232040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232048 */     GIR_RootConstrainSelectedInstOperands,
     /* 232049 */     // GIR_Coverage, 10264,
     /* 232049 */     GIR_EraseRootFromParent_Done,
     /* 232050 */   // Label 4615: @232050
     /* 232050 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(232092), // Rule ID 10265 //
     /* 232055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 232063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 232082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232090 */     GIR_RootConstrainSelectedInstOperands,
     /* 232091 */     // GIR_Coverage, 10265,
     /* 232091 */     GIR_EraseRootFromParent_Done,
     /* 232092 */   // Label 4616: @232092
     /* 232092 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(232134), // Rule ID 10266 //
     /* 232097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 232105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 232124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232132 */     GIR_RootConstrainSelectedInstOperands,
     /* 232133 */     // GIR_Coverage, 10266,
     /* 232133 */     GIR_EraseRootFromParent_Done,
     /* 232134 */   // Label 4617: @232134
     /* 232134 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232176), // Rule ID 10270 //
     /* 232139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 232147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 232166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232174 */     GIR_RootConstrainSelectedInstOperands,
     /* 232175 */     // GIR_Coverage, 10270,
     /* 232175 */     GIR_EraseRootFromParent_Done,
     /* 232176 */   // Label 4618: @232176
     /* 232176 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232218), // Rule ID 10274 //
     /* 232181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 232189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 232208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232216 */     GIR_RootConstrainSelectedInstOperands,
     /* 232217 */     // GIR_Coverage, 10274,
     /* 232217 */     GIR_EraseRootFromParent_Done,
     /* 232218 */   // Label 4619: @232218
     /* 232218 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232260), // Rule ID 10278 //
     /* 232223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 232231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 232250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232258 */     GIR_RootConstrainSelectedInstOperands,
     /* 232259 */     // GIR_Coverage, 10278,
     /* 232259 */     GIR_EraseRootFromParent_Done,
     /* 232260 */   // Label 4620: @232260
     /* 232260 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232302), // Rule ID 10282 //
     /* 232265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 232273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 232292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232300 */     GIR_RootConstrainSelectedInstOperands,
     /* 232301 */     // GIR_Coverage, 10282,
     /* 232301 */     GIR_EraseRootFromParent_Done,
     /* 232302 */   // Label 4621: @232302
     /* 232302 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232344), // Rule ID 10286 //
     /* 232307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 232315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232331 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 232334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232342 */     GIR_RootConstrainSelectedInstOperands,
     /* 232343 */     // GIR_Coverage, 10286,
     /* 232343 */     GIR_EraseRootFromParent_Done,
     /* 232344 */   // Label 4622: @232344
     /* 232344 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232386), // Rule ID 11283 //
     /* 232349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 232352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 232357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 232376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232384 */     GIR_RootConstrainSelectedInstOperands,
     /* 232385 */     // GIR_Coverage, 11283,
     /* 232385 */     GIR_EraseRootFromParent_Done,
     /* 232386 */   // Label 4623: @232386
     /* 232386 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232428), // Rule ID 11284 //
     /* 232391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 232394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 232399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 232418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232426 */     GIR_RootConstrainSelectedInstOperands,
     /* 232427 */     // GIR_Coverage, 11284,
     /* 232427 */     GIR_EraseRootFromParent_Done,
     /* 232428 */   // Label 4624: @232428
     /* 232428 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232470), // Rule ID 11286 //
     /* 232433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 232436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 232441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 232460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232468 */     GIR_RootConstrainSelectedInstOperands,
     /* 232469 */     // GIR_Coverage, 11286,
     /* 232469 */     GIR_EraseRootFromParent_Done,
     /* 232470 */   // Label 4625: @232470
     /* 232470 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232512), // Rule ID 11287 //
     /* 232475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 232478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 232483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232499 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 232502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232510 */     GIR_RootConstrainSelectedInstOperands,
     /* 232511 */     // GIR_Coverage, 11287,
     /* 232511 */     GIR_EraseRootFromParent_Done,
     /* 232512 */   // Label 4626: @232512
     /* 232512 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232554), // Rule ID 11341 //
     /* 232517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 232544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232552 */     GIR_RootConstrainSelectedInstOperands,
     /* 232553 */     // GIR_Coverage, 11341,
     /* 232553 */     GIR_EraseRootFromParent_Done,
     /* 232554 */   // Label 4627: @232554
     /* 232554 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232596), // Rule ID 11342 //
     /* 232559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 232586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232594 */     GIR_RootConstrainSelectedInstOperands,
     /* 232595 */     // GIR_Coverage, 11342,
     /* 232595 */     GIR_EraseRootFromParent_Done,
     /* 232596 */   // Label 4628: @232596
     /* 232596 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232638), // Rule ID 11343 //
     /* 232601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 232628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232636 */     GIR_RootConstrainSelectedInstOperands,
     /* 232637 */     // GIR_Coverage, 11343,
     /* 232637 */     GIR_EraseRootFromParent_Done,
     /* 232638 */   // Label 4629: @232638
     /* 232638 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232680), // Rule ID 11344 //
     /* 232643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 232670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232678 */     GIR_RootConstrainSelectedInstOperands,
     /* 232679 */     // GIR_Coverage, 11344,
     /* 232679 */     GIR_EraseRootFromParent_Done,
     /* 232680 */   // Label 4630: @232680
     /* 232680 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232722), // Rule ID 11397 //
     /* 232685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 232712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232720 */     GIR_RootConstrainSelectedInstOperands,
     /* 232721 */     // GIR_Coverage, 11397,
     /* 232721 */     GIR_EraseRootFromParent_Done,
     /* 232722 */   // Label 4631: @232722
     /* 232722 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232764), // Rule ID 11398 //
     /* 232727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 232754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232762 */     GIR_RootConstrainSelectedInstOperands,
     /* 232763 */     // GIR_Coverage, 11398,
     /* 232763 */     GIR_EraseRootFromParent_Done,
     /* 232764 */   // Label 4632: @232764
     /* 232764 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232806), // Rule ID 11399 //
     /* 232769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 232796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232804 */     GIR_RootConstrainSelectedInstOperands,
     /* 232805 */     // GIR_Coverage, 11399,
     /* 232805 */     GIR_EraseRootFromParent_Done,
     /* 232806 */   // Label 4633: @232806
     /* 232806 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232848), // Rule ID 11400 //
     /* 232811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 232838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232846 */     GIR_RootConstrainSelectedInstOperands,
     /* 232847 */     // GIR_Coverage, 11400,
     /* 232847 */     GIR_EraseRootFromParent_Done,
     /* 232848 */   // Label 4634: @232848
     /* 232848 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232890), // Rule ID 11401 //
     /* 232853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 232880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232888 */     GIR_RootConstrainSelectedInstOperands,
     /* 232889 */     // GIR_Coverage, 11401,
     /* 232889 */     GIR_EraseRootFromParent_Done,
     /* 232890 */   // Label 4635: @232890
     /* 232890 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232932), // Rule ID 11402 //
     /* 232895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 232922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232930 */     GIR_RootConstrainSelectedInstOperands,
     /* 232931 */     // GIR_Coverage, 11402,
     /* 232931 */     GIR_EraseRootFromParent_Done,
     /* 232932 */   // Label 4636: @232932
     /* 232932 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232974), // Rule ID 11403 //
     /* 232937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 232945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 232964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232972 */     GIR_RootConstrainSelectedInstOperands,
     /* 232973 */     // GIR_Coverage, 11403,
     /* 232973 */     GIR_EraseRootFromParent_Done,
     /* 232974 */   // Label 4637: @232974
     /* 232974 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(233016), // Rule ID 11404 //
     /* 232979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 232987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 233006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233014 */     GIR_RootConstrainSelectedInstOperands,
     /* 233015 */     // GIR_Coverage, 11404,
     /* 233015 */     GIR_EraseRootFromParent_Done,
     /* 233016 */   // Label 4638: @233016
     /* 233016 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(233058), // Rule ID 11405 //
     /* 233021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 233029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 233048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233056 */     GIR_RootConstrainSelectedInstOperands,
     /* 233057 */     // GIR_Coverage, 11405,
     /* 233057 */     GIR_EraseRootFromParent_Done,
     /* 233058 */   // Label 4639: @233058
     /* 233058 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(233100), // Rule ID 11406 //
     /* 233063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 233090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233098 */     GIR_RootConstrainSelectedInstOperands,
     /* 233099 */     // GIR_Coverage, 11406,
     /* 233099 */     GIR_EraseRootFromParent_Done,
     /* 233100 */   // Label 4640: @233100
     /* 233100 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(233142), // Rule ID 11407 //
     /* 233105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 233132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233140 */     GIR_RootConstrainSelectedInstOperands,
     /* 233141 */     // GIR_Coverage, 11407,
     /* 233141 */     GIR_EraseRootFromParent_Done,
     /* 233142 */   // Label 4641: @233142
     /* 233142 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233184), // Rule ID 11408 //
     /* 233147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 233174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233182 */     GIR_RootConstrainSelectedInstOperands,
     /* 233183 */     // GIR_Coverage, 11408,
     /* 233183 */     GIR_EraseRootFromParent_Done,
     /* 233184 */   // Label 4642: @233184
     /* 233184 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233226), // Rule ID 11409 //
     /* 233189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 233216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233224 */     GIR_RootConstrainSelectedInstOperands,
     /* 233225 */     // GIR_Coverage, 11409,
     /* 233225 */     GIR_EraseRootFromParent_Done,
     /* 233226 */   // Label 4643: @233226
     /* 233226 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233268), // Rule ID 11410 //
     /* 233231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 233258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233266 */     GIR_RootConstrainSelectedInstOperands,
     /* 233267 */     // GIR_Coverage, 11410,
     /* 233267 */     GIR_EraseRootFromParent_Done,
     /* 233268 */   // Label 4644: @233268
     /* 233268 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233310), // Rule ID 11411 //
     /* 233273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 233300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233308 */     GIR_RootConstrainSelectedInstOperands,
     /* 233309 */     // GIR_Coverage, 11411,
     /* 233309 */     GIR_EraseRootFromParent_Done,
     /* 233310 */   // Label 4645: @233310
     /* 233310 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233352), // Rule ID 11412 //
     /* 233315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 233342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233350 */     GIR_RootConstrainSelectedInstOperands,
     /* 233351 */     // GIR_Coverage, 11412,
     /* 233351 */     GIR_EraseRootFromParent_Done,
     /* 233352 */   // Label 4646: @233352
     /* 233352 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233394), // Rule ID 11413 //
     /* 233357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 233384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233392 */     GIR_RootConstrainSelectedInstOperands,
     /* 233393 */     // GIR_Coverage, 11413,
     /* 233393 */     GIR_EraseRootFromParent_Done,
     /* 233394 */   // Label 4647: @233394
     /* 233394 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233436), // Rule ID 11414 //
     /* 233399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 233426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233434 */     GIR_RootConstrainSelectedInstOperands,
     /* 233435 */     // GIR_Coverage, 11414,
     /* 233435 */     GIR_EraseRootFromParent_Done,
     /* 233436 */   // Label 4648: @233436
     /* 233436 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233478), // Rule ID 11415 //
     /* 233441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 233468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233476 */     GIR_RootConstrainSelectedInstOperands,
     /* 233477 */     // GIR_Coverage, 11415,
     /* 233477 */     GIR_EraseRootFromParent_Done,
     /* 233478 */   // Label 4649: @233478
     /* 233478 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233520), // Rule ID 11416 //
     /* 233483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 233510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233518 */     GIR_RootConstrainSelectedInstOperands,
     /* 233519 */     // GIR_Coverage, 11416,
     /* 233519 */     GIR_EraseRootFromParent_Done,
     /* 233520 */   // Label 4650: @233520
     /* 233520 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233562), // Rule ID 11417 //
     /* 233525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 233552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233560 */     GIR_RootConstrainSelectedInstOperands,
     /* 233561 */     // GIR_Coverage, 11417,
     /* 233561 */     GIR_EraseRootFromParent_Done,
     /* 233562 */   // Label 4651: @233562
     /* 233562 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233604), // Rule ID 11426 //
     /* 233567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 233594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233602 */     GIR_RootConstrainSelectedInstOperands,
     /* 233603 */     // GIR_Coverage, 11426,
     /* 233603 */     GIR_EraseRootFromParent_Done,
     /* 233604 */   // Label 4652: @233604
     /* 233604 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233646), // Rule ID 11427 //
     /* 233609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 233636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233644 */     GIR_RootConstrainSelectedInstOperands,
     /* 233645 */     // GIR_Coverage, 11427,
     /* 233645 */     GIR_EraseRootFromParent_Done,
     /* 233646 */   // Label 4653: @233646
     /* 233646 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233688), // Rule ID 11428 //
     /* 233651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 233678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233686 */     GIR_RootConstrainSelectedInstOperands,
     /* 233687 */     // GIR_Coverage, 11428,
     /* 233687 */     GIR_EraseRootFromParent_Done,
     /* 233688 */   // Label 4654: @233688
     /* 233688 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233730), // Rule ID 11429 //
     /* 233693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 233720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233728 */     GIR_RootConstrainSelectedInstOperands,
     /* 233729 */     // GIR_Coverage, 11429,
     /* 233729 */     GIR_EraseRootFromParent_Done,
     /* 233730 */   // Label 4655: @233730
     /* 233730 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233772), // Rule ID 11430 //
     /* 233735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 233762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233770 */     GIR_RootConstrainSelectedInstOperands,
     /* 233771 */     // GIR_Coverage, 11430,
     /* 233771 */     GIR_EraseRootFromParent_Done,
     /* 233772 */   // Label 4656: @233772
     /* 233772 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233814), // Rule ID 11431 //
     /* 233777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 233804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233812 */     GIR_RootConstrainSelectedInstOperands,
     /* 233813 */     // GIR_Coverage, 11431,
     /* 233813 */     GIR_EraseRootFromParent_Done,
     /* 233814 */   // Label 4657: @233814
     /* 233814 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233856), // Rule ID 11432 //
     /* 233819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 233846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233854 */     GIR_RootConstrainSelectedInstOperands,
     /* 233855 */     // GIR_Coverage, 11432,
     /* 233855 */     GIR_EraseRootFromParent_Done,
     /* 233856 */   // Label 4658: @233856
     /* 233856 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233898), // Rule ID 11433 //
     /* 233861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 233888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233896 */     GIR_RootConstrainSelectedInstOperands,
     /* 233897 */     // GIR_Coverage, 11433,
     /* 233897 */     GIR_EraseRootFromParent_Done,
     /* 233898 */   // Label 4659: @233898
     /* 233898 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233940), // Rule ID 11434 //
     /* 233903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 233930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233938 */     GIR_RootConstrainSelectedInstOperands,
     /* 233939 */     // GIR_Coverage, 11434,
     /* 233939 */     GIR_EraseRootFromParent_Done,
     /* 233940 */   // Label 4660: @233940
     /* 233940 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233982), // Rule ID 11435 //
     /* 233945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 233953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 233972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233980 */     GIR_RootConstrainSelectedInstOperands,
     /* 233981 */     // GIR_Coverage, 11435,
     /* 233981 */     GIR_EraseRootFromParent_Done,
     /* 233982 */   // Label 4661: @233982
     /* 233982 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(234024), // Rule ID 11436 //
     /* 233987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 233995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 234014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234022 */     GIR_RootConstrainSelectedInstOperands,
     /* 234023 */     // GIR_Coverage, 11436,
     /* 234023 */     GIR_EraseRootFromParent_Done,
     /* 234024 */   // Label 4662: @234024
     /* 234024 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(234066), // Rule ID 11437 //
     /* 234029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 234037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 234056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234064 */     GIR_RootConstrainSelectedInstOperands,
     /* 234065 */     // GIR_Coverage, 11437,
     /* 234065 */     GIR_EraseRootFromParent_Done,
     /* 234066 */   // Label 4663: @234066
     /* 234066 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(234108), // Rule ID 11438 //
     /* 234071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 234098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234106 */     GIR_RootConstrainSelectedInstOperands,
     /* 234107 */     // GIR_Coverage, 11438,
     /* 234107 */     GIR_EraseRootFromParent_Done,
     /* 234108 */   // Label 4664: @234108
     /* 234108 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234150), // Rule ID 11439 //
     /* 234113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 234140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234148 */     GIR_RootConstrainSelectedInstOperands,
     /* 234149 */     // GIR_Coverage, 11439,
     /* 234149 */     GIR_EraseRootFromParent_Done,
     /* 234150 */   // Label 4665: @234150
     /* 234150 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234192), // Rule ID 11440 //
     /* 234155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 234182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234190 */     GIR_RootConstrainSelectedInstOperands,
     /* 234191 */     // GIR_Coverage, 11440,
     /* 234191 */     GIR_EraseRootFromParent_Done,
     /* 234192 */   // Label 4666: @234192
     /* 234192 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234234), // Rule ID 11441 //
     /* 234197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 234224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234232 */     GIR_RootConstrainSelectedInstOperands,
     /* 234233 */     // GIR_Coverage, 11441,
     /* 234233 */     GIR_EraseRootFromParent_Done,
     /* 234234 */   // Label 4667: @234234
     /* 234234 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234276), // Rule ID 11442 //
     /* 234239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 234266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234274 */     GIR_RootConstrainSelectedInstOperands,
     /* 234275 */     // GIR_Coverage, 11442,
     /* 234275 */     GIR_EraseRootFromParent_Done,
     /* 234276 */   // Label 4668: @234276
     /* 234276 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234318), // Rule ID 11443 //
     /* 234281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 234308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234316 */     GIR_RootConstrainSelectedInstOperands,
     /* 234317 */     // GIR_Coverage, 11443,
     /* 234317 */     GIR_EraseRootFromParent_Done,
     /* 234318 */   // Label 4669: @234318
     /* 234318 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234360), // Rule ID 11444 //
     /* 234323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 234350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234358 */     GIR_RootConstrainSelectedInstOperands,
     /* 234359 */     // GIR_Coverage, 11444,
     /* 234359 */     GIR_EraseRootFromParent_Done,
     /* 234360 */   // Label 4670: @234360
     /* 234360 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234402), // Rule ID 11446 //
     /* 234365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 234392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234400 */     GIR_RootConstrainSelectedInstOperands,
     /* 234401 */     // GIR_Coverage, 11446,
     /* 234401 */     GIR_EraseRootFromParent_Done,
     /* 234402 */   // Label 4671: @234402
     /* 234402 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234444), // Rule ID 11448 //
     /* 234407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 234434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234442 */     GIR_RootConstrainSelectedInstOperands,
     /* 234443 */     // GIR_Coverage, 11448,
     /* 234443 */     GIR_EraseRootFromParent_Done,
     /* 234444 */   // Label 4672: @234444
     /* 234444 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234486), // Rule ID 11450 //
     /* 234449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 234476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234484 */     GIR_RootConstrainSelectedInstOperands,
     /* 234485 */     // GIR_Coverage, 11450,
     /* 234485 */     GIR_EraseRootFromParent_Done,
     /* 234486 */   // Label 4673: @234486
     /* 234486 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234528), // Rule ID 11452 //
     /* 234491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234515 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 234518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234526 */     GIR_RootConstrainSelectedInstOperands,
     /* 234527 */     // GIR_Coverage, 11452,
     /* 234527 */     GIR_EraseRootFromParent_Done,
     /* 234528 */   // Label 4674: @234528
     /* 234528 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234570), // Rule ID 11453 //
     /* 234533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234557 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 234560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234568 */     GIR_RootConstrainSelectedInstOperands,
     /* 234569 */     // GIR_Coverage, 11453,
     /* 234569 */     GIR_EraseRootFromParent_Done,
     /* 234570 */   // Label 4675: @234570
     /* 234570 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234612), // Rule ID 11454 //
     /* 234575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 234602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234610 */     GIR_RootConstrainSelectedInstOperands,
     /* 234611 */     // GIR_Coverage, 11454,
     /* 234611 */     GIR_EraseRootFromParent_Done,
     /* 234612 */   // Label 4676: @234612
     /* 234612 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234654), // Rule ID 11455 //
     /* 234617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 234644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234652 */     GIR_RootConstrainSelectedInstOperands,
     /* 234653 */     // GIR_Coverage, 11455,
     /* 234653 */     GIR_EraseRootFromParent_Done,
     /* 234654 */   // Label 4677: @234654
     /* 234654 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234696), // Rule ID 11456 //
     /* 234659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234683 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 234686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234694 */     GIR_RootConstrainSelectedInstOperands,
     /* 234695 */     // GIR_Coverage, 11456,
     /* 234695 */     GIR_EraseRootFromParent_Done,
     /* 234696 */   // Label 4678: @234696
     /* 234696 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234738), // Rule ID 11457 //
     /* 234701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 234728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234736 */     GIR_RootConstrainSelectedInstOperands,
     /* 234737 */     // GIR_Coverage, 11457,
     /* 234737 */     GIR_EraseRootFromParent_Done,
     /* 234738 */   // Label 4679: @234738
     /* 234738 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234780), // Rule ID 11458 //
     /* 234743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 234770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234778 */     GIR_RootConstrainSelectedInstOperands,
     /* 234779 */     // GIR_Coverage, 11458,
     /* 234779 */     GIR_EraseRootFromParent_Done,
     /* 234780 */   // Label 4680: @234780
     /* 234780 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234822), // Rule ID 11459 //
     /* 234785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 234812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234820 */     GIR_RootConstrainSelectedInstOperands,
     /* 234821 */     // GIR_Coverage, 11459,
     /* 234821 */     GIR_EraseRootFromParent_Done,
     /* 234822 */   // Label 4681: @234822
     /* 234822 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234864), // Rule ID 11460 //
     /* 234827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234851 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 234854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234862 */     GIR_RootConstrainSelectedInstOperands,
     /* 234863 */     // GIR_Coverage, 11460,
     /* 234863 */     GIR_EraseRootFromParent_Done,
     /* 234864 */   // Label 4682: @234864
     /* 234864 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234906), // Rule ID 11462 //
     /* 234869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 234896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234904 */     GIR_RootConstrainSelectedInstOperands,
     /* 234905 */     // GIR_Coverage, 11462,
     /* 234905 */     GIR_EraseRootFromParent_Done,
     /* 234906 */   // Label 4683: @234906
     /* 234906 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234948), // Rule ID 11464 //
     /* 234911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 234938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234946 */     GIR_RootConstrainSelectedInstOperands,
     /* 234947 */     // GIR_Coverage, 11464,
     /* 234947 */     GIR_EraseRootFromParent_Done,
     /* 234948 */   // Label 4684: @234948
     /* 234948 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234990), // Rule ID 11466 //
     /* 234953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 234980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234988 */     GIR_RootConstrainSelectedInstOperands,
     /* 234989 */     // GIR_Coverage, 11466,
     /* 234989 */     GIR_EraseRootFromParent_Done,
     /* 234990 */   // Label 4685: @234990
     /* 234990 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(235032), // Rule ID 11468 //
     /* 234995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 235022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235030 */     GIR_RootConstrainSelectedInstOperands,
     /* 235031 */     // GIR_Coverage, 11468,
     /* 235031 */     GIR_EraseRootFromParent_Done,
     /* 235032 */   // Label 4686: @235032
     /* 235032 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(235074), // Rule ID 11470 //
     /* 235037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 235064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235072 */     GIR_RootConstrainSelectedInstOperands,
     /* 235073 */     // GIR_Coverage, 11470,
     /* 235073 */     GIR_EraseRootFromParent_Done,
     /* 235074 */   // Label 4687: @235074
     /* 235074 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(235116), // Rule ID 11472 //
     /* 235079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235103 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 235106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235114 */     GIR_RootConstrainSelectedInstOperands,
     /* 235115 */     // GIR_Coverage, 11472,
     /* 235115 */     GIR_EraseRootFromParent_Done,
     /* 235116 */   // Label 4688: @235116
     /* 235116 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235158), // Rule ID 11474 //
     /* 235121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 235148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235156 */     GIR_RootConstrainSelectedInstOperands,
     /* 235157 */     // GIR_Coverage, 11474,
     /* 235157 */     GIR_EraseRootFromParent_Done,
     /* 235158 */   // Label 4689: @235158
     /* 235158 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235200), // Rule ID 11476 //
     /* 235163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235187 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 235190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235198 */     GIR_RootConstrainSelectedInstOperands,
     /* 235199 */     // GIR_Coverage, 11476,
     /* 235199 */     GIR_EraseRootFromParent_Done,
     /* 235200 */   // Label 4690: @235200
     /* 235200 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235242), // Rule ID 11477 //
     /* 235205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 235232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235240 */     GIR_RootConstrainSelectedInstOperands,
     /* 235241 */     // GIR_Coverage, 11477,
     /* 235241 */     GIR_EraseRootFromParent_Done,
     /* 235242 */   // Label 4691: @235242
     /* 235242 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235284), // Rule ID 11478 //
     /* 235247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 235274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235282 */     GIR_RootConstrainSelectedInstOperands,
     /* 235283 */     // GIR_Coverage, 11478,
     /* 235283 */     GIR_EraseRootFromParent_Done,
     /* 235284 */   // Label 4692: @235284
     /* 235284 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235326), // Rule ID 11479 //
     /* 235289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235313 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 235316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235324 */     GIR_RootConstrainSelectedInstOperands,
     /* 235325 */     // GIR_Coverage, 11479,
     /* 235325 */     GIR_EraseRootFromParent_Done,
     /* 235326 */   // Label 4693: @235326
     /* 235326 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235368), // Rule ID 11480 //
     /* 235331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 235358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235366 */     GIR_RootConstrainSelectedInstOperands,
     /* 235367 */     // GIR_Coverage, 11480,
     /* 235367 */     GIR_EraseRootFromParent_Done,
     /* 235368 */   // Label 4694: @235368
     /* 235368 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235410), // Rule ID 11481 //
     /* 235373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 235400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235408 */     GIR_RootConstrainSelectedInstOperands,
     /* 235409 */     // GIR_Coverage, 11481,
     /* 235409 */     GIR_EraseRootFromParent_Done,
     /* 235410 */   // Label 4695: @235410
     /* 235410 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235452), // Rule ID 11482 //
     /* 235415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 235442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235450 */     GIR_RootConstrainSelectedInstOperands,
     /* 235451 */     // GIR_Coverage, 11482,
     /* 235451 */     GIR_EraseRootFromParent_Done,
     /* 235452 */   // Label 4696: @235452
     /* 235452 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235494), // Rule ID 11483 //
     /* 235457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 235484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235492 */     GIR_RootConstrainSelectedInstOperands,
     /* 235493 */     // GIR_Coverage, 11483,
     /* 235493 */     GIR_EraseRootFromParent_Done,
     /* 235494 */   // Label 4697: @235494
     /* 235494 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235536), // Rule ID 11484 //
     /* 235499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 235526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235534 */     GIR_RootConstrainSelectedInstOperands,
     /* 235535 */     // GIR_Coverage, 11484,
     /* 235535 */     GIR_EraseRootFromParent_Done,
     /* 235536 */   // Label 4698: @235536
     /* 235536 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235578), // Rule ID 11485 //
     /* 235541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 235568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235576 */     GIR_RootConstrainSelectedInstOperands,
     /* 235577 */     // GIR_Coverage, 11485,
     /* 235577 */     GIR_EraseRootFromParent_Done,
     /* 235578 */   // Label 4699: @235578
     /* 235578 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235620), // Rule ID 11486 //
     /* 235583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235607 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 235610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235618 */     GIR_RootConstrainSelectedInstOperands,
     /* 235619 */     // GIR_Coverage, 11486,
     /* 235619 */     GIR_EraseRootFromParent_Done,
     /* 235620 */   // Label 4700: @235620
     /* 235620 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235662), // Rule ID 11487 //
     /* 235625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 235652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235660 */     GIR_RootConstrainSelectedInstOperands,
     /* 235661 */     // GIR_Coverage, 11487,
     /* 235661 */     GIR_EraseRootFromParent_Done,
     /* 235662 */   // Label 4701: @235662
     /* 235662 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235704), // Rule ID 11488 //
     /* 235667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 235694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235702 */     GIR_RootConstrainSelectedInstOperands,
     /* 235703 */     // GIR_Coverage, 11488,
     /* 235703 */     GIR_EraseRootFromParent_Done,
     /* 235704 */   // Label 4702: @235704
     /* 235704 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235746), // Rule ID 11489 //
     /* 235709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 235736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235744 */     GIR_RootConstrainSelectedInstOperands,
     /* 235745 */     // GIR_Coverage, 11489,
     /* 235745 */     GIR_EraseRootFromParent_Done,
     /* 235746 */   // Label 4703: @235746
     /* 235746 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235788), // Rule ID 11490 //
     /* 235751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 235778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235786 */     GIR_RootConstrainSelectedInstOperands,
     /* 235787 */     // GIR_Coverage, 11490,
     /* 235787 */     GIR_EraseRootFromParent_Done,
     /* 235788 */   // Label 4704: @235788
     /* 235788 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235830), // Rule ID 11491 //
     /* 235793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235817 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 235820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235828 */     GIR_RootConstrainSelectedInstOperands,
     /* 235829 */     // GIR_Coverage, 11491,
     /* 235829 */     GIR_EraseRootFromParent_Done,
     /* 235830 */   // Label 4705: @235830
     /* 235830 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235872), // Rule ID 11492 //
     /* 235835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 235862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235870 */     GIR_RootConstrainSelectedInstOperands,
     /* 235871 */     // GIR_Coverage, 11492,
     /* 235871 */     GIR_EraseRootFromParent_Done,
     /* 235872 */   // Label 4706: @235872
     /* 235872 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235914), // Rule ID 11493 //
     /* 235877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 235904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235912 */     GIR_RootConstrainSelectedInstOperands,
     /* 235913 */     // GIR_Coverage, 11493,
     /* 235913 */     GIR_EraseRootFromParent_Done,
     /* 235914 */   // Label 4707: @235914
     /* 235914 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235956), // Rule ID 11494 //
     /* 235919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 235946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235954 */     GIR_RootConstrainSelectedInstOperands,
     /* 235955 */     // GIR_Coverage, 11494,
     /* 235955 */     GIR_EraseRootFromParent_Done,
     /* 235956 */   // Label 4708: @235956
     /* 235956 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235998), // Rule ID 11495 //
     /* 235961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 235969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235985 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 235988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235996 */     GIR_RootConstrainSelectedInstOperands,
     /* 235997 */     // GIR_Coverage, 11495,
     /* 235997 */     GIR_EraseRootFromParent_Done,
     /* 235998 */   // Label 4709: @235998
     /* 235998 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(236040), // Rule ID 11496 //
     /* 236003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 236030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236038 */     GIR_RootConstrainSelectedInstOperands,
     /* 236039 */     // GIR_Coverage, 11496,
     /* 236039 */     GIR_EraseRootFromParent_Done,
     /* 236040 */   // Label 4710: @236040
     /* 236040 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(236082), // Rule ID 11497 //
     /* 236045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 236072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236080 */     GIR_RootConstrainSelectedInstOperands,
     /* 236081 */     // GIR_Coverage, 11497,
     /* 236081 */     GIR_EraseRootFromParent_Done,
     /* 236082 */   // Label 4711: @236082
     /* 236082 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(236124), // Rule ID 11498 //
     /* 236087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 236114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236122 */     GIR_RootConstrainSelectedInstOperands,
     /* 236123 */     // GIR_Coverage, 11498,
     /* 236123 */     GIR_EraseRootFromParent_Done,
     /* 236124 */   // Label 4712: @236124
     /* 236124 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236166), // Rule ID 11499 //
     /* 236129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236153 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 236156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236164 */     GIR_RootConstrainSelectedInstOperands,
     /* 236165 */     // GIR_Coverage, 11499,
     /* 236165 */     GIR_EraseRootFromParent_Done,
     /* 236166 */   // Label 4713: @236166
     /* 236166 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236208), // Rule ID 11500 //
     /* 236171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 236198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236206 */     GIR_RootConstrainSelectedInstOperands,
     /* 236207 */     // GIR_Coverage, 11500,
     /* 236207 */     GIR_EraseRootFromParent_Done,
     /* 236208 */   // Label 4714: @236208
     /* 236208 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236250), // Rule ID 11501 //
     /* 236213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 236240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236248 */     GIR_RootConstrainSelectedInstOperands,
     /* 236249 */     // GIR_Coverage, 11501,
     /* 236249 */     GIR_EraseRootFromParent_Done,
     /* 236250 */   // Label 4715: @236250
     /* 236250 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236292), // Rule ID 11502 //
     /* 236255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 236282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236290 */     GIR_RootConstrainSelectedInstOperands,
     /* 236291 */     // GIR_Coverage, 11502,
     /* 236291 */     GIR_EraseRootFromParent_Done,
     /* 236292 */   // Label 4716: @236292
     /* 236292 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236334), // Rule ID 11503 //
     /* 236297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236321 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 236324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236332 */     GIR_RootConstrainSelectedInstOperands,
     /* 236333 */     // GIR_Coverage, 11503,
     /* 236333 */     GIR_EraseRootFromParent_Done,
     /* 236334 */   // Label 4717: @236334
     /* 236334 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236376), // Rule ID 11504 //
     /* 236339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236363 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 236366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236374 */     GIR_RootConstrainSelectedInstOperands,
     /* 236375 */     // GIR_Coverage, 11504,
     /* 236375 */     GIR_EraseRootFromParent_Done,
     /* 236376 */   // Label 4718: @236376
     /* 236376 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236418), // Rule ID 11505 //
     /* 236381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 236408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236416 */     GIR_RootConstrainSelectedInstOperands,
     /* 236417 */     // GIR_Coverage, 11505,
     /* 236417 */     GIR_EraseRootFromParent_Done,
     /* 236418 */   // Label 4719: @236418
     /* 236418 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236460), // Rule ID 11506 //
     /* 236423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236447 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 236450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236458 */     GIR_RootConstrainSelectedInstOperands,
     /* 236459 */     // GIR_Coverage, 11506,
     /* 236459 */     GIR_EraseRootFromParent_Done,
     /* 236460 */   // Label 4720: @236460
     /* 236460 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236502), // Rule ID 11507 //
     /* 236465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 236473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 236492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236500 */     GIR_RootConstrainSelectedInstOperands,
     /* 236501 */     // GIR_Coverage, 11507,
     /* 236501 */     GIR_EraseRootFromParent_Done,
     /* 236502 */   // Label 4721: @236502
     /* 236502 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236544), // Rule ID 11518 //
     /* 236507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 236524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 236534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236542 */     GIR_RootConstrainSelectedInstOperands,
     /* 236543 */     // GIR_Coverage, 11518,
     /* 236543 */     GIR_EraseRootFromParent_Done,
     /* 236544 */   // Label 4722: @236544
     /* 236544 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236586), // Rule ID 11519 //
     /* 236549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 236576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236584 */     GIR_RootConstrainSelectedInstOperands,
     /* 236585 */     // GIR_Coverage, 11519,
     /* 236585 */     GIR_EraseRootFromParent_Done,
     /* 236586 */   // Label 4723: @236586
     /* 236586 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236628), // Rule ID 11520 //
     /* 236591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 236618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236626 */     GIR_RootConstrainSelectedInstOperands,
     /* 236627 */     // GIR_Coverage, 11520,
     /* 236627 */     GIR_EraseRootFromParent_Done,
     /* 236628 */   // Label 4724: @236628
     /* 236628 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236670), // Rule ID 11521 //
     /* 236633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 236660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236668 */     GIR_RootConstrainSelectedInstOperands,
     /* 236669 */     // GIR_Coverage, 11521,
     /* 236669 */     GIR_EraseRootFromParent_Done,
     /* 236670 */   // Label 4725: @236670
     /* 236670 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236712), // Rule ID 11530 //
     /* 236675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 236702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236710 */     GIR_RootConstrainSelectedInstOperands,
     /* 236711 */     // GIR_Coverage, 11530,
     /* 236711 */     GIR_EraseRootFromParent_Done,
     /* 236712 */   // Label 4726: @236712
     /* 236712 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236754), // Rule ID 11531 //
     /* 236717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 236744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236752 */     GIR_RootConstrainSelectedInstOperands,
     /* 236753 */     // GIR_Coverage, 11531,
     /* 236753 */     GIR_EraseRootFromParent_Done,
     /* 236754 */   // Label 4727: @236754
     /* 236754 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236796), // Rule ID 11532 //
     /* 236759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 236786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236794 */     GIR_RootConstrainSelectedInstOperands,
     /* 236795 */     // GIR_Coverage, 11532,
     /* 236795 */     GIR_EraseRootFromParent_Done,
     /* 236796 */   // Label 4728: @236796
     /* 236796 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236838), // Rule ID 11533 //
     /* 236801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 236828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236836 */     GIR_RootConstrainSelectedInstOperands,
     /* 236837 */     // GIR_Coverage, 11533,
     /* 236837 */     GIR_EraseRootFromParent_Done,
     /* 236838 */   // Label 4729: @236838
     /* 236838 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236880), // Rule ID 11534 //
     /* 236843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1996:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 236870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236878 */     GIR_RootConstrainSelectedInstOperands,
     /* 236879 */     // GIR_Coverage, 11534,
     /* 236879 */     GIR_EraseRootFromParent_Done,
     /* 236880 */   // Label 4730: @236880
     /* 236880 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236922), // Rule ID 11535 //
     /* 236885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 236912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236920 */     GIR_RootConstrainSelectedInstOperands,
     /* 236921 */     // GIR_Coverage, 11535,
     /* 236921 */     GIR_EraseRootFromParent_Done,
     /* 236922 */   // Label 4731: @236922
     /* 236922 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236964), // Rule ID 11536 //
     /* 236927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 236954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236962 */     GIR_RootConstrainSelectedInstOperands,
     /* 236963 */     // GIR_Coverage, 11536,
     /* 236963 */     GIR_EraseRootFromParent_Done,
     /* 236964 */   // Label 4732: @236964
     /* 236964 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(237006), // Rule ID 11537 //
     /* 236969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 236996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237004 */     GIR_RootConstrainSelectedInstOperands,
     /* 237005 */     // GIR_Coverage, 11537,
     /* 237005 */     GIR_EraseRootFromParent_Done,
     /* 237006 */   // Label 4733: @237006
     /* 237006 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(237048), // Rule ID 11538 //
     /* 237011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237046 */     GIR_RootConstrainSelectedInstOperands,
     /* 237047 */     // GIR_Coverage, 11538,
     /* 237047 */     GIR_EraseRootFromParent_Done,
     /* 237048 */   // Label 4734: @237048
     /* 237048 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(237090), // Rule ID 11539 //
     /* 237053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 237080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237088 */     GIR_RootConstrainSelectedInstOperands,
     /* 237089 */     // GIR_Coverage, 11539,
     /* 237089 */     GIR_EraseRootFromParent_Done,
     /* 237090 */   // Label 4735: @237090
     /* 237090 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(237132), // Rule ID 11540 //
     /* 237095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 237122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237130 */     GIR_RootConstrainSelectedInstOperands,
     /* 237131 */     // GIR_Coverage, 11540,
     /* 237131 */     GIR_EraseRootFromParent_Done,
     /* 237132 */   // Label 4736: @237132
     /* 237132 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237174), // Rule ID 11541 //
     /* 237137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 237164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237172 */     GIR_RootConstrainSelectedInstOperands,
     /* 237173 */     // GIR_Coverage, 11541,
     /* 237173 */     GIR_EraseRootFromParent_Done,
     /* 237174 */   // Label 4737: @237174
     /* 237174 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237216), // Rule ID 11542 //
     /* 237179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 237206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237214 */     GIR_RootConstrainSelectedInstOperands,
     /* 237215 */     // GIR_Coverage, 11542,
     /* 237215 */     GIR_EraseRootFromParent_Done,
     /* 237216 */   // Label 4738: @237216
     /* 237216 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237258), // Rule ID 11543 //
     /* 237221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237256 */     GIR_RootConstrainSelectedInstOperands,
     /* 237257 */     // GIR_Coverage, 11543,
     /* 237257 */     GIR_EraseRootFromParent_Done,
     /* 237258 */   // Label 4739: @237258
     /* 237258 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237300), // Rule ID 11544 //
     /* 237263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 237290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237298 */     GIR_RootConstrainSelectedInstOperands,
     /* 237299 */     // GIR_Coverage, 11544,
     /* 237299 */     GIR_EraseRootFromParent_Done,
     /* 237300 */   // Label 4740: @237300
     /* 237300 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237342), // Rule ID 11545 //
     /* 237305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237340 */     GIR_RootConstrainSelectedInstOperands,
     /* 237341 */     // GIR_Coverage, 11545,
     /* 237341 */     GIR_EraseRootFromParent_Done,
     /* 237342 */   // Label 4741: @237342
     /* 237342 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237384), // Rule ID 11546 //
     /* 237347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 237374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237382 */     GIR_RootConstrainSelectedInstOperands,
     /* 237383 */     // GIR_Coverage, 11546,
     /* 237383 */     GIR_EraseRootFromParent_Done,
     /* 237384 */   // Label 4742: @237384
     /* 237384 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237426), // Rule ID 11547 //
     /* 237389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237424 */     GIR_RootConstrainSelectedInstOperands,
     /* 237425 */     // GIR_Coverage, 11547,
     /* 237425 */     GIR_EraseRootFromParent_Done,
     /* 237426 */   // Label 4743: @237426
     /* 237426 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237468), // Rule ID 11548 //
     /* 237431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237466 */     GIR_RootConstrainSelectedInstOperands,
     /* 237467 */     // GIR_Coverage, 11548,
     /* 237467 */     GIR_EraseRootFromParent_Done,
     /* 237468 */   // Label 4744: @237468
     /* 237468 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237510), // Rule ID 11549 //
     /* 237473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 237500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237508 */     GIR_RootConstrainSelectedInstOperands,
     /* 237509 */     // GIR_Coverage, 11549,
     /* 237509 */     GIR_EraseRootFromParent_Done,
     /* 237510 */   // Label 4745: @237510
     /* 237510 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237552), // Rule ID 11550 //
     /* 237515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2061:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 237542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237550 */     GIR_RootConstrainSelectedInstOperands,
     /* 237551 */     // GIR_Coverage, 11550,
     /* 237551 */     GIR_EraseRootFromParent_Done,
     /* 237552 */   // Label 4746: @237552
     /* 237552 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237594), // Rule ID 11551 //
     /* 237557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2061:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237592 */     GIR_RootConstrainSelectedInstOperands,
     /* 237593 */     // GIR_Coverage, 11551,
     /* 237593 */     GIR_EraseRootFromParent_Done,
     /* 237594 */   // Label 4747: @237594
     /* 237594 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237636), // Rule ID 11552 //
     /* 237599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237634 */     GIR_RootConstrainSelectedInstOperands,
     /* 237635 */     // GIR_Coverage, 11552,
     /* 237635 */     GIR_EraseRootFromParent_Done,
     /* 237636 */   // Label 4748: @237636
     /* 237636 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237678), // Rule ID 11553 //
     /* 237641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2061:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237676 */     GIR_RootConstrainSelectedInstOperands,
     /* 237677 */     // GIR_Coverage, 11553,
     /* 237677 */     GIR_EraseRootFromParent_Done,
     /* 237678 */   // Label 4749: @237678
     /* 237678 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237720), // Rule ID 11554 //
     /* 237683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237718 */     GIR_RootConstrainSelectedInstOperands,
     /* 237719 */     // GIR_Coverage, 11554,
     /* 237719 */     GIR_EraseRootFromParent_Done,
     /* 237720 */   // Label 4750: @237720
     /* 237720 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237762), // Rule ID 11555 //
     /* 237725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 237752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237760 */     GIR_RootConstrainSelectedInstOperands,
     /* 237761 */     // GIR_Coverage, 11555,
     /* 237761 */     GIR_EraseRootFromParent_Done,
     /* 237762 */   // Label 4751: @237762
     /* 237762 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237804), // Rule ID 11556 //
     /* 237767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237802 */     GIR_RootConstrainSelectedInstOperands,
     /* 237803 */     // GIR_Coverage, 11556,
     /* 237803 */     GIR_EraseRootFromParent_Done,
     /* 237804 */   // Label 4752: @237804
     /* 237804 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237846), // Rule ID 11557 //
     /* 237809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237833 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237844 */     GIR_RootConstrainSelectedInstOperands,
     /* 237845 */     // GIR_Coverage, 11557,
     /* 237845 */     GIR_EraseRootFromParent_Done,
     /* 237846 */   // Label 4753: @237846
     /* 237846 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237888), // Rule ID 11558 //
     /* 237851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237886 */     GIR_RootConstrainSelectedInstOperands,
     /* 237887 */     // GIR_Coverage, 11558,
     /* 237887 */     GIR_EraseRootFromParent_Done,
     /* 237888 */   // Label 4754: @237888
     /* 237888 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237930), // Rule ID 11559 //
     /* 237893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 237920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237928 */     GIR_RootConstrainSelectedInstOperands,
     /* 237929 */     // GIR_Coverage, 11559,
     /* 237929 */     GIR_EraseRootFromParent_Done,
     /* 237930 */   // Label 4755: @237930
     /* 237930 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237972), // Rule ID 11560 //
     /* 237935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 237962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237970 */     GIR_RootConstrainSelectedInstOperands,
     /* 237971 */     // GIR_Coverage, 11560,
     /* 237971 */     GIR_EraseRootFromParent_Done,
     /* 237972 */   // Label 4756: @237972
     /* 237972 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(238014), // Rule ID 11561 //
     /* 237977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238012 */     GIR_RootConstrainSelectedInstOperands,
     /* 238013 */     // GIR_Coverage, 11561,
     /* 238013 */     GIR_EraseRootFromParent_Done,
     /* 238014 */   // Label 4757: @238014
     /* 238014 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(238056), // Rule ID 11562 //
     /* 238019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238054 */     GIR_RootConstrainSelectedInstOperands,
     /* 238055 */     // GIR_Coverage, 11562,
     /* 238055 */     GIR_EraseRootFromParent_Done,
     /* 238056 */   // Label 4758: @238056
     /* 238056 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(238098), // Rule ID 11563 //
     /* 238061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 238088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238096 */     GIR_RootConstrainSelectedInstOperands,
     /* 238097 */     // GIR_Coverage, 11563,
     /* 238097 */     GIR_EraseRootFromParent_Done,
     /* 238098 */   // Label 4759: @238098
     /* 238098 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(238140), // Rule ID 11564 //
     /* 238103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 238130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238138 */     GIR_RootConstrainSelectedInstOperands,
     /* 238139 */     // GIR_Coverage, 11564,
     /* 238139 */     GIR_EraseRootFromParent_Done,
     /* 238140 */   // Label 4760: @238140
     /* 238140 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238182), // Rule ID 11565 //
     /* 238145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 238172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238180 */     GIR_RootConstrainSelectedInstOperands,
     /* 238181 */     // GIR_Coverage, 11565,
     /* 238181 */     GIR_EraseRootFromParent_Done,
     /* 238182 */   // Label 4761: @238182
     /* 238182 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238224), // Rule ID 11566 //
     /* 238187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238222 */     GIR_RootConstrainSelectedInstOperands,
     /* 238223 */     // GIR_Coverage, 11566,
     /* 238223 */     GIR_EraseRootFromParent_Done,
     /* 238224 */   // Label 4762: @238224
     /* 238224 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238266), // Rule ID 11567 //
     /* 238229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238264 */     GIR_RootConstrainSelectedInstOperands,
     /* 238265 */     // GIR_Coverage, 11567,
     /* 238265 */     GIR_EraseRootFromParent_Done,
     /* 238266 */   // Label 4763: @238266
     /* 238266 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238308), // Rule ID 11568 //
     /* 238271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 238298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238306 */     GIR_RootConstrainSelectedInstOperands,
     /* 238307 */     // GIR_Coverage, 11568,
     /* 238307 */     GIR_EraseRootFromParent_Done,
     /* 238308 */   // Label 4764: @238308
     /* 238308 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238350), // Rule ID 11569 //
     /* 238313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 238340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238348 */     GIR_RootConstrainSelectedInstOperands,
     /* 238349 */     // GIR_Coverage, 11569,
     /* 238349 */     GIR_EraseRootFromParent_Done,
     /* 238350 */   // Label 4765: @238350
     /* 238350 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238392), // Rule ID 11570 //
     /* 238355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238379 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 238382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238390 */     GIR_RootConstrainSelectedInstOperands,
     /* 238391 */     // GIR_Coverage, 11570,
     /* 238391 */     GIR_EraseRootFromParent_Done,
     /* 238392 */   // Label 4766: @238392
     /* 238392 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238434), // Rule ID 11571 //
     /* 238397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 238424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238432 */     GIR_RootConstrainSelectedInstOperands,
     /* 238433 */     // GIR_Coverage, 11571,
     /* 238433 */     GIR_EraseRootFromParent_Done,
     /* 238434 */   // Label 4767: @238434
     /* 238434 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238476), // Rule ID 11572 //
     /* 238439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 238466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238474 */     GIR_RootConstrainSelectedInstOperands,
     /* 238475 */     // GIR_Coverage, 11572,
     /* 238475 */     GIR_EraseRootFromParent_Done,
     /* 238476 */   // Label 4768: @238476
     /* 238476 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238518), // Rule ID 11573 //
     /* 238481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 238508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238516 */     GIR_RootConstrainSelectedInstOperands,
     /* 238517 */     // GIR_Coverage, 11573,
     /* 238517 */     GIR_EraseRootFromParent_Done,
     /* 238518 */   // Label 4769: @238518
     /* 238518 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238560), // Rule ID 11574 //
     /* 238523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238547 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 238550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238558 */     GIR_RootConstrainSelectedInstOperands,
     /* 238559 */     // GIR_Coverage, 11574,
     /* 238559 */     GIR_EraseRootFromParent_Done,
     /* 238560 */   // Label 4770: @238560
     /* 238560 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238602), // Rule ID 11575 //
     /* 238565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 238592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238600 */     GIR_RootConstrainSelectedInstOperands,
     /* 238601 */     // GIR_Coverage, 11575,
     /* 238601 */     GIR_EraseRootFromParent_Done,
     /* 238602 */   // Label 4771: @238602
     /* 238602 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238644), // Rule ID 11576 //
     /* 238607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238642 */     GIR_RootConstrainSelectedInstOperands,
     /* 238643 */     // GIR_Coverage, 11576,
     /* 238643 */     GIR_EraseRootFromParent_Done,
     /* 238644 */   // Label 4772: @238644
     /* 238644 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238686), // Rule ID 11577 //
     /* 238649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 238676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238684 */     GIR_RootConstrainSelectedInstOperands,
     /* 238685 */     // GIR_Coverage, 11577,
     /* 238685 */     GIR_EraseRootFromParent_Done,
     /* 238686 */   // Label 4773: @238686
     /* 238686 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238728), // Rule ID 11578 //
     /* 238691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 238718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238726 */     GIR_RootConstrainSelectedInstOperands,
     /* 238727 */     // GIR_Coverage, 11578,
     /* 238727 */     GIR_EraseRootFromParent_Done,
     /* 238728 */   // Label 4774: @238728
     /* 238728 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238770), // Rule ID 11579 //
     /* 238733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 238760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238768 */     GIR_RootConstrainSelectedInstOperands,
     /* 238769 */     // GIR_Coverage, 11579,
     /* 238769 */     GIR_EraseRootFromParent_Done,
     /* 238770 */   // Label 4775: @238770
     /* 238770 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238812), // Rule ID 11580 //
     /* 238775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 238802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238810 */     GIR_RootConstrainSelectedInstOperands,
     /* 238811 */     // GIR_Coverage, 11580,
     /* 238811 */     GIR_EraseRootFromParent_Done,
     /* 238812 */   // Label 4776: @238812
     /* 238812 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238854), // Rule ID 11581 //
     /* 238817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 238844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238852 */     GIR_RootConstrainSelectedInstOperands,
     /* 238853 */     // GIR_Coverage, 11581,
     /* 238853 */     GIR_EraseRootFromParent_Done,
     /* 238854 */   // Label 4777: @238854
     /* 238854 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238896), // Rule ID 11582 //
     /* 238859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238883 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238894 */     GIR_RootConstrainSelectedInstOperands,
     /* 238895 */     // GIR_Coverage, 11582,
     /* 238895 */     GIR_EraseRootFromParent_Done,
     /* 238896 */   // Label 4778: @238896
     /* 238896 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238938), // Rule ID 11583 //
     /* 238901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238936 */     GIR_RootConstrainSelectedInstOperands,
     /* 238937 */     // GIR_Coverage, 11583,
     /* 238937 */     GIR_EraseRootFromParent_Done,
     /* 238938 */   // Label 4779: @238938
     /* 238938 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238980), // Rule ID 11584 //
     /* 238943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 238970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238978 */     GIR_RootConstrainSelectedInstOperands,
     /* 238979 */     // GIR_Coverage, 11584,
     /* 238979 */     GIR_EraseRootFromParent_Done,
     /* 238980 */   // Label 4780: @238980
     /* 238980 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(239022), // Rule ID 11585 //
     /* 238985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2030:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239020 */     GIR_RootConstrainSelectedInstOperands,
     /* 239021 */     // GIR_Coverage, 11585,
     /* 239021 */     GIR_EraseRootFromParent_Done,
     /* 239022 */   // Label 4781: @239022
     /* 239022 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(239064), // Rule ID 11748 //
     /* 239027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 239054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239062 */     GIR_RootConstrainSelectedInstOperands,
     /* 239063 */     // GIR_Coverage, 11748,
     /* 239063 */     GIR_EraseRootFromParent_Done,
     /* 239064 */   // Label 4782: @239064
     /* 239064 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(239106), // Rule ID 11750 //
     /* 239069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239104 */     GIR_RootConstrainSelectedInstOperands,
     /* 239105 */     // GIR_Coverage, 11750,
     /* 239105 */     GIR_EraseRootFromParent_Done,
     /* 239106 */   // Label 4783: @239106
     /* 239106 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239148), // Rule ID 11752 //
     /* 239111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239146 */     GIR_RootConstrainSelectedInstOperands,
     /* 239147 */     // GIR_Coverage, 11752,
     /* 239147 */     GIR_EraseRootFromParent_Done,
     /* 239148 */   // Label 4784: @239148
     /* 239148 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239190), // Rule ID 11754 //
     /* 239153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 239180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239188 */     GIR_RootConstrainSelectedInstOperands,
     /* 239189 */     // GIR_Coverage, 11754,
     /* 239189 */     GIR_EraseRootFromParent_Done,
     /* 239190 */   // Label 4785: @239190
     /* 239190 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239232), // Rule ID 11756 //
     /* 239195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239230 */     GIR_RootConstrainSelectedInstOperands,
     /* 239231 */     // GIR_Coverage, 11756,
     /* 239231 */     GIR_EraseRootFromParent_Done,
     /* 239232 */   // Label 4786: @239232
     /* 239232 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239274), // Rule ID 11757 //
     /* 239237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 239264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239272 */     GIR_RootConstrainSelectedInstOperands,
     /* 239273 */     // GIR_Coverage, 11757,
     /* 239273 */     GIR_EraseRootFromParent_Done,
     /* 239274 */   // Label 4787: @239274
     /* 239274 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239316), // Rule ID 11758 //
     /* 239279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239314 */     GIR_RootConstrainSelectedInstOperands,
     /* 239315 */     // GIR_Coverage, 11758,
     /* 239315 */     GIR_EraseRootFromParent_Done,
     /* 239316 */   // Label 4788: @239316
     /* 239316 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239358), // Rule ID 11759 //
     /* 239321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239356 */     GIR_RootConstrainSelectedInstOperands,
     /* 239357 */     // GIR_Coverage, 11759,
     /* 239357 */     GIR_EraseRootFromParent_Done,
     /* 239358 */   // Label 4789: @239358
     /* 239358 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239400), // Rule ID 11760 //
     /* 239363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 239390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239398 */     GIR_RootConstrainSelectedInstOperands,
     /* 239399 */     // GIR_Coverage, 11760,
     /* 239399 */     GIR_EraseRootFromParent_Done,
     /* 239400 */   // Label 4790: @239400
     /* 239400 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239442), // Rule ID 11761 //
     /* 239405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239440 */     GIR_RootConstrainSelectedInstOperands,
     /* 239441 */     // GIR_Coverage, 11761,
     /* 239441 */     GIR_EraseRootFromParent_Done,
     /* 239442 */   // Label 4791: @239442
     /* 239442 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239484), // Rule ID 11762 //
     /* 239447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 239474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239482 */     GIR_RootConstrainSelectedInstOperands,
     /* 239483 */     // GIR_Coverage, 11762,
     /* 239483 */     GIR_EraseRootFromParent_Done,
     /* 239484 */   // Label 4792: @239484
     /* 239484 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239526), // Rule ID 11763 //
     /* 239489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239524 */     GIR_RootConstrainSelectedInstOperands,
     /* 239525 */     // GIR_Coverage, 11763,
     /* 239525 */     GIR_EraseRootFromParent_Done,
     /* 239526 */   // Label 4793: @239526
     /* 239526 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239568), // Rule ID 11764 //
     /* 239531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 239558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239566 */     GIR_RootConstrainSelectedInstOperands,
     /* 239567 */     // GIR_Coverage, 11764,
     /* 239567 */     GIR_EraseRootFromParent_Done,
     /* 239568 */   // Label 4794: @239568
     /* 239568 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239610), // Rule ID 11765 //
     /* 239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 239581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239608 */     GIR_RootConstrainSelectedInstOperands,
     /* 239609 */     // GIR_Coverage, 11765,
     /* 239609 */     GIR_EraseRootFromParent_Done,
     /* 239610 */   // Label 4795: @239610
     /* 239610 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239652), // Rule ID 11766 //
     /* 239615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 239623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239650 */     GIR_RootConstrainSelectedInstOperands,
     /* 239651 */     // GIR_Coverage, 11766,
     /* 239651 */     GIR_EraseRootFromParent_Done,
     /* 239652 */   // Label 4796: @239652
     /* 239652 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239694), // Rule ID 11767 //
     /* 239657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 239665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 239684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239692 */     GIR_RootConstrainSelectedInstOperands,
     /* 239693 */     // GIR_Coverage, 11767,
     /* 239693 */     GIR_EraseRootFromParent_Done,
     /* 239694 */   // Label 4797: @239694
     /* 239694 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239736), // Rule ID 11768 //
     /* 239699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 239707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 239726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239734 */     GIR_RootConstrainSelectedInstOperands,
     /* 239735 */     // GIR_Coverage, 11768,
     /* 239735 */     GIR_EraseRootFromParent_Done,
     /* 239736 */   // Label 4798: @239736
     /* 239736 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239778), // Rule ID 11769 //
     /* 239741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 239749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239776 */     GIR_RootConstrainSelectedInstOperands,
     /* 239777 */     // GIR_Coverage, 11769,
     /* 239777 */     GIR_EraseRootFromParent_Done,
     /* 239778 */   // Label 4799: @239778
     /* 239778 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239820), // Rule ID 11770 //
     /* 239783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 239791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239818 */     GIR_RootConstrainSelectedInstOperands,
     /* 239819 */     // GIR_Coverage, 11770,
     /* 239819 */     GIR_EraseRootFromParent_Done,
     /* 239820 */   // Label 4800: @239820
     /* 239820 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239862), // Rule ID 11825 //
     /* 239825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 239852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239860 */     GIR_RootConstrainSelectedInstOperands,
     /* 239861 */     // GIR_Coverage, 11825,
     /* 239861 */     GIR_EraseRootFromParent_Done,
     /* 239862 */   // Label 4801: @239862
     /* 239862 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239904), // Rule ID 11826 //
     /* 239867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239902 */     GIR_RootConstrainSelectedInstOperands,
     /* 239903 */     // GIR_Coverage, 11826,
     /* 239903 */     GIR_EraseRootFromParent_Done,
     /* 239904 */   // Label 4802: @239904
     /* 239904 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239946), // Rule ID 11827 //
     /* 239909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 239936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239944 */     GIR_RootConstrainSelectedInstOperands,
     /* 239945 */     // GIR_Coverage, 11827,
     /* 239945 */     GIR_EraseRootFromParent_Done,
     /* 239946 */   // Label 4803: @239946
     /* 239946 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239988), // Rule ID 11828 //
     /* 239951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 239959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239986 */     GIR_RootConstrainSelectedInstOperands,
     /* 239987 */     // GIR_Coverage, 11828,
     /* 239987 */     GIR_EraseRootFromParent_Done,
     /* 239988 */   // Label 4804: @239988
     /* 239988 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(240030), // Rule ID 11829 //
     /* 239993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 240001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 240020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240028 */     GIR_RootConstrainSelectedInstOperands,
     /* 240029 */     // GIR_Coverage, 11829,
     /* 240029 */     GIR_EraseRootFromParent_Done,
     /* 240030 */   // Label 4805: @240030
     /* 240030 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(240072), // Rule ID 11830 //
     /* 240035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 240043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 240062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240070 */     GIR_RootConstrainSelectedInstOperands,
     /* 240071 */     // GIR_Coverage, 11830,
     /* 240071 */     GIR_EraseRootFromParent_Done,
     /* 240072 */   // Label 4806: @240072
     /* 240072 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240114), // Rule ID 11831 //
     /* 240077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 240104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240112 */     GIR_RootConstrainSelectedInstOperands,
     /* 240113 */     // GIR_Coverage, 11831,
     /* 240113 */     GIR_EraseRootFromParent_Done,
     /* 240114 */   // Label 4807: @240114
     /* 240114 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240156), // Rule ID 11832 //
     /* 240119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 240146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240154 */     GIR_RootConstrainSelectedInstOperands,
     /* 240155 */     // GIR_Coverage, 11832,
     /* 240155 */     GIR_EraseRootFromParent_Done,
     /* 240156 */   // Label 4808: @240156
     /* 240156 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240198), // Rule ID 11833 //
     /* 240161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240196 */     GIR_RootConstrainSelectedInstOperands,
     /* 240197 */     // GIR_Coverage, 11833,
     /* 240197 */     GIR_EraseRootFromParent_Done,
     /* 240198 */   // Label 4809: @240198
     /* 240198 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240243), // Rule ID 11846 //
     /* 240203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 240206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 240211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240227 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 240230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240241 */     GIR_RootConstrainSelectedInstOperands,
     /* 240242 */     // GIR_Coverage, 11846,
     /* 240242 */     GIR_EraseRootFromParent_Done,
     /* 240243 */   // Label 4810: @240243
     /* 240243 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240288), // Rule ID 11847 //
     /* 240248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 240251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 240256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 240275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240286 */     GIR_RootConstrainSelectedInstOperands,
     /* 240287 */     // GIR_Coverage, 11847,
     /* 240287 */     GIR_EraseRootFromParent_Done,
     /* 240288 */   // Label 4811: @240288
     /* 240288 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240330), // Rule ID 11848 //
     /* 240293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240317 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1354:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 240320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240328 */     GIR_RootConstrainSelectedInstOperands,
     /* 240329 */     // GIR_Coverage, 11848,
     /* 240329 */     GIR_EraseRootFromParent_Done,
     /* 240330 */   // Label 4812: @240330
     /* 240330 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240372), // Rule ID 11849 //
     /* 240335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1354:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240370 */     GIR_RootConstrainSelectedInstOperands,
     /* 240371 */     // GIR_Coverage, 11849,
     /* 240371 */     GIR_EraseRootFromParent_Done,
     /* 240372 */   // Label 4813: @240372
     /* 240372 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240414), // Rule ID 11850 //
     /* 240377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1354:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 240404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240412 */     GIR_RootConstrainSelectedInstOperands,
     /* 240413 */     // GIR_Coverage, 11850,
     /* 240413 */     GIR_EraseRootFromParent_Done,
     /* 240414 */   // Label 4814: @240414
     /* 240414 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240456), // Rule ID 11851 //
     /* 240419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1354:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 240446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240454 */     GIR_RootConstrainSelectedInstOperands,
     /* 240455 */     // GIR_Coverage, 11851,
     /* 240455 */     GIR_EraseRootFromParent_Done,
     /* 240456 */   // Label 4815: @240456
     /* 240456 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240498), // Rule ID 11867 //
     /* 240461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240485 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1437:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 240488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240496 */     GIR_RootConstrainSelectedInstOperands,
     /* 240497 */     // GIR_Coverage, 11867,
     /* 240497 */     GIR_EraseRootFromParent_Done,
     /* 240498 */   // Label 4816: @240498
     /* 240498 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240540), // Rule ID 11868 //
     /* 240503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240527 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1437:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 240530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240538 */     GIR_RootConstrainSelectedInstOperands,
     /* 240539 */     // GIR_Coverage, 11868,
     /* 240539 */     GIR_EraseRootFromParent_Done,
     /* 240540 */   // Label 4817: @240540
     /* 240540 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240582), // Rule ID 11869 //
     /* 240545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240569 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1437:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 240572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240580 */     GIR_RootConstrainSelectedInstOperands,
     /* 240581 */     // GIR_Coverage, 11869,
     /* 240581 */     GIR_EraseRootFromParent_Done,
     /* 240582 */   // Label 4818: @240582
     /* 240582 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240624), // Rule ID 11870 //
     /* 240587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240611 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 240614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240622 */     GIR_RootConstrainSelectedInstOperands,
     /* 240623 */     // GIR_Coverage, 11870,
     /* 240623 */     GIR_EraseRootFromParent_Done,
     /* 240624 */   // Label 4819: @240624
     /* 240624 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240666), // Rule ID 11871 //
     /* 240629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240653 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240664 */     GIR_RootConstrainSelectedInstOperands,
     /* 240665 */     // GIR_Coverage, 11871,
     /* 240665 */     GIR_EraseRootFromParent_Done,
     /* 240666 */   // Label 4820: @240666
     /* 240666 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240708), // Rule ID 11872 //
     /* 240671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 240698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240706 */     GIR_RootConstrainSelectedInstOperands,
     /* 240707 */     // GIR_Coverage, 11872,
     /* 240707 */     GIR_EraseRootFromParent_Done,
     /* 240708 */   // Label 4821: @240708
     /* 240708 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240750), // Rule ID 11873 //
     /* 240713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240737 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1440:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 240740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240748 */     GIR_RootConstrainSelectedInstOperands,
     /* 240749 */     // GIR_Coverage, 11873,
     /* 240749 */     GIR_EraseRootFromParent_Done,
     /* 240750 */   // Label 4822: @240750
     /* 240750 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240792), // Rule ID 11874 //
     /* 240755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240779 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1440:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 240782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240790 */     GIR_RootConstrainSelectedInstOperands,
     /* 240791 */     // GIR_Coverage, 11874,
     /* 240791 */     GIR_EraseRootFromParent_Done,
     /* 240792 */   // Label 4823: @240792
     /* 240792 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240834), // Rule ID 11875 //
     /* 240797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240821 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1440:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 240824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240832 */     GIR_RootConstrainSelectedInstOperands,
     /* 240833 */     // GIR_Coverage, 11875,
     /* 240833 */     GIR_EraseRootFromParent_Done,
     /* 240834 */   // Label 4824: @240834
     /* 240834 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240876), // Rule ID 11876 //
     /* 240839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240863 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1458:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 240866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240874 */     GIR_RootConstrainSelectedInstOperands,
     /* 240875 */     // GIR_Coverage, 11876,
     /* 240875 */     GIR_EraseRootFromParent_Done,
     /* 240876 */   // Label 4825: @240876
     /* 240876 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240918), // Rule ID 11877 //
     /* 240881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240905 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 240908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240916 */     GIR_RootConstrainSelectedInstOperands,
     /* 240917 */     // GIR_Coverage, 11877,
     /* 240917 */     GIR_EraseRootFromParent_Done,
     /* 240918 */   // Label 4826: @240918
     /* 240918 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240960), // Rule ID 11878 //
     /* 240923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240947 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1458:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 240950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240958 */     GIR_RootConstrainSelectedInstOperands,
     /* 240959 */     // GIR_Coverage, 11878,
     /* 240959 */     GIR_EraseRootFromParent_Done,
     /* 240960 */   // Label 4827: @240960
     /* 240960 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(241002), // Rule ID 11883 //
     /* 240965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 240973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240989 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 240992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241000 */     GIR_RootConstrainSelectedInstOperands,
     /* 241001 */     // GIR_Coverage, 11883,
     /* 241001 */     GIR_EraseRootFromParent_Done,
     /* 241002 */   // Label 4828: @241002
     /* 241002 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241044), // Rule ID 11884 //
     /* 241007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 241015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241031 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 241034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241042 */     GIR_RootConstrainSelectedInstOperands,
     /* 241043 */     // GIR_Coverage, 11884,
     /* 241043 */     GIR_EraseRootFromParent_Done,
     /* 241044 */   // Label 4829: @241044
     /* 241044 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241086), // Rule ID 11885 //
     /* 241049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 241057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241073 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 241076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241084 */     GIR_RootConstrainSelectedInstOperands,
     /* 241085 */     // GIR_Coverage, 11885,
     /* 241085 */     GIR_EraseRootFromParent_Done,
     /* 241086 */   // Label 4830: @241086
     /* 241086 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241128), // Rule ID 11886 //
     /* 241091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 241099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241115 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 241118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241126 */     GIR_RootConstrainSelectedInstOperands,
     /* 241127 */     // GIR_Coverage, 11886,
     /* 241127 */     GIR_EraseRootFromParent_Done,
     /* 241128 */   // Label 4831: @241128
     /* 241128 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241170), // Rule ID 11887 //
     /* 241133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241157 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241168 */     GIR_RootConstrainSelectedInstOperands,
     /* 241169 */     // GIR_Coverage, 11887,
     /* 241169 */     GIR_EraseRootFromParent_Done,
     /* 241170 */   // Label 4832: @241170
     /* 241170 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241212), // Rule ID 11889 //
     /* 241175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1271:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241210 */     GIR_RootConstrainSelectedInstOperands,
     /* 241211 */     // GIR_Coverage, 11889,
     /* 241211 */     GIR_EraseRootFromParent_Done,
     /* 241212 */   // Label 4833: @241212
     /* 241212 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241254), // Rule ID 11891 //
     /* 241217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1271:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241252 */     GIR_RootConstrainSelectedInstOperands,
     /* 241253 */     // GIR_Coverage, 11891,
     /* 241253 */     GIR_EraseRootFromParent_Done,
     /* 241254 */   // Label 4834: @241254
     /* 241254 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241296), // Rule ID 11893 //
     /* 241259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1271:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241294 */     GIR_RootConstrainSelectedInstOperands,
     /* 241295 */     // GIR_Coverage, 11893,
     /* 241295 */     GIR_EraseRootFromParent_Done,
     /* 241296 */   // Label 4835: @241296
     /* 241296 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241338), // Rule ID 11895 //
     /* 241301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241325 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241336 */     GIR_RootConstrainSelectedInstOperands,
     /* 241337 */     // GIR_Coverage, 11895,
     /* 241337 */     GIR_EraseRootFromParent_Done,
     /* 241338 */   // Label 4836: @241338
     /* 241338 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241380), // Rule ID 11897 //
     /* 241343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241378 */     GIR_RootConstrainSelectedInstOperands,
     /* 241379 */     // GIR_Coverage, 11897,
     /* 241379 */     GIR_EraseRootFromParent_Done,
     /* 241380 */   // Label 4837: @241380
     /* 241380 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241422), // Rule ID 11899 //
     /* 241385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241420 */     GIR_RootConstrainSelectedInstOperands,
     /* 241421 */     // GIR_Coverage, 11899,
     /* 241421 */     GIR_EraseRootFromParent_Done,
     /* 241422 */   // Label 4838: @241422
     /* 241422 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241464), // Rule ID 11901 //
     /* 241427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241462 */     GIR_RootConstrainSelectedInstOperands,
     /* 241463 */     // GIR_Coverage, 11901,
     /* 241463 */     GIR_EraseRootFromParent_Done,
     /* 241464 */   // Label 4839: @241464
     /* 241464 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241506), // Rule ID 11903 //
     /* 241469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1301:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241504 */     GIR_RootConstrainSelectedInstOperands,
     /* 241505 */     // GIR_Coverage, 11903,
     /* 241505 */     GIR_EraseRootFromParent_Done,
     /* 241506 */   // Label 4840: @241506
     /* 241506 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241548), // Rule ID 11904 //
     /* 241511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241535 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1301:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241546 */     GIR_RootConstrainSelectedInstOperands,
     /* 241547 */     // GIR_Coverage, 11904,
     /* 241547 */     GIR_EraseRootFromParent_Done,
     /* 241548 */   // Label 4841: @241548
     /* 241548 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241590), // Rule ID 11905 //
     /* 241553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1301:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241588 */     GIR_RootConstrainSelectedInstOperands,
     /* 241589 */     // GIR_Coverage, 11905,
     /* 241589 */     GIR_EraseRootFromParent_Done,
     /* 241590 */   // Label 4842: @241590
     /* 241590 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241632), // Rule ID 11906 //
     /* 241595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1301:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241630 */     GIR_RootConstrainSelectedInstOperands,
     /* 241631 */     // GIR_Coverage, 11906,
     /* 241631 */     GIR_EraseRootFromParent_Done,
     /* 241632 */   // Label 4843: @241632
     /* 241632 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241674), // Rule ID 11907 //
     /* 241637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241661 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241672 */     GIR_RootConstrainSelectedInstOperands,
     /* 241673 */     // GIR_Coverage, 11907,
     /* 241673 */     GIR_EraseRootFromParent_Done,
     /* 241674 */   // Label 4844: @241674
     /* 241674 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241716), // Rule ID 11908 //
     /* 241679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241714 */     GIR_RootConstrainSelectedInstOperands,
     /* 241715 */     // GIR_Coverage, 11908,
     /* 241715 */     GIR_EraseRootFromParent_Done,
     /* 241716 */   // Label 4845: @241716
     /* 241716 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241758), // Rule ID 11909 //
     /* 241721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241756 */     GIR_RootConstrainSelectedInstOperands,
     /* 241757 */     // GIR_Coverage, 11909,
     /* 241757 */     GIR_EraseRootFromParent_Done,
     /* 241758 */   // Label 4846: @241758
     /* 241758 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241800), // Rule ID 11910 //
     /* 241763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241798 */     GIR_RootConstrainSelectedInstOperands,
     /* 241799 */     // GIR_Coverage, 11910,
     /* 241799 */     GIR_EraseRootFromParent_Done,
     /* 241800 */   // Label 4847: @241800
     /* 241800 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241842), // Rule ID 11911 //
     /* 241805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241829 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1612:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241840 */     GIR_RootConstrainSelectedInstOperands,
     /* 241841 */     // GIR_Coverage, 11911,
     /* 241841 */     GIR_EraseRootFromParent_Done,
     /* 241842 */   // Label 4848: @241842
     /* 241842 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241884), // Rule ID 11913 //
     /* 241847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241871 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241882 */     GIR_RootConstrainSelectedInstOperands,
     /* 241883 */     // GIR_Coverage, 11913,
     /* 241883 */     GIR_EraseRootFromParent_Done,
     /* 241884 */   // Label 4849: @241884
     /* 241884 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(241926), // Rule ID 11915 //
     /* 241889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241924 */     GIR_RootConstrainSelectedInstOperands,
     /* 241925 */     // GIR_Coverage, 11915,
     /* 241925 */     GIR_EraseRootFromParent_Done,
     /* 241926 */   // Label 4850: @241926
     /* 241926 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(241968), // Rule ID 11917 //
     /* 241931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241955 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241966 */     GIR_RootConstrainSelectedInstOperands,
     /* 241967 */     // GIR_Coverage, 11917,
     /* 241967 */     GIR_EraseRootFromParent_Done,
     /* 241968 */   // Label 4851: @241968
     /* 241968 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242010), // Rule ID 12006 //
     /* 241973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 241976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 241981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 242000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242008 */     GIR_RootConstrainSelectedInstOperands,
     /* 242009 */     // GIR_Coverage, 12006,
     /* 242009 */     GIR_EraseRootFromParent_Done,
     /* 242010 */   // Label 4852: @242010
     /* 242010 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242052), // Rule ID 12008 //
     /* 242015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 242042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242050 */     GIR_RootConstrainSelectedInstOperands,
     /* 242051 */     // GIR_Coverage, 12008,
     /* 242051 */     GIR_EraseRootFromParent_Done,
     /* 242052 */   // Label 4853: @242052
     /* 242052 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242094), // Rule ID 12010 //
     /* 242057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 242084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242092 */     GIR_RootConstrainSelectedInstOperands,
     /* 242093 */     // GIR_Coverage, 12010,
     /* 242093 */     GIR_EraseRootFromParent_Done,
     /* 242094 */   // Label 4854: @242094
     /* 242094 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242136), // Rule ID 12012 //
     /* 242099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 242126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242134 */     GIR_RootConstrainSelectedInstOperands,
     /* 242135 */     // GIR_Coverage, 12012,
     /* 242135 */     GIR_EraseRootFromParent_Done,
     /* 242136 */   // Label 4855: @242136
     /* 242136 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242178), // Rule ID 12014 //
     /* 242141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 242149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 242168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242176 */     GIR_RootConstrainSelectedInstOperands,
     /* 242177 */     // GIR_Coverage, 12014,
     /* 242177 */     GIR_EraseRootFromParent_Done,
     /* 242178 */   // Label 4856: @242178
     /* 242178 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242220), // Rule ID 12016 //
     /* 242183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 242191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 242210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242218 */     GIR_RootConstrainSelectedInstOperands,
     /* 242219 */     // GIR_Coverage, 12016,
     /* 242219 */     GIR_EraseRootFromParent_Done,
     /* 242220 */   // Label 4857: @242220
     /* 242220 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242262), // Rule ID 12179 //
     /* 242225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 242239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 242252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242260 */     GIR_RootConstrainSelectedInstOperands,
     /* 242261 */     // GIR_Coverage, 12179,
     /* 242261 */     GIR_EraseRootFromParent_Done,
     /* 242262 */   // Label 4858: @242262
     /* 242262 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242304), // Rule ID 12180 //
     /* 242267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 242294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242302 */     GIR_RootConstrainSelectedInstOperands,
     /* 242303 */     // GIR_Coverage, 12180,
     /* 242303 */     GIR_EraseRootFromParent_Done,
     /* 242304 */   // Label 4859: @242304
     /* 242304 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242346), // Rule ID 12181 //
     /* 242309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 242336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242344 */     GIR_RootConstrainSelectedInstOperands,
     /* 242345 */     // GIR_Coverage, 12181,
     /* 242345 */     GIR_EraseRootFromParent_Done,
     /* 242346 */   // Label 4860: @242346
     /* 242346 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242388), // Rule ID 12182 //
     /* 242351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 242378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242386 */     GIR_RootConstrainSelectedInstOperands,
     /* 242387 */     // GIR_Coverage, 12182,
     /* 242387 */     GIR_EraseRootFromParent_Done,
     /* 242388 */   // Label 4861: @242388
     /* 242388 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242430), // Rule ID 12183 //
     /* 242393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242417 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 242420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242428 */     GIR_RootConstrainSelectedInstOperands,
     /* 242429 */     // GIR_Coverage, 12183,
     /* 242429 */     GIR_EraseRootFromParent_Done,
     /* 242430 */   // Label 4862: @242430
     /* 242430 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242472), // Rule ID 12184 //
     /* 242435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 242462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242470 */     GIR_RootConstrainSelectedInstOperands,
     /* 242471 */     // GIR_Coverage, 12184,
     /* 242471 */     GIR_EraseRootFromParent_Done,
     /* 242472 */   // Label 4863: @242472
     /* 242472 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242514), // Rule ID 12185 //
     /* 242477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242501 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 242504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242512 */     GIR_RootConstrainSelectedInstOperands,
     /* 242513 */     // GIR_Coverage, 12185,
     /* 242513 */     GIR_EraseRootFromParent_Done,
     /* 242514 */   // Label 4864: @242514
     /* 242514 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242556), // Rule ID 12530 //
     /* 242519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242543 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 242546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242554 */     GIR_RootConstrainSelectedInstOperands,
     /* 242555 */     // GIR_Coverage, 12530,
     /* 242555 */     GIR_EraseRootFromParent_Done,
     /* 242556 */   // Label 4865: @242556
     /* 242556 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242598), // Rule ID 12531 //
     /* 242561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242585 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 242588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242596 */     GIR_RootConstrainSelectedInstOperands,
     /* 242597 */     // GIR_Coverage, 12531,
     /* 242597 */     GIR_EraseRootFromParent_Done,
     /* 242598 */   // Label 4866: @242598
     /* 242598 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242640), // Rule ID 12532 //
     /* 242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242627 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 242630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242638 */     GIR_RootConstrainSelectedInstOperands,
     /* 242639 */     // GIR_Coverage, 12532,
     /* 242639 */     GIR_EraseRootFromParent_Done,
     /* 242640 */   // Label 4867: @242640
     /* 242640 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242682), // Rule ID 12533 //
     /* 242645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242669 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 242672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242680 */     GIR_RootConstrainSelectedInstOperands,
     /* 242681 */     // GIR_Coverage, 12533,
     /* 242681 */     GIR_EraseRootFromParent_Done,
     /* 242682 */   // Label 4868: @242682
     /* 242682 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242724), // Rule ID 12534 //
     /* 242687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 242714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242722 */     GIR_RootConstrainSelectedInstOperands,
     /* 242723 */     // GIR_Coverage, 12534,
     /* 242723 */     GIR_EraseRootFromParent_Done,
     /* 242724 */   // Label 4869: @242724
     /* 242724 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242766), // Rule ID 12535 //
     /* 242729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242753 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 242756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242764 */     GIR_RootConstrainSelectedInstOperands,
     /* 242765 */     // GIR_Coverage, 12535,
     /* 242765 */     GIR_EraseRootFromParent_Done,
     /* 242766 */   // Label 4870: @242766
     /* 242766 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(242808), // Rule ID 12536 //
     /* 242771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242806 */     GIR_RootConstrainSelectedInstOperands,
     /* 242807 */     // GIR_Coverage, 12536,
     /* 242807 */     GIR_EraseRootFromParent_Done,
     /* 242808 */   // Label 4871: @242808
     /* 242808 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(242850), // Rule ID 12539 //
     /* 242813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242837 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242848 */     GIR_RootConstrainSelectedInstOperands,
     /* 242849 */     // GIR_Coverage, 12539,
     /* 242849 */     GIR_EraseRootFromParent_Done,
     /* 242850 */   // Label 4872: @242850
     /* 242850 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(242892), // Rule ID 12542 //
     /* 242855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242890 */     GIR_RootConstrainSelectedInstOperands,
     /* 242891 */     // GIR_Coverage, 12542,
     /* 242891 */     GIR_EraseRootFromParent_Done,
     /* 242892 */   // Label 4873: @242892
     /* 242892 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(242934), // Rule ID 12545 //
     /* 242897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242921 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 242924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242932 */     GIR_RootConstrainSelectedInstOperands,
     /* 242933 */     // GIR_Coverage, 12545,
     /* 242933 */     GIR_EraseRootFromParent_Done,
     /* 242934 */   // Label 4874: @242934
     /* 242934 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(242976), // Rule ID 12548 //
     /* 242939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242963 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 242966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242974 */     GIR_RootConstrainSelectedInstOperands,
     /* 242975 */     // GIR_Coverage, 12548,
     /* 242975 */     GIR_EraseRootFromParent_Done,
     /* 242976 */   // Label 4875: @242976
     /* 242976 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243018), // Rule ID 12551 //
     /* 242981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243005 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 243008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243016 */     GIR_RootConstrainSelectedInstOperands,
     /* 243017 */     // GIR_Coverage, 12551,
     /* 243017 */     GIR_EraseRootFromParent_Done,
     /* 243018 */   // Label 4876: @243018
     /* 243018 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243060), // Rule ID 12554 //
     /* 243023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243047 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243058 */     GIR_RootConstrainSelectedInstOperands,
     /* 243059 */     // GIR_Coverage, 12554,
     /* 243059 */     GIR_EraseRootFromParent_Done,
     /* 243060 */   // Label 4877: @243060
     /* 243060 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243102), // Rule ID 12557 //
     /* 243065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243089 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 243089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243100 */     GIR_RootConstrainSelectedInstOperands,
     /* 243101 */     // GIR_Coverage, 12557,
     /* 243101 */     GIR_EraseRootFromParent_Done,
     /* 243102 */   // Label 4878: @243102
     /* 243102 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243144), // Rule ID 12560 //
     /* 243107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243131 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 243131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243142 */     GIR_RootConstrainSelectedInstOperands,
     /* 243143 */     // GIR_Coverage, 12560,
     /* 243143 */     GIR_EraseRootFromParent_Done,
     /* 243144 */   // Label 4879: @243144
     /* 243144 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243186), // Rule ID 12563 //
     /* 243149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243173 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 243176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243184 */     GIR_RootConstrainSelectedInstOperands,
     /* 243185 */     // GIR_Coverage, 12563,
     /* 243185 */     GIR_EraseRootFromParent_Done,
     /* 243186 */   // Label 4880: @243186
     /* 243186 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243228), // Rule ID 12566 //
     /* 243191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243215 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 243215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 243218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243226 */     GIR_RootConstrainSelectedInstOperands,
     /* 243227 */     // GIR_Coverage, 12566,
     /* 243227 */     GIR_EraseRootFromParent_Done,
     /* 243228 */   // Label 4881: @243228
     /* 243228 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243270), // Rule ID 12569 //
     /* 243233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 243260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243268 */     GIR_RootConstrainSelectedInstOperands,
     /* 243269 */     // GIR_Coverage, 12569,
     /* 243269 */     GIR_EraseRootFromParent_Done,
     /* 243270 */   // Label 4882: @243270
     /* 243270 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243413), // Rule ID 5588 //
     /* 243275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 243289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243296 */     // MIs[0] idx
     /* 243296 */     // No operand predicates
     /* 243296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243296 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 243299 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243303 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 243310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 243313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243322 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 243325 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243329 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 243332 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243337 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243342 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 243409 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243411 */     GIR_RootConstrainSelectedInstOperands,
     /* 243412 */     // GIR_Coverage, 5588,
     /* 243412 */     GIR_EraseRootFromParent_Done,
     /* 243413 */   // Label 4883: @243413
     /* 243413 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243504), // Rule ID 5589 //
     /* 243418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 243432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243439 */     // MIs[0] idx
     /* 243439 */     // No operand predicates
     /* 243439 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243500 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243502 */     GIR_RootConstrainSelectedInstOperands,
     /* 243503 */     // GIR_Coverage, 5589,
     /* 243503 */     GIR_EraseRootFromParent_Done,
     /* 243504 */   // Label 4884: @243504
     /* 243504 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243595), // Rule ID 5590 //
     /* 243509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243530 */     // MIs[0] idx
     /* 243530 */     // No operand predicates
     /* 243530 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243591 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243593 */     GIR_RootConstrainSelectedInstOperands,
     /* 243594 */     // GIR_Coverage, 5590,
     /* 243594 */     GIR_EraseRootFromParent_Done,
     /* 243595 */   // Label 4885: @243595
     /* 243595 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243634), // Rule ID 5591 //
     /* 243600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243621 */     // MIs[0] idx
     /* 243621 */     // No operand predicates
     /* 243621 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243630 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243632 */     GIR_RootConstrainSelectedInstOperands,
     /* 243633 */     // GIR_Coverage, 5591,
     /* 243633 */     GIR_EraseRootFromParent_Done,
     /* 243634 */   // Label 4886: @243634
     /* 243634 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243777), // Rule ID 5592 //
     /* 243639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 243653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243660 */     // MIs[0] idx
     /* 243660 */     // No operand predicates
     /* 243660 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243660 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 243663 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243667 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 243674 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 243677 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243681 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243686 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 243689 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243693 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 243696 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243701 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243706 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 243773 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243775 */     GIR_RootConstrainSelectedInstOperands,
     /* 243776 */     // GIR_Coverage, 5592,
     /* 243776 */     GIR_EraseRootFromParent_Done,
     /* 243777 */   // Label 4887: @243777
     /* 243777 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243868), // Rule ID 5593 //
     /* 243782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 243796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243803 */     // MIs[0] idx
     /* 243803 */     // No operand predicates
     /* 243803 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243836 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243864 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243866 */     GIR_RootConstrainSelectedInstOperands,
     /* 243867 */     // GIR_Coverage, 5593,
     /* 243867 */     GIR_EraseRootFromParent_Done,
     /* 243868 */   // Label 4888: @243868
     /* 243868 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243959), // Rule ID 5594 //
     /* 243873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243894 */     // MIs[0] idx
     /* 243894 */     // No operand predicates
     /* 243894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243955 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243957 */     GIR_RootConstrainSelectedInstOperands,
     /* 243958 */     // GIR_Coverage, 5594,
     /* 243958 */     GIR_EraseRootFromParent_Done,
     /* 243959 */   // Label 4889: @243959
     /* 243959 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243998), // Rule ID 5595 //
     /* 243964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243985 */     // MIs[0] idx
     /* 243985 */     // No operand predicates
     /* 243985 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243994 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243996 */     GIR_RootConstrainSelectedInstOperands,
     /* 243997 */     // GIR_Coverage, 5595,
     /* 243997 */     GIR_EraseRootFromParent_Done,
     /* 243998 */   // Label 4890: @243998
     /* 243998 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244141), // Rule ID 5596 //
     /* 244003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 244011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 244017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244024 */     // MIs[0] idx
     /* 244024 */     // No operand predicates
     /* 244024 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 244027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 244038 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 244041 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244045 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244050 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 244053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244057 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 244060 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244065 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244070 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244101 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 244108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 244137 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244139 */     GIR_RootConstrainSelectedInstOperands,
     /* 244140 */     // GIR_Coverage, 5596,
     /* 244140 */     GIR_EraseRootFromParent_Done,
     /* 244141 */   // Label 4891: @244141
     /* 244141 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244232), // Rule ID 5597 //
     /* 244146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 244154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 244160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244167 */     // MIs[0] idx
     /* 244167 */     // No operand predicates
     /* 244167 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 244200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244228 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244230 */     GIR_RootConstrainSelectedInstOperands,
     /* 244231 */     // GIR_Coverage, 5597,
     /* 244231 */     GIR_EraseRootFromParent_Done,
     /* 244232 */   // Label 4892: @244232
     /* 244232 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244323), // Rule ID 5598 //
     /* 244237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 244245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244258 */     // MIs[0] idx
     /* 244258 */     // No operand predicates
     /* 244258 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244319 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244321 */     GIR_RootConstrainSelectedInstOperands,
     /* 244322 */     // GIR_Coverage, 5598,
     /* 244322 */     GIR_EraseRootFromParent_Done,
     /* 244323 */   // Label 4893: @244323
     /* 244323 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244362), // Rule ID 5599 //
     /* 244328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 244336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244349 */     // MIs[0] idx
     /* 244349 */     // No operand predicates
     /* 244349 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244358 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244360 */     GIR_RootConstrainSelectedInstOperands,
     /* 244361 */     // GIR_Coverage, 5599,
     /* 244361 */     GIR_EraseRootFromParent_Done,
     /* 244362 */   // Label 4894: @244362
     /* 244362 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244401), // Rule ID 5600 //
     /* 244367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 244375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244388 */     // MIs[0] idx
     /* 244388 */     // No operand predicates
     /* 244388 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 244391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244397 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244399 */     GIR_RootConstrainSelectedInstOperands,
     /* 244400 */     // GIR_Coverage, 5600,
     /* 244400 */     GIR_EraseRootFromParent_Done,
     /* 244401 */   // Label 4895: @244401
     /* 244401 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244492), // Rule ID 5601 //
     /* 244406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 244414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244427 */     // MIs[0] idx
     /* 244427 */     // No operand predicates
     /* 244427 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 244481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244488 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244490 */     GIR_RootConstrainSelectedInstOperands,
     /* 244491 */     // GIR_Coverage, 5601,
     /* 244491 */     GIR_EraseRootFromParent_Done,
     /* 244492 */   // Label 4896: @244492
     /* 244492 */   GIM_Reject,
     /* 244493 */ // Label 4020: @244493
     /* 244493 */ GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(251604),
     /* 244498 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 244501 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244548), // Rule ID 2965 //
     /* 244506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 244529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 244533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 244536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244544 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244546 */     GIR_RootConstrainSelectedInstOperands,
     /* 244547 */     // GIR_Coverage, 2965,
     /* 244547 */     GIR_EraseRootFromParent_Done,
     /* 244548 */   // Label 4898: @244548
     /* 244548 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244595), // Rule ID 2967 //
     /* 244553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 244580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 244583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244593 */     GIR_RootConstrainSelectedInstOperands,
     /* 244594 */     // GIR_Coverage, 2967,
     /* 244594 */     GIR_EraseRootFromParent_Done,
     /* 244595 */   // Label 4899: @244595
     /* 244595 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244642), // Rule ID 2969 //
     /* 244600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 244627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244638 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244640 */     GIR_RootConstrainSelectedInstOperands,
     /* 244641 */     // GIR_Coverage, 2969,
     /* 244641 */     GIR_EraseRootFromParent_Done,
     /* 244642 */   // Label 4900: @244642
     /* 244642 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244689), // Rule ID 2971 //
     /* 244647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 244674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 244677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244685 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244687 */     GIR_RootConstrainSelectedInstOperands,
     /* 244688 */     // GIR_Coverage, 2971,
     /* 244688 */     GIR_EraseRootFromParent_Done,
     /* 244689 */   // Label 4901: @244689
     /* 244689 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244736), // Rule ID 7604 //
     /* 244694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 244717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 244721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 244724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244732 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244734 */     GIR_RootConstrainSelectedInstOperands,
     /* 244735 */     // GIR_Coverage, 7604,
     /* 244735 */     GIR_EraseRootFromParent_Done,
     /* 244736 */   // Label 4902: @244736
     /* 244736 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244783), // Rule ID 7606 //
     /* 244741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 244768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 244771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244779 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244781 */     GIR_RootConstrainSelectedInstOperands,
     /* 244782 */     // GIR_Coverage, 7606,
     /* 244782 */     GIR_EraseRootFromParent_Done,
     /* 244783 */   // Label 4903: @244783
     /* 244783 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(244830), // Rule ID 7608 //
     /* 244788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 244815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 244818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244826 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244828 */     GIR_RootConstrainSelectedInstOperands,
     /* 244829 */     // GIR_Coverage, 7608,
     /* 244829 */     GIR_EraseRootFromParent_Done,
     /* 244830 */   // Label 4904: @244830
     /* 244830 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(244877), // Rule ID 7610 //
     /* 244835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 244862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 244865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244873 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244875 */     GIR_RootConstrainSelectedInstOperands,
     /* 244876 */     // GIR_Coverage, 7610,
     /* 244876 */     GIR_EraseRootFromParent_Done,
     /* 244877 */   // Label 4905: @244877
     /* 244877 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244957), // Rule ID 5708 //
     /* 244882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 244887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 244899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 244902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 244914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 244922 */     // MIs[1] Operand 1
     /* 244922 */     // No operand predicates
     /* 244922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 244930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 244938 */     // MIs[2] Operand 1
     /* 244938 */     // No operand predicates
     /* 244938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244940 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 244940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 244943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 244947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 244950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 244952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 244955 */     GIR_RootConstrainSelectedInstOperands,
     /* 244956 */     // GIR_Coverage, 5708,
     /* 244956 */     GIR_EraseRootFromParent_Done,
     /* 244957 */   // Label 4906: @244957
     /* 244957 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245037), // Rule ID 5709 //
     /* 244962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 244967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 244979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 244982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 244994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 245002 */     // MIs[1] Operand 1
     /* 245002 */     // No operand predicates
     /* 245002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 245018 */     // MIs[2] Operand 1
     /* 245018 */     // No operand predicates
     /* 245018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245020 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 245020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 245023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245035 */     GIR_RootConstrainSelectedInstOperands,
     /* 245036 */     // GIR_Coverage, 5709,
     /* 245036 */     GIR_EraseRootFromParent_Done,
     /* 245037 */   // Label 4907: @245037
     /* 245037 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245117), // Rule ID 5710 //
     /* 245042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 245047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 245056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 245062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 245074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 245082 */     // MIs[1] Operand 1
     /* 245082 */     // No operand predicates
     /* 245082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 245098 */     // MIs[2] Operand 1
     /* 245098 */     // No operand predicates
     /* 245098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245100 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 245100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 245103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245115 */     GIR_RootConstrainSelectedInstOperands,
     /* 245116 */     // GIR_Coverage, 5710,
     /* 245116 */     GIR_EraseRootFromParent_Done,
     /* 245117 */   // Label 4908: @245117
     /* 245117 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245197), // Rule ID 5711 //
     /* 245122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 245127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 245130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 245133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 245136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 245139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 245142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 245154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 245162 */     // MIs[1] Operand 1
     /* 245162 */     // No operand predicates
     /* 245162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 245178 */     // MIs[2] Operand 1
     /* 245178 */     // No operand predicates
     /* 245178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245180 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 245180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 245183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245195 */     GIR_RootConstrainSelectedInstOperands,
     /* 245196 */     // GIR_Coverage, 5711,
     /* 245196 */     GIR_EraseRootFromParent_Done,
     /* 245197 */   // Label 4909: @245197
     /* 245197 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245261), // Rule ID 3849 //
     /* 245202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 245210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245238 */     // MIs[0] imm
     /* 245238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 245249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245257 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245259 */     GIR_RootConstrainSelectedInstOperands,
     /* 245260 */     // GIR_Coverage, 3849,
     /* 245260 */     GIR_EraseRootFromParent_Done,
     /* 245261 */   // Label 4910: @245261
     /* 245261 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245325), // Rule ID 3850 //
     /* 245266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 245274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245302 */     // MIs[0] imm
     /* 245302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 245313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245321 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245323 */     GIR_RootConstrainSelectedInstOperands,
     /* 245324 */     // GIR_Coverage, 3850,
     /* 245324 */     GIR_EraseRootFromParent_Done,
     /* 245325 */   // Label 4911: @245325
     /* 245325 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245389), // Rule ID 3851 //
     /* 245330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 245338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245366 */     // MIs[0] imm
     /* 245366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245374 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245385 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245387 */     GIR_RootConstrainSelectedInstOperands,
     /* 245388 */     // GIR_Coverage, 3851,
     /* 245388 */     GIR_EraseRootFromParent_Done,
     /* 245389 */   // Label 4912: @245389
     /* 245389 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245453), // Rule ID 3852 //
     /* 245394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 245402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245430 */     // MIs[0] imm
     /* 245430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245438 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 245441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245449 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245451 */     GIR_RootConstrainSelectedInstOperands,
     /* 245452 */     // GIR_Coverage, 3852,
     /* 245452 */     GIR_EraseRootFromParent_Done,
     /* 245453 */   // Label 4913: @245453
     /* 245453 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245505), // Rule ID 2850 //
     /* 245458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245482 */     // MIs[0] idx
     /* 245482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245490 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 245490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 245493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245501 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245503 */     GIR_RootConstrainSelectedInstOperands,
     /* 245504 */     // GIR_Coverage, 2850,
     /* 245504 */     GIR_EraseRootFromParent_Done,
     /* 245505 */   // Label 4914: @245505
     /* 245505 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245557), // Rule ID 2851 //
     /* 245510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245534 */     // MIs[0] idx
     /* 245534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 245542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 245545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245553 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245555 */     GIR_RootConstrainSelectedInstOperands,
     /* 245556 */     // GIR_Coverage, 2851,
     /* 245556 */     GIR_EraseRootFromParent_Done,
     /* 245557 */   // Label 4915: @245557
     /* 245557 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245609), // Rule ID 2852 //
     /* 245562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245586 */     // MIs[0] idx
     /* 245586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 245594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 245597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245605 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245607 */     GIR_RootConstrainSelectedInstOperands,
     /* 245608 */     // GIR_Coverage, 2852,
     /* 245608 */     GIR_EraseRootFromParent_Done,
     /* 245609 */   // Label 4916: @245609
     /* 245609 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245661), // Rule ID 2980 //
     /* 245614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245638 */     // MIs[0] Op4
     /* 245638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 245649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245657 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245659 */     GIR_RootConstrainSelectedInstOperands,
     /* 245660 */     // GIR_Coverage, 2980,
     /* 245660 */     GIR_EraseRootFromParent_Done,
     /* 245661 */   // Label 4917: @245661
     /* 245661 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245713), // Rule ID 2981 //
     /* 245666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245690 */     // MIs[0] Op4
     /* 245690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 245701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245711 */     GIR_RootConstrainSelectedInstOperands,
     /* 245712 */     // GIR_Coverage, 2981,
     /* 245712 */     GIR_EraseRootFromParent_Done,
     /* 245713 */   // Label 4918: @245713
     /* 245713 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245765), // Rule ID 2982 //
     /* 245718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245742 */     // MIs[0] Op4
     /* 245742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 245753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245763 */     GIR_RootConstrainSelectedInstOperands,
     /* 245764 */     // GIR_Coverage, 2982,
     /* 245764 */     GIR_EraseRootFromParent_Done,
     /* 245765 */   // Label 4919: @245765
     /* 245765 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245817), // Rule ID 2983 //
     /* 245770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 245778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245794 */     // MIs[0] Op4
     /* 245794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 245805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245815 */     GIR_RootConstrainSelectedInstOperands,
     /* 245816 */     // GIR_Coverage, 2983,
     /* 245816 */     GIR_EraseRootFromParent_Done,
     /* 245817 */   // Label 4920: @245817
     /* 245817 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(245869), // Rule ID 2984 //
     /* 245822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 245830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245846 */     // MIs[0] Op4
     /* 245846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 245857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245867 */     GIR_RootConstrainSelectedInstOperands,
     /* 245868 */     // GIR_Coverage, 2984,
     /* 245868 */     GIR_EraseRootFromParent_Done,
     /* 245869 */   // Label 4921: @245869
     /* 245869 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(245921), // Rule ID 2987 //
     /* 245874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 245882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245898 */     // MIs[0] Op4
     /* 245898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 245909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245917 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245919 */     GIR_RootConstrainSelectedInstOperands,
     /* 245920 */     // GIR_Coverage, 2987,
     /* 245920 */     GIR_EraseRootFromParent_Done,
     /* 245921 */   // Label 4922: @245921
     /* 245921 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(245973), // Rule ID 2988 //
     /* 245926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 245934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245950 */     // MIs[0] Op4
     /* 245950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 245961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245969 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245971 */     GIR_RootConstrainSelectedInstOperands,
     /* 245972 */     // GIR_Coverage, 2988,
     /* 245972 */     GIR_EraseRootFromParent_Done,
     /* 245973 */   // Label 4923: @245973
     /* 245973 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246025), // Rule ID 3462 //
     /* 245978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 245981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 245986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246002 */     // MIs[0] Op4
     /* 246002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 246013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246021 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246023 */     GIR_RootConstrainSelectedInstOperands,
     /* 246024 */     // GIR_Coverage, 3462,
     /* 246024 */     GIR_EraseRootFromParent_Done,
     /* 246025 */   // Label 4924: @246025
     /* 246025 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246077), // Rule ID 3506 //
     /* 246030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 246038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246054 */     // MIs[0] Op4
     /* 246054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 246065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246073 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246075 */     GIR_RootConstrainSelectedInstOperands,
     /* 246076 */     // GIR_Coverage, 3506,
     /* 246076 */     GIR_EraseRootFromParent_Done,
     /* 246077 */   // Label 4925: @246077
     /* 246077 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246129), // Rule ID 7678 //
     /* 246082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 246090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246106 */     // MIs[0] Op4
     /* 246106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1957:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 246117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246127 */     GIR_RootConstrainSelectedInstOperands,
     /* 246128 */     // GIR_Coverage, 7678,
     /* 246128 */     GIR_EraseRootFromParent_Done,
     /* 246129 */   // Label 4926: @246129
     /* 246129 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246181), // Rule ID 7679 //
     /* 246134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 246142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246158 */     // MIs[0] Op4
     /* 246158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1957:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 246169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246177 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246179 */     GIR_RootConstrainSelectedInstOperands,
     /* 246180 */     // GIR_Coverage, 7679,
     /* 246180 */     GIR_EraseRootFromParent_Done,
     /* 246181 */   // Label 4927: @246181
     /* 246181 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246233), // Rule ID 8319 //
     /* 246186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246210 */     // MIs[0] idx
     /* 246210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246218 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 246218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 246221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246229 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246231 */     GIR_RootConstrainSelectedInstOperands,
     /* 246232 */     // GIR_Coverage, 8319,
     /* 246232 */     GIR_EraseRootFromParent_Done,
     /* 246233 */   // Label 4928: @246233
     /* 246233 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246285), // Rule ID 8320 //
     /* 246238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246262 */     // MIs[0] idx
     /* 246262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246270 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 246270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 246273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246281 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246283 */     GIR_RootConstrainSelectedInstOperands,
     /* 246284 */     // GIR_Coverage, 8320,
     /* 246284 */     GIR_EraseRootFromParent_Done,
     /* 246285 */   // Label 4929: @246285
     /* 246285 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246337), // Rule ID 8321 //
     /* 246290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246314 */     // MIs[0] idx
     /* 246314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 246322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 246325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246333 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246335 */     GIR_RootConstrainSelectedInstOperands,
     /* 246336 */     // GIR_Coverage, 8321,
     /* 246336 */     GIR_EraseRootFromParent_Done,
     /* 246337 */   // Label 4930: @246337
     /* 246337 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246389), // Rule ID 11285 //
     /* 246342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 246345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 246350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246366 */     // MIs[0] Op4
     /* 246366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 246377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246387 */     GIR_RootConstrainSelectedInstOperands,
     /* 246388 */     // GIR_Coverage, 11285,
     /* 246388 */     GIR_EraseRootFromParent_Done,
     /* 246389 */   // Label 4931: @246389
     /* 246389 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246441), // Rule ID 11332 //
     /* 246394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246418 */     // MIs[0] Op4
     /* 246418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 246429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246437 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246439 */     GIR_RootConstrainSelectedInstOperands,
     /* 246440 */     // GIR_Coverage, 11332,
     /* 246440 */     GIR_EraseRootFromParent_Done,
     /* 246441 */   // Label 4932: @246441
     /* 246441 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246493), // Rule ID 11333 //
     /* 246446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246470 */     // MIs[0] Op4
     /* 246470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 246481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246491 */     GIR_RootConstrainSelectedInstOperands,
     /* 246492 */     // GIR_Coverage, 11333,
     /* 246492 */     GIR_EraseRootFromParent_Done,
     /* 246493 */   // Label 4933: @246493
     /* 246493 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246545), // Rule ID 11334 //
     /* 246498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246522 */     // MIs[0] Op4
     /* 246522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 246533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246543 */     GIR_RootConstrainSelectedInstOperands,
     /* 246544 */     // GIR_Coverage, 11334,
     /* 246544 */     GIR_EraseRootFromParent_Done,
     /* 246545 */   // Label 4934: @246545
     /* 246545 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246597), // Rule ID 11335 //
     /* 246550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246574 */     // MIs[0] Op4
     /* 246574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 246585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246593 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246595 */     GIR_RootConstrainSelectedInstOperands,
     /* 246596 */     // GIR_Coverage, 11335,
     /* 246596 */     GIR_EraseRootFromParent_Done,
     /* 246597 */   // Label 4935: @246597
     /* 246597 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246649), // Rule ID 11336 //
     /* 246602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246626 */     // MIs[0] Op4
     /* 246626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 246637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246645 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246647 */     GIR_RootConstrainSelectedInstOperands,
     /* 246648 */     // GIR_Coverage, 11336,
     /* 246648 */     GIR_EraseRootFromParent_Done,
     /* 246649 */   // Label 4936: @246649
     /* 246649 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246701), // Rule ID 11337 //
     /* 246654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246678 */     // MIs[0] Op4
     /* 246678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 246689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246697 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246699 */     GIR_RootConstrainSelectedInstOperands,
     /* 246700 */     // GIR_Coverage, 11337,
     /* 246700 */     GIR_EraseRootFromParent_Done,
     /* 246701 */   // Label 4937: @246701
     /* 246701 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246753), // Rule ID 11338 //
     /* 246706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246730 */     // MIs[0] Op4
     /* 246730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246733 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246749 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246751 */     GIR_RootConstrainSelectedInstOperands,
     /* 246752 */     // GIR_Coverage, 11338,
     /* 246752 */     GIR_EraseRootFromParent_Done,
     /* 246753 */   // Label 4938: @246753
     /* 246753 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246805), // Rule ID 11339 //
     /* 246758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246782 */     // MIs[0] Op4
     /* 246782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 246793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246801 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246803 */     GIR_RootConstrainSelectedInstOperands,
     /* 246804 */     // GIR_Coverage, 11339,
     /* 246804 */     GIR_EraseRootFromParent_Done,
     /* 246805 */   // Label 4939: @246805
     /* 246805 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246857), // Rule ID 11340 //
     /* 246810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246834 */     // MIs[0] Op4
     /* 246834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 246845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246853 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246855 */     GIR_RootConstrainSelectedInstOperands,
     /* 246856 */     // GIR_Coverage, 11340,
     /* 246856 */     GIR_EraseRootFromParent_Done,
     /* 246857 */   // Label 4940: @246857
     /* 246857 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246909), // Rule ID 11383 //
     /* 246862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 246870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246886 */     // MIs[0] Op4
     /* 246886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 246897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246905 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246907 */     GIR_RootConstrainSelectedInstOperands,
     /* 246908 */     // GIR_Coverage, 11383,
     /* 246908 */     GIR_EraseRootFromParent_Done,
     /* 246909 */   // Label 4941: @246909
     /* 246909 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246961), // Rule ID 11384 //
     /* 246914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 246922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246938 */     // MIs[0] Op4
     /* 246938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 246949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246959 */     GIR_RootConstrainSelectedInstOperands,
     /* 246960 */     // GIR_Coverage, 11384,
     /* 246960 */     GIR_EraseRootFromParent_Done,
     /* 246961 */   // Label 4942: @246961
     /* 246961 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247013), // Rule ID 11385 //
     /* 246966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 246974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246990 */     // MIs[0] Op4
     /* 246990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 247001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247011 */     GIR_RootConstrainSelectedInstOperands,
     /* 247012 */     // GIR_Coverage, 11385,
     /* 247012 */     GIR_EraseRootFromParent_Done,
     /* 247013 */   // Label 4943: @247013
     /* 247013 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247065), // Rule ID 11386 //
     /* 247018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 247026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247042 */     // MIs[0] Op4
     /* 247042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 247053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247061 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247063 */     GIR_RootConstrainSelectedInstOperands,
     /* 247064 */     // GIR_Coverage, 11386,
     /* 247064 */     GIR_EraseRootFromParent_Done,
     /* 247065 */   // Label 4944: @247065
     /* 247065 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247117), // Rule ID 11387 //
     /* 247070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 247078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247094 */     // MIs[0] Op4
     /* 247094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 247105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247113 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247115 */     GIR_RootConstrainSelectedInstOperands,
     /* 247116 */     // GIR_Coverage, 11387,
     /* 247116 */     GIR_EraseRootFromParent_Done,
     /* 247117 */   // Label 4945: @247117
     /* 247117 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247169), // Rule ID 11388 //
     /* 247122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 247130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247146 */     // MIs[0] Op4
     /* 247146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247165 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247167 */     GIR_RootConstrainSelectedInstOperands,
     /* 247168 */     // GIR_Coverage, 11388,
     /* 247168 */     GIR_EraseRootFromParent_Done,
     /* 247169 */   // Label 4946: @247169
     /* 247169 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247221), // Rule ID 11389 //
     /* 247174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 247182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247198 */     // MIs[0] Op4
     /* 247198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 247209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247217 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247219 */     GIR_RootConstrainSelectedInstOperands,
     /* 247220 */     // GIR_Coverage, 11389,
     /* 247220 */     GIR_EraseRootFromParent_Done,
     /* 247221 */   // Label 4947: @247221
     /* 247221 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247273), // Rule ID 11390 //
     /* 247226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 247234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247250 */     // MIs[0] Op4
     /* 247250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 247261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247269 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247271 */     GIR_RootConstrainSelectedInstOperands,
     /* 247272 */     // GIR_Coverage, 11390,
     /* 247272 */     GIR_EraseRootFromParent_Done,
     /* 247273 */   // Label 4948: @247273
     /* 247273 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247325), // Rule ID 11391 //
     /* 247278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 247286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247302 */     // MIs[0] Op4
     /* 247302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 247313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247321 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247323 */     GIR_RootConstrainSelectedInstOperands,
     /* 247324 */     // GIR_Coverage, 11391,
     /* 247324 */     GIR_EraseRootFromParent_Done,
     /* 247325 */   // Label 4949: @247325
     /* 247325 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247377), // Rule ID 11392 //
     /* 247330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 247338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247354 */     // MIs[0] Op4
     /* 247354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 247365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247373 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247375 */     GIR_RootConstrainSelectedInstOperands,
     /* 247376 */     // GIR_Coverage, 11392,
     /* 247376 */     GIR_EraseRootFromParent_Done,
     /* 247377 */   // Label 4950: @247377
     /* 247377 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247429), // Rule ID 11393 //
     /* 247382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 247390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247406 */     // MIs[0] Op4
     /* 247406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 247417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247425 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247427 */     GIR_RootConstrainSelectedInstOperands,
     /* 247428 */     // GIR_Coverage, 11393,
     /* 247428 */     GIR_EraseRootFromParent_Done,
     /* 247429 */   // Label 4951: @247429
     /* 247429 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247481), // Rule ID 11394 //
     /* 247434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 247442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247458 */     // MIs[0] Op4
     /* 247458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 247469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247477 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247479 */     GIR_RootConstrainSelectedInstOperands,
     /* 247480 */     // GIR_Coverage, 11394,
     /* 247480 */     GIR_EraseRootFromParent_Done,
     /* 247481 */   // Label 4952: @247481
     /* 247481 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247533), // Rule ID 11395 //
     /* 247486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 247494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247510 */     // MIs[0] Op4
     /* 247510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 247521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247529 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247531 */     GIR_RootConstrainSelectedInstOperands,
     /* 247532 */     // GIR_Coverage, 11395,
     /* 247532 */     GIR_EraseRootFromParent_Done,
     /* 247533 */   // Label 4953: @247533
     /* 247533 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247585), // Rule ID 11396 //
     /* 247538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 247546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247562 */     // MIs[0] Op4
     /* 247562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 247573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247581 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247583 */     GIR_RootConstrainSelectedInstOperands,
     /* 247584 */     // GIR_Coverage, 11396,
     /* 247584 */     GIR_EraseRootFromParent_Done,
     /* 247585 */   // Label 4954: @247585
     /* 247585 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247637), // Rule ID 11418 //
     /* 247590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 247598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247614 */     // MIs[0] Op4
     /* 247614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247635 */     GIR_RootConstrainSelectedInstOperands,
     /* 247636 */     // GIR_Coverage, 11418,
     /* 247636 */     GIR_EraseRootFromParent_Done,
     /* 247637 */   // Label 4955: @247637
     /* 247637 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247689), // Rule ID 11419 //
     /* 247642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 247650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247666 */     // MIs[0] Op4
     /* 247666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 247677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247685 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247687 */     GIR_RootConstrainSelectedInstOperands,
     /* 247688 */     // GIR_Coverage, 11419,
     /* 247688 */     GIR_EraseRootFromParent_Done,
     /* 247689 */   // Label 4956: @247689
     /* 247689 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247741), // Rule ID 11420 //
     /* 247694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 247702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247718 */     // MIs[0] Op4
     /* 247718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 247729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247737 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247739 */     GIR_RootConstrainSelectedInstOperands,
     /* 247740 */     // GIR_Coverage, 11420,
     /* 247740 */     GIR_EraseRootFromParent_Done,
     /* 247741 */   // Label 4957: @247741
     /* 247741 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247793), // Rule ID 11421 //
     /* 247746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 247754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247770 */     // MIs[0] Op4
     /* 247770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 247781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247789 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247791 */     GIR_RootConstrainSelectedInstOperands,
     /* 247792 */     // GIR_Coverage, 11421,
     /* 247792 */     GIR_EraseRootFromParent_Done,
     /* 247793 */   // Label 4958: @247793
     /* 247793 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247845), // Rule ID 11422 //
     /* 247798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 247806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247822 */     // MIs[0] Op4
     /* 247822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247841 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247843 */     GIR_RootConstrainSelectedInstOperands,
     /* 247844 */     // GIR_Coverage, 11422,
     /* 247844 */     GIR_EraseRootFromParent_Done,
     /* 247845 */   // Label 4959: @247845
     /* 247845 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247897), // Rule ID 11423 //
     /* 247850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 247858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247874 */     // MIs[0] Op4
     /* 247874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 247885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247893 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247895 */     GIR_RootConstrainSelectedInstOperands,
     /* 247896 */     // GIR_Coverage, 11423,
     /* 247896 */     GIR_EraseRootFromParent_Done,
     /* 247897 */   // Label 4960: @247897
     /* 247897 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247949), // Rule ID 11424 //
     /* 247902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 247910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247926 */     // MIs[0] Op4
     /* 247926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 247937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247947 */     GIR_RootConstrainSelectedInstOperands,
     /* 247948 */     // GIR_Coverage, 11424,
     /* 247948 */     GIR_EraseRootFromParent_Done,
     /* 247949 */   // Label 4961: @247949
     /* 247949 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(248001), // Rule ID 11425 //
     /* 247954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 247962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247978 */     // MIs[0] Op4
     /* 247978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 247989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247997 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247999 */     GIR_RootConstrainSelectedInstOperands,
     /* 248000 */     // GIR_Coverage, 11425,
     /* 248000 */     GIR_EraseRootFromParent_Done,
     /* 248001 */   // Label 4962: @248001
     /* 248001 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248053), // Rule ID 11879 //
     /* 248006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 248014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248030 */     // MIs[0] Op4
     /* 248030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248038 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248049 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248051 */     GIR_RootConstrainSelectedInstOperands,
     /* 248052 */     // GIR_Coverage, 11879,
     /* 248052 */     GIR_EraseRootFromParent_Done,
     /* 248053 */   // Label 4963: @248053
     /* 248053 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248105), // Rule ID 11880 //
     /* 248058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 248066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248082 */     // MIs[0] Op4
     /* 248082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 248093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248101 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248103 */     GIR_RootConstrainSelectedInstOperands,
     /* 248104 */     // GIR_Coverage, 11880,
     /* 248104 */     GIR_EraseRootFromParent_Done,
     /* 248105 */   // Label 4964: @248105
     /* 248105 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248157), // Rule ID 11881 //
     /* 248110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 248118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248134 */     // MIs[0] Op4
     /* 248134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 248145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248153 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248155 */     GIR_RootConstrainSelectedInstOperands,
     /* 248156 */     // GIR_Coverage, 11881,
     /* 248156 */     GIR_EraseRootFromParent_Done,
     /* 248157 */   // Label 4965: @248157
     /* 248157 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248209), // Rule ID 11882 //
     /* 248162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 248170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248186 */     // MIs[0] Op4
     /* 248186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248194 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 248197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248207 */     GIR_RootConstrainSelectedInstOperands,
     /* 248208 */     // GIR_Coverage, 11882,
     /* 248208 */     GIR_EraseRootFromParent_Done,
     /* 248209 */   // Label 4966: @248209
     /* 248209 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248261), // Rule ID 12015 //
     /* 248214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 248217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 248222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248238 */     // MIs[0] Op4
     /* 248238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 248246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 248246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 248249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248259 */     GIR_RootConstrainSelectedInstOperands,
     /* 248260 */     // GIR_Coverage, 12015,
     /* 248260 */     GIR_EraseRootFromParent_Done,
     /* 248261 */   // Label 4967: @248261
     /* 248261 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248313), // Rule ID 12017 //
     /* 248266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 248269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 248274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248290 */     // MIs[0] Op4
     /* 248290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 248298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 248298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 248301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248309 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248311 */     GIR_RootConstrainSelectedInstOperands,
     /* 248312 */     // GIR_Coverage, 12017,
     /* 248312 */     GIR_EraseRootFromParent_Done,
     /* 248313 */   // Label 4968: @248313
     /* 248313 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248360), // Rule ID 2829 //
     /* 248318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248345 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248356 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248358 */     GIR_RootConstrainSelectedInstOperands,
     /* 248359 */     // GIR_Coverage, 2829,
     /* 248359 */     GIR_EraseRootFromParent_Done,
     /* 248360 */   // Label 4969: @248360
     /* 248360 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248407), // Rule ID 2832 //
     /* 248365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248392 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248403 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248405 */     GIR_RootConstrainSelectedInstOperands,
     /* 248406 */     // GIR_Coverage, 2832,
     /* 248406 */     GIR_EraseRootFromParent_Done,
     /* 248407 */   // Label 4970: @248407
     /* 248407 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248454), // Rule ID 2835 //
     /* 248412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248439 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248450 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248452 */     GIR_RootConstrainSelectedInstOperands,
     /* 248453 */     // GIR_Coverage, 2835,
     /* 248453 */     GIR_EraseRootFromParent_Done,
     /* 248454 */   // Label 4971: @248454
     /* 248454 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248501), // Rule ID 2838 //
     /* 248459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248486 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 248489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248497 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248499 */     GIR_RootConstrainSelectedInstOperands,
     /* 248500 */     // GIR_Coverage, 2838,
     /* 248500 */     GIR_EraseRootFromParent_Done,
     /* 248501 */   // Label 4972: @248501
     /* 248501 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248548), // Rule ID 2841 //
     /* 248506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248533 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 248536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248544 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248546 */     GIR_RootConstrainSelectedInstOperands,
     /* 248547 */     // GIR_Coverage, 2841,
     /* 248547 */     GIR_EraseRootFromParent_Done,
     /* 248548 */   // Label 4973: @248548
     /* 248548 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248595), // Rule ID 2844 //
     /* 248553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248580 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248593 */     GIR_RootConstrainSelectedInstOperands,
     /* 248594 */     // GIR_Coverage, 2844,
     /* 248594 */     GIR_EraseRootFromParent_Done,
     /* 248595 */   // Label 4974: @248595
     /* 248595 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248642), // Rule ID 2847 //
     /* 248600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 248630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248638 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248640 */     GIR_RootConstrainSelectedInstOperands,
     /* 248641 */     // GIR_Coverage, 2847,
     /* 248641 */     GIR_EraseRootFromParent_Done,
     /* 248642 */   // Label 4975: @248642
     /* 248642 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248689), // Rule ID 2848 //
     /* 248647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248674 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 248677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248685 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248687 */     GIR_RootConstrainSelectedInstOperands,
     /* 248688 */     // GIR_Coverage, 2848,
     /* 248688 */     GIR_EraseRootFromParent_Done,
     /* 248689 */   // Label 4976: @248689
     /* 248689 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248736), // Rule ID 2849 //
     /* 248694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248721 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 248724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248732 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248734 */     GIR_RootConstrainSelectedInstOperands,
     /* 248735 */     // GIR_Coverage, 2849,
     /* 248735 */     GIR_EraseRootFromParent_Done,
     /* 248736 */   // Label 4977: @248736
     /* 248736 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248783), // Rule ID 2945 //
     /* 248741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 248764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 248768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248779 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248781 */     GIR_RootConstrainSelectedInstOperands,
     /* 248782 */     // GIR_Coverage, 2945,
     /* 248782 */     GIR_EraseRootFromParent_Done,
     /* 248783 */   // Label 4978: @248783
     /* 248783 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248830), // Rule ID 2948 //
     /* 248788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 248815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248826 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248828 */     GIR_RootConstrainSelectedInstOperands,
     /* 248829 */     // GIR_Coverage, 2948,
     /* 248829 */     GIR_EraseRootFromParent_Done,
     /* 248830 */   // Label 4979: @248830
     /* 248830 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248877), // Rule ID 2951 //
     /* 248835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 248862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248873 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248875 */     GIR_RootConstrainSelectedInstOperands,
     /* 248876 */     // GIR_Coverage, 2951,
     /* 248876 */     GIR_EraseRootFromParent_Done,
     /* 248877 */   // Label 4980: @248877
     /* 248877 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248924), // Rule ID 2954 //
     /* 248882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 248909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 248912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248920 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248922 */     GIR_RootConstrainSelectedInstOperands,
     /* 248923 */     // GIR_Coverage, 2954,
     /* 248923 */     GIR_EraseRootFromParent_Done,
     /* 248924 */   // Label 4981: @248924
     /* 248924 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248971), // Rule ID 2957 //
     /* 248929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 248937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 248952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 248956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 248959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248967 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248969 */     GIR_RootConstrainSelectedInstOperands,
     /* 248970 */     // GIR_Coverage, 2957,
     /* 248970 */     GIR_EraseRootFromParent_Done,
     /* 248971 */   // Label 4982: @248971
     /* 248971 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249018), // Rule ID 2959 //
     /* 248976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 248984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 249003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 249006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249014 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249016 */     GIR_RootConstrainSelectedInstOperands,
     /* 249017 */     // GIR_Coverage, 2959,
     /* 249017 */     GIR_EraseRootFromParent_Done,
     /* 249018 */   // Label 4983: @249018
     /* 249018 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249065), // Rule ID 2961 //
     /* 249023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 249031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 249053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249061 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249063 */     GIR_RootConstrainSelectedInstOperands,
     /* 249064 */     // GIR_Coverage, 2961,
     /* 249064 */     GIR_EraseRootFromParent_Done,
     /* 249065 */   // Label 4984: @249065
     /* 249065 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249112), // Rule ID 2963 //
     /* 249070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 249078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 249100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249108 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249110 */     GIR_RootConstrainSelectedInstOperands,
     /* 249111 */     // GIR_Coverage, 2963,
     /* 249111 */     GIR_EraseRootFromParent_Done,
     /* 249112 */   // Label 4985: @249112
     /* 249112 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249159), // Rule ID 7584 //
     /* 249117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 249140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 249144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 249147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249155 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249157 */     GIR_RootConstrainSelectedInstOperands,
     /* 249158 */     // GIR_Coverage, 7584,
     /* 249158 */     GIR_EraseRootFromParent_Done,
     /* 249159 */   // Label 4986: @249159
     /* 249159 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249206), // Rule ID 7587 //
     /* 249164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 249191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249202 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249204 */     GIR_RootConstrainSelectedInstOperands,
     /* 249205 */     // GIR_Coverage, 7587,
     /* 249205 */     GIR_EraseRootFromParent_Done,
     /* 249206 */   // Label 4987: @249206
     /* 249206 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249253), // Rule ID 7590 //
     /* 249211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 249241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249249 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249251 */     GIR_RootConstrainSelectedInstOperands,
     /* 249252 */     // GIR_Coverage, 7590,
     /* 249252 */     GIR_EraseRootFromParent_Done,
     /* 249253 */   // Label 4988: @249253
     /* 249253 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249300), // Rule ID 7593 //
     /* 249258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 249288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249296 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249298 */     GIR_RootConstrainSelectedInstOperands,
     /* 249299 */     // GIR_Coverage, 7593,
     /* 249299 */     GIR_EraseRootFromParent_Done,
     /* 249300 */   // Label 4989: @249300
     /* 249300 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249347), // Rule ID 7596 //
     /* 249305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 249328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 249332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 249335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249343 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249345 */     GIR_RootConstrainSelectedInstOperands,
     /* 249346 */     // GIR_Coverage, 7596,
     /* 249346 */     GIR_EraseRootFromParent_Done,
     /* 249347 */   // Label 4990: @249347
     /* 249347 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249394), // Rule ID 7598 //
     /* 249352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 249379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 249382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249390 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249392 */     GIR_RootConstrainSelectedInstOperands,
     /* 249393 */     // GIR_Coverage, 7598,
     /* 249393 */     GIR_EraseRootFromParent_Done,
     /* 249394 */   // Label 4991: @249394
     /* 249394 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249441), // Rule ID 7600 //
     /* 249399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249437 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249439 */     GIR_RootConstrainSelectedInstOperands,
     /* 249440 */     // GIR_Coverage, 7600,
     /* 249440 */     GIR_EraseRootFromParent_Done,
     /* 249441 */   // Label 4992: @249441
     /* 249441 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249488), // Rule ID 7602 //
     /* 249446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 249476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249484 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249486 */     GIR_RootConstrainSelectedInstOperands,
     /* 249487 */     // GIR_Coverage, 7602,
     /* 249487 */     GIR_EraseRootFromParent_Done,
     /* 249488 */   // Label 4993: @249488
     /* 249488 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249535), // Rule ID 8232 //
     /* 249493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249531 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249533 */     GIR_RootConstrainSelectedInstOperands,
     /* 249534 */     // GIR_Coverage, 8232,
     /* 249534 */     GIR_EraseRootFromParent_Done,
     /* 249535 */   // Label 4994: @249535
     /* 249535 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249582), // Rule ID 8235 //
     /* 249540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249567 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249578 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249580 */     GIR_RootConstrainSelectedInstOperands,
     /* 249581 */     // GIR_Coverage, 8235,
     /* 249581 */     GIR_EraseRootFromParent_Done,
     /* 249582 */   // Label 4995: @249582
     /* 249582 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249629), // Rule ID 8238 //
     /* 249587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249614 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249625 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249627 */     GIR_RootConstrainSelectedInstOperands,
     /* 249628 */     // GIR_Coverage, 8238,
     /* 249628 */     GIR_EraseRootFromParent_Done,
     /* 249629 */   // Label 4996: @249629
     /* 249629 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249676), // Rule ID 8241 //
     /* 249634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249661 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 249664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249672 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249674 */     GIR_RootConstrainSelectedInstOperands,
     /* 249675 */     // GIR_Coverage, 8241,
     /* 249675 */     GIR_EraseRootFromParent_Done,
     /* 249676 */   // Label 4997: @249676
     /* 249676 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249723), // Rule ID 8244 //
     /* 249681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249708 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 249711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249719 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249721 */     GIR_RootConstrainSelectedInstOperands,
     /* 249722 */     // GIR_Coverage, 8244,
     /* 249722 */     GIR_EraseRootFromParent_Done,
     /* 249723 */   // Label 4998: @249723
     /* 249723 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249770), // Rule ID 8247 //
     /* 249728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249755 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 249758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249766 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249768 */     GIR_RootConstrainSelectedInstOperands,
     /* 249769 */     // GIR_Coverage, 8247,
     /* 249769 */     GIR_EraseRootFromParent_Done,
     /* 249770 */   // Label 4999: @249770
     /* 249770 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249817), // Rule ID 8250 //
     /* 249775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249815 */     GIR_RootConstrainSelectedInstOperands,
     /* 249816 */     // GIR_Coverage, 8250,
     /* 249816 */     GIR_EraseRootFromParent_Done,
     /* 249817 */   // Label 5000: @249817
     /* 249817 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249864), // Rule ID 8251 //
     /* 249822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249849 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249860 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249862 */     GIR_RootConstrainSelectedInstOperands,
     /* 249863 */     // GIR_Coverage, 8251,
     /* 249863 */     GIR_EraseRootFromParent_Done,
     /* 249864 */   // Label 5001: @249864
     /* 249864 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249911), // Rule ID 8252 //
     /* 249869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249896 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249907 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249909 */     GIR_RootConstrainSelectedInstOperands,
     /* 249910 */     // GIR_Coverage, 8252,
     /* 249910 */     GIR_EraseRootFromParent_Done,
     /* 249911 */   // Label 5002: @249911
     /* 249911 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249958), // Rule ID 8253 //
     /* 249916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249943 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 249946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249954 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249956 */     GIR_RootConstrainSelectedInstOperands,
     /* 249957 */     // GIR_Coverage, 8253,
     /* 249957 */     GIR_EraseRootFromParent_Done,
     /* 249958 */   // Label 5003: @249958
     /* 249958 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(250005), // Rule ID 8254 //
     /* 249963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 249993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250003 */     GIR_RootConstrainSelectedInstOperands,
     /* 250004 */     // GIR_Coverage, 8254,
     /* 250004 */     GIR_EraseRootFromParent_Done,
     /* 250005 */   // Label 5004: @250005
     /* 250005 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250052), // Rule ID 8255 //
     /* 250010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 250018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250037 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 250040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250048 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250050 */     GIR_RootConstrainSelectedInstOperands,
     /* 250051 */     // GIR_Coverage, 8255,
     /* 250051 */     GIR_EraseRootFromParent_Done,
     /* 250052 */   // Label 5005: @250052
     /* 250052 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250099), // Rule ID 8256 //
     /* 250057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250095 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250097 */     GIR_RootConstrainSelectedInstOperands,
     /* 250098 */     // GIR_Coverage, 8256,
     /* 250098 */     GIR_EraseRootFromParent_Done,
     /* 250099 */   // Label 5006: @250099
     /* 250099 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250146), // Rule ID 8257 //
     /* 250104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 250115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 250121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 250124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 250127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250131 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 250131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250142 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250144 */     GIR_RootConstrainSelectedInstOperands,
     /* 250145 */     // GIR_Coverage, 8257,
     /* 250145 */     GIR_EraseRootFromParent_Done,
     /* 250146 */   // Label 5007: @250146
     /* 250146 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250193), // Rule ID 8258 //
     /* 250151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 250162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 250168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 250171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 250174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250178 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 250178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250189 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250191 */     GIR_RootConstrainSelectedInstOperands,
     /* 250192 */     // GIR_Coverage, 8258,
     /* 250192 */     GIR_EraseRootFromParent_Done,
     /* 250193 */   // Label 5008: @250193
     /* 250193 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250240), // Rule ID 8259 //
     /* 250198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 250228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250236 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250238 */     GIR_RootConstrainSelectedInstOperands,
     /* 250239 */     // GIR_Coverage, 8259,
     /* 250239 */     GIR_EraseRootFromParent_Done,
     /* 250240 */   // Label 5009: @250240
     /* 250240 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250287), // Rule ID 8260 //
     /* 250245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 250256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 250262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 250265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 250268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250272 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 250272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250283 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250285 */     GIR_RootConstrainSelectedInstOperands,
     /* 250286 */     // GIR_Coverage, 8260,
     /* 250286 */     GIR_EraseRootFromParent_Done,
     /* 250287 */   // Label 5010: @250287
     /* 250287 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250334), // Rule ID 8261 //
     /* 250292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250319 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 250322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250332 */     GIR_RootConstrainSelectedInstOperands,
     /* 250333 */     // GIR_Coverage, 8261,
     /* 250333 */     GIR_EraseRootFromParent_Done,
     /* 250334 */   // Label 5011: @250334
     /* 250334 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250381), // Rule ID 8262 //
     /* 250339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250366 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 250369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250377 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250379 */     GIR_RootConstrainSelectedInstOperands,
     /* 250380 */     // GIR_Coverage, 8262,
     /* 250380 */     GIR_EraseRootFromParent_Done,
     /* 250381 */   // Label 5012: @250381
     /* 250381 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250428), // Rule ID 8263 //
     /* 250386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250413 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 250416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250424 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250426 */     GIR_RootConstrainSelectedInstOperands,
     /* 250427 */     // GIR_Coverage, 8263,
     /* 250427 */     GIR_EraseRootFromParent_Done,
     /* 250428 */   // Label 5013: @250428
     /* 250428 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250475), // Rule ID 8264 //
     /* 250433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250460 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 250463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250471 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250473 */     GIR_RootConstrainSelectedInstOperands,
     /* 250474 */     // GIR_Coverage, 8264,
     /* 250474 */     GIR_EraseRootFromParent_Done,
     /* 250475 */   // Label 5014: @250475
     /* 250475 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250522), // Rule ID 8265 //
     /* 250480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 250510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250518 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250520 */     GIR_RootConstrainSelectedInstOperands,
     /* 250521 */     // GIR_Coverage, 8265,
     /* 250521 */     GIR_EraseRootFromParent_Done,
     /* 250522 */   // Label 5015: @250522
     /* 250522 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250569), // Rule ID 8266 //
     /* 250527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 250557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250565 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250567 */     GIR_RootConstrainSelectedInstOperands,
     /* 250568 */     // GIR_Coverage, 8266,
     /* 250568 */     GIR_EraseRootFromParent_Done,
     /* 250569 */   // Label 5016: @250569
     /* 250569 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250616), // Rule ID 8267 //
     /* 250574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250601 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 250604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250612 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250614 */     GIR_RootConstrainSelectedInstOperands,
     /* 250615 */     // GIR_Coverage, 8267,
     /* 250615 */     GIR_EraseRootFromParent_Done,
     /* 250616 */   // Label 5017: @250616
     /* 250616 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250663), // Rule ID 8268 //
     /* 250621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 250651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250659 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250661 */     GIR_RootConstrainSelectedInstOperands,
     /* 250662 */     // GIR_Coverage, 8268,
     /* 250662 */     GIR_EraseRootFromParent_Done,
     /* 250663 */   // Label 5018: @250663
     /* 250663 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250710), // Rule ID 8269 //
     /* 250668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250695 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 250698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250708 */     GIR_RootConstrainSelectedInstOperands,
     /* 250709 */     // GIR_Coverage, 8269,
     /* 250709 */     GIR_EraseRootFromParent_Done,
     /* 250710 */   // Label 5019: @250710
     /* 250710 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250757), // Rule ID 8270 //
     /* 250715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250742 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 250745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250753 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250755 */     GIR_RootConstrainSelectedInstOperands,
     /* 250756 */     // GIR_Coverage, 8270,
     /* 250756 */     GIR_EraseRootFromParent_Done,
     /* 250757 */   // Label 5020: @250757
     /* 250757 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250804), // Rule ID 8271 //
     /* 250762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250789 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250800 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250802 */     GIR_RootConstrainSelectedInstOperands,
     /* 250803 */     // GIR_Coverage, 8271,
     /* 250803 */     GIR_EraseRootFromParent_Done,
     /* 250804 */   // Label 5021: @250804
     /* 250804 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250851), // Rule ID 8274 //
     /* 250809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 250820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 250826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 250829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 250832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250836 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 250836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250847 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250849 */     GIR_RootConstrainSelectedInstOperands,
     /* 250850 */     // GIR_Coverage, 8274,
     /* 250850 */     GIR_EraseRootFromParent_Done,
     /* 250851 */   // Label 5022: @250851
     /* 250851 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250898), // Rule ID 8277 //
     /* 250856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 250867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 250873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 250876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 250879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250883 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 250883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250894 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250896 */     GIR_RootConstrainSelectedInstOperands,
     /* 250897 */     // GIR_Coverage, 8277,
     /* 250897 */     GIR_EraseRootFromParent_Done,
     /* 250898 */   // Label 5023: @250898
     /* 250898 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250945), // Rule ID 8280 //
     /* 250903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 250933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250941 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250943 */     GIR_RootConstrainSelectedInstOperands,
     /* 250944 */     // GIR_Coverage, 8280,
     /* 250944 */     GIR_EraseRootFromParent_Done,
     /* 250945 */   // Label 5024: @250945
     /* 250945 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250992), // Rule ID 8283 //
     /* 250950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 250961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 250967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 250970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 250973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250977 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 250977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 250980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250988 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250990 */     GIR_RootConstrainSelectedInstOperands,
     /* 250991 */     // GIR_Coverage, 8283,
     /* 250991 */     GIR_EraseRootFromParent_Done,
     /* 250992 */   // Label 5025: @250992
     /* 250992 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251039), // Rule ID 8286 //
     /* 250997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 251005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 251027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251037 */     GIR_RootConstrainSelectedInstOperands,
     /* 251038 */     // GIR_Coverage, 8286,
     /* 251038 */     GIR_EraseRootFromParent_Done,
     /* 251039 */   // Label 5026: @251039
     /* 251039 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251086), // Rule ID 8289 //
     /* 251044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251071 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 251071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251082 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251084 */     GIR_RootConstrainSelectedInstOperands,
     /* 251085 */     // GIR_Coverage, 8289,
     /* 251085 */     GIR_EraseRootFromParent_Done,
     /* 251086 */   // Label 5027: @251086
     /* 251086 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251133), // Rule ID 8292 //
     /* 251091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 251102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 251108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 251111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 251114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251118 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 251118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251129 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251131 */     GIR_RootConstrainSelectedInstOperands,
     /* 251132 */     // GIR_Coverage, 8292,
     /* 251132 */     GIR_EraseRootFromParent_Done,
     /* 251133 */   // Label 5028: @251133
     /* 251133 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251180), // Rule ID 8295 //
     /* 251138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 251149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 251155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 251158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 251161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251165 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 251165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251176 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251178 */     GIR_RootConstrainSelectedInstOperands,
     /* 251179 */     // GIR_Coverage, 8295,
     /* 251179 */     GIR_EraseRootFromParent_Done,
     /* 251180 */   // Label 5029: @251180
     /* 251180 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251227), // Rule ID 8298 //
     /* 251185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251212 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 251212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 251215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251225 */     GIR_RootConstrainSelectedInstOperands,
     /* 251226 */     // GIR_Coverage, 8298,
     /* 251226 */     GIR_EraseRootFromParent_Done,
     /* 251227 */   // Label 5030: @251227
     /* 251227 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251274), // Rule ID 8301 //
     /* 251232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 251243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 251249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 251252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 251255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251259 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 251259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 251262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251272 */     GIR_RootConstrainSelectedInstOperands,
     /* 251273 */     // GIR_Coverage, 8301,
     /* 251273 */     GIR_EraseRootFromParent_Done,
     /* 251274 */   // Label 5031: @251274
     /* 251274 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251321), // Rule ID 8304 //
     /* 251279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251306 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 251309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251317 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251319 */     GIR_RootConstrainSelectedInstOperands,
     /* 251320 */     // GIR_Coverage, 8304,
     /* 251320 */     GIR_EraseRootFromParent_Done,
     /* 251321 */   // Label 5032: @251321
     /* 251321 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251368), // Rule ID 8307 //
     /* 251326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251353 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 251353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251364 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251366 */     GIR_RootConstrainSelectedInstOperands,
     /* 251367 */     // GIR_Coverage, 8307,
     /* 251367 */     GIR_EraseRootFromParent_Done,
     /* 251368 */   // Label 5033: @251368
     /* 251368 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251415), // Rule ID 8309 //
     /* 251373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 251384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 251390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 251393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 251396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251400 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 251400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251413 */     GIR_RootConstrainSelectedInstOperands,
     /* 251414 */     // GIR_Coverage, 8309,
     /* 251414 */     GIR_EraseRootFromParent_Done,
     /* 251415 */   // Label 5034: @251415
     /* 251415 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251462), // Rule ID 8311 //
     /* 251420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 251431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 251437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 251440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 251443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251447 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 251447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251458 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251460 */     GIR_RootConstrainSelectedInstOperands,
     /* 251461 */     // GIR_Coverage, 8311,
     /* 251461 */     GIR_EraseRootFromParent_Done,
     /* 251462 */   // Label 5035: @251462
     /* 251462 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251509), // Rule ID 8313 //
     /* 251467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 251494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 251497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251507 */     GIR_RootConstrainSelectedInstOperands,
     /* 251508 */     // GIR_Coverage, 8313,
     /* 251508 */     GIR_EraseRootFromParent_Done,
     /* 251509 */   // Label 5036: @251509
     /* 251509 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251556), // Rule ID 8315 //
     /* 251514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 251525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 251531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 251534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 251537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251541 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 251541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251552 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251554 */     GIR_RootConstrainSelectedInstOperands,
     /* 251555 */     // GIR_Coverage, 8315,
     /* 251555 */     GIR_EraseRootFromParent_Done,
     /* 251556 */   // Label 5037: @251556
     /* 251556 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251603), // Rule ID 8317 //
     /* 251561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 251591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251601 */     GIR_RootConstrainSelectedInstOperands,
     /* 251602 */     // GIR_Coverage, 8317,
     /* 251602 */     GIR_EraseRootFromParent_Done,
     /* 251603 */   // Label 5038: @251603
     /* 251603 */   GIM_Reject,
     /* 251604 */ // Label 4897: @251604
     /* 251604 */ GIM_Reject,
     /* 251605 */ // Label 38: @251605
     /* 251605 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251683),
     /* 251610 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 251613 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251635), // Rule ID 78 //
     /* 251618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 251621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 251626 */     // (intrinsic_void 2166:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 251626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 251629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251633 */     GIR_RootConstrainSelectedInstOperands,
     /* 251634 */     // GIR_Coverage, 78,
     /* 251634 */     GIR_EraseRootFromParent_Done,
     /* 251635 */   // Label 5040: @251635
     /* 251635 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251660), // Rule ID 2386 //
     /* 251640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 251648 */     // (intrinsic_void 1716:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 251648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 251651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 251654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251658 */     GIR_RootConstrainSelectedInstOperands,
     /* 251659 */     // GIR_Coverage, 2386,
     /* 251659 */     GIR_EraseRootFromParent_Done,
     /* 251660 */   // Label 5041: @251660
     /* 251660 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251682), // Rule ID 7138 //
     /* 251665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 251670 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 251670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 251673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 251676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251680 */     GIR_RootConstrainSelectedInstOperands,
     /* 251681 */     // GIR_Coverage, 7138,
     /* 251681 */     GIR_EraseRootFromParent_Done,
     /* 251682 */   // Label 5042: @251682
     /* 251682 */   GIM_Reject,
     /* 251683 */ // Label 5039: @251683
     /* 251683 */ GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252283),
     /* 251688 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 251691 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251723), // Rule ID 79 //
     /* 251696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 251699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 251704 */     // MIs[0] imm
     /* 251704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 251712 */     // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 251712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 251715 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251721 */     GIR_RootConstrainSelectedInstOperands,
     /* 251722 */     // GIR_Coverage, 79,
     /* 251722 */     GIR_EraseRootFromParent_Done,
     /* 251723 */   // Label 5044: @251723
     /* 251723 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251748), // Rule ID 227 //
     /* 251728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 251733 */     // MIs[0] imm
     /* 251733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 251741 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 251741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 251744 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251746 */     GIR_RootConstrainSelectedInstOperands,
     /* 251747 */     // GIR_Coverage, 227,
     /* 251747 */     GIR_EraseRootFromParent_Done,
     /* 251748 */   // Label 5045: @251748
     /* 251748 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(251773), // Rule ID 228 //
     /* 251753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 251758 */     // MIs[0] imm
     /* 251758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 251766 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 251766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 251769 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251771 */     GIR_RootConstrainSelectedInstOperands,
     /* 251772 */     // GIR_Coverage, 228,
     /* 251772 */     GIR_EraseRootFromParent_Done,
     /* 251773 */   // Label 5046: @251773
     /* 251773 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(251805), // Rule ID 3624 //
     /* 251778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 251781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 251786 */     // MIs[0] imm
     /* 251786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 251794 */     // (intrinsic_void 1222:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 251794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 251797 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251803 */     GIR_RootConstrainSelectedInstOperands,
     /* 251804 */     // GIR_Coverage, 3624,
     /* 251804 */     GIR_EraseRootFromParent_Done,
     /* 251805 */   // Label 5047: @251805
     /* 251805 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(251845), // Rule ID 16 //
     /* 251810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 251815 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 251830 */     // MIs[1] Operand 1
     /* 251830 */     // No operand predicates
     /* 251830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251832 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 251832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 251835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 251838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251843 */     GIR_RootConstrainSelectedInstOperands,
     /* 251844 */     // GIR_Coverage, 16,
     /* 251844 */     GIR_EraseRootFromParent_Done,
     /* 251845 */   // Label 5048: @251845
     /* 251845 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(251885), // Rule ID 17 //
     /* 251850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 251855 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251870 */     // MIs[1] Operand 1
     /* 251870 */     // No operand predicates
     /* 251870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251872 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 251872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 251875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251883 */     GIR_RootConstrainSelectedInstOperands,
     /* 251884 */     // GIR_Coverage, 17,
     /* 251884 */     GIR_EraseRootFromParent_Done,
     /* 251885 */   // Label 5049: @251885
     /* 251885 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(251925), // Rule ID 18 //
     /* 251890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 251895 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251910 */     // MIs[1] Operand 1
     /* 251910 */     // No operand predicates
     /* 251910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251912 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 251912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 251915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251923 */     GIR_RootConstrainSelectedInstOperands,
     /* 251924 */     // GIR_Coverage, 18,
     /* 251924 */     GIR_EraseRootFromParent_Done,
     /* 251925 */   // Label 5050: @251925
     /* 251925 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(251965), // Rule ID 19 //
     /* 251930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 251935 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251950 */     // MIs[1] Operand 1
     /* 251950 */     // No operand predicates
     /* 251950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251952 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 251952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 251955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251963 */     GIR_RootConstrainSelectedInstOperands,
     /* 251964 */     // GIR_Coverage, 19,
     /* 251964 */     GIR_EraseRootFromParent_Done,
     /* 251965 */   // Label 5051: @251965
     /* 251965 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(251989), // Rule ID 72 //
     /* 251970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 251975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251982 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 251982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 251985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251987 */     GIR_RootConstrainSelectedInstOperands,
     /* 251988 */     // GIR_Coverage, 72,
     /* 251988 */     GIR_EraseRootFromParent_Done,
     /* 251989 */   // Label 5052: @251989
     /* 251989 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252013), // Rule ID 74 //
     /* 251994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 251999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252006 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 252006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 252009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252011 */     GIR_RootConstrainSelectedInstOperands,
     /* 252012 */     // GIR_Coverage, 74,
     /* 252012 */     GIR_EraseRootFromParent_Done,
     /* 252013 */   // Label 5053: @252013
     /* 252013 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252044), // Rule ID 77 //
     /* 252018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 252021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 252026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252033 */     // (intrinsic_w_chain:{ *:[i64] } 2167:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 252033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 252036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252042 */     GIR_RootConstrainSelectedInstOperands,
     /* 252043 */     // GIR_Coverage, 77,
     /* 252043 */     GIR_EraseRootFromParent_Done,
     /* 252044 */   // Label 5054: @252044
     /* 252044 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252071), // Rule ID 80 //
     /* 252049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 252052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 252057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252064 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 252064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 252067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252069 */     GIR_RootConstrainSelectedInstOperands,
     /* 252070 */     // GIR_Coverage, 80,
     /* 252070 */     GIR_EraseRootFromParent_Done,
     /* 252071 */   // Label 5055: @252071
     /* 252071 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252102), // Rule ID 2385 //
     /* 252076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 252084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 252087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252091 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1666:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 252091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 252094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 252096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252100 */     GIR_RootConstrainSelectedInstOperands,
     /* 252101 */     // GIR_Coverage, 2385,
     /* 252101 */     GIR_EraseRootFromParent_Done,
     /* 252102 */   // Label 5056: @252102
     /* 252102 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252142), // Rule ID 12801 //
     /* 252107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 252110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 252115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252122 */     // (intrinsic_w_chain:{ *:[i64] } 891:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 252122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 252125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252127 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 252137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 252140 */     GIR_RootConstrainSelectedInstOperands,
     /* 252141 */     // GIR_Coverage, 12801,
     /* 252141 */     GIR_EraseRootFromParent_Done,
     /* 252142 */   // Label 5057: @252142
     /* 252142 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252176), // Rule ID 2387 //
     /* 252147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 252155 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 252158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252162 */     // (intrinsic_void 2146:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 252162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 252165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 252167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 252170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252174 */     GIR_RootConstrainSelectedInstOperands,
     /* 252175 */     // GIR_Coverage, 2387,
     /* 252175 */     GIR_EraseRootFromParent_Done,
     /* 252176 */   // Label 5058: @252176
     /* 252176 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252199), // Rule ID 73 //
     /* 252181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 252186 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252189 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 252189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 252192 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 252197 */     GIR_RootConstrainSelectedInstOperands,
     /* 252198 */     // GIR_Coverage, 73,
     /* 252198 */     GIR_EraseRootFromParent_Done,
     /* 252199 */   // Label 5059: @252199
     /* 252199 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252222), // Rule ID 75 //
     /* 252204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 252209 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252212 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 252212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 252215 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 252220 */     GIR_RootConstrainSelectedInstOperands,
     /* 252221 */     // GIR_Coverage, 75,
     /* 252221 */     GIR_EraseRootFromParent_Done,
     /* 252222 */   // Label 5060: @252222
     /* 252222 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252249), // Rule ID 76 //
     /* 252227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 252232 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252235 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 252235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 252238 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 252243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252247 */     GIR_RootConstrainSelectedInstOperands,
     /* 252248 */     // GIR_Coverage, 76,
     /* 252248 */     GIR_EraseRootFromParent_Done,
     /* 252249 */   // Label 5061: @252249
     /* 252249 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252282), // Rule ID 12800 //
     /* 252254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 252257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 252262 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252265 */     // (intrinsic_void 966:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 252265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 252268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 252278 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252280 */     GIR_RootConstrainSelectedInstOperands,
     /* 252281 */     // GIR_Coverage, 12800,
     /* 252281 */     GIR_EraseRootFromParent_Done,
     /* 252282 */   // Label 5062: @252282
     /* 252282 */   GIM_Reject,
     /* 252283 */ // Label 5043: @252283
     /* 252283 */ GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253254),
     /* 252288 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 252291 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252367), // Rule ID 7104 //
     /* 252296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252308 */     // MIs[0] addr
     /* 252308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 252320 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 252327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252336 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252366 */     // GIR_Coverage, 7104,
     /* 252366 */     GIR_EraseRootFromParent_Done,
     /* 252367 */   // Label 5064: @252367
     /* 252367 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252443), // Rule ID 7105 //
     /* 252372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252384 */     // MIs[0] addr
     /* 252384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 252396 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 252403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252442 */     // GIR_Coverage, 7105,
     /* 252442 */     GIR_EraseRootFromParent_Done,
     /* 252443 */   // Label 5065: @252443
     /* 252443 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252519), // Rule ID 7106 //
     /* 252448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252460 */     // MIs[0] addr
     /* 252460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 252472 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 252479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252488 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252518 */     // GIR_Coverage, 7106,
     /* 252518 */     GIR_EraseRootFromParent_Done,
     /* 252519 */   // Label 5066: @252519
     /* 252519 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252561), // Rule ID 7107 //
     /* 252524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252536 */     // MIs[0] addr
     /* 252536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 252548 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 252548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 252551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252553 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 252555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252559 */     GIR_RootConstrainSelectedInstOperands,
     /* 252560 */     // GIR_Coverage, 7107,
     /* 252560 */     GIR_EraseRootFromParent_Done,
     /* 252561 */   // Label 5067: @252561
     /* 252561 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(252637), // Rule ID 7111 //
     /* 252566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252578 */     // MIs[0] addr
     /* 252578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 252590 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 252597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252636 */     // GIR_Coverage, 7111,
     /* 252636 */     GIR_EraseRootFromParent_Done,
     /* 252637 */   // Label 5068: @252637
     /* 252637 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(252713), // Rule ID 7112 //
     /* 252642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252654 */     // MIs[0] addr
     /* 252654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 252666 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 252673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252712 */     // GIR_Coverage, 7112,
     /* 252712 */     GIR_EraseRootFromParent_Done,
     /* 252713 */   // Label 5069: @252713
     /* 252713 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(252789), // Rule ID 7113 //
     /* 252718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252730 */     // MIs[0] addr
     /* 252730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 252742 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 252749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252788 */     // GIR_Coverage, 7113,
     /* 252788 */     GIR_EraseRootFromParent_Done,
     /* 252789 */   // Label 5070: @252789
     /* 252789 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(252831), // Rule ID 7114 //
     /* 252794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252806 */     // MIs[0] addr
     /* 252806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 252818 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 252818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 252821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252823 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 252825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252829 */     GIR_RootConstrainSelectedInstOperands,
     /* 252830 */     // GIR_Coverage, 7114,
     /* 252830 */     GIR_EraseRootFromParent_Done,
     /* 252831 */   // Label 5071: @252831
     /* 252831 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(252871), // Rule ID 20 //
     /* 252836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 252839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 252844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252858 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 252858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 252861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 252865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252869 */     GIR_RootConstrainSelectedInstOperands,
     /* 252870 */     // GIR_Coverage, 20,
     /* 252870 */     GIR_EraseRootFromParent_Done,
     /* 252871 */   // Label 5072: @252871
     /* 252871 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(252911), // Rule ID 2384 //
     /* 252876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 252884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 252887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252898 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 252898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 252901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 252903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 252905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252909 */     GIR_RootConstrainSelectedInstOperands,
     /* 252910 */     // GIR_Coverage, 2384,
     /* 252910 */     GIR_EraseRootFromParent_Done,
     /* 252911 */   // Label 5073: @252911
     /* 252911 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(252951), // Rule ID 2495 //
     /* 252916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 252924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 252930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252938 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 252938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 252941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 252943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 252945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252949 */     GIR_RootConstrainSelectedInstOperands,
     /* 252950 */     // GIR_Coverage, 2495,
     /* 252950 */     GIR_EraseRootFromParent_Done,
     /* 252951 */   // Label 5074: @252951
     /* 252951 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(252991), // Rule ID 2496 //
     /* 252956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 252964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 252970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252978 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 252978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 252981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 252983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 252985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252989 */     GIR_RootConstrainSelectedInstOperands,
     /* 252990 */     // GIR_Coverage, 2496,
     /* 252990 */     GIR_EraseRootFromParent_Done,
     /* 252991 */   // Label 5075: @252991
     /* 252991 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253031), // Rule ID 6991 //
     /* 252996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 253004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 253007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 253010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253018 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 253018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 253021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253029 */     GIR_RootConstrainSelectedInstOperands,
     /* 253030 */     // GIR_Coverage, 6991,
     /* 253030 */     GIR_EraseRootFromParent_Done,
     /* 253031 */   // Label 5076: @253031
     /* 253031 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253071), // Rule ID 6992 //
     /* 253036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 253039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 253044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 253047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 253050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253058 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 253058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 253061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253069 */     GIR_RootConstrainSelectedInstOperands,
     /* 253070 */     // GIR_Coverage, 6992,
     /* 253070 */     GIR_EraseRootFromParent_Done,
     /* 253071 */   // Label 5077: @253071
     /* 253071 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253107), // Rule ID 3577 //
     /* 253076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 253084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253094 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 253097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253105 */     GIR_RootConstrainSelectedInstOperands,
     /* 253106 */     // GIR_Coverage, 3577,
     /* 253106 */     GIR_EraseRootFromParent_Done,
     /* 253107 */   // Label 5078: @253107
     /* 253107 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253145), // Rule ID 4001 //
     /* 253112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 253115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 253120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253130 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 253130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 253133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 253141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 253143 */     GIR_RootConstrainSelectedInstOperands,
     /* 253144 */     // GIR_Coverage, 4001,
     /* 253144 */     GIR_EraseRootFromParent_Done,
     /* 253145 */   // Label 5079: @253145
     /* 253145 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253181), // Rule ID 12526 //
     /* 253150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 253158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253168 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 253171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253179 */     GIR_RootConstrainSelectedInstOperands,
     /* 253180 */     // GIR_Coverage, 12526,
     /* 253180 */     GIR_EraseRootFromParent_Done,
     /* 253181 */   // Label 5080: @253181
     /* 253181 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253217), // Rule ID 12527 //
     /* 253186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 253194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253204 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 253207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253215 */     GIR_RootConstrainSelectedInstOperands,
     /* 253216 */     // GIR_Coverage, 12527,
     /* 253216 */     GIR_EraseRootFromParent_Done,
     /* 253217 */   // Label 5081: @253217
     /* 253217 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253253), // Rule ID 12528 //
     /* 253222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 253230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253240 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 253243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253251 */     GIR_RootConstrainSelectedInstOperands,
     /* 253252 */     // GIR_Coverage, 12528,
     /* 253252 */     GIR_EraseRootFromParent_Done,
     /* 253253 */   // Label 5082: @253253
     /* 253253 */   GIM_Reject,
     /* 253254 */ // Label 5063: @253254
     /* 253254 */ GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(257422),
     /* 253259 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 253262 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253359), // Rule ID 7122 //
     /* 253267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253315 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 253326 */     // MIs[0] addr
     /* 253326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253340 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253349 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253357 */     GIR_RootConstrainSelectedInstOperands,
     /* 253358 */     // GIR_Coverage, 7122,
     /* 253358 */     GIR_EraseRootFromParent_Done,
     /* 253359 */   // Label 5084: @253359
     /* 253359 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253456), // Rule ID 7123 //
     /* 253364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253412 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 253423 */     // MIs[0] addr
     /* 253423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253437 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253446 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253454 */     GIR_RootConstrainSelectedInstOperands,
     /* 253455 */     // GIR_Coverage, 7123,
     /* 253455 */     GIR_EraseRootFromParent_Done,
     /* 253456 */   // Label 5085: @253456
     /* 253456 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253553), // Rule ID 7132 //
     /* 253461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253509 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 253520 */     // MIs[0] addr
     /* 253520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 253532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253534 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 253537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253543 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253551 */     GIR_RootConstrainSelectedInstOperands,
     /* 253552 */     // GIR_Coverage, 7132,
     /* 253552 */     GIR_EraseRootFromParent_Done,
     /* 253553 */   // Label 5086: @253553
     /* 253553 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253650), // Rule ID 7133 //
     /* 253558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253606 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 253617 */     // MIs[0] addr
     /* 253617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 253629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253631 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 253634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253640 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253648 */     GIR_RootConstrainSelectedInstOperands,
     /* 253649 */     // GIR_Coverage, 7133,
     /* 253649 */     GIR_EraseRootFromParent_Done,
     /* 253650 */   // Label 5087: @253650
     /* 253650 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253761), // Rule ID 7125 //
     /* 253655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253691 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 253702 */     // MIs[0] addr
     /* 253702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253716 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253752 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253759 */     GIR_RootConstrainSelectedInstOperands,
     /* 253760 */     // GIR_Coverage, 7125,
     /* 253760 */     GIR_EraseRootFromParent_Done,
     /* 253761 */   // Label 5088: @253761
     /* 253761 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(253872), // Rule ID 7126 //
     /* 253766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253802 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 253813 */     // MIs[0] addr
     /* 253813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253827 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253863 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253870 */     GIR_RootConstrainSelectedInstOperands,
     /* 253871 */     // GIR_Coverage, 7126,
     /* 253871 */     GIR_EraseRootFromParent_Done,
     /* 253872 */   // Label 5089: @253872
     /* 253872 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(253983), // Rule ID 7127 //
     /* 253877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253913 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 253924 */     // MIs[0] addr
     /* 253924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 253936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253938 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253950 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 253969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253974 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253981 */     GIR_RootConstrainSelectedInstOperands,
     /* 253982 */     // GIR_Coverage, 7127,
     /* 253982 */     GIR_EraseRootFromParent_Done,
     /* 253983 */   // Label 5090: @253983
     /* 253983 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254094), // Rule ID 7135 //
     /* 253988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254024 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 254035 */     // MIs[0] addr
     /* 254035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 254047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254049 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254061 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 254080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254085 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254092 */     GIR_RootConstrainSelectedInstOperands,
     /* 254093 */     // GIR_Coverage, 7135,
     /* 254093 */     GIR_EraseRootFromParent_Done,
     /* 254094 */   // Label 5091: @254094
     /* 254094 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254205), // Rule ID 7136 //
     /* 254099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254135 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 254146 */     // MIs[0] addr
     /* 254146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254160 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254196 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254203 */     GIR_RootConstrainSelectedInstOperands,
     /* 254204 */     // GIR_Coverage, 7136,
     /* 254204 */     GIR_EraseRootFromParent_Done,
     /* 254205 */   // Label 5092: @254205
     /* 254205 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254316), // Rule ID 7137 //
     /* 254210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254246 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 254257 */     // MIs[0] addr
     /* 254257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254271 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254283 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254307 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254314 */     GIR_RootConstrainSelectedInstOperands,
     /* 254315 */     // GIR_Coverage, 7137,
     /* 254315 */     GIR_EraseRootFromParent_Done,
     /* 254316 */   // Label 5093: @254316
     /* 254316 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254367), // Rule ID 70 //
     /* 254321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 254326 */     // MIs[0] ptr
     /* 254326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254334 */     // MIs[0] accessinfo
     /* 254334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 254337 */     // MIs[0] fixed_shadow
     /* 254337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254340 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 254340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 254343 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 254345 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 254347 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 254349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254365 */     GIR_RootConstrainSelectedInstOperands,
     /* 254366 */     // GIR_Coverage, 70,
     /* 254366 */     GIR_EraseRootFromParent_Done,
     /* 254367 */   // Label 5094: @254367
     /* 254367 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254418), // Rule ID 71 //
     /* 254372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 254377 */     // MIs[0] ptr
     /* 254377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254385 */     // MIs[0] accessinfo
     /* 254385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 254388 */     // MIs[0] fixed_shadow
     /* 254388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254391 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 254391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 254394 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 254396 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 254398 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 254400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254416 */     GIR_RootConstrainSelectedInstOperands,
     /* 254417 */     // GIR_Coverage, 71,
     /* 254417 */     GIR_EraseRootFromParent_Done,
     /* 254418 */   // Label 5095: @254418
     /* 254418 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254487), // Rule ID 7124 //
     /* 254423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 254446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 254450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254455 */     // MIs[0] addr
     /* 254455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 254467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254469 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 254472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 254478 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254485 */     GIR_RootConstrainSelectedInstOperands,
     /* 254486 */     // GIR_Coverage, 7124,
     /* 254486 */     GIR_EraseRootFromParent_Done,
     /* 254487 */   // Label 5096: @254487
     /* 254487 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254556), // Rule ID 7134 //
     /* 254492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 254515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 254519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254524 */     // MIs[0] addr
     /* 254524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254538 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 254547 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254554 */     GIR_RootConstrainSelectedInstOperands,
     /* 254555 */     // GIR_Coverage, 7134,
     /* 254555 */     GIR_EraseRootFromParent_Done,
     /* 254556 */   // Label 5097: @254556
     /* 254556 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254598), // Rule ID 3601 //
     /* 254561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 254569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254575 */     // MIs[0] tile
     /* 254575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254583 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 254586 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254596 */     GIR_RootConstrainSelectedInstOperands,
     /* 254597 */     // GIR_Coverage, 3601,
     /* 254597 */     GIR_EraseRootFromParent_Done,
     /* 254598 */   // Label 5098: @254598
     /* 254598 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254640), // Rule ID 3605 //
     /* 254603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 254611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254617 */     // MIs[0] tile
     /* 254617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254625 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 254628 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254638 */     GIR_RootConstrainSelectedInstOperands,
     /* 254639 */     // GIR_Coverage, 3605,
     /* 254639 */     GIR_EraseRootFromParent_Done,
     /* 254640 */   // Label 5099: @254640
     /* 254640 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254682), // Rule ID 3609 //
     /* 254645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 254648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 254653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254659 */     // MIs[0] tile
     /* 254659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254667 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 254670 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254680 */     GIR_RootConstrainSelectedInstOperands,
     /* 254681 */     // GIR_Coverage, 3609,
     /* 254681 */     GIR_EraseRootFromParent_Done,
     /* 254682 */   // Label 5100: @254682
     /* 254682 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254724), // Rule ID 3779 //
     /* 254687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 254690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254701 */     // MIs[0] tile
     /* 254701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 254709 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 254712 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254722 */     GIR_RootConstrainSelectedInstOperands,
     /* 254723 */     // GIR_Coverage, 3779,
     /* 254723 */     GIR_EraseRootFromParent_Done,
     /* 254724 */   // Label 5101: @254724
     /* 254724 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254766), // Rule ID 3783 //
     /* 254729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 254732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 254737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254743 */     // MIs[0] tile
     /* 254743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254751 */     // (intrinsic_void 875:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 254754 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254764 */     GIR_RootConstrainSelectedInstOperands,
     /* 254765 */     // GIR_Coverage, 3783,
     /* 254765 */     GIR_EraseRootFromParent_Done,
     /* 254766 */   // Label 5102: @254766
     /* 254766 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254808), // Rule ID 3787 //
     /* 254771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254785 */     // MIs[0] tile
     /* 254785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254793 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 254793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 254796 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254806 */     GIR_RootConstrainSelectedInstOperands,
     /* 254807 */     // GIR_Coverage, 3787,
     /* 254807 */     GIR_EraseRootFromParent_Done,
     /* 254808 */   // Label 5103: @254808
     /* 254808 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254850), // Rule ID 3791 //
     /* 254813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 254816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254827 */     // MIs[0] tile
     /* 254827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254835 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 254835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 254838 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254848 */     GIR_RootConstrainSelectedInstOperands,
     /* 254849 */     // GIR_Coverage, 3791,
     /* 254849 */     GIR_EraseRootFromParent_Done,
     /* 254850 */   // Label 5104: @254850
     /* 254850 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254892), // Rule ID 3795 //
     /* 254855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 254863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254869 */     // MIs[0] tile
     /* 254869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254877 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 254880 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254890 */     GIR_RootConstrainSelectedInstOperands,
     /* 254891 */     // GIR_Coverage, 3795,
     /* 254891 */     GIR_EraseRootFromParent_Done,
     /* 254892 */   // Label 5105: @254892
     /* 254892 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254934), // Rule ID 3799 //
     /* 254897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 254900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 254905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254911 */     // MIs[0] tile
     /* 254911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 254919 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 254922 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254932 */     GIR_RootConstrainSelectedInstOperands,
     /* 254933 */     // GIR_Coverage, 3799,
     /* 254933 */     GIR_EraseRootFromParent_Done,
     /* 254934 */   // Label 5106: @254934
     /* 254934 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(254976), // Rule ID 12605 //
     /* 254939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 254947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254953 */     // MIs[0] tile
     /* 254953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254961 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 254964 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254974 */     GIR_RootConstrainSelectedInstOperands,
     /* 254975 */     // GIR_Coverage, 12605,
     /* 254975 */     GIR_EraseRootFromParent_Done,
     /* 254976 */   // Label 5107: @254976
     /* 254976 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255018), // Rule ID 12609 //
     /* 254981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 254989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254995 */     // MIs[0] tile
     /* 254995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255003 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 255006 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255016 */     GIR_RootConstrainSelectedInstOperands,
     /* 255017 */     // GIR_Coverage, 12609,
     /* 255017 */     GIR_EraseRootFromParent_Done,
     /* 255018 */   // Label 5108: @255018
     /* 255018 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255060), // Rule ID 12613 //
     /* 255023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 255031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255037 */     // MIs[0] tile
     /* 255037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255045 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 255048 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255058 */     GIR_RootConstrainSelectedInstOperands,
     /* 255059 */     // GIR_Coverage, 12613,
     /* 255059 */     GIR_EraseRootFromParent_Done,
     /* 255060 */   // Label 5109: @255060
     /* 255060 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255102), // Rule ID 12617 //
     /* 255065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 255073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255079 */     // MIs[0] tile
     /* 255079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255087 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 255090 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255100 */     GIR_RootConstrainSelectedInstOperands,
     /* 255101 */     // GIR_Coverage, 12617,
     /* 255101 */     GIR_EraseRootFromParent_Done,
     /* 255102 */   // Label 5110: @255102
     /* 255102 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255144), // Rule ID 12621 //
     /* 255107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 255115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255121 */     // MIs[0] tile
     /* 255121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255129 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 255132 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255142 */     GIR_RootConstrainSelectedInstOperands,
     /* 255143 */     // GIR_Coverage, 12621,
     /* 255143 */     GIR_EraseRootFromParent_Done,
     /* 255144 */   // Label 5111: @255144
     /* 255144 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255186), // Rule ID 12625 //
     /* 255149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 255157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255163 */     // MIs[0] tile
     /* 255163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255171 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 255174 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255184 */     GIR_RootConstrainSelectedInstOperands,
     /* 255185 */     // GIR_Coverage, 12625,
     /* 255185 */     GIR_EraseRootFromParent_Done,
     /* 255186 */   // Label 5112: @255186
     /* 255186 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255228), // Rule ID 12629 //
     /* 255191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 255199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255205 */     // MIs[0] tile
     /* 255205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255213 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 255216 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255226 */     GIR_RootConstrainSelectedInstOperands,
     /* 255227 */     // GIR_Coverage, 12629,
     /* 255227 */     GIR_EraseRootFromParent_Done,
     /* 255228 */   // Label 5113: @255228
     /* 255228 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255270), // Rule ID 12633 //
     /* 255233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 255241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255247 */     // MIs[0] tile
     /* 255247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255255 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 255258 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255268 */     GIR_RootConstrainSelectedInstOperands,
     /* 255269 */     // GIR_Coverage, 12633,
     /* 255269 */     GIR_EraseRootFromParent_Done,
     /* 255270 */   // Label 5114: @255270
     /* 255270 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255312), // Rule ID 12637 //
     /* 255275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 255283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255289 */     // MIs[0] tile
     /* 255289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255297 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 255300 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255310 */     GIR_RootConstrainSelectedInstOperands,
     /* 255311 */     // GIR_Coverage, 12637,
     /* 255311 */     GIR_EraseRootFromParent_Done,
     /* 255312 */   // Label 5115: @255312
     /* 255312 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255354), // Rule ID 12641 //
     /* 255317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 255325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255331 */     // MIs[0] tile
     /* 255331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255339 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 255342 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255352 */     GIR_RootConstrainSelectedInstOperands,
     /* 255353 */     // GIR_Coverage, 12641,
     /* 255353 */     GIR_EraseRootFromParent_Done,
     /* 255354 */   // Label 5116: @255354
     /* 255354 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255396), // Rule ID 12645 //
     /* 255359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 255367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255373 */     // MIs[0] tile
     /* 255373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255381 */     // (intrinsic_void 1027:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 255384 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255394 */     GIR_RootConstrainSelectedInstOperands,
     /* 255395 */     // GIR_Coverage, 12645,
     /* 255395 */     GIR_EraseRootFromParent_Done,
     /* 255396 */   // Label 5117: @255396
     /* 255396 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255438), // Rule ID 12649 //
     /* 255401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 255409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255415 */     // MIs[0] tile
     /* 255415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255423 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 255426 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255436 */     GIR_RootConstrainSelectedInstOperands,
     /* 255437 */     // GIR_Coverage, 12649,
     /* 255437 */     GIR_EraseRootFromParent_Done,
     /* 255438 */   // Label 5118: @255438
     /* 255438 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255480), // Rule ID 12653 //
     /* 255443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 255451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255457 */     // MIs[0] tile
     /* 255457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255465 */     // (intrinsic_void 1079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 255468 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255478 */     GIR_RootConstrainSelectedInstOperands,
     /* 255479 */     // GIR_Coverage, 12653,
     /* 255479 */     GIR_EraseRootFromParent_Done,
     /* 255480 */   // Label 5119: @255480
     /* 255480 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255522), // Rule ID 12657 //
     /* 255485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 255493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255499 */     // MIs[0] tile
     /* 255499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255507 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 255510 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255520 */     GIR_RootConstrainSelectedInstOperands,
     /* 255521 */     // GIR_Coverage, 12657,
     /* 255521 */     GIR_EraseRootFromParent_Done,
     /* 255522 */   // Label 5120: @255522
     /* 255522 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255564), // Rule ID 12661 //
     /* 255527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 255535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255541 */     // MIs[0] tile
     /* 255541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255549 */     // (intrinsic_void 1162:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 255552 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255562 */     GIR_RootConstrainSelectedInstOperands,
     /* 255563 */     // GIR_Coverage, 12661,
     /* 255563 */     GIR_EraseRootFromParent_Done,
     /* 255564 */   // Label 5121: @255564
     /* 255564 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255606), // Rule ID 12665 //
     /* 255569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 255577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255583 */     // MIs[0] tile
     /* 255583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255591 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 255594 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255604 */     GIR_RootConstrainSelectedInstOperands,
     /* 255605 */     // GIR_Coverage, 12665,
     /* 255605 */     GIR_EraseRootFromParent_Done,
     /* 255606 */   // Label 5122: @255606
     /* 255606 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(255648), // Rule ID 12669 //
     /* 255611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 255619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255625 */     // MIs[0] tile
     /* 255625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255633 */     // (intrinsic_void 1196:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 255636 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255646 */     GIR_RootConstrainSelectedInstOperands,
     /* 255647 */     // GIR_Coverage, 12669,
     /* 255647 */     GIR_EraseRootFromParent_Done,
     /* 255648 */   // Label 5123: @255648
     /* 255648 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(255690), // Rule ID 13124 //
     /* 255653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 255661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255667 */     // MIs[0] tile
     /* 255667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255675 */     // (intrinsic_void 924:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 255675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 255678 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255688 */     GIR_RootConstrainSelectedInstOperands,
     /* 255689 */     // GIR_Coverage, 13124,
     /* 255689 */     GIR_EraseRootFromParent_Done,
     /* 255690 */   // Label 5124: @255690
     /* 255690 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(255732), // Rule ID 13128 //
     /* 255695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255709 */     // MIs[0] tile
     /* 255709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255717 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 255717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 255720 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255730 */     GIR_RootConstrainSelectedInstOperands,
     /* 255731 */     // GIR_Coverage, 13128,
     /* 255731 */     GIR_EraseRootFromParent_Done,
     /* 255732 */   // Label 5125: @255732
     /* 255732 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(255774), // Rule ID 13132 //
     /* 255737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 255740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255751 */     // MIs[0] tile
     /* 255751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 255759 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 255759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 255762 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255772 */     GIR_RootConstrainSelectedInstOperands,
     /* 255773 */     // GIR_Coverage, 13132,
     /* 255773 */     GIR_EraseRootFromParent_Done,
     /* 255774 */   // Label 5126: @255774
     /* 255774 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(255816), // Rule ID 13136 //
     /* 255779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 255782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255793 */     // MIs[0] tile
     /* 255793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255801 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 255801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 255804 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255814 */     GIR_RootConstrainSelectedInstOperands,
     /* 255815 */     // GIR_Coverage, 13136,
     /* 255815 */     GIR_EraseRootFromParent_Done,
     /* 255816 */   // Label 5127: @255816
     /* 255816 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255870), // Rule ID 8871 //
     /* 255821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255829 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 255832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255836 */     // MIs[0] base
     /* 255836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255844 */     // MIs[0] prfop
     /* 255844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255852 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 255855 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255859 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255868 */     GIR_RootConstrainSelectedInstOperands,
     /* 255869 */     // GIR_Coverage, 8871,
     /* 255869 */     GIR_EraseRootFromParent_Done,
     /* 255870 */   // Label 5128: @255870
     /* 255870 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(255924), // Rule ID 8874 //
     /* 255875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255883 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 255886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255890 */     // MIs[0] base
     /* 255890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255898 */     // MIs[0] prfop
     /* 255898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255906 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 255909 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255911 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255913 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255922 */     GIR_RootConstrainSelectedInstOperands,
     /* 255923 */     // GIR_Coverage, 8874,
     /* 255923 */     GIR_EraseRootFromParent_Done,
     /* 255924 */   // Label 5129: @255924
     /* 255924 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(255978), // Rule ID 8877 //
     /* 255929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255937 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255944 */     // MIs[0] base
     /* 255944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255952 */     // MIs[0] prfop
     /* 255952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255960 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 255963 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255965 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255967 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255976 */     GIR_RootConstrainSelectedInstOperands,
     /* 255977 */     // GIR_Coverage, 8877,
     /* 255977 */     GIR_EraseRootFromParent_Done,
     /* 255978 */   // Label 5130: @255978
     /* 255978 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256032), // Rule ID 8880 //
     /* 255983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255991 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255998 */     // MIs[0] base
     /* 255998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256006 */     // MIs[0] prfop
     /* 256006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256014 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 256014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 256017 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 256019 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 256021 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 256023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256030 */     GIR_RootConstrainSelectedInstOperands,
     /* 256031 */     // GIR_Coverage, 8880,
     /* 256031 */     GIR_EraseRootFromParent_Done,
     /* 256032 */   // Label 5131: @256032
     /* 256032 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256086), // Rule ID 15 //
     /* 256037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 256042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 256045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 256051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 256059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256063 */     // MIs[1] Operand 1
     /* 256063 */     // No operand predicates
     /* 256063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256069 */     // (intrinsic_w_chain:{ *:[i64] } 1232:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 256069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 256072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 256077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 256084 */     GIR_RootConstrainSelectedInstOperands,
     /* 256085 */     // GIR_Coverage, 15,
     /* 256085 */     GIR_EraseRootFromParent_Done,
     /* 256086 */   // Label 5132: @256086
     /* 256086 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256154), // Rule ID 68 //
     /* 256091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 256096 */     // MIs[0] Operand 1
     /* 256096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 256100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 256104 */     // MIs[0] ptr
     /* 256104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 256112 */     // MIs[0] accessinfo
     /* 256112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256115 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 256115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256119 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 256129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 256132 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 256134 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 256136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 256139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 256142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 256145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 256148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256152 */     GIR_RootConstrainSelectedInstOperands,
     /* 256153 */     // GIR_Coverage, 68,
     /* 256153 */     GIR_EraseRootFromParent_Done,
     /* 256154 */   // Label 5133: @256154
     /* 256154 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256222), // Rule ID 69 //
     /* 256159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 256164 */     // MIs[0] Operand 1
     /* 256164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 256168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 256172 */     // MIs[0] ptr
     /* 256172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 256180 */     // MIs[0] accessinfo
     /* 256180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256183 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 256183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256187 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 256197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 256200 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 256202 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 256204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 256207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 256210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 256213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 256216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256220 */     GIR_RootConstrainSelectedInstOperands,
     /* 256221 */     // GIR_Coverage, 69,
     /* 256221 */     GIR_EraseRootFromParent_Done,
     /* 256222 */   // Label 5134: @256222
     /* 256222 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256302), // Rule ID 7118 //
     /* 256227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256246 */     // MIs[0] addr
     /* 256246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 256258 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 256289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256294 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256300 */     GIR_RootConstrainSelectedInstOperands,
     /* 256301 */     // GIR_Coverage, 7118,
     /* 256301 */     GIR_EraseRootFromParent_Done,
     /* 256302 */   // Label 5135: @256302
     /* 256302 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256382), // Rule ID 7119 //
     /* 256307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256326 */     // MIs[0] addr
     /* 256326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 256338 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256350 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 256369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256374 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256380 */     GIR_RootConstrainSelectedInstOperands,
     /* 256381 */     // GIR_Coverage, 7119,
     /* 256381 */     GIR_EraseRootFromParent_Done,
     /* 256382 */   // Label 5136: @256382
     /* 256382 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256462), // Rule ID 7120 //
     /* 256387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256406 */     // MIs[0] addr
     /* 256406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 256418 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256430 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 256449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256454 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256460 */     GIR_RootConstrainSelectedInstOperands,
     /* 256461 */     // GIR_Coverage, 7120,
     /* 256461 */     GIR_EraseRootFromParent_Done,
     /* 256462 */   // Label 5137: @256462
     /* 256462 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256513), // Rule ID 7121 //
     /* 256467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256486 */     // MIs[0] addr
     /* 256486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 256498 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 256498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 256501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256503 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 256505 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256511 */     GIR_RootConstrainSelectedInstOperands,
     /* 256512 */     // GIR_Coverage, 7121,
     /* 256512 */     GIR_EraseRootFromParent_Done,
     /* 256513 */   // Label 5138: @256513
     /* 256513 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256593), // Rule ID 7128 //
     /* 256518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256537 */     // MIs[0] addr
     /* 256537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 256549 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256561 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 256580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256585 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256591 */     GIR_RootConstrainSelectedInstOperands,
     /* 256592 */     // GIR_Coverage, 7128,
     /* 256592 */     GIR_EraseRootFromParent_Done,
     /* 256593 */   // Label 5139: @256593
     /* 256593 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(256673), // Rule ID 7129 //
     /* 256598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256617 */     // MIs[0] addr
     /* 256617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 256629 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256641 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 256660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256665 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256671 */     GIR_RootConstrainSelectedInstOperands,
     /* 256672 */     // GIR_Coverage, 7129,
     /* 256672 */     GIR_EraseRootFromParent_Done,
     /* 256673 */   // Label 5140: @256673
     /* 256673 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(256753), // Rule ID 7130 //
     /* 256678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256697 */     // MIs[0] addr
     /* 256697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 256709 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256721 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 256740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256745 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256751 */     GIR_RootConstrainSelectedInstOperands,
     /* 256752 */     // GIR_Coverage, 7130,
     /* 256752 */     GIR_EraseRootFromParent_Done,
     /* 256753 */   // Label 5141: @256753
     /* 256753 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(256804), // Rule ID 7131 //
     /* 256758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256777 */     // MIs[0] addr
     /* 256777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 256789 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 256789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 256792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256794 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 256796 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256802 */     GIR_RootConstrainSelectedInstOperands,
     /* 256803 */     // GIR_Coverage, 7131,
     /* 256803 */     GIR_EraseRootFromParent_Done,
     /* 256804 */   // Label 5142: @256804
     /* 256804 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(256853), // Rule ID 2488 //
     /* 256809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 256820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256838 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 256838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 256841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256851 */     GIR_RootConstrainSelectedInstOperands,
     /* 256852 */     // GIR_Coverage, 2488,
     /* 256852 */     GIR_EraseRootFromParent_Done,
     /* 256853 */   // Label 5143: @256853
     /* 256853 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(256902), // Rule ID 2489 //
     /* 256858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256887 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 256887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 256890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256900 */     GIR_RootConstrainSelectedInstOperands,
     /* 256901 */     // GIR_Coverage, 2489,
     /* 256901 */     GIR_EraseRootFromParent_Done,
     /* 256902 */   // Label 5144: @256902
     /* 256902 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(256951), // Rule ID 2490 //
     /* 256907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 256918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 256924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256936 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 256936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 256939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256949 */     GIR_RootConstrainSelectedInstOperands,
     /* 256950 */     // GIR_Coverage, 2490,
     /* 256950 */     GIR_EraseRootFromParent_Done,
     /* 256951 */   // Label 5145: @256951
     /* 256951 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257004), // Rule ID 8757 //
     /* 256956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 256959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 256964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 256970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256978 */     // MIs[0] base
     /* 256978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256986 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 256986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 256989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 256991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 256993 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 256995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257002 */     GIR_RootConstrainSelectedInstOperands,
     /* 257003 */     // GIR_Coverage, 8757,
     /* 257003 */     GIR_EraseRootFromParent_Done,
     /* 257004 */   // Label 5146: @257004
     /* 257004 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257057), // Rule ID 8760 //
     /* 257009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 257017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257031 */     // MIs[0] base
     /* 257031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257039 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 257042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257046 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257055 */     GIR_RootConstrainSelectedInstOperands,
     /* 257056 */     // GIR_Coverage, 8760,
     /* 257056 */     GIR_EraseRootFromParent_Done,
     /* 257057 */   // Label 5147: @257057
     /* 257057 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257110), // Rule ID 8769 //
     /* 257062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 257070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257084 */     // MIs[0] base
     /* 257084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257092 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 257095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257099 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257108 */     GIR_RootConstrainSelectedInstOperands,
     /* 257109 */     // GIR_Coverage, 8769,
     /* 257109 */     GIR_EraseRootFromParent_Done,
     /* 257110 */   // Label 5148: @257110
     /* 257110 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257163), // Rule ID 8772 //
     /* 257115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 257123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257137 */     // MIs[0] base
     /* 257137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257145 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 257148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257152 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257161 */     GIR_RootConstrainSelectedInstOperands,
     /* 257162 */     // GIR_Coverage, 8772,
     /* 257162 */     GIR_EraseRootFromParent_Done,
     /* 257163 */   // Label 5149: @257163
     /* 257163 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257209), // Rule ID 137 //
     /* 257168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 257171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 257176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 257179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257186 */     // MIs[0] Rn
     /* 257186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257198 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 257198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 257201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257207 */     GIR_RootConstrainSelectedInstOperands,
     /* 257208 */     // GIR_Coverage, 137,
     /* 257208 */     GIR_EraseRootFromParent_Done,
     /* 257209 */   // Label 5150: @257209
     /* 257209 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257262), // Rule ID 8763 //
     /* 257214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 257222 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257236 */     // MIs[0] base
     /* 257236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257244 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 257247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257251 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257260 */     GIR_RootConstrainSelectedInstOperands,
     /* 257261 */     // GIR_Coverage, 8763,
     /* 257261 */     GIR_EraseRootFromParent_Done,
     /* 257262 */   // Label 5151: @257262
     /* 257262 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257315), // Rule ID 8766 //
     /* 257267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 257275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257289 */     // MIs[0] base
     /* 257289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257297 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 257300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257304 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257313 */     GIR_RootConstrainSelectedInstOperands,
     /* 257314 */     // GIR_Coverage, 8766,
     /* 257314 */     GIR_EraseRootFromParent_Done,
     /* 257315 */   // Label 5152: @257315
     /* 257315 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257368), // Rule ID 8775 //
     /* 257320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 257328 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 257331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257342 */     // MIs[0] base
     /* 257342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257350 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 257353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257357 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257366 */     GIR_RootConstrainSelectedInstOperands,
     /* 257367 */     // GIR_Coverage, 8775,
     /* 257367 */     GIR_EraseRootFromParent_Done,
     /* 257368 */   // Label 5153: @257368
     /* 257368 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257421), // Rule ID 8778 //
     /* 257373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 257381 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 257384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257395 */     // MIs[0] base
     /* 257395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257403 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 257406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257410 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257419 */     GIR_RootConstrainSelectedInstOperands,
     /* 257420 */     // GIR_Coverage, 8778,
     /* 257420 */     GIR_EraseRootFromParent_Done,
     /* 257421 */   // Label 5154: @257421
     /* 257421 */   GIM_Reject,
     /* 257422 */ // Label 5083: @257422
     /* 257422 */ GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(260127),
     /* 257427 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 257430 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257501), // Rule ID 3413 //
     /* 257435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 257443 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 257472 */     // MIs[1] Operand 1
     /* 257472 */     // No operand predicates
     /* 257472 */     // MIs[0] prfop
     /* 257472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257482 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 257482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 257485 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 257491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 257494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 257499 */     GIR_RootConstrainSelectedInstOperands,
     /* 257500 */     // GIR_Coverage, 3413,
     /* 257500 */     GIR_EraseRootFromParent_Done,
     /* 257501 */   // Label 5156: @257501
     /* 257501 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257572), // Rule ID 3426 //
     /* 257506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 257514 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 257520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 257543 */     // MIs[1] Operand 1
     /* 257543 */     // No operand predicates
     /* 257543 */     // MIs[0] prfop
     /* 257543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257553 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 257553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 257556 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 257562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 257565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 257570 */     GIR_RootConstrainSelectedInstOperands,
     /* 257571 */     // GIR_Coverage, 3426,
     /* 257571 */     GIR_EraseRootFromParent_Done,
     /* 257572 */   // Label 5157: @257572
     /* 257572 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257631), // Rule ID 3613 //
     /* 257577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 257585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 257591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257594 */     // MIs[0] tile
     /* 257594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257614 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 257614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 257617 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257619 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257621 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257623 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257629 */     GIR_RootConstrainSelectedInstOperands,
     /* 257630 */     // GIR_Coverage, 3613,
     /* 257630 */     GIR_EraseRootFromParent_Done,
     /* 257631 */   // Label 5158: @257631
     /* 257631 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257690), // Rule ID 3614 //
     /* 257636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 257639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 257644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 257650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257653 */     // MIs[0] tile
     /* 257653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257673 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 257673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 257676 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257678 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257680 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257682 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257688 */     GIR_RootConstrainSelectedInstOperands,
     /* 257689 */     // GIR_Coverage, 3614,
     /* 257689 */     GIR_EraseRootFromParent_Done,
     /* 257690 */   // Label 5159: @257690
     /* 257690 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257749), // Rule ID 12586 //
     /* 257695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 257703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 257709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257712 */     // MIs[0] tile
     /* 257712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257732 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 257732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 257735 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257737 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257739 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257741 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257747 */     GIR_RootConstrainSelectedInstOperands,
     /* 257748 */     // GIR_Coverage, 12586,
     /* 257748 */     GIR_EraseRootFromParent_Done,
     /* 257749 */   // Label 5160: @257749
     /* 257749 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257808), // Rule ID 12587 //
     /* 257754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 257757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 257762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 257768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257771 */     // MIs[0] tile
     /* 257771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257791 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 257791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 257794 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257796 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257798 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257800 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257806 */     GIR_RootConstrainSelectedInstOperands,
     /* 257807 */     // GIR_Coverage, 12587,
     /* 257807 */     GIR_EraseRootFromParent_Done,
     /* 257808 */   // Label 5161: @257808
     /* 257808 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257868), // Rule ID 3411 //
     /* 257813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 257821 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257831 */     // MIs[0] Rn
     /* 257831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257843 */     // MIs[0] prfop
     /* 257843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257851 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 257851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 257854 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257866 */     GIR_RootConstrainSelectedInstOperands,
     /* 257867 */     // GIR_Coverage, 3411,
     /* 257867 */     GIR_EraseRootFromParent_Done,
     /* 257868 */   // Label 5162: @257868
     /* 257868 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257928), // Rule ID 3412 //
     /* 257873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 257881 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257891 */     // MIs[0] Rn
     /* 257891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257903 */     // MIs[0] prfop
     /* 257903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257911 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 257911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 257914 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257926 */     GIR_RootConstrainSelectedInstOperands,
     /* 257927 */     // GIR_Coverage, 3412,
     /* 257927 */     GIR_EraseRootFromParent_Done,
     /* 257928 */   // Label 5163: @257928
     /* 257928 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(257988), // Rule ID 3423 //
     /* 257933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 257941 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257951 */     // MIs[0] Rn
     /* 257951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257963 */     // MIs[0] prfop
     /* 257963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257971 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 257971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 257974 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257986 */     GIR_RootConstrainSelectedInstOperands,
     /* 257987 */     // GIR_Coverage, 3423,
     /* 257987 */     GIR_EraseRootFromParent_Done,
     /* 257988 */   // Label 5164: @257988
     /* 257988 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258048), // Rule ID 3424 //
     /* 257993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 258001 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258011 */     // MIs[0] Rn
     /* 258011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258023 */     // MIs[0] prfop
     /* 258023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258031 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 258031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 258034 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258046 */     GIR_RootConstrainSelectedInstOperands,
     /* 258047 */     // GIR_Coverage, 3424,
     /* 258047 */     GIR_EraseRootFromParent_Done,
     /* 258048 */   // Label 5165: @258048
     /* 258048 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258108), // Rule ID 3425 //
     /* 258053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 258061 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258071 */     // MIs[0] Rn
     /* 258071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258083 */     // MIs[0] prfop
     /* 258083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258091 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 258091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 258094 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258106 */     GIR_RootConstrainSelectedInstOperands,
     /* 258107 */     // GIR_Coverage, 3425,
     /* 258107 */     GIR_EraseRootFromParent_Done,
     /* 258108 */   // Label 5166: @258108
     /* 258108 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258168), // Rule ID 8883 //
     /* 258113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 258121 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258131 */     // MIs[0] Rn
     /* 258131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258143 */     // MIs[0] prfop
     /* 258143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258151 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 258151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 258154 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258166 */     GIR_RootConstrainSelectedInstOperands,
     /* 258167 */     // GIR_Coverage, 8883,
     /* 258167 */     GIR_EraseRootFromParent_Done,
     /* 258168 */   // Label 5167: @258168
     /* 258168 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258228), // Rule ID 8884 //
     /* 258173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 258181 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258191 */     // MIs[0] Rn
     /* 258191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258203 */     // MIs[0] prfop
     /* 258203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258211 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 258211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 258214 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258226 */     GIR_RootConstrainSelectedInstOperands,
     /* 258227 */     // GIR_Coverage, 8884,
     /* 258227 */     GIR_EraseRootFromParent_Done,
     /* 258228 */   // Label 5168: @258228
     /* 258228 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258288), // Rule ID 8885 //
     /* 258233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 258241 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258251 */     // MIs[0] Rn
     /* 258251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258263 */     // MIs[0] prfop
     /* 258263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258271 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 258271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 258274 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258286 */     GIR_RootConstrainSelectedInstOperands,
     /* 258287 */     // GIR_Coverage, 8885,
     /* 258287 */     GIR_EraseRootFromParent_Done,
     /* 258288 */   // Label 5169: @258288
     /* 258288 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258348), // Rule ID 8886 //
     /* 258293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 258301 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258311 */     // MIs[0] Rn
     /* 258311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258323 */     // MIs[0] prfop
     /* 258323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258331 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 258331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 258334 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258346 */     GIR_RootConstrainSelectedInstOperands,
     /* 258347 */     // GIR_Coverage, 8886,
     /* 258347 */     GIR_EraseRootFromParent_Done,
     /* 258348 */   // Label 5170: @258348
     /* 258348 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258408), // Rule ID 8887 //
     /* 258353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 258361 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258371 */     // MIs[0] Rn
     /* 258371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258383 */     // MIs[0] prfop
     /* 258383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258391 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 258391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 258394 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258406 */     GIR_RootConstrainSelectedInstOperands,
     /* 258407 */     // GIR_Coverage, 8887,
     /* 258407 */     GIR_EraseRootFromParent_Done,
     /* 258408 */   // Label 5171: @258408
     /* 258408 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258468), // Rule ID 8888 //
     /* 258413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 258421 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258431 */     // MIs[0] Rn
     /* 258431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258443 */     // MIs[0] prfop
     /* 258443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258451 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 258451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 258454 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258466 */     GIR_RootConstrainSelectedInstOperands,
     /* 258467 */     // GIR_Coverage, 8888,
     /* 258467 */     GIR_EraseRootFromParent_Done,
     /* 258468 */   // Label 5172: @258468
     /* 258468 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258528), // Rule ID 8889 //
     /* 258473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 258481 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258491 */     // MIs[0] Rn
     /* 258491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258503 */     // MIs[0] prfop
     /* 258503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258511 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 258511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 258514 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258526 */     GIR_RootConstrainSelectedInstOperands,
     /* 258527 */     // GIR_Coverage, 8889,
     /* 258527 */     GIR_EraseRootFromParent_Done,
     /* 258528 */   // Label 5173: @258528
     /* 258528 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258588), // Rule ID 8890 //
     /* 258533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 258541 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258551 */     // MIs[0] Rn
     /* 258551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258563 */     // MIs[0] prfop
     /* 258563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258571 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 258571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 258574 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258586 */     GIR_RootConstrainSelectedInstOperands,
     /* 258587 */     // GIR_Coverage, 8890,
     /* 258587 */     GIR_EraseRootFromParent_Done,
     /* 258588 */   // Label 5174: @258588
     /* 258588 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258648), // Rule ID 8891 //
     /* 258593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 258601 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258611 */     // MIs[0] Rn
     /* 258611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258623 */     // MIs[0] prfop
     /* 258623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258631 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 258631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 258634 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258646 */     GIR_RootConstrainSelectedInstOperands,
     /* 258647 */     // GIR_Coverage, 8891,
     /* 258647 */     GIR_EraseRootFromParent_Done,
     /* 258648 */   // Label 5175: @258648
     /* 258648 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(258708), // Rule ID 8892 //
     /* 258653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 258661 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258671 */     // MIs[0] Rn
     /* 258671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258683 */     // MIs[0] prfop
     /* 258683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258691 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 258691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 258694 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258706 */     GIR_RootConstrainSelectedInstOperands,
     /* 258707 */     // GIR_Coverage, 8892,
     /* 258707 */     GIR_EraseRootFromParent_Done,
     /* 258708 */   // Label 5176: @258708
     /* 258708 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258768), // Rule ID 8893 //
     /* 258713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 258721 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258731 */     // MIs[0] Rn
     /* 258731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258743 */     // MIs[0] prfop
     /* 258743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258751 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 258751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 258754 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258766 */     GIR_RootConstrainSelectedInstOperands,
     /* 258767 */     // GIR_Coverage, 8893,
     /* 258767 */     GIR_EraseRootFromParent_Done,
     /* 258768 */   // Label 5177: @258768
     /* 258768 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258828), // Rule ID 8894 //
     /* 258773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 258781 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258791 */     // MIs[0] Rn
     /* 258791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258803 */     // MIs[0] prfop
     /* 258803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258811 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 258811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 258814 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258826 */     GIR_RootConstrainSelectedInstOperands,
     /* 258827 */     // GIR_Coverage, 8894,
     /* 258827 */     GIR_EraseRootFromParent_Done,
     /* 258828 */   // Label 5178: @258828
     /* 258828 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258888), // Rule ID 8895 //
     /* 258833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 258841 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258851 */     // MIs[0] Rn
     /* 258851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258863 */     // MIs[0] prfop
     /* 258863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258871 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 258871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 258874 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258886 */     GIR_RootConstrainSelectedInstOperands,
     /* 258887 */     // GIR_Coverage, 8895,
     /* 258887 */     GIR_EraseRootFromParent_Done,
     /* 258888 */   // Label 5179: @258888
     /* 258888 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(258948), // Rule ID 8896 //
     /* 258893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 258901 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258911 */     // MIs[0] Rn
     /* 258911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258923 */     // MIs[0] prfop
     /* 258923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258931 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 258931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 258934 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258946 */     GIR_RootConstrainSelectedInstOperands,
     /* 258947 */     // GIR_Coverage, 8896,
     /* 258947 */     GIR_EraseRootFromParent_Done,
     /* 258948 */   // Label 5180: @258948
     /* 258948 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259008), // Rule ID 8897 //
     /* 258953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 258961 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258971 */     // MIs[0] Rn
     /* 258971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258983 */     // MIs[0] prfop
     /* 258983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258991 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 258991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 258994 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 259000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 259002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259006 */     GIR_RootConstrainSelectedInstOperands,
     /* 259007 */     // GIR_Coverage, 8897,
     /* 259007 */     GIR_EraseRootFromParent_Done,
     /* 259008 */   // Label 5181: @259008
     /* 259008 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259066), // Rule ID 2374 //
     /* 259013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 259021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259049 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 259052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259064 */     GIR_RootConstrainSelectedInstOperands,
     /* 259065 */     // GIR_Coverage, 2374,
     /* 259065 */     GIR_EraseRootFromParent_Done,
     /* 259066 */   // Label 5182: @259066
     /* 259066 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259124), // Rule ID 2375 //
     /* 259071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 259079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259107 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 259110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259122 */     GIR_RootConstrainSelectedInstOperands,
     /* 259123 */     // GIR_Coverage, 2375,
     /* 259123 */     GIR_EraseRootFromParent_Done,
     /* 259124 */   // Label 5183: @259124
     /* 259124 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259182), // Rule ID 2376 //
     /* 259129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 259137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259165 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 259168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259180 */     GIR_RootConstrainSelectedInstOperands,
     /* 259181 */     // GIR_Coverage, 2376,
     /* 259181 */     GIR_EraseRootFromParent_Done,
     /* 259182 */   // Label 5184: @259182
     /* 259182 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259240), // Rule ID 2377 //
     /* 259187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 259195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259223 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 259226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259238 */     GIR_RootConstrainSelectedInstOperands,
     /* 259239 */     // GIR_Coverage, 2377,
     /* 259239 */     GIR_EraseRootFromParent_Done,
     /* 259240 */   // Label 5185: @259240
     /* 259240 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259298), // Rule ID 2378 //
     /* 259245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 259253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259281 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 259284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259296 */     GIR_RootConstrainSelectedInstOperands,
     /* 259297 */     // GIR_Coverage, 2378,
     /* 259297 */     GIR_EraseRootFromParent_Done,
     /* 259298 */   // Label 5186: @259298
     /* 259298 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259356), // Rule ID 2379 //
     /* 259303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 259311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259339 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 259342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259354 */     GIR_RootConstrainSelectedInstOperands,
     /* 259355 */     // GIR_Coverage, 2379,
     /* 259355 */     GIR_EraseRootFromParent_Done,
     /* 259356 */   // Label 5187: @259356
     /* 259356 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259414), // Rule ID 2380 //
     /* 259361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 259364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 259369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 259381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259397 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 259397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 259400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259412 */     GIR_RootConstrainSelectedInstOperands,
     /* 259413 */     // GIR_Coverage, 2380,
     /* 259413 */     GIR_EraseRootFromParent_Done,
     /* 259414 */   // Label 5188: @259414
     /* 259414 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259472), // Rule ID 2381 //
     /* 259419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 259422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 259427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259455 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 259458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259470 */     GIR_RootConstrainSelectedInstOperands,
     /* 259471 */     // GIR_Coverage, 2381,
     /* 259471 */     GIR_EraseRootFromParent_Done,
     /* 259472 */   // Label 5189: @259472
     /* 259472 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259530), // Rule ID 2382 //
     /* 259477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 259480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 259485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 259488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 259497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259513 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 259513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 259516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259528 */     GIR_RootConstrainSelectedInstOperands,
     /* 259529 */     // GIR_Coverage, 2382,
     /* 259529 */     GIR_EraseRootFromParent_Done,
     /* 259530 */   // Label 5190: @259530
     /* 259530 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259588), // Rule ID 2383 //
     /* 259535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 259538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 259543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259571 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 259574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259586 */     GIR_RootConstrainSelectedInstOperands,
     /* 259587 */     // GIR_Coverage, 2383,
     /* 259587 */     GIR_EraseRootFromParent_Done,
     /* 259588 */   // Label 5191: @259588
     /* 259588 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(259646), // Rule ID 2491 //
     /* 259593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 259596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 259601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259629 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 259629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 259632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259634 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 259636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259644 */     GIR_RootConstrainSelectedInstOperands,
     /* 259645 */     // GIR_Coverage, 2491,
     /* 259645 */     GIR_EraseRootFromParent_Done,
     /* 259646 */   // Label 5192: @259646
     /* 259646 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(259702), // Rule ID 13145 //
     /* 259651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 259656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 259662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259677 */     // MIs[0] addr
     /* 259677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 259681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259685 */     // (intrinsic_w_chain:{ *:[i32] } 1238:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 259685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 259688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 259690 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 259692 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 259694 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 259696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259700 */     GIR_RootConstrainSelectedInstOperands,
     /* 259701 */     // GIR_Coverage, 13145,
     /* 259701 */     GIR_EraseRootFromParent_Done,
     /* 259702 */   // Label 5193: @259702
     /* 259702 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259758), // Rule ID 13146 //
     /* 259707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 259712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 259718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259733 */     // MIs[0] addr
     /* 259733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 259737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259741 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 259741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 259744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 259746 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 259748 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 259750 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 259752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259756 */     GIR_RootConstrainSelectedInstOperands,
     /* 259757 */     // GIR_Coverage, 13146,
     /* 259757 */     GIR_EraseRootFromParent_Done,
     /* 259758 */   // Label 5194: @259758
     /* 259758 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259804), // Rule ID 3459 //
     /* 259763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 259766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 259771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259787 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 259790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259802 */     GIR_RootConstrainSelectedInstOperands,
     /* 259803 */     // GIR_Coverage, 3459,
     /* 259803 */     GIR_EraseRootFromParent_Done,
     /* 259804 */   // Label 5195: @259804
     /* 259804 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(259850), // Rule ID 3581 //
     /* 259809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 259817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259833 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 259836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259848 */     GIR_RootConstrainSelectedInstOperands,
     /* 259849 */     // GIR_Coverage, 3581,
     /* 259849 */     GIR_EraseRootFromParent_Done,
     /* 259850 */   // Label 5196: @259850
     /* 259850 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(259896), // Rule ID 12573 //
     /* 259855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 259863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259879 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 259882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259894 */     GIR_RootConstrainSelectedInstOperands,
     /* 259895 */     // GIR_Coverage, 12573,
     /* 259895 */     GIR_EraseRootFromParent_Done,
     /* 259896 */   // Label 5197: @259896
     /* 259896 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(259942), // Rule ID 12577 //
     /* 259901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 259909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259925 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1507:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 259928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259940 */     GIR_RootConstrainSelectedInstOperands,
     /* 259941 */     // GIR_Coverage, 12577,
     /* 259941 */     GIR_EraseRootFromParent_Done,
     /* 259942 */   // Label 5198: @259942
     /* 259942 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(259988), // Rule ID 12578 //
     /* 259947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 259955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259971 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 259974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259986 */     GIR_RootConstrainSelectedInstOperands,
     /* 259987 */     // GIR_Coverage, 12578,
     /* 259987 */     GIR_EraseRootFromParent_Done,
     /* 259988 */   // Label 5199: @259988
     /* 259988 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260034), // Rule ID 12579 //
     /* 259993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 260001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260017 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 260020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260032 */     GIR_RootConstrainSelectedInstOperands,
     /* 260033 */     // GIR_Coverage, 12579,
     /* 260033 */     GIR_EraseRootFromParent_Done,
     /* 260034 */   // Label 5200: @260034
     /* 260034 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260080), // Rule ID 12580 //
     /* 260039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 260047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260063 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260078 */     GIR_RootConstrainSelectedInstOperands,
     /* 260079 */     // GIR_Coverage, 12580,
     /* 260079 */     GIR_EraseRootFromParent_Done,
     /* 260080 */   // Label 5201: @260080
     /* 260080 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260126), // Rule ID 12581 //
     /* 260085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 260093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260109 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 260112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260124 */     GIR_RootConstrainSelectedInstOperands,
     /* 260125 */     // GIR_Coverage, 12581,
     /* 260125 */     GIR_EraseRootFromParent_Done,
     /* 260126 */   // Label 5202: @260126
     /* 260126 */   GIM_Reject,
     /* 260127 */ // Label 5155: @260127
     /* 260127 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(263120),
     /* 260132 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 260135 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(260203), // Rule ID 2518 //
     /* 260140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 260148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260176 */     // MIs[0] Idx
     /* 260176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260184 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 260187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260195 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260201 */     GIR_RootConstrainSelectedInstOperands,
     /* 260202 */     // GIR_Coverage, 2518,
     /* 260202 */     GIR_EraseRootFromParent_Done,
     /* 260203 */   // Label 5204: @260203
     /* 260203 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260271), // Rule ID 2519 //
     /* 260208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 260216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260244 */     // MIs[0] Idx
     /* 260244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260252 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 260255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260263 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260269 */     GIR_RootConstrainSelectedInstOperands,
     /* 260270 */     // GIR_Coverage, 2519,
     /* 260270 */     GIR_EraseRootFromParent_Done,
     /* 260271 */   // Label 5205: @260271
     /* 260271 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260339), // Rule ID 2520 //
     /* 260276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 260279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 260284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 260287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260312 */     // MIs[0] Idx
     /* 260312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260320 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 260323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260331 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260337 */     GIR_RootConstrainSelectedInstOperands,
     /* 260338 */     // GIR_Coverage, 2520,
     /* 260338 */     GIR_EraseRootFromParent_Done,
     /* 260339 */   // Label 5206: @260339
     /* 260339 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260407), // Rule ID 2521 //
     /* 260344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 260347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 260352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260380 */     // MIs[0] Idx
     /* 260380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260388 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 260391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260405 */     GIR_RootConstrainSelectedInstOperands,
     /* 260406 */     // GIR_Coverage, 2521,
     /* 260406 */     GIR_EraseRootFromParent_Done,
     /* 260407 */   // Label 5207: @260407
     /* 260407 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260475), // Rule ID 2522 //
     /* 260412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 260415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 260420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 260423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 260448 */     // MIs[0] Idx
     /* 260448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260456 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 260459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260467 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260473 */     GIR_RootConstrainSelectedInstOperands,
     /* 260474 */     // GIR_Coverage, 2522,
     /* 260474 */     GIR_EraseRootFromParent_Done,
     /* 260475 */   // Label 5208: @260475
     /* 260475 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260543), // Rule ID 2523 //
     /* 260480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 260483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 260488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 260516 */     // MIs[0] Idx
     /* 260516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260524 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 260527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260541 */     GIR_RootConstrainSelectedInstOperands,
     /* 260542 */     // GIR_Coverage, 2523,
     /* 260542 */     GIR_EraseRootFromParent_Done,
     /* 260543 */   // Label 5209: @260543
     /* 260543 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260611), // Rule ID 6993 //
     /* 260548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 260556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260584 */     // MIs[0] Idx
     /* 260584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260592 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 260595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260603 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260609 */     GIR_RootConstrainSelectedInstOperands,
     /* 260610 */     // GIR_Coverage, 6993,
     /* 260610 */     GIR_EraseRootFromParent_Done,
     /* 260611 */   // Label 5210: @260611
     /* 260611 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260679), // Rule ID 6994 //
     /* 260616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 260624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260652 */     // MIs[0] Idx
     /* 260652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260660 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 260663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260671 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260677 */     GIR_RootConstrainSelectedInstOperands,
     /* 260678 */     // GIR_Coverage, 6994,
     /* 260678 */     GIR_EraseRootFromParent_Done,
     /* 260679 */   // Label 5211: @260679
     /* 260679 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(260747), // Rule ID 6995 //
     /* 260684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 260692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260720 */     // MIs[0] Idx
     /* 260720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260728 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 260731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260739 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260745 */     GIR_RootConstrainSelectedInstOperands,
     /* 260746 */     // GIR_Coverage, 6995,
     /* 260746 */     GIR_EraseRootFromParent_Done,
     /* 260747 */   // Label 5212: @260747
     /* 260747 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(260815), // Rule ID 6996 //
     /* 260752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 260760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260788 */     // MIs[0] Idx
     /* 260788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260796 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 260799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260813 */     GIR_RootConstrainSelectedInstOperands,
     /* 260814 */     // GIR_Coverage, 6996,
     /* 260814 */     GIR_EraseRootFromParent_Done,
     /* 260815 */   // Label 5213: @260815
     /* 260815 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(260875), // Rule ID 3593 //
     /* 260820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 260828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 260834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260840 */     // MIs[0] tile
     /* 260840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260856 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 260856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 260859 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260867 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260873 */     GIR_RootConstrainSelectedInstOperands,
     /* 260874 */     // GIR_Coverage, 3593,
     /* 260874 */     GIR_EraseRootFromParent_Done,
     /* 260875 */   // Label 5214: @260875
     /* 260875 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(260935), // Rule ID 3594 //
     /* 260880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 260883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 260888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260900 */     // MIs[0] tile
     /* 260900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260916 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260927 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260933 */     GIR_RootConstrainSelectedInstOperands,
     /* 260934 */     // GIR_Coverage, 3594,
     /* 260934 */     GIR_EraseRootFromParent_Done,
     /* 260935 */   // Label 5215: @260935
     /* 260935 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260995), // Rule ID 3595 //
     /* 260940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 260943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 260948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 260951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 260954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 260960 */     // MIs[0] tile
     /* 260960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260976 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 260976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 260979 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260987 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260993 */     GIR_RootConstrainSelectedInstOperands,
     /* 260994 */     // GIR_Coverage, 3595,
     /* 260994 */     GIR_EraseRootFromParent_Done,
     /* 260995 */   // Label 5216: @260995
     /* 260995 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261055), // Rule ID 3596 //
     /* 261000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 261003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 261008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261020 */     // MIs[0] tile
     /* 261020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 261028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261036 */     // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 261039 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261047 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261053 */     GIR_RootConstrainSelectedInstOperands,
     /* 261054 */     // GIR_Coverage, 3596,
     /* 261054 */     GIR_EraseRootFromParent_Done,
     /* 261055 */   // Label 5217: @261055
     /* 261055 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261115), // Rule ID 3597 //
     /* 261060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 261063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 261068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261080 */     // MIs[0] tile
     /* 261080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 261088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261096 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 261099 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261107 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261113 */     GIR_RootConstrainSelectedInstOperands,
     /* 261114 */     // GIR_Coverage, 3597,
     /* 261114 */     GIR_EraseRootFromParent_Done,
     /* 261115 */   // Label 5218: @261115
     /* 261115 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261175), // Rule ID 3598 //
     /* 261120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 261128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261140 */     // MIs[0] tile
     /* 261140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261156 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 261159 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261173 */     GIR_RootConstrainSelectedInstOperands,
     /* 261174 */     // GIR_Coverage, 3598,
     /* 261174 */     GIR_EraseRootFromParent_Done,
     /* 261175 */   // Label 5219: @261175
     /* 261175 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261235), // Rule ID 3599 //
     /* 261180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 261183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 261188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261200 */     // MIs[0] tile
     /* 261200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 261208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261216 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 261219 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261233 */     GIR_RootConstrainSelectedInstOperands,
     /* 261234 */     // GIR_Coverage, 3599,
     /* 261234 */     GIR_EraseRootFromParent_Done,
     /* 261235 */   // Label 5220: @261235
     /* 261235 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261295), // Rule ID 3600 //
     /* 261240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 261248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261260 */     // MIs[0] tile
     /* 261260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261276 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 261279 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261293 */     GIR_RootConstrainSelectedInstOperands,
     /* 261294 */     // GIR_Coverage, 3600,
     /* 261294 */     GIR_EraseRootFromParent_Done,
     /* 261295 */   // Label 5221: @261295
     /* 261295 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261355), // Rule ID 3694 //
     /* 261300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 261308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261320 */     // MIs[0] tile
     /* 261320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261336 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 261339 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261353 */     GIR_RootConstrainSelectedInstOperands,
     /* 261354 */     // GIR_Coverage, 3694,
     /* 261354 */     GIR_EraseRootFromParent_Done,
     /* 261355 */   // Label 5222: @261355
     /* 261355 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261415), // Rule ID 3695 //
     /* 261360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 261368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 261374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261380 */     // MIs[0] tile
     /* 261380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261396 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 261396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 261399 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261407 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261413 */     GIR_RootConstrainSelectedInstOperands,
     /* 261414 */     // GIR_Coverage, 3695,
     /* 261414 */     GIR_EraseRootFromParent_Done,
     /* 261415 */   // Label 5223: @261415
     /* 261415 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261475), // Rule ID 12588 //
     /* 261420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 261428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 261434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261440 */     // MIs[0] tile
     /* 261440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261456 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 261456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 261459 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261467 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261473 */     GIR_RootConstrainSelectedInstOperands,
     /* 261474 */     // GIR_Coverage, 12588,
     /* 261474 */     GIR_EraseRootFromParent_Done,
     /* 261475 */   // Label 5224: @261475
     /* 261475 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261535), // Rule ID 12589 //
     /* 261480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 261483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 261488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 261494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261500 */     // MIs[0] tile
     /* 261500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 261508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261516 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 261516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 261519 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261533 */     GIR_RootConstrainSelectedInstOperands,
     /* 261534 */     // GIR_Coverage, 12589,
     /* 261534 */     GIR_EraseRootFromParent_Done,
     /* 261535 */   // Label 5225: @261535
     /* 261535 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261595), // Rule ID 12590 //
     /* 261540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 261548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261560 */     // MIs[0] tile
     /* 261560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261576 */     // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 261579 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261593 */     GIR_RootConstrainSelectedInstOperands,
     /* 261594 */     // GIR_Coverage, 12590,
     /* 261594 */     GIR_EraseRootFromParent_Done,
     /* 261595 */   // Label 5226: @261595
     /* 261595 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261655), // Rule ID 12591 //
     /* 261600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 261608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261620 */     // MIs[0] tile
     /* 261620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261636 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 261639 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261647 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261653 */     GIR_RootConstrainSelectedInstOperands,
     /* 261654 */     // GIR_Coverage, 12591,
     /* 261654 */     GIR_EraseRootFromParent_Done,
     /* 261655 */   // Label 5227: @261655
     /* 261655 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261715), // Rule ID 12592 //
     /* 261660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 261668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261680 */     // MIs[0] tile
     /* 261680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261696 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 261699 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261707 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261713 */     GIR_RootConstrainSelectedInstOperands,
     /* 261714 */     // GIR_Coverage, 12592,
     /* 261714 */     GIR_EraseRootFromParent_Done,
     /* 261715 */   // Label 5228: @261715
     /* 261715 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261775), // Rule ID 12593 //
     /* 261720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 261728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261740 */     // MIs[0] tile
     /* 261740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261756 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 261759 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261767 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261773 */     GIR_RootConstrainSelectedInstOperands,
     /* 261774 */     // GIR_Coverage, 12593,
     /* 261774 */     GIR_EraseRootFromParent_Done,
     /* 261775 */   // Label 5229: @261775
     /* 261775 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261835), // Rule ID 12594 //
     /* 261780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 261788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261800 */     // MIs[0] tile
     /* 261800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261816 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 261819 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261827 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261833 */     GIR_RootConstrainSelectedInstOperands,
     /* 261834 */     // GIR_Coverage, 12594,
     /* 261834 */     GIR_EraseRootFromParent_Done,
     /* 261835 */   // Label 5230: @261835
     /* 261835 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261895), // Rule ID 12595 //
     /* 261840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 261848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261860 */     // MIs[0] tile
     /* 261860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261876 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261887 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261893 */     GIR_RootConstrainSelectedInstOperands,
     /* 261894 */     // GIR_Coverage, 12595,
     /* 261894 */     GIR_EraseRootFromParent_Done,
     /* 261895 */   // Label 5231: @261895
     /* 261895 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261955), // Rule ID 12596 //
     /* 261900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 261908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261920 */     // MIs[0] tile
     /* 261920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261936 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 261939 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261947 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261953 */     GIR_RootConstrainSelectedInstOperands,
     /* 261954 */     // GIR_Coverage, 12596,
     /* 261954 */     GIR_EraseRootFromParent_Done,
     /* 261955 */   // Label 5232: @261955
     /* 261955 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(262015), // Rule ID 12597 //
     /* 261960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 261968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261980 */     // MIs[0] tile
     /* 261980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261996 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 261999 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262013 */     GIR_RootConstrainSelectedInstOperands,
     /* 262014 */     // GIR_Coverage, 12597,
     /* 262014 */     GIR_EraseRootFromParent_Done,
     /* 262015 */   // Label 5233: @262015
     /* 262015 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(262075), // Rule ID 12598 //
     /* 262020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 262028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262040 */     // MIs[0] tile
     /* 262040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262056 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 262059 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262067 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262073 */     GIR_RootConstrainSelectedInstOperands,
     /* 262074 */     // GIR_Coverage, 12598,
     /* 262074 */     GIR_EraseRootFromParent_Done,
     /* 262075 */   // Label 5234: @262075
     /* 262075 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262135), // Rule ID 12599 //
     /* 262080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 262088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262100 */     // MIs[0] tile
     /* 262100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262116 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 262119 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262127 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262133 */     GIR_RootConstrainSelectedInstOperands,
     /* 262134 */     // GIR_Coverage, 12599,
     /* 262134 */     GIR_EraseRootFromParent_Done,
     /* 262135 */   // Label 5235: @262135
     /* 262135 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262195), // Rule ID 12600 //
     /* 262140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 262148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262160 */     // MIs[0] tile
     /* 262160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262176 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 262179 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262187 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262193 */     GIR_RootConstrainSelectedInstOperands,
     /* 262194 */     // GIR_Coverage, 12600,
     /* 262194 */     GIR_EraseRootFromParent_Done,
     /* 262195 */   // Label 5236: @262195
     /* 262195 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262255), // Rule ID 12601 //
     /* 262200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 262208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262220 */     // MIs[0] tile
     /* 262220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262236 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262247 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262253 */     GIR_RootConstrainSelectedInstOperands,
     /* 262254 */     // GIR_Coverage, 12601,
     /* 262254 */     GIR_EraseRootFromParent_Done,
     /* 262255 */   // Label 5237: @262255
     /* 262255 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262315), // Rule ID 12602 //
     /* 262260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 262268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262280 */     // MIs[0] tile
     /* 262280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262296 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 262299 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262313 */     GIR_RootConstrainSelectedInstOperands,
     /* 262314 */     // GIR_Coverage, 12602,
     /* 262314 */     GIR_EraseRootFromParent_Done,
     /* 262315 */   // Label 5238: @262315
     /* 262315 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262375), // Rule ID 12603 //
     /* 262320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 262328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262340 */     // MIs[0] tile
     /* 262340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262356 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 262359 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262367 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262373 */     GIR_RootConstrainSelectedInstOperands,
     /* 262374 */     // GIR_Coverage, 12603,
     /* 262374 */     GIR_EraseRootFromParent_Done,
     /* 262375 */   // Label 5239: @262375
     /* 262375 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262435), // Rule ID 12604 //
     /* 262380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 262388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262400 */     // MIs[0] tile
     /* 262400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262416 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 262419 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262433 */     GIR_RootConstrainSelectedInstOperands,
     /* 262434 */     // GIR_Coverage, 12604,
     /* 262434 */     GIR_EraseRootFromParent_Done,
     /* 262435 */   // Label 5240: @262435
     /* 262435 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262495), // Rule ID 12978 //
     /* 262440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 262448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 262454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262460 */     // MIs[0] tile
     /* 262460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262476 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 262476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 262479 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262493 */     GIR_RootConstrainSelectedInstOperands,
     /* 262494 */     // GIR_Coverage, 12978,
     /* 262494 */     GIR_EraseRootFromParent_Done,
     /* 262495 */   // Label 5241: @262495
     /* 262495 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262555), // Rule ID 12979 //
     /* 262500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 262508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262520 */     // MIs[0] tile
     /* 262520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262536 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 262539 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262553 */     GIR_RootConstrainSelectedInstOperands,
     /* 262554 */     // GIR_Coverage, 12979,
     /* 262554 */     GIR_EraseRootFromParent_Done,
     /* 262555 */   // Label 5242: @262555
     /* 262555 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262615), // Rule ID 12980 //
     /* 262560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 262568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262580 */     // MIs[0] tile
     /* 262580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262596 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 262599 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262613 */     GIR_RootConstrainSelectedInstOperands,
     /* 262614 */     // GIR_Coverage, 12980,
     /* 262614 */     GIR_EraseRootFromParent_Done,
     /* 262615 */   // Label 5243: @262615
     /* 262615 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262675), // Rule ID 12981 //
     /* 262620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 262628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262640 */     // MIs[0] tile
     /* 262640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262656 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 262659 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262673 */     GIR_RootConstrainSelectedInstOperands,
     /* 262674 */     // GIR_Coverage, 12981,
     /* 262674 */     GIR_EraseRootFromParent_Done,
     /* 262675 */   // Label 5244: @262675
     /* 262675 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262735), // Rule ID 13092 //
     /* 262680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 262683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 262688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262700 */     // MIs[0] tile
     /* 262700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 262708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262716 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 262716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 262719 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262733 */     GIR_RootConstrainSelectedInstOperands,
     /* 262734 */     // GIR_Coverage, 13092,
     /* 262734 */     GIR_EraseRootFromParent_Done,
     /* 262735 */   // Label 5245: @262735
     /* 262735 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262783), // Rule ID 3580 //
     /* 262740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 262748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262764 */     // MIs[0] Op4
     /* 262764 */     // No operand predicates
     /* 262764 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 262767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262781 */     GIR_RootConstrainSelectedInstOperands,
     /* 262782 */     // GIR_Coverage, 3580,
     /* 262782 */     GIR_EraseRootFromParent_Done,
     /* 262783 */   // Label 5246: @262783
     /* 262783 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262831), // Rule ID 3582 //
     /* 262788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 262796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262812 */     // MIs[0] Op4
     /* 262812 */     // No operand predicates
     /* 262812 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 262815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262823 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262829 */     GIR_RootConstrainSelectedInstOperands,
     /* 262830 */     // GIR_Coverage, 3582,
     /* 262830 */     GIR_EraseRootFromParent_Done,
     /* 262831 */   // Label 5247: @262831
     /* 262831 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262879), // Rule ID 3583 //
     /* 262836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 262839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 262844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262860 */     // MIs[0] Op4
     /* 262860 */     // No operand predicates
     /* 262860 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 262863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262871 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262877 */     GIR_RootConstrainSelectedInstOperands,
     /* 262878 */     // GIR_Coverage, 3583,
     /* 262878 */     GIR_EraseRootFromParent_Done,
     /* 262879 */   // Label 5248: @262879
     /* 262879 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262927), // Rule ID 3584 //
     /* 262884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 262887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 262892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262908 */     // MIs[0] Op4
     /* 262908 */     // No operand predicates
     /* 262908 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 262911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262919 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262925 */     GIR_RootConstrainSelectedInstOperands,
     /* 262926 */     // GIR_Coverage, 3584,
     /* 262926 */     GIR_EraseRootFromParent_Done,
     /* 262927 */   // Label 5249: @262927
     /* 262927 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262975), // Rule ID 12572 //
     /* 262932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 262940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262956 */     // MIs[0] Op4
     /* 262956 */     // No operand predicates
     /* 262956 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 262959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262967 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262973 */     GIR_RootConstrainSelectedInstOperands,
     /* 262974 */     // GIR_Coverage, 12572,
     /* 262974 */     GIR_EraseRootFromParent_Done,
     /* 262975 */   // Label 5250: @262975
     /* 262975 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(263023), // Rule ID 12574 //
     /* 262980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 262988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263004 */     // MIs[0] Op4
     /* 263004 */     // No operand predicates
     /* 263004 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 263004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 263007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263021 */     GIR_RootConstrainSelectedInstOperands,
     /* 263022 */     // GIR_Coverage, 12574,
     /* 263022 */     GIR_EraseRootFromParent_Done,
     /* 263023 */   // Label 5251: @263023
     /* 263023 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(263071), // Rule ID 12575 //
     /* 263028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 263031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 263036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263052 */     // MIs[0] Op4
     /* 263052 */     // No operand predicates
     /* 263052 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 263052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 263055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263063 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263069 */     GIR_RootConstrainSelectedInstOperands,
     /* 263070 */     // GIR_Coverage, 12575,
     /* 263070 */     GIR_EraseRootFromParent_Done,
     /* 263071 */   // Label 5252: @263071
     /* 263071 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(263119), // Rule ID 12576 //
     /* 263076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 263079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 263084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263100 */     // MIs[0] Op4
     /* 263100 */     // No operand predicates
     /* 263100 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 263100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 263103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263117 */     GIR_RootConstrainSelectedInstOperands,
     /* 263118 */     // GIR_Coverage, 12576,
     /* 263118 */     GIR_EraseRootFromParent_Done,
     /* 263119 */   // Label 5253: @263119
     /* 263119 */   GIM_Reject,
     /* 263120 */ // Label 5203: @263120
     /* 263120 */ GIM_Reject,
     /* 263121 */ // Label 39: @263121
     /* 263121 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5258*/ GIMT_Encode4(263410),
     /* 263132 */ /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(263164), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263144 */ /*GILLT_v2s64*//*Label 5255*/ GIMT_Encode4(263224), GIMT_Encode4(0),
     /* 263152 */ /*GILLT_v4s32*//*Label 5256*/ GIMT_Encode4(263286), GIMT_Encode4(0),
     /* 263160 */ /*GILLT_v8s16*//*Label 5257*/ GIMT_Encode4(263348),
     /* 263164 */ // Label 5254: @263164
     /* 263164 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(263223), // Rule ID 6505 //
     /* 263169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263180 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 263180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 263204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 263207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263222 */   // GIR_Coverage, 6505,
     /* 263222 */   GIR_EraseRootFromParent_Done,
     /* 263223 */ // Label 5259: @263223
     /* 263223 */ GIM_Reject,
     /* 263224 */ // Label 5255: @263224
     /* 263224 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(263285),
     /* 263229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 263232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263236 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(263263), // Rule ID 6377 //
     /* 263241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263248 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 263248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 263251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263261 */     GIR_RootConstrainSelectedInstOperands,
     /* 263262 */     // GIR_Coverage, 6377,
     /* 263262 */     GIR_EraseRootFromParent_Done,
     /* 263263 */   // Label 5261: @263263
     /* 263263 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(263284), // Rule ID 6370 //
     /* 263268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263272 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 263272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 263275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263282 */     GIR_RootConstrainSelectedInstOperands,
     /* 263283 */     // GIR_Coverage, 6370,
     /* 263283 */     GIR_EraseRootFromParent_Done,
     /* 263284 */   // Label 5262: @263284
     /* 263284 */   GIM_Reject,
     /* 263285 */ // Label 5260: @263285
     /* 263285 */ GIM_Reject,
     /* 263286 */ // Label 5256: @263286
     /* 263286 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(263347),
     /* 263291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263298 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263325), // Rule ID 6374 //
     /* 263303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263310 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 263310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 263313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263323 */     GIR_RootConstrainSelectedInstOperands,
     /* 263324 */     // GIR_Coverage, 6374,
     /* 263324 */     GIR_EraseRootFromParent_Done,
     /* 263325 */   // Label 5264: @263325
     /* 263325 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263346), // Rule ID 6367 //
     /* 263330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263334 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 263334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 263337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263344 */     GIR_RootConstrainSelectedInstOperands,
     /* 263345 */     // GIR_Coverage, 6367,
     /* 263345 */     GIR_EraseRootFromParent_Done,
     /* 263346 */   // Label 5265: @263346
     /* 263346 */   GIM_Reject,
     /* 263347 */ // Label 5263: @263347
     /* 263347 */ GIM_Reject,
     /* 263348 */ // Label 5257: @263348
     /* 263348 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263409),
     /* 263353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 263356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263360 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263387), // Rule ID 6371 //
     /* 263365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 263372 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 263372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 263375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263385 */     GIR_RootConstrainSelectedInstOperands,
     /* 263386 */     // GIR_Coverage, 6371,
     /* 263386 */     GIR_EraseRootFromParent_Done,
     /* 263387 */   // Label 5267: @263387
     /* 263387 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263408), // Rule ID 6364 //
     /* 263392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263396 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 263396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 263399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263406 */     GIR_RootConstrainSelectedInstOperands,
     /* 263407 */     // GIR_Coverage, 6364,
     /* 263407 */     GIR_EraseRootFromParent_Done,
     /* 263408 */   // Label 5268: @263408
     /* 263408 */   GIM_Reject,
     /* 263409 */ // Label 5266: @263409
     /* 263409 */ GIM_Reject,
     /* 263410 */ // Label 5258: @263410
     /* 263410 */ GIM_Reject,
     /* 263411 */ // Label 40: @263411
     /* 263411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5273*/ GIMT_Encode4(264847),
     /* 263422 */ /*GILLT_s32*//*Label 5269*/ GIMT_Encode4(263454), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263434 */ /*GILLT_v2s32*//*Label 5270*/ GIMT_Encode4(263493), GIMT_Encode4(0),
     /* 263442 */ /*GILLT_v4s16*//*Label 5271*/ GIMT_Encode4(263849), GIMT_Encode4(0),
     /* 263450 */ /*GILLT_v8s8*//*Label 5272*/ GIMT_Encode4(264348),
     /* 263454 */ // Label 5269: @263454
     /* 263454 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263492), // Rule ID 6526 //
     /* 263459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 263466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 263470 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 263470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263475 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 263481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 263486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 263491 */   // GIR_Coverage, 6526,
     /* 263491 */   GIR_EraseRootFromParent_Done,
     /* 263492 */ // Label 5274: @263492
     /* 263492 */ GIM_Reject,
     /* 263493 */ // Label 5270: @263493
     /* 263493 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263848),
     /* 263498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263505 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263583), // Rule ID 5430 //
     /* 263510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 263530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 263547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 263553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 263555 */     // MIs[1] Operand 2
     /* 263555 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 263568 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 263568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 263571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263581 */     GIR_RootConstrainSelectedInstOperands,
     /* 263582 */     // GIR_Coverage, 5430,
     /* 263582 */     GIR_EraseRootFromParent_Done,
     /* 263583 */   // Label 5276: @263583
     /* 263583 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263654), // Rule ID 5426 //
     /* 263588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 263608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263626 */     // MIs[1] Operand 2
     /* 263626 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263639 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 263639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 263642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263652 */     GIR_RootConstrainSelectedInstOperands,
     /* 263653 */     // GIR_Coverage, 5426,
     /* 263653 */     GIR_EraseRootFromParent_Done,
     /* 263654 */   // Label 5277: @263654
     /* 263654 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263725), // Rule ID 5428 //
     /* 263659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 263679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263697 */     // MIs[1] Operand 2
     /* 263697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263710 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 263710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 263713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263723 */     GIR_RootConstrainSelectedInstOperands,
     /* 263724 */     // GIR_Coverage, 5428,
     /* 263724 */     GIR_EraseRootFromParent_Done,
     /* 263725 */   // Label 5278: @263725
     /* 263725 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263778), // Rule ID 2162 //
     /* 263730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 263741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263750 */     // MIs[1] imm
     /* 263750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 263762 */     // MIs[2] Operand 1
     /* 263762 */     // No operand predicates
     /* 263762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263764 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 263764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 263767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263776 */     GIR_RootConstrainSelectedInstOperands,
     /* 263777 */     // GIR_Coverage, 2162,
     /* 263777 */     GIR_EraseRootFromParent_Done,
     /* 263778 */   // Label 5279: @263778
     /* 263778 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263828), // Rule ID 6352 //
     /* 263783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263800 */     // MIs[1] imm
     /* 263800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 263812 */     // MIs[2] Operand 1
     /* 263812 */     // No operand predicates
     /* 263812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263814 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 263814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 263817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263826 */     GIR_RootConstrainSelectedInstOperands,
     /* 263827 */     // GIR_Coverage, 6352,
     /* 263827 */     GIR_EraseRootFromParent_Done,
     /* 263828 */   // Label 5280: @263828
     /* 263828 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263847), // Rule ID 1099 //
     /* 263833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263840 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 263840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 263845 */     GIR_RootConstrainSelectedInstOperands,
     /* 263846 */     // GIR_Coverage, 1099,
     /* 263846 */     GIR_Done,
     /* 263847 */   // Label 5281: @263847
     /* 263847 */   GIM_Reject,
     /* 263848 */ // Label 5275: @263848
     /* 263848 */ GIM_Reject,
     /* 263849 */ // Label 5271: @263849
     /* 263849 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(264347),
     /* 263854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263861 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263939), // Rule ID 5424 //
     /* 263866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 263886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 263903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 263909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 263911 */     // MIs[1] Operand 2
     /* 263911 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 263924 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 263924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 263927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263937 */     GIR_RootConstrainSelectedInstOperands,
     /* 263938 */     // GIR_Coverage, 5424,
     /* 263938 */     GIR_EraseRootFromParent_Done,
     /* 263939 */   // Label 5283: @263939
     /* 263939 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264010), // Rule ID 5420 //
     /* 263944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 263964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263982 */     // MIs[1] Operand 2
     /* 263982 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263995 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 263995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 263998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264008 */     GIR_RootConstrainSelectedInstOperands,
     /* 264009 */     // GIR_Coverage, 5420,
     /* 264009 */     GIR_EraseRootFromParent_Done,
     /* 264010 */   // Label 5284: @264010
     /* 264010 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264081), // Rule ID 5422 //
     /* 264015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 264035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 264043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264053 */     // MIs[1] Operand 2
     /* 264053 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 264064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264066 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 264066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 264069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264079 */     GIR_RootConstrainSelectedInstOperands,
     /* 264080 */     // GIR_Coverage, 5422,
     /* 264080 */     GIR_EraseRootFromParent_Done,
     /* 264081 */   // Label 5285: @264081
     /* 264081 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264173), // Rule ID 5546 //
     /* 264086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264094 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 264117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 264126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 264134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264141 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 264141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 264144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 264148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 264157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 264161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 264166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264171 */     GIR_RootConstrainSelectedInstOperands,
     /* 264172 */     // GIR_Coverage, 5546,
     /* 264172 */     GIR_EraseRootFromParent_Done,
     /* 264173 */   // Label 5286: @264173
     /* 264173 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264226), // Rule ID 2161 //
     /* 264178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 264189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264198 */     // MIs[1] imm
     /* 264198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 264210 */     // MIs[2] Operand 1
     /* 264210 */     // No operand predicates
     /* 264210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264212 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 264212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 264215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264224 */     GIR_RootConstrainSelectedInstOperands,
     /* 264225 */     // GIR_Coverage, 2161,
     /* 264225 */     GIR_EraseRootFromParent_Done,
     /* 264226 */   // Label 5287: @264226
     /* 264226 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264276), // Rule ID 6351 //
     /* 264231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264248 */     // MIs[1] imm
     /* 264248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 264260 */     // MIs[2] Operand 1
     /* 264260 */     // No operand predicates
     /* 264260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264262 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 264262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 264265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264274 */     GIR_RootConstrainSelectedInstOperands,
     /* 264275 */     // GIR_Coverage, 6351,
     /* 264275 */     GIR_EraseRootFromParent_Done,
     /* 264276 */   // Label 5288: @264276
     /* 264276 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264327), // Rule ID 5574 //
     /* 264281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264289 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264312 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 264312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 264315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 264321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 264325 */     GIR_RootConstrainSelectedInstOperands,
     /* 264326 */     // GIR_Coverage, 5574,
     /* 264326 */     GIR_EraseRootFromParent_Done,
     /* 264327 */   // Label 5289: @264327
     /* 264327 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264346), // Rule ID 1098 //
     /* 264332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264339 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 264339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 264344 */     GIR_RootConstrainSelectedInstOperands,
     /* 264345 */     // GIR_Coverage, 1098,
     /* 264345 */     GIR_Done,
     /* 264346 */   // Label 5290: @264346
     /* 264346 */   GIM_Reject,
     /* 264347 */ // Label 5282: @264347
     /* 264347 */ GIM_Reject,
     /* 264348 */ // Label 5272: @264348
     /* 264348 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264846),
     /* 264353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264360 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264438), // Rule ID 5418 //
     /* 264365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 264385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264402 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 264410 */     // MIs[1] Operand 2
     /* 264410 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264423 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 264423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 264426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264436 */     GIR_RootConstrainSelectedInstOperands,
     /* 264437 */     // GIR_Coverage, 5418,
     /* 264437 */     GIR_EraseRootFromParent_Done,
     /* 264438 */   // Label 5292: @264438
     /* 264438 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264509), // Rule ID 5414 //
     /* 264443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 264463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264481 */     // MIs[1] Operand 2
     /* 264481 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264494 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 264494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 264497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264507 */     GIR_RootConstrainSelectedInstOperands,
     /* 264508 */     // GIR_Coverage, 5414,
     /* 264508 */     GIR_EraseRootFromParent_Done,
     /* 264509 */   // Label 5293: @264509
     /* 264509 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264580), // Rule ID 5416 //
     /* 264514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 264534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264552 */     // MIs[1] Operand 2
     /* 264552 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264565 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 264565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 264568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264578 */     GIR_RootConstrainSelectedInstOperands,
     /* 264579 */     // GIR_Coverage, 5416,
     /* 264579 */     GIR_EraseRootFromParent_Done,
     /* 264580 */   // Label 5294: @264580
     /* 264580 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264672), // Rule ID 5519 //
     /* 264585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264593 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 264625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264640 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 264640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 264643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 264647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 264656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 264660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 264665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264670 */     GIR_RootConstrainSelectedInstOperands,
     /* 264671 */     // GIR_Coverage, 5519,
     /* 264671 */     GIR_EraseRootFromParent_Done,
     /* 264672 */   // Label 5295: @264672
     /* 264672 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264725), // Rule ID 2160 //
     /* 264677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 264688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264697 */     // MIs[1] imm
     /* 264697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 264709 */     // MIs[2] Operand 1
     /* 264709 */     // No operand predicates
     /* 264709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264711 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 264711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 264714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264723 */     GIR_RootConstrainSelectedInstOperands,
     /* 264724 */     // GIR_Coverage, 2160,
     /* 264724 */     GIR_EraseRootFromParent_Done,
     /* 264725 */   // Label 5296: @264725
     /* 264725 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264775), // Rule ID 6350 //
     /* 264730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264747 */     // MIs[1] imm
     /* 264747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264755 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 264759 */     // MIs[2] Operand 1
     /* 264759 */     // No operand predicates
     /* 264759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264761 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 264761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 264764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264773 */     GIR_RootConstrainSelectedInstOperands,
     /* 264774 */     // GIR_Coverage, 6350,
     /* 264774 */     GIR_EraseRootFromParent_Done,
     /* 264775 */   // Label 5297: @264775
     /* 264775 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264826), // Rule ID 5573 //
     /* 264780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264788 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264811 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 264811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 264814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 264820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 264824 */     GIR_RootConstrainSelectedInstOperands,
     /* 264825 */     // GIR_Coverage, 5573,
     /* 264825 */     GIR_EraseRootFromParent_Done,
     /* 264826 */   // Label 5298: @264826
     /* 264826 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264845), // Rule ID 1097 //
     /* 264831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264838 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 264838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 264843 */     GIR_RootConstrainSelectedInstOperands,
     /* 264844 */     // GIR_Coverage, 1097,
     /* 264844 */     GIR_Done,
     /* 264845 */   // Label 5299: @264845
     /* 264845 */   GIM_Reject,
     /* 264846 */ // Label 5291: @264846
     /* 264846 */ GIM_Reject,
     /* 264847 */ // Label 5273: @264847
     /* 264847 */ GIM_Reject,
     /* 264848 */ // Label 41: @264848
     /* 264848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5302*/ GIMT_Encode4(264967),
     /* 264859 */ /*GILLT_s32*//*Label 5300*/ GIMT_Encode4(264867),
     /* 264863 */ /*GILLT_s64*//*Label 5301*/ GIMT_Encode4(264887),
     /* 264867 */ // Label 5300: @264867
     /* 264867 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(264886), // Rule ID 81 //
     /* 264872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264876 */   // MIs[0] Operand 1
     /* 264876 */   // No operand predicates
     /* 264876 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 264876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 264879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264881 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 264884 */   GIR_RootConstrainSelectedInstOperands,
     /* 264885 */   // GIR_Coverage, 81,
     /* 264885 */   GIR_EraseRootFromParent_Done,
     /* 264886 */ // Label 5303: @264886
     /* 264886 */ GIM_Reject,
     /* 264887 */ // Label 5301: @264887
     /* 264887 */ GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264947), // Rule ID 3905 //
     /* 264892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 264895 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 264899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264903 */   // MIs[0] Operand 1
     /* 264903 */   // No operand predicates
     /* 264903 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 264903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 264906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 264910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264915 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 264920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 264936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264946 */   // GIR_Coverage, 3905,
     /* 264946 */   GIR_EraseRootFromParent_Done,
     /* 264947 */ // Label 5304: @264947
     /* 264947 */ GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264966), // Rule ID 82 //
     /* 264952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264956 */   // MIs[0] Operand 1
     /* 264956 */   // No operand predicates
     /* 264956 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 264956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 264959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 264964 */   GIR_RootConstrainSelectedInstOperands,
     /* 264965 */   // GIR_Coverage, 82,
     /* 264965 */   GIR_EraseRootFromParent_Done,
     /* 264966 */ // Label 5305: @264966
     /* 264966 */ GIM_Reject,
     /* 264967 */ // Label 5302: @264967
     /* 264967 */ GIM_Reject,
     /* 264968 */ // Label 42: @264968
     /* 264968 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5309*/ GIMT_Encode4(265208),
     /* 264979 */ /*GILLT_s16*//*Label 5306*/ GIMT_Encode4(264991),
     /* 264983 */ /*GILLT_s32*//*Label 5307*/ GIMT_Encode4(265043),
     /* 264987 */ /*GILLT_s64*//*Label 5308*/ GIMT_Encode4(265156),
     /* 264991 */ // Label 5306: @264991
     /* 264991 */ GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265014), // Rule ID 506 //
     /* 264996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 264999 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 265003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265007 */   // MIs[0] Operand 1
     /* 265007 */   // No operand predicates
     /* 265007 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 265007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 265010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265012 */   GIR_RootConstrainSelectedInstOperands,
     /* 265013 */   // GIR_Coverage, 506,
     /* 265013 */   GIR_EraseRootFromParent_Done,
     /* 265014 */ // Label 5310: @265014
     /* 265014 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265042), // Rule ID 688 //
     /* 265019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 265022 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 265026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265030 */   // MIs[0] Operand 1
     /* 265030 */   // No operand predicates
     /* 265030 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 265030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 265033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265035 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 265040 */   GIR_RootConstrainSelectedInstOperands,
     /* 265041 */   // GIR_Coverage, 688,
     /* 265041 */   GIR_EraseRootFromParent_Done,
     /* 265042 */ // Label 5311: @265042
     /* 265042 */ GIM_Reject,
     /* 265043 */ // Label 5307: @265043
     /* 265043 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265066), // Rule ID 507 //
     /* 265048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265051 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 265055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265059 */   // MIs[0] Operand 1
     /* 265059 */   // No operand predicates
     /* 265059 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 265059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 265062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265064 */   GIR_RootConstrainSelectedInstOperands,
     /* 265065 */   // GIR_Coverage, 507,
     /* 265065 */   GIR_EraseRootFromParent_Done,
     /* 265066 */ // Label 5312: @265066
     /* 265066 */ GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265094), // Rule ID 689 //
     /* 265071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265074 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 265078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265082 */   // MIs[0] Operand 1
     /* 265082 */   // No operand predicates
     /* 265082 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 265082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 265085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265087 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 265092 */   GIR_RootConstrainSelectedInstOperands,
     /* 265093 */   // GIR_Coverage, 689,
     /* 265093 */   GIR_EraseRootFromParent_Done,
     /* 265094 */ // Label 5313: @265094
     /* 265094 */ GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265155), // Rule ID 6039 //
     /* 265099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265102 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 265106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265110 */   // MIs[0] Operand 1
     /* 265110 */   // No operand predicates
     /* 265110 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 265110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 265113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 265117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265122 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 265127 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 265130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265137 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 265144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265154 */   // GIR_Coverage, 6039,
     /* 265154 */   GIR_EraseRootFromParent_Done,
     /* 265155 */ // Label 5314: @265155
     /* 265155 */ GIM_Reject,
     /* 265156 */ // Label 5308: @265156
     /* 265156 */ GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265179), // Rule ID 508 //
     /* 265161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265164 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 265168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265172 */   // MIs[0] Operand 1
     /* 265172 */   // No operand predicates
     /* 265172 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 265172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 265175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265177 */   GIR_RootConstrainSelectedInstOperands,
     /* 265178 */   // GIR_Coverage, 508,
     /* 265178 */   GIR_EraseRootFromParent_Done,
     /* 265179 */ // Label 5315: @265179
     /* 265179 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265207), // Rule ID 690 //
     /* 265184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265187 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 265191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265195 */   // MIs[0] Operand 1
     /* 265195 */   // No operand predicates
     /* 265195 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 265195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 265198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265200 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 265205 */   GIR_RootConstrainSelectedInstOperands,
     /* 265206 */   // GIR_Coverage, 690,
     /* 265206 */   GIR_EraseRootFromParent_Done,
     /* 265207 */ // Label 5316: @265207
     /* 265207 */ GIM_Reject,
     /* 265208 */ // Label 5309: @265208
     /* 265208 */ GIM_Reject,
     /* 265209 */ // Label 43: @265209
     /* 265209 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5322*/ GIMT_Encode4(267106),
     /* 265220 */ /*GILLT_s32*//*Label 5317*/ GIMT_Encode4(265256),
     /* 265224 */ /*GILLT_s64*//*Label 5318*/ GIMT_Encode4(266697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265236 */ /*GILLT_v2s64*//*Label 5319*/ GIMT_Encode4(266920), GIMT_Encode4(0),
     /* 265244 */ /*GILLT_v4s32*//*Label 5320*/ GIMT_Encode4(266982), GIMT_Encode4(0),
     /* 265252 */ /*GILLT_v8s16*//*Label 5321*/ GIMT_Encode4(267044),
     /* 265256 */ // Label 5317: @265256
     /* 265256 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265376), // Rule ID 13147 //
     /* 265261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265268 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265276 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265279 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265284 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265288 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265295 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265295 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265298 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 265302 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265307 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265313 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265316 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265320 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265339 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265342 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265345 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265374 */   GIR_RootConstrainSelectedInstOperands,
     /* 265375 */   // GIR_Coverage, 13147,
     /* 265375 */   GIR_EraseRootFromParent_Done,
     /* 265376 */ // Label 5323: @265376
     /* 265376 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(265496), // Rule ID 13149 //
     /* 265381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265388 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265396 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265399 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265404 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265408 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265415 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265415 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265418 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 265422 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265427 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265433 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265436 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265440 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265459 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265462 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265465 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265478 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265494 */   GIR_RootConstrainSelectedInstOperands,
     /* 265495 */   // GIR_Coverage, 13149,
     /* 265495 */   GIR_EraseRootFromParent_Done,
     /* 265496 */ // Label 5324: @265496
     /* 265496 */ GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265616), // Rule ID 13151 //
     /* 265501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265508 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265516 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265519 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265528 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265535 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265535 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 265538 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 265542 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265547 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265579 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265582 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265585 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265614 */   GIR_RootConstrainSelectedInstOperands,
     /* 265615 */   // GIR_Coverage, 13151,
     /* 265615 */   GIR_EraseRootFromParent_Done,
     /* 265616 */ // Label 5325: @265616
     /* 265616 */ GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265736), // Rule ID 13153 //
     /* 265621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265628 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265636 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265639 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265644 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 265648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265655 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265655 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 265658 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 265662 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265667 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265673 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265676 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265680 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265699 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265702 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265705 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265734 */   GIR_RootConstrainSelectedInstOperands,
     /* 265735 */   // GIR_Coverage, 13153,
     /* 265735 */   GIR_EraseRootFromParent_Done,
     /* 265736 */ // Label 5326: @265736
     /* 265736 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(265856), // Rule ID 13169 //
     /* 265741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265748 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265756 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265759 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 265764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265775 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265775 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265778 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 265782 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265787 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265793 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265796 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265800 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265822 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265825 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265854 */   GIR_RootConstrainSelectedInstOperands,
     /* 265855 */   // GIR_Coverage, 13169,
     /* 265855 */   GIR_EraseRootFromParent_Done,
     /* 265856 */ // Label 5327: @265856
     /* 265856 */ GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(265976), // Rule ID 13171 //
     /* 265861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265876 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265879 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 265884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265888 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265895 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265895 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265898 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 265902 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265907 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265939 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265942 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265945 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265974 */   GIR_RootConstrainSelectedInstOperands,
     /* 265975 */   // GIR_Coverage, 13171,
     /* 265975 */   GIR_EraseRootFromParent_Done,
     /* 265976 */ // Label 5328: @265976
     /* 265976 */ GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266096), // Rule ID 13173 //
     /* 265981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265988 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265996 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265999 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 266004 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266008 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266015 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266015 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266018 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 266022 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266027 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266033 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266036 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266040 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266062 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266065 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266094 */   GIR_RootConstrainSelectedInstOperands,
     /* 266095 */   // GIR_Coverage, 13173,
     /* 266095 */   GIR_EraseRootFromParent_Done,
     /* 266096 */ // Label 5329: @266096
     /* 266096 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266216), // Rule ID 13175 //
     /* 266101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266108 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266116 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266119 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 266124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266128 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266135 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266135 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266138 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 266142 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266147 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266153 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266156 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266160 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266179 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266182 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266185 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266193 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266214 */   GIR_RootConstrainSelectedInstOperands,
     /* 266215 */   // GIR_Coverage, 13175,
     /* 266215 */   GIR_EraseRootFromParent_Done,
     /* 266216 */ // Label 5330: @266216
     /* 266216 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(266336), // Rule ID 13179 //
     /* 266221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266236 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266239 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266248 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266255 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266255 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 266258 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 266262 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266267 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266273 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266276 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266280 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266299 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266302 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266305 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 266308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 266326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266334 */   GIR_RootConstrainSelectedInstOperands,
     /* 266335 */   // GIR_Coverage, 13179,
     /* 266335 */   GIR_EraseRootFromParent_Done,
     /* 266336 */ // Label 5331: @266336
     /* 266336 */ GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(266456), // Rule ID 13181 //
     /* 266341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266348 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266356 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266359 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266375 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266375 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 266378 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 266382 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266387 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266393 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266396 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266400 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266419 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266422 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266425 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 266428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 266446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266454 */   GIR_RootConstrainSelectedInstOperands,
     /* 266455 */   // GIR_Coverage, 13181,
     /* 266455 */   GIR_EraseRootFromParent_Done,
     /* 266456 */ // Label 5332: @266456
     /* 266456 */ GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266576), // Rule ID 13183 //
     /* 266461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266468 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266476 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266479 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266488 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266495 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266495 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266498 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 266502 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266507 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266513 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266516 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266520 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266539 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266542 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266545 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266574 */   GIR_RootConstrainSelectedInstOperands,
     /* 266575 */   // GIR_Coverage, 13183,
     /* 266575 */   GIR_EraseRootFromParent_Done,
     /* 266576 */ // Label 5333: @266576
     /* 266576 */ GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266696), // Rule ID 13185 //
     /* 266581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266588 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266596 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266599 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266615 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266615 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266618 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 266622 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266627 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266633 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266636 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266640 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266659 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266662 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266665 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266673 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266694 */   GIR_RootConstrainSelectedInstOperands,
     /* 266695 */   // GIR_Coverage, 13185,
     /* 266695 */   GIR_EraseRootFromParent_Done,
     /* 266696 */ // Label 5334: @266696
     /* 266696 */ GIM_Reject,
     /* 266697 */ // Label 5318: @266697
     /* 266697 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266919),
     /* 266702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266709 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266763), // Rule ID 5657 //
     /* 266714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 266726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 266747 */     // MIs[2] Operand 1
     /* 266747 */     // No operand predicates
     /* 266747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266749 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 266749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 266752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266761 */     GIR_RootConstrainSelectedInstOperands,
     /* 266762 */     // GIR_Coverage, 5657,
     /* 266762 */     GIR_EraseRootFromParent_Done,
     /* 266763 */   // Label 5336: @266763
     /* 266763 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266842), // Rule ID 11252 //
     /* 266768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 266771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 266783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266795 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 266799 */     // MIs[2] Operand 1
     /* 266799 */     // No operand predicates
     /* 266799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266801 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 266801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 266804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 266819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 266832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 266840 */     GIR_RootConstrainSelectedInstOperands,
     /* 266841 */     // GIR_Coverage, 11252,
     /* 266841 */     GIR_EraseRootFromParent_Done,
     /* 266842 */   // Label 5337: @266842
     /* 266842 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266918), // Rule ID 6507 //
     /* 266847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266851 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 266851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 266854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 266884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 266916 */     GIR_RootConstrainSelectedInstOperands,
     /* 266917 */     // GIR_Coverage, 6507,
     /* 266917 */     GIR_EraseRootFromParent_Done,
     /* 266918 */   // Label 5338: @266918
     /* 266918 */   GIM_Reject,
     /* 266919 */ // Label 5335: @266919
     /* 266919 */ GIM_Reject,
     /* 266920 */ // Label 5319: @266920
     /* 266920 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(266981),
     /* 266925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 266928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266932 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(266959), // Rule ID 6379 //
     /* 266937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 266944 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 266944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 266947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 266954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266957 */     GIR_RootConstrainSelectedInstOperands,
     /* 266958 */     // GIR_Coverage, 6379,
     /* 266958 */     GIR_EraseRootFromParent_Done,
     /* 266959 */   // Label 5340: @266959
     /* 266959 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(266980), // Rule ID 6368 //
     /* 266964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266968 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 266968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 266971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266978 */     GIR_RootConstrainSelectedInstOperands,
     /* 266979 */     // GIR_Coverage, 6368,
     /* 266979 */     GIR_EraseRootFromParent_Done,
     /* 266980 */   // Label 5341: @266980
     /* 266980 */   GIM_Reject,
     /* 266981 */ // Label 5339: @266981
     /* 266981 */ GIM_Reject,
     /* 266982 */ // Label 5320: @266982
     /* 266982 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267043),
     /* 266987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 266990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266994 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267021), // Rule ID 6376 //
     /* 266999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267006 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 267006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 267009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267019 */     GIR_RootConstrainSelectedInstOperands,
     /* 267020 */     // GIR_Coverage, 6376,
     /* 267020 */     GIR_EraseRootFromParent_Done,
     /* 267021 */   // Label 5343: @267021
     /* 267021 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267042), // Rule ID 6365 //
     /* 267026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267030 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 267030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 267033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267040 */     GIR_RootConstrainSelectedInstOperands,
     /* 267041 */     // GIR_Coverage, 6365,
     /* 267041 */     GIR_EraseRootFromParent_Done,
     /* 267042 */   // Label 5344: @267042
     /* 267042 */   GIM_Reject,
     /* 267043 */ // Label 5342: @267043
     /* 267043 */ GIM_Reject,
     /* 267044 */ // Label 5321: @267044
     /* 267044 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267105),
     /* 267049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 267052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267056 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267083), // Rule ID 6373 //
     /* 267061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 267068 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 267068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 267071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267081 */     GIR_RootConstrainSelectedInstOperands,
     /* 267082 */     // GIR_Coverage, 6373,
     /* 267082 */     GIR_EraseRootFromParent_Done,
     /* 267083 */   // Label 5346: @267083
     /* 267083 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(267104), // Rule ID 6362 //
     /* 267088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267092 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 267092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 267095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267102 */     GIR_RootConstrainSelectedInstOperands,
     /* 267103 */     // GIR_Coverage, 6362,
     /* 267103 */     GIR_EraseRootFromParent_Done,
     /* 267104 */   // Label 5347: @267104
     /* 267104 */   GIM_Reject,
     /* 267105 */ // Label 5345: @267105
     /* 267105 */ GIM_Reject,
     /* 267106 */ // Label 5322: @267106
     /* 267106 */ GIM_Reject,
     /* 267107 */ // Label 44: @267107
     /* 267107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5353*/ GIMT_Encode4(268760),
     /* 267118 */ /*GILLT_s32*//*Label 5348*/ GIMT_Encode4(267198),
     /* 267122 */ /*GILLT_s64*//*Label 5349*/ GIMT_Encode4(267692), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 267174 */ /*GILLT_nxv2s64*//*Label 5350*/ GIMT_Encode4(268334), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 267186 */ /*GILLT_nxv4s32*//*Label 5351*/ GIMT_Encode4(268543), GIMT_Encode4(0),
     /* 267194 */ /*GILLT_nxv8s16*//*Label 5352*/ GIMT_Encode4(268687),
     /* 267198 */ // Label 5348: @267198
     /* 267198 */ GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(267691),
     /* 267203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 267206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267210 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(267275), // Rule ID 5652 //
     /* 267215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 267227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267244 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267248 */     // MIs[2] Operand 1
     /* 267248 */     // No operand predicates
     /* 267248 */     // MIs[0] Operand 2
     /* 267248 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267261 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 267261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 267264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267273 */     GIR_RootConstrainSelectedInstOperands,
     /* 267274 */     // GIR_Coverage, 5652,
     /* 267274 */     GIR_EraseRootFromParent_Done,
     /* 267275 */   // Label 5355: @267275
     /* 267275 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(267340), // Rule ID 5654 //
     /* 267280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267313 */     // MIs[2] Operand 1
     /* 267313 */     // No operand predicates
     /* 267313 */     // MIs[0] Operand 2
     /* 267313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267326 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267338 */     GIR_RootConstrainSelectedInstOperands,
     /* 267339 */     // GIR_Coverage, 5654,
     /* 267339 */     GIR_EraseRootFromParent_Done,
     /* 267340 */   // Label 5356: @267340
     /* 267340 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(267405), // Rule ID 5656 //
     /* 267345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267378 */     // MIs[2] Operand 1
     /* 267378 */     // No operand predicates
     /* 267378 */     // MIs[0] Operand 2
     /* 267378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267391 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267403 */     GIR_RootConstrainSelectedInstOperands,
     /* 267404 */     // GIR_Coverage, 5656,
     /* 267404 */     GIR_EraseRootFromParent_Done,
     /* 267405 */   // Label 5357: @267405
     /* 267405 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(267495), // Rule ID 11248 //
     /* 267410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 267425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267441 */     // MIs[2] Operand 1
     /* 267441 */     // No operand predicates
     /* 267441 */     // MIs[0] Operand 2
     /* 267441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267454 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 267454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 267457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 267485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 267493 */     GIR_RootConstrainSelectedInstOperands,
     /* 267494 */     // GIR_Coverage, 11248,
     /* 267494 */     GIR_EraseRootFromParent_Done,
     /* 267495 */   // Label 5358: @267495
     /* 267495 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(267585), // Rule ID 11250 //
     /* 267500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 267515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267531 */     // MIs[2] Operand 1
     /* 267531 */     // No operand predicates
     /* 267531 */     // MIs[0] Operand 2
     /* 267531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267544 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 267544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 267547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 267583 */     GIR_RootConstrainSelectedInstOperands,
     /* 267584 */     // GIR_Coverage, 11250,
     /* 267584 */     GIR_EraseRootFromParent_Done,
     /* 267585 */   // Label 5359: @267585
     /* 267585 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(267620), // Rule ID 6512 //
     /* 267590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267594 */     // MIs[0] Operand 2
     /* 267594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267605 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 267605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 267618 */     GIR_RootConstrainSelectedInstOperands,
     /* 267619 */     // GIR_Coverage, 6512,
     /* 267619 */     GIR_EraseRootFromParent_Done,
     /* 267620 */   // Label 5360: @267620
     /* 267620 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(267655), // Rule ID 6513 //
     /* 267625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267629 */     // MIs[0] Operand 2
     /* 267629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267640 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 267640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 267653 */     GIR_RootConstrainSelectedInstOperands,
     /* 267654 */     // GIR_Coverage, 6513,
     /* 267654 */     GIR_EraseRootFromParent_Done,
     /* 267655 */   // Label 5361: @267655
     /* 267655 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(267690), // Rule ID 6514 //
     /* 267660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267664 */     // MIs[0] Operand 2
     /* 267664 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 267675 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 267675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267688 */     GIR_RootConstrainSelectedInstOperands,
     /* 267689 */     // GIR_Coverage, 6514,
     /* 267689 */     GIR_EraseRootFromParent_Done,
     /* 267690 */   // Label 5362: @267690
     /* 267690 */   GIM_Reject,
     /* 267691 */ // Label 5354: @267691
     /* 267691 */ GIM_Reject,
     /* 267692 */ // Label 5349: @267692
     /* 267692 */ GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(268333),
     /* 267697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 267700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267704 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(267781), // Rule ID 5658 //
     /* 267709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 267733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267750 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267754 */     // MIs[3] Operand 1
     /* 267754 */     // No operand predicates
     /* 267754 */     // MIs[0] Operand 2
     /* 267754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267767 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 267767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 267770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 267776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 267779 */     GIR_RootConstrainSelectedInstOperands,
     /* 267780 */     // GIR_Coverage, 5658,
     /* 267780 */     GIR_EraseRootFromParent_Done,
     /* 267781 */   // Label 5364: @267781
     /* 267781 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(267858), // Rule ID 5659 //
     /* 267786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267831 */     // MIs[3] Operand 1
     /* 267831 */     // No operand predicates
     /* 267831 */     // MIs[0] Operand 2
     /* 267831 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267844 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 267847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 267853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 267856 */     GIR_RootConstrainSelectedInstOperands,
     /* 267857 */     // GIR_Coverage, 5659,
     /* 267857 */     GIR_EraseRootFromParent_Done,
     /* 267858 */   // Label 5365: @267858
     /* 267858 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(267960), // Rule ID 11249 //
     /* 267863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 267890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267906 */     // MIs[3] Operand 1
     /* 267906 */     // No operand predicates
     /* 267906 */     // MIs[0] Operand 2
     /* 267906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267919 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 267919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 267922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267931 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 267950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 267958 */     GIR_RootConstrainSelectedInstOperands,
     /* 267959 */     // GIR_Coverage, 11249,
     /* 267959 */     GIR_EraseRootFromParent_Done,
     /* 267960 */   // Label 5366: @267960
     /* 267960 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(268062), // Rule ID 11251 //
     /* 267965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 267992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 268000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 268008 */     // MIs[3] Operand 1
     /* 268008 */     // No operand predicates
     /* 268008 */     // MIs[0] Operand 2
     /* 268008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268021 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 268021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 268024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268033 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 268039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 268052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 268060 */     GIR_RootConstrainSelectedInstOperands,
     /* 268061 */     // GIR_Coverage, 11251,
     /* 268061 */     GIR_EraseRootFromParent_Done,
     /* 268062 */   // Label 5367: @268062
     /* 268062 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(268127), // Rule ID 5653 //
     /* 268067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 268075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 268079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 268092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 268100 */     // MIs[2] Operand 1
     /* 268100 */     // No operand predicates
     /* 268100 */     // MIs[0] Operand 2
     /* 268100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268113 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 268113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 268116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 268122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 268125 */     GIR_RootConstrainSelectedInstOperands,
     /* 268126 */     // GIR_Coverage, 5653,
     /* 268126 */     GIR_EraseRootFromParent_Done,
     /* 268127 */   // Label 5368: @268127
     /* 268127 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(268192), // Rule ID 5655 //
     /* 268132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 268140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 268144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 268157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 268165 */     // MIs[2] Operand 1
     /* 268165 */     // No operand predicates
     /* 268165 */     // MIs[0] Operand 2
     /* 268165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268178 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 268178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 268181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 268187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 268190 */     GIR_RootConstrainSelectedInstOperands,
     /* 268191 */     // GIR_Coverage, 5655,
     /* 268191 */     GIR_EraseRootFromParent_Done,
     /* 268192 */   // Label 5369: @268192
     /* 268192 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(268227), // Rule ID 6508 //
     /* 268197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268201 */     // MIs[0] Operand 2
     /* 268201 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 268212 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 268212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 268225 */     GIR_RootConstrainSelectedInstOperands,
     /* 268226 */     // GIR_Coverage, 6508,
     /* 268226 */     GIR_EraseRootFromParent_Done,
     /* 268227 */   // Label 5370: @268227
     /* 268227 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(268262), // Rule ID 6509 //
     /* 268232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268236 */     // MIs[0] Operand 2
     /* 268236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268247 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 268247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 268260 */     GIR_RootConstrainSelectedInstOperands,
     /* 268261 */     // GIR_Coverage, 6509,
     /* 268261 */     GIR_EraseRootFromParent_Done,
     /* 268262 */   // Label 5371: @268262
     /* 268262 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(268297), // Rule ID 6510 //
     /* 268267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268271 */     // MIs[0] Operand 2
     /* 268271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268282 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 268282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 268295 */     GIR_RootConstrainSelectedInstOperands,
     /* 268296 */     // GIR_Coverage, 6510,
     /* 268296 */     GIR_EraseRootFromParent_Done,
     /* 268297 */   // Label 5372: @268297
     /* 268297 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(268332), // Rule ID 6511 //
     /* 268302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268306 */     // MIs[0] Operand 2
     /* 268306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 268317 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 268317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268330 */     GIR_RootConstrainSelectedInstOperands,
     /* 268331 */     // GIR_Coverage, 6511,
     /* 268331 */     GIR_EraseRootFromParent_Done,
     /* 268332 */   // Label 5373: @268332
     /* 268332 */   GIM_Reject,
     /* 268333 */ // Label 5363: @268333
     /* 268333 */ GIM_Reject,
     /* 268334 */ // Label 5350: @268334
     /* 268334 */ GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(268542),
     /* 268339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 268342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268346 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(268411), // Rule ID 10520 //
     /* 268351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268354 */     // MIs[0] Operand 2
     /* 268354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 268365 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268377 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 268399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268409 */     GIR_RootConstrainSelectedInstOperands,
     /* 268410 */     // GIR_Coverage, 10520,
     /* 268410 */     GIR_EraseRootFromParent_Done,
     /* 268411 */   // Label 5375: @268411
     /* 268411 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(268476), // Rule ID 10521 //
     /* 268416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268419 */     // MIs[0] Operand 2
     /* 268419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268430 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 268464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268474 */     GIR_RootConstrainSelectedInstOperands,
     /* 268475 */     // GIR_Coverage, 10521,
     /* 268475 */     GIR_EraseRootFromParent_Done,
     /* 268476 */   // Label 5376: @268476
     /* 268476 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(268541), // Rule ID 10522 //
     /* 268481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268484 */     // MIs[0] Operand 2
     /* 268484 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268495 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268507 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 268529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268539 */     GIR_RootConstrainSelectedInstOperands,
     /* 268540 */     // GIR_Coverage, 10522,
     /* 268540 */     GIR_EraseRootFromParent_Done,
     /* 268541 */   // Label 5377: @268541
     /* 268541 */   GIM_Reject,
     /* 268542 */ // Label 5374: @268542
     /* 268542 */ GIM_Reject,
     /* 268543 */ // Label 5351: @268543
     /* 268543 */ GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(268686),
     /* 268548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 268551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268555 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(268620), // Rule ID 10523 //
     /* 268560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268563 */     // MIs[0] Operand 2
     /* 268563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268574 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 268574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 268581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 268608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268618 */     GIR_RootConstrainSelectedInstOperands,
     /* 268619 */     // GIR_Coverage, 10523,
     /* 268619 */     GIR_EraseRootFromParent_Done,
     /* 268620 */   // Label 5379: @268620
     /* 268620 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(268685), // Rule ID 10524 //
     /* 268625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268628 */     // MIs[0] Operand 2
     /* 268628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268639 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 268639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 268646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268651 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 268673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268683 */     GIR_RootConstrainSelectedInstOperands,
     /* 268684 */     // GIR_Coverage, 10524,
     /* 268684 */     GIR_EraseRootFromParent_Done,
     /* 268685 */   // Label 5380: @268685
     /* 268685 */   GIM_Reject,
     /* 268686 */ // Label 5378: @268686
     /* 268686 */ GIM_Reject,
     /* 268687 */ // Label 5352: @268687
     /* 268687 */ GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(268759), // Rule ID 10525 //
     /* 268692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 268698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268702 */   // MIs[0] Operand 2
     /* 268702 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268713 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 268713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 268720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268725 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 268747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268757 */   GIR_RootConstrainSelectedInstOperands,
     /* 268758 */   // GIR_Coverage, 10525,
     /* 268758 */   GIR_EraseRootFromParent_Done,
     /* 268759 */ // Label 5381: @268759
     /* 268759 */ GIM_Reject,
     /* 268760 */ // Label 5353: @268760
     /* 268760 */ GIM_Reject,
     /* 268761 */ // Label 45: @268761
     /* 268761 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5386*/ GIMT_Encode4(271539),
     /* 268772 */ /*GILLT_s32*//*Label 5382*/ GIMT_Encode4(268808), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 268788 */ /*GILLT_v2s64*//*Label 5383*/ GIMT_Encode4(270609), GIMT_Encode4(0),
     /* 268796 */ /*GILLT_v4s32*//*Label 5384*/ GIMT_Encode4(270919), GIMT_Encode4(0),
     /* 268804 */ /*GILLT_v8s16*//*Label 5385*/ GIMT_Encode4(271229),
     /* 268808 */ // Label 5382: @268808
     /* 268808 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(268958), // Rule ID 13156 //
     /* 268813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268820 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268828 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268831 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 268836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268847 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268847 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268850 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 268854 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268859 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268865 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268868 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268872 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268891 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268894 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268897 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268900 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268905 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268910 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268927 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268957 */   // GIR_Coverage, 13156,
     /* 268957 */   GIR_EraseRootFromParent_Done,
     /* 268958 */ // Label 5387: @268958
     /* 268958 */ GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269108), // Rule ID 13158 //
     /* 268963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268970 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268978 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268981 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 268986 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268990 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268997 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268997 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 269000 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 269004 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269009 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269015 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269018 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269022 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269029 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269032 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269036 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269044 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269047 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269050 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269055 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269060 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269077 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269107 */   // GIR_Coverage, 13158,
     /* 269107 */   GIR_EraseRootFromParent_Done,
     /* 269108 */ // Label 5388: @269108
     /* 269108 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269258), // Rule ID 13160 //
     /* 269113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269120 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269128 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269131 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 269136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269140 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269147 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269147 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269150 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 269154 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269159 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269165 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269168 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269172 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269179 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269182 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269186 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269191 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269194 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269197 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269200 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269205 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269210 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269227 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269257 */   // GIR_Coverage, 13160,
     /* 269257 */   GIR_EraseRootFromParent_Done,
     /* 269258 */ // Label 5389: @269258
     /* 269258 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269408), // Rule ID 13162 //
     /* 269263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269270 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269278 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269281 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 269286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269290 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269297 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269297 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269300 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 269304 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269309 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269315 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269318 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269322 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269329 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269332 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269336 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269341 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269344 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269347 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269350 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269355 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269360 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269377 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269389 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269407 */   // GIR_Coverage, 13162,
     /* 269407 */   GIR_EraseRootFromParent_Done,
     /* 269408 */ // Label 5390: @269408
     /* 269408 */ GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269558), // Rule ID 13189 //
     /* 269413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 269416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269420 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269424 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269428 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269431 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269440 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269445 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269447 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269447 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 269450 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 269454 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269459 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269465 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269468 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269472 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269479 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269482 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269486 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269491 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269494 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269497 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269500 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269505 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269510 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269527 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269534 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269557 */   // GIR_Coverage, 13189,
     /* 269557 */   GIR_EraseRootFromParent_Done,
     /* 269558 */ // Label 5391: @269558
     /* 269558 */ GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(269708), // Rule ID 13191 //
     /* 269563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 269566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269570 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269578 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269581 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269586 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269590 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269597 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269597 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 269600 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 269604 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269609 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269615 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269618 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269622 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269629 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269632 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269636 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269641 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269644 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269647 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269650 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269655 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269660 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269677 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269702 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269707 */   // GIR_Coverage, 13191,
     /* 269707 */   GIR_EraseRootFromParent_Done,
     /* 269708 */ // Label 5392: @269708
     /* 269708 */ GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(269858), // Rule ID 13193 //
     /* 269713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269720 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269728 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269731 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269736 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269740 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269747 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269747 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269750 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 269754 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269759 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269765 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269768 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269772 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269779 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269782 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269786 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269791 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269794 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269797 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269800 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269805 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269810 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269827 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269834 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269839 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269857 */   // GIR_Coverage, 13193,
     /* 269857 */   GIR_EraseRootFromParent_Done,
     /* 269858 */ // Label 5393: @269858
     /* 269858 */ GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(270008), // Rule ID 13195 //
     /* 269863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269870 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269878 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269881 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269897 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269897 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269900 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 269904 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269909 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269915 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269918 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269922 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269929 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269932 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269936 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269941 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269944 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269947 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269950 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269955 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269960 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269977 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269989 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270007 */   // GIR_Coverage, 13195,
     /* 270007 */   GIR_EraseRootFromParent_Done,
     /* 270008 */ // Label 5394: @270008
     /* 270008 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270158), // Rule ID 13199 //
     /* 270013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 270016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270020 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270028 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270031 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270036 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 270040 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270045 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270047 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270047 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 270050 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 270054 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270059 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270065 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270068 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270072 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270079 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270082 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270086 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270091 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270094 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270097 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 270100 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270105 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270110 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 270115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270127 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270134 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270139 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270157 */   // GIR_Coverage, 13199,
     /* 270157 */   GIR_EraseRootFromParent_Done,
     /* 270158 */ // Label 5395: @270158
     /* 270158 */ GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270308), // Rule ID 13201 //
     /* 270163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 270166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270170 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270178 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270181 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270190 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270197 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270197 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 270200 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 270204 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270209 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270215 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270218 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270222 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270229 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270232 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270236 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270241 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270244 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270247 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 270250 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270255 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270260 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 270265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270277 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270307 */   // GIR_Coverage, 13201,
     /* 270307 */   GIR_EraseRootFromParent_Done,
     /* 270308 */ // Label 5396: @270308
     /* 270308 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270458), // Rule ID 13203 //
     /* 270313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 270316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270328 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270331 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270347 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270347 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 270350 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 270354 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270359 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270365 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270368 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270372 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270379 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270382 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270386 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270391 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270394 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270397 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 270400 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270405 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270410 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 270415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270427 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270457 */   // GIR_Coverage, 13203,
     /* 270457 */   GIR_EraseRootFromParent_Done,
     /* 270458 */ // Label 5397: @270458
     /* 270458 */ GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(270608), // Rule ID 13205 //
     /* 270463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 270466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270470 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270478 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270481 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270497 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270497 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 270500 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 270504 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270509 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270515 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270518 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270522 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270529 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270532 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270536 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270541 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270544 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270547 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 270550 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270555 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270560 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 270565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270577 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270607 */   // GIR_Coverage, 13205,
     /* 270607 */   GIR_EraseRootFromParent_Done,
     /* 270608 */ // Label 5398: @270608
     /* 270608 */ GIM_Reject,
     /* 270609 */ // Label 5383: @270609
     /* 270609 */ GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(270918),
     /* 270614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270621 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270686), // Rule ID 702 //
     /* 270626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270637 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270640 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270649 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270669 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 270669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 270672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270684 */     GIR_RootConstrainSelectedInstOperands,
     /* 270685 */     // GIR_Coverage, 702,
     /* 270685 */     GIR_EraseRootFromParent_Done,
     /* 270686 */   // Label 5400: @270686
     /* 270686 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(270751), // Rule ID 1711 //
     /* 270691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270702 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270705 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 270710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270734 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 270734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 270737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270749 */     GIR_RootConstrainSelectedInstOperands,
     /* 270750 */     // GIR_Coverage, 1711,
     /* 270750 */     GIR_EraseRootFromParent_Done,
     /* 270751 */   // Label 5401: @270751
     /* 270751 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270810), // Rule ID 700 //
     /* 270756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270767 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270770 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270779 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270795 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 270795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 270798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 270808 */     GIR_RootConstrainSelectedInstOperands,
     /* 270809 */     // GIR_Coverage, 700,
     /* 270809 */     GIR_EraseRootFromParent_Done,
     /* 270810 */   // Label 5402: @270810
     /* 270810 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270869), // Rule ID 1709 //
     /* 270815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270826 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270829 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 270834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270838 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270854 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 270854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 270857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 270867 */     GIR_RootConstrainSelectedInstOperands,
     /* 270868 */     // GIR_Coverage, 1709,
     /* 270868 */     GIR_EraseRootFromParent_Done,
     /* 270869 */   // Label 5403: @270869
     /* 270869 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270896), // Rule ID 6378 //
     /* 270874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270881 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 270881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 270884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270894 */     GIR_RootConstrainSelectedInstOperands,
     /* 270895 */     // GIR_Coverage, 6378,
     /* 270895 */     GIR_EraseRootFromParent_Done,
     /* 270896 */   // Label 5404: @270896
     /* 270896 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(270917), // Rule ID 6369 //
     /* 270901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270905 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 270905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 270908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270915 */     GIR_RootConstrainSelectedInstOperands,
     /* 270916 */     // GIR_Coverage, 6369,
     /* 270916 */     GIR_EraseRootFromParent_Done,
     /* 270917 */   // Label 5405: @270917
     /* 270917 */   GIM_Reject,
     /* 270918 */ // Label 5399: @270918
     /* 270918 */ GIM_Reject,
     /* 270919 */ // Label 5384: @270919
     /* 270919 */ GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(271228),
     /* 270924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270931 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(270996), // Rule ID 698 //
     /* 270936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270947 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270950 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 270963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 270972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 270979 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 270982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270994 */     GIR_RootConstrainSelectedInstOperands,
     /* 270995 */     // GIR_Coverage, 698,
     /* 270995 */     GIR_EraseRootFromParent_Done,
     /* 270996 */   // Label 5407: @270996
     /* 270996 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(271061), // Rule ID 1707 //
     /* 271001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271024 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271044 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 271044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 271047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271059 */     GIR_RootConstrainSelectedInstOperands,
     /* 271060 */     // GIR_Coverage, 1707,
     /* 271060 */     GIR_EraseRootFromParent_Done,
     /* 271061 */   // Label 5408: @271061
     /* 271061 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(271120), // Rule ID 696 //
     /* 271066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271077 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271080 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271089 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271105 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 271105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 271108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271118 */     GIR_RootConstrainSelectedInstOperands,
     /* 271119 */     // GIR_Coverage, 696,
     /* 271119 */     GIR_EraseRootFromParent_Done,
     /* 271120 */   // Label 5409: @271120
     /* 271120 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(271179), // Rule ID 1705 //
     /* 271125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271136 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271139 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271164 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 271164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 271167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271177 */     GIR_RootConstrainSelectedInstOperands,
     /* 271178 */     // GIR_Coverage, 1705,
     /* 271178 */     GIR_EraseRootFromParent_Done,
     /* 271179 */   // Label 5410: @271179
     /* 271179 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(271206), // Rule ID 6375 //
     /* 271184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271191 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 271191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 271194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271204 */     GIR_RootConstrainSelectedInstOperands,
     /* 271205 */     // GIR_Coverage, 6375,
     /* 271205 */     GIR_EraseRootFromParent_Done,
     /* 271206 */   // Label 5411: @271206
     /* 271206 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(271227), // Rule ID 6366 //
     /* 271211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271215 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 271215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 271218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271225 */     GIR_RootConstrainSelectedInstOperands,
     /* 271226 */     // GIR_Coverage, 6366,
     /* 271226 */     GIR_EraseRootFromParent_Done,
     /* 271227 */   // Label 5412: @271227
     /* 271227 */   GIM_Reject,
     /* 271228 */ // Label 5406: @271228
     /* 271228 */ GIM_Reject,
     /* 271229 */ // Label 5385: @271229
     /* 271229 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(271538),
     /* 271234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271241 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(271306), // Rule ID 694 //
     /* 271246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271257 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271260 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271269 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271289 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 271292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271304 */     GIR_RootConstrainSelectedInstOperands,
     /* 271305 */     // GIR_Coverage, 694,
     /* 271305 */     GIR_EraseRootFromParent_Done,
     /* 271306 */   // Label 5414: @271306
     /* 271306 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(271371), // Rule ID 1703 //
     /* 271311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271322 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271325 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271334 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271354 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 271357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271369 */     GIR_RootConstrainSelectedInstOperands,
     /* 271370 */     // GIR_Coverage, 1703,
     /* 271370 */     GIR_EraseRootFromParent_Done,
     /* 271371 */   // Label 5415: @271371
     /* 271371 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(271430), // Rule ID 692 //
     /* 271376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271387 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271390 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271415 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 271415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 271418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271428 */     GIR_RootConstrainSelectedInstOperands,
     /* 271429 */     // GIR_Coverage, 692,
     /* 271429 */     GIR_EraseRootFromParent_Done,
     /* 271430 */   // Label 5416: @271430
     /* 271430 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(271489), // Rule ID 1701 //
     /* 271435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271474 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 271474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 271477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271487 */     GIR_RootConstrainSelectedInstOperands,
     /* 271488 */     // GIR_Coverage, 1701,
     /* 271488 */     GIR_EraseRootFromParent_Done,
     /* 271489 */   // Label 5417: @271489
     /* 271489 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(271516), // Rule ID 6372 //
     /* 271494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271501 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 271501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 271504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271514 */     GIR_RootConstrainSelectedInstOperands,
     /* 271515 */     // GIR_Coverage, 6372,
     /* 271515 */     GIR_EraseRootFromParent_Done,
     /* 271516 */   // Label 5418: @271516
     /* 271516 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(271537), // Rule ID 6363 //
     /* 271521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271525 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 271525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 271528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271535 */     GIR_RootConstrainSelectedInstOperands,
     /* 271536 */     // GIR_Coverage, 6363,
     /* 271536 */     GIR_EraseRootFromParent_Done,
     /* 271537 */   // Label 5419: @271537
     /* 271537 */   GIM_Reject,
     /* 271538 */ // Label 5413: @271538
     /* 271538 */ GIM_Reject,
     /* 271539 */ // Label 5386: @271539
     /* 271539 */ GIM_Reject,
     /* 271540 */ // Label 46: @271540
     /* 271540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5425*/ GIMT_Encode4(272364),
     /* 271551 */ /*GILLT_s32*//*Label 5420*/ GIMT_Encode4(271587),
     /* 271555 */ /*GILLT_s64*//*Label 5421*/ GIMT_Encode4(271764), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271567 */ /*GILLT_v2s64*//*Label 5422*/ GIMT_Encode4(271937), GIMT_Encode4(0),
     /* 271575 */ /*GILLT_v4s32*//*Label 5423*/ GIMT_Encode4(272082), GIMT_Encode4(0),
     /* 271583 */ /*GILLT_v8s16*//*Label 5424*/ GIMT_Encode4(272223),
     /* 271587 */ // Label 5420: @271587
     /* 271587 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(271763),
     /* 271592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271606 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271643), // Rule ID 3935 //
     /* 271611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271630 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271641 */     GIR_RootConstrainSelectedInstOperands,
     /* 271642 */     // GIR_Coverage, 3935,
     /* 271642 */     GIR_EraseRootFromParent_Done,
     /* 271643 */   // Label 5427: @271643
     /* 271643 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271680), // Rule ID 3936 //
     /* 271648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271667 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271678 */     GIR_RootConstrainSelectedInstOperands,
     /* 271679 */     // GIR_Coverage, 3936,
     /* 271679 */     GIR_EraseRootFromParent_Done,
     /* 271680 */   // Label 5428: @271680
     /* 271680 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271717), // Rule ID 3934 //
     /* 271685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271704 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271715 */     GIR_RootConstrainSelectedInstOperands,
     /* 271716 */     // GIR_Coverage, 3934,
     /* 271716 */     GIR_EraseRootFromParent_Done,
     /* 271717 */   // Label 5429: @271717
     /* 271717 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271762), // Rule ID 3933 //
     /* 271722 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 271722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 271740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271760 */     GIR_RootConstrainSelectedInstOperands,
     /* 271761 */     // GIR_Coverage, 3933,
     /* 271761 */     GIR_EraseRootFromParent_Done,
     /* 271762 */   // Label 5430: @271762
     /* 271762 */   GIM_Reject,
     /* 271763 */ // Label 5426: @271763
     /* 271763 */ GIM_Reject,
     /* 271764 */ // Label 5421: @271764
     /* 271764 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271936),
     /* 271769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271783 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271851), // Rule ID 3937 //
     /* 271788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271807 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271826 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271849 */     GIR_RootConstrainSelectedInstOperands,
     /* 271850 */     // GIR_Coverage, 3937,
     /* 271850 */     GIR_EraseRootFromParent_Done,
     /* 271851 */   // Label 5432: @271851
     /* 271851 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271919), // Rule ID 3938 //
     /* 271856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271875 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271917 */     GIR_RootConstrainSelectedInstOperands,
     /* 271918 */     // GIR_Coverage, 3938,
     /* 271918 */     GIR_EraseRootFromParent_Done,
     /* 271919 */   // Label 5433: @271919
     /* 271919 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271935), // Rule ID 120 //
     /* 271924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271928 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271933 */     GIR_RootConstrainSelectedInstOperands,
     /* 271934 */     // GIR_Coverage, 120,
     /* 271934 */     GIR_Done,
     /* 271935 */   // Label 5434: @271935
     /* 271935 */   GIM_Reject,
     /* 271936 */ // Label 5431: @271936
     /* 271936 */ GIM_Reject,
     /* 271937 */ // Label 5422: @271937
     /* 271937 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(272081),
     /* 271942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271952 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(272016), // Rule ID 6361 //
     /* 271957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 271982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 271986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 271990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271998 */     // MIs[3] Operand 1
     /* 271998 */     // No operand predicates
     /* 271998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272000 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 272000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 272003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272009 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 272014 */     GIR_RootConstrainSelectedInstOperands,
     /* 272015 */     // GIR_Coverage, 6361,
     /* 272015 */     GIR_EraseRootFromParent_Done,
     /* 272016 */   // Label 5436: @272016
     /* 272016 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(272080), // Rule ID 6358 //
     /* 272021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 272050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272062 */     // MIs[3] Operand 1
     /* 272062 */     // No operand predicates
     /* 272062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272064 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 272064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 272067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272073 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 272078 */     GIR_RootConstrainSelectedInstOperands,
     /* 272079 */     // GIR_Coverage, 6358,
     /* 272079 */     GIR_EraseRootFromParent_Done,
     /* 272080 */   // Label 5437: @272080
     /* 272080 */   GIM_Reject,
     /* 272081 */ // Label 5435: @272081
     /* 272081 */ GIM_Reject,
     /* 272082 */ // Label 5423: @272082
     /* 272082 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(272222),
     /* 272087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272097 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(272159), // Rule ID 6360 //
     /* 272102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272139 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 272143 */     // MIs[3] Operand 1
     /* 272143 */     // No operand predicates
     /* 272143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272145 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 272145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 272148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272157 */     GIR_RootConstrainSelectedInstOperands,
     /* 272158 */     // GIR_Coverage, 6360,
     /* 272158 */     GIR_EraseRootFromParent_Done,
     /* 272159 */   // Label 5439: @272159
     /* 272159 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(272221), // Rule ID 6357 //
     /* 272164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 272205 */     // MIs[3] Operand 1
     /* 272205 */     // No operand predicates
     /* 272205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272207 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 272207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 272210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272219 */     GIR_RootConstrainSelectedInstOperands,
     /* 272220 */     // GIR_Coverage, 6357,
     /* 272220 */     GIR_EraseRootFromParent_Done,
     /* 272221 */   // Label 5440: @272221
     /* 272221 */   GIM_Reject,
     /* 272222 */ // Label 5438: @272222
     /* 272222 */ GIM_Reject,
     /* 272223 */ // Label 5424: @272223
     /* 272223 */ GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(272363),
     /* 272228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272238 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(272300), // Rule ID 6359 //
     /* 272243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272280 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 272284 */     // MIs[3] Operand 1
     /* 272284 */     // No operand predicates
     /* 272284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272286 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 272286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 272289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272298 */     GIR_RootConstrainSelectedInstOperands,
     /* 272299 */     // GIR_Coverage, 6359,
     /* 272299 */     GIR_EraseRootFromParent_Done,
     /* 272300 */   // Label 5442: @272300
     /* 272300 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(272362), // Rule ID 6356 //
     /* 272305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272342 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 272346 */     // MIs[3] Operand 1
     /* 272346 */     // No operand predicates
     /* 272346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272348 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 272348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 272351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272360 */     GIR_RootConstrainSelectedInstOperands,
     /* 272361 */     // GIR_Coverage, 6356,
     /* 272361 */     GIR_EraseRootFromParent_Done,
     /* 272362 */   // Label 5443: @272362
     /* 272362 */   GIM_Reject,
     /* 272363 */ // Label 5441: @272363
     /* 272363 */ GIM_Reject,
     /* 272364 */ // Label 5425: @272364
     /* 272364 */ GIM_Reject,
     /* 272365 */ // Label 47: @272365
     /* 272365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5446*/ GIMT_Encode4(272802),
     /* 272376 */ /*GILLT_s32*//*Label 5444*/ GIMT_Encode4(272384),
     /* 272380 */ /*GILLT_s64*//*Label 5445*/ GIMT_Encode4(272595),
     /* 272384 */ // Label 5444: @272384
     /* 272384 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272594),
     /* 272389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272403 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(272437), // Rule ID 4024 //
     /* 272408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272420 */     // MIs[1] Operand 1
     /* 272420 */     // No operand predicates
     /* 272420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272422 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 272422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 272425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 272435 */     GIR_RootConstrainSelectedInstOperands,
     /* 272436 */     // GIR_Coverage, 4024,
     /* 272436 */     GIR_EraseRootFromParent_Done,
     /* 272437 */   // Label 5448: @272437
     /* 272437 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272474), // Rule ID 3941 //
     /* 272442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 272450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272461 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272472 */     GIR_RootConstrainSelectedInstOperands,
     /* 272473 */     // GIR_Coverage, 3941,
     /* 272473 */     GIR_EraseRootFromParent_Done,
     /* 272474 */   // Label 5449: @272474
     /* 272474 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272511), // Rule ID 3942 //
     /* 272479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272498 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272509 */     GIR_RootConstrainSelectedInstOperands,
     /* 272510 */     // GIR_Coverage, 3942,
     /* 272510 */     GIR_EraseRootFromParent_Done,
     /* 272511 */   // Label 5450: @272511
     /* 272511 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272548), // Rule ID 3940 //
     /* 272516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272535 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272546 */     GIR_RootConstrainSelectedInstOperands,
     /* 272547 */     // GIR_Coverage, 3940,
     /* 272547 */     GIR_EraseRootFromParent_Done,
     /* 272548 */   // Label 5451: @272548
     /* 272548 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(272593), // Rule ID 3939 //
     /* 272553 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 272553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 272571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272591 */     GIR_RootConstrainSelectedInstOperands,
     /* 272592 */     // GIR_Coverage, 3939,
     /* 272592 */     GIR_EraseRootFromParent_Done,
     /* 272593 */   // Label 5452: @272593
     /* 272593 */   GIM_Reject,
     /* 272594 */ // Label 5447: @272594
     /* 272594 */ GIM_Reject,
     /* 272595 */ // Label 5445: @272595
     /* 272595 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(272801),
     /* 272600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272614 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(272648), // Rule ID 4025 //
     /* 272619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 272631 */     // MIs[1] Operand 1
     /* 272631 */     // No operand predicates
     /* 272631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272633 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 272633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 272636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 272646 */     GIR_RootConstrainSelectedInstOperands,
     /* 272647 */     // GIR_Coverage, 4025,
     /* 272647 */     GIR_EraseRootFromParent_Done,
     /* 272648 */   // Label 5454: @272648
     /* 272648 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272716), // Rule ID 3943 //
     /* 272653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272672 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272714 */     GIR_RootConstrainSelectedInstOperands,
     /* 272715 */     // GIR_Coverage, 3943,
     /* 272715 */     GIR_EraseRootFromParent_Done,
     /* 272716 */   // Label 5455: @272716
     /* 272716 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(272784), // Rule ID 3944 //
     /* 272721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272740 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272782 */     GIR_RootConstrainSelectedInstOperands,
     /* 272783 */     // GIR_Coverage, 3944,
     /* 272783 */     GIR_EraseRootFromParent_Done,
     /* 272784 */   // Label 5456: @272784
     /* 272784 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(272800), // Rule ID 121 //
     /* 272789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272793 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272798 */     GIR_RootConstrainSelectedInstOperands,
     /* 272799 */     // GIR_Coverage, 121,
     /* 272799 */     GIR_Done,
     /* 272800 */   // Label 5457: @272800
     /* 272800 */   GIM_Reject,
     /* 272801 */ // Label 5453: @272801
     /* 272801 */ GIM_Reject,
     /* 272802 */ // Label 5446: @272802
     /* 272802 */ GIM_Reject,
     /* 272803 */ // Label 48: @272803
     /* 272803 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5460*/ GIMT_Encode4(273627),
     /* 272814 */ /*GILLT_s32*//*Label 5458*/ GIMT_Encode4(272822),
     /* 272818 */ /*GILLT_s64*//*Label 5459*/ GIMT_Encode4(273177),
     /* 272822 */ // Label 5458: @272822
     /* 272822 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(273176),
     /* 272827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272837 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272901), // Rule ID 6521 //
     /* 272842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 272850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272859 */     // MIs[1] Operand 2
     /* 272859 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 272870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 272882 */     // MIs[2] Operand 1
     /* 272882 */     // No operand predicates
     /* 272882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272884 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 272884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 272896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 272899 */     GIR_RootConstrainSelectedInstOperands,
     /* 272900 */     // GIR_Coverage, 6521,
     /* 272900 */     GIR_EraseRootFromParent_Done,
     /* 272901 */   // Label 5462: @272901
     /* 272901 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(272965), // Rule ID 6523 //
     /* 272906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 272914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272923 */     // MIs[1] Operand 2
     /* 272923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 272934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 272946 */     // MIs[2] Operand 1
     /* 272946 */     // No operand predicates
     /* 272946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272948 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 272948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 272960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 272963 */     GIR_RootConstrainSelectedInstOperands,
     /* 272964 */     // GIR_Coverage, 6523,
     /* 272964 */     GIR_EraseRootFromParent_Done,
     /* 272965 */   // Label 5463: @272965
     /* 272965 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(273003), // Rule ID 4022 //
     /* 272970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272986 */     // MIs[1] Operand 1
     /* 272986 */     // No operand predicates
     /* 272986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272988 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 272988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 273001 */     GIR_RootConstrainSelectedInstOperands,
     /* 273002 */     // GIR_Coverage, 4022,
     /* 273002 */     GIR_EraseRootFromParent_Done,
     /* 273003 */   // Label 5464: @273003
     /* 273003 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(273044), // Rule ID 2435 //
     /* 273008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 273020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273031 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273042 */     GIR_RootConstrainSelectedInstOperands,
     /* 273043 */     // GIR_Coverage, 2435,
     /* 273043 */     GIR_EraseRootFromParent_Done,
     /* 273044 */   // Label 5465: @273044
     /* 273044 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(273085), // Rule ID 2436 //
     /* 273049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273072 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273083 */     GIR_RootConstrainSelectedInstOperands,
     /* 273084 */     // GIR_Coverage, 2436,
     /* 273084 */     GIR_EraseRootFromParent_Done,
     /* 273085 */   // Label 5466: @273085
     /* 273085 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(273126), // Rule ID 2434 //
     /* 273090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273113 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273124 */     GIR_RootConstrainSelectedInstOperands,
     /* 273125 */     // GIR_Coverage, 2434,
     /* 273125 */     GIR_EraseRootFromParent_Done,
     /* 273126 */   // Label 5467: @273126
     /* 273126 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(273175), // Rule ID 2433 //
     /* 273131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273135 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 273135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 273138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 273153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273173 */     GIR_RootConstrainSelectedInstOperands,
     /* 273174 */     // GIR_Coverage, 2433,
     /* 273174 */     GIR_EraseRootFromParent_Done,
     /* 273175 */   // Label 5468: @273175
     /* 273175 */   GIM_Reject,
     /* 273176 */ // Label 5461: @273176
     /* 273176 */ GIM_Reject,
     /* 273177 */ // Label 5459: @273177
     /* 273177 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(273626),
     /* 273182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273192 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(273256), // Rule ID 6522 //
     /* 273197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 273205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 273209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273214 */     // MIs[1] Operand 2
     /* 273214 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 273225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 273237 */     // MIs[2] Operand 1
     /* 273237 */     // No operand predicates
     /* 273237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273239 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 273239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 273254 */     GIR_RootConstrainSelectedInstOperands,
     /* 273255 */     // GIR_Coverage, 6522,
     /* 273255 */     GIR_EraseRootFromParent_Done,
     /* 273256 */   // Label 5470: @273256
     /* 273256 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(273320), // Rule ID 6524 //
     /* 273261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 273269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 273273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273278 */     // MIs[1] Operand 2
     /* 273278 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 273289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 273301 */     // MIs[2] Operand 1
     /* 273301 */     // No operand predicates
     /* 273301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273303 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 273303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 273318 */     GIR_RootConstrainSelectedInstOperands,
     /* 273319 */     // GIR_Coverage, 6524,
     /* 273319 */     GIR_EraseRootFromParent_Done,
     /* 273320 */   // Label 5471: @273320
     /* 273320 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(273423), // Rule ID 6525 //
     /* 273325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273350 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273354 */     // MIs[2] Operand 1
     /* 273354 */     // No operand predicates
     /* 273354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273356 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 273356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 273359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 273363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 273370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 273377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 273421 */     GIR_RootConstrainSelectedInstOperands,
     /* 273422 */     // GIR_Coverage, 6525,
     /* 273422 */     GIR_EraseRootFromParent_Done,
     /* 273423 */   // Label 5472: @273423
     /* 273423 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(273461), // Rule ID 4023 //
     /* 273428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 273444 */     // MIs[1] Operand 1
     /* 273444 */     // No operand predicates
     /* 273444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273446 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 273446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 273459 */     GIR_RootConstrainSelectedInstOperands,
     /* 273460 */     // GIR_Coverage, 4023,
     /* 273460 */     GIR_EraseRootFromParent_Done,
     /* 273461 */   // Label 5473: @273461
     /* 273461 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(273533), // Rule ID 2437 //
     /* 273466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273489 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 273489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 273496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 273504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273531 */     GIR_RootConstrainSelectedInstOperands,
     /* 273532 */     // GIR_Coverage, 2437,
     /* 273532 */     GIR_EraseRootFromParent_Done,
     /* 273533 */   // Label 5474: @273533
     /* 273533 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(273605), // Rule ID 2438 //
     /* 273538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273561 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 273561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 273568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 273576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273603 */     GIR_RootConstrainSelectedInstOperands,
     /* 273604 */     // GIR_Coverage, 2438,
     /* 273604 */     GIR_EraseRootFromParent_Done,
     /* 273605 */   // Label 5475: @273605
     /* 273605 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(273625), // Rule ID 119 //
     /* 273610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273618 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 273618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273623 */     GIR_RootConstrainSelectedInstOperands,
     /* 273624 */     // GIR_Coverage, 119,
     /* 273624 */     GIR_Done,
     /* 273625 */   // Label 5476: @273625
     /* 273625 */   GIM_Reject,
     /* 273626 */ // Label 5469: @273626
     /* 273626 */ GIM_Reject,
     /* 273627 */ // Label 5460: @273627
     /* 273627 */ GIM_Reject,
     /* 273628 */ // Label 49: @273628
     /* 273628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5479*/ GIMT_Encode4(273757),
     /* 273639 */ /*GILLT_s32*//*Label 5477*/ GIMT_Encode4(273647),
     /* 273643 */ /*GILLT_s64*//*Label 5478*/ GIMT_Encode4(273702),
     /* 273647 */ // Label 5477: @273647
     /* 273647 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(273701), // Rule ID 188 //
     /* 273652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 273655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 273658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273681 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273685 */   // MIs[1] Operand 1
     /* 273685 */   // No operand predicates
     /* 273685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273687 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 273687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 273690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273692 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273694 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 273696 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273699 */   GIR_RootConstrainSelectedInstOperands,
     /* 273700 */   // GIR_Coverage, 188,
     /* 273700 */   GIR_EraseRootFromParent_Done,
     /* 273701 */ // Label 5480: @273701
     /* 273701 */ GIM_Reject,
     /* 273702 */ // Label 5478: @273702
     /* 273702 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(273756), // Rule ID 189 //
     /* 273707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273736 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 273740 */   // MIs[1] Operand 1
     /* 273740 */   // No operand predicates
     /* 273740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273742 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 273742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 273745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273747 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273749 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 273751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273754 */   GIR_RootConstrainSelectedInstOperands,
     /* 273755 */   // GIR_Coverage, 189,
     /* 273755 */   GIR_EraseRootFromParent_Done,
     /* 273756 */ // Label 5481: @273756
     /* 273756 */ GIM_Reject,
     /* 273757 */ // Label 5479: @273757
     /* 273757 */ GIM_Reject,
     /* 273758 */ // Label 50: @273758
     /* 273758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5484*/ GIMT_Encode4(274299),
     /* 273769 */ /*GILLT_s32*//*Label 5482*/ GIMT_Encode4(273777),
     /* 273773 */ /*GILLT_s64*//*Label 5483*/ GIMT_Encode4(274042),
     /* 273777 */ // Label 5482: @273777
     /* 273777 */ GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(274041),
     /* 273782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 273785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273792 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273831), // Rule ID 184 //
     /* 273797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 273805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 273818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273820 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 273820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 273823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273829 */     GIR_RootConstrainSelectedInstOperands,
     /* 273830 */     // GIR_Coverage, 184,
     /* 273830 */     GIR_EraseRootFromParent_Done,
     /* 273831 */   // Label 5486: @273831
     /* 273831 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273868), // Rule ID 4018 //
     /* 273836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273852 */     // MIs[1] Operand 1
     /* 273852 */     // No operand predicates
     /* 273852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273854 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 273857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273866 */     GIR_RootConstrainSelectedInstOperands,
     /* 273867 */     // GIR_Coverage, 4018,
     /* 273867 */     GIR_EraseRootFromParent_Done,
     /* 273868 */   // Label 5487: @273868
     /* 273868 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273909), // Rule ID 3947 //
     /* 273873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 273885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273896 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273907 */     GIR_RootConstrainSelectedInstOperands,
     /* 273908 */     // GIR_Coverage, 3947,
     /* 273908 */     GIR_EraseRootFromParent_Done,
     /* 273909 */   // Label 5488: @273909
     /* 273909 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273950), // Rule ID 3948 //
     /* 273914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273937 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273948 */     GIR_RootConstrainSelectedInstOperands,
     /* 273949 */     // GIR_Coverage, 3948,
     /* 273949 */     GIR_EraseRootFromParent_Done,
     /* 273950 */   // Label 5489: @273950
     /* 273950 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273991), // Rule ID 3946 //
     /* 273955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273978 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273989 */     GIR_RootConstrainSelectedInstOperands,
     /* 273990 */     // GIR_Coverage, 3946,
     /* 273990 */     GIR_EraseRootFromParent_Done,
     /* 273991 */   // Label 5490: @273991
     /* 273991 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(274040), // Rule ID 3945 //
     /* 273996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274000 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 274000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 274003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274012 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 274018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 274031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274038 */     GIR_RootConstrainSelectedInstOperands,
     /* 274039 */     // GIR_Coverage, 3945,
     /* 274039 */     GIR_EraseRootFromParent_Done,
     /* 274040 */   // Label 5491: @274040
     /* 274040 */   GIM_Reject,
     /* 274041 */ // Label 5485: @274041
     /* 274041 */ GIM_Reject,
     /* 274042 */ // Label 5483: @274042
     /* 274042 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(274298),
     /* 274047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 274050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274057 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(274096), // Rule ID 187 //
     /* 274062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 274070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 274074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 274083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274085 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 274085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 274088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 274094 */     GIR_RootConstrainSelectedInstOperands,
     /* 274095 */     // GIR_Coverage, 187,
     /* 274095 */     GIR_EraseRootFromParent_Done,
     /* 274096 */   // Label 5493: @274096
     /* 274096 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(274133), // Rule ID 4019 //
     /* 274101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 274113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 274117 */     // MIs[1] Operand 1
     /* 274117 */     // No operand predicates
     /* 274117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274119 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 274119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 274122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 274131 */     GIR_RootConstrainSelectedInstOperands,
     /* 274132 */     // GIR_Coverage, 4019,
     /* 274132 */     GIR_EraseRootFromParent_Done,
     /* 274133 */   // Label 5494: @274133
     /* 274133 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(274205), // Rule ID 3949 //
     /* 274138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 274150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 274154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274161 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 274161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 274164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 274168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274173 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 274176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 274180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 274183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 274188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274203 */     GIR_RootConstrainSelectedInstOperands,
     /* 274204 */     // GIR_Coverage, 3949,
     /* 274204 */     GIR_EraseRootFromParent_Done,
     /* 274205 */   // Label 5495: @274205
     /* 274205 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(274277), // Rule ID 3950 //
     /* 274210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 274222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 274226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274233 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 274233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 274236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 274240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 274248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 274252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 274255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 274260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274275 */     GIR_RootConstrainSelectedInstOperands,
     /* 274276 */     // GIR_Coverage, 3950,
     /* 274276 */     GIR_EraseRootFromParent_Done,
     /* 274277 */   // Label 5496: @274277
     /* 274277 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(274297), // Rule ID 122 //
     /* 274282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274290 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 274290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274295 */     GIR_RootConstrainSelectedInstOperands,
     /* 274296 */     // GIR_Coverage, 122,
     /* 274296 */     GIR_Done,
     /* 274297 */   // Label 5497: @274297
     /* 274297 */   GIM_Reject,
     /* 274298 */ // Label 5492: @274298
     /* 274298 */ GIM_Reject,
     /* 274299 */ // Label 5484: @274299
     /* 274299 */ GIM_Reject,
     /* 274300 */ // Label 51: @274300
     /* 274300 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5506*/ GIMT_Encode4(282076),
     /* 274311 */ /*GILLT_s64*//*Label 5498*/ GIMT_Encode4(274347), GIMT_Encode4(0),
     /* 274319 */ /*GILLT_v2s32*//*Label 5499*/ GIMT_Encode4(274740),
     /* 274323 */ /*GILLT_v2s64*//*Label 5500*/ GIMT_Encode4(275788),
     /* 274327 */ /*GILLT_v4s16*//*Label 5501*/ GIMT_Encode4(276836),
     /* 274331 */ /*GILLT_v4s32*//*Label 5502*/ GIMT_Encode4(277884),
     /* 274335 */ /*GILLT_v8s8*//*Label 5503*/ GIMT_Encode4(278932),
     /* 274339 */ /*GILLT_v8s16*//*Label 5504*/ GIMT_Encode4(279980),
     /* 274343 */ /*GILLT_v16s8*//*Label 5505*/ GIMT_Encode4(281028),
     /* 274347 */ // Label 5498: @274347
     /* 274347 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(274739),
     /* 274352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 274358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274362 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(274398), // Rule ID 5242 //
     /* 274367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274370 */     // MIs[0] Operand 1
     /* 274370 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274389 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 274392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274396 */     GIR_RootConstrainSelectedInstOperands,
     /* 274397 */     // GIR_Coverage, 5242,
     /* 274397 */     GIR_EraseRootFromParent_Done,
     /* 274398 */   // Label 5508: @274398
     /* 274398 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(274434), // Rule ID 5243 //
     /* 274403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274406 */     // MIs[0] Operand 1
     /* 274406 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274421 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274425 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 274428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274432 */     GIR_RootConstrainSelectedInstOperands,
     /* 274433 */     // GIR_Coverage, 5243,
     /* 274433 */     GIR_EraseRootFromParent_Done,
     /* 274434 */   // Label 5509: @274434
     /* 274434 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(274470), // Rule ID 2512 //
     /* 274439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274442 */     // MIs[0] Operand 1
     /* 274442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274461 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 274464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274468 */     GIR_RootConstrainSelectedInstOperands,
     /* 274469 */     // GIR_Coverage, 2512,
     /* 274469 */     GIR_EraseRootFromParent_Done,
     /* 274470 */   // Label 5510: @274470
     /* 274470 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(274506), // Rule ID 5239 //
     /* 274475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274478 */     // MIs[0] Operand 1
     /* 274478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274487 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274493 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274497 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 274500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274504 */     GIR_RootConstrainSelectedInstOperands,
     /* 274505 */     // GIR_Coverage, 5239,
     /* 274505 */     GIR_EraseRootFromParent_Done,
     /* 274506 */   // Label 5511: @274506
     /* 274506 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(274542), // Rule ID 5240 //
     /* 274511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274514 */     // MIs[0] Operand 1
     /* 274514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274529 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274533 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 274536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274540 */     GIR_RootConstrainSelectedInstOperands,
     /* 274541 */     // GIR_Coverage, 5240,
     /* 274541 */     GIR_EraseRootFromParent_Done,
     /* 274542 */   // Label 5512: @274542
     /* 274542 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(274578), // Rule ID 5241 //
     /* 274547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274550 */     // MIs[0] Operand 1
     /* 274550 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274569 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 274572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274576 */     GIR_RootConstrainSelectedInstOperands,
     /* 274577 */     // GIR_Coverage, 5241,
     /* 274577 */     GIR_EraseRootFromParent_Done,
     /* 274578 */   // Label 5513: @274578
     /* 274578 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(274610), // Rule ID 1608 //
     /* 274583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274586 */     // MIs[0] Operand 1
     /* 274586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274599 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 274602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274608 */     GIR_RootConstrainSelectedInstOperands,
     /* 274609 */     // GIR_Coverage, 1608,
     /* 274609 */     GIR_EraseRootFromParent_Done,
     /* 274610 */   // Label 5514: @274610
     /* 274610 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274642), // Rule ID 1609 //
     /* 274615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274618 */     // MIs[0] Operand 1
     /* 274618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274631 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 274634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274640 */     GIR_RootConstrainSelectedInstOperands,
     /* 274641 */     // GIR_Coverage, 1609,
     /* 274641 */     GIR_EraseRootFromParent_Done,
     /* 274642 */   // Label 5515: @274642
     /* 274642 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274674), // Rule ID 1610 //
     /* 274647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274650 */     // MIs[0] Operand 1
     /* 274650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274663 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 274666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274672 */     GIR_RootConstrainSelectedInstOperands,
     /* 274673 */     // GIR_Coverage, 1610,
     /* 274673 */     GIR_EraseRootFromParent_Done,
     /* 274674 */   // Label 5516: @274674
     /* 274674 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274706), // Rule ID 1611 //
     /* 274679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274682 */     // MIs[0] Operand 1
     /* 274682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274695 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 274698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274704 */     GIR_RootConstrainSelectedInstOperands,
     /* 274705 */     // GIR_Coverage, 1611,
     /* 274705 */     GIR_EraseRootFromParent_Done,
     /* 274706 */   // Label 5517: @274706
     /* 274706 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274738), // Rule ID 1612 //
     /* 274711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274714 */     // MIs[0] Operand 1
     /* 274714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274727 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 274730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274736 */     GIR_RootConstrainSelectedInstOperands,
     /* 274737 */     // GIR_Coverage, 1612,
     /* 274737 */     GIR_EraseRootFromParent_Done,
     /* 274738 */   // Label 5518: @274738
     /* 274738 */   GIM_Reject,
     /* 274739 */ // Label 5507: @274739
     /* 274739 */ GIM_Reject,
     /* 274740 */ // Label 5499: @274740
     /* 274740 */ GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(275787),
     /* 274745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 274751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274755 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274795), // Rule ID 754 //
     /* 274760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274763 */     // MIs[0] Operand 1
     /* 274763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274772 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274778 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274786 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 274789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274793 */     GIR_RootConstrainSelectedInstOperands,
     /* 274794 */     // GIR_Coverage, 754,
     /* 274794 */     GIR_EraseRootFromParent_Done,
     /* 274795 */   // Label 5520: @274795
     /* 274795 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274835), // Rule ID 761 //
     /* 274800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274803 */     // MIs[0] Operand 1
     /* 274803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274812 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274818 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274826 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 274829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274833 */     GIR_RootConstrainSelectedInstOperands,
     /* 274834 */     // GIR_Coverage, 761,
     /* 274834 */     GIR_EraseRootFromParent_Done,
     /* 274835 */   // Label 5521: @274835
     /* 274835 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274872), // Rule ID 5176 //
     /* 274840 */     // MIs[0] Operand 1
     /* 274840 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274849 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274855 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274863 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 274866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274870 */     GIR_RootConstrainSelectedInstOperands,
     /* 274871 */     // GIR_Coverage, 5176,
     /* 274871 */     GIR_EraseRootFromParent_Done,
     /* 274872 */   // Label 5522: @274872
     /* 274872 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274909), // Rule ID 5183 //
     /* 274877 */     // MIs[0] Operand 1
     /* 274877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274886 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274892 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274900 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 274903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274907 */     GIR_RootConstrainSelectedInstOperands,
     /* 274908 */     // GIR_Coverage, 5183,
     /* 274908 */     GIR_EraseRootFromParent_Done,
     /* 274909 */   // Label 5523: @274909
     /* 274909 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274946), // Rule ID 5190 //
     /* 274914 */     // MIs[0] Operand 1
     /* 274914 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274937 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 274940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274944 */     GIR_RootConstrainSelectedInstOperands,
     /* 274945 */     // GIR_Coverage, 5190,
     /* 274945 */     GIR_EraseRootFromParent_Done,
     /* 274946 */   // Label 5524: @274946
     /* 274946 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274983), // Rule ID 5197 //
     /* 274951 */     // MIs[0] Operand 1
     /* 274951 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274966 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274974 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 274977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274981 */     GIR_RootConstrainSelectedInstOperands,
     /* 274982 */     // GIR_Coverage, 5197,
     /* 274982 */     GIR_EraseRootFromParent_Done,
     /* 274983 */   // Label 5525: @274983
     /* 274983 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(275020), // Rule ID 5204 //
     /* 274988 */     // MIs[0] Operand 1
     /* 274988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275011 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275018 */     GIR_RootConstrainSelectedInstOperands,
     /* 275019 */     // GIR_Coverage, 5204,
     /* 275019 */     GIR_EraseRootFromParent_Done,
     /* 275020 */   // Label 5526: @275020
     /* 275020 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(275060), // Rule ID 726 //
     /* 275025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275028 */     // MIs[0] Operand 1
     /* 275028 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275041 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275047 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275051 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 275054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275058 */     GIR_RootConstrainSelectedInstOperands,
     /* 275059 */     // GIR_Coverage, 726,
     /* 275059 */     GIR_EraseRootFromParent_Done,
     /* 275060 */   // Label 5527: @275060
     /* 275060 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(275100), // Rule ID 737 //
     /* 275065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275068 */     // MIs[0] Operand 1
     /* 275068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275091 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275098 */     GIR_RootConstrainSelectedInstOperands,
     /* 275099 */     // GIR_Coverage, 737,
     /* 275099 */     GIR_EraseRootFromParent_Done,
     /* 275100 */   // Label 5528: @275100
     /* 275100 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(275140), // Rule ID 738 //
     /* 275105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275108 */     // MIs[0] Operand 1
     /* 275108 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275131 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275138 */     GIR_RootConstrainSelectedInstOperands,
     /* 275139 */     // GIR_Coverage, 738,
     /* 275139 */     GIR_EraseRootFromParent_Done,
     /* 275140 */   // Label 5529: @275140
     /* 275140 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(275180), // Rule ID 747 //
     /* 275145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275148 */     // MIs[0] Operand 1
     /* 275148 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275171 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 275174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275178 */     GIR_RootConstrainSelectedInstOperands,
     /* 275179 */     // GIR_Coverage, 747,
     /* 275179 */     GIR_EraseRootFromParent_Done,
     /* 275180 */   // Label 5530: @275180
     /* 275180 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(275217), // Rule ID 5141 //
     /* 275185 */     // MIs[0] Operand 1
     /* 275185 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275198 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275204 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275208 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 275211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275215 */     GIR_RootConstrainSelectedInstOperands,
     /* 275216 */     // GIR_Coverage, 5141,
     /* 275216 */     GIR_EraseRootFromParent_Done,
     /* 275217 */   // Label 5531: @275217
     /* 275217 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(275254), // Rule ID 5148 //
     /* 275222 */     // MIs[0] Operand 1
     /* 275222 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275235 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275241 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275245 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 275248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275252 */     GIR_RootConstrainSelectedInstOperands,
     /* 275253 */     // GIR_Coverage, 5148,
     /* 275253 */     GIR_EraseRootFromParent_Done,
     /* 275254 */   // Label 5532: @275254
     /* 275254 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(275291), // Rule ID 5155 //
     /* 275259 */     // MIs[0] Operand 1
     /* 275259 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275272 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275278 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275282 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275289 */     GIR_RootConstrainSelectedInstOperands,
     /* 275290 */     // GIR_Coverage, 5155,
     /* 275290 */     GIR_EraseRootFromParent_Done,
     /* 275291 */   // Label 5533: @275291
     /* 275291 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(275328), // Rule ID 5162 //
     /* 275296 */     // MIs[0] Operand 1
     /* 275296 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275309 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275315 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275319 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 275322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275326 */     GIR_RootConstrainSelectedInstOperands,
     /* 275327 */     // GIR_Coverage, 5162,
     /* 275327 */     GIR_EraseRootFromParent_Done,
     /* 275328 */   // Label 5534: @275328
     /* 275328 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(275365), // Rule ID 5169 //
     /* 275333 */     // MIs[0] Operand 1
     /* 275333 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275356 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 275359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275363 */     GIR_RootConstrainSelectedInstOperands,
     /* 275364 */     // GIR_Coverage, 5169,
     /* 275364 */     GIR_EraseRootFromParent_Done,
     /* 275365 */   // Label 5535: @275365
     /* 275365 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(275397), // Rule ID 1125 //
     /* 275370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275373 */     // MIs[0] Operand 1
     /* 275373 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275386 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 275389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275395 */     GIR_RootConstrainSelectedInstOperands,
     /* 275396 */     // GIR_Coverage, 1125,
     /* 275396 */     GIR_EraseRootFromParent_Done,
     /* 275397 */   // Label 5536: @275397
     /* 275397 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(275429), // Rule ID 1132 //
     /* 275402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275405 */     // MIs[0] Operand 1
     /* 275405 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275418 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275427 */     GIR_RootConstrainSelectedInstOperands,
     /* 275428 */     // GIR_Coverage, 1132,
     /* 275428 */     GIR_EraseRootFromParent_Done,
     /* 275429 */   // Label 5537: @275429
     /* 275429 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(275461), // Rule ID 1139 //
     /* 275434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275437 */     // MIs[0] Operand 1
     /* 275437 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275450 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275459 */     GIR_RootConstrainSelectedInstOperands,
     /* 275460 */     // GIR_Coverage, 1139,
     /* 275460 */     GIR_EraseRootFromParent_Done,
     /* 275461 */   // Label 5538: @275461
     /* 275461 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(275493), // Rule ID 1146 //
     /* 275466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275469 */     // MIs[0] Operand 1
     /* 275469 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275482 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275491 */     GIR_RootConstrainSelectedInstOperands,
     /* 275492 */     // GIR_Coverage, 1146,
     /* 275492 */     GIR_EraseRootFromParent_Done,
     /* 275493 */   // Label 5539: @275493
     /* 275493 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(275525), // Rule ID 1153 //
     /* 275498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275501 */     // MIs[0] Operand 1
     /* 275501 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275514 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275523 */     GIR_RootConstrainSelectedInstOperands,
     /* 275524 */     // GIR_Coverage, 1153,
     /* 275524 */     GIR_EraseRootFromParent_Done,
     /* 275525 */   // Label 5540: @275525
     /* 275525 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(275554), // Rule ID 5078 //
     /* 275530 */     // MIs[0] Operand 1
     /* 275530 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275543 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 275546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275552 */     GIR_RootConstrainSelectedInstOperands,
     /* 275553 */     // GIR_Coverage, 5078,
     /* 275553 */     GIR_EraseRootFromParent_Done,
     /* 275554 */   // Label 5541: @275554
     /* 275554 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(275583), // Rule ID 5085 //
     /* 275559 */     // MIs[0] Operand 1
     /* 275559 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275572 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275581 */     GIR_RootConstrainSelectedInstOperands,
     /* 275582 */     // GIR_Coverage, 5085,
     /* 275582 */     GIR_EraseRootFromParent_Done,
     /* 275583 */   // Label 5542: @275583
     /* 275583 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(275612), // Rule ID 5092 //
     /* 275588 */     // MIs[0] Operand 1
     /* 275588 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275601 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275610 */     GIR_RootConstrainSelectedInstOperands,
     /* 275611 */     // GIR_Coverage, 5092,
     /* 275611 */     GIR_EraseRootFromParent_Done,
     /* 275612 */   // Label 5543: @275612
     /* 275612 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(275641), // Rule ID 5099 //
     /* 275617 */     // MIs[0] Operand 1
     /* 275617 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275630 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275639 */     GIR_RootConstrainSelectedInstOperands,
     /* 275640 */     // GIR_Coverage, 5099,
     /* 275640 */     GIR_EraseRootFromParent_Done,
     /* 275641 */   // Label 5544: @275641
     /* 275641 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275670), // Rule ID 5106 //
     /* 275646 */     // MIs[0] Operand 1
     /* 275646 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275659 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275668 */     GIR_RootConstrainSelectedInstOperands,
     /* 275669 */     // GIR_Coverage, 5106,
     /* 275669 */     GIR_EraseRootFromParent_Done,
     /* 275670 */   // Label 5545: @275670
     /* 275670 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275699), // Rule ID 5113 //
     /* 275675 */     // MIs[0] Operand 1
     /* 275675 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275688 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275697 */     GIR_RootConstrainSelectedInstOperands,
     /* 275698 */     // GIR_Coverage, 5113,
     /* 275698 */     GIR_EraseRootFromParent_Done,
     /* 275699 */   // Label 5546: @275699
     /* 275699 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275728), // Rule ID 5120 //
     /* 275704 */     // MIs[0] Operand 1
     /* 275704 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275717 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275726 */     GIR_RootConstrainSelectedInstOperands,
     /* 275727 */     // GIR_Coverage, 5120,
     /* 275727 */     GIR_EraseRootFromParent_Done,
     /* 275728 */   // Label 5547: @275728
     /* 275728 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275757), // Rule ID 5127 //
     /* 275733 */     // MIs[0] Operand 1
     /* 275733 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275746 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275755 */     GIR_RootConstrainSelectedInstOperands,
     /* 275756 */     // GIR_Coverage, 5127,
     /* 275756 */     GIR_EraseRootFromParent_Done,
     /* 275757 */   // Label 5548: @275757
     /* 275757 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275786), // Rule ID 5134 //
     /* 275762 */     // MIs[0] Operand 1
     /* 275762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275775 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275784 */     GIR_RootConstrainSelectedInstOperands,
     /* 275785 */     // GIR_Coverage, 5134,
     /* 275785 */     GIR_EraseRootFromParent_Done,
     /* 275786 */   // Label 5549: @275786
     /* 275786 */   GIM_Reject,
     /* 275787 */ // Label 5519: @275787
     /* 275787 */ GIM_Reject,
     /* 275788 */ // Label 5500: @275788
     /* 275788 */ GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(276835),
     /* 275793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 275796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 275799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275803 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275843), // Rule ID 756 //
     /* 275808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275811 */     // MIs[0] Operand 1
     /* 275811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275820 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275826 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275834 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 275837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275841 */     GIR_RootConstrainSelectedInstOperands,
     /* 275842 */     // GIR_Coverage, 756,
     /* 275842 */     GIR_EraseRootFromParent_Done,
     /* 275843 */   // Label 5551: @275843
     /* 275843 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275883), // Rule ID 763 //
     /* 275848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275851 */     // MIs[0] Operand 1
     /* 275851 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275874 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 275877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275881 */     GIR_RootConstrainSelectedInstOperands,
     /* 275882 */     // GIR_Coverage, 763,
     /* 275882 */     GIR_EraseRootFromParent_Done,
     /* 275883 */   // Label 5552: @275883
     /* 275883 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275920), // Rule ID 5178 //
     /* 275888 */     // MIs[0] Operand 1
     /* 275888 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275911 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 275914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275918 */     GIR_RootConstrainSelectedInstOperands,
     /* 275919 */     // GIR_Coverage, 5178,
     /* 275919 */     GIR_EraseRootFromParent_Done,
     /* 275920 */   // Label 5553: @275920
     /* 275920 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275957), // Rule ID 5185 //
     /* 275925 */     // MIs[0] Operand 1
     /* 275925 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275934 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275940 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275948 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 275951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275955 */     GIR_RootConstrainSelectedInstOperands,
     /* 275956 */     // GIR_Coverage, 5185,
     /* 275956 */     GIR_EraseRootFromParent_Done,
     /* 275957 */   // Label 5554: @275957
     /* 275957 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275994), // Rule ID 5192 //
     /* 275962 */     // MIs[0] Operand 1
     /* 275962 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275977 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275985 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 275988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275992 */     GIR_RootConstrainSelectedInstOperands,
     /* 275993 */     // GIR_Coverage, 5192,
     /* 275993 */     GIR_EraseRootFromParent_Done,
     /* 275994 */   // Label 5555: @275994
     /* 275994 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(276031), // Rule ID 5199 //
     /* 275999 */     // MIs[0] Operand 1
     /* 275999 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276022 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276029 */     GIR_RootConstrainSelectedInstOperands,
     /* 276030 */     // GIR_Coverage, 5199,
     /* 276030 */     GIR_EraseRootFromParent_Done,
     /* 276031 */   // Label 5556: @276031
     /* 276031 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(276068), // Rule ID 5206 //
     /* 276036 */     // MIs[0] Operand 1
     /* 276036 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276045 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276051 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276059 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276066 */     GIR_RootConstrainSelectedInstOperands,
     /* 276067 */     // GIR_Coverage, 5206,
     /* 276067 */     GIR_EraseRootFromParent_Done,
     /* 276068 */   // Label 5557: @276068
     /* 276068 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(276108), // Rule ID 728 //
     /* 276073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276076 */     // MIs[0] Operand 1
     /* 276076 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276099 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 276102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276106 */     GIR_RootConstrainSelectedInstOperands,
     /* 276107 */     // GIR_Coverage, 728,
     /* 276107 */     GIR_EraseRootFromParent_Done,
     /* 276108 */   // Label 5558: @276108
     /* 276108 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(276148), // Rule ID 741 //
     /* 276113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276116 */     // MIs[0] Operand 1
     /* 276116 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276139 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276146 */     GIR_RootConstrainSelectedInstOperands,
     /* 276147 */     // GIR_Coverage, 741,
     /* 276147 */     GIR_EraseRootFromParent_Done,
     /* 276148 */   // Label 5559: @276148
     /* 276148 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(276188), // Rule ID 742 //
     /* 276153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276156 */     // MIs[0] Operand 1
     /* 276156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276179 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276186 */     GIR_RootConstrainSelectedInstOperands,
     /* 276187 */     // GIR_Coverage, 742,
     /* 276187 */     GIR_EraseRootFromParent_Done,
     /* 276188 */   // Label 5560: @276188
     /* 276188 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(276228), // Rule ID 749 //
     /* 276193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276196 */     // MIs[0] Operand 1
     /* 276196 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276215 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276219 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276226 */     GIR_RootConstrainSelectedInstOperands,
     /* 276227 */     // GIR_Coverage, 749,
     /* 276227 */     GIR_EraseRootFromParent_Done,
     /* 276228 */   // Label 5561: @276228
     /* 276228 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(276265), // Rule ID 5143 //
     /* 276233 */     // MIs[0] Operand 1
     /* 276233 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276246 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276252 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276256 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 276259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276263 */     GIR_RootConstrainSelectedInstOperands,
     /* 276264 */     // GIR_Coverage, 5143,
     /* 276264 */     GIR_EraseRootFromParent_Done,
     /* 276265 */   // Label 5562: @276265
     /* 276265 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(276302), // Rule ID 5150 //
     /* 276270 */     // MIs[0] Operand 1
     /* 276270 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276283 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276289 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276293 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276300 */     GIR_RootConstrainSelectedInstOperands,
     /* 276301 */     // GIR_Coverage, 5150,
     /* 276301 */     GIR_EraseRootFromParent_Done,
     /* 276302 */   // Label 5563: @276302
     /* 276302 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(276339), // Rule ID 5157 //
     /* 276307 */     // MIs[0] Operand 1
     /* 276307 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276320 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276326 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276330 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276337 */     GIR_RootConstrainSelectedInstOperands,
     /* 276338 */     // GIR_Coverage, 5157,
     /* 276338 */     GIR_EraseRootFromParent_Done,
     /* 276339 */   // Label 5564: @276339
     /* 276339 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(276376), // Rule ID 5164 //
     /* 276344 */     // MIs[0] Operand 1
     /* 276344 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276357 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276363 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276367 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 276370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276374 */     GIR_RootConstrainSelectedInstOperands,
     /* 276375 */     // GIR_Coverage, 5164,
     /* 276375 */     GIR_EraseRootFromParent_Done,
     /* 276376 */   // Label 5565: @276376
     /* 276376 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(276413), // Rule ID 5171 //
     /* 276381 */     // MIs[0] Operand 1
     /* 276381 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276404 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 276407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276411 */     GIR_RootConstrainSelectedInstOperands,
     /* 276412 */     // GIR_Coverage, 5171,
     /* 276412 */     GIR_EraseRootFromParent_Done,
     /* 276413 */   // Label 5566: @276413
     /* 276413 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(276445), // Rule ID 1127 //
     /* 276418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276421 */     // MIs[0] Operand 1
     /* 276421 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276434 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 276437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276443 */     GIR_RootConstrainSelectedInstOperands,
     /* 276444 */     // GIR_Coverage, 1127,
     /* 276444 */     GIR_EraseRootFromParent_Done,
     /* 276445 */   // Label 5567: @276445
     /* 276445 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(276477), // Rule ID 1134 //
     /* 276450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276453 */     // MIs[0] Operand 1
     /* 276453 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276466 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276475 */     GIR_RootConstrainSelectedInstOperands,
     /* 276476 */     // GIR_Coverage, 1134,
     /* 276476 */     GIR_EraseRootFromParent_Done,
     /* 276477 */   // Label 5568: @276477
     /* 276477 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(276509), // Rule ID 1141 //
     /* 276482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276485 */     // MIs[0] Operand 1
     /* 276485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276498 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276507 */     GIR_RootConstrainSelectedInstOperands,
     /* 276508 */     // GIR_Coverage, 1141,
     /* 276508 */     GIR_EraseRootFromParent_Done,
     /* 276509 */   // Label 5569: @276509
     /* 276509 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(276541), // Rule ID 1148 //
     /* 276514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276517 */     // MIs[0] Operand 1
     /* 276517 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276530 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276539 */     GIR_RootConstrainSelectedInstOperands,
     /* 276540 */     // GIR_Coverage, 1148,
     /* 276540 */     GIR_EraseRootFromParent_Done,
     /* 276541 */   // Label 5570: @276541
     /* 276541 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(276573), // Rule ID 1155 //
     /* 276546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276549 */     // MIs[0] Operand 1
     /* 276549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276562 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276571 */     GIR_RootConstrainSelectedInstOperands,
     /* 276572 */     // GIR_Coverage, 1155,
     /* 276572 */     GIR_EraseRootFromParent_Done,
     /* 276573 */   // Label 5571: @276573
     /* 276573 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(276602), // Rule ID 5080 //
     /* 276578 */     // MIs[0] Operand 1
     /* 276578 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276591 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 276594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276600 */     GIR_RootConstrainSelectedInstOperands,
     /* 276601 */     // GIR_Coverage, 5080,
     /* 276601 */     GIR_EraseRootFromParent_Done,
     /* 276602 */   // Label 5572: @276602
     /* 276602 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(276631), // Rule ID 5087 //
     /* 276607 */     // MIs[0] Operand 1
     /* 276607 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276620 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276629 */     GIR_RootConstrainSelectedInstOperands,
     /* 276630 */     // GIR_Coverage, 5087,
     /* 276630 */     GIR_EraseRootFromParent_Done,
     /* 276631 */   // Label 5573: @276631
     /* 276631 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(276660), // Rule ID 5094 //
     /* 276636 */     // MIs[0] Operand 1
     /* 276636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276649 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276658 */     GIR_RootConstrainSelectedInstOperands,
     /* 276659 */     // GIR_Coverage, 5094,
     /* 276659 */     GIR_EraseRootFromParent_Done,
     /* 276660 */   // Label 5574: @276660
     /* 276660 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276689), // Rule ID 5101 //
     /* 276665 */     // MIs[0] Operand 1
     /* 276665 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276678 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276687 */     GIR_RootConstrainSelectedInstOperands,
     /* 276688 */     // GIR_Coverage, 5101,
     /* 276688 */     GIR_EraseRootFromParent_Done,
     /* 276689 */   // Label 5575: @276689
     /* 276689 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276718), // Rule ID 5108 //
     /* 276694 */     // MIs[0] Operand 1
     /* 276694 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276707 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276716 */     GIR_RootConstrainSelectedInstOperands,
     /* 276717 */     // GIR_Coverage, 5108,
     /* 276717 */     GIR_EraseRootFromParent_Done,
     /* 276718 */   // Label 5576: @276718
     /* 276718 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276747), // Rule ID 5115 //
     /* 276723 */     // MIs[0] Operand 1
     /* 276723 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276736 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276745 */     GIR_RootConstrainSelectedInstOperands,
     /* 276746 */     // GIR_Coverage, 5115,
     /* 276746 */     GIR_EraseRootFromParent_Done,
     /* 276747 */   // Label 5577: @276747
     /* 276747 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276776), // Rule ID 5122 //
     /* 276752 */     // MIs[0] Operand 1
     /* 276752 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276765 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276774 */     GIR_RootConstrainSelectedInstOperands,
     /* 276775 */     // GIR_Coverage, 5122,
     /* 276775 */     GIR_EraseRootFromParent_Done,
     /* 276776 */   // Label 5578: @276776
     /* 276776 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276805), // Rule ID 5129 //
     /* 276781 */     // MIs[0] Operand 1
     /* 276781 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276794 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276803 */     GIR_RootConstrainSelectedInstOperands,
     /* 276804 */     // GIR_Coverage, 5129,
     /* 276804 */     GIR_EraseRootFromParent_Done,
     /* 276805 */   // Label 5579: @276805
     /* 276805 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276834), // Rule ID 5136 //
     /* 276810 */     // MIs[0] Operand 1
     /* 276810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276823 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276832 */     GIR_RootConstrainSelectedInstOperands,
     /* 276833 */     // GIR_Coverage, 5136,
     /* 276833 */     GIR_EraseRootFromParent_Done,
     /* 276834 */   // Label 5580: @276834
     /* 276834 */   GIM_Reject,
     /* 276835 */ // Label 5550: @276835
     /* 276835 */ GIM_Reject,
     /* 276836 */ // Label 5501: @276836
     /* 276836 */ GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(277883),
     /* 276841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 276844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 276847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276851 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276891), // Rule ID 752 //
     /* 276856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276859 */     // MIs[0] Operand 1
     /* 276859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276868 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276874 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276882 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 276885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276889 */     GIR_RootConstrainSelectedInstOperands,
     /* 276890 */     // GIR_Coverage, 752,
     /* 276890 */     GIR_EraseRootFromParent_Done,
     /* 276891 */   // Label 5582: @276891
     /* 276891 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276931), // Rule ID 759 //
     /* 276896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276899 */     // MIs[0] Operand 1
     /* 276899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276908 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276914 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276922 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 276925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276929 */     GIR_RootConstrainSelectedInstOperands,
     /* 276930 */     // GIR_Coverage, 759,
     /* 276930 */     GIR_EraseRootFromParent_Done,
     /* 276931 */   // Label 5583: @276931
     /* 276931 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276968), // Rule ID 5174 //
     /* 276936 */     // MIs[0] Operand 1
     /* 276936 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276945 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276951 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276959 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 276962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276966 */     GIR_RootConstrainSelectedInstOperands,
     /* 276967 */     // GIR_Coverage, 5174,
     /* 276967 */     GIR_EraseRootFromParent_Done,
     /* 276968 */   // Label 5584: @276968
     /* 276968 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(277005), // Rule ID 5181 //
     /* 276973 */     // MIs[0] Operand 1
     /* 276973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276996 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 276999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277003 */     GIR_RootConstrainSelectedInstOperands,
     /* 277004 */     // GIR_Coverage, 5181,
     /* 277004 */     GIR_EraseRootFromParent_Done,
     /* 277005 */   // Label 5585: @277005
     /* 277005 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(277042), // Rule ID 5188 //
     /* 277010 */     // MIs[0] Operand 1
     /* 277010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277033 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 277036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277040 */     GIR_RootConstrainSelectedInstOperands,
     /* 277041 */     // GIR_Coverage, 5188,
     /* 277041 */     GIR_EraseRootFromParent_Done,
     /* 277042 */   // Label 5586: @277042
     /* 277042 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(277079), // Rule ID 5195 //
     /* 277047 */     // MIs[0] Operand 1
     /* 277047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277070 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277077 */     GIR_RootConstrainSelectedInstOperands,
     /* 277078 */     // GIR_Coverage, 5195,
     /* 277078 */     GIR_EraseRootFromParent_Done,
     /* 277079 */   // Label 5587: @277079
     /* 277079 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(277116), // Rule ID 5202 //
     /* 277084 */     // MIs[0] Operand 1
     /* 277084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277107 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277114 */     GIR_RootConstrainSelectedInstOperands,
     /* 277115 */     // GIR_Coverage, 5202,
     /* 277115 */     GIR_EraseRootFromParent_Done,
     /* 277116 */   // Label 5588: @277116
     /* 277116 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(277156), // Rule ID 724 //
     /* 277121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277124 */     // MIs[0] Operand 1
     /* 277124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277147 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 277150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277154 */     GIR_RootConstrainSelectedInstOperands,
     /* 277155 */     // GIR_Coverage, 724,
     /* 277155 */     GIR_EraseRootFromParent_Done,
     /* 277156 */   // Label 5589: @277156
     /* 277156 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(277196), // Rule ID 733 //
     /* 277161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277164 */     // MIs[0] Operand 1
     /* 277164 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277187 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277194 */     GIR_RootConstrainSelectedInstOperands,
     /* 277195 */     // GIR_Coverage, 733,
     /* 277195 */     GIR_EraseRootFromParent_Done,
     /* 277196 */   // Label 5590: @277196
     /* 277196 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(277236), // Rule ID 734 //
     /* 277201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277204 */     // MIs[0] Operand 1
     /* 277204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277223 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277227 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277234 */     GIR_RootConstrainSelectedInstOperands,
     /* 277235 */     // GIR_Coverage, 734,
     /* 277235 */     GIR_EraseRootFromParent_Done,
     /* 277236 */   // Label 5591: @277236
     /* 277236 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(277276), // Rule ID 745 //
     /* 277241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277244 */     // MIs[0] Operand 1
     /* 277244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277257 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277263 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277267 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277274 */     GIR_RootConstrainSelectedInstOperands,
     /* 277275 */     // GIR_Coverage, 745,
     /* 277275 */     GIR_EraseRootFromParent_Done,
     /* 277276 */   // Label 5592: @277276
     /* 277276 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(277313), // Rule ID 5139 //
     /* 277281 */     // MIs[0] Operand 1
     /* 277281 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277294 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277300 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277304 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 277307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277311 */     GIR_RootConstrainSelectedInstOperands,
     /* 277312 */     // GIR_Coverage, 5139,
     /* 277312 */     GIR_EraseRootFromParent_Done,
     /* 277313 */   // Label 5593: @277313
     /* 277313 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(277350), // Rule ID 5146 //
     /* 277318 */     // MIs[0] Operand 1
     /* 277318 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277331 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277337 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277341 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277348 */     GIR_RootConstrainSelectedInstOperands,
     /* 277349 */     // GIR_Coverage, 5146,
     /* 277349 */     GIR_EraseRootFromParent_Done,
     /* 277350 */   // Label 5594: @277350
     /* 277350 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(277387), // Rule ID 5153 //
     /* 277355 */     // MIs[0] Operand 1
     /* 277355 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277374 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277378 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277385 */     GIR_RootConstrainSelectedInstOperands,
     /* 277386 */     // GIR_Coverage, 5153,
     /* 277386 */     GIR_EraseRootFromParent_Done,
     /* 277387 */   // Label 5595: @277387
     /* 277387 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(277424), // Rule ID 5160 //
     /* 277392 */     // MIs[0] Operand 1
     /* 277392 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277405 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277411 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277415 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 277418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277422 */     GIR_RootConstrainSelectedInstOperands,
     /* 277423 */     // GIR_Coverage, 5160,
     /* 277423 */     GIR_EraseRootFromParent_Done,
     /* 277424 */   // Label 5596: @277424
     /* 277424 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(277461), // Rule ID 5167 //
     /* 277429 */     // MIs[0] Operand 1
     /* 277429 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277442 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277448 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277452 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 277455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277459 */     GIR_RootConstrainSelectedInstOperands,
     /* 277460 */     // GIR_Coverage, 5167,
     /* 277460 */     GIR_EraseRootFromParent_Done,
     /* 277461 */   // Label 5597: @277461
     /* 277461 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(277493), // Rule ID 1123 //
     /* 277466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277469 */     // MIs[0] Operand 1
     /* 277469 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277482 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 277485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277491 */     GIR_RootConstrainSelectedInstOperands,
     /* 277492 */     // GIR_Coverage, 1123,
     /* 277492 */     GIR_EraseRootFromParent_Done,
     /* 277493 */   // Label 5598: @277493
     /* 277493 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(277525), // Rule ID 1130 //
     /* 277498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277501 */     // MIs[0] Operand 1
     /* 277501 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277514 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277523 */     GIR_RootConstrainSelectedInstOperands,
     /* 277524 */     // GIR_Coverage, 1130,
     /* 277524 */     GIR_EraseRootFromParent_Done,
     /* 277525 */   // Label 5599: @277525
     /* 277525 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(277557), // Rule ID 1137 //
     /* 277530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277533 */     // MIs[0] Operand 1
     /* 277533 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277546 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277555 */     GIR_RootConstrainSelectedInstOperands,
     /* 277556 */     // GIR_Coverage, 1137,
     /* 277556 */     GIR_EraseRootFromParent_Done,
     /* 277557 */   // Label 5600: @277557
     /* 277557 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(277589), // Rule ID 1144 //
     /* 277562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277565 */     // MIs[0] Operand 1
     /* 277565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277578 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277587 */     GIR_RootConstrainSelectedInstOperands,
     /* 277588 */     // GIR_Coverage, 1144,
     /* 277588 */     GIR_EraseRootFromParent_Done,
     /* 277589 */   // Label 5601: @277589
     /* 277589 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(277621), // Rule ID 1151 //
     /* 277594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277597 */     // MIs[0] Operand 1
     /* 277597 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277610 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277619 */     GIR_RootConstrainSelectedInstOperands,
     /* 277620 */     // GIR_Coverage, 1151,
     /* 277620 */     GIR_EraseRootFromParent_Done,
     /* 277621 */   // Label 5602: @277621
     /* 277621 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(277650), // Rule ID 5076 //
     /* 277626 */     // MIs[0] Operand 1
     /* 277626 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277639 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 277642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277648 */     GIR_RootConstrainSelectedInstOperands,
     /* 277649 */     // GIR_Coverage, 5076,
     /* 277649 */     GIR_EraseRootFromParent_Done,
     /* 277650 */   // Label 5603: @277650
     /* 277650 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(277679), // Rule ID 5083 //
     /* 277655 */     // MIs[0] Operand 1
     /* 277655 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277668 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277677 */     GIR_RootConstrainSelectedInstOperands,
     /* 277678 */     // GIR_Coverage, 5083,
     /* 277678 */     GIR_EraseRootFromParent_Done,
     /* 277679 */   // Label 5604: @277679
     /* 277679 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277708), // Rule ID 5090 //
     /* 277684 */     // MIs[0] Operand 1
     /* 277684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277697 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277706 */     GIR_RootConstrainSelectedInstOperands,
     /* 277707 */     // GIR_Coverage, 5090,
     /* 277707 */     GIR_EraseRootFromParent_Done,
     /* 277708 */   // Label 5605: @277708
     /* 277708 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277737), // Rule ID 5097 //
     /* 277713 */     // MIs[0] Operand 1
     /* 277713 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277726 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277735 */     GIR_RootConstrainSelectedInstOperands,
     /* 277736 */     // GIR_Coverage, 5097,
     /* 277736 */     GIR_EraseRootFromParent_Done,
     /* 277737 */   // Label 5606: @277737
     /* 277737 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277766), // Rule ID 5104 //
     /* 277742 */     // MIs[0] Operand 1
     /* 277742 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277755 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277764 */     GIR_RootConstrainSelectedInstOperands,
     /* 277765 */     // GIR_Coverage, 5104,
     /* 277765 */     GIR_EraseRootFromParent_Done,
     /* 277766 */   // Label 5607: @277766
     /* 277766 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277795), // Rule ID 5111 //
     /* 277771 */     // MIs[0] Operand 1
     /* 277771 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277784 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277793 */     GIR_RootConstrainSelectedInstOperands,
     /* 277794 */     // GIR_Coverage, 5111,
     /* 277794 */     GIR_EraseRootFromParent_Done,
     /* 277795 */   // Label 5608: @277795
     /* 277795 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277824), // Rule ID 5118 //
     /* 277800 */     // MIs[0] Operand 1
     /* 277800 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277813 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277822 */     GIR_RootConstrainSelectedInstOperands,
     /* 277823 */     // GIR_Coverage, 5118,
     /* 277823 */     GIR_EraseRootFromParent_Done,
     /* 277824 */   // Label 5609: @277824
     /* 277824 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277853), // Rule ID 5125 //
     /* 277829 */     // MIs[0] Operand 1
     /* 277829 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277842 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277851 */     GIR_RootConstrainSelectedInstOperands,
     /* 277852 */     // GIR_Coverage, 5125,
     /* 277852 */     GIR_EraseRootFromParent_Done,
     /* 277853 */   // Label 5610: @277853
     /* 277853 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277882), // Rule ID 5132 //
     /* 277858 */     // MIs[0] Operand 1
     /* 277858 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277871 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277880 */     GIR_RootConstrainSelectedInstOperands,
     /* 277881 */     // GIR_Coverage, 5132,
     /* 277881 */     GIR_EraseRootFromParent_Done,
     /* 277882 */   // Label 5611: @277882
     /* 277882 */   GIM_Reject,
     /* 277883 */ // Label 5581: @277883
     /* 277883 */ GIM_Reject,
     /* 277884 */ // Label 5502: @277884
     /* 277884 */ GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(278931),
     /* 277889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277899 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277939), // Rule ID 755 //
     /* 277904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277907 */     // MIs[0] Operand 1
     /* 277907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277922 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277930 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 277930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 277933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277937 */     GIR_RootConstrainSelectedInstOperands,
     /* 277938 */     // GIR_Coverage, 755,
     /* 277938 */     GIR_EraseRootFromParent_Done,
     /* 277939 */   // Label 5613: @277939
     /* 277939 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277979), // Rule ID 762 //
     /* 277944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277947 */     // MIs[0] Operand 1
     /* 277947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277956 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277962 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277970 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 277970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 277973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277977 */     GIR_RootConstrainSelectedInstOperands,
     /* 277978 */     // GIR_Coverage, 762,
     /* 277978 */     GIR_EraseRootFromParent_Done,
     /* 277979 */   // Label 5614: @277979
     /* 277979 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(278016), // Rule ID 5177 //
     /* 277984 */     // MIs[0] Operand 1
     /* 277984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277993 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277999 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278007 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278014 */     GIR_RootConstrainSelectedInstOperands,
     /* 278015 */     // GIR_Coverage, 5177,
     /* 278015 */     GIR_EraseRootFromParent_Done,
     /* 278016 */   // Label 5615: @278016
     /* 278016 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(278053), // Rule ID 5184 //
     /* 278021 */     // MIs[0] Operand 1
     /* 278021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278030 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278036 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278044 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 278047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278051 */     GIR_RootConstrainSelectedInstOperands,
     /* 278052 */     // GIR_Coverage, 5184,
     /* 278052 */     GIR_EraseRootFromParent_Done,
     /* 278053 */   // Label 5616: @278053
     /* 278053 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(278090), // Rule ID 5191 //
     /* 278058 */     // MIs[0] Operand 1
     /* 278058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278081 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 278084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278088 */     GIR_RootConstrainSelectedInstOperands,
     /* 278089 */     // GIR_Coverage, 5191,
     /* 278089 */     GIR_EraseRootFromParent_Done,
     /* 278090 */   // Label 5617: @278090
     /* 278090 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(278127), // Rule ID 5198 //
     /* 278095 */     // MIs[0] Operand 1
     /* 278095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278118 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278125 */     GIR_RootConstrainSelectedInstOperands,
     /* 278126 */     // GIR_Coverage, 5198,
     /* 278126 */     GIR_EraseRootFromParent_Done,
     /* 278127 */   // Label 5618: @278127
     /* 278127 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(278164), // Rule ID 5205 //
     /* 278132 */     // MIs[0] Operand 1
     /* 278132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278155 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278162 */     GIR_RootConstrainSelectedInstOperands,
     /* 278163 */     // GIR_Coverage, 5205,
     /* 278163 */     GIR_EraseRootFromParent_Done,
     /* 278164 */   // Label 5619: @278164
     /* 278164 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(278204), // Rule ID 727 //
     /* 278169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278172 */     // MIs[0] Operand 1
     /* 278172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278185 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278191 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278195 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278202 */     GIR_RootConstrainSelectedInstOperands,
     /* 278203 */     // GIR_Coverage, 727,
     /* 278203 */     GIR_EraseRootFromParent_Done,
     /* 278204 */   // Label 5620: @278204
     /* 278204 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(278244), // Rule ID 739 //
     /* 278209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278212 */     // MIs[0] Operand 1
     /* 278212 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278235 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278242 */     GIR_RootConstrainSelectedInstOperands,
     /* 278243 */     // GIR_Coverage, 739,
     /* 278243 */     GIR_EraseRootFromParent_Done,
     /* 278244 */   // Label 5621: @278244
     /* 278244 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(278284), // Rule ID 740 //
     /* 278249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278252 */     // MIs[0] Operand 1
     /* 278252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278275 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278282 */     GIR_RootConstrainSelectedInstOperands,
     /* 278283 */     // GIR_Coverage, 740,
     /* 278283 */     GIR_EraseRootFromParent_Done,
     /* 278284 */   // Label 5622: @278284
     /* 278284 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(278324), // Rule ID 748 //
     /* 278289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278292 */     // MIs[0] Operand 1
     /* 278292 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278315 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278322 */     GIR_RootConstrainSelectedInstOperands,
     /* 278323 */     // GIR_Coverage, 748,
     /* 278323 */     GIR_EraseRootFromParent_Done,
     /* 278324 */   // Label 5623: @278324
     /* 278324 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(278361), // Rule ID 5142 //
     /* 278329 */     // MIs[0] Operand 1
     /* 278329 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278352 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278359 */     GIR_RootConstrainSelectedInstOperands,
     /* 278360 */     // GIR_Coverage, 5142,
     /* 278360 */     GIR_EraseRootFromParent_Done,
     /* 278361 */   // Label 5624: @278361
     /* 278361 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(278398), // Rule ID 5149 //
     /* 278366 */     // MIs[0] Operand 1
     /* 278366 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278389 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278396 */     GIR_RootConstrainSelectedInstOperands,
     /* 278397 */     // GIR_Coverage, 5149,
     /* 278397 */     GIR_EraseRootFromParent_Done,
     /* 278398 */   // Label 5625: @278398
     /* 278398 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(278435), // Rule ID 5156 //
     /* 278403 */     // MIs[0] Operand 1
     /* 278403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278416 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278422 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278426 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278433 */     GIR_RootConstrainSelectedInstOperands,
     /* 278434 */     // GIR_Coverage, 5156,
     /* 278434 */     GIR_EraseRootFromParent_Done,
     /* 278435 */   // Label 5626: @278435
     /* 278435 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(278472), // Rule ID 5163 //
     /* 278440 */     // MIs[0] Operand 1
     /* 278440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278463 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 278466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278470 */     GIR_RootConstrainSelectedInstOperands,
     /* 278471 */     // GIR_Coverage, 5163,
     /* 278471 */     GIR_EraseRootFromParent_Done,
     /* 278472 */   // Label 5627: @278472
     /* 278472 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(278509), // Rule ID 5170 //
     /* 278477 */     // MIs[0] Operand 1
     /* 278477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278500 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 278503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278507 */     GIR_RootConstrainSelectedInstOperands,
     /* 278508 */     // GIR_Coverage, 5170,
     /* 278508 */     GIR_EraseRootFromParent_Done,
     /* 278509 */   // Label 5628: @278509
     /* 278509 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(278541), // Rule ID 1126 //
     /* 278514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278517 */     // MIs[0] Operand 1
     /* 278517 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278530 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 278533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278539 */     GIR_RootConstrainSelectedInstOperands,
     /* 278540 */     // GIR_Coverage, 1126,
     /* 278540 */     GIR_EraseRootFromParent_Done,
     /* 278541 */   // Label 5629: @278541
     /* 278541 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(278573), // Rule ID 1133 //
     /* 278546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278549 */     // MIs[0] Operand 1
     /* 278549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278562 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278571 */     GIR_RootConstrainSelectedInstOperands,
     /* 278572 */     // GIR_Coverage, 1133,
     /* 278572 */     GIR_EraseRootFromParent_Done,
     /* 278573 */   // Label 5630: @278573
     /* 278573 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(278605), // Rule ID 1140 //
     /* 278578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278581 */     // MIs[0] Operand 1
     /* 278581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278594 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278603 */     GIR_RootConstrainSelectedInstOperands,
     /* 278604 */     // GIR_Coverage, 1140,
     /* 278604 */     GIR_EraseRootFromParent_Done,
     /* 278605 */   // Label 5631: @278605
     /* 278605 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(278637), // Rule ID 1147 //
     /* 278610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278613 */     // MIs[0] Operand 1
     /* 278613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278626 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278635 */     GIR_RootConstrainSelectedInstOperands,
     /* 278636 */     // GIR_Coverage, 1147,
     /* 278636 */     GIR_EraseRootFromParent_Done,
     /* 278637 */   // Label 5632: @278637
     /* 278637 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(278669), // Rule ID 1154 //
     /* 278642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278645 */     // MIs[0] Operand 1
     /* 278645 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278658 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278667 */     GIR_RootConstrainSelectedInstOperands,
     /* 278668 */     // GIR_Coverage, 1154,
     /* 278668 */     GIR_EraseRootFromParent_Done,
     /* 278669 */   // Label 5633: @278669
     /* 278669 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(278698), // Rule ID 5079 //
     /* 278674 */     // MIs[0] Operand 1
     /* 278674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278687 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 278690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278696 */     GIR_RootConstrainSelectedInstOperands,
     /* 278697 */     // GIR_Coverage, 5079,
     /* 278697 */     GIR_EraseRootFromParent_Done,
     /* 278698 */   // Label 5634: @278698
     /* 278698 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(278727), // Rule ID 5086 //
     /* 278703 */     // MIs[0] Operand 1
     /* 278703 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278716 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278725 */     GIR_RootConstrainSelectedInstOperands,
     /* 278726 */     // GIR_Coverage, 5086,
     /* 278726 */     GIR_EraseRootFromParent_Done,
     /* 278727 */   // Label 5635: @278727
     /* 278727 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(278756), // Rule ID 5093 //
     /* 278732 */     // MIs[0] Operand 1
     /* 278732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278745 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278754 */     GIR_RootConstrainSelectedInstOperands,
     /* 278755 */     // GIR_Coverage, 5093,
     /* 278755 */     GIR_EraseRootFromParent_Done,
     /* 278756 */   // Label 5636: @278756
     /* 278756 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(278785), // Rule ID 5100 //
     /* 278761 */     // MIs[0] Operand 1
     /* 278761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278774 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278783 */     GIR_RootConstrainSelectedInstOperands,
     /* 278784 */     // GIR_Coverage, 5100,
     /* 278784 */     GIR_EraseRootFromParent_Done,
     /* 278785 */   // Label 5637: @278785
     /* 278785 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(278814), // Rule ID 5107 //
     /* 278790 */     // MIs[0] Operand 1
     /* 278790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278803 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278812 */     GIR_RootConstrainSelectedInstOperands,
     /* 278813 */     // GIR_Coverage, 5107,
     /* 278813 */     GIR_EraseRootFromParent_Done,
     /* 278814 */   // Label 5638: @278814
     /* 278814 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(278843), // Rule ID 5114 //
     /* 278819 */     // MIs[0] Operand 1
     /* 278819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278832 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278841 */     GIR_RootConstrainSelectedInstOperands,
     /* 278842 */     // GIR_Coverage, 5114,
     /* 278842 */     GIR_EraseRootFromParent_Done,
     /* 278843 */   // Label 5639: @278843
     /* 278843 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278872), // Rule ID 5121 //
     /* 278848 */     // MIs[0] Operand 1
     /* 278848 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278861 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278870 */     GIR_RootConstrainSelectedInstOperands,
     /* 278871 */     // GIR_Coverage, 5121,
     /* 278871 */     GIR_EraseRootFromParent_Done,
     /* 278872 */   // Label 5640: @278872
     /* 278872 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278901), // Rule ID 5128 //
     /* 278877 */     // MIs[0] Operand 1
     /* 278877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278890 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278899 */     GIR_RootConstrainSelectedInstOperands,
     /* 278900 */     // GIR_Coverage, 5128,
     /* 278900 */     GIR_EraseRootFromParent_Done,
     /* 278901 */   // Label 5641: @278901
     /* 278901 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278930), // Rule ID 5135 //
     /* 278906 */     // MIs[0] Operand 1
     /* 278906 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278919 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278928 */     GIR_RootConstrainSelectedInstOperands,
     /* 278929 */     // GIR_Coverage, 5135,
     /* 278929 */     GIR_EraseRootFromParent_Done,
     /* 278930 */   // Label 5642: @278930
     /* 278930 */   GIM_Reject,
     /* 278931 */ // Label 5612: @278931
     /* 278931 */ GIM_Reject,
     /* 278932 */ // Label 5503: @278932
     /* 278932 */ GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(279979),
     /* 278937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 278943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278947 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278987), // Rule ID 750 //
     /* 278952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278955 */     // MIs[0] Operand 1
     /* 278955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278964 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278970 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278978 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 278978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 278981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278985 */     GIR_RootConstrainSelectedInstOperands,
     /* 278986 */     // GIR_Coverage, 750,
     /* 278986 */     GIR_EraseRootFromParent_Done,
     /* 278987 */   // Label 5644: @278987
     /* 278987 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(279027), // Rule ID 757 //
     /* 278992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278995 */     // MIs[0] Operand 1
     /* 278995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279004 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279010 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279018 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279025 */     GIR_RootConstrainSelectedInstOperands,
     /* 279026 */     // GIR_Coverage, 757,
     /* 279026 */     GIR_EraseRootFromParent_Done,
     /* 279027 */   // Label 5645: @279027
     /* 279027 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(279064), // Rule ID 5172 //
     /* 279032 */     // MIs[0] Operand 1
     /* 279032 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279041 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279047 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279055 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279062 */     GIR_RootConstrainSelectedInstOperands,
     /* 279063 */     // GIR_Coverage, 5172,
     /* 279063 */     GIR_EraseRootFromParent_Done,
     /* 279064 */   // Label 5646: @279064
     /* 279064 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(279101), // Rule ID 5179 //
     /* 279069 */     // MIs[0] Operand 1
     /* 279069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279078 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279084 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279092 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279099 */     GIR_RootConstrainSelectedInstOperands,
     /* 279100 */     // GIR_Coverage, 5179,
     /* 279100 */     GIR_EraseRootFromParent_Done,
     /* 279101 */   // Label 5647: @279101
     /* 279101 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(279138), // Rule ID 5186 //
     /* 279106 */     // MIs[0] Operand 1
     /* 279106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279129 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 279132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279136 */     GIR_RootConstrainSelectedInstOperands,
     /* 279137 */     // GIR_Coverage, 5186,
     /* 279137 */     GIR_EraseRootFromParent_Done,
     /* 279138 */   // Label 5648: @279138
     /* 279138 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(279175), // Rule ID 5193 //
     /* 279143 */     // MIs[0] Operand 1
     /* 279143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279166 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279173 */     GIR_RootConstrainSelectedInstOperands,
     /* 279174 */     // GIR_Coverage, 5193,
     /* 279174 */     GIR_EraseRootFromParent_Done,
     /* 279175 */   // Label 5649: @279175
     /* 279175 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(279212), // Rule ID 5200 //
     /* 279180 */     // MIs[0] Operand 1
     /* 279180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279203 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279210 */     GIR_RootConstrainSelectedInstOperands,
     /* 279211 */     // GIR_Coverage, 5200,
     /* 279211 */     GIR_EraseRootFromParent_Done,
     /* 279212 */   // Label 5650: @279212
     /* 279212 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(279252), // Rule ID 722 //
     /* 279217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279220 */     // MIs[0] Operand 1
     /* 279220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279243 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279250 */     GIR_RootConstrainSelectedInstOperands,
     /* 279251 */     // GIR_Coverage, 722,
     /* 279251 */     GIR_EraseRootFromParent_Done,
     /* 279252 */   // Label 5651: @279252
     /* 279252 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(279292), // Rule ID 729 //
     /* 279257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279260 */     // MIs[0] Operand 1
     /* 279260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279283 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279290 */     GIR_RootConstrainSelectedInstOperands,
     /* 279291 */     // GIR_Coverage, 729,
     /* 279291 */     GIR_EraseRootFromParent_Done,
     /* 279292 */   // Label 5652: @279292
     /* 279292 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(279332), // Rule ID 730 //
     /* 279297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279300 */     // MIs[0] Operand 1
     /* 279300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279319 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 279321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279323 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279330 */     GIR_RootConstrainSelectedInstOperands,
     /* 279331 */     // GIR_Coverage, 730,
     /* 279331 */     GIR_EraseRootFromParent_Done,
     /* 279332 */   // Label 5653: @279332
     /* 279332 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(279372), // Rule ID 743 //
     /* 279337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279340 */     // MIs[0] Operand 1
     /* 279340 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279363 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279370 */     GIR_RootConstrainSelectedInstOperands,
     /* 279371 */     // GIR_Coverage, 743,
     /* 279371 */     GIR_EraseRootFromParent_Done,
     /* 279372 */   // Label 5654: @279372
     /* 279372 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(279409), // Rule ID 5137 //
     /* 279377 */     // MIs[0] Operand 1
     /* 279377 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279390 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279396 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279400 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279407 */     GIR_RootConstrainSelectedInstOperands,
     /* 279408 */     // GIR_Coverage, 5137,
     /* 279408 */     GIR_EraseRootFromParent_Done,
     /* 279409 */   // Label 5655: @279409
     /* 279409 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(279446), // Rule ID 5144 //
     /* 279414 */     // MIs[0] Operand 1
     /* 279414 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279437 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279444 */     GIR_RootConstrainSelectedInstOperands,
     /* 279445 */     // GIR_Coverage, 5144,
     /* 279445 */     GIR_EraseRootFromParent_Done,
     /* 279446 */   // Label 5656: @279446
     /* 279446 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(279483), // Rule ID 5151 //
     /* 279451 */     // MIs[0] Operand 1
     /* 279451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279474 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279481 */     GIR_RootConstrainSelectedInstOperands,
     /* 279482 */     // GIR_Coverage, 5151,
     /* 279482 */     GIR_EraseRootFromParent_Done,
     /* 279483 */   // Label 5657: @279483
     /* 279483 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(279520), // Rule ID 5158 //
     /* 279488 */     // MIs[0] Operand 1
     /* 279488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279511 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279518 */     GIR_RootConstrainSelectedInstOperands,
     /* 279519 */     // GIR_Coverage, 5158,
     /* 279519 */     GIR_EraseRootFromParent_Done,
     /* 279520 */   // Label 5658: @279520
     /* 279520 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(279557), // Rule ID 5165 //
     /* 279525 */     // MIs[0] Operand 1
     /* 279525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279548 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 279551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279555 */     GIR_RootConstrainSelectedInstOperands,
     /* 279556 */     // GIR_Coverage, 5165,
     /* 279556 */     GIR_EraseRootFromParent_Done,
     /* 279557 */   // Label 5659: @279557
     /* 279557 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(279589), // Rule ID 1121 //
     /* 279562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279565 */     // MIs[0] Operand 1
     /* 279565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279578 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 279581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279587 */     GIR_RootConstrainSelectedInstOperands,
     /* 279588 */     // GIR_Coverage, 1121,
     /* 279588 */     GIR_EraseRootFromParent_Done,
     /* 279589 */   // Label 5660: @279589
     /* 279589 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(279621), // Rule ID 1128 //
     /* 279594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279597 */     // MIs[0] Operand 1
     /* 279597 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279610 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279619 */     GIR_RootConstrainSelectedInstOperands,
     /* 279620 */     // GIR_Coverage, 1128,
     /* 279620 */     GIR_EraseRootFromParent_Done,
     /* 279621 */   // Label 5661: @279621
     /* 279621 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(279653), // Rule ID 1135 //
     /* 279626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279629 */     // MIs[0] Operand 1
     /* 279629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279642 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279651 */     GIR_RootConstrainSelectedInstOperands,
     /* 279652 */     // GIR_Coverage, 1135,
     /* 279652 */     GIR_EraseRootFromParent_Done,
     /* 279653 */   // Label 5662: @279653
     /* 279653 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(279685), // Rule ID 1142 //
     /* 279658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279661 */     // MIs[0] Operand 1
     /* 279661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279674 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279683 */     GIR_RootConstrainSelectedInstOperands,
     /* 279684 */     // GIR_Coverage, 1142,
     /* 279684 */     GIR_EraseRootFromParent_Done,
     /* 279685 */   // Label 5663: @279685
     /* 279685 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(279717), // Rule ID 1149 //
     /* 279690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279693 */     // MIs[0] Operand 1
     /* 279693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279706 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279715 */     GIR_RootConstrainSelectedInstOperands,
     /* 279716 */     // GIR_Coverage, 1149,
     /* 279716 */     GIR_EraseRootFromParent_Done,
     /* 279717 */   // Label 5664: @279717
     /* 279717 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(279746), // Rule ID 5074 //
     /* 279722 */     // MIs[0] Operand 1
     /* 279722 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279735 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 279738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279744 */     GIR_RootConstrainSelectedInstOperands,
     /* 279745 */     // GIR_Coverage, 5074,
     /* 279745 */     GIR_EraseRootFromParent_Done,
     /* 279746 */   // Label 5665: @279746
     /* 279746 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(279775), // Rule ID 5081 //
     /* 279751 */     // MIs[0] Operand 1
     /* 279751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279764 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279773 */     GIR_RootConstrainSelectedInstOperands,
     /* 279774 */     // GIR_Coverage, 5081,
     /* 279774 */     GIR_EraseRootFromParent_Done,
     /* 279775 */   // Label 5666: @279775
     /* 279775 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(279804), // Rule ID 5088 //
     /* 279780 */     // MIs[0] Operand 1
     /* 279780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279793 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279802 */     GIR_RootConstrainSelectedInstOperands,
     /* 279803 */     // GIR_Coverage, 5088,
     /* 279803 */     GIR_EraseRootFromParent_Done,
     /* 279804 */   // Label 5667: @279804
     /* 279804 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(279833), // Rule ID 5095 //
     /* 279809 */     // MIs[0] Operand 1
     /* 279809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279822 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279831 */     GIR_RootConstrainSelectedInstOperands,
     /* 279832 */     // GIR_Coverage, 5095,
     /* 279832 */     GIR_EraseRootFromParent_Done,
     /* 279833 */   // Label 5668: @279833
     /* 279833 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(279862), // Rule ID 5102 //
     /* 279838 */     // MIs[0] Operand 1
     /* 279838 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279851 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279860 */     GIR_RootConstrainSelectedInstOperands,
     /* 279861 */     // GIR_Coverage, 5102,
     /* 279861 */     GIR_EraseRootFromParent_Done,
     /* 279862 */   // Label 5669: @279862
     /* 279862 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279891), // Rule ID 5109 //
     /* 279867 */     // MIs[0] Operand 1
     /* 279867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279880 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279889 */     GIR_RootConstrainSelectedInstOperands,
     /* 279890 */     // GIR_Coverage, 5109,
     /* 279890 */     GIR_EraseRootFromParent_Done,
     /* 279891 */   // Label 5670: @279891
     /* 279891 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279920), // Rule ID 5116 //
     /* 279896 */     // MIs[0] Operand 1
     /* 279896 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279909 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279918 */     GIR_RootConstrainSelectedInstOperands,
     /* 279919 */     // GIR_Coverage, 5116,
     /* 279919 */     GIR_EraseRootFromParent_Done,
     /* 279920 */   // Label 5671: @279920
     /* 279920 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279949), // Rule ID 5123 //
     /* 279925 */     // MIs[0] Operand 1
     /* 279925 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279938 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279947 */     GIR_RootConstrainSelectedInstOperands,
     /* 279948 */     // GIR_Coverage, 5123,
     /* 279948 */     GIR_EraseRootFromParent_Done,
     /* 279949 */   // Label 5672: @279949
     /* 279949 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279978), // Rule ID 5130 //
     /* 279954 */     // MIs[0] Operand 1
     /* 279954 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279967 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279976 */     GIR_RootConstrainSelectedInstOperands,
     /* 279977 */     // GIR_Coverage, 5130,
     /* 279977 */     GIR_EraseRootFromParent_Done,
     /* 279978 */   // Label 5673: @279978
     /* 279978 */   GIM_Reject,
     /* 279979 */ // Label 5643: @279979
     /* 279979 */ GIM_Reject,
     /* 279980 */ // Label 5504: @279980
     /* 279980 */ GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(281027),
     /* 279985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 279991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279995 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(280035), // Rule ID 753 //
     /* 280000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280003 */     // MIs[0] Operand 1
     /* 280003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280012 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280018 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280026 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280033 */     GIR_RootConstrainSelectedInstOperands,
     /* 280034 */     // GIR_Coverage, 753,
     /* 280034 */     GIR_EraseRootFromParent_Done,
     /* 280035 */   // Label 5675: @280035
     /* 280035 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(280075), // Rule ID 760 //
     /* 280040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280043 */     // MIs[0] Operand 1
     /* 280043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280066 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280073 */     GIR_RootConstrainSelectedInstOperands,
     /* 280074 */     // GIR_Coverage, 760,
     /* 280074 */     GIR_EraseRootFromParent_Done,
     /* 280075 */   // Label 5676: @280075
     /* 280075 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(280112), // Rule ID 5175 //
     /* 280080 */     // MIs[0] Operand 1
     /* 280080 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280103 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280110 */     GIR_RootConstrainSelectedInstOperands,
     /* 280111 */     // GIR_Coverage, 5175,
     /* 280111 */     GIR_EraseRootFromParent_Done,
     /* 280112 */   // Label 5677: @280112
     /* 280112 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(280149), // Rule ID 5182 //
     /* 280117 */     // MIs[0] Operand 1
     /* 280117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280126 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280132 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280140 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280147 */     GIR_RootConstrainSelectedInstOperands,
     /* 280148 */     // GIR_Coverage, 5182,
     /* 280148 */     GIR_EraseRootFromParent_Done,
     /* 280149 */   // Label 5678: @280149
     /* 280149 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(280186), // Rule ID 5189 //
     /* 280154 */     // MIs[0] Operand 1
     /* 280154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280177 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280184 */     GIR_RootConstrainSelectedInstOperands,
     /* 280185 */     // GIR_Coverage, 5189,
     /* 280185 */     GIR_EraseRootFromParent_Done,
     /* 280186 */   // Label 5679: @280186
     /* 280186 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(280223), // Rule ID 5196 //
     /* 280191 */     // MIs[0] Operand 1
     /* 280191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280214 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280221 */     GIR_RootConstrainSelectedInstOperands,
     /* 280222 */     // GIR_Coverage, 5196,
     /* 280222 */     GIR_EraseRootFromParent_Done,
     /* 280223 */   // Label 5680: @280223
     /* 280223 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(280260), // Rule ID 5203 //
     /* 280228 */     // MIs[0] Operand 1
     /* 280228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280251 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280258 */     GIR_RootConstrainSelectedInstOperands,
     /* 280259 */     // GIR_Coverage, 5203,
     /* 280259 */     GIR_EraseRootFromParent_Done,
     /* 280260 */   // Label 5681: @280260
     /* 280260 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(280300), // Rule ID 725 //
     /* 280265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280268 */     // MIs[0] Operand 1
     /* 280268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280291 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280298 */     GIR_RootConstrainSelectedInstOperands,
     /* 280299 */     // GIR_Coverage, 725,
     /* 280299 */     GIR_EraseRootFromParent_Done,
     /* 280300 */   // Label 5682: @280300
     /* 280300 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(280340), // Rule ID 735 //
     /* 280305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280308 */     // MIs[0] Operand 1
     /* 280308 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280331 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280338 */     GIR_RootConstrainSelectedInstOperands,
     /* 280339 */     // GIR_Coverage, 735,
     /* 280339 */     GIR_EraseRootFromParent_Done,
     /* 280340 */   // Label 5683: @280340
     /* 280340 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(280380), // Rule ID 736 //
     /* 280345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280348 */     // MIs[0] Operand 1
     /* 280348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 280369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280371 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280378 */     GIR_RootConstrainSelectedInstOperands,
     /* 280379 */     // GIR_Coverage, 736,
     /* 280379 */     GIR_EraseRootFromParent_Done,
     /* 280380 */   // Label 5684: @280380
     /* 280380 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(280420), // Rule ID 746 //
     /* 280385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280388 */     // MIs[0] Operand 1
     /* 280388 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280401 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280407 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280411 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280418 */     GIR_RootConstrainSelectedInstOperands,
     /* 280419 */     // GIR_Coverage, 746,
     /* 280419 */     GIR_EraseRootFromParent_Done,
     /* 280420 */   // Label 5685: @280420
     /* 280420 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(280457), // Rule ID 5140 //
     /* 280425 */     // MIs[0] Operand 1
     /* 280425 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280448 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280455 */     GIR_RootConstrainSelectedInstOperands,
     /* 280456 */     // GIR_Coverage, 5140,
     /* 280456 */     GIR_EraseRootFromParent_Done,
     /* 280457 */   // Label 5686: @280457
     /* 280457 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(280494), // Rule ID 5147 //
     /* 280462 */     // MIs[0] Operand 1
     /* 280462 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280485 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280492 */     GIR_RootConstrainSelectedInstOperands,
     /* 280493 */     // GIR_Coverage, 5147,
     /* 280493 */     GIR_EraseRootFromParent_Done,
     /* 280494 */   // Label 5687: @280494
     /* 280494 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(280531), // Rule ID 5154 //
     /* 280499 */     // MIs[0] Operand 1
     /* 280499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280522 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280529 */     GIR_RootConstrainSelectedInstOperands,
     /* 280530 */     // GIR_Coverage, 5154,
     /* 280530 */     GIR_EraseRootFromParent_Done,
     /* 280531 */   // Label 5688: @280531
     /* 280531 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(280568), // Rule ID 5161 //
     /* 280536 */     // MIs[0] Operand 1
     /* 280536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280559 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280566 */     GIR_RootConstrainSelectedInstOperands,
     /* 280567 */     // GIR_Coverage, 5161,
     /* 280567 */     GIR_EraseRootFromParent_Done,
     /* 280568 */   // Label 5689: @280568
     /* 280568 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(280605), // Rule ID 5168 //
     /* 280573 */     // MIs[0] Operand 1
     /* 280573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280596 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280603 */     GIR_RootConstrainSelectedInstOperands,
     /* 280604 */     // GIR_Coverage, 5168,
     /* 280604 */     GIR_EraseRootFromParent_Done,
     /* 280605 */   // Label 5690: @280605
     /* 280605 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(280637), // Rule ID 1124 //
     /* 280610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280613 */     // MIs[0] Operand 1
     /* 280613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280626 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 280629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280635 */     GIR_RootConstrainSelectedInstOperands,
     /* 280636 */     // GIR_Coverage, 1124,
     /* 280636 */     GIR_EraseRootFromParent_Done,
     /* 280637 */   // Label 5691: @280637
     /* 280637 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(280669), // Rule ID 1131 //
     /* 280642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280645 */     // MIs[0] Operand 1
     /* 280645 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280658 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280667 */     GIR_RootConstrainSelectedInstOperands,
     /* 280668 */     // GIR_Coverage, 1131,
     /* 280668 */     GIR_EraseRootFromParent_Done,
     /* 280669 */   // Label 5692: @280669
     /* 280669 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(280701), // Rule ID 1138 //
     /* 280674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280677 */     // MIs[0] Operand 1
     /* 280677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280690 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280699 */     GIR_RootConstrainSelectedInstOperands,
     /* 280700 */     // GIR_Coverage, 1138,
     /* 280700 */     GIR_EraseRootFromParent_Done,
     /* 280701 */   // Label 5693: @280701
     /* 280701 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(280733), // Rule ID 1145 //
     /* 280706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280709 */     // MIs[0] Operand 1
     /* 280709 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280722 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280731 */     GIR_RootConstrainSelectedInstOperands,
     /* 280732 */     // GIR_Coverage, 1145,
     /* 280732 */     GIR_EraseRootFromParent_Done,
     /* 280733 */   // Label 5694: @280733
     /* 280733 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(280765), // Rule ID 1152 //
     /* 280738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280741 */     // MIs[0] Operand 1
     /* 280741 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280754 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 280757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280763 */     GIR_RootConstrainSelectedInstOperands,
     /* 280764 */     // GIR_Coverage, 1152,
     /* 280764 */     GIR_EraseRootFromParent_Done,
     /* 280765 */   // Label 5695: @280765
     /* 280765 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(280794), // Rule ID 5077 //
     /* 280770 */     // MIs[0] Operand 1
     /* 280770 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280783 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 280786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280792 */     GIR_RootConstrainSelectedInstOperands,
     /* 280793 */     // GIR_Coverage, 5077,
     /* 280793 */     GIR_EraseRootFromParent_Done,
     /* 280794 */   // Label 5696: @280794
     /* 280794 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(280823), // Rule ID 5084 //
     /* 280799 */     // MIs[0] Operand 1
     /* 280799 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280812 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280821 */     GIR_RootConstrainSelectedInstOperands,
     /* 280822 */     // GIR_Coverage, 5084,
     /* 280822 */     GIR_EraseRootFromParent_Done,
     /* 280823 */   // Label 5697: @280823
     /* 280823 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(280852), // Rule ID 5091 //
     /* 280828 */     // MIs[0] Operand 1
     /* 280828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280841 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280850 */     GIR_RootConstrainSelectedInstOperands,
     /* 280851 */     // GIR_Coverage, 5091,
     /* 280851 */     GIR_EraseRootFromParent_Done,
     /* 280852 */   // Label 5698: @280852
     /* 280852 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(280881), // Rule ID 5098 //
     /* 280857 */     // MIs[0] Operand 1
     /* 280857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280870 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280879 */     GIR_RootConstrainSelectedInstOperands,
     /* 280880 */     // GIR_Coverage, 5098,
     /* 280880 */     GIR_EraseRootFromParent_Done,
     /* 280881 */   // Label 5699: @280881
     /* 280881 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(280910), // Rule ID 5105 //
     /* 280886 */     // MIs[0] Operand 1
     /* 280886 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280899 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 280902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280908 */     GIR_RootConstrainSelectedInstOperands,
     /* 280909 */     // GIR_Coverage, 5105,
     /* 280909 */     GIR_EraseRootFromParent_Done,
     /* 280910 */   // Label 5700: @280910
     /* 280910 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(280939), // Rule ID 5112 //
     /* 280915 */     // MIs[0] Operand 1
     /* 280915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280928 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280937 */     GIR_RootConstrainSelectedInstOperands,
     /* 280938 */     // GIR_Coverage, 5112,
     /* 280938 */     GIR_EraseRootFromParent_Done,
     /* 280939 */   // Label 5701: @280939
     /* 280939 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(280968), // Rule ID 5119 //
     /* 280944 */     // MIs[0] Operand 1
     /* 280944 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280957 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280966 */     GIR_RootConstrainSelectedInstOperands,
     /* 280967 */     // GIR_Coverage, 5119,
     /* 280967 */     GIR_EraseRootFromParent_Done,
     /* 280968 */   // Label 5702: @280968
     /* 280968 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(280997), // Rule ID 5126 //
     /* 280973 */     // MIs[0] Operand 1
     /* 280973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 280978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280986 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280995 */     GIR_RootConstrainSelectedInstOperands,
     /* 280996 */     // GIR_Coverage, 5126,
     /* 280996 */     GIR_EraseRootFromParent_Done,
     /* 280997 */   // Label 5703: @280997
     /* 280997 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(281026), // Rule ID 5133 //
     /* 281002 */     // MIs[0] Operand 1
     /* 281002 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 281007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281015 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 281015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 281018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281024 */     GIR_RootConstrainSelectedInstOperands,
     /* 281025 */     // GIR_Coverage, 5133,
     /* 281025 */     GIR_EraseRootFromParent_Done,
     /* 281026 */   // Label 5704: @281026
     /* 281026 */   GIM_Reject,
     /* 281027 */ // Label 5674: @281027
     /* 281027 */ GIM_Reject,
     /* 281028 */ // Label 5505: @281028
     /* 281028 */ GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(282075),
     /* 281033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 281039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281043 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(281083), // Rule ID 751 //
     /* 281048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281051 */     // MIs[0] Operand 1
     /* 281051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281074 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281081 */     GIR_RootConstrainSelectedInstOperands,
     /* 281082 */     // GIR_Coverage, 751,
     /* 281082 */     GIR_EraseRootFromParent_Done,
     /* 281083 */   // Label 5706: @281083
     /* 281083 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(281123), // Rule ID 758 //
     /* 281088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281091 */     // MIs[0] Operand 1
     /* 281091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281100 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281106 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281114 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281121 */     GIR_RootConstrainSelectedInstOperands,
     /* 281122 */     // GIR_Coverage, 758,
     /* 281122 */     GIR_EraseRootFromParent_Done,
     /* 281123 */   // Label 5707: @281123
     /* 281123 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(281160), // Rule ID 5173 //
     /* 281128 */     // MIs[0] Operand 1
     /* 281128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281151 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281158 */     GIR_RootConstrainSelectedInstOperands,
     /* 281159 */     // GIR_Coverage, 5173,
     /* 281159 */     GIR_EraseRootFromParent_Done,
     /* 281160 */   // Label 5708: @281160
     /* 281160 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(281197), // Rule ID 5180 //
     /* 281165 */     // MIs[0] Operand 1
     /* 281165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281180 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281188 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281195 */     GIR_RootConstrainSelectedInstOperands,
     /* 281196 */     // GIR_Coverage, 5180,
     /* 281196 */     GIR_EraseRootFromParent_Done,
     /* 281197 */   // Label 5709: @281197
     /* 281197 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(281234), // Rule ID 5187 //
     /* 281202 */     // MIs[0] Operand 1
     /* 281202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281225 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281232 */     GIR_RootConstrainSelectedInstOperands,
     /* 281233 */     // GIR_Coverage, 5187,
     /* 281233 */     GIR_EraseRootFromParent_Done,
     /* 281234 */   // Label 5710: @281234
     /* 281234 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(281271), // Rule ID 5194 //
     /* 281239 */     // MIs[0] Operand 1
     /* 281239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281262 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281269 */     GIR_RootConstrainSelectedInstOperands,
     /* 281270 */     // GIR_Coverage, 5194,
     /* 281270 */     GIR_EraseRootFromParent_Done,
     /* 281271 */   // Label 5711: @281271
     /* 281271 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(281308), // Rule ID 5201 //
     /* 281276 */     // MIs[0] Operand 1
     /* 281276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281299 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281306 */     GIR_RootConstrainSelectedInstOperands,
     /* 281307 */     // GIR_Coverage, 5201,
     /* 281307 */     GIR_EraseRootFromParent_Done,
     /* 281308 */   // Label 5712: @281308
     /* 281308 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(281348), // Rule ID 723 //
     /* 281313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281316 */     // MIs[0] Operand 1
     /* 281316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281329 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281335 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281339 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281346 */     GIR_RootConstrainSelectedInstOperands,
     /* 281347 */     // GIR_Coverage, 723,
     /* 281347 */     GIR_EraseRootFromParent_Done,
     /* 281348 */   // Label 5713: @281348
     /* 281348 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(281388), // Rule ID 731 //
     /* 281353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281356 */     // MIs[0] Operand 1
     /* 281356 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281379 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281386 */     GIR_RootConstrainSelectedInstOperands,
     /* 281387 */     // GIR_Coverage, 731,
     /* 281387 */     GIR_EraseRootFromParent_Done,
     /* 281388 */   // Label 5714: @281388
     /* 281388 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(281428), // Rule ID 732 //
     /* 281393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281396 */     // MIs[0] Operand 1
     /* 281396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 281417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281419 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281426 */     GIR_RootConstrainSelectedInstOperands,
     /* 281427 */     // GIR_Coverage, 732,
     /* 281427 */     GIR_EraseRootFromParent_Done,
     /* 281428 */   // Label 5715: @281428
     /* 281428 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(281468), // Rule ID 744 //
     /* 281433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281436 */     // MIs[0] Operand 1
     /* 281436 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281449 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281455 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281459 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281466 */     GIR_RootConstrainSelectedInstOperands,
     /* 281467 */     // GIR_Coverage, 744,
     /* 281467 */     GIR_EraseRootFromParent_Done,
     /* 281468 */   // Label 5716: @281468
     /* 281468 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(281505), // Rule ID 5138 //
     /* 281473 */     // MIs[0] Operand 1
     /* 281473 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281496 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281503 */     GIR_RootConstrainSelectedInstOperands,
     /* 281504 */     // GIR_Coverage, 5138,
     /* 281504 */     GIR_EraseRootFromParent_Done,
     /* 281505 */   // Label 5717: @281505
     /* 281505 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(281542), // Rule ID 5145 //
     /* 281510 */     // MIs[0] Operand 1
     /* 281510 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281533 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281540 */     GIR_RootConstrainSelectedInstOperands,
     /* 281541 */     // GIR_Coverage, 5145,
     /* 281541 */     GIR_EraseRootFromParent_Done,
     /* 281542 */   // Label 5718: @281542
     /* 281542 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(281579), // Rule ID 5152 //
     /* 281547 */     // MIs[0] Operand 1
     /* 281547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281570 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281577 */     GIR_RootConstrainSelectedInstOperands,
     /* 281578 */     // GIR_Coverage, 5152,
     /* 281578 */     GIR_EraseRootFromParent_Done,
     /* 281579 */   // Label 5719: @281579
     /* 281579 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(281616), // Rule ID 5159 //
     /* 281584 */     // MIs[0] Operand 1
     /* 281584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281607 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281614 */     GIR_RootConstrainSelectedInstOperands,
     /* 281615 */     // GIR_Coverage, 5159,
     /* 281615 */     GIR_EraseRootFromParent_Done,
     /* 281616 */   // Label 5720: @281616
     /* 281616 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(281653), // Rule ID 5166 //
     /* 281621 */     // MIs[0] Operand 1
     /* 281621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281644 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281651 */     GIR_RootConstrainSelectedInstOperands,
     /* 281652 */     // GIR_Coverage, 5166,
     /* 281652 */     GIR_EraseRootFromParent_Done,
     /* 281653 */   // Label 5721: @281653
     /* 281653 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(281685), // Rule ID 1122 //
     /* 281658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281661 */     // MIs[0] Operand 1
     /* 281661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281674 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 281677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281683 */     GIR_RootConstrainSelectedInstOperands,
     /* 281684 */     // GIR_Coverage, 1122,
     /* 281684 */     GIR_EraseRootFromParent_Done,
     /* 281685 */   // Label 5722: @281685
     /* 281685 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(281717), // Rule ID 1129 //
     /* 281690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281693 */     // MIs[0] Operand 1
     /* 281693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281706 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 281709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281715 */     GIR_RootConstrainSelectedInstOperands,
     /* 281716 */     // GIR_Coverage, 1129,
     /* 281716 */     GIR_EraseRootFromParent_Done,
     /* 281717 */   // Label 5723: @281717
     /* 281717 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(281749), // Rule ID 1136 //
     /* 281722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281725 */     // MIs[0] Operand 1
     /* 281725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281738 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281747 */     GIR_RootConstrainSelectedInstOperands,
     /* 281748 */     // GIR_Coverage, 1136,
     /* 281748 */     GIR_EraseRootFromParent_Done,
     /* 281749 */   // Label 5724: @281749
     /* 281749 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(281781), // Rule ID 1143 //
     /* 281754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281757 */     // MIs[0] Operand 1
     /* 281757 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 281762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281770 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 281773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281779 */     GIR_RootConstrainSelectedInstOperands,
     /* 281780 */     // GIR_Coverage, 1143,
     /* 281780 */     GIR_EraseRootFromParent_Done,
     /* 281781 */   // Label 5725: @281781
     /* 281781 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(281813), // Rule ID 1150 //
     /* 281786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281789 */     // MIs[0] Operand 1
     /* 281789 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 281794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281802 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 281805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281811 */     GIR_RootConstrainSelectedInstOperands,
     /* 281812 */     // GIR_Coverage, 1150,
     /* 281812 */     GIR_EraseRootFromParent_Done,
     /* 281813 */   // Label 5726: @281813
     /* 281813 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(281842), // Rule ID 5075 //
     /* 281818 */     // MIs[0] Operand 1
     /* 281818 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281831 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 281834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281840 */     GIR_RootConstrainSelectedInstOperands,
     /* 281841 */     // GIR_Coverage, 5075,
     /* 281841 */     GIR_EraseRootFromParent_Done,
     /* 281842 */   // Label 5727: @281842
     /* 281842 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(281871), // Rule ID 5082 //
     /* 281847 */     // MIs[0] Operand 1
     /* 281847 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281860 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281869 */     GIR_RootConstrainSelectedInstOperands,
     /* 281870 */     // GIR_Coverage, 5082,
     /* 281870 */     GIR_EraseRootFromParent_Done,
     /* 281871 */   // Label 5728: @281871
     /* 281871 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(281900), // Rule ID 5089 //
     /* 281876 */     // MIs[0] Operand 1
     /* 281876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281889 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 281892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281898 */     GIR_RootConstrainSelectedInstOperands,
     /* 281899 */     // GIR_Coverage, 5089,
     /* 281899 */     GIR_EraseRootFromParent_Done,
     /* 281900 */   // Label 5729: @281900
     /* 281900 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(281929), // Rule ID 5096 //
     /* 281905 */     // MIs[0] Operand 1
     /* 281905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 281910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281918 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 281921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281927 */     GIR_RootConstrainSelectedInstOperands,
     /* 281928 */     // GIR_Coverage, 5096,
     /* 281928 */     GIR_EraseRootFromParent_Done,
     /* 281929 */   // Label 5730: @281929
     /* 281929 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(281958), // Rule ID 5103 //
     /* 281934 */     // MIs[0] Operand 1
     /* 281934 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 281939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281947 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 281950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281956 */     GIR_RootConstrainSelectedInstOperands,
     /* 281957 */     // GIR_Coverage, 5103,
     /* 281957 */     GIR_EraseRootFromParent_Done,
     /* 281958 */   // Label 5731: @281958
     /* 281958 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(281987), // Rule ID 5110 //
     /* 281963 */     // MIs[0] Operand 1
     /* 281963 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281976 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 281976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281985 */     GIR_RootConstrainSelectedInstOperands,
     /* 281986 */     // GIR_Coverage, 5110,
     /* 281986 */     GIR_EraseRootFromParent_Done,
     /* 281987 */   // Label 5732: @281987
     /* 281987 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(282016), // Rule ID 5117 //
     /* 281992 */     // MIs[0] Operand 1
     /* 281992 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282005 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 282005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 282008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282014 */     GIR_RootConstrainSelectedInstOperands,
     /* 282015 */     // GIR_Coverage, 5117,
     /* 282015 */     GIR_EraseRootFromParent_Done,
     /* 282016 */   // Label 5733: @282016
     /* 282016 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(282045), // Rule ID 5124 //
     /* 282021 */     // MIs[0] Operand 1
     /* 282021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 282026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282034 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 282034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 282037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282043 */     GIR_RootConstrainSelectedInstOperands,
     /* 282044 */     // GIR_Coverage, 5124,
     /* 282044 */     GIR_EraseRootFromParent_Done,
     /* 282045 */   // Label 5734: @282045
     /* 282045 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(282074), // Rule ID 5131 //
     /* 282050 */     // MIs[0] Operand 1
     /* 282050 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 282055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282063 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 282063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 282066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282072 */     GIR_RootConstrainSelectedInstOperands,
     /* 282073 */     // GIR_Coverage, 5131,
     /* 282073 */     GIR_EraseRootFromParent_Done,
     /* 282074 */   // Label 5735: @282074
     /* 282074 */   GIM_Reject,
     /* 282075 */ // Label 5705: @282075
     /* 282075 */ GIM_Reject,
     /* 282076 */ // Label 5506: @282076
     /* 282076 */ GIM_Reject,
     /* 282077 */ // Label 52: @282077
     /* 282077 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5748*/ GIMT_Encode4(283121),
     /* 282088 */ /*GILLT_nxv1s1*//*Label 5736*/ GIMT_Encode4(282136),
     /* 282092 */ /*GILLT_nxv2s1*//*Label 5737*/ GIMT_Encode4(282165),
     /* 282096 */ /*GILLT_nxv2s16*//*Label 5738*/ GIMT_Encode4(282194),
     /* 282100 */ /*GILLT_nxv2s32*//*Label 5739*/ GIMT_Encode4(282279),
     /* 282104 */ /*GILLT_nxv2s64*//*Label 5740*/ GIMT_Encode4(282364),
     /* 282108 */ /*GILLT_nxv4s1*//*Label 5741*/ GIMT_Encode4(282530),
     /* 282112 */ /*GILLT_nxv4s16*//*Label 5742*/ GIMT_Encode4(282559),
     /* 282116 */ /*GILLT_nxv4s32*//*Label 5743*/ GIMT_Encode4(282644),
     /* 282120 */ /*GILLT_nxv8s1*//*Label 5744*/ GIMT_Encode4(282810),
     /* 282124 */ /*GILLT_nxv8s16*//*Label 5745*/ GIMT_Encode4(282839),
     /* 282128 */ /*GILLT_nxv16s1*//*Label 5746*/ GIMT_Encode4(283005),
     /* 282132 */ /*GILLT_nxv16s8*//*Label 5747*/ GIMT_Encode4(283034),
     /* 282136 */ // Label 5736: @282136
     /* 282136 */ GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(282164), // Rule ID 8469 //
     /* 282141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 282147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 282150 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 282153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282157 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 282157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282162 */   GIR_RootConstrainSelectedInstOperands,
     /* 282163 */   // GIR_Coverage, 8469,
     /* 282163 */   GIR_Done,
     /* 282164 */ // Label 5749: @282164
     /* 282164 */ GIM_Reject,
     /* 282165 */ // Label 5737: @282165
     /* 282165 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(282193), // Rule ID 8468 //
     /* 282170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 282179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 282182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282186 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 282186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282191 */   GIR_RootConstrainSelectedInstOperands,
     /* 282192 */   // GIR_Coverage, 8468,
     /* 282192 */   GIR_Done,
     /* 282193 */ // Label 5750: @282193
     /* 282193 */ GIM_Reject,
     /* 282194 */ // Label 5738: @282194
     /* 282194 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(282278),
     /* 282199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 282205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 282208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282212 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(282262), // Rule ID 3161 //
     /* 282217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282240 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282244 */     // MIs[2] Operand 1
     /* 282244 */     // No operand predicates
     /* 282244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282246 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282251 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282253 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282255 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282260 */     GIR_RootConstrainSelectedInstOperands,
     /* 282261 */     // GIR_Coverage, 3161,
     /* 282261 */     GIR_EraseRootFromParent_Done,
     /* 282262 */   // Label 5752: @282262
     /* 282262 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(282277), // Rule ID 2741 //
     /* 282267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282270 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 282270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282275 */     GIR_RootConstrainSelectedInstOperands,
     /* 282276 */     // GIR_Coverage, 2741,
     /* 282276 */     GIR_Done,
     /* 282277 */   // Label 5753: @282277
     /* 282277 */   GIM_Reject,
     /* 282278 */ // Label 5751: @282278
     /* 282278 */ GIM_Reject,
     /* 282279 */ // Label 5739: @282279
     /* 282279 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(282363),
     /* 282284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 282290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 282293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282297 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(282347), // Rule ID 3163 //
     /* 282302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282325 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 282329 */     // MIs[2] Operand 1
     /* 282329 */     // No operand predicates
     /* 282329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282331 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 282331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 282334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282336 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282338 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282340 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 282345 */     GIR_RootConstrainSelectedInstOperands,
     /* 282346 */     // GIR_Coverage, 3163,
     /* 282346 */     GIR_EraseRootFromParent_Done,
     /* 282347 */   // Label 5755: @282347
     /* 282347 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(282362), // Rule ID 2742 //
     /* 282352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282355 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 282355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282360 */     GIR_RootConstrainSelectedInstOperands,
     /* 282361 */     // GIR_Coverage, 2742,
     /* 282361 */     GIR_Done,
     /* 282362 */   // Label 5756: @282362
     /* 282362 */   GIM_Reject,
     /* 282363 */ // Label 5754: @282363
     /* 282363 */ GIM_Reject,
     /* 282364 */ // Label 5740: @282364
     /* 282364 */ GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(282529),
     /* 282369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282375 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(282432), // Rule ID 3164 //
     /* 282380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 282402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282410 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 282414 */     // MIs[2] Operand 1
     /* 282414 */     // No operand predicates
     /* 282414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282416 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 282416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 282419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282421 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282423 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282425 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 282430 */     GIR_RootConstrainSelectedInstOperands,
     /* 282431 */     // GIR_Coverage, 3164,
     /* 282431 */     GIR_EraseRootFromParent_Done,
     /* 282432 */   // Label 5758: @282432
     /* 282432 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(282484), // Rule ID 7515 //
     /* 282437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282460 */     // MIs[0] Op2
     /* 282460 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282467 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 282467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 282470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282482 */     GIR_RootConstrainSelectedInstOperands,
     /* 282483 */     // GIR_Coverage, 7515,
     /* 282483 */     GIR_EraseRootFromParent_Done,
     /* 282484 */   // Label 5759: @282484
     /* 282484 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(282506), // Rule ID 2737 //
     /* 282489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282499 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 282499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282504 */     GIR_RootConstrainSelectedInstOperands,
     /* 282505 */     // GIR_Coverage, 2737,
     /* 282505 */     GIR_Done,
     /* 282506 */   // Label 5760: @282506
     /* 282506 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(282528), // Rule ID 2743 //
     /* 282511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282521 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 282521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282526 */     GIR_RootConstrainSelectedInstOperands,
     /* 282527 */     // GIR_Coverage, 2743,
     /* 282527 */     GIR_Done,
     /* 282528 */   // Label 5761: @282528
     /* 282528 */   GIM_Reject,
     /* 282529 */ // Label 5757: @282529
     /* 282529 */ GIM_Reject,
     /* 282530 */ // Label 5741: @282530
     /* 282530 */ GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(282558), // Rule ID 8467 //
     /* 282535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 282544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 282547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282551 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 282551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282556 */   GIR_RootConstrainSelectedInstOperands,
     /* 282557 */   // GIR_Coverage, 8467,
     /* 282557 */   GIR_Done,
     /* 282558 */ // Label 5762: @282558
     /* 282558 */ GIM_Reject,
     /* 282559 */ // Label 5742: @282559
     /* 282559 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(282643),
     /* 282564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 282570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 282573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282577 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(282627), // Rule ID 3160 //
     /* 282582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282605 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282609 */     // MIs[2] Operand 1
     /* 282609 */     // No operand predicates
     /* 282609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282611 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282616 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282618 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282620 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282625 */     GIR_RootConstrainSelectedInstOperands,
     /* 282626 */     // GIR_Coverage, 3160,
     /* 282626 */     GIR_EraseRootFromParent_Done,
     /* 282627 */   // Label 5764: @282627
     /* 282627 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(282642), // Rule ID 2739 //
     /* 282632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282635 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 282635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282640 */     GIR_RootConstrainSelectedInstOperands,
     /* 282641 */     // GIR_Coverage, 2739,
     /* 282641 */     GIR_Done,
     /* 282642 */   // Label 5765: @282642
     /* 282642 */   GIM_Reject,
     /* 282643 */ // Label 5763: @282643
     /* 282643 */ GIM_Reject,
     /* 282644 */ // Label 5743: @282644
     /* 282644 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(282809),
     /* 282649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282655 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(282712), // Rule ID 3162 //
     /* 282660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282690 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 282694 */     // MIs[2] Operand 1
     /* 282694 */     // No operand predicates
     /* 282694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282696 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 282696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 282699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282701 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282703 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282705 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 282710 */     GIR_RootConstrainSelectedInstOperands,
     /* 282711 */     // GIR_Coverage, 3162,
     /* 282711 */     GIR_EraseRootFromParent_Done,
     /* 282712 */   // Label 5767: @282712
     /* 282712 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(282764), // Rule ID 7513 //
     /* 282717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282740 */     // MIs[0] Op2
     /* 282740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282747 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 282747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 282750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282762 */     GIR_RootConstrainSelectedInstOperands,
     /* 282763 */     // GIR_Coverage, 7513,
     /* 282763 */     GIR_EraseRootFromParent_Done,
     /* 282764 */   // Label 5768: @282764
     /* 282764 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(282786), // Rule ID 2736 //
     /* 282769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282779 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 282779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282784 */     GIR_RootConstrainSelectedInstOperands,
     /* 282785 */     // GIR_Coverage, 2736,
     /* 282785 */     GIR_Done,
     /* 282786 */   // Label 5769: @282786
     /* 282786 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(282808), // Rule ID 2740 //
     /* 282791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282801 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 282801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282806 */     GIR_RootConstrainSelectedInstOperands,
     /* 282807 */     // GIR_Coverage, 2740,
     /* 282807 */     GIR_Done,
     /* 282808 */   // Label 5770: @282808
     /* 282808 */   GIM_Reject,
     /* 282809 */ // Label 5766: @282809
     /* 282809 */ GIM_Reject,
     /* 282810 */ // Label 5744: @282810
     /* 282810 */ GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(282838), // Rule ID 8466 //
     /* 282815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 282821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 282824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 282827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282831 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 282831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282836 */   GIR_RootConstrainSelectedInstOperands,
     /* 282837 */   // GIR_Coverage, 8466,
     /* 282837 */   GIR_Done,
     /* 282838 */ // Label 5771: @282838
     /* 282838 */ GIM_Reject,
     /* 282839 */ // Label 5745: @282839
     /* 282839 */ GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(283004),
     /* 282844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 282847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282850 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(282907), // Rule ID 3159 //
     /* 282855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282885 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282889 */     // MIs[2] Operand 1
     /* 282889 */     // No operand predicates
     /* 282889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282891 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282896 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282898 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282900 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282905 */     GIR_RootConstrainSelectedInstOperands,
     /* 282906 */     // GIR_Coverage, 3159,
     /* 282906 */     GIR_EraseRootFromParent_Done,
     /* 282907 */   // Label 5773: @282907
     /* 282907 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(282959), // Rule ID 7511 //
     /* 282912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282935 */     // MIs[0] Op2
     /* 282935 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282942 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 282942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 282945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282957 */     GIR_RootConstrainSelectedInstOperands,
     /* 282958 */     // GIR_Coverage, 7511,
     /* 282958 */     GIR_EraseRootFromParent_Done,
     /* 282959 */   // Label 5774: @282959
     /* 282959 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(282981), // Rule ID 2735 //
     /* 282964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282974 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 282974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 282979 */     GIR_RootConstrainSelectedInstOperands,
     /* 282980 */     // GIR_Coverage, 2735,
     /* 282980 */     GIR_Done,
     /* 282981 */   // Label 5775: @282981
     /* 282981 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(283003), // Rule ID 2738 //
     /* 282986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282996 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 282996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 283001 */     GIR_RootConstrainSelectedInstOperands,
     /* 283002 */     // GIR_Coverage, 2738,
     /* 283002 */     GIR_Done,
     /* 283003 */   // Label 5776: @283003
     /* 283003 */   GIM_Reject,
     /* 283004 */ // Label 5772: @283004
     /* 283004 */ GIM_Reject,
     /* 283005 */ // Label 5746: @283005
     /* 283005 */ GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(283033), // Rule ID 8465 //
     /* 283010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 283016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 283019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 283022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 283026 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 283026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 283031 */   GIR_RootConstrainSelectedInstOperands,
     /* 283032 */   // GIR_Coverage, 8465,
     /* 283032 */   GIR_Done,
     /* 283033 */ // Label 5777: @283033
     /* 283033 */ GIM_Reject,
     /* 283034 */ // Label 5747: @283034
     /* 283034 */ GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(283120),
     /* 283039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 283042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283045 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(283097), // Rule ID 7509 //
     /* 283050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 283065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283073 */     // MIs[0] Op2
     /* 283073 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 283078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283080 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 283080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 283083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 283085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 283087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 283091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 283095 */     GIR_RootConstrainSelectedInstOperands,
     /* 283096 */     // GIR_Coverage, 7509,
     /* 283096 */     GIR_EraseRootFromParent_Done,
     /* 283097 */   // Label 5779: @283097
     /* 283097 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(283119), // Rule ID 2734 //
     /* 283102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 283108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283112 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 283112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 283117 */     GIR_RootConstrainSelectedInstOperands,
     /* 283118 */     // GIR_Coverage, 2734,
     /* 283118 */     GIR_Done,
     /* 283119 */   // Label 5780: @283119
     /* 283119 */   GIM_Reject,
     /* 283120 */ // Label 5778: @283120
     /* 283120 */ GIM_Reject,
     /* 283121 */ // Label 5748: @283121
     /* 283121 */ GIM_Reject,
     /* 283122 */ // Label 53: @283122
     /* 283122 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5785*/ GIMT_Encode4(283605),
     /* 283133 */ /*GILLT_s64*//*Label 5781*/ GIMT_Encode4(283169), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283153 */ /*GILLT_v4s32*//*Label 5782*/ GIMT_Encode4(283200), GIMT_Encode4(0),
     /* 283161 */ /*GILLT_v8s16*//*Label 5783*/ GIMT_Encode4(283335),
     /* 283165 */ /*GILLT_v16s8*//*Label 5784*/ GIMT_Encode4(283470),
     /* 283169 */ // Label 5781: @283169
     /* 283169 */ GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(283199), // Rule ID 128 //
     /* 283174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283192 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 283192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 283197 */   GIR_RootConstrainSelectedInstOperands,
     /* 283198 */   // GIR_Coverage, 128,
     /* 283198 */   GIR_Done,
     /* 283199 */ // Label 5786: @283199
     /* 283199 */ GIM_Reject,
     /* 283200 */ // Label 5782: @283200
     /* 283200 */ GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(283334), // Rule ID 6535 //
     /* 283205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283223 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 283223 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283226 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 283230 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283235 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283239 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283245 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283248 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283252 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283257 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283263 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283273 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283276 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283280 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283285 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283291 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283296 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 283308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283313 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 283324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283332 */   GIR_RootConstrainSelectedInstOperands,
     /* 283333 */   // GIR_Coverage, 6535,
     /* 283333 */   GIR_EraseRootFromParent_Done,
     /* 283334 */ // Label 5787: @283334
     /* 283334 */ GIM_Reject,
     /* 283335 */ // Label 5783: @283335
     /* 283335 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283469), // Rule ID 6534 //
     /* 283340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283358 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 283358 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283361 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 283365 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283370 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283374 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283380 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283383 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283387 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283392 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283398 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283403 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283408 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283411 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283415 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283420 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283426 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283431 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 283443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 283459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283467 */   GIR_RootConstrainSelectedInstOperands,
     /* 283468 */   // GIR_Coverage, 6534,
     /* 283468 */   GIR_EraseRootFromParent_Done,
     /* 283469 */ // Label 5788: @283469
     /* 283469 */ GIM_Reject,
     /* 283470 */ // Label 5784: @283470
     /* 283470 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283604), // Rule ID 6533 //
     /* 283475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283493 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 283493 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283496 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 283500 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283505 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283509 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283515 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283518 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283522 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283527 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283533 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283538 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283543 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283546 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283550 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283555 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283561 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283566 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 283578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283583 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 283594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283602 */   GIR_RootConstrainSelectedInstOperands,
     /* 283603 */   // GIR_Coverage, 6533,
     /* 283603 */   GIR_EraseRootFromParent_Done,
     /* 283604 */ // Label 5789: @283604
     /* 283604 */ GIM_Reject,
     /* 283605 */ // Label 5785: @283605
     /* 283605 */ GIM_Reject,
     /* 283606 */ // Label 54: @283606
     /* 283606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5794*/ GIMT_Encode4(284089),
     /* 283617 */ /*GILLT_s64*//*Label 5790*/ GIMT_Encode4(283653), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283637 */ /*GILLT_v4s32*//*Label 5791*/ GIMT_Encode4(283684), GIMT_Encode4(0),
     /* 283645 */ /*GILLT_v8s16*//*Label 5792*/ GIMT_Encode4(283819),
     /* 283649 */ /*GILLT_v16s8*//*Label 5793*/ GIMT_Encode4(283954),
     /* 283653 */ // Label 5790: @283653
     /* 283653 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(283683), // Rule ID 127 //
     /* 283658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283676 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 283676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 283681 */   GIR_RootConstrainSelectedInstOperands,
     /* 283682 */   // GIR_Coverage, 127,
     /* 283682 */   GIR_Done,
     /* 283683 */ // Label 5795: @283683
     /* 283683 */ GIM_Reject,
     /* 283684 */ // Label 5791: @283684
     /* 283684 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283818), // Rule ID 6532 //
     /* 283689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283707 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 283707 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283710 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 283714 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283719 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283723 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283729 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283732 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283736 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283741 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283747 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283752 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283757 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283760 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283764 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283769 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283775 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283780 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 283792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283797 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283800 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 283808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283816 */   GIR_RootConstrainSelectedInstOperands,
     /* 283817 */   // GIR_Coverage, 6532,
     /* 283817 */   GIR_EraseRootFromParent_Done,
     /* 283818 */ // Label 5796: @283818
     /* 283818 */ GIM_Reject,
     /* 283819 */ // Label 5792: @283819
     /* 283819 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(283953), // Rule ID 6531 //
     /* 283824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283842 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 283842 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283845 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 283849 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283854 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283858 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283864 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283867 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283871 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283876 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283882 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283887 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283892 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283895 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283899 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283904 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283910 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283915 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 283927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283932 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283935 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 283943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283951 */   GIR_RootConstrainSelectedInstOperands,
     /* 283952 */   // GIR_Coverage, 6531,
     /* 283952 */   GIR_EraseRootFromParent_Done,
     /* 283953 */ // Label 5797: @283953
     /* 283953 */ GIM_Reject,
     /* 283954 */ // Label 5793: @283954
     /* 283954 */ GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(284088), // Rule ID 6530 //
     /* 283959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283977 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 283977 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283980 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 283984 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283989 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283993 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283999 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 284002 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284006 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284011 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 284017 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284022 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 284030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284039 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284045 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284050 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 284058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 284062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284067 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284070 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 284073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 284078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 284086 */   GIR_RootConstrainSelectedInstOperands,
     /* 284087 */   // GIR_Coverage, 6530,
     /* 284087 */   GIR_EraseRootFromParent_Done,
     /* 284088 */ // Label 5798: @284088
     /* 284088 */ GIM_Reject,
     /* 284089 */ // Label 5794: @284089
     /* 284089 */ GIM_Reject,
     /* 284090 */ // Label 55: @284090
     /* 284090 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5810*/ GIMT_Encode4(284519),
     /* 284101 */ /*GILLT_v2s32*//*Label 5799*/ GIMT_Encode4(284177),
     /* 284105 */ /*GILLT_v2s64*//*Label 5800*/ GIMT_Encode4(284211),
     /* 284109 */ /*GILLT_v4s16*//*Label 5801*/ GIMT_Encode4(284245),
     /* 284113 */ /*GILLT_v4s32*//*Label 5802*/ GIMT_Encode4(284279),
     /* 284117 */ /*GILLT_v8s8*//*Label 5803*/ GIMT_Encode4(284313),
     /* 284121 */ /*GILLT_v8s16*//*Label 5804*/ GIMT_Encode4(284347),
     /* 284125 */ /*GILLT_v16s8*//*Label 5805*/ GIMT_Encode4(284381), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284145 */ /*GILLT_nxv2s64*//*Label 5806*/ GIMT_Encode4(284415), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284157 */ /*GILLT_nxv4s32*//*Label 5807*/ GIMT_Encode4(284441), GIMT_Encode4(0),
     /* 284165 */ /*GILLT_nxv8s16*//*Label 5808*/ GIMT_Encode4(284467), GIMT_Encode4(0),
     /* 284173 */ /*GILLT_nxv16s8*//*Label 5809*/ GIMT_Encode4(284493),
     /* 284177 */ // Label 5799: @284177
     /* 284177 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(284210), // Rule ID 5023 //
     /* 284182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284203 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 284203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 284208 */   GIR_RootConstrainSelectedInstOperands,
     /* 284209 */   // GIR_Coverage, 5023,
     /* 284209 */   GIR_Done,
     /* 284210 */ // Label 5811: @284210
     /* 284210 */ GIM_Reject,
     /* 284211 */ // Label 5800: @284211
     /* 284211 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(284244), // Rule ID 5027 //
     /* 284216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284237 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 284237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 284242 */   GIR_RootConstrainSelectedInstOperands,
     /* 284243 */   // GIR_Coverage, 5027,
     /* 284243 */   GIR_Done,
     /* 284244 */ // Label 5812: @284244
     /* 284244 */ GIM_Reject,
     /* 284245 */ // Label 5801: @284245
     /* 284245 */ GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(284278), // Rule ID 5022 //
     /* 284250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284271 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 284271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 284276 */   GIR_RootConstrainSelectedInstOperands,
     /* 284277 */   // GIR_Coverage, 5022,
     /* 284277 */   GIR_Done,
     /* 284278 */ // Label 5813: @284278
     /* 284278 */ GIM_Reject,
     /* 284279 */ // Label 5802: @284279
     /* 284279 */ GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(284312), // Rule ID 5026 //
     /* 284284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284305 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 284305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 284310 */   GIR_RootConstrainSelectedInstOperands,
     /* 284311 */   // GIR_Coverage, 5026,
     /* 284311 */   GIR_Done,
     /* 284312 */ // Label 5814: @284312
     /* 284312 */ GIM_Reject,
     /* 284313 */ // Label 5803: @284313
     /* 284313 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(284346), // Rule ID 5021 //
     /* 284318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284339 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 284339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 284344 */   GIR_RootConstrainSelectedInstOperands,
     /* 284345 */   // GIR_Coverage, 5021,
     /* 284345 */   GIR_Done,
     /* 284346 */ // Label 5815: @284346
     /* 284346 */ GIM_Reject,
     /* 284347 */ // Label 5804: @284347
     /* 284347 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(284380), // Rule ID 5025 //
     /* 284352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284373 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 284373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 284378 */   GIR_RootConstrainSelectedInstOperands,
     /* 284379 */   // GIR_Coverage, 5025,
     /* 284379 */   GIR_Done,
     /* 284380 */ // Label 5816: @284380
     /* 284380 */ GIM_Reject,
     /* 284381 */ // Label 5805: @284381
     /* 284381 */ GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(284414), // Rule ID 5024 //
     /* 284386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284407 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 284407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 284412 */   GIR_RootConstrainSelectedInstOperands,
     /* 284413 */   // GIR_Coverage, 5024,
     /* 284413 */   GIR_Done,
     /* 284414 */ // Label 5817: @284414
     /* 284414 */ GIM_Reject,
     /* 284415 */ // Label 5806: @284415
     /* 284415 */ GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(284440), // Rule ID 7467 //
     /* 284420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284433 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 284433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 284438 */   GIR_RootConstrainSelectedInstOperands,
     /* 284439 */   // GIR_Coverage, 7467,
     /* 284439 */   GIR_Done,
     /* 284440 */ // Label 5818: @284440
     /* 284440 */ GIM_Reject,
     /* 284441 */ // Label 5807: @284441
     /* 284441 */ GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(284466), // Rule ID 7466 //
     /* 284446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284459 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 284459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 284464 */   GIR_RootConstrainSelectedInstOperands,
     /* 284465 */   // GIR_Coverage, 7466,
     /* 284465 */   GIR_Done,
     /* 284466 */ // Label 5819: @284466
     /* 284466 */ GIM_Reject,
     /* 284467 */ // Label 5808: @284467
     /* 284467 */ GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(284492), // Rule ID 7465 //
     /* 284472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284485 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 284485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 284490 */   GIR_RootConstrainSelectedInstOperands,
     /* 284491 */   // GIR_Coverage, 7465,
     /* 284491 */   GIR_Done,
     /* 284492 */ // Label 5820: @284492
     /* 284492 */ GIM_Reject,
     /* 284493 */ // Label 5809: @284493
     /* 284493 */ GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(284518), // Rule ID 7464 //
     /* 284498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 284507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284511 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 284511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 284516 */   GIR_RootConstrainSelectedInstOperands,
     /* 284517 */   // GIR_Coverage, 7464,
     /* 284517 */   GIR_Done,
     /* 284518 */ // Label 5821: @284518
     /* 284518 */ GIM_Reject,
     /* 284519 */ // Label 5810: @284519
     /* 284519 */ GIM_Reject,
     /* 284520 */ // Label 56: @284520
     /* 284520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5833*/ GIMT_Encode4(284949),
     /* 284531 */ /*GILLT_v2s32*//*Label 5822*/ GIMT_Encode4(284607),
     /* 284535 */ /*GILLT_v2s64*//*Label 5823*/ GIMT_Encode4(284641),
     /* 284539 */ /*GILLT_v4s16*//*Label 5824*/ GIMT_Encode4(284675),
     /* 284543 */ /*GILLT_v4s32*//*Label 5825*/ GIMT_Encode4(284709),
     /* 284547 */ /*GILLT_v8s8*//*Label 5826*/ GIMT_Encode4(284743),
     /* 284551 */ /*GILLT_v8s16*//*Label 5827*/ GIMT_Encode4(284777),
     /* 284555 */ /*GILLT_v16s8*//*Label 5828*/ GIMT_Encode4(284811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284575 */ /*GILLT_nxv2s64*//*Label 5829*/ GIMT_Encode4(284845), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284587 */ /*GILLT_nxv4s32*//*Label 5830*/ GIMT_Encode4(284871), GIMT_Encode4(0),
     /* 284595 */ /*GILLT_nxv8s16*//*Label 5831*/ GIMT_Encode4(284897), GIMT_Encode4(0),
     /* 284603 */ /*GILLT_nxv16s8*//*Label 5832*/ GIMT_Encode4(284923),
     /* 284607 */ // Label 5822: @284607
     /* 284607 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(284640), // Rule ID 2477 //
     /* 284612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284633 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 284633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 284638 */   GIR_RootConstrainSelectedInstOperands,
     /* 284639 */   // GIR_Coverage, 2477,
     /* 284639 */   GIR_Done,
     /* 284640 */ // Label 5834: @284640
     /* 284640 */ GIM_Reject,
     /* 284641 */ // Label 5823: @284641
     /* 284641 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(284674), // Rule ID 2481 //
     /* 284646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284667 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 284667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 284672 */   GIR_RootConstrainSelectedInstOperands,
     /* 284673 */   // GIR_Coverage, 2481,
     /* 284673 */   GIR_Done,
     /* 284674 */ // Label 5835: @284674
     /* 284674 */ GIM_Reject,
     /* 284675 */ // Label 5824: @284675
     /* 284675 */ GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(284708), // Rule ID 2476 //
     /* 284680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284701 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 284701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 284706 */   GIR_RootConstrainSelectedInstOperands,
     /* 284707 */   // GIR_Coverage, 2476,
     /* 284707 */   GIR_Done,
     /* 284708 */ // Label 5836: @284708
     /* 284708 */ GIM_Reject,
     /* 284709 */ // Label 5825: @284709
     /* 284709 */ GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(284742), // Rule ID 2480 //
     /* 284714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284735 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 284735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 284740 */   GIR_RootConstrainSelectedInstOperands,
     /* 284741 */   // GIR_Coverage, 2480,
     /* 284741 */   GIR_Done,
     /* 284742 */ // Label 5837: @284742
     /* 284742 */ GIM_Reject,
     /* 284743 */ // Label 5826: @284743
     /* 284743 */ GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(284776), // Rule ID 2475 //
     /* 284748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284769 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 284769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 284774 */   GIR_RootConstrainSelectedInstOperands,
     /* 284775 */   // GIR_Coverage, 2475,
     /* 284775 */   GIR_Done,
     /* 284776 */ // Label 5838: @284776
     /* 284776 */ GIM_Reject,
     /* 284777 */ // Label 5827: @284777
     /* 284777 */ GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(284810), // Rule ID 2479 //
     /* 284782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284803 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 284803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 284808 */   GIR_RootConstrainSelectedInstOperands,
     /* 284809 */   // GIR_Coverage, 2479,
     /* 284809 */   GIR_Done,
     /* 284810 */ // Label 5839: @284810
     /* 284810 */ GIM_Reject,
     /* 284811 */ // Label 5828: @284811
     /* 284811 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(284844), // Rule ID 2478 //
     /* 284816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284837 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 284837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 284842 */   GIR_RootConstrainSelectedInstOperands,
     /* 284843 */   // GIR_Coverage, 2478,
     /* 284843 */   GIR_Done,
     /* 284844 */ // Label 5840: @284844
     /* 284844 */ GIM_Reject,
     /* 284845 */ // Label 5829: @284845
     /* 284845 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(284870), // Rule ID 7463 //
     /* 284850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284863 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 284863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 284868 */   GIR_RootConstrainSelectedInstOperands,
     /* 284869 */   // GIR_Coverage, 7463,
     /* 284869 */   GIR_Done,
     /* 284870 */ // Label 5841: @284870
     /* 284870 */ GIM_Reject,
     /* 284871 */ // Label 5830: @284871
     /* 284871 */ GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(284896), // Rule ID 7462 //
     /* 284876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284889 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 284889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 284894 */   GIR_RootConstrainSelectedInstOperands,
     /* 284895 */   // GIR_Coverage, 7462,
     /* 284895 */   GIR_Done,
     /* 284896 */ // Label 5842: @284896
     /* 284896 */ GIM_Reject,
     /* 284897 */ // Label 5831: @284897
     /* 284897 */ GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(284922), // Rule ID 7461 //
     /* 284902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284915 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 284915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 284920 */   GIR_RootConstrainSelectedInstOperands,
     /* 284921 */   // GIR_Coverage, 7461,
     /* 284921 */   GIR_Done,
     /* 284922 */ // Label 5843: @284922
     /* 284922 */ GIM_Reject,
     /* 284923 */ // Label 5832: @284923
     /* 284923 */ GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(284948), // Rule ID 7460 //
     /* 284928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 284937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284941 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 284941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 284946 */   GIR_RootConstrainSelectedInstOperands,
     /* 284947 */   // GIR_Coverage, 7460,
     /* 284947 */   GIR_Done,
     /* 284948 */ // Label 5844: @284948
     /* 284948 */ GIM_Reject,
     /* 284949 */ // Label 5833: @284949
     /* 284949 */ GIM_Reject,
     /* 284950 */ // Label 57: @284950
     /* 284950 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5856*/ GIMT_Encode4(285379),
     /* 284961 */ /*GILLT_v2s32*//*Label 5845*/ GIMT_Encode4(285037),
     /* 284965 */ /*GILLT_v2s64*//*Label 5846*/ GIMT_Encode4(285071),
     /* 284969 */ /*GILLT_v4s16*//*Label 5847*/ GIMT_Encode4(285105),
     /* 284973 */ /*GILLT_v4s32*//*Label 5848*/ GIMT_Encode4(285139),
     /* 284977 */ /*GILLT_v8s8*//*Label 5849*/ GIMT_Encode4(285173),
     /* 284981 */ /*GILLT_v8s16*//*Label 5850*/ GIMT_Encode4(285207),
     /* 284985 */ /*GILLT_v16s8*//*Label 5851*/ GIMT_Encode4(285241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285005 */ /*GILLT_nxv2s64*//*Label 5852*/ GIMT_Encode4(285275), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285017 */ /*GILLT_nxv4s32*//*Label 5853*/ GIMT_Encode4(285301), GIMT_Encode4(0),
     /* 285025 */ /*GILLT_nxv8s16*//*Label 5854*/ GIMT_Encode4(285327), GIMT_Encode4(0),
     /* 285033 */ /*GILLT_nxv16s8*//*Label 5855*/ GIMT_Encode4(285353),
     /* 285037 */ // Label 5845: @285037
     /* 285037 */ GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(285070), // Rule ID 5037 //
     /* 285042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285063 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 285063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 285068 */   GIR_RootConstrainSelectedInstOperands,
     /* 285069 */   // GIR_Coverage, 5037,
     /* 285069 */   GIR_Done,
     /* 285070 */ // Label 5857: @285070
     /* 285070 */ GIM_Reject,
     /* 285071 */ // Label 5846: @285071
     /* 285071 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(285104), // Rule ID 5041 //
     /* 285076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285097 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 285097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 285102 */   GIR_RootConstrainSelectedInstOperands,
     /* 285103 */   // GIR_Coverage, 5041,
     /* 285103 */   GIR_Done,
     /* 285104 */ // Label 5858: @285104
     /* 285104 */ GIM_Reject,
     /* 285105 */ // Label 5847: @285105
     /* 285105 */ GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(285138), // Rule ID 5036 //
     /* 285110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285131 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 285131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 285136 */   GIR_RootConstrainSelectedInstOperands,
     /* 285137 */   // GIR_Coverage, 5036,
     /* 285137 */   GIR_Done,
     /* 285138 */ // Label 5859: @285138
     /* 285138 */ GIM_Reject,
     /* 285139 */ // Label 5848: @285139
     /* 285139 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(285172), // Rule ID 5040 //
     /* 285144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285165 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 285165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 285170 */   GIR_RootConstrainSelectedInstOperands,
     /* 285171 */   // GIR_Coverage, 5040,
     /* 285171 */   GIR_Done,
     /* 285172 */ // Label 5860: @285172
     /* 285172 */ GIM_Reject,
     /* 285173 */ // Label 5849: @285173
     /* 285173 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(285206), // Rule ID 5035 //
     /* 285178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285199 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 285199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 285204 */   GIR_RootConstrainSelectedInstOperands,
     /* 285205 */   // GIR_Coverage, 5035,
     /* 285205 */   GIR_Done,
     /* 285206 */ // Label 5861: @285206
     /* 285206 */ GIM_Reject,
     /* 285207 */ // Label 5850: @285207
     /* 285207 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(285240), // Rule ID 5039 //
     /* 285212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285233 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 285233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 285238 */   GIR_RootConstrainSelectedInstOperands,
     /* 285239 */   // GIR_Coverage, 5039,
     /* 285239 */   GIR_Done,
     /* 285240 */ // Label 5862: @285240
     /* 285240 */ GIM_Reject,
     /* 285241 */ // Label 5851: @285241
     /* 285241 */ GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(285274), // Rule ID 5038 //
     /* 285246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 285252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285267 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 285267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 285272 */   GIR_RootConstrainSelectedInstOperands,
     /* 285273 */   // GIR_Coverage, 5038,
     /* 285273 */   GIR_Done,
     /* 285274 */ // Label 5863: @285274
     /* 285274 */ GIM_Reject,
     /* 285275 */ // Label 5852: @285275
     /* 285275 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(285300), // Rule ID 7475 //
     /* 285280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285293 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 285293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 285298 */   GIR_RootConstrainSelectedInstOperands,
     /* 285299 */   // GIR_Coverage, 7475,
     /* 285299 */   GIR_Done,
     /* 285300 */ // Label 5864: @285300
     /* 285300 */ GIM_Reject,
     /* 285301 */ // Label 5853: @285301
     /* 285301 */ GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(285326), // Rule ID 7474 //
     /* 285306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285319 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 285319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 285324 */   GIR_RootConstrainSelectedInstOperands,
     /* 285325 */   // GIR_Coverage, 7474,
     /* 285325 */   GIR_Done,
     /* 285326 */ // Label 5865: @285326
     /* 285326 */ GIM_Reject,
     /* 285327 */ // Label 5854: @285327
     /* 285327 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(285352), // Rule ID 7473 //
     /* 285332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285345 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 285345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 285350 */   GIR_RootConstrainSelectedInstOperands,
     /* 285351 */   // GIR_Coverage, 7473,
     /* 285351 */   GIR_Done,
     /* 285352 */ // Label 5866: @285352
     /* 285352 */ GIM_Reject,
     /* 285353 */ // Label 5855: @285353
     /* 285353 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(285378), // Rule ID 7472 //
     /* 285358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 285364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 285367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285371 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 285371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 285376 */   GIR_RootConstrainSelectedInstOperands,
     /* 285377 */   // GIR_Coverage, 7472,
     /* 285377 */   GIR_Done,
     /* 285378 */ // Label 5867: @285378
     /* 285378 */ GIM_Reject,
     /* 285379 */ // Label 5856: @285379
     /* 285379 */ GIM_Reject,
     /* 285380 */ // Label 58: @285380
     /* 285380 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5879*/ GIMT_Encode4(285809),
     /* 285391 */ /*GILLT_v2s32*//*Label 5868*/ GIMT_Encode4(285467),
     /* 285395 */ /*GILLT_v2s64*//*Label 5869*/ GIMT_Encode4(285501),
     /* 285399 */ /*GILLT_v4s16*//*Label 5870*/ GIMT_Encode4(285535),
     /* 285403 */ /*GILLT_v4s32*//*Label 5871*/ GIMT_Encode4(285569),
     /* 285407 */ /*GILLT_v8s8*//*Label 5872*/ GIMT_Encode4(285603),
     /* 285411 */ /*GILLT_v8s16*//*Label 5873*/ GIMT_Encode4(285637),
     /* 285415 */ /*GILLT_v16s8*//*Label 5874*/ GIMT_Encode4(285671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285435 */ /*GILLT_nxv2s64*//*Label 5875*/ GIMT_Encode4(285705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285447 */ /*GILLT_nxv4s32*//*Label 5876*/ GIMT_Encode4(285731), GIMT_Encode4(0),
     /* 285455 */ /*GILLT_nxv8s16*//*Label 5877*/ GIMT_Encode4(285757), GIMT_Encode4(0),
     /* 285463 */ /*GILLT_nxv16s8*//*Label 5878*/ GIMT_Encode4(285783),
     /* 285467 */ // Label 5868: @285467
     /* 285467 */ GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285500), // Rule ID 5030 //
     /* 285472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285493 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 285493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 285498 */   GIR_RootConstrainSelectedInstOperands,
     /* 285499 */   // GIR_Coverage, 5030,
     /* 285499 */   GIR_Done,
     /* 285500 */ // Label 5880: @285500
     /* 285500 */ GIM_Reject,
     /* 285501 */ // Label 5869: @285501
     /* 285501 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(285534), // Rule ID 5034 //
     /* 285506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285527 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 285527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 285532 */   GIR_RootConstrainSelectedInstOperands,
     /* 285533 */   // GIR_Coverage, 5034,
     /* 285533 */   GIR_Done,
     /* 285534 */ // Label 5881: @285534
     /* 285534 */ GIM_Reject,
     /* 285535 */ // Label 5870: @285535
     /* 285535 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(285568), // Rule ID 5029 //
     /* 285540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285561 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 285561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 285566 */   GIR_RootConstrainSelectedInstOperands,
     /* 285567 */   // GIR_Coverage, 5029,
     /* 285567 */   GIR_Done,
     /* 285568 */ // Label 5882: @285568
     /* 285568 */ GIM_Reject,
     /* 285569 */ // Label 5871: @285569
     /* 285569 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(285602), // Rule ID 5033 //
     /* 285574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285595 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 285595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 285600 */   GIR_RootConstrainSelectedInstOperands,
     /* 285601 */   // GIR_Coverage, 5033,
     /* 285601 */   GIR_Done,
     /* 285602 */ // Label 5883: @285602
     /* 285602 */ GIM_Reject,
     /* 285603 */ // Label 5872: @285603
     /* 285603 */ GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(285636), // Rule ID 5028 //
     /* 285608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285629 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 285629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 285634 */   GIR_RootConstrainSelectedInstOperands,
     /* 285635 */   // GIR_Coverage, 5028,
     /* 285635 */   GIR_Done,
     /* 285636 */ // Label 5884: @285636
     /* 285636 */ GIM_Reject,
     /* 285637 */ // Label 5873: @285637
     /* 285637 */ GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(285670), // Rule ID 5032 //
     /* 285642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285663 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 285663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 285668 */   GIR_RootConstrainSelectedInstOperands,
     /* 285669 */   // GIR_Coverage, 5032,
     /* 285669 */   GIR_Done,
     /* 285670 */ // Label 5885: @285670
     /* 285670 */ GIM_Reject,
     /* 285671 */ // Label 5874: @285671
     /* 285671 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(285704), // Rule ID 5031 //
     /* 285676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 285682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285697 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 285697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 285702 */   GIR_RootConstrainSelectedInstOperands,
     /* 285703 */   // GIR_Coverage, 5031,
     /* 285703 */   GIR_Done,
     /* 285704 */ // Label 5886: @285704
     /* 285704 */ GIM_Reject,
     /* 285705 */ // Label 5875: @285705
     /* 285705 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(285730), // Rule ID 7471 //
     /* 285710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285723 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 285723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 285728 */   GIR_RootConstrainSelectedInstOperands,
     /* 285729 */   // GIR_Coverage, 7471,
     /* 285729 */   GIR_Done,
     /* 285730 */ // Label 5887: @285730
     /* 285730 */ GIM_Reject,
     /* 285731 */ // Label 5876: @285731
     /* 285731 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(285756), // Rule ID 7470 //
     /* 285736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285749 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 285749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 285754 */   GIR_RootConstrainSelectedInstOperands,
     /* 285755 */   // GIR_Coverage, 7470,
     /* 285755 */   GIR_Done,
     /* 285756 */ // Label 5888: @285756
     /* 285756 */ GIM_Reject,
     /* 285757 */ // Label 5877: @285757
     /* 285757 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(285782), // Rule ID 7469 //
     /* 285762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285775 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 285775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 285780 */   GIR_RootConstrainSelectedInstOperands,
     /* 285781 */   // GIR_Coverage, 7469,
     /* 285781 */   GIR_Done,
     /* 285782 */ // Label 5889: @285782
     /* 285782 */ GIM_Reject,
     /* 285783 */ // Label 5878: @285783
     /* 285783 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(285808), // Rule ID 7468 //
     /* 285788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 285794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 285797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285801 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 285801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 285806 */   GIR_RootConstrainSelectedInstOperands,
     /* 285807 */   // GIR_Coverage, 7468,
     /* 285807 */   GIR_Done,
     /* 285808 */ // Label 5890: @285808
     /* 285808 */ GIM_Reject,
     /* 285809 */ // Label 5879: @285809
     /* 285809 */ GIM_Reject,
     /* 285810 */ // Label 59: @285810
     /* 285810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5902*/ GIMT_Encode4(287607),
     /* 285821 */ /*GILLT_s16*//*Label 5891*/ GIMT_Encode4(285905),
     /* 285825 */ /*GILLT_s32*//*Label 5892*/ GIMT_Encode4(286131),
     /* 285829 */ /*GILLT_s64*//*Label 5893*/ GIMT_Encode4(286485), GIMT_Encode4(0),
     /* 285837 */ /*GILLT_v2s32*//*Label 5894*/ GIMT_Encode4(286657),
     /* 285841 */ /*GILLT_v2s64*//*Label 5895*/ GIMT_Encode4(286695),
     /* 285845 */ /*GILLT_v4s16*//*Label 5896*/ GIMT_Encode4(286871),
     /* 285849 */ /*GILLT_v4s32*//*Label 5897*/ GIMT_Encode4(286909), GIMT_Encode4(0),
     /* 285857 */ /*GILLT_v8s16*//*Label 5898*/ GIMT_Encode4(287085), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285881 */ /*GILLT_nxv2s64*//*Label 5899*/ GIMT_Encode4(287529), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285893 */ /*GILLT_nxv4s32*//*Label 5900*/ GIMT_Encode4(287555), GIMT_Encode4(0),
     /* 285901 */ /*GILLT_nxv8s16*//*Label 5901*/ GIMT_Encode4(287581),
     /* 285905 */ // Label 5891: @285905
     /* 285905 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(286130),
     /* 285910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285920 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(286011), // Rule ID 6923 //
     /* 285925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285962 */     // MIs[2] Rn
     /* 285962 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285967 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 285971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285973 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 285973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285985 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 286004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286009 */     GIR_RootConstrainSelectedInstOperands,
     /* 286010 */     // GIR_Coverage, 6923,
     /* 286010 */     GIR_EraseRootFromParent_Done,
     /* 286011 */   // Label 5904: @286011
     /* 286011 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(286102), // Rule ID 13958 //
     /* 286016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286037 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286053 */     // MIs[2] Rn
     /* 286053 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286064 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 286064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 286095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286100 */     GIR_RootConstrainSelectedInstOperands,
     /* 286101 */     // GIR_Coverage, 13958,
     /* 286101 */     GIR_EraseRootFromParent_Done,
     /* 286102 */   // Label 5905: @286102
     /* 286102 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(286129), // Rule ID 584 //
     /* 286107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286118 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 286123 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286127 */     GIR_RootConstrainSelectedInstOperands,
     /* 286128 */     // GIR_Coverage, 584,
     /* 286128 */     GIR_Done,
     /* 286129 */   // Label 5906: @286129
     /* 286129 */   GIM_Reject,
     /* 286130 */ // Label 5903: @286130
     /* 286130 */ GIM_Reject,
     /* 286131 */ // Label 5892: @286131
     /* 286131 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(286484),
     /* 286136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286146 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(286237), // Rule ID 6921 //
     /* 286151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286188 */     // MIs[2] Rn
     /* 286188 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286199 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 286199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286235 */     GIR_RootConstrainSelectedInstOperands,
     /* 286236 */     // GIR_Coverage, 6921,
     /* 286236 */     GIR_EraseRootFromParent_Done,
     /* 286237 */   // Label 5908: @286237
     /* 286237 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(286301), // Rule ID 13140 //
     /* 286242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286279 */     // MIs[2] Rn
     /* 286279 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286284 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286290 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 286290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286299 */     GIR_RootConstrainSelectedInstOperands,
     /* 286300 */     // GIR_Coverage, 13140,
     /* 286300 */     GIR_EraseRootFromParent_Done,
     /* 286301 */   // Label 5909: @286301
     /* 286301 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(286392), // Rule ID 13956 //
     /* 286306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286327 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286343 */     // MIs[2] Rn
     /* 286343 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286348 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286354 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 286354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286390 */     GIR_RootConstrainSelectedInstOperands,
     /* 286391 */     // GIR_Coverage, 13956,
     /* 286391 */     GIR_EraseRootFromParent_Done,
     /* 286392 */   // Label 5910: @286392
     /* 286392 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(286456), // Rule ID 15643 //
     /* 286397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286434 */     // MIs[2] Rn
     /* 286434 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286439 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286445 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 286445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286454 */     GIR_RootConstrainSelectedInstOperands,
     /* 286455 */     // GIR_Coverage, 15643,
     /* 286455 */     GIR_EraseRootFromParent_Done,
     /* 286456 */   // Label 5911: @286456
     /* 286456 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(286483), // Rule ID 586 //
     /* 286461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286472 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 286472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 286477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286481 */     GIR_RootConstrainSelectedInstOperands,
     /* 286482 */     // GIR_Coverage, 586,
     /* 286482 */     GIR_Done,
     /* 286483 */   // Label 5912: @286483
     /* 286483 */   GIM_Reject,
     /* 286484 */ // Label 5907: @286484
     /* 286484 */ GIM_Reject,
     /* 286485 */ // Label 5893: @286485
     /* 286485 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(286656),
     /* 286490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286500 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(286564), // Rule ID 6919 //
     /* 286505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286526 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286542 */     // MIs[2] Rn
     /* 286542 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286553 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 286553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 286556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286562 */     GIR_RootConstrainSelectedInstOperands,
     /* 286563 */     // GIR_Coverage, 6919,
     /* 286563 */     GIR_EraseRootFromParent_Done,
     /* 286564 */   // Label 5914: @286564
     /* 286564 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(286628), // Rule ID 13954 //
     /* 286569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286606 */     // MIs[2] Rn
     /* 286606 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286611 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286617 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 286617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 286620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286626 */     GIR_RootConstrainSelectedInstOperands,
     /* 286627 */     // GIR_Coverage, 13954,
     /* 286627 */     GIR_EraseRootFromParent_Done,
     /* 286628 */   // Label 5915: @286628
     /* 286628 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(286655), // Rule ID 588 //
     /* 286633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286644 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 286644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 286649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286653 */     GIR_RootConstrainSelectedInstOperands,
     /* 286654 */     // GIR_Coverage, 588,
     /* 286654 */     GIR_Done,
     /* 286655 */   // Label 5916: @286655
     /* 286655 */   GIM_Reject,
     /* 286656 */ // Label 5913: @286656
     /* 286656 */ GIM_Reject,
     /* 286657 */ // Label 5894: @286657
     /* 286657 */ GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(286694), // Rule ID 1203 //
     /* 286662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 286671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286683 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 286683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 286688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286692 */   GIR_RootConstrainSelectedInstOperands,
     /* 286693 */   // GIR_Coverage, 1203,
     /* 286693 */   GIR_Done,
     /* 286694 */ // Label 5917: @286694
     /* 286694 */ GIM_Reject,
     /* 286695 */ // Label 5895: @286695
     /* 286695 */ GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(286870),
     /* 286700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286710 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(286776), // Rule ID 6941 //
     /* 286715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 286723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 286749 */     // MIs[2] Rn
     /* 286749 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286754 */     // MIs[2] Rm
     /* 286754 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286761 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 286761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 286764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286774 */     GIR_RootConstrainSelectedInstOperands,
     /* 286775 */     // GIR_Coverage, 6941,
     /* 286775 */     GIR_EraseRootFromParent_Done,
     /* 286776 */   // Label 5919: @286776
     /* 286776 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(286842), // Rule ID 13966 //
     /* 286781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 286789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 286815 */     // MIs[2] Rn
     /* 286815 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286820 */     // MIs[2] Rm
     /* 286820 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286827 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 286827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 286830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286840 */     GIR_RootConstrainSelectedInstOperands,
     /* 286841 */     // GIR_Coverage, 13966,
     /* 286841 */     GIR_EraseRootFromParent_Done,
     /* 286842 */   // Label 5920: @286842
     /* 286842 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(286869), // Rule ID 1207 //
     /* 286847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286858 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 286858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 286863 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286867 */     GIR_RootConstrainSelectedInstOperands,
     /* 286868 */     // GIR_Coverage, 1207,
     /* 286868 */     GIR_Done,
     /* 286869 */   // Label 5921: @286869
     /* 286869 */   GIM_Reject,
     /* 286870 */ // Label 5918: @286870
     /* 286870 */ GIM_Reject,
     /* 286871 */ // Label 5896: @286871
     /* 286871 */ GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(286908), // Rule ID 1199 //
     /* 286876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286897 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 286897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 286902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286906 */   GIR_RootConstrainSelectedInstOperands,
     /* 286907 */   // GIR_Coverage, 1199,
     /* 286907 */   GIR_Done,
     /* 286908 */ // Label 5922: @286908
     /* 286908 */ GIM_Reject,
     /* 286909 */ // Label 5897: @286909
     /* 286909 */ GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(287084),
     /* 286914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286924 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(286990), // Rule ID 6942 //
     /* 286929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 286937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 286963 */     // MIs[2] Rn
     /* 286963 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286968 */     // MIs[2] Rm
     /* 286968 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286975 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 286975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 286978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286988 */     GIR_RootConstrainSelectedInstOperands,
     /* 286989 */     // GIR_Coverage, 6942,
     /* 286989 */     GIR_EraseRootFromParent_Done,
     /* 286990 */   // Label 5924: @286990
     /* 286990 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(287056), // Rule ID 13967 //
     /* 286995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 287003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 287011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 287029 */     // MIs[2] Rn
     /* 287029 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287034 */     // MIs[2] Rm
     /* 287034 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287041 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 287041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 287044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287054 */     GIR_RootConstrainSelectedInstOperands,
     /* 287055 */     // GIR_Coverage, 13967,
     /* 287055 */     GIR_EraseRootFromParent_Done,
     /* 287056 */   // Label 5925: @287056
     /* 287056 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(287083), // Rule ID 1205 //
     /* 287061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287072 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 287072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287081 */     GIR_RootConstrainSelectedInstOperands,
     /* 287082 */     // GIR_Coverage, 1205,
     /* 287082 */     GIR_Done,
     /* 287083 */   // Label 5926: @287083
     /* 287083 */   GIM_Reject,
     /* 287084 */ // Label 5923: @287084
     /* 287084 */ GIM_Reject,
     /* 287085 */ // Label 5898: @287085
     /* 287085 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(287528),
     /* 287090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287100 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(287169), // Rule ID 6943 //
     /* 287105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 287116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 287142 */     // MIs[2] Rn
     /* 287142 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287147 */     // MIs[2] Rm
     /* 287147 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287154 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 287154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 287157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287167 */     GIR_RootConstrainSelectedInstOperands,
     /* 287168 */     // GIR_Coverage, 6943,
     /* 287168 */     GIR_EraseRootFromParent_Done,
     /* 287169 */   // Label 5928: @287169
     /* 287169 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(287238), // Rule ID 13968 //
     /* 287174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 287185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 287211 */     // MIs[2] Rn
     /* 287211 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287216 */     // MIs[2] Rm
     /* 287216 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287223 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 287223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 287226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287236 */     GIR_RootConstrainSelectedInstOperands,
     /* 287237 */     // GIR_Coverage, 13968,
     /* 287237 */     GIR_EraseRootFromParent_Done,
     /* 287238 */   // Label 5929: @287238
     /* 287238 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(287265), // Rule ID 1201 //
     /* 287243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287254 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 287254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 287259 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287263 */     GIR_RootConstrainSelectedInstOperands,
     /* 287264 */     // GIR_Coverage, 1201,
     /* 287264 */     GIR_Done,
     /* 287265 */   // Label 5930: @287265
     /* 287265 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(287527), // Rule ID 7012 //
     /* 287270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 287273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287281 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 287281 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 287284 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 287288 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287293 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 287297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 287299 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 287302 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 287306 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287311 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 287315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 287317 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 287320 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287324 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287329 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 287332 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 287335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 287337 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 287340 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287344 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287349 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287355 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287360 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287365 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 287368 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 287372 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287377 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 287380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 287382 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 287385 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287389 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287394 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287400 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287405 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287410 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 287413 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 287417 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287422 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 287425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 287427 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 287430 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287434 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287439 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 287442 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 287445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 287447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 287450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 287454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287459 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 287462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 287464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 287467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 287481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 287496 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 287499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 287517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 287525 */     GIR_RootConstrainSelectedInstOperands,
     /* 287526 */     // GIR_Coverage, 7012,
     /* 287526 */     GIR_EraseRootFromParent_Done,
     /* 287527 */   // Label 5931: @287527
     /* 287527 */   GIM_Reject,
     /* 287528 */ // Label 5927: @287528
     /* 287528 */ GIM_Reject,
     /* 287529 */ // Label 5899: @287529
     /* 287529 */ GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(287554), // Rule ID 2824 //
     /* 287534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 287540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 287543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287547 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 287547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 287552 */   GIR_RootConstrainSelectedInstOperands,
     /* 287553 */   // GIR_Coverage, 2824,
     /* 287553 */   GIR_Done,
     /* 287554 */ // Label 5932: @287554
     /* 287554 */ GIM_Reject,
     /* 287555 */ // Label 5900: @287555
     /* 287555 */ GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(287580), // Rule ID 2822 //
     /* 287560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 287566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 287569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287573 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 287573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 287578 */   GIR_RootConstrainSelectedInstOperands,
     /* 287579 */   // GIR_Coverage, 2822,
     /* 287579 */   GIR_Done,
     /* 287580 */ // Label 5933: @287580
     /* 287580 */ GIM_Reject,
     /* 287581 */ // Label 5901: @287581
     /* 287581 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(287606), // Rule ID 2820 //
     /* 287586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 287592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 287595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287599 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 287599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 287604 */   GIR_RootConstrainSelectedInstOperands,
     /* 287605 */   // GIR_Coverage, 2820,
     /* 287605 */   GIR_Done,
     /* 287606 */ // Label 5934: @287606
     /* 287606 */ GIM_Reject,
     /* 287607 */ // Label 5902: @287607
     /* 287607 */ GIM_Reject,
     /* 287608 */ // Label 60: @287608
     /* 287608 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5946*/ GIMT_Encode4(288345),
     /* 287619 */ /*GILLT_s16*//*Label 5935*/ GIMT_Encode4(287703),
     /* 287623 */ /*GILLT_s32*//*Label 5936*/ GIMT_Encode4(287741),
     /* 287627 */ /*GILLT_s64*//*Label 5937*/ GIMT_Encode4(287779), GIMT_Encode4(0),
     /* 287635 */ /*GILLT_v2s32*//*Label 5938*/ GIMT_Encode4(287817),
     /* 287639 */ /*GILLT_v2s64*//*Label 5939*/ GIMT_Encode4(287855),
     /* 287643 */ /*GILLT_v4s16*//*Label 5940*/ GIMT_Encode4(287893),
     /* 287647 */ /*GILLT_v4s32*//*Label 5941*/ GIMT_Encode4(287931), GIMT_Encode4(0),
     /* 287655 */ /*GILLT_v8s16*//*Label 5942*/ GIMT_Encode4(287969), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 287679 */ /*GILLT_nxv2s64*//*Label 5943*/ GIMT_Encode4(288267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 287691 */ /*GILLT_nxv4s32*//*Label 5944*/ GIMT_Encode4(288293), GIMT_Encode4(0),
     /* 287699 */ /*GILLT_nxv8s16*//*Label 5945*/ GIMT_Encode4(288319),
     /* 287703 */ // Label 5935: @287703
     /* 287703 */ GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(287740), // Rule ID 632 //
     /* 287708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 287714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 287717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287729 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 287729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 287734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287738 */   GIR_RootConstrainSelectedInstOperands,
     /* 287739 */   // GIR_Coverage, 632,
     /* 287739 */   GIR_Done,
     /* 287740 */ // Label 5947: @287740
     /* 287740 */ GIM_Reject,
     /* 287741 */ // Label 5936: @287741
     /* 287741 */ GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(287778), // Rule ID 634 //
     /* 287746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287767 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 287767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 287772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287776 */   GIR_RootConstrainSelectedInstOperands,
     /* 287777 */   // GIR_Coverage, 634,
     /* 287777 */   GIR_Done,
     /* 287778 */ // Label 5948: @287778
     /* 287778 */ GIM_Reject,
     /* 287779 */ // Label 5937: @287779
     /* 287779 */ GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(287816), // Rule ID 636 //
     /* 287784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287805 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 287805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 287810 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287814 */   GIR_RootConstrainSelectedInstOperands,
     /* 287815 */   // GIR_Coverage, 636,
     /* 287815 */   GIR_Done,
     /* 287816 */ // Label 5949: @287816
     /* 287816 */ GIM_Reject,
     /* 287817 */ // Label 5938: @287817
     /* 287817 */ GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(287854), // Rule ID 1343 //
     /* 287822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287843 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 287843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 287848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287852 */   GIR_RootConstrainSelectedInstOperands,
     /* 287853 */   // GIR_Coverage, 1343,
     /* 287853 */   GIR_Done,
     /* 287854 */ // Label 5950: @287854
     /* 287854 */ GIM_Reject,
     /* 287855 */ // Label 5939: @287855
     /* 287855 */ GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(287892), // Rule ID 1347 //
     /* 287860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 287869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287881 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 287881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 287886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287890 */   GIR_RootConstrainSelectedInstOperands,
     /* 287891 */   // GIR_Coverage, 1347,
     /* 287891 */   GIR_Done,
     /* 287892 */ // Label 5951: @287892
     /* 287892 */ GIM_Reject,
     /* 287893 */ // Label 5940: @287893
     /* 287893 */ GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(287930), // Rule ID 1339 //
     /* 287898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 287904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287919 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 287919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 287924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287928 */   GIR_RootConstrainSelectedInstOperands,
     /* 287929 */   // GIR_Coverage, 1339,
     /* 287929 */   GIR_Done,
     /* 287930 */ // Label 5952: @287930
     /* 287930 */ GIM_Reject,
     /* 287931 */ // Label 5941: @287931
     /* 287931 */ GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(287968), // Rule ID 1345 //
     /* 287936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 287945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287957 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 287957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 287962 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287966 */   GIR_RootConstrainSelectedInstOperands,
     /* 287967 */   // GIR_Coverage, 1345,
     /* 287967 */   GIR_Done,
     /* 287968 */ // Label 5953: @287968
     /* 287968 */ GIM_Reject,
     /* 287969 */ // Label 5942: @287969
     /* 287969 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288266),
     /* 287974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287992 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288011), // Rule ID 1341 //
     /* 287997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288000 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 288000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 288005 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288009 */     GIR_RootConstrainSelectedInstOperands,
     /* 288010 */     // GIR_Coverage, 1341,
     /* 288010 */     GIR_Done,
     /* 288011 */   // Label 5955: @288011
     /* 288011 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288265), // Rule ID 7018 //
     /* 288016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 288019 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 288019 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 288022 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 288026 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288031 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 288035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 288037 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 288040 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 288044 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288049 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 288053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 288055 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 288058 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 288062 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288067 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 288070 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 288073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 288075 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 288078 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288082 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288087 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288093 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288098 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288103 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 288106 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 288110 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288115 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 288118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 288120 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 288123 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288127 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288132 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288138 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288143 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288148 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 288151 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 288155 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288160 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 288163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 288165 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 288168 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 288172 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288177 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 288180 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 288183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 288185 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 288188 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 288192 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288197 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 288200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 288202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 288205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 288219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 288234 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 288255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 288263 */     GIR_RootConstrainSelectedInstOperands,
     /* 288264 */     // GIR_Coverage, 7018,
     /* 288264 */     GIR_EraseRootFromParent_Done,
     /* 288265 */   // Label 5956: @288265
     /* 288265 */   GIM_Reject,
     /* 288266 */ // Label 5954: @288266
     /* 288266 */ GIM_Reject,
     /* 288267 */ // Label 5943: @288267
     /* 288267 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288292), // Rule ID 8218 //
     /* 288272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 288278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 288281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288285 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 288285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 288290 */   GIR_RootConstrainSelectedInstOperands,
     /* 288291 */   // GIR_Coverage, 8218,
     /* 288291 */   GIR_Done,
     /* 288292 */ // Label 5957: @288292
     /* 288292 */ GIM_Reject,
     /* 288293 */ // Label 5944: @288293
     /* 288293 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(288318), // Rule ID 8216 //
     /* 288298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 288304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 288307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288311 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 288311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 288316 */   GIR_RootConstrainSelectedInstOperands,
     /* 288317 */   // GIR_Coverage, 8216,
     /* 288317 */   GIR_Done,
     /* 288318 */ // Label 5958: @288318
     /* 288318 */ GIM_Reject,
     /* 288319 */ // Label 5945: @288319
     /* 288319 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288344), // Rule ID 8214 //
     /* 288324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 288330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 288333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288337 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 288337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 288342 */   GIR_RootConstrainSelectedInstOperands,
     /* 288343 */   // GIR_Coverage, 8214,
     /* 288343 */   GIR_Done,
     /* 288344 */ // Label 5959: @288344
     /* 288344 */ GIM_Reject,
     /* 288345 */ // Label 5946: @288345
     /* 288345 */ GIM_Reject,
     /* 288346 */ // Label 61: @288346
     /* 288346 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5971*/ GIMT_Encode4(292441),
     /* 288357 */ /*GILLT_s16*//*Label 5960*/ GIMT_Encode4(288441),
     /* 288361 */ /*GILLT_s32*//*Label 5961*/ GIMT_Encode4(289083),
     /* 288365 */ /*GILLT_s64*//*Label 5962*/ GIMT_Encode4(289713), GIMT_Encode4(0),
     /* 288373 */ /*GILLT_v2s32*//*Label 5963*/ GIMT_Encode4(290343),
     /* 288377 */ /*GILLT_v2s64*//*Label 5964*/ GIMT_Encode4(290873),
     /* 288381 */ /*GILLT_v4s16*//*Label 5965*/ GIMT_Encode4(291231),
     /* 288385 */ /*GILLT_v4s32*//*Label 5966*/ GIMT_Encode4(291573), GIMT_Encode4(0),
     /* 288393 */ /*GILLT_v8s16*//*Label 5967*/ GIMT_Encode4(291931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 288417 */ /*GILLT_nxv2s64*//*Label 5968*/ GIMT_Encode4(292363), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 288429 */ /*GILLT_nxv4s32*//*Label 5969*/ GIMT_Encode4(292389), GIMT_Encode4(0),
     /* 288437 */ /*GILLT_nxv8s16*//*Label 5970*/ GIMT_Encode4(292415),
     /* 288441 */ // Label 5960: @288441
     /* 288441 */ GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289082),
     /* 288446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 288449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 288452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288456 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(288569), // Rule ID 6253 //
     /* 288461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288485 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288522 */     // MIs[3] Operand 1
     /* 288522 */     // No operand predicates
     /* 288522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288524 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 288542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288567 */     GIR_RootConstrainSelectedInstOperands,
     /* 288568 */     // GIR_Coverage, 6253,
     /* 288568 */     GIR_EraseRootFromParent_Done,
     /* 288569 */   // Label 5973: @288569
     /* 288569 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(288682), // Rule ID 13935 //
     /* 288574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288610 */     // MIs[2] Operand 1
     /* 288610 */     // No operand predicates
     /* 288610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288626 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288631 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 288635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288637 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 288655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288680 */     GIR_RootConstrainSelectedInstOperands,
     /* 288681 */     // GIR_Coverage, 13935,
     /* 288681 */     GIR_EraseRootFromParent_Done,
     /* 288682 */   // Label 5974: @288682
     /* 288682 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(288761), // Rule ID 13869 //
     /* 288687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288721 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 288721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 288739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 288752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288759 */     GIR_RootConstrainSelectedInstOperands,
     /* 288760 */     // GIR_Coverage, 13869,
     /* 288760 */     GIR_EraseRootFromParent_Done,
     /* 288761 */   // Label 5975: @288761
     /* 288761 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(288840), // Rule ID 4803 //
     /* 288766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288800 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 288800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 288818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 288831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288838 */     GIR_RootConstrainSelectedInstOperands,
     /* 288839 */     // GIR_Coverage, 4803,
     /* 288839 */     GIR_EraseRootFromParent_Done,
     /* 288840 */   // Label 5976: @288840
     /* 288840 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(288903), // Rule ID 13484 //
     /* 288845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288881 */     // MIs[2] Operand 1
     /* 288881 */     // No operand predicates
     /* 288881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288887 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288901 */     GIR_RootConstrainSelectedInstOperands,
     /* 288902 */     // GIR_Coverage, 13484,
     /* 288902 */     GIR_EraseRootFromParent_Done,
     /* 288903 */   // Label 5977: @288903
     /* 288903 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(288966), // Rule ID 2012 //
     /* 288908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288948 */     // MIs[2] Operand 1
     /* 288948 */     // No operand predicates
     /* 288948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288950 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288964 */     GIR_RootConstrainSelectedInstOperands,
     /* 288965 */     // GIR_Coverage, 2012,
     /* 288965 */     GIR_EraseRootFromParent_Done,
     /* 288966 */   // Label 5978: @288966
     /* 288966 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(289010), // Rule ID 4808 //
     /* 288971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288997 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 288997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 289000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289006 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 289008 */     GIR_RootConstrainSelectedInstOperands,
     /* 289009 */     // GIR_Coverage, 4808,
     /* 289009 */     GIR_EraseRootFromParent_Done,
     /* 289010 */   // Label 5979: @289010
     /* 289010 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(289054), // Rule ID 13874 //
     /* 289015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 289034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289041 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 289041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 289044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289050 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 289052 */     GIR_RootConstrainSelectedInstOperands,
     /* 289053 */     // GIR_Coverage, 13874,
     /* 289053 */     GIR_EraseRootFromParent_Done,
     /* 289054 */   // Label 5980: @289054
     /* 289054 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(289081), // Rule ID 620 //
     /* 289059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289070 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 289070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 289075 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289079 */     GIR_RootConstrainSelectedInstOperands,
     /* 289080 */     // GIR_Coverage, 620,
     /* 289080 */     GIR_Done,
     /* 289081 */   // Label 5981: @289081
     /* 289081 */   GIM_Reject,
     /* 289082 */ // Label 5972: @289082
     /* 289082 */ GIM_Reject,
     /* 289083 */ // Label 5961: @289083
     /* 289083 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(289712),
     /* 289088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 289094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289098 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(289211), // Rule ID 6255 //
     /* 289103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289127 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289160 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289164 */     // MIs[3] Operand 1
     /* 289164 */     // No operand predicates
     /* 289164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289166 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289209 */     GIR_RootConstrainSelectedInstOperands,
     /* 289210 */     // GIR_Coverage, 6255,
     /* 289210 */     GIR_EraseRootFromParent_Done,
     /* 289211 */   // Label 5983: @289211
     /* 289211 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(289324), // Rule ID 13937 //
     /* 289216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289252 */     // MIs[2] Operand 1
     /* 289252 */     // No operand predicates
     /* 289252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289268 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289273 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289279 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289322 */     GIR_RootConstrainSelectedInstOperands,
     /* 289323 */     // GIR_Coverage, 13937,
     /* 289323 */     GIR_EraseRootFromParent_Done,
     /* 289324 */   // Label 5984: @289324
     /* 289324 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(289400), // Rule ID 13871 //
     /* 289329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289360 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 289360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289372 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289398 */     GIR_RootConstrainSelectedInstOperands,
     /* 289399 */     // GIR_Coverage, 13871,
     /* 289399 */     GIR_EraseRootFromParent_Done,
     /* 289400 */   // Label 5985: @289400
     /* 289400 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(289476), // Rule ID 4805 //
     /* 289405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289436 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 289436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289474 */     GIR_RootConstrainSelectedInstOperands,
     /* 289475 */     // GIR_Coverage, 4805,
     /* 289475 */     GIR_EraseRootFromParent_Done,
     /* 289476 */   // Label 5986: @289476
     /* 289476 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(289539), // Rule ID 13486 //
     /* 289481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289517 */     // MIs[2] Operand 1
     /* 289517 */     // No operand predicates
     /* 289517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289523 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289537 */     GIR_RootConstrainSelectedInstOperands,
     /* 289538 */     // GIR_Coverage, 13486,
     /* 289538 */     GIR_EraseRootFromParent_Done,
     /* 289539 */   // Label 5987: @289539
     /* 289539 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(289602), // Rule ID 2014 //
     /* 289544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289584 */     // MIs[2] Operand 1
     /* 289584 */     // No operand predicates
     /* 289584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289586 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289600 */     GIR_RootConstrainSelectedInstOperands,
     /* 289601 */     // GIR_Coverage, 2014,
     /* 289601 */     GIR_EraseRootFromParent_Done,
     /* 289602 */   // Label 5988: @289602
     /* 289602 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(289643), // Rule ID 4809 //
     /* 289607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289630 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 289630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 289633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289639 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 289641 */     GIR_RootConstrainSelectedInstOperands,
     /* 289642 */     // GIR_Coverage, 4809,
     /* 289642 */     GIR_EraseRootFromParent_Done,
     /* 289643 */   // Label 5989: @289643
     /* 289643 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(289684), // Rule ID 13875 //
     /* 289648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289671 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 289671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 289674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289680 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 289682 */     GIR_RootConstrainSelectedInstOperands,
     /* 289683 */     // GIR_Coverage, 13875,
     /* 289683 */     GIR_EraseRootFromParent_Done,
     /* 289684 */   // Label 5990: @289684
     /* 289684 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(289711), // Rule ID 622 //
     /* 289689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289700 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 289700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289705 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289709 */     GIR_RootConstrainSelectedInstOperands,
     /* 289710 */     // GIR_Coverage, 622,
     /* 289710 */     GIR_Done,
     /* 289711 */   // Label 5991: @289711
     /* 289711 */   GIM_Reject,
     /* 289712 */ // Label 5982: @289712
     /* 289712 */ GIM_Reject,
     /* 289713 */ // Label 5962: @289713
     /* 289713 */ GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(290342),
     /* 289718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289728 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(289841), // Rule ID 6257 //
     /* 289733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289757 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289790 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289794 */     // MIs[3] Operand 1
     /* 289794 */     // No operand predicates
     /* 289794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289796 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289808 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 289827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289839 */     GIR_RootConstrainSelectedInstOperands,
     /* 289840 */     // GIR_Coverage, 6257,
     /* 289840 */     GIR_EraseRootFromParent_Done,
     /* 289841 */   // Label 5993: @289841
     /* 289841 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(289954), // Rule ID 13939 //
     /* 289846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289882 */     // MIs[2] Operand 1
     /* 289882 */     // No operand predicates
     /* 289882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289903 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289909 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289921 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 289940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289952 */     GIR_RootConstrainSelectedInstOperands,
     /* 289953 */     // GIR_Coverage, 13939,
     /* 289953 */     GIR_EraseRootFromParent_Done,
     /* 289954 */   // Label 5994: @289954
     /* 289954 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(290030), // Rule ID 13873 //
     /* 289959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289990 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 289990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290028 */     GIR_RootConstrainSelectedInstOperands,
     /* 290029 */     // GIR_Coverage, 13873,
     /* 290029 */     GIR_EraseRootFromParent_Done,
     /* 290030 */   // Label 5995: @290030
     /* 290030 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(290106), // Rule ID 4807 //
     /* 290035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290060 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290066 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 290066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290104 */     GIR_RootConstrainSelectedInstOperands,
     /* 290105 */     // GIR_Coverage, 4807,
     /* 290105 */     GIR_EraseRootFromParent_Done,
     /* 290106 */   // Label 5996: @290106
     /* 290106 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(290169), // Rule ID 13488 //
     /* 290111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290147 */     // MIs[2] Operand 1
     /* 290147 */     // No operand predicates
     /* 290147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290153 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 290156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290167 */     GIR_RootConstrainSelectedInstOperands,
     /* 290168 */     // GIR_Coverage, 13488,
     /* 290168 */     GIR_EraseRootFromParent_Done,
     /* 290169 */   // Label 5997: @290169
     /* 290169 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(290232), // Rule ID 2016 //
     /* 290174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290210 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290214 */     // MIs[2] Operand 1
     /* 290214 */     // No operand predicates
     /* 290214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290216 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 290219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290230 */     GIR_RootConstrainSelectedInstOperands,
     /* 290231 */     // GIR_Coverage, 2016,
     /* 290231 */     GIR_EraseRootFromParent_Done,
     /* 290232 */   // Label 5998: @290232
     /* 290232 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(290273), // Rule ID 4810 //
     /* 290237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290260 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 290260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 290263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 290269 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 290271 */     GIR_RootConstrainSelectedInstOperands,
     /* 290272 */     // GIR_Coverage, 4810,
     /* 290272 */     GIR_EraseRootFromParent_Done,
     /* 290273 */   // Label 5999: @290273
     /* 290273 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(290314), // Rule ID 13876 //
     /* 290278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290301 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 290301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 290304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 290310 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 290312 */     GIR_RootConstrainSelectedInstOperands,
     /* 290313 */     // GIR_Coverage, 13876,
     /* 290313 */     GIR_EraseRootFromParent_Done,
     /* 290314 */   // Label 6000: @290314
     /* 290314 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(290341), // Rule ID 624 //
     /* 290319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290330 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 290330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290335 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290339 */     GIR_RootConstrainSelectedInstOperands,
     /* 290340 */     // GIR_Coverage, 624,
     /* 290340 */     GIR_Done,
     /* 290341 */   // Label 6001: @290341
     /* 290341 */   GIM_Reject,
     /* 290342 */ // Label 5992: @290342
     /* 290342 */ GIM_Reject,
     /* 290343 */ // Label 5963: @290343
     /* 290343 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(290872),
     /* 290348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 290351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 290354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290358 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(290444), // Rule ID 13477 //
     /* 290363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 290374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290411 */     // MIs[3] Operand 1
     /* 290411 */     // No operand predicates
     /* 290411 */     // MIs[1] Operand 2
     /* 290411 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 290422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290428 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290442 */     GIR_RootConstrainSelectedInstOperands,
     /* 290443 */     // GIR_Coverage, 13477,
     /* 290443 */     GIR_EraseRootFromParent_Done,
     /* 290444 */   // Label 6003: @290444
     /* 290444 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(290530), // Rule ID 2005 //
     /* 290449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 290464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290497 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290501 */     // MIs[3] Operand 1
     /* 290501 */     // No operand predicates
     /* 290501 */     // MIs[1] Operand 2
     /* 290501 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 290512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290514 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290528 */     GIR_RootConstrainSelectedInstOperands,
     /* 290529 */     // GIR_Coverage, 2005,
     /* 290529 */     GIR_EraseRootFromParent_Done,
     /* 290530 */   // Label 6004: @290530
     /* 290530 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(290593), // Rule ID 13478 //
     /* 290535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290571 */     // MIs[2] Operand 1
     /* 290571 */     // No operand predicates
     /* 290571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290577 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290591 */     GIR_RootConstrainSelectedInstOperands,
     /* 290592 */     // GIR_Coverage, 13478,
     /* 290592 */     GIR_EraseRootFromParent_Done,
     /* 290593 */   // Label 6005: @290593
     /* 290593 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(290656), // Rule ID 2006 //
     /* 290598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290638 */     // MIs[2] Operand 1
     /* 290638 */     // No operand predicates
     /* 290638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290640 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290654 */     GIR_RootConstrainSelectedInstOperands,
     /* 290655 */     // GIR_Coverage, 2006,
     /* 290655 */     GIR_EraseRootFromParent_Done,
     /* 290656 */   // Label 6006: @290656
     /* 290656 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(290750), // Rule ID 13941 //
     /* 290661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290684 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290748 */     GIR_RootConstrainSelectedInstOperands,
     /* 290749 */     // GIR_Coverage, 13941,
     /* 290749 */     GIR_EraseRootFromParent_Done,
     /* 290750 */   // Label 6007: @290750
     /* 290750 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(290844), // Rule ID 6259 //
     /* 290755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290778 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290842 */     GIR_RootConstrainSelectedInstOperands,
     /* 290843 */     // GIR_Coverage, 6259,
     /* 290843 */     GIR_EraseRootFromParent_Done,
     /* 290844 */   // Label 6008: @290844
     /* 290844 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(290871), // Rule ID 1323 //
     /* 290849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290860 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 290860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 290865 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290869 */     GIR_RootConstrainSelectedInstOperands,
     /* 290870 */     // GIR_Coverage, 1323,
     /* 290870 */     GIR_Done,
     /* 290871 */   // Label 6009: @290871
     /* 290871 */   GIM_Reject,
     /* 290872 */ // Label 6002: @290872
     /* 290872 */ GIM_Reject,
     /* 290873 */ // Label 5964: @290873
     /* 290873 */ GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(291230),
     /* 290878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290888 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(290951), // Rule ID 13482 //
     /* 290893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290929 */     // MIs[2] Operand 1
     /* 290929 */     // No operand predicates
     /* 290929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290935 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 290938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290949 */     GIR_RootConstrainSelectedInstOperands,
     /* 290950 */     // GIR_Coverage, 13482,
     /* 290950 */     GIR_EraseRootFromParent_Done,
     /* 290951 */   // Label 6011: @290951
     /* 290951 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(291014), // Rule ID 2010 //
     /* 290956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290996 */     // MIs[2] Operand 1
     /* 290996 */     // No operand predicates
     /* 290996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290998 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 291001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291012 */     GIR_RootConstrainSelectedInstOperands,
     /* 291013 */     // GIR_Coverage, 2010,
     /* 291013 */     GIR_EraseRootFromParent_Done,
     /* 291014 */   // Label 6012: @291014
     /* 291014 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(291108), // Rule ID 13945 //
     /* 291019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291042 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291068 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291075 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 291096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291106 */     GIR_RootConstrainSelectedInstOperands,
     /* 291107 */     // GIR_Coverage, 13945,
     /* 291107 */     GIR_EraseRootFromParent_Done,
     /* 291108 */   // Label 6013: @291108
     /* 291108 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(291202), // Rule ID 6263 //
     /* 291113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291136 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291162 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 291190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291200 */     GIR_RootConstrainSelectedInstOperands,
     /* 291201 */     // GIR_Coverage, 6263,
     /* 291201 */     GIR_EraseRootFromParent_Done,
     /* 291202 */   // Label 6014: @291202
     /* 291202 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(291229), // Rule ID 1327 //
     /* 291207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291218 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 291223 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291227 */     GIR_RootConstrainSelectedInstOperands,
     /* 291228 */     // GIR_Coverage, 1327,
     /* 291228 */     GIR_Done,
     /* 291229 */   // Label 6015: @291229
     /* 291229 */   GIM_Reject,
     /* 291230 */ // Label 6010: @291230
     /* 291230 */ GIM_Reject,
     /* 291231 */ // Label 5965: @291231
     /* 291231 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(291572),
     /* 291236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291246 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(291332), // Rule ID 13471 //
     /* 291251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 291262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291295 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291299 */     // MIs[3] Operand 1
     /* 291299 */     // No operand predicates
     /* 291299 */     // MIs[1] Operand 2
     /* 291299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 291310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291316 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291330 */     GIR_RootConstrainSelectedInstOperands,
     /* 291331 */     // GIR_Coverage, 13471,
     /* 291331 */     GIR_EraseRootFromParent_Done,
     /* 291332 */   // Label 6017: @291332
     /* 291332 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(291418), // Rule ID 1999 //
     /* 291337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 291352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291389 */     // MIs[3] Operand 1
     /* 291389 */     // No operand predicates
     /* 291389 */     // MIs[1] Operand 2
     /* 291389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 291400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291402 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291416 */     GIR_RootConstrainSelectedInstOperands,
     /* 291417 */     // GIR_Coverage, 1999,
     /* 291417 */     GIR_EraseRootFromParent_Done,
     /* 291418 */   // Label 6018: @291418
     /* 291418 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(291481), // Rule ID 13472 //
     /* 291423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291459 */     // MIs[2] Operand 1
     /* 291459 */     // No operand predicates
     /* 291459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291465 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291479 */     GIR_RootConstrainSelectedInstOperands,
     /* 291480 */     // GIR_Coverage, 13472,
     /* 291480 */     GIR_EraseRootFromParent_Done,
     /* 291481 */   // Label 6019: @291481
     /* 291481 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(291544), // Rule ID 2000 //
     /* 291486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291526 */     // MIs[2] Operand 1
     /* 291526 */     // No operand predicates
     /* 291526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291528 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291542 */     GIR_RootConstrainSelectedInstOperands,
     /* 291543 */     // GIR_Coverage, 2000,
     /* 291543 */     GIR_EraseRootFromParent_Done,
     /* 291544 */   // Label 6020: @291544
     /* 291544 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(291571), // Rule ID 1319 //
     /* 291549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291560 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 291560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 291565 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291569 */     GIR_RootConstrainSelectedInstOperands,
     /* 291570 */     // GIR_Coverage, 1319,
     /* 291570 */     GIR_Done,
     /* 291571 */   // Label 6021: @291571
     /* 291571 */   GIM_Reject,
     /* 291572 */ // Label 6016: @291572
     /* 291572 */ GIM_Reject,
     /* 291573 */ // Label 5966: @291573
     /* 291573 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(291930),
     /* 291578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 291584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291588 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(291651), // Rule ID 13480 //
     /* 291593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291629 */     // MIs[2] Operand 1
     /* 291629 */     // No operand predicates
     /* 291629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291635 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291649 */     GIR_RootConstrainSelectedInstOperands,
     /* 291650 */     // GIR_Coverage, 13480,
     /* 291650 */     GIR_EraseRootFromParent_Done,
     /* 291651 */   // Label 6023: @291651
     /* 291651 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(291714), // Rule ID 2008 //
     /* 291656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291696 */     // MIs[2] Operand 1
     /* 291696 */     // No operand predicates
     /* 291696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291698 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291712 */     GIR_RootConstrainSelectedInstOperands,
     /* 291713 */     // GIR_Coverage, 2008,
     /* 291713 */     GIR_EraseRootFromParent_Done,
     /* 291714 */   // Label 6024: @291714
     /* 291714 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(291808), // Rule ID 13943 //
     /* 291719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291742 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291806 */     GIR_RootConstrainSelectedInstOperands,
     /* 291807 */     // GIR_Coverage, 13943,
     /* 291807 */     GIR_EraseRootFromParent_Done,
     /* 291808 */   // Label 6025: @291808
     /* 291808 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(291902), // Rule ID 6261 //
     /* 291813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291836 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291900 */     GIR_RootConstrainSelectedInstOperands,
     /* 291901 */     // GIR_Coverage, 6261,
     /* 291901 */     GIR_EraseRootFromParent_Done,
     /* 291902 */   // Label 6026: @291902
     /* 291902 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(291929), // Rule ID 1325 //
     /* 291907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291918 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 291918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 291923 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291927 */     GIR_RootConstrainSelectedInstOperands,
     /* 291928 */     // GIR_Coverage, 1325,
     /* 291928 */     GIR_Done,
     /* 291929 */   // Label 6027: @291929
     /* 291929 */   GIM_Reject,
     /* 291930 */ // Label 6022: @291930
     /* 291930 */ GIM_Reject,
     /* 291931 */ // Label 5967: @291931
     /* 291931 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(292362),
     /* 291936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 291942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291946 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(292009), // Rule ID 13474 //
     /* 291951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291987 */     // MIs[2] Operand 1
     /* 291987 */     // No operand predicates
     /* 291987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291993 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 291996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292007 */     GIR_RootConstrainSelectedInstOperands,
     /* 292008 */     // GIR_Coverage, 13474,
     /* 292008 */     GIR_EraseRootFromParent_Done,
     /* 292009 */   // Label 6029: @292009
     /* 292009 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(292072), // Rule ID 2002 //
     /* 292014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 292029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292054 */     // MIs[2] Operand 1
     /* 292054 */     // No operand predicates
     /* 292054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292056 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 292056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 292059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292070 */     GIR_RootConstrainSelectedInstOperands,
     /* 292071 */     // GIR_Coverage, 2002,
     /* 292071 */     GIR_EraseRootFromParent_Done,
     /* 292072 */   // Label 6030: @292072
     /* 292072 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(292099), // Rule ID 1321 //
     /* 292077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292088 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 292088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 292093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 292097 */     GIR_RootConstrainSelectedInstOperands,
     /* 292098 */     // GIR_Coverage, 1321,
     /* 292098 */     GIR_Done,
     /* 292099 */   // Label 6031: @292099
     /* 292099 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(292361), // Rule ID 7016 //
     /* 292104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 292107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292115 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 292115 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 292118 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 292122 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292127 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 292131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 292133 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 292136 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 292140 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292145 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 292149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 292151 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 292154 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 292158 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292163 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 292166 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 292169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 292171 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 292174 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292178 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292183 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 292189 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292194 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292199 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 292202 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 292206 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292211 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 292214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 292216 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 292219 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292223 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292228 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292234 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292239 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292244 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 292247 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 292251 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292256 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 292259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 292261 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 292264 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 292268 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292273 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 292276 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 292279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 292281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 292284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 292288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292293 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 292296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 292298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 292301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 292305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 292312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 292319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 292327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 292330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 292333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 292351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 292359 */     GIR_RootConstrainSelectedInstOperands,
     /* 292360 */     // GIR_Coverage, 7016,
     /* 292360 */     GIR_EraseRootFromParent_Done,
     /* 292361 */   // Label 6032: @292361
     /* 292361 */   GIM_Reject,
     /* 292362 */ // Label 6028: @292362
     /* 292362 */ GIM_Reject,
     /* 292363 */ // Label 5968: @292363
     /* 292363 */ GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(292388), // Rule ID 8224 //
     /* 292368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 292374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 292377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292381 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 292381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 292386 */   GIR_RootConstrainSelectedInstOperands,
     /* 292387 */   // GIR_Coverage, 8224,
     /* 292387 */   GIR_Done,
     /* 292388 */ // Label 6033: @292388
     /* 292388 */ GIM_Reject,
     /* 292389 */ // Label 5969: @292389
     /* 292389 */ GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(292414), // Rule ID 8222 //
     /* 292394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 292400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 292403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292407 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 292407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 292412 */   GIR_RootConstrainSelectedInstOperands,
     /* 292413 */   // GIR_Coverage, 8222,
     /* 292413 */   GIR_Done,
     /* 292414 */ // Label 6034: @292414
     /* 292414 */ GIM_Reject,
     /* 292415 */ // Label 5970: @292415
     /* 292415 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(292440), // Rule ID 8220 //
     /* 292420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 292426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 292429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292433 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 292433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 292438 */   GIR_RootConstrainSelectedInstOperands,
     /* 292439 */   // GIR_Coverage, 8220,
     /* 292439 */   GIR_Done,
     /* 292440 */ // Label 6035: @292440
     /* 292440 */ GIM_Reject,
     /* 292441 */ // Label 5971: @292441
     /* 292441 */ GIM_Reject,
     /* 292442 */ // Label 62: @292442
     /* 292442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6044*/ GIMT_Encode4(308714),
     /* 292453 */ /*GILLT_s16*//*Label 6036*/ GIMT_Encode4(292493),
     /* 292457 */ /*GILLT_s32*//*Label 6037*/ GIMT_Encode4(295497),
     /* 292461 */ /*GILLT_s64*//*Label 6038*/ GIMT_Encode4(298645), GIMT_Encode4(0),
     /* 292469 */ /*GILLT_v2s32*//*Label 6039*/ GIMT_Encode4(301793),
     /* 292473 */ /*GILLT_v2s64*//*Label 6040*/ GIMT_Encode4(303314),
     /* 292477 */ /*GILLT_v4s16*//*Label 6041*/ GIMT_Encode4(304835),
     /* 292481 */ /*GILLT_v4s32*//*Label 6042*/ GIMT_Encode4(306014), GIMT_Encode4(0),
     /* 292489 */ /*GILLT_v8s16*//*Label 6043*/ GIMT_Encode4(307535),
     /* 292493 */ // Label 6036: @292493
     /* 292493 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295496),
     /* 292498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 292507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292511 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(292661), // Rule ID 4865 //
     /* 292516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292540 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292565 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 292573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292577 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 292581 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292588 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292600 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292628 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 292659 */     GIR_RootConstrainSelectedInstOperands,
     /* 292660 */     // GIR_Coverage, 4865,
     /* 292660 */     GIR_EraseRootFromParent_Done,
     /* 292661 */   // Label 6046: @292661
     /* 292661 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(292808), // Rule ID 4829 //
     /* 292666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292690 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292727 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292737 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292749 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292777 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292806 */     GIR_RootConstrainSelectedInstOperands,
     /* 292807 */     // GIR_Coverage, 4829,
     /* 292807 */     GIR_EraseRootFromParent_Done,
     /* 292808 */   // Label 6047: @292808
     /* 292808 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(292955), // Rule ID 13882 //
     /* 292813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292874 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292884 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292896 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292902 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292907 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292924 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292953 */     GIR_RootConstrainSelectedInstOperands,
     /* 292954 */     // GIR_Coverage, 13882,
     /* 292954 */     GIR_EraseRootFromParent_Done,
     /* 292955 */   // Label 6048: @292955
     /* 292955 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(293086), // Rule ID 6091 //
     /* 292960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292984 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293008 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293012 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293016 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293025 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293029 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293033 */     // MIs[4] Operand 1
     /* 293033 */     // No operand predicates
     /* 293033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293039 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293051 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293084 */     GIR_RootConstrainSelectedInstOperands,
     /* 293085 */     // GIR_Coverage, 6091,
     /* 293085 */     GIR_EraseRootFromParent_Done,
     /* 293086 */   // Label 6049: @293086
     /* 293086 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(293217), // Rule ID 6123 //
     /* 293091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293127 */     // MIs[2] Operand 1
     /* 293127 */     // No operand predicates
     /* 293127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293135 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 293139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293143 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293147 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293151 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293155 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293160 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293168 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293170 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293215 */     GIR_RootConstrainSelectedInstOperands,
     /* 293216 */     // GIR_Coverage, 6123,
     /* 293216 */     GIR_EraseRootFromParent_Done,
     /* 293217 */   // Label 6050: @293217
     /* 293217 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(293348), // Rule ID 6187 //
     /* 293222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293258 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293274 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293278 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293283 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293287 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293291 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293295 */     // MIs[4] Operand 1
     /* 293295 */     // No operand predicates
     /* 293295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293301 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293313 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293346 */     GIR_RootConstrainSelectedInstOperands,
     /* 293347 */     // GIR_Coverage, 6187,
     /* 293347 */     GIR_EraseRootFromParent_Done,
     /* 293348 */   // Label 6051: @293348
     /* 293348 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(293479), // Rule ID 6155 //
     /* 293353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293401 */     // MIs[3] Operand 1
     /* 293401 */     // No operand predicates
     /* 293401 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 293405 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293409 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293413 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293417 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293422 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293430 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293432 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293444 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293477 */     GIR_RootConstrainSelectedInstOperands,
     /* 293478 */     // GIR_Coverage, 6155,
     /* 293478 */     GIR_EraseRootFromParent_Done,
     /* 293479 */   // Label 6052: @293479
     /* 293479 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(293614), // Rule ID 2456 //
     /* 293484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293533 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293543 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 293543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 293546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293555 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 293561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293583 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293612 */     GIR_RootConstrainSelectedInstOperands,
     /* 293613 */     // GIR_Coverage, 2456,
     /* 293613 */     GIR_EraseRootFromParent_Done,
     /* 293614 */   // Label 6053: @293614
     /* 293614 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(293733), // Rule ID 6059 //
     /* 293619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293676 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293680 */     // MIs[3] Operand 1
     /* 293680 */     // No operand predicates
     /* 293680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293686 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293698 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293731 */     GIR_RootConstrainSelectedInstOperands,
     /* 293732 */     // GIR_Coverage, 6059,
     /* 293732 */     GIR_EraseRootFromParent_Done,
     /* 293733 */   // Label 6054: @293733
     /* 293733 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(293852), // Rule ID 2538 //
     /* 293738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293774 */     // MIs[2] Operand 1
     /* 293774 */     // No operand predicates
     /* 293774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293790 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293795 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293805 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293850 */     GIR_RootConstrainSelectedInstOperands,
     /* 293851 */     // GIR_Coverage, 2538,
     /* 293851 */     GIR_EraseRootFromParent_Done,
     /* 293852 */   // Label 6055: @293852
     /* 293852 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(293952), // Rule ID 4827 //
     /* 293857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293908 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293950 */     GIR_RootConstrainSelectedInstOperands,
     /* 293951 */     // GIR_Coverage, 4827,
     /* 293951 */     GIR_EraseRootFromParent_Done,
     /* 293952 */   // Label 6056: @293952
     /* 293952 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(294052), // Rule ID 4863 //
     /* 293957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293981 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294008 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294020 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 294039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294050 */     GIR_RootConstrainSelectedInstOperands,
     /* 294051 */     // GIR_Coverage, 4863,
     /* 294051 */     GIR_EraseRootFromParent_Done,
     /* 294052 */   // Label 6057: @294052
     /* 294052 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(294149), // Rule ID 13878 //
     /* 294057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294093 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294107 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294147 */     GIR_RootConstrainSelectedInstOperands,
     /* 294148 */     // GIR_Coverage, 13878,
     /* 294148 */     GIR_EraseRootFromParent_Done,
     /* 294149 */   // Label 6058: @294149
     /* 294149 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(294249), // Rule ID 13880 //
     /* 294154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294195 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294205 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294247 */     GIR_RootConstrainSelectedInstOperands,
     /* 294248 */     // GIR_Coverage, 13880,
     /* 294248 */     GIR_EraseRootFromParent_Done,
     /* 294249 */   // Label 6059: @294249
     /* 294249 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(294349), // Rule ID 4861 //
     /* 294254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294305 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 294336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294347 */     GIR_RootConstrainSelectedInstOperands,
     /* 294348 */     // GIR_Coverage, 4861,
     /* 294348 */     GIR_EraseRootFromParent_Done,
     /* 294349 */   // Label 6060: @294349
     /* 294349 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(294446), // Rule ID 4825 //
     /* 294354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294404 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294444 */     GIR_RootConstrainSelectedInstOperands,
     /* 294445 */     // GIR_Coverage, 4825,
     /* 294445 */     GIR_EraseRootFromParent_Done,
     /* 294446 */   // Label 6061: @294446
     /* 294446 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(294530), // Rule ID 6121 //
     /* 294451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294487 */     // MIs[2] Operand 1
     /* 294487 */     // No operand predicates
     /* 294487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 294499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294510 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294528 */     GIR_RootConstrainSelectedInstOperands,
     /* 294529 */     // GIR_Coverage, 6121,
     /* 294529 */     GIR_EraseRootFromParent_Done,
     /* 294530 */   // Label 6062: @294530
     /* 294530 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(294611), // Rule ID 6153 //
     /* 294535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294583 */     // MIs[3] Operand 1
     /* 294583 */     // No operand predicates
     /* 294583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294593 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294609 */     GIR_RootConstrainSelectedInstOperands,
     /* 294610 */     // GIR_Coverage, 6153,
     /* 294610 */     GIR_EraseRootFromParent_Done,
     /* 294611 */   // Label 6063: @294611
     /* 294611 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(294695), // Rule ID 6185 //
     /* 294616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294665 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294669 */     // MIs[3] Operand 1
     /* 294669 */     // No operand predicates
     /* 294669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294675 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294693 */     GIR_RootConstrainSelectedInstOperands,
     /* 294694 */     // GIR_Coverage, 6185,
     /* 294694 */     GIR_EraseRootFromParent_Done,
     /* 294695 */   // Label 6064: @294695
     /* 294695 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(294776), // Rule ID 6089 //
     /* 294700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294748 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294752 */     // MIs[3] Operand 1
     /* 294752 */     // No operand predicates
     /* 294752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294758 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294774 */     GIR_RootConstrainSelectedInstOperands,
     /* 294775 */     // GIR_Coverage, 6089,
     /* 294775 */     GIR_EraseRootFromParent_Done,
     /* 294776 */   // Label 6065: @294776
     /* 294776 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(294861), // Rule ID 2454 //
     /* 294781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294819 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294831 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 294850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294859 */     GIR_RootConstrainSelectedInstOperands,
     /* 294860 */     // GIR_Coverage, 2454,
     /* 294860 */     GIR_EraseRootFromParent_Done,
     /* 294861 */   // Label 6066: @294861
     /* 294861 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(294946), // Rule ID 2452 //
     /* 294866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294894 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294904 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 294935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294944 */     GIR_RootConstrainSelectedInstOperands,
     /* 294945 */     // GIR_Coverage, 2452,
     /* 294945 */     GIR_EraseRootFromParent_Done,
     /* 294946 */   // Label 6067: @294946
     /* 294946 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(295015), // Rule ID 2536 //
     /* 294951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294987 */     // MIs[2] Operand 1
     /* 294987 */     // No operand predicates
     /* 294987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294997 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 295000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295013 */     GIR_RootConstrainSelectedInstOperands,
     /* 295014 */     // GIR_Coverage, 2536,
     /* 295014 */     GIR_EraseRootFromParent_Done,
     /* 295015 */   // Label 6068: @295015
     /* 295015 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(295084), // Rule ID 6057 //
     /* 295020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 295048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 295060 */     // MIs[2] Operand 1
     /* 295060 */     // No operand predicates
     /* 295060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295066 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 295066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 295069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295082 */     GIR_RootConstrainSelectedInstOperands,
     /* 295083 */     // GIR_Coverage, 6057,
     /* 295083 */     GIR_EraseRootFromParent_Done,
     /* 295084 */   // Label 6069: @295084
     /* 295084 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(295149), // Rule ID 4881 //
     /* 295089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295132 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 295135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295147 */     GIR_RootConstrainSelectedInstOperands,
     /* 295148 */     // GIR_Coverage, 4881,
     /* 295148 */     GIR_EraseRootFromParent_Done,
     /* 295149 */   // Label 6070: @295149
     /* 295149 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(295214), // Rule ID 13898 //
     /* 295154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295197 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 295200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295212 */     GIR_RootConstrainSelectedInstOperands,
     /* 295213 */     // GIR_Coverage, 13898,
     /* 295213 */     GIR_EraseRootFromParent_Done,
     /* 295214 */   // Label 6071: @295214
     /* 295214 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(295264), // Rule ID 4878 //
     /* 295219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295249 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295262 */     GIR_RootConstrainSelectedInstOperands,
     /* 295263 */     // GIR_Coverage, 4878,
     /* 295263 */     GIR_EraseRootFromParent_Done,
     /* 295264 */   // Label 6072: @295264
     /* 295264 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(295314), // Rule ID 13324 //
     /* 295269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295299 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295312 */     GIR_RootConstrainSelectedInstOperands,
     /* 295313 */     // GIR_Coverage, 13324,
     /* 295313 */     GIR_EraseRootFromParent_Done,
     /* 295314 */   // Label 6073: @295314
     /* 295314 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(295364), // Rule ID 644 //
     /* 295319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295349 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295362 */     GIR_RootConstrainSelectedInstOperands,
     /* 295363 */     // GIR_Coverage, 644,
     /* 295363 */     GIR_EraseRootFromParent_Done,
     /* 295364 */   // Label 6074: @295364
     /* 295364 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(295414), // Rule ID 13895 //
     /* 295369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295399 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295412 */     GIR_RootConstrainSelectedInstOperands,
     /* 295413 */     // GIR_Coverage, 13895,
     /* 295413 */     GIR_EraseRootFromParent_Done,
     /* 295414 */   // Label 6075: @295414
     /* 295414 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(295464), // Rule ID 656 //
     /* 295419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295449 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 295452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 295462 */     GIR_RootConstrainSelectedInstOperands,
     /* 295463 */     // GIR_Coverage, 656,
     /* 295463 */     GIR_EraseRootFromParent_Done,
     /* 295464 */   // Label 6076: @295464
     /* 295464 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(295495), // Rule ID 638 //
     /* 295469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295484 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 295489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295493 */     GIR_RootConstrainSelectedInstOperands,
     /* 295494 */     // GIR_Coverage, 638,
     /* 295494 */     GIR_Done,
     /* 295495 */   // Label 6077: @295495
     /* 295495 */   GIM_Reject,
     /* 295496 */ // Label 6045: @295496
     /* 295496 */ GIM_Reject,
     /* 295497 */ // Label 6037: @295497
     /* 295497 */ GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298644),
     /* 295502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 295511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295515 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(295665), // Rule ID 4871 //
     /* 295520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295544 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295569 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 295577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 295585 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295592 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295592 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295595 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295599 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295604 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295632 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 295663 */     GIR_RootConstrainSelectedInstOperands,
     /* 295664 */     // GIR_Coverage, 4871,
     /* 295664 */     GIR_EraseRootFromParent_Done,
     /* 295665 */   // Label 6079: @295665
     /* 295665 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(295812), // Rule ID 4835 //
     /* 295670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 295714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295726 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295731 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295741 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295753 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295810 */     GIR_RootConstrainSelectedInstOperands,
     /* 295811 */     // GIR_Coverage, 4835,
     /* 295811 */     GIR_EraseRootFromParent_Done,
     /* 295812 */   // Label 6080: @295812
     /* 295812 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(295959), // Rule ID 13888 //
     /* 295817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295853 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295865 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295869 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295873 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295878 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295888 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295900 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295928 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295957 */     GIR_RootConstrainSelectedInstOperands,
     /* 295958 */     // GIR_Coverage, 13888,
     /* 295958 */     GIR_EraseRootFromParent_Done,
     /* 295959 */   // Label 6081: @295959
     /* 295959 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(296090), // Rule ID 6107 //
     /* 295964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296033 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296037 */     // MIs[4] Operand 1
     /* 296037 */     // No operand predicates
     /* 296037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296041 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296043 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296088 */     GIR_RootConstrainSelectedInstOperands,
     /* 296089 */     // GIR_Coverage, 6107,
     /* 296089 */     GIR_EraseRootFromParent_Done,
     /* 296090 */   // Label 6082: @296090
     /* 296090 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(296221), // Rule ID 6139 //
     /* 296095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296131 */     // MIs[2] Operand 1
     /* 296131 */     // No operand predicates
     /* 296131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 296143 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 296147 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296151 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296155 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296159 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296164 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296172 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296174 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296186 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296219 */     GIR_RootConstrainSelectedInstOperands,
     /* 296220 */     // GIR_Coverage, 6139,
     /* 296220 */     GIR_EraseRootFromParent_Done,
     /* 296221 */   // Label 6083: @296221
     /* 296221 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(296352), // Rule ID 6203 //
     /* 296226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296262 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296295 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296299 */     // MIs[4] Operand 1
     /* 296299 */     // No operand predicates
     /* 296299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296305 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296350 */     GIR_RootConstrainSelectedInstOperands,
     /* 296351 */     // GIR_Coverage, 6203,
     /* 296351 */     GIR_EraseRootFromParent_Done,
     /* 296352 */   // Label 6084: @296352
     /* 296352 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(296483), // Rule ID 6171 //
     /* 296357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296405 */     // MIs[3] Operand 1
     /* 296405 */     // No operand predicates
     /* 296405 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 296409 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296413 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296417 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296421 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296426 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296436 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296481 */     GIR_RootConstrainSelectedInstOperands,
     /* 296482 */     // GIR_Coverage, 6171,
     /* 296482 */     GIR_EraseRootFromParent_Done,
     /* 296483 */   // Label 6085: @296483
     /* 296483 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(296618), // Rule ID 2462 //
     /* 296488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296547 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 296547 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 296550 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296554 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296559 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 296565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296616 */     GIR_RootConstrainSelectedInstOperands,
     /* 296617 */     // GIR_Coverage, 2462,
     /* 296617 */     GIR_EraseRootFromParent_Done,
     /* 296618 */   // Label 6086: @296618
     /* 296618 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(296737), // Rule ID 6075 //
     /* 296623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296680 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296684 */     // MIs[3] Operand 1
     /* 296684 */     // No operand predicates
     /* 296684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296690 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296735 */     GIR_RootConstrainSelectedInstOperands,
     /* 296736 */     // GIR_Coverage, 6075,
     /* 296736 */     GIR_EraseRootFromParent_Done,
     /* 296737 */   // Label 6087: @296737
     /* 296737 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(296856), // Rule ID 2554 //
     /* 296742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296778 */     // MIs[2] Operand 1
     /* 296778 */     // No operand predicates
     /* 296778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296794 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296799 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296809 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296854 */     GIR_RootConstrainSelectedInstOperands,
     /* 296855 */     // GIR_Coverage, 2554,
     /* 296855 */     GIR_EraseRootFromParent_Done,
     /* 296856 */   // Label 6088: @296856
     /* 296856 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(296956), // Rule ID 4833 //
     /* 296861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296885 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296912 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296924 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296954 */     GIR_RootConstrainSelectedInstOperands,
     /* 296955 */     // GIR_Coverage, 4833,
     /* 296955 */     GIR_EraseRootFromParent_Done,
     /* 296956 */   // Label 6089: @296956
     /* 296956 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(297056), // Rule ID 4869 //
     /* 296961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296985 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 297005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297012 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 297043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297054 */     GIR_RootConstrainSelectedInstOperands,
     /* 297055 */     // GIR_Coverage, 4869,
     /* 297055 */     GIR_EraseRootFromParent_Done,
     /* 297056 */   // Label 6090: @297056
     /* 297056 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(297153), // Rule ID 13884 //
     /* 297061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297097 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297111 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297151 */     GIR_RootConstrainSelectedInstOperands,
     /* 297152 */     // GIR_Coverage, 13884,
     /* 297152 */     GIR_EraseRootFromParent_Done,
     /* 297153 */   // Label 6091: @297153
     /* 297153 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(297253), // Rule ID 13886 //
     /* 297158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297209 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297251 */     GIR_RootConstrainSelectedInstOperands,
     /* 297252 */     // GIR_Coverage, 13886,
     /* 297252 */     GIR_EraseRootFromParent_Done,
     /* 297253 */   // Label 6092: @297253
     /* 297253 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(297353), // Rule ID 4867 //
     /* 297258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297286 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 297302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297309 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 297340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297351 */     GIR_RootConstrainSelectedInstOperands,
     /* 297352 */     // GIR_Coverage, 4867,
     /* 297352 */     GIR_EraseRootFromParent_Done,
     /* 297353 */   // Label 6093: @297353
     /* 297353 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(297450), // Rule ID 4831 //
     /* 297358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297408 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297448 */     GIR_RootConstrainSelectedInstOperands,
     /* 297449 */     // GIR_Coverage, 4831,
     /* 297449 */     GIR_EraseRootFromParent_Done,
     /* 297450 */   // Label 6094: @297450
     /* 297450 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(297528), // Rule ID 6225 //
     /* 297455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297500 */     // MIs[3] Operand 1
     /* 297500 */     // No operand predicates
     /* 297500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297510 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297526 */     GIR_RootConstrainSelectedInstOperands,
     /* 297527 */     // GIR_Coverage, 6225,
     /* 297527 */     GIR_EraseRootFromParent_Done,
     /* 297528 */   // Label 6095: @297528
     /* 297528 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(297612), // Rule ID 6137 //
     /* 297533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297569 */     // MIs[2] Operand 1
     /* 297569 */     // No operand predicates
     /* 297569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297577 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 297581 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297592 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 297603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297610 */     GIR_RootConstrainSelectedInstOperands,
     /* 297611 */     // GIR_Coverage, 6137,
     /* 297611 */     GIR_EraseRootFromParent_Done,
     /* 297612 */   // Label 6096: @297612
     /* 297612 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(297693), // Rule ID 6169 //
     /* 297617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297661 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297665 */     // MIs[3] Operand 1
     /* 297665 */     // No operand predicates
     /* 297665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297675 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297691 */     GIR_RootConstrainSelectedInstOperands,
     /* 297692 */     // GIR_Coverage, 6169,
     /* 297692 */     GIR_EraseRootFromParent_Done,
     /* 297693 */   // Label 6097: @297693
     /* 297693 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(297777), // Rule ID 6201 //
     /* 297698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297747 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297751 */     // MIs[3] Operand 1
     /* 297751 */     // No operand predicates
     /* 297751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297757 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297775 */     GIR_RootConstrainSelectedInstOperands,
     /* 297776 */     // GIR_Coverage, 6201,
     /* 297776 */     GIR_EraseRootFromParent_Done,
     /* 297777 */   // Label 6098: @297777
     /* 297777 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(297855), // Rule ID 6247 //
     /* 297782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297831 */     // MIs[3] Operand 1
     /* 297831 */     // No operand predicates
     /* 297831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297837 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297853 */     GIR_RootConstrainSelectedInstOperands,
     /* 297854 */     // GIR_Coverage, 6247,
     /* 297854 */     GIR_EraseRootFromParent_Done,
     /* 297855 */   // Label 6099: @297855
     /* 297855 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(297936), // Rule ID 6105 //
     /* 297860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297912 */     // MIs[3] Operand 1
     /* 297912 */     // No operand predicates
     /* 297912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297918 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297934 */     GIR_RootConstrainSelectedInstOperands,
     /* 297935 */     // GIR_Coverage, 6105,
     /* 297935 */     GIR_EraseRootFromParent_Done,
     /* 297936 */   // Label 6100: @297936
     /* 297936 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(298021), // Rule ID 2460 //
     /* 297941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297965 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297979 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298019 */     GIR_RootConstrainSelectedInstOperands,
     /* 298020 */     // GIR_Coverage, 2460,
     /* 298020 */     GIR_EraseRootFromParent_Done,
     /* 298021 */   // Label 6101: @298021
     /* 298021 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(298106), // Rule ID 2458 //
     /* 298026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298054 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298064 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 298064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 298082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298104 */     GIR_RootConstrainSelectedInstOperands,
     /* 298105 */     // GIR_Coverage, 2458,
     /* 298105 */     GIR_EraseRootFromParent_Done,
     /* 298106 */   // Label 6102: @298106
     /* 298106 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(298175), // Rule ID 2552 //
     /* 298111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298147 */     // MIs[2] Operand 1
     /* 298147 */     // No operand predicates
     /* 298147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298157 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 298160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298173 */     GIR_RootConstrainSelectedInstOperands,
     /* 298174 */     // GIR_Coverage, 2552,
     /* 298174 */     GIR_EraseRootFromParent_Done,
     /* 298175 */   // Label 6103: @298175
     /* 298175 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(298244), // Rule ID 6073 //
     /* 298180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298220 */     // MIs[2] Operand 1
     /* 298220 */     // No operand predicates
     /* 298220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298226 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 298229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298242 */     GIR_RootConstrainSelectedInstOperands,
     /* 298243 */     // GIR_Coverage, 6073,
     /* 298243 */     GIR_EraseRootFromParent_Done,
     /* 298244 */   // Label 6104: @298244
     /* 298244 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(298306), // Rule ID 4882 //
     /* 298249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 298282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298289 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298304 */     GIR_RootConstrainSelectedInstOperands,
     /* 298305 */     // GIR_Coverage, 4882,
     /* 298305 */     GIR_EraseRootFromParent_Done,
     /* 298306 */   // Label 6105: @298306
     /* 298306 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(298368), // Rule ID 13899 //
     /* 298311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 298344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298351 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298366 */     GIR_RootConstrainSelectedInstOperands,
     /* 298367 */     // GIR_Coverage, 13899,
     /* 298367 */     GIR_EraseRootFromParent_Done,
     /* 298368 */   // Label 6106: @298368
     /* 298368 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(298415), // Rule ID 4879 //
     /* 298373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298400 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298413 */     GIR_RootConstrainSelectedInstOperands,
     /* 298414 */     // GIR_Coverage, 4879,
     /* 298414 */     GIR_EraseRootFromParent_Done,
     /* 298415 */   // Label 6107: @298415
     /* 298415 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(298465), // Rule ID 13326 //
     /* 298420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298450 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298463 */     GIR_RootConstrainSelectedInstOperands,
     /* 298464 */     // GIR_Coverage, 13326,
     /* 298464 */     GIR_EraseRootFromParent_Done,
     /* 298465 */   // Label 6108: @298465
     /* 298465 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(298515), // Rule ID 646 //
     /* 298470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298500 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298513 */     GIR_RootConstrainSelectedInstOperands,
     /* 298514 */     // GIR_Coverage, 646,
     /* 298514 */     GIR_EraseRootFromParent_Done,
     /* 298515 */   // Label 6109: @298515
     /* 298515 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(298562), // Rule ID 13896 //
     /* 298520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298547 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298560 */     GIR_RootConstrainSelectedInstOperands,
     /* 298561 */     // GIR_Coverage, 13896,
     /* 298561 */     GIR_EraseRootFromParent_Done,
     /* 298562 */   // Label 6110: @298562
     /* 298562 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(298612), // Rule ID 658 //
     /* 298567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298597 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 298600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 298610 */     GIR_RootConstrainSelectedInstOperands,
     /* 298611 */     // GIR_Coverage, 658,
     /* 298611 */     GIR_EraseRootFromParent_Done,
     /* 298612 */   // Label 6111: @298612
     /* 298612 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(298643), // Rule ID 640 //
     /* 298617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298632 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298641 */     GIR_RootConstrainSelectedInstOperands,
     /* 298642 */     // GIR_Coverage, 640,
     /* 298642 */     GIR_Done,
     /* 298643 */   // Label 6112: @298643
     /* 298643 */   GIM_Reject,
     /* 298644 */ // Label 6078: @298644
     /* 298644 */ GIM_Reject,
     /* 298645 */ // Label 6038: @298645
     /* 298645 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301792),
     /* 298650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 298659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298663 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(298813), // Rule ID 4877 //
     /* 298668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298717 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 298725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298729 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 298733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298740 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298740 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298743 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298747 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298752 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298758 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298780 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 298811 */     GIR_RootConstrainSelectedInstOperands,
     /* 298812 */     // GIR_Coverage, 4877,
     /* 298812 */     GIR_EraseRootFromParent_Done,
     /* 298813 */   // Label 6114: @298813
     /* 298813 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(298960), // Rule ID 4841 //
     /* 298818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298842 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298866 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298870 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298874 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298879 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298889 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298901 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298907 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298912 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298929 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298958 */     GIR_RootConstrainSelectedInstOperands,
     /* 298959 */     // GIR_Coverage, 4841,
     /* 298959 */     GIR_EraseRootFromParent_Done,
     /* 298960 */   // Label 6115: @298960
     /* 298960 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(299107), // Rule ID 13894 //
     /* 298965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299026 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 299030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299036 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299048 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 299103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299105 */     GIR_RootConstrainSelectedInstOperands,
     /* 299106 */     // GIR_Coverage, 13894,
     /* 299106 */     GIR_EraseRootFromParent_Done,
     /* 299107 */   // Label 6116: @299107
     /* 299107 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(299238), // Rule ID 6111 //
     /* 299112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299136 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299168 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299173 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299177 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299181 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299185 */     // MIs[4] Operand 1
     /* 299185 */     // No operand predicates
     /* 299185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299191 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299236 */     GIR_RootConstrainSelectedInstOperands,
     /* 299237 */     // GIR_Coverage, 6111,
     /* 299237 */     GIR_EraseRootFromParent_Done,
     /* 299238 */   // Label 6117: @299238
     /* 299238 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(299369), // Rule ID 6143 //
     /* 299243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299275 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299279 */     // MIs[2] Operand 1
     /* 299279 */     // No operand predicates
     /* 299279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 299291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 299295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299303 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 299307 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299312 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 299316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299320 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299322 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299367 */     GIR_RootConstrainSelectedInstOperands,
     /* 299368 */     // GIR_Coverage, 6143,
     /* 299368 */     GIR_EraseRootFromParent_Done,
     /* 299369 */   // Label 6118: @299369
     /* 299369 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(299500), // Rule ID 6207 //
     /* 299374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299435 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299439 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299443 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299447 */     // MIs[4] Operand 1
     /* 299447 */     // No operand predicates
     /* 299447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299453 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299465 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299498 */     GIR_RootConstrainSelectedInstOperands,
     /* 299499 */     // GIR_Coverage, 6207,
     /* 299499 */     GIR_EraseRootFromParent_Done,
     /* 299500 */   // Label 6119: @299500
     /* 299500 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(299631), // Rule ID 6175 //
     /* 299505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299549 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299553 */     // MIs[3] Operand 1
     /* 299553 */     // No operand predicates
     /* 299553 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 299557 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299561 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299565 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 299569 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299574 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 299578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299584 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299629 */     GIR_RootConstrainSelectedInstOperands,
     /* 299630 */     // GIR_Coverage, 6175,
     /* 299630 */     GIR_EraseRootFromParent_Done,
     /* 299631 */   // Label 6120: @299631
     /* 299631 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(299766), // Rule ID 2468 //
     /* 299636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299695 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299707 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 299762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299764 */     GIR_RootConstrainSelectedInstOperands,
     /* 299765 */     // GIR_Coverage, 2468,
     /* 299765 */     GIR_EraseRootFromParent_Done,
     /* 299766 */   // Label 6121: @299766
     /* 299766 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(299885), // Rule ID 6079 //
     /* 299771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299832 */     // MIs[3] Operand 1
     /* 299832 */     // No operand predicates
     /* 299832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299838 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299850 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299883 */     GIR_RootConstrainSelectedInstOperands,
     /* 299884 */     // GIR_Coverage, 6079,
     /* 299884 */     GIR_EraseRootFromParent_Done,
     /* 299885 */   // Label 6122: @299885
     /* 299885 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(300004), // Rule ID 2558 //
     /* 299890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299926 */     // MIs[2] Operand 1
     /* 299926 */     // No operand predicates
     /* 299926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299947 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 299951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299957 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300002 */     GIR_RootConstrainSelectedInstOperands,
     /* 300003 */     // GIR_Coverage, 2558,
     /* 300003 */     GIR_EraseRootFromParent_Done,
     /* 300004 */   // Label 6123: @300004
     /* 300004 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(300104), // Rule ID 4839 //
     /* 300009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300060 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300102 */     GIR_RootConstrainSelectedInstOperands,
     /* 300103 */     // GIR_Coverage, 4839,
     /* 300103 */     GIR_EraseRootFromParent_Done,
     /* 300104 */   // Label 6124: @300104
     /* 300104 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(300204), // Rule ID 4875 //
     /* 300109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 300145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300160 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 300191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 300198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 300202 */     GIR_RootConstrainSelectedInstOperands,
     /* 300203 */     // GIR_Coverage, 4875,
     /* 300203 */     GIR_EraseRootFromParent_Done,
     /* 300204 */   // Label 6125: @300204
     /* 300204 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(300301), // Rule ID 13890 //
     /* 300209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300245 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300259 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300271 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300299 */     GIR_RootConstrainSelectedInstOperands,
     /* 300300 */     // GIR_Coverage, 13890,
     /* 300300 */     GIR_EraseRootFromParent_Done,
     /* 300301 */   // Label 6126: @300301
     /* 300301 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(300401), // Rule ID 13892 //
     /* 300306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300357 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300399 */     GIR_RootConstrainSelectedInstOperands,
     /* 300400 */     // GIR_Coverage, 13892,
     /* 300400 */     GIR_EraseRootFromParent_Done,
     /* 300401 */   // Label 6127: @300401
     /* 300401 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(300501), // Rule ID 4873 //
     /* 300406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 300442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300457 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 300488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 300499 */     GIR_RootConstrainSelectedInstOperands,
     /* 300500 */     // GIR_Coverage, 4873,
     /* 300500 */     GIR_EraseRootFromParent_Done,
     /* 300501 */   // Label 6128: @300501
     /* 300501 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(300598), // Rule ID 4837 //
     /* 300506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300546 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300556 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300568 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300596 */     GIR_RootConstrainSelectedInstOperands,
     /* 300597 */     // GIR_Coverage, 4837,
     /* 300597 */     GIR_EraseRootFromParent_Done,
     /* 300598 */   // Label 6129: @300598
     /* 300598 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(300676), // Rule ID 6229 //
     /* 300603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300644 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300648 */     // MIs[3] Operand 1
     /* 300648 */     // No operand predicates
     /* 300648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300658 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300674 */     GIR_RootConstrainSelectedInstOperands,
     /* 300675 */     // GIR_Coverage, 6229,
     /* 300675 */     GIR_EraseRootFromParent_Done,
     /* 300676 */   // Label 6130: @300676
     /* 300676 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(300760), // Rule ID 6141 //
     /* 300681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300717 */     // MIs[2] Operand 1
     /* 300717 */     // No operand predicates
     /* 300717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 300729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300740 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300758 */     GIR_RootConstrainSelectedInstOperands,
     /* 300759 */     // GIR_Coverage, 6141,
     /* 300759 */     GIR_EraseRootFromParent_Done,
     /* 300760 */   // Label 6131: @300760
     /* 300760 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(300841), // Rule ID 6173 //
     /* 300765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300809 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300813 */     // MIs[3] Operand 1
     /* 300813 */     // No operand predicates
     /* 300813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300823 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300839 */     GIR_RootConstrainSelectedInstOperands,
     /* 300840 */     // GIR_Coverage, 6173,
     /* 300840 */     GIR_EraseRootFromParent_Done,
     /* 300841 */   // Label 6132: @300841
     /* 300841 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(300925), // Rule ID 6205 //
     /* 300846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300895 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300899 */     // MIs[3] Operand 1
     /* 300899 */     // No operand predicates
     /* 300899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300905 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300923 */     GIR_RootConstrainSelectedInstOperands,
     /* 300924 */     // GIR_Coverage, 6205,
     /* 300924 */     GIR_EraseRootFromParent_Done,
     /* 300925 */   // Label 6133: @300925
     /* 300925 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(301003), // Rule ID 6251 //
     /* 300930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300979 */     // MIs[3] Operand 1
     /* 300979 */     // No operand predicates
     /* 300979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300985 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301001 */     GIR_RootConstrainSelectedInstOperands,
     /* 301002 */     // GIR_Coverage, 6251,
     /* 301002 */     GIR_EraseRootFromParent_Done,
     /* 301003 */   // Label 6134: @301003
     /* 301003 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(301084), // Rule ID 6109 //
     /* 301008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301056 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301060 */     // MIs[3] Operand 1
     /* 301060 */     // No operand predicates
     /* 301060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301066 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 301069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301082 */     GIR_RootConstrainSelectedInstOperands,
     /* 301083 */     // GIR_Coverage, 6109,
     /* 301083 */     GIR_EraseRootFromParent_Done,
     /* 301084 */   // Label 6135: @301084
     /* 301084 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(301169), // Rule ID 2466 //
     /* 301089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301113 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301127 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301167 */     GIR_RootConstrainSelectedInstOperands,
     /* 301168 */     // GIR_Coverage, 2466,
     /* 301168 */     GIR_EraseRootFromParent_Done,
     /* 301169 */   // Label 6136: @301169
     /* 301169 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(301254), // Rule ID 2464 //
     /* 301174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301202 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301212 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301224 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301252 */     GIR_RootConstrainSelectedInstOperands,
     /* 301253 */     // GIR_Coverage, 2464,
     /* 301253 */     GIR_EraseRootFromParent_Done,
     /* 301254 */   // Label 6137: @301254
     /* 301254 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(301323), // Rule ID 2556 //
     /* 301259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301295 */     // MIs[2] Operand 1
     /* 301295 */     // No operand predicates
     /* 301295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301305 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 301308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301321 */     GIR_RootConstrainSelectedInstOperands,
     /* 301322 */     // GIR_Coverage, 2556,
     /* 301322 */     GIR_EraseRootFromParent_Done,
     /* 301323 */   // Label 6138: @301323
     /* 301323 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(301392), // Rule ID 6077 //
     /* 301328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301364 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301368 */     // MIs[2] Operand 1
     /* 301368 */     // No operand predicates
     /* 301368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301374 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 301377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301390 */     GIR_RootConstrainSelectedInstOperands,
     /* 301391 */     // GIR_Coverage, 6077,
     /* 301391 */     GIR_EraseRootFromParent_Done,
     /* 301392 */   // Label 6139: @301392
     /* 301392 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(301454), // Rule ID 4883 //
     /* 301397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 301422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301437 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 301452 */     GIR_RootConstrainSelectedInstOperands,
     /* 301453 */     // GIR_Coverage, 4883,
     /* 301453 */     GIR_EraseRootFromParent_Done,
     /* 301454 */   // Label 6140: @301454
     /* 301454 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(301516), // Rule ID 13900 //
     /* 301459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 301484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301499 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 301514 */     GIR_RootConstrainSelectedInstOperands,
     /* 301515 */     // GIR_Coverage, 13900,
     /* 301515 */     GIR_EraseRootFromParent_Done,
     /* 301516 */   // Label 6141: @301516
     /* 301516 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(301563), // Rule ID 4880 //
     /* 301521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301548 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301561 */     GIR_RootConstrainSelectedInstOperands,
     /* 301562 */     // GIR_Coverage, 4880,
     /* 301562 */     GIR_EraseRootFromParent_Done,
     /* 301563 */   // Label 6142: @301563
     /* 301563 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(301613), // Rule ID 13328 //
     /* 301568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301598 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301611 */     GIR_RootConstrainSelectedInstOperands,
     /* 301612 */     // GIR_Coverage, 13328,
     /* 301612 */     GIR_EraseRootFromParent_Done,
     /* 301613 */   // Label 6143: @301613
     /* 301613 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(301663), // Rule ID 648 //
     /* 301618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301648 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301661 */     GIR_RootConstrainSelectedInstOperands,
     /* 301662 */     // GIR_Coverage, 648,
     /* 301662 */     GIR_EraseRootFromParent_Done,
     /* 301663 */   // Label 6144: @301663
     /* 301663 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(301710), // Rule ID 13897 //
     /* 301668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301695 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301708 */     GIR_RootConstrainSelectedInstOperands,
     /* 301709 */     // GIR_Coverage, 13897,
     /* 301709 */     GIR_EraseRootFromParent_Done,
     /* 301710 */   // Label 6145: @301710
     /* 301710 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(301760), // Rule ID 660 //
     /* 301715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 301730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301745 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 301748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 301758 */     GIR_RootConstrainSelectedInstOperands,
     /* 301759 */     // GIR_Coverage, 660,
     /* 301759 */     GIR_EraseRootFromParent_Done,
     /* 301760 */   // Label 6146: @301760
     /* 301760 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(301791), // Rule ID 642 //
     /* 301765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301780 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301789 */     GIR_RootConstrainSelectedInstOperands,
     /* 301790 */     // GIR_Coverage, 642,
     /* 301790 */     GIR_Done,
     /* 301791 */   // Label 6147: @301791
     /* 301791 */   GIM_Reject,
     /* 301792 */ // Label 6113: @301792
     /* 301792 */ GIM_Reject,
     /* 301793 */ // Label 6039: @301793
     /* 301793 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303313),
     /* 301798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301811 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(301889), // Rule ID 6209 //
     /* 301816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301857 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301861 */     // MIs[3] Operand 1
     /* 301861 */     // No operand predicates
     /* 301861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301871 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301887 */     GIR_RootConstrainSelectedInstOperands,
     /* 301888 */     // GIR_Coverage, 6209,
     /* 301888 */     GIR_EraseRootFromParent_Done,
     /* 301889 */   // Label 6149: @301889
     /* 301889 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(301973), // Rule ID 6125 //
     /* 301894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301926 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301930 */     // MIs[2] Operand 1
     /* 301930 */     // No operand predicates
     /* 301930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 301934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301953 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 301964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301971 */     GIR_RootConstrainSelectedInstOperands,
     /* 301972 */     // GIR_Coverage, 6125,
     /* 301972 */     GIR_EraseRootFromParent_Done,
     /* 301973 */   // Label 6150: @301973
     /* 301973 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(302054), // Rule ID 6157 //
     /* 301978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302022 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302026 */     // MIs[3] Operand 1
     /* 302026 */     // No operand predicates
     /* 302026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302036 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302052 */     GIR_RootConstrainSelectedInstOperands,
     /* 302053 */     // GIR_Coverage, 6157,
     /* 302053 */     GIR_EraseRootFromParent_Done,
     /* 302054 */   // Label 6151: @302054
     /* 302054 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(302138), // Rule ID 6189 //
     /* 302059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302108 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302112 */     // MIs[3] Operand 1
     /* 302112 */     // No operand predicates
     /* 302112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302118 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302136 */     GIR_RootConstrainSelectedInstOperands,
     /* 302137 */     // GIR_Coverage, 6189,
     /* 302137 */     GIR_EraseRootFromParent_Done,
     /* 302138 */   // Label 6152: @302138
     /* 302138 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(302216), // Rule ID 6231 //
     /* 302143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 302184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302188 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302192 */     // MIs[3] Operand 1
     /* 302192 */     // No operand predicates
     /* 302192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302198 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302214 */     GIR_RootConstrainSelectedInstOperands,
     /* 302215 */     // GIR_Coverage, 6231,
     /* 302215 */     GIR_EraseRootFromParent_Done,
     /* 302216 */   // Label 6153: @302216
     /* 302216 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(302297), // Rule ID 6093 //
     /* 302221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302269 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302273 */     // MIs[3] Operand 1
     /* 302273 */     // No operand predicates
     /* 302273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302279 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302295 */     GIR_RootConstrainSelectedInstOperands,
     /* 302296 */     // GIR_Coverage, 6093,
     /* 302296 */     GIR_EraseRootFromParent_Done,
     /* 302297 */   // Label 6154: @302297
     /* 302297 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(302366), // Rule ID 2540 //
     /* 302302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302334 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302338 */     // MIs[2] Operand 1
     /* 302338 */     // No operand predicates
     /* 302338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302348 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 302351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302364 */     GIR_RootConstrainSelectedInstOperands,
     /* 302365 */     // GIR_Coverage, 2540,
     /* 302365 */     GIR_EraseRootFromParent_Done,
     /* 302366 */   // Label 6155: @302366
     /* 302366 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(302435), // Rule ID 6061 //
     /* 302371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302407 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302411 */     // MIs[2] Operand 1
     /* 302411 */     // No operand predicates
     /* 302411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302417 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 302420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302433 */     GIR_RootConstrainSelectedInstOperands,
     /* 302434 */     // GIR_Coverage, 6061,
     /* 302434 */     GIR_EraseRootFromParent_Done,
     /* 302435 */   // Label 6156: @302435
     /* 302435 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(302528), // Rule ID 6213 //
     /* 302440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302479 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302526 */     GIR_RootConstrainSelectedInstOperands,
     /* 302527 */     // GIR_Coverage, 6213,
     /* 302527 */     GIR_EraseRootFromParent_Done,
     /* 302528 */   // Label 6157: @302528
     /* 302528 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(302627), // Rule ID 6127 //
     /* 302533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302576 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302625 */     GIR_RootConstrainSelectedInstOperands,
     /* 302626 */     // GIR_Coverage, 6127,
     /* 302626 */     GIR_EraseRootFromParent_Done,
     /* 302627 */   // Label 6158: @302627
     /* 302627 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(302723), // Rule ID 6159 //
     /* 302632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302674 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302721 */     GIR_RootConstrainSelectedInstOperands,
     /* 302722 */     // GIR_Coverage, 6159,
     /* 302722 */     GIR_EraseRootFromParent_Done,
     /* 302723 */   // Label 6159: @302723
     /* 302723 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(302822), // Rule ID 6191 //
     /* 302728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302771 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302820 */     GIR_RootConstrainSelectedInstOperands,
     /* 302821 */     // GIR_Coverage, 6191,
     /* 302821 */     GIR_EraseRootFromParent_Done,
     /* 302822 */   // Label 6160: @302822
     /* 302822 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(302915), // Rule ID 6235 //
     /* 302827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302866 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302913 */     GIR_RootConstrainSelectedInstOperands,
     /* 302914 */     // GIR_Coverage, 6235,
     /* 302914 */     GIR_EraseRootFromParent_Done,
     /* 302915 */   // Label 6161: @302915
     /* 302915 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(303011), // Rule ID 6095 //
     /* 302920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302962 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303009 */     GIR_RootConstrainSelectedInstOperands,
     /* 303010 */     // GIR_Coverage, 6095,
     /* 303010 */     GIR_EraseRootFromParent_Done,
     /* 303011 */   // Label 6162: @303011
     /* 303011 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(303095), // Rule ID 2542 //
     /* 303016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303046 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 303081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303093 */     GIR_RootConstrainSelectedInstOperands,
     /* 303094 */     // GIR_Coverage, 2542,
     /* 303094 */     GIR_EraseRootFromParent_Done,
     /* 303095 */   // Label 6163: @303095
     /* 303095 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(303145), // Rule ID 13358 //
     /* 303100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303130 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 303133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303143 */     GIR_RootConstrainSelectedInstOperands,
     /* 303144 */     // GIR_Coverage, 13358,
     /* 303144 */     GIR_EraseRootFromParent_Done,
     /* 303145 */   // Label 6164: @303145
     /* 303145 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(303229), // Rule ID 6063 //
     /* 303150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303180 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 303215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303227 */     GIR_RootConstrainSelectedInstOperands,
     /* 303228 */     // GIR_Coverage, 6063,
     /* 303228 */     GIR_EraseRootFromParent_Done,
     /* 303229 */   // Label 6165: @303229
     /* 303229 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(303279), // Rule ID 1308 //
     /* 303234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303264 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 303267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303277 */     GIR_RootConstrainSelectedInstOperands,
     /* 303278 */     // GIR_Coverage, 1308,
     /* 303278 */     GIR_EraseRootFromParent_Done,
     /* 303279 */   // Label 6166: @303279
     /* 303279 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(303312), // Rule ID 1298 //
     /* 303284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303299 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 303302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303310 */     GIR_RootConstrainSelectedInstOperands,
     /* 303311 */     // GIR_Coverage, 1298,
     /* 303311 */     GIR_EraseRootFromParent_Done,
     /* 303312 */   // Label 6167: @303312
     /* 303312 */   GIM_Reject,
     /* 303313 */ // Label 6148: @303313
     /* 303313 */ GIM_Reject,
     /* 303314 */ // Label 6040: @303314
     /* 303314 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(304834),
     /* 303319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 303328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303332 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(303410), // Rule ID 6221 //
     /* 303337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303378 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303382 */     // MIs[3] Operand 1
     /* 303382 */     // No operand predicates
     /* 303382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303392 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303408 */     GIR_RootConstrainSelectedInstOperands,
     /* 303409 */     // GIR_Coverage, 6221,
     /* 303409 */     GIR_EraseRootFromParent_Done,
     /* 303410 */   // Label 6169: @303410
     /* 303410 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(303494), // Rule ID 6133 //
     /* 303415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303451 */     // MIs[2] Operand 1
     /* 303451 */     // No operand predicates
     /* 303451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303459 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303463 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303474 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303492 */     GIR_RootConstrainSelectedInstOperands,
     /* 303493 */     // GIR_Coverage, 6133,
     /* 303493 */     GIR_EraseRootFromParent_Done,
     /* 303494 */   // Label 6170: @303494
     /* 303494 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(303575), // Rule ID 6165 //
     /* 303499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303543 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303547 */     // MIs[3] Operand 1
     /* 303547 */     // No operand predicates
     /* 303547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303557 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303573 */     GIR_RootConstrainSelectedInstOperands,
     /* 303574 */     // GIR_Coverage, 6165,
     /* 303574 */     GIR_EraseRootFromParent_Done,
     /* 303575 */   // Label 6171: @303575
     /* 303575 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(303659), // Rule ID 6197 //
     /* 303580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303629 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303633 */     // MIs[3] Operand 1
     /* 303633 */     // No operand predicates
     /* 303633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303639 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303657 */     GIR_RootConstrainSelectedInstOperands,
     /* 303658 */     // GIR_Coverage, 6197,
     /* 303658 */     GIR_EraseRootFromParent_Done,
     /* 303659 */   // Label 6172: @303659
     /* 303659 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(303737), // Rule ID 6243 //
     /* 303664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303709 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303713 */     // MIs[3] Operand 1
     /* 303713 */     // No operand predicates
     /* 303713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303719 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303735 */     GIR_RootConstrainSelectedInstOperands,
     /* 303736 */     // GIR_Coverage, 6243,
     /* 303736 */     GIR_EraseRootFromParent_Done,
     /* 303737 */   // Label 6173: @303737
     /* 303737 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(303818), // Rule ID 6101 //
     /* 303742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303790 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303794 */     // MIs[3] Operand 1
     /* 303794 */     // No operand predicates
     /* 303794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303800 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303816 */     GIR_RootConstrainSelectedInstOperands,
     /* 303817 */     // GIR_Coverage, 6101,
     /* 303817 */     GIR_EraseRootFromParent_Done,
     /* 303818 */   // Label 6174: @303818
     /* 303818 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(303887), // Rule ID 2548 //
     /* 303823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303859 */     // MIs[2] Operand 1
     /* 303859 */     // No operand predicates
     /* 303859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303869 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303885 */     GIR_RootConstrainSelectedInstOperands,
     /* 303886 */     // GIR_Coverage, 2548,
     /* 303886 */     GIR_EraseRootFromParent_Done,
     /* 303887 */   // Label 6175: @303887
     /* 303887 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(303956), // Rule ID 6069 //
     /* 303892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303932 */     // MIs[2] Operand 1
     /* 303932 */     // No operand predicates
     /* 303932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303938 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303954 */     GIR_RootConstrainSelectedInstOperands,
     /* 303955 */     // GIR_Coverage, 6069,
     /* 303955 */     GIR_EraseRootFromParent_Done,
     /* 303956 */   // Label 6176: @303956
     /* 303956 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(304049), // Rule ID 6223 //
     /* 303961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 303985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304000 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304015 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304047 */     GIR_RootConstrainSelectedInstOperands,
     /* 304048 */     // GIR_Coverage, 6223,
     /* 304048 */     GIR_EraseRootFromParent_Done,
     /* 304049 */   // Label 6177: @304049
     /* 304049 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(304148), // Rule ID 6135 //
     /* 304054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304097 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304146 */     GIR_RootConstrainSelectedInstOperands,
     /* 304147 */     // GIR_Coverage, 6135,
     /* 304147 */     GIR_EraseRootFromParent_Done,
     /* 304148 */   // Label 6178: @304148
     /* 304148 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(304244), // Rule ID 6167 //
     /* 304153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304195 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304214 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304242 */     GIR_RootConstrainSelectedInstOperands,
     /* 304243 */     // GIR_Coverage, 6167,
     /* 304243 */     GIR_EraseRootFromParent_Done,
     /* 304244 */   // Label 6179: @304244
     /* 304244 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(304343), // Rule ID 6199 //
     /* 304249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304292 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304341 */     GIR_RootConstrainSelectedInstOperands,
     /* 304342 */     // GIR_Coverage, 6199,
     /* 304342 */     GIR_EraseRootFromParent_Done,
     /* 304343 */   // Label 6180: @304343
     /* 304343 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(304436), // Rule ID 6245 //
     /* 304348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304387 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304434 */     GIR_RootConstrainSelectedInstOperands,
     /* 304435 */     // GIR_Coverage, 6245,
     /* 304435 */     GIR_EraseRootFromParent_Done,
     /* 304436 */   // Label 6181: @304436
     /* 304436 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(304532), // Rule ID 6103 //
     /* 304441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304483 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304495 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304530 */     GIR_RootConstrainSelectedInstOperands,
     /* 304531 */     // GIR_Coverage, 6103,
     /* 304531 */     GIR_EraseRootFromParent_Done,
     /* 304532 */   // Label 6182: @304532
     /* 304532 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(304616), // Rule ID 2550 //
     /* 304537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304567 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 304602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304614 */     GIR_RootConstrainSelectedInstOperands,
     /* 304615 */     // GIR_Coverage, 2550,
     /* 304615 */     GIR_EraseRootFromParent_Done,
     /* 304616 */   // Label 6183: @304616
     /* 304616 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(304666), // Rule ID 13362 //
     /* 304621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304651 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 304654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304664 */     GIR_RootConstrainSelectedInstOperands,
     /* 304665 */     // GIR_Coverage, 13362,
     /* 304665 */     GIR_EraseRootFromParent_Done,
     /* 304666 */   // Label 6184: @304666
     /* 304666 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(304750), // Rule ID 6071 //
     /* 304671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304701 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 304736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304748 */     GIR_RootConstrainSelectedInstOperands,
     /* 304749 */     // GIR_Coverage, 6071,
     /* 304749 */     GIR_EraseRootFromParent_Done,
     /* 304750 */   // Label 6185: @304750
     /* 304750 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(304800), // Rule ID 1312 //
     /* 304755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304785 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 304788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304798 */     GIR_RootConstrainSelectedInstOperands,
     /* 304799 */     // GIR_Coverage, 1312,
     /* 304799 */     GIR_EraseRootFromParent_Done,
     /* 304800 */   // Label 6186: @304800
     /* 304800 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(304833), // Rule ID 1302 //
     /* 304805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304820 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 304823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304831 */     GIR_RootConstrainSelectedInstOperands,
     /* 304832 */     // GIR_Coverage, 1302,
     /* 304832 */     GIR_EraseRootFromParent_Done,
     /* 304833 */   // Label 6187: @304833
     /* 304833 */   GIM_Reject,
     /* 304834 */ // Label 6168: @304834
     /* 304834 */ GIM_Reject,
     /* 304835 */ // Label 6041: @304835
     /* 304835 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(306013),
     /* 304840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304846 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 304849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304853 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(304937), // Rule ID 6117 //
     /* 304858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304894 */     // MIs[2] Operand 1
     /* 304894 */     // No operand predicates
     /* 304894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304906 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304917 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 304920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 304928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304935 */     GIR_RootConstrainSelectedInstOperands,
     /* 304936 */     // GIR_Coverage, 6117,
     /* 304936 */     GIR_EraseRootFromParent_Done,
     /* 304937 */   // Label 6189: @304937
     /* 304937 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(305018), // Rule ID 6149 //
     /* 304942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304986 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304990 */     // MIs[3] Operand 1
     /* 304990 */     // No operand predicates
     /* 304990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305000 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305016 */     GIR_RootConstrainSelectedInstOperands,
     /* 305017 */     // GIR_Coverage, 6149,
     /* 305017 */     GIR_EraseRootFromParent_Done,
     /* 305018 */   // Label 6190: @305018
     /* 305018 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(305102), // Rule ID 6181 //
     /* 305023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305076 */     // MIs[3] Operand 1
     /* 305076 */     // No operand predicates
     /* 305076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305082 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305100 */     GIR_RootConstrainSelectedInstOperands,
     /* 305101 */     // GIR_Coverage, 6181,
     /* 305101 */     GIR_EraseRootFromParent_Done,
     /* 305102 */   // Label 6191: @305102
     /* 305102 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(305183), // Rule ID 6085 //
     /* 305107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305155 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305159 */     // MIs[3] Operand 1
     /* 305159 */     // No operand predicates
     /* 305159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305165 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305181 */     GIR_RootConstrainSelectedInstOperands,
     /* 305182 */     // GIR_Coverage, 6085,
     /* 305182 */     GIR_EraseRootFromParent_Done,
     /* 305183 */   // Label 6192: @305183
     /* 305183 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(305252), // Rule ID 2532 //
     /* 305188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305224 */     // MIs[2] Operand 1
     /* 305224 */     // No operand predicates
     /* 305224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305234 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305250 */     GIR_RootConstrainSelectedInstOperands,
     /* 305251 */     // GIR_Coverage, 2532,
     /* 305251 */     GIR_EraseRootFromParent_Done,
     /* 305252 */   // Label 6193: @305252
     /* 305252 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(305321), // Rule ID 6053 //
     /* 305257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305297 */     // MIs[2] Operand 1
     /* 305297 */     // No operand predicates
     /* 305297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305303 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305319 */     GIR_RootConstrainSelectedInstOperands,
     /* 305320 */     // GIR_Coverage, 6053,
     /* 305320 */     GIR_EraseRootFromParent_Done,
     /* 305321 */   // Label 6194: @305321
     /* 305321 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(305420), // Rule ID 6119 //
     /* 305326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305369 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305418 */     GIR_RootConstrainSelectedInstOperands,
     /* 305419 */     // GIR_Coverage, 6119,
     /* 305419 */     GIR_EraseRootFromParent_Done,
     /* 305420 */   // Label 6195: @305420
     /* 305420 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(305516), // Rule ID 6151 //
     /* 305425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305467 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305486 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305514 */     GIR_RootConstrainSelectedInstOperands,
     /* 305515 */     // GIR_Coverage, 6151,
     /* 305515 */     GIR_EraseRootFromParent_Done,
     /* 305516 */   // Label 6196: @305516
     /* 305516 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(305615), // Rule ID 6183 //
     /* 305521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305564 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305613 */     GIR_RootConstrainSelectedInstOperands,
     /* 305614 */     // GIR_Coverage, 6183,
     /* 305614 */     GIR_EraseRootFromParent_Done,
     /* 305615 */   // Label 6197: @305615
     /* 305615 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(305711), // Rule ID 6087 //
     /* 305620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305662 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305709 */     GIR_RootConstrainSelectedInstOperands,
     /* 305710 */     // GIR_Coverage, 6087,
     /* 305710 */     GIR_EraseRootFromParent_Done,
     /* 305711 */   // Label 6198: @305711
     /* 305711 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(305795), // Rule ID 2534 //
     /* 305716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305746 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305793 */     GIR_RootConstrainSelectedInstOperands,
     /* 305794 */     // GIR_Coverage, 2534,
     /* 305794 */     GIR_EraseRootFromParent_Done,
     /* 305795 */   // Label 6199: @305795
     /* 305795 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(305845), // Rule ID 13354 //
     /* 305800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305830 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 305833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305843 */     GIR_RootConstrainSelectedInstOperands,
     /* 305844 */     // GIR_Coverage, 13354,
     /* 305844 */     GIR_EraseRootFromParent_Done,
     /* 305845 */   // Label 6200: @305845
     /* 305845 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(305929), // Rule ID 6055 //
     /* 305850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305880 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305927 */     GIR_RootConstrainSelectedInstOperands,
     /* 305928 */     // GIR_Coverage, 6055,
     /* 305928 */     GIR_EraseRootFromParent_Done,
     /* 305929 */   // Label 6201: @305929
     /* 305929 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(305979), // Rule ID 1304 //
     /* 305934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305964 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 305967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305977 */     GIR_RootConstrainSelectedInstOperands,
     /* 305978 */     // GIR_Coverage, 1304,
     /* 305978 */     GIR_EraseRootFromParent_Done,
     /* 305979 */   // Label 6202: @305979
     /* 305979 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306012), // Rule ID 1294 //
     /* 305984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305999 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 306002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 306010 */     GIR_RootConstrainSelectedInstOperands,
     /* 306011 */     // GIR_Coverage, 1294,
     /* 306011 */     GIR_EraseRootFromParent_Done,
     /* 306012 */   // Label 6203: @306012
     /* 306012 */   GIM_Reject,
     /* 306013 */ // Label 6188: @306013
     /* 306013 */ GIM_Reject,
     /* 306014 */ // Label 6042: @306014
     /* 306014 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(307534),
     /* 306019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 306028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306032 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(306110), // Rule ID 6215 //
     /* 306037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306078 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306082 */     // MIs[3] Operand 1
     /* 306082 */     // No operand predicates
     /* 306082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306092 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306108 */     GIR_RootConstrainSelectedInstOperands,
     /* 306109 */     // GIR_Coverage, 6215,
     /* 306109 */     GIR_EraseRootFromParent_Done,
     /* 306110 */   // Label 6205: @306110
     /* 306110 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(306194), // Rule ID 6129 //
     /* 306115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306151 */     // MIs[2] Operand 1
     /* 306151 */     // No operand predicates
     /* 306151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306163 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306174 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 306185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306192 */     GIR_RootConstrainSelectedInstOperands,
     /* 306193 */     // GIR_Coverage, 6129,
     /* 306193 */     GIR_EraseRootFromParent_Done,
     /* 306194 */   // Label 6206: @306194
     /* 306194 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(306275), // Rule ID 6161 //
     /* 306199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306247 */     // MIs[3] Operand 1
     /* 306247 */     // No operand predicates
     /* 306247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306257 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306273 */     GIR_RootConstrainSelectedInstOperands,
     /* 306274 */     // GIR_Coverage, 6161,
     /* 306274 */     GIR_EraseRootFromParent_Done,
     /* 306275 */   // Label 6207: @306275
     /* 306275 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(306359), // Rule ID 6193 //
     /* 306280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306329 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306333 */     // MIs[3] Operand 1
     /* 306333 */     // No operand predicates
     /* 306333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306339 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306357 */     GIR_RootConstrainSelectedInstOperands,
     /* 306358 */     // GIR_Coverage, 6193,
     /* 306358 */     GIR_EraseRootFromParent_Done,
     /* 306359 */   // Label 6208: @306359
     /* 306359 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(306437), // Rule ID 6237 //
     /* 306364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306409 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306413 */     // MIs[3] Operand 1
     /* 306413 */     // No operand predicates
     /* 306413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306419 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306435 */     GIR_RootConstrainSelectedInstOperands,
     /* 306436 */     // GIR_Coverage, 6237,
     /* 306436 */     GIR_EraseRootFromParent_Done,
     /* 306437 */   // Label 6209: @306437
     /* 306437 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(306518), // Rule ID 6097 //
     /* 306442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306490 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306494 */     // MIs[3] Operand 1
     /* 306494 */     // No operand predicates
     /* 306494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306500 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306516 */     GIR_RootConstrainSelectedInstOperands,
     /* 306517 */     // GIR_Coverage, 6097,
     /* 306517 */     GIR_EraseRootFromParent_Done,
     /* 306518 */   // Label 6210: @306518
     /* 306518 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(306587), // Rule ID 2544 //
     /* 306523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306559 */     // MIs[2] Operand 1
     /* 306559 */     // No operand predicates
     /* 306559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306569 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 306572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306585 */     GIR_RootConstrainSelectedInstOperands,
     /* 306586 */     // GIR_Coverage, 2544,
     /* 306586 */     GIR_EraseRootFromParent_Done,
     /* 306587 */   // Label 6211: @306587
     /* 306587 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(306656), // Rule ID 6065 //
     /* 306592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306632 */     // MIs[2] Operand 1
     /* 306632 */     // No operand predicates
     /* 306632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306638 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 306641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306654 */     GIR_RootConstrainSelectedInstOperands,
     /* 306655 */     // GIR_Coverage, 6065,
     /* 306655 */     GIR_EraseRootFromParent_Done,
     /* 306656 */   // Label 6212: @306656
     /* 306656 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(306749), // Rule ID 6219 //
     /* 306661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306700 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306747 */     GIR_RootConstrainSelectedInstOperands,
     /* 306748 */     // GIR_Coverage, 6219,
     /* 306748 */     GIR_EraseRootFromParent_Done,
     /* 306749 */   // Label 6213: @306749
     /* 306749 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(306848), // Rule ID 6131 //
     /* 306754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306797 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 306840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306846 */     GIR_RootConstrainSelectedInstOperands,
     /* 306847 */     // GIR_Coverage, 6131,
     /* 306847 */     GIR_EraseRootFromParent_Done,
     /* 306848 */   // Label 6214: @306848
     /* 306848 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(306944), // Rule ID 6163 //
     /* 306853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306895 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306942 */     GIR_RootConstrainSelectedInstOperands,
     /* 306943 */     // GIR_Coverage, 6163,
     /* 306943 */     GIR_EraseRootFromParent_Done,
     /* 306944 */   // Label 6215: @306944
     /* 306944 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307043), // Rule ID 6195 //
     /* 306949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306992 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307011 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307041 */     GIR_RootConstrainSelectedInstOperands,
     /* 307042 */     // GIR_Coverage, 6195,
     /* 307042 */     GIR_EraseRootFromParent_Done,
     /* 307043 */   // Label 6216: @307043
     /* 307043 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307136), // Rule ID 6241 //
     /* 307048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 307076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307087 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307134 */     GIR_RootConstrainSelectedInstOperands,
     /* 307135 */     // GIR_Coverage, 6241,
     /* 307135 */     GIR_EraseRootFromParent_Done,
     /* 307136 */   // Label 6217: @307136
     /* 307136 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307232), // Rule ID 6099 //
     /* 307141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 307168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 307172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307183 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307230 */     GIR_RootConstrainSelectedInstOperands,
     /* 307231 */     // GIR_Coverage, 6099,
     /* 307231 */     GIR_EraseRootFromParent_Done,
     /* 307232 */   // Label 6218: @307232
     /* 307232 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307316), // Rule ID 2546 //
     /* 307237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307267 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 307302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307314 */     GIR_RootConstrainSelectedInstOperands,
     /* 307315 */     // GIR_Coverage, 2546,
     /* 307315 */     GIR_EraseRootFromParent_Done,
     /* 307316 */   // Label 6219: @307316
     /* 307316 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307366), // Rule ID 13360 //
     /* 307321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307351 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 307354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307364 */     GIR_RootConstrainSelectedInstOperands,
     /* 307365 */     // GIR_Coverage, 13360,
     /* 307365 */     GIR_EraseRootFromParent_Done,
     /* 307366 */   // Label 6220: @307366
     /* 307366 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307450), // Rule ID 6067 //
     /* 307371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307401 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 307436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307448 */     GIR_RootConstrainSelectedInstOperands,
     /* 307449 */     // GIR_Coverage, 6067,
     /* 307449 */     GIR_EraseRootFromParent_Done,
     /* 307450 */   // Label 6221: @307450
     /* 307450 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307500), // Rule ID 1310 //
     /* 307455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307485 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 307488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307498 */     GIR_RootConstrainSelectedInstOperands,
     /* 307499 */     // GIR_Coverage, 1310,
     /* 307499 */     GIR_EraseRootFromParent_Done,
     /* 307500 */   // Label 6222: @307500
     /* 307500 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(307533), // Rule ID 1300 //
     /* 307505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307520 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 307523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 307531 */     GIR_RootConstrainSelectedInstOperands,
     /* 307532 */     // GIR_Coverage, 1300,
     /* 307532 */     GIR_EraseRootFromParent_Done,
     /* 307533 */   // Label 6223: @307533
     /* 307533 */   GIM_Reject,
     /* 307534 */ // Label 6204: @307534
     /* 307534 */ GIM_Reject,
     /* 307535 */ // Label 6043: @307535
     /* 307535 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(308713),
     /* 307540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 307546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 307549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307553 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(307637), // Rule ID 6113 //
     /* 307558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307594 */     // MIs[2] Operand 1
     /* 307594 */     // No operand predicates
     /* 307594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307606 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307617 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 307628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307635 */     GIR_RootConstrainSelectedInstOperands,
     /* 307636 */     // GIR_Coverage, 6113,
     /* 307636 */     GIR_EraseRootFromParent_Done,
     /* 307637 */   // Label 6225: @307637
     /* 307637 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(307718), // Rule ID 6145 //
     /* 307642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307686 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307690 */     // MIs[3] Operand 1
     /* 307690 */     // No operand predicates
     /* 307690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307700 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307716 */     GIR_RootConstrainSelectedInstOperands,
     /* 307717 */     // GIR_Coverage, 6145,
     /* 307717 */     GIR_EraseRootFromParent_Done,
     /* 307718 */   // Label 6226: @307718
     /* 307718 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(307802), // Rule ID 6177 //
     /* 307723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 307747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307772 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307776 */     // MIs[3] Operand 1
     /* 307776 */     // No operand predicates
     /* 307776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307782 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307800 */     GIR_RootConstrainSelectedInstOperands,
     /* 307801 */     // GIR_Coverage, 6177,
     /* 307801 */     GIR_EraseRootFromParent_Done,
     /* 307802 */   // Label 6227: @307802
     /* 307802 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(307883), // Rule ID 6081 //
     /* 307807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307859 */     // MIs[3] Operand 1
     /* 307859 */     // No operand predicates
     /* 307859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307865 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307881 */     GIR_RootConstrainSelectedInstOperands,
     /* 307882 */     // GIR_Coverage, 6081,
     /* 307882 */     GIR_EraseRootFromParent_Done,
     /* 307883 */   // Label 6228: @307883
     /* 307883 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(307952), // Rule ID 2528 //
     /* 307888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307924 */     // MIs[2] Operand 1
     /* 307924 */     // No operand predicates
     /* 307924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307934 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 307937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307950 */     GIR_RootConstrainSelectedInstOperands,
     /* 307951 */     // GIR_Coverage, 2528,
     /* 307951 */     GIR_EraseRootFromParent_Done,
     /* 307952 */   // Label 6229: @307952
     /* 307952 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308021), // Rule ID 6049 //
     /* 307957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307993 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307997 */     // MIs[2] Operand 1
     /* 307997 */     // No operand predicates
     /* 307997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308003 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 308006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308019 */     GIR_RootConstrainSelectedInstOperands,
     /* 308020 */     // GIR_Coverage, 6049,
     /* 308020 */     GIR_EraseRootFromParent_Done,
     /* 308021 */   // Label 6230: @308021
     /* 308021 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308120), // Rule ID 6115 //
     /* 308026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308069 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 308112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308118 */     GIR_RootConstrainSelectedInstOperands,
     /* 308119 */     // GIR_Coverage, 6115,
     /* 308119 */     GIR_EraseRootFromParent_Done,
     /* 308120 */   // Label 6231: @308120
     /* 308120 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308216), // Rule ID 6147 //
     /* 308125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308167 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308214 */     GIR_RootConstrainSelectedInstOperands,
     /* 308215 */     // GIR_Coverage, 6147,
     /* 308215 */     GIR_EraseRootFromParent_Done,
     /* 308216 */   // Label 6232: @308216
     /* 308216 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308315), // Rule ID 6179 //
     /* 308221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308264 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308313 */     GIR_RootConstrainSelectedInstOperands,
     /* 308314 */     // GIR_Coverage, 6179,
     /* 308314 */     GIR_EraseRootFromParent_Done,
     /* 308315 */   // Label 6233: @308315
     /* 308315 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(308411), // Rule ID 6083 //
     /* 308320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308362 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308409 */     GIR_RootConstrainSelectedInstOperands,
     /* 308410 */     // GIR_Coverage, 6083,
     /* 308410 */     GIR_EraseRootFromParent_Done,
     /* 308411 */   // Label 6234: @308411
     /* 308411 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(308495), // Rule ID 2530 //
     /* 308416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308446 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 308481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308493 */     GIR_RootConstrainSelectedInstOperands,
     /* 308494 */     // GIR_Coverage, 2530,
     /* 308494 */     GIR_EraseRootFromParent_Done,
     /* 308495 */   // Label 6235: @308495
     /* 308495 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(308545), // Rule ID 13356 //
     /* 308500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308530 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 308533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308543 */     GIR_RootConstrainSelectedInstOperands,
     /* 308544 */     // GIR_Coverage, 13356,
     /* 308544 */     GIR_EraseRootFromParent_Done,
     /* 308545 */   // Label 6236: @308545
     /* 308545 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(308629), // Rule ID 6051 //
     /* 308550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308580 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308592 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 308615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308627 */     GIR_RootConstrainSelectedInstOperands,
     /* 308628 */     // GIR_Coverage, 6051,
     /* 308628 */     GIR_EraseRootFromParent_Done,
     /* 308629 */   // Label 6237: @308629
     /* 308629 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(308679), // Rule ID 1306 //
     /* 308634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308664 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 308667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308677 */     GIR_RootConstrainSelectedInstOperands,
     /* 308678 */     // GIR_Coverage, 1306,
     /* 308678 */     GIR_EraseRootFromParent_Done,
     /* 308679 */   // Label 6238: @308679
     /* 308679 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308712), // Rule ID 1296 //
     /* 308684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308699 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 308702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 308710 */     GIR_RootConstrainSelectedInstOperands,
     /* 308711 */     // GIR_Coverage, 1296,
     /* 308711 */     GIR_EraseRootFromParent_Done,
     /* 308712 */   // Label 6239: @308712
     /* 308712 */   GIM_Reject,
     /* 308713 */ // Label 6224: @308713
     /* 308713 */ GIM_Reject,
     /* 308714 */ // Label 6044: @308714
     /* 308714 */ GIM_Reject,
     /* 308715 */ // Label 63: @308715
     /* 308715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6248*/ GIMT_Encode4(309330),
     /* 308726 */ /*GILLT_s16*//*Label 6240*/ GIMT_Encode4(308766),
     /* 308730 */ /*GILLT_s32*//*Label 6241*/ GIMT_Encode4(308804),
     /* 308734 */ /*GILLT_s64*//*Label 6242*/ GIMT_Encode4(308842), GIMT_Encode4(0),
     /* 308742 */ /*GILLT_v2s32*//*Label 6243*/ GIMT_Encode4(308880),
     /* 308746 */ /*GILLT_v2s64*//*Label 6244*/ GIMT_Encode4(308918),
     /* 308750 */ /*GILLT_v4s16*//*Label 6245*/ GIMT_Encode4(308956),
     /* 308754 */ /*GILLT_v4s32*//*Label 6246*/ GIMT_Encode4(308994), GIMT_Encode4(0),
     /* 308762 */ /*GILLT_v8s16*//*Label 6247*/ GIMT_Encode4(309032),
     /* 308766 */ // Label 6240: @308766
     /* 308766 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(308803), // Rule ID 590 //
     /* 308771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308792 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 308797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308801 */   GIR_RootConstrainSelectedInstOperands,
     /* 308802 */   // GIR_Coverage, 590,
     /* 308802 */   GIR_Done,
     /* 308803 */ // Label 6249: @308803
     /* 308803 */ GIM_Reject,
     /* 308804 */ // Label 6241: @308804
     /* 308804 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(308841), // Rule ID 592 //
     /* 308809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 308818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308830 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 308835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308839 */   GIR_RootConstrainSelectedInstOperands,
     /* 308840 */   // GIR_Coverage, 592,
     /* 308840 */   GIR_Done,
     /* 308841 */ // Label 6250: @308841
     /* 308841 */ GIM_Reject,
     /* 308842 */ // Label 6242: @308842
     /* 308842 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(308879), // Rule ID 594 //
     /* 308847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 308856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308868 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 308868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 308873 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308877 */   GIR_RootConstrainSelectedInstOperands,
     /* 308878 */   // GIR_Coverage, 594,
     /* 308878 */   GIR_Done,
     /* 308879 */ // Label 6251: @308879
     /* 308879 */ GIM_Reject,
     /* 308880 */ // Label 6243: @308880
     /* 308880 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(308917), // Rule ID 1228 //
     /* 308885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 308894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308906 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 308906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 308911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308915 */   GIR_RootConstrainSelectedInstOperands,
     /* 308916 */   // GIR_Coverage, 1228,
     /* 308916 */   GIR_Done,
     /* 308917 */ // Label 6252: @308917
     /* 308917 */ GIM_Reject,
     /* 308918 */ // Label 6244: @308918
     /* 308918 */ GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(308955), // Rule ID 1232 //
     /* 308923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308944 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 308949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308953 */   GIR_RootConstrainSelectedInstOperands,
     /* 308954 */   // GIR_Coverage, 1232,
     /* 308954 */   GIR_Done,
     /* 308955 */ // Label 6253: @308955
     /* 308955 */ GIM_Reject,
     /* 308956 */ // Label 6245: @308956
     /* 308956 */ GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(308993), // Rule ID 1224 //
     /* 308961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308982 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 308987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308991 */   GIR_RootConstrainSelectedInstOperands,
     /* 308992 */   // GIR_Coverage, 1224,
     /* 308992 */   GIR_Done,
     /* 308993 */ // Label 6254: @308993
     /* 308993 */ GIM_Reject,
     /* 308994 */ // Label 6246: @308994
     /* 308994 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(309031), // Rule ID 1230 //
     /* 308999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 309008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309020 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309029 */   GIR_RootConstrainSelectedInstOperands,
     /* 309030 */   // GIR_Coverage, 1230,
     /* 309030 */   GIR_Done,
     /* 309031 */ // Label 6255: @309031
     /* 309031 */ GIM_Reject,
     /* 309032 */ // Label 6247: @309032
     /* 309032 */ GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(309329),
     /* 309037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309055 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(309074), // Rule ID 1226 //
     /* 309060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309063 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 309068 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309072 */     GIR_RootConstrainSelectedInstOperands,
     /* 309073 */     // GIR_Coverage, 1226,
     /* 309073 */     GIR_Done,
     /* 309074 */   // Label 6257: @309074
     /* 309074 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(309328), // Rule ID 7014 //
     /* 309079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309082 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309082 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309085 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309089 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309094 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309100 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309103 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309107 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309112 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309118 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309121 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309125 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309130 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309133 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309138 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309141 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309145 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309150 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309156 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309161 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309166 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309169 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309173 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309178 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309183 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309186 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309190 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309195 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309201 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309206 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309211 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309214 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309218 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309223 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309228 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309231 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309235 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309240 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309243 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309260 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309326 */     GIR_RootConstrainSelectedInstOperands,
     /* 309327 */     // GIR_Coverage, 7014,
     /* 309327 */     GIR_EraseRootFromParent_Done,
     /* 309328 */   // Label 6258: @309328
     /* 309328 */   GIM_Reject,
     /* 309329 */ // Label 6256: @309329
     /* 309329 */ GIM_Reject,
     /* 309330 */ // Label 6248: @309330
     /* 309330 */ GIM_Reject,
     /* 309331 */ // Label 64: @309331
     /* 309331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6267*/ GIMT_Encode4(312837),
     /* 309342 */ /*GILLT_s16*//*Label 6259*/ GIMT_Encode4(309382),
     /* 309346 */ /*GILLT_s32*//*Label 6260*/ GIMT_Encode4(310550),
     /* 309350 */ /*GILLT_s64*//*Label 6261*/ GIMT_Encode4(311573), GIMT_Encode4(0),
     /* 309358 */ /*GILLT_v2s32*//*Label 6262*/ GIMT_Encode4(312596),
     /* 309362 */ /*GILLT_v2s64*//*Label 6263*/ GIMT_Encode4(312623),
     /* 309366 */ /*GILLT_v4s16*//*Label 6264*/ GIMT_Encode4(312650),
     /* 309370 */ /*GILLT_v4s32*//*Label 6265*/ GIMT_Encode4(312730), GIMT_Encode4(0),
     /* 309378 */ /*GILLT_v8s16*//*Label 6266*/ GIMT_Encode4(312757),
     /* 309382 */ // Label 6259: @309382
     /* 309382 */ GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(310549),
     /* 309387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309394 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(309552), // Rule ID 4847 //
     /* 309399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309459 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309463 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309468 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309479 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309491 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309519 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309550 */     GIR_RootConstrainSelectedInstOperands,
     /* 309551 */     // GIR_Coverage, 4847,
     /* 309551 */     GIR_EraseRootFromParent_Done,
     /* 309552 */   // Label 6269: @309552
     /* 309552 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(309710), // Rule ID 4846 //
     /* 309557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309576 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309601 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309621 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309626 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309637 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309649 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309708 */     GIR_RootConstrainSelectedInstOperands,
     /* 309709 */     // GIR_Coverage, 4846,
     /* 309709 */     GIR_EraseRootFromParent_Done,
     /* 309710 */   // Label 6270: @309710
     /* 309710 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(309821), // Rule ID 4845 //
     /* 309715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309734 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309759 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309775 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309819 */     GIR_RootConstrainSelectedInstOperands,
     /* 309820 */     // GIR_Coverage, 4845,
     /* 309820 */     GIR_EraseRootFromParent_Done,
     /* 309821 */   // Label 6271: @309821
     /* 309821 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(309932), // Rule ID 4843 //
     /* 309826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309845 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309875 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309886 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309898 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309930 */     GIR_RootConstrainSelectedInstOperands,
     /* 309931 */     // GIR_Coverage, 4843,
     /* 309931 */     GIR_EraseRootFromParent_Done,
     /* 309932 */   // Label 6272: @309932
     /* 309932 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(310043), // Rule ID 4844 //
     /* 309937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309956 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309981 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309997 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310009 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310041 */     GIR_RootConstrainSelectedInstOperands,
     /* 310042 */     // GIR_Coverage, 4844,
     /* 310042 */     GIR_EraseRootFromParent_Done,
     /* 310043 */   // Label 6273: @310043
     /* 310043 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(310154), // Rule ID 4842 //
     /* 310048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310097 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310108 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310152 */     GIR_RootConstrainSelectedInstOperands,
     /* 310153 */     // GIR_Coverage, 4842,
     /* 310153 */     GIR_EraseRootFromParent_Done,
     /* 310154 */   // Label 6274: @310154
     /* 310154 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(310218), // Rule ID 650 //
     /* 310159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310178 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310199 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310216 */     GIR_RootConstrainSelectedInstOperands,
     /* 310217 */     // GIR_Coverage, 650,
     /* 310217 */     GIR_EraseRootFromParent_Done,
     /* 310218 */   // Label 6275: @310218
     /* 310218 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(310282), // Rule ID 649 //
     /* 310223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310242 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310263 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310280 */     GIR_RootConstrainSelectedInstOperands,
     /* 310281 */     // GIR_Coverage, 649,
     /* 310281 */     GIR_EraseRootFromParent_Done,
     /* 310282 */   // Label 6276: @310282
     /* 310282 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(310333), // Rule ID 626 //
     /* 310287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 310298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310318 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 310318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 310321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310331 */     GIR_RootConstrainSelectedInstOperands,
     /* 310332 */     // GIR_Coverage, 626,
     /* 310332 */     GIR_EraseRootFromParent_Done,
     /* 310333 */   // Label 6277: @310333
     /* 310333 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310384), // Rule ID 625 //
     /* 310338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 310349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310369 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 310369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 310372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310382 */     GIR_RootConstrainSelectedInstOperands,
     /* 310383 */     // GIR_Coverage, 625,
     /* 310383 */     GIR_EraseRootFromParent_Done,
     /* 310384 */   // Label 6278: @310384
     /* 310384 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310403), // Rule ID 524 //
     /* 310389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310396 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 310396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 310401 */     GIR_RootConstrainSelectedInstOperands,
     /* 310402 */     // GIR_Coverage, 524,
     /* 310402 */     GIR_Done,
     /* 310403 */   // Label 6279: @310403
     /* 310403 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310548), // Rule ID 6381 //
     /* 310408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310412 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 310412 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 310415 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310419 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310426 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310429 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310433 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310438 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310441 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 310445 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 310448 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310453 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310458 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310463 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310466 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310470 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310475 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310478 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310483 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310486 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 310490 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310495 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310498 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 310503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310517 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310530 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 310537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310547 */     // GIR_Coverage, 6381,
     /* 310547 */     GIR_EraseRootFromParent_Done,
     /* 310548 */   // Label 6280: @310548
     /* 310548 */   GIM_Reject,
     /* 310549 */ // Label 6268: @310549
     /* 310549 */ GIM_Reject,
     /* 310550 */ // Label 6260: @310550
     /* 310550 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311572),
     /* 310555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310562 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310720), // Rule ID 4853 //
     /* 310567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310611 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310627 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310636 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310647 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 310647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310659 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 310665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310687 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310718 */     GIR_RootConstrainSelectedInstOperands,
     /* 310719 */     // GIR_Coverage, 4853,
     /* 310719 */     GIR_EraseRootFromParent_Done,
     /* 310720 */   // Label 6282: @310720
     /* 310720 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(310878), // Rule ID 4852 //
     /* 310725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310769 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310785 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310789 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310794 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310805 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 310805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310817 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 310823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310828 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310876 */     GIR_RootConstrainSelectedInstOperands,
     /* 310877 */     // GIR_Coverage, 4852,
     /* 310877 */     GIR_EraseRootFromParent_Done,
     /* 310878 */   // Label 6283: @310878
     /* 310878 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(310989), // Rule ID 4851 //
     /* 310883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310902 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310927 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310943 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 310943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310987 */     GIR_RootConstrainSelectedInstOperands,
     /* 310988 */     // GIR_Coverage, 4851,
     /* 310988 */     GIR_EraseRootFromParent_Done,
     /* 310989 */   // Label 6284: @310989
     /* 310989 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311100), // Rule ID 4849 //
     /* 310994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311013 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311043 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311054 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311066 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311098 */     GIR_RootConstrainSelectedInstOperands,
     /* 311099 */     // GIR_Coverage, 4849,
     /* 311099 */     GIR_EraseRootFromParent_Done,
     /* 311100 */   // Label 6285: @311100
     /* 311100 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311211), // Rule ID 4850 //
     /* 311105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311165 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311177 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311209 */     GIR_RootConstrainSelectedInstOperands,
     /* 311210 */     // GIR_Coverage, 4850,
     /* 311210 */     GIR_EraseRootFromParent_Done,
     /* 311211 */   // Label 6286: @311211
     /* 311211 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311322), // Rule ID 4848 //
     /* 311216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311235 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311265 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311276 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311320 */     GIR_RootConstrainSelectedInstOperands,
     /* 311321 */     // GIR_Coverage, 4848,
     /* 311321 */     GIR_EraseRootFromParent_Done,
     /* 311322 */   // Label 6287: @311322
     /* 311322 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311386), // Rule ID 652 //
     /* 311327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311346 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311367 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311384 */     GIR_RootConstrainSelectedInstOperands,
     /* 311385 */     // GIR_Coverage, 652,
     /* 311385 */     GIR_EraseRootFromParent_Done,
     /* 311386 */   // Label 6288: @311386
     /* 311386 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311450), // Rule ID 651 //
     /* 311391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311431 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311448 */     GIR_RootConstrainSelectedInstOperands,
     /* 311449 */     // GIR_Coverage, 651,
     /* 311449 */     GIR_EraseRootFromParent_Done,
     /* 311450 */   // Label 6289: @311450
     /* 311450 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311501), // Rule ID 628 //
     /* 311455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 311466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311486 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 311489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311499 */     GIR_RootConstrainSelectedInstOperands,
     /* 311500 */     // GIR_Coverage, 628,
     /* 311500 */     GIR_EraseRootFromParent_Done,
     /* 311501 */   // Label 6290: @311501
     /* 311501 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311552), // Rule ID 627 //
     /* 311506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 311517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311537 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 311540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311550 */     GIR_RootConstrainSelectedInstOperands,
     /* 311551 */     // GIR_Coverage, 627,
     /* 311551 */     GIR_EraseRootFromParent_Done,
     /* 311552 */   // Label 6291: @311552
     /* 311552 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(311571), // Rule ID 525 //
     /* 311557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311564 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 311564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 311569 */     GIR_RootConstrainSelectedInstOperands,
     /* 311570 */     // GIR_Coverage, 525,
     /* 311570 */     GIR_Done,
     /* 311571 */   // Label 6292: @311571
     /* 311571 */   GIM_Reject,
     /* 311572 */ // Label 6281: @311572
     /* 311572 */ GIM_Reject,
     /* 311573 */ // Label 6261: @311573
     /* 311573 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(312595),
     /* 311578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311585 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(311743), // Rule ID 4859 //
     /* 311590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311609 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311634 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 311642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311646 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311654 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311659 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311670 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 311670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311682 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 311688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311741 */     GIR_RootConstrainSelectedInstOperands,
     /* 311742 */     // GIR_Coverage, 4859,
     /* 311742 */     GIR_EraseRootFromParent_Done,
     /* 311743 */   // Label 6294: @311743
     /* 311743 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(311901), // Rule ID 4858 //
     /* 311748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311767 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 311800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311812 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311817 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311828 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 311828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311840 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 311846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311868 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311899 */     GIR_RootConstrainSelectedInstOperands,
     /* 311900 */     // GIR_Coverage, 4858,
     /* 311900 */     GIR_EraseRootFromParent_Done,
     /* 311901 */   // Label 6295: @311901
     /* 311901 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(312012), // Rule ID 4857 //
     /* 311906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311925 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311966 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 311966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312010 */     GIR_RootConstrainSelectedInstOperands,
     /* 312011 */     // GIR_Coverage, 4857,
     /* 312011 */     GIR_EraseRootFromParent_Done,
     /* 312012 */   // Label 6296: @312012
     /* 312012 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(312123), // Rule ID 4855 //
     /* 312017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 312028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312036 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312066 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312077 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 312077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 312095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312121 */     GIR_RootConstrainSelectedInstOperands,
     /* 312122 */     // GIR_Coverage, 4855,
     /* 312122 */     GIR_EraseRootFromParent_Done,
     /* 312123 */   // Label 6297: @312123
     /* 312123 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(312234), // Rule ID 4856 //
     /* 312128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312188 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312200 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 312206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312232 */     GIR_RootConstrainSelectedInstOperands,
     /* 312233 */     // GIR_Coverage, 4856,
     /* 312233 */     GIR_EraseRootFromParent_Done,
     /* 312234 */   // Label 6298: @312234
     /* 312234 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(312345), // Rule ID 4854 //
     /* 312239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312299 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 312299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 312317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312343 */     GIR_RootConstrainSelectedInstOperands,
     /* 312344 */     // GIR_Coverage, 4854,
     /* 312344 */     GIR_EraseRootFromParent_Done,
     /* 312345 */   // Label 6299: @312345
     /* 312345 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(312409), // Rule ID 654 //
     /* 312350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 312361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312390 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312407 */     GIR_RootConstrainSelectedInstOperands,
     /* 312408 */     // GIR_Coverage, 654,
     /* 312408 */     GIR_EraseRootFromParent_Done,
     /* 312409 */   // Label 6300: @312409
     /* 312409 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(312473), // Rule ID 653 //
     /* 312414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312433 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312454 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312471 */     GIR_RootConstrainSelectedInstOperands,
     /* 312472 */     // GIR_Coverage, 653,
     /* 312472 */     GIR_EraseRootFromParent_Done,
     /* 312473 */   // Label 6301: @312473
     /* 312473 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(312524), // Rule ID 630 //
     /* 312478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 312489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312509 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 312512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312522 */     GIR_RootConstrainSelectedInstOperands,
     /* 312523 */     // GIR_Coverage, 630,
     /* 312523 */     GIR_EraseRootFromParent_Done,
     /* 312524 */   // Label 6302: @312524
     /* 312524 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(312575), // Rule ID 629 //
     /* 312529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 312540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312560 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 312563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312573 */     GIR_RootConstrainSelectedInstOperands,
     /* 312574 */     // GIR_Coverage, 629,
     /* 312574 */     GIR_EraseRootFromParent_Done,
     /* 312575 */   // Label 6303: @312575
     /* 312575 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(312594), // Rule ID 526 //
     /* 312580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312587 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 312587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 312592 */     GIR_RootConstrainSelectedInstOperands,
     /* 312593 */     // GIR_Coverage, 526,
     /* 312593 */     GIR_Done,
     /* 312594 */   // Label 6304: @312594
     /* 312594 */   GIM_Reject,
     /* 312595 */ // Label 6293: @312595
     /* 312595 */ GIM_Reject,
     /* 312596 */ // Label 6262: @312596
     /* 312596 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(312622), // Rule ID 860 //
     /* 312601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312615 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 312615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 312620 */   GIR_RootConstrainSelectedInstOperands,
     /* 312621 */   // GIR_Coverage, 860,
     /* 312621 */   GIR_Done,
     /* 312622 */ // Label 6305: @312622
     /* 312622 */ GIM_Reject,
     /* 312623 */ // Label 6263: @312623
     /* 312623 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(312649), // Rule ID 862 //
     /* 312628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312642 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 312642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 312647 */   GIR_RootConstrainSelectedInstOperands,
     /* 312648 */   // GIR_Coverage, 862,
     /* 312648 */   GIR_Done,
     /* 312649 */ // Label 6306: @312649
     /* 312649 */ GIM_Reject,
     /* 312650 */ // Label 6264: @312650
     /* 312650 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(312729),
     /* 312655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312666 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(312681), // Rule ID 858 //
     /* 312671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312674 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 312674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 312679 */     GIR_RootConstrainSelectedInstOperands,
     /* 312680 */     // GIR_Coverage, 858,
     /* 312680 */     GIR_Done,
     /* 312681 */   // Label 6308: @312681
     /* 312681 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(312728), // Rule ID 6384 //
     /* 312686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312689 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 312689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 312696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312701 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 312711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 312714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 312719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312726 */     GIR_RootConstrainSelectedInstOperands,
     /* 312727 */     // GIR_Coverage, 6384,
     /* 312727 */     GIR_EraseRootFromParent_Done,
     /* 312728 */   // Label 6309: @312728
     /* 312728 */   GIM_Reject,
     /* 312729 */ // Label 6307: @312729
     /* 312729 */ GIM_Reject,
     /* 312730 */ // Label 6265: @312730
     /* 312730 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(312756), // Rule ID 861 //
     /* 312735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312749 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 312749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 312754 */   GIR_RootConstrainSelectedInstOperands,
     /* 312755 */   // GIR_Coverage, 861,
     /* 312755 */   GIR_Done,
     /* 312756 */ // Label 6310: @312756
     /* 312756 */ GIM_Reject,
     /* 312757 */ // Label 6266: @312757
     /* 312757 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(312836),
     /* 312762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312773 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(312788), // Rule ID 859 //
     /* 312778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312781 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 312781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 312786 */     GIR_RootConstrainSelectedInstOperands,
     /* 312787 */     // GIR_Coverage, 859,
     /* 312787 */     GIR_Done,
     /* 312788 */   // Label 6312: @312788
     /* 312788 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(312835), // Rule ID 6385 //
     /* 312793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312796 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 312796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 312803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312808 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 312818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 312821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 312826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312833 */     GIR_RootConstrainSelectedInstOperands,
     /* 312834 */     // GIR_Coverage, 6385,
     /* 312834 */     GIR_EraseRootFromParent_Done,
     /* 312835 */   // Label 6313: @312835
     /* 312835 */   GIM_Reject,
     /* 312836 */ // Label 6311: @312836
     /* 312836 */ GIM_Reject,
     /* 312837 */ // Label 6267: @312837
     /* 312837 */ GIM_Reject,
     /* 312838 */ // Label 65: @312838
     /* 312838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6318*/ GIMT_Encode4(313085),
     /* 312849 */ /*GILLT_s32*//*Label 6314*/ GIMT_Encode4(312877),
     /* 312853 */ /*GILLT_s64*//*Label 6315*/ GIMT_Encode4(312908), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 312865 */ /*GILLT_v2s64*//*Label 6316*/ GIMT_Encode4(312969), GIMT_Encode4(0),
     /* 312873 */ /*GILLT_v4s32*//*Label 6317*/ GIMT_Encode4(313027),
     /* 312877 */ // Label 6314: @312877
     /* 312877 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312907), // Rule ID 516 //
     /* 312882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312896 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 312896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 312901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312905 */   GIR_RootConstrainSelectedInstOperands,
     /* 312906 */   // GIR_Coverage, 516,
     /* 312906 */   GIR_Done,
     /* 312907 */ // Label 6319: @312907
     /* 312907 */ GIM_Reject,
     /* 312908 */ // Label 6315: @312908
     /* 312908 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312938), // Rule ID 514 //
     /* 312913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312927 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 312927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 312932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312936 */   GIR_RootConstrainSelectedInstOperands,
     /* 312937 */   // GIR_Coverage, 514,
     /* 312937 */   GIR_Done,
     /* 312938 */ // Label 6320: @312938
     /* 312938 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(312968), // Rule ID 518 //
     /* 312943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312957 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 312957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 312962 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312966 */   GIR_RootConstrainSelectedInstOperands,
     /* 312967 */   // GIR_Coverage, 518,
     /* 312967 */   GIR_Done,
     /* 312968 */ // Label 6321: @312968
     /* 312968 */ GIM_Reject,
     /* 312969 */ // Label 6316: @312969
     /* 312969 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(313026),
     /* 312974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312981 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(313005), // Rule ID 4902 //
     /* 312986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 312993 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 312993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 312996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313003 */     GIR_RootConstrainSelectedInstOperands,
     /* 313004 */     // GIR_Coverage, 4902,
     /* 313004 */     GIR_EraseRootFromParent_Done,
     /* 313005 */   // Label 6323: @313005
     /* 313005 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(313025), // Rule ID 4900 //
     /* 313010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313014 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 313014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 313019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313023 */     GIR_RootConstrainSelectedInstOperands,
     /* 313024 */     // GIR_Coverage, 4900,
     /* 313024 */     GIR_Done,
     /* 313025 */   // Label 6324: @313025
     /* 313025 */   GIM_Reject,
     /* 313026 */ // Label 6322: @313026
     /* 313026 */ GIM_Reject,
     /* 313027 */ // Label 6317: @313027
     /* 313027 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(313084),
     /* 313032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313039 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(313063), // Rule ID 4906 //
     /* 313044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 313051 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 313051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 313054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313061 */     GIR_RootConstrainSelectedInstOperands,
     /* 313062 */     // GIR_Coverage, 4906,
     /* 313062 */     GIR_EraseRootFromParent_Done,
     /* 313063 */   // Label 6326: @313063
     /* 313063 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(313083), // Rule ID 4904 //
     /* 313068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313072 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 313072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 313077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313081 */     GIR_RootConstrainSelectedInstOperands,
     /* 313082 */     // GIR_Coverage, 4904,
     /* 313082 */     GIR_Done,
     /* 313083 */   // Label 6327: @313083
     /* 313083 */   GIM_Reject,
     /* 313084 */ // Label 6325: @313084
     /* 313084 */ GIM_Reject,
     /* 313085 */ // Label 6318: @313085
     /* 313085 */ GIM_Reject,
     /* 313086 */ // Label 66: @313086
     /* 313086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6332*/ GIMT_Encode4(313273),
     /* 313097 */ /*GILLT_s16*//*Label 6328*/ GIMT_Encode4(313125),
     /* 313101 */ /*GILLT_s32*//*Label 6329*/ GIMT_Encode4(313186), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 313113 */ /*GILLT_v2s32*//*Label 6330*/ GIMT_Encode4(313217), GIMT_Encode4(0),
     /* 313121 */ /*GILLT_v4s16*//*Label 6331*/ GIMT_Encode4(313245),
     /* 313125 */ // Label 6328: @313125
     /* 313125 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(313155), // Rule ID 510 //
     /* 313130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313144 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 313144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 313149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313153 */   GIR_RootConstrainSelectedInstOperands,
     /* 313154 */   // GIR_Coverage, 510,
     /* 313154 */   GIR_Done,
     /* 313155 */ // Label 6333: @313155
     /* 313155 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(313185), // Rule ID 520 //
     /* 313160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313174 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 313174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 313179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313183 */   GIR_RootConstrainSelectedInstOperands,
     /* 313184 */   // GIR_Coverage, 520,
     /* 313184 */   GIR_Done,
     /* 313185 */ // Label 6334: @313185
     /* 313185 */ GIM_Reject,
     /* 313186 */ // Label 6329: @313186
     /* 313186 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(313216), // Rule ID 512 //
     /* 313191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313205 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 313205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 313210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313214 */   GIR_RootConstrainSelectedInstOperands,
     /* 313215 */   // GIR_Coverage, 512,
     /* 313215 */   GIR_Done,
     /* 313216 */ // Label 6335: @313216
     /* 313216 */ GIM_Reject,
     /* 313217 */ // Label 6330: @313217
     /* 313217 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(313244), // Rule ID 4910 //
     /* 313222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313233 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 313233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 313238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313242 */   GIR_RootConstrainSelectedInstOperands,
     /* 313243 */   // GIR_Coverage, 4910,
     /* 313243 */   GIR_Done,
     /* 313244 */ // Label 6336: @313244
     /* 313244 */ GIM_Reject,
     /* 313245 */ // Label 6331: @313245
     /* 313245 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(313272), // Rule ID 4912 //
     /* 313250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313261 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 313261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 313266 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313270 */   GIR_RootConstrainSelectedInstOperands,
     /* 313271 */   // GIR_Coverage, 4912,
     /* 313271 */   GIR_Done,
     /* 313272 */ // Label 6337: @313272
     /* 313272 */ GIM_Reject,
     /* 313273 */ // Label 6332: @313273
     /* 313273 */ GIM_Reject,
     /* 313274 */ // Label 67: @313274
     /* 313274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6345*/ GIMT_Encode4(314250),
     /* 313285 */ /*GILLT_s32*//*Label 6338*/ GIMT_Encode4(313321),
     /* 313289 */ /*GILLT_s64*//*Label 6339*/ GIMT_Encode4(313708), GIMT_Encode4(0),
     /* 313297 */ /*GILLT_v2s32*//*Label 6340*/ GIMT_Encode4(314095),
     /* 313301 */ /*GILLT_v2s64*//*Label 6341*/ GIMT_Encode4(314126),
     /* 313305 */ /*GILLT_v4s16*//*Label 6342*/ GIMT_Encode4(314157),
     /* 313309 */ /*GILLT_v4s32*//*Label 6343*/ GIMT_Encode4(314188), GIMT_Encode4(0),
     /* 313317 */ /*GILLT_v8s16*//*Label 6344*/ GIMT_Encode4(314219),
     /* 313321 */ // Label 6338: @313321
     /* 313321 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(313358), // Rule ID 4649 //
     /* 313326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313341 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313347 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 313350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313352 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313356 */   GIR_RootConstrainSelectedInstOperands,
     /* 313357 */   // GIR_Coverage, 4649,
     /* 313357 */   GIR_EraseRootFromParent_Done,
     /* 313358 */ // Label 6346: @313358
     /* 313358 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(313395), // Rule ID 4651 //
     /* 313363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313384 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 313387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313389 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313393 */   GIR_RootConstrainSelectedInstOperands,
     /* 313394 */   // GIR_Coverage, 4651,
     /* 313394 */   GIR_EraseRootFromParent_Done,
     /* 313395 */ // Label 6347: @313395
     /* 313395 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(313432), // Rule ID 4669 //
     /* 313400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313415 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313421 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 313424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313426 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313430 */   GIR_RootConstrainSelectedInstOperands,
     /* 313431 */   // GIR_Coverage, 4669,
     /* 313431 */   GIR_EraseRootFromParent_Done,
     /* 313432 */ // Label 6348: @313432
     /* 313432 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(313469), // Rule ID 4671 //
     /* 313437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313452 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313458 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 313461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313463 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313467 */   GIR_RootConstrainSelectedInstOperands,
     /* 313468 */   // GIR_Coverage, 4671,
     /* 313468 */   GIR_EraseRootFromParent_Done,
     /* 313469 */ // Label 6349: @313469
     /* 313469 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(313506), // Rule ID 4709 //
     /* 313474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313489 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313495 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 313498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313500 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313504 */   GIR_RootConstrainSelectedInstOperands,
     /* 313505 */   // GIR_Coverage, 4709,
     /* 313505 */   GIR_EraseRootFromParent_Done,
     /* 313506 */ // Label 6350: @313506
     /* 313506 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(313543), // Rule ID 4711 //
     /* 313511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313530 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313532 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 313535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313537 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313541 */   GIR_RootConstrainSelectedInstOperands,
     /* 313542 */   // GIR_Coverage, 4711,
     /* 313542 */   GIR_EraseRootFromParent_Done,
     /* 313543 */ // Label 6351: @313543
     /* 313543 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(313580), // Rule ID 4689 //
     /* 313548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313569 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 313572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313578 */   GIR_RootConstrainSelectedInstOperands,
     /* 313579 */   // GIR_Coverage, 4689,
     /* 313579 */   GIR_EraseRootFromParent_Done,
     /* 313580 */ // Label 6352: @313580
     /* 313580 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(313617), // Rule ID 4691 //
     /* 313585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313606 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 313609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313611 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313615 */   GIR_RootConstrainSelectedInstOperands,
     /* 313616 */   // GIR_Coverage, 4691,
     /* 313616 */   GIR_EraseRootFromParent_Done,
     /* 313617 */ // Label 6353: @313617
     /* 313617 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(313647), // Rule ID 395 //
     /* 313622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313636 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 313636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 313641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313645 */   GIR_RootConstrainSelectedInstOperands,
     /* 313646 */   // GIR_Coverage, 395,
     /* 313646 */   GIR_Done,
     /* 313647 */ // Label 6354: @313647
     /* 313647 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(313677), // Rule ID 399 //
     /* 313652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313666 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 313666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 313671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313675 */   GIR_RootConstrainSelectedInstOperands,
     /* 313676 */   // GIR_Coverage, 399,
     /* 313676 */   GIR_Done,
     /* 313677 */ // Label 6355: @313677
     /* 313677 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(313707), // Rule ID 403 //
     /* 313682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313696 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 313696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 313701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313705 */   GIR_RootConstrainSelectedInstOperands,
     /* 313706 */   // GIR_Coverage, 403,
     /* 313706 */   GIR_Done,
     /* 313707 */ // Label 6356: @313707
     /* 313707 */ GIM_Reject,
     /* 313708 */ // Label 6339: @313708
     /* 313708 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(313745), // Rule ID 4650 //
     /* 313713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313728 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313734 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 313737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313743 */   GIR_RootConstrainSelectedInstOperands,
     /* 313744 */   // GIR_Coverage, 4650,
     /* 313744 */   GIR_EraseRootFromParent_Done,
     /* 313745 */ // Label 6357: @313745
     /* 313745 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(313782), // Rule ID 4652 //
     /* 313750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313757 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313761 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313765 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313771 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 313774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313776 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313780 */   GIR_RootConstrainSelectedInstOperands,
     /* 313781 */   // GIR_Coverage, 4652,
     /* 313781 */   GIR_EraseRootFromParent_Done,
     /* 313782 */ // Label 6358: @313782
     /* 313782 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(313819), // Rule ID 4670 //
     /* 313787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313802 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313808 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 313811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313813 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313817 */   GIR_RootConstrainSelectedInstOperands,
     /* 313818 */   // GIR_Coverage, 4670,
     /* 313818 */   GIR_EraseRootFromParent_Done,
     /* 313819 */ // Label 6359: @313819
     /* 313819 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(313856), // Rule ID 4672 //
     /* 313824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313839 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313845 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 313848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313854 */   GIR_RootConstrainSelectedInstOperands,
     /* 313855 */   // GIR_Coverage, 4672,
     /* 313855 */   GIR_EraseRootFromParent_Done,
     /* 313856 */ // Label 6360: @313856
     /* 313856 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(313893), // Rule ID 4710 //
     /* 313861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313876 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313882 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 313885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313887 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313891 */   GIR_RootConstrainSelectedInstOperands,
     /* 313892 */   // GIR_Coverage, 4710,
     /* 313892 */   GIR_EraseRootFromParent_Done,
     /* 313893 */ // Label 6361: @313893
     /* 313893 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(313930), // Rule ID 4712 //
     /* 313898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313913 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313919 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 313922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313924 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313928 */   GIR_RootConstrainSelectedInstOperands,
     /* 313929 */   // GIR_Coverage, 4712,
     /* 313929 */   GIR_EraseRootFromParent_Done,
     /* 313930 */ // Label 6362: @313930
     /* 313930 */ GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(313967), // Rule ID 4690 //
     /* 313935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313956 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 313959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313965 */   GIR_RootConstrainSelectedInstOperands,
     /* 313966 */   // GIR_Coverage, 4690,
     /* 313966 */   GIR_EraseRootFromParent_Done,
     /* 313967 */ // Label 6363: @313967
     /* 313967 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(314004), // Rule ID 4692 //
     /* 313972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313993 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 313996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313998 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314002 */   GIR_RootConstrainSelectedInstOperands,
     /* 314003 */   // GIR_Coverage, 4692,
     /* 314003 */   GIR_EraseRootFromParent_Done,
     /* 314004 */ // Label 6364: @314004
     /* 314004 */ GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(314034), // Rule ID 397 //
     /* 314009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314023 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 314023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 314028 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314032 */   GIR_RootConstrainSelectedInstOperands,
     /* 314033 */   // GIR_Coverage, 397,
     /* 314033 */   GIR_Done,
     /* 314034 */ // Label 6365: @314034
     /* 314034 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(314064), // Rule ID 401 //
     /* 314039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314053 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 314053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 314058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314062 */   GIR_RootConstrainSelectedInstOperands,
     /* 314063 */   // GIR_Coverage, 401,
     /* 314063 */   GIR_Done,
     /* 314064 */ // Label 6366: @314064
     /* 314064 */ GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(314094), // Rule ID 405 //
     /* 314069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314083 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 314083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 314088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314092 */   GIR_RootConstrainSelectedInstOperands,
     /* 314093 */   // GIR_Coverage, 405,
     /* 314093 */   GIR_Done,
     /* 314094 */ // Label 6367: @314094
     /* 314094 */ GIM_Reject,
     /* 314095 */ // Label 6340: @314095
     /* 314095 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(314125), // Rule ID 843 //
     /* 314100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314114 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 314114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 314119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314123 */   GIR_RootConstrainSelectedInstOperands,
     /* 314124 */   // GIR_Coverage, 843,
     /* 314124 */   GIR_Done,
     /* 314125 */ // Label 6368: @314125
     /* 314125 */ GIM_Reject,
     /* 314126 */ // Label 6341: @314126
     /* 314126 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(314156), // Rule ID 847 //
     /* 314131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314145 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 314145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 314150 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314154 */   GIR_RootConstrainSelectedInstOperands,
     /* 314155 */   // GIR_Coverage, 847,
     /* 314155 */   GIR_Done,
     /* 314156 */ // Label 6369: @314156
     /* 314156 */ GIM_Reject,
     /* 314157 */ // Label 6342: @314157
     /* 314157 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(314187), // Rule ID 839 //
     /* 314162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314176 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 314176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 314181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314185 */   GIR_RootConstrainSelectedInstOperands,
     /* 314186 */   // GIR_Coverage, 839,
     /* 314186 */   GIR_Done,
     /* 314187 */ // Label 6370: @314187
     /* 314187 */ GIM_Reject,
     /* 314188 */ // Label 6343: @314188
     /* 314188 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(314218), // Rule ID 845 //
     /* 314193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314207 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 314207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 314212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314216 */   GIR_RootConstrainSelectedInstOperands,
     /* 314217 */   // GIR_Coverage, 845,
     /* 314217 */   GIR_Done,
     /* 314218 */ // Label 6371: @314218
     /* 314218 */ GIM_Reject,
     /* 314219 */ // Label 6344: @314219
     /* 314219 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(314249), // Rule ID 841 //
     /* 314224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314238 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 314238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 314243 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314247 */   GIR_RootConstrainSelectedInstOperands,
     /* 314248 */   // GIR_Coverage, 841,
     /* 314248 */   GIR_Done,
     /* 314249 */ // Label 6372: @314249
     /* 314249 */ GIM_Reject,
     /* 314250 */ // Label 6345: @314250
     /* 314250 */ GIM_Reject,
     /* 314251 */ // Label 68: @314251
     /* 314251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6380*/ GIMT_Encode4(315227),
     /* 314262 */ /*GILLT_s32*//*Label 6373*/ GIMT_Encode4(314298),
     /* 314266 */ /*GILLT_s64*//*Label 6374*/ GIMT_Encode4(314685), GIMT_Encode4(0),
     /* 314274 */ /*GILLT_v2s32*//*Label 6375*/ GIMT_Encode4(315072),
     /* 314278 */ /*GILLT_v2s64*//*Label 6376*/ GIMT_Encode4(315103),
     /* 314282 */ /*GILLT_v4s16*//*Label 6377*/ GIMT_Encode4(315134),
     /* 314286 */ /*GILLT_v4s32*//*Label 6378*/ GIMT_Encode4(315165), GIMT_Encode4(0),
     /* 314294 */ /*GILLT_v8s16*//*Label 6379*/ GIMT_Encode4(315196),
     /* 314298 */ // Label 6373: @314298
     /* 314298 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314335), // Rule ID 4659 //
     /* 314303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314318 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314324 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 314327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314329 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314333 */   GIR_RootConstrainSelectedInstOperands,
     /* 314334 */   // GIR_Coverage, 4659,
     /* 314334 */   GIR_EraseRootFromParent_Done,
     /* 314335 */ // Label 6381: @314335
     /* 314335 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(314372), // Rule ID 4661 //
     /* 314340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314355 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314361 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 314364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314366 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314370 */   GIR_RootConstrainSelectedInstOperands,
     /* 314371 */   // GIR_Coverage, 4661,
     /* 314371 */   GIR_EraseRootFromParent_Done,
     /* 314372 */ // Label 6382: @314372
     /* 314372 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(314409), // Rule ID 4679 //
     /* 314377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314392 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314398 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 314401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314407 */   GIR_RootConstrainSelectedInstOperands,
     /* 314408 */   // GIR_Coverage, 4679,
     /* 314408 */   GIR_EraseRootFromParent_Done,
     /* 314409 */ // Label 6383: @314409
     /* 314409 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(314446), // Rule ID 4681 //
     /* 314414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314429 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314435 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 314438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314440 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314444 */   GIR_RootConstrainSelectedInstOperands,
     /* 314445 */   // GIR_Coverage, 4681,
     /* 314445 */   GIR_EraseRootFromParent_Done,
     /* 314446 */ // Label 6384: @314446
     /* 314446 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(314483), // Rule ID 4719 //
     /* 314451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314466 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314472 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 314475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314477 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314481 */   GIR_RootConstrainSelectedInstOperands,
     /* 314482 */   // GIR_Coverage, 4719,
     /* 314482 */   GIR_EraseRootFromParent_Done,
     /* 314483 */ // Label 6385: @314483
     /* 314483 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(314520), // Rule ID 4721 //
     /* 314488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314503 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314509 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 314512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314514 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314518 */   GIR_RootConstrainSelectedInstOperands,
     /* 314519 */   // GIR_Coverage, 4721,
     /* 314519 */   GIR_EraseRootFromParent_Done,
     /* 314520 */ // Label 6386: @314520
     /* 314520 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(314557), // Rule ID 4699 //
     /* 314525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314540 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314546 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 314549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314551 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314555 */   GIR_RootConstrainSelectedInstOperands,
     /* 314556 */   // GIR_Coverage, 4699,
     /* 314556 */   GIR_EraseRootFromParent_Done,
     /* 314557 */ // Label 6387: @314557
     /* 314557 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(314594), // Rule ID 4701 //
     /* 314562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314577 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314583 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 314586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314588 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314592 */   GIR_RootConstrainSelectedInstOperands,
     /* 314593 */   // GIR_Coverage, 4701,
     /* 314593 */   GIR_EraseRootFromParent_Done,
     /* 314594 */ // Label 6388: @314594
     /* 314594 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(314624), // Rule ID 407 //
     /* 314599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314613 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 314613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 314618 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314622 */   GIR_RootConstrainSelectedInstOperands,
     /* 314623 */   // GIR_Coverage, 407,
     /* 314623 */   GIR_Done,
     /* 314624 */ // Label 6389: @314624
     /* 314624 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(314654), // Rule ID 411 //
     /* 314629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314643 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 314643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 314648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314652 */   GIR_RootConstrainSelectedInstOperands,
     /* 314653 */   // GIR_Coverage, 411,
     /* 314653 */   GIR_Done,
     /* 314654 */ // Label 6390: @314654
     /* 314654 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(314684), // Rule ID 415 //
     /* 314659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314673 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 314673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 314678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314682 */   GIR_RootConstrainSelectedInstOperands,
     /* 314683 */   // GIR_Coverage, 415,
     /* 314683 */   GIR_Done,
     /* 314684 */ // Label 6391: @314684
     /* 314684 */ GIM_Reject,
     /* 314685 */ // Label 6374: @314685
     /* 314685 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(314722), // Rule ID 4660 //
     /* 314690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314705 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314711 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 314714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314716 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314720 */   GIR_RootConstrainSelectedInstOperands,
     /* 314721 */   // GIR_Coverage, 4660,
     /* 314721 */   GIR_EraseRootFromParent_Done,
     /* 314722 */ // Label 6392: @314722
     /* 314722 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(314759), // Rule ID 4662 //
     /* 314727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314742 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314748 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 314751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314757 */   GIR_RootConstrainSelectedInstOperands,
     /* 314758 */   // GIR_Coverage, 4662,
     /* 314758 */   GIR_EraseRootFromParent_Done,
     /* 314759 */ // Label 6393: @314759
     /* 314759 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(314796), // Rule ID 4680 //
     /* 314764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314779 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314785 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 314788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314790 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314794 */   GIR_RootConstrainSelectedInstOperands,
     /* 314795 */   // GIR_Coverage, 4680,
     /* 314795 */   GIR_EraseRootFromParent_Done,
     /* 314796 */ // Label 6394: @314796
     /* 314796 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(314833), // Rule ID 4682 //
     /* 314801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314822 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 314825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314827 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314831 */   GIR_RootConstrainSelectedInstOperands,
     /* 314832 */   // GIR_Coverage, 4682,
     /* 314832 */   GIR_EraseRootFromParent_Done,
     /* 314833 */ // Label 6395: @314833
     /* 314833 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(314870), // Rule ID 4720 //
     /* 314838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314853 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314859 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 314862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314864 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314868 */   GIR_RootConstrainSelectedInstOperands,
     /* 314869 */   // GIR_Coverage, 4720,
     /* 314869 */   GIR_EraseRootFromParent_Done,
     /* 314870 */ // Label 6396: @314870
     /* 314870 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(314907), // Rule ID 4722 //
     /* 314875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314882 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314886 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314890 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314896 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 314899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314901 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314905 */   GIR_RootConstrainSelectedInstOperands,
     /* 314906 */   // GIR_Coverage, 4722,
     /* 314906 */   GIR_EraseRootFromParent_Done,
     /* 314907 */ // Label 6397: @314907
     /* 314907 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(314944), // Rule ID 4700 //
     /* 314912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314927 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314933 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 314936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314938 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314942 */   GIR_RootConstrainSelectedInstOperands,
     /* 314943 */   // GIR_Coverage, 4700,
     /* 314943 */   GIR_EraseRootFromParent_Done,
     /* 314944 */ // Label 6398: @314944
     /* 314944 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(314981), // Rule ID 4702 //
     /* 314949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314964 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314970 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 314973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314975 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314979 */   GIR_RootConstrainSelectedInstOperands,
     /* 314980 */   // GIR_Coverage, 4702,
     /* 314980 */   GIR_EraseRootFromParent_Done,
     /* 314981 */ // Label 6399: @314981
     /* 314981 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(315011), // Rule ID 409 //
     /* 314986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315000 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 315000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 315005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315009 */   GIR_RootConstrainSelectedInstOperands,
     /* 315010 */   // GIR_Coverage, 409,
     /* 315010 */   GIR_Done,
     /* 315011 */ // Label 6400: @315011
     /* 315011 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(315041), // Rule ID 413 //
     /* 315016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315030 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 315030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 315035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315039 */   GIR_RootConstrainSelectedInstOperands,
     /* 315040 */   // GIR_Coverage, 413,
     /* 315040 */   GIR_Done,
     /* 315041 */ // Label 6401: @315041
     /* 315041 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(315071), // Rule ID 417 //
     /* 315046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315060 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 315060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 315065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315069 */   GIR_RootConstrainSelectedInstOperands,
     /* 315070 */   // GIR_Coverage, 417,
     /* 315070 */   GIR_Done,
     /* 315071 */ // Label 6402: @315071
     /* 315071 */ GIM_Reject,
     /* 315072 */ // Label 6375: @315072
     /* 315072 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(315102), // Rule ID 853 //
     /* 315077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315091 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 315091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 315096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315100 */   GIR_RootConstrainSelectedInstOperands,
     /* 315101 */   // GIR_Coverage, 853,
     /* 315101 */   GIR_Done,
     /* 315102 */ // Label 6403: @315102
     /* 315102 */ GIM_Reject,
     /* 315103 */ // Label 6376: @315103
     /* 315103 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(315133), // Rule ID 857 //
     /* 315108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315122 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 315122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 315127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315131 */   GIR_RootConstrainSelectedInstOperands,
     /* 315132 */   // GIR_Coverage, 857,
     /* 315132 */   GIR_Done,
     /* 315133 */ // Label 6404: @315133
     /* 315133 */ GIM_Reject,
     /* 315134 */ // Label 6377: @315134
     /* 315134 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(315164), // Rule ID 849 //
     /* 315139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315153 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 315153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 315158 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315162 */   GIR_RootConstrainSelectedInstOperands,
     /* 315163 */   // GIR_Coverage, 849,
     /* 315163 */   GIR_Done,
     /* 315164 */ // Label 6405: @315164
     /* 315164 */ GIM_Reject,
     /* 315165 */ // Label 6378: @315165
     /* 315165 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(315195), // Rule ID 855 //
     /* 315170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315184 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 315184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 315189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315193 */   GIR_RootConstrainSelectedInstOperands,
     /* 315194 */   // GIR_Coverage, 855,
     /* 315194 */   GIR_Done,
     /* 315195 */ // Label 6406: @315195
     /* 315195 */ GIM_Reject,
     /* 315196 */ // Label 6379: @315196
     /* 315196 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(315226), // Rule ID 851 //
     /* 315201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315215 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 315215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 315220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315224 */   GIR_RootConstrainSelectedInstOperands,
     /* 315225 */   // GIR_Coverage, 851,
     /* 315225 */   GIR_Done,
     /* 315226 */ // Label 6407: @315226
     /* 315226 */ GIM_Reject,
     /* 315227 */ // Label 6380: @315227
     /* 315227 */ GIM_Reject,
     /* 315228 */ // Label 69: @315228
     /* 315228 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6416*/ GIMT_Encode4(319855),
     /* 315239 */ /*GILLT_s16*//*Label 6408*/ GIMT_Encode4(315279),
     /* 315243 */ /*GILLT_s32*//*Label 6409*/ GIMT_Encode4(315720),
     /* 315247 */ /*GILLT_s64*//*Label 6410*/ GIMT_Encode4(317716), GIMT_Encode4(0),
     /* 315255 */ /*GILLT_v2s32*//*Label 6411*/ GIMT_Encode4(319700),
     /* 315259 */ /*GILLT_v2s64*//*Label 6412*/ GIMT_Encode4(319731),
     /* 315263 */ /*GILLT_v4s16*//*Label 6413*/ GIMT_Encode4(319762),
     /* 315267 */ /*GILLT_v4s32*//*Label 6414*/ GIMT_Encode4(319793), GIMT_Encode4(0),
     /* 315275 */ /*GILLT_v8s16*//*Label 6415*/ GIMT_Encode4(319824),
     /* 315279 */ // Label 6408: @315279
     /* 315279 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(315382), // Rule ID 5323 //
     /* 315284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 315287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 315302 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315314 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315318 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315322 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315327 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315331 */   // MIs[1] Operand 2
     /* 315331 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 315342 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315344 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 315344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 315347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315356 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 315362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 315375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315380 */   GIR_RootConstrainSelectedInstOperands,
     /* 315381 */   // GIR_Coverage, 5323,
     /* 315381 */   GIR_EraseRootFromParent_Done,
     /* 315382 */ // Label 6417: @315382
     /* 315382 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(315462), // Rule ID 2444 //
     /* 315387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315409 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315413 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315418 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315424 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 315424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315436 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 315455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315460 */   GIR_RootConstrainSelectedInstOperands,
     /* 315461 */   // GIR_Coverage, 2444,
     /* 315461 */   GIR_EraseRootFromParent_Done,
     /* 315462 */ // Label 6418: @315462
     /* 315462 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(315542), // Rule ID 2448 //
     /* 315467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315477 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315481 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315485 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315489 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315493 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315498 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315504 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 315504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315516 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 315535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315540 */   GIR_RootConstrainSelectedInstOperands,
     /* 315541 */   // GIR_Coverage, 2448,
     /* 315541 */   GIR_EraseRootFromParent_Done,
     /* 315542 */ // Label 6419: @315542
     /* 315542 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(315599), // Rule ID 5314 //
     /* 315547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 315550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 315565 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315571 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 315571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 315574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 315578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315583 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 315589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 315592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315597 */   GIR_RootConstrainSelectedInstOperands,
     /* 315598 */   // GIR_Coverage, 5314,
     /* 315598 */   GIR_EraseRootFromParent_Done,
     /* 315599 */ // Label 6420: @315599
     /* 315599 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(315629), // Rule ID 443 //
     /* 315604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315618 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 315618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 315623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315627 */   GIR_RootConstrainSelectedInstOperands,
     /* 315628 */   // GIR_Coverage, 443,
     /* 315628 */   GIR_Done,
     /* 315629 */ // Label 6421: @315629
     /* 315629 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(315659), // Rule ID 449 //
     /* 315634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315648 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 315648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 315653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315657 */   GIR_RootConstrainSelectedInstOperands,
     /* 315658 */   // GIR_Coverage, 449,
     /* 315658 */   GIR_Done,
     /* 315659 */ // Label 6422: @315659
     /* 315659 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(315689), // Rule ID 491 //
     /* 315664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315678 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 315678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 315683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315687 */   GIR_RootConstrainSelectedInstOperands,
     /* 315688 */   // GIR_Coverage, 491,
     /* 315688 */   GIR_Done,
     /* 315689 */ // Label 6423: @315689
     /* 315689 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(315719), // Rule ID 495 //
     /* 315694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315708 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 315708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 315713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315717 */   GIR_RootConstrainSelectedInstOperands,
     /* 315718 */   // GIR_Coverage, 495,
     /* 315718 */   GIR_Done,
     /* 315719 */ // Label 6424: @315719
     /* 315719 */ GIM_Reject,
     /* 315720 */ // Label 6409: @315720
     /* 315720 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(315958), // Rule ID 6386 //
     /* 315725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315743 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315746 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 315766 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315766 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 315769 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 315773 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315793 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315800 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315803 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315807 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315814 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315817 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315821 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315826 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315829 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315832 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 315835 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315840 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315845 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315850 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315853 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 315857 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315862 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315865 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315870 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315873 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315877 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315882 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315889 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315894 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315911 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315914 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315931 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315938 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315943 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315956 */   GIR_RootConstrainSelectedInstOperands,
     /* 315957 */   // GIR_Coverage, 6386,
     /* 315957 */   GIR_EraseRootFromParent_Done,
     /* 315958 */ // Label 6425: @315958
     /* 315958 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(316196), // Rule ID 6387 //
     /* 315963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315981 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315984 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315991 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315997 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 316004 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316004 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 316007 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 316011 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316031 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316038 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316041 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316045 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316052 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316055 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316059 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316064 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316067 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316070 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316073 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316078 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316083 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316088 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316091 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316095 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316100 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316103 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316108 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316111 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316115 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316120 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316127 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316132 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316149 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316152 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316169 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316194 */   GIR_RootConstrainSelectedInstOperands,
     /* 316195 */   // GIR_Coverage, 6387,
     /* 316195 */   GIR_EraseRootFromParent_Done,
     /* 316196 */ // Label 6426: @316196
     /* 316196 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(316385), // Rule ID 6390 //
     /* 316201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316219 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316222 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316229 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316235 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 316242 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316242 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 316245 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 316249 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316269 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316276 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316279 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316283 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316290 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316293 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316297 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316302 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316305 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316308 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 316311 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316316 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316321 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316338 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316341 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316358 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316383 */   GIR_RootConstrainSelectedInstOperands,
     /* 316384 */   // GIR_Coverage, 6390,
     /* 316384 */   GIR_EraseRootFromParent_Done,
     /* 316385 */ // Label 6427: @316385
     /* 316385 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(316574), // Rule ID 6391 //
     /* 316390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316408 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316411 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316418 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316424 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 316431 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316431 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 316434 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 316438 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316458 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316465 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316468 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316472 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316479 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316482 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316486 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316491 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316494 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316497 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 316500 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316505 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316510 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316515 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316518 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316522 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316527 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316530 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316547 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316572 */   GIR_RootConstrainSelectedInstOperands,
     /* 316573 */   // GIR_Coverage, 6391,
     /* 316573 */   GIR_EraseRootFromParent_Done,
     /* 316574 */ // Label 6428: @316574
     /* 316574 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(316807), // Rule ID 6388 //
     /* 316579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316597 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316600 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 316607 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316613 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 316620 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316620 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 316623 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 316627 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316642 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316649 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316652 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316656 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316663 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316666 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316670 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316675 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316678 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316681 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316684 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316689 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316694 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316699 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316702 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316706 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316711 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316714 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316719 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316722 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316726 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316731 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316738 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316743 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316760 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316763 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316780 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316805 */   GIR_RootConstrainSelectedInstOperands,
     /* 316806 */   // GIR_Coverage, 6388,
     /* 316806 */   GIR_EraseRootFromParent_Done,
     /* 316807 */ // Label 6429: @316807
     /* 316807 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(317040), // Rule ID 6389 //
     /* 316812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316830 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316833 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 316840 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316846 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 316853 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316853 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 316856 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 316860 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316875 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316882 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316885 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316889 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316896 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316899 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316903 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316908 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316911 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316914 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316917 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316922 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316927 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316932 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316935 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316939 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316944 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316947 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316952 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316955 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316959 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316964 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316971 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316976 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316981 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316984 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316988 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316993 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316996 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317013 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317020 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317038 */   GIR_RootConstrainSelectedInstOperands,
     /* 317039 */   // GIR_Coverage, 6389,
     /* 317039 */   GIR_EraseRootFromParent_Done,
     /* 317040 */ // Label 6430: @317040
     /* 317040 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(317224), // Rule ID 6392 //
     /* 317045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317063 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317066 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317073 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317077 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317079 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 317086 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 317086 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 317089 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 317093 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317108 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317115 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317118 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317122 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317129 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317132 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317136 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317141 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317144 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317147 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 317150 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317155 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317160 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317165 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317168 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317172 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317177 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317180 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317197 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317209 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317222 */   GIR_RootConstrainSelectedInstOperands,
     /* 317223 */   // GIR_Coverage, 6392,
     /* 317223 */   GIR_EraseRootFromParent_Done,
     /* 317224 */ // Label 6431: @317224
     /* 317224 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(317408), // Rule ID 6393 //
     /* 317229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317247 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317250 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317257 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317263 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 317270 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 317270 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 317273 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 317277 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317292 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317299 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317302 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317306 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317313 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317316 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317320 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317325 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317328 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317331 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 317334 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317339 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317344 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317349 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317352 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317356 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317361 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317364 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317381 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317393 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317406 */   GIR_RootConstrainSelectedInstOperands,
     /* 317407 */   // GIR_Coverage, 6393,
     /* 317407 */   GIR_EraseRootFromParent_Done,
     /* 317408 */ // Label 6432: @317408
     /* 317408 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(317488), // Rule ID 2450 //
     /* 317413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317431 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317435 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317444 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317450 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 317450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317462 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 317481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317486 */   GIR_RootConstrainSelectedInstOperands,
     /* 317487 */   // GIR_Coverage, 2450,
     /* 317487 */   GIR_EraseRootFromParent_Done,
     /* 317488 */ // Label 6433: @317488
     /* 317488 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(317568), // Rule ID 5319 //
     /* 317493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317511 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317524 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317528 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317530 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 317530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317542 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 317548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317566 */   GIR_RootConstrainSelectedInstOperands,
     /* 317567 */   // GIR_Coverage, 5319,
     /* 317567 */   GIR_EraseRootFromParent_Done,
     /* 317568 */ // Label 6434: @317568
     /* 317568 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(317625), // Rule ID 5302 //
     /* 317573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 317591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317597 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 317597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 317604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317623 */   GIR_RootConstrainSelectedInstOperands,
     /* 317624 */   // GIR_Coverage, 5302,
     /* 317624 */   GIR_EraseRootFromParent_Done,
     /* 317625 */ // Label 6435: @317625
     /* 317625 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(317655), // Rule ID 445 //
     /* 317630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317644 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 317644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 317649 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317653 */   GIR_RootConstrainSelectedInstOperands,
     /* 317654 */   // GIR_Coverage, 445,
     /* 317654 */   GIR_Done,
     /* 317655 */ // Label 6436: @317655
     /* 317655 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(317685), // Rule ID 451 //
     /* 317660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317674 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 317674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 317679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317683 */   GIR_RootConstrainSelectedInstOperands,
     /* 317684 */   // GIR_Coverage, 451,
     /* 317684 */   GIR_Done,
     /* 317685 */ // Label 6437: @317685
     /* 317685 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(317715), // Rule ID 497 //
     /* 317690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317704 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 317704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 317709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317713 */   GIR_RootConstrainSelectedInstOperands,
     /* 317714 */   // GIR_Coverage, 497,
     /* 317714 */   GIR_Done,
     /* 317715 */ // Label 6438: @317715
     /* 317715 */ GIM_Reject,
     /* 317716 */ // Label 6410: @317716
     /* 317716 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(317902), // Rule ID 6398 //
     /* 317721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317739 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317746 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317752 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 317759 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317759 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317762 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 317766 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 317786 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317793 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317796 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317800 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317807 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317810 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317814 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317819 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317822 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317825 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 317828 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317833 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317838 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317843 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317846 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317850 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317855 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317858 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317866 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317870 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317875 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317900 */   GIR_RootConstrainSelectedInstOperands,
     /* 317901 */   // GIR_Coverage, 6398,
     /* 317901 */   GIR_EraseRootFromParent_Done,
     /* 317902 */ // Label 6439: @317902
     /* 317902 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(318088), // Rule ID 6399 //
     /* 317907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317925 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317932 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317938 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 317945 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317945 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317948 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 317952 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 317972 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317979 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317982 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317986 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318005 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318008 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318011 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318014 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318019 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318024 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318029 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318032 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318036 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318044 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318061 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318086 */   GIR_RootConstrainSelectedInstOperands,
     /* 318087 */   // GIR_Coverage, 6399,
     /* 318087 */   GIR_EraseRootFromParent_Done,
     /* 318088 */ // Label 6440: @318088
     /* 318088 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(318326), // Rule ID 6394 //
     /* 318093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318111 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318114 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318121 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318127 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 318134 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318134 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318137 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 318141 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 318161 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 318168 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 318171 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318175 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 318182 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 318185 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318189 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318194 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 318197 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 318200 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 318203 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318208 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318213 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318218 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 318221 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 318225 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318230 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 318233 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 318236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318238 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318241 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318245 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318250 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318257 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318262 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318267 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318270 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318274 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318279 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318282 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318299 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318324 */   GIR_RootConstrainSelectedInstOperands,
     /* 318325 */   // GIR_Coverage, 6394,
     /* 318325 */   GIR_EraseRootFromParent_Done,
     /* 318326 */ // Label 6441: @318326
     /* 318326 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(318564), // Rule ID 6395 //
     /* 318331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318349 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318352 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318359 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318365 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 318372 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318372 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318375 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 318379 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 318399 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 318406 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 318409 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318413 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 318420 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 318423 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318427 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318432 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 318435 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 318438 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 318441 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318446 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318451 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318456 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 318459 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 318463 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318468 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 318471 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 318474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318476 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318479 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318483 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318488 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318495 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318500 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318517 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318520 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318537 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318562 */   GIR_RootConstrainSelectedInstOperands,
     /* 318563 */   // GIR_Coverage, 6395,
     /* 318563 */   GIR_EraseRootFromParent_Done,
     /* 318564 */ // Label 6442: @318564
     /* 318564 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(318745), // Rule ID 6400 //
     /* 318569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318587 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318594 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318600 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 318607 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318607 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 318610 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 318614 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318629 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 318636 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 318639 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318643 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318650 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318653 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318657 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318662 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318665 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318668 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318671 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318676 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318681 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318686 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318689 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318693 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318698 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318701 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318718 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318725 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318730 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318743 */   GIR_RootConstrainSelectedInstOperands,
     /* 318744 */   // GIR_Coverage, 6400,
     /* 318744 */   GIR_EraseRootFromParent_Done,
     /* 318745 */ // Label 6443: @318745
     /* 318745 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(318926), // Rule ID 6401 //
     /* 318750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318768 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318771 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318775 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318781 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 318788 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318788 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 318791 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 318795 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318810 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 318817 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 318820 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318824 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318831 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318834 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318838 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318843 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318846 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318849 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318852 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318857 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318862 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318867 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318870 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318874 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318879 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318882 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318899 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318924 */   GIR_RootConstrainSelectedInstOperands,
     /* 318925 */   // GIR_Coverage, 6401,
     /* 318925 */   GIR_EraseRootFromParent_Done,
     /* 318926 */ // Label 6444: @318926
     /* 318926 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(319159), // Rule ID 6396 //
     /* 318931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318941 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318949 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318952 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318959 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318965 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 318972 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318972 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318975 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318979 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318994 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 319001 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 319004 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319008 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 319015 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 319018 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319022 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319027 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 319030 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 319033 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 319036 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319041 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319046 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319051 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 319054 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 319058 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319063 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 319066 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 319069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 319071 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 319074 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319078 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319083 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319090 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319095 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319100 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 319103 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 319107 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319112 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319115 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 319118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319132 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319139 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319157 */   GIR_RootConstrainSelectedInstOperands,
     /* 319158 */   // GIR_Coverage, 6396,
     /* 319158 */   GIR_EraseRootFromParent_Done,
     /* 319159 */ // Label 6445: @319159
     /* 319159 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(319392), // Rule ID 6397 //
     /* 319164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 319167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 319182 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319185 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319192 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319198 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 319205 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 319205 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 319208 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 319212 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319227 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 319234 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 319237 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319241 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 319248 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 319251 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319255 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319260 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 319263 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 319266 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 319269 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319274 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319279 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319284 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 319287 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 319291 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319296 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 319299 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 319302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 319304 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 319307 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319311 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319316 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319323 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319328 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319333 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 319336 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 319340 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319345 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319348 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 319351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319365 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319390 */   GIR_RootConstrainSelectedInstOperands,
     /* 319391 */   // GIR_Coverage, 6397,
     /* 319391 */   GIR_EraseRootFromParent_Done,
     /* 319392 */ // Label 6446: @319392
     /* 319392 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(319472), // Rule ID 2446 //
     /* 319397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319415 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319419 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319428 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319434 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 319434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319446 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 319452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 319465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319470 */   GIR_RootConstrainSelectedInstOperands,
     /* 319471 */   // GIR_Coverage, 2446,
     /* 319471 */   GIR_EraseRootFromParent_Done,
     /* 319472 */ // Label 6447: @319472
     /* 319472 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(319552), // Rule ID 5321 //
     /* 319477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319499 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319508 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319514 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 319514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319526 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 319532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319550 */   GIR_RootConstrainSelectedInstOperands,
     /* 319551 */   // GIR_Coverage, 5321,
     /* 319551 */   GIR_EraseRootFromParent_Done,
     /* 319552 */ // Label 6448: @319552
     /* 319552 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(319609), // Rule ID 5298 //
     /* 319557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 319575 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319581 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 319581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 319588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319607 */   GIR_RootConstrainSelectedInstOperands,
     /* 319608 */   // GIR_Coverage, 5298,
     /* 319608 */   GIR_EraseRootFromParent_Done,
     /* 319609 */ // Label 6449: @319609
     /* 319609 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(319639), // Rule ID 447 //
     /* 319614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 319628 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 319628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 319633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319637 */   GIR_RootConstrainSelectedInstOperands,
     /* 319638 */   // GIR_Coverage, 447,
     /* 319638 */   GIR_Done,
     /* 319639 */ // Label 6450: @319639
     /* 319639 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(319669), // Rule ID 453 //
     /* 319644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319658 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 319658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 319663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319667 */   GIR_RootConstrainSelectedInstOperands,
     /* 319668 */   // GIR_Coverage, 453,
     /* 319668 */   GIR_Done,
     /* 319669 */ // Label 6451: @319669
     /* 319669 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(319699), // Rule ID 493 //
     /* 319674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319688 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 319688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 319693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319697 */   GIR_RootConstrainSelectedInstOperands,
     /* 319698 */   // GIR_Coverage, 493,
     /* 319698 */   GIR_Done,
     /* 319699 */ // Label 6452: @319699
     /* 319699 */ GIM_Reject,
     /* 319700 */ // Label 6411: @319700
     /* 319700 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(319730), // Rule ID 1017 //
     /* 319705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319719 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 319719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 319724 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319728 */   GIR_RootConstrainSelectedInstOperands,
     /* 319729 */   // GIR_Coverage, 1017,
     /* 319729 */   GIR_Done,
     /* 319730 */ // Label 6453: @319730
     /* 319730 */ GIM_Reject,
     /* 319731 */ // Label 6412: @319731
     /* 319731 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(319761), // Rule ID 1021 //
     /* 319736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319750 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 319750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 319755 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319759 */   GIR_RootConstrainSelectedInstOperands,
     /* 319760 */   // GIR_Coverage, 1021,
     /* 319760 */   GIR_Done,
     /* 319761 */ // Label 6454: @319761
     /* 319761 */ GIM_Reject,
     /* 319762 */ // Label 6413: @319762
     /* 319762 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(319792), // Rule ID 1013 //
     /* 319767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319781 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 319781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 319786 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319790 */   GIR_RootConstrainSelectedInstOperands,
     /* 319791 */   // GIR_Coverage, 1013,
     /* 319791 */   GIR_Done,
     /* 319792 */ // Label 6455: @319792
     /* 319792 */ GIM_Reject,
     /* 319793 */ // Label 6414: @319793
     /* 319793 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(319823), // Rule ID 1019 //
     /* 319798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319812 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 319812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 319817 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319821 */   GIR_RootConstrainSelectedInstOperands,
     /* 319822 */   // GIR_Coverage, 1019,
     /* 319822 */   GIR_Done,
     /* 319823 */ // Label 6456: @319823
     /* 319823 */ GIM_Reject,
     /* 319824 */ // Label 6415: @319824
     /* 319824 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(319854), // Rule ID 1015 //
     /* 319829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319843 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 319843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 319848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319852 */   GIR_RootConstrainSelectedInstOperands,
     /* 319853 */   // GIR_Coverage, 1015,
     /* 319853 */   GIR_Done,
     /* 319854 */ // Label 6457: @319854
     /* 319854 */ GIM_Reject,
     /* 319855 */ // Label 6416: @319855
     /* 319855 */ GIM_Reject,
     /* 319856 */ // Label 70: @319856
     /* 319856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6466*/ GIMT_Encode4(323861),
     /* 319867 */ /*GILLT_s16*//*Label 6458*/ GIMT_Encode4(319907),
     /* 319871 */ /*GILLT_s32*//*Label 6459*/ GIMT_Encode4(320352),
     /* 319875 */ /*GILLT_s64*//*Label 6460*/ GIMT_Encode4(321760), GIMT_Encode4(0),
     /* 319883 */ /*GILLT_v2s32*//*Label 6461*/ GIMT_Encode4(323706),
     /* 319887 */ /*GILLT_v2s64*//*Label 6462*/ GIMT_Encode4(323737),
     /* 319891 */ /*GILLT_v4s16*//*Label 6463*/ GIMT_Encode4(323768),
     /* 319895 */ /*GILLT_v4s32*//*Label 6464*/ GIMT_Encode4(323799), GIMT_Encode4(0),
     /* 319903 */ /*GILLT_v8s16*//*Label 6465*/ GIMT_Encode4(323830),
     /* 319907 */ // Label 6458: @319907
     /* 319907 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(320014), // Rule ID 5324 //
     /* 319912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 319915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 319930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 319938 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319942 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319946 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319950 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319954 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319959 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 319963 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 319974 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319976 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 319976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 319979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319988 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 319994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 320007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320012 */   GIR_RootConstrainSelectedInstOperands,
     /* 320013 */   // GIR_Coverage, 5324,
     /* 320013 */   GIR_EraseRootFromParent_Done,
     /* 320014 */ // Label 6467: @320014
     /* 320014 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(320094), // Rule ID 4748 //
     /* 320019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320045 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320050 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320056 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 320056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320068 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 320074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 320087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320092 */   GIR_RootConstrainSelectedInstOperands,
     /* 320093 */   // GIR_Coverage, 4748,
     /* 320093 */   GIR_EraseRootFromParent_Done,
     /* 320094 */ // Label 6468: @320094
     /* 320094 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(320174), // Rule ID 4752 //
     /* 320099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320117 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320121 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320125 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320130 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320136 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320148 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 320167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320172 */   GIR_RootConstrainSelectedInstOperands,
     /* 320173 */   // GIR_Coverage, 4752,
     /* 320173 */   GIR_EraseRootFromParent_Done,
     /* 320174 */ // Label 6469: @320174
     /* 320174 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(320231), // Rule ID 5318 //
     /* 320179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 320182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320197 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320203 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 320203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 320206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 320210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 320224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320229 */   GIR_RootConstrainSelectedInstOperands,
     /* 320230 */   // GIR_Coverage, 5318,
     /* 320230 */   GIR_EraseRootFromParent_Done,
     /* 320231 */ // Label 6470: @320231
     /* 320231 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(320261), // Rule ID 467 //
     /* 320236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320250 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 320250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 320255 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320259 */   GIR_RootConstrainSelectedInstOperands,
     /* 320260 */   // GIR_Coverage, 467,
     /* 320260 */   GIR_Done,
     /* 320261 */ // Label 6471: @320261
     /* 320261 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(320291), // Rule ID 473 //
     /* 320266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320280 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 320280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 320285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320289 */   GIR_RootConstrainSelectedInstOperands,
     /* 320290 */   // GIR_Coverage, 473,
     /* 320290 */   GIR_Done,
     /* 320291 */ // Label 6472: @320291
     /* 320291 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(320321), // Rule ID 499 //
     /* 320296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320310 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 320310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 320315 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320319 */   GIR_RootConstrainSelectedInstOperands,
     /* 320320 */   // GIR_Coverage, 499,
     /* 320320 */   GIR_Done,
     /* 320321 */ // Label 6473: @320321
     /* 320321 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(320351), // Rule ID 503 //
     /* 320326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320340 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 320340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 320345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320349 */   GIR_RootConstrainSelectedInstOperands,
     /* 320350 */   // GIR_Coverage, 503,
     /* 320350 */   GIR_Done,
     /* 320351 */ // Label 6474: @320351
     /* 320351 */ GIM_Reject,
     /* 320352 */ // Label 6459: @320352
     /* 320352 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(320492), // Rule ID 5325 //
     /* 320357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320375 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320378 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320385 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320391 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 320398 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320398 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320401 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 320405 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320425 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320432 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320435 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320439 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320458 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320461 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320464 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320490 */   GIR_RootConstrainSelectedInstOperands,
     /* 320491 */   // GIR_Coverage, 5325,
     /* 320491 */   GIR_EraseRootFromParent_Done,
     /* 320492 */ // Label 6475: @320492
     /* 320492 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(320632), // Rule ID 5326 //
     /* 320497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320515 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320518 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320525 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320531 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 320538 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320538 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320541 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 320545 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320565 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320572 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320575 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320579 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320598 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320604 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320630 */   GIR_RootConstrainSelectedInstOperands,
     /* 320631 */   // GIR_Coverage, 5326,
     /* 320631 */   GIR_EraseRootFromParent_Done,
     /* 320632 */ // Label 6476: @320632
     /* 320632 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(320772), // Rule ID 5329 //
     /* 320637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320655 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320658 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320665 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320671 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 320678 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320678 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320681 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 320685 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320705 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320738 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320744 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320752 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320770 */   GIR_RootConstrainSelectedInstOperands,
     /* 320771 */   // GIR_Coverage, 5329,
     /* 320771 */   GIR_EraseRootFromParent_Done,
     /* 320772 */ // Label 6477: @320772
     /* 320772 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(320912), // Rule ID 5330 //
     /* 320777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320795 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320798 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320805 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320811 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 320818 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320818 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320821 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 320825 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320845 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320878 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320881 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320884 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320910 */   GIR_RootConstrainSelectedInstOperands,
     /* 320911 */   // GIR_Coverage, 5330,
     /* 320911 */   GIR_EraseRootFromParent_Done,
     /* 320912 */ // Label 6478: @320912
     /* 320912 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(321047), // Rule ID 5327 //
     /* 320917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320935 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320938 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320945 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320951 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 320958 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 320958 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320961 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 320965 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320980 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320990 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320994 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321016 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321019 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321045 */   GIR_RootConstrainSelectedInstOperands,
     /* 321046 */   // GIR_Coverage, 5327,
     /* 321046 */   GIR_EraseRootFromParent_Done,
     /* 321047 */ // Label 6479: @321047
     /* 321047 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(321182), // Rule ID 5328 //
     /* 321052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321070 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321073 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 321080 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321086 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 321093 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 321093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 321096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 321100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321115 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321122 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321125 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321129 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321148 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321151 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321154 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321157 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321180 */   GIR_RootConstrainSelectedInstOperands,
     /* 321181 */   // GIR_Coverage, 5328,
     /* 321181 */   GIR_EraseRootFromParent_Done,
     /* 321182 */ // Label 6480: @321182
     /* 321182 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(321317), // Rule ID 5331 //
     /* 321187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321205 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321208 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321215 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321221 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 321228 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 321228 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321231 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 321235 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321250 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321257 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321260 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321264 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321283 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321286 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321289 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321315 */   GIR_RootConstrainSelectedInstOperands,
     /* 321316 */   // GIR_Coverage, 5331,
     /* 321316 */   GIR_EraseRootFromParent_Done,
     /* 321317 */ // Label 6481: @321317
     /* 321317 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(321452), // Rule ID 5332 //
     /* 321322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321340 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321343 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321350 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321356 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 321363 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 321363 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321366 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 321370 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321385 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321392 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321395 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321399 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321418 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321421 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321424 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321450 */   GIR_RootConstrainSelectedInstOperands,
     /* 321451 */   // GIR_Coverage, 5332,
     /* 321451 */   GIR_EraseRootFromParent_Done,
     /* 321452 */ // Label 6482: @321452
     /* 321452 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(321532), // Rule ID 4754 //
     /* 321457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321488 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321494 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 321494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321506 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 321512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 321525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321530 */   GIR_RootConstrainSelectedInstOperands,
     /* 321531 */   // GIR_Coverage, 4754,
     /* 321531 */   GIR_EraseRootFromParent_Done,
     /* 321532 */ // Label 6483: @321532
     /* 321532 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(321612), // Rule ID 5320 //
     /* 321537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321555 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321568 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321574 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 321574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321586 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 321592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321610 */   GIR_RootConstrainSelectedInstOperands,
     /* 321611 */   // GIR_Coverage, 5320,
     /* 321611 */   GIR_EraseRootFromParent_Done,
     /* 321612 */ // Label 6484: @321612
     /* 321612 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(321669), // Rule ID 5310 //
     /* 321617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 321635 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321639 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321641 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 321641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 321648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321653 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321667 */   GIR_RootConstrainSelectedInstOperands,
     /* 321668 */   // GIR_Coverage, 5310,
     /* 321668 */   GIR_EraseRootFromParent_Done,
     /* 321669 */ // Label 6485: @321669
     /* 321669 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(321699), // Rule ID 469 //
     /* 321674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321688 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 321688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 321693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321697 */   GIR_RootConstrainSelectedInstOperands,
     /* 321698 */   // GIR_Coverage, 469,
     /* 321698 */   GIR_Done,
     /* 321699 */ // Label 6486: @321699
     /* 321699 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(321729), // Rule ID 475 //
     /* 321704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321718 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 321718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 321723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321727 */   GIR_RootConstrainSelectedInstOperands,
     /* 321728 */   // GIR_Coverage, 475,
     /* 321728 */   GIR_Done,
     /* 321729 */ // Label 6487: @321729
     /* 321729 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(321759), // Rule ID 505 //
     /* 321734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321748 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 321748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 321753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321757 */   GIR_RootConstrainSelectedInstOperands,
     /* 321758 */   // GIR_Coverage, 505,
     /* 321758 */   GIR_Done,
     /* 321759 */ // Label 6488: @321759
     /* 321759 */ GIM_Reject,
     /* 321760 */ // Label 6460: @321760
     /* 321760 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(321897), // Rule ID 5341 //
     /* 321765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321775 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321783 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321790 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321796 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 321803 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 321803 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321806 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 321810 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 321825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 321830 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321837 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321840 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321844 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321863 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321866 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321869 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321895 */   GIR_RootConstrainSelectedInstOperands,
     /* 321896 */   // GIR_Coverage, 5341,
     /* 321896 */   GIR_EraseRootFromParent_Done,
     /* 321897 */ // Label 6489: @321897
     /* 321897 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(322034), // Rule ID 5342 //
     /* 321902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321920 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 321940 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 321940 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321943 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 321947 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 321962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 321967 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321974 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321977 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321981 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322000 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322003 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322006 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322019 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322032 */   GIR_RootConstrainSelectedInstOperands,
     /* 322033 */   // GIR_Coverage, 5342,
     /* 322033 */   GIR_EraseRootFromParent_Done,
     /* 322034 */ // Label 6490: @322034
     /* 322034 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(322174), // Rule ID 5333 //
     /* 322039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322057 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322060 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322067 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322073 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 322080 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 322080 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322083 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 322087 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322107 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322114 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322117 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322121 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322143 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322146 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322172 */   GIR_RootConstrainSelectedInstOperands,
     /* 322173 */   // GIR_Coverage, 5333,
     /* 322173 */   GIR_EraseRootFromParent_Done,
     /* 322174 */ // Label 6491: @322174
     /* 322174 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(322314), // Rule ID 5334 //
     /* 322179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322197 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322200 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322207 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322213 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 322220 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 322220 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322223 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 322227 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322247 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322280 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322283 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322286 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322299 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322312 */   GIR_RootConstrainSelectedInstOperands,
     /* 322313 */   // GIR_Coverage, 5334,
     /* 322313 */   GIR_EraseRootFromParent_Done,
     /* 322314 */ // Label 6492: @322314
     /* 322314 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(322454), // Rule ID 5337 //
     /* 322319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322337 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322340 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 322347 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322353 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 322360 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 322360 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 322363 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 322367 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322387 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322394 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322397 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322401 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322426 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322452 */   GIR_RootConstrainSelectedInstOperands,
     /* 322453 */   // GIR_Coverage, 5337,
     /* 322453 */   GIR_EraseRootFromParent_Done,
     /* 322454 */ // Label 6493: @322454
     /* 322454 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(322594), // Rule ID 5338 //
     /* 322459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322477 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322480 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 322487 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322493 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 322500 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 322500 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 322503 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 322507 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322527 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322534 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322537 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322541 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322560 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322563 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322566 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322569 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322592 */   GIR_RootConstrainSelectedInstOperands,
     /* 322593 */   // GIR_Coverage, 5338,
     /* 322593 */   GIR_EraseRootFromParent_Done,
     /* 322594 */ // Label 6494: @322594
     /* 322594 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(322726), // Rule ID 5343 //
     /* 322599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 322617 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322620 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 322624 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322630 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 322637 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 322637 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 322640 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 322644 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322659 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322666 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322669 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322673 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322692 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322695 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322698 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322701 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322724 */   GIR_RootConstrainSelectedInstOperands,
     /* 322725 */   // GIR_Coverage, 5343,
     /* 322725 */   GIR_EraseRootFromParent_Done,
     /* 322726 */ // Label 6495: @322726
     /* 322726 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(322858), // Rule ID 5344 //
     /* 322731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 322749 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 322756 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322762 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 322769 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 322769 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 322772 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 322776 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322791 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322824 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322827 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322830 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322856 */   GIR_RootConstrainSelectedInstOperands,
     /* 322857 */   // GIR_Coverage, 5344,
     /* 322857 */   GIR_EraseRootFromParent_Done,
     /* 322858 */ // Label 6496: @322858
     /* 322858 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(322993), // Rule ID 5335 //
     /* 322863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322881 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322884 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322891 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322897 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 322904 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 322904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 322911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322926 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322959 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322962 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322965 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322991 */   GIR_RootConstrainSelectedInstOperands,
     /* 322992 */   // GIR_Coverage, 5335,
     /* 322992 */   GIR_EraseRootFromParent_Done,
     /* 322993 */ // Label 6497: @322993
     /* 322993 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(323128), // Rule ID 5336 //
     /* 322998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323008 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323012 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323016 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323019 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 323026 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323032 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 323039 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 323039 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 323042 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 323046 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323061 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323094 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323100 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 323103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 323118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323126 */   GIR_RootConstrainSelectedInstOperands,
     /* 323127 */   // GIR_Coverage, 5336,
     /* 323127 */   GIR_EraseRootFromParent_Done,
     /* 323128 */ // Label 6498: @323128
     /* 323128 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(323263), // Rule ID 5339 //
     /* 323133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323151 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323154 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 323161 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323167 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 323174 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 323174 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 323177 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 323181 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323196 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323203 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323206 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323210 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323232 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323235 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323261 */   GIR_RootConstrainSelectedInstOperands,
     /* 323262 */   // GIR_Coverage, 5339,
     /* 323262 */   GIR_EraseRootFromParent_Done,
     /* 323263 */ // Label 6499: @323263
     /* 323263 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(323398), // Rule ID 5340 //
     /* 323268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323286 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323289 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 323296 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323300 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323302 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 323309 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 323309 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 323312 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 323316 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323331 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323364 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323367 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323370 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323396 */   GIR_RootConstrainSelectedInstOperands,
     /* 323397 */   // GIR_Coverage, 5340,
     /* 323397 */   GIR_EraseRootFromParent_Done,
     /* 323398 */ // Label 6500: @323398
     /* 323398 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(323478), // Rule ID 4750 //
     /* 323403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 323406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323429 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323434 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 323438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323440 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 323440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323452 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 323458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 323471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323476 */   GIR_RootConstrainSelectedInstOperands,
     /* 323477 */   // GIR_Coverage, 4750,
     /* 323477 */   GIR_EraseRootFromParent_Done,
     /* 323478 */ // Label 6501: @323478
     /* 323478 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(323558), // Rule ID 5322 //
     /* 323483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323501 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323505 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323514 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 323518 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323520 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 323520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323532 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 323538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323556 */   GIR_RootConstrainSelectedInstOperands,
     /* 323557 */   // GIR_Coverage, 5322,
     /* 323557 */   GIR_EraseRootFromParent_Done,
     /* 323558 */ // Label 6502: @323558
     /* 323558 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(323615), // Rule ID 5306 //
     /* 323563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 323581 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323587 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 323587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 323594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323613 */   GIR_RootConstrainSelectedInstOperands,
     /* 323614 */   // GIR_Coverage, 5306,
     /* 323614 */   GIR_EraseRootFromParent_Done,
     /* 323615 */ // Label 6503: @323615
     /* 323615 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(323645), // Rule ID 471 //
     /* 323620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323634 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 323634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 323639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323643 */   GIR_RootConstrainSelectedInstOperands,
     /* 323644 */   // GIR_Coverage, 471,
     /* 323644 */   GIR_Done,
     /* 323645 */ // Label 6504: @323645
     /* 323645 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(323675), // Rule ID 477 //
     /* 323650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323664 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 323664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 323669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323673 */   GIR_RootConstrainSelectedInstOperands,
     /* 323674 */   // GIR_Coverage, 477,
     /* 323674 */   GIR_Done,
     /* 323675 */ // Label 6505: @323675
     /* 323675 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(323705), // Rule ID 501 //
     /* 323680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 323683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323694 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 323694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 323699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323703 */   GIR_RootConstrainSelectedInstOperands,
     /* 323704 */   // GIR_Coverage, 501,
     /* 323704 */   GIR_Done,
     /* 323705 */ // Label 6506: @323705
     /* 323705 */ GIM_Reject,
     /* 323706 */ // Label 6461: @323706
     /* 323706 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(323736), // Rule ID 1078 //
     /* 323711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323725 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 323725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 323730 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323734 */   GIR_RootConstrainSelectedInstOperands,
     /* 323735 */   // GIR_Coverage, 1078,
     /* 323735 */   GIR_Done,
     /* 323736 */ // Label 6507: @323736
     /* 323736 */ GIM_Reject,
     /* 323737 */ // Label 6462: @323737
     /* 323737 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(323767), // Rule ID 1082 //
     /* 323742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323756 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 323756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 323761 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323765 */   GIR_RootConstrainSelectedInstOperands,
     /* 323766 */   // GIR_Coverage, 1082,
     /* 323766 */   GIR_Done,
     /* 323767 */ // Label 6508: @323767
     /* 323767 */ GIM_Reject,
     /* 323768 */ // Label 6463: @323768
     /* 323768 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(323798), // Rule ID 1074 //
     /* 323773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323787 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 323787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 323792 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323796 */   GIR_RootConstrainSelectedInstOperands,
     /* 323797 */   // GIR_Coverage, 1074,
     /* 323797 */   GIR_Done,
     /* 323798 */ // Label 6509: @323798
     /* 323798 */ GIM_Reject,
     /* 323799 */ // Label 6464: @323799
     /* 323799 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(323829), // Rule ID 1080 //
     /* 323804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323818 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 323818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 323823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323827 */   GIR_RootConstrainSelectedInstOperands,
     /* 323828 */   // GIR_Coverage, 1080,
     /* 323828 */   GIR_Done,
     /* 323829 */ // Label 6510: @323829
     /* 323829 */ GIM_Reject,
     /* 323830 */ // Label 6465: @323830
     /* 323830 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(323860), // Rule ID 1076 //
     /* 323835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323849 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 323849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 323854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323858 */   GIR_RootConstrainSelectedInstOperands,
     /* 323859 */   // GIR_Coverage, 1076,
     /* 323859 */   GIR_Done,
     /* 323860 */ // Label 6511: @323860
     /* 323860 */ GIM_Reject,
     /* 323861 */ // Label 6466: @323861
     /* 323861 */ GIM_Reject,
     /* 323862 */ // Label 71: @323862
     /* 323862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6519*/ GIMT_Encode4(324181),
     /* 323873 */ /*GILLT_s32*//*Label 6512*/ GIMT_Encode4(323909),
     /* 323877 */ /*GILLT_s64*//*Label 6513*/ GIMT_Encode4(323982), GIMT_Encode4(0),
     /* 323885 */ /*GILLT_v2s32*//*Label 6514*/ GIMT_Encode4(324055),
     /* 323889 */ /*GILLT_v2s64*//*Label 6515*/ GIMT_Encode4(324079),
     /* 323893 */ /*GILLT_v4s16*//*Label 6516*/ GIMT_Encode4(324103),
     /* 323897 */ /*GILLT_v4s32*//*Label 6517*/ GIMT_Encode4(324130), GIMT_Encode4(0),
     /* 323905 */ /*GILLT_v8s16*//*Label 6518*/ GIMT_Encode4(324154),
     /* 323909 */ // Label 6512: @323909
     /* 323909 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(323935), // Rule ID 4583 //
     /* 323914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323924 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 323924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 323929 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323933 */   GIR_RootConstrainSelectedInstOperands,
     /* 323934 */   // GIR_Coverage, 4583,
     /* 323934 */   GIR_Done,
     /* 323935 */ // Label 6520: @323935
     /* 323935 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(323958), // Rule ID 4585 //
     /* 323940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323947 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 323947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 323952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323956 */   GIR_RootConstrainSelectedInstOperands,
     /* 323957 */   // GIR_Coverage, 4585,
     /* 323957 */   GIR_Done,
     /* 323958 */ // Label 6521: @323958
     /* 323958 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(323981), // Rule ID 4587 //
     /* 323963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323970 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 323970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 323975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323979 */   GIR_RootConstrainSelectedInstOperands,
     /* 323980 */   // GIR_Coverage, 4587,
     /* 323980 */   GIR_Done,
     /* 323981 */ // Label 6522: @323981
     /* 323981 */ GIM_Reject,
     /* 323982 */ // Label 6513: @323982
     /* 323982 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(324008), // Rule ID 4584 //
     /* 323987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323997 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 323997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 324002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324006 */   GIR_RootConstrainSelectedInstOperands,
     /* 324007 */   // GIR_Coverage, 4584,
     /* 324007 */   GIR_Done,
     /* 324008 */ // Label 6523: @324008
     /* 324008 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(324031), // Rule ID 4586 //
     /* 324013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324020 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 324025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324029 */   GIR_RootConstrainSelectedInstOperands,
     /* 324030 */   // GIR_Coverage, 4586,
     /* 324030 */   GIR_Done,
     /* 324031 */ // Label 6524: @324031
     /* 324031 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(324054), // Rule ID 4588 //
     /* 324036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324043 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 324048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324052 */   GIR_RootConstrainSelectedInstOperands,
     /* 324053 */   // GIR_Coverage, 4588,
     /* 324053 */   GIR_Done,
     /* 324054 */ // Label 6525: @324054
     /* 324054 */ GIM_Reject,
     /* 324055 */ // Label 6514: @324055
     /* 324055 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(324078), // Rule ID 4924 //
     /* 324060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324067 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 324067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 324072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324076 */   GIR_RootConstrainSelectedInstOperands,
     /* 324077 */   // GIR_Coverage, 4924,
     /* 324077 */   GIR_Done,
     /* 324078 */ // Label 6526: @324078
     /* 324078 */ GIM_Reject,
     /* 324079 */ // Label 6515: @324079
     /* 324079 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(324102), // Rule ID 4926 //
     /* 324084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324091 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 324091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 324096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324100 */   GIR_RootConstrainSelectedInstOperands,
     /* 324101 */   // GIR_Coverage, 4926,
     /* 324101 */   GIR_Done,
     /* 324102 */ // Label 6527: @324102
     /* 324102 */ GIM_Reject,
     /* 324103 */ // Label 6516: @324103
     /* 324103 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(324129), // Rule ID 4919 //
     /* 324108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324118 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 324118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 324123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324127 */   GIR_RootConstrainSelectedInstOperands,
     /* 324128 */   // GIR_Coverage, 4919,
     /* 324128 */   GIR_Done,
     /* 324129 */ // Label 6528: @324129
     /* 324129 */ GIM_Reject,
     /* 324130 */ // Label 6517: @324130
     /* 324130 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(324153), // Rule ID 4925 //
     /* 324135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324142 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 324142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 324147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324151 */   GIR_RootConstrainSelectedInstOperands,
     /* 324152 */   // GIR_Coverage, 4925,
     /* 324152 */   GIR_Done,
     /* 324153 */ // Label 6529: @324153
     /* 324153 */ GIM_Reject,
     /* 324154 */ // Label 6518: @324154
     /* 324154 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(324180), // Rule ID 4920 //
     /* 324159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324169 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 324169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 324174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324178 */   GIR_RootConstrainSelectedInstOperands,
     /* 324179 */   // GIR_Coverage, 4920,
     /* 324179 */   GIR_Done,
     /* 324180 */ // Label 6530: @324180
     /* 324180 */ GIM_Reject,
     /* 324181 */ // Label 6519: @324181
     /* 324181 */ GIM_Reject,
     /* 324182 */ // Label 72: @324182
     /* 324182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6538*/ GIMT_Encode4(324501),
     /* 324193 */ /*GILLT_s32*//*Label 6531*/ GIMT_Encode4(324229),
     /* 324197 */ /*GILLT_s64*//*Label 6532*/ GIMT_Encode4(324302), GIMT_Encode4(0),
     /* 324205 */ /*GILLT_v2s32*//*Label 6533*/ GIMT_Encode4(324375),
     /* 324209 */ /*GILLT_v2s64*//*Label 6534*/ GIMT_Encode4(324399),
     /* 324213 */ /*GILLT_v4s16*//*Label 6535*/ GIMT_Encode4(324423),
     /* 324217 */ /*GILLT_v4s32*//*Label 6536*/ GIMT_Encode4(324450), GIMT_Encode4(0),
     /* 324225 */ /*GILLT_v8s16*//*Label 6537*/ GIMT_Encode4(324474),
     /* 324229 */ // Label 6531: @324229
     /* 324229 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(324255), // Rule ID 4607 //
     /* 324234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324244 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 324244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 324249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324253 */   GIR_RootConstrainSelectedInstOperands,
     /* 324254 */   // GIR_Coverage, 4607,
     /* 324254 */   GIR_Done,
     /* 324255 */ // Label 6539: @324255
     /* 324255 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(324278), // Rule ID 4609 //
     /* 324260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324267 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 324267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 324272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324276 */   GIR_RootConstrainSelectedInstOperands,
     /* 324277 */   // GIR_Coverage, 4609,
     /* 324277 */   GIR_Done,
     /* 324278 */ // Label 6540: @324278
     /* 324278 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(324301), // Rule ID 4611 //
     /* 324283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324290 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 324290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 324295 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324299 */   GIR_RootConstrainSelectedInstOperands,
     /* 324300 */   // GIR_Coverage, 4611,
     /* 324300 */   GIR_Done,
     /* 324301 */ // Label 6541: @324301
     /* 324301 */ GIM_Reject,
     /* 324302 */ // Label 6532: @324302
     /* 324302 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(324328), // Rule ID 4608 //
     /* 324307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324317 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 324317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 324322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324326 */   GIR_RootConstrainSelectedInstOperands,
     /* 324327 */   // GIR_Coverage, 4608,
     /* 324327 */   GIR_Done,
     /* 324328 */ // Label 6542: @324328
     /* 324328 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(324351), // Rule ID 4610 //
     /* 324333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324340 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 324345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324349 */   GIR_RootConstrainSelectedInstOperands,
     /* 324350 */   // GIR_Coverage, 4610,
     /* 324350 */   GIR_Done,
     /* 324351 */ // Label 6543: @324351
     /* 324351 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(324374), // Rule ID 4612 //
     /* 324356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324363 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 324368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324372 */   GIR_RootConstrainSelectedInstOperands,
     /* 324373 */   // GIR_Coverage, 4612,
     /* 324373 */   GIR_Done,
     /* 324374 */ // Label 6544: @324374
     /* 324374 */ GIM_Reject,
     /* 324375 */ // Label 6533: @324375
     /* 324375 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(324398), // Rule ID 4934 //
     /* 324380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324387 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 324387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 324392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324396 */   GIR_RootConstrainSelectedInstOperands,
     /* 324397 */   // GIR_Coverage, 4934,
     /* 324397 */   GIR_Done,
     /* 324398 */ // Label 6545: @324398
     /* 324398 */ GIM_Reject,
     /* 324399 */ // Label 6534: @324399
     /* 324399 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(324422), // Rule ID 4936 //
     /* 324404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324411 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 324411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 324416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324420 */   GIR_RootConstrainSelectedInstOperands,
     /* 324421 */   // GIR_Coverage, 4936,
     /* 324421 */   GIR_Done,
     /* 324422 */ // Label 6546: @324422
     /* 324422 */ GIM_Reject,
     /* 324423 */ // Label 6535: @324423
     /* 324423 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(324449), // Rule ID 4929 //
     /* 324428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324438 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 324438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 324443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324447 */   GIR_RootConstrainSelectedInstOperands,
     /* 324448 */   // GIR_Coverage, 4929,
     /* 324448 */   GIR_Done,
     /* 324449 */ // Label 6547: @324449
     /* 324449 */ GIM_Reject,
     /* 324450 */ // Label 6536: @324450
     /* 324450 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(324473), // Rule ID 4935 //
     /* 324455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324462 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 324462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 324467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324471 */   GIR_RootConstrainSelectedInstOperands,
     /* 324472 */   // GIR_Coverage, 4935,
     /* 324472 */   GIR_Done,
     /* 324473 */ // Label 6548: @324473
     /* 324473 */ GIM_Reject,
     /* 324474 */ // Label 6537: @324474
     /* 324474 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(324500), // Rule ID 4930 //
     /* 324479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324489 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 324489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 324494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324498 */   GIR_RootConstrainSelectedInstOperands,
     /* 324499 */   // GIR_Coverage, 4930,
     /* 324499 */   GIR_Done,
     /* 324500 */ // Label 6549: @324500
     /* 324500 */ GIM_Reject,
     /* 324501 */ // Label 6538: @324501
     /* 324501 */ GIM_Reject,
     /* 324502 */ // Label 73: @324502
     /* 324502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6558*/ GIMT_Encode4(325358),
     /* 324513 */ /*GILLT_s16*//*Label 6550*/ GIMT_Encode4(324553),
     /* 324517 */ /*GILLT_s32*//*Label 6551*/ GIMT_Encode4(324772),
     /* 324521 */ /*GILLT_s64*//*Label 6552*/ GIMT_Encode4(324846), GIMT_Encode4(0),
     /* 324529 */ /*GILLT_v2s32*//*Label 6553*/ GIMT_Encode4(324920),
     /* 324533 */ /*GILLT_v2s64*//*Label 6554*/ GIMT_Encode4(324994),
     /* 324537 */ /*GILLT_v4s16*//*Label 6555*/ GIMT_Encode4(325068),
     /* 324541 */ /*GILLT_v4s32*//*Label 6556*/ GIMT_Encode4(325176), GIMT_Encode4(0),
     /* 324549 */ /*GILLT_v8s16*//*Label 6557*/ GIMT_Encode4(325250),
     /* 324553 */ // Label 6550: @324553
     /* 324553 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(324771),
     /* 324558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324565 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(324606), // Rule ID 5208 //
     /* 324570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324591 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 324591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 324594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324604 */     GIR_RootConstrainSelectedInstOperands,
     /* 324605 */     // GIR_Coverage, 5208,
     /* 324605 */     GIR_EraseRootFromParent_Done,
     /* 324606 */   // Label 6560: @324606
     /* 324606 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(324625), // Rule ID 521 //
     /* 324611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324618 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 324618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 324623 */     GIR_RootConstrainSelectedInstOperands,
     /* 324624 */     // GIR_Coverage, 521,
     /* 324624 */     GIR_Done,
     /* 324625 */   // Label 6561: @324625
     /* 324625 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(324770), // Rule ID 6380 //
     /* 324630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324634 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 324634 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 324637 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 324641 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 324648 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 324651 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 324655 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324660 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 324663 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324667 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 324670 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324675 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324680 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 324688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324697 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 324700 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 324708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 324712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324717 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 324720 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 324725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324752 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 324759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324769 */     // GIR_Coverage, 6380,
     /* 324769 */     GIR_EraseRootFromParent_Done,
     /* 324770 */   // Label 6562: @324770
     /* 324770 */   GIM_Reject,
     /* 324771 */ // Label 6559: @324771
     /* 324771 */ GIM_Reject,
     /* 324772 */ // Label 6551: @324772
     /* 324772 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(324845),
     /* 324777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324784 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(324825), // Rule ID 5209 //
     /* 324789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 324808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324810 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 324810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 324813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324823 */     GIR_RootConstrainSelectedInstOperands,
     /* 324824 */     // GIR_Coverage, 5209,
     /* 324824 */     GIR_EraseRootFromParent_Done,
     /* 324825 */   // Label 6564: @324825
     /* 324825 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(324844), // Rule ID 522 //
     /* 324830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324837 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 324837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 324842 */     GIR_RootConstrainSelectedInstOperands,
     /* 324843 */     // GIR_Coverage, 522,
     /* 324843 */     GIR_Done,
     /* 324844 */   // Label 6565: @324844
     /* 324844 */   GIM_Reject,
     /* 324845 */ // Label 6563: @324845
     /* 324845 */ GIM_Reject,
     /* 324846 */ // Label 6552: @324846
     /* 324846 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(324919),
     /* 324851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324858 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(324899), // Rule ID 5210 //
     /* 324863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 324878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324884 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 324884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 324887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324897 */     GIR_RootConstrainSelectedInstOperands,
     /* 324898 */     // GIR_Coverage, 5210,
     /* 324898 */     GIR_EraseRootFromParent_Done,
     /* 324899 */   // Label 6567: @324899
     /* 324899 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(324918), // Rule ID 523 //
     /* 324904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324911 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 324911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 324916 */     GIR_RootConstrainSelectedInstOperands,
     /* 324917 */     // GIR_Coverage, 523,
     /* 324917 */     GIR_Done,
     /* 324918 */   // Label 6568: @324918
     /* 324918 */   GIM_Reject,
     /* 324919 */ // Label 6566: @324919
     /* 324919 */ GIM_Reject,
     /* 324920 */ // Label 6553: @324920
     /* 324920 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(324993),
     /* 324925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324932 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(324973), // Rule ID 5001 //
     /* 324937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324958 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 324958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 324961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324971 */     GIR_RootConstrainSelectedInstOperands,
     /* 324972 */     // GIR_Coverage, 5001,
     /* 324972 */     GIR_EraseRootFromParent_Done,
     /* 324973 */   // Label 6570: @324973
     /* 324973 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(324992), // Rule ID 768 //
     /* 324978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324985 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 324985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 324990 */     GIR_RootConstrainSelectedInstOperands,
     /* 324991 */     // GIR_Coverage, 768,
     /* 324991 */     GIR_Done,
     /* 324992 */   // Label 6571: @324992
     /* 324992 */   GIM_Reject,
     /* 324993 */ // Label 6569: @324993
     /* 324993 */ GIM_Reject,
     /* 324994 */ // Label 6554: @324994
     /* 324994 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(325067),
     /* 324999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325006 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(325047), // Rule ID 5003 //
     /* 325011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325032 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 325032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 325035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325045 */     GIR_RootConstrainSelectedInstOperands,
     /* 325046 */     // GIR_Coverage, 5003,
     /* 325046 */     GIR_EraseRootFromParent_Done,
     /* 325047 */   // Label 6573: @325047
     /* 325047 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(325066), // Rule ID 770 //
     /* 325052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325059 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 325059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 325064 */     GIR_RootConstrainSelectedInstOperands,
     /* 325065 */     // GIR_Coverage, 770,
     /* 325065 */     GIR_Done,
     /* 325066 */   // Label 6574: @325066
     /* 325066 */   GIM_Reject,
     /* 325067 */ // Label 6572: @325067
     /* 325067 */ GIM_Reject,
     /* 325068 */ // Label 6555: @325068
     /* 325068 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(325175),
     /* 325073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325080 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(325121), // Rule ID 5004 //
     /* 325085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325106 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 325106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 325109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325119 */     GIR_RootConstrainSelectedInstOperands,
     /* 325120 */     // GIR_Coverage, 5004,
     /* 325120 */     GIR_EraseRootFromParent_Done,
     /* 325121 */   // Label 6576: @325121
     /* 325121 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(325140), // Rule ID 766 //
     /* 325126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325133 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 325133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 325138 */     GIR_RootConstrainSelectedInstOperands,
     /* 325139 */     // GIR_Coverage, 766,
     /* 325139 */     GIR_Done,
     /* 325140 */   // Label 6577: @325140
     /* 325140 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(325174), // Rule ID 6382 //
     /* 325145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325152 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 325152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 325155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325159 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 325169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 325172 */     GIR_RootConstrainSelectedInstOperands,
     /* 325173 */     // GIR_Coverage, 6382,
     /* 325173 */     GIR_EraseRootFromParent_Done,
     /* 325174 */   // Label 6578: @325174
     /* 325174 */   GIM_Reject,
     /* 325175 */ // Label 6575: @325175
     /* 325175 */ GIM_Reject,
     /* 325176 */ // Label 6556: @325176
     /* 325176 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(325249),
     /* 325181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325188 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(325229), // Rule ID 5002 //
     /* 325193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325214 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 325214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 325217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325227 */     GIR_RootConstrainSelectedInstOperands,
     /* 325228 */     // GIR_Coverage, 5002,
     /* 325228 */     GIR_EraseRootFromParent_Done,
     /* 325229 */   // Label 6580: @325229
     /* 325229 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(325248), // Rule ID 769 //
     /* 325234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325241 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 325241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 325246 */     GIR_RootConstrainSelectedInstOperands,
     /* 325247 */     // GIR_Coverage, 769,
     /* 325247 */     GIR_Done,
     /* 325248 */   // Label 6581: @325248
     /* 325248 */   GIM_Reject,
     /* 325249 */ // Label 6579: @325249
     /* 325249 */ GIM_Reject,
     /* 325250 */ // Label 6557: @325250
     /* 325250 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(325357),
     /* 325255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325262 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(325303), // Rule ID 5005 //
     /* 325267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325288 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 325288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 325291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325301 */     GIR_RootConstrainSelectedInstOperands,
     /* 325302 */     // GIR_Coverage, 5005,
     /* 325302 */     GIR_EraseRootFromParent_Done,
     /* 325303 */   // Label 6583: @325303
     /* 325303 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(325322), // Rule ID 767 //
     /* 325308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325315 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 325315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 325320 */     GIR_RootConstrainSelectedInstOperands,
     /* 325321 */     // GIR_Coverage, 767,
     /* 325321 */     GIR_Done,
     /* 325322 */   // Label 6584: @325322
     /* 325322 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(325356), // Rule ID 6383 //
     /* 325327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325334 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 325334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 325337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325341 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 325351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 325354 */     GIR_RootConstrainSelectedInstOperands,
     /* 325355 */     // GIR_Coverage, 6383,
     /* 325355 */     GIR_EraseRootFromParent_Done,
     /* 325356 */   // Label 6585: @325356
     /* 325356 */   GIM_Reject,
     /* 325357 */ // Label 6582: @325357
     /* 325357 */ GIM_Reject,
     /* 325358 */ // Label 6558: @325358
     /* 325358 */ GIM_Reject,
     /* 325359 */ // Label 74: @325359
     /* 325359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6594*/ GIMT_Encode4(325640),
     /* 325370 */ /*GILLT_s16*//*Label 6586*/ GIMT_Encode4(325410),
     /* 325374 */ /*GILLT_s32*//*Label 6587*/ GIMT_Encode4(325437),
     /* 325378 */ /*GILLT_s64*//*Label 6588*/ GIMT_Encode4(325461), GIMT_Encode4(0),
     /* 325386 */ /*GILLT_v2s32*//*Label 6589*/ GIMT_Encode4(325485),
     /* 325390 */ /*GILLT_v2s64*//*Label 6590*/ GIMT_Encode4(325516),
     /* 325394 */ /*GILLT_v4s16*//*Label 6591*/ GIMT_Encode4(325547),
     /* 325398 */ /*GILLT_v4s32*//*Label 6592*/ GIMT_Encode4(325578), GIMT_Encode4(0),
     /* 325406 */ /*GILLT_v8s16*//*Label 6593*/ GIMT_Encode4(325609),
     /* 325410 */ // Label 6586: @325410
     /* 325410 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(325436), // Rule ID 4823 //
     /* 325415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325425 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 325425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 325428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325430 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325432 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325434 */   GIR_RootConstrainSelectedInstOperands,
     /* 325435 */   // GIR_Coverage, 4823,
     /* 325435 */   GIR_EraseRootFromParent_Done,
     /* 325436 */ // Label 6595: @325436
     /* 325436 */ GIM_Reject,
     /* 325437 */ // Label 6587: @325437
     /* 325437 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(325460), // Rule ID 4820 //
     /* 325442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325449 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 325449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 325452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325454 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325456 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325458 */   GIR_RootConstrainSelectedInstOperands,
     /* 325459 */   // GIR_Coverage, 4820,
     /* 325459 */   GIR_EraseRootFromParent_Done,
     /* 325460 */ // Label 6596: @325460
     /* 325460 */ GIM_Reject,
     /* 325461 */ // Label 6588: @325461
     /* 325461 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(325484), // Rule ID 4817 //
     /* 325466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325473 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 325473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325478 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325480 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325482 */   GIR_RootConstrainSelectedInstOperands,
     /* 325483 */   // GIR_Coverage, 4817,
     /* 325483 */   GIR_EraseRootFromParent_Done,
     /* 325484 */ // Label 6597: @325484
     /* 325484 */ GIM_Reject,
     /* 325485 */ // Label 6589: @325485
     /* 325485 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(325515), // Rule ID 5014 //
     /* 325490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325504 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 325504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 325507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325509 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325511 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325513 */   GIR_RootConstrainSelectedInstOperands,
     /* 325514 */   // GIR_Coverage, 5014,
     /* 325514 */   GIR_EraseRootFromParent_Done,
     /* 325515 */ // Label 6598: @325515
     /* 325515 */ GIM_Reject,
     /* 325516 */ // Label 6590: @325516
     /* 325516 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(325546), // Rule ID 5008 //
     /* 325521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325535 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 325535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 325538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325540 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325542 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325544 */   GIR_RootConstrainSelectedInstOperands,
     /* 325545 */   // GIR_Coverage, 5008,
     /* 325545 */   GIR_EraseRootFromParent_Done,
     /* 325546 */ // Label 6599: @325546
     /* 325546 */ GIM_Reject,
     /* 325547 */ // Label 6591: @325547
     /* 325547 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(325577), // Rule ID 5020 //
     /* 325552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325566 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 325566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 325569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325571 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325573 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325575 */   GIR_RootConstrainSelectedInstOperands,
     /* 325576 */   // GIR_Coverage, 5020,
     /* 325576 */   GIR_EraseRootFromParent_Done,
     /* 325577 */ // Label 6600: @325577
     /* 325577 */ GIM_Reject,
     /* 325578 */ // Label 6592: @325578
     /* 325578 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(325608), // Rule ID 5011 //
     /* 325583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325597 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 325597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 325600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325602 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325604 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325606 */   GIR_RootConstrainSelectedInstOperands,
     /* 325607 */   // GIR_Coverage, 5011,
     /* 325607 */   GIR_EraseRootFromParent_Done,
     /* 325608 */ // Label 6601: @325608
     /* 325608 */ GIM_Reject,
     /* 325609 */ // Label 6593: @325609
     /* 325609 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(325639), // Rule ID 5017 //
     /* 325614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325628 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 325628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 325631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325637 */   GIR_RootConstrainSelectedInstOperands,
     /* 325638 */   // GIR_Coverage, 5017,
     /* 325638 */   GIR_EraseRootFromParent_Done,
     /* 325639 */ // Label 6602: @325639
     /* 325639 */ GIM_Reject,
     /* 325640 */ // Label 6594: @325640
     /* 325640 */ GIM_Reject,
     /* 325641 */ // Label 75: @325641
     /* 325641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6611*/ GIMT_Encode4(326018),
     /* 325652 */ /*GILLT_s16*//*Label 6603*/ GIMT_Encode4(325692),
     /* 325656 */ /*GILLT_s32*//*Label 6604*/ GIMT_Encode4(325730),
     /* 325660 */ /*GILLT_s64*//*Label 6605*/ GIMT_Encode4(325768), GIMT_Encode4(0),
     /* 325668 */ /*GILLT_v2s32*//*Label 6606*/ GIMT_Encode4(325828),
     /* 325672 */ /*GILLT_v2s64*//*Label 6607*/ GIMT_Encode4(325866),
     /* 325676 */ /*GILLT_v4s16*//*Label 6608*/ GIMT_Encode4(325904),
     /* 325680 */ /*GILLT_v4s32*//*Label 6609*/ GIMT_Encode4(325942), GIMT_Encode4(0),
     /* 325688 */ /*GILLT_v8s16*//*Label 6610*/ GIMT_Encode4(325980),
     /* 325692 */ // Label 6603: @325692
     /* 325692 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(325729), // Rule ID 608 //
     /* 325697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325718 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 325723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325727 */   GIR_RootConstrainSelectedInstOperands,
     /* 325728 */   // GIR_Coverage, 608,
     /* 325728 */   GIR_Done,
     /* 325729 */ // Label 6612: @325729
     /* 325729 */ GIM_Reject,
     /* 325730 */ // Label 6604: @325730
     /* 325730 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(325767), // Rule ID 610 //
     /* 325735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325756 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 325761 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325765 */   GIR_RootConstrainSelectedInstOperands,
     /* 325766 */   // GIR_Coverage, 610,
     /* 325766 */   GIR_Done,
     /* 325767 */ // Label 6613: @325767
     /* 325767 */ GIM_Reject,
     /* 325768 */ // Label 6605: @325768
     /* 325768 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(325827),
     /* 325773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325791 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(325810), // Rule ID 612 //
     /* 325796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325799 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325804 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325808 */     GIR_RootConstrainSelectedInstOperands,
     /* 325809 */     // GIR_Coverage, 612,
     /* 325809 */     GIR_Done,
     /* 325810 */   // Label 6615: @325810
     /* 325810 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(325826), // Rule ID 4814 //
     /* 325815 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 325815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325820 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325824 */     GIR_RootConstrainSelectedInstOperands,
     /* 325825 */     // GIR_Coverage, 4814,
     /* 325825 */     GIR_Done,
     /* 325826 */   // Label 6616: @325826
     /* 325826 */   GIM_Reject,
     /* 325827 */ // Label 6614: @325827
     /* 325827 */ GIM_Reject,
     /* 325828 */ // Label 6606: @325828
     /* 325828 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(325865), // Rule ID 1273 //
     /* 325833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325854 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 325859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325863 */   GIR_RootConstrainSelectedInstOperands,
     /* 325864 */   // GIR_Coverage, 1273,
     /* 325864 */   GIR_Done,
     /* 325865 */ // Label 6617: @325865
     /* 325865 */ GIM_Reject,
     /* 325866 */ // Label 6607: @325866
     /* 325866 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(325903), // Rule ID 1277 //
     /* 325871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325892 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 325897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325901 */   GIR_RootConstrainSelectedInstOperands,
     /* 325902 */   // GIR_Coverage, 1277,
     /* 325902 */   GIR_Done,
     /* 325903 */ // Label 6618: @325903
     /* 325903 */ GIM_Reject,
     /* 325904 */ // Label 6608: @325904
     /* 325904 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(325941), // Rule ID 1269 //
     /* 325909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325930 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 325935 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325939 */   GIR_RootConstrainSelectedInstOperands,
     /* 325940 */   // GIR_Coverage, 1269,
     /* 325940 */   GIR_Done,
     /* 325941 */ // Label 6619: @325941
     /* 325941 */ GIM_Reject,
     /* 325942 */ // Label 6609: @325942
     /* 325942 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(325979), // Rule ID 1275 //
     /* 325947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325968 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 325973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325977 */   GIR_RootConstrainSelectedInstOperands,
     /* 325978 */   // GIR_Coverage, 1275,
     /* 325978 */   GIR_Done,
     /* 325979 */ // Label 6620: @325979
     /* 325979 */ GIM_Reject,
     /* 325980 */ // Label 6610: @325980
     /* 325980 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(326017), // Rule ID 1271 //
     /* 325985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326006 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 326011 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326015 */   GIR_RootConstrainSelectedInstOperands,
     /* 326016 */   // GIR_Coverage, 1271,
     /* 326016 */   GIR_Done,
     /* 326017 */ // Label 6621: @326017
     /* 326017 */ GIM_Reject,
     /* 326018 */ // Label 6611: @326018
     /* 326018 */ GIM_Reject,
     /* 326019 */ // Label 76: @326019
     /* 326019 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6630*/ GIMT_Encode4(326396),
     /* 326030 */ /*GILLT_s16*//*Label 6622*/ GIMT_Encode4(326070),
     /* 326034 */ /*GILLT_s32*//*Label 6623*/ GIMT_Encode4(326108),
     /* 326038 */ /*GILLT_s64*//*Label 6624*/ GIMT_Encode4(326146), GIMT_Encode4(0),
     /* 326046 */ /*GILLT_v2s32*//*Label 6625*/ GIMT_Encode4(326206),
     /* 326050 */ /*GILLT_v2s64*//*Label 6626*/ GIMT_Encode4(326244),
     /* 326054 */ /*GILLT_v4s16*//*Label 6627*/ GIMT_Encode4(326282),
     /* 326058 */ /*GILLT_v4s32*//*Label 6628*/ GIMT_Encode4(326320), GIMT_Encode4(0),
     /* 326066 */ /*GILLT_v8s16*//*Label 6629*/ GIMT_Encode4(326358),
     /* 326070 */ // Label 6622: @326070
     /* 326070 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(326107), // Rule ID 596 //
     /* 326075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326096 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 326101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326105 */   GIR_RootConstrainSelectedInstOperands,
     /* 326106 */   // GIR_Coverage, 596,
     /* 326106 */   GIR_Done,
     /* 326107 */ // Label 6631: @326107
     /* 326107 */ GIM_Reject,
     /* 326108 */ // Label 6623: @326108
     /* 326108 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(326145), // Rule ID 598 //
     /* 326113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326134 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 326139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326143 */   GIR_RootConstrainSelectedInstOperands,
     /* 326144 */   // GIR_Coverage, 598,
     /* 326144 */   GIR_Done,
     /* 326145 */ // Label 6632: @326145
     /* 326145 */ GIM_Reject,
     /* 326146 */ // Label 6624: @326146
     /* 326146 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(326205),
     /* 326151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326169 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(326188), // Rule ID 600 //
     /* 326174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326177 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326186 */     GIR_RootConstrainSelectedInstOperands,
     /* 326187 */     // GIR_Coverage, 600,
     /* 326187 */     GIR_Done,
     /* 326188 */   // Label 6634: @326188
     /* 326188 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(326204), // Rule ID 4813 //
     /* 326193 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 326193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326198 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326202 */     GIR_RootConstrainSelectedInstOperands,
     /* 326203 */     // GIR_Coverage, 4813,
     /* 326203 */     GIR_Done,
     /* 326204 */   // Label 6635: @326204
     /* 326204 */   GIM_Reject,
     /* 326205 */ // Label 6633: @326205
     /* 326205 */ GIM_Reject,
     /* 326206 */ // Label 6625: @326206
     /* 326206 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(326243), // Rule ID 1243 //
     /* 326211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326232 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 326237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326241 */   GIR_RootConstrainSelectedInstOperands,
     /* 326242 */   // GIR_Coverage, 1243,
     /* 326242 */   GIR_Done,
     /* 326243 */ // Label 6636: @326243
     /* 326243 */ GIM_Reject,
     /* 326244 */ // Label 6626: @326244
     /* 326244 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(326281), // Rule ID 1247 //
     /* 326249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326270 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 326275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326279 */   GIR_RootConstrainSelectedInstOperands,
     /* 326280 */   // GIR_Coverage, 1247,
     /* 326280 */   GIR_Done,
     /* 326281 */ // Label 6637: @326281
     /* 326281 */ GIM_Reject,
     /* 326282 */ // Label 6627: @326282
     /* 326282 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(326319), // Rule ID 1239 //
     /* 326287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326308 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 326313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326317 */   GIR_RootConstrainSelectedInstOperands,
     /* 326318 */   // GIR_Coverage, 1239,
     /* 326318 */   GIR_Done,
     /* 326319 */ // Label 6638: @326319
     /* 326319 */ GIM_Reject,
     /* 326320 */ // Label 6628: @326320
     /* 326320 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(326357), // Rule ID 1245 //
     /* 326325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326346 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 326351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326355 */   GIR_RootConstrainSelectedInstOperands,
     /* 326356 */   // GIR_Coverage, 1245,
     /* 326356 */   GIR_Done,
     /* 326357 */ // Label 6639: @326357
     /* 326357 */ GIM_Reject,
     /* 326358 */ // Label 6629: @326358
     /* 326358 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(326395), // Rule ID 1241 //
     /* 326363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326384 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 326389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326393 */   GIR_RootConstrainSelectedInstOperands,
     /* 326394 */   // GIR_Coverage, 1241,
     /* 326394 */   GIR_Done,
     /* 326395 */ // Label 6640: @326395
     /* 326395 */ GIM_Reject,
     /* 326396 */ // Label 6630: @326396
     /* 326396 */ GIM_Reject,
     /* 326397 */ // Label 77: @326397
     /* 326397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6649*/ GIMT_Encode4(326746),
     /* 326408 */ /*GILLT_s16*//*Label 6641*/ GIMT_Encode4(326448),
     /* 326412 */ /*GILLT_s32*//*Label 6642*/ GIMT_Encode4(326486),
     /* 326416 */ /*GILLT_s64*//*Label 6643*/ GIMT_Encode4(326521), GIMT_Encode4(0),
     /* 326424 */ /*GILLT_v2s32*//*Label 6644*/ GIMT_Encode4(326556),
     /* 326428 */ /*GILLT_v2s64*//*Label 6645*/ GIMT_Encode4(326594),
     /* 326432 */ /*GILLT_v4s16*//*Label 6646*/ GIMT_Encode4(326632),
     /* 326436 */ /*GILLT_v4s32*//*Label 6647*/ GIMT_Encode4(326670), GIMT_Encode4(0),
     /* 326444 */ /*GILLT_v8s16*//*Label 6648*/ GIMT_Encode4(326708),
     /* 326448 */ // Label 6641: @326448
     /* 326448 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(326485), // Rule ID 4821 //
     /* 326453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326474 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 326474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 326479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326483 */   GIR_RootConstrainSelectedInstOperands,
     /* 326484 */   // GIR_Coverage, 4821,
     /* 326484 */   GIR_Done,
     /* 326485 */ // Label 6650: @326485
     /* 326485 */ GIM_Reject,
     /* 326486 */ // Label 6642: @326486
     /* 326486 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(326520), // Rule ID 4818 //
     /* 326491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326509 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 326509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 326514 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326518 */   GIR_RootConstrainSelectedInstOperands,
     /* 326519 */   // GIR_Coverage, 4818,
     /* 326519 */   GIR_Done,
     /* 326520 */ // Label 6651: @326520
     /* 326520 */ GIM_Reject,
     /* 326521 */ // Label 6643: @326521
     /* 326521 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(326555), // Rule ID 4815 //
     /* 326526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326544 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 326544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 326549 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326553 */   GIR_RootConstrainSelectedInstOperands,
     /* 326554 */   // GIR_Coverage, 4815,
     /* 326554 */   GIR_Done,
     /* 326555 */ // Label 6652: @326555
     /* 326555 */ GIM_Reject,
     /* 326556 */ // Label 6644: @326556
     /* 326556 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(326593), // Rule ID 5012 //
     /* 326561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326582 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 326587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326591 */   GIR_RootConstrainSelectedInstOperands,
     /* 326592 */   // GIR_Coverage, 5012,
     /* 326592 */   GIR_Done,
     /* 326593 */ // Label 6653: @326593
     /* 326593 */ GIM_Reject,
     /* 326594 */ // Label 6645: @326594
     /* 326594 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(326631), // Rule ID 5006 //
     /* 326599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326620 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 326625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326629 */   GIR_RootConstrainSelectedInstOperands,
     /* 326630 */   // GIR_Coverage, 5006,
     /* 326630 */   GIR_Done,
     /* 326631 */ // Label 6654: @326631
     /* 326631 */ GIM_Reject,
     /* 326632 */ // Label 6646: @326632
     /* 326632 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(326669), // Rule ID 5018 //
     /* 326637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326658 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 326663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326667 */   GIR_RootConstrainSelectedInstOperands,
     /* 326668 */   // GIR_Coverage, 5018,
     /* 326668 */   GIR_Done,
     /* 326669 */ // Label 6655: @326669
     /* 326669 */ GIM_Reject,
     /* 326670 */ // Label 6647: @326670
     /* 326670 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(326707), // Rule ID 5009 //
     /* 326675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326696 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 326701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326705 */   GIR_RootConstrainSelectedInstOperands,
     /* 326706 */   // GIR_Coverage, 5009,
     /* 326706 */   GIR_Done,
     /* 326707 */ // Label 6656: @326707
     /* 326707 */ GIM_Reject,
     /* 326708 */ // Label 6648: @326708
     /* 326708 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(326745), // Rule ID 5015 //
     /* 326713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326734 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 326739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326743 */   GIR_RootConstrainSelectedInstOperands,
     /* 326744 */   // GIR_Coverage, 5015,
     /* 326744 */   GIR_Done,
     /* 326745 */ // Label 6657: @326745
     /* 326745 */ GIM_Reject,
     /* 326746 */ // Label 6649: @326746
     /* 326746 */ GIM_Reject,
     /* 326747 */ // Label 78: @326747
     /* 326747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6666*/ GIMT_Encode4(327096),
     /* 326758 */ /*GILLT_s16*//*Label 6658*/ GIMT_Encode4(326798),
     /* 326762 */ /*GILLT_s32*//*Label 6659*/ GIMT_Encode4(326836),
     /* 326766 */ /*GILLT_s64*//*Label 6660*/ GIMT_Encode4(326871), GIMT_Encode4(0),
     /* 326774 */ /*GILLT_v2s32*//*Label 6661*/ GIMT_Encode4(326906),
     /* 326778 */ /*GILLT_v2s64*//*Label 6662*/ GIMT_Encode4(326944),
     /* 326782 */ /*GILLT_v4s16*//*Label 6663*/ GIMT_Encode4(326982),
     /* 326786 */ /*GILLT_v4s32*//*Label 6664*/ GIMT_Encode4(327020), GIMT_Encode4(0),
     /* 326794 */ /*GILLT_v8s16*//*Label 6665*/ GIMT_Encode4(327058),
     /* 326798 */ // Label 6658: @326798
     /* 326798 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(326835), // Rule ID 4822 //
     /* 326803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326824 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 326824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 326829 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326833 */   GIR_RootConstrainSelectedInstOperands,
     /* 326834 */   // GIR_Coverage, 4822,
     /* 326834 */   GIR_Done,
     /* 326835 */ // Label 6667: @326835
     /* 326835 */ GIM_Reject,
     /* 326836 */ // Label 6659: @326836
     /* 326836 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(326870), // Rule ID 4819 //
     /* 326841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326859 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 326859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 326864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326868 */   GIR_RootConstrainSelectedInstOperands,
     /* 326869 */   // GIR_Coverage, 4819,
     /* 326869 */   GIR_Done,
     /* 326870 */ // Label 6668: @326870
     /* 326870 */ GIM_Reject,
     /* 326871 */ // Label 6660: @326871
     /* 326871 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(326905), // Rule ID 4816 //
     /* 326876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326894 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 326894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326899 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326903 */   GIR_RootConstrainSelectedInstOperands,
     /* 326904 */   // GIR_Coverage, 4816,
     /* 326904 */   GIR_Done,
     /* 326905 */ // Label 6669: @326905
     /* 326905 */ GIM_Reject,
     /* 326906 */ // Label 6661: @326906
     /* 326906 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(326943), // Rule ID 5013 //
     /* 326911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326932 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 326937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326941 */   GIR_RootConstrainSelectedInstOperands,
     /* 326942 */   // GIR_Coverage, 5013,
     /* 326942 */   GIR_Done,
     /* 326943 */ // Label 6670: @326943
     /* 326943 */ GIM_Reject,
     /* 326944 */ // Label 6662: @326944
     /* 326944 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(326981), // Rule ID 5007 //
     /* 326949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326970 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 326975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326979 */   GIR_RootConstrainSelectedInstOperands,
     /* 326980 */   // GIR_Coverage, 5007,
     /* 326980 */   GIR_Done,
     /* 326981 */ // Label 6671: @326981
     /* 326981 */ GIM_Reject,
     /* 326982 */ // Label 6663: @326982
     /* 326982 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(327019), // Rule ID 5019 //
     /* 326987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327008 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 327013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327017 */   GIR_RootConstrainSelectedInstOperands,
     /* 327018 */   // GIR_Coverage, 5019,
     /* 327018 */   GIR_Done,
     /* 327019 */ // Label 6672: @327019
     /* 327019 */ GIM_Reject,
     /* 327020 */ // Label 6664: @327020
     /* 327020 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(327057), // Rule ID 5010 //
     /* 327025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327046 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 327051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327055 */   GIR_RootConstrainSelectedInstOperands,
     /* 327056 */   // GIR_Coverage, 5010,
     /* 327056 */   GIR_Done,
     /* 327057 */ // Label 6673: @327057
     /* 327057 */ GIM_Reject,
     /* 327058 */ // Label 6665: @327058
     /* 327058 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(327095), // Rule ID 5016 //
     /* 327063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327084 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 327089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327093 */   GIR_RootConstrainSelectedInstOperands,
     /* 327094 */   // GIR_Coverage, 5016,
     /* 327094 */   GIR_Done,
     /* 327095 */ // Label 6674: @327095
     /* 327095 */ GIM_Reject,
     /* 327096 */ // Label 6666: @327096
     /* 327096 */ GIM_Reject,
     /* 327097 */ // Label 79: @327097
     /* 327097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6683*/ GIMT_Encode4(327799),
     /* 327108 */ /*GILLT_s16*//*Label 6675*/ GIMT_Encode4(327148),
     /* 327112 */ /*GILLT_s32*//*Label 6676*/ GIMT_Encode4(327186),
     /* 327116 */ /*GILLT_s64*//*Label 6677*/ GIMT_Encode4(327224), GIMT_Encode4(0),
     /* 327124 */ /*GILLT_v2s32*//*Label 6678*/ GIMT_Encode4(327284),
     /* 327128 */ /*GILLT_v2s64*//*Label 6679*/ GIMT_Encode4(327387),
     /* 327132 */ /*GILLT_v4s16*//*Label 6680*/ GIMT_Encode4(327490),
     /* 327136 */ /*GILLT_v4s32*//*Label 6681*/ GIMT_Encode4(327593), GIMT_Encode4(0),
     /* 327144 */ /*GILLT_v8s16*//*Label 6682*/ GIMT_Encode4(327696),
     /* 327148 */ // Label 6675: @327148
     /* 327148 */ GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(327185), // Rule ID 614 //
     /* 327153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 327162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327174 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 327179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327183 */   GIR_RootConstrainSelectedInstOperands,
     /* 327184 */   // GIR_Coverage, 614,
     /* 327184 */   GIR_Done,
     /* 327185 */ // Label 6684: @327185
     /* 327185 */ GIM_Reject,
     /* 327186 */ // Label 6676: @327186
     /* 327186 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(327223), // Rule ID 616 //
     /* 327191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327212 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 327217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327221 */   GIR_RootConstrainSelectedInstOperands,
     /* 327222 */   // GIR_Coverage, 616,
     /* 327222 */   GIR_Done,
     /* 327223 */ // Label 6685: @327223
     /* 327223 */ GIM_Reject,
     /* 327224 */ // Label 6677: @327224
     /* 327224 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(327283),
     /* 327229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327247 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(327266), // Rule ID 618 //
     /* 327252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327255 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 327255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 327260 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327264 */     GIR_RootConstrainSelectedInstOperands,
     /* 327265 */     // GIR_Coverage, 618,
     /* 327265 */     GIR_Done,
     /* 327266 */   // Label 6687: @327266
     /* 327266 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(327282), // Rule ID 4812 //
     /* 327271 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 327271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 327276 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327280 */     GIR_RootConstrainSelectedInstOperands,
     /* 327281 */     // GIR_Coverage, 4812,
     /* 327281 */     GIR_Done,
     /* 327282 */   // Label 6688: @327282
     /* 327282 */   GIM_Reject,
     /* 327283 */ // Label 6686: @327283
     /* 327283 */ GIM_Reject,
     /* 327284 */ // Label 6678: @327284
     /* 327284 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(327386),
     /* 327289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327299 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(327358), // Rule ID 2366 //
     /* 327304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327343 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 327343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 327346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327356 */     GIR_RootConstrainSelectedInstOperands,
     /* 327357 */     // GIR_Coverage, 2366,
     /* 327357 */     GIR_EraseRootFromParent_Done,
     /* 327358 */   // Label 6690: @327358
     /* 327358 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(327385), // Rule ID 1288 //
     /* 327363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327374 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 327374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 327379 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327383 */     GIR_RootConstrainSelectedInstOperands,
     /* 327384 */     // GIR_Coverage, 1288,
     /* 327384 */     GIR_Done,
     /* 327385 */   // Label 6691: @327385
     /* 327385 */   GIM_Reject,
     /* 327386 */ // Label 6689: @327386
     /* 327386 */ GIM_Reject,
     /* 327387 */ // Label 6679: @327387
     /* 327387 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(327489),
     /* 327392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327402 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(327461), // Rule ID 2372 //
     /* 327407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327446 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 327446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 327449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327459 */     GIR_RootConstrainSelectedInstOperands,
     /* 327460 */     // GIR_Coverage, 2372,
     /* 327460 */     GIR_EraseRootFromParent_Done,
     /* 327461 */   // Label 6693: @327461
     /* 327461 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(327488), // Rule ID 1292 //
     /* 327466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327477 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 327477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 327482 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327486 */     GIR_RootConstrainSelectedInstOperands,
     /* 327487 */     // GIR_Coverage, 1292,
     /* 327487 */     GIR_Done,
     /* 327488 */   // Label 6694: @327488
     /* 327488 */   GIM_Reject,
     /* 327489 */ // Label 6692: @327489
     /* 327489 */ GIM_Reject,
     /* 327490 */ // Label 6680: @327490
     /* 327490 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(327592),
     /* 327495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327505 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(327564), // Rule ID 2360 //
     /* 327510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327549 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 327552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327562 */     GIR_RootConstrainSelectedInstOperands,
     /* 327563 */     // GIR_Coverage, 2360,
     /* 327563 */     GIR_EraseRootFromParent_Done,
     /* 327564 */   // Label 6696: @327564
     /* 327564 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(327591), // Rule ID 1284 //
     /* 327569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327580 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 327585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327589 */     GIR_RootConstrainSelectedInstOperands,
     /* 327590 */     // GIR_Coverage, 1284,
     /* 327590 */     GIR_Done,
     /* 327591 */   // Label 6697: @327591
     /* 327591 */   GIM_Reject,
     /* 327592 */ // Label 6695: @327592
     /* 327592 */ GIM_Reject,
     /* 327593 */ // Label 6681: @327593
     /* 327593 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(327695),
     /* 327598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327608 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(327667), // Rule ID 2369 //
     /* 327613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327652 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 327655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327665 */     GIR_RootConstrainSelectedInstOperands,
     /* 327666 */     // GIR_Coverage, 2369,
     /* 327666 */     GIR_EraseRootFromParent_Done,
     /* 327667 */   // Label 6699: @327667
     /* 327667 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(327694), // Rule ID 1290 //
     /* 327672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327683 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 327688 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327692 */     GIR_RootConstrainSelectedInstOperands,
     /* 327693 */     // GIR_Coverage, 1290,
     /* 327693 */     GIR_Done,
     /* 327694 */   // Label 6700: @327694
     /* 327694 */   GIM_Reject,
     /* 327695 */ // Label 6698: @327695
     /* 327695 */ GIM_Reject,
     /* 327696 */ // Label 6682: @327696
     /* 327696 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(327798),
     /* 327701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327711 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(327770), // Rule ID 2363 //
     /* 327716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327755 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 327758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327768 */     GIR_RootConstrainSelectedInstOperands,
     /* 327769 */     // GIR_Coverage, 2363,
     /* 327769 */     GIR_EraseRootFromParent_Done,
     /* 327770 */   // Label 6702: @327770
     /* 327770 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(327797), // Rule ID 1286 //
     /* 327775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327786 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 327791 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327795 */     GIR_RootConstrainSelectedInstOperands,
     /* 327796 */     // GIR_Coverage, 1286,
     /* 327796 */     GIR_Done,
     /* 327797 */   // Label 6703: @327797
     /* 327797 */   GIM_Reject,
     /* 327798 */ // Label 6701: @327798
     /* 327798 */ GIM_Reject,
     /* 327799 */ // Label 6683: @327799
     /* 327799 */ GIM_Reject,
     /* 327800 */ // Label 80: @327800
     /* 327800 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6712*/ GIMT_Encode4(328502),
     /* 327811 */ /*GILLT_s16*//*Label 6704*/ GIMT_Encode4(327851),
     /* 327815 */ /*GILLT_s32*//*Label 6705*/ GIMT_Encode4(327889),
     /* 327819 */ /*GILLT_s64*//*Label 6706*/ GIMT_Encode4(327927), GIMT_Encode4(0),
     /* 327827 */ /*GILLT_v2s32*//*Label 6707*/ GIMT_Encode4(327987),
     /* 327831 */ /*GILLT_v2s64*//*Label 6708*/ GIMT_Encode4(328090),
     /* 327835 */ /*GILLT_v4s16*//*Label 6709*/ GIMT_Encode4(328193),
     /* 327839 */ /*GILLT_v4s32*//*Label 6710*/ GIMT_Encode4(328296), GIMT_Encode4(0),
     /* 327847 */ /*GILLT_v8s16*//*Label 6711*/ GIMT_Encode4(328399),
     /* 327851 */ // Label 6704: @327851
     /* 327851 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(327888), // Rule ID 602 //
     /* 327856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 327865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327877 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 327882 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327886 */   GIR_RootConstrainSelectedInstOperands,
     /* 327887 */   // GIR_Coverage, 602,
     /* 327887 */   GIR_Done,
     /* 327888 */ // Label 6713: @327888
     /* 327888 */ GIM_Reject,
     /* 327889 */ // Label 6705: @327889
     /* 327889 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(327926), // Rule ID 604 //
     /* 327894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327915 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 327920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327924 */   GIR_RootConstrainSelectedInstOperands,
     /* 327925 */   // GIR_Coverage, 604,
     /* 327925 */   GIR_Done,
     /* 327926 */ // Label 6714: @327926
     /* 327926 */ GIM_Reject,
     /* 327927 */ // Label 6706: @327927
     /* 327927 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(327986),
     /* 327932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327950 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(327969), // Rule ID 606 //
     /* 327955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327958 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 327958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 327963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327967 */     GIR_RootConstrainSelectedInstOperands,
     /* 327968 */     // GIR_Coverage, 606,
     /* 327968 */     GIR_Done,
     /* 327969 */   // Label 6716: @327969
     /* 327969 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(327985), // Rule ID 4811 //
     /* 327974 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 327974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 327979 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327983 */     GIR_RootConstrainSelectedInstOperands,
     /* 327984 */     // GIR_Coverage, 4811,
     /* 327984 */     GIR_Done,
     /* 327985 */   // Label 6717: @327985
     /* 327985 */   GIM_Reject,
     /* 327986 */ // Label 6715: @327986
     /* 327986 */ GIM_Reject,
     /* 327987 */ // Label 6707: @327987
     /* 327987 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(328089),
     /* 327992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328002 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(328061), // Rule ID 2351 //
     /* 328007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328046 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 328046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 328049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328059 */     GIR_RootConstrainSelectedInstOperands,
     /* 328060 */     // GIR_Coverage, 2351,
     /* 328060 */     GIR_EraseRootFromParent_Done,
     /* 328061 */   // Label 6719: @328061
     /* 328061 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(328088), // Rule ID 1258 //
     /* 328066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328077 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 328077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 328082 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328086 */     GIR_RootConstrainSelectedInstOperands,
     /* 328087 */     // GIR_Coverage, 1258,
     /* 328087 */     GIR_Done,
     /* 328088 */   // Label 6720: @328088
     /* 328088 */   GIM_Reject,
     /* 328089 */ // Label 6718: @328089
     /* 328089 */ GIM_Reject,
     /* 328090 */ // Label 6708: @328090
     /* 328090 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(328192),
     /* 328095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 328101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328105 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(328164), // Rule ID 2357 //
     /* 328110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328149 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 328149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 328152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328162 */     GIR_RootConstrainSelectedInstOperands,
     /* 328163 */     // GIR_Coverage, 2357,
     /* 328163 */     GIR_EraseRootFromParent_Done,
     /* 328164 */   // Label 6722: @328164
     /* 328164 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(328191), // Rule ID 1262 //
     /* 328169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328180 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 328180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 328185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328189 */     GIR_RootConstrainSelectedInstOperands,
     /* 328190 */     // GIR_Coverage, 1262,
     /* 328190 */     GIR_Done,
     /* 328191 */   // Label 6723: @328191
     /* 328191 */   GIM_Reject,
     /* 328192 */ // Label 6721: @328192
     /* 328192 */ GIM_Reject,
     /* 328193 */ // Label 6709: @328193
     /* 328193 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(328295),
     /* 328198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328208 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(328267), // Rule ID 2345 //
     /* 328213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328252 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 328252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 328255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328265 */     GIR_RootConstrainSelectedInstOperands,
     /* 328266 */     // GIR_Coverage, 2345,
     /* 328266 */     GIR_EraseRootFromParent_Done,
     /* 328267 */   // Label 6725: @328267
     /* 328267 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(328294), // Rule ID 1254 //
     /* 328272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328283 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 328283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 328288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328292 */     GIR_RootConstrainSelectedInstOperands,
     /* 328293 */     // GIR_Coverage, 1254,
     /* 328293 */     GIR_Done,
     /* 328294 */   // Label 6726: @328294
     /* 328294 */   GIM_Reject,
     /* 328295 */ // Label 6724: @328295
     /* 328295 */ GIM_Reject,
     /* 328296 */ // Label 6710: @328296
     /* 328296 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(328398),
     /* 328301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328311 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(328370), // Rule ID 2354 //
     /* 328316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328355 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 328355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 328358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328368 */     GIR_RootConstrainSelectedInstOperands,
     /* 328369 */     // GIR_Coverage, 2354,
     /* 328369 */     GIR_EraseRootFromParent_Done,
     /* 328370 */   // Label 6728: @328370
     /* 328370 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(328397), // Rule ID 1260 //
     /* 328375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328386 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 328386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 328391 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328395 */     GIR_RootConstrainSelectedInstOperands,
     /* 328396 */     // GIR_Coverage, 1260,
     /* 328396 */     GIR_Done,
     /* 328397 */   // Label 6729: @328397
     /* 328397 */   GIM_Reject,
     /* 328398 */ // Label 6727: @328398
     /* 328398 */ GIM_Reject,
     /* 328399 */ // Label 6711: @328399
     /* 328399 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(328501),
     /* 328404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328414 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(328473), // Rule ID 2348 //
     /* 328419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328458 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 328458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 328461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328471 */     GIR_RootConstrainSelectedInstOperands,
     /* 328472 */     // GIR_Coverage, 2348,
     /* 328472 */     GIR_EraseRootFromParent_Done,
     /* 328473 */   // Label 6731: @328473
     /* 328473 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(328500), // Rule ID 1256 //
     /* 328478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328489 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 328489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 328494 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328498 */     GIR_RootConstrainSelectedInstOperands,
     /* 328499 */     // GIR_Coverage, 1256,
     /* 328499 */     GIR_Done,
     /* 328500 */   // Label 6732: @328500
     /* 328500 */   GIM_Reject,
     /* 328501 */ // Label 6730: @328501
     /* 328501 */ GIM_Reject,
     /* 328502 */ // Label 6712: @328502
     /* 328502 */ GIM_Reject,
     /* 328503 */ // Label 81: @328503
     /* 328503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6741*/ GIMT_Encode4(328906),
     /* 328514 */ /*GILLT_s32*//*Label 6733*/ GIMT_Encode4(328554),
     /* 328518 */ /*GILLT_s64*//*Label 6734*/ GIMT_Encode4(328628), GIMT_Encode4(0),
     /* 328526 */ /*GILLT_v2s32*//*Label 6735*/ GIMT_Encode4(328702), GIMT_Encode4(0),
     /* 328534 */ /*GILLT_v4s16*//*Label 6736*/ GIMT_Encode4(328736),
     /* 328538 */ /*GILLT_v4s32*//*Label 6737*/ GIMT_Encode4(328770),
     /* 328542 */ /*GILLT_v8s8*//*Label 6738*/ GIMT_Encode4(328804),
     /* 328546 */ /*GILLT_v8s16*//*Label 6739*/ GIMT_Encode4(328838),
     /* 328550 */ /*GILLT_v16s8*//*Label 6740*/ GIMT_Encode4(328872),
     /* 328554 */ // Label 6733: @328554
     /* 328554 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(328627),
     /* 328559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 328565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328573 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(328607), // Rule ID 2328 //
     /* 328578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 328593 */     // MIs[1] Operand 1
     /* 328593 */     // No operand predicates
     /* 328593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328595 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 328595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 328598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328605 */     GIR_RootConstrainSelectedInstOperands,
     /* 328606 */     // GIR_Coverage, 2328,
     /* 328606 */     GIR_EraseRootFromParent_Done,
     /* 328607 */   // Label 6743: @328607
     /* 328607 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328626), // Rule ID 2327 //
     /* 328612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328619 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 328619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 328624 */     GIR_RootConstrainSelectedInstOperands,
     /* 328625 */     // GIR_Coverage, 2327,
     /* 328625 */     GIR_Done,
     /* 328626 */   // Label 6744: @328626
     /* 328626 */   GIM_Reject,
     /* 328627 */ // Label 6742: @328627
     /* 328627 */ GIM_Reject,
     /* 328628 */ // Label 6734: @328628
     /* 328628 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(328701),
     /* 328633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 328639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328647 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(328681), // Rule ID 2330 //
     /* 328652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 328667 */     // MIs[1] Operand 1
     /* 328667 */     // No operand predicates
     /* 328667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328669 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 328669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 328672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328679 */     GIR_RootConstrainSelectedInstOperands,
     /* 328680 */     // GIR_Coverage, 2330,
     /* 328680 */     GIR_EraseRootFromParent_Done,
     /* 328681 */   // Label 6746: @328681
     /* 328681 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(328700), // Rule ID 2329 //
     /* 328686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328693 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 328693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 328698 */     GIR_RootConstrainSelectedInstOperands,
     /* 328699 */     // GIR_Coverage, 2329,
     /* 328699 */     GIR_Done,
     /* 328700 */   // Label 6747: @328700
     /* 328700 */   GIM_Reject,
     /* 328701 */ // Label 6745: @328701
     /* 328701 */ GIM_Reject,
     /* 328702 */ // Label 6735: @328702
     /* 328702 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(328735), // Rule ID 1414 //
     /* 328707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 328716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328728 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 328728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 328733 */   GIR_RootConstrainSelectedInstOperands,
     /* 328734 */   // GIR_Coverage, 1414,
     /* 328734 */   GIR_Done,
     /* 328735 */ // Label 6748: @328735
     /* 328735 */ GIM_Reject,
     /* 328736 */ // Label 6736: @328736
     /* 328736 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(328769), // Rule ID 1412 //
     /* 328741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328762 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 328762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 328767 */   GIR_RootConstrainSelectedInstOperands,
     /* 328768 */   // GIR_Coverage, 1412,
     /* 328768 */   GIR_Done,
     /* 328769 */ // Label 6749: @328769
     /* 328769 */ GIM_Reject,
     /* 328770 */ // Label 6737: @328770
     /* 328770 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(328803), // Rule ID 1415 //
     /* 328775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328796 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 328796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 328801 */   GIR_RootConstrainSelectedInstOperands,
     /* 328802 */   // GIR_Coverage, 1415,
     /* 328802 */   GIR_Done,
     /* 328803 */ // Label 6750: @328803
     /* 328803 */ GIM_Reject,
     /* 328804 */ // Label 6738: @328804
     /* 328804 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(328837), // Rule ID 1410 //
     /* 328809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 328818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328830 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 328830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 328835 */   GIR_RootConstrainSelectedInstOperands,
     /* 328836 */   // GIR_Coverage, 1410,
     /* 328836 */   GIR_Done,
     /* 328837 */ // Label 6751: @328837
     /* 328837 */ GIM_Reject,
     /* 328838 */ // Label 6739: @328838
     /* 328838 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(328871), // Rule ID 1413 //
     /* 328843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328864 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 328864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 328869 */   GIR_RootConstrainSelectedInstOperands,
     /* 328870 */   // GIR_Coverage, 1413,
     /* 328870 */   GIR_Done,
     /* 328871 */ // Label 6752: @328871
     /* 328871 */ GIM_Reject,
     /* 328872 */ // Label 6740: @328872
     /* 328872 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(328905), // Rule ID 1411 //
     /* 328877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 328883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 328886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328898 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 328898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 328903 */   GIR_RootConstrainSelectedInstOperands,
     /* 328904 */   // GIR_Coverage, 1411,
     /* 328904 */   GIR_Done,
     /* 328905 */ // Label 6753: @328905
     /* 328905 */ GIM_Reject,
     /* 328906 */ // Label 6741: @328906
     /* 328906 */ GIM_Reject,
     /* 328907 */ // Label 82: @328907
     /* 328907 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6762*/ GIMT_Encode4(329310),
     /* 328918 */ /*GILLT_s32*//*Label 6754*/ GIMT_Encode4(328958),
     /* 328922 */ /*GILLT_s64*//*Label 6755*/ GIMT_Encode4(329032), GIMT_Encode4(0),
     /* 328930 */ /*GILLT_v2s32*//*Label 6756*/ GIMT_Encode4(329106), GIMT_Encode4(0),
     /* 328938 */ /*GILLT_v4s16*//*Label 6757*/ GIMT_Encode4(329140),
     /* 328942 */ /*GILLT_v4s32*//*Label 6758*/ GIMT_Encode4(329174),
     /* 328946 */ /*GILLT_v8s8*//*Label 6759*/ GIMT_Encode4(329208),
     /* 328950 */ /*GILLT_v8s16*//*Label 6760*/ GIMT_Encode4(329242),
     /* 328954 */ /*GILLT_v16s8*//*Label 6761*/ GIMT_Encode4(329276),
     /* 328958 */ // Label 6754: @328958
     /* 328958 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(329031),
     /* 328963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 328969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328977 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(329011), // Rule ID 2324 //
     /* 328982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 328997 */     // MIs[1] Operand 1
     /* 328997 */     // No operand predicates
     /* 328997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328999 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 328999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 329002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329009 */     GIR_RootConstrainSelectedInstOperands,
     /* 329010 */     // GIR_Coverage, 2324,
     /* 329010 */     GIR_EraseRootFromParent_Done,
     /* 329011 */   // Label 6764: @329011
     /* 329011 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(329030), // Rule ID 2323 //
     /* 329016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329023 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 329028 */     GIR_RootConstrainSelectedInstOperands,
     /* 329029 */     // GIR_Coverage, 2323,
     /* 329029 */     GIR_Done,
     /* 329030 */   // Label 6765: @329030
     /* 329030 */   GIM_Reject,
     /* 329031 */ // Label 6763: @329031
     /* 329031 */ GIM_Reject,
     /* 329032 */ // Label 6755: @329032
     /* 329032 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(329105),
     /* 329037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329051 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(329085), // Rule ID 2326 //
     /* 329056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 329071 */     // MIs[1] Operand 1
     /* 329071 */     // No operand predicates
     /* 329071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329073 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 329076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329083 */     GIR_RootConstrainSelectedInstOperands,
     /* 329084 */     // GIR_Coverage, 2326,
     /* 329084 */     GIR_EraseRootFromParent_Done,
     /* 329085 */   // Label 6767: @329085
     /* 329085 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(329104), // Rule ID 2325 //
     /* 329090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329097 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 329102 */     GIR_RootConstrainSelectedInstOperands,
     /* 329103 */     // GIR_Coverage, 2325,
     /* 329103 */     GIR_Done,
     /* 329104 */   // Label 6768: @329104
     /* 329104 */   GIM_Reject,
     /* 329105 */ // Label 6766: @329105
     /* 329105 */ GIM_Reject,
     /* 329106 */ // Label 6756: @329106
     /* 329106 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(329139), // Rule ID 1402 //
     /* 329111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329132 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 329137 */   GIR_RootConstrainSelectedInstOperands,
     /* 329138 */   // GIR_Coverage, 1402,
     /* 329138 */   GIR_Done,
     /* 329139 */ // Label 6769: @329139
     /* 329139 */ GIM_Reject,
     /* 329140 */ // Label 6757: @329140
     /* 329140 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(329173), // Rule ID 1400 //
     /* 329145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329166 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 329171 */   GIR_RootConstrainSelectedInstOperands,
     /* 329172 */   // GIR_Coverage, 1400,
     /* 329172 */   GIR_Done,
     /* 329173 */ // Label 6770: @329173
     /* 329173 */ GIM_Reject,
     /* 329174 */ // Label 6758: @329174
     /* 329174 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(329207), // Rule ID 1403 //
     /* 329179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329200 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 329200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 329205 */   GIR_RootConstrainSelectedInstOperands,
     /* 329206 */   // GIR_Coverage, 1403,
     /* 329206 */   GIR_Done,
     /* 329207 */ // Label 6771: @329207
     /* 329207 */ GIM_Reject,
     /* 329208 */ // Label 6759: @329208
     /* 329208 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(329241), // Rule ID 1398 //
     /* 329213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 329222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329234 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 329234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 329239 */   GIR_RootConstrainSelectedInstOperands,
     /* 329240 */   // GIR_Coverage, 1398,
     /* 329240 */   GIR_Done,
     /* 329241 */ // Label 6772: @329241
     /* 329241 */ GIM_Reject,
     /* 329242 */ // Label 6760: @329242
     /* 329242 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(329275), // Rule ID 1401 //
     /* 329247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329268 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 329268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 329273 */   GIR_RootConstrainSelectedInstOperands,
     /* 329274 */   // GIR_Coverage, 1401,
     /* 329274 */   GIR_Done,
     /* 329275 */ // Label 6773: @329275
     /* 329275 */ GIM_Reject,
     /* 329276 */ // Label 6761: @329276
     /* 329276 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(329309), // Rule ID 1399 //
     /* 329281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 329290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329302 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 329302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 329307 */   GIR_RootConstrainSelectedInstOperands,
     /* 329308 */   // GIR_Coverage, 1399,
     /* 329308 */   GIR_Done,
     /* 329309 */ // Label 6774: @329309
     /* 329309 */ GIM_Reject,
     /* 329310 */ // Label 6762: @329310
     /* 329310 */ GIM_Reject,
     /* 329311 */ // Label 83: @329311
     /* 329311 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6783*/ GIMT_Encode4(329714),
     /* 329322 */ /*GILLT_s32*//*Label 6775*/ GIMT_Encode4(329362),
     /* 329326 */ /*GILLT_s64*//*Label 6776*/ GIMT_Encode4(329436), GIMT_Encode4(0),
     /* 329334 */ /*GILLT_v2s32*//*Label 6777*/ GIMT_Encode4(329510), GIMT_Encode4(0),
     /* 329342 */ /*GILLT_v4s16*//*Label 6778*/ GIMT_Encode4(329544),
     /* 329346 */ /*GILLT_v4s32*//*Label 6779*/ GIMT_Encode4(329578),
     /* 329350 */ /*GILLT_v8s8*//*Label 6780*/ GIMT_Encode4(329612),
     /* 329354 */ /*GILLT_v8s16*//*Label 6781*/ GIMT_Encode4(329646),
     /* 329358 */ /*GILLT_v16s8*//*Label 6782*/ GIMT_Encode4(329680),
     /* 329362 */ // Label 6775: @329362
     /* 329362 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(329435),
     /* 329367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329381 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(329415), // Rule ID 2336 //
     /* 329386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 329401 */     // MIs[1] Operand 1
     /* 329401 */     // No operand predicates
     /* 329401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329403 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 329403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 329406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329413 */     GIR_RootConstrainSelectedInstOperands,
     /* 329414 */     // GIR_Coverage, 2336,
     /* 329414 */     GIR_EraseRootFromParent_Done,
     /* 329415 */   // Label 6785: @329415
     /* 329415 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(329434), // Rule ID 2335 //
     /* 329420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329427 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 329432 */     GIR_RootConstrainSelectedInstOperands,
     /* 329433 */     // GIR_Coverage, 2335,
     /* 329433 */     GIR_Done,
     /* 329434 */   // Label 6786: @329434
     /* 329434 */   GIM_Reject,
     /* 329435 */ // Label 6784: @329435
     /* 329435 */ GIM_Reject,
     /* 329436 */ // Label 6776: @329436
     /* 329436 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(329509),
     /* 329441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329455 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(329489), // Rule ID 2338 //
     /* 329460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 329475 */     // MIs[1] Operand 1
     /* 329475 */     // No operand predicates
     /* 329475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329477 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 329480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329487 */     GIR_RootConstrainSelectedInstOperands,
     /* 329488 */     // GIR_Coverage, 2338,
     /* 329488 */     GIR_EraseRootFromParent_Done,
     /* 329489 */   // Label 6788: @329489
     /* 329489 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(329508), // Rule ID 2337 //
     /* 329494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329501 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 329506 */     GIR_RootConstrainSelectedInstOperands,
     /* 329507 */     // GIR_Coverage, 2337,
     /* 329507 */     GIR_Done,
     /* 329508 */   // Label 6789: @329508
     /* 329508 */   GIM_Reject,
     /* 329509 */ // Label 6787: @329509
     /* 329509 */ GIM_Reject,
     /* 329510 */ // Label 6777: @329510
     /* 329510 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(329543), // Rule ID 1537 //
     /* 329515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329536 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 329541 */   GIR_RootConstrainSelectedInstOperands,
     /* 329542 */   // GIR_Coverage, 1537,
     /* 329542 */   GIR_Done,
     /* 329543 */ // Label 6790: @329543
     /* 329543 */ GIM_Reject,
     /* 329544 */ // Label 6778: @329544
     /* 329544 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(329577), // Rule ID 1535 //
     /* 329549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329570 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 329575 */   GIR_RootConstrainSelectedInstOperands,
     /* 329576 */   // GIR_Coverage, 1535,
     /* 329576 */   GIR_Done,
     /* 329577 */ // Label 6791: @329577
     /* 329577 */ GIM_Reject,
     /* 329578 */ // Label 6779: @329578
     /* 329578 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(329611), // Rule ID 1538 //
     /* 329583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329604 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 329604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 329609 */   GIR_RootConstrainSelectedInstOperands,
     /* 329610 */   // GIR_Coverage, 1538,
     /* 329610 */   GIR_Done,
     /* 329611 */ // Label 6792: @329611
     /* 329611 */ GIM_Reject,
     /* 329612 */ // Label 6780: @329612
     /* 329612 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(329645), // Rule ID 1533 //
     /* 329617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 329626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329638 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 329638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 329643 */   GIR_RootConstrainSelectedInstOperands,
     /* 329644 */   // GIR_Coverage, 1533,
     /* 329644 */   GIR_Done,
     /* 329645 */ // Label 6793: @329645
     /* 329645 */ GIM_Reject,
     /* 329646 */ // Label 6781: @329646
     /* 329646 */ GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(329679), // Rule ID 1536 //
     /* 329651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329672 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 329672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 329677 */   GIR_RootConstrainSelectedInstOperands,
     /* 329678 */   // GIR_Coverage, 1536,
     /* 329678 */   GIR_Done,
     /* 329679 */ // Label 6794: @329679
     /* 329679 */ GIM_Reject,
     /* 329680 */ // Label 6782: @329680
     /* 329680 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(329713), // Rule ID 1534 //
     /* 329685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 329694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329706 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 329706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 329711 */   GIR_RootConstrainSelectedInstOperands,
     /* 329712 */   // GIR_Coverage, 1534,
     /* 329712 */   GIR_Done,
     /* 329713 */ // Label 6795: @329713
     /* 329713 */ GIM_Reject,
     /* 329714 */ // Label 6783: @329714
     /* 329714 */ GIM_Reject,
     /* 329715 */ // Label 84: @329715
     /* 329715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6804*/ GIMT_Encode4(330118),
     /* 329726 */ /*GILLT_s32*//*Label 6796*/ GIMT_Encode4(329766),
     /* 329730 */ /*GILLT_s64*//*Label 6797*/ GIMT_Encode4(329840), GIMT_Encode4(0),
     /* 329738 */ /*GILLT_v2s32*//*Label 6798*/ GIMT_Encode4(329914), GIMT_Encode4(0),
     /* 329746 */ /*GILLT_v4s16*//*Label 6799*/ GIMT_Encode4(329948),
     /* 329750 */ /*GILLT_v4s32*//*Label 6800*/ GIMT_Encode4(329982),
     /* 329754 */ /*GILLT_v8s8*//*Label 6801*/ GIMT_Encode4(330016),
     /* 329758 */ /*GILLT_v8s16*//*Label 6802*/ GIMT_Encode4(330050),
     /* 329762 */ /*GILLT_v16s8*//*Label 6803*/ GIMT_Encode4(330084),
     /* 329766 */ // Label 6796: @329766
     /* 329766 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(329839),
     /* 329771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329785 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(329819), // Rule ID 2332 //
     /* 329790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 329805 */     // MIs[1] Operand 1
     /* 329805 */     // No operand predicates
     /* 329805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329807 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 329807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 329810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329817 */     GIR_RootConstrainSelectedInstOperands,
     /* 329818 */     // GIR_Coverage, 2332,
     /* 329818 */     GIR_EraseRootFromParent_Done,
     /* 329819 */   // Label 6806: @329819
     /* 329819 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(329838), // Rule ID 2331 //
     /* 329824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329831 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 329836 */     GIR_RootConstrainSelectedInstOperands,
     /* 329837 */     // GIR_Coverage, 2331,
     /* 329837 */     GIR_Done,
     /* 329838 */   // Label 6807: @329838
     /* 329838 */   GIM_Reject,
     /* 329839 */ // Label 6805: @329839
     /* 329839 */ GIM_Reject,
     /* 329840 */ // Label 6797: @329840
     /* 329840 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(329913),
     /* 329845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329859 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(329893), // Rule ID 2334 //
     /* 329864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 329879 */     // MIs[1] Operand 1
     /* 329879 */     // No operand predicates
     /* 329879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329881 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 329884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329891 */     GIR_RootConstrainSelectedInstOperands,
     /* 329892 */     // GIR_Coverage, 2334,
     /* 329892 */     GIR_EraseRootFromParent_Done,
     /* 329893 */   // Label 6809: @329893
     /* 329893 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(329912), // Rule ID 2333 //
     /* 329898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329905 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 329910 */     GIR_RootConstrainSelectedInstOperands,
     /* 329911 */     // GIR_Coverage, 2333,
     /* 329911 */     GIR_Done,
     /* 329912 */   // Label 6810: @329912
     /* 329912 */   GIM_Reject,
     /* 329913 */ // Label 6808: @329913
     /* 329913 */ GIM_Reject,
     /* 329914 */ // Label 6798: @329914
     /* 329914 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(329947), // Rule ID 1525 //
     /* 329919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329940 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 329945 */   GIR_RootConstrainSelectedInstOperands,
     /* 329946 */   // GIR_Coverage, 1525,
     /* 329946 */   GIR_Done,
     /* 329947 */ // Label 6811: @329947
     /* 329947 */ GIM_Reject,
     /* 329948 */ // Label 6799: @329948
     /* 329948 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(329981), // Rule ID 1523 //
     /* 329953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329974 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 329979 */   GIR_RootConstrainSelectedInstOperands,
     /* 329980 */   // GIR_Coverage, 1523,
     /* 329980 */   GIR_Done,
     /* 329981 */ // Label 6812: @329981
     /* 329981 */ GIM_Reject,
     /* 329982 */ // Label 6800: @329982
     /* 329982 */ GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(330015), // Rule ID 1526 //
     /* 329987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330008 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 330008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 330013 */   GIR_RootConstrainSelectedInstOperands,
     /* 330014 */   // GIR_Coverage, 1526,
     /* 330014 */   GIR_Done,
     /* 330015 */ // Label 6813: @330015
     /* 330015 */ GIM_Reject,
     /* 330016 */ // Label 6801: @330016
     /* 330016 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(330049), // Rule ID 1521 //
     /* 330021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 330030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330042 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 330042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 330047 */   GIR_RootConstrainSelectedInstOperands,
     /* 330048 */   // GIR_Coverage, 1521,
     /* 330048 */   GIR_Done,
     /* 330049 */ // Label 6814: @330049
     /* 330049 */ GIM_Reject,
     /* 330050 */ // Label 6802: @330050
     /* 330050 */ GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(330083), // Rule ID 1524 //
     /* 330055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330076 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 330076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 330081 */   GIR_RootConstrainSelectedInstOperands,
     /* 330082 */   // GIR_Coverage, 1524,
     /* 330082 */   GIR_Done,
     /* 330083 */ // Label 6815: @330083
     /* 330083 */ GIM_Reject,
     /* 330084 */ // Label 6803: @330084
     /* 330084 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(330117), // Rule ID 1522 //
     /* 330089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 330095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 330098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330110 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 330110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 330115 */   GIR_RootConstrainSelectedInstOperands,
     /* 330116 */   // GIR_Coverage, 1522,
     /* 330116 */   GIR_Done,
     /* 330117 */ // Label 6816: @330117
     /* 330117 */ GIM_Reject,
     /* 330118 */ // Label 6804: @330118
     /* 330118 */ GIM_Reject,
     /* 330119 */ // Label 85: @330119
     /* 330119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6826*/ GIMT_Encode4(330933),
     /* 330130 */ /*GILLT_s32*//*Label 6817*/ GIMT_Encode4(330170),
     /* 330134 */ /*GILLT_s64*//*Label 6818*/ GIMT_Encode4(330197), GIMT_Encode4(0),
     /* 330142 */ /*GILLT_v2s32*//*Label 6819*/ GIMT_Encode4(330276),
     /* 330146 */ /*GILLT_v2s64*//*Label 6820*/ GIMT_Encode4(330303),
     /* 330150 */ /*GILLT_v4s16*//*Label 6821*/ GIMT_Encode4(330486),
     /* 330154 */ /*GILLT_v4s32*//*Label 6822*/ GIMT_Encode4(330513),
     /* 330158 */ /*GILLT_v8s8*//*Label 6823*/ GIMT_Encode4(330696),
     /* 330162 */ /*GILLT_v8s16*//*Label 6824*/ GIMT_Encode4(330723),
     /* 330166 */ /*GILLT_v16s8*//*Label 6825*/ GIMT_Encode4(330906),
     /* 330170 */ // Label 6817: @330170
     /* 330170 */ GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(330196), // Rule ID 2317 //
     /* 330175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 330178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330189 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 330189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 330194 */   GIR_RootConstrainSelectedInstOperands,
     /* 330195 */   // GIR_Coverage, 2317,
     /* 330195 */   GIR_Done,
     /* 330196 */ // Label 6827: @330196
     /* 330196 */ GIM_Reject,
     /* 330197 */ // Label 6818: @330197
     /* 330197 */ GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(330275),
     /* 330202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330205 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(330228), // Rule ID 1652 //
     /* 330210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330221 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 330221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 330226 */     GIR_RootConstrainSelectedInstOperands,
     /* 330227 */     // GIR_Coverage, 1652,
     /* 330227 */     GIR_Done,
     /* 330228 */   // Label 6829: @330228
     /* 330228 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(330251), // Rule ID 2318 //
     /* 330233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 330236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330244 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 330244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 330249 */     GIR_RootConstrainSelectedInstOperands,
     /* 330250 */     // GIR_Coverage, 2318,
     /* 330250 */     GIR_Done,
     /* 330251 */   // Label 6830: @330251
     /* 330251 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(330274), // Rule ID 2514 //
     /* 330256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 330259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330267 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 330267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 330272 */     GIR_RootConstrainSelectedInstOperands,
     /* 330273 */     // GIR_Coverage, 2514,
     /* 330273 */     GIR_Done,
     /* 330274 */   // Label 6831: @330274
     /* 330274 */   GIM_Reject,
     /* 330275 */ // Label 6828: @330275
     /* 330275 */ GIM_Reject,
     /* 330276 */ // Label 6819: @330276
     /* 330276 */ GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(330302), // Rule ID 707 //
     /* 330281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330295 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 330295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 330300 */   GIR_RootConstrainSelectedInstOperands,
     /* 330301 */   // GIR_Coverage, 707,
     /* 330301 */   GIR_Done,
     /* 330302 */ // Label 6832: @330302
     /* 330302 */ GIM_Reject,
     /* 330303 */ // Label 6820: @330303
     /* 330303 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(330485),
     /* 330308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330315 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(330393), // Rule ID 4889 //
     /* 330320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 330336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 330369 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 330376 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 330376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 330379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330391 */     GIR_RootConstrainSelectedInstOperands,
     /* 330392 */     // GIR_Coverage, 4889,
     /* 330392 */     GIR_EraseRootFromParent_Done,
     /* 330393 */   // Label 6834: @330393
     /* 330393 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(330465), // Rule ID 4888 //
     /* 330398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 330414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330443 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330450 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 330450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 330453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330463 */     GIR_RootConstrainSelectedInstOperands,
     /* 330464 */     // GIR_Coverage, 4888,
     /* 330464 */     GIR_EraseRootFromParent_Done,
     /* 330465 */   // Label 6835: @330465
     /* 330465 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(330484), // Rule ID 709 //
     /* 330470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330477 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 330477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 330482 */     GIR_RootConstrainSelectedInstOperands,
     /* 330483 */     // GIR_Coverage, 709,
     /* 330483 */     GIR_Done,
     /* 330484 */   // Label 6836: @330484
     /* 330484 */   GIM_Reject,
     /* 330485 */ // Label 6833: @330485
     /* 330485 */ GIM_Reject,
     /* 330486 */ // Label 6821: @330486
     /* 330486 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(330512), // Rule ID 705 //
     /* 330491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330505 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 330505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 330510 */   GIR_RootConstrainSelectedInstOperands,
     /* 330511 */   // GIR_Coverage, 705,
     /* 330511 */   GIR_Done,
     /* 330512 */ // Label 6837: @330512
     /* 330512 */ GIM_Reject,
     /* 330513 */ // Label 6822: @330513
     /* 330513 */ GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(330695),
     /* 330518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330525 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(330603), // Rule ID 4887 //
     /* 330530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 330546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 330579 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 330586 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 330586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 330589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330601 */     GIR_RootConstrainSelectedInstOperands,
     /* 330602 */     // GIR_Coverage, 4887,
     /* 330602 */     GIR_EraseRootFromParent_Done,
     /* 330603 */   // Label 6839: @330603
     /* 330603 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(330675), // Rule ID 4886 //
     /* 330608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 330624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330660 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 330660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 330663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330673 */     GIR_RootConstrainSelectedInstOperands,
     /* 330674 */     // GIR_Coverage, 4886,
     /* 330674 */     GIR_EraseRootFromParent_Done,
     /* 330675 */   // Label 6840: @330675
     /* 330675 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(330694), // Rule ID 708 //
     /* 330680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330687 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 330687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 330692 */     GIR_RootConstrainSelectedInstOperands,
     /* 330693 */     // GIR_Coverage, 708,
     /* 330693 */     GIR_Done,
     /* 330694 */   // Label 6841: @330694
     /* 330694 */   GIM_Reject,
     /* 330695 */ // Label 6838: @330695
     /* 330695 */ GIM_Reject,
     /* 330696 */ // Label 6823: @330696
     /* 330696 */ GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(330722), // Rule ID 703 //
     /* 330701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330715 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 330715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 330720 */   GIR_RootConstrainSelectedInstOperands,
     /* 330721 */   // GIR_Coverage, 703,
     /* 330721 */   GIR_Done,
     /* 330722 */ // Label 6842: @330722
     /* 330722 */ GIM_Reject,
     /* 330723 */ // Label 6824: @330723
     /* 330723 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(330905),
     /* 330728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330735 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(330813), // Rule ID 4885 //
     /* 330740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 330789 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 330796 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 330796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 330799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330811 */     GIR_RootConstrainSelectedInstOperands,
     /* 330812 */     // GIR_Coverage, 4885,
     /* 330812 */     GIR_EraseRootFromParent_Done,
     /* 330813 */   // Label 6844: @330813
     /* 330813 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(330885), // Rule ID 4884 //
     /* 330818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330859 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330870 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 330870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 330873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330883 */     GIR_RootConstrainSelectedInstOperands,
     /* 330884 */     // GIR_Coverage, 4884,
     /* 330884 */     GIR_EraseRootFromParent_Done,
     /* 330885 */   // Label 6845: @330885
     /* 330885 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(330904), // Rule ID 706 //
     /* 330890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330897 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 330897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 330902 */     GIR_RootConstrainSelectedInstOperands,
     /* 330903 */     // GIR_Coverage, 706,
     /* 330903 */     GIR_Done,
     /* 330904 */   // Label 6846: @330904
     /* 330904 */   GIM_Reject,
     /* 330905 */ // Label 6843: @330905
     /* 330905 */ GIM_Reject,
     /* 330906 */ // Label 6825: @330906
     /* 330906 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(330932), // Rule ID 704 //
     /* 330911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 330917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330925 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 330925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 330930 */   GIR_RootConstrainSelectedInstOperands,
     /* 330931 */   // GIR_Coverage, 704,
     /* 330931 */   GIR_Done,
     /* 330932 */ // Label 6847: @330932
     /* 330932 */ GIM_Reject,
     /* 330933 */ // Label 6826: @330933
     /* 330933 */ GIM_Reject,
     /* 330934 */ // Label 86: @330934
     /* 330934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6850*/ GIMT_Encode4(331099),
     /* 330945 */ /*GILLT_s32*//*Label 6848*/ GIMT_Encode4(330953),
     /* 330949 */ /*GILLT_s64*//*Label 6849*/ GIMT_Encode4(331026),
     /* 330953 */ // Label 6848: @330953
     /* 330953 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(330979), // Rule ID 4730 //
     /* 330958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330968 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 330968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 330973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330977 */   GIR_RootConstrainSelectedInstOperands,
     /* 330978 */   // GIR_Coverage, 4730,
     /* 330978 */   GIR_Done,
     /* 330979 */ // Label 6851: @330979
     /* 330979 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(331002), // Rule ID 4736 //
     /* 330984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330991 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 330996 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331000 */   GIR_RootConstrainSelectedInstOperands,
     /* 331001 */   // GIR_Coverage, 4736,
     /* 331001 */   GIR_Done,
     /* 331002 */ // Label 6852: @331002
     /* 331002 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(331025), // Rule ID 4738 //
     /* 331007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331014 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 331019 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331023 */   GIR_RootConstrainSelectedInstOperands,
     /* 331024 */   // GIR_Coverage, 4738,
     /* 331024 */   GIR_Done,
     /* 331025 */ // Label 6853: @331025
     /* 331025 */ GIM_Reject,
     /* 331026 */ // Label 6849: @331026
     /* 331026 */ GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(331052), // Rule ID 4732 //
     /* 331031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331041 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 331041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 331046 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331050 */   GIR_RootConstrainSelectedInstOperands,
     /* 331051 */   // GIR_Coverage, 4732,
     /* 331051 */   GIR_Done,
     /* 331052 */ // Label 6854: @331052
     /* 331052 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(331075), // Rule ID 4740 //
     /* 331057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331064 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331073 */   GIR_RootConstrainSelectedInstOperands,
     /* 331074 */   // GIR_Coverage, 4740,
     /* 331074 */   GIR_Done,
     /* 331075 */ // Label 6855: @331075
     /* 331075 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(331098), // Rule ID 4742 //
     /* 331080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331087 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331096 */   GIR_RootConstrainSelectedInstOperands,
     /* 331097 */   // GIR_Coverage, 4742,
     /* 331097 */   GIR_Done,
     /* 331098 */ // Label 6856: @331098
     /* 331098 */ GIM_Reject,
     /* 331099 */ // Label 6850: @331099
     /* 331099 */ GIM_Reject,
     /* 331100 */ // Label 87: @331100
     /* 331100 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(331198),
     /* 331105 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 331108 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6861*/ GIMT_Encode4(331197),
     /* 331119 */   /*GILLT_s16*//*Label 6858*/ GIMT_Encode4(331131),
     /* 331123 */   /*GILLT_s32*//*Label 6859*/ GIMT_Encode4(331155),
     /* 331127 */   /*GILLT_s64*//*Label 6860*/ GIMT_Encode4(331176),
     /* 331131 */   // Label 6858: @331131
     /* 331131 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(331154), // Rule ID 4734 //
     /* 331136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331143 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 331143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 331148 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331152 */     GIR_RootConstrainSelectedInstOperands,
     /* 331153 */     // GIR_Coverage, 4734,
     /* 331153 */     GIR_Done,
     /* 331154 */   // Label 6862: @331154
     /* 331154 */   GIM_Reject,
     /* 331155 */   // Label 6859: @331155
     /* 331155 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(331175), // Rule ID 4744 //
     /* 331160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331164 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331169 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331173 */     GIR_RootConstrainSelectedInstOperands,
     /* 331174 */     // GIR_Coverage, 4744,
     /* 331174 */     GIR_Done,
     /* 331175 */   // Label 6863: @331175
     /* 331175 */   GIM_Reject,
     /* 331176 */   // Label 6860: @331176
     /* 331176 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(331196), // Rule ID 4746 //
     /* 331181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331185 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331190 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331194 */     GIR_RootConstrainSelectedInstOperands,
     /* 331195 */     // GIR_Coverage, 4746,
     /* 331195 */     GIR_Done,
     /* 331196 */   // Label 6864: @331196
     /* 331196 */   GIM_Reject,
     /* 331197 */   // Label 6861: @331197
     /* 331197 */   GIM_Reject,
     /* 331198 */ // Label 6857: @331198
     /* 331198 */ GIM_Reject,
     /* 331199 */ // Label 88: @331199
     /* 331199 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(331214), // Rule ID 225 //
     /* 331204 */   // MIs[0] addr
     /* 331204 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 331207 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 331207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 331212 */   GIR_RootConstrainSelectedInstOperands,
     /* 331213 */   // GIR_Coverage, 225,
     /* 331213 */   GIR_Done,
     /* 331214 */ // Label 6865: @331214
     /* 331214 */ GIM_Reject,
     /* 331215 */ // Label 89: @331215
     /* 331215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6877*/ GIMT_Encode4(336586),
     /* 331226 */ /*GILLT_s64*//*Label 6866*/ GIMT_Encode4(331298), GIMT_Encode4(0),
     /* 331234 */ /*GILLT_v2s32*//*Label 6867*/ GIMT_Encode4(331700), GIMT_Encode4(0),
     /* 331242 */ /*GILLT_v4s16*//*Label 6868*/ GIMT_Encode4(332102), GIMT_Encode4(0),
     /* 331250 */ /*GILLT_v8s8*//*Label 6869*/ GIMT_Encode4(332504), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 331262 */ /*GILLT_nxv1s1*//*Label 6870*/ GIMT_Encode4(332684),
     /* 331266 */ /*GILLT_nxv2s1*//*Label 6871*/ GIMT_Encode4(334947),
     /* 331270 */ /*GILLT_nxv2s16*//*Label 6872*/ GIMT_Encode4(335802),
     /* 331274 */ /*GILLT_nxv2s32*//*Label 6873*/ GIMT_Encode4(336089), GIMT_Encode4(0),
     /* 331282 */ /*GILLT_nxv4s1*//*Label 6874*/ GIMT_Encode4(336159),
     /* 331286 */ /*GILLT_nxv4s16*//*Label 6875*/ GIMT_Encode4(336446), GIMT_Encode4(0),
     /* 331294 */ /*GILLT_nxv8s1*//*Label 6876*/ GIMT_Encode4(336516),
     /* 331298 */ // Label 6866: @331298
     /* 331298 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(331699),
     /* 331303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331310 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(331362), // Rule ID 5580 //
     /* 331315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331327 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331334 */     // MIs[0] Operand 2
     /* 331334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331347 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 331347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 331350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331360 */     GIR_RootConstrainSelectedInstOperands,
     /* 331361 */     // GIR_Coverage, 5580,
     /* 331361 */     GIR_EraseRootFromParent_Done,
     /* 331362 */   // Label 6879: @331362
     /* 331362 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(331414), // Rule ID 5583 //
     /* 331367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331379 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331386 */     // MIs[0] Operand 2
     /* 331386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331399 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 331399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 331402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331412 */     GIR_RootConstrainSelectedInstOperands,
     /* 331413 */     // GIR_Coverage, 5583,
     /* 331413 */     GIR_EraseRootFromParent_Done,
     /* 331414 */   // Label 6880: @331414
     /* 331414 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(331482), // Rule ID 5459 //
     /* 331419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331423 */     // MIs[0] Operand 2
     /* 331423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331434 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331481 */     // GIR_Coverage, 5459,
     /* 331481 */     GIR_EraseRootFromParent_Done,
     /* 331482 */   // Label 6881: @331482
     /* 331482 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(331550), // Rule ID 5464 //
     /* 331487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331491 */     // MIs[0] Operand 2
     /* 331491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331502 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331549 */     // GIR_Coverage, 5464,
     /* 331549 */     GIR_EraseRootFromParent_Done,
     /* 331550 */   // Label 6882: @331550
     /* 331550 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(331592), // Rule ID 6897 //
     /* 331555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331559 */     // MIs[0] Operand 2
     /* 331559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331570 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 331570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331575 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331591 */     // GIR_Coverage, 6897,
     /* 331591 */     GIR_EraseRootFromParent_Done,
     /* 331592 */   // Label 6883: @331592
     /* 331592 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(331634), // Rule ID 6898 //
     /* 331597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331601 */     // MIs[0] Operand 2
     /* 331601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331612 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 331612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331617 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331633 */     // GIR_Coverage, 6898,
     /* 331633 */     GIR_EraseRootFromParent_Done,
     /* 331634 */   // Label 6884: @331634
     /* 331634 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(331698), // Rule ID 6902 //
     /* 331639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331643 */     // MIs[0] Operand 2
     /* 331643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331654 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 331654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 331661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 331673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331680 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331697 */     // GIR_Coverage, 6902,
     /* 331697 */     GIR_EraseRootFromParent_Done,
     /* 331698 */   // Label 6885: @331698
     /* 331698 */   GIM_Reject,
     /* 331699 */ // Label 6878: @331699
     /* 331699 */ GIM_Reject,
     /* 331700 */ // Label 6867: @331700
     /* 331700 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332101),
     /* 331705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331712 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(331764), // Rule ID 5579 //
     /* 331717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331729 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331736 */     // MIs[0] Operand 2
     /* 331736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331749 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 331749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 331752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331762 */     GIR_RootConstrainSelectedInstOperands,
     /* 331763 */     // GIR_Coverage, 5579,
     /* 331763 */     GIR_EraseRootFromParent_Done,
     /* 331764 */   // Label 6887: @331764
     /* 331764 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(331816), // Rule ID 5582 //
     /* 331769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331781 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331788 */     // MIs[0] Operand 2
     /* 331788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331801 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 331801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 331804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331814 */     GIR_RootConstrainSelectedInstOperands,
     /* 331815 */     // GIR_Coverage, 5582,
     /* 331815 */     GIR_EraseRootFromParent_Done,
     /* 331816 */   // Label 6888: @331816
     /* 331816 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(331884), // Rule ID 5449 //
     /* 331821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331825 */     // MIs[0] Operand 2
     /* 331825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331836 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331856 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331866 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331883 */     // GIR_Coverage, 5449,
     /* 331883 */     GIR_EraseRootFromParent_Done,
     /* 331884 */   // Label 6889: @331884
     /* 331884 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(331952), // Rule ID 5454 //
     /* 331889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331893 */     // MIs[0] Operand 2
     /* 331893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331904 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331934 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331951 */     // GIR_Coverage, 5454,
     /* 331951 */     GIR_EraseRootFromParent_Done,
     /* 331952 */   // Label 6890: @331952
     /* 331952 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(331994), // Rule ID 6894 //
     /* 331957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331961 */     // MIs[0] Operand 2
     /* 331961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331972 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 331972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331977 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331993 */     // GIR_Coverage, 6894,
     /* 331993 */     GIR_EraseRootFromParent_Done,
     /* 331994 */   // Label 6891: @331994
     /* 331994 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332036), // Rule ID 6896 //
     /* 331999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332003 */     // MIs[0] Operand 2
     /* 332003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332014 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 332014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332019 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332035 */     // GIR_Coverage, 6896,
     /* 332035 */     GIR_EraseRootFromParent_Done,
     /* 332036 */   // Label 6892: @332036
     /* 332036 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(332100), // Rule ID 6901 //
     /* 332041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332045 */     // MIs[0] Operand 2
     /* 332045 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332056 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332082 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332099 */     // GIR_Coverage, 6901,
     /* 332099 */     GIR_EraseRootFromParent_Done,
     /* 332100 */   // Label 6893: @332100
     /* 332100 */   GIM_Reject,
     /* 332101 */ // Label 6886: @332101
     /* 332101 */ GIM_Reject,
     /* 332102 */ // Label 6868: @332102
     /* 332102 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(332503),
     /* 332107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332114 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(332166), // Rule ID 5578 //
     /* 332119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 332127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 332131 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 332133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332138 */     // MIs[0] Operand 2
     /* 332138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332151 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 332151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 332154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332164 */     GIR_RootConstrainSelectedInstOperands,
     /* 332165 */     // GIR_Coverage, 5578,
     /* 332165 */     GIR_EraseRootFromParent_Done,
     /* 332166 */   // Label 6895: @332166
     /* 332166 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(332218), // Rule ID 5581 //
     /* 332171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 332179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 332183 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 332185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332190 */     // MIs[0] Operand 2
     /* 332190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332203 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 332203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 332206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332216 */     GIR_RootConstrainSelectedInstOperands,
     /* 332217 */     // GIR_Coverage, 5581,
     /* 332217 */     GIR_EraseRootFromParent_Done,
     /* 332218 */   // Label 6896: @332218
     /* 332218 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(332286), // Rule ID 5439 //
     /* 332223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332227 */     // MIs[0] Operand 2
     /* 332227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332238 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332268 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332285 */     // GIR_Coverage, 5439,
     /* 332285 */     GIR_EraseRootFromParent_Done,
     /* 332286 */   // Label 6897: @332286
     /* 332286 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(332354), // Rule ID 5444 //
     /* 332291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332295 */     // MIs[0] Operand 2
     /* 332295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332306 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332326 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332336 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332353 */     // GIR_Coverage, 5444,
     /* 332353 */     GIR_EraseRootFromParent_Done,
     /* 332354 */   // Label 6898: @332354
     /* 332354 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(332396), // Rule ID 6892 //
     /* 332359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332363 */     // MIs[0] Operand 2
     /* 332363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332374 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 332374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332379 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332395 */     // GIR_Coverage, 6892,
     /* 332395 */     GIR_EraseRootFromParent_Done,
     /* 332396 */   // Label 6899: @332396
     /* 332396 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(332438), // Rule ID 6895 //
     /* 332401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332405 */     // MIs[0] Operand 2
     /* 332405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332416 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 332416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332421 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332437 */     // GIR_Coverage, 6895,
     /* 332437 */     GIR_EraseRootFromParent_Done,
     /* 332438 */   // Label 6900: @332438
     /* 332438 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(332502), // Rule ID 6900 //
     /* 332443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332447 */     // MIs[0] Operand 2
     /* 332447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332458 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332501 */     // GIR_Coverage, 6900,
     /* 332501 */     GIR_EraseRootFromParent_Done,
     /* 332502 */   // Label 6901: @332502
     /* 332502 */   GIM_Reject,
     /* 332503 */ // Label 6894: @332503
     /* 332503 */ GIM_Reject,
     /* 332504 */ // Label 6869: @332504
     /* 332504 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(332683),
     /* 332509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 332512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332520 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(332584), // Rule ID 5434 //
     /* 332525 */     // MIs[0] Operand 2
     /* 332525 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332536 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332566 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332583 */     // GIR_Coverage, 5434,
     /* 332583 */     GIR_EraseRootFromParent_Done,
     /* 332584 */   // Label 6903: @332584
     /* 332584 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(332622), // Rule ID 6893 //
     /* 332589 */     // MIs[0] Operand 2
     /* 332589 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332600 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 332600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332605 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332621 */     // GIR_Coverage, 6893,
     /* 332621 */     GIR_EraseRootFromParent_Done,
     /* 332622 */   // Label 6904: @332622
     /* 332622 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(332682), // Rule ID 6899 //
     /* 332627 */     // MIs[0] Operand 2
     /* 332627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332638 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332664 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332681 */     // GIR_Coverage, 6899,
     /* 332681 */     GIR_EraseRootFromParent_Done,
     /* 332682 */   // Label 6905: @332682
     /* 332682 */   GIM_Reject,
     /* 332683 */ // Label 6902: @332683
     /* 332683 */ GIM_Reject,
     /* 332684 */ // Label 6870: @332684
     /* 332684 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(332719), // Rule ID 8991 //
     /* 332689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 332695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332699 */   // MIs[0] Operand 2
     /* 332699 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332710 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 332710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332715 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332717 */   GIR_RootConstrainSelectedInstOperands,
     /* 332718 */   // GIR_Coverage, 8991,
     /* 332718 */   GIR_EraseRootFromParent_Done,
     /* 332719 */ // Label 6906: @332719
     /* 332719 */ GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(332754), // Rule ID 8992 //
     /* 332724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 332730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332734 */   // MIs[0] Operand 2
     /* 332734 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332745 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 332745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332750 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332752 */   GIR_RootConstrainSelectedInstOperands,
     /* 332753 */   // GIR_Coverage, 8992,
     /* 332753 */   GIR_EraseRootFromParent_Done,
     /* 332754 */ // Label 6907: @332754
     /* 332754 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(332808), // Rule ID 8999 //
     /* 332759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332769 */   // MIs[0] Operand 2
     /* 332769 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332780 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332806 */   GIR_RootConstrainSelectedInstOperands,
     /* 332807 */   // GIR_Coverage, 8999,
     /* 332807 */   GIR_EraseRootFromParent_Done,
     /* 332808 */ // Label 6908: @332808
     /* 332808 */ GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(332862), // Rule ID 9000 //
     /* 332813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332823 */   // MIs[0] Operand 2
     /* 332823 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332834 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332860 */   GIR_RootConstrainSelectedInstOperands,
     /* 332861 */   // GIR_Coverage, 9000,
     /* 332861 */   GIR_EraseRootFromParent_Done,
     /* 332862 */ // Label 6909: @332862
     /* 332862 */ GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(332916), // Rule ID 9001 //
     /* 332867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332877 */   // MIs[0] Operand 2
     /* 332877 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332888 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332900 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332914 */   GIR_RootConstrainSelectedInstOperands,
     /* 332915 */   // GIR_Coverage, 9001,
     /* 332915 */   GIR_EraseRootFromParent_Done,
     /* 332916 */ // Label 6910: @332916
     /* 332916 */ GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(332970), // Rule ID 9002 //
     /* 332921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332931 */   // MIs[0] Operand 2
     /* 332931 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 332942 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332954 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332968 */   GIR_RootConstrainSelectedInstOperands,
     /* 332969 */   // GIR_Coverage, 9002,
     /* 332969 */   GIR_EraseRootFromParent_Done,
     /* 332970 */ // Label 6911: @332970
     /* 332970 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(333041), // Rule ID 9011 //
     /* 332975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332985 */   // MIs[0] Operand 2
     /* 332985 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332996 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 332996 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332999 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333003 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333008 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333026 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333039 */   GIR_RootConstrainSelectedInstOperands,
     /* 333040 */   // GIR_Coverage, 9011,
     /* 333040 */   GIR_EraseRootFromParent_Done,
     /* 333041 */ // Label 6912: @333041
     /* 333041 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(333112), // Rule ID 9012 //
     /* 333046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333056 */   // MIs[0] Operand 2
     /* 333056 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 333067 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333079 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333110 */   GIR_RootConstrainSelectedInstOperands,
     /* 333111 */   // GIR_Coverage, 9012,
     /* 333111 */   GIR_EraseRootFromParent_Done,
     /* 333112 */ // Label 6913: @333112
     /* 333112 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(333183), // Rule ID 9013 //
     /* 333117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333127 */   // MIs[0] Operand 2
     /* 333127 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333138 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333138 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333141 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333145 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333150 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333168 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333181 */   GIR_RootConstrainSelectedInstOperands,
     /* 333182 */   // GIR_Coverage, 9013,
     /* 333182 */   GIR_EraseRootFromParent_Done,
     /* 333183 */ // Label 6914: @333183
     /* 333183 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(333254), // Rule ID 9014 //
     /* 333188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333198 */   // MIs[0] Operand 2
     /* 333198 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 333209 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333209 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333212 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333216 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333221 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333239 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333252 */   GIR_RootConstrainSelectedInstOperands,
     /* 333253 */   // GIR_Coverage, 9014,
     /* 333253 */   GIR_EraseRootFromParent_Done,
     /* 333254 */ // Label 6915: @333254
     /* 333254 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(333325), // Rule ID 9015 //
     /* 333259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333269 */   // MIs[0] Operand 2
     /* 333269 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333280 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333280 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333283 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333287 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333292 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333310 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333323 */   GIR_RootConstrainSelectedInstOperands,
     /* 333324 */   // GIR_Coverage, 9015,
     /* 333324 */   GIR_EraseRootFromParent_Done,
     /* 333325 */ // Label 6916: @333325
     /* 333325 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(333396), // Rule ID 9016 //
     /* 333330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333340 */   // MIs[0] Operand 2
     /* 333340 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 333351 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333351 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333354 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333358 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333363 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333381 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333394 */   GIR_RootConstrainSelectedInstOperands,
     /* 333395 */   // GIR_Coverage, 9016,
     /* 333395 */   GIR_EraseRootFromParent_Done,
     /* 333396 */ // Label 6917: @333396
     /* 333396 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(333467), // Rule ID 9017 //
     /* 333401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333411 */   // MIs[0] Operand 2
     /* 333411 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 333422 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333422 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333425 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333429 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333434 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333452 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333465 */   GIR_RootConstrainSelectedInstOperands,
     /* 333466 */   // GIR_Coverage, 9017,
     /* 333466 */   GIR_EraseRootFromParent_Done,
     /* 333467 */ // Label 6918: @333467
     /* 333467 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(333538), // Rule ID 9018 //
     /* 333472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333482 */   // MIs[0] Operand 2
     /* 333482 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 333493 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333493 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333496 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333500 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333505 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333523 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333536 */   GIR_RootConstrainSelectedInstOperands,
     /* 333537 */   // GIR_Coverage, 9018,
     /* 333537 */   GIR_EraseRootFromParent_Done,
     /* 333538 */ // Label 6919: @333538
     /* 333538 */ GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(333626), // Rule ID 9027 //
     /* 333543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333553 */   // MIs[0] Operand 2
     /* 333553 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333564 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333564 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333567 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333571 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333576 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333594 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333611 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333624 */   GIR_RootConstrainSelectedInstOperands,
     /* 333625 */   // GIR_Coverage, 9027,
     /* 333625 */   GIR_EraseRootFromParent_Done,
     /* 333626 */ // Label 6920: @333626
     /* 333626 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(333714), // Rule ID 9028 //
     /* 333631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333641 */   // MIs[0] Operand 2
     /* 333641 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 333652 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333652 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333655 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333659 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333664 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333670 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333673 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333677 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333682 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333699 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333712 */   GIR_RootConstrainSelectedInstOperands,
     /* 333713 */   // GIR_Coverage, 9028,
     /* 333713 */   GIR_EraseRootFromParent_Done,
     /* 333714 */ // Label 6921: @333714
     /* 333714 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(333802), // Rule ID 9029 //
     /* 333719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333729 */   // MIs[0] Operand 2
     /* 333729 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333740 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333740 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333743 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333747 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333752 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333770 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333787 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333800 */   GIR_RootConstrainSelectedInstOperands,
     /* 333801 */   // GIR_Coverage, 9029,
     /* 333801 */   GIR_EraseRootFromParent_Done,
     /* 333802 */ // Label 6922: @333802
     /* 333802 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(333890), // Rule ID 9030 //
     /* 333807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333817 */   // MIs[0] Operand 2
     /* 333817 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 333828 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333828 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333831 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333835 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333840 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333846 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333849 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333853 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333858 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333866 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333870 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333888 */   GIR_RootConstrainSelectedInstOperands,
     /* 333889 */   // GIR_Coverage, 9030,
     /* 333889 */   GIR_EraseRootFromParent_Done,
     /* 333890 */ // Label 6923: @333890
     /* 333890 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(333978), // Rule ID 9031 //
     /* 333895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333905 */   // MIs[0] Operand 2
     /* 333905 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333916 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333916 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333919 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333923 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333928 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333934 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333937 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333941 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333946 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333963 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333976 */   GIR_RootConstrainSelectedInstOperands,
     /* 333977 */   // GIR_Coverage, 9031,
     /* 333977 */   GIR_EraseRootFromParent_Done,
     /* 333978 */ // Label 6924: @333978
     /* 333978 */ GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(334066), // Rule ID 9032 //
     /* 333983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333993 */   // MIs[0] Operand 2
     /* 333993 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 334004 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334004 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334007 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334011 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334016 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334025 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334029 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334034 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334064 */   GIR_RootConstrainSelectedInstOperands,
     /* 334065 */   // GIR_Coverage, 9032,
     /* 334065 */   GIR_EraseRootFromParent_Done,
     /* 334066 */ // Label 6925: @334066
     /* 334066 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(334154), // Rule ID 9033 //
     /* 334071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334081 */   // MIs[0] Operand 2
     /* 334081 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 334092 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334092 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334095 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334099 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334104 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334110 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334113 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334117 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334122 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334139 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334152 */   GIR_RootConstrainSelectedInstOperands,
     /* 334153 */   // GIR_Coverage, 9033,
     /* 334153 */   GIR_EraseRootFromParent_Done,
     /* 334154 */ // Label 6926: @334154
     /* 334154 */ GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(334242), // Rule ID 9034 //
     /* 334159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334169 */   // MIs[0] Operand 2
     /* 334169 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 334180 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334180 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334183 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334187 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334192 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334198 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334201 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334205 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334210 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334227 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334240 */   GIR_RootConstrainSelectedInstOperands,
     /* 334241 */   // GIR_Coverage, 9034,
     /* 334241 */   GIR_EraseRootFromParent_Done,
     /* 334242 */ // Label 6927: @334242
     /* 334242 */ GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(334330), // Rule ID 9035 //
     /* 334247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334257 */   // MIs[0] Operand 2
     /* 334257 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 334268 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334268 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334271 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334275 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334280 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334286 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334289 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334293 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334298 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334315 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334328 */   GIR_RootConstrainSelectedInstOperands,
     /* 334329 */   // GIR_Coverage, 9035,
     /* 334329 */   GIR_EraseRootFromParent_Done,
     /* 334330 */ // Label 6928: @334330
     /* 334330 */ GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(334418), // Rule ID 9036 //
     /* 334335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334345 */   // MIs[0] Operand 2
     /* 334345 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 334356 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334356 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334359 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334363 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334368 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334374 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334377 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334381 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334386 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334403 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334416 */   GIR_RootConstrainSelectedInstOperands,
     /* 334417 */   // GIR_Coverage, 9036,
     /* 334417 */   GIR_EraseRootFromParent_Done,
     /* 334418 */ // Label 6929: @334418
     /* 334418 */ GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(334506), // Rule ID 9037 //
     /* 334423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334433 */   // MIs[0] Operand 2
     /* 334433 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 334444 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334456 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334474 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334504 */   GIR_RootConstrainSelectedInstOperands,
     /* 334505 */   // GIR_Coverage, 9037,
     /* 334505 */   GIR_EraseRootFromParent_Done,
     /* 334506 */ // Label 6930: @334506
     /* 334506 */ GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(334594), // Rule ID 9038 //
     /* 334511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334521 */   // MIs[0] Operand 2
     /* 334521 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 334532 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334532 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334535 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334539 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334544 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334562 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334579 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334592 */   GIR_RootConstrainSelectedInstOperands,
     /* 334593 */   // GIR_Coverage, 9038,
     /* 334593 */   GIR_EraseRootFromParent_Done,
     /* 334594 */ // Label 6931: @334594
     /* 334594 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(334682), // Rule ID 9039 //
     /* 334599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334609 */   // MIs[0] Operand 2
     /* 334609 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 334620 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334620 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334623 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334627 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334632 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334650 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334667 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334680 */   GIR_RootConstrainSelectedInstOperands,
     /* 334681 */   // GIR_Coverage, 9039,
     /* 334681 */   GIR_EraseRootFromParent_Done,
     /* 334682 */ // Label 6932: @334682
     /* 334682 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(334770), // Rule ID 9040 //
     /* 334687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334697 */   // MIs[0] Operand 2
     /* 334697 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 334708 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334708 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334711 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334715 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334720 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334726 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334729 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334733 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334738 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334755 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334768 */   GIR_RootConstrainSelectedInstOperands,
     /* 334769 */   // GIR_Coverage, 9040,
     /* 334769 */   GIR_EraseRootFromParent_Done,
     /* 334770 */ // Label 6933: @334770
     /* 334770 */ GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(334858), // Rule ID 9041 //
     /* 334775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334785 */   // MIs[0] Operand 2
     /* 334785 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 334796 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334796 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334799 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334803 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334808 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334814 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334817 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334821 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334826 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334843 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334856 */   GIR_RootConstrainSelectedInstOperands,
     /* 334857 */   // GIR_Coverage, 9041,
     /* 334857 */   GIR_EraseRootFromParent_Done,
     /* 334858 */ // Label 6934: @334858
     /* 334858 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(334946), // Rule ID 9042 //
     /* 334863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334873 */   // MIs[0] Operand 2
     /* 334873 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 334884 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334884 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334887 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334891 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334896 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334902 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334905 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334909 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334914 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334931 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334944 */   GIR_RootConstrainSelectedInstOperands,
     /* 334945 */   // GIR_Coverage, 9042,
     /* 334945 */   GIR_EraseRootFromParent_Done,
     /* 334946 */ // Label 6935: @334946
     /* 334946 */ GIM_Reject,
     /* 334947 */ // Label 6871: @334947
     /* 334947 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(334982), // Rule ID 8993 //
     /* 334952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 334958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334962 */   // MIs[0] Operand 2
     /* 334962 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334973 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 334973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334978 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334980 */   GIR_RootConstrainSelectedInstOperands,
     /* 334981 */   // GIR_Coverage, 8993,
     /* 334981 */   GIR_EraseRootFromParent_Done,
     /* 334982 */ // Label 6936: @334982
     /* 334982 */ GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(335017), // Rule ID 8994 //
     /* 334987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 334993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334997 */   // MIs[0] Operand 2
     /* 334997 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335008 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 335008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335013 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 335015 */   GIR_RootConstrainSelectedInstOperands,
     /* 335016 */   // GIR_Coverage, 8994,
     /* 335016 */   GIR_EraseRootFromParent_Done,
     /* 335017 */ // Label 6937: @335017
     /* 335017 */ GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(335071), // Rule ID 9003 //
     /* 335022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335032 */   // MIs[0] Operand 2
     /* 335032 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335043 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335043 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335046 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335050 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335055 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335069 */   GIR_RootConstrainSelectedInstOperands,
     /* 335070 */   // GIR_Coverage, 9003,
     /* 335070 */   GIR_EraseRootFromParent_Done,
     /* 335071 */ // Label 6938: @335071
     /* 335071 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(335125), // Rule ID 9004 //
     /* 335076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335086 */   // MIs[0] Operand 2
     /* 335086 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335097 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335123 */   GIR_RootConstrainSelectedInstOperands,
     /* 335124 */   // GIR_Coverage, 9004,
     /* 335124 */   GIR_EraseRootFromParent_Done,
     /* 335125 */ // Label 6939: @335125
     /* 335125 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(335179), // Rule ID 9005 //
     /* 335130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335140 */   // MIs[0] Operand 2
     /* 335140 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 335151 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335163 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335177 */   GIR_RootConstrainSelectedInstOperands,
     /* 335178 */   // GIR_Coverage, 9005,
     /* 335178 */   GIR_EraseRootFromParent_Done,
     /* 335179 */ // Label 6940: @335179
     /* 335179 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(335233), // Rule ID 9006 //
     /* 335184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335194 */   // MIs[0] Operand 2
     /* 335194 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 335205 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335217 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335231 */   GIR_RootConstrainSelectedInstOperands,
     /* 335232 */   // GIR_Coverage, 9006,
     /* 335232 */   GIR_EraseRootFromParent_Done,
     /* 335233 */ // Label 6941: @335233
     /* 335233 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(335304), // Rule ID 9019 //
     /* 335238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335248 */   // MIs[0] Operand 2
     /* 335248 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335259 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335271 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335289 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335302 */   GIR_RootConstrainSelectedInstOperands,
     /* 335303 */   // GIR_Coverage, 9019,
     /* 335303 */   GIR_EraseRootFromParent_Done,
     /* 335304 */ // Label 6942: @335304
     /* 335304 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(335375), // Rule ID 9020 //
     /* 335309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335319 */   // MIs[0] Operand 2
     /* 335319 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335330 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335330 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335333 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335337 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335342 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335360 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335373 */   GIR_RootConstrainSelectedInstOperands,
     /* 335374 */   // GIR_Coverage, 9020,
     /* 335374 */   GIR_EraseRootFromParent_Done,
     /* 335375 */ // Label 6943: @335375
     /* 335375 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(335446), // Rule ID 9021 //
     /* 335380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335390 */   // MIs[0] Operand 2
     /* 335390 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 335401 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335401 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335404 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335408 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335413 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335431 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335444 */   GIR_RootConstrainSelectedInstOperands,
     /* 335445 */   // GIR_Coverage, 9021,
     /* 335445 */   GIR_EraseRootFromParent_Done,
     /* 335446 */ // Label 6944: @335446
     /* 335446 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(335517), // Rule ID 9022 //
     /* 335451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335461 */   // MIs[0] Operand 2
     /* 335461 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 335472 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335472 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335475 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335479 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335484 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335502 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335515 */   GIR_RootConstrainSelectedInstOperands,
     /* 335516 */   // GIR_Coverage, 9022,
     /* 335516 */   GIR_EraseRootFromParent_Done,
     /* 335517 */ // Label 6945: @335517
     /* 335517 */ GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(335588), // Rule ID 9023 //
     /* 335522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335532 */   // MIs[0] Operand 2
     /* 335532 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 335543 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335543 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335546 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335550 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335555 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335573 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335586 */   GIR_RootConstrainSelectedInstOperands,
     /* 335587 */   // GIR_Coverage, 9023,
     /* 335587 */   GIR_EraseRootFromParent_Done,
     /* 335588 */ // Label 6946: @335588
     /* 335588 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(335659), // Rule ID 9024 //
     /* 335593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335603 */   // MIs[0] Operand 2
     /* 335603 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 335614 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335614 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335617 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335621 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335626 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335644 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335657 */   GIR_RootConstrainSelectedInstOperands,
     /* 335658 */   // GIR_Coverage, 9024,
     /* 335658 */   GIR_EraseRootFromParent_Done,
     /* 335659 */ // Label 6947: @335659
     /* 335659 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(335730), // Rule ID 9025 //
     /* 335664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335674 */   // MIs[0] Operand 2
     /* 335674 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 335685 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335685 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335688 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335692 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335697 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335715 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335728 */   GIR_RootConstrainSelectedInstOperands,
     /* 335729 */   // GIR_Coverage, 9025,
     /* 335729 */   GIR_EraseRootFromParent_Done,
     /* 335730 */ // Label 6948: @335730
     /* 335730 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(335801), // Rule ID 9026 //
     /* 335735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335745 */   // MIs[0] Operand 2
     /* 335745 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 335756 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335756 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335759 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335763 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335768 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335786 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335799 */   GIR_RootConstrainSelectedInstOperands,
     /* 335800 */   // GIR_Coverage, 9026,
     /* 335800 */   GIR_EraseRootFromParent_Done,
     /* 335801 */ // Label 6949: @335801
     /* 335801 */ GIM_Reject,
     /* 335802 */ // Label 6872: @335802
     /* 335802 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335837), // Rule ID 9043 //
     /* 335807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 335813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335817 */   // MIs[0] Operand 2
     /* 335817 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335828 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 335828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 335831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335833 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 335835 */   GIR_RootConstrainSelectedInstOperands,
     /* 335836 */   // GIR_Coverage, 9043,
     /* 335836 */   GIR_EraseRootFromParent_Done,
     /* 335837 */ // Label 6950: @335837
     /* 335837 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(335872), // Rule ID 9044 //
     /* 335842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 335848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335852 */   // MIs[0] Operand 2
     /* 335852 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335863 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 335863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 335866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335868 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 335870 */   GIR_RootConstrainSelectedInstOperands,
     /* 335871 */   // GIR_Coverage, 9044,
     /* 335871 */   GIR_EraseRootFromParent_Done,
     /* 335872 */ // Label 6951: @335872
     /* 335872 */ GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(335926), // Rule ID 9049 //
     /* 335877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335887 */   // MIs[0] Operand 2
     /* 335887 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335898 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 335898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 335901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 335905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335910 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 335914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 335919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335924 */   GIR_RootConstrainSelectedInstOperands,
     /* 335925 */   // GIR_Coverage, 9049,
     /* 335925 */   GIR_EraseRootFromParent_Done,
     /* 335926 */ // Label 6952: @335926
     /* 335926 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(335980), // Rule ID 9050 //
     /* 335931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335941 */   // MIs[0] Operand 2
     /* 335941 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335952 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 335952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 335955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 335959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 335968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 335973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335978 */   GIR_RootConstrainSelectedInstOperands,
     /* 335979 */   // GIR_Coverage, 9050,
     /* 335979 */   GIR_EraseRootFromParent_Done,
     /* 335980 */ // Label 6953: @335980
     /* 335980 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(336034), // Rule ID 9051 //
     /* 335985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335995 */   // MIs[0] Operand 2
     /* 335995 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336006 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 336006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 336009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 336022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 336027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336032 */   GIR_RootConstrainSelectedInstOperands,
     /* 336033 */   // GIR_Coverage, 9051,
     /* 336033 */   GIR_EraseRootFromParent_Done,
     /* 336034 */ // Label 6954: @336034
     /* 336034 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(336088), // Rule ID 9052 //
     /* 336039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 336045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336049 */   // MIs[0] Operand 2
     /* 336049 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 336060 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 336060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 336063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 336076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 336081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336086 */   GIR_RootConstrainSelectedInstOperands,
     /* 336087 */   // GIR_Coverage, 9052,
     /* 336087 */   GIR_EraseRootFromParent_Done,
     /* 336088 */ // Label 6955: @336088
     /* 336088 */ GIM_Reject,
     /* 336089 */ // Label 6873: @336089
     /* 336089 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(336158),
     /* 336094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 336097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336101 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(336129), // Rule ID 9047 //
     /* 336106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336109 */     // MIs[0] Operand 2
     /* 336109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336120 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 336120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 336123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336127 */     GIR_RootConstrainSelectedInstOperands,
     /* 336128 */     // GIR_Coverage, 9047,
     /* 336128 */     GIR_EraseRootFromParent_Done,
     /* 336129 */   // Label 6957: @336129
     /* 336129 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(336157), // Rule ID 9048 //
     /* 336134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336137 */     // MIs[0] Operand 2
     /* 336137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 336148 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 336148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 336151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336155 */     GIR_RootConstrainSelectedInstOperands,
     /* 336156 */     // GIR_Coverage, 9048,
     /* 336156 */     GIR_EraseRootFromParent_Done,
     /* 336157 */   // Label 6958: @336157
     /* 336157 */   GIM_Reject,
     /* 336158 */ // Label 6956: @336158
     /* 336158 */ GIM_Reject,
     /* 336159 */ // Label 6874: @336159
     /* 336159 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(336194), // Rule ID 8995 //
     /* 336164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 336170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336174 */   // MIs[0] Operand 2
     /* 336174 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336185 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 336185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336190 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336192 */   GIR_RootConstrainSelectedInstOperands,
     /* 336193 */   // GIR_Coverage, 8995,
     /* 336193 */   GIR_EraseRootFromParent_Done,
     /* 336194 */ // Label 6959: @336194
     /* 336194 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(336229), // Rule ID 8996 //
     /* 336199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 336205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336209 */   // MIs[0] Operand 2
     /* 336209 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336220 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 336220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336227 */   GIR_RootConstrainSelectedInstOperands,
     /* 336228 */   // GIR_Coverage, 8996,
     /* 336228 */   GIR_EraseRootFromParent_Done,
     /* 336229 */ // Label 6960: @336229
     /* 336229 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(336283), // Rule ID 9007 //
     /* 336234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336244 */   // MIs[0] Operand 2
     /* 336244 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336255 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336267 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336281 */   GIR_RootConstrainSelectedInstOperands,
     /* 336282 */   // GIR_Coverage, 9007,
     /* 336282 */   GIR_EraseRootFromParent_Done,
     /* 336283 */ // Label 6961: @336283
     /* 336283 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(336337), // Rule ID 9008 //
     /* 336288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336298 */   // MIs[0] Operand 2
     /* 336298 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336309 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336335 */   GIR_RootConstrainSelectedInstOperands,
     /* 336336 */   // GIR_Coverage, 9008,
     /* 336336 */   GIR_EraseRootFromParent_Done,
     /* 336337 */ // Label 6962: @336337
     /* 336337 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(336391), // Rule ID 9009 //
     /* 336342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336352 */   // MIs[0] Operand 2
     /* 336352 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 336363 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336375 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336389 */   GIR_RootConstrainSelectedInstOperands,
     /* 336390 */   // GIR_Coverage, 9009,
     /* 336390 */   GIR_EraseRootFromParent_Done,
     /* 336391 */ // Label 6963: @336391
     /* 336391 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(336445), // Rule ID 9010 //
     /* 336396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336406 */   // MIs[0] Operand 2
     /* 336406 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 336417 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336443 */   GIR_RootConstrainSelectedInstOperands,
     /* 336444 */   // GIR_Coverage, 9010,
     /* 336444 */   GIR_EraseRootFromParent_Done,
     /* 336445 */ // Label 6964: @336445
     /* 336445 */ GIM_Reject,
     /* 336446 */ // Label 6875: @336446
     /* 336446 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(336515),
     /* 336451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 336454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336458 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(336486), // Rule ID 9045 //
     /* 336463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336466 */     // MIs[0] Operand 2
     /* 336466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336477 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 336477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 336480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336484 */     GIR_RootConstrainSelectedInstOperands,
     /* 336485 */     // GIR_Coverage, 9045,
     /* 336485 */     GIR_EraseRootFromParent_Done,
     /* 336486 */   // Label 6966: @336486
     /* 336486 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(336514), // Rule ID 9046 //
     /* 336491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336494 */     // MIs[0] Operand 2
     /* 336494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336505 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 336505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336512 */     GIR_RootConstrainSelectedInstOperands,
     /* 336513 */     // GIR_Coverage, 9046,
     /* 336513 */     GIR_EraseRootFromParent_Done,
     /* 336514 */   // Label 6967: @336514
     /* 336514 */   GIM_Reject,
     /* 336515 */ // Label 6965: @336515
     /* 336515 */ GIM_Reject,
     /* 336516 */ // Label 6876: @336516
     /* 336516 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(336585),
     /* 336521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336528 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(336556), // Rule ID 8997 //
     /* 336533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336536 */     // MIs[0] Operand 2
     /* 336536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336547 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 336547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336554 */     GIR_RootConstrainSelectedInstOperands,
     /* 336555 */     // GIR_Coverage, 8997,
     /* 336555 */     GIR_EraseRootFromParent_Done,
     /* 336556 */   // Label 6969: @336556
     /* 336556 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(336584), // Rule ID 8998 //
     /* 336561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336564 */     // MIs[0] Operand 2
     /* 336564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 336575 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 336575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336582 */     GIR_RootConstrainSelectedInstOperands,
     /* 336583 */     // GIR_Coverage, 8998,
     /* 336583 */     GIR_EraseRootFromParent_Done,
     /* 336584 */   // Label 6970: @336584
     /* 336584 */   GIM_Reject,
     /* 336585 */ // Label 6968: @336585
     /* 336585 */ GIM_Reject,
     /* 336586 */ // Label 6877: @336586
     /* 336586 */ GIM_Reject,
     /* 336587 */ // Label 90: @336587
     /* 336587 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6986*/ GIMT_Encode4(365731),
     /* 336598 */ /*GILLT_s64*//*Label 6971*/ GIMT_Encode4(336682), GIMT_Encode4(0),
     /* 336606 */ /*GILLT_v2s32*//*Label 6972*/ GIMT_Encode4(337392),
     /* 336610 */ /*GILLT_v2s64*//*Label 6973*/ GIMT_Encode4(340923),
     /* 336614 */ /*GILLT_v4s16*//*Label 6974*/ GIMT_Encode4(344164),
     /* 336618 */ /*GILLT_v4s32*//*Label 6975*/ GIMT_Encode4(347804),
     /* 336622 */ /*GILLT_v8s8*//*Label 6976*/ GIMT_Encode4(350872),
     /* 336626 */ /*GILLT_v8s16*//*Label 6977*/ GIMT_Encode4(352716),
     /* 336630 */ /*GILLT_v16s8*//*Label 6978*/ GIMT_Encode4(356135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 336642 */ /*GILLT_nxv2s16*//*Label 6979*/ GIMT_Encode4(357937),
     /* 336646 */ /*GILLT_nxv2s32*//*Label 6980*/ GIMT_Encode4(358062),
     /* 336650 */ /*GILLT_nxv2s64*//*Label 6981*/ GIMT_Encode4(358187), GIMT_Encode4(0),
     /* 336658 */ /*GILLT_nxv4s16*//*Label 6982*/ GIMT_Encode4(360165),
     /* 336662 */ /*GILLT_nxv4s32*//*Label 6983*/ GIMT_Encode4(360317), GIMT_Encode4(0),
     /* 336670 */ /*GILLT_nxv8s16*//*Label 6984*/ GIMT_Encode4(362349), GIMT_Encode4(0),
     /* 336678 */ /*GILLT_nxv16s8*//*Label 6985*/ GIMT_Encode4(364617),
     /* 336682 */ // Label 6971: @336682
     /* 336682 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(337391),
     /* 336687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 336693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336700 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(336830), // Rule ID 5734 //
     /* 336705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336738 */     // MIs[2] Operand 1
     /* 336738 */     // No operand predicates
     /* 336738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336746 */     // MIs[3] Operand 1
     /* 336746 */     // No operand predicates
     /* 336746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336748 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336760 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336767 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336775 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336812 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336829 */     // GIR_Coverage, 5734,
     /* 336829 */     GIR_EraseRootFromParent_Done,
     /* 336830 */   // Label 6988: @336830
     /* 336830 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(336991), // Rule ID 5735 //
     /* 336835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336868 */     // MIs[2] Operand 1
     /* 336868 */     // No operand predicates
     /* 336868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336876 */     // MIs[3] Operand 1
     /* 336876 */     // No operand predicates
     /* 336876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336878 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336890 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336893 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336897 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336900 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336905 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336922 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336925 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336929 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336973 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336990 */     // GIR_Coverage, 5735,
     /* 336990 */     GIR_EraseRootFromParent_Done,
     /* 336991 */   // Label 6989: @336991
     /* 336991 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(337121), // Rule ID 5766 //
     /* 336996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337029 */     // MIs[2] Operand 1
     /* 337029 */     // No operand predicates
     /* 337029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337037 */     // MIs[3] Operand 1
     /* 337037 */     // No operand predicates
     /* 337037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337039 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337051 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 337078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337103 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337120 */     // GIR_Coverage, 5766,
     /* 337120 */     GIR_EraseRootFromParent_Done,
     /* 337121 */   // Label 6990: @337121
     /* 337121 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(337282), // Rule ID 5767 //
     /* 337126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 337142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337159 */     // MIs[2] Operand 1
     /* 337159 */     // No operand predicates
     /* 337159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337167 */     // MIs[3] Operand 1
     /* 337167 */     // No operand predicates
     /* 337167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337169 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337169 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337172 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337176 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337181 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337184 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337188 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337191 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337213 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337216 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337220 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 337240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337281 */     // GIR_Coverage, 5767,
     /* 337281 */     GIR_EraseRootFromParent_Done,
     /* 337282 */   // Label 6991: @337282
     /* 337282 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(337318), // Rule ID 6673 //
     /* 337287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337305 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 337305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337317 */     // GIR_Coverage, 6673,
     /* 337317 */     GIR_EraseRootFromParent_Done,
     /* 337318 */   // Label 6992: @337318
     /* 337318 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(337354), // Rule ID 6675 //
     /* 337323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337341 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 337341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337353 */     // GIR_Coverage, 6675,
     /* 337353 */     GIR_EraseRootFromParent_Done,
     /* 337354 */   // Label 6993: @337354
     /* 337354 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(337390), // Rule ID 6677 //
     /* 337359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337377 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 337377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337380 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 337382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337389 */     // GIR_Coverage, 6677,
     /* 337389 */     GIR_EraseRootFromParent_Done,
     /* 337390 */   // Label 6994: @337390
     /* 337390 */   GIM_Reject,
     /* 337391 */ // Label 6987: @337391
     /* 337391 */ GIM_Reject,
     /* 337392 */ // Label 6972: @337392
     /* 337392 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340922),
     /* 337397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337410 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(337519), // Rule ID 4272 //
     /* 337415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337435 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337459 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337486 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337518 */     // GIR_Coverage, 4272,
     /* 337518 */     GIR_EraseRootFromParent_Done,
     /* 337519 */   // Label 6996: @337519
     /* 337519 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(337628), // Rule ID 4273 //
     /* 337524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337534 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337544 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337551 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337568 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337627 */     // GIR_Coverage, 4273,
     /* 337627 */     GIR_EraseRootFromParent_Done,
     /* 337628 */   // Label 6997: @337628
     /* 337628 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(337737), // Rule ID 4380 //
     /* 337633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337653 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337660 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337677 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337704 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337736 */     // GIR_Coverage, 4380,
     /* 337736 */     GIR_EraseRootFromParent_Done,
     /* 337737 */   // Label 6998: @337737
     /* 337737 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(337846), // Rule ID 4381 //
     /* 337742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337746 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337752 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337762 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337769 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337786 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337813 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337845 */     // GIR_Coverage, 4381,
     /* 337845 */     GIR_EraseRootFromParent_Done,
     /* 337846 */   // Label 6999: @337846
     /* 337846 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(337951), // Rule ID 4278 //
     /* 337851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337867 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337870 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337874 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337891 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337918 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337950 */     // GIR_Coverage, 4278,
     /* 337950 */     GIR_EraseRootFromParent_Done,
     /* 337951 */   // Label 7000: @337951
     /* 337951 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(338056), // Rule ID 4280 //
     /* 337956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337972 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337979 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337996 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 338003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338055 */     // GIR_Coverage, 4280,
     /* 338055 */     GIR_EraseRootFromParent_Done,
     /* 338056 */   // Label 7001: @338056
     /* 338056 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(338161), // Rule ID 4386 //
     /* 338061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338077 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338084 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 338101 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 338101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 338108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338128 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338160 */     // GIR_Coverage, 4386,
     /* 338160 */     GIR_EraseRootFromParent_Done,
     /* 338161 */   // Label 7002: @338161
     /* 338161 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(338266), // Rule ID 4388 //
     /* 338166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 338206 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 338206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 338213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338265 */     // GIR_Coverage, 4388,
     /* 338265 */     GIR_EraseRootFromParent_Done,
     /* 338266 */   // Label 7003: @338266
     /* 338266 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(338370), // Rule ID 4270 //
     /* 338271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338275 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338281 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338291 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338298 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338315 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338337 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338369 */     // GIR_Coverage, 4270,
     /* 338369 */     GIR_EraseRootFromParent_Done,
     /* 338370 */   // Label 7004: @338370
     /* 338370 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(338474), // Rule ID 4271 //
     /* 338375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338395 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338419 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338473 */     // GIR_Coverage, 4271,
     /* 338473 */     GIR_EraseRootFromParent_Done,
     /* 338474 */   // Label 7005: @338474
     /* 338474 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(338578), // Rule ID 4378 //
     /* 338479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338506 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338523 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338545 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338577 */     // GIR_Coverage, 4378,
     /* 338577 */     GIR_EraseRootFromParent_Done,
     /* 338578 */   // Label 7006: @338578
     /* 338578 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(338682), // Rule ID 4379 //
     /* 338583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338587 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338593 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338603 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338610 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338627 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338681 */     // GIR_Coverage, 4379,
     /* 338681 */     GIR_EraseRootFromParent_Done,
     /* 338682 */   // Label 7007: @338682
     /* 338682 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(338782), // Rule ID 4274 //
     /* 338687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338703 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338710 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338727 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338781 */     // GIR_Coverage, 4274,
     /* 338781 */     GIR_EraseRootFromParent_Done,
     /* 338782 */   // Label 7008: @338782
     /* 338782 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(338882), // Rule ID 4276 //
     /* 338787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338827 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338881 */     // GIR_Coverage, 4276,
     /* 338881 */     GIR_EraseRootFromParent_Done,
     /* 338882 */   // Label 7009: @338882
     /* 338882 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(338982), // Rule ID 4382 //
     /* 338887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338903 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338910 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338927 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338949 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338981 */     // GIR_Coverage, 4382,
     /* 338981 */     GIR_EraseRootFromParent_Done,
     /* 338982 */   // Label 7010: @338982
     /* 338982 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(339082), // Rule ID 4384 //
     /* 338987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339003 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 339027 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 339027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 339034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 339071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339081 */     // GIR_Coverage, 4384,
     /* 339081 */     GIR_EraseRootFromParent_Done,
     /* 339082 */   // Label 7011: @339082
     /* 339082 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(339202), // Rule ID 6452 //
     /* 339087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339106 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339109 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339113 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339120 */     // MIs[2] Rn
     /* 339120 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339135 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 339138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 339156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339161 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339171 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339184 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339201 */     // GIR_Coverage, 6452,
     /* 339201 */     GIR_EraseRootFromParent_Done,
     /* 339202 */   // Label 7012: @339202
     /* 339202 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(339322), // Rule ID 6454 //
     /* 339207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339229 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339233 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339240 */     // MIs[2] Rn
     /* 339240 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339255 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 339258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 339276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339291 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339304 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339321 */     // GIR_Coverage, 6454,
     /* 339321 */     GIR_EraseRootFromParent_Done,
     /* 339322 */   // Label 7013: @339322
     /* 339322 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(339452), // Rule ID 5726 //
     /* 339327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339360 */     // MIs[2] Operand 1
     /* 339360 */     // No operand predicates
     /* 339360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339368 */     // MIs[3] Operand 1
     /* 339368 */     // No operand predicates
     /* 339368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339370 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339385 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339389 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339434 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339451 */     // GIR_Coverage, 5726,
     /* 339451 */     GIR_EraseRootFromParent_Done,
     /* 339452 */   // Label 7014: @339452
     /* 339452 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(339613), // Rule ID 5727 //
     /* 339457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339490 */     // MIs[2] Operand 1
     /* 339490 */     // No operand predicates
     /* 339490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339498 */     // MIs[3] Operand 1
     /* 339498 */     // No operand predicates
     /* 339498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339500 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339512 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 339515 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339519 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339522 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339527 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339595 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339612 */     // GIR_Coverage, 5727,
     /* 339612 */     GIR_EraseRootFromParent_Done,
     /* 339613 */   // Label 7015: @339613
     /* 339613 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(339743), // Rule ID 5758 //
     /* 339618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339651 */     // MIs[2] Operand 1
     /* 339651 */     // No operand predicates
     /* 339651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339659 */     // MIs[3] Operand 1
     /* 339659 */     // No operand predicates
     /* 339659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339661 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339673 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339676 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339742 */     // GIR_Coverage, 5758,
     /* 339742 */     GIR_EraseRootFromParent_Done,
     /* 339743 */   // Label 7016: @339743
     /* 339743 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(339904), // Rule ID 5759 //
     /* 339748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339781 */     // MIs[2] Operand 1
     /* 339781 */     // No operand predicates
     /* 339781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339789 */     // MIs[3] Operand 1
     /* 339789 */     // No operand predicates
     /* 339789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339791 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339791 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339794 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339798 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339803 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 339806 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339810 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339813 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339818 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339835 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339842 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339845 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339850 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339886 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339903 */     // GIR_Coverage, 5759,
     /* 339903 */     GIR_EraseRootFromParent_Done,
     /* 339904 */   // Label 7017: @339904
     /* 339904 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(339970), // Rule ID 5677 //
     /* 339909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339927 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 339927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 339930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 339954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339969 */     // GIR_Coverage, 5677,
     /* 339969 */     GIR_EraseRootFromParent_Done,
     /* 339970 */   // Label 7018: @339970
     /* 339970 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(340036), // Rule ID 5689 //
     /* 339975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339993 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 339993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 339996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340035 */     // GIR_Coverage, 5689,
     /* 340035 */     GIR_EraseRootFromParent_Done,
     /* 340036 */   // Label 7019: @340036
     /* 340036 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(340171), // Rule ID 5697 //
     /* 340041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340053 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340057 */     // MIs[1] Operand 1
     /* 340057 */     // No operand predicates
     /* 340057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340065 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340069 */     // MIs[2] Operand 1
     /* 340069 */     // No operand predicates
     /* 340069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340071 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 340071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340097 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340104 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340107 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 340129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 340140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340170 */     // GIR_Coverage, 5697,
     /* 340170 */     GIR_EraseRootFromParent_Done,
     /* 340171 */   // Label 7020: @340171
     /* 340171 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(340303), // Rule ID 6460 //
     /* 340176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340195 */     // MIs[1] Rn
     /* 340195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340216 */     // MIs[2] Operand 1
     /* 340216 */     // No operand predicates
     /* 340216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340218 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 340218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340230 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340233 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340237 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340240 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 340257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340262 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340285 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340302 */     // GIR_Coverage, 6460,
     /* 340302 */     GIR_EraseRootFromParent_Done,
     /* 340303 */   // Label 7021: @340303
     /* 340303 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(340435), // Rule ID 6461 //
     /* 340308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340327 */     // MIs[1] Rn
     /* 340327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340348 */     // MIs[2] Operand 1
     /* 340348 */     // No operand predicates
     /* 340348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340350 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 340350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340362 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 340389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340434 */     // GIR_Coverage, 6461,
     /* 340434 */     GIR_EraseRootFromParent_Done,
     /* 340435 */   // Label 7022: @340435
     /* 340435 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(340618), // Rule ID 5769 //
     /* 340440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 340452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340465 */     // MIs[2] Operand 1
     /* 340465 */     // No operand predicates
     /* 340465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340467 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340467 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 340470 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340474 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340481 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 340484 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340488 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340493 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340496 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 340500 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 340503 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340508 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340513 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340544 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 340551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 340576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 340587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340590 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340617 */     // GIR_Coverage, 5769,
     /* 340617 */     GIR_EraseRootFromParent_Done,
     /* 340618 */   // Label 7023: @340618
     /* 340618 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(340796), // Rule ID 5700 //
     /* 340623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340643 */     // MIs[1] Operand 1
     /* 340643 */     // No operand predicates
     /* 340643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340645 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340645 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 340648 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340652 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340659 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 340662 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340666 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340671 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340674 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340678 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 340681 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340686 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340691 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340696 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340699 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340703 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340722 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340725 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340729 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 340754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340778 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340795 */     // GIR_Coverage, 5700,
     /* 340795 */     GIR_EraseRootFromParent_Done,
     /* 340796 */   // Label 7024: @340796
     /* 340796 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(340921), // Rule ID 5703 //
     /* 340801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340821 */     // MIs[1] Operand 1
     /* 340821 */     // No operand predicates
     /* 340821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340823 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 340823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340849 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340852 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340856 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 340881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340920 */     // GIR_Coverage, 5703,
     /* 340920 */     GIR_EraseRootFromParent_Done,
     /* 340921 */   // Label 7025: @340921
     /* 340921 */   GIM_Reject,
     /* 340922 */ // Label 6995: @340922
     /* 340922 */ GIM_Reject,
     /* 340923 */ // Label 6973: @340923
     /* 340923 */ GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(344163),
     /* 340928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 340934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340941 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(341050), // Rule ID 4296 //
     /* 340946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340950 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340956 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340966 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340973 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 340990 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 340990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 340997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341049 */     // GIR_Coverage, 4296,
     /* 341049 */     GIR_EraseRootFromParent_Done,
     /* 341050 */   // Label 7027: @341050
     /* 341050 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(341159), // Rule ID 4297 //
     /* 341055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341059 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341065 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341075 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341082 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341099 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341126 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341158 */     // GIR_Coverage, 4297,
     /* 341158 */     GIR_EraseRootFromParent_Done,
     /* 341159 */   // Label 7028: @341159
     /* 341159 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(341268), // Rule ID 4404 //
     /* 341164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341174 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341184 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341191 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341208 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341235 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341267 */     // GIR_Coverage, 4404,
     /* 341267 */     GIR_EraseRootFromParent_Done,
     /* 341268 */   // Label 7029: @341268
     /* 341268 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(341377), // Rule ID 4405 //
     /* 341273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341277 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341283 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341293 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341300 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341317 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341376 */     // GIR_Coverage, 4405,
     /* 341376 */     GIR_EraseRootFromParent_Done,
     /* 341377 */   // Label 7030: @341377
     /* 341377 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(341482), // Rule ID 4302 //
     /* 341382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341398 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341405 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341422 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341481 */     // GIR_Coverage, 4302,
     /* 341481 */     GIR_EraseRootFromParent_Done,
     /* 341482 */   // Label 7031: @341482
     /* 341482 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(341587), // Rule ID 4304 //
     /* 341487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341503 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341510 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341527 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341554 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341586 */     // GIR_Coverage, 4304,
     /* 341586 */     GIR_EraseRootFromParent_Done,
     /* 341587 */   // Label 7032: @341587
     /* 341587 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(341692), // Rule ID 4410 //
     /* 341592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341608 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341615 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341632 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341659 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341691 */     // GIR_Coverage, 4410,
     /* 341691 */     GIR_EraseRootFromParent_Done,
     /* 341692 */   // Label 7033: @341692
     /* 341692 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(341797), // Rule ID 4412 //
     /* 341697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341713 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341720 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341737 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341764 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341796 */     // GIR_Coverage, 4412,
     /* 341796 */     GIR_EraseRootFromParent_Done,
     /* 341797 */   // Label 7034: @341797
     /* 341797 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(341901), // Rule ID 4294 //
     /* 341802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341806 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341812 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341822 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341829 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 341846 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 341846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 341853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341868 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341900 */     // GIR_Coverage, 4294,
     /* 341900 */     GIR_EraseRootFromParent_Done,
     /* 341901 */   // Label 7035: @341901
     /* 341901 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(342005), // Rule ID 4295 //
     /* 341906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341910 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341916 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341926 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341933 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 341950 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 341950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 341957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342004 */     // GIR_Coverage, 4295,
     /* 342004 */     GIR_EraseRootFromParent_Done,
     /* 342005 */   // Label 7036: @342005
     /* 342005 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(342109), // Rule ID 4402 //
     /* 342010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342020 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342030 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342037 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342054 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342108 */     // GIR_Coverage, 4402,
     /* 342108 */     GIR_EraseRootFromParent_Done,
     /* 342109 */   // Label 7037: @342109
     /* 342109 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(342213), // Rule ID 4403 //
     /* 342114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342118 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342124 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342134 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342141 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342158 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342180 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342212 */     // GIR_Coverage, 4403,
     /* 342212 */     GIR_EraseRootFromParent_Done,
     /* 342213 */   // Label 7038: @342213
     /* 342213 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(342313), // Rule ID 4298 //
     /* 342218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342234 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342241 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342258 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342312 */     // GIR_Coverage, 4298,
     /* 342312 */     GIR_EraseRootFromParent_Done,
     /* 342313 */   // Label 7039: @342313
     /* 342313 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(342413), // Rule ID 4300 //
     /* 342318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342334 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342341 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342358 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342380 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342412 */     // GIR_Coverage, 4300,
     /* 342412 */     GIR_EraseRootFromParent_Done,
     /* 342413 */   // Label 7040: @342413
     /* 342413 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(342513), // Rule ID 4406 //
     /* 342418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342434 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342441 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342458 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342480 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342512 */     // GIR_Coverage, 4406,
     /* 342512 */     GIR_EraseRootFromParent_Done,
     /* 342513 */   // Label 7041: @342513
     /* 342513 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(342613), // Rule ID 4408 //
     /* 342518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342534 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342541 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342558 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342580 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342612 */     // GIR_Coverage, 4408,
     /* 342612 */     GIR_EraseRootFromParent_Done,
     /* 342613 */   // Label 7042: @342613
     /* 342613 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(342726), // Rule ID 5732 //
     /* 342618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 342642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342655 */     // MIs[3] Operand 1
     /* 342655 */     // No operand predicates
     /* 342655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342661 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 342664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 342668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 342680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 342707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342725 */     // GIR_Coverage, 5732,
     /* 342725 */     GIR_EraseRootFromParent_Done,
     /* 342726 */   // Label 7043: @342726
     /* 342726 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(342839), // Rule ID 5764 //
     /* 342731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 342755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342768 */     // MIs[3] Operand 1
     /* 342768 */     // No operand predicates
     /* 342768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342774 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 342777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 342781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 342793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 342820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342838 */     // GIR_Coverage, 5764,
     /* 342838 */     GIR_EraseRootFromParent_Done,
     /* 342839 */   // Label 7044: @342839
     /* 342839 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(342917), // Rule ID 1941 //
     /* 342844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342884 */     // MIs[2] Operand 1
     /* 342884 */     // No operand predicates
     /* 342884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342892 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342896 */     // MIs[3] Operand 1
     /* 342896 */     // No operand predicates
     /* 342896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342898 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 342898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 342901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 342915 */     GIR_RootConstrainSelectedInstOperands,
     /* 342916 */     // GIR_Coverage, 1941,
     /* 342916 */     GIR_EraseRootFromParent_Done,
     /* 342917 */   // Label 7045: @342917
     /* 342917 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(343012), // Rule ID 7440 //
     /* 342922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 342925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 342937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 342945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342949 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 342952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342956 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 342963 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 342966 */     // MIs[2] Rn
     /* 342966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 342970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342987 */     // MIs[3] Operand 1
     /* 342987 */     // No operand predicates
     /* 342987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342989 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15871>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 342992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 343003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 343010 */     GIR_RootConstrainSelectedInstOperands,
     /* 343011 */     // GIR_Coverage, 7440,
     /* 343011 */     GIR_EraseRootFromParent_Done,
     /* 343012 */   // Label 7046: @343012
     /* 343012 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(343101), // Rule ID 5729 //
     /* 343017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 343029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343045 */     // MIs[2] Operand 1
     /* 343045 */     // No operand predicates
     /* 343045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343053 */     // MIs[3] Operand 1
     /* 343053 */     // No operand predicates
     /* 343053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343055 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 343055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 343073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343099 */     GIR_RootConstrainSelectedInstOperands,
     /* 343100 */     // GIR_Coverage, 5729,
     /* 343100 */     GIR_EraseRootFromParent_Done,
     /* 343101 */   // Label 7047: @343101
     /* 343101 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(343190), // Rule ID 5761 //
     /* 343106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 343118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343134 */     // MIs[2] Operand 1
     /* 343134 */     // No operand predicates
     /* 343134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343142 */     // MIs[3] Operand 1
     /* 343142 */     // No operand predicates
     /* 343142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343144 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 343144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343156 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 343162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343188 */     GIR_RootConstrainSelectedInstOperands,
     /* 343189 */     // GIR_Coverage, 5761,
     /* 343189 */     GIR_EraseRootFromParent_Done,
     /* 343190 */   // Label 7048: @343190
     /* 343190 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(343257), // Rule ID 5731 //
     /* 343195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343228 */     // MIs[2] Operand 1
     /* 343228 */     // No operand predicates
     /* 343228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343236 */     // MIs[3] Operand 1
     /* 343236 */     // No operand predicates
     /* 343236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343238 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 343238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343255 */     GIR_RootConstrainSelectedInstOperands,
     /* 343256 */     // GIR_Coverage, 5731,
     /* 343256 */     GIR_EraseRootFromParent_Done,
     /* 343257 */   // Label 7049: @343257
     /* 343257 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(343355), // Rule ID 5733 //
     /* 343262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343295 */     // MIs[2] Operand 1
     /* 343295 */     // No operand predicates
     /* 343295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343303 */     // MIs[3] Operand 1
     /* 343303 */     // No operand predicates
     /* 343303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343305 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 343305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343353 */     GIR_RootConstrainSelectedInstOperands,
     /* 343354 */     // GIR_Coverage, 5733,
     /* 343354 */     GIR_EraseRootFromParent_Done,
     /* 343355 */   // Label 7050: @343355
     /* 343355 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(343422), // Rule ID 5763 //
     /* 343360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343393 */     // MIs[2] Operand 1
     /* 343393 */     // No operand predicates
     /* 343393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343401 */     // MIs[3] Operand 1
     /* 343401 */     // No operand predicates
     /* 343401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343403 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 343403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343420 */     GIR_RootConstrainSelectedInstOperands,
     /* 343421 */     // GIR_Coverage, 5763,
     /* 343421 */     GIR_EraseRootFromParent_Done,
     /* 343422 */   // Label 7051: @343422
     /* 343422 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(343520), // Rule ID 5765 //
     /* 343427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343460 */     // MIs[2] Operand 1
     /* 343460 */     // No operand predicates
     /* 343460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343468 */     // MIs[3] Operand 1
     /* 343468 */     // No operand predicates
     /* 343468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343470 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 343470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343518 */     GIR_RootConstrainSelectedInstOperands,
     /* 343519 */     // GIR_Coverage, 5765,
     /* 343519 */     GIR_EraseRootFromParent_Done,
     /* 343520 */   // Label 7052: @343520
     /* 343520 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(343586), // Rule ID 5681 //
     /* 343525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343543 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 343543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343585 */     // GIR_Coverage, 5681,
     /* 343585 */     GIR_EraseRootFromParent_Done,
     /* 343586 */   // Label 7053: @343586
     /* 343586 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(343652), // Rule ID 5691 //
     /* 343591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343609 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 343609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343651 */     // GIR_Coverage, 5691,
     /* 343651 */     GIR_EraseRootFromParent_Done,
     /* 343652 */   // Label 7054: @343652
     /* 343652 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(343721), // Rule ID 6443 //
     /* 343657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343672 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343676 */     // MIs[1] Rn
     /* 343676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343697 */     // MIs[2] Operand 1
     /* 343697 */     // No operand predicates
     /* 343697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343699 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 343702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343719 */     GIR_RootConstrainSelectedInstOperands,
     /* 343720 */     // GIR_Coverage, 6443,
     /* 343720 */     GIR_EraseRootFromParent_Done,
     /* 343721 */   // Label 7055: @343721
     /* 343721 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(343790), // Rule ID 6444 //
     /* 343726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343745 */     // MIs[1] Rn
     /* 343745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343762 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343766 */     // MIs[2] Operand 1
     /* 343766 */     // No operand predicates
     /* 343766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343768 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 343771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343788 */     GIR_RootConstrainSelectedInstOperands,
     /* 343789 */     // GIR_Coverage, 6444,
     /* 343789 */     GIR_EraseRootFromParent_Done,
     /* 343790 */   // Label 7056: @343790
     /* 343790 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(343872), // Rule ID 7439 //
     /* 343795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 343798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343810 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 343813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343817 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 343824 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 343827 */     // MIs[1] Rn
     /* 343827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343844 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343848 */     // MIs[2] Operand 1
     /* 343848 */     // No operand predicates
     /* 343848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343850 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15871>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 343853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343870 */     GIR_RootConstrainSelectedInstOperands,
     /* 343871 */     // GIR_Coverage, 7439,
     /* 343871 */     GIR_EraseRootFromParent_Done,
     /* 343872 */   // Label 7057: @343872
     /* 343872 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(343921), // Rule ID 5698 //
     /* 343877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343885 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343889 */     // MIs[1] Operand 1
     /* 343889 */     // No operand predicates
     /* 343889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343897 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343901 */     // MIs[2] Operand 1
     /* 343901 */     // No operand predicates
     /* 343901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343903 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 343903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 343906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 343913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343919 */     GIR_RootConstrainSelectedInstOperands,
     /* 343920 */     // GIR_Coverage, 5698,
     /* 343920 */     GIR_EraseRootFromParent_Done,
     /* 343921 */   // Label 7058: @343921
     /* 343921 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(344022), // Rule ID 5770 //
     /* 343926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 343934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343951 */     // MIs[2] Operand 1
     /* 343951 */     // No operand predicates
     /* 343951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343953 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 343953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 343967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 343986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 344007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 344011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 344014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344020 */     GIR_RootConstrainSelectedInstOperands,
     /* 344021 */     // GIR_Coverage, 5770,
     /* 344021 */     GIR_EraseRootFromParent_Done,
     /* 344022 */   // Label 7059: @344022
     /* 344022 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(344066), // Rule ID 1937 //
     /* 344027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 344050 */     // MIs[1] Operand 1
     /* 344050 */     // No operand predicates
     /* 344050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344052 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 344052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 344055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 344059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 344062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 344064 */     GIR_RootConstrainSelectedInstOperands,
     /* 344065 */     // GIR_Coverage, 1937,
     /* 344065 */     GIR_EraseRootFromParent_Done,
     /* 344066 */   // Label 7060: @344066
     /* 344066 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(344162), // Rule ID 5702 //
     /* 344071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 344091 */     // MIs[1] Operand 1
     /* 344091 */     // No operand predicates
     /* 344091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344093 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 344093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 344096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 344110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 344129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 344147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344160 */     GIR_RootConstrainSelectedInstOperands,
     /* 344161 */     // GIR_Coverage, 5702,
     /* 344161 */     GIR_EraseRootFromParent_Done,
     /* 344162 */   // Label 7061: @344162
     /* 344162 */   GIM_Reject,
     /* 344163 */ // Label 7026: @344163
     /* 344163 */ GIM_Reject,
     /* 344164 */ // Label 6974: @344164
     /* 344164 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(347803),
     /* 344169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344172 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(344298), // Rule ID 4236 //
     /* 344177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344191 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344197 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344210 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344214 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344221 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344238 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344265 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344297 */     // GIR_Coverage, 4236,
     /* 344297 */     GIR_EraseRootFromParent_Done,
     /* 344298 */   // Label 7063: @344298
     /* 344298 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(344424), // Rule ID 4237 //
     /* 344303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344317 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344323 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344333 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344336 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344340 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344347 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344364 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344391 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344423 */     // GIR_Coverage, 4237,
     /* 344423 */     GIR_EraseRootFromParent_Done,
     /* 344424 */   // Label 7064: @344424
     /* 344424 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(344543), // Rule ID 4344 //
     /* 344429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344449 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344459 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344466 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344483 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344510 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344542 */     // GIR_Coverage, 4344,
     /* 344542 */     GIR_EraseRootFromParent_Done,
     /* 344543 */   // Label 7065: @344543
     /* 344543 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(344662), // Rule ID 4345 //
     /* 344548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344602 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344661 */     // GIR_Coverage, 4345,
     /* 344661 */     GIR_EraseRootFromParent_Done,
     /* 344662 */   // Label 7066: @344662
     /* 344662 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(344784), // Rule ID 4242 //
     /* 344667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344693 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344696 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344700 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344707 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344724 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344751 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344783 */     // GIR_Coverage, 4242,
     /* 344783 */     GIR_EraseRootFromParent_Done,
     /* 344784 */   // Label 7067: @344784
     /* 344784 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(344906), // Rule ID 4244 //
     /* 344789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344818 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344822 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344829 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344846 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344873 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344905 */     // GIR_Coverage, 4244,
     /* 344905 */     GIR_EraseRootFromParent_Done,
     /* 344906 */   // Label 7068: @344906
     /* 344906 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(345021), // Rule ID 4350 //
     /* 344911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344937 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344961 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344988 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345020 */     // GIR_Coverage, 4350,
     /* 345020 */     GIR_EraseRootFromParent_Done,
     /* 345021 */   // Label 7069: @345021
     /* 345021 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(345136), // Rule ID 4352 //
     /* 345026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345052 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345059 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345076 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345103 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345135 */     // GIR_Coverage, 4352,
     /* 345135 */     GIR_EraseRootFromParent_Done,
     /* 345136 */   // Label 7070: @345136
     /* 345136 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(345257), // Rule ID 4234 //
     /* 345141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345155 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345161 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345171 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345174 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345178 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345185 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345202 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345224 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345256 */     // GIR_Coverage, 4234,
     /* 345256 */     GIR_EraseRootFromParent_Done,
     /* 345257 */   // Label 7071: @345257
     /* 345257 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(345378), // Rule ID 4235 //
     /* 345262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345276 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345282 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345292 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345295 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345299 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345306 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345323 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345345 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345377 */     // GIR_Coverage, 4235,
     /* 345377 */     GIR_EraseRootFromParent_Done,
     /* 345378 */   // Label 7072: @345378
     /* 345378 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(345492), // Rule ID 4342 //
     /* 345383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345397 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345403 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345437 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345459 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345491 */     // GIR_Coverage, 4342,
     /* 345491 */     GIR_EraseRootFromParent_Done,
     /* 345492 */   // Label 7073: @345492
     /* 345492 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(345606), // Rule ID 4343 //
     /* 345497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345511 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345517 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345551 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345605 */     // GIR_Coverage, 4343,
     /* 345605 */     GIR_EraseRootFromParent_Done,
     /* 345606 */   // Label 7074: @345606
     /* 345606 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(345723), // Rule ID 4238 //
     /* 345611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345637 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345640 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345644 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345651 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345668 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345690 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345722 */     // GIR_Coverage, 4238,
     /* 345722 */     GIR_EraseRootFromParent_Done,
     /* 345723 */   // Label 7075: @345723
     /* 345723 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(345840), // Rule ID 4240 //
     /* 345728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345757 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345761 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345768 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345785 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345807 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345839 */     // GIR_Coverage, 4240,
     /* 345839 */     GIR_EraseRootFromParent_Done,
     /* 345840 */   // Label 7076: @345840
     /* 345840 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(345950), // Rule ID 4346 //
     /* 345845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345871 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345878 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345895 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345917 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345949 */     // GIR_Coverage, 4346,
     /* 345949 */     GIR_EraseRootFromParent_Done,
     /* 345950 */   // Label 7077: @345950
     /* 345950 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(346060), // Rule ID 4348 //
     /* 345955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345981 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345988 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 346005 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 346005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346027 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346059 */     // GIR_Coverage, 4348,
     /* 346059 */     GIR_EraseRootFromParent_Done,
     /* 346060 */   // Label 7078: @346060
     /* 346060 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(346190), // Rule ID 6456 //
     /* 346065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346094 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346097 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346101 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 346108 */     // MIs[2] Rn
     /* 346108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 346112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346123 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 346123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 346126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 346144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 346159 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346189 */     // GIR_Coverage, 6456,
     /* 346189 */     GIR_EraseRootFromParent_Done,
     /* 346190 */   // Label 7079: @346190
     /* 346190 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(346330), // Rule ID 5718 //
     /* 346195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346238 */     // MIs[2] Operand 1
     /* 346238 */     // No operand predicates
     /* 346238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346246 */     // MIs[3] Operand 1
     /* 346246 */     // No operand predicates
     /* 346246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346248 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346260 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346292 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346329 */     // GIR_Coverage, 5718,
     /* 346329 */     GIR_EraseRootFromParent_Done,
     /* 346330 */   // Label 7080: @346330
     /* 346330 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(346501), // Rule ID 5719 //
     /* 346335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346378 */     // MIs[2] Operand 1
     /* 346378 */     // No operand predicates
     /* 346378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346386 */     // MIs[3] Operand 1
     /* 346386 */     // No operand predicates
     /* 346386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346388 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 346391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346400 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346403 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346407 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 346410 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346415 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346432 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346439 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346483 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346500 */     // GIR_Coverage, 5719,
     /* 346500 */     GIR_EraseRootFromParent_Done,
     /* 346501 */   // Label 7081: @346501
     /* 346501 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(346641), // Rule ID 5750 //
     /* 346506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346549 */     // MIs[2] Operand 1
     /* 346549 */     // No operand predicates
     /* 346549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346557 */     // MIs[3] Operand 1
     /* 346557 */     // No operand predicates
     /* 346557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346559 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346640 */     // GIR_Coverage, 5750,
     /* 346640 */     GIR_EraseRootFromParent_Done,
     /* 346641 */   // Label 7082: @346641
     /* 346641 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(346812), // Rule ID 5751 //
     /* 346646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346689 */     // MIs[2] Operand 1
     /* 346689 */     // No operand predicates
     /* 346689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346697 */     // MIs[3] Operand 1
     /* 346697 */     // No operand predicates
     /* 346697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346699 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346699 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 346702 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346706 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346711 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346714 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346718 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 346721 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346726 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346743 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346746 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346750 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346753 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346758 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346794 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346811 */     // GIR_Coverage, 5751,
     /* 346811 */     GIR_EraseRootFromParent_Done,
     /* 346812 */   // Label 7083: @346812
     /* 346812 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(346891), // Rule ID 5671 //
     /* 346817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346845 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 346845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 346861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346890 */     // GIR_Coverage, 5671,
     /* 346890 */     GIR_EraseRootFromParent_Done,
     /* 346891 */   // Label 7084: @346891
     /* 346891 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(346967), // Rule ID 5673 //
     /* 346896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346924 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 346924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 346927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346966 */     // GIR_Coverage, 5673,
     /* 346966 */     GIR_EraseRootFromParent_Done,
     /* 346967 */   // Label 7085: @346967
     /* 346967 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(347043), // Rule ID 5683 //
     /* 346972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347000 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 347000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 347003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347042 */     // GIR_Coverage, 5683,
     /* 347042 */     GIR_EraseRootFromParent_Done,
     /* 347043 */   // Label 7086: @347043
     /* 347043 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(347188), // Rule ID 5695 //
     /* 347048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 347070 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 347074 */     // MIs[1] Operand 1
     /* 347074 */     // No operand predicates
     /* 347074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347082 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347086 */     // MIs[2] Operand 1
     /* 347086 */     // No operand predicates
     /* 347086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347088 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347088 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347091 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347095 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347114 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347117 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347121 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 347157 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 347163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347170 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347187 */     // GIR_Coverage, 5695,
     /* 347187 */     GIR_EraseRootFromParent_Done,
     /* 347188 */   // Label 7087: @347188
     /* 347188 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(347337), // Rule ID 6459 //
     /* 347193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347218 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347222 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347229 */     // MIs[1] Rn
     /* 347229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347250 */     // MIs[2] Operand 1
     /* 347250 */     // No operand predicates
     /* 347250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347252 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 347252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347264 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 347271 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347279 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 347302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347306 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347319 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347336 */     // GIR_Coverage, 6459,
     /* 347336 */     GIR_EraseRootFromParent_Done,
     /* 347337 */   // Label 7088: @347337
     /* 347337 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(347479), // Rule ID 6462 //
     /* 347342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347371 */     // MIs[1] Rn
     /* 347371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347392 */     // MIs[2] Operand 1
     /* 347392 */     // No operand predicates
     /* 347392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347394 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 347394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347406 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347409 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 347413 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 347444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347478 */     // GIR_Coverage, 6462,
     /* 347478 */     GIR_EraseRootFromParent_Done,
     /* 347479 */   // Label 7089: @347479
     /* 347479 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(347667), // Rule ID 5693 //
     /* 347484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347514 */     // MIs[1] Operand 1
     /* 347514 */     // No operand predicates
     /* 347514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347516 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347516 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 347519 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347523 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 347530 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 347533 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347537 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347542 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 347545 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347549 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 347552 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347557 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347562 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347567 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347570 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347574 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347593 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347596 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347600 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347603 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 347636 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 347642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347666 */     // GIR_Coverage, 5693,
     /* 347666 */     GIR_EraseRootFromParent_Done,
     /* 347667 */   // Label 7090: @347667
     /* 347667 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(347802), // Rule ID 5704 //
     /* 347672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347702 */     // MIs[1] Operand 1
     /* 347702 */     // No operand predicates
     /* 347702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347704 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 347704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 347773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347801 */     // GIR_Coverage, 5704,
     /* 347801 */     GIR_EraseRootFromParent_Done,
     /* 347802 */   // Label 7091: @347802
     /* 347802 */   GIM_Reject,
     /* 347803 */ // Label 7062: @347803
     /* 347803 */ GIM_Reject,
     /* 347804 */ // Label 6975: @347804
     /* 347804 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350871),
     /* 347809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347822 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(347931), // Rule ID 4260 //
     /* 347827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347831 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347837 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347847 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347854 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 347871 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 347878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347898 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347930 */     // GIR_Coverage, 4260,
     /* 347930 */     GIR_EraseRootFromParent_Done,
     /* 347931 */   // Label 7093: @347931
     /* 347931 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(348040), // Rule ID 4261 //
     /* 347936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347956 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 347980 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 347987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348039 */     // GIR_Coverage, 4261,
     /* 348039 */     GIR_EraseRootFromParent_Done,
     /* 348040 */   // Label 7094: @348040
     /* 348040 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(348149), // Rule ID 4368 //
     /* 348045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348049 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348055 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348072 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348089 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348148 */     // GIR_Coverage, 4368,
     /* 348148 */     GIR_EraseRootFromParent_Done,
     /* 348149 */   // Label 7095: @348149
     /* 348149 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(348258), // Rule ID 4369 //
     /* 348154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348158 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348164 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348174 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348181 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348198 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348225 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348257 */     // GIR_Coverage, 4369,
     /* 348257 */     GIR_EraseRootFromParent_Done,
     /* 348258 */   // Label 7096: @348258
     /* 348258 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(348363), // Rule ID 4266 //
     /* 348263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348279 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348303 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348362 */     // GIR_Coverage, 4266,
     /* 348362 */     GIR_EraseRootFromParent_Done,
     /* 348363 */   // Label 7097: @348363
     /* 348363 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(348468), // Rule ID 4268 //
     /* 348368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348384 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348391 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348408 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348467 */     // GIR_Coverage, 4268,
     /* 348467 */     GIR_EraseRootFromParent_Done,
     /* 348468 */   // Label 7098: @348468
     /* 348468 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(348573), // Rule ID 4374 //
     /* 348473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348489 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348492 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348496 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348513 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348572 */     // GIR_Coverage, 4374,
     /* 348572 */     GIR_EraseRootFromParent_Done,
     /* 348573 */   // Label 7099: @348573
     /* 348573 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(348678), // Rule ID 4376 //
     /* 348578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348594 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348601 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348618 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348677 */     // GIR_Coverage, 4376,
     /* 348677 */     GIR_EraseRootFromParent_Done,
     /* 348678 */   // Label 7100: @348678
     /* 348678 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(348782), // Rule ID 4258 //
     /* 348683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348693 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348703 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348710 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348727 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348781 */     // GIR_Coverage, 4258,
     /* 348781 */     GIR_EraseRootFromParent_Done,
     /* 348782 */   // Label 7101: @348782
     /* 348782 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(348886), // Rule ID 4259 //
     /* 348787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348807 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348814 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 348831 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 348831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 348838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348853 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348885 */     // GIR_Coverage, 4259,
     /* 348885 */     GIR_EraseRootFromParent_Done,
     /* 348886 */   // Label 7102: @348886
     /* 348886 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(348990), // Rule ID 4366 //
     /* 348891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348901 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348911 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348918 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348935 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348957 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348989 */     // GIR_Coverage, 4366,
     /* 348989 */     GIR_EraseRootFromParent_Done,
     /* 348990 */   // Label 7103: @348990
     /* 348990 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(349094), // Rule ID 4367 //
     /* 348995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349015 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349022 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349039 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349061 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349093 */     // GIR_Coverage, 4367,
     /* 349093 */     GIR_EraseRootFromParent_Done,
     /* 349094 */   // Label 7104: @349094
     /* 349094 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(349194), // Rule ID 4262 //
     /* 349099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349115 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349122 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 349139 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 349139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 349146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349161 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349193 */     // GIR_Coverage, 4262,
     /* 349193 */     GIR_EraseRootFromParent_Done,
     /* 349194 */   // Label 7105: @349194
     /* 349194 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(349294), // Rule ID 4264 //
     /* 349199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349215 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349222 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349239 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349261 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349293 */     // GIR_Coverage, 4264,
     /* 349293 */     GIR_EraseRootFromParent_Done,
     /* 349294 */   // Label 7106: @349294
     /* 349294 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(349394), // Rule ID 4370 //
     /* 349299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349315 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349322 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 349339 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 349339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 349346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349361 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349393 */     // GIR_Coverage, 4370,
     /* 349393 */     GIR_EraseRootFromParent_Done,
     /* 349394 */   // Label 7107: @349394
     /* 349394 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(349494), // Rule ID 4372 //
     /* 349399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349415 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349422 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349439 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349493 */     // GIR_Coverage, 4372,
     /* 349493 */     GIR_EraseRootFromParent_Done,
     /* 349494 */   // Label 7108: @349494
     /* 349494 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(349607), // Rule ID 5724 //
     /* 349499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 349523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 349532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349536 */     // MIs[3] Operand 1
     /* 349536 */     // No operand predicates
     /* 349536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349542 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 349542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 349545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 349549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 349558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 349561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 349588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349606 */     // GIR_Coverage, 5724,
     /* 349606 */     GIR_EraseRootFromParent_Done,
     /* 349607 */   // Label 7109: @349607
     /* 349607 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(349720), // Rule ID 5756 //
     /* 349612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 349636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 349645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349649 */     // MIs[3] Operand 1
     /* 349649 */     // No operand predicates
     /* 349649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349655 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 349655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 349658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 349662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 349671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 349674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 349701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349719 */     // GIR_Coverage, 5756,
     /* 349719 */     GIR_EraseRootFromParent_Done,
     /* 349720 */   // Label 7110: @349720
     /* 349720 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(349798), // Rule ID 1940 //
     /* 349725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349765 */     // MIs[2] Operand 1
     /* 349765 */     // No operand predicates
     /* 349765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349777 */     // MIs[3] Operand 1
     /* 349777 */     // No operand predicates
     /* 349777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349779 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 349779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 349789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 349796 */     GIR_RootConstrainSelectedInstOperands,
     /* 349797 */     // GIR_Coverage, 1940,
     /* 349797 */     GIR_EraseRootFromParent_Done,
     /* 349798 */   // Label 7111: @349798
     /* 349798 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(349887), // Rule ID 5721 //
     /* 349803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 349815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349831 */     // MIs[2] Operand 1
     /* 349831 */     // No operand predicates
     /* 349831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349839 */     // MIs[3] Operand 1
     /* 349839 */     // No operand predicates
     /* 349839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349841 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 349841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 349859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349885 */     GIR_RootConstrainSelectedInstOperands,
     /* 349886 */     // GIR_Coverage, 5721,
     /* 349886 */     GIR_EraseRootFromParent_Done,
     /* 349887 */   // Label 7112: @349887
     /* 349887 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(349976), // Rule ID 5753 //
     /* 349892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 349904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349916 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349920 */     // MIs[2] Operand 1
     /* 349920 */     // No operand predicates
     /* 349920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349928 */     // MIs[3] Operand 1
     /* 349928 */     // No operand predicates
     /* 349928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349930 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 349930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 349948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349974 */     GIR_RootConstrainSelectedInstOperands,
     /* 349975 */     // GIR_Coverage, 5753,
     /* 349975 */     GIR_EraseRootFromParent_Done,
     /* 349976 */   // Label 7113: @349976
     /* 349976 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(350043), // Rule ID 5723 //
     /* 349981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350014 */     // MIs[2] Operand 1
     /* 350014 */     // No operand predicates
     /* 350014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350022 */     // MIs[3] Operand 1
     /* 350022 */     // No operand predicates
     /* 350022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350024 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350041 */     GIR_RootConstrainSelectedInstOperands,
     /* 350042 */     // GIR_Coverage, 5723,
     /* 350042 */     GIR_EraseRootFromParent_Done,
     /* 350043 */   // Label 7114: @350043
     /* 350043 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(350141), // Rule ID 5725 //
     /* 350048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350081 */     // MIs[2] Operand 1
     /* 350081 */     // No operand predicates
     /* 350081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350089 */     // MIs[3] Operand 1
     /* 350089 */     // No operand predicates
     /* 350089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350091 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350139 */     GIR_RootConstrainSelectedInstOperands,
     /* 350140 */     // GIR_Coverage, 5725,
     /* 350140 */     GIR_EraseRootFromParent_Done,
     /* 350141 */   // Label 7115: @350141
     /* 350141 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(350208), // Rule ID 5755 //
     /* 350146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350179 */     // MIs[2] Operand 1
     /* 350179 */     // No operand predicates
     /* 350179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350187 */     // MIs[3] Operand 1
     /* 350187 */     // No operand predicates
     /* 350187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350189 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350206 */     GIR_RootConstrainSelectedInstOperands,
     /* 350207 */     // GIR_Coverage, 5755,
     /* 350207 */     GIR_EraseRootFromParent_Done,
     /* 350208 */   // Label 7116: @350208
     /* 350208 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(350306), // Rule ID 5757 //
     /* 350213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350246 */     // MIs[2] Operand 1
     /* 350246 */     // No operand predicates
     /* 350246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350254 */     // MIs[3] Operand 1
     /* 350254 */     // No operand predicates
     /* 350254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350256 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350271 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350275 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350293 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350304 */     GIR_RootConstrainSelectedInstOperands,
     /* 350305 */     // GIR_Coverage, 5757,
     /* 350305 */     GIR_EraseRootFromParent_Done,
     /* 350306 */   // Label 7117: @350306
     /* 350306 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(350372), // Rule ID 5679 //
     /* 350311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350329 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 350329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350371 */     // GIR_Coverage, 5679,
     /* 350371 */     GIR_EraseRootFromParent_Done,
     /* 350372 */   // Label 7118: @350372
     /* 350372 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(350438), // Rule ID 5687 //
     /* 350377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350395 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 350395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350437 */     // GIR_Coverage, 5687,
     /* 350437 */     GIR_EraseRootFromParent_Done,
     /* 350438 */   // Label 7119: @350438
     /* 350438 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(350491), // Rule ID 5696 //
     /* 350443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 350455 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 350459 */     // MIs[1] Operand 1
     /* 350459 */     // No operand predicates
     /* 350459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350471 */     // MIs[2] Operand 1
     /* 350471 */     // No operand predicates
     /* 350471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350473 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 350473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 350476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 350483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350489 */     GIR_RootConstrainSelectedInstOperands,
     /* 350490 */     // GIR_Coverage, 5696,
     /* 350490 */     GIR_EraseRootFromParent_Done,
     /* 350491 */   // Label 7120: @350491
     /* 350491 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(350560), // Rule ID 6441 //
     /* 350496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 350515 */     // MIs[1] Rn
     /* 350515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 350519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 350524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350536 */     // MIs[2] Operand 1
     /* 350536 */     // No operand predicates
     /* 350536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350538 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 350538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 350541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 350548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350558 */     GIR_RootConstrainSelectedInstOperands,
     /* 350559 */     // GIR_Coverage, 6441,
     /* 350559 */     GIR_EraseRootFromParent_Done,
     /* 350560 */   // Label 7121: @350560
     /* 350560 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(350629), // Rule ID 6442 //
     /* 350565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 350584 */     // MIs[1] Rn
     /* 350584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 350588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 350593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350605 */     // MIs[2] Operand 1
     /* 350605 */     // No operand predicates
     /* 350605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350607 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 350607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 350610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 350617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350627 */     GIR_RootConstrainSelectedInstOperands,
     /* 350628 */     // GIR_Coverage, 6442,
     /* 350628 */     GIR_EraseRootFromParent_Done,
     /* 350629 */   // Label 7122: @350629
     /* 350629 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(350730), // Rule ID 5768 //
     /* 350634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 350642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 350646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350659 */     // MIs[2] Operand 1
     /* 350659 */     // No operand predicates
     /* 350659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350661 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 350661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 350664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 350694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 350697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 350722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350728 */     GIR_RootConstrainSelectedInstOperands,
     /* 350729 */     // GIR_Coverage, 5768,
     /* 350729 */     GIR_EraseRootFromParent_Done,
     /* 350730 */   // Label 7123: @350730
     /* 350730 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(350774), // Rule ID 1936 //
     /* 350735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 350750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350758 */     // MIs[1] Operand 1
     /* 350758 */     // No operand predicates
     /* 350758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350760 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 350760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 350763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 350770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350772 */     GIR_RootConstrainSelectedInstOperands,
     /* 350773 */     // GIR_Coverage, 1936,
     /* 350773 */     GIR_EraseRootFromParent_Done,
     /* 350774 */   // Label 7124: @350774
     /* 350774 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(350870), // Rule ID 5701 //
     /* 350779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 350791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350799 */     // MIs[1] Operand 1
     /* 350799 */     // No operand predicates
     /* 350799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350801 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 350801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 350804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 350834 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 350837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 350862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350868 */     GIR_RootConstrainSelectedInstOperands,
     /* 350869 */     // GIR_Coverage, 5701,
     /* 350869 */     GIR_EraseRootFromParent_Done,
     /* 350870 */   // Label 7125: @350870
     /* 350870 */   GIM_Reject,
     /* 350871 */ // Label 7092: @350871
     /* 350871 */ GIM_Reject,
     /* 350872 */ // Label 6976: @350872
     /* 350872 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(352715),
     /* 350877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350880 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(351006), // Rule ID 4200 //
     /* 350885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350899 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350905 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350915 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350918 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350922 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350929 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 350946 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 350946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 350953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350973 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351005 */     // GIR_Coverage, 4200,
     /* 351005 */     GIR_EraseRootFromParent_Done,
     /* 351006 */   // Label 7127: @351006
     /* 351006 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(351132), // Rule ID 4201 //
     /* 351011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351044 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351048 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351072 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351131 */     // GIR_Coverage, 4201,
     /* 351131 */     GIR_EraseRootFromParent_Done,
     /* 351132 */   // Label 7128: @351132
     /* 351132 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(351254), // Rule ID 4206 //
     /* 351137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351163 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351166 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351170 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351177 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351194 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351221 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351253 */     // GIR_Coverage, 4206,
     /* 351253 */     GIR_EraseRootFromParent_Done,
     /* 351254 */   // Label 7129: @351254
     /* 351254 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(351376), // Rule ID 4208 //
     /* 351259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351288 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351292 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351299 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351316 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351375 */     // GIR_Coverage, 4208,
     /* 351375 */     GIR_EraseRootFromParent_Done,
     /* 351376 */   // Label 7130: @351376
     /* 351376 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(351497), // Rule ID 4198 //
     /* 351381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351411 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351414 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351418 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351425 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 351442 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 351442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 351449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351496 */     // GIR_Coverage, 4198,
     /* 351496 */     GIR_EraseRootFromParent_Done,
     /* 351497 */   // Label 7131: @351497
     /* 351497 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(351618), // Rule ID 4199 //
     /* 351502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351516 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351522 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351535 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351539 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 351563 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 351563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 351570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351617 */     // GIR_Coverage, 4199,
     /* 351617 */     GIR_EraseRootFromParent_Done,
     /* 351618 */   // Label 7132: @351618
     /* 351618 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(351735), // Rule ID 4202 //
     /* 351623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351649 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351652 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351656 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351663 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 351680 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 351680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 351687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351734 */     // GIR_Coverage, 4202,
     /* 351734 */     GIR_EraseRootFromParent_Done,
     /* 351735 */   // Label 7133: @351735
     /* 351735 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(351852), // Rule ID 4204 //
     /* 351740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351766 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351769 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351773 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351780 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 351797 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 351797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 351804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351851 */     // GIR_Coverage, 4204,
     /* 351851 */     GIR_EraseRootFromParent_Done,
     /* 351852 */   // Label 7134: @351852
     /* 351852 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(351992), // Rule ID 5742 //
     /* 351857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351900 */     // MIs[2] Operand 1
     /* 351900 */     // No operand predicates
     /* 351900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351908 */     // MIs[3] Operand 1
     /* 351908 */     // No operand predicates
     /* 351908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351910 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 351910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 351913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351922 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 351925 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 351929 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 351932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 351949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 351960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 351967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351974 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351991 */     // GIR_Coverage, 5742,
     /* 351991 */     GIR_EraseRootFromParent_Done,
     /* 351992 */   // Label 7135: @351992
     /* 351992 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(352163), // Rule ID 5743 //
     /* 351997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 352023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352040 */     // MIs[2] Operand 1
     /* 352040 */     // No operand predicates
     /* 352040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352048 */     // MIs[3] Operand 1
     /* 352048 */     // No operand predicates
     /* 352048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352050 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352050 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352053 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352057 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352062 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352065 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352069 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352072 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352077 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352094 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352101 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352145 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352162 */     // GIR_Coverage, 5743,
     /* 352162 */     GIR_EraseRootFromParent_Done,
     /* 352163 */   // Label 7136: @352163
     /* 352163 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(352242), // Rule ID 5666 //
     /* 352168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352196 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 352196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 352212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352241 */     // GIR_Coverage, 5666,
     /* 352241 */     GIR_EraseRootFromParent_Done,
     /* 352242 */   // Label 7137: @352242
     /* 352242 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(352391), // Rule ID 6458 //
     /* 352247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352272 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352276 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352283 */     // MIs[1] Rn
     /* 352283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352304 */     // MIs[2] Operand 1
     /* 352304 */     // No operand predicates
     /* 352304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352306 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 352306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352321 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 352325 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 352345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 352356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352390 */     // GIR_Coverage, 6458,
     /* 352390 */     GIR_EraseRootFromParent_Done,
     /* 352391 */   // Label 7138: @352391
     /* 352391 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(352526), // Rule ID 5705 //
     /* 352396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352426 */     // MIs[1] Operand 1
     /* 352426 */     // No operand predicates
     /* 352426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352428 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 352428 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 352431 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352435 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352442 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 352445 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352449 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352454 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 352461 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352474 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 352486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 352497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352508 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352525 */     // GIR_Coverage, 5705,
     /* 352525 */     GIR_EraseRootFromParent_Done,
     /* 352526 */   // Label 7139: @352526
     /* 352526 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(352714), // Rule ID 5706 //
     /* 352531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 352534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352561 */     // MIs[1] Operand 1
     /* 352561 */     // No operand predicates
     /* 352561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352563 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 352563 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 352566 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352570 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 352577 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 352580 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352584 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352589 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 352592 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352596 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 352599 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352604 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352609 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 352617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 352631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 352647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 352683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 352686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 352689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352696 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352713 */     // GIR_Coverage, 5706,
     /* 352713 */     GIR_EraseRootFromParent_Done,
     /* 352714 */   // Label 7140: @352714
     /* 352714 */   GIM_Reject,
     /* 352715 */ // Label 7126: @352715
     /* 352715 */ GIM_Reject,
     /* 352716 */ // Label 6977: @352716
     /* 352716 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356134),
     /* 352721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 352724 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(352850), // Rule ID 4224 //
     /* 352729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352759 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352762 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352766 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352773 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 352790 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 352790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 352797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352817 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352849 */     // GIR_Coverage, 4224,
     /* 352849 */     GIR_EraseRootFromParent_Done,
     /* 352850 */   // Label 7142: @352850
     /* 352850 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(352976), // Rule ID 4225 //
     /* 352855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352888 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352892 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352899 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 352916 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 352916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 352923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352943 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352975 */     // GIR_Coverage, 4225,
     /* 352975 */     GIR_EraseRootFromParent_Done,
     /* 352976 */   // Label 7143: @352976
     /* 352976 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(353095), // Rule ID 4332 //
     /* 352981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352995 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353001 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353011 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353018 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353035 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353062 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353094 */     // GIR_Coverage, 4332,
     /* 353094 */     GIR_EraseRootFromParent_Done,
     /* 353095 */   // Label 7144: @353095
     /* 353095 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(353214), // Rule ID 4333 //
     /* 353100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353114 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353120 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353130 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353137 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353154 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353181 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353213 */     // GIR_Coverage, 4333,
     /* 353213 */     GIR_EraseRootFromParent_Done,
     /* 353214 */   // Label 7145: @353214
     /* 353214 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(353336), // Rule ID 4230 //
     /* 353219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353245 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353248 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353252 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353259 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353276 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353303 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353335 */     // GIR_Coverage, 4230,
     /* 353335 */     GIR_EraseRootFromParent_Done,
     /* 353336 */   // Label 7146: @353336
     /* 353336 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(353458), // Rule ID 4232 //
     /* 353341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353367 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353370 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353374 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353381 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353398 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353457 */     // GIR_Coverage, 4232,
     /* 353457 */     GIR_EraseRootFromParent_Done,
     /* 353458 */   // Label 7147: @353458
     /* 353458 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(353573), // Rule ID 4338 //
     /* 353463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353489 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353492 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353496 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353513 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353572 */     // GIR_Coverage, 4338,
     /* 353572 */     GIR_EraseRootFromParent_Done,
     /* 353573 */   // Label 7148: @353573
     /* 353573 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(353688), // Rule ID 4340 //
     /* 353578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353604 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353611 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353628 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353687 */     // GIR_Coverage, 4340,
     /* 353687 */     GIR_EraseRootFromParent_Done,
     /* 353688 */   // Label 7149: @353688
     /* 353688 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(353809), // Rule ID 4222 //
     /* 353693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353723 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353726 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353730 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353737 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 353754 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 353754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 353761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353776 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353808 */     // GIR_Coverage, 4222,
     /* 353808 */     GIR_EraseRootFromParent_Done,
     /* 353809 */   // Label 7150: @353809
     /* 353809 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(353930), // Rule ID 4223 //
     /* 353814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353844 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353847 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353851 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 353875 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 353875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 353882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353929 */     // GIR_Coverage, 4223,
     /* 353929 */     GIR_EraseRootFromParent_Done,
     /* 353930 */   // Label 7151: @353930
     /* 353930 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(354044), // Rule ID 4330 //
     /* 353935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353965 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353972 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 353989 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 353989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 353996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354011 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354043 */     // GIR_Coverage, 4330,
     /* 354043 */     GIR_EraseRootFromParent_Done,
     /* 354044 */   // Label 7152: @354044
     /* 354044 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(354158), // Rule ID 4331 //
     /* 354049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354063 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354069 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354079 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354086 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354103 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354157 */     // GIR_Coverage, 4331,
     /* 354157 */     GIR_EraseRootFromParent_Done,
     /* 354158 */   // Label 7153: @354158
     /* 354158 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(354275), // Rule ID 4226 //
     /* 354163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354192 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354196 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354203 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 354220 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 354220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 354227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354242 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354274 */     // GIR_Coverage, 4226,
     /* 354274 */     GIR_EraseRootFromParent_Done,
     /* 354275 */   // Label 7154: @354275
     /* 354275 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(354392), // Rule ID 4228 //
     /* 354280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354306 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354309 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354313 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354320 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354337 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354359 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354391 */     // GIR_Coverage, 4228,
     /* 354391 */     GIR_EraseRootFromParent_Done,
     /* 354392 */   // Label 7155: @354392
     /* 354392 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(354502), // Rule ID 4334 //
     /* 354397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354423 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354430 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 354447 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 354447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 354454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354469 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354501 */     // GIR_Coverage, 4334,
     /* 354501 */     GIR_EraseRootFromParent_Done,
     /* 354502 */   // Label 7156: @354502
     /* 354502 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(354612), // Rule ID 4336 //
     /* 354507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354533 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354540 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354557 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354579 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354611 */     // GIR_Coverage, 4336,
     /* 354611 */     GIR_EraseRootFromParent_Done,
     /* 354612 */   // Label 7157: @354612
     /* 354612 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(354735), // Rule ID 5716 //
     /* 354617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 354660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354664 */     // MIs[3] Operand 1
     /* 354664 */     // No operand predicates
     /* 354664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354670 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 354670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 354673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 354677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 354689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 354716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354734 */     // GIR_Coverage, 5716,
     /* 354734 */     GIR_EraseRootFromParent_Done,
     /* 354735 */   // Label 7158: @354735
     /* 354735 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(354858), // Rule ID 5748 //
     /* 354740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 354783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354787 */     // MIs[3] Operand 1
     /* 354787 */     // No operand predicates
     /* 354787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354793 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 354793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 354796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 354800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 354812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 354839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354857 */     // GIR_Coverage, 5748,
     /* 354857 */     GIR_EraseRootFromParent_Done,
     /* 354858 */   // Label 7159: @354858
     /* 354858 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(354946), // Rule ID 1939 //
     /* 354863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354909 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354913 */     // MIs[2] Operand 1
     /* 354913 */     // No operand predicates
     /* 354913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354925 */     // MIs[3] Operand 1
     /* 354925 */     // No operand predicates
     /* 354925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354927 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 354927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 354930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 354934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 354937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 354944 */     GIR_RootConstrainSelectedInstOperands,
     /* 354945 */     // GIR_Coverage, 1939,
     /* 354945 */     GIR_EraseRootFromParent_Done,
     /* 354946 */   // Label 7160: @354946
     /* 354946 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(355045), // Rule ID 5713 //
     /* 354951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354989 */     // MIs[2] Operand 1
     /* 354989 */     // No operand predicates
     /* 354989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354997 */     // MIs[3] Operand 1
     /* 354997 */     // No operand predicates
     /* 354997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354999 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 354999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355011 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 355017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355043 */     GIR_RootConstrainSelectedInstOperands,
     /* 355044 */     // GIR_Coverage, 5713,
     /* 355044 */     GIR_EraseRootFromParent_Done,
     /* 355045 */   // Label 7161: @355045
     /* 355045 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(355144), // Rule ID 5745 //
     /* 355050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 355072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355088 */     // MIs[2] Operand 1
     /* 355088 */     // No operand predicates
     /* 355088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355096 */     // MIs[3] Operand 1
     /* 355096 */     // No operand predicates
     /* 355096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355098 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 355098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355110 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 355116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355142 */     GIR_RootConstrainSelectedInstOperands,
     /* 355143 */     // GIR_Coverage, 5745,
     /* 355143 */     GIR_EraseRootFromParent_Done,
     /* 355144 */   // Label 7162: @355144
     /* 355144 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(355221), // Rule ID 5715 //
     /* 355149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355192 */     // MIs[2] Operand 1
     /* 355192 */     // No operand predicates
     /* 355192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355200 */     // MIs[3] Operand 1
     /* 355200 */     // No operand predicates
     /* 355200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355202 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 355202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355219 */     GIR_RootConstrainSelectedInstOperands,
     /* 355220 */     // GIR_Coverage, 5715,
     /* 355220 */     GIR_EraseRootFromParent_Done,
     /* 355221 */   // Label 7163: @355221
     /* 355221 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(355329), // Rule ID 5717 //
     /* 355226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355269 */     // MIs[2] Operand 1
     /* 355269 */     // No operand predicates
     /* 355269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355277 */     // MIs[3] Operand 1
     /* 355277 */     // No operand predicates
     /* 355277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355279 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 355279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 355301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355327 */     GIR_RootConstrainSelectedInstOperands,
     /* 355328 */     // GIR_Coverage, 5717,
     /* 355328 */     GIR_EraseRootFromParent_Done,
     /* 355329 */   // Label 7164: @355329
     /* 355329 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(355406), // Rule ID 5747 //
     /* 355334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355377 */     // MIs[2] Operand 1
     /* 355377 */     // No operand predicates
     /* 355377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355385 */     // MIs[3] Operand 1
     /* 355385 */     // No operand predicates
     /* 355385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355387 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 355387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355404 */     GIR_RootConstrainSelectedInstOperands,
     /* 355405 */     // GIR_Coverage, 5747,
     /* 355405 */     GIR_EraseRootFromParent_Done,
     /* 355406 */   // Label 7165: @355406
     /* 355406 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(355514), // Rule ID 5749 //
     /* 355411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355454 */     // MIs[2] Operand 1
     /* 355454 */     // No operand predicates
     /* 355454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355462 */     // MIs[3] Operand 1
     /* 355462 */     // No operand predicates
     /* 355462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355464 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 355464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 355486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355512 */     GIR_RootConstrainSelectedInstOperands,
     /* 355513 */     // GIR_Coverage, 5749,
     /* 355513 */     GIR_EraseRootFromParent_Done,
     /* 355514 */   // Label 7166: @355514
     /* 355514 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(355593), // Rule ID 5669 //
     /* 355519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355547 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 355547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 355563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355592 */     // GIR_Coverage, 5669,
     /* 355592 */     GIR_EraseRootFromParent_Done,
     /* 355593 */   // Label 7167: @355593
     /* 355593 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(355669), // Rule ID 5675 //
     /* 355598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355626 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 355626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355668 */     // GIR_Coverage, 5675,
     /* 355668 */     GIR_EraseRootFromParent_Done,
     /* 355669 */   // Label 7168: @355669
     /* 355669 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(355745), // Rule ID 5685 //
     /* 355674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355702 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 355702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355744 */     // GIR_Coverage, 5685,
     /* 355744 */     GIR_EraseRootFromParent_Done,
     /* 355745 */   // Label 7169: @355745
     /* 355745 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(355808), // Rule ID 5694 //
     /* 355750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 355772 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 355776 */     // MIs[1] Operand 1
     /* 355776 */     // No operand predicates
     /* 355776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355788 */     // MIs[2] Operand 1
     /* 355788 */     // No operand predicates
     /* 355788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355790 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 355790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 355793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 355800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355806 */     GIR_RootConstrainSelectedInstOperands,
     /* 355807 */     // GIR_Coverage, 5694,
     /* 355807 */     GIR_EraseRootFromParent_Done,
     /* 355808 */   // Label 7170: @355808
     /* 355808 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(355894), // Rule ID 6440 //
     /* 355813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355838 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355842 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355849 */     // MIs[1] Rn
     /* 355849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355870 */     // MIs[2] Operand 1
     /* 355870 */     // No operand predicates
     /* 355870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355872 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 355872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 355879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 355882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355892 */     GIR_RootConstrainSelectedInstOperands,
     /* 355893 */     // GIR_Coverage, 6440,
     /* 355893 */     GIR_EraseRootFromParent_Done,
     /* 355894 */   // Label 7171: @355894
     /* 355894 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(355973), // Rule ID 6445 //
     /* 355899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355928 */     // MIs[1] Rn
     /* 355928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355949 */     // MIs[2] Operand 1
     /* 355949 */     // No operand predicates
     /* 355949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355951 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 355951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 355958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 355961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355971 */     GIR_RootConstrainSelectedInstOperands,
     /* 355972 */     // GIR_Coverage, 6445,
     /* 355972 */     GIR_EraseRootFromParent_Done,
     /* 355973 */   // Label 7172: @355973
     /* 355973 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(356027), // Rule ID 1935 //
     /* 355978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 356011 */     // MIs[1] Operand 1
     /* 356011 */     // No operand predicates
     /* 356011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356013 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 356013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 356016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 356020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 356023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356025 */     GIR_RootConstrainSelectedInstOperands,
     /* 356026 */     // GIR_Coverage, 1935,
     /* 356026 */     GIR_EraseRootFromParent_Done,
     /* 356027 */   // Label 7173: @356027
     /* 356027 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(356133), // Rule ID 5699 //
     /* 356032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 356035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 356062 */     // MIs[1] Operand 1
     /* 356062 */     // No operand predicates
     /* 356062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356064 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 356067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 356081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 356100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 356118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 356122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 356125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356131 */     GIR_RootConstrainSelectedInstOperands,
     /* 356132 */     // GIR_Coverage, 5699,
     /* 356132 */     GIR_EraseRootFromParent_Done,
     /* 356133 */   // Label 7174: @356133
     /* 356133 */   GIM_Reject,
     /* 356134 */ // Label 7141: @356134
     /* 356134 */ GIM_Reject,
     /* 356135 */ // Label 6978: @356135
     /* 356135 */ GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357936),
     /* 356140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 356143 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(356269), // Rule ID 4188 //
     /* 356148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356162 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356168 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356178 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356181 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356185 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356209 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356236 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356268 */     // GIR_Coverage, 4188,
     /* 356268 */     GIR_EraseRootFromParent_Done,
     /* 356269 */   // Label 7176: @356269
     /* 356269 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(356395), // Rule ID 4189 //
     /* 356274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356288 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356294 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356304 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356307 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356311 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356318 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356335 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356362 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356394 */     // GIR_Coverage, 4189,
     /* 356394 */     GIR_EraseRootFromParent_Done,
     /* 356395 */   // Label 7177: @356395
     /* 356395 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(356517), // Rule ID 4194 //
     /* 356400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356426 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356429 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356433 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356457 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356516 */     // GIR_Coverage, 4194,
     /* 356516 */     GIR_EraseRootFromParent_Done,
     /* 356517 */   // Label 7178: @356517
     /* 356517 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(356639), // Rule ID 4196 //
     /* 356522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356548 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356551 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356555 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356562 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356579 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356638 */     // GIR_Coverage, 4196,
     /* 356638 */     GIR_EraseRootFromParent_Done,
     /* 356639 */   // Label 7179: @356639
     /* 356639 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(356760), // Rule ID 4186 //
     /* 356644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356658 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356664 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356674 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356677 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356681 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356705 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356759 */     // GIR_Coverage, 4186,
     /* 356759 */     GIR_EraseRootFromParent_Done,
     /* 356760 */   // Label 7180: @356760
     /* 356760 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(356881), // Rule ID 4187 //
     /* 356765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356798 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356802 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356809 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 356826 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 356826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 356833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356848 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356880 */     // GIR_Coverage, 4187,
     /* 356880 */     GIR_EraseRootFromParent_Done,
     /* 356881 */   // Label 7181: @356881
     /* 356881 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(356998), // Rule ID 4190 //
     /* 356886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356912 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356915 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356919 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356926 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356943 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356965 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356997 */     // GIR_Coverage, 4190,
     /* 356997 */     GIR_EraseRootFromParent_Done,
     /* 356998 */   // Label 7182: @356998
     /* 356998 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(357115), // Rule ID 4192 //
     /* 357003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357029 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357032 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357036 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357043 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 357060 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 357060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 357063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 357067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357082 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 357104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357114 */     // GIR_Coverage, 4192,
     /* 357114 */     GIR_EraseRootFromParent_Done,
     /* 357115 */   // Label 7183: @357115
     /* 357115 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(357238), // Rule ID 5740 //
     /* 357120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 357163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357167 */     // MIs[3] Operand 1
     /* 357167 */     // No operand predicates
     /* 357167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357173 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 357173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 357176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 357180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 357192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 357219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 357222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357237 */     // GIR_Coverage, 5740,
     /* 357237 */     GIR_EraseRootFromParent_Done,
     /* 357238 */   // Label 7184: @357238
     /* 357238 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(357326), // Rule ID 1938 //
     /* 357243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357293 */     // MIs[2] Operand 1
     /* 357293 */     // No operand predicates
     /* 357293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357305 */     // MIs[3] Operand 1
     /* 357305 */     // No operand predicates
     /* 357305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357307 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 357307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 357317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 357324 */     GIR_RootConstrainSelectedInstOperands,
     /* 357325 */     // GIR_Coverage, 1938,
     /* 357325 */     GIR_EraseRootFromParent_Done,
     /* 357326 */   // Label 7185: @357326
     /* 357326 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357425), // Rule ID 5737 //
     /* 357331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 357353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357369 */     // MIs[2] Operand 1
     /* 357369 */     // No operand predicates
     /* 357369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357377 */     // MIs[3] Operand 1
     /* 357377 */     // No operand predicates
     /* 357377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357379 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 357379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 357397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 357414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357423 */     GIR_RootConstrainSelectedInstOperands,
     /* 357424 */     // GIR_Coverage, 5737,
     /* 357424 */     GIR_EraseRootFromParent_Done,
     /* 357425 */   // Label 7186: @357425
     /* 357425 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(357502), // Rule ID 5739 //
     /* 357430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357473 */     // MIs[2] Operand 1
     /* 357473 */     // No operand predicates
     /* 357473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357481 */     // MIs[3] Operand 1
     /* 357481 */     // No operand predicates
     /* 357481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357483 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 357483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 357490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357500 */     GIR_RootConstrainSelectedInstOperands,
     /* 357501 */     // GIR_Coverage, 5739,
     /* 357501 */     GIR_EraseRootFromParent_Done,
     /* 357502 */   // Label 7187: @357502
     /* 357502 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(357610), // Rule ID 5741 //
     /* 357507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 357533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357550 */     // MIs[2] Operand 1
     /* 357550 */     // No operand predicates
     /* 357550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357558 */     // MIs[3] Operand 1
     /* 357558 */     // No operand predicates
     /* 357558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357560 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 357560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357572 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 357599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357608 */     GIR_RootConstrainSelectedInstOperands,
     /* 357609 */     // GIR_Coverage, 5741,
     /* 357609 */     GIR_EraseRootFromParent_Done,
     /* 357610 */   // Label 7188: @357610
     /* 357610 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(357689), // Rule ID 5664 //
     /* 357615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357643 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 357643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 357659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357688 */     // GIR_Coverage, 5664,
     /* 357688 */     GIR_EraseRootFromParent_Done,
     /* 357689 */   // Label 7189: @357689
     /* 357689 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(357775), // Rule ID 6439 //
     /* 357694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357719 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357723 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357730 */     // MIs[1] Rn
     /* 357730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357747 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357751 */     // MIs[2] Operand 1
     /* 357751 */     // No operand predicates
     /* 357751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357753 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 357753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 357756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 357763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357773 */     GIR_RootConstrainSelectedInstOperands,
     /* 357774 */     // GIR_Coverage, 6439,
     /* 357774 */     GIR_EraseRootFromParent_Done,
     /* 357775 */   // Label 7190: @357775
     /* 357775 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(357829), // Rule ID 1934 //
     /* 357780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357813 */     // MIs[1] Operand 1
     /* 357813 */     // No operand predicates
     /* 357813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357815 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 357815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 357818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 357825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357827 */     GIR_RootConstrainSelectedInstOperands,
     /* 357828 */     // GIR_Coverage, 1934,
     /* 357828 */     GIR_EraseRootFromParent_Done,
     /* 357829 */   // Label 7191: @357829
     /* 357829 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(357935), // Rule ID 5707 //
     /* 357834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 357837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357864 */     // MIs[1] Operand 1
     /* 357864 */     // No operand predicates
     /* 357864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357866 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 357866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 357869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 357902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 357924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 357927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357933 */     GIR_RootConstrainSelectedInstOperands,
     /* 357934 */     // GIR_Coverage, 5707,
     /* 357934 */     GIR_EraseRootFromParent_Done,
     /* 357935 */   // Label 7192: @357935
     /* 357935 */   GIM_Reject,
     /* 357936 */ // Label 7175: @357936
     /* 357936 */ GIM_Reject,
     /* 357937 */ // Label 6979: @357937
     /* 357937 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(358061), // Rule ID 11212 //
     /* 357942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 357948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 357951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357966 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 357966 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357969 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 357973 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357978 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 357982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 357991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357996 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357999 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358004 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358007 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358011 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358016 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358033 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358036 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358039 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358042 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 358050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358052 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358057 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358059 */   GIR_RootConstrainSelectedInstOperands,
     /* 358060 */   // GIR_Coverage, 11212,
     /* 358060 */   GIR_EraseRootFromParent_Done,
     /* 358061 */ // Label 7193: @358061
     /* 358061 */ GIM_Reject,
     /* 358062 */ // Label 6980: @358062
     /* 358062 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(358186), // Rule ID 11215 //
     /* 358067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 358073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358091 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 358091 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358094 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 358098 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358103 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 358107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358109 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358112 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 358116 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358121 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358124 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358129 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358132 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358136 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358141 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358161 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358164 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358167 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 358175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358177 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358182 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358184 */   GIR_RootConstrainSelectedInstOperands,
     /* 358185 */   // GIR_Coverage, 11215,
     /* 358185 */   GIR_EraseRootFromParent_Done,
     /* 358186 */ // Label 7194: @358186
     /* 358186 */ GIM_Reject,
     /* 358187 */ // Label 6981: @358187
     /* 358187 */ GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360164),
     /* 358192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358205 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(358314), // Rule ID 4320 //
     /* 358210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358214 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358220 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358230 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358237 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358254 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358281 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358313 */     // GIR_Coverage, 4320,
     /* 358313 */     GIR_EraseRootFromParent_Done,
     /* 358314 */   // Label 7196: @358314
     /* 358314 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(358423), // Rule ID 4321 //
     /* 358319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358363 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358390 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358422 */     // GIR_Coverage, 4321,
     /* 358422 */     GIR_EraseRootFromParent_Done,
     /* 358423 */   // Label 7197: @358423
     /* 358423 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(358532), // Rule ID 4428 //
     /* 358428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358438 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358448 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358455 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358472 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358499 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358531 */     // GIR_Coverage, 4428,
     /* 358531 */     GIR_EraseRootFromParent_Done,
     /* 358532 */   // Label 7198: @358532
     /* 358532 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(358641), // Rule ID 4429 //
     /* 358537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358557 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358564 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358581 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358608 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358640 */     // GIR_Coverage, 4429,
     /* 358640 */     GIR_EraseRootFromParent_Done,
     /* 358641 */   // Label 7199: @358641
     /* 358641 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(358746), // Rule ID 4326 //
     /* 358646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358662 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358669 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358686 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358713 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358745 */     // GIR_Coverage, 4326,
     /* 358745 */     GIR_EraseRootFromParent_Done,
     /* 358746 */   // Label 7200: @358746
     /* 358746 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(358851), // Rule ID 4328 //
     /* 358751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358767 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358774 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358791 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358818 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358850 */     // GIR_Coverage, 4328,
     /* 358850 */     GIR_EraseRootFromParent_Done,
     /* 358851 */   // Label 7201: @358851
     /* 358851 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(358956), // Rule ID 4434 //
     /* 358856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358872 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358879 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358896 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358923 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358955 */     // GIR_Coverage, 4434,
     /* 358955 */     GIR_EraseRootFromParent_Done,
     /* 358956 */   // Label 7202: @358956
     /* 358956 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(359061), // Rule ID 4436 //
     /* 358961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358977 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358984 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359001 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359028 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359060 */     // GIR_Coverage, 4436,
     /* 359060 */     GIR_EraseRootFromParent_Done,
     /* 359061 */   // Label 7203: @359061
     /* 359061 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(359165), // Rule ID 4318 //
     /* 359066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359070 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359076 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359086 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359093 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359110 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359132 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359164 */     // GIR_Coverage, 4318,
     /* 359164 */     GIR_EraseRootFromParent_Done,
     /* 359165 */   // Label 7204: @359165
     /* 359165 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(359269), // Rule ID 4319 //
     /* 359170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359180 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359190 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359197 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359214 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359236 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359268 */     // GIR_Coverage, 4319,
     /* 359268 */     GIR_EraseRootFromParent_Done,
     /* 359269 */   // Label 7205: @359269
     /* 359269 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(359373), // Rule ID 4426 //
     /* 359274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359278 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359284 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359294 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359301 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359318 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359340 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359372 */     // GIR_Coverage, 4426,
     /* 359372 */     GIR_EraseRootFromParent_Done,
     /* 359373 */   // Label 7206: @359373
     /* 359373 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(359477), // Rule ID 4427 //
     /* 359378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359382 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359388 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359398 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359405 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359422 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359444 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359476 */     // GIR_Coverage, 4427,
     /* 359476 */     GIR_EraseRootFromParent_Done,
     /* 359477 */   // Label 7207: @359477
     /* 359477 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(359577), // Rule ID 4322 //
     /* 359482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359498 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359505 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359522 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359544 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359576 */     // GIR_Coverage, 4322,
     /* 359576 */     GIR_EraseRootFromParent_Done,
     /* 359577 */   // Label 7208: @359577
     /* 359577 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(359677), // Rule ID 4324 //
     /* 359582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359598 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359605 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359622 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359644 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359676 */     // GIR_Coverage, 4324,
     /* 359676 */     GIR_EraseRootFromParent_Done,
     /* 359677 */   // Label 7209: @359677
     /* 359677 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(359777), // Rule ID 4430 //
     /* 359682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359698 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359705 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359722 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359744 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359776 */     // GIR_Coverage, 4430,
     /* 359776 */     GIR_EraseRootFromParent_Done,
     /* 359777 */   // Label 7210: @359777
     /* 359777 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(359877), // Rule ID 4432 //
     /* 359782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359798 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359805 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359822 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359844 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359876 */     // GIR_Coverage, 4432,
     /* 359876 */     GIR_EraseRootFromParent_Done,
     /* 359877 */   // Label 7211: @359877
     /* 359877 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(359941), // Rule ID 11270 //
     /* 359882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359917 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 359921 */     // MIs[3] Operand 1
     /* 359921 */     // No operand predicates
     /* 359921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359927 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 359927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 359930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 359936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 359939 */     GIR_RootConstrainSelectedInstOperands,
     /* 359940 */     // GIR_Coverage, 11270,
     /* 359940 */     GIR_EraseRootFromParent_Done,
     /* 359941 */   // Label 7212: @359941
     /* 359941 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(360052), // Rule ID 11211 //
     /* 359946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359957 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 359957 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359960 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 359964 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359969 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 359973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359975 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359978 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 359982 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359987 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 360002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360007 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 360019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360033 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 360041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360043 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360050 */     GIR_RootConstrainSelectedInstOperands,
     /* 360051 */     // GIR_Coverage, 11211,
     /* 360051 */     GIR_EraseRootFromParent_Done,
     /* 360052 */   // Label 7213: @360052
     /* 360052 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(360163), // Rule ID 11217 //
     /* 360057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360068 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 360068 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360071 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 360075 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360080 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 360084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 360093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360098 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360101 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 360113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 360130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360138 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360144 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 360152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360154 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360161 */     GIR_RootConstrainSelectedInstOperands,
     /* 360162 */     // GIR_Coverage, 11217,
     /* 360162 */     GIR_EraseRootFromParent_Done,
     /* 360163 */   // Label 7214: @360163
     /* 360163 */   GIM_Reject,
     /* 360164 */ // Label 7195: @360164
     /* 360164 */ GIM_Reject,
     /* 360165 */ // Label 6982: @360165
     /* 360165 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(360316), // Rule ID 11213 //
     /* 360170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360190 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360194 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 360194 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360197 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360201 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360206 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360212 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360217 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360222 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360225 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 360229 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360234 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360239 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360242 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 360246 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360251 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360254 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 360266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360271 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 360283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360294 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360297 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 360305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360307 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360312 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360314 */   GIR_RootConstrainSelectedInstOperands,
     /* 360315 */   // GIR_Coverage, 11213,
     /* 360315 */   GIR_EraseRootFromParent_Done,
     /* 360316 */ // Label 7215: @360316
     /* 360316 */ GIM_Reject,
     /* 360317 */ // Label 6983: @360317
     /* 360317 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362348),
     /* 360322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 360325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360335 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(360444), // Rule ID 4284 //
     /* 360340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360384 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360411 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360443 */     // GIR_Coverage, 4284,
     /* 360443 */     GIR_EraseRootFromParent_Done,
     /* 360444 */   // Label 7217: @360444
     /* 360444 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(360553), // Rule ID 4285 //
     /* 360449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360469 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360476 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360493 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360552 */     // GIR_Coverage, 4285,
     /* 360552 */     GIR_EraseRootFromParent_Done,
     /* 360553 */   // Label 7218: @360553
     /* 360553 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(360662), // Rule ID 4392 //
     /* 360558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360602 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360661 */     // GIR_Coverage, 4392,
     /* 360661 */     GIR_EraseRootFromParent_Done,
     /* 360662 */   // Label 7219: @360662
     /* 360662 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(360771), // Rule ID 4393 //
     /* 360667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360694 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360711 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360770 */     // GIR_Coverage, 4393,
     /* 360770 */     GIR_EraseRootFromParent_Done,
     /* 360771 */   // Label 7220: @360771
     /* 360771 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(360876), // Rule ID 4290 //
     /* 360776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360816 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360875 */     // GIR_Coverage, 4290,
     /* 360875 */     GIR_EraseRootFromParent_Done,
     /* 360876 */   // Label 7221: @360876
     /* 360876 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(360981), // Rule ID 4292 //
     /* 360881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360921 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360980 */     // GIR_Coverage, 4292,
     /* 360980 */     GIR_EraseRootFromParent_Done,
     /* 360981 */   // Label 7222: @360981
     /* 360981 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(361086), // Rule ID 4398 //
     /* 360986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361002 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361009 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 361026 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 361026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 361033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361085 */     // GIR_Coverage, 4398,
     /* 361085 */     GIR_EraseRootFromParent_Done,
     /* 361086 */   // Label 7223: @361086
     /* 361086 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(361191), // Rule ID 4400 //
     /* 361091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 361131 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 361131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 361138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361190 */     // GIR_Coverage, 4400,
     /* 361190 */     GIR_EraseRootFromParent_Done,
     /* 361191 */   // Label 7224: @361191
     /* 361191 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(361295), // Rule ID 4282 //
     /* 361196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361223 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361240 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361294 */     // GIR_Coverage, 4282,
     /* 361294 */     GIR_EraseRootFromParent_Done,
     /* 361295 */   // Label 7225: @361295
     /* 361295 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(361399), // Rule ID 4283 //
     /* 361300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361327 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361344 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361398 */     // GIR_Coverage, 4283,
     /* 361398 */     GIR_EraseRootFromParent_Done,
     /* 361399 */   // Label 7226: @361399
     /* 361399 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(361503), // Rule ID 4390 //
     /* 361404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361424 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361431 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361448 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361502 */     // GIR_Coverage, 4390,
     /* 361502 */     GIR_EraseRootFromParent_Done,
     /* 361503 */   // Label 7227: @361503
     /* 361503 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(361607), // Rule ID 4391 //
     /* 361508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361528 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361552 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361606 */     // GIR_Coverage, 4391,
     /* 361606 */     GIR_EraseRootFromParent_Done,
     /* 361607 */   // Label 7228: @361607
     /* 361607 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(361707), // Rule ID 4286 //
     /* 361612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361628 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361635 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361652 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361706 */     // GIR_Coverage, 4286,
     /* 361706 */     GIR_EraseRootFromParent_Done,
     /* 361707 */   // Label 7229: @361707
     /* 361707 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(361807), // Rule ID 4288 //
     /* 361712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361728 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361752 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361806 */     // GIR_Coverage, 4288,
     /* 361806 */     GIR_EraseRootFromParent_Done,
     /* 361807 */   // Label 7230: @361807
     /* 361807 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(361907), // Rule ID 4394 //
     /* 361812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361852 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361906 */     // GIR_Coverage, 4394,
     /* 361906 */     GIR_EraseRootFromParent_Done,
     /* 361907 */   // Label 7231: @361907
     /* 361907 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(362007), // Rule ID 4396 //
     /* 361912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361952 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361974 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362006 */     // GIR_Coverage, 4396,
     /* 362006 */     GIR_EraseRootFromParent_Done,
     /* 362007 */   // Label 7232: @362007
     /* 362007 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362071), // Rule ID 11268 //
     /* 362012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362047 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362051 */     // MIs[3] Operand 1
     /* 362051 */     // No operand predicates
     /* 362051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362057 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 362057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 362066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 362069 */     GIR_RootConstrainSelectedInstOperands,
     /* 362070 */     // GIR_Coverage, 11268,
     /* 362070 */     GIR_EraseRootFromParent_Done,
     /* 362071 */   // Label 7233: @362071
     /* 362071 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(362209), // Rule ID 11210 //
     /* 362076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362087 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 362087 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362090 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362094 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362099 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362105 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362110 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362115 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362118 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 362122 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362127 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 362135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 362139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362144 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362147 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 362150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362152 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 362155 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 362159 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 362167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 362176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362184 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 362190 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 362198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362200 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 362207 */     GIR_RootConstrainSelectedInstOperands,
     /* 362208 */     // GIR_Coverage, 11210,
     /* 362208 */     GIR_EraseRootFromParent_Done,
     /* 362209 */   // Label 7234: @362209
     /* 362209 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(362347), // Rule ID 11216 //
     /* 362214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362225 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 362225 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362228 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362232 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362237 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362243 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362248 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362253 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362256 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 362260 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362265 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362270 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 362273 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 362277 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362282 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 362288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 362293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 362297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 362305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 362314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 362328 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 362336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362338 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 362345 */     GIR_RootConstrainSelectedInstOperands,
     /* 362346 */     // GIR_Coverage, 11216,
     /* 362346 */     GIR_EraseRootFromParent_Done,
     /* 362347 */   // Label 7235: @362347
     /* 362347 */   GIM_Reject,
     /* 362348 */ // Label 7216: @362348
     /* 362348 */ GIM_Reject,
     /* 362349 */ // Label 6984: @362349
     /* 362349 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364616),
     /* 362354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362357 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(362483), // Rule ID 4248 //
     /* 362362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362382 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362392 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362395 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362399 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362423 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362482 */     // GIR_Coverage, 4248,
     /* 362482 */     GIR_EraseRootFromParent_Done,
     /* 362483 */   // Label 7237: @362483
     /* 362483 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(362609), // Rule ID 4249 //
     /* 362488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362502 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362508 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362518 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362521 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362525 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362549 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362576 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362608 */     // GIR_Coverage, 4249,
     /* 362608 */     GIR_EraseRootFromParent_Done,
     /* 362609 */   // Label 7238: @362609
     /* 362609 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(362728), // Rule ID 4356 //
     /* 362614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362628 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362634 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362644 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362651 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362668 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362695 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362727 */     // GIR_Coverage, 4356,
     /* 362727 */     GIR_EraseRootFromParent_Done,
     /* 362728 */   // Label 7239: @362728
     /* 362728 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(362847), // Rule ID 4357 //
     /* 362733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362747 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362753 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362763 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362770 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362787 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362814 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362846 */     // GIR_Coverage, 4357,
     /* 362846 */     GIR_EraseRootFromParent_Done,
     /* 362847 */   // Label 7240: @362847
     /* 362847 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(362969), // Rule ID 4254 //
     /* 362852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362878 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362881 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362885 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362909 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362936 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362968 */     // GIR_Coverage, 4254,
     /* 362968 */     GIR_EraseRootFromParent_Done,
     /* 362969 */   // Label 7241: @362969
     /* 362969 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(363091), // Rule ID 4256 //
     /* 362974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363003 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363007 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363031 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363058 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363090 */     // GIR_Coverage, 4256,
     /* 363090 */     GIR_EraseRootFromParent_Done,
     /* 363091 */   // Label 7242: @363091
     /* 363091 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(363206), // Rule ID 4362 //
     /* 363096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363122 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363129 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363146 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363173 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363205 */     // GIR_Coverage, 4362,
     /* 363205 */     GIR_EraseRootFromParent_Done,
     /* 363206 */   // Label 7243: @363206
     /* 363206 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(363321), // Rule ID 4364 //
     /* 363211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363237 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363244 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363261 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363320 */     // GIR_Coverage, 4364,
     /* 363320 */     GIR_EraseRootFromParent_Done,
     /* 363321 */   // Label 7244: @363321
     /* 363321 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(363442), // Rule ID 4246 //
     /* 363326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363356 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363359 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363363 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363370 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363387 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363441 */     // GIR_Coverage, 4246,
     /* 363441 */     GIR_EraseRootFromParent_Done,
     /* 363442 */   // Label 7245: @363442
     /* 363442 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363563), // Rule ID 4247 //
     /* 363447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363461 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363467 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363477 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363480 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363484 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363491 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363508 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363562 */     // GIR_Coverage, 4247,
     /* 363562 */     GIR_EraseRootFromParent_Done,
     /* 363563 */   // Label 7246: @363563
     /* 363563 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363677), // Rule ID 4354 //
     /* 363568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363582 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363588 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363598 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363605 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363622 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363644 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363676 */     // GIR_Coverage, 4354,
     /* 363676 */     GIR_EraseRootFromParent_Done,
     /* 363677 */   // Label 7247: @363677
     /* 363677 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363791), // Rule ID 4355 //
     /* 363682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363696 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363702 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363712 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363719 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363736 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363790 */     // GIR_Coverage, 4355,
     /* 363790 */     GIR_EraseRootFromParent_Done,
     /* 363791 */   // Label 7248: @363791
     /* 363791 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363908), // Rule ID 4250 //
     /* 363796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363822 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363825 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363829 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363836 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363853 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363875 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363907 */     // GIR_Coverage, 4250,
     /* 363907 */     GIR_EraseRootFromParent_Done,
     /* 363908 */   // Label 7249: @363908
     /* 363908 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(364025), // Rule ID 4252 //
     /* 363913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363942 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363946 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363953 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363970 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363992 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364024 */     // GIR_Coverage, 4252,
     /* 364024 */     GIR_EraseRootFromParent_Done,
     /* 364025 */   // Label 7250: @364025
     /* 364025 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(364135), // Rule ID 4358 //
     /* 364030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364056 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364063 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364080 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364102 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364134 */     // GIR_Coverage, 4358,
     /* 364134 */     GIR_EraseRootFromParent_Done,
     /* 364135 */   // Label 7251: @364135
     /* 364135 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(364245), // Rule ID 4360 //
     /* 364140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364166 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364173 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364190 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364212 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364244 */     // GIR_Coverage, 4360,
     /* 364244 */     GIR_EraseRootFromParent_Done,
     /* 364245 */   // Label 7252: @364245
     /* 364245 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(364319), // Rule ID 11266 //
     /* 364250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364295 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364299 */     // MIs[3] Operand 1
     /* 364299 */     // No operand predicates
     /* 364299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364305 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 364305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 364314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 364317 */     GIR_RootConstrainSelectedInstOperands,
     /* 364318 */     // GIR_Coverage, 11266,
     /* 364318 */     GIR_EraseRootFromParent_Done,
     /* 364319 */   // Label 7253: @364319
     /* 364319 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(364467), // Rule ID 11209 //
     /* 364324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364345 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 364345 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 364348 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364352 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364357 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 364363 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364368 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364373 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 364376 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 364380 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364385 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 364393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 364397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364402 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364405 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 364408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 364413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 364417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364422 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 364425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 364434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364448 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 364456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364458 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 364465 */     GIR_RootConstrainSelectedInstOperands,
     /* 364466 */     // GIR_Coverage, 11209,
     /* 364466 */     GIR_EraseRootFromParent_Done,
     /* 364467 */   // Label 7254: @364467
     /* 364467 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(364615), // Rule ID 11214 //
     /* 364472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364493 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 364493 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 364496 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364500 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364505 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 364511 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364516 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 364524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 364528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364533 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 364541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 364545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364553 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 364556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 364561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 364565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364570 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 364573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 364582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364593 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364596 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 364604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364606 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 364613 */     GIR_RootConstrainSelectedInstOperands,
     /* 364614 */     // GIR_Coverage, 11214,
     /* 364614 */     GIR_EraseRootFromParent_Done,
     /* 364615 */   // Label 7255: @364615
     /* 364615 */   GIM_Reject,
     /* 364616 */ // Label 7236: @364616
     /* 364616 */ GIM_Reject,
     /* 364617 */ // Label 6985: @364617
     /* 364617 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(365730),
     /* 364622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 364625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364635 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(364751), // Rule ID 4212 //
     /* 364640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364663 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364667 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364674 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 364691 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 364698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364718 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364750 */     // GIR_Coverage, 4212,
     /* 364750 */     GIR_EraseRootFromParent_Done,
     /* 364751 */   // Label 7257: @364751
     /* 364751 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364867), // Rule ID 4213 //
     /* 364756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364779 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364783 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 364807 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 364814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364834 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364866 */     // GIR_Coverage, 4213,
     /* 364866 */     GIR_EraseRootFromParent_Done,
     /* 364867 */   // Label 7258: @364867
     /* 364867 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364979), // Rule ID 4218 //
     /* 364872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364891 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364895 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 364919 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 364926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364978 */     // GIR_Coverage, 4218,
     /* 364978 */     GIR_EraseRootFromParent_Done,
     /* 364979 */   // Label 7259: @364979
     /* 364979 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(365091), // Rule ID 4220 //
     /* 364984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365003 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365007 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 365031 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 365031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 365038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365058 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365090 */     // GIR_Coverage, 4220,
     /* 365090 */     GIR_EraseRootFromParent_Done,
     /* 365091 */   // Label 7260: @365091
     /* 365091 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(365202), // Rule ID 4210 //
     /* 365096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365100 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365106 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365116 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365119 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365123 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365130 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 365147 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 365147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 365154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365201 */     // GIR_Coverage, 4210,
     /* 365201 */     GIR_EraseRootFromParent_Done,
     /* 365202 */   // Label 7261: @365202
     /* 365202 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(365313), // Rule ID 4211 //
     /* 365207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365227 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365230 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365234 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365241 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 365258 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 365258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 365265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365312 */     // GIR_Coverage, 4211,
     /* 365312 */     GIR_EraseRootFromParent_Done,
     /* 365313 */   // Label 7262: @365313
     /* 365313 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(365420), // Rule ID 4214 //
     /* 365318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365334 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365337 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365341 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365348 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 365365 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 365365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 365372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365387 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365419 */     // GIR_Coverage, 4214,
     /* 365419 */     GIR_EraseRootFromParent_Done,
     /* 365420 */   // Label 7263: @365420
     /* 365420 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(365527), // Rule ID 4216 //
     /* 365425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365444 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365448 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365455 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 365472 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 365472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 365479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365494 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365526 */     // GIR_Coverage, 4216,
     /* 365526 */     GIR_EraseRootFromParent_Done,
     /* 365527 */   // Label 7264: @365527
     /* 365527 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(365591), // Rule ID 11264 //
     /* 365532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 365555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365567 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 365571 */     // MIs[3] Operand 1
     /* 365571 */     // No operand predicates
     /* 365571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365577 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 365577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 365580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 365586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 365589 */     GIR_RootConstrainSelectedInstOperands,
     /* 365590 */     // GIR_Coverage, 11264,
     /* 365590 */     GIR_EraseRootFromParent_Done,
     /* 365591 */   // Label 7265: @365591
     /* 365591 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(365729), // Rule ID 11208 //
     /* 365596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365607 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 365607 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 365610 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365614 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365619 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 365625 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365630 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365635 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 365638 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 365642 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365647 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 365650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 365652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 365655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 365659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365664 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 365667 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 365670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 365675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 365679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365684 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 365687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 365692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 365696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365701 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 365710 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 365713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 365718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365720 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 365722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365725 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 365727 */     GIR_RootConstrainSelectedInstOperands,
     /* 365728 */     // GIR_Coverage, 11208,
     /* 365728 */     GIR_EraseRootFromParent_Done,
     /* 365729 */   // Label 7266: @365729
     /* 365729 */   GIM_Reject,
     /* 365730 */ // Label 7256: @365730
     /* 365730 */ GIM_Reject,
     /* 365731 */ // Label 6986: @365731
     /* 365731 */ GIM_Reject,
     /* 365732 */ // Label 91: @365732
     /* 365732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7270*/ GIMT_Encode4(368649),
     /* 365743 */ /*GILLT_s16*//*Label 7267*/ GIMT_Encode4(365755),
     /* 365747 */ /*GILLT_s32*//*Label 7268*/ GIMT_Encode4(366389),
     /* 365751 */ /*GILLT_s64*//*Label 7269*/ GIMT_Encode4(367982),
     /* 365755 */ // Label 7267: @365755
     /* 365755 */ GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(365799), // Rule ID 11257 //
     /* 365760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365773 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365777 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 365777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365782 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365798 */   // GIR_Coverage, 11257,
     /* 365798 */   GIR_EraseRootFromParent_Done,
     /* 365799 */ // Label 7271: @365799
     /* 365799 */ GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(365843), // Rule ID 11258 //
     /* 365804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 365810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365817 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365821 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 365821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365826 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365842 */   // GIR_Coverage, 11258,
     /* 365842 */   GIR_EraseRootFromParent_Done,
     /* 365843 */ // Label 7272: @365843
     /* 365843 */ GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(365887), // Rule ID 11259 //
     /* 365848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 365854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365861 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365865 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 365865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365870 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365886 */   // GIR_Coverage, 11259,
     /* 365886 */   GIR_EraseRootFromParent_Done,
     /* 365887 */ // Label 7273: @365887
     /* 365887 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(365932), // Rule ID 5789 //
     /* 365892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365906 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365910 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 365910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365915 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365931 */   // GIR_Coverage, 5789,
     /* 365931 */   GIR_EraseRootFromParent_Done,
     /* 365932 */ // Label 7274: @365932
     /* 365932 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(365977), // Rule ID 5792 //
     /* 365937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365951 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365955 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365959 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365963 */   // MIs[1] Operand 1
     /* 365963 */   // No operand predicates
     /* 365963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365965 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 365968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365970 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365972 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365975 */   GIR_RootConstrainSelectedInstOperands,
     /* 365976 */   // GIR_Coverage, 5792,
     /* 365976 */   GIR_EraseRootFromParent_Done,
     /* 365977 */ // Label 7275: @365977
     /* 365977 */ GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(366053), // Rule ID 11232 //
     /* 365982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366003 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366007 */   // MIs[1] Operand 1
     /* 366007 */   // No operand predicates
     /* 366007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366009 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 366009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366021 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366025 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366035 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366052 */   // GIR_Coverage, 11232,
     /* 366052 */   GIR_EraseRootFromParent_Done,
     /* 366053 */ // Label 7276: @366053
     /* 366053 */ GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(366129), // Rule ID 11233 //
     /* 366058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 366064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366079 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366083 */   // MIs[1] Operand 1
     /* 366083 */   // No operand predicates
     /* 366083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366085 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 366085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366101 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366111 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366118 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366128 */   // GIR_Coverage, 11233,
     /* 366128 */   GIR_EraseRootFromParent_Done,
     /* 366129 */ // Label 7277: @366129
     /* 366129 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(366205), // Rule ID 11234 //
     /* 366134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 366140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366155 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 366159 */   // MIs[1] Operand 1
     /* 366159 */   // No operand predicates
     /* 366159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366161 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 366161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 366168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366173 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366177 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366187 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366204 */   // GIR_Coverage, 11234,
     /* 366204 */   GIR_EraseRootFromParent_Done,
     /* 366205 */ // Label 7278: @366205
     /* 366205 */ GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(366266), // Rule ID 11222 //
     /* 366210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366227 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 366227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 366234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366239 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366245 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366249 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366262 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366264 */   GIR_RootConstrainSelectedInstOperands,
     /* 366265 */   // GIR_Coverage, 11222,
     /* 366265 */   GIR_EraseRootFromParent_Done,
     /* 366266 */ // Label 7279: @366266
     /* 366266 */ GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(366327), // Rule ID 11223 //
     /* 366271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 366277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366288 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 366288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 366295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366300 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366306 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366310 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366323 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366325 */   GIR_RootConstrainSelectedInstOperands,
     /* 366326 */   // GIR_Coverage, 11223,
     /* 366326 */   GIR_EraseRootFromParent_Done,
     /* 366327 */ // Label 7280: @366327
     /* 366327 */ GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(366388), // Rule ID 11224 //
     /* 366332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 366338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366349 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 366349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 366356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366361 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366371 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366384 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366386 */   GIR_RootConstrainSelectedInstOperands,
     /* 366387 */   // GIR_Coverage, 11224,
     /* 366387 */   GIR_EraseRootFromParent_Done,
     /* 366388 */ // Label 7281: @366388
     /* 366388 */ GIM_Reject,
     /* 366389 */ // Label 7268: @366389
     /* 366389 */ GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(366434), // Rule ID 6966 //
     /* 366394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366408 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366412 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 366412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366417 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 366423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366433 */   // GIR_Coverage, 6966,
     /* 366433 */   GIR_EraseRootFromParent_Done,
     /* 366434 */ // Label 7282: @366434
     /* 366434 */ GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(366479), // Rule ID 6967 //
     /* 366439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366453 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366457 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 366457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366462 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 366468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366478 */   // GIR_Coverage, 6967,
     /* 366478 */   GIR_EraseRootFromParent_Done,
     /* 366479 */ // Label 7283: @366479
     /* 366479 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(366523), // Rule ID 11253 //
     /* 366484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366497 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366501 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 366501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366506 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366522 */   // GIR_Coverage, 11253,
     /* 366522 */   GIR_EraseRootFromParent_Done,
     /* 366523 */ // Label 7284: @366523
     /* 366523 */ GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(366567), // Rule ID 11254 //
     /* 366528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366541 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366545 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 366545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366550 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366566 */   // GIR_Coverage, 11254,
     /* 366566 */   GIR_EraseRootFromParent_Done,
     /* 366567 */ // Label 7285: @366567
     /* 366567 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(366611), // Rule ID 11255 //
     /* 366572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366585 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366589 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 366589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366594 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366610 */   // GIR_Coverage, 11255,
     /* 366610 */   GIR_EraseRootFromParent_Done,
     /* 366611 */ // Label 7286: @366611
     /* 366611 */ GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(366655), // Rule ID 11260 //
     /* 366616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366629 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366633 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 366633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366638 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366654 */   // GIR_Coverage, 11260,
     /* 366654 */   GIR_EraseRootFromParent_Done,
     /* 366655 */ // Label 7287: @366655
     /* 366655 */ GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(366699), // Rule ID 11261 //
     /* 366660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 366666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366673 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366677 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 366677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366682 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366698 */   // GIR_Coverage, 11261,
     /* 366698 */   GIR_EraseRootFromParent_Done,
     /* 366699 */ // Label 7288: @366699
     /* 366699 */ GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(366744), // Rule ID 5788 //
     /* 366704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366718 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366722 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 366722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366727 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 366733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366743 */   // GIR_Coverage, 5788,
     /* 366743 */   GIR_EraseRootFromParent_Done,
     /* 366744 */ // Label 7289: @366744
     /* 366744 */ GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(366817), // Rule ID 11238 //
     /* 366749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366770 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 366774 */   // MIs[1] Operand 1
     /* 366774 */   // No operand predicates
     /* 366774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366776 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 366776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 366779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366788 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 366807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366812 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366815 */   GIR_RootConstrainSelectedInstOperands,
     /* 366816 */   // GIR_Coverage, 11238,
     /* 366816 */   GIR_EraseRootFromParent_Done,
     /* 366817 */ // Label 7290: @366817
     /* 366817 */ GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(366890), // Rule ID 11239 //
     /* 366822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366843 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366847 */   // MIs[1] Operand 1
     /* 366847 */   // No operand predicates
     /* 366847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366849 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 366849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 366852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366861 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 366880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366885 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366888 */   GIR_RootConstrainSelectedInstOperands,
     /* 366889 */   // GIR_Coverage, 11239,
     /* 366889 */   GIR_EraseRootFromParent_Done,
     /* 366890 */ // Label 7291: @366890
     /* 366890 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(366963), // Rule ID 11240 //
     /* 366895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366916 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366920 */   // MIs[1] Operand 1
     /* 366920 */   // No operand predicates
     /* 366920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366922 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 366922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366934 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 366953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366958 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366961 */   GIR_RootConstrainSelectedInstOperands,
     /* 366962 */   // GIR_Coverage, 11240,
     /* 366962 */   GIR_EraseRootFromParent_Done,
     /* 366963 */ // Label 7292: @366963
     /* 366963 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(367011), // Rule ID 1926 //
     /* 366968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 366971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 366974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366993 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 366997 */   // MIs[1] Operand 1
     /* 366997 */   // No operand predicates
     /* 366997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366999 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 366999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 367002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367004 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367006 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367009 */   GIR_RootConstrainSelectedInstOperands,
     /* 367010 */   // GIR_Coverage, 1926,
     /* 367010 */   GIR_EraseRootFromParent_Done,
     /* 367011 */ // Label 7293: @367011
     /* 367011 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(367059), // Rule ID 1927 //
     /* 367016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 367019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367041 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 367045 */   // MIs[1] Operand 1
     /* 367045 */   // No operand predicates
     /* 367045 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367047 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 367050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367052 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367054 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367057 */   GIR_RootConstrainSelectedInstOperands,
     /* 367058 */   // GIR_Coverage, 1927,
     /* 367058 */   GIR_EraseRootFromParent_Done,
     /* 367059 */ // Label 7294: @367059
     /* 367059 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(367107), // Rule ID 1928 //
     /* 367064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 367067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367081 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367089 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 367093 */   // MIs[1] Operand 1
     /* 367093 */   // No operand predicates
     /* 367093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367095 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 367098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367100 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367102 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367105 */   GIR_RootConstrainSelectedInstOperands,
     /* 367106 */   // GIR_Coverage, 1928,
     /* 367106 */   GIR_EraseRootFromParent_Done,
     /* 367107 */ // Label 7295: @367107
     /* 367107 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(367155), // Rule ID 1930 //
     /* 367112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367137 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 367141 */   // MIs[1] Operand 1
     /* 367141 */   // No operand predicates
     /* 367141 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367143 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 367146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367148 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367150 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367153 */   GIR_RootConstrainSelectedInstOperands,
     /* 367154 */   // GIR_Coverage, 1930,
     /* 367154 */   GIR_EraseRootFromParent_Done,
     /* 367155 */ // Label 7296: @367155
     /* 367155 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(367203), // Rule ID 1931 //
     /* 367160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367185 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367189 */   // MIs[1] Operand 1
     /* 367189 */   // No operand predicates
     /* 367189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367191 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 367194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367196 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367198 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367201 */   GIR_RootConstrainSelectedInstOperands,
     /* 367202 */   // GIR_Coverage, 1931,
     /* 367202 */   GIR_EraseRootFromParent_Done,
     /* 367203 */ // Label 7297: @367203
     /* 367203 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(367251), // Rule ID 1932 //
     /* 367208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367233 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367237 */   // MIs[1] Operand 1
     /* 367237 */   // No operand predicates
     /* 367237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367239 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 367242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367244 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367246 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367249 */   GIR_RootConstrainSelectedInstOperands,
     /* 367250 */   // GIR_Coverage, 1932,
     /* 367250 */   GIR_EraseRootFromParent_Done,
     /* 367251 */ // Label 7298: @367251
     /* 367251 */ GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(367296), // Rule ID 5791 //
     /* 367256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367278 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367282 */   // MIs[1] Operand 1
     /* 367282 */   // No operand predicates
     /* 367282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367284 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 367287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367289 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367291 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367294 */   GIR_RootConstrainSelectedInstOperands,
     /* 367295 */   // GIR_Coverage, 5791,
     /* 367295 */   GIR_EraseRootFromParent_Done,
     /* 367296 */ // Label 7299: @367296
     /* 367296 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(367372), // Rule ID 11228 //
     /* 367301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 367307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367322 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 367326 */   // MIs[1] Operand 1
     /* 367326 */   // No operand predicates
     /* 367326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367328 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 367328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 367335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367344 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367354 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367371 */   // GIR_Coverage, 11228,
     /* 367371 */   GIR_EraseRootFromParent_Done,
     /* 367372 */ // Label 7300: @367372
     /* 367372 */ GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(367448), // Rule ID 11229 //
     /* 367377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 367383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367398 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 367402 */   // MIs[1] Operand 1
     /* 367402 */   // No operand predicates
     /* 367402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367404 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 367404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 367411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367416 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367420 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367430 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367447 */   // GIR_Coverage, 11229,
     /* 367447 */   GIR_EraseRootFromParent_Done,
     /* 367448 */ // Label 7301: @367448
     /* 367448 */ GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(367524), // Rule ID 11230 //
     /* 367453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367474 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367478 */   // MIs[1] Operand 1
     /* 367478 */   // No operand predicates
     /* 367478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367480 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 367480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367492 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367496 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367506 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367523 */   // GIR_Coverage, 11230,
     /* 367523 */   GIR_EraseRootFromParent_Done,
     /* 367524 */ // Label 7302: @367524
     /* 367524 */ GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(367600), // Rule ID 11235 //
     /* 367529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367550 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367554 */   // MIs[1] Operand 1
     /* 367554 */   // No operand predicates
     /* 367554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367556 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 367556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367572 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367582 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367599 */   // GIR_Coverage, 11235,
     /* 367599 */   GIR_EraseRootFromParent_Done,
     /* 367600 */ // Label 7303: @367600
     /* 367600 */ GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(367676), // Rule ID 11236 //
     /* 367605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 367611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367626 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 367630 */   // MIs[1] Operand 1
     /* 367630 */   // No operand predicates
     /* 367630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367632 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 367632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 367639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367644 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367648 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367658 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367670 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367675 */   // GIR_Coverage, 11236,
     /* 367675 */   GIR_EraseRootFromParent_Done,
     /* 367676 */ // Label 7304: @367676
     /* 367676 */ GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(367737), // Rule ID 11218 //
     /* 367681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 367687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367698 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 367698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 367705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367710 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367716 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367720 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 367728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367733 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367735 */   GIR_RootConstrainSelectedInstOperands,
     /* 367736 */   // GIR_Coverage, 11218,
     /* 367736 */   GIR_EraseRootFromParent_Done,
     /* 367737 */ // Label 7305: @367737
     /* 367737 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(367798), // Rule ID 11219 //
     /* 367742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 367748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367759 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 367759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 367766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367771 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367777 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367781 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 367789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367794 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367796 */   GIR_RootConstrainSelectedInstOperands,
     /* 367797 */   // GIR_Coverage, 11219,
     /* 367797 */   GIR_EraseRootFromParent_Done,
     /* 367798 */ // Label 7306: @367798
     /* 367798 */ GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(367859), // Rule ID 11220 //
     /* 367803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367820 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 367820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 367827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367832 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367842 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 367850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367855 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367857 */   GIR_RootConstrainSelectedInstOperands,
     /* 367858 */   // GIR_Coverage, 11220,
     /* 367858 */   GIR_EraseRootFromParent_Done,
     /* 367859 */ // Label 7307: @367859
     /* 367859 */ GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(367920), // Rule ID 11225 //
     /* 367864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367881 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 367881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 367888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367893 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367899 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367903 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 367911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 367913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367916 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367918 */   GIR_RootConstrainSelectedInstOperands,
     /* 367919 */   // GIR_Coverage, 11225,
     /* 367919 */   GIR_EraseRootFromParent_Done,
     /* 367920 */ // Label 7308: @367920
     /* 367920 */ GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(367981), // Rule ID 11226 //
     /* 367925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 367931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367942 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 367942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 367949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367954 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367960 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367964 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 367972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 367974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367977 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367979 */   GIR_RootConstrainSelectedInstOperands,
     /* 367980 */   // GIR_Coverage, 11226,
     /* 367980 */   GIR_EraseRootFromParent_Done,
     /* 367981 */ // Label 7309: @367981
     /* 367981 */ GIM_Reject,
     /* 367982 */ // Label 7269: @367982
     /* 367982 */ GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(368027), // Rule ID 6965 //
     /* 367987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368001 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368005 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 368005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368010 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 368016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368026 */   // GIR_Coverage, 6965,
     /* 368026 */   GIR_EraseRootFromParent_Done,
     /* 368027 */ // Label 7310: @368027
     /* 368027 */ GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(368071), // Rule ID 11256 //
     /* 368032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368045 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368049 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 368049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368054 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 368060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368070 */   // GIR_Coverage, 11256,
     /* 368070 */   GIR_EraseRootFromParent_Done,
     /* 368071 */ // Label 7311: @368071
     /* 368071 */ GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(368115), // Rule ID 11262 //
     /* 368076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368089 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368093 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 368093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368098 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 368104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368114 */   // GIR_Coverage, 11262,
     /* 368114 */   GIR_EraseRootFromParent_Done,
     /* 368115 */ // Label 7312: @368115
     /* 368115 */ GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(368160), // Rule ID 5787 //
     /* 368120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368134 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368138 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 368138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368143 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368159 */   // GIR_Coverage, 5787,
     /* 368159 */   GIR_EraseRootFromParent_Done,
     /* 368160 */ // Label 7313: @368160
     /* 368160 */ GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(368233), // Rule ID 11241 //
     /* 368165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368186 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368190 */   // MIs[1] Operand 1
     /* 368190 */   // No operand predicates
     /* 368190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368192 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 368192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 368195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368204 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 368210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 368223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368228 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 368231 */   GIR_RootConstrainSelectedInstOperands,
     /* 368232 */   // GIR_Coverage, 11241,
     /* 368232 */   GIR_EraseRootFromParent_Done,
     /* 368233 */ // Label 7314: @368233
     /* 368233 */ GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(368281), // Rule ID 1929 //
     /* 368238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 368241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368263 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 368267 */   // MIs[1] Operand 1
     /* 368267 */   // No operand predicates
     /* 368267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368269 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 368269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 368272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368276 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368279 */   GIR_RootConstrainSelectedInstOperands,
     /* 368280 */   // GIR_Coverage, 1929,
     /* 368280 */   GIR_EraseRootFromParent_Done,
     /* 368281 */ // Label 7315: @368281
     /* 368281 */ GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(368329), // Rule ID 1933 //
     /* 368286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368311 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368315 */   // MIs[1] Operand 1
     /* 368315 */   // No operand predicates
     /* 368315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368317 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 368317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 368320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368322 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368324 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368327 */   GIR_RootConstrainSelectedInstOperands,
     /* 368328 */   // GIR_Coverage, 1933,
     /* 368328 */   GIR_EraseRootFromParent_Done,
     /* 368329 */ // Label 7316: @368329
     /* 368329 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(368374), // Rule ID 5790 //
     /* 368334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368356 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368360 */   // MIs[1] Operand 1
     /* 368360 */   // No operand predicates
     /* 368360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368362 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 368362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 368365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368367 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368369 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368372 */   GIR_RootConstrainSelectedInstOperands,
     /* 368373 */   // GIR_Coverage, 5790,
     /* 368373 */   GIR_EraseRootFromParent_Done,
     /* 368374 */ // Label 7317: @368374
     /* 368374 */ GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(368450), // Rule ID 11231 //
     /* 368379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368400 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368404 */   // MIs[1] Operand 1
     /* 368404 */   // No operand predicates
     /* 368404 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368406 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 368406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 368422 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 368425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368432 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368449 */   // GIR_Coverage, 11231,
     /* 368449 */   GIR_EraseRootFromParent_Done,
     /* 368450 */ // Label 7318: @368450
     /* 368450 */ GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(368526), // Rule ID 11237 //
     /* 368455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368476 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368480 */   // MIs[1] Operand 1
     /* 368480 */   // No operand predicates
     /* 368480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368482 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 368482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 368498 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 368501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368508 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368525 */   // GIR_Coverage, 11237,
     /* 368525 */   GIR_EraseRootFromParent_Done,
     /* 368526 */ // Label 7319: @368526
     /* 368526 */ GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(368587), // Rule ID 11221 //
     /* 368531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368548 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 368548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 368551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 368555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368560 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 368566 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 368570 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 368573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 368578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368583 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 368585 */   GIR_RootConstrainSelectedInstOperands,
     /* 368586 */   // GIR_Coverage, 11221,
     /* 368586 */   GIR_EraseRootFromParent_Done,
     /* 368587 */ // Label 7320: @368587
     /* 368587 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(368648), // Rule ID 11227 //
     /* 368592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368609 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 368609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 368612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 368616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368621 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 368627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 368631 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 368634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 368639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 368641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368644 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 368646 */   GIR_RootConstrainSelectedInstOperands,
     /* 368647 */   // GIR_Coverage, 11227,
     /* 368647 */   GIR_EraseRootFromParent_Done,
     /* 368648 */ // Label 7321: @368648
     /* 368648 */ GIM_Reject,
     /* 368649 */ // Label 7270: @368649
     /* 368649 */ GIM_Reject,
     /* 368650 */ // Label 92: @368650
     /* 368650 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7329*/ GIMT_Encode4(370969),
     /* 368661 */ /*GILLT_nxv2s16*//*Label 7322*/ GIMT_Encode4(368701),
     /* 368665 */ /*GILLT_nxv2s32*//*Label 7323*/ GIMT_Encode4(369060),
     /* 368669 */ /*GILLT_nxv2s64*//*Label 7324*/ GIMT_Encode4(369362), GIMT_Encode4(0),
     /* 368677 */ /*GILLT_nxv4s16*//*Label 7325*/ GIMT_Encode4(369737),
     /* 368681 */ /*GILLT_nxv4s32*//*Label 7326*/ GIMT_Encode4(370039), GIMT_Encode4(0),
     /* 368689 */ /*GILLT_nxv8s16*//*Label 7327*/ GIMT_Encode4(370414), GIMT_Encode4(0),
     /* 368697 */ /*GILLT_nxv16s8*//*Label 7328*/ GIMT_Encode4(370825),
     /* 368701 */ // Label 7322: @368701
     /* 368701 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(369059),
     /* 368706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368713 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(368777), // Rule ID 6021 //
     /* 368718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368729 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368733 */     // MIs[1] Operand 1
     /* 368733 */     // No operand predicates
     /* 368733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368735 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368776 */     // GIR_Coverage, 6021,
     /* 368776 */     GIR_EraseRootFromParent_Done,
     /* 368777 */   // Label 7331: @368777
     /* 368777 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(368834), // Rule ID 2675 //
     /* 368782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 368797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 368818 */     // MIs[2] Operand 1
     /* 368818 */     // No operand predicates
     /* 368818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368820 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 368820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368832 */     GIR_RootConstrainSelectedInstOperands,
     /* 368833 */     // GIR_Coverage, 2675,
     /* 368833 */     GIR_EraseRootFromParent_Done,
     /* 368834 */   // Label 7332: @368834
     /* 368834 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(368891), // Rule ID 2677 //
     /* 368839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 368854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368875 */     // MIs[2] Operand 1
     /* 368875 */     // No operand predicates
     /* 368875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368877 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 368877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368889 */     GIR_RootConstrainSelectedInstOperands,
     /* 368890 */     // GIR_Coverage, 2677,
     /* 368890 */     GIR_EraseRootFromParent_Done,
     /* 368891 */   // Label 7333: @368891
     /* 368891 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(368948), // Rule ID 8361 //
     /* 368896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 368911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 368932 */     // MIs[2] Operand 1
     /* 368932 */     // No operand predicates
     /* 368932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368934 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 368934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 368937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368946 */     GIR_RootConstrainSelectedInstOperands,
     /* 368947 */     // GIR_Coverage, 8361,
     /* 368947 */     GIR_EraseRootFromParent_Done,
     /* 368948 */   // Label 7334: @368948
     /* 368948 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(368982), // Rule ID 8404 //
     /* 368953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368964 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 368968 */     // MIs[1] Operand 1
     /* 368968 */     // No operand predicates
     /* 368968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368970 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 368970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 368973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368975 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 368980 */     GIR_RootConstrainSelectedInstOperands,
     /* 368981 */     // GIR_Coverage, 8404,
     /* 368981 */     GIR_EraseRootFromParent_Done,
     /* 368982 */   // Label 7335: @368982
     /* 368982 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(369058), // Rule ID 8382 //
     /* 368987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368994 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 368997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 369030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369056 */     GIR_RootConstrainSelectedInstOperands,
     /* 369057 */     // GIR_Coverage, 8382,
     /* 369057 */     GIR_EraseRootFromParent_Done,
     /* 369058 */   // Label 7336: @369058
     /* 369058 */   GIM_Reject,
     /* 369059 */ // Label 7330: @369059
     /* 369059 */ GIM_Reject,
     /* 369060 */ // Label 7323: @369060
     /* 369060 */ GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(369361),
     /* 369065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369072 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(369136), // Rule ID 6019 //
     /* 369077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369088 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369092 */     // MIs[1] Operand 1
     /* 369092 */     // No operand predicates
     /* 369092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369094 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369135 */     // GIR_Coverage, 6019,
     /* 369135 */     GIR_EraseRootFromParent_Done,
     /* 369136 */   // Label 7338: @369136
     /* 369136 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(369193), // Rule ID 8370 //
     /* 369141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 369156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369173 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 369177 */     // MIs[2] Operand 1
     /* 369177 */     // No operand predicates
     /* 369177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369179 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 369179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369191 */     GIR_RootConstrainSelectedInstOperands,
     /* 369192 */     // GIR_Coverage, 8370,
     /* 369192 */     GIR_EraseRootFromParent_Done,
     /* 369193 */   // Label 7339: @369193
     /* 369193 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(369250), // Rule ID 8379 //
     /* 369198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 369213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369234 */     // MIs[2] Operand 1
     /* 369234 */     // No operand predicates
     /* 369234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369236 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369248 */     GIR_RootConstrainSelectedInstOperands,
     /* 369249 */     // GIR_Coverage, 8379,
     /* 369249 */     GIR_EraseRootFromParent_Done,
     /* 369250 */   // Label 7340: @369250
     /* 369250 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(369284), // Rule ID 8406 //
     /* 369255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369266 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 369270 */     // MIs[1] Operand 1
     /* 369270 */     // No operand predicates
     /* 369270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369272 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 369272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 369275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369277 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 369282 */     GIR_RootConstrainSelectedInstOperands,
     /* 369283 */     // GIR_Coverage, 8406,
     /* 369283 */     GIR_EraseRootFromParent_Done,
     /* 369284 */   // Label 7341: @369284
     /* 369284 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(369360), // Rule ID 8384 //
     /* 369289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369296 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369358 */     GIR_RootConstrainSelectedInstOperands,
     /* 369359 */     // GIR_Coverage, 8384,
     /* 369359 */     GIR_EraseRootFromParent_Done,
     /* 369360 */   // Label 7342: @369360
     /* 369360 */   GIM_Reject,
     /* 369361 */ // Label 7337: @369361
     /* 369361 */ GIM_Reject,
     /* 369362 */ // Label 7324: @369362
     /* 369362 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(369736),
     /* 369367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369374 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(369428), // Rule ID 6014 //
     /* 369379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 369386 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369427 */     // GIR_Coverage, 6014,
     /* 369427 */     GIR_EraseRootFromParent_Done,
     /* 369428 */   // Label 7344: @369428
     /* 369428 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(369492), // Rule ID 6018 //
     /* 369433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369444 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369448 */     // MIs[1] Operand 1
     /* 369448 */     // No operand predicates
     /* 369448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369450 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369491 */     // GIR_Coverage, 6018,
     /* 369491 */     GIR_EraseRootFromParent_Done,
     /* 369492 */   // Label 7345: @369492
     /* 369492 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(369549), // Rule ID 2672 //
     /* 369497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 369512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369533 */     // MIs[2] Operand 1
     /* 369533 */     // No operand predicates
     /* 369533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369535 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369547 */     GIR_RootConstrainSelectedInstOperands,
     /* 369548 */     // GIR_Coverage, 2672,
     /* 369548 */     GIR_EraseRootFromParent_Done,
     /* 369549 */   // Label 7346: @369549
     /* 369549 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(369606), // Rule ID 8376 //
     /* 369554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 369569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369590 */     // MIs[2] Operand 1
     /* 369590 */     // No operand predicates
     /* 369590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369592 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369604 */     GIR_RootConstrainSelectedInstOperands,
     /* 369605 */     // GIR_Coverage, 8376,
     /* 369605 */     GIR_EraseRootFromParent_Done,
     /* 369606 */   // Label 7347: @369606
     /* 369606 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(369640), // Rule ID 8407 //
     /* 369611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369622 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 369626 */     // MIs[1] Operand 1
     /* 369626 */     // No operand predicates
     /* 369626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369628 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 369628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 369631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369633 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 369638 */     GIR_RootConstrainSelectedInstOperands,
     /* 369639 */     // GIR_Coverage, 8407,
     /* 369639 */     GIR_EraseRootFromParent_Done,
     /* 369640 */   // Label 7348: @369640
     /* 369640 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(369659), // Rule ID 2391 //
     /* 369645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369652 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 369652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 369657 */     GIR_RootConstrainSelectedInstOperands,
     /* 369658 */     // GIR_Coverage, 2391,
     /* 369658 */     GIR_Done,
     /* 369659 */   // Label 7349: @369659
     /* 369659 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(369735), // Rule ID 8385 //
     /* 369664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369671 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369733 */     GIR_RootConstrainSelectedInstOperands,
     /* 369734 */     // GIR_Coverage, 8385,
     /* 369734 */     GIR_EraseRootFromParent_Done,
     /* 369735 */   // Label 7350: @369735
     /* 369735 */   GIM_Reject,
     /* 369736 */ // Label 7343: @369736
     /* 369736 */ GIM_Reject,
     /* 369737 */ // Label 7325: @369737
     /* 369737 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(370038),
     /* 369742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369749 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(369813), // Rule ID 6022 //
     /* 369754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369765 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369769 */     // MIs[1] Operand 1
     /* 369769 */     // No operand predicates
     /* 369769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369771 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369812 */     // GIR_Coverage, 6022,
     /* 369812 */     GIR_EraseRootFromParent_Done,
     /* 369813 */   // Label 7352: @369813
     /* 369813 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(369870), // Rule ID 2676 //
     /* 369818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 369833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369850 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 369854 */     // MIs[2] Operand 1
     /* 369854 */     // No operand predicates
     /* 369854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369856 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 369856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369868 */     GIR_RootConstrainSelectedInstOperands,
     /* 369869 */     // GIR_Coverage, 2676,
     /* 369869 */     GIR_EraseRootFromParent_Done,
     /* 369870 */   // Label 7353: @369870
     /* 369870 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(369927), // Rule ID 8364 //
     /* 369875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 369890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 369911 */     // MIs[2] Operand 1
     /* 369911 */     // No operand predicates
     /* 369911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369913 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 369913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369925 */     GIR_RootConstrainSelectedInstOperands,
     /* 369926 */     // GIR_Coverage, 8364,
     /* 369926 */     GIR_EraseRootFromParent_Done,
     /* 369927 */   // Label 7354: @369927
     /* 369927 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(369961), // Rule ID 8403 //
     /* 369932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369943 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 369947 */     // MIs[1] Operand 1
     /* 369947 */     // No operand predicates
     /* 369947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369949 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 369949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 369952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369954 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 369959 */     GIR_RootConstrainSelectedInstOperands,
     /* 369960 */     // GIR_Coverage, 8403,
     /* 369960 */     GIR_EraseRootFromParent_Done,
     /* 369961 */   // Label 7355: @369961
     /* 369961 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(370037), // Rule ID 8381 //
     /* 369966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369973 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369999 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 370009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370035 */     GIR_RootConstrainSelectedInstOperands,
     /* 370036 */     // GIR_Coverage, 8381,
     /* 370036 */     GIR_EraseRootFromParent_Done,
     /* 370037 */   // Label 7356: @370037
     /* 370037 */   GIM_Reject,
     /* 370038 */ // Label 7351: @370038
     /* 370038 */ GIM_Reject,
     /* 370039 */ // Label 7326: @370039
     /* 370039 */ GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(370413),
     /* 370044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370051 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(370105), // Rule ID 6015 //
     /* 370056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370063 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370075 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370104 */     // GIR_Coverage, 6015,
     /* 370104 */     GIR_EraseRootFromParent_Done,
     /* 370105 */   // Label 7358: @370105
     /* 370105 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(370169), // Rule ID 6020 //
     /* 370110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370121 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 370125 */     // MIs[1] Operand 1
     /* 370125 */     // No operand predicates
     /* 370125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370127 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370168 */     // GIR_Coverage, 6020,
     /* 370168 */     GIR_EraseRootFromParent_Done,
     /* 370169 */   // Label 7359: @370169
     /* 370169 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(370226), // Rule ID 2669 //
     /* 370174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 370189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 370210 */     // MIs[2] Operand 1
     /* 370210 */     // No operand predicates
     /* 370210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370212 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 370212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370224 */     GIR_RootConstrainSelectedInstOperands,
     /* 370225 */     // GIR_Coverage, 2669,
     /* 370225 */     GIR_EraseRootFromParent_Done,
     /* 370226 */   // Label 7360: @370226
     /* 370226 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(370283), // Rule ID 8373 //
     /* 370231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 370246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370263 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 370267 */     // MIs[2] Operand 1
     /* 370267 */     // No operand predicates
     /* 370267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370269 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 370269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370281 */     GIR_RootConstrainSelectedInstOperands,
     /* 370282 */     // GIR_Coverage, 8373,
     /* 370282 */     GIR_EraseRootFromParent_Done,
     /* 370283 */   // Label 7361: @370283
     /* 370283 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(370317), // Rule ID 8405 //
     /* 370288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370299 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 370303 */     // MIs[1] Operand 1
     /* 370303 */     // No operand predicates
     /* 370303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370305 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 370305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 370308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370310 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 370315 */     GIR_RootConstrainSelectedInstOperands,
     /* 370316 */     // GIR_Coverage, 8405,
     /* 370316 */     GIR_EraseRootFromParent_Done,
     /* 370317 */   // Label 7362: @370317
     /* 370317 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(370336), // Rule ID 2390 //
     /* 370322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370329 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 370334 */     GIR_RootConstrainSelectedInstOperands,
     /* 370335 */     // GIR_Coverage, 2390,
     /* 370335 */     GIR_Done,
     /* 370336 */   // Label 7363: @370336
     /* 370336 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(370412), // Rule ID 8383 //
     /* 370341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370348 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 370351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 370365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 370384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370410 */     GIR_RootConstrainSelectedInstOperands,
     /* 370411 */     // GIR_Coverage, 8383,
     /* 370411 */     GIR_EraseRootFromParent_Done,
     /* 370412 */   // Label 7364: @370412
     /* 370412 */   GIM_Reject,
     /* 370413 */ // Label 7357: @370413
     /* 370413 */ GIM_Reject,
     /* 370414 */ // Label 7327: @370414
     /* 370414 */ GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(370475), // Rule ID 6016 //
     /* 370419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370429 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370433 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370445 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370474 */   // GIR_Coverage, 6016,
     /* 370474 */   GIR_EraseRootFromParent_Done,
     /* 370475 */ // Label 7365: @370475
     /* 370475 */ GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(370546), // Rule ID 6023 //
     /* 370480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370498 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 370502 */   // MIs[1] Operand 1
     /* 370502 */   // No operand predicates
     /* 370502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370504 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370516 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370545 */   // GIR_Coverage, 6023,
     /* 370545 */   GIR_EraseRootFromParent_Done,
     /* 370546 */ // Label 7366: @370546
     /* 370546 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(370610), // Rule ID 2666 //
     /* 370551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370569 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 370573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370577 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370582 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370586 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370590 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 370594 */   // MIs[2] Operand 1
     /* 370594 */   // No operand predicates
     /* 370594 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370596 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 370596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370605 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370608 */   GIR_RootConstrainSelectedInstOperands,
     /* 370609 */   // GIR_Coverage, 2666,
     /* 370609 */   GIR_EraseRootFromParent_Done,
     /* 370610 */ // Label 7367: @370610
     /* 370610 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(370674), // Rule ID 8367 //
     /* 370615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370633 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 370637 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370641 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370646 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370650 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370654 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 370658 */   // MIs[2] Operand 1
     /* 370658 */   // No operand predicates
     /* 370658 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370660 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 370660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370669 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370672 */   GIR_RootConstrainSelectedInstOperands,
     /* 370673 */   // GIR_Coverage, 8367,
     /* 370673 */   GIR_EraseRootFromParent_Done,
     /* 370674 */ // Label 7368: @370674
     /* 370674 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(370715), // Rule ID 8402 //
     /* 370679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370697 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 370701 */   // MIs[1] Operand 1
     /* 370701 */   // No operand predicates
     /* 370701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370703 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 370703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 370706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370708 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 370713 */   GIR_RootConstrainSelectedInstOperands,
     /* 370714 */   // GIR_Coverage, 8402,
     /* 370714 */   GIR_EraseRootFromParent_Done,
     /* 370715 */ // Label 7369: @370715
     /* 370715 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(370741), // Rule ID 2389 //
     /* 370720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370734 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 370739 */   GIR_RootConstrainSelectedInstOperands,
     /* 370740 */   // GIR_Coverage, 2389,
     /* 370740 */   GIR_Done,
     /* 370741 */ // Label 7370: @370741
     /* 370741 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(370824), // Rule ID 8380 //
     /* 370746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370760 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 370763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 370777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370786 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370789 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370793 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 370796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370822 */   GIR_RootConstrainSelectedInstOperands,
     /* 370823 */   // GIR_Coverage, 8380,
     /* 370823 */   GIR_EraseRootFromParent_Done,
     /* 370824 */ // Label 7371: @370824
     /* 370824 */ GIM_Reject,
     /* 370825 */ // Label 7328: @370825
     /* 370825 */ GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(370968),
     /* 370830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370837 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(370891), // Rule ID 6017 //
     /* 370842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370849 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370890 */     // GIR_Coverage, 6017,
     /* 370890 */     GIR_EraseRootFromParent_Done,
     /* 370891 */   // Label 7373: @370891
     /* 370891 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(370948), // Rule ID 2663 //
     /* 370896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 370911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 370932 */     // MIs[2] Operand 1
     /* 370932 */     // No operand predicates
     /* 370932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370934 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 370934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 370937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370946 */     GIR_RootConstrainSelectedInstOperands,
     /* 370947 */     // GIR_Coverage, 2663,
     /* 370947 */     GIR_EraseRootFromParent_Done,
     /* 370948 */   // Label 7374: @370948
     /* 370948 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(370967), // Rule ID 2388 //
     /* 370953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370960 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 370965 */     GIR_RootConstrainSelectedInstOperands,
     /* 370966 */     // GIR_Coverage, 2388,
     /* 370966 */     GIR_Done,
     /* 370967 */   // Label 7375: @370967
     /* 370967 */   GIM_Reject,
     /* 370968 */ // Label 7372: @370968
     /* 370968 */ GIM_Reject,
     /* 370969 */ // Label 7329: @370969
     /* 370969 */ GIM_Reject,
     /* 370970 */ // Label 93: @370970
     /* 370970 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7378*/ GIMT_Encode4(371121),
     /* 370981 */ /*GILLT_s32*//*Label 7376*/ GIMT_Encode4(370989),
     /* 370985 */ /*GILLT_s64*//*Label 7377*/ GIMT_Encode4(371055),
     /* 370989 */ // Label 7376: @370989
     /* 370989 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(371054),
     /* 370994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371005 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(371020), // Rule ID 2321 //
     /* 371010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371013 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 371018 */     GIR_RootConstrainSelectedInstOperands,
     /* 371019 */     // GIR_Coverage, 2321,
     /* 371019 */     GIR_Done,
     /* 371020 */   // Label 7380: @371020
     /* 371020 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(371053), // Rule ID 4005 //
     /* 371025 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 371025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 371032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 371046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371051 */     GIR_RootConstrainSelectedInstOperands,
     /* 371052 */     // GIR_Coverage, 4005,
     /* 371052 */     GIR_EraseRootFromParent_Done,
     /* 371053 */   // Label 7381: @371053
     /* 371053 */   GIM_Reject,
     /* 371054 */ // Label 7379: @371054
     /* 371054 */ GIM_Reject,
     /* 371055 */ // Label 7377: @371055
     /* 371055 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(371120),
     /* 371060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371071 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(371086), // Rule ID 2322 //
     /* 371076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371079 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 371084 */     GIR_RootConstrainSelectedInstOperands,
     /* 371085 */     // GIR_Coverage, 2322,
     /* 371085 */     GIR_Done,
     /* 371086 */   // Label 7383: @371086
     /* 371086 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(371119), // Rule ID 4006 //
     /* 371091 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 371091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 371098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 371112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371117 */     GIR_RootConstrainSelectedInstOperands,
     /* 371118 */     // GIR_Coverage, 4006,
     /* 371118 */     GIR_EraseRootFromParent_Done,
     /* 371119 */   // Label 7384: @371119
     /* 371119 */   GIM_Reject,
     /* 371120 */ // Label 7382: @371120
     /* 371120 */ GIM_Reject,
     /* 371121 */ // Label 7378: @371121
     /* 371121 */ GIM_Reject,
     /* 371122 */ // Label 94: @371122
     /* 371122 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7393*/ GIMT_Encode4(371795),
     /* 371133 */ /*GILLT_s32*//*Label 7385*/ GIMT_Encode4(371173),
     /* 371137 */ /*GILLT_s64*//*Label 7386*/ GIMT_Encode4(371403), GIMT_Encode4(0),
     /* 371145 */ /*GILLT_v2s32*//*Label 7387*/ GIMT_Encode4(371633), GIMT_Encode4(0),
     /* 371153 */ /*GILLT_v4s16*//*Label 7388*/ GIMT_Encode4(371660),
     /* 371157 */ /*GILLT_v4s32*//*Label 7389*/ GIMT_Encode4(371687),
     /* 371161 */ /*GILLT_v8s8*//*Label 7390*/ GIMT_Encode4(371714),
     /* 371165 */ /*GILLT_v8s16*//*Label 7391*/ GIMT_Encode4(371741),
     /* 371169 */ /*GILLT_v16s8*//*Label 7392*/ GIMT_Encode4(371768),
     /* 371173 */ // Label 7385: @371173
     /* 371173 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(371402),
     /* 371178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371185 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(371285), // Rule ID 4007 //
     /* 371190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 371234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 371238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 371246 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371250 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 371259 */     // MIs[3] Rn
     /* 371259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 371264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371268 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371272 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371274 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 371277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 371283 */     GIR_RootConstrainSelectedInstOperands,
     /* 371284 */     // GIR_Coverage, 4007,
     /* 371284 */     GIR_EraseRootFromParent_Done,
     /* 371285 */   // Label 7395: @371285
     /* 371285 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(371385), // Rule ID 13819 //
     /* 371290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 371334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 371338 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371355 */     // MIs[4] Rn
     /* 371355 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 371360 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 371364 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371368 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371372 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371374 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 371377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 371383 */     GIR_RootConstrainSelectedInstOperands,
     /* 371384 */     // GIR_Coverage, 13819,
     /* 371384 */     GIR_EraseRootFromParent_Done,
     /* 371385 */   // Label 7396: @371385
     /* 371385 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(371401), // Rule ID 180 //
     /* 371390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371394 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 371399 */     GIR_RootConstrainSelectedInstOperands,
     /* 371400 */     // GIR_Coverage, 180,
     /* 371400 */     GIR_Done,
     /* 371401 */   // Label 7397: @371401
     /* 371401 */   GIM_Reject,
     /* 371402 */ // Label 7394: @371402
     /* 371402 */ GIM_Reject,
     /* 371403 */ // Label 7386: @371403
     /* 371403 */ GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(371632),
     /* 371408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371415 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(371515), // Rule ID 4008 //
     /* 371420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 371464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 371468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 371476 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371480 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371485 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 371489 */     // MIs[3] Rn
     /* 371489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 371494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371498 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371502 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371504 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 371507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 371513 */     GIR_RootConstrainSelectedInstOperands,
     /* 371514 */     // GIR_Coverage, 4008,
     /* 371514 */     GIR_EraseRootFromParent_Done,
     /* 371515 */   // Label 7399: @371515
     /* 371515 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(371615), // Rule ID 13820 //
     /* 371520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 371564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371568 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371581 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371585 */     // MIs[4] Rn
     /* 371585 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 371590 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 371594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371598 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371602 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371604 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 371607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 371613 */     GIR_RootConstrainSelectedInstOperands,
     /* 371614 */     // GIR_Coverage, 13820,
     /* 371614 */     GIR_EraseRootFromParent_Done,
     /* 371615 */   // Label 7400: @371615
     /* 371615 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(371631), // Rule ID 181 //
     /* 371620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371624 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 371629 */     GIR_RootConstrainSelectedInstOperands,
     /* 371630 */     // GIR_Coverage, 181,
     /* 371630 */     GIR_Done,
     /* 371631 */   // Label 7401: @371631
     /* 371631 */   GIM_Reject,
     /* 371632 */ // Label 7398: @371632
     /* 371632 */ GIM_Reject,
     /* 371633 */ // Label 7387: @371633
     /* 371633 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(371659), // Rule ID 720 //
     /* 371638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371652 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 371652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 371657 */   GIR_RootConstrainSelectedInstOperands,
     /* 371658 */   // GIR_Coverage, 720,
     /* 371658 */   GIR_Done,
     /* 371659 */ // Label 7402: @371659
     /* 371659 */ GIM_Reject,
     /* 371660 */ // Label 7388: @371660
     /* 371660 */ GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(371686), // Rule ID 718 //
     /* 371665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371679 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 371679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 371684 */   GIR_RootConstrainSelectedInstOperands,
     /* 371685 */   // GIR_Coverage, 718,
     /* 371685 */   GIR_Done,
     /* 371686 */ // Label 7403: @371686
     /* 371686 */ GIM_Reject,
     /* 371687 */ // Label 7389: @371687
     /* 371687 */ GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(371713), // Rule ID 721 //
     /* 371692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371706 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 371706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 371711 */   GIR_RootConstrainSelectedInstOperands,
     /* 371712 */   // GIR_Coverage, 721,
     /* 371712 */   GIR_Done,
     /* 371713 */ // Label 7404: @371713
     /* 371713 */ GIM_Reject,
     /* 371714 */ // Label 7390: @371714
     /* 371714 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(371740), // Rule ID 716 //
     /* 371719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371733 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 371733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 371738 */   GIR_RootConstrainSelectedInstOperands,
     /* 371739 */   // GIR_Coverage, 716,
     /* 371739 */   GIR_Done,
     /* 371740 */ // Label 7405: @371740
     /* 371740 */ GIM_Reject,
     /* 371741 */ // Label 7391: @371741
     /* 371741 */ GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(371767), // Rule ID 719 //
     /* 371746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371760 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 371760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 371765 */   GIR_RootConstrainSelectedInstOperands,
     /* 371766 */   // GIR_Coverage, 719,
     /* 371766 */   GIR_Done,
     /* 371767 */ // Label 7406: @371767
     /* 371767 */ GIM_Reject,
     /* 371768 */ // Label 7392: @371768
     /* 371768 */ GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(371794), // Rule ID 717 //
     /* 371773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371787 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 371787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 371792 */   GIR_RootConstrainSelectedInstOperands,
     /* 371793 */   // GIR_Coverage, 717,
     /* 371793 */   GIR_Done,
     /* 371794 */ // Label 7407: @371794
     /* 371794 */ GIM_Reject,
     /* 371795 */ // Label 7393: @371795
     /* 371795 */ GIM_Reject,
     /* 371796 */ // Label 95: @371796
     /* 371796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7412*/ GIMT_Encode4(371955),
     /* 371807 */ /*GILLT_s32*//*Label 7408*/ GIMT_Encode4(371847),
     /* 371811 */ /*GILLT_s64*//*Label 7409*/ GIMT_Encode4(371874), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 371835 */ /*GILLT_v8s8*//*Label 7410*/ GIMT_Encode4(371901), GIMT_Encode4(0),
     /* 371843 */ /*GILLT_v16s8*//*Label 7411*/ GIMT_Encode4(371928),
     /* 371847 */ // Label 7408: @371847
     /* 371847 */ GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(371873), // Rule ID 2319 //
     /* 371852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371866 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 371871 */   GIR_RootConstrainSelectedInstOperands,
     /* 371872 */   // GIR_Coverage, 2319,
     /* 371872 */   GIR_Done,
     /* 371873 */ // Label 7413: @371873
     /* 371873 */ GIM_Reject,
     /* 371874 */ // Label 7409: @371874
     /* 371874 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(371900), // Rule ID 2320 //
     /* 371879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371893 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 371898 */   GIR_RootConstrainSelectedInstOperands,
     /* 371899 */   // GIR_Coverage, 2320,
     /* 371899 */   GIR_Done,
     /* 371900 */ // Label 7414: @371900
     /* 371900 */ GIM_Reject,
     /* 371901 */ // Label 7410: @371901
     /* 371901 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(371927), // Rule ID 764 //
     /* 371906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371920 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 371920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 371925 */   GIR_RootConstrainSelectedInstOperands,
     /* 371926 */   // GIR_Coverage, 764,
     /* 371926 */   GIR_Done,
     /* 371927 */ // Label 7415: @371927
     /* 371927 */ GIM_Reject,
     /* 371928 */ // Label 7411: @371928
     /* 371928 */ GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(371954), // Rule ID 765 //
     /* 371933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371947 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 371947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 371952 */   GIR_RootConstrainSelectedInstOperands,
     /* 371953 */   // GIR_Coverage, 765,
     /* 371953 */   GIR_Done,
     /* 371954 */ // Label 7416: @371954
     /* 371954 */ GIM_Reject,
     /* 371955 */ // Label 7412: @371955
     /* 371955 */ GIM_Reject,
     /* 371956 */ // Label 96: @371956
     /* 371956 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7424*/ GIMT_Encode4(372269),
     /* 371967 */ /*GILLT_s32*//*Label 7417*/ GIMT_Encode4(372003),
     /* 371971 */ /*GILLT_s64*//*Label 7418*/ GIMT_Encode4(372076), GIMT_Encode4(0),
     /* 371979 */ /*GILLT_v2s32*//*Label 7419*/ GIMT_Encode4(372149),
     /* 371983 */ /*GILLT_v2s64*//*Label 7420*/ GIMT_Encode4(372173),
     /* 371987 */ /*GILLT_v4s16*//*Label 7421*/ GIMT_Encode4(372197),
     /* 371991 */ /*GILLT_v4s32*//*Label 7422*/ GIMT_Encode4(372221), GIMT_Encode4(0),
     /* 371999 */ /*GILLT_v8s16*//*Label 7423*/ GIMT_Encode4(372245),
     /* 372003 */ // Label 7417: @372003
     /* 372003 */ GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(372075),
     /* 372008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372015 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(372058), // Rule ID 4011 //
     /* 372020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 372028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 372045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372047 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 372050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372056 */     GIR_RootConstrainSelectedInstOperands,
     /* 372057 */     // GIR_Coverage, 4011,
     /* 372057 */     GIR_EraseRootFromParent_Done,
     /* 372058 */   // Label 7426: @372058
     /* 372058 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(372074), // Rule ID 185 //
     /* 372063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372067 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 372072 */     GIR_RootConstrainSelectedInstOperands,
     /* 372073 */     // GIR_Coverage, 185,
     /* 372073 */     GIR_Done,
     /* 372074 */   // Label 7427: @372074
     /* 372074 */   GIM_Reject,
     /* 372075 */ // Label 7425: @372075
     /* 372075 */ GIM_Reject,
     /* 372076 */ // Label 7418: @372076
     /* 372076 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(372148),
     /* 372081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372088 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(372131), // Rule ID 4012 //
     /* 372093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 372101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 372118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372120 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 372123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372129 */     GIR_RootConstrainSelectedInstOperands,
     /* 372130 */     // GIR_Coverage, 4012,
     /* 372130 */     GIR_EraseRootFromParent_Done,
     /* 372131 */   // Label 7429: @372131
     /* 372131 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(372147), // Rule ID 186 //
     /* 372136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372140 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 372145 */     GIR_RootConstrainSelectedInstOperands,
     /* 372146 */     // GIR_Coverage, 186,
     /* 372146 */     GIR_Done,
     /* 372147 */   // Label 7430: @372147
     /* 372147 */   GIM_Reject,
     /* 372148 */ // Label 7428: @372148
     /* 372148 */ GIM_Reject,
     /* 372149 */ // Label 7419: @372149
     /* 372149 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(372172), // Rule ID 4988 //
     /* 372154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372165 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 372165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 372170 */   GIR_RootConstrainSelectedInstOperands,
     /* 372171 */   // GIR_Coverage, 4988,
     /* 372171 */   GIR_Done,
     /* 372172 */ // Label 7431: @372172
     /* 372172 */ GIM_Reject,
     /* 372173 */ // Label 7420: @372173
     /* 372173 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(372196), // Rule ID 4990 //
     /* 372178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372189 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 372189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 372194 */   GIR_RootConstrainSelectedInstOperands,
     /* 372195 */   // GIR_Coverage, 4990,
     /* 372195 */   GIR_Done,
     /* 372196 */ // Label 7432: @372196
     /* 372196 */ GIM_Reject,
     /* 372197 */ // Label 7421: @372197
     /* 372197 */ GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(372220), // Rule ID 4986 //
     /* 372202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372213 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 372213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 372218 */   GIR_RootConstrainSelectedInstOperands,
     /* 372219 */   // GIR_Coverage, 4986,
     /* 372219 */   GIR_Done,
     /* 372220 */ // Label 7433: @372220
     /* 372220 */ GIM_Reject,
     /* 372221 */ // Label 7422: @372221
     /* 372221 */ GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(372244), // Rule ID 4989 //
     /* 372226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372237 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 372237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 372242 */   GIR_RootConstrainSelectedInstOperands,
     /* 372243 */   // GIR_Coverage, 4989,
     /* 372243 */   GIR_Done,
     /* 372244 */ // Label 7434: @372244
     /* 372244 */ GIM_Reject,
     /* 372245 */ // Label 7423: @372245
     /* 372245 */ GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(372268), // Rule ID 4987 //
     /* 372250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372261 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 372261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 372266 */   GIR_RootConstrainSelectedInstOperands,
     /* 372267 */   // GIR_Coverage, 4987,
     /* 372267 */   GIR_Done,
     /* 372268 */ // Label 7435: @372268
     /* 372268 */ GIM_Reject,
     /* 372269 */ // Label 7424: @372269
     /* 372269 */ GIM_Reject,
     /* 372270 */ // Label 97: @372270
     /* 372270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7440*/ GIMT_Encode4(372423),
     /* 372281 */ /*GILLT_s32*//*Label 7436*/ GIMT_Encode4(372321),
     /* 372285 */ /*GILLT_s64*//*Label 7437*/ GIMT_Encode4(372345), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 372309 */ /*GILLT_v8s8*//*Label 7438*/ GIMT_Encode4(372369), GIMT_Encode4(0),
     /* 372317 */ /*GILLT_v16s8*//*Label 7439*/ GIMT_Encode4(372396),
     /* 372321 */ // Label 7436: @372321
     /* 372321 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(372344), // Rule ID 182 //
     /* 372326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372337 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 372342 */   GIR_RootConstrainSelectedInstOperands,
     /* 372343 */   // GIR_Coverage, 182,
     /* 372343 */   GIR_Done,
     /* 372344 */ // Label 7441: @372344
     /* 372344 */ GIM_Reject,
     /* 372345 */ // Label 7437: @372345
     /* 372345 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(372368), // Rule ID 183 //
     /* 372350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372361 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 372366 */   GIR_RootConstrainSelectedInstOperands,
     /* 372367 */   // GIR_Coverage, 183,
     /* 372367 */   GIR_Done,
     /* 372368 */ // Label 7442: @372368
     /* 372368 */ GIM_Reject,
     /* 372369 */ // Label 7438: @372369
     /* 372369 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(372395), // Rule ID 974 //
     /* 372374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 372380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372388 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 372388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 372393 */   GIR_RootConstrainSelectedInstOperands,
     /* 372394 */   // GIR_Coverage, 974,
     /* 372394 */   GIR_Done,
     /* 372395 */ // Label 7443: @372395
     /* 372395 */ GIM_Reject,
     /* 372396 */ // Label 7439: @372396
     /* 372396 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(372422), // Rule ID 975 //
     /* 372401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 372407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372415 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 372415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 372420 */   GIR_RootConstrainSelectedInstOperands,
     /* 372421 */   // GIR_Coverage, 975,
     /* 372421 */   GIR_Done,
     /* 372422 */ // Label 7444: @372422
     /* 372422 */ GIM_Reject,
     /* 372423 */ // Label 7440: @372423
     /* 372423 */ GIM_Reject,
     /* 372424 */ // Label 98: @372424
     /* 372424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7453*/ GIMT_Encode4(372914),
     /* 372435 */ /*GILLT_s16*//*Label 7445*/ GIMT_Encode4(372475),
     /* 372439 */ /*GILLT_s32*//*Label 7446*/ GIMT_Encode4(372506),
     /* 372443 */ /*GILLT_s64*//*Label 7447*/ GIMT_Encode4(372537), GIMT_Encode4(0),
     /* 372451 */ /*GILLT_v2s32*//*Label 7448*/ GIMT_Encode4(372568),
     /* 372455 */ /*GILLT_v2s64*//*Label 7449*/ GIMT_Encode4(372599),
     /* 372459 */ /*GILLT_v4s16*//*Label 7450*/ GIMT_Encode4(372630),
     /* 372463 */ /*GILLT_v4s32*//*Label 7451*/ GIMT_Encode4(372661), GIMT_Encode4(0),
     /* 372471 */ /*GILLT_v8s16*//*Label 7452*/ GIMT_Encode4(372692),
     /* 372475 */ // Label 7445: @372475
     /* 372475 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(372505), // Rule ID 552 //
     /* 372480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372494 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 372499 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372503 */   GIR_RootConstrainSelectedInstOperands,
     /* 372504 */   // GIR_Coverage, 552,
     /* 372504 */   GIR_Done,
     /* 372505 */ // Label 7454: @372505
     /* 372505 */ GIM_Reject,
     /* 372506 */ // Label 7446: @372506
     /* 372506 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(372536), // Rule ID 554 //
     /* 372511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372525 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 372525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 372530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372534 */   GIR_RootConstrainSelectedInstOperands,
     /* 372535 */   // GIR_Coverage, 554,
     /* 372535 */   GIR_Done,
     /* 372536 */ // Label 7455: @372536
     /* 372536 */ GIM_Reject,
     /* 372537 */ // Label 7447: @372537
     /* 372537 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(372567), // Rule ID 556 //
     /* 372542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372556 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 372556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 372561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372565 */   GIR_RootConstrainSelectedInstOperands,
     /* 372566 */   // GIR_Coverage, 556,
     /* 372566 */   GIR_Done,
     /* 372567 */ // Label 7456: @372567
     /* 372567 */ GIM_Reject,
     /* 372568 */ // Label 7448: @372568
     /* 372568 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(372598), // Rule ID 913 //
     /* 372573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372587 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 372587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 372592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372596 */   GIR_RootConstrainSelectedInstOperands,
     /* 372597 */   // GIR_Coverage, 913,
     /* 372597 */   GIR_Done,
     /* 372598 */ // Label 7457: @372598
     /* 372598 */ GIM_Reject,
     /* 372599 */ // Label 7449: @372599
     /* 372599 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(372629), // Rule ID 917 //
     /* 372604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372618 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 372618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 372623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372627 */   GIR_RootConstrainSelectedInstOperands,
     /* 372628 */   // GIR_Coverage, 917,
     /* 372628 */   GIR_Done,
     /* 372629 */ // Label 7458: @372629
     /* 372629 */ GIM_Reject,
     /* 372630 */ // Label 7450: @372630
     /* 372630 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(372660), // Rule ID 909 //
     /* 372635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372649 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 372649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 372654 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372658 */   GIR_RootConstrainSelectedInstOperands,
     /* 372659 */   // GIR_Coverage, 909,
     /* 372659 */   GIR_Done,
     /* 372660 */ // Label 7459: @372660
     /* 372660 */ GIM_Reject,
     /* 372661 */ // Label 7451: @372661
     /* 372661 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(372691), // Rule ID 915 //
     /* 372666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372680 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 372680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372689 */   GIR_RootConstrainSelectedInstOperands,
     /* 372690 */   // GIR_Coverage, 915,
     /* 372690 */   GIR_Done,
     /* 372691 */ // Label 7460: @372691
     /* 372691 */ GIM_Reject,
     /* 372692 */ // Label 7452: @372692
     /* 372692 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(372913),
     /* 372697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372708 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(372727), // Rule ID 911 //
     /* 372713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372716 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 372716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 372721 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372725 */     GIR_RootConstrainSelectedInstOperands,
     /* 372726 */     // GIR_Coverage, 911,
     /* 372726 */     GIR_Done,
     /* 372727 */   // Label 7462: @372727
     /* 372727 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(372912), // Rule ID 6998 //
     /* 372732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 372735 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 372735 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 372738 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372742 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372747 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 372753 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372756 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372760 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372765 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 372768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 372770 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 372773 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372777 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372782 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372788 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372793 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372798 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372801 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372805 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372810 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372815 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372818 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372822 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372827 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372832 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372835 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372839 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372844 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 372910 */     GIR_RootConstrainSelectedInstOperands,
     /* 372911 */     // GIR_Coverage, 6998,
     /* 372911 */     GIR_EraseRootFromParent_Done,
     /* 372912 */   // Label 7463: @372912
     /* 372912 */   GIM_Reject,
     /* 372913 */ // Label 7461: @372913
     /* 372913 */ GIM_Reject,
     /* 372914 */ // Label 7453: @372914
     /* 372914 */ GIM_Reject,
     /* 372915 */ // Label 99: @372915
     /* 372915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7472*/ GIMT_Encode4(373214),
     /* 372926 */ /*GILLT_s16*//*Label 7464*/ GIMT_Encode4(372966),
     /* 372930 */ /*GILLT_s32*//*Label 7465*/ GIMT_Encode4(372997),
     /* 372934 */ /*GILLT_s64*//*Label 7466*/ GIMT_Encode4(373028), GIMT_Encode4(0),
     /* 372942 */ /*GILLT_v2s32*//*Label 7467*/ GIMT_Encode4(373059),
     /* 372946 */ /*GILLT_v2s64*//*Label 7468*/ GIMT_Encode4(373090),
     /* 372950 */ /*GILLT_v4s16*//*Label 7469*/ GIMT_Encode4(373121),
     /* 372954 */ /*GILLT_v4s32*//*Label 7470*/ GIMT_Encode4(373152), GIMT_Encode4(0),
     /* 372962 */ /*GILLT_v8s16*//*Label 7471*/ GIMT_Encode4(373183),
     /* 372966 */ // Label 7464: @372966
     /* 372966 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(372996), // Rule ID 570 //
     /* 372971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372985 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 372990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372994 */   GIR_RootConstrainSelectedInstOperands,
     /* 372995 */   // GIR_Coverage, 570,
     /* 372995 */   GIR_Done,
     /* 372996 */ // Label 7473: @372996
     /* 372996 */ GIM_Reject,
     /* 372997 */ // Label 7465: @372997
     /* 372997 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(373027), // Rule ID 572 //
     /* 373002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373016 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 373021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373025 */   GIR_RootConstrainSelectedInstOperands,
     /* 373026 */   // GIR_Coverage, 572,
     /* 373026 */   GIR_Done,
     /* 373027 */ // Label 7474: @373027
     /* 373027 */ GIM_Reject,
     /* 373028 */ // Label 7466: @373028
     /* 373028 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(373058), // Rule ID 574 //
     /* 373033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373047 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 373052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373056 */   GIR_RootConstrainSelectedInstOperands,
     /* 373057 */   // GIR_Coverage, 574,
     /* 373057 */   GIR_Done,
     /* 373058 */ // Label 7475: @373058
     /* 373058 */ GIM_Reject,
     /* 373059 */ // Label 7467: @373059
     /* 373059 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(373089), // Rule ID 960 //
     /* 373064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373078 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 373083 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373087 */   GIR_RootConstrainSelectedInstOperands,
     /* 373088 */   // GIR_Coverage, 960,
     /* 373088 */   GIR_Done,
     /* 373089 */ // Label 7476: @373089
     /* 373089 */ GIM_Reject,
     /* 373090 */ // Label 7468: @373090
     /* 373090 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(373120), // Rule ID 964 //
     /* 373095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373109 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 373114 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373118 */   GIR_RootConstrainSelectedInstOperands,
     /* 373119 */   // GIR_Coverage, 964,
     /* 373119 */   GIR_Done,
     /* 373120 */ // Label 7477: @373120
     /* 373120 */ GIM_Reject,
     /* 373121 */ // Label 7469: @373121
     /* 373121 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(373151), // Rule ID 956 //
     /* 373126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373140 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 373145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373149 */   GIR_RootConstrainSelectedInstOperands,
     /* 373150 */   // GIR_Coverage, 956,
     /* 373150 */   GIR_Done,
     /* 373151 */ // Label 7478: @373151
     /* 373151 */ GIM_Reject,
     /* 373152 */ // Label 7470: @373152
     /* 373152 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(373182), // Rule ID 962 //
     /* 373157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373171 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 373176 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373180 */   GIR_RootConstrainSelectedInstOperands,
     /* 373181 */   // GIR_Coverage, 962,
     /* 373181 */   GIR_Done,
     /* 373182 */ // Label 7479: @373182
     /* 373182 */ GIM_Reject,
     /* 373183 */ // Label 7471: @373183
     /* 373183 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(373213), // Rule ID 958 //
     /* 373188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373202 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 373207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373211 */   GIR_RootConstrainSelectedInstOperands,
     /* 373212 */   // GIR_Coverage, 958,
     /* 373212 */   GIR_Done,
     /* 373213 */ // Label 7480: @373213
     /* 373213 */ GIM_Reject,
     /* 373214 */ // Label 7472: @373214
     /* 373214 */ GIM_Reject,
     /* 373215 */ // Label 100: @373215
     /* 373215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7489*/ GIMT_Encode4(373705),
     /* 373226 */ /*GILLT_s16*//*Label 7481*/ GIMT_Encode4(373266),
     /* 373230 */ /*GILLT_s32*//*Label 7482*/ GIMT_Encode4(373297),
     /* 373234 */ /*GILLT_s64*//*Label 7483*/ GIMT_Encode4(373328), GIMT_Encode4(0),
     /* 373242 */ /*GILLT_v2s32*//*Label 7484*/ GIMT_Encode4(373359),
     /* 373246 */ /*GILLT_v2s64*//*Label 7485*/ GIMT_Encode4(373390),
     /* 373250 */ /*GILLT_v4s16*//*Label 7486*/ GIMT_Encode4(373421),
     /* 373254 */ /*GILLT_v4s32*//*Label 7487*/ GIMT_Encode4(373452), GIMT_Encode4(0),
     /* 373262 */ /*GILLT_v8s16*//*Label 7488*/ GIMT_Encode4(373483),
     /* 373266 */ // Label 7481: @373266
     /* 373266 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(373296), // Rule ID 540 //
     /* 373271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 373277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373285 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 373285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 373290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373294 */   GIR_RootConstrainSelectedInstOperands,
     /* 373295 */   // GIR_Coverage, 540,
     /* 373295 */   GIR_Done,
     /* 373296 */ // Label 7490: @373296
     /* 373296 */ GIM_Reject,
     /* 373297 */ // Label 7482: @373297
     /* 373297 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(373327), // Rule ID 542 //
     /* 373302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373316 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 373321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373325 */   GIR_RootConstrainSelectedInstOperands,
     /* 373326 */   // GIR_Coverage, 542,
     /* 373326 */   GIR_Done,
     /* 373327 */ // Label 7491: @373327
     /* 373327 */ GIM_Reject,
     /* 373328 */ // Label 7483: @373328
     /* 373328 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(373358), // Rule ID 544 //
     /* 373333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373347 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 373352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373356 */   GIR_RootConstrainSelectedInstOperands,
     /* 373357 */   // GIR_Coverage, 544,
     /* 373357 */   GIR_Done,
     /* 373358 */ // Label 7492: @373358
     /* 373358 */ GIM_Reject,
     /* 373359 */ // Label 7484: @373359
     /* 373359 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(373389), // Rule ID 893 //
     /* 373364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373378 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 373383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373387 */   GIR_RootConstrainSelectedInstOperands,
     /* 373388 */   // GIR_Coverage, 893,
     /* 373388 */   GIR_Done,
     /* 373389 */ // Label 7493: @373389
     /* 373389 */ GIM_Reject,
     /* 373390 */ // Label 7485: @373390
     /* 373390 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(373420), // Rule ID 897 //
     /* 373395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373409 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 373414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373418 */   GIR_RootConstrainSelectedInstOperands,
     /* 373419 */   // GIR_Coverage, 897,
     /* 373419 */   GIR_Done,
     /* 373420 */ // Label 7494: @373420
     /* 373420 */ GIM_Reject,
     /* 373421 */ // Label 7486: @373421
     /* 373421 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(373451), // Rule ID 889 //
     /* 373426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373440 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 373445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373449 */   GIR_RootConstrainSelectedInstOperands,
     /* 373450 */   // GIR_Coverage, 889,
     /* 373450 */   GIR_Done,
     /* 373451 */ // Label 7495: @373451
     /* 373451 */ GIM_Reject,
     /* 373452 */ // Label 7487: @373452
     /* 373452 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(373482), // Rule ID 895 //
     /* 373457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373471 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373480 */   GIR_RootConstrainSelectedInstOperands,
     /* 373481 */   // GIR_Coverage, 895,
     /* 373481 */   GIR_Done,
     /* 373482 */ // Label 7496: @373482
     /* 373482 */ GIM_Reject,
     /* 373483 */ // Label 7488: @373483
     /* 373483 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(373704),
     /* 373488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373499 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(373518), // Rule ID 891 //
     /* 373504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373507 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 373512 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373516 */     GIR_RootConstrainSelectedInstOperands,
     /* 373517 */     // GIR_Coverage, 891,
     /* 373517 */     GIR_Done,
     /* 373518 */   // Label 7498: @373518
     /* 373518 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(373703), // Rule ID 7000 //
     /* 373523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 373526 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 373526 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 373529 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 373533 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373538 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 373542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 373544 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 373547 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373551 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373556 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 373559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 373561 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 373564 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373568 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373573 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373579 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373584 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373589 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 373592 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 373596 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373601 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 373604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 373606 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 373609 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373613 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373618 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 373621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 373623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 373626 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 373630 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373635 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 373638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 373640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 373643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 373672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 373693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 373701 */     GIR_RootConstrainSelectedInstOperands,
     /* 373702 */     // GIR_Coverage, 7000,
     /* 373702 */     GIR_EraseRootFromParent_Done,
     /* 373703 */   // Label 7499: @373703
     /* 373703 */   GIM_Reject,
     /* 373704 */ // Label 7497: @373704
     /* 373704 */ GIM_Reject,
     /* 373705 */ // Label 7489: @373705
     /* 373705 */ GIM_Reject,
     /* 373706 */ // Label 101: @373706
     /* 373706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7508*/ GIMT_Encode4(374196),
     /* 373717 */ /*GILLT_s16*//*Label 7500*/ GIMT_Encode4(373757),
     /* 373721 */ /*GILLT_s32*//*Label 7501*/ GIMT_Encode4(373788),
     /* 373725 */ /*GILLT_s64*//*Label 7502*/ GIMT_Encode4(373819), GIMT_Encode4(0),
     /* 373733 */ /*GILLT_v2s32*//*Label 7503*/ GIMT_Encode4(373850),
     /* 373737 */ /*GILLT_v2s64*//*Label 7504*/ GIMT_Encode4(373881),
     /* 373741 */ /*GILLT_v4s16*//*Label 7505*/ GIMT_Encode4(373912),
     /* 373745 */ /*GILLT_v4s32*//*Label 7506*/ GIMT_Encode4(373943), GIMT_Encode4(0),
     /* 373753 */ /*GILLT_v8s16*//*Label 7507*/ GIMT_Encode4(373974),
     /* 373757 */ // Label 7500: @373757
     /* 373757 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(373787), // Rule ID 558 //
     /* 373762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 373768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373776 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 373776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 373781 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373785 */   GIR_RootConstrainSelectedInstOperands,
     /* 373786 */   // GIR_Coverage, 558,
     /* 373786 */   GIR_Done,
     /* 373787 */ // Label 7509: @373787
     /* 373787 */ GIM_Reject,
     /* 373788 */ // Label 7501: @373788
     /* 373788 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(373818), // Rule ID 560 //
     /* 373793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373807 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 373812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373816 */   GIR_RootConstrainSelectedInstOperands,
     /* 373817 */   // GIR_Coverage, 560,
     /* 373817 */   GIR_Done,
     /* 373818 */ // Label 7510: @373818
     /* 373818 */ GIM_Reject,
     /* 373819 */ // Label 7502: @373819
     /* 373819 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(373849), // Rule ID 562 //
     /* 373824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373838 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 373843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373847 */   GIR_RootConstrainSelectedInstOperands,
     /* 373848 */   // GIR_Coverage, 562,
     /* 373848 */   GIR_Done,
     /* 373849 */ // Label 7511: @373849
     /* 373849 */ GIM_Reject,
     /* 373850 */ // Label 7503: @373850
     /* 373850 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(373880), // Rule ID 923 //
     /* 373855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373869 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 373874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373878 */   GIR_RootConstrainSelectedInstOperands,
     /* 373879 */   // GIR_Coverage, 923,
     /* 373879 */   GIR_Done,
     /* 373880 */ // Label 7512: @373880
     /* 373880 */ GIM_Reject,
     /* 373881 */ // Label 7504: @373881
     /* 373881 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(373911), // Rule ID 927 //
     /* 373886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373900 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 373905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373909 */   GIR_RootConstrainSelectedInstOperands,
     /* 373910 */   // GIR_Coverage, 927,
     /* 373910 */   GIR_Done,
     /* 373911 */ // Label 7513: @373911
     /* 373911 */ GIM_Reject,
     /* 373912 */ // Label 7505: @373912
     /* 373912 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(373942), // Rule ID 919 //
     /* 373917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373931 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 373936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373940 */   GIR_RootConstrainSelectedInstOperands,
     /* 373941 */   // GIR_Coverage, 919,
     /* 373941 */   GIR_Done,
     /* 373942 */ // Label 7514: @373942
     /* 373942 */ GIM_Reject,
     /* 373943 */ // Label 7506: @373943
     /* 373943 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(373973), // Rule ID 925 //
     /* 373948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373962 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 373967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373971 */   GIR_RootConstrainSelectedInstOperands,
     /* 373972 */   // GIR_Coverage, 925,
     /* 373972 */   GIR_Done,
     /* 373973 */ // Label 7515: @373973
     /* 373973 */ GIM_Reject,
     /* 373974 */ // Label 7507: @373974
     /* 373974 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(374195),
     /* 373979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373990 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(374009), // Rule ID 921 //
     /* 373995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373998 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 374003 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374007 */     GIR_RootConstrainSelectedInstOperands,
     /* 374008 */     // GIR_Coverage, 921,
     /* 374008 */     GIR_Done,
     /* 374009 */   // Label 7517: @374009
     /* 374009 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(374194), // Rule ID 7008 //
     /* 374014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374017 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 374017 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 374020 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374024 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374029 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 374035 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374038 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 374042 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374047 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374052 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374055 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374059 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374064 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374070 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374075 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374080 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374083 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374087 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374092 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374097 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374100 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 374104 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374109 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374114 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374117 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374121 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374126 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 374192 */     GIR_RootConstrainSelectedInstOperands,
     /* 374193 */     // GIR_Coverage, 7008,
     /* 374193 */     GIR_EraseRootFromParent_Done,
     /* 374194 */   // Label 7518: @374194
     /* 374194 */   GIM_Reject,
     /* 374195 */ // Label 7516: @374195
     /* 374195 */ GIM_Reject,
     /* 374196 */ // Label 7508: @374196
     /* 374196 */ GIM_Reject,
     /* 374197 */ // Label 102: @374197
     /* 374197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7527*/ GIMT_Encode4(374687),
     /* 374208 */ /*GILLT_s16*//*Label 7519*/ GIMT_Encode4(374248),
     /* 374212 */ /*GILLT_s32*//*Label 7520*/ GIMT_Encode4(374279),
     /* 374216 */ /*GILLT_s64*//*Label 7521*/ GIMT_Encode4(374310), GIMT_Encode4(0),
     /* 374224 */ /*GILLT_v2s32*//*Label 7522*/ GIMT_Encode4(374341),
     /* 374228 */ /*GILLT_v2s64*//*Label 7523*/ GIMT_Encode4(374372),
     /* 374232 */ /*GILLT_v4s16*//*Label 7524*/ GIMT_Encode4(374403),
     /* 374236 */ /*GILLT_v4s32*//*Label 7525*/ GIMT_Encode4(374434), GIMT_Encode4(0),
     /* 374244 */ /*GILLT_v8s16*//*Label 7526*/ GIMT_Encode4(374465),
     /* 374248 */ // Label 7519: @374248
     /* 374248 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(374278), // Rule ID 534 //
     /* 374253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374267 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 374267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 374272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374276 */   GIR_RootConstrainSelectedInstOperands,
     /* 374277 */   // GIR_Coverage, 534,
     /* 374277 */   GIR_Done,
     /* 374278 */ // Label 7528: @374278
     /* 374278 */ GIM_Reject,
     /* 374279 */ // Label 7520: @374279
     /* 374279 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(374309), // Rule ID 536 //
     /* 374284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374298 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 374298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 374303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374307 */   GIR_RootConstrainSelectedInstOperands,
     /* 374308 */   // GIR_Coverage, 536,
     /* 374308 */   GIR_Done,
     /* 374309 */ // Label 7529: @374309
     /* 374309 */ GIM_Reject,
     /* 374310 */ // Label 7521: @374310
     /* 374310 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(374340), // Rule ID 538 //
     /* 374315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 374321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374329 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 374329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 374334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374338 */   GIR_RootConstrainSelectedInstOperands,
     /* 374339 */   // GIR_Coverage, 538,
     /* 374339 */   GIR_Done,
     /* 374340 */ // Label 7530: @374340
     /* 374340 */ GIM_Reject,
     /* 374341 */ // Label 7522: @374341
     /* 374341 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(374371), // Rule ID 883 //
     /* 374346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374360 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 374360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 374365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374369 */   GIR_RootConstrainSelectedInstOperands,
     /* 374370 */   // GIR_Coverage, 883,
     /* 374370 */   GIR_Done,
     /* 374371 */ // Label 7531: @374371
     /* 374371 */ GIM_Reject,
     /* 374372 */ // Label 7523: @374372
     /* 374372 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(374402), // Rule ID 887 //
     /* 374377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374391 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 374391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 374396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374400 */   GIR_RootConstrainSelectedInstOperands,
     /* 374401 */   // GIR_Coverage, 887,
     /* 374401 */   GIR_Done,
     /* 374402 */ // Label 7532: @374402
     /* 374402 */ GIM_Reject,
     /* 374403 */ // Label 7524: @374403
     /* 374403 */ GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(374433), // Rule ID 879 //
     /* 374408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374422 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 374422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 374427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374431 */   GIR_RootConstrainSelectedInstOperands,
     /* 374432 */   // GIR_Coverage, 879,
     /* 374432 */   GIR_Done,
     /* 374433 */ // Label 7533: @374433
     /* 374433 */ GIM_Reject,
     /* 374434 */ // Label 7525: @374434
     /* 374434 */ GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(374464), // Rule ID 885 //
     /* 374439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374453 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 374453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374462 */   GIR_RootConstrainSelectedInstOperands,
     /* 374463 */   // GIR_Coverage, 885,
     /* 374463 */   GIR_Done,
     /* 374464 */ // Label 7534: @374464
     /* 374464 */ GIM_Reject,
     /* 374465 */ // Label 7526: @374465
     /* 374465 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(374686),
     /* 374470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374481 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(374500), // Rule ID 881 //
     /* 374486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374489 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 374489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 374494 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374498 */     GIR_RootConstrainSelectedInstOperands,
     /* 374499 */     // GIR_Coverage, 881,
     /* 374499 */     GIR_Done,
     /* 374500 */   // Label 7536: @374500
     /* 374500 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(374685), // Rule ID 7002 //
     /* 374505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374508 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 374508 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 374511 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374515 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374520 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 374526 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374529 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374533 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374538 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374543 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374546 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374550 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374555 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374561 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374566 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374571 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374574 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374578 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374583 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374588 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374591 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374595 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374600 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374605 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374608 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374612 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374617 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374648 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 374683 */     GIR_RootConstrainSelectedInstOperands,
     /* 374684 */     // GIR_Coverage, 7002,
     /* 374684 */     GIR_EraseRootFromParent_Done,
     /* 374685 */   // Label 7537: @374685
     /* 374685 */   GIM_Reject,
     /* 374686 */ // Label 7535: @374686
     /* 374686 */ GIM_Reject,
     /* 374687 */ // Label 7527: @374687
     /* 374687 */ GIM_Reject,
     /* 374688 */ // Label 103: @374688
     /* 374688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7546*/ GIMT_Encode4(375813),
     /* 374699 */ /*GILLT_s16*//*Label 7538*/ GIMT_Encode4(374739),
     /* 374703 */ /*GILLT_s32*//*Label 7539*/ GIMT_Encode4(374965),
     /* 374707 */ /*GILLT_s64*//*Label 7540*/ GIMT_Encode4(375191), GIMT_Encode4(0),
     /* 374715 */ /*GILLT_v2s32*//*Label 7541*/ GIMT_Encode4(375363),
     /* 374719 */ /*GILLT_v2s64*//*Label 7542*/ GIMT_Encode4(375401),
     /* 374723 */ /*GILLT_v4s16*//*Label 7543*/ GIMT_Encode4(375439),
     /* 374727 */ /*GILLT_v4s32*//*Label 7544*/ GIMT_Encode4(375477), GIMT_Encode4(0),
     /* 374735 */ /*GILLT_v8s16*//*Label 7545*/ GIMT_Encode4(375515),
     /* 374739 */ // Label 7538: @374739
     /* 374739 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(374964),
     /* 374744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374754 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(374845), // Rule ID 6922 //
     /* 374759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374796 */     // MIs[2] Rn
     /* 374796 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 374805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374807 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 374807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374819 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 374838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374843 */     GIR_RootConstrainSelectedInstOperands,
     /* 374844 */     // GIR_Coverage, 6922,
     /* 374844 */     GIR_EraseRootFromParent_Done,
     /* 374845 */   // Label 7548: @374845
     /* 374845 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(374936), // Rule ID 13957 //
     /* 374850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 374875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374887 */     // MIs[2] Rn
     /* 374887 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374892 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374898 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 374898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374910 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 374929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374934 */     GIR_RootConstrainSelectedInstOperands,
     /* 374935 */     // GIR_Coverage, 13957,
     /* 374935 */     GIR_EraseRootFromParent_Done,
     /* 374936 */   // Label 7549: @374936
     /* 374936 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(374963), // Rule ID 583 //
     /* 374941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374952 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 374952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 374957 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374961 */     GIR_RootConstrainSelectedInstOperands,
     /* 374962 */     // GIR_Coverage, 583,
     /* 374962 */     GIR_Done,
     /* 374963 */   // Label 7550: @374963
     /* 374963 */   GIM_Reject,
     /* 374964 */ // Label 7547: @374964
     /* 374964 */ GIM_Reject,
     /* 374965 */ // Label 7539: @374965
     /* 374965 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(375190),
     /* 374970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374980 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(375071), // Rule ID 6920 //
     /* 374985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375006 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375022 */     // MIs[2] Rn
     /* 375022 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 375031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375033 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 375033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375045 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 375064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375069 */     GIR_RootConstrainSelectedInstOperands,
     /* 375070 */     // GIR_Coverage, 6920,
     /* 375070 */     GIR_EraseRootFromParent_Done,
     /* 375071 */   // Label 7552: @375071
     /* 375071 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(375162), // Rule ID 13955 //
     /* 375076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375097 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 375101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375113 */     // MIs[2] Rn
     /* 375113 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375118 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375124 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 375124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 375155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375160 */     GIR_RootConstrainSelectedInstOperands,
     /* 375161 */     // GIR_Coverage, 13955,
     /* 375161 */     GIR_EraseRootFromParent_Done,
     /* 375162 */   // Label 7553: @375162
     /* 375162 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(375189), // Rule ID 585 //
     /* 375167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375178 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 375183 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375187 */     GIR_RootConstrainSelectedInstOperands,
     /* 375188 */     // GIR_Coverage, 585,
     /* 375188 */     GIR_Done,
     /* 375189 */   // Label 7554: @375189
     /* 375189 */   GIM_Reject,
     /* 375190 */ // Label 7551: @375190
     /* 375190 */ GIM_Reject,
     /* 375191 */ // Label 7540: @375191
     /* 375191 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(375362),
     /* 375196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375206 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(375270), // Rule ID 6918 //
     /* 375211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375232 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375248 */     // MIs[2] Rn
     /* 375248 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375253 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 375257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375259 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 375259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 375262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375268 */     GIR_RootConstrainSelectedInstOperands,
     /* 375269 */     // GIR_Coverage, 6918,
     /* 375269 */     GIR_EraseRootFromParent_Done,
     /* 375270 */   // Label 7556: @375270
     /* 375270 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(375334), // Rule ID 13953 //
     /* 375275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 375300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375312 */     // MIs[2] Rn
     /* 375312 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375323 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 375323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 375326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375332 */     GIR_RootConstrainSelectedInstOperands,
     /* 375333 */     // GIR_Coverage, 13953,
     /* 375333 */     GIR_EraseRootFromParent_Done,
     /* 375334 */   // Label 7557: @375334
     /* 375334 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(375361), // Rule ID 587 //
     /* 375339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375350 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 375355 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375359 */     GIR_RootConstrainSelectedInstOperands,
     /* 375360 */     // GIR_Coverage, 587,
     /* 375360 */     GIR_Done,
     /* 375361 */   // Label 7558: @375361
     /* 375361 */   GIM_Reject,
     /* 375362 */ // Label 7555: @375362
     /* 375362 */ GIM_Reject,
     /* 375363 */ // Label 7541: @375363
     /* 375363 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(375400), // Rule ID 1202 //
     /* 375368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375389 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 375389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 375394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375398 */   GIR_RootConstrainSelectedInstOperands,
     /* 375399 */   // GIR_Coverage, 1202,
     /* 375399 */   GIR_Done,
     /* 375400 */ // Label 7559: @375400
     /* 375400 */ GIM_Reject,
     /* 375401 */ // Label 7542: @375401
     /* 375401 */ GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(375438), // Rule ID 1206 //
     /* 375406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 375415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375427 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 375432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375436 */   GIR_RootConstrainSelectedInstOperands,
     /* 375437 */   // GIR_Coverage, 1206,
     /* 375437 */   GIR_Done,
     /* 375438 */ // Label 7560: @375438
     /* 375438 */ GIM_Reject,
     /* 375439 */ // Label 7543: @375439
     /* 375439 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(375476), // Rule ID 1198 //
     /* 375444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375465 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 375470 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375474 */   GIR_RootConstrainSelectedInstOperands,
     /* 375475 */   // GIR_Coverage, 1198,
     /* 375475 */   GIR_Done,
     /* 375476 */ // Label 7561: @375476
     /* 375476 */ GIM_Reject,
     /* 375477 */ // Label 7544: @375477
     /* 375477 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(375514), // Rule ID 1204 //
     /* 375482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375503 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375508 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375512 */   GIR_RootConstrainSelectedInstOperands,
     /* 375513 */   // GIR_Coverage, 1204,
     /* 375513 */   GIR_Done,
     /* 375514 */ // Label 7562: @375514
     /* 375514 */ GIM_Reject,
     /* 375515 */ // Label 7545: @375515
     /* 375515 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(375812),
     /* 375520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375538 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(375557), // Rule ID 1200 //
     /* 375543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375546 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 375551 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375555 */     GIR_RootConstrainSelectedInstOperands,
     /* 375556 */     // GIR_Coverage, 1200,
     /* 375556 */     GIR_Done,
     /* 375557 */   // Label 7564: @375557
     /* 375557 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(375811), // Rule ID 7011 //
     /* 375562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375565 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375565 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375568 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375572 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375577 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375583 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375586 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375590 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375595 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375601 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375604 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375608 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375613 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375616 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375621 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375624 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375628 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375633 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375639 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375644 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375649 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375652 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375656 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375661 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375666 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375669 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375673 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375678 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375684 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375689 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375694 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375697 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375701 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375706 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375711 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375714 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375718 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375723 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375726 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375743 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375809 */     GIR_RootConstrainSelectedInstOperands,
     /* 375810 */     // GIR_Coverage, 7011,
     /* 375810 */     GIR_EraseRootFromParent_Done,
     /* 375811 */   // Label 7565: @375811
     /* 375811 */   GIM_Reject,
     /* 375812 */ // Label 7563: @375812
     /* 375812 */ GIM_Reject,
     /* 375813 */ // Label 7546: @375813
     /* 375813 */ GIM_Reject,
     /* 375814 */ // Label 104: @375814
     /* 375814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7574*/ GIMT_Encode4(376429),
     /* 375825 */ /*GILLT_s16*//*Label 7566*/ GIMT_Encode4(375865),
     /* 375829 */ /*GILLT_s32*//*Label 7567*/ GIMT_Encode4(375903),
     /* 375833 */ /*GILLT_s64*//*Label 7568*/ GIMT_Encode4(375941), GIMT_Encode4(0),
     /* 375841 */ /*GILLT_v2s32*//*Label 7569*/ GIMT_Encode4(375979),
     /* 375845 */ /*GILLT_v2s64*//*Label 7570*/ GIMT_Encode4(376017),
     /* 375849 */ /*GILLT_v4s16*//*Label 7571*/ GIMT_Encode4(376055),
     /* 375853 */ /*GILLT_v4s32*//*Label 7572*/ GIMT_Encode4(376093), GIMT_Encode4(0),
     /* 375861 */ /*GILLT_v8s16*//*Label 7573*/ GIMT_Encode4(376131),
     /* 375865 */ // Label 7566: @375865
     /* 375865 */ GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(375902), // Rule ID 631 //
     /* 375870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375891 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 375896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375900 */   GIR_RootConstrainSelectedInstOperands,
     /* 375901 */   // GIR_Coverage, 631,
     /* 375901 */   GIR_Done,
     /* 375902 */ // Label 7575: @375902
     /* 375902 */ GIM_Reject,
     /* 375903 */ // Label 7567: @375903
     /* 375903 */ GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(375940), // Rule ID 633 //
     /* 375908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375929 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 375934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375938 */   GIR_RootConstrainSelectedInstOperands,
     /* 375939 */   // GIR_Coverage, 633,
     /* 375939 */   GIR_Done,
     /* 375940 */ // Label 7576: @375940
     /* 375940 */ GIM_Reject,
     /* 375941 */ // Label 7568: @375941
     /* 375941 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(375978), // Rule ID 635 //
     /* 375946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375967 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 375972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375976 */   GIR_RootConstrainSelectedInstOperands,
     /* 375977 */   // GIR_Coverage, 635,
     /* 375977 */   GIR_Done,
     /* 375978 */ // Label 7577: @375978
     /* 375978 */ GIM_Reject,
     /* 375979 */ // Label 7569: @375979
     /* 375979 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(376016), // Rule ID 1342 //
     /* 375984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376005 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 376005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 376010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376014 */   GIR_RootConstrainSelectedInstOperands,
     /* 376015 */   // GIR_Coverage, 1342,
     /* 376015 */   GIR_Done,
     /* 376016 */ // Label 7578: @376016
     /* 376016 */ GIM_Reject,
     /* 376017 */ // Label 7570: @376017
     /* 376017 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(376054), // Rule ID 1346 //
     /* 376022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 376031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376043 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 376048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376052 */   GIR_RootConstrainSelectedInstOperands,
     /* 376053 */   // GIR_Coverage, 1346,
     /* 376053 */   GIR_Done,
     /* 376054 */ // Label 7579: @376054
     /* 376054 */ GIM_Reject,
     /* 376055 */ // Label 7571: @376055
     /* 376055 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(376092), // Rule ID 1338 //
     /* 376060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376081 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 376086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376090 */   GIR_RootConstrainSelectedInstOperands,
     /* 376091 */   // GIR_Coverage, 1338,
     /* 376091 */   GIR_Done,
     /* 376092 */ // Label 7580: @376092
     /* 376092 */ GIM_Reject,
     /* 376093 */ // Label 7572: @376093
     /* 376093 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(376130), // Rule ID 1344 //
     /* 376098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 376107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376119 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 376119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376128 */   GIR_RootConstrainSelectedInstOperands,
     /* 376129 */   // GIR_Coverage, 1344,
     /* 376129 */   GIR_Done,
     /* 376130 */ // Label 7581: @376130
     /* 376130 */ GIM_Reject,
     /* 376131 */ // Label 7573: @376131
     /* 376131 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(376428),
     /* 376136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 376142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376154 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(376173), // Rule ID 1340 //
     /* 376159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376162 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 376162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 376167 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376171 */     GIR_RootConstrainSelectedInstOperands,
     /* 376172 */     // GIR_Coverage, 1340,
     /* 376172 */     GIR_Done,
     /* 376173 */   // Label 7583: @376173
     /* 376173 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(376427), // Rule ID 7017 //
     /* 376178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 376181 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 376181 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 376184 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376188 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376193 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 376199 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 376202 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376206 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376211 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 376215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 376217 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 376220 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376224 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376229 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 376232 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 376235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 376237 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 376240 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376244 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376249 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376255 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376260 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376265 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 376268 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376272 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376277 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 376280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 376282 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 376285 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376289 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376294 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376300 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376305 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376310 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 376313 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376317 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376322 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 376325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 376327 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 376330 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376334 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376339 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 376342 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 376345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376347 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 376350 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 376354 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376359 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 376362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 376367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 376417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 376425 */     GIR_RootConstrainSelectedInstOperands,
     /* 376426 */     // GIR_Coverage, 7017,
     /* 376426 */     GIR_EraseRootFromParent_Done,
     /* 376427 */   // Label 7584: @376427
     /* 376427 */   GIM_Reject,
     /* 376428 */ // Label 7582: @376428
     /* 376428 */ GIM_Reject,
     /* 376429 */ // Label 7574: @376429
     /* 376429 */ GIM_Reject,
     /* 376430 */ // Label 105: @376430
     /* 376430 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7593*/ GIMT_Encode4(380151),
     /* 376441 */ /*GILLT_s16*//*Label 7585*/ GIMT_Encode4(376481),
     /* 376445 */ /*GILLT_s32*//*Label 7586*/ GIMT_Encode4(377035),
     /* 376449 */ /*GILLT_s64*//*Label 7587*/ GIMT_Encode4(377583), GIMT_Encode4(0),
     /* 376457 */ /*GILLT_v2s32*//*Label 7588*/ GIMT_Encode4(378131),
     /* 376461 */ /*GILLT_v2s64*//*Label 7589*/ GIMT_Encode4(378661),
     /* 376465 */ /*GILLT_v4s16*//*Label 7590*/ GIMT_Encode4(379019),
     /* 376469 */ /*GILLT_v4s32*//*Label 7591*/ GIMT_Encode4(379361), GIMT_Encode4(0),
     /* 376477 */ /*GILLT_v8s16*//*Label 7592*/ GIMT_Encode4(379719),
     /* 376481 */ // Label 7585: @376481
     /* 376481 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(377034),
     /* 376486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376496 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(376609), // Rule ID 6252 //
     /* 376501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376525 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376558 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376562 */     // MIs[3] Operand 1
     /* 376562 */     // No operand predicates
     /* 376562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376564 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376576 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376607 */     GIR_RootConstrainSelectedInstOperands,
     /* 376608 */     // GIR_Coverage, 6252,
     /* 376608 */     GIR_EraseRootFromParent_Done,
     /* 376609 */   // Label 7595: @376609
     /* 376609 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(376722), // Rule ID 13934 //
     /* 376614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376650 */     // MIs[2] Operand 1
     /* 376650 */     // No operand predicates
     /* 376650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376662 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376666 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376671 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376677 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376720 */     GIR_RootConstrainSelectedInstOperands,
     /* 376721 */     // GIR_Coverage, 13934,
     /* 376721 */     GIR_EraseRootFromParent_Done,
     /* 376722 */   // Label 7596: @376722
     /* 376722 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(376801), // Rule ID 13868 //
     /* 376727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376751 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376761 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 376761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 376792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376799 */     GIR_RootConstrainSelectedInstOperands,
     /* 376800 */     // GIR_Coverage, 13868,
     /* 376800 */     GIR_EraseRootFromParent_Done,
     /* 376801 */   // Label 7597: @376801
     /* 376801 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(376880), // Rule ID 4802 //
     /* 376806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376834 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376840 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 376840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376852 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 376871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376878 */     GIR_RootConstrainSelectedInstOperands,
     /* 376879 */     // GIR_Coverage, 4802,
     /* 376879 */     GIR_EraseRootFromParent_Done,
     /* 376880 */   // Label 7598: @376880
     /* 376880 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(376943), // Rule ID 13483 //
     /* 376885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376921 */     // MIs[2] Operand 1
     /* 376921 */     // No operand predicates
     /* 376921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376927 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376941 */     GIR_RootConstrainSelectedInstOperands,
     /* 376942 */     // GIR_Coverage, 13483,
     /* 376942 */     GIR_EraseRootFromParent_Done,
     /* 376943 */   // Label 7599: @376943
     /* 376943 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(377006), // Rule ID 2011 //
     /* 376948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376988 */     // MIs[2] Operand 1
     /* 376988 */     // No operand predicates
     /* 376988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376990 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377004 */     GIR_RootConstrainSelectedInstOperands,
     /* 377005 */     // GIR_Coverage, 2011,
     /* 377005 */     GIR_EraseRootFromParent_Done,
     /* 377006 */   // Label 7600: @377006
     /* 377006 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(377033), // Rule ID 619 //
     /* 377011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377022 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 377022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 377027 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377031 */     GIR_RootConstrainSelectedInstOperands,
     /* 377032 */     // GIR_Coverage, 619,
     /* 377032 */     GIR_Done,
     /* 377033 */   // Label 7601: @377033
     /* 377033 */   GIM_Reject,
     /* 377034 */ // Label 7594: @377034
     /* 377034 */ GIM_Reject,
     /* 377035 */ // Label 7586: @377035
     /* 377035 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(377582),
     /* 377040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 377043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377050 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(377163), // Rule ID 6254 //
     /* 377055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377079 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377112 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377116 */     // MIs[3] Operand 1
     /* 377116 */     // No operand predicates
     /* 377116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377118 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 377136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377161 */     GIR_RootConstrainSelectedInstOperands,
     /* 377162 */     // GIR_Coverage, 6254,
     /* 377162 */     GIR_EraseRootFromParent_Done,
     /* 377163 */   // Label 7603: @377163
     /* 377163 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(377276), // Rule ID 13936 //
     /* 377168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377200 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377204 */     // MIs[2] Operand 1
     /* 377204 */     // No operand predicates
     /* 377204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377212 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377216 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377220 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377225 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377231 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377243 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 377249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377274 */     GIR_RootConstrainSelectedInstOperands,
     /* 377275 */     // GIR_Coverage, 13936,
     /* 377275 */     GIR_EraseRootFromParent_Done,
     /* 377276 */   // Label 7604: @377276
     /* 377276 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(377352), // Rule ID 13870 //
     /* 377281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377302 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377312 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 377312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377324 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 377330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377350 */     GIR_RootConstrainSelectedInstOperands,
     /* 377351 */     // GIR_Coverage, 13870,
     /* 377351 */     GIR_EraseRootFromParent_Done,
     /* 377352 */   // Label 7605: @377352
     /* 377352 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(377428), // Rule ID 4804 //
     /* 377357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377388 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 377388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377400 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 377406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377426 */     GIR_RootConstrainSelectedInstOperands,
     /* 377427 */     // GIR_Coverage, 4804,
     /* 377427 */     GIR_EraseRootFromParent_Done,
     /* 377428 */   // Label 7606: @377428
     /* 377428 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(377491), // Rule ID 13485 //
     /* 377433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377469 */     // MIs[2] Operand 1
     /* 377469 */     // No operand predicates
     /* 377469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377475 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377489 */     GIR_RootConstrainSelectedInstOperands,
     /* 377490 */     // GIR_Coverage, 13485,
     /* 377490 */     GIR_EraseRootFromParent_Done,
     /* 377491 */   // Label 7607: @377491
     /* 377491 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(377554), // Rule ID 2013 //
     /* 377496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377536 */     // MIs[2] Operand 1
     /* 377536 */     // No operand predicates
     /* 377536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377538 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377552 */     GIR_RootConstrainSelectedInstOperands,
     /* 377553 */     // GIR_Coverage, 2013,
     /* 377553 */     GIR_EraseRootFromParent_Done,
     /* 377554 */   // Label 7608: @377554
     /* 377554 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(377581), // Rule ID 621 //
     /* 377559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377570 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 377570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377575 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377579 */     GIR_RootConstrainSelectedInstOperands,
     /* 377580 */     // GIR_Coverage, 621,
     /* 377580 */     GIR_Done,
     /* 377581 */   // Label 7609: @377581
     /* 377581 */   GIM_Reject,
     /* 377582 */ // Label 7602: @377582
     /* 377582 */ GIM_Reject,
     /* 377583 */ // Label 7587: @377583
     /* 377583 */ GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(378130),
     /* 377588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 377591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 377594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377598 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(377711), // Rule ID 6256 //
     /* 377603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377627 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377660 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377664 */     // MIs[3] Operand 1
     /* 377664 */     // No operand predicates
     /* 377664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377666 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 377697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377709 */     GIR_RootConstrainSelectedInstOperands,
     /* 377710 */     // GIR_Coverage, 6256,
     /* 377710 */     GIR_EraseRootFromParent_Done,
     /* 377711 */   // Label 7611: @377711
     /* 377711 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(377824), // Rule ID 13938 //
     /* 377716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377748 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377752 */     // MIs[2] Operand 1
     /* 377752 */     // No operand predicates
     /* 377752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377779 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377791 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 377810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377822 */     GIR_RootConstrainSelectedInstOperands,
     /* 377823 */     // GIR_Coverage, 13938,
     /* 377823 */     GIR_EraseRootFromParent_Done,
     /* 377824 */   // Label 7612: @377824
     /* 377824 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(377900), // Rule ID 13872 //
     /* 377829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377850 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377860 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 377860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377872 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 377891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377898 */     GIR_RootConstrainSelectedInstOperands,
     /* 377899 */     // GIR_Coverage, 13872,
     /* 377899 */     GIR_EraseRootFromParent_Done,
     /* 377900 */   // Label 7613: @377900
     /* 377900 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(377976), // Rule ID 4806 //
     /* 377905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377936 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 377936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377948 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 377967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377974 */     GIR_RootConstrainSelectedInstOperands,
     /* 377975 */     // GIR_Coverage, 4806,
     /* 377975 */     GIR_EraseRootFromParent_Done,
     /* 377976 */   // Label 7614: @377976
     /* 377976 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(378039), // Rule ID 13487 //
     /* 377981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378013 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378017 */     // MIs[2] Operand 1
     /* 378017 */     // No operand predicates
     /* 378017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378023 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 378026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378037 */     GIR_RootConstrainSelectedInstOperands,
     /* 378038 */     // GIR_Coverage, 13487,
     /* 378038 */     GIR_EraseRootFromParent_Done,
     /* 378039 */   // Label 7615: @378039
     /* 378039 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(378102), // Rule ID 2015 //
     /* 378044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378084 */     // MIs[2] Operand 1
     /* 378084 */     // No operand predicates
     /* 378084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378086 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 378089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378100 */     GIR_RootConstrainSelectedInstOperands,
     /* 378101 */     // GIR_Coverage, 2015,
     /* 378101 */     GIR_EraseRootFromParent_Done,
     /* 378102 */   // Label 7616: @378102
     /* 378102 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(378129), // Rule ID 623 //
     /* 378107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378118 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 378118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 378123 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378127 */     GIR_RootConstrainSelectedInstOperands,
     /* 378128 */     // GIR_Coverage, 623,
     /* 378128 */     GIR_Done,
     /* 378129 */   // Label 7617: @378129
     /* 378129 */   GIM_Reject,
     /* 378130 */ // Label 7610: @378130
     /* 378130 */ GIM_Reject,
     /* 378131 */ // Label 7588: @378131
     /* 378131 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(378660),
     /* 378136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 378139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 378142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378146 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(378232), // Rule ID 13475 //
     /* 378151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 378162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378199 */     // MIs[3] Operand 1
     /* 378199 */     // No operand predicates
     /* 378199 */     // MIs[1] Operand 2
     /* 378199 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 378210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378216 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378230 */     GIR_RootConstrainSelectedInstOperands,
     /* 378231 */     // GIR_Coverage, 13475,
     /* 378231 */     GIR_EraseRootFromParent_Done,
     /* 378232 */   // Label 7619: @378232
     /* 378232 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(378318), // Rule ID 2003 //
     /* 378237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 378252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378289 */     // MIs[3] Operand 1
     /* 378289 */     // No operand predicates
     /* 378289 */     // MIs[1] Operand 2
     /* 378289 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 378300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378302 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378316 */     GIR_RootConstrainSelectedInstOperands,
     /* 378317 */     // GIR_Coverage, 2003,
     /* 378317 */     GIR_EraseRootFromParent_Done,
     /* 378318 */   // Label 7620: @378318
     /* 378318 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(378381), // Rule ID 13476 //
     /* 378323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378359 */     // MIs[2] Operand 1
     /* 378359 */     // No operand predicates
     /* 378359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378365 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378379 */     GIR_RootConstrainSelectedInstOperands,
     /* 378380 */     // GIR_Coverage, 13476,
     /* 378380 */     GIR_EraseRootFromParent_Done,
     /* 378381 */   // Label 7621: @378381
     /* 378381 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(378444), // Rule ID 2004 //
     /* 378386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378426 */     // MIs[2] Operand 1
     /* 378426 */     // No operand predicates
     /* 378426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378428 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378442 */     GIR_RootConstrainSelectedInstOperands,
     /* 378443 */     // GIR_Coverage, 2004,
     /* 378443 */     GIR_EraseRootFromParent_Done,
     /* 378444 */   // Label 7622: @378444
     /* 378444 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(378538), // Rule ID 13940 //
     /* 378449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378472 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378498 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378505 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378536 */     GIR_RootConstrainSelectedInstOperands,
     /* 378537 */     // GIR_Coverage, 13940,
     /* 378537 */     GIR_EraseRootFromParent_Done,
     /* 378538 */   // Label 7623: @378538
     /* 378538 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(378632), // Rule ID 6258 //
     /* 378543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378566 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378630 */     GIR_RootConstrainSelectedInstOperands,
     /* 378631 */     // GIR_Coverage, 6258,
     /* 378631 */     GIR_EraseRootFromParent_Done,
     /* 378632 */   // Label 7624: @378632
     /* 378632 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(378659), // Rule ID 1322 //
     /* 378637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378648 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 378648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 378653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378657 */     GIR_RootConstrainSelectedInstOperands,
     /* 378658 */     // GIR_Coverage, 1322,
     /* 378658 */     GIR_Done,
     /* 378659 */   // Label 7625: @378659
     /* 378659 */   GIM_Reject,
     /* 378660 */ // Label 7618: @378660
     /* 378660 */ GIM_Reject,
     /* 378661 */ // Label 7589: @378661
     /* 378661 */ GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(379018),
     /* 378666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 378672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378676 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(378739), // Rule ID 13481 //
     /* 378681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 378692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378717 */     // MIs[2] Operand 1
     /* 378717 */     // No operand predicates
     /* 378717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378723 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378737 */     GIR_RootConstrainSelectedInstOperands,
     /* 378738 */     // GIR_Coverage, 13481,
     /* 378738 */     GIR_EraseRootFromParent_Done,
     /* 378739 */   // Label 7627: @378739
     /* 378739 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(378802), // Rule ID 2009 //
     /* 378744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 378759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378784 */     // MIs[2] Operand 1
     /* 378784 */     // No operand predicates
     /* 378784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378786 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378800 */     GIR_RootConstrainSelectedInstOperands,
     /* 378801 */     // GIR_Coverage, 2009,
     /* 378801 */     GIR_EraseRootFromParent_Done,
     /* 378802 */   // Label 7628: @378802
     /* 378802 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(378896), // Rule ID 13944 //
     /* 378807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378830 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378894 */     GIR_RootConstrainSelectedInstOperands,
     /* 378895 */     // GIR_Coverage, 13944,
     /* 378895 */     GIR_EraseRootFromParent_Done,
     /* 378896 */   // Label 7629: @378896
     /* 378896 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(378990), // Rule ID 6262 //
     /* 378901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378924 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378988 */     GIR_RootConstrainSelectedInstOperands,
     /* 378989 */     // GIR_Coverage, 6262,
     /* 378989 */     GIR_EraseRootFromParent_Done,
     /* 378990 */   // Label 7630: @378990
     /* 378990 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(379017), // Rule ID 1326 //
     /* 378995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379006 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 379006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 379011 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379015 */     GIR_RootConstrainSelectedInstOperands,
     /* 379016 */     // GIR_Coverage, 1326,
     /* 379016 */     GIR_Done,
     /* 379017 */   // Label 7631: @379017
     /* 379017 */   GIM_Reject,
     /* 379018 */ // Label 7626: @379018
     /* 379018 */ GIM_Reject,
     /* 379019 */ // Label 7590: @379019
     /* 379019 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(379360),
     /* 379024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 379030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379034 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(379120), // Rule ID 13469 //
     /* 379039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 379050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379087 */     // MIs[3] Operand 1
     /* 379087 */     // No operand predicates
     /* 379087 */     // MIs[1] Operand 2
     /* 379087 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 379098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379104 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379118 */     GIR_RootConstrainSelectedInstOperands,
     /* 379119 */     // GIR_Coverage, 13469,
     /* 379119 */     GIR_EraseRootFromParent_Done,
     /* 379120 */   // Label 7633: @379120
     /* 379120 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(379206), // Rule ID 1997 //
     /* 379125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 379140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379173 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379177 */     // MIs[3] Operand 1
     /* 379177 */     // No operand predicates
     /* 379177 */     // MIs[1] Operand 2
     /* 379177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 379188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379190 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379204 */     GIR_RootConstrainSelectedInstOperands,
     /* 379205 */     // GIR_Coverage, 1997,
     /* 379205 */     GIR_EraseRootFromParent_Done,
     /* 379206 */   // Label 7634: @379206
     /* 379206 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379269), // Rule ID 13470 //
     /* 379211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379243 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379247 */     // MIs[2] Operand 1
     /* 379247 */     // No operand predicates
     /* 379247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379253 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379267 */     GIR_RootConstrainSelectedInstOperands,
     /* 379268 */     // GIR_Coverage, 13470,
     /* 379268 */     GIR_EraseRootFromParent_Done,
     /* 379269 */   // Label 7635: @379269
     /* 379269 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(379332), // Rule ID 1998 //
     /* 379274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379314 */     // MIs[2] Operand 1
     /* 379314 */     // No operand predicates
     /* 379314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379316 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379330 */     GIR_RootConstrainSelectedInstOperands,
     /* 379331 */     // GIR_Coverage, 1998,
     /* 379331 */     GIR_EraseRootFromParent_Done,
     /* 379332 */   // Label 7636: @379332
     /* 379332 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(379359), // Rule ID 1318 //
     /* 379337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379348 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 379348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 379353 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379357 */     GIR_RootConstrainSelectedInstOperands,
     /* 379358 */     // GIR_Coverage, 1318,
     /* 379358 */     GIR_Done,
     /* 379359 */   // Label 7637: @379359
     /* 379359 */   GIM_Reject,
     /* 379360 */ // Label 7632: @379360
     /* 379360 */ GIM_Reject,
     /* 379361 */ // Label 7591: @379361
     /* 379361 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(379718),
     /* 379366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 379372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379376 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(379439), // Rule ID 13479 //
     /* 379381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 379392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379413 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379417 */     // MIs[2] Operand 1
     /* 379417 */     // No operand predicates
     /* 379417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379423 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379437 */     GIR_RootConstrainSelectedInstOperands,
     /* 379438 */     // GIR_Coverage, 13479,
     /* 379438 */     GIR_EraseRootFromParent_Done,
     /* 379439 */   // Label 7639: @379439
     /* 379439 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(379502), // Rule ID 2007 //
     /* 379444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 379459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379484 */     // MIs[2] Operand 1
     /* 379484 */     // No operand predicates
     /* 379484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379486 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379500 */     GIR_RootConstrainSelectedInstOperands,
     /* 379501 */     // GIR_Coverage, 2007,
     /* 379501 */     GIR_EraseRootFromParent_Done,
     /* 379502 */   // Label 7640: @379502
     /* 379502 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(379596), // Rule ID 13942 //
     /* 379507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379530 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 379533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 379547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 379566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379594 */     GIR_RootConstrainSelectedInstOperands,
     /* 379595 */     // GIR_Coverage, 13942,
     /* 379595 */     GIR_EraseRootFromParent_Done,
     /* 379596 */   // Label 7641: @379596
     /* 379596 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(379690), // Rule ID 6260 //
     /* 379601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379624 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379624 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 379627 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379631 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 379641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379650 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379653 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 379660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379688 */     GIR_RootConstrainSelectedInstOperands,
     /* 379689 */     // GIR_Coverage, 6260,
     /* 379689 */     GIR_EraseRootFromParent_Done,
     /* 379690 */   // Label 7642: @379690
     /* 379690 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(379717), // Rule ID 1324 //
     /* 379695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379706 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 379706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 379711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379715 */     GIR_RootConstrainSelectedInstOperands,
     /* 379716 */     // GIR_Coverage, 1324,
     /* 379716 */     GIR_Done,
     /* 379717 */   // Label 7643: @379717
     /* 379717 */   GIM_Reject,
     /* 379718 */ // Label 7638: @379718
     /* 379718 */ GIM_Reject,
     /* 379719 */ // Label 7592: @379719
     /* 379719 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(380150),
     /* 379724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 379730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379734 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(379797), // Rule ID 13473 //
     /* 379739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379775 */     // MIs[2] Operand 1
     /* 379775 */     // No operand predicates
     /* 379775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379781 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 379784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379795 */     GIR_RootConstrainSelectedInstOperands,
     /* 379796 */     // GIR_Coverage, 13473,
     /* 379796 */     GIR_EraseRootFromParent_Done,
     /* 379797 */   // Label 7645: @379797
     /* 379797 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(379860), // Rule ID 2001 //
     /* 379802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379842 */     // MIs[2] Operand 1
     /* 379842 */     // No operand predicates
     /* 379842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379844 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 379847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379858 */     GIR_RootConstrainSelectedInstOperands,
     /* 379859 */     // GIR_Coverage, 2001,
     /* 379859 */     GIR_EraseRootFromParent_Done,
     /* 379860 */   // Label 7646: @379860
     /* 379860 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(379887), // Rule ID 1320 //
     /* 379865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379876 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 379881 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379885 */     GIR_RootConstrainSelectedInstOperands,
     /* 379886 */     // GIR_Coverage, 1320,
     /* 379886 */     GIR_Done,
     /* 379887 */   // Label 7647: @379887
     /* 379887 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(380149), // Rule ID 7015 //
     /* 379892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 379895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379903 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 379903 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 379906 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 379910 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379915 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 379919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 379921 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 379924 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 379928 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379933 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 379937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 379939 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 379942 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 379946 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379951 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 379954 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 379957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 379959 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 379962 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379966 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379971 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 379977 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379982 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379987 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 379990 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 379994 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379999 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 380002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 380004 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 380007 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380011 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380016 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 380022 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380027 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380032 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 380035 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380039 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380044 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 380047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 380049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 380052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 380056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380061 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380064 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 380067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380069 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 380072 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 380076 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380081 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 380084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 380093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 380107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 380121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 380139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 380147 */     GIR_RootConstrainSelectedInstOperands,
     /* 380148 */     // GIR_Coverage, 7015,
     /* 380148 */     GIR_EraseRootFromParent_Done,
     /* 380149 */   // Label 7648: @380149
     /* 380149 */   GIM_Reject,
     /* 380150 */ // Label 7644: @380150
     /* 380150 */ GIM_Reject,
     /* 380151 */ // Label 7593: @380151
     /* 380151 */ GIM_Reject,
     /* 380152 */ // Label 106: @380152
     /* 380152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7657*/ GIMT_Encode4(380767),
     /* 380163 */ /*GILLT_s16*//*Label 7649*/ GIMT_Encode4(380203),
     /* 380167 */ /*GILLT_s32*//*Label 7650*/ GIMT_Encode4(380241),
     /* 380171 */ /*GILLT_s64*//*Label 7651*/ GIMT_Encode4(380279), GIMT_Encode4(0),
     /* 380179 */ /*GILLT_v2s32*//*Label 7652*/ GIMT_Encode4(380317),
     /* 380183 */ /*GILLT_v2s64*//*Label 7653*/ GIMT_Encode4(380355),
     /* 380187 */ /*GILLT_v4s16*//*Label 7654*/ GIMT_Encode4(380393),
     /* 380191 */ /*GILLT_v4s32*//*Label 7655*/ GIMT_Encode4(380431), GIMT_Encode4(0),
     /* 380199 */ /*GILLT_v8s16*//*Label 7656*/ GIMT_Encode4(380469),
     /* 380203 */ // Label 7649: @380203
     /* 380203 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(380240), // Rule ID 589 //
     /* 380208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380229 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 380229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 380234 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380238 */   GIR_RootConstrainSelectedInstOperands,
     /* 380239 */   // GIR_Coverage, 589,
     /* 380239 */   GIR_Done,
     /* 380240 */ // Label 7658: @380240
     /* 380240 */ GIM_Reject,
     /* 380241 */ // Label 7650: @380241
     /* 380241 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(380278), // Rule ID 591 //
     /* 380246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 380252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380267 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 380267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 380272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380276 */   GIR_RootConstrainSelectedInstOperands,
     /* 380277 */   // GIR_Coverage, 591,
     /* 380277 */   GIR_Done,
     /* 380278 */ // Label 7659: @380278
     /* 380278 */ GIM_Reject,
     /* 380279 */ // Label 7651: @380279
     /* 380279 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(380316), // Rule ID 593 //
     /* 380284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 380290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 380293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380305 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 380305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 380310 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380314 */   GIR_RootConstrainSelectedInstOperands,
     /* 380315 */   // GIR_Coverage, 593,
     /* 380315 */   GIR_Done,
     /* 380316 */ // Label 7660: @380316
     /* 380316 */ GIM_Reject,
     /* 380317 */ // Label 7652: @380317
     /* 380317 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(380354), // Rule ID 1227 //
     /* 380322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 380331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380343 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 380343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 380348 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380352 */   GIR_RootConstrainSelectedInstOperands,
     /* 380353 */   // GIR_Coverage, 1227,
     /* 380353 */   GIR_Done,
     /* 380354 */ // Label 7661: @380354
     /* 380354 */ GIM_Reject,
     /* 380355 */ // Label 7653: @380355
     /* 380355 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(380392), // Rule ID 1231 //
     /* 380360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 380369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380381 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 380381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 380386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380390 */   GIR_RootConstrainSelectedInstOperands,
     /* 380391 */   // GIR_Coverage, 1231,
     /* 380391 */   GIR_Done,
     /* 380392 */ // Label 7662: @380392
     /* 380392 */ GIM_Reject,
     /* 380393 */ // Label 7654: @380393
     /* 380393 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(380430), // Rule ID 1223 //
     /* 380398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 380407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380419 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 380419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 380424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380428 */   GIR_RootConstrainSelectedInstOperands,
     /* 380429 */   // GIR_Coverage, 1223,
     /* 380429 */   GIR_Done,
     /* 380430 */ // Label 7663: @380430
     /* 380430 */ GIM_Reject,
     /* 380431 */ // Label 7655: @380431
     /* 380431 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(380468), // Rule ID 1229 //
     /* 380436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 380445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380457 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 380457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380466 */   GIR_RootConstrainSelectedInstOperands,
     /* 380467 */   // GIR_Coverage, 1229,
     /* 380467 */   GIR_Done,
     /* 380468 */ // Label 7664: @380468
     /* 380468 */ GIM_Reject,
     /* 380469 */ // Label 7656: @380469
     /* 380469 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(380766),
     /* 380474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 380480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380492 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(380511), // Rule ID 1225 //
     /* 380497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380500 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 380500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 380505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380509 */     GIR_RootConstrainSelectedInstOperands,
     /* 380510 */     // GIR_Coverage, 1225,
     /* 380510 */     GIR_Done,
     /* 380511 */   // Label 7666: @380511
     /* 380511 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(380765), // Rule ID 7013 //
     /* 380516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 380519 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 380519 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 380522 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 380526 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380531 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 380535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 380537 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 380540 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 380544 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380549 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 380555 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 380558 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380562 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380567 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 380570 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 380573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 380575 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 380578 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380582 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380587 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 380593 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380598 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380603 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 380606 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380610 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380615 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 380618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 380620 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 380623 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380627 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380632 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 380638 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380643 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380648 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 380651 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380655 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380660 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 380663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 380665 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 380668 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380672 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380677 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380680 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 380683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 380688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 380692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380697 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 380700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 380709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 380723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 380737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 380755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 380763 */     GIR_RootConstrainSelectedInstOperands,
     /* 380764 */     // GIR_Coverage, 7013,
     /* 380764 */     GIR_EraseRootFromParent_Done,
     /* 380765 */   // Label 7667: @380765
     /* 380765 */   GIM_Reject,
     /* 380766 */ // Label 7665: @380766
     /* 380766 */ GIM_Reject,
     /* 380767 */ // Label 7657: @380767
     /* 380767 */ GIM_Reject,
     /* 380768 */ // Label 107: @380768
     /* 380768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7676*/ GIMT_Encode4(396374),
     /* 380779 */ /*GILLT_s16*//*Label 7668*/ GIMT_Encode4(380819),
     /* 380783 */ /*GILLT_s32*//*Label 7669*/ GIMT_Encode4(383593),
     /* 380787 */ /*GILLT_s64*//*Label 7670*/ GIMT_Encode4(386523), GIMT_Encode4(0),
     /* 380795 */ /*GILLT_v2s32*//*Label 7671*/ GIMT_Encode4(389453),
     /* 380799 */ /*GILLT_v2s64*//*Label 7672*/ GIMT_Encode4(390974),
     /* 380803 */ /*GILLT_v4s16*//*Label 7673*/ GIMT_Encode4(392495),
     /* 380807 */ /*GILLT_v4s32*//*Label 7674*/ GIMT_Encode4(393674), GIMT_Encode4(0),
     /* 380815 */ /*GILLT_v8s16*//*Label 7675*/ GIMT_Encode4(395195),
     /* 380819 */ // Label 7668: @380819
     /* 380819 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383592),
     /* 380824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 380833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380837 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(380987), // Rule ID 4864 //
     /* 380842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380866 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 380899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 380907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380914 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 380914 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 380917 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380921 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380926 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 380932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 380973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 380985 */     GIR_RootConstrainSelectedInstOperands,
     /* 380986 */     // GIR_Coverage, 4864,
     /* 380986 */     GIR_EraseRootFromParent_Done,
     /* 380987 */   // Label 7678: @380987
     /* 380987 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(381134), // Rule ID 4828 //
     /* 380992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381048 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381053 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381063 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381075 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381086 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381132 */     GIR_RootConstrainSelectedInstOperands,
     /* 381133 */     // GIR_Coverage, 4828,
     /* 381133 */     GIR_EraseRootFromParent_Done,
     /* 381134 */   // Label 7679: @381134
     /* 381134 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(381281), // Rule ID 13881 //
     /* 381139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381200 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381210 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381222 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381279 */     GIR_RootConstrainSelectedInstOperands,
     /* 381280 */     // GIR_Coverage, 13881,
     /* 381280 */     GIR_EraseRootFromParent_Done,
     /* 381281 */   // Label 7680: @381281
     /* 381281 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(381412), // Rule ID 6090 //
     /* 381286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381310 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381334 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381338 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381342 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 381351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381355 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381359 */     // MIs[4] Operand 1
     /* 381359 */     // No operand predicates
     /* 381359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381365 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381377 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 381407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 381410 */     GIR_RootConstrainSelectedInstOperands,
     /* 381411 */     // GIR_Coverage, 6090,
     /* 381411 */     GIR_EraseRootFromParent_Done,
     /* 381412 */   // Label 7681: @381412
     /* 381412 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(381543), // Rule ID 6122 //
     /* 381417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381453 */     // MIs[2] Operand 1
     /* 381453 */     // No operand predicates
     /* 381453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381461 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 381465 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 381469 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381473 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381477 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 381481 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381486 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 381490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381496 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381508 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381541 */     GIR_RootConstrainSelectedInstOperands,
     /* 381542 */     // GIR_Coverage, 6122,
     /* 381542 */     GIR_EraseRootFromParent_Done,
     /* 381543 */   // Label 7682: @381543
     /* 381543 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(381674), // Rule ID 6186 //
     /* 381548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381584 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381604 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381609 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 381613 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381617 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381621 */     // MIs[4] Operand 1
     /* 381621 */     // No operand predicates
     /* 381621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381625 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381627 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 381669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 381672 */     GIR_RootConstrainSelectedInstOperands,
     /* 381673 */     // GIR_Coverage, 6186,
     /* 381673 */     GIR_EraseRootFromParent_Done,
     /* 381674 */   // Label 7683: @381674
     /* 381674 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(381805), // Rule ID 6154 //
     /* 381679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381727 */     // MIs[3] Operand 1
     /* 381727 */     // No operand predicates
     /* 381727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 381731 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381735 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381739 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 381743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381748 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 381752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381758 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381770 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381803 */     GIR_RootConstrainSelectedInstOperands,
     /* 381804 */     // GIR_Coverage, 6154,
     /* 381804 */     GIR_EraseRootFromParent_Done,
     /* 381805 */   // Label 7684: @381805
     /* 381805 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(381940), // Rule ID 2455 //
     /* 381810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381834 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381859 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381869 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381881 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381909 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 381928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381938 */     GIR_RootConstrainSelectedInstOperands,
     /* 381939 */     // GIR_Coverage, 2455,
     /* 381939 */     GIR_EraseRootFromParent_Done,
     /* 381940 */   // Label 7685: @381940
     /* 381940 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(382059), // Rule ID 6058 //
     /* 381945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381969 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382002 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382006 */     // MIs[3] Operand 1
     /* 382006 */     // No operand predicates
     /* 382006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382012 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 382043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382057 */     GIR_RootConstrainSelectedInstOperands,
     /* 382058 */     // GIR_Coverage, 6058,
     /* 382058 */     GIR_EraseRootFromParent_Done,
     /* 382059 */   // Label 7686: @382059
     /* 382059 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(382178), // Rule ID 2537 //
     /* 382064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382100 */     // MIs[2] Operand 1
     /* 382100 */     // No operand predicates
     /* 382100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382121 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382131 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 382162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382176 */     GIR_RootConstrainSelectedInstOperands,
     /* 382177 */     // GIR_Coverage, 2537,
     /* 382177 */     GIR_EraseRootFromParent_Done,
     /* 382178 */   // Label 7687: @382178
     /* 382178 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(382278), // Rule ID 4826 //
     /* 382183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382234 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382246 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382276 */     GIR_RootConstrainSelectedInstOperands,
     /* 382277 */     // GIR_Coverage, 4826,
     /* 382277 */     GIR_EraseRootFromParent_Done,
     /* 382278 */   // Label 7688: @382278
     /* 382278 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(382378), // Rule ID 4862 //
     /* 382283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382307 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 382319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382334 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 382365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 382376 */     GIR_RootConstrainSelectedInstOperands,
     /* 382377 */     // GIR_Coverage, 4862,
     /* 382377 */     GIR_EraseRootFromParent_Done,
     /* 382378 */   // Label 7689: @382378
     /* 382378 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(382475), // Rule ID 13877 //
     /* 382383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382419 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382433 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382473 */     GIR_RootConstrainSelectedInstOperands,
     /* 382474 */     // GIR_Coverage, 13877,
     /* 382474 */     GIR_EraseRootFromParent_Done,
     /* 382475 */   // Label 7690: @382475
     /* 382475 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(382575), // Rule ID 13879 //
     /* 382480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382531 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382573 */     GIR_RootConstrainSelectedInstOperands,
     /* 382574 */     // GIR_Coverage, 13879,
     /* 382574 */     GIR_EraseRootFromParent_Done,
     /* 382575 */   // Label 7691: @382575
     /* 382575 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(382675), // Rule ID 4860 //
     /* 382580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 382616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382631 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382643 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 382662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 382673 */     GIR_RootConstrainSelectedInstOperands,
     /* 382674 */     // GIR_Coverage, 4860,
     /* 382674 */     GIR_EraseRootFromParent_Done,
     /* 382675 */   // Label 7692: @382675
     /* 382675 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(382772), // Rule ID 4824 //
     /* 382680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382720 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382730 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382742 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382770 */     GIR_RootConstrainSelectedInstOperands,
     /* 382771 */     // GIR_Coverage, 4824,
     /* 382771 */     GIR_EraseRootFromParent_Done,
     /* 382772 */   // Label 7693: @382772
     /* 382772 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(382856), // Rule ID 6120 //
     /* 382777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382813 */     // MIs[2] Operand 1
     /* 382813 */     // No operand predicates
     /* 382813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 382825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382836 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 382839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 382847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382854 */     GIR_RootConstrainSelectedInstOperands,
     /* 382855 */     // GIR_Coverage, 6120,
     /* 382855 */     GIR_EraseRootFromParent_Done,
     /* 382856 */   // Label 7694: @382856
     /* 382856 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(382937), // Rule ID 6152 //
     /* 382861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382909 */     // MIs[3] Operand 1
     /* 382909 */     // No operand predicates
     /* 382909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382919 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 382922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382935 */     GIR_RootConstrainSelectedInstOperands,
     /* 382936 */     // GIR_Coverage, 6152,
     /* 382936 */     GIR_EraseRootFromParent_Done,
     /* 382937 */   // Label 7695: @382937
     /* 382937 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(383021), // Rule ID 6184 //
     /* 382942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382991 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382995 */     // MIs[3] Operand 1
     /* 382995 */     // No operand predicates
     /* 382995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383001 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 383004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383019 */     GIR_RootConstrainSelectedInstOperands,
     /* 383020 */     // GIR_Coverage, 6184,
     /* 383020 */     GIR_EraseRootFromParent_Done,
     /* 383021 */   // Label 7696: @383021
     /* 383021 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(383102), // Rule ID 6088 //
     /* 383026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383074 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383078 */     // MIs[3] Operand 1
     /* 383078 */     // No operand predicates
     /* 383078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383084 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 383087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383100 */     GIR_RootConstrainSelectedInstOperands,
     /* 383101 */     // GIR_Coverage, 6088,
     /* 383101 */     GIR_EraseRootFromParent_Done,
     /* 383102 */   // Label 7697: @383102
     /* 383102 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(383187), // Rule ID 2453 //
     /* 383107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383131 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383145 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383157 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 383163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383185 */     GIR_RootConstrainSelectedInstOperands,
     /* 383186 */     // GIR_Coverage, 2453,
     /* 383186 */     GIR_EraseRootFromParent_Done,
     /* 383187 */   // Label 7698: @383187
     /* 383187 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(383272), // Rule ID 2451 //
     /* 383192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383220 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383230 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 383230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383242 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 383248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383270 */     GIR_RootConstrainSelectedInstOperands,
     /* 383271 */     // GIR_Coverage, 2451,
     /* 383271 */     GIR_EraseRootFromParent_Done,
     /* 383272 */   // Label 7699: @383272
     /* 383272 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(383341), // Rule ID 2535 //
     /* 383277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383313 */     // MIs[2] Operand 1
     /* 383313 */     // No operand predicates
     /* 383313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383323 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 383326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383339 */     GIR_RootConstrainSelectedInstOperands,
     /* 383340 */     // GIR_Coverage, 2535,
     /* 383340 */     GIR_EraseRootFromParent_Done,
     /* 383341 */   // Label 7700: @383341
     /* 383341 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(383410), // Rule ID 6056 //
     /* 383346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383386 */     // MIs[2] Operand 1
     /* 383386 */     // No operand predicates
     /* 383386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383392 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 383395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383408 */     GIR_RootConstrainSelectedInstOperands,
     /* 383409 */     // GIR_Coverage, 6056,
     /* 383409 */     GIR_EraseRootFromParent_Done,
     /* 383410 */   // Label 7701: @383410
     /* 383410 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(383460), // Rule ID 13323 //
     /* 383415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383445 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 383448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383458 */     GIR_RootConstrainSelectedInstOperands,
     /* 383459 */     // GIR_Coverage, 13323,
     /* 383459 */     GIR_EraseRootFromParent_Done,
     /* 383460 */   // Label 7702: @383460
     /* 383460 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(383510), // Rule ID 643 //
     /* 383465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383495 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 383498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383508 */     GIR_RootConstrainSelectedInstOperands,
     /* 383509 */     // GIR_Coverage, 643,
     /* 383509 */     GIR_EraseRootFromParent_Done,
     /* 383510 */   // Label 7703: @383510
     /* 383510 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(383560), // Rule ID 655 //
     /* 383515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 383530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383545 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 383548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 383558 */     GIR_RootConstrainSelectedInstOperands,
     /* 383559 */     // GIR_Coverage, 655,
     /* 383559 */     GIR_EraseRootFromParent_Done,
     /* 383560 */   // Label 7704: @383560
     /* 383560 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(383591), // Rule ID 637 //
     /* 383565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383580 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383589 */     GIR_RootConstrainSelectedInstOperands,
     /* 383590 */     // GIR_Coverage, 637,
     /* 383590 */     GIR_Done,
     /* 383591 */   // Label 7705: @383591
     /* 383591 */   GIM_Reject,
     /* 383592 */ // Label 7677: @383592
     /* 383592 */ GIM_Reject,
     /* 383593 */ // Label 7669: @383593
     /* 383593 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(386522),
     /* 383598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 383601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 383607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383611 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(383761), // Rule ID 4870 //
     /* 383616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383640 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 383673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 383681 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383688 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383700 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 383747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 383759 */     GIR_RootConstrainSelectedInstOperands,
     /* 383760 */     // GIR_Coverage, 4870,
     /* 383760 */     GIR_EraseRootFromParent_Done,
     /* 383761 */   // Label 7707: @383761
     /* 383761 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(383908), // Rule ID 4834 //
     /* 383766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383790 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383822 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383827 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383837 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383849 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 383896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383906 */     GIR_RootConstrainSelectedInstOperands,
     /* 383907 */     // GIR_Coverage, 4834,
     /* 383907 */     GIR_EraseRootFromParent_Done,
     /* 383908 */   // Label 7708: @383908
     /* 383908 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384055), // Rule ID 13887 //
     /* 383913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383949 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383961 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383965 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383969 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383974 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383984 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383984 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383987 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383991 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383996 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 384002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 384043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 384051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384053 */     GIR_RootConstrainSelectedInstOperands,
     /* 384054 */     // GIR_Coverage, 13887,
     /* 384054 */     GIR_EraseRootFromParent_Done,
     /* 384055 */   // Label 7709: @384055
     /* 384055 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384186), // Rule ID 6106 //
     /* 384060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 384125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384129 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384133 */     // MIs[4] Operand 1
     /* 384133 */     // No operand predicates
     /* 384133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384139 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384151 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 384181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 384184 */     GIR_RootConstrainSelectedInstOperands,
     /* 384185 */     // GIR_Coverage, 6106,
     /* 384185 */     GIR_EraseRootFromParent_Done,
     /* 384186 */   // Label 7710: @384186
     /* 384186 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384317), // Rule ID 6138 //
     /* 384191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384227 */     // MIs[2] Operand 1
     /* 384227 */     // No operand predicates
     /* 384227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 384239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 384243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 384255 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384260 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 384264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384268 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384270 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384282 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384315 */     GIR_RootConstrainSelectedInstOperands,
     /* 384316 */     // GIR_Coverage, 6138,
     /* 384316 */     GIR_EraseRootFromParent_Done,
     /* 384317 */   // Label 7711: @384317
     /* 384317 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(384448), // Rule ID 6202 //
     /* 384322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384358 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384370 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384374 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384378 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384383 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 384387 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384391 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384395 */     // MIs[4] Operand 1
     /* 384395 */     // No operand predicates
     /* 384395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384399 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384401 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 384443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 384446 */     GIR_RootConstrainSelectedInstOperands,
     /* 384447 */     // GIR_Coverage, 6202,
     /* 384447 */     GIR_EraseRootFromParent_Done,
     /* 384448 */   // Label 7712: @384448
     /* 384448 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(384579), // Rule ID 6170 //
     /* 384453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384497 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384501 */     // MIs[3] Operand 1
     /* 384501 */     // No operand predicates
     /* 384501 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 384505 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384509 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384513 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 384517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384522 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 384526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384530 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384532 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384544 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384577 */     GIR_RootConstrainSelectedInstOperands,
     /* 384578 */     // GIR_Coverage, 6170,
     /* 384578 */     GIR_EraseRootFromParent_Done,
     /* 384579 */   // Label 7713: @384579
     /* 384579 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(384714), // Rule ID 2461 //
     /* 384584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384633 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384643 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 384643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 384646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384655 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 384661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384683 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 384702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 384710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384712 */     GIR_RootConstrainSelectedInstOperands,
     /* 384713 */     // GIR_Coverage, 2461,
     /* 384713 */     GIR_EraseRootFromParent_Done,
     /* 384714 */   // Label 7714: @384714
     /* 384714 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(384833), // Rule ID 6074 //
     /* 384719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384743 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384776 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384780 */     // MIs[3] Operand 1
     /* 384780 */     // No operand predicates
     /* 384780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384786 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384798 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384831 */     GIR_RootConstrainSelectedInstOperands,
     /* 384832 */     // GIR_Coverage, 6074,
     /* 384832 */     GIR_EraseRootFromParent_Done,
     /* 384833 */   // Label 7715: @384833
     /* 384833 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(384952), // Rule ID 2553 //
     /* 384838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384874 */     // MIs[2] Operand 1
     /* 384874 */     // No operand predicates
     /* 384874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384895 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 384899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384905 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384917 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384950 */     GIR_RootConstrainSelectedInstOperands,
     /* 384951 */     // GIR_Coverage, 2553,
     /* 384951 */     GIR_EraseRootFromParent_Done,
     /* 384952 */   // Label 7716: @384952
     /* 384952 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(385052), // Rule ID 4832 //
     /* 384957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384981 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385008 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385020 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385050 */     GIR_RootConstrainSelectedInstOperands,
     /* 385051 */     // GIR_Coverage, 4832,
     /* 385051 */     GIR_EraseRootFromParent_Done,
     /* 385052 */   // Label 7717: @385052
     /* 385052 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(385152), // Rule ID 4868 //
     /* 385057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 385093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385108 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 385139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 385146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 385150 */     GIR_RootConstrainSelectedInstOperands,
     /* 385151 */     // GIR_Coverage, 4868,
     /* 385151 */     GIR_EraseRootFromParent_Done,
     /* 385152 */   // Label 7718: @385152
     /* 385152 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(385249), // Rule ID 13883 //
     /* 385157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385207 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385219 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385247 */     GIR_RootConstrainSelectedInstOperands,
     /* 385248 */     // GIR_Coverage, 13883,
     /* 385248 */     GIR_EraseRootFromParent_Done,
     /* 385249 */   // Label 7719: @385249
     /* 385249 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(385349), // Rule ID 13885 //
     /* 385254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385305 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385347 */     GIR_RootConstrainSelectedInstOperands,
     /* 385348 */     // GIR_Coverage, 13885,
     /* 385348 */     GIR_EraseRootFromParent_Done,
     /* 385349 */   // Label 7720: @385349
     /* 385349 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(385449), // Rule ID 4866 //
     /* 385354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 385390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385405 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 385436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 385447 */     GIR_RootConstrainSelectedInstOperands,
     /* 385448 */     // GIR_Coverage, 4866,
     /* 385448 */     GIR_EraseRootFromParent_Done,
     /* 385449 */   // Label 7721: @385449
     /* 385449 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(385546), // Rule ID 4830 //
     /* 385454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385504 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385544 */     GIR_RootConstrainSelectedInstOperands,
     /* 385545 */     // GIR_Coverage, 4830,
     /* 385545 */     GIR_EraseRootFromParent_Done,
     /* 385546 */   // Label 7722: @385546
     /* 385546 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(385624), // Rule ID 6224 //
     /* 385551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385596 */     // MIs[3] Operand 1
     /* 385596 */     // No operand predicates
     /* 385596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385606 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385622 */     GIR_RootConstrainSelectedInstOperands,
     /* 385623 */     // GIR_Coverage, 6224,
     /* 385623 */     GIR_EraseRootFromParent_Done,
     /* 385624 */   // Label 7723: @385624
     /* 385624 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(385708), // Rule ID 6136 //
     /* 385629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385665 */     // MIs[2] Operand 1
     /* 385665 */     // No operand predicates
     /* 385665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385673 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 385677 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385688 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 385699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385706 */     GIR_RootConstrainSelectedInstOperands,
     /* 385707 */     // GIR_Coverage, 6136,
     /* 385707 */     GIR_EraseRootFromParent_Done,
     /* 385708 */   // Label 7724: @385708
     /* 385708 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(385789), // Rule ID 6168 //
     /* 385713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385757 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385761 */     // MIs[3] Operand 1
     /* 385761 */     // No operand predicates
     /* 385761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385771 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385787 */     GIR_RootConstrainSelectedInstOperands,
     /* 385788 */     // GIR_Coverage, 6168,
     /* 385788 */     GIR_EraseRootFromParent_Done,
     /* 385789 */   // Label 7725: @385789
     /* 385789 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(385873), // Rule ID 6200 //
     /* 385794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385847 */     // MIs[3] Operand 1
     /* 385847 */     // No operand predicates
     /* 385847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385853 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385871 */     GIR_RootConstrainSelectedInstOperands,
     /* 385872 */     // GIR_Coverage, 6200,
     /* 385872 */     GIR_EraseRootFromParent_Done,
     /* 385873 */   // Label 7726: @385873
     /* 385873 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(385951), // Rule ID 6246 //
     /* 385878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385923 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385927 */     // MIs[3] Operand 1
     /* 385927 */     // No operand predicates
     /* 385927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385933 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385949 */     GIR_RootConstrainSelectedInstOperands,
     /* 385950 */     // GIR_Coverage, 6246,
     /* 385950 */     GIR_EraseRootFromParent_Done,
     /* 385951 */   // Label 7727: @385951
     /* 385951 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(386032), // Rule ID 6104 //
     /* 385956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386008 */     // MIs[3] Operand 1
     /* 386008 */     // No operand predicates
     /* 386008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386014 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 386017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386030 */     GIR_RootConstrainSelectedInstOperands,
     /* 386031 */     // GIR_Coverage, 6104,
     /* 386031 */     GIR_EraseRootFromParent_Done,
     /* 386032 */   // Label 7728: @386032
     /* 386032 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(386117), // Rule ID 2459 //
     /* 386037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386075 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 386078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386087 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386115 */     GIR_RootConstrainSelectedInstOperands,
     /* 386116 */     // GIR_Coverage, 2459,
     /* 386116 */     GIR_EraseRootFromParent_Done,
     /* 386117 */   // Label 7729: @386117
     /* 386117 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(386202), // Rule ID 2457 //
     /* 386122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386150 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386160 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 386160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 386163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 386178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386200 */     GIR_RootConstrainSelectedInstOperands,
     /* 386201 */     // GIR_Coverage, 2457,
     /* 386201 */     GIR_EraseRootFromParent_Done,
     /* 386202 */   // Label 7730: @386202
     /* 386202 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(386271), // Rule ID 2551 //
     /* 386207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386239 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386243 */     // MIs[2] Operand 1
     /* 386243 */     // No operand predicates
     /* 386243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386253 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 386256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386269 */     GIR_RootConstrainSelectedInstOperands,
     /* 386270 */     // GIR_Coverage, 2551,
     /* 386270 */     GIR_EraseRootFromParent_Done,
     /* 386271 */   // Label 7731: @386271
     /* 386271 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(386340), // Rule ID 6072 //
     /* 386276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386316 */     // MIs[2] Operand 1
     /* 386316 */     // No operand predicates
     /* 386316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386322 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 386325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386338 */     GIR_RootConstrainSelectedInstOperands,
     /* 386339 */     // GIR_Coverage, 6072,
     /* 386339 */     GIR_EraseRootFromParent_Done,
     /* 386340 */   // Label 7732: @386340
     /* 386340 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(386390), // Rule ID 13325 //
     /* 386345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386375 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 386378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386388 */     GIR_RootConstrainSelectedInstOperands,
     /* 386389 */     // GIR_Coverage, 13325,
     /* 386389 */     GIR_EraseRootFromParent_Done,
     /* 386390 */   // Label 7733: @386390
     /* 386390 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(386440), // Rule ID 645 //
     /* 386395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386425 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 386428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386438 */     GIR_RootConstrainSelectedInstOperands,
     /* 386439 */     // GIR_Coverage, 645,
     /* 386439 */     GIR_EraseRootFromParent_Done,
     /* 386440 */   // Label 7734: @386440
     /* 386440 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(386490), // Rule ID 657 //
     /* 386445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386475 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 386478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 386488 */     GIR_RootConstrainSelectedInstOperands,
     /* 386489 */     // GIR_Coverage, 657,
     /* 386489 */     GIR_EraseRootFromParent_Done,
     /* 386490 */   // Label 7735: @386490
     /* 386490 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(386521), // Rule ID 639 //
     /* 386495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386510 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386515 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 386519 */     GIR_RootConstrainSelectedInstOperands,
     /* 386520 */     // GIR_Coverage, 639,
     /* 386520 */     GIR_Done,
     /* 386521 */   // Label 7736: @386521
     /* 386521 */   GIM_Reject,
     /* 386522 */ // Label 7706: @386522
     /* 386522 */ GIM_Reject,
     /* 386523 */ // Label 7670: @386523
     /* 386523 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(389452),
     /* 386528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386541 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(386691), // Rule ID 4876 //
     /* 386546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386595 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 386611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386618 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386630 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386658 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 386677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 386689 */     GIR_RootConstrainSelectedInstOperands,
     /* 386690 */     // GIR_Coverage, 4876,
     /* 386690 */     GIR_EraseRootFromParent_Done,
     /* 386691 */   // Label 7738: @386691
     /* 386691 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(386838), // Rule ID 4840 //
     /* 386696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 386752 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386757 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 386761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386767 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386779 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386836 */     GIR_RootConstrainSelectedInstOperands,
     /* 386837 */     // GIR_Coverage, 4840,
     /* 386837 */     GIR_EraseRootFromParent_Done,
     /* 386838 */   // Label 7739: @386838
     /* 386838 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(386985), // Rule ID 13893 //
     /* 386843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 386887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386891 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 386899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386904 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 386908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386914 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386914 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386917 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386921 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386926 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386983 */     GIR_RootConstrainSelectedInstOperands,
     /* 386984 */     // GIR_Coverage, 13893,
     /* 386984 */     GIR_EraseRootFromParent_Done,
     /* 386985 */   // Label 7740: @386985
     /* 386985 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(387116), // Rule ID 6110 //
     /* 386990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 387034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387051 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 387055 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387059 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387063 */     // MIs[4] Operand 1
     /* 387063 */     // No operand predicates
     /* 387063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387069 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387081 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 387111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 387114 */     GIR_RootConstrainSelectedInstOperands,
     /* 387115 */     // GIR_Coverage, 6110,
     /* 387115 */     GIR_EraseRootFromParent_Done,
     /* 387116 */   // Label 7741: @387116
     /* 387116 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(387247), // Rule ID 6142 //
     /* 387121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387157 */     // MIs[2] Operand 1
     /* 387157 */     // No operand predicates
     /* 387157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 387169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 387173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387177 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387181 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 387185 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387190 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 387194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387198 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387200 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387212 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387245 */     GIR_RootConstrainSelectedInstOperands,
     /* 387246 */     // GIR_Coverage, 6142,
     /* 387246 */     GIR_EraseRootFromParent_Done,
     /* 387247 */   // Label 7742: @387247
     /* 387247 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(387378), // Rule ID 6206 //
     /* 387252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 387292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 387317 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387321 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387325 */     // MIs[4] Operand 1
     /* 387325 */     // No operand predicates
     /* 387325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387329 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387331 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387343 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 387373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 387376 */     GIR_RootConstrainSelectedInstOperands,
     /* 387377 */     // GIR_Coverage, 6206,
     /* 387377 */     GIR_EraseRootFromParent_Done,
     /* 387378 */   // Label 7743: @387378
     /* 387378 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(387509), // Rule ID 6174 //
     /* 387383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387431 */     // MIs[3] Operand 1
     /* 387431 */     // No operand predicates
     /* 387431 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 387435 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387439 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387443 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 387447 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387452 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 387456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387460 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387462 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387507 */     GIR_RootConstrainSelectedInstOperands,
     /* 387508 */     // GIR_Coverage, 6174,
     /* 387508 */     GIR_EraseRootFromParent_Done,
     /* 387509 */   // Label 7744: @387509
     /* 387509 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(387644), // Rule ID 2467 //
     /* 387514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387563 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 387567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387573 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 387573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 387576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387585 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 387591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 387632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 387640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387642 */     GIR_RootConstrainSelectedInstOperands,
     /* 387643 */     // GIR_Coverage, 2467,
     /* 387643 */     GIR_EraseRootFromParent_Done,
     /* 387644 */   // Label 7745: @387644
     /* 387644 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(387763), // Rule ID 6078 //
     /* 387649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387710 */     // MIs[3] Operand 1
     /* 387710 */     // No operand predicates
     /* 387710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387716 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387761 */     GIR_RootConstrainSelectedInstOperands,
     /* 387762 */     // GIR_Coverage, 6078,
     /* 387762 */     GIR_EraseRootFromParent_Done,
     /* 387763 */   // Label 7746: @387763
     /* 387763 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(387882), // Rule ID 2557 //
     /* 387768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387804 */     // MIs[2] Operand 1
     /* 387804 */     // No operand predicates
     /* 387804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387820 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387825 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 387829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387835 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387880 */     GIR_RootConstrainSelectedInstOperands,
     /* 387881 */     // GIR_Coverage, 2557,
     /* 387881 */     GIR_EraseRootFromParent_Done,
     /* 387882 */   // Label 7747: @387882
     /* 387882 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(387982), // Rule ID 4838 //
     /* 387887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387911 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387938 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387950 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 387969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387980 */     GIR_RootConstrainSelectedInstOperands,
     /* 387981 */     // GIR_Coverage, 4838,
     /* 387981 */     GIR_EraseRootFromParent_Done,
     /* 387982 */   // Label 7748: @387982
     /* 387982 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(388082), // Rule ID 4874 //
     /* 387987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 388023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388038 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 388038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388050 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 388069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 388080 */     GIR_RootConstrainSelectedInstOperands,
     /* 388081 */     // GIR_Coverage, 4874,
     /* 388081 */     GIR_EraseRootFromParent_Done,
     /* 388082 */   // Label 7749: @388082
     /* 388082 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(388179), // Rule ID 13889 //
     /* 388087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388123 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388137 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388149 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388177 */     GIR_RootConstrainSelectedInstOperands,
     /* 388178 */     // GIR_Coverage, 13889,
     /* 388178 */     GIR_EraseRootFromParent_Done,
     /* 388179 */   // Label 7750: @388179
     /* 388179 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(388279), // Rule ID 13891 //
     /* 388184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388225 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388235 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 388235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388277 */     GIR_RootConstrainSelectedInstOperands,
     /* 388278 */     // GIR_Coverage, 13891,
     /* 388278 */     GIR_EraseRootFromParent_Done,
     /* 388279 */   // Label 7751: @388279
     /* 388279 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(388379), // Rule ID 4872 //
     /* 388284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388312 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 388320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388335 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 388366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 388377 */     GIR_RootConstrainSelectedInstOperands,
     /* 388378 */     // GIR_Coverage, 4872,
     /* 388378 */     GIR_EraseRootFromParent_Done,
     /* 388379 */   // Label 7752: @388379
     /* 388379 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(388476), // Rule ID 4836 //
     /* 388384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388434 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388446 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388474 */     GIR_RootConstrainSelectedInstOperands,
     /* 388475 */     // GIR_Coverage, 4836,
     /* 388475 */     GIR_EraseRootFromParent_Done,
     /* 388476 */   // Label 7753: @388476
     /* 388476 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(388554), // Rule ID 6228 //
     /* 388481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388526 */     // MIs[3] Operand 1
     /* 388526 */     // No operand predicates
     /* 388526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388536 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388552 */     GIR_RootConstrainSelectedInstOperands,
     /* 388553 */     // GIR_Coverage, 6228,
     /* 388553 */     GIR_EraseRootFromParent_Done,
     /* 388554 */   // Label 7754: @388554
     /* 388554 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(388638), // Rule ID 6140 //
     /* 388559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388591 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388595 */     // MIs[2] Operand 1
     /* 388595 */     // No operand predicates
     /* 388595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 388607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388618 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388636 */     GIR_RootConstrainSelectedInstOperands,
     /* 388637 */     // GIR_Coverage, 6140,
     /* 388637 */     GIR_EraseRootFromParent_Done,
     /* 388638 */   // Label 7755: @388638
     /* 388638 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(388719), // Rule ID 6172 //
     /* 388643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388691 */     // MIs[3] Operand 1
     /* 388691 */     // No operand predicates
     /* 388691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388701 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388717 */     GIR_RootConstrainSelectedInstOperands,
     /* 388718 */     // GIR_Coverage, 6172,
     /* 388718 */     GIR_EraseRootFromParent_Done,
     /* 388719 */   // Label 7756: @388719
     /* 388719 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(388803), // Rule ID 6204 //
     /* 388724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388777 */     // MIs[3] Operand 1
     /* 388777 */     // No operand predicates
     /* 388777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388783 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388801 */     GIR_RootConstrainSelectedInstOperands,
     /* 388802 */     // GIR_Coverage, 6204,
     /* 388802 */     GIR_EraseRootFromParent_Done,
     /* 388803 */   // Label 7757: @388803
     /* 388803 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(388881), // Rule ID 6250 //
     /* 388808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388857 */     // MIs[3] Operand 1
     /* 388857 */     // No operand predicates
     /* 388857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388863 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388879 */     GIR_RootConstrainSelectedInstOperands,
     /* 388880 */     // GIR_Coverage, 6250,
     /* 388880 */     GIR_EraseRootFromParent_Done,
     /* 388881 */   // Label 7758: @388881
     /* 388881 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(388962), // Rule ID 6108 //
     /* 388886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388938 */     // MIs[3] Operand 1
     /* 388938 */     // No operand predicates
     /* 388938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388944 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388960 */     GIR_RootConstrainSelectedInstOperands,
     /* 388961 */     // GIR_Coverage, 6108,
     /* 388961 */     GIR_EraseRootFromParent_Done,
     /* 388962 */   // Label 7759: @388962
     /* 388962 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(389047), // Rule ID 2465 //
     /* 388967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389005 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389017 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 389023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389045 */     GIR_RootConstrainSelectedInstOperands,
     /* 389046 */     // GIR_Coverage, 2465,
     /* 389046 */     GIR_EraseRootFromParent_Done,
     /* 389047 */   // Label 7760: @389047
     /* 389047 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(389132), // Rule ID 2463 //
     /* 389052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 389084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389090 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 389090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 389108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389130 */     GIR_RootConstrainSelectedInstOperands,
     /* 389131 */     // GIR_Coverage, 2463,
     /* 389131 */     GIR_EraseRootFromParent_Done,
     /* 389132 */   // Label 7761: @389132
     /* 389132 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(389201), // Rule ID 2555 //
     /* 389137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389173 */     // MIs[2] Operand 1
     /* 389173 */     // No operand predicates
     /* 389173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389183 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 389186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389199 */     GIR_RootConstrainSelectedInstOperands,
     /* 389200 */     // GIR_Coverage, 2555,
     /* 389200 */     GIR_EraseRootFromParent_Done,
     /* 389201 */   // Label 7762: @389201
     /* 389201 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(389270), // Rule ID 6076 //
     /* 389206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389246 */     // MIs[2] Operand 1
     /* 389246 */     // No operand predicates
     /* 389246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389252 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 389255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389268 */     GIR_RootConstrainSelectedInstOperands,
     /* 389269 */     // GIR_Coverage, 6076,
     /* 389269 */     GIR_EraseRootFromParent_Done,
     /* 389270 */   // Label 7763: @389270
     /* 389270 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(389320), // Rule ID 13327 //
     /* 389275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389305 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 389308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389318 */     GIR_RootConstrainSelectedInstOperands,
     /* 389319 */     // GIR_Coverage, 13327,
     /* 389319 */     GIR_EraseRootFromParent_Done,
     /* 389320 */   // Label 7764: @389320
     /* 389320 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(389370), // Rule ID 647 //
     /* 389325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389355 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 389358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389368 */     GIR_RootConstrainSelectedInstOperands,
     /* 389369 */     // GIR_Coverage, 647,
     /* 389369 */     GIR_EraseRootFromParent_Done,
     /* 389370 */   // Label 7765: @389370
     /* 389370 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(389420), // Rule ID 659 //
     /* 389375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 389390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389405 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 389408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 389418 */     GIR_RootConstrainSelectedInstOperands,
     /* 389419 */     // GIR_Coverage, 659,
     /* 389419 */     GIR_EraseRootFromParent_Done,
     /* 389420 */   // Label 7766: @389420
     /* 389420 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(389451), // Rule ID 641 //
     /* 389425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389440 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389449 */     GIR_RootConstrainSelectedInstOperands,
     /* 389450 */     // GIR_Coverage, 641,
     /* 389450 */     GIR_Done,
     /* 389451 */   // Label 7767: @389451
     /* 389451 */   GIM_Reject,
     /* 389452 */ // Label 7737: @389452
     /* 389452 */ GIM_Reject,
     /* 389453 */ // Label 7671: @389453
     /* 389453 */ GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(390973),
     /* 389458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 389467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389471 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(389549), // Rule ID 6208 //
     /* 389476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389517 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389521 */     // MIs[3] Operand 1
     /* 389521 */     // No operand predicates
     /* 389521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389531 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389547 */     GIR_RootConstrainSelectedInstOperands,
     /* 389548 */     // GIR_Coverage, 6208,
     /* 389548 */     GIR_EraseRootFromParent_Done,
     /* 389549 */   // Label 7769: @389549
     /* 389549 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(389633), // Rule ID 6124 //
     /* 389554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389590 */     // MIs[2] Operand 1
     /* 389590 */     // No operand predicates
     /* 389590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 389594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389602 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389613 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389631 */     GIR_RootConstrainSelectedInstOperands,
     /* 389632 */     // GIR_Coverage, 6124,
     /* 389632 */     GIR_EraseRootFromParent_Done,
     /* 389633 */   // Label 7770: @389633
     /* 389633 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(389714), // Rule ID 6156 //
     /* 389638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389682 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389686 */     // MIs[3] Operand 1
     /* 389686 */     // No operand predicates
     /* 389686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389696 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389712 */     GIR_RootConstrainSelectedInstOperands,
     /* 389713 */     // GIR_Coverage, 6156,
     /* 389713 */     GIR_EraseRootFromParent_Done,
     /* 389714 */   // Label 7771: @389714
     /* 389714 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(389798), // Rule ID 6188 //
     /* 389719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389768 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389772 */     // MIs[3] Operand 1
     /* 389772 */     // No operand predicates
     /* 389772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389778 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389796 */     GIR_RootConstrainSelectedInstOperands,
     /* 389797 */     // GIR_Coverage, 6188,
     /* 389797 */     GIR_EraseRootFromParent_Done,
     /* 389798 */   // Label 7772: @389798
     /* 389798 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(389876), // Rule ID 6230 //
     /* 389803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389848 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389852 */     // MIs[3] Operand 1
     /* 389852 */     // No operand predicates
     /* 389852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389858 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389874 */     GIR_RootConstrainSelectedInstOperands,
     /* 389875 */     // GIR_Coverage, 6230,
     /* 389875 */     GIR_EraseRootFromParent_Done,
     /* 389876 */   // Label 7773: @389876
     /* 389876 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(389957), // Rule ID 6092 //
     /* 389881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389929 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389933 */     // MIs[3] Operand 1
     /* 389933 */     // No operand predicates
     /* 389933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389939 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389955 */     GIR_RootConstrainSelectedInstOperands,
     /* 389956 */     // GIR_Coverage, 6092,
     /* 389956 */     GIR_EraseRootFromParent_Done,
     /* 389957 */   // Label 7774: @389957
     /* 389957 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(390026), // Rule ID 2539 //
     /* 389962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389994 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389998 */     // MIs[2] Operand 1
     /* 389998 */     // No operand predicates
     /* 389998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390008 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390024 */     GIR_RootConstrainSelectedInstOperands,
     /* 390025 */     // GIR_Coverage, 2539,
     /* 390025 */     GIR_EraseRootFromParent_Done,
     /* 390026 */   // Label 7775: @390026
     /* 390026 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(390095), // Rule ID 6060 //
     /* 390031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390071 */     // MIs[2] Operand 1
     /* 390071 */     // No operand predicates
     /* 390071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390077 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390093 */     GIR_RootConstrainSelectedInstOperands,
     /* 390094 */     // GIR_Coverage, 6060,
     /* 390094 */     GIR_EraseRootFromParent_Done,
     /* 390095 */   // Label 7776: @390095
     /* 390095 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(390188), // Rule ID 6212 //
     /* 390100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390139 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390151 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390158 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390186 */     GIR_RootConstrainSelectedInstOperands,
     /* 390187 */     // GIR_Coverage, 6212,
     /* 390187 */     GIR_EraseRootFromParent_Done,
     /* 390188 */   // Label 7777: @390188
     /* 390188 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(390287), // Rule ID 6126 //
     /* 390193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390236 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390248 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390285 */     GIR_RootConstrainSelectedInstOperands,
     /* 390286 */     // GIR_Coverage, 6126,
     /* 390286 */     GIR_EraseRootFromParent_Done,
     /* 390287 */   // Label 7778: @390287
     /* 390287 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(390383), // Rule ID 6158 //
     /* 390292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390334 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390381 */     GIR_RootConstrainSelectedInstOperands,
     /* 390382 */     // GIR_Coverage, 6158,
     /* 390382 */     GIR_EraseRootFromParent_Done,
     /* 390383 */   // Label 7779: @390383
     /* 390383 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(390482), // Rule ID 6190 //
     /* 390388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390431 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390480 */     GIR_RootConstrainSelectedInstOperands,
     /* 390481 */     // GIR_Coverage, 6190,
     /* 390481 */     GIR_EraseRootFromParent_Done,
     /* 390482 */   // Label 7780: @390482
     /* 390482 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(390575), // Rule ID 6234 //
     /* 390487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390526 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390538 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390545 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390573 */     GIR_RootConstrainSelectedInstOperands,
     /* 390574 */     // GIR_Coverage, 6234,
     /* 390574 */     GIR_EraseRootFromParent_Done,
     /* 390575 */   // Label 7781: @390575
     /* 390575 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(390671), // Rule ID 6094 //
     /* 390580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390622 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390669 */     GIR_RootConstrainSelectedInstOperands,
     /* 390670 */     // GIR_Coverage, 6094,
     /* 390670 */     GIR_EraseRootFromParent_Done,
     /* 390671 */   // Label 7782: @390671
     /* 390671 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(390755), // Rule ID 2541 //
     /* 390676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390706 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390753 */     GIR_RootConstrainSelectedInstOperands,
     /* 390754 */     // GIR_Coverage, 2541,
     /* 390754 */     GIR_EraseRootFromParent_Done,
     /* 390755 */   // Label 7783: @390755
     /* 390755 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(390805), // Rule ID 13357 //
     /* 390760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390790 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 390793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390803 */     GIR_RootConstrainSelectedInstOperands,
     /* 390804 */     // GIR_Coverage, 13357,
     /* 390804 */     GIR_EraseRootFromParent_Done,
     /* 390805 */   // Label 7784: @390805
     /* 390805 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(390889), // Rule ID 6062 //
     /* 390810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390840 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390887 */     GIR_RootConstrainSelectedInstOperands,
     /* 390888 */     // GIR_Coverage, 6062,
     /* 390888 */     GIR_EraseRootFromParent_Done,
     /* 390889 */   // Label 7785: @390889
     /* 390889 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(390939), // Rule ID 1307 //
     /* 390894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390924 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 390927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390937 */     GIR_RootConstrainSelectedInstOperands,
     /* 390938 */     // GIR_Coverage, 1307,
     /* 390938 */     GIR_EraseRootFromParent_Done,
     /* 390939 */   // Label 7786: @390939
     /* 390939 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(390972), // Rule ID 1297 //
     /* 390944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390959 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 390962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390970 */     GIR_RootConstrainSelectedInstOperands,
     /* 390971 */     // GIR_Coverage, 1297,
     /* 390971 */     GIR_EraseRootFromParent_Done,
     /* 390972 */   // Label 7787: @390972
     /* 390972 */   GIM_Reject,
     /* 390973 */ // Label 7768: @390973
     /* 390973 */ GIM_Reject,
     /* 390974 */ // Label 7672: @390974
     /* 390974 */ GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(392494),
     /* 390979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 390985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 390988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390992 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(391070), // Rule ID 6220 //
     /* 390997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 391034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391038 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391042 */     // MIs[3] Operand 1
     /* 391042 */     // No operand predicates
     /* 391042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391052 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391068 */     GIR_RootConstrainSelectedInstOperands,
     /* 391069 */     // GIR_Coverage, 6220,
     /* 391069 */     GIR_EraseRootFromParent_Done,
     /* 391070 */   // Label 7789: @391070
     /* 391070 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(391154), // Rule ID 6132 //
     /* 391075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391107 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391111 */     // MIs[2] Operand 1
     /* 391111 */     // No operand predicates
     /* 391111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 391115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391134 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391152 */     GIR_RootConstrainSelectedInstOperands,
     /* 391153 */     // GIR_Coverage, 6132,
     /* 391153 */     GIR_EraseRootFromParent_Done,
     /* 391154 */   // Label 7790: @391154
     /* 391154 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(391235), // Rule ID 6164 //
     /* 391159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391203 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391207 */     // MIs[3] Operand 1
     /* 391207 */     // No operand predicates
     /* 391207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391217 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391233 */     GIR_RootConstrainSelectedInstOperands,
     /* 391234 */     // GIR_Coverage, 6164,
     /* 391234 */     GIR_EraseRootFromParent_Done,
     /* 391235 */   // Label 7791: @391235
     /* 391235 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(391319), // Rule ID 6196 //
     /* 391240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391293 */     // MIs[3] Operand 1
     /* 391293 */     // No operand predicates
     /* 391293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391299 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391317 */     GIR_RootConstrainSelectedInstOperands,
     /* 391318 */     // GIR_Coverage, 6196,
     /* 391318 */     GIR_EraseRootFromParent_Done,
     /* 391319 */   // Label 7792: @391319
     /* 391319 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(391397), // Rule ID 6242 //
     /* 391324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 391365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391373 */     // MIs[3] Operand 1
     /* 391373 */     // No operand predicates
     /* 391373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391379 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391395 */     GIR_RootConstrainSelectedInstOperands,
     /* 391396 */     // GIR_Coverage, 6242,
     /* 391396 */     GIR_EraseRootFromParent_Done,
     /* 391397 */   // Label 7793: @391397
     /* 391397 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(391478), // Rule ID 6100 //
     /* 391402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391454 */     // MIs[3] Operand 1
     /* 391454 */     // No operand predicates
     /* 391454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391460 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391476 */     GIR_RootConstrainSelectedInstOperands,
     /* 391477 */     // GIR_Coverage, 6100,
     /* 391477 */     GIR_EraseRootFromParent_Done,
     /* 391478 */   // Label 7794: @391478
     /* 391478 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(391547), // Rule ID 2547 //
     /* 391483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391519 */     // MIs[2] Operand 1
     /* 391519 */     // No operand predicates
     /* 391519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391529 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 391532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391545 */     GIR_RootConstrainSelectedInstOperands,
     /* 391546 */     // GIR_Coverage, 2547,
     /* 391546 */     GIR_EraseRootFromParent_Done,
     /* 391547 */   // Label 7795: @391547
     /* 391547 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(391616), // Rule ID 6068 //
     /* 391552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391588 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391592 */     // MIs[2] Operand 1
     /* 391592 */     // No operand predicates
     /* 391592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391598 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 391601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391614 */     GIR_RootConstrainSelectedInstOperands,
     /* 391615 */     // GIR_Coverage, 6068,
     /* 391615 */     GIR_EraseRootFromParent_Done,
     /* 391616 */   // Label 7796: @391616
     /* 391616 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(391709), // Rule ID 6222 //
     /* 391621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391660 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391707 */     GIR_RootConstrainSelectedInstOperands,
     /* 391708 */     // GIR_Coverage, 6222,
     /* 391708 */     GIR_EraseRootFromParent_Done,
     /* 391709 */   // Label 7797: @391709
     /* 391709 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(391808), // Rule ID 6134 //
     /* 391714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391757 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 391800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391806 */     GIR_RootConstrainSelectedInstOperands,
     /* 391807 */     // GIR_Coverage, 6134,
     /* 391807 */     GIR_EraseRootFromParent_Done,
     /* 391808 */   // Label 7798: @391808
     /* 391808 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(391904), // Rule ID 6166 //
     /* 391813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391855 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391902 */     GIR_RootConstrainSelectedInstOperands,
     /* 391903 */     // GIR_Coverage, 6166,
     /* 391903 */     GIR_EraseRootFromParent_Done,
     /* 391904 */   // Label 7799: @391904
     /* 391904 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(392003), // Rule ID 6198 //
     /* 391909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391952 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392001 */     GIR_RootConstrainSelectedInstOperands,
     /* 392002 */     // GIR_Coverage, 6198,
     /* 392002 */     GIR_EraseRootFromParent_Done,
     /* 392003 */   // Label 7800: @392003
     /* 392003 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(392096), // Rule ID 6244 //
     /* 392008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392047 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 392082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392094 */     GIR_RootConstrainSelectedInstOperands,
     /* 392095 */     // GIR_Coverage, 6244,
     /* 392095 */     GIR_EraseRootFromParent_Done,
     /* 392096 */   // Label 7801: @392096
     /* 392096 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(392192), // Rule ID 6102 //
     /* 392101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 392128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392143 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 392178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392190 */     GIR_RootConstrainSelectedInstOperands,
     /* 392191 */     // GIR_Coverage, 6102,
     /* 392191 */     GIR_EraseRootFromParent_Done,
     /* 392192 */   // Label 7802: @392192
     /* 392192 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(392276), // Rule ID 2549 //
     /* 392197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392227 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392246 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 392262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392274 */     GIR_RootConstrainSelectedInstOperands,
     /* 392275 */     // GIR_Coverage, 2549,
     /* 392275 */     GIR_EraseRootFromParent_Done,
     /* 392276 */   // Label 7803: @392276
     /* 392276 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(392326), // Rule ID 13361 //
     /* 392281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392311 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 392314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392324 */     GIR_RootConstrainSelectedInstOperands,
     /* 392325 */     // GIR_Coverage, 13361,
     /* 392325 */     GIR_EraseRootFromParent_Done,
     /* 392326 */   // Label 7804: @392326
     /* 392326 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(392410), // Rule ID 6070 //
     /* 392331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392361 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 392396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392408 */     GIR_RootConstrainSelectedInstOperands,
     /* 392409 */     // GIR_Coverage, 6070,
     /* 392409 */     GIR_EraseRootFromParent_Done,
     /* 392410 */   // Label 7805: @392410
     /* 392410 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(392460), // Rule ID 1311 //
     /* 392415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392445 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 392448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392458 */     GIR_RootConstrainSelectedInstOperands,
     /* 392459 */     // GIR_Coverage, 1311,
     /* 392459 */     GIR_EraseRootFromParent_Done,
     /* 392460 */   // Label 7806: @392460
     /* 392460 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(392493), // Rule ID 1301 //
     /* 392465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392480 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 392483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 392491 */     GIR_RootConstrainSelectedInstOperands,
     /* 392492 */     // GIR_Coverage, 1301,
     /* 392492 */     GIR_EraseRootFromParent_Done,
     /* 392493 */   // Label 7807: @392493
     /* 392493 */   GIM_Reject,
     /* 392494 */ // Label 7788: @392494
     /* 392494 */ GIM_Reject,
     /* 392495 */ // Label 7673: @392495
     /* 392495 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(393673),
     /* 392500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 392506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 392509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392513 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(392597), // Rule ID 6116 //
     /* 392518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392554 */     // MIs[2] Operand 1
     /* 392554 */     // No operand predicates
     /* 392554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 392558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392562 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392566 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392577 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392595 */     GIR_RootConstrainSelectedInstOperands,
     /* 392596 */     // GIR_Coverage, 6116,
     /* 392596 */     GIR_EraseRootFromParent_Done,
     /* 392597 */   // Label 7809: @392597
     /* 392597 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(392678), // Rule ID 6148 //
     /* 392602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392646 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392650 */     // MIs[3] Operand 1
     /* 392650 */     // No operand predicates
     /* 392650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392660 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392676 */     GIR_RootConstrainSelectedInstOperands,
     /* 392677 */     // GIR_Coverage, 6148,
     /* 392677 */     GIR_EraseRootFromParent_Done,
     /* 392678 */   // Label 7810: @392678
     /* 392678 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(392762), // Rule ID 6180 //
     /* 392683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392732 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392736 */     // MIs[3] Operand 1
     /* 392736 */     // No operand predicates
     /* 392736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392742 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392760 */     GIR_RootConstrainSelectedInstOperands,
     /* 392761 */     // GIR_Coverage, 6180,
     /* 392761 */     GIR_EraseRootFromParent_Done,
     /* 392762 */   // Label 7811: @392762
     /* 392762 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(392843), // Rule ID 6084 //
     /* 392767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392819 */     // MIs[3] Operand 1
     /* 392819 */     // No operand predicates
     /* 392819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392825 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392841 */     GIR_RootConstrainSelectedInstOperands,
     /* 392842 */     // GIR_Coverage, 6084,
     /* 392842 */     GIR_EraseRootFromParent_Done,
     /* 392843 */   // Label 7812: @392843
     /* 392843 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(392912), // Rule ID 2531 //
     /* 392848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392884 */     // MIs[2] Operand 1
     /* 392884 */     // No operand predicates
     /* 392884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392894 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 392897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392910 */     GIR_RootConstrainSelectedInstOperands,
     /* 392911 */     // GIR_Coverage, 2531,
     /* 392911 */     GIR_EraseRootFromParent_Done,
     /* 392912 */   // Label 7813: @392912
     /* 392912 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(392981), // Rule ID 6052 //
     /* 392917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392957 */     // MIs[2] Operand 1
     /* 392957 */     // No operand predicates
     /* 392957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392963 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 392966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392979 */     GIR_RootConstrainSelectedInstOperands,
     /* 392980 */     // GIR_Coverage, 6052,
     /* 392980 */     GIR_EraseRootFromParent_Done,
     /* 392981 */   // Label 7814: @392981
     /* 392981 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(393080), // Rule ID 6118 //
     /* 392986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393029 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 393072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393078 */     GIR_RootConstrainSelectedInstOperands,
     /* 393079 */     // GIR_Coverage, 6118,
     /* 393079 */     GIR_EraseRootFromParent_Done,
     /* 393080 */   // Label 7815: @393080
     /* 393080 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(393176), // Rule ID 6150 //
     /* 393085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393127 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393174 */     GIR_RootConstrainSelectedInstOperands,
     /* 393175 */     // GIR_Coverage, 6150,
     /* 393175 */     GIR_EraseRootFromParent_Done,
     /* 393176 */   // Label 7816: @393176
     /* 393176 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(393275), // Rule ID 6182 //
     /* 393181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393224 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393273 */     GIR_RootConstrainSelectedInstOperands,
     /* 393274 */     // GIR_Coverage, 6182,
     /* 393274 */     GIR_EraseRootFromParent_Done,
     /* 393275 */   // Label 7817: @393275
     /* 393275 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(393371), // Rule ID 6086 //
     /* 393280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393322 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393369 */     GIR_RootConstrainSelectedInstOperands,
     /* 393370 */     // GIR_Coverage, 6086,
     /* 393370 */     GIR_EraseRootFromParent_Done,
     /* 393371 */   // Label 7818: @393371
     /* 393371 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(393455), // Rule ID 2533 //
     /* 393376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393406 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 393441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393453 */     GIR_RootConstrainSelectedInstOperands,
     /* 393454 */     // GIR_Coverage, 2533,
     /* 393454 */     GIR_EraseRootFromParent_Done,
     /* 393455 */   // Label 7819: @393455
     /* 393455 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(393505), // Rule ID 13353 //
     /* 393460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393490 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 393493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393503 */     GIR_RootConstrainSelectedInstOperands,
     /* 393504 */     // GIR_Coverage, 13353,
     /* 393504 */     GIR_EraseRootFromParent_Done,
     /* 393505 */   // Label 7820: @393505
     /* 393505 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(393589), // Rule ID 6054 //
     /* 393510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393540 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 393575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393587 */     GIR_RootConstrainSelectedInstOperands,
     /* 393588 */     // GIR_Coverage, 6054,
     /* 393588 */     GIR_EraseRootFromParent_Done,
     /* 393589 */   // Label 7821: @393589
     /* 393589 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(393639), // Rule ID 1303 //
     /* 393594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393624 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 393627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393637 */     GIR_RootConstrainSelectedInstOperands,
     /* 393638 */     // GIR_Coverage, 1303,
     /* 393638 */     GIR_EraseRootFromParent_Done,
     /* 393639 */   // Label 7822: @393639
     /* 393639 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(393672), // Rule ID 1293 //
     /* 393644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393659 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 393662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 393670 */     GIR_RootConstrainSelectedInstOperands,
     /* 393671 */     // GIR_Coverage, 1293,
     /* 393671 */     GIR_EraseRootFromParent_Done,
     /* 393672 */   // Label 7823: @393672
     /* 393672 */   GIM_Reject,
     /* 393673 */ // Label 7808: @393673
     /* 393673 */ GIM_Reject,
     /* 393674 */ // Label 7674: @393674
     /* 393674 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(395194),
     /* 393679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 393688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393692 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(393770), // Rule ID 6214 //
     /* 393697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 393734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393742 */     // MIs[3] Operand 1
     /* 393742 */     // No operand predicates
     /* 393742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393752 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393768 */     GIR_RootConstrainSelectedInstOperands,
     /* 393769 */     // GIR_Coverage, 6214,
     /* 393769 */     GIR_EraseRootFromParent_Done,
     /* 393770 */   // Label 7825: @393770
     /* 393770 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(393854), // Rule ID 6128 //
     /* 393775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393811 */     // MIs[2] Operand 1
     /* 393811 */     // No operand predicates
     /* 393811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393834 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393852 */     GIR_RootConstrainSelectedInstOperands,
     /* 393853 */     // GIR_Coverage, 6128,
     /* 393853 */     GIR_EraseRootFromParent_Done,
     /* 393854 */   // Label 7826: @393854
     /* 393854 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(393935), // Rule ID 6160 //
     /* 393859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393903 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393907 */     // MIs[3] Operand 1
     /* 393907 */     // No operand predicates
     /* 393907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393917 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393933 */     GIR_RootConstrainSelectedInstOperands,
     /* 393934 */     // GIR_Coverage, 6160,
     /* 393934 */     GIR_EraseRootFromParent_Done,
     /* 393935 */   // Label 7827: @393935
     /* 393935 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(394019), // Rule ID 6192 //
     /* 393940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393993 */     // MIs[3] Operand 1
     /* 393993 */     // No operand predicates
     /* 393993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393999 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394017 */     GIR_RootConstrainSelectedInstOperands,
     /* 394018 */     // GIR_Coverage, 6192,
     /* 394018 */     GIR_EraseRootFromParent_Done,
     /* 394019 */   // Label 7828: @394019
     /* 394019 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(394097), // Rule ID 6236 //
     /* 394024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 394065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394073 */     // MIs[3] Operand 1
     /* 394073 */     // No operand predicates
     /* 394073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394079 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394095 */     GIR_RootConstrainSelectedInstOperands,
     /* 394096 */     // GIR_Coverage, 6236,
     /* 394096 */     GIR_EraseRootFromParent_Done,
     /* 394097 */   // Label 7829: @394097
     /* 394097 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(394178), // Rule ID 6096 //
     /* 394102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394154 */     // MIs[3] Operand 1
     /* 394154 */     // No operand predicates
     /* 394154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394160 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394176 */     GIR_RootConstrainSelectedInstOperands,
     /* 394177 */     // GIR_Coverage, 6096,
     /* 394177 */     GIR_EraseRootFromParent_Done,
     /* 394178 */   // Label 7830: @394178
     /* 394178 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(394247), // Rule ID 2543 //
     /* 394183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394219 */     // MIs[2] Operand 1
     /* 394219 */     // No operand predicates
     /* 394219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394229 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394245 */     GIR_RootConstrainSelectedInstOperands,
     /* 394246 */     // GIR_Coverage, 2543,
     /* 394246 */     GIR_EraseRootFromParent_Done,
     /* 394247 */   // Label 7831: @394247
     /* 394247 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(394316), // Rule ID 6064 //
     /* 394252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394288 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394292 */     // MIs[2] Operand 1
     /* 394292 */     // No operand predicates
     /* 394292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394298 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394314 */     GIR_RootConstrainSelectedInstOperands,
     /* 394315 */     // GIR_Coverage, 6064,
     /* 394315 */     GIR_EraseRootFromParent_Done,
     /* 394316 */   // Label 7832: @394316
     /* 394316 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(394409), // Rule ID 6218 //
     /* 394321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394360 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394407 */     GIR_RootConstrainSelectedInstOperands,
     /* 394408 */     // GIR_Coverage, 6218,
     /* 394408 */     GIR_EraseRootFromParent_Done,
     /* 394409 */   // Label 7833: @394409
     /* 394409 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(394508), // Rule ID 6130 //
     /* 394414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394457 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394469 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 394500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394506 */     GIR_RootConstrainSelectedInstOperands,
     /* 394507 */     // GIR_Coverage, 6130,
     /* 394507 */     GIR_EraseRootFromParent_Done,
     /* 394508 */   // Label 7834: @394508
     /* 394508 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(394604), // Rule ID 6162 //
     /* 394513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394555 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394602 */     GIR_RootConstrainSelectedInstOperands,
     /* 394603 */     // GIR_Coverage, 6162,
     /* 394603 */     GIR_EraseRootFromParent_Done,
     /* 394604 */   // Label 7835: @394604
     /* 394604 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(394703), // Rule ID 6194 //
     /* 394609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394652 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394701 */     GIR_RootConstrainSelectedInstOperands,
     /* 394702 */     // GIR_Coverage, 6194,
     /* 394702 */     GIR_EraseRootFromParent_Done,
     /* 394703 */   // Label 7836: @394703
     /* 394703 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(394796), // Rule ID 6240 //
     /* 394708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394747 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394794 */     GIR_RootConstrainSelectedInstOperands,
     /* 394795 */     // GIR_Coverage, 6240,
     /* 394795 */     GIR_EraseRootFromParent_Done,
     /* 394796 */   // Label 7837: @394796
     /* 394796 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(394892), // Rule ID 6098 //
     /* 394801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394843 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394890 */     GIR_RootConstrainSelectedInstOperands,
     /* 394891 */     // GIR_Coverage, 6098,
     /* 394891 */     GIR_EraseRootFromParent_Done,
     /* 394892 */   // Label 7838: @394892
     /* 394892 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(394976), // Rule ID 2545 //
     /* 394897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394927 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394974 */     GIR_RootConstrainSelectedInstOperands,
     /* 394975 */     // GIR_Coverage, 2545,
     /* 394975 */     GIR_EraseRootFromParent_Done,
     /* 394976 */   // Label 7839: @394976
     /* 394976 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(395026), // Rule ID 13359 //
     /* 394981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395011 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 395014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395024 */     GIR_RootConstrainSelectedInstOperands,
     /* 395025 */     // GIR_Coverage, 13359,
     /* 395025 */     GIR_EraseRootFromParent_Done,
     /* 395026 */   // Label 7840: @395026
     /* 395026 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(395110), // Rule ID 6066 //
     /* 395031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 395046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 395050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395061 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 395083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 395096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395108 */     GIR_RootConstrainSelectedInstOperands,
     /* 395109 */     // GIR_Coverage, 6066,
     /* 395109 */     GIR_EraseRootFromParent_Done,
     /* 395110 */   // Label 7841: @395110
     /* 395110 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(395160), // Rule ID 1309 //
     /* 395115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395145 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 395148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395158 */     GIR_RootConstrainSelectedInstOperands,
     /* 395159 */     // GIR_Coverage, 1309,
     /* 395159 */     GIR_EraseRootFromParent_Done,
     /* 395160 */   // Label 7842: @395160
     /* 395160 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(395193), // Rule ID 1299 //
     /* 395165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395180 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 395183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 395191 */     GIR_RootConstrainSelectedInstOperands,
     /* 395192 */     // GIR_Coverage, 1299,
     /* 395192 */     GIR_EraseRootFromParent_Done,
     /* 395193 */   // Label 7843: @395193
     /* 395193 */   GIM_Reject,
     /* 395194 */ // Label 7824: @395194
     /* 395194 */ GIM_Reject,
     /* 395195 */ // Label 7675: @395195
     /* 395195 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(396373),
     /* 395200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 395209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395213 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(395297), // Rule ID 6112 //
     /* 395218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395254 */     // MIs[2] Operand 1
     /* 395254 */     // No operand predicates
     /* 395254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395277 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 395288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395295 */     GIR_RootConstrainSelectedInstOperands,
     /* 395296 */     // GIR_Coverage, 6112,
     /* 395296 */     GIR_EraseRootFromParent_Done,
     /* 395297 */   // Label 7845: @395297
     /* 395297 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(395378), // Rule ID 6144 //
     /* 395302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395346 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395350 */     // MIs[3] Operand 1
     /* 395350 */     // No operand predicates
     /* 395350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395360 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395376 */     GIR_RootConstrainSelectedInstOperands,
     /* 395377 */     // GIR_Coverage, 6144,
     /* 395377 */     GIR_EraseRootFromParent_Done,
     /* 395378 */   // Label 7846: @395378
     /* 395378 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(395462), // Rule ID 6176 //
     /* 395383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395432 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395436 */     // MIs[3] Operand 1
     /* 395436 */     // No operand predicates
     /* 395436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395442 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395460 */     GIR_RootConstrainSelectedInstOperands,
     /* 395461 */     // GIR_Coverage, 6176,
     /* 395461 */     GIR_EraseRootFromParent_Done,
     /* 395462 */   // Label 7847: @395462
     /* 395462 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(395543), // Rule ID 6080 //
     /* 395467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395515 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395519 */     // MIs[3] Operand 1
     /* 395519 */     // No operand predicates
     /* 395519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395525 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395541 */     GIR_RootConstrainSelectedInstOperands,
     /* 395542 */     // GIR_Coverage, 6080,
     /* 395542 */     GIR_EraseRootFromParent_Done,
     /* 395543 */   // Label 7848: @395543
     /* 395543 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(395612), // Rule ID 2527 //
     /* 395548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395584 */     // MIs[2] Operand 1
     /* 395584 */     // No operand predicates
     /* 395584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395594 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 395597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395610 */     GIR_RootConstrainSelectedInstOperands,
     /* 395611 */     // GIR_Coverage, 2527,
     /* 395611 */     GIR_EraseRootFromParent_Done,
     /* 395612 */   // Label 7849: @395612
     /* 395612 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(395681), // Rule ID 6048 //
     /* 395617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395657 */     // MIs[2] Operand 1
     /* 395657 */     // No operand predicates
     /* 395657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395663 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 395666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395679 */     GIR_RootConstrainSelectedInstOperands,
     /* 395680 */     // GIR_Coverage, 6048,
     /* 395680 */     GIR_EraseRootFromParent_Done,
     /* 395681 */   // Label 7850: @395681
     /* 395681 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(395780), // Rule ID 6114 //
     /* 395686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 395697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395729 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 395772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395778 */     GIR_RootConstrainSelectedInstOperands,
     /* 395779 */     // GIR_Coverage, 6114,
     /* 395779 */     GIR_EraseRootFromParent_Done,
     /* 395780 */   // Label 7851: @395780
     /* 395780 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(395876), // Rule ID 6146 //
     /* 395785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 395808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395827 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395874 */     GIR_RootConstrainSelectedInstOperands,
     /* 395875 */     // GIR_Coverage, 6146,
     /* 395875 */     GIR_EraseRootFromParent_Done,
     /* 395876 */   // Label 7852: @395876
     /* 395876 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(395975), // Rule ID 6178 //
     /* 395881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 395909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395924 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395973 */     GIR_RootConstrainSelectedInstOperands,
     /* 395974 */     // GIR_Coverage, 6178,
     /* 395974 */     GIR_EraseRootFromParent_Done,
     /* 395975 */   // Label 7853: @395975
     /* 395975 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(396071), // Rule ID 6082 //
     /* 395980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 396007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396022 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 396057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396069 */     GIR_RootConstrainSelectedInstOperands,
     /* 396070 */     // GIR_Coverage, 6082,
     /* 396070 */     GIR_EraseRootFromParent_Done,
     /* 396071 */   // Label 7854: @396071
     /* 396071 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(396155), // Rule ID 2529 //
     /* 396076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 396087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396106 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 396141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396153 */     GIR_RootConstrainSelectedInstOperands,
     /* 396154 */     // GIR_Coverage, 2529,
     /* 396154 */     GIR_EraseRootFromParent_Done,
     /* 396155 */   // Label 7855: @396155
     /* 396155 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(396205), // Rule ID 13355 //
     /* 396160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 396171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396190 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 396193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396203 */     GIR_RootConstrainSelectedInstOperands,
     /* 396204 */     // GIR_Coverage, 13355,
     /* 396204 */     GIR_EraseRootFromParent_Done,
     /* 396205 */   // Label 7856: @396205
     /* 396205 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(396289), // Rule ID 6050 //
     /* 396210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 396225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396240 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 396275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396287 */     GIR_RootConstrainSelectedInstOperands,
     /* 396288 */     // GIR_Coverage, 6050,
     /* 396288 */     GIR_EraseRootFromParent_Done,
     /* 396289 */   // Label 7857: @396289
     /* 396289 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(396339), // Rule ID 1305 //
     /* 396294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 396309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396324 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 396327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396337 */     GIR_RootConstrainSelectedInstOperands,
     /* 396338 */     // GIR_Coverage, 1305,
     /* 396338 */     GIR_EraseRootFromParent_Done,
     /* 396339 */   // Label 7858: @396339
     /* 396339 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(396372), // Rule ID 1295 //
     /* 396344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396359 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 396362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 396370 */     GIR_RootConstrainSelectedInstOperands,
     /* 396371 */     // GIR_Coverage, 1295,
     /* 396371 */     GIR_EraseRootFromParent_Done,
     /* 396372 */   // Label 7859: @396372
     /* 396372 */   GIM_Reject,
     /* 396373 */ // Label 7844: @396373
     /* 396373 */ GIM_Reject,
     /* 396374 */ // Label 7676: @396374
     /* 396374 */ GIM_Reject,
     /* 396375 */ // Label 108: @396375
     /* 396375 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7868*/ GIMT_Encode4(396674),
     /* 396386 */ /*GILLT_s16*//*Label 7860*/ GIMT_Encode4(396426),
     /* 396390 */ /*GILLT_s32*//*Label 7861*/ GIMT_Encode4(396457),
     /* 396394 */ /*GILLT_s64*//*Label 7862*/ GIMT_Encode4(396488), GIMT_Encode4(0),
     /* 396402 */ /*GILLT_v2s32*//*Label 7863*/ GIMT_Encode4(396519),
     /* 396406 */ /*GILLT_v2s64*//*Label 7864*/ GIMT_Encode4(396550),
     /* 396410 */ /*GILLT_v4s16*//*Label 7865*/ GIMT_Encode4(396581),
     /* 396414 */ /*GILLT_v4s32*//*Label 7866*/ GIMT_Encode4(396612), GIMT_Encode4(0),
     /* 396422 */ /*GILLT_v8s16*//*Label 7867*/ GIMT_Encode4(396643),
     /* 396426 */ // Label 7860: @396426
     /* 396426 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(396456), // Rule ID 569 //
     /* 396431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396445 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 396450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396454 */   GIR_RootConstrainSelectedInstOperands,
     /* 396455 */   // GIR_Coverage, 569,
     /* 396455 */   GIR_Done,
     /* 396456 */ // Label 7869: @396456
     /* 396456 */ GIM_Reject,
     /* 396457 */ // Label 7861: @396457
     /* 396457 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(396487), // Rule ID 571 //
     /* 396462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396476 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 396481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396485 */   GIR_RootConstrainSelectedInstOperands,
     /* 396486 */   // GIR_Coverage, 571,
     /* 396486 */   GIR_Done,
     /* 396487 */ // Label 7870: @396487
     /* 396487 */ GIM_Reject,
     /* 396488 */ // Label 7862: @396488
     /* 396488 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(396518), // Rule ID 573 //
     /* 396493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396507 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 396507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 396512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396516 */   GIR_RootConstrainSelectedInstOperands,
     /* 396517 */   // GIR_Coverage, 573,
     /* 396517 */   GIR_Done,
     /* 396518 */ // Label 7871: @396518
     /* 396518 */ GIM_Reject,
     /* 396519 */ // Label 7863: @396519
     /* 396519 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(396549), // Rule ID 959 //
     /* 396524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396538 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 396543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396547 */   GIR_RootConstrainSelectedInstOperands,
     /* 396548 */   // GIR_Coverage, 959,
     /* 396548 */   GIR_Done,
     /* 396549 */ // Label 7872: @396549
     /* 396549 */ GIM_Reject,
     /* 396550 */ // Label 7864: @396550
     /* 396550 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(396580), // Rule ID 963 //
     /* 396555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396569 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 396574 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396578 */   GIR_RootConstrainSelectedInstOperands,
     /* 396579 */   // GIR_Coverage, 963,
     /* 396579 */   GIR_Done,
     /* 396580 */ // Label 7873: @396580
     /* 396580 */ GIM_Reject,
     /* 396581 */ // Label 7865: @396581
     /* 396581 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(396611), // Rule ID 955 //
     /* 396586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396600 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 396605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396609 */   GIR_RootConstrainSelectedInstOperands,
     /* 396610 */   // GIR_Coverage, 955,
     /* 396610 */   GIR_Done,
     /* 396611 */ // Label 7874: @396611
     /* 396611 */ GIM_Reject,
     /* 396612 */ // Label 7866: @396612
     /* 396612 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(396642), // Rule ID 961 //
     /* 396617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396631 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 396636 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396640 */   GIR_RootConstrainSelectedInstOperands,
     /* 396641 */   // GIR_Coverage, 961,
     /* 396641 */   GIR_Done,
     /* 396642 */ // Label 7875: @396642
     /* 396642 */ GIM_Reject,
     /* 396643 */ // Label 7867: @396643
     /* 396643 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(396673), // Rule ID 957 //
     /* 396648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396662 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 396667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396671 */   GIR_RootConstrainSelectedInstOperands,
     /* 396672 */   // GIR_Coverage, 957,
     /* 396672 */   GIR_Done,
     /* 396673 */ // Label 7876: @396673
     /* 396673 */ GIM_Reject,
     /* 396674 */ // Label 7868: @396674
     /* 396674 */ GIM_Reject,
     /* 396675 */ // Label 109: @396675
     /* 396675 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(396688), // Rule ID 6527 //
     /* 396680 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 396680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 396686 */   GIR_RootConstrainSelectedInstOperands,
     /* 396687 */   // GIR_Coverage, 6527,
     /* 396687 */   GIR_EraseRootFromParent_Done,
     /* 396688 */ // Label 7877: @396688
     /* 396688 */ GIM_Reject,
     /* 396689 */ // Label 110: @396689
     /* 396689 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(396709), // Rule ID 6528 //
     /* 396694 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 396694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396697 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 396707 */   GIR_RootConstrainSelectedInstOperands,
     /* 396708 */   // GIR_Coverage, 6528,
     /* 396708 */   GIR_EraseRootFromParent_Done,
     /* 396709 */ // Label 7878: @396709
     /* 396709 */ GIM_Reject,
     /* 396710 */ // Label 111: @396710
     /* 396710 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(396734), // Rule ID 6529 //
     /* 396715 */   // MIs[0] kind
     /* 396715 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 396718 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 396723 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 396723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396726 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 396732 */   GIR_RootConstrainSelectedInstOperands,
     /* 396733 */   // GIR_Coverage, 6529,
     /* 396733 */   GIR_EraseRootFromParent_Done,
     /* 396734 */ // Label 7879: @396734
     /* 396734 */ GIM_Reject,
     /* 396735 */ // Label 112: @396735
     /* 396735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7883*/ GIMT_Encode4(397044),
     /* 396746 */ /*GILLT_s16*//*Label 7880*/ GIMT_Encode4(396758),
     /* 396750 */ /*GILLT_s32*//*Label 7881*/ GIMT_Encode4(396911),
     /* 396754 */ /*GILLT_s64*//*Label 7882*/ GIMT_Encode4(397016),
     /* 396758 */ // Label 7880: @396758
     /* 396758 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(396859), // Rule ID 5606 //
     /* 396763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396777 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 396777 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 396780 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 396784 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396789 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396793 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396799 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396802 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 396806 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396811 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 396814 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396832 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 396839 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396844 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396857 */   GIR_RootConstrainSelectedInstOperands,
     /* 396858 */   // GIR_Coverage, 5606,
     /* 396858 */   GIR_EraseRootFromParent_Done,
     /* 396859 */ // Label 7884: @396859
     /* 396859 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(396910), // Rule ID 5607 //
     /* 396864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396878 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 396878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 396885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396894 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396908 */   GIR_RootConstrainSelectedInstOperands,
     /* 396909 */   // GIR_Coverage, 5607,
     /* 396909 */   GIR_EraseRootFromParent_Done,
     /* 396910 */ // Label 7885: @396910
     /* 396910 */ GIM_Reject,
     /* 396911 */ // Label 7881: @396911
     /* 396911 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(396988), // Rule ID 5608 //
     /* 396916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396927 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 396927 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396930 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 396934 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396939 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396943 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396961 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 396968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 396981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396986 */   GIR_RootConstrainSelectedInstOperands,
     /* 396987 */   // GIR_Coverage, 5608,
     /* 396987 */   GIR_EraseRootFromParent_Done,
     /* 396988 */ // Label 7886: @396988
     /* 396988 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(397015), // Rule ID 5609 //
     /* 396993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397004 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397009 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397013 */   GIR_RootConstrainSelectedInstOperands,
     /* 397014 */   // GIR_Coverage, 5609,
     /* 397014 */   GIR_Done,
     /* 397015 */ // Label 7887: @397015
     /* 397015 */ GIM_Reject,
     /* 397016 */ // Label 7882: @397016
     /* 397016 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(397043), // Rule ID 5610 //
     /* 397021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397032 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397041 */   GIR_RootConstrainSelectedInstOperands,
     /* 397042 */   // GIR_Coverage, 5610,
     /* 397042 */   GIR_Done,
     /* 397043 */ // Label 7888: @397043
     /* 397043 */ GIM_Reject,
     /* 397044 */ // Label 7883: @397044
     /* 397044 */ GIM_Reject,
     /* 397045 */ // Label 113: @397045
     /* 397045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7892*/ GIMT_Encode4(397215),
     /* 397056 */ /*GILLT_s16*//*Label 7889*/ GIMT_Encode4(397068),
     /* 397060 */ /*GILLT_s32*//*Label 7890*/ GIMT_Encode4(397129),
     /* 397064 */ /*GILLT_s64*//*Label 7891*/ GIMT_Encode4(397187),
     /* 397068 */ // Label 7889: @397068
     /* 397068 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(397098), // Rule ID 1942 //
     /* 397073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397087 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 397092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397096 */   GIR_RootConstrainSelectedInstOperands,
     /* 397097 */   // GIR_Coverage, 1942,
     /* 397097 */   GIR_Done,
     /* 397098 */ // Label 7893: @397098
     /* 397098 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(397128), // Rule ID 1944 //
     /* 397103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397117 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 397122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397126 */   GIR_RootConstrainSelectedInstOperands,
     /* 397127 */   // GIR_Coverage, 1944,
     /* 397127 */   GIR_Done,
     /* 397128 */ // Label 7894: @397128
     /* 397128 */ GIM_Reject,
     /* 397129 */ // Label 7890: @397129
     /* 397129 */ GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(397159), // Rule ID 1946 //
     /* 397134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397148 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 397153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397157 */   GIR_RootConstrainSelectedInstOperands,
     /* 397158 */   // GIR_Coverage, 1946,
     /* 397158 */   GIR_Done,
     /* 397159 */ // Label 7895: @397159
     /* 397159 */ GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(397186), // Rule ID 5616 //
     /* 397164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397175 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 397180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397184 */   GIR_RootConstrainSelectedInstOperands,
     /* 397185 */   // GIR_Coverage, 5616,
     /* 397185 */   GIR_Done,
     /* 397186 */ // Label 7896: @397186
     /* 397186 */ GIM_Reject,
     /* 397187 */ // Label 7891: @397187
     /* 397187 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(397214), // Rule ID 5618 //
     /* 397192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397203 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 397208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397212 */   GIR_RootConstrainSelectedInstOperands,
     /* 397213 */   // GIR_Coverage, 5618,
     /* 397213 */   GIR_Done,
     /* 397214 */ // Label 7897: @397214
     /* 397214 */ GIM_Reject,
     /* 397215 */ // Label 7892: @397215
     /* 397215 */ GIM_Reject,
     /* 397216 */ // Label 114: @397216
     /* 397216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7901*/ GIMT_Encode4(397386),
     /* 397227 */ /*GILLT_s16*//*Label 7898*/ GIMT_Encode4(397239),
     /* 397231 */ /*GILLT_s32*//*Label 7899*/ GIMT_Encode4(397300),
     /* 397235 */ /*GILLT_s64*//*Label 7900*/ GIMT_Encode4(397358),
     /* 397239 */ // Label 7898: @397239
     /* 397239 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(397269), // Rule ID 1954 //
     /* 397244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397258 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 397263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397267 */   GIR_RootConstrainSelectedInstOperands,
     /* 397268 */   // GIR_Coverage, 1954,
     /* 397268 */   GIR_Done,
     /* 397269 */ // Label 7902: @397269
     /* 397269 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(397299), // Rule ID 1956 //
     /* 397274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397288 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 397293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397297 */   GIR_RootConstrainSelectedInstOperands,
     /* 397298 */   // GIR_Coverage, 1956,
     /* 397298 */   GIR_Done,
     /* 397299 */ // Label 7903: @397299
     /* 397299 */ GIM_Reject,
     /* 397300 */ // Label 7899: @397300
     /* 397300 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(397330), // Rule ID 1958 //
     /* 397305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397319 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 397324 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397328 */   GIR_RootConstrainSelectedInstOperands,
     /* 397329 */   // GIR_Coverage, 1958,
     /* 397329 */   GIR_Done,
     /* 397330 */ // Label 7904: @397330
     /* 397330 */ GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(397357), // Rule ID 5624 //
     /* 397335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397346 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 397351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397355 */   GIR_RootConstrainSelectedInstOperands,
     /* 397356 */   // GIR_Coverage, 5624,
     /* 397356 */   GIR_Done,
     /* 397357 */ // Label 7905: @397357
     /* 397357 */ GIM_Reject,
     /* 397358 */ // Label 7900: @397358
     /* 397358 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(397385), // Rule ID 5626 //
     /* 397363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397374 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 397379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397383 */   GIR_RootConstrainSelectedInstOperands,
     /* 397384 */   // GIR_Coverage, 5626,
     /* 397384 */   GIR_Done,
     /* 397385 */ // Label 7906: @397385
     /* 397385 */ GIM_Reject,
     /* 397386 */ // Label 7901: @397386
     /* 397386 */ GIM_Reject,
     /* 397387 */ // Label 115: @397387
     /* 397387 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7910*/ GIMT_Encode4(397557),
     /* 397398 */ /*GILLT_s16*//*Label 7907*/ GIMT_Encode4(397410),
     /* 397402 */ /*GILLT_s32*//*Label 7908*/ GIMT_Encode4(397471),
     /* 397406 */ /*GILLT_s64*//*Label 7909*/ GIMT_Encode4(397529),
     /* 397410 */ // Label 7907: @397410
     /* 397410 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(397440), // Rule ID 1948 //
     /* 397415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397429 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 397434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397438 */   GIR_RootConstrainSelectedInstOperands,
     /* 397439 */   // GIR_Coverage, 1948,
     /* 397439 */   GIR_Done,
     /* 397440 */ // Label 7911: @397440
     /* 397440 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(397470), // Rule ID 1950 //
     /* 397445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397459 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 397464 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397468 */   GIR_RootConstrainSelectedInstOperands,
     /* 397469 */   // GIR_Coverage, 1950,
     /* 397469 */   GIR_Done,
     /* 397470 */ // Label 7912: @397470
     /* 397470 */ GIM_Reject,
     /* 397471 */ // Label 7908: @397471
     /* 397471 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(397501), // Rule ID 1952 //
     /* 397476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397490 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 397495 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397499 */   GIR_RootConstrainSelectedInstOperands,
     /* 397500 */   // GIR_Coverage, 1952,
     /* 397500 */   GIR_Done,
     /* 397501 */ // Label 7913: @397501
     /* 397501 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(397528), // Rule ID 5620 //
     /* 397506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397517 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 397522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397526 */   GIR_RootConstrainSelectedInstOperands,
     /* 397527 */   // GIR_Coverage, 5620,
     /* 397527 */   GIR_Done,
     /* 397528 */ // Label 7914: @397528
     /* 397528 */ GIM_Reject,
     /* 397529 */ // Label 7909: @397529
     /* 397529 */ GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(397556), // Rule ID 5622 //
     /* 397534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397545 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 397550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397554 */   GIR_RootConstrainSelectedInstOperands,
     /* 397555 */   // GIR_Coverage, 5622,
     /* 397555 */   GIR_Done,
     /* 397556 */ // Label 7915: @397556
     /* 397556 */ GIM_Reject,
     /* 397557 */ // Label 7910: @397557
     /* 397557 */ GIM_Reject,
     /* 397558 */ // Label 116: @397558
     /* 397558 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7919*/ GIMT_Encode4(397728),
     /* 397569 */ /*GILLT_s16*//*Label 7916*/ GIMT_Encode4(397581),
     /* 397573 */ /*GILLT_s32*//*Label 7917*/ GIMT_Encode4(397642),
     /* 397577 */ /*GILLT_s64*//*Label 7918*/ GIMT_Encode4(397700),
     /* 397581 */ // Label 7916: @397581
     /* 397581 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(397611), // Rule ID 1960 //
     /* 397586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397600 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 397605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397609 */   GIR_RootConstrainSelectedInstOperands,
     /* 397610 */   // GIR_Coverage, 1960,
     /* 397610 */   GIR_Done,
     /* 397611 */ // Label 7920: @397611
     /* 397611 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(397641), // Rule ID 1962 //
     /* 397616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397630 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 397635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397639 */   GIR_RootConstrainSelectedInstOperands,
     /* 397640 */   // GIR_Coverage, 1962,
     /* 397640 */   GIR_Done,
     /* 397641 */ // Label 7921: @397641
     /* 397641 */ GIM_Reject,
     /* 397642 */ // Label 7917: @397642
     /* 397642 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(397672), // Rule ID 1964 //
     /* 397647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397661 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 397666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397670 */   GIR_RootConstrainSelectedInstOperands,
     /* 397671 */   // GIR_Coverage, 1964,
     /* 397671 */   GIR_Done,
     /* 397672 */ // Label 7922: @397672
     /* 397672 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(397699), // Rule ID 5628 //
     /* 397677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397688 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 397693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397697 */   GIR_RootConstrainSelectedInstOperands,
     /* 397698 */   // GIR_Coverage, 5628,
     /* 397698 */   GIR_Done,
     /* 397699 */ // Label 7923: @397699
     /* 397699 */ GIM_Reject,
     /* 397700 */ // Label 7918: @397700
     /* 397700 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(397727), // Rule ID 5630 //
     /* 397705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397716 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 397721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397725 */   GIR_RootConstrainSelectedInstOperands,
     /* 397726 */   // GIR_Coverage, 5630,
     /* 397726 */   GIR_Done,
     /* 397727 */ // Label 7924: @397727
     /* 397727 */ GIM_Reject,
     /* 397728 */ // Label 7919: @397728
     /* 397728 */ GIM_Reject,
     /* 397729 */ // Label 117: @397729
     /* 397729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7929*/ GIMT_Encode4(398857),
     /* 397740 */ /*GILLT_s8*//*Label 7925*/ GIMT_Encode4(397756),
     /* 397744 */ /*GILLT_s16*//*Label 7926*/ GIMT_Encode4(397803),
     /* 397748 */ /*GILLT_s32*//*Label 7927*/ GIMT_Encode4(398218),
     /* 397752 */ /*GILLT_s64*//*Label 7928*/ GIMT_Encode4(398671),
     /* 397756 */ // Label 7925: @397756
     /* 397756 */ GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(397779), // Rule ID 5901 //
     /* 397761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397772 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 397772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 397777 */   GIR_RootConstrainSelectedInstOperands,
     /* 397778 */   // GIR_Coverage, 5901,
     /* 397778 */   GIR_Done,
     /* 397779 */ // Label 7930: @397779
     /* 397779 */ GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(397802), // Rule ID 5902 //
     /* 397784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397795 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 397795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 397800 */   GIR_RootConstrainSelectedInstOperands,
     /* 397801 */   // GIR_Coverage, 5902,
     /* 397801 */   GIR_Done,
     /* 397802 */ // Label 7931: @397802
     /* 397802 */ GIM_Reject,
     /* 397803 */ // Label 7926: @397803
     /* 397803 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(397853), // Rule ID 5848 //
     /* 397808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397823 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397826 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 397831 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397842 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 397842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 397845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397847 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397851 */   GIR_RootConstrainSelectedInstOperands,
     /* 397852 */   // GIR_Coverage, 5848,
     /* 397852 */   GIR_EraseRootFromParent_Done,
     /* 397853 */ // Label 7932: @397853
     /* 397853 */ GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(397903), // Rule ID 5850 //
     /* 397858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397873 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397876 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 397881 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397885 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397892 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 397892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 397895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397901 */   GIR_RootConstrainSelectedInstOperands,
     /* 397902 */   // GIR_Coverage, 5850,
     /* 397902 */   GIR_EraseRootFromParent_Done,
     /* 397903 */ // Label 7933: @397903
     /* 397903 */ GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(397953), // Rule ID 5858 //
     /* 397908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397923 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397926 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 397931 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397935 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397942 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 397942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 397945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397947 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397951 */   GIR_RootConstrainSelectedInstOperands,
     /* 397952 */   // GIR_Coverage, 5858,
     /* 397952 */   GIR_EraseRootFromParent_Done,
     /* 397953 */ // Label 7934: @397953
     /* 397953 */ GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(398003), // Rule ID 5860 //
     /* 397958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397973 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397976 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 397981 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397985 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397990 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397992 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 397992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 397995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398001 */   GIR_RootConstrainSelectedInstOperands,
     /* 398002 */   // GIR_Coverage, 5860,
     /* 398002 */   GIR_EraseRootFromParent_Done,
     /* 398003 */ // Label 7935: @398003
     /* 398003 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(398045), // Rule ID 5857 //
     /* 398008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398015 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398019 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398023 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398034 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 398037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398039 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398043 */   GIR_RootConstrainSelectedInstOperands,
     /* 398044 */   // GIR_Coverage, 5857,
     /* 398044 */   GIR_EraseRootFromParent_Done,
     /* 398045 */ // Label 7936: @398045
     /* 398045 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(398087), // Rule ID 5859 //
     /* 398050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398065 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398069 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398076 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 398079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398081 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398085 */   GIR_RootConstrainSelectedInstOperands,
     /* 398086 */   // GIR_Coverage, 5859,
     /* 398086 */   GIR_EraseRootFromParent_Done,
     /* 398087 */ // Label 7937: @398087
     /* 398087 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(398129), // Rule ID 5847 //
     /* 398092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398118 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 398121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398123 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398127 */   GIR_RootConstrainSelectedInstOperands,
     /* 398128 */   // GIR_Coverage, 5847,
     /* 398128 */   GIR_EraseRootFromParent_Done,
     /* 398129 */ // Label 7938: @398129
     /* 398129 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(398171), // Rule ID 5849 //
     /* 398134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398153 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398160 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 398163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398165 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398169 */   GIR_RootConstrainSelectedInstOperands,
     /* 398170 */   // GIR_Coverage, 5849,
     /* 398170 */   GIR_EraseRootFromParent_Done,
     /* 398171 */ // Label 7939: @398171
     /* 398171 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(398194), // Rule ID 5903 //
     /* 398176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398187 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 398187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 398192 */   GIR_RootConstrainSelectedInstOperands,
     /* 398193 */   // GIR_Coverage, 5903,
     /* 398193 */   GIR_Done,
     /* 398194 */ // Label 7940: @398194
     /* 398194 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(398217), // Rule ID 5904 //
     /* 398199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398210 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 398210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 398215 */   GIR_RootConstrainSelectedInstOperands,
     /* 398216 */   // GIR_Coverage, 5904,
     /* 398216 */   GIR_Done,
     /* 398217 */ // Label 7941: @398217
     /* 398217 */ GIM_Reject,
     /* 398218 */ // Label 7927: @398218
     /* 398218 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(398268), // Rule ID 5852 //
     /* 398223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398238 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398241 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398257 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398262 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398266 */   GIR_RootConstrainSelectedInstOperands,
     /* 398267 */   // GIR_Coverage, 5852,
     /* 398267 */   GIR_EraseRootFromParent_Done,
     /* 398268 */ // Label 7942: @398268
     /* 398268 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(398318), // Rule ID 5854 //
     /* 398273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398280 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398284 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398288 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398291 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398296 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398300 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398307 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 398310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398312 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398316 */   GIR_RootConstrainSelectedInstOperands,
     /* 398317 */   // GIR_Coverage, 5854,
     /* 398317 */   GIR_EraseRootFromParent_Done,
     /* 398318 */ // Label 7943: @398318
     /* 398318 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(398368), // Rule ID 5862 //
     /* 398323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398338 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398341 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398350 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398357 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 398360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398362 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398366 */   GIR_RootConstrainSelectedInstOperands,
     /* 398367 */   // GIR_Coverage, 5862,
     /* 398367 */   GIR_EraseRootFromParent_Done,
     /* 398368 */ // Label 7944: @398368
     /* 398368 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(398418), // Rule ID 5864 //
     /* 398373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398388 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398391 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398396 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398400 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398407 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 398410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398412 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398416 */   GIR_RootConstrainSelectedInstOperands,
     /* 398417 */   // GIR_Coverage, 5864,
     /* 398417 */   GIR_EraseRootFromParent_Done,
     /* 398418 */ // Label 7945: @398418
     /* 398418 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(398460), // Rule ID 5861 //
     /* 398423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398438 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398449 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 398452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398458 */   GIR_RootConstrainSelectedInstOperands,
     /* 398459 */   // GIR_Coverage, 5861,
     /* 398459 */   GIR_EraseRootFromParent_Done,
     /* 398460 */ // Label 7946: @398460
     /* 398460 */ GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(398502), // Rule ID 5863 //
     /* 398465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398480 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398484 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398491 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 398494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398496 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398500 */   GIR_RootConstrainSelectedInstOperands,
     /* 398501 */   // GIR_Coverage, 5863,
     /* 398501 */   GIR_EraseRootFromParent_Done,
     /* 398502 */ // Label 7947: @398502
     /* 398502 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(398544), // Rule ID 5851 //
     /* 398507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398522 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398533 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398538 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398542 */   GIR_RootConstrainSelectedInstOperands,
     /* 398543 */   // GIR_Coverage, 5851,
     /* 398543 */   GIR_EraseRootFromParent_Done,
     /* 398544 */ // Label 7948: @398544
     /* 398544 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(398586), // Rule ID 5853 //
     /* 398549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398568 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398575 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 398578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398584 */   GIR_RootConstrainSelectedInstOperands,
     /* 398585 */   // GIR_Coverage, 5853,
     /* 398585 */   GIR_EraseRootFromParent_Done,
     /* 398586 */ // Label 7949: @398586
     /* 398586 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(398647), // Rule ID 5905 //
     /* 398591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398602 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 398602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 398609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398614 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398629 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 398636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398646 */   // GIR_Coverage, 5905,
     /* 398646 */   GIR_EraseRootFromParent_Done,
     /* 398647 */ // Label 7950: @398647
     /* 398647 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(398670), // Rule ID 5906 //
     /* 398652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398663 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 398668 */   GIR_RootConstrainSelectedInstOperands,
     /* 398669 */   // GIR_Coverage, 5906,
     /* 398669 */   GIR_Done,
     /* 398670 */ // Label 7951: @398670
     /* 398670 */ GIM_Reject,
     /* 398671 */ // Label 7928: @398671
     /* 398671 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(398856),
     /* 398676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398683 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(398726), // Rule ID 5856 //
     /* 398688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398715 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 398718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398724 */     GIR_RootConstrainSelectedInstOperands,
     /* 398725 */     // GIR_Coverage, 5856,
     /* 398725 */     GIR_EraseRootFromParent_Done,
     /* 398726 */   // Label 7953: @398726
     /* 398726 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(398769), // Rule ID 5866 //
     /* 398731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398739 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398742 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398758 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 398761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398767 */     GIR_RootConstrainSelectedInstOperands,
     /* 398768 */     // GIR_Coverage, 5866,
     /* 398768 */     GIR_EraseRootFromParent_Done,
     /* 398769 */   // Label 7954: @398769
     /* 398769 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(398804), // Rule ID 5865 //
     /* 398774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398793 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 398796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398802 */     GIR_RootConstrainSelectedInstOperands,
     /* 398803 */     // GIR_Coverage, 5865,
     /* 398803 */     GIR_EraseRootFromParent_Done,
     /* 398804 */   // Label 7955: @398804
     /* 398804 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(398839), // Rule ID 5855 //
     /* 398809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398828 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 398831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398837 */     GIR_RootConstrainSelectedInstOperands,
     /* 398838 */     // GIR_Coverage, 5855,
     /* 398838 */     GIR_EraseRootFromParent_Done,
     /* 398839 */   // Label 7956: @398839
     /* 398839 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(398855), // Rule ID 5907 //
     /* 398844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398848 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 398848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 398853 */     GIR_RootConstrainSelectedInstOperands,
     /* 398854 */     // GIR_Coverage, 5907,
     /* 398854 */     GIR_Done,
     /* 398855 */   // Label 7957: @398855
     /* 398855 */   GIM_Reject,
     /* 398856 */ // Label 7952: @398856
     /* 398856 */ GIM_Reject,
     /* 398857 */ // Label 7929: @398857
     /* 398857 */ GIM_Reject,
     /* 398858 */ // Label 118: @398858
     /* 398858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7961*/ GIMT_Encode4(399060),
     /* 398869 */ /*GILLT_s8*//*Label 7958*/ GIMT_Encode4(398881),
     /* 398873 */ /*GILLT_s16*//*Label 7959*/ GIMT_Encode4(398928),
     /* 398877 */ /*GILLT_s32*//*Label 7960*/ GIMT_Encode4(398975),
     /* 398881 */ // Label 7958: @398881
     /* 398881 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(398904), // Rule ID 5998 //
     /* 398886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 398893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398897 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 398897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 398902 */   GIR_RootConstrainSelectedInstOperands,
     /* 398903 */   // GIR_Coverage, 5998,
     /* 398903 */   GIR_Done,
     /* 398904 */ // Label 7962: @398904
     /* 398904 */ GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(398927), // Rule ID 5999 //
     /* 398909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 398916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398920 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 398920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 398925 */   GIR_RootConstrainSelectedInstOperands,
     /* 398926 */   // GIR_Coverage, 5999,
     /* 398926 */   GIR_Done,
     /* 398927 */ // Label 7963: @398927
     /* 398927 */ GIM_Reject,
     /* 398928 */ // Label 7959: @398928
     /* 398928 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(398951), // Rule ID 6000 //
     /* 398933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398944 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 398944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 398949 */   GIR_RootConstrainSelectedInstOperands,
     /* 398950 */   // GIR_Coverage, 6000,
     /* 398950 */   GIR_Done,
     /* 398951 */ // Label 7964: @398951
     /* 398951 */ GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(398974), // Rule ID 6001 //
     /* 398956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398967 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 398967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 398972 */   GIR_RootConstrainSelectedInstOperands,
     /* 398973 */   // GIR_Coverage, 6001,
     /* 398973 */   GIR_Done,
     /* 398974 */ // Label 7965: @398974
     /* 398974 */ GIM_Reject,
     /* 398975 */ // Label 7960: @398975
     /* 398975 */ GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(398998), // Rule ID 6002 //
     /* 398980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398991 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 398996 */   GIR_RootConstrainSelectedInstOperands,
     /* 398997 */   // GIR_Coverage, 6002,
     /* 398997 */   GIR_Done,
     /* 398998 */ // Label 7966: @398998
     /* 398998 */ GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(399059), // Rule ID 6003 //
     /* 399003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399014 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 399021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399026 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399030 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399041 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399058 */   // GIR_Coverage, 6003,
     /* 399058 */   GIR_EraseRootFromParent_Done,
     /* 399059 */ // Label 7967: @399059
     /* 399059 */ GIM_Reject,
     /* 399060 */ // Label 7961: @399060
     /* 399060 */ GIM_Reject,
     /* 399061 */ // Label 119: @399061
     /* 399061 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7971*/ GIMT_Encode4(399263),
     /* 399072 */ /*GILLT_s8*//*Label 7968*/ GIMT_Encode4(399084),
     /* 399076 */ /*GILLT_s16*//*Label 7969*/ GIMT_Encode4(399131),
     /* 399080 */ /*GILLT_s32*//*Label 7970*/ GIMT_Encode4(399178),
     /* 399084 */ // Label 7968: @399084
     /* 399084 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(399107), // Rule ID 5992 //
     /* 399089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399100 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 399105 */   GIR_RootConstrainSelectedInstOperands,
     /* 399106 */   // GIR_Coverage, 5992,
     /* 399106 */   GIR_Done,
     /* 399107 */ // Label 7972: @399107
     /* 399107 */ GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(399130), // Rule ID 5993 //
     /* 399112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399123 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 399128 */   GIR_RootConstrainSelectedInstOperands,
     /* 399129 */   // GIR_Coverage, 5993,
     /* 399129 */   GIR_Done,
     /* 399130 */ // Label 7973: @399130
     /* 399130 */ GIM_Reject,
     /* 399131 */ // Label 7969: @399131
     /* 399131 */ GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(399154), // Rule ID 5994 //
     /* 399136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399147 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 399152 */   GIR_RootConstrainSelectedInstOperands,
     /* 399153 */   // GIR_Coverage, 5994,
     /* 399153 */   GIR_Done,
     /* 399154 */ // Label 7974: @399154
     /* 399154 */ GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(399177), // Rule ID 5995 //
     /* 399159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399170 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 399175 */   GIR_RootConstrainSelectedInstOperands,
     /* 399176 */   // GIR_Coverage, 5995,
     /* 399176 */   GIR_Done,
     /* 399177 */ // Label 7975: @399177
     /* 399177 */ GIM_Reject,
     /* 399178 */ // Label 7970: @399178
     /* 399178 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(399201), // Rule ID 5996 //
     /* 399183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399194 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 399199 */   GIR_RootConstrainSelectedInstOperands,
     /* 399200 */   // GIR_Coverage, 5996,
     /* 399200 */   GIR_Done,
     /* 399201 */ // Label 7976: @399201
     /* 399201 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(399262), // Rule ID 5997 //
     /* 399206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399217 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 399224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399229 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399233 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399244 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399261 */   // GIR_Coverage, 5997,
     /* 399261 */   GIR_EraseRootFromParent_Done,
     /* 399262 */ // Label 7977: @399262
     /* 399262 */ GIM_Reject,
     /* 399263 */ // Label 7971: @399263
     /* 399263 */ GIM_Reject,
     /* 399264 */ // Label 120: @399264
     /* 399264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7981*/ GIMT_Encode4(399466),
     /* 399275 */ /*GILLT_s8*//*Label 7978*/ GIMT_Encode4(399287),
     /* 399279 */ /*GILLT_s16*//*Label 7979*/ GIMT_Encode4(399334),
     /* 399283 */ /*GILLT_s32*//*Label 7980*/ GIMT_Encode4(399381),
     /* 399287 */ // Label 7978: @399287
     /* 399287 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(399310), // Rule ID 5986 //
     /* 399292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399303 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 399308 */   GIR_RootConstrainSelectedInstOperands,
     /* 399309 */   // GIR_Coverage, 5986,
     /* 399309 */   GIR_Done,
     /* 399310 */ // Label 7982: @399310
     /* 399310 */ GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(399333), // Rule ID 5987 //
     /* 399315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399326 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 399331 */   GIR_RootConstrainSelectedInstOperands,
     /* 399332 */   // GIR_Coverage, 5987,
     /* 399332 */   GIR_Done,
     /* 399333 */ // Label 7983: @399333
     /* 399333 */ GIM_Reject,
     /* 399334 */ // Label 7979: @399334
     /* 399334 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(399357), // Rule ID 5988 //
     /* 399339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399350 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 399355 */   GIR_RootConstrainSelectedInstOperands,
     /* 399356 */   // GIR_Coverage, 5988,
     /* 399356 */   GIR_Done,
     /* 399357 */ // Label 7984: @399357
     /* 399357 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(399380), // Rule ID 5989 //
     /* 399362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399373 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 399378 */   GIR_RootConstrainSelectedInstOperands,
     /* 399379 */   // GIR_Coverage, 5989,
     /* 399379 */   GIR_Done,
     /* 399380 */ // Label 7985: @399380
     /* 399380 */ GIM_Reject,
     /* 399381 */ // Label 7980: @399381
     /* 399381 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(399404), // Rule ID 5990 //
     /* 399386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399397 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 399402 */   GIR_RootConstrainSelectedInstOperands,
     /* 399403 */   // GIR_Coverage, 5990,
     /* 399403 */   GIR_Done,
     /* 399404 */ // Label 7986: @399404
     /* 399404 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(399465), // Rule ID 5991 //
     /* 399409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399420 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 399427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399432 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399447 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399464 */   // GIR_Coverage, 5991,
     /* 399464 */   GIR_EraseRootFromParent_Done,
     /* 399465 */ // Label 7987: @399465
     /* 399465 */ GIM_Reject,
     /* 399466 */ // Label 7981: @399466
     /* 399466 */ GIM_Reject,
     /* 399467 */ // Label 121: @399467
     /* 399467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7991*/ GIMT_Encode4(399669),
     /* 399478 */ /*GILLT_s8*//*Label 7988*/ GIMT_Encode4(399490),
     /* 399482 */ /*GILLT_s16*//*Label 7989*/ GIMT_Encode4(399537),
     /* 399486 */ /*GILLT_s32*//*Label 7990*/ GIMT_Encode4(399584),
     /* 399490 */ // Label 7988: @399490
     /* 399490 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(399513), // Rule ID 5980 //
     /* 399495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399506 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 399511 */   GIR_RootConstrainSelectedInstOperands,
     /* 399512 */   // GIR_Coverage, 5980,
     /* 399512 */   GIR_Done,
     /* 399513 */ // Label 7992: @399513
     /* 399513 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(399536), // Rule ID 5981 //
     /* 399518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399529 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 399534 */   GIR_RootConstrainSelectedInstOperands,
     /* 399535 */   // GIR_Coverage, 5981,
     /* 399535 */   GIR_Done,
     /* 399536 */ // Label 7993: @399536
     /* 399536 */ GIM_Reject,
     /* 399537 */ // Label 7989: @399537
     /* 399537 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(399560), // Rule ID 5982 //
     /* 399542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399553 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 399558 */   GIR_RootConstrainSelectedInstOperands,
     /* 399559 */   // GIR_Coverage, 5982,
     /* 399559 */   GIR_Done,
     /* 399560 */ // Label 7994: @399560
     /* 399560 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(399583), // Rule ID 5983 //
     /* 399565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399576 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 399581 */   GIR_RootConstrainSelectedInstOperands,
     /* 399582 */   // GIR_Coverage, 5983,
     /* 399582 */   GIR_Done,
     /* 399583 */ // Label 7995: @399583
     /* 399583 */ GIM_Reject,
     /* 399584 */ // Label 7990: @399584
     /* 399584 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(399607), // Rule ID 5984 //
     /* 399589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399600 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 399605 */   GIR_RootConstrainSelectedInstOperands,
     /* 399606 */   // GIR_Coverage, 5984,
     /* 399606 */   GIR_Done,
     /* 399607 */ // Label 7996: @399607
     /* 399607 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(399668), // Rule ID 5985 //
     /* 399612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399623 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 399630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399635 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399639 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399650 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399667 */   // GIR_Coverage, 5985,
     /* 399667 */   GIR_EraseRootFromParent_Done,
     /* 399668 */ // Label 7997: @399668
     /* 399668 */ GIM_Reject,
     /* 399669 */ // Label 7991: @399669
     /* 399669 */ GIM_Reject,
     /* 399670 */ // Label 122: @399670
     /* 399670 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(399809),
     /* 399675 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 399678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 399682 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(399716), // Rule ID 257 //
     /* 399687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 399694 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 399694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 399697 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 399709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 399714 */     GIR_RootConstrainSelectedInstOperands,
     /* 399715 */     // GIR_Coverage, 257,
     /* 399715 */     GIR_EraseRootFromParent_Done,
     /* 399716 */   // Label 7999: @399716
     /* 399716 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(399750), // Rule ID 258 //
     /* 399721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 399728 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 399728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 399731 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 399743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 399748 */     GIR_RootConstrainSelectedInstOperands,
     /* 399749 */     // GIR_Coverage, 258,
     /* 399749 */     GIR_EraseRootFromParent_Done,
     /* 399750 */   // Label 8000: @399750
     /* 399750 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(399779), // Rule ID 273 //
     /* 399755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 399762 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 399762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 399765 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 399777 */     GIR_RootConstrainSelectedInstOperands,
     /* 399778 */     // GIR_Coverage, 273,
     /* 399778 */     GIR_EraseRootFromParent_Done,
     /* 399779 */   // Label 8001: @399779
     /* 399779 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(399808), // Rule ID 294 //
     /* 399784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 399791 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 399791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 399794 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 399806 */     GIR_RootConstrainSelectedInstOperands,
     /* 399807 */     // GIR_Coverage, 294,
     /* 399807 */     GIR_EraseRootFromParent_Done,
     /* 399808 */   // Label 8002: @399808
     /* 399808 */   GIM_Reject,
     /* 399809 */ // Label 7998: @399809
     /* 399809 */ GIM_Reject,
     /* 399810 */ // Label 123: @399810
     /* 399810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8015*/ GIMT_Encode4(400349),
     /* 399821 */ /*GILLT_s64*//*Label 8003*/ GIMT_Encode4(399905), GIMT_Encode4(0),
     /* 399829 */ /*GILLT_v2s32*//*Label 8004*/ GIMT_Encode4(399943),
     /* 399833 */ /*GILLT_v2s64*//*Label 8005*/ GIMT_Encode4(399981),
     /* 399837 */ /*GILLT_v4s16*//*Label 8006*/ GIMT_Encode4(400019),
     /* 399841 */ /*GILLT_v4s32*//*Label 8007*/ GIMT_Encode4(400057),
     /* 399845 */ /*GILLT_v8s8*//*Label 8008*/ GIMT_Encode4(400095),
     /* 399849 */ /*GILLT_v8s16*//*Label 8009*/ GIMT_Encode4(400133),
     /* 399853 */ /*GILLT_v16s8*//*Label 8010*/ GIMT_Encode4(400171), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399873 */ /*GILLT_nxv2s64*//*Label 8011*/ GIMT_Encode4(400209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399885 */ /*GILLT_nxv4s32*//*Label 8012*/ GIMT_Encode4(400244), GIMT_Encode4(0),
     /* 399893 */ /*GILLT_nxv8s16*//*Label 8013*/ GIMT_Encode4(400279), GIMT_Encode4(0),
     /* 399901 */ /*GILLT_nxv16s8*//*Label 8014*/ GIMT_Encode4(400314),
     /* 399905 */ // Label 8003: @399905
     /* 399905 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(399942), // Rule ID 5069 //
     /* 399910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 399919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399935 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 399935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 399940 */   GIR_RootConstrainSelectedInstOperands,
     /* 399941 */   // GIR_Coverage, 5069,
     /* 399941 */   GIR_Done,
     /* 399942 */ // Label 8016: @399942
     /* 399942 */ GIM_Reject,
     /* 399943 */ // Label 8004: @399943
     /* 399943 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(399980), // Rule ID 5068 //
     /* 399948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 399957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399973 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 399973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 399978 */   GIR_RootConstrainSelectedInstOperands,
     /* 399979 */   // GIR_Coverage, 5068,
     /* 399979 */   GIR_Done,
     /* 399980 */ // Label 8017: @399980
     /* 399980 */ GIM_Reject,
     /* 399981 */ // Label 8005: @399981
     /* 399981 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(400018), // Rule ID 5073 //
     /* 399986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 399995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400007 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400011 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 400011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400016 */   GIR_RootConstrainSelectedInstOperands,
     /* 400017 */   // GIR_Coverage, 5073,
     /* 400017 */   GIR_Done,
     /* 400018 */ // Label 8018: @400018
     /* 400018 */ GIM_Reject,
     /* 400019 */ // Label 8006: @400019
     /* 400019 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(400056), // Rule ID 5067 //
     /* 400024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 400033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400049 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 400049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 400054 */   GIR_RootConstrainSelectedInstOperands,
     /* 400055 */   // GIR_Coverage, 5067,
     /* 400055 */   GIR_Done,
     /* 400056 */ // Label 8019: @400056
     /* 400056 */ GIM_Reject,
     /* 400057 */ // Label 8007: @400057
     /* 400057 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(400094), // Rule ID 5072 //
     /* 400062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 400071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400087 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 400087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400092 */   GIR_RootConstrainSelectedInstOperands,
     /* 400093 */   // GIR_Coverage, 5072,
     /* 400093 */   GIR_Done,
     /* 400094 */ // Label 8020: @400094
     /* 400094 */ GIM_Reject,
     /* 400095 */ // Label 8008: @400095
     /* 400095 */ GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(400132), // Rule ID 5066 //
     /* 400100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 400106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 400109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400125 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 400125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 400130 */   GIR_RootConstrainSelectedInstOperands,
     /* 400131 */   // GIR_Coverage, 5066,
     /* 400131 */   GIR_Done,
     /* 400132 */ // Label 8021: @400132
     /* 400132 */ GIM_Reject,
     /* 400133 */ // Label 8009: @400133
     /* 400133 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(400170), // Rule ID 5071 //
     /* 400138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 400147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400163 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 400163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400168 */   GIR_RootConstrainSelectedInstOperands,
     /* 400169 */   // GIR_Coverage, 5071,
     /* 400169 */   GIR_Done,
     /* 400170 */ // Label 8022: @400170
     /* 400170 */ GIM_Reject,
     /* 400171 */ // Label 8010: @400171
     /* 400171 */ GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(400208), // Rule ID 5070 //
     /* 400176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 400182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 400185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400201 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 400201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400206 */   GIR_RootConstrainSelectedInstOperands,
     /* 400207 */   // GIR_Coverage, 5070,
     /* 400207 */   GIR_Done,
     /* 400208 */ // Label 8023: @400208
     /* 400208 */ GIM_Reject,
     /* 400209 */ // Label 8011: @400209
     /* 400209 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(400243), // Rule ID 11902 //
     /* 400214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 400220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 400223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 400226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400230 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 400230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400235 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400237 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400239 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400241 */   GIR_RootConstrainSelectedInstOperands,
     /* 400242 */   // GIR_Coverage, 11902,
     /* 400242 */   GIR_EraseRootFromParent_Done,
     /* 400243 */ // Label 8024: @400243
     /* 400243 */ GIM_Reject,
     /* 400244 */ // Label 8012: @400244
     /* 400244 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(400278), // Rule ID 11900 //
     /* 400249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 400255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 400258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 400261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400265 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 400265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400270 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400272 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400276 */   GIR_RootConstrainSelectedInstOperands,
     /* 400277 */   // GIR_Coverage, 11900,
     /* 400277 */   GIR_EraseRootFromParent_Done,
     /* 400278 */ // Label 8025: @400278
     /* 400278 */ GIM_Reject,
     /* 400279 */ // Label 8013: @400279
     /* 400279 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(400313), // Rule ID 11898 //
     /* 400284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 400290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 400293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 400296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400300 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 400300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400305 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400307 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400309 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400311 */   GIR_RootConstrainSelectedInstOperands,
     /* 400312 */   // GIR_Coverage, 11898,
     /* 400312 */   GIR_EraseRootFromParent_Done,
     /* 400313 */ // Label 8026: @400313
     /* 400313 */ GIM_Reject,
     /* 400314 */ // Label 8014: @400314
     /* 400314 */ GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(400348), // Rule ID 11896 //
     /* 400319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 400325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 400328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 400331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400335 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 400335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400340 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400342 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400344 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400346 */   GIR_RootConstrainSelectedInstOperands,
     /* 400347 */   // GIR_Coverage, 11896,
     /* 400347 */   GIR_EraseRootFromParent_Done,
     /* 400348 */ // Label 8027: @400348
     /* 400348 */ GIM_Reject,
     /* 400349 */ // Label 8015: @400349
     /* 400349 */ GIM_Reject,
     /* 400350 */ // Label 124: @400350
     /* 400350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8036*/ GIMT_Encode4(402172),
     /* 400361 */ /*GILLT_s64*//*Label 8028*/ GIMT_Encode4(400397), GIMT_Encode4(0),
     /* 400369 */ /*GILLT_v2s32*//*Label 8029*/ GIMT_Encode4(400592),
     /* 400373 */ /*GILLT_v2s64*//*Label 8030*/ GIMT_Encode4(400839),
     /* 400377 */ /*GILLT_v4s16*//*Label 8031*/ GIMT_Encode4(401086),
     /* 400381 */ /*GILLT_v4s32*//*Label 8032*/ GIMT_Encode4(401362),
     /* 400385 */ /*GILLT_v8s8*//*Label 8033*/ GIMT_Encode4(401609),
     /* 400389 */ /*GILLT_v8s16*//*Label 8034*/ GIMT_Encode4(401754),
     /* 400393 */ /*GILLT_v16s8*//*Label 8035*/ GIMT_Encode4(402030),
     /* 400397 */ // Label 8028: @400397
     /* 400397 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(400591),
     /* 400402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400409 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(400456), // Rule ID 6425 //
     /* 400414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400429 */     // MIs[1] Rn
     /* 400429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400440 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400454 */     GIR_RootConstrainSelectedInstOperands,
     /* 400455 */     // GIR_Coverage, 6425,
     /* 400455 */     GIR_EraseRootFromParent_Done,
     /* 400456 */   // Label 8038: @400456
     /* 400456 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(400503), // Rule ID 6436 //
     /* 400461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400469 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400476 */     // MIs[1] Rn
     /* 400476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400487 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400501 */     GIR_RootConstrainSelectedInstOperands,
     /* 400502 */     // GIR_Coverage, 6436,
     /* 400502 */     GIR_EraseRootFromParent_Done,
     /* 400503 */   // Label 8039: @400503
     /* 400503 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(400550), // Rule ID 13226 //
     /* 400508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400523 */     // MIs[1] Rn
     /* 400523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400534 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400548 */     GIR_RootConstrainSelectedInstOperands,
     /* 400549 */     // GIR_Coverage, 13226,
     /* 400549 */     GIR_EraseRootFromParent_Done,
     /* 400550 */   // Label 8040: @400550
     /* 400550 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(400570), // Rule ID 5632 //
     /* 400555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 400559 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 400559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400569 */     // GIR_Coverage, 5632,
     /* 400569 */     GIR_Done,
     /* 400570 */   // Label 8041: @400570
     /* 400570 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(400590), // Rule ID 5633 //
     /* 400575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400579 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 400579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400589 */     // GIR_Coverage, 5633,
     /* 400589 */     GIR_Done,
     /* 400590 */   // Label 8042: @400590
     /* 400590 */   GIM_Reject,
     /* 400591 */ // Label 8037: @400591
     /* 400591 */ GIM_Reject,
     /* 400592 */ // Label 8029: @400592
     /* 400592 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(400838),
     /* 400597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400604 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(400651), // Rule ID 6422 //
     /* 400609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400617 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400624 */     // MIs[1] Rn
     /* 400624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400635 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400649 */     GIR_RootConstrainSelectedInstOperands,
     /* 400650 */     // GIR_Coverage, 6422,
     /* 400650 */     GIR_EraseRootFromParent_Done,
     /* 400651 */   // Label 8044: @400651
     /* 400651 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(400698), // Rule ID 6433 //
     /* 400656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400671 */     // MIs[1] Rn
     /* 400671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400682 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400696 */     GIR_RootConstrainSelectedInstOperands,
     /* 400697 */     // GIR_Coverage, 6433,
     /* 400697 */     GIR_EraseRootFromParent_Done,
     /* 400698 */   // Label 8045: @400698
     /* 400698 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(400745), // Rule ID 13223 //
     /* 400703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400718 */     // MIs[1] Rn
     /* 400718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400729 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400743 */     GIR_RootConstrainSelectedInstOperands,
     /* 400744 */     // GIR_Coverage, 13223,
     /* 400744 */     GIR_EraseRootFromParent_Done,
     /* 400745 */   // Label 8046: @400745
     /* 400745 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(400764), // Rule ID 1916 //
     /* 400750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 400757 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 400757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 400762 */     GIR_RootConstrainSelectedInstOperands,
     /* 400763 */     // GIR_Coverage, 1916,
     /* 400763 */     GIR_Done,
     /* 400764 */   // Label 8047: @400764
     /* 400764 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(400837), // Rule ID 5634 //
     /* 400769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400773 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 400827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400835 */     GIR_RootConstrainSelectedInstOperands,
     /* 400836 */     // GIR_Coverage, 5634,
     /* 400836 */     GIR_EraseRootFromParent_Done,
     /* 400837 */   // Label 8048: @400837
     /* 400837 */   GIM_Reject,
     /* 400838 */ // Label 8043: @400838
     /* 400838 */ GIM_Reject,
     /* 400839 */ // Label 8030: @400839
     /* 400839 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(401085),
     /* 400844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400851 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(400898), // Rule ID 6424 //
     /* 400856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400871 */     // MIs[1] Rn
     /* 400871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400882 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400896 */     GIR_RootConstrainSelectedInstOperands,
     /* 400897 */     // GIR_Coverage, 6424,
     /* 400897 */     GIR_EraseRootFromParent_Done,
     /* 400898 */   // Label 8050: @400898
     /* 400898 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(400945), // Rule ID 6435 //
     /* 400903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400918 */     // MIs[1] Rn
     /* 400918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400929 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400943 */     GIR_RootConstrainSelectedInstOperands,
     /* 400944 */     // GIR_Coverage, 6435,
     /* 400944 */     GIR_EraseRootFromParent_Done,
     /* 400945 */   // Label 8051: @400945
     /* 400945 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(400992), // Rule ID 13225 //
     /* 400950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400965 */     // MIs[1] Rn
     /* 400965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400976 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400990 */     GIR_RootConstrainSelectedInstOperands,
     /* 400991 */     // GIR_Coverage, 13225,
     /* 400991 */     GIR_EraseRootFromParent_Done,
     /* 400992 */   // Label 8052: @400992
     /* 400992 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(401011), // Rule ID 1918 //
     /* 400997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 401004 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 401004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 401009 */     GIR_RootConstrainSelectedInstOperands,
     /* 401010 */     // GIR_Coverage, 1918,
     /* 401010 */     GIR_Done,
     /* 401011 */   // Label 8053: @401011
     /* 401011 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(401084), // Rule ID 5636 //
     /* 401016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401020 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 401074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401082 */     GIR_RootConstrainSelectedInstOperands,
     /* 401083 */     // GIR_Coverage, 5636,
     /* 401083 */     GIR_EraseRootFromParent_Done,
     /* 401084 */   // Label 8054: @401084
     /* 401084 */   GIM_Reject,
     /* 401085 */ // Label 8049: @401085
     /* 401085 */ GIM_Reject,
     /* 401086 */ // Label 8031: @401086
     /* 401086 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(401147), // Rule ID 6420 //
     /* 401091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401106 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401113 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 401120 */   // MIs[1] Rn
     /* 401120 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401131 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401136 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401145 */   GIR_RootConstrainSelectedInstOperands,
     /* 401146 */   // GIR_Coverage, 6420,
     /* 401146 */   GIR_EraseRootFromParent_Done,
     /* 401147 */ // Label 8055: @401147
     /* 401147 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(401201), // Rule ID 6437 //
     /* 401152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401167 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401174 */   // MIs[1] Rn
     /* 401174 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401178 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401185 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401190 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401199 */   GIR_RootConstrainSelectedInstOperands,
     /* 401200 */   // GIR_Coverage, 6437,
     /* 401200 */   GIR_EraseRootFromParent_Done,
     /* 401201 */ // Label 8056: @401201
     /* 401201 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(401255), // Rule ID 13221 //
     /* 401206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401221 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401228 */   // MIs[1] Rn
     /* 401228 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401232 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401239 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401244 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401253 */   GIR_RootConstrainSelectedInstOperands,
     /* 401254 */   // GIR_Coverage, 13221,
     /* 401254 */   GIR_EraseRootFromParent_Done,
     /* 401255 */ // Label 8057: @401255
     /* 401255 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(401281), // Rule ID 1914 //
     /* 401260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401274 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 401274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 401279 */   GIR_RootConstrainSelectedInstOperands,
     /* 401280 */   // GIR_Coverage, 1914,
     /* 401280 */   GIR_Done,
     /* 401281 */ // Label 8058: @401281
     /* 401281 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(401361), // Rule ID 5637 //
     /* 401286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401297 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401297 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 401300 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401304 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 401314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401323 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401330 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 401333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 401351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401359 */   GIR_RootConstrainSelectedInstOperands,
     /* 401360 */   // GIR_Coverage, 5637,
     /* 401360 */   GIR_EraseRootFromParent_Done,
     /* 401361 */ // Label 8059: @401361
     /* 401361 */ GIM_Reject,
     /* 401362 */ // Label 8032: @401362
     /* 401362 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(401608),
     /* 401367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401374 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(401421), // Rule ID 6423 //
     /* 401379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401394 */     // MIs[1] Rn
     /* 401394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401405 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401419 */     GIR_RootConstrainSelectedInstOperands,
     /* 401420 */     // GIR_Coverage, 6423,
     /* 401420 */     GIR_EraseRootFromParent_Done,
     /* 401421 */   // Label 8061: @401421
     /* 401421 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(401468), // Rule ID 6434 //
     /* 401426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401441 */     // MIs[1] Rn
     /* 401441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401452 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401466 */     GIR_RootConstrainSelectedInstOperands,
     /* 401467 */     // GIR_Coverage, 6434,
     /* 401467 */     GIR_EraseRootFromParent_Done,
     /* 401468 */   // Label 8062: @401468
     /* 401468 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(401515), // Rule ID 13224 //
     /* 401473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401488 */     // MIs[1] Rn
     /* 401488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401499 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401513 */     GIR_RootConstrainSelectedInstOperands,
     /* 401514 */     // GIR_Coverage, 13224,
     /* 401514 */     GIR_EraseRootFromParent_Done,
     /* 401515 */   // Label 8063: @401515
     /* 401515 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(401534), // Rule ID 1917 //
     /* 401520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401527 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 401527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 401532 */     GIR_RootConstrainSelectedInstOperands,
     /* 401533 */     // GIR_Coverage, 1917,
     /* 401533 */     GIR_Done,
     /* 401534 */   // Label 8064: @401534
     /* 401534 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(401607), // Rule ID 5635 //
     /* 401539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401543 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 401597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401605 */     GIR_RootConstrainSelectedInstOperands,
     /* 401606 */     // GIR_Coverage, 5635,
     /* 401606 */     GIR_EraseRootFromParent_Done,
     /* 401607 */   // Label 8065: @401607
     /* 401607 */   GIM_Reject,
     /* 401608 */ // Label 8060: @401608
     /* 401608 */ GIM_Reject,
     /* 401609 */ // Label 8033: @401609
     /* 401609 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(401666), // Rule ID 13219 //
     /* 401614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 401617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401629 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401636 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 401640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401642 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 401649 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 401652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 401659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401664 */   GIR_RootConstrainSelectedInstOperands,
     /* 401665 */   // GIR_Coverage, 13219,
     /* 401665 */   GIR_EraseRootFromParent_Done,
     /* 401666 */ // Label 8066: @401666
     /* 401666 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(401727), // Rule ID 6418 //
     /* 401671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401686 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401689 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401693 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 401700 */   // MIs[1] Rn
     /* 401700 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401711 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 401714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401716 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401725 */   GIR_RootConstrainSelectedInstOperands,
     /* 401726 */   // GIR_Coverage, 6418,
     /* 401726 */   GIR_EraseRootFromParent_Done,
     /* 401727 */ // Label 8067: @401727
     /* 401727 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(401753), // Rule ID 1912 //
     /* 401732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401746 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 401746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 401751 */   GIR_RootConstrainSelectedInstOperands,
     /* 401752 */   // GIR_Coverage, 1912,
     /* 401752 */   GIR_Done,
     /* 401753 */ // Label 8068: @401753
     /* 401753 */ GIM_Reject,
     /* 401754 */ // Label 8034: @401754
     /* 401754 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(401815), // Rule ID 6421 //
     /* 401759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401766 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401774 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401777 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401781 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 401788 */   // MIs[1] Rn
     /* 401788 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401792 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401799 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401804 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401813 */   GIR_RootConstrainSelectedInstOperands,
     /* 401814 */   // GIR_Coverage, 6421,
     /* 401814 */   GIR_EraseRootFromParent_Done,
     /* 401815 */ // Label 8069: @401815
     /* 401815 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(401869), // Rule ID 6438 //
     /* 401820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401835 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401842 */   // MIs[1] Rn
     /* 401842 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401853 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401858 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401867 */   GIR_RootConstrainSelectedInstOperands,
     /* 401868 */   // GIR_Coverage, 6438,
     /* 401868 */   GIR_EraseRootFromParent_Done,
     /* 401869 */ // Label 8070: @401869
     /* 401869 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(401923), // Rule ID 13222 //
     /* 401874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401889 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401896 */   // MIs[1] Rn
     /* 401896 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401900 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401907 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401912 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401921 */   GIR_RootConstrainSelectedInstOperands,
     /* 401922 */   // GIR_Coverage, 13222,
     /* 401922 */   GIR_EraseRootFromParent_Done,
     /* 401923 */ // Label 8071: @401923
     /* 401923 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(401949), // Rule ID 1915 //
     /* 401928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401942 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 401942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 401947 */   GIR_RootConstrainSelectedInstOperands,
     /* 401948 */   // GIR_Coverage, 1915,
     /* 401948 */   GIR_Done,
     /* 401949 */ // Label 8072: @401949
     /* 401949 */ GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(402029), // Rule ID 5638 //
     /* 401954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401965 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401965 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 401968 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401972 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 401982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401991 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401994 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401998 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 402001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402027 */   GIR_RootConstrainSelectedInstOperands,
     /* 402028 */   // GIR_Coverage, 5638,
     /* 402028 */   GIR_EraseRootFromParent_Done,
     /* 402029 */ // Label 8073: @402029
     /* 402029 */ GIM_Reject,
     /* 402030 */ // Label 8035: @402030
     /* 402030 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(402091), // Rule ID 6419 //
     /* 402035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402050 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402053 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402057 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 402064 */   // MIs[1] Rn
     /* 402064 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402068 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402075 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402080 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402089 */   GIR_RootConstrainSelectedInstOperands,
     /* 402090 */   // GIR_Coverage, 6419,
     /* 402090 */   GIR_EraseRootFromParent_Done,
     /* 402091 */ // Label 8074: @402091
     /* 402091 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(402145), // Rule ID 13220 //
     /* 402096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 402099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402111 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402118 */   // MIs[1] Rn
     /* 402118 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402122 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402129 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402134 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402143 */   GIR_RootConstrainSelectedInstOperands,
     /* 402144 */   // GIR_Coverage, 13220,
     /* 402144 */   GIR_EraseRootFromParent_Done,
     /* 402145 */ // Label 8075: @402145
     /* 402145 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(402171), // Rule ID 1913 //
     /* 402150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402164 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 402164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 402169 */   GIR_RootConstrainSelectedInstOperands,
     /* 402170 */   // GIR_Coverage, 1913,
     /* 402170 */   GIR_Done,
     /* 402171 */ // Label 8076: @402171
     /* 402171 */ GIM_Reject,
     /* 402172 */ // Label 8036: @402172
     /* 402172 */ GIM_Reject,
     /* 402173 */ // Label 125: @402173
     /* 402173 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8079*/ GIMT_Encode4(402427),
     /* 402184 */ /*GILLT_v4s16*//*Label 8077*/ GIMT_Encode4(402200), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402196 */ /*GILLT_v8s16*//*Label 8078*/ GIMT_Encode4(402286),
     /* 402200 */ // Label 8077: @402200
     /* 402200 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(402285),
     /* 402205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402219 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(402253), // Rule ID 1922 //
     /* 402224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402239 */     // MIs[1] Operand 1
     /* 402239 */     // No operand predicates
     /* 402239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402241 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 402244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402251 */     GIR_RootConstrainSelectedInstOperands,
     /* 402252 */     // GIR_Coverage, 1922,
     /* 402252 */     GIR_EraseRootFromParent_Done,
     /* 402253 */   // Label 8081: @402253
     /* 402253 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(402284), // Rule ID 5639 //
     /* 402258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402270 */     // MIs[1] Operand 1
     /* 402270 */     // No operand predicates
     /* 402270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402272 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 402272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 402275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402282 */     GIR_RootConstrainSelectedInstOperands,
     /* 402283 */     // GIR_Coverage, 5639,
     /* 402283 */     GIR_EraseRootFromParent_Done,
     /* 402284 */   // Label 8082: @402284
     /* 402284 */   GIM_Reject,
     /* 402285 */ // Label 8080: @402285
     /* 402285 */ GIM_Reject,
     /* 402286 */ // Label 8078: @402286
     /* 402286 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(402426),
     /* 402291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402301 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(402352), // Rule ID 6429 //
     /* 402306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402321 */     // MIs[1] Rn
     /* 402321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402336 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 402339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402350 */     GIR_RootConstrainSelectedInstOperands,
     /* 402351 */     // GIR_Coverage, 6429,
     /* 402351 */     GIR_EraseRootFromParent_Done,
     /* 402352 */   // Label 8084: @402352
     /* 402352 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(402390), // Rule ID 1923 //
     /* 402357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402376 */     // MIs[1] Operand 1
     /* 402376 */     // No operand predicates
     /* 402376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402378 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402388 */     GIR_RootConstrainSelectedInstOperands,
     /* 402389 */     // GIR_Coverage, 1923,
     /* 402389 */     GIR_EraseRootFromParent_Done,
     /* 402390 */   // Label 8085: @402390
     /* 402390 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(402425), // Rule ID 5640 //
     /* 402395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402411 */     // MIs[1] Operand 1
     /* 402411 */     // No operand predicates
     /* 402411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402413 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 402413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402423 */     GIR_RootConstrainSelectedInstOperands,
     /* 402424 */     // GIR_Coverage, 5640,
     /* 402424 */     GIR_EraseRootFromParent_Done,
     /* 402425 */   // Label 8086: @402425
     /* 402425 */   GIM_Reject,
     /* 402426 */ // Label 8083: @402426
     /* 402426 */ GIM_Reject,
     /* 402427 */ // Label 8079: @402427
     /* 402427 */ GIM_Reject,
     /* 402428 */ // Label 126: @402428
     /* 402428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8089*/ GIMT_Encode4(402682),
     /* 402439 */ /*GILLT_v2s32*//*Label 8087*/ GIMT_Encode4(402455), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402451 */ /*GILLT_v4s32*//*Label 8088*/ GIMT_Encode4(402541),
     /* 402455 */ // Label 8087: @402455
     /* 402455 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(402540),
     /* 402460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402474 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(402508), // Rule ID 1920 //
     /* 402479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402494 */     // MIs[1] Operand 1
     /* 402494 */     // No operand predicates
     /* 402494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402496 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 402499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402506 */     GIR_RootConstrainSelectedInstOperands,
     /* 402507 */     // GIR_Coverage, 1920,
     /* 402507 */     GIR_EraseRootFromParent_Done,
     /* 402508 */   // Label 8091: @402508
     /* 402508 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(402539), // Rule ID 5641 //
     /* 402513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402525 */     // MIs[1] Operand 1
     /* 402525 */     // No operand predicates
     /* 402525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402527 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 402527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 402530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402537 */     GIR_RootConstrainSelectedInstOperands,
     /* 402538 */     // GIR_Coverage, 5641,
     /* 402538 */     GIR_EraseRootFromParent_Done,
     /* 402539 */   // Label 8092: @402539
     /* 402539 */   GIM_Reject,
     /* 402540 */ // Label 8090: @402540
     /* 402540 */ GIM_Reject,
     /* 402541 */ // Label 8088: @402541
     /* 402541 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(402681),
     /* 402546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402556 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(402607), // Rule ID 6431 //
     /* 402561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402576 */     // MIs[1] Rn
     /* 402576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402591 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 402594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402605 */     GIR_RootConstrainSelectedInstOperands,
     /* 402606 */     // GIR_Coverage, 6431,
     /* 402606 */     GIR_EraseRootFromParent_Done,
     /* 402607 */   // Label 8094: @402607
     /* 402607 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(402645), // Rule ID 1921 //
     /* 402612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402631 */     // MIs[1] Operand 1
     /* 402631 */     // No operand predicates
     /* 402631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402633 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 402636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402643 */     GIR_RootConstrainSelectedInstOperands,
     /* 402644 */     // GIR_Coverage, 1921,
     /* 402644 */     GIR_EraseRootFromParent_Done,
     /* 402645 */   // Label 8095: @402645
     /* 402645 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(402680), // Rule ID 5642 //
     /* 402650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402666 */     // MIs[1] Operand 1
     /* 402666 */     // No operand predicates
     /* 402666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402668 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 402668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 402671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402678 */     GIR_RootConstrainSelectedInstOperands,
     /* 402679 */     // GIR_Coverage, 5642,
     /* 402679 */     GIR_EraseRootFromParent_Done,
     /* 402680 */   // Label 8096: @402680
     /* 402680 */   GIM_Reject,
     /* 402681 */ // Label 8093: @402681
     /* 402681 */ GIM_Reject,
     /* 402682 */ // Label 8089: @402682
     /* 402682 */ GIM_Reject,
     /* 402683 */ // Label 127: @402683
     /* 402683 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(402828),
     /* 402688 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 402691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402701 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(402752), // Rule ID 6432 //
     /* 402706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402721 */     // MIs[1] Rn
     /* 402721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402736 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 402739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402750 */     GIR_RootConstrainSelectedInstOperands,
     /* 402751 */     // GIR_Coverage, 6432,
     /* 402751 */     GIR_EraseRootFromParent_Done,
     /* 402752 */   // Label 8098: @402752
     /* 402752 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(402827),
     /* 402757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402761 */     GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(402795), // Rule ID 1919 //
     /* 402766 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402769 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402773 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402777 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 402781 */       // MIs[1] Operand 1
     /* 402781 */       // No operand predicates
     /* 402781 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402783 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402783 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 402786 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402788 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402790 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402793 */       GIR_RootConstrainSelectedInstOperands,
     /* 402794 */       // GIR_Coverage, 1919,
     /* 402794 */       GIR_EraseRootFromParent_Done,
     /* 402795 */     // Label 8100: @402795
     /* 402795 */     GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(402826), // Rule ID 5643 //
     /* 402800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402804 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402808 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 402812 */       // MIs[1] Operand 1
     /* 402812 */       // No operand predicates
     /* 402812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402814 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 402814 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 402817 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402819 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402821 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402824 */       GIR_RootConstrainSelectedInstOperands,
     /* 402825 */       // GIR_Coverage, 5643,
     /* 402825 */       GIR_EraseRootFromParent_Done,
     /* 402826 */     // Label 8101: @402826
     /* 402826 */     GIM_Reject,
     /* 402827 */   // Label 8099: @402827
     /* 402827 */   GIM_Reject,
     /* 402828 */ // Label 8097: @402828
     /* 402828 */ GIM_Reject,
     /* 402829 */ // Label 128: @402829
     /* 402829 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8104*/ GIMT_Encode4(403007),
     /* 402840 */ /*GILLT_v8s8*//*Label 8102*/ GIMT_Encode4(402852), GIMT_Encode4(0),
     /* 402848 */ /*GILLT_v16s8*//*Label 8103*/ GIMT_Encode4(402901),
     /* 402852 */ // Label 8102: @402852
     /* 402852 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(402900), // Rule ID 1924 //
     /* 402857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402882 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 402886 */   // MIs[1] Operand 1
     /* 402886 */   // No operand predicates
     /* 402886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402888 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 402891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402893 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402895 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402898 */   GIR_RootConstrainSelectedInstOperands,
     /* 402899 */   // GIR_Coverage, 1924,
     /* 402899 */   GIR_EraseRootFromParent_Done,
     /* 402900 */ // Label 8105: @402900
     /* 402900 */ GIM_Reject,
     /* 402901 */ // Label 8103: @402901
     /* 402901 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(403006),
     /* 402906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402916 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(402967), // Rule ID 6427 //
     /* 402921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402936 */     // MIs[1] Rn
     /* 402936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402951 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402965 */     GIR_RootConstrainSelectedInstOperands,
     /* 402966 */     // GIR_Coverage, 6427,
     /* 402966 */     GIR_EraseRootFromParent_Done,
     /* 402967 */   // Label 8107: @402967
     /* 402967 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(403005), // Rule ID 1925 //
     /* 402972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 402991 */     // MIs[1] Operand 1
     /* 402991 */     // No operand predicates
     /* 402991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402993 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 402996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 403003 */     GIR_RootConstrainSelectedInstOperands,
     /* 403004 */     // GIR_Coverage, 1925,
     /* 403004 */     GIR_EraseRootFromParent_Done,
     /* 403005 */   // Label 8108: @403005
     /* 403005 */   GIM_Reject,
     /* 403006 */ // Label 8106: @403006
     /* 403006 */ GIM_Reject,
     /* 403007 */ // Label 8104: @403007
     /* 403007 */ GIM_Reject,
     /* 403008 */ // Label 129: @403008
     /* 403008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8118*/ GIMT_Encode4(404657),
     /* 403019 */ /*GILLT_s64*//*Label 8109*/ GIMT_Encode4(403103), GIMT_Encode4(0),
     /* 403027 */ /*GILLT_v2s32*//*Label 8110*/ GIMT_Encode4(403424),
     /* 403031 */ /*GILLT_v2s64*//*Label 8111*/ GIMT_Encode4(403745),
     /* 403035 */ /*GILLT_v4s16*//*Label 8112*/ GIMT_Encode4(403828),
     /* 403039 */ /*GILLT_v4s32*//*Label 8113*/ GIMT_Encode4(404149),
     /* 403043 */ /*GILLT_v8s8*//*Label 8114*/ GIMT_Encode4(404232),
     /* 403047 */ /*GILLT_v8s16*//*Label 8115*/ GIMT_Encode4(404441),
     /* 403051 */ /*GILLT_v16s8*//*Label 8116*/ GIMT_Encode4(404524), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403099 */ /*GILLT_nxv16s8*//*Label 8117*/ GIMT_Encode4(404610),
     /* 403103 */ // Label 8109: @403103
     /* 403103 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(403423),
     /* 403108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 403114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403118 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(403233), // Rule ID 5460 //
     /* 403123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403140 */     // MIs[1] Operand 2
     /* 403140 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403159 */     // MIs[2] Rn
     /* 403159 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403164 */     // MIs[2] Operand 2
     /* 403164 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 403175 */     // MIs[0] imm
     /* 403175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403183 */     // MIs[3] Operand 1
     /* 403183 */     // No operand predicates
     /* 403183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403185 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403215 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403232 */     // GIR_Coverage, 5460,
     /* 403232 */     GIR_EraseRootFromParent_Done,
     /* 403233 */   // Label 8120: @403233
     /* 403233 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(403348), // Rule ID 5465 //
     /* 403238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403255 */     // MIs[1] Operand 2
     /* 403255 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403274 */     // MIs[2] Rn
     /* 403274 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403279 */     // MIs[2] Operand 2
     /* 403279 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 403290 */     // MIs[0] imm
     /* 403290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403298 */     // MIs[3] Operand 1
     /* 403298 */     // No operand predicates
     /* 403298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403300 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403330 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403347 */     // GIR_Coverage, 5465,
     /* 403347 */     GIR_EraseRootFromParent_Done,
     /* 403348 */   // Label 8121: @403348
     /* 403348 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(403385), // Rule ID 5457 //
     /* 403353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403361 */     // MIs[0] imm
     /* 403361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403369 */     // MIs[1] Operand 1
     /* 403369 */     // No operand predicates
     /* 403369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403371 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403383 */     GIR_RootConstrainSelectedInstOperands,
     /* 403384 */     // GIR_Coverage, 5457,
     /* 403384 */     GIR_EraseRootFromParent_Done,
     /* 403385 */   // Label 8122: @403385
     /* 403385 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(403422), // Rule ID 5462 //
     /* 403390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403398 */     // MIs[0] imm
     /* 403398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403406 */     // MIs[1] Operand 1
     /* 403406 */     // No operand predicates
     /* 403406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403408 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403420 */     GIR_RootConstrainSelectedInstOperands,
     /* 403421 */     // GIR_Coverage, 5462,
     /* 403421 */     GIR_EraseRootFromParent_Done,
     /* 403422 */   // Label 8123: @403422
     /* 403422 */   GIM_Reject,
     /* 403423 */ // Label 8119: @403423
     /* 403423 */ GIM_Reject,
     /* 403424 */ // Label 8110: @403424
     /* 403424 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(403744),
     /* 403429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 403435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403439 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(403554), // Rule ID 5450 //
     /* 403444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403461 */     // MIs[1] Operand 2
     /* 403461 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403480 */     // MIs[2] Rn
     /* 403480 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403485 */     // MIs[2] Operand 2
     /* 403485 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 403496 */     // MIs[0] imm
     /* 403496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403504 */     // MIs[3] Operand 1
     /* 403504 */     // No operand predicates
     /* 403504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403506 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403553 */     // GIR_Coverage, 5450,
     /* 403553 */     GIR_EraseRootFromParent_Done,
     /* 403554 */   // Label 8125: @403554
     /* 403554 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(403669), // Rule ID 5455 //
     /* 403559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403576 */     // MIs[1] Operand 2
     /* 403576 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403595 */     // MIs[2] Rn
     /* 403595 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403600 */     // MIs[2] Operand 2
     /* 403600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 403611 */     // MIs[0] imm
     /* 403611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403619 */     // MIs[3] Operand 1
     /* 403619 */     // No operand predicates
     /* 403619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403621 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403668 */     // GIR_Coverage, 5455,
     /* 403668 */     GIR_EraseRootFromParent_Done,
     /* 403669 */   // Label 8126: @403669
     /* 403669 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(403706), // Rule ID 5447 //
     /* 403674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403682 */     // MIs[0] imm
     /* 403682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403690 */     // MIs[1] Operand 1
     /* 403690 */     // No operand predicates
     /* 403690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403692 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403704 */     GIR_RootConstrainSelectedInstOperands,
     /* 403705 */     // GIR_Coverage, 5447,
     /* 403705 */     GIR_EraseRootFromParent_Done,
     /* 403706 */   // Label 8127: @403706
     /* 403706 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(403743), // Rule ID 5452 //
     /* 403711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403719 */     // MIs[0] imm
     /* 403719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403727 */     // MIs[1] Operand 1
     /* 403727 */     // No operand predicates
     /* 403727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403729 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403741 */     GIR_RootConstrainSelectedInstOperands,
     /* 403742 */     // GIR_Coverage, 5452,
     /* 403742 */     GIR_EraseRootFromParent_Done,
     /* 403743 */   // Label 8128: @403743
     /* 403743 */   GIM_Reject,
     /* 403744 */ // Label 8124: @403744
     /* 403744 */ GIM_Reject,
     /* 403745 */ // Label 8111: @403745
     /* 403745 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(403827),
     /* 403750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 403756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403768 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(403797), // Rule ID 5458 //
     /* 403773 */     // MIs[0] imm
     /* 403773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403781 */     // MIs[1] Operand 1
     /* 403781 */     // No operand predicates
     /* 403781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403783 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403795 */     GIR_RootConstrainSelectedInstOperands,
     /* 403796 */     // GIR_Coverage, 5458,
     /* 403796 */     GIR_EraseRootFromParent_Done,
     /* 403797 */   // Label 8130: @403797
     /* 403797 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(403826), // Rule ID 5463 //
     /* 403802 */     // MIs[0] imm
     /* 403802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403810 */     // MIs[1] Operand 1
     /* 403810 */     // No operand predicates
     /* 403810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403812 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403824 */     GIR_RootConstrainSelectedInstOperands,
     /* 403825 */     // GIR_Coverage, 5463,
     /* 403825 */     GIR_EraseRootFromParent_Done,
     /* 403826 */   // Label 8131: @403826
     /* 403826 */   GIM_Reject,
     /* 403827 */ // Label 8129: @403827
     /* 403827 */ GIM_Reject,
     /* 403828 */ // Label 8112: @403828
     /* 403828 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(404148),
     /* 403833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 403839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403843 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(403958), // Rule ID 5440 //
     /* 403848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403865 */     // MIs[1] Operand 2
     /* 403865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403884 */     // MIs[2] Rn
     /* 403884 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403889 */     // MIs[2] Operand 2
     /* 403889 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 403900 */     // MIs[0] imm
     /* 403900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403908 */     // MIs[3] Operand 1
     /* 403908 */     // No operand predicates
     /* 403908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403910 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403940 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403957 */     // GIR_Coverage, 5440,
     /* 403957 */     GIR_EraseRootFromParent_Done,
     /* 403958 */   // Label 8133: @403958
     /* 403958 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(404073), // Rule ID 5445 //
     /* 403963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403980 */     // MIs[1] Operand 2
     /* 403980 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403999 */     // MIs[2] Rn
     /* 403999 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 404004 */     // MIs[2] Operand 2
     /* 404004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 404015 */     // MIs[0] imm
     /* 404015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404023 */     // MIs[3] Operand 1
     /* 404023 */     // No operand predicates
     /* 404023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404025 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 404025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 404028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 404048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 404062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404072 */     // GIR_Coverage, 5445,
     /* 404072 */     GIR_EraseRootFromParent_Done,
     /* 404073 */   // Label 8134: @404073
     /* 404073 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(404110), // Rule ID 5437 //
     /* 404078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404086 */     // MIs[0] imm
     /* 404086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404094 */     // MIs[1] Operand 1
     /* 404094 */     // No operand predicates
     /* 404094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404096 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404108 */     GIR_RootConstrainSelectedInstOperands,
     /* 404109 */     // GIR_Coverage, 5437,
     /* 404109 */     GIR_EraseRootFromParent_Done,
     /* 404110 */   // Label 8135: @404110
     /* 404110 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(404147), // Rule ID 5442 //
     /* 404115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404123 */     // MIs[0] imm
     /* 404123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404131 */     // MIs[1] Operand 1
     /* 404131 */     // No operand predicates
     /* 404131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404133 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404145 */     GIR_RootConstrainSelectedInstOperands,
     /* 404146 */     // GIR_Coverage, 5442,
     /* 404146 */     GIR_EraseRootFromParent_Done,
     /* 404147 */   // Label 8136: @404147
     /* 404147 */   GIM_Reject,
     /* 404148 */ // Label 8132: @404148
     /* 404148 */ GIM_Reject,
     /* 404149 */ // Label 8113: @404149
     /* 404149 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(404231),
     /* 404154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 404160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404172 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(404201), // Rule ID 5448 //
     /* 404177 */     // MIs[0] imm
     /* 404177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404185 */     // MIs[1] Operand 1
     /* 404185 */     // No operand predicates
     /* 404185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404187 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404199 */     GIR_RootConstrainSelectedInstOperands,
     /* 404200 */     // GIR_Coverage, 5448,
     /* 404200 */     GIR_EraseRootFromParent_Done,
     /* 404201 */   // Label 8138: @404201
     /* 404201 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(404230), // Rule ID 5453 //
     /* 404206 */     // MIs[0] imm
     /* 404206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404214 */     // MIs[1] Operand 1
     /* 404214 */     // No operand predicates
     /* 404214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404216 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404228 */     GIR_RootConstrainSelectedInstOperands,
     /* 404229 */     // GIR_Coverage, 5453,
     /* 404229 */     GIR_EraseRootFromParent_Done,
     /* 404230 */   // Label 8139: @404230
     /* 404230 */   GIM_Reject,
     /* 404231 */ // Label 8137: @404231
     /* 404231 */ GIM_Reject,
     /* 404232 */ // Label 8114: @404232
     /* 404232 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(404440),
     /* 404237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404247 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(404362), // Rule ID 5435 //
     /* 404252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404269 */     // MIs[1] Operand 2
     /* 404269 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404288 */     // MIs[2] Rn
     /* 404288 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 404293 */     // MIs[2] Operand 2
     /* 404293 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 404304 */     // MIs[0] imm
     /* 404304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404312 */     // MIs[3] Operand 1
     /* 404312 */     // No operand predicates
     /* 404312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404314 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 404314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 404317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 404337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404344 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 404351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404361 */     // GIR_Coverage, 5435,
     /* 404361 */     GIR_EraseRootFromParent_Done,
     /* 404362 */   // Label 8141: @404362
     /* 404362 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(404402), // Rule ID 1868 //
     /* 404367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404378 */     // MIs[0] imm
     /* 404378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404386 */     // MIs[1] Operand 1
     /* 404386 */     // No operand predicates
     /* 404386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404388 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404400 */     GIR_RootConstrainSelectedInstOperands,
     /* 404401 */     // GIR_Coverage, 1868,
     /* 404401 */     GIR_EraseRootFromParent_Done,
     /* 404402 */   // Label 8142: @404402
     /* 404402 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(404439), // Rule ID 5432 //
     /* 404407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404415 */     // MIs[0] imm
     /* 404415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404423 */     // MIs[1] Operand 1
     /* 404423 */     // No operand predicates
     /* 404423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404425 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404437 */     GIR_RootConstrainSelectedInstOperands,
     /* 404438 */     // GIR_Coverage, 5432,
     /* 404438 */     GIR_EraseRootFromParent_Done,
     /* 404439 */   // Label 8143: @404439
     /* 404439 */   GIM_Reject,
     /* 404440 */ // Label 8140: @404440
     /* 404440 */ GIM_Reject,
     /* 404441 */ // Label 8115: @404441
     /* 404441 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(404523),
     /* 404446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 404452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404464 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(404493), // Rule ID 5438 //
     /* 404469 */     // MIs[0] imm
     /* 404469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404477 */     // MIs[1] Operand 1
     /* 404477 */     // No operand predicates
     /* 404477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404479 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404491 */     GIR_RootConstrainSelectedInstOperands,
     /* 404492 */     // GIR_Coverage, 5438,
     /* 404492 */     GIR_EraseRootFromParent_Done,
     /* 404493 */   // Label 8145: @404493
     /* 404493 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(404522), // Rule ID 5443 //
     /* 404498 */     // MIs[0] imm
     /* 404498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404506 */     // MIs[1] Operand 1
     /* 404506 */     // No operand predicates
     /* 404506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404508 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404520 */     GIR_RootConstrainSelectedInstOperands,
     /* 404521 */     // GIR_Coverage, 5443,
     /* 404521 */     GIR_EraseRootFromParent_Done,
     /* 404522 */   // Label 8146: @404522
     /* 404522 */   GIM_Reject,
     /* 404523 */ // Label 8144: @404523
     /* 404523 */ GIM_Reject,
     /* 404524 */ // Label 8116: @404524
     /* 404524 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(404609),
     /* 404529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404547 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(404579), // Rule ID 1869 //
     /* 404552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404555 */     // MIs[0] imm
     /* 404555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404563 */     // MIs[1] Operand 1
     /* 404563 */     // No operand predicates
     /* 404563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404565 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404577 */     GIR_RootConstrainSelectedInstOperands,
     /* 404578 */     // GIR_Coverage, 1869,
     /* 404578 */     GIR_EraseRootFromParent_Done,
     /* 404579 */   // Label 8148: @404579
     /* 404579 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(404608), // Rule ID 5433 //
     /* 404584 */     // MIs[0] imm
     /* 404584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404592 */     // MIs[1] Operand 1
     /* 404592 */     // No operand predicates
     /* 404592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404594 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404606 */     GIR_RootConstrainSelectedInstOperands,
     /* 404607 */     // GIR_Coverage, 5433,
     /* 404607 */     GIR_EraseRootFromParent_Done,
     /* 404608 */   // Label 8149: @404608
     /* 404608 */   GIM_Reject,
     /* 404609 */ // Label 8147: @404609
     /* 404609 */ GIM_Reject,
     /* 404610 */ // Label 8117: @404610
     /* 404610 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(404656), // Rule ID 2733 //
     /* 404615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 404621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404628 */   // MIs[0] Op3
     /* 404628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404636 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 404640 */   // MIs[1] Operand 1
     /* 404640 */   // No operand predicates
     /* 404640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404642 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 404642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 404645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 404647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 404649 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 404651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 404654 */   GIR_RootConstrainSelectedInstOperands,
     /* 404655 */   // GIR_Coverage, 2733,
     /* 404655 */   GIR_EraseRootFromParent_Done,
     /* 404656 */ // Label 8150: @404656
     /* 404656 */ GIM_Reject,
     /* 404657 */ // Label 8118: @404657
     /* 404657 */ GIM_Reject,
     /* 404658 */ // Label 130: @404658
     /* 404658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8158*/ GIMT_Encode4(405216),
     /* 404669 */ /*GILLT_s32*//*Label 8151*/ GIMT_Encode4(404705),
     /* 404673 */ /*GILLT_s64*//*Label 8152*/ GIMT_Encode4(404743), GIMT_Encode4(0),
     /* 404681 */ /*GILLT_v2s32*//*Label 8153*/ GIMT_Encode4(404841),
     /* 404685 */ /*GILLT_v2s64*//*Label 8154*/ GIMT_Encode4(404916),
     /* 404689 */ /*GILLT_v4s16*//*Label 8155*/ GIMT_Encode4(404991),
     /* 404693 */ /*GILLT_v4s32*//*Label 8156*/ GIMT_Encode4(405066), GIMT_Encode4(0),
     /* 404701 */ /*GILLT_v8s16*//*Label 8157*/ GIMT_Encode4(405141),
     /* 404705 */ // Label 8151: @404705
     /* 404705 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(404742), // Rule ID 1622 //
     /* 404710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 404719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404731 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 404731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 404736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404740 */   GIR_RootConstrainSelectedInstOperands,
     /* 404741 */   // GIR_Coverage, 1622,
     /* 404741 */   GIR_Done,
     /* 404742 */ // Label 8159: @404742
     /* 404742 */ GIM_Reject,
     /* 404743 */ // Label 8152: @404743
     /* 404743 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(404840),
     /* 404748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 404754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404762 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(404793), // Rule ID 2513 //
     /* 404767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404784 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 404784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 404787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404791 */     GIR_RootConstrainSelectedInstOperands,
     /* 404792 */     // GIR_Coverage, 2513,
     /* 404792 */     GIR_EraseRootFromParent_Done,
     /* 404793 */   // Label 8161: @404793
     /* 404793 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(404816), // Rule ID 1621 //
     /* 404798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404805 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 404805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 404810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404814 */     GIR_RootConstrainSelectedInstOperands,
     /* 404815 */     // GIR_Coverage, 1621,
     /* 404815 */     GIR_Done,
     /* 404816 */   // Label 8162: @404816
     /* 404816 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(404839), // Rule ID 5212 //
     /* 404821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404828 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 404828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 404833 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404837 */     GIR_RootConstrainSelectedInstOperands,
     /* 404838 */     // GIR_Coverage, 5212,
     /* 404838 */     GIR_Done,
     /* 404839 */   // Label 8163: @404839
     /* 404839 */   GIM_Reject,
     /* 404840 */ // Label 8160: @404840
     /* 404840 */ GIM_Reject,
     /* 404841 */ // Label 8153: @404841
     /* 404841 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(404915),
     /* 404846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404860 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(404891), // Rule ID 773 //
     /* 404865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404882 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 404882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 404885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404889 */     GIR_RootConstrainSelectedInstOperands,
     /* 404890 */     // GIR_Coverage, 773,
     /* 404890 */     GIR_EraseRootFromParent_Done,
     /* 404891 */   // Label 8165: @404891
     /* 404891 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(404914), // Rule ID 1210 //
     /* 404896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404903 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 404903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 404908 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404912 */     GIR_RootConstrainSelectedInstOperands,
     /* 404913 */     // GIR_Coverage, 1210,
     /* 404913 */     GIR_Done,
     /* 404914 */   // Label 8166: @404914
     /* 404914 */   GIM_Reject,
     /* 404915 */ // Label 8164: @404915
     /* 404915 */ GIM_Reject,
     /* 404916 */ // Label 8154: @404916
     /* 404916 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(404990),
     /* 404921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 404927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404935 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(404966), // Rule ID 775 //
     /* 404940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404957 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 404957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 404960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404964 */     GIR_RootConstrainSelectedInstOperands,
     /* 404965 */     // GIR_Coverage, 775,
     /* 404965 */     GIR_EraseRootFromParent_Done,
     /* 404966 */   // Label 8168: @404966
     /* 404966 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(404989), // Rule ID 1212 //
     /* 404971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404978 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 404983 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404987 */     GIR_RootConstrainSelectedInstOperands,
     /* 404988 */     // GIR_Coverage, 1212,
     /* 404988 */     GIR_Done,
     /* 404989 */   // Label 8169: @404989
     /* 404989 */   GIM_Reject,
     /* 404990 */ // Label 8167: @404990
     /* 404990 */ GIM_Reject,
     /* 404991 */ // Label 8155: @404991
     /* 404991 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(405065),
     /* 404996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405010 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(405041), // Rule ID 771 //
     /* 405015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405032 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 405035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405039 */     GIR_RootConstrainSelectedInstOperands,
     /* 405040 */     // GIR_Coverage, 771,
     /* 405040 */     GIR_EraseRootFromParent_Done,
     /* 405041 */   // Label 8171: @405041
     /* 405041 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(405064), // Rule ID 1208 //
     /* 405046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405053 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 405058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405062 */     GIR_RootConstrainSelectedInstOperands,
     /* 405063 */     // GIR_Coverage, 1208,
     /* 405063 */     GIR_Done,
     /* 405064 */   // Label 8172: @405064
     /* 405064 */   GIM_Reject,
     /* 405065 */ // Label 8170: @405065
     /* 405065 */ GIM_Reject,
     /* 405066 */ // Label 8156: @405066
     /* 405066 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(405140),
     /* 405071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405085 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(405116), // Rule ID 774 //
     /* 405090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405097 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405103 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405107 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 405107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 405110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405114 */     GIR_RootConstrainSelectedInstOperands,
     /* 405115 */     // GIR_Coverage, 774,
     /* 405115 */     GIR_EraseRootFromParent_Done,
     /* 405116 */   // Label 8174: @405116
     /* 405116 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(405139), // Rule ID 1211 //
     /* 405121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405128 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 405133 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405137 */     GIR_RootConstrainSelectedInstOperands,
     /* 405138 */     // GIR_Coverage, 1211,
     /* 405138 */     GIR_Done,
     /* 405139 */   // Label 8175: @405139
     /* 405139 */   GIM_Reject,
     /* 405140 */ // Label 8173: @405140
     /* 405140 */ GIM_Reject,
     /* 405141 */ // Label 8157: @405141
     /* 405141 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(405215),
     /* 405146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405160 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(405191), // Rule ID 772 //
     /* 405165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405172 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405178 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405182 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 405182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 405185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405189 */     GIR_RootConstrainSelectedInstOperands,
     /* 405190 */     // GIR_Coverage, 772,
     /* 405190 */     GIR_EraseRootFromParent_Done,
     /* 405191 */   // Label 8177: @405191
     /* 405191 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(405214), // Rule ID 1209 //
     /* 405196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405203 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 405208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405212 */     GIR_RootConstrainSelectedInstOperands,
     /* 405213 */     // GIR_Coverage, 1209,
     /* 405213 */     GIR_Done,
     /* 405214 */   // Label 8178: @405214
     /* 405214 */   GIM_Reject,
     /* 405215 */ // Label 8176: @405215
     /* 405215 */ GIM_Reject,
     /* 405216 */ // Label 8158: @405216
     /* 405216 */ GIM_Reject,
     /* 405217 */ // Label 131: @405217
     /* 405217 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8186*/ GIMT_Encode4(406308),
     /* 405228 */ /*GILLT_s32*//*Label 8179*/ GIMT_Encode4(405264),
     /* 405232 */ /*GILLT_s64*//*Label 8180*/ GIMT_Encode4(405302), GIMT_Encode4(0),
     /* 405240 */ /*GILLT_v2s32*//*Label 8181*/ GIMT_Encode4(405443),
     /* 405244 */ /*GILLT_v2s64*//*Label 8182*/ GIMT_Encode4(405616),
     /* 405248 */ /*GILLT_v4s16*//*Label 8183*/ GIMT_Encode4(405789),
     /* 405252 */ /*GILLT_v4s32*//*Label 8184*/ GIMT_Encode4(405962), GIMT_Encode4(0),
     /* 405260 */ /*GILLT_v8s16*//*Label 8185*/ GIMT_Encode4(406135),
     /* 405264 */ // Label 8179: @405264
     /* 405264 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(405301), // Rule ID 1624 //
     /* 405269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 405275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 405278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405290 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 405290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 405295 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405299 */   GIR_RootConstrainSelectedInstOperands,
     /* 405300 */   // GIR_Coverage, 1624,
     /* 405300 */   GIR_Done,
     /* 405301 */ // Label 8187: @405301
     /* 405301 */ GIM_Reject,
     /* 405302 */ // Label 8180: @405302
     /* 405302 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(405442),
     /* 405307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 405313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405317 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(405352), // Rule ID 5246 //
     /* 405322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405329 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405335 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405343 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 405343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 405346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405350 */     GIR_RootConstrainSelectedInstOperands,
     /* 405351 */     // GIR_Coverage, 5246,
     /* 405351 */     GIR_EraseRootFromParent_Done,
     /* 405352 */   // Label 8189: @405352
     /* 405352 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(405387), // Rule ID 5244 //
     /* 405357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405374 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405378 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 405378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 405381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405385 */     GIR_RootConstrainSelectedInstOperands,
     /* 405386 */     // GIR_Coverage, 5244,
     /* 405386 */     GIR_EraseRootFromParent_Done,
     /* 405387 */   // Label 8190: @405387
     /* 405387 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(405414), // Rule ID 1623 //
     /* 405392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405403 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 405403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 405408 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405412 */     GIR_RootConstrainSelectedInstOperands,
     /* 405413 */     // GIR_Coverage, 1623,
     /* 405413 */     GIR_Done,
     /* 405414 */   // Label 8191: @405414
     /* 405414 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(405441), // Rule ID 5213 //
     /* 405419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405430 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 405430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 405435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405439 */     GIR_RootConstrainSelectedInstOperands,
     /* 405440 */     // GIR_Coverage, 5213,
     /* 405440 */     GIR_Done,
     /* 405441 */   // Label 8192: @405441
     /* 405441 */   GIM_Reject,
     /* 405442 */ // Label 8188: @405442
     /* 405442 */ GIM_Reject,
     /* 405443 */ // Label 8181: @405443
     /* 405443 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(405615),
     /* 405448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405458 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(405517), // Rule ID 1172 //
     /* 405463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405502 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 405505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405515 */     GIR_RootConstrainSelectedInstOperands,
     /* 405516 */     // GIR_Coverage, 1172,
     /* 405516 */     GIR_EraseRootFromParent_Done,
     /* 405517 */   // Label 8194: @405517
     /* 405517 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(405552), // Rule ID 788 //
     /* 405522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405543 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 405546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405550 */     GIR_RootConstrainSelectedInstOperands,
     /* 405551 */     // GIR_Coverage, 788,
     /* 405551 */     GIR_EraseRootFromParent_Done,
     /* 405552 */   // Label 8195: @405552
     /* 405552 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(405587), // Rule ID 778 //
     /* 405557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405574 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405578 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 405581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405585 */     GIR_RootConstrainSelectedInstOperands,
     /* 405586 */     // GIR_Coverage, 778,
     /* 405586 */     GIR_EraseRootFromParent_Done,
     /* 405587 */   // Label 8196: @405587
     /* 405587 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(405614), // Rule ID 1215 //
     /* 405592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405603 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 405608 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405612 */     GIR_RootConstrainSelectedInstOperands,
     /* 405613 */     // GIR_Coverage, 1215,
     /* 405613 */     GIR_Done,
     /* 405614 */   // Label 8197: @405614
     /* 405614 */   GIM_Reject,
     /* 405615 */ // Label 8193: @405615
     /* 405615 */ GIM_Reject,
     /* 405616 */ // Label 8182: @405616
     /* 405616 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(405788),
     /* 405621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405631 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(405690), // Rule ID 1176 //
     /* 405636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405675 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 405678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405688 */     GIR_RootConstrainSelectedInstOperands,
     /* 405689 */     // GIR_Coverage, 1176,
     /* 405689 */     GIR_EraseRootFromParent_Done,
     /* 405690 */   // Label 8199: @405690
     /* 405690 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(405725), // Rule ID 790 //
     /* 405695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405702 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405708 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405716 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 405719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405723 */     GIR_RootConstrainSelectedInstOperands,
     /* 405724 */     // GIR_Coverage, 790,
     /* 405724 */     GIR_EraseRootFromParent_Done,
     /* 405725 */   // Label 8200: @405725
     /* 405725 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(405760), // Rule ID 780 //
     /* 405730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405751 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 405754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405758 */     GIR_RootConstrainSelectedInstOperands,
     /* 405759 */     // GIR_Coverage, 780,
     /* 405759 */     GIR_EraseRootFromParent_Done,
     /* 405760 */   // Label 8201: @405760
     /* 405760 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(405787), // Rule ID 1217 //
     /* 405765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405776 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 405781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405785 */     GIR_RootConstrainSelectedInstOperands,
     /* 405786 */     // GIR_Coverage, 1217,
     /* 405786 */     GIR_Done,
     /* 405787 */   // Label 8202: @405787
     /* 405787 */   GIM_Reject,
     /* 405788 */ // Label 8198: @405788
     /* 405788 */ GIM_Reject,
     /* 405789 */ // Label 8183: @405789
     /* 405789 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(405961),
     /* 405794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405804 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(405863), // Rule ID 1168 //
     /* 405809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405848 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 405851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405861 */     GIR_RootConstrainSelectedInstOperands,
     /* 405862 */     // GIR_Coverage, 1168,
     /* 405862 */     GIR_EraseRootFromParent_Done,
     /* 405863 */   // Label 8204: @405863
     /* 405863 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(405898), // Rule ID 786 //
     /* 405868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405875 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405889 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 405892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405896 */     GIR_RootConstrainSelectedInstOperands,
     /* 405897 */     // GIR_Coverage, 786,
     /* 405897 */     GIR_EraseRootFromParent_Done,
     /* 405898 */   // Label 8205: @405898
     /* 405898 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(405933), // Rule ID 776 //
     /* 405903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405924 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 405927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405931 */     GIR_RootConstrainSelectedInstOperands,
     /* 405932 */     // GIR_Coverage, 776,
     /* 405932 */     GIR_EraseRootFromParent_Done,
     /* 405933 */   // Label 8206: @405933
     /* 405933 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(405960), // Rule ID 1213 //
     /* 405938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405949 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 405954 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405958 */     GIR_RootConstrainSelectedInstOperands,
     /* 405959 */     // GIR_Coverage, 1213,
     /* 405959 */     GIR_Done,
     /* 405960 */   // Label 8207: @405960
     /* 405960 */   GIM_Reject,
     /* 405961 */ // Label 8203: @405961
     /* 405961 */ GIM_Reject,
     /* 405962 */ // Label 8184: @405962
     /* 405962 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(406134),
     /* 405967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405977 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(406036), // Rule ID 1174 //
     /* 405982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406021 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 406024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406034 */     GIR_RootConstrainSelectedInstOperands,
     /* 406035 */     // GIR_Coverage, 1174,
     /* 406035 */     GIR_EraseRootFromParent_Done,
     /* 406036 */   // Label 8209: @406036
     /* 406036 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(406071), // Rule ID 789 //
     /* 406041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406062 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 406062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 406065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406069 */     GIR_RootConstrainSelectedInstOperands,
     /* 406070 */     // GIR_Coverage, 789,
     /* 406070 */     GIR_EraseRootFromParent_Done,
     /* 406071 */   // Label 8210: @406071
     /* 406071 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(406106), // Rule ID 779 //
     /* 406076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406087 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406093 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406097 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 406097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 406100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406104 */     GIR_RootConstrainSelectedInstOperands,
     /* 406105 */     // GIR_Coverage, 779,
     /* 406105 */     GIR_EraseRootFromParent_Done,
     /* 406106 */   // Label 8211: @406106
     /* 406106 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(406133), // Rule ID 1216 //
     /* 406111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406122 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 406127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406131 */     GIR_RootConstrainSelectedInstOperands,
     /* 406132 */     // GIR_Coverage, 1216,
     /* 406132 */     GIR_Done,
     /* 406133 */   // Label 8212: @406133
     /* 406133 */   GIM_Reject,
     /* 406134 */ // Label 8208: @406134
     /* 406134 */ GIM_Reject,
     /* 406135 */ // Label 8185: @406135
     /* 406135 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(406307),
     /* 406140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406150 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(406209), // Rule ID 1170 //
     /* 406155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406194 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 406197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406207 */     GIR_RootConstrainSelectedInstOperands,
     /* 406208 */     // GIR_Coverage, 1170,
     /* 406208 */     GIR_EraseRootFromParent_Done,
     /* 406209 */   // Label 8214: @406209
     /* 406209 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(406244), // Rule ID 787 //
     /* 406214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406221 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406227 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406235 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 406235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 406238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406242 */     GIR_RootConstrainSelectedInstOperands,
     /* 406243 */     // GIR_Coverage, 787,
     /* 406243 */     GIR_EraseRootFromParent_Done,
     /* 406244 */   // Label 8215: @406244
     /* 406244 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(406279), // Rule ID 777 //
     /* 406249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406270 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 406270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 406273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406277 */     GIR_RootConstrainSelectedInstOperands,
     /* 406278 */     // GIR_Coverage, 777,
     /* 406278 */     GIR_EraseRootFromParent_Done,
     /* 406279 */   // Label 8216: @406279
     /* 406279 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(406306), // Rule ID 1214 //
     /* 406284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406295 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 406300 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406304 */     GIR_RootConstrainSelectedInstOperands,
     /* 406305 */     // GIR_Coverage, 1214,
     /* 406305 */     GIR_Done,
     /* 406306 */   // Label 8217: @406306
     /* 406306 */   GIM_Reject,
     /* 406307 */ // Label 8213: @406307
     /* 406307 */ GIM_Reject,
     /* 406308 */ // Label 8186: @406308
     /* 406308 */ GIM_Reject,
     /* 406309 */ // Label 132: @406309
     /* 406309 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8225*/ GIMT_Encode4(407400),
     /* 406320 */ /*GILLT_s32*//*Label 8218*/ GIMT_Encode4(406356),
     /* 406324 */ /*GILLT_s64*//*Label 8219*/ GIMT_Encode4(406394), GIMT_Encode4(0),
     /* 406332 */ /*GILLT_v2s32*//*Label 8220*/ GIMT_Encode4(406535),
     /* 406336 */ /*GILLT_v2s64*//*Label 8221*/ GIMT_Encode4(406708),
     /* 406340 */ /*GILLT_v4s16*//*Label 8222*/ GIMT_Encode4(406881),
     /* 406344 */ /*GILLT_v4s32*//*Label 8223*/ GIMT_Encode4(407054), GIMT_Encode4(0),
     /* 406352 */ /*GILLT_v8s16*//*Label 8224*/ GIMT_Encode4(407227),
     /* 406356 */ // Label 8218: @406356
     /* 406356 */ GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(406393), // Rule ID 1626 //
     /* 406361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 406367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 406370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406382 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 406382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 406387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406391 */   GIR_RootConstrainSelectedInstOperands,
     /* 406392 */   // GIR_Coverage, 1626,
     /* 406392 */   GIR_Done,
     /* 406393 */ // Label 8226: @406393
     /* 406393 */ GIM_Reject,
     /* 406394 */ // Label 8219: @406394
     /* 406394 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(406534),
     /* 406399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 406402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 406405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406409 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(406444), // Rule ID 5247 //
     /* 406414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406421 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406427 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406435 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 406435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 406438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406442 */     GIR_RootConstrainSelectedInstOperands,
     /* 406443 */     // GIR_Coverage, 5247,
     /* 406443 */     GIR_EraseRootFromParent_Done,
     /* 406444 */   // Label 8228: @406444
     /* 406444 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(406479), // Rule ID 5245 //
     /* 406449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406460 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406466 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406470 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 406470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 406473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406477 */     GIR_RootConstrainSelectedInstOperands,
     /* 406478 */     // GIR_Coverage, 5245,
     /* 406478 */     GIR_EraseRootFromParent_Done,
     /* 406479 */   // Label 8229: @406479
     /* 406479 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(406506), // Rule ID 1625 //
     /* 406484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406495 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 406495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 406500 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406504 */     GIR_RootConstrainSelectedInstOperands,
     /* 406505 */     // GIR_Coverage, 1625,
     /* 406505 */     GIR_Done,
     /* 406506 */   // Label 8230: @406506
     /* 406506 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(406533), // Rule ID 5214 //
     /* 406511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406522 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 406522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 406527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406531 */     GIR_RootConstrainSelectedInstOperands,
     /* 406532 */     // GIR_Coverage, 5214,
     /* 406532 */     GIR_Done,
     /* 406533 */   // Label 8231: @406533
     /* 406533 */   GIM_Reject,
     /* 406534 */ // Label 8227: @406534
     /* 406534 */ GIM_Reject,
     /* 406535 */ // Label 8220: @406535
     /* 406535 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(406707),
     /* 406540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406550 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(406609), // Rule ID 1182 //
     /* 406555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406594 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 406597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406607 */     GIR_RootConstrainSelectedInstOperands,
     /* 406608 */     // GIR_Coverage, 1182,
     /* 406608 */     GIR_EraseRootFromParent_Done,
     /* 406609 */   // Label 8233: @406609
     /* 406609 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(406644), // Rule ID 793 //
     /* 406614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406621 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406627 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406635 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 406635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 406638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406642 */     GIR_RootConstrainSelectedInstOperands,
     /* 406643 */     // GIR_Coverage, 793,
     /* 406643 */     GIR_EraseRootFromParent_Done,
     /* 406644 */   // Label 8234: @406644
     /* 406644 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(406679), // Rule ID 783 //
     /* 406649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406660 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406666 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406670 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 406670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 406673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406677 */     GIR_RootConstrainSelectedInstOperands,
     /* 406678 */     // GIR_Coverage, 783,
     /* 406678 */     GIR_EraseRootFromParent_Done,
     /* 406679 */   // Label 8235: @406679
     /* 406679 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(406706), // Rule ID 1220 //
     /* 406684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406695 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 406700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406704 */     GIR_RootConstrainSelectedInstOperands,
     /* 406705 */     // GIR_Coverage, 1220,
     /* 406705 */     GIR_Done,
     /* 406706 */   // Label 8236: @406706
     /* 406706 */   GIM_Reject,
     /* 406707 */ // Label 8232: @406707
     /* 406707 */ GIM_Reject,
     /* 406708 */ // Label 8221: @406708
     /* 406708 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(406880),
     /* 406713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406723 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(406782), // Rule ID 1186 //
     /* 406728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406767 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 406770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406780 */     GIR_RootConstrainSelectedInstOperands,
     /* 406781 */     // GIR_Coverage, 1186,
     /* 406781 */     GIR_EraseRootFromParent_Done,
     /* 406782 */   // Label 8238: @406782
     /* 406782 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(406817), // Rule ID 795 //
     /* 406787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406794 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406800 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406808 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 406808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 406811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406815 */     GIR_RootConstrainSelectedInstOperands,
     /* 406816 */     // GIR_Coverage, 795,
     /* 406816 */     GIR_EraseRootFromParent_Done,
     /* 406817 */   // Label 8239: @406817
     /* 406817 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(406852), // Rule ID 785 //
     /* 406822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406833 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406839 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406843 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 406843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 406846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406850 */     GIR_RootConstrainSelectedInstOperands,
     /* 406851 */     // GIR_Coverage, 785,
     /* 406851 */     GIR_EraseRootFromParent_Done,
     /* 406852 */   // Label 8240: @406852
     /* 406852 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(406879), // Rule ID 1222 //
     /* 406857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406868 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 406873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406877 */     GIR_RootConstrainSelectedInstOperands,
     /* 406878 */     // GIR_Coverage, 1222,
     /* 406878 */     GIR_Done,
     /* 406879 */   // Label 8241: @406879
     /* 406879 */   GIM_Reject,
     /* 406880 */ // Label 8237: @406880
     /* 406880 */ GIM_Reject,
     /* 406881 */ // Label 8222: @406881
     /* 406881 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(407053),
     /* 406886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406896 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(406955), // Rule ID 1178 //
     /* 406901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406940 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 406943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406953 */     GIR_RootConstrainSelectedInstOperands,
     /* 406954 */     // GIR_Coverage, 1178,
     /* 406954 */     GIR_EraseRootFromParent_Done,
     /* 406955 */   // Label 8243: @406955
     /* 406955 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(406990), // Rule ID 791 //
     /* 406960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406967 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406973 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406981 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 406981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 406984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406988 */     GIR_RootConstrainSelectedInstOperands,
     /* 406989 */     // GIR_Coverage, 791,
     /* 406989 */     GIR_EraseRootFromParent_Done,
     /* 406990 */   // Label 8244: @406990
     /* 406990 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(407025), // Rule ID 781 //
     /* 406995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407016 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 407016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 407019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407023 */     GIR_RootConstrainSelectedInstOperands,
     /* 407024 */     // GIR_Coverage, 781,
     /* 407024 */     GIR_EraseRootFromParent_Done,
     /* 407025 */   // Label 8245: @407025
     /* 407025 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(407052), // Rule ID 1218 //
     /* 407030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407041 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 407041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 407046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407050 */     GIR_RootConstrainSelectedInstOperands,
     /* 407051 */     // GIR_Coverage, 1218,
     /* 407051 */     GIR_Done,
     /* 407052 */   // Label 8246: @407052
     /* 407052 */   GIM_Reject,
     /* 407053 */ // Label 8242: @407053
     /* 407053 */ GIM_Reject,
     /* 407054 */ // Label 8223: @407054
     /* 407054 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(407226),
     /* 407059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 407065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407069 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(407128), // Rule ID 1184 //
     /* 407074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407113 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 407116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 407122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407126 */     GIR_RootConstrainSelectedInstOperands,
     /* 407127 */     // GIR_Coverage, 1184,
     /* 407127 */     GIR_EraseRootFromParent_Done,
     /* 407128 */   // Label 8248: @407128
     /* 407128 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(407163), // Rule ID 794 //
     /* 407133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407154 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 407154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 407157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407161 */     GIR_RootConstrainSelectedInstOperands,
     /* 407162 */     // GIR_Coverage, 794,
     /* 407162 */     GIR_EraseRootFromParent_Done,
     /* 407163 */   // Label 8249: @407163
     /* 407163 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(407198), // Rule ID 784 //
     /* 407168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407179 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407185 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407189 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 407189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 407192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407196 */     GIR_RootConstrainSelectedInstOperands,
     /* 407197 */     // GIR_Coverage, 784,
     /* 407197 */     GIR_EraseRootFromParent_Done,
     /* 407198 */   // Label 8250: @407198
     /* 407198 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(407225), // Rule ID 1221 //
     /* 407203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407214 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 407219 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407223 */     GIR_RootConstrainSelectedInstOperands,
     /* 407224 */     // GIR_Coverage, 1221,
     /* 407224 */     GIR_Done,
     /* 407225 */   // Label 8251: @407225
     /* 407225 */   GIM_Reject,
     /* 407226 */ // Label 8247: @407226
     /* 407226 */ GIM_Reject,
     /* 407227 */ // Label 8224: @407227
     /* 407227 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(407399),
     /* 407232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407242 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(407301), // Rule ID 1180 //
     /* 407247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407286 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 407289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 407295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407299 */     GIR_RootConstrainSelectedInstOperands,
     /* 407300 */     // GIR_Coverage, 1180,
     /* 407300 */     GIR_EraseRootFromParent_Done,
     /* 407301 */   // Label 8253: @407301
     /* 407301 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(407336), // Rule ID 792 //
     /* 407306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407327 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 407327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 407330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407334 */     GIR_RootConstrainSelectedInstOperands,
     /* 407335 */     // GIR_Coverage, 792,
     /* 407335 */     GIR_EraseRootFromParent_Done,
     /* 407336 */   // Label 8254: @407336
     /* 407336 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(407371), // Rule ID 782 //
     /* 407341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407362 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 407362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 407365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407369 */     GIR_RootConstrainSelectedInstOperands,
     /* 407370 */     // GIR_Coverage, 782,
     /* 407370 */     GIR_EraseRootFromParent_Done,
     /* 407371 */   // Label 8255: @407371
     /* 407371 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(407398), // Rule ID 1219 //
     /* 407376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407387 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 407392 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407396 */     GIR_RootConstrainSelectedInstOperands,
     /* 407397 */     // GIR_Coverage, 1219,
     /* 407397 */     GIR_Done,
     /* 407398 */   // Label 8256: @407398
     /* 407398 */   GIM_Reject,
     /* 407399 */ // Label 8252: @407399
     /* 407399 */ GIM_Reject,
     /* 407400 */ // Label 8225: @407400
     /* 407400 */ GIM_Reject,
     /* 407401 */ // Label 133: @407401
     /* 407401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8261*/ GIMT_Encode4(407554),
     /* 407412 */ /*GILLT_s32*//*Label 8257*/ GIMT_Encode4(407452),
     /* 407416 */ /*GILLT_s64*//*Label 8258*/ GIMT_Encode4(407476), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407440 */ /*GILLT_v8s8*//*Label 8259*/ GIMT_Encode4(407500), GIMT_Encode4(0),
     /* 407448 */ /*GILLT_v16s8*//*Label 8260*/ GIMT_Encode4(407527),
     /* 407452 */ // Label 8257: @407452
     /* 407452 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(407475), // Rule ID 4015 //
     /* 407457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 407460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 407464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 407468 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 407468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 407473 */   GIR_RootConstrainSelectedInstOperands,
     /* 407474 */   // GIR_Coverage, 4015,
     /* 407474 */   GIR_Done,
     /* 407475 */ // Label 8262: @407475
     /* 407475 */ GIM_Reject,
     /* 407476 */ // Label 8258: @407476
     /* 407476 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(407499), // Rule ID 4016 //
     /* 407481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 407488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 407492 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 407492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 407497 */   GIR_RootConstrainSelectedInstOperands,
     /* 407498 */   // GIR_Coverage, 4016,
     /* 407498 */   GIR_Done,
     /* 407499 */ // Label 8263: @407499
     /* 407499 */ GIM_Reject,
     /* 407500 */ // Label 8259: @407500
     /* 407500 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(407526), // Rule ID 976 //
     /* 407505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407519 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 407524 */   GIR_RootConstrainSelectedInstOperands,
     /* 407525 */   // GIR_Coverage, 976,
     /* 407525 */   GIR_Done,
     /* 407526 */ // Label 8264: @407526
     /* 407526 */ GIM_Reject,
     /* 407527 */ // Label 8260: @407527
     /* 407527 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(407553), // Rule ID 977 //
     /* 407532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407546 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 407551 */   GIR_RootConstrainSelectedInstOperands,
     /* 407552 */   // GIR_Coverage, 977,
     /* 407552 */   GIR_Done,
     /* 407553 */ // Label 8265: @407553
     /* 407553 */ GIM_Reject,
     /* 407554 */ // Label 8261: @407554
     /* 407554 */ GIM_Reject,
     /* 407555 */ // Label 134: @407555
     /* 407555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8270*/ GIMT_Encode4(407730),
     /* 407566 */ /*GILLT_v4s16*//*Label 8266*/ GIMT_Encode4(407586), GIMT_Encode4(0),
     /* 407574 */ /*GILLT_v8s8*//*Label 8267*/ GIMT_Encode4(407631),
     /* 407578 */ /*GILLT_v8s16*//*Label 8268*/ GIMT_Encode4(407658),
     /* 407582 */ /*GILLT_v16s8*//*Label 8269*/ GIMT_Encode4(407703),
     /* 407586 */ // Label 8266: @407586
     /* 407586 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(407630),
     /* 407591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407602 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(407617), // Rule ID 980 //
     /* 407607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407610 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 407610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 407615 */     GIR_RootConstrainSelectedInstOperands,
     /* 407616 */     // GIR_Coverage, 980,
     /* 407616 */     GIR_Done,
     /* 407617 */   // Label 8272: @407617
     /* 407617 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(407629), // Rule ID 4962 //
     /* 407622 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 407622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 407627 */     GIR_RootConstrainSelectedInstOperands,
     /* 407628 */     // GIR_Coverage, 4962,
     /* 407628 */     GIR_Done,
     /* 407629 */   // Label 8273: @407629
     /* 407629 */   GIM_Reject,
     /* 407630 */ // Label 8271: @407630
     /* 407630 */ GIM_Reject,
     /* 407631 */ // Label 8267: @407631
     /* 407631 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(407657), // Rule ID 978 //
     /* 407636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407650 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 407655 */   GIR_RootConstrainSelectedInstOperands,
     /* 407656 */   // GIR_Coverage, 978,
     /* 407656 */   GIR_Done,
     /* 407657 */ // Label 8274: @407657
     /* 407657 */ GIM_Reject,
     /* 407658 */ // Label 8268: @407658
     /* 407658 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(407702),
     /* 407663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407674 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(407689), // Rule ID 981 //
     /* 407679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407682 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 407682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 407687 */     GIR_RootConstrainSelectedInstOperands,
     /* 407688 */     // GIR_Coverage, 981,
     /* 407688 */     GIR_Done,
     /* 407689 */   // Label 8276: @407689
     /* 407689 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(407701), // Rule ID 4964 //
     /* 407694 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 407694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 407699 */     GIR_RootConstrainSelectedInstOperands,
     /* 407700 */     // GIR_Coverage, 4964,
     /* 407700 */     GIR_Done,
     /* 407701 */   // Label 8277: @407701
     /* 407701 */   GIM_Reject,
     /* 407702 */ // Label 8275: @407702
     /* 407702 */ GIM_Reject,
     /* 407703 */ // Label 8269: @407703
     /* 407703 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(407729), // Rule ID 979 //
     /* 407708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407722 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 407727 */   GIR_RootConstrainSelectedInstOperands,
     /* 407728 */   // GIR_Coverage, 979,
     /* 407728 */   GIR_Done,
     /* 407729 */ // Label 8278: @407729
     /* 407729 */ GIM_Reject,
     /* 407730 */ // Label 8270: @407730
     /* 407730 */ GIM_Reject,
     /* 407731 */ // Label 135: @407731
     /* 407731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8285*/ GIMT_Encode4(408004),
     /* 407742 */ /*GILLT_v2s32*//*Label 8279*/ GIMT_Encode4(407770), GIMT_Encode4(0),
     /* 407750 */ /*GILLT_v4s16*//*Label 8280*/ GIMT_Encode4(407815),
     /* 407754 */ /*GILLT_v4s32*//*Label 8281*/ GIMT_Encode4(407860),
     /* 407758 */ /*GILLT_v8s8*//*Label 8282*/ GIMT_Encode4(407905),
     /* 407762 */ /*GILLT_v8s16*//*Label 8283*/ GIMT_Encode4(407932),
     /* 407766 */ /*GILLT_v16s8*//*Label 8284*/ GIMT_Encode4(407977),
     /* 407770 */ // Label 8279: @407770
     /* 407770 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(407814),
     /* 407775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407786 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(407801), // Rule ID 986 //
     /* 407791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407794 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 407794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 407799 */     GIR_RootConstrainSelectedInstOperands,
     /* 407800 */     // GIR_Coverage, 986,
     /* 407800 */     GIR_Done,
     /* 407801 */   // Label 8287: @407801
     /* 407801 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(407813), // Rule ID 4966 //
     /* 407806 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 407806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 407811 */     GIR_RootConstrainSelectedInstOperands,
     /* 407812 */     // GIR_Coverage, 4966,
     /* 407812 */     GIR_Done,
     /* 407813 */   // Label 8288: @407813
     /* 407813 */   GIM_Reject,
     /* 407814 */ // Label 8286: @407814
     /* 407814 */ GIM_Reject,
     /* 407815 */ // Label 8280: @407815
     /* 407815 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(407859),
     /* 407820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407831 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(407846), // Rule ID 984 //
     /* 407836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407839 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 407839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 407844 */     GIR_RootConstrainSelectedInstOperands,
     /* 407845 */     // GIR_Coverage, 984,
     /* 407845 */     GIR_Done,
     /* 407846 */   // Label 8290: @407846
     /* 407846 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(407858), // Rule ID 4963 //
     /* 407851 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 407851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 407856 */     GIR_RootConstrainSelectedInstOperands,
     /* 407857 */     // GIR_Coverage, 4963,
     /* 407857 */     GIR_Done,
     /* 407858 */   // Label 8291: @407858
     /* 407858 */   GIM_Reject,
     /* 407859 */ // Label 8289: @407859
     /* 407859 */ GIM_Reject,
     /* 407860 */ // Label 8281: @407860
     /* 407860 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(407904),
     /* 407865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407876 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(407891), // Rule ID 987 //
     /* 407881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407884 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 407884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 407889 */     GIR_RootConstrainSelectedInstOperands,
     /* 407890 */     // GIR_Coverage, 987,
     /* 407890 */     GIR_Done,
     /* 407891 */   // Label 8293: @407891
     /* 407891 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(407903), // Rule ID 4967 //
     /* 407896 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 407896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 407901 */     GIR_RootConstrainSelectedInstOperands,
     /* 407902 */     // GIR_Coverage, 4967,
     /* 407902 */     GIR_Done,
     /* 407903 */   // Label 8294: @407903
     /* 407903 */   GIM_Reject,
     /* 407904 */ // Label 8292: @407904
     /* 407904 */ GIM_Reject,
     /* 407905 */ // Label 8282: @407905
     /* 407905 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(407931), // Rule ID 982 //
     /* 407910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407924 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 407929 */   GIR_RootConstrainSelectedInstOperands,
     /* 407930 */   // GIR_Coverage, 982,
     /* 407930 */   GIR_Done,
     /* 407931 */ // Label 8295: @407931
     /* 407931 */ GIM_Reject,
     /* 407932 */ // Label 8283: @407932
     /* 407932 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(407976),
     /* 407937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407948 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(407963), // Rule ID 985 //
     /* 407953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407956 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 407956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 407961 */     GIR_RootConstrainSelectedInstOperands,
     /* 407962 */     // GIR_Coverage, 985,
     /* 407962 */     GIR_Done,
     /* 407963 */   // Label 8297: @407963
     /* 407963 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(407975), // Rule ID 4965 //
     /* 407968 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 407968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 407973 */     GIR_RootConstrainSelectedInstOperands,
     /* 407974 */     // GIR_Coverage, 4965,
     /* 407974 */     GIR_Done,
     /* 407975 */   // Label 8298: @407975
     /* 407975 */   GIM_Reject,
     /* 407976 */ // Label 8296: @407976
     /* 407976 */ GIM_Reject,
     /* 407977 */ // Label 8284: @407977
     /* 407977 */ GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(408003), // Rule ID 983 //
     /* 407982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407996 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 408001 */   GIR_RootConstrainSelectedInstOperands,
     /* 408002 */   // GIR_Coverage, 983,
     /* 408002 */   GIR_Done,
     /* 408003 */ // Label 8299: @408003
     /* 408003 */ GIM_Reject,
     /* 408004 */ // Label 8285: @408004
     /* 408004 */ GIM_Reject,
     /* 408005 */ // Label 136: @408005
     /* 408005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8306*/ GIMT_Encode4(408210),
     /* 408016 */ /*GILLT_s64*//*Label 8300*/ GIMT_Encode4(408048), GIMT_Encode4(0),
     /* 408024 */ /*GILLT_v2s32*//*Label 8301*/ GIMT_Encode4(408075),
     /* 408028 */ /*GILLT_v2s64*//*Label 8302*/ GIMT_Encode4(408102),
     /* 408032 */ /*GILLT_v4s16*//*Label 8303*/ GIMT_Encode4(408129),
     /* 408036 */ /*GILLT_v4s32*//*Label 8304*/ GIMT_Encode4(408156), GIMT_Encode4(0),
     /* 408044 */ /*GILLT_v8s16*//*Label 8305*/ GIMT_Encode4(408183),
     /* 408048 */ // Label 8300: @408048
     /* 408048 */ GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(408074), // Rule ID 1008 //
     /* 408053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408067 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 408067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 408072 */   GIR_RootConstrainSelectedInstOperands,
     /* 408073 */   // GIR_Coverage, 1008,
     /* 408073 */   GIR_Done,
     /* 408074 */ // Label 8307: @408074
     /* 408074 */ GIM_Reject,
     /* 408075 */ // Label 8301: @408075
     /* 408075 */ GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(408101), // Rule ID 1004 //
     /* 408080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408094 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 408094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 408099 */   GIR_RootConstrainSelectedInstOperands,
     /* 408100 */   // GIR_Coverage, 1004,
     /* 408100 */   GIR_Done,
     /* 408101 */ // Label 8308: @408101
     /* 408101 */ GIM_Reject,
     /* 408102 */ // Label 8302: @408102
     /* 408102 */ GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(408128), // Rule ID 1010 //
     /* 408107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408121 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 408121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 408126 */   GIR_RootConstrainSelectedInstOperands,
     /* 408127 */   // GIR_Coverage, 1010,
     /* 408127 */   GIR_Done,
     /* 408128 */ // Label 8309: @408128
     /* 408128 */ GIM_Reject,
     /* 408129 */ // Label 8303: @408129
     /* 408129 */ GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(408155), // Rule ID 1000 //
     /* 408134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408148 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 408148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 408153 */   GIR_RootConstrainSelectedInstOperands,
     /* 408154 */   // GIR_Coverage, 1000,
     /* 408154 */   GIR_Done,
     /* 408155 */ // Label 8310: @408155
     /* 408155 */ GIM_Reject,
     /* 408156 */ // Label 8304: @408156
     /* 408156 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(408182), // Rule ID 1006 //
     /* 408161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408175 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 408175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 408180 */   GIR_RootConstrainSelectedInstOperands,
     /* 408181 */   // GIR_Coverage, 1006,
     /* 408181 */   GIR_Done,
     /* 408182 */ // Label 8311: @408182
     /* 408182 */ GIM_Reject,
     /* 408183 */ // Label 8305: @408183
     /* 408183 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(408209), // Rule ID 1002 //
     /* 408188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408202 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 408202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 408207 */   GIR_RootConstrainSelectedInstOperands,
     /* 408208 */   // GIR_Coverage, 1002,
     /* 408208 */   GIR_Done,
     /* 408209 */ // Label 8312: @408209
     /* 408209 */ GIM_Reject,
     /* 408210 */ // Label 8306: @408210
     /* 408210 */ GIM_Reject,
     /* 408211 */ // Label 137: @408211
     /* 408211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8315*/ GIMT_Encode4(408609),
     /* 408222 */ /*GILLT_v2s64*//*Label 8313*/ GIMT_Encode4(408234), GIMT_Encode4(0),
     /* 408230 */ /*GILLT_v4s32*//*Label 8314*/ GIMT_Encode4(408372),
     /* 408234 */ // Label 8313: @408234
     /* 408234 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(408293), // Rule ID 5882 //
     /* 408239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408250 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 408250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 408257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408262 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408292 */   // GIR_Coverage, 5882,
     /* 408292 */   GIR_EraseRootFromParent_Done,
     /* 408293 */ // Label 8316: @408293
     /* 408293 */ GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(408371), // Rule ID 6004 //
     /* 408298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408309 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 408309 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408312 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 408316 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408321 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 408327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 408330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 408334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 408344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408370 */   // GIR_Coverage, 6004,
     /* 408370 */   GIR_EraseRootFromParent_Done,
     /* 408371 */ // Label 8317: @408371
     /* 408371 */ GIM_Reject,
     /* 408372 */ // Label 8314: @408372
     /* 408372 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(408431), // Rule ID 5878 //
     /* 408377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408388 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 408388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 408395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408400 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408430 */   // GIR_Coverage, 5878,
     /* 408430 */   GIR_EraseRootFromParent_Done,
     /* 408431 */ // Label 8318: @408431
     /* 408431 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(408490), // Rule ID 5879 //
     /* 408436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408447 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 408447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 408454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408489 */   // GIR_Coverage, 5879,
     /* 408489 */   GIR_EraseRootFromParent_Done,
     /* 408490 */ // Label 8319: @408490
     /* 408490 */ GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(408549), // Rule ID 5880 //
     /* 408495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408506 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 408506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 408513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408548 */   // GIR_Coverage, 5880,
     /* 408548 */   GIR_EraseRootFromParent_Done,
     /* 408549 */ // Label 8320: @408549
     /* 408549 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(408608), // Rule ID 5881 //
     /* 408554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408565 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 408565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 408572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408577 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408607 */   // GIR_Coverage, 5881,
     /* 408607 */   GIR_EraseRootFromParent_Done,
     /* 408608 */ // Label 8321: @408608
     /* 408608 */ GIM_Reject,
     /* 408609 */ // Label 8315: @408609
     /* 408609 */ GIM_Reject,
     /* 408610 */ // Label 138: @408610
     /* 408610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8326*/ GIMT_Encode4(408979),
     /* 408621 */ /*GILLT_v2s32*//*Label 8322*/ GIMT_Encode4(408681), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408633 */ /*GILLT_v4s32*//*Label 8323*/ GIMT_Encode4(408801), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408665 */ /*GILLT_nxv2s64*//*Label 8324*/ GIMT_Encode4(408921), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408677 */ /*GILLT_nxv4s32*//*Label 8325*/ GIMT_Encode4(408950),
     /* 408681 */ // Label 8322: @408681
     /* 408681 */ GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(408800),
     /* 408686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 408695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408707 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(408780), // Rule ID 26 //
     /* 408712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408756 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408760 */     // MIs[3] Operand 1
     /* 408760 */     // No operand predicates
     /* 408760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408762 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 408765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408778 */     GIR_RootConstrainSelectedInstOperands,
     /* 408779 */     // GIR_Coverage, 26,
     /* 408779 */     GIR_EraseRootFromParent_Done,
     /* 408780 */   // Label 8328: @408780
     /* 408780 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(408799), // Rule ID 22 //
     /* 408785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408792 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 408797 */     GIR_RootConstrainSelectedInstOperands,
     /* 408798 */     // GIR_Coverage, 22,
     /* 408798 */     GIR_Done,
     /* 408799 */   // Label 8329: @408799
     /* 408799 */   GIM_Reject,
     /* 408800 */ // Label 8327: @408800
     /* 408800 */ GIM_Reject,
     /* 408801 */ // Label 8323: @408801
     /* 408801 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(408920),
     /* 408806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 408815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408827 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(408900), // Rule ID 27 //
     /* 408832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408880 */     // MIs[3] Operand 1
     /* 408880 */     // No operand predicates
     /* 408880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408882 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 408885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408898 */     GIR_RootConstrainSelectedInstOperands,
     /* 408899 */     // GIR_Coverage, 27,
     /* 408899 */     GIR_EraseRootFromParent_Done,
     /* 408900 */   // Label 8331: @408900
     /* 408900 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(408919), // Rule ID 23 //
     /* 408905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408912 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 408917 */     GIR_RootConstrainSelectedInstOperands,
     /* 408918 */     // GIR_Coverage, 23,
     /* 408918 */     GIR_Done,
     /* 408919 */   // Label 8332: @408919
     /* 408919 */   GIM_Reject,
     /* 408920 */ // Label 8330: @408920
     /* 408920 */ GIM_Reject,
     /* 408921 */ // Label 8324: @408921
     /* 408921 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(408949), // Rule ID 2986 //
     /* 408926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 408932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 408935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 408938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408942 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 408942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 408947 */   GIR_RootConstrainSelectedInstOperands,
     /* 408948 */   // GIR_Coverage, 2986,
     /* 408948 */   GIR_Done,
     /* 408949 */ // Label 8333: @408949
     /* 408949 */ GIM_Reject,
     /* 408950 */ // Label 8325: @408950
     /* 408950 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(408978), // Rule ID 2985 //
     /* 408955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 408961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 408967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408971 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 408971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 408976 */   GIR_RootConstrainSelectedInstOperands,
     /* 408977 */   // GIR_Coverage, 2985,
     /* 408977 */   GIR_Done,
     /* 408978 */ // Label 8334: @408978
     /* 408978 */ GIM_Reject,
     /* 408979 */ // Label 8326: @408979
     /* 408979 */ GIM_Reject,
     /* 408980 */ // Label 139: @408980
     /* 408980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8338*/ GIMT_Encode4(409096),
     /* 408991 */ /*GILLT_s16*//*Label 8335*/ GIMT_Encode4(409003),
     /* 408995 */ /*GILLT_s32*//*Label 8336*/ GIMT_Encode4(409034),
     /* 408999 */ /*GILLT_s64*//*Label 8337*/ GIMT_Encode4(409065),
     /* 409003 */ // Label 8335: @409003
     /* 409003 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(409033), // Rule ID 1658 //
     /* 409008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 409011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 409014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409022 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 409022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 409027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409031 */   GIR_RootConstrainSelectedInstOperands,
     /* 409032 */   // GIR_Coverage, 1658,
     /* 409032 */   GIR_Done,
     /* 409033 */ // Label 8339: @409033
     /* 409033 */ GIM_Reject,
     /* 409034 */ // Label 8336: @409034
     /* 409034 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(409064), // Rule ID 1657 //
     /* 409039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 409045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409053 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 409053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 409058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409062 */   GIR_RootConstrainSelectedInstOperands,
     /* 409063 */   // GIR_Coverage, 1657,
     /* 409063 */   GIR_Done,
     /* 409064 */ // Label 8340: @409064
     /* 409064 */ GIM_Reject,
     /* 409065 */ // Label 8337: @409065
     /* 409065 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(409095), // Rule ID 1656 //
     /* 409070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 409076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409084 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 409084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 409089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409093 */   GIR_RootConstrainSelectedInstOperands,
     /* 409094 */   // GIR_Coverage, 1656,
     /* 409094 */   GIR_Done,
     /* 409095 */ // Label 8341: @409095
     /* 409095 */ GIM_Reject,
     /* 409096 */ // Label 8338: @409096
     /* 409096 */ GIM_Reject,
     /* 409097 */ // Label 140: @409097
     /* 409097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8345*/ GIMT_Encode4(410329),
     /* 409108 */ /*GILLT_v2s64*//*Label 8342*/ GIMT_Encode4(409128), GIMT_Encode4(0),
     /* 409116 */ /*GILLT_v4s32*//*Label 8343*/ GIMT_Encode4(409689), GIMT_Encode4(0),
     /* 409124 */ /*GILLT_v8s16*//*Label 8344*/ GIMT_Encode4(410250),
     /* 409128 */ // Label 8342: @409128
     /* 409128 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(409688),
     /* 409133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409143 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(409235), // Rule ID 2054 //
     /* 409148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409192 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409196 */     // MIs[3] Operand 1
     /* 409196 */     // No operand predicates
     /* 409196 */     // MIs[1] Operand 2
     /* 409196 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409216 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 409219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409233 */     GIR_RootConstrainSelectedInstOperands,
     /* 409234 */     // GIR_Coverage, 2054,
     /* 409234 */     GIR_EraseRootFromParent_Done,
     /* 409235 */   // Label 8347: @409235
     /* 409235 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(409327), // Rule ID 13524 //
     /* 409240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409288 */     // MIs[3] Operand 1
     /* 409288 */     // No operand predicates
     /* 409288 */     // MIs[1] Operand 2
     /* 409288 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409308 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 409311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409325 */     GIR_RootConstrainSelectedInstOperands,
     /* 409326 */     // GIR_Coverage, 13524,
     /* 409326 */     GIR_EraseRootFromParent_Done,
     /* 409327 */   // Label 8348: @409327
     /* 409327 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(409413), // Rule ID 13522 //
     /* 409332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409376 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409380 */     // MIs[3] Operand 1
     /* 409380 */     // No operand predicates
     /* 409380 */     // MIs[1] Operand 2
     /* 409380 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409397 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409411 */     GIR_RootConstrainSelectedInstOperands,
     /* 409412 */     // GIR_Coverage, 13522,
     /* 409412 */     GIR_EraseRootFromParent_Done,
     /* 409413 */   // Label 8349: @409413
     /* 409413 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(409499), // Rule ID 2052 //
     /* 409418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409470 */     // MIs[3] Operand 1
     /* 409470 */     // No operand predicates
     /* 409470 */     // MIs[1] Operand 2
     /* 409470 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409483 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409497 */     GIR_RootConstrainSelectedInstOperands,
     /* 409498 */     // GIR_Coverage, 2052,
     /* 409498 */     GIR_EraseRootFromParent_Done,
     /* 409499 */   // Label 8350: @409499
     /* 409499 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(409538), // Rule ID 1741 //
     /* 409504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409521 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 409524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409536 */     GIR_RootConstrainSelectedInstOperands,
     /* 409537 */     // GIR_Coverage, 1741,
     /* 409537 */     GIR_EraseRootFromParent_Done,
     /* 409538 */   // Label 8351: @409538
     /* 409538 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(409601), // Rule ID 13523 //
     /* 409543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409579 */     // MIs[2] Operand 1
     /* 409579 */     // No operand predicates
     /* 409579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409585 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409599 */     GIR_RootConstrainSelectedInstOperands,
     /* 409600 */     // GIR_Coverage, 13523,
     /* 409600 */     GIR_EraseRootFromParent_Done,
     /* 409601 */   // Label 8352: @409601
     /* 409601 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(409664), // Rule ID 2053 //
     /* 409606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409646 */     // MIs[2] Operand 1
     /* 409646 */     // No operand predicates
     /* 409646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409648 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409662 */     GIR_RootConstrainSelectedInstOperands,
     /* 409663 */     // GIR_Coverage, 2053,
     /* 409663 */     GIR_EraseRootFromParent_Done,
     /* 409664 */   // Label 8353: @409664
     /* 409664 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(409687), // Rule ID 1740 //
     /* 409669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409680 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 409685 */     GIR_RootConstrainSelectedInstOperands,
     /* 409686 */     // GIR_Coverage, 1740,
     /* 409686 */     GIR_Done,
     /* 409687 */   // Label 8354: @409687
     /* 409687 */   GIM_Reject,
     /* 409688 */ // Label 8346: @409688
     /* 409688 */ GIM_Reject,
     /* 409689 */ // Label 8343: @409689
     /* 409689 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(410249),
     /* 409694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409704 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(409796), // Rule ID 2051 //
     /* 409709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409753 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409757 */     // MIs[3] Operand 1
     /* 409757 */     // No operand predicates
     /* 409757 */     // MIs[1] Operand 2
     /* 409757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409777 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 409780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409794 */     GIR_RootConstrainSelectedInstOperands,
     /* 409795 */     // GIR_Coverage, 2051,
     /* 409795 */     GIR_EraseRootFromParent_Done,
     /* 409796 */   // Label 8356: @409796
     /* 409796 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(409888), // Rule ID 13521 //
     /* 409801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409845 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409849 */     // MIs[3] Operand 1
     /* 409849 */     // No operand predicates
     /* 409849 */     // MIs[1] Operand 2
     /* 409849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409869 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 409872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409886 */     GIR_RootConstrainSelectedInstOperands,
     /* 409887 */     // GIR_Coverage, 13521,
     /* 409887 */     GIR_EraseRootFromParent_Done,
     /* 409888 */   // Label 8357: @409888
     /* 409888 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(409974), // Rule ID 13519 //
     /* 409893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409937 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409941 */     // MIs[3] Operand 1
     /* 409941 */     // No operand predicates
     /* 409941 */     // MIs[1] Operand 2
     /* 409941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409958 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 409961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409972 */     GIR_RootConstrainSelectedInstOperands,
     /* 409973 */     // GIR_Coverage, 13519,
     /* 409973 */     GIR_EraseRootFromParent_Done,
     /* 409974 */   // Label 8358: @409974
     /* 409974 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(410060), // Rule ID 2049 //
     /* 409979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410027 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410031 */     // MIs[3] Operand 1
     /* 410031 */     // No operand predicates
     /* 410031 */     // MIs[1] Operand 2
     /* 410031 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410044 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410058 */     GIR_RootConstrainSelectedInstOperands,
     /* 410059 */     // GIR_Coverage, 2049,
     /* 410059 */     GIR_EraseRootFromParent_Done,
     /* 410060 */   // Label 8359: @410060
     /* 410060 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(410099), // Rule ID 1739 //
     /* 410065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410082 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 410085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410097 */     GIR_RootConstrainSelectedInstOperands,
     /* 410098 */     // GIR_Coverage, 1739,
     /* 410098 */     GIR_EraseRootFromParent_Done,
     /* 410099 */   // Label 8360: @410099
     /* 410099 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(410162), // Rule ID 13520 //
     /* 410104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410136 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410140 */     // MIs[2] Operand 1
     /* 410140 */     // No operand predicates
     /* 410140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410146 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410160 */     GIR_RootConstrainSelectedInstOperands,
     /* 410161 */     // GIR_Coverage, 13520,
     /* 410161 */     GIR_EraseRootFromParent_Done,
     /* 410162 */   // Label 8361: @410162
     /* 410162 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(410225), // Rule ID 2050 //
     /* 410167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410207 */     // MIs[2] Operand 1
     /* 410207 */     // No operand predicates
     /* 410207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410209 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410223 */     GIR_RootConstrainSelectedInstOperands,
     /* 410224 */     // GIR_Coverage, 2050,
     /* 410224 */     GIR_EraseRootFromParent_Done,
     /* 410225 */   // Label 8362: @410225
     /* 410225 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(410248), // Rule ID 1738 //
     /* 410230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410241 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 410246 */     GIR_RootConstrainSelectedInstOperands,
     /* 410247 */     // GIR_Coverage, 1738,
     /* 410247 */     GIR_Done,
     /* 410248 */   // Label 8363: @410248
     /* 410248 */   GIM_Reject,
     /* 410249 */ // Label 8355: @410249
     /* 410249 */ GIM_Reject,
     /* 410250 */ // Label 8344: @410250
     /* 410250 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(410328),
     /* 410255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410265 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(410304), // Rule ID 1737 //
     /* 410270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410287 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 410290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410302 */     GIR_RootConstrainSelectedInstOperands,
     /* 410303 */     // GIR_Coverage, 1737,
     /* 410303 */     GIR_EraseRootFromParent_Done,
     /* 410304 */   // Label 8365: @410304
     /* 410304 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(410327), // Rule ID 1736 //
     /* 410309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410320 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 410325 */     GIR_RootConstrainSelectedInstOperands,
     /* 410326 */     // GIR_Coverage, 1736,
     /* 410326 */     GIR_Done,
     /* 410327 */   // Label 8366: @410327
     /* 410327 */   GIM_Reject,
     /* 410328 */ // Label 8364: @410328
     /* 410328 */ GIM_Reject,
     /* 410329 */ // Label 8345: @410329
     /* 410329 */ GIM_Reject,
     /* 410330 */ // Label 141: @410330
     /* 410330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8385*/ GIMT_Encode4(411109),
     /* 410341 */ /*GILLT_v2s32*//*Label 8367*/ GIMT_Encode4(410417),
     /* 410345 */ /*GILLT_v2s64*//*Label 8368*/ GIMT_Encode4(410472),
     /* 410349 */ /*GILLT_v4s16*//*Label 8369*/ GIMT_Encode4(410527),
     /* 410353 */ /*GILLT_v4s32*//*Label 8370*/ GIMT_Encode4(410582),
     /* 410357 */ /*GILLT_v8s8*//*Label 8371*/ GIMT_Encode4(410637),
     /* 410361 */ /*GILLT_v8s16*//*Label 8372*/ GIMT_Encode4(410671),
     /* 410365 */ /*GILLT_v16s8*//*Label 8373*/ GIMT_Encode4(410726), GIMT_Encode4(0),
     /* 410373 */ /*GILLT_nxv2s1*//*Label 8374*/ GIMT_Encode4(410760),
     /* 410377 */ /*GILLT_nxv2s16*//*Label 8375*/ GIMT_Encode4(410786),
     /* 410381 */ /*GILLT_nxv2s32*//*Label 8376*/ GIMT_Encode4(410812),
     /* 410385 */ /*GILLT_nxv2s64*//*Label 8377*/ GIMT_Encode4(410838),
     /* 410389 */ /*GILLT_nxv4s1*//*Label 8378*/ GIMT_Encode4(410885),
     /* 410393 */ /*GILLT_nxv4s16*//*Label 8379*/ GIMT_Encode4(410911),
     /* 410397 */ /*GILLT_nxv4s32*//*Label 8380*/ GIMT_Encode4(410937),
     /* 410401 */ /*GILLT_nxv8s1*//*Label 8381*/ GIMT_Encode4(410984),
     /* 410405 */ /*GILLT_nxv8s16*//*Label 8382*/ GIMT_Encode4(411010),
     /* 410409 */ /*GILLT_nxv16s1*//*Label 8383*/ GIMT_Encode4(411057),
     /* 410413 */ /*GILLT_nxv16s8*//*Label 8384*/ GIMT_Encode4(411083),
     /* 410417 */ // Label 8367: @410417
     /* 410417 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(410471),
     /* 410422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410440 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(410455), // Rule ID 1874 //
     /* 410445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410448 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 410453 */     GIR_RootConstrainSelectedInstOperands,
     /* 410454 */     // GIR_Coverage, 1874,
     /* 410454 */     GIR_Done,
     /* 410455 */   // Label 8387: @410455
     /* 410455 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(410470), // Rule ID 2505 //
     /* 410460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410463 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 410468 */     GIR_RootConstrainSelectedInstOperands,
     /* 410469 */     // GIR_Coverage, 2505,
     /* 410469 */     GIR_Done,
     /* 410470 */   // Label 8388: @410470
     /* 410470 */   GIM_Reject,
     /* 410471 */ // Label 8386: @410471
     /* 410471 */ GIM_Reject,
     /* 410472 */ // Label 8368: @410472
     /* 410472 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(410526),
     /* 410477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410495 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(410510), // Rule ID 1876 //
     /* 410500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410503 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 410508 */     GIR_RootConstrainSelectedInstOperands,
     /* 410509 */     // GIR_Coverage, 1876,
     /* 410509 */     GIR_Done,
     /* 410510 */   // Label 8390: @410510
     /* 410510 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(410525), // Rule ID 2507 //
     /* 410515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410518 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 410523 */     GIR_RootConstrainSelectedInstOperands,
     /* 410524 */     // GIR_Coverage, 2507,
     /* 410524 */     GIR_Done,
     /* 410525 */   // Label 8391: @410525
     /* 410525 */   GIM_Reject,
     /* 410526 */ // Label 8389: @410526
     /* 410526 */ GIM_Reject,
     /* 410527 */ // Label 8369: @410527
     /* 410527 */ GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(410581),
     /* 410532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410550 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(410565), // Rule ID 1872 //
     /* 410555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410558 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 410563 */     GIR_RootConstrainSelectedInstOperands,
     /* 410564 */     // GIR_Coverage, 1872,
     /* 410564 */     GIR_Done,
     /* 410565 */   // Label 8393: @410565
     /* 410565 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(410580), // Rule ID 2503 //
     /* 410570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410573 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 410578 */     GIR_RootConstrainSelectedInstOperands,
     /* 410579 */     // GIR_Coverage, 2503,
     /* 410579 */     GIR_Done,
     /* 410580 */   // Label 8394: @410580
     /* 410580 */   GIM_Reject,
     /* 410581 */ // Label 8392: @410581
     /* 410581 */ GIM_Reject,
     /* 410582 */ // Label 8370: @410582
     /* 410582 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(410636),
     /* 410587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410605 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(410620), // Rule ID 1875 //
     /* 410610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410613 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 410618 */     GIR_RootConstrainSelectedInstOperands,
     /* 410619 */     // GIR_Coverage, 1875,
     /* 410619 */     GIR_Done,
     /* 410620 */   // Label 8396: @410620
     /* 410620 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(410635), // Rule ID 2506 //
     /* 410625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410628 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 410628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 410633 */     GIR_RootConstrainSelectedInstOperands,
     /* 410634 */     // GIR_Coverage, 2506,
     /* 410634 */     GIR_Done,
     /* 410635 */   // Label 8397: @410635
     /* 410635 */   GIM_Reject,
     /* 410636 */ // Label 8395: @410636
     /* 410636 */ GIM_Reject,
     /* 410637 */ // Label 8371: @410637
     /* 410637 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(410670), // Rule ID 1870 //
     /* 410642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410663 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 410668 */   GIR_RootConstrainSelectedInstOperands,
     /* 410669 */   // GIR_Coverage, 1870,
     /* 410669 */   GIR_Done,
     /* 410670 */ // Label 8398: @410670
     /* 410670 */ GIM_Reject,
     /* 410671 */ // Label 8372: @410671
     /* 410671 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(410725),
     /* 410676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410694 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(410709), // Rule ID 1873 //
     /* 410699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410702 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 410707 */     GIR_RootConstrainSelectedInstOperands,
     /* 410708 */     // GIR_Coverage, 1873,
     /* 410708 */     GIR_Done,
     /* 410709 */   // Label 8400: @410709
     /* 410709 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(410724), // Rule ID 2504 //
     /* 410714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410717 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 410722 */     GIR_RootConstrainSelectedInstOperands,
     /* 410723 */     // GIR_Coverage, 2504,
     /* 410723 */     GIR_Done,
     /* 410724 */   // Label 8401: @410724
     /* 410724 */   GIM_Reject,
     /* 410725 */ // Label 8399: @410725
     /* 410725 */ GIM_Reject,
     /* 410726 */ // Label 8373: @410726
     /* 410726 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(410759), // Rule ID 1871 //
     /* 410731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410752 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 410757 */   GIR_RootConstrainSelectedInstOperands,
     /* 410758 */   // GIR_Coverage, 1871,
     /* 410758 */   GIR_Done,
     /* 410759 */ // Label 8402: @410759
     /* 410759 */ GIM_Reject,
     /* 410760 */ // Label 8374: @410760
     /* 410760 */ GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(410785), // Rule ID 8987 //
     /* 410765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410778 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 410783 */   GIR_RootConstrainSelectedInstOperands,
     /* 410784 */   // GIR_Coverage, 8987,
     /* 410784 */   GIR_Done,
     /* 410785 */ // Label 8403: @410785
     /* 410785 */ GIM_Reject,
     /* 410786 */ // Label 8375: @410786
     /* 410786 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(410811), // Rule ID 8963 //
     /* 410791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410804 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410809 */   GIR_RootConstrainSelectedInstOperands,
     /* 410810 */   // GIR_Coverage, 8963,
     /* 410810 */   GIR_Done,
     /* 410811 */ // Label 8404: @410811
     /* 410811 */ GIM_Reject,
     /* 410812 */ // Label 8376: @410812
     /* 410812 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(410837), // Rule ID 8964 //
     /* 410817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410830 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410835 */   GIR_RootConstrainSelectedInstOperands,
     /* 410836 */   // GIR_Coverage, 8964,
     /* 410836 */   GIR_Done,
     /* 410837 */ // Label 8405: @410837
     /* 410837 */ GIM_Reject,
     /* 410838 */ // Label 8377: @410838
     /* 410838 */ GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(410884),
     /* 410843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410853 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(410868), // Rule ID 8959 //
     /* 410858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410861 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410866 */     GIR_RootConstrainSelectedInstOperands,
     /* 410867 */     // GIR_Coverage, 8959,
     /* 410867 */     GIR_Done,
     /* 410868 */   // Label 8407: @410868
     /* 410868 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(410883), // Rule ID 8965 //
     /* 410873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410876 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410881 */     GIR_RootConstrainSelectedInstOperands,
     /* 410882 */     // GIR_Coverage, 8965,
     /* 410882 */     GIR_Done,
     /* 410883 */   // Label 8408: @410883
     /* 410883 */   GIM_Reject,
     /* 410884 */ // Label 8406: @410884
     /* 410884 */ GIM_Reject,
     /* 410885 */ // Label 8378: @410885
     /* 410885 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(410910), // Rule ID 8986 //
     /* 410890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410903 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 410908 */   GIR_RootConstrainSelectedInstOperands,
     /* 410909 */   // GIR_Coverage, 8986,
     /* 410909 */   GIR_Done,
     /* 410910 */ // Label 8409: @410910
     /* 410910 */ GIM_Reject,
     /* 410911 */ // Label 8379: @410911
     /* 410911 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(410936), // Rule ID 8961 //
     /* 410916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410929 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410934 */   GIR_RootConstrainSelectedInstOperands,
     /* 410935 */   // GIR_Coverage, 8961,
     /* 410935 */   GIR_Done,
     /* 410936 */ // Label 8410: @410936
     /* 410936 */ GIM_Reject,
     /* 410937 */ // Label 8380: @410937
     /* 410937 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(410983),
     /* 410942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 410945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 410948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410952 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(410967), // Rule ID 8958 //
     /* 410957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410960 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 410960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410965 */     GIR_RootConstrainSelectedInstOperands,
     /* 410966 */     // GIR_Coverage, 8958,
     /* 410966 */     GIR_Done,
     /* 410967 */   // Label 8412: @410967
     /* 410967 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(410982), // Rule ID 8962 //
     /* 410972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410975 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 410975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410980 */     GIR_RootConstrainSelectedInstOperands,
     /* 410981 */     // GIR_Coverage, 8962,
     /* 410981 */     GIR_Done,
     /* 410982 */   // Label 8413: @410982
     /* 410982 */   GIM_Reject,
     /* 410983 */ // Label 8411: @410983
     /* 410983 */ GIM_Reject,
     /* 410984 */ // Label 8381: @410984
     /* 410984 */ GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(411009), // Rule ID 8985 //
     /* 410989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 410995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 410998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411002 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 411007 */   GIR_RootConstrainSelectedInstOperands,
     /* 411008 */   // GIR_Coverage, 8985,
     /* 411008 */   GIR_Done,
     /* 411009 */ // Label 8414: @411009
     /* 411009 */ GIM_Reject,
     /* 411010 */ // Label 8382: @411010
     /* 411010 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(411056),
     /* 411015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411025 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(411040), // Rule ID 8957 //
     /* 411030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411033 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 411038 */     GIR_RootConstrainSelectedInstOperands,
     /* 411039 */     // GIR_Coverage, 8957,
     /* 411039 */     GIR_Done,
     /* 411040 */   // Label 8416: @411040
     /* 411040 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(411055), // Rule ID 8960 //
     /* 411045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411048 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 411053 */     GIR_RootConstrainSelectedInstOperands,
     /* 411054 */     // GIR_Coverage, 8960,
     /* 411054 */     GIR_Done,
     /* 411055 */   // Label 8417: @411055
     /* 411055 */   GIM_Reject,
     /* 411056 */ // Label 8415: @411056
     /* 411056 */ GIM_Reject,
     /* 411057 */ // Label 8383: @411057
     /* 411057 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(411082), // Rule ID 2414 //
     /* 411062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411075 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 411080 */   GIR_RootConstrainSelectedInstOperands,
     /* 411081 */   // GIR_Coverage, 2414,
     /* 411081 */   GIR_Done,
     /* 411082 */ // Label 8418: @411082
     /* 411082 */ GIM_Reject,
     /* 411083 */ // Label 8384: @411083
     /* 411083 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(411108), // Rule ID 8956 //
     /* 411088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411101 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 411106 */   GIR_RootConstrainSelectedInstOperands,
     /* 411107 */   // GIR_Coverage, 8956,
     /* 411107 */   GIR_Done,
     /* 411108 */ // Label 8419: @411108
     /* 411108 */ GIM_Reject,
     /* 411109 */ // Label 8385: @411109
     /* 411109 */ GIM_Reject,
     /* 411110 */ // Label 142: @411110
     /* 411110 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8438*/ GIMT_Encode4(411889),
     /* 411121 */ /*GILLT_v2s32*//*Label 8420*/ GIMT_Encode4(411197),
     /* 411125 */ /*GILLT_v2s64*//*Label 8421*/ GIMT_Encode4(411252),
     /* 411129 */ /*GILLT_v4s16*//*Label 8422*/ GIMT_Encode4(411307),
     /* 411133 */ /*GILLT_v4s32*//*Label 8423*/ GIMT_Encode4(411362),
     /* 411137 */ /*GILLT_v8s8*//*Label 8424*/ GIMT_Encode4(411417),
     /* 411141 */ /*GILLT_v8s16*//*Label 8425*/ GIMT_Encode4(411451),
     /* 411145 */ /*GILLT_v16s8*//*Label 8426*/ GIMT_Encode4(411506), GIMT_Encode4(0),
     /* 411153 */ /*GILLT_nxv2s1*//*Label 8427*/ GIMT_Encode4(411540),
     /* 411157 */ /*GILLT_nxv2s16*//*Label 8428*/ GIMT_Encode4(411566),
     /* 411161 */ /*GILLT_nxv2s32*//*Label 8429*/ GIMT_Encode4(411592),
     /* 411165 */ /*GILLT_nxv2s64*//*Label 8430*/ GIMT_Encode4(411618),
     /* 411169 */ /*GILLT_nxv4s1*//*Label 8431*/ GIMT_Encode4(411665),
     /* 411173 */ /*GILLT_nxv4s16*//*Label 8432*/ GIMT_Encode4(411691),
     /* 411177 */ /*GILLT_nxv4s32*//*Label 8433*/ GIMT_Encode4(411717),
     /* 411181 */ /*GILLT_nxv8s1*//*Label 8434*/ GIMT_Encode4(411764),
     /* 411185 */ /*GILLT_nxv8s16*//*Label 8435*/ GIMT_Encode4(411790),
     /* 411189 */ /*GILLT_nxv16s1*//*Label 8436*/ GIMT_Encode4(411837),
     /* 411193 */ /*GILLT_nxv16s8*//*Label 8437*/ GIMT_Encode4(411863),
     /* 411197 */ // Label 8420: @411197
     /* 411197 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(411251),
     /* 411202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411220 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(411235), // Rule ID 1881 //
     /* 411225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411228 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 411228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 411233 */     GIR_RootConstrainSelectedInstOperands,
     /* 411234 */     // GIR_Coverage, 1881,
     /* 411234 */     GIR_Done,
     /* 411235 */   // Label 8440: @411235
     /* 411235 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(411250), // Rule ID 5469 //
     /* 411240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411243 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 411248 */     GIR_RootConstrainSelectedInstOperands,
     /* 411249 */     // GIR_Coverage, 5469,
     /* 411249 */     GIR_Done,
     /* 411250 */   // Label 8441: @411250
     /* 411250 */   GIM_Reject,
     /* 411251 */ // Label 8439: @411251
     /* 411251 */ GIM_Reject,
     /* 411252 */ // Label 8421: @411252
     /* 411252 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(411306),
     /* 411257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411275 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(411290), // Rule ID 1883 //
     /* 411280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411283 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 411283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 411288 */     GIR_RootConstrainSelectedInstOperands,
     /* 411289 */     // GIR_Coverage, 1883,
     /* 411289 */     GIR_Done,
     /* 411290 */   // Label 8443: @411290
     /* 411290 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(411305), // Rule ID 5471 //
     /* 411295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411298 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 411303 */     GIR_RootConstrainSelectedInstOperands,
     /* 411304 */     // GIR_Coverage, 5471,
     /* 411304 */     GIR_Done,
     /* 411305 */   // Label 8444: @411305
     /* 411305 */   GIM_Reject,
     /* 411306 */ // Label 8442: @411306
     /* 411306 */ GIM_Reject,
     /* 411307 */ // Label 8422: @411307
     /* 411307 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(411361),
     /* 411312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411330 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(411345), // Rule ID 1879 //
     /* 411335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411338 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 411338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 411343 */     GIR_RootConstrainSelectedInstOperands,
     /* 411344 */     // GIR_Coverage, 1879,
     /* 411344 */     GIR_Done,
     /* 411345 */   // Label 8446: @411345
     /* 411345 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(411360), // Rule ID 5467 //
     /* 411350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411353 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 411353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 411358 */     GIR_RootConstrainSelectedInstOperands,
     /* 411359 */     // GIR_Coverage, 5467,
     /* 411359 */     GIR_Done,
     /* 411360 */   // Label 8447: @411360
     /* 411360 */   GIM_Reject,
     /* 411361 */ // Label 8445: @411361
     /* 411361 */ GIM_Reject,
     /* 411362 */ // Label 8423: @411362
     /* 411362 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(411416),
     /* 411367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 411373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411385 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(411400), // Rule ID 1882 //
     /* 411390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411393 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 411393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 411398 */     GIR_RootConstrainSelectedInstOperands,
     /* 411399 */     // GIR_Coverage, 1882,
     /* 411399 */     GIR_Done,
     /* 411400 */   // Label 8449: @411400
     /* 411400 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(411415), // Rule ID 5470 //
     /* 411405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411408 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 411413 */     GIR_RootConstrainSelectedInstOperands,
     /* 411414 */     // GIR_Coverage, 5470,
     /* 411414 */     GIR_Done,
     /* 411415 */   // Label 8450: @411415
     /* 411415 */   GIM_Reject,
     /* 411416 */ // Label 8448: @411416
     /* 411416 */ GIM_Reject,
     /* 411417 */ // Label 8424: @411417
     /* 411417 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(411450), // Rule ID 1877 //
     /* 411422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411443 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 411448 */   GIR_RootConstrainSelectedInstOperands,
     /* 411449 */   // GIR_Coverage, 1877,
     /* 411449 */   GIR_Done,
     /* 411450 */ // Label 8451: @411450
     /* 411450 */ GIM_Reject,
     /* 411451 */ // Label 8425: @411451
     /* 411451 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(411505),
     /* 411456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411474 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(411489), // Rule ID 1880 //
     /* 411479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411482 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 411487 */     GIR_RootConstrainSelectedInstOperands,
     /* 411488 */     // GIR_Coverage, 1880,
     /* 411488 */     GIR_Done,
     /* 411489 */   // Label 8453: @411489
     /* 411489 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(411504), // Rule ID 5468 //
     /* 411494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411497 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 411497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 411502 */     GIR_RootConstrainSelectedInstOperands,
     /* 411503 */     // GIR_Coverage, 5468,
     /* 411503 */     GIR_Done,
     /* 411504 */   // Label 8454: @411504
     /* 411504 */   GIM_Reject,
     /* 411505 */ // Label 8452: @411505
     /* 411505 */ GIM_Reject,
     /* 411506 */ // Label 8426: @411506
     /* 411506 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(411539), // Rule ID 1878 //
     /* 411511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411532 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 411537 */   GIR_RootConstrainSelectedInstOperands,
     /* 411538 */   // GIR_Coverage, 1878,
     /* 411538 */   GIR_Done,
     /* 411539 */ // Label 8455: @411539
     /* 411539 */ GIM_Reject,
     /* 411540 */ // Label 8427: @411540
     /* 411540 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(411565), // Rule ID 8990 //
     /* 411545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 411551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 411554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411558 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 411558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 411563 */   GIR_RootConstrainSelectedInstOperands,
     /* 411564 */   // GIR_Coverage, 8990,
     /* 411564 */   GIR_Done,
     /* 411565 */ // Label 8456: @411565
     /* 411565 */ GIM_Reject,
     /* 411566 */ // Label 8428: @411566
     /* 411566 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(411591), // Rule ID 8973 //
     /* 411571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 411577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 411580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411584 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 411584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411589 */   GIR_RootConstrainSelectedInstOperands,
     /* 411590 */   // GIR_Coverage, 8973,
     /* 411590 */   GIR_Done,
     /* 411591 */ // Label 8457: @411591
     /* 411591 */ GIM_Reject,
     /* 411592 */ // Label 8429: @411592
     /* 411592 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(411617), // Rule ID 8974 //
     /* 411597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 411603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 411606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411610 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 411610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411615 */   GIR_RootConstrainSelectedInstOperands,
     /* 411616 */   // GIR_Coverage, 8974,
     /* 411616 */   GIR_Done,
     /* 411617 */ // Label 8458: @411617
     /* 411617 */ GIM_Reject,
     /* 411618 */ // Label 8430: @411618
     /* 411618 */ GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(411664),
     /* 411623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 411629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411633 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(411648), // Rule ID 8969 //
     /* 411638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411641 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411646 */     GIR_RootConstrainSelectedInstOperands,
     /* 411647 */     // GIR_Coverage, 8969,
     /* 411647 */     GIR_Done,
     /* 411648 */   // Label 8460: @411648
     /* 411648 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(411663), // Rule ID 8975 //
     /* 411653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411656 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411661 */     GIR_RootConstrainSelectedInstOperands,
     /* 411662 */     // GIR_Coverage, 8975,
     /* 411662 */     GIR_Done,
     /* 411663 */   // Label 8461: @411663
     /* 411663 */   GIM_Reject,
     /* 411664 */ // Label 8459: @411664
     /* 411664 */ GIM_Reject,
     /* 411665 */ // Label 8431: @411665
     /* 411665 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(411690), // Rule ID 8989 //
     /* 411670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411683 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 411688 */   GIR_RootConstrainSelectedInstOperands,
     /* 411689 */   // GIR_Coverage, 8989,
     /* 411689 */   GIR_Done,
     /* 411690 */ // Label 8462: @411690
     /* 411690 */ GIM_Reject,
     /* 411691 */ // Label 8432: @411691
     /* 411691 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(411716), // Rule ID 8971 //
     /* 411696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411709 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411714 */   GIR_RootConstrainSelectedInstOperands,
     /* 411715 */   // GIR_Coverage, 8971,
     /* 411715 */   GIR_Done,
     /* 411716 */ // Label 8463: @411716
     /* 411716 */ GIM_Reject,
     /* 411717 */ // Label 8433: @411717
     /* 411717 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(411763),
     /* 411722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411732 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(411747), // Rule ID 8968 //
     /* 411737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411740 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411745 */     GIR_RootConstrainSelectedInstOperands,
     /* 411746 */     // GIR_Coverage, 8968,
     /* 411746 */     GIR_Done,
     /* 411747 */   // Label 8465: @411747
     /* 411747 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(411762), // Rule ID 8972 //
     /* 411752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411755 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411760 */     GIR_RootConstrainSelectedInstOperands,
     /* 411761 */     // GIR_Coverage, 8972,
     /* 411761 */     GIR_Done,
     /* 411762 */   // Label 8466: @411762
     /* 411762 */   GIM_Reject,
     /* 411763 */ // Label 8464: @411763
     /* 411763 */ GIM_Reject,
     /* 411764 */ // Label 8434: @411764
     /* 411764 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(411789), // Rule ID 8988 //
     /* 411769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411782 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 411787 */   GIR_RootConstrainSelectedInstOperands,
     /* 411788 */   // GIR_Coverage, 8988,
     /* 411788 */   GIR_Done,
     /* 411789 */ // Label 8467: @411789
     /* 411789 */ GIM_Reject,
     /* 411790 */ // Label 8435: @411790
     /* 411790 */ GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(411836),
     /* 411795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411805 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(411820), // Rule ID 8967 //
     /* 411810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411813 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 411818 */     GIR_RootConstrainSelectedInstOperands,
     /* 411819 */     // GIR_Coverage, 8967,
     /* 411819 */     GIR_Done,
     /* 411820 */   // Label 8469: @411820
     /* 411820 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(411835), // Rule ID 8970 //
     /* 411825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411828 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 411833 */     GIR_RootConstrainSelectedInstOperands,
     /* 411834 */     // GIR_Coverage, 8970,
     /* 411834 */     GIR_Done,
     /* 411835 */   // Label 8470: @411835
     /* 411835 */   GIM_Reject,
     /* 411836 */ // Label 8468: @411836
     /* 411836 */ GIM_Reject,
     /* 411837 */ // Label 8436: @411837
     /* 411837 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(411862), // Rule ID 2418 //
     /* 411842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411855 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 411860 */   GIR_RootConstrainSelectedInstOperands,
     /* 411861 */   // GIR_Coverage, 2418,
     /* 411861 */   GIR_Done,
     /* 411862 */ // Label 8471: @411862
     /* 411862 */ GIM_Reject,
     /* 411863 */ // Label 8437: @411863
     /* 411863 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(411888), // Rule ID 8966 //
     /* 411868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411881 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 411886 */   GIR_RootConstrainSelectedInstOperands,
     /* 411887 */   // GIR_Coverage, 8966,
     /* 411887 */   GIR_Done,
     /* 411888 */ // Label 8472: @411888
     /* 411888 */ GIM_Reject,
     /* 411889 */ // Label 8438: @411889
     /* 411889 */ GIM_Reject,
     /* 411890 */ // Label 143: @411890
     /* 411890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8479*/ GIMT_Encode4(412095),
     /* 411901 */ /*GILLT_s64*//*Label 8473*/ GIMT_Encode4(411933), GIMT_Encode4(0),
     /* 411909 */ /*GILLT_v2s32*//*Label 8474*/ GIMT_Encode4(411960),
     /* 411913 */ /*GILLT_v2s64*//*Label 8475*/ GIMT_Encode4(411987),
     /* 411917 */ /*GILLT_v4s16*//*Label 8476*/ GIMT_Encode4(412014),
     /* 411921 */ /*GILLT_v4s32*//*Label 8477*/ GIMT_Encode4(412041), GIMT_Encode4(0),
     /* 411929 */ /*GILLT_v8s16*//*Label 8478*/ GIMT_Encode4(412068),
     /* 411933 */ // Label 8473: @411933
     /* 411933 */ GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(411959), // Rule ID 1069 //
     /* 411938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411952 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 411952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 411957 */   GIR_RootConstrainSelectedInstOperands,
     /* 411958 */   // GIR_Coverage, 1069,
     /* 411958 */   GIR_Done,
     /* 411959 */ // Label 8480: @411959
     /* 411959 */ GIM_Reject,
     /* 411960 */ // Label 8474: @411960
     /* 411960 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(411986), // Rule ID 1065 //
     /* 411965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411979 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 411979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 411984 */   GIR_RootConstrainSelectedInstOperands,
     /* 411985 */   // GIR_Coverage, 1065,
     /* 411985 */   GIR_Done,
     /* 411986 */ // Label 8481: @411986
     /* 411986 */ GIM_Reject,
     /* 411987 */ // Label 8475: @411987
     /* 411987 */ GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(412013), // Rule ID 1071 //
     /* 411992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412006 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 412006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 412011 */   GIR_RootConstrainSelectedInstOperands,
     /* 412012 */   // GIR_Coverage, 1071,
     /* 412012 */   GIR_Done,
     /* 412013 */ // Label 8482: @412013
     /* 412013 */ GIM_Reject,
     /* 412014 */ // Label 8476: @412014
     /* 412014 */ GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(412040), // Rule ID 1061 //
     /* 412019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412033 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 412033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 412038 */   GIR_RootConstrainSelectedInstOperands,
     /* 412039 */   // GIR_Coverage, 1061,
     /* 412039 */   GIR_Done,
     /* 412040 */ // Label 8483: @412040
     /* 412040 */ GIM_Reject,
     /* 412041 */ // Label 8477: @412041
     /* 412041 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(412067), // Rule ID 1067 //
     /* 412046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412060 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 412060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 412065 */   GIR_RootConstrainSelectedInstOperands,
     /* 412066 */   // GIR_Coverage, 1067,
     /* 412066 */   GIR_Done,
     /* 412067 */ // Label 8484: @412067
     /* 412067 */ GIM_Reject,
     /* 412068 */ // Label 8478: @412068
     /* 412068 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(412094), // Rule ID 1063 //
     /* 412073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412087 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 412087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 412092 */   GIR_RootConstrainSelectedInstOperands,
     /* 412093 */   // GIR_Coverage, 1063,
     /* 412093 */   GIR_Done,
     /* 412094 */ // Label 8485: @412094
     /* 412094 */ GIM_Reject,
     /* 412095 */ // Label 8479: @412095
     /* 412095 */ GIM_Reject,
     /* 412096 */ // Label 144: @412096
     /* 412096 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8488*/ GIMT_Encode4(412962),
     /* 412107 */ /*GILLT_v2s64*//*Label 8486*/ GIMT_Encode4(412119), GIMT_Encode4(0),
     /* 412115 */ /*GILLT_v4s32*//*Label 8487*/ GIMT_Encode4(412413),
     /* 412119 */ // Label 8486: @412119
     /* 412119 */ GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(412201), // Rule ID 5868 //
     /* 412124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412139 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412142 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412147 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 412151 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412158 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 412158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412170 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412200 */   // GIR_Coverage, 5868,
     /* 412200 */   GIR_EraseRootFromParent_Done,
     /* 412201 */ // Label 8489: @412201
     /* 412201 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(412275), // Rule ID 5867 //
     /* 412206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412225 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412232 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 412232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412244 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412274 */   // GIR_Coverage, 5867,
     /* 412274 */   GIR_EraseRootFromParent_Done,
     /* 412275 */ // Label 8490: @412275
     /* 412275 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(412334), // Rule ID 5877 //
     /* 412280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412291 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 412291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 412294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 412298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412303 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 412323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412333 */   // GIR_Coverage, 5877,
     /* 412333 */   GIR_EraseRootFromParent_Done,
     /* 412334 */ // Label 8491: @412334
     /* 412334 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(412412), // Rule ID 6005 //
     /* 412339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412350 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 412350 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 412353 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 412357 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412362 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 412368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 412371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 412375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 412385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 412393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 412396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412411 */   // GIR_Coverage, 6005,
     /* 412411 */   GIR_EraseRootFromParent_Done,
     /* 412412 */ // Label 8492: @412412
     /* 412412 */ GIM_Reject,
     /* 412413 */ // Label 8487: @412413
     /* 412413 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(412495), // Rule ID 5870 //
     /* 412418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412433 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412436 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412441 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 412445 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412450 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412452 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 412452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412494 */   // GIR_Coverage, 5870,
     /* 412494 */   GIR_EraseRootFromParent_Done,
     /* 412495 */ // Label 8493: @412495
     /* 412495 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(412577), // Rule ID 5872 //
     /* 412500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412515 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412518 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 412527 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412534 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 412534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412576 */   // GIR_Coverage, 5872,
     /* 412576 */   GIR_EraseRootFromParent_Done,
     /* 412577 */ // Label 8494: @412577
     /* 412577 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(412651), // Rule ID 5869 //
     /* 412582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412601 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412608 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 412608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412620 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412650 */   // GIR_Coverage, 5869,
     /* 412650 */   GIR_EraseRootFromParent_Done,
     /* 412651 */ // Label 8495: @412651
     /* 412651 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(412725), // Rule ID 5871 //
     /* 412656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412671 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412675 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412682 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 412682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412724 */   // GIR_Coverage, 5871,
     /* 412724 */   GIR_EraseRootFromParent_Done,
     /* 412725 */ // Label 8496: @412725
     /* 412725 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(412784), // Rule ID 5873 //
     /* 412730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412741 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 412741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412783 */   // GIR_Coverage, 5873,
     /* 412783 */   GIR_EraseRootFromParent_Done,
     /* 412784 */ // Label 8497: @412784
     /* 412784 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(412843), // Rule ID 5874 //
     /* 412789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412800 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 412800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 412807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412812 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412842 */   // GIR_Coverage, 5874,
     /* 412842 */   GIR_EraseRootFromParent_Done,
     /* 412843 */ // Label 8498: @412843
     /* 412843 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(412902), // Rule ID 5875 //
     /* 412848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412859 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 412859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412901 */   // GIR_Coverage, 5875,
     /* 412901 */   GIR_EraseRootFromParent_Done,
     /* 412902 */ // Label 8499: @412902
     /* 412902 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(412961), // Rule ID 5876 //
     /* 412907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412918 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 412918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412960 */   // GIR_Coverage, 5876,
     /* 412960 */   GIR_EraseRootFromParent_Done,
     /* 412961 */ // Label 8500: @412961
     /* 412961 */ GIM_Reject,
     /* 412962 */ // Label 8488: @412962
     /* 412962 */ GIM_Reject,
     /* 412963 */ // Label 145: @412963
     /* 412963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8505*/ GIMT_Encode4(413332),
     /* 412974 */ /*GILLT_v2s32*//*Label 8501*/ GIMT_Encode4(413034), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 412986 */ /*GILLT_v4s32*//*Label 8502*/ GIMT_Encode4(413154), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 413018 */ /*GILLT_nxv2s64*//*Label 8503*/ GIMT_Encode4(413274), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 413030 */ /*GILLT_nxv4s32*//*Label 8504*/ GIMT_Encode4(413303),
     /* 413034 */ // Label 8501: @413034
     /* 413034 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(413153),
     /* 413039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 413048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413060 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(413133), // Rule ID 28 //
     /* 413065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 413072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 413076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413109 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413113 */     // MIs[3] Operand 1
     /* 413113 */     // No operand predicates
     /* 413113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413115 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 413118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 413122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413131 */     GIR_RootConstrainSelectedInstOperands,
     /* 413132 */     // GIR_Coverage, 28,
     /* 413132 */     GIR_EraseRootFromParent_Done,
     /* 413133 */   // Label 8507: @413133
     /* 413133 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(413152), // Rule ID 24 //
     /* 413138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413145 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 413150 */     GIR_RootConstrainSelectedInstOperands,
     /* 413151 */     // GIR_Coverage, 24,
     /* 413151 */     GIR_Done,
     /* 413152 */   // Label 8508: @413152
     /* 413152 */   GIM_Reject,
     /* 413153 */ // Label 8506: @413153
     /* 413153 */ GIM_Reject,
     /* 413154 */ // Label 8502: @413154
     /* 413154 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(413273),
     /* 413159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 413168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413180 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(413253), // Rule ID 29 //
     /* 413185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 413192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 413196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413229 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413233 */     // MIs[3] Operand 1
     /* 413233 */     // No operand predicates
     /* 413233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413235 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 413238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 413242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413251 */     GIR_RootConstrainSelectedInstOperands,
     /* 413252 */     // GIR_Coverage, 29,
     /* 413252 */     GIR_EraseRootFromParent_Done,
     /* 413253 */   // Label 8510: @413253
     /* 413253 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(413272), // Rule ID 25 //
     /* 413258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413265 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 413270 */     GIR_RootConstrainSelectedInstOperands,
     /* 413271 */     // GIR_Coverage, 25,
     /* 413271 */     GIR_Done,
     /* 413272 */   // Label 8511: @413272
     /* 413272 */   GIM_Reject,
     /* 413273 */ // Label 8509: @413273
     /* 413273 */ GIM_Reject,
     /* 413274 */ // Label 8503: @413274
     /* 413274 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(413302), // Rule ID 7673 //
     /* 413279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 413291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413295 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 413295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 413300 */   GIR_RootConstrainSelectedInstOperands,
     /* 413301 */   // GIR_Coverage, 7673,
     /* 413301 */   GIR_Done,
     /* 413302 */ // Label 8512: @413302
     /* 413302 */ GIM_Reject,
     /* 413303 */ // Label 8504: @413303
     /* 413303 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(413331), // Rule ID 7672 //
     /* 413308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 413320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413324 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 413324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 413329 */   GIR_RootConstrainSelectedInstOperands,
     /* 413330 */   // GIR_Coverage, 7672,
     /* 413330 */   GIR_Done,
     /* 413331 */ // Label 8513: @413331
     /* 413331 */ GIM_Reject,
     /* 413332 */ // Label 8505: @413332
     /* 413332 */ GIM_Reject,
     /* 413333 */ // Label 146: @413333
     /* 413333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8517*/ GIMT_Encode4(413449),
     /* 413344 */ /*GILLT_s16*//*Label 8514*/ GIMT_Encode4(413356),
     /* 413348 */ /*GILLT_s32*//*Label 8515*/ GIMT_Encode4(413387),
     /* 413352 */ /*GILLT_s64*//*Label 8516*/ GIMT_Encode4(413418),
     /* 413356 */ // Label 8514: @413356
     /* 413356 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(413386), // Rule ID 1669 //
     /* 413361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 413364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 413367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 413371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 413375 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 413375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 413380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413384 */   GIR_RootConstrainSelectedInstOperands,
     /* 413385 */   // GIR_Coverage, 1669,
     /* 413385 */   GIR_Done,
     /* 413386 */ // Label 8518: @413386
     /* 413386 */ GIM_Reject,
     /* 413387 */ // Label 8515: @413387
     /* 413387 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(413417), // Rule ID 1668 //
     /* 413392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 413395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 413398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413406 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 413406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 413411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413415 */   GIR_RootConstrainSelectedInstOperands,
     /* 413416 */   // GIR_Coverage, 1668,
     /* 413416 */   GIR_Done,
     /* 413417 */ // Label 8519: @413417
     /* 413417 */ GIM_Reject,
     /* 413418 */ // Label 8516: @413418
     /* 413418 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(413448), // Rule ID 1667 //
     /* 413423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 413426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 413429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413437 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 413437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 413442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413446 */   GIR_RootConstrainSelectedInstOperands,
     /* 413447 */   // GIR_Coverage, 1667,
     /* 413447 */   GIR_Done,
     /* 413448 */ // Label 8520: @413448
     /* 413448 */ GIM_Reject,
     /* 413449 */ // Label 8517: @413449
     /* 413449 */ GIM_Reject,
     /* 413450 */ // Label 147: @413450
     /* 413450 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8524*/ GIMT_Encode4(414682),
     /* 413461 */ /*GILLT_v2s64*//*Label 8521*/ GIMT_Encode4(413481), GIMT_Encode4(0),
     /* 413469 */ /*GILLT_v4s32*//*Label 8522*/ GIMT_Encode4(414042), GIMT_Encode4(0),
     /* 413477 */ /*GILLT_v8s16*//*Label 8523*/ GIMT_Encode4(414603),
     /* 413481 */ // Label 8521: @413481
     /* 413481 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(414041),
     /* 413486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413496 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(413588), // Rule ID 2106 //
     /* 413501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413549 */     // MIs[3] Operand 1
     /* 413549 */     // No operand predicates
     /* 413549 */     // MIs[1] Operand 2
     /* 413549 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 413560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413569 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 413572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413586 */     GIR_RootConstrainSelectedInstOperands,
     /* 413587 */     // GIR_Coverage, 2106,
     /* 413587 */     GIR_EraseRootFromParent_Done,
     /* 413588 */   // Label 8526: @413588
     /* 413588 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(413680), // Rule ID 13554 //
     /* 413593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413641 */     // MIs[3] Operand 1
     /* 413641 */     // No operand predicates
     /* 413641 */     // MIs[1] Operand 2
     /* 413641 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 413652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413661 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 413664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413678 */     GIR_RootConstrainSelectedInstOperands,
     /* 413679 */     // GIR_Coverage, 13554,
     /* 413679 */     GIR_EraseRootFromParent_Done,
     /* 413680 */   // Label 8527: @413680
     /* 413680 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(413766), // Rule ID 13552 //
     /* 413685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413729 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413733 */     // MIs[3] Operand 1
     /* 413733 */     // No operand predicates
     /* 413733 */     // MIs[1] Operand 2
     /* 413733 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 413744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413750 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413764 */     GIR_RootConstrainSelectedInstOperands,
     /* 413765 */     // GIR_Coverage, 13552,
     /* 413765 */     GIR_EraseRootFromParent_Done,
     /* 413766 */   // Label 8528: @413766
     /* 413766 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(413852), // Rule ID 2104 //
     /* 413771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413819 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413823 */     // MIs[3] Operand 1
     /* 413823 */     // No operand predicates
     /* 413823 */     // MIs[1] Operand 2
     /* 413823 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 413834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413836 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413850 */     GIR_RootConstrainSelectedInstOperands,
     /* 413851 */     // GIR_Coverage, 2104,
     /* 413851 */     GIR_EraseRootFromParent_Done,
     /* 413852 */   // Label 8529: @413852
     /* 413852 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(413891), // Rule ID 1831 //
     /* 413857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413874 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 413877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 413889 */     GIR_RootConstrainSelectedInstOperands,
     /* 413890 */     // GIR_Coverage, 1831,
     /* 413890 */     GIR_EraseRootFromParent_Done,
     /* 413891 */   // Label 8530: @413891
     /* 413891 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(413954), // Rule ID 13553 //
     /* 413896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413932 */     // MIs[2] Operand 1
     /* 413932 */     // No operand predicates
     /* 413932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413938 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413952 */     GIR_RootConstrainSelectedInstOperands,
     /* 413953 */     // GIR_Coverage, 13553,
     /* 413953 */     GIR_EraseRootFromParent_Done,
     /* 413954 */   // Label 8531: @413954
     /* 413954 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(414017), // Rule ID 2105 //
     /* 413959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413999 */     // MIs[2] Operand 1
     /* 413999 */     // No operand predicates
     /* 413999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414001 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 414004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414015 */     GIR_RootConstrainSelectedInstOperands,
     /* 414016 */     // GIR_Coverage, 2105,
     /* 414016 */     GIR_EraseRootFromParent_Done,
     /* 414017 */   // Label 8532: @414017
     /* 414017 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(414040), // Rule ID 1830 //
     /* 414022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414033 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 414038 */     GIR_RootConstrainSelectedInstOperands,
     /* 414039 */     // GIR_Coverage, 1830,
     /* 414039 */     GIR_Done,
     /* 414040 */   // Label 8533: @414040
     /* 414040 */   GIM_Reject,
     /* 414041 */ // Label 8525: @414041
     /* 414041 */ GIM_Reject,
     /* 414042 */ // Label 8522: @414042
     /* 414042 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(414602),
     /* 414047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414057 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(414149), // Rule ID 2103 //
     /* 414062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414110 */     // MIs[3] Operand 1
     /* 414110 */     // No operand predicates
     /* 414110 */     // MIs[1] Operand 2
     /* 414110 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 414121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414130 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 414133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414147 */     GIR_RootConstrainSelectedInstOperands,
     /* 414148 */     // GIR_Coverage, 2103,
     /* 414148 */     GIR_EraseRootFromParent_Done,
     /* 414149 */   // Label 8535: @414149
     /* 414149 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(414241), // Rule ID 13551 //
     /* 414154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414202 */     // MIs[3] Operand 1
     /* 414202 */     // No operand predicates
     /* 414202 */     // MIs[1] Operand 2
     /* 414202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 414213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414222 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 414225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414239 */     GIR_RootConstrainSelectedInstOperands,
     /* 414240 */     // GIR_Coverage, 13551,
     /* 414240 */     GIR_EraseRootFromParent_Done,
     /* 414241 */   // Label 8536: @414241
     /* 414241 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(414327), // Rule ID 13549 //
     /* 414246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414290 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414294 */     // MIs[3] Operand 1
     /* 414294 */     // No operand predicates
     /* 414294 */     // MIs[1] Operand 2
     /* 414294 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 414305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414311 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414325 */     GIR_RootConstrainSelectedInstOperands,
     /* 414326 */     // GIR_Coverage, 13549,
     /* 414326 */     GIR_EraseRootFromParent_Done,
     /* 414327 */   // Label 8537: @414327
     /* 414327 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(414413), // Rule ID 2101 //
     /* 414332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414384 */     // MIs[3] Operand 1
     /* 414384 */     // No operand predicates
     /* 414384 */     // MIs[1] Operand 2
     /* 414384 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 414395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414397 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414411 */     GIR_RootConstrainSelectedInstOperands,
     /* 414412 */     // GIR_Coverage, 2101,
     /* 414412 */     GIR_EraseRootFromParent_Done,
     /* 414413 */   // Label 8538: @414413
     /* 414413 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(414452), // Rule ID 1829 //
     /* 414418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414435 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 414435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 414438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 414450 */     GIR_RootConstrainSelectedInstOperands,
     /* 414451 */     // GIR_Coverage, 1829,
     /* 414451 */     GIR_EraseRootFromParent_Done,
     /* 414452 */   // Label 8539: @414452
     /* 414452 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(414515), // Rule ID 13550 //
     /* 414457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414493 */     // MIs[2] Operand 1
     /* 414493 */     // No operand predicates
     /* 414493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414499 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414513 */     GIR_RootConstrainSelectedInstOperands,
     /* 414514 */     // GIR_Coverage, 13550,
     /* 414514 */     GIR_EraseRootFromParent_Done,
     /* 414515 */   // Label 8540: @414515
     /* 414515 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(414578), // Rule ID 2102 //
     /* 414520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414560 */     // MIs[2] Operand 1
     /* 414560 */     // No operand predicates
     /* 414560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414562 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414576 */     GIR_RootConstrainSelectedInstOperands,
     /* 414577 */     // GIR_Coverage, 2102,
     /* 414577 */     GIR_EraseRootFromParent_Done,
     /* 414578 */   // Label 8541: @414578
     /* 414578 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(414601), // Rule ID 1828 //
     /* 414583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414594 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 414599 */     GIR_RootConstrainSelectedInstOperands,
     /* 414600 */     // GIR_Coverage, 1828,
     /* 414600 */     GIR_Done,
     /* 414601 */   // Label 8542: @414601
     /* 414601 */   GIM_Reject,
     /* 414602 */ // Label 8534: @414602
     /* 414602 */ GIM_Reject,
     /* 414603 */ // Label 8523: @414603
     /* 414603 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(414681),
     /* 414608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414618 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(414657), // Rule ID 1827 //
     /* 414623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 414633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 414640 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 414640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 414643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 414655 */     GIR_RootConstrainSelectedInstOperands,
     /* 414656 */     // GIR_Coverage, 1827,
     /* 414656 */     GIR_EraseRootFromParent_Done,
     /* 414657 */   // Label 8544: @414657
     /* 414657 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(414680), // Rule ID 1826 //
     /* 414662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414673 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 414673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 414678 */     GIR_RootConstrainSelectedInstOperands,
     /* 414679 */     // GIR_Coverage, 1826,
     /* 414679 */     GIR_Done,
     /* 414680 */   // Label 8545: @414680
     /* 414680 */   GIM_Reject,
     /* 414681 */ // Label 8543: @414681
     /* 414681 */ GIM_Reject,
     /* 414682 */ // Label 8524: @414682
     /* 414682 */ GIM_Reject,
     /* 414683 */ // Label 148: @414683
     /* 414683 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8564*/ GIMT_Encode4(415462),
     /* 414694 */ /*GILLT_v2s32*//*Label 8546*/ GIMT_Encode4(414770),
     /* 414698 */ /*GILLT_v2s64*//*Label 8547*/ GIMT_Encode4(414825),
     /* 414702 */ /*GILLT_v4s16*//*Label 8548*/ GIMT_Encode4(414880),
     /* 414706 */ /*GILLT_v4s32*//*Label 8549*/ GIMT_Encode4(414935),
     /* 414710 */ /*GILLT_v8s8*//*Label 8550*/ GIMT_Encode4(414990),
     /* 414714 */ /*GILLT_v8s16*//*Label 8551*/ GIMT_Encode4(415024),
     /* 414718 */ /*GILLT_v16s8*//*Label 8552*/ GIMT_Encode4(415079), GIMT_Encode4(0),
     /* 414726 */ /*GILLT_nxv2s1*//*Label 8553*/ GIMT_Encode4(415113),
     /* 414730 */ /*GILLT_nxv2s16*//*Label 8554*/ GIMT_Encode4(415139),
     /* 414734 */ /*GILLT_nxv2s32*//*Label 8555*/ GIMT_Encode4(415165),
     /* 414738 */ /*GILLT_nxv2s64*//*Label 8556*/ GIMT_Encode4(415191),
     /* 414742 */ /*GILLT_nxv4s1*//*Label 8557*/ GIMT_Encode4(415238),
     /* 414746 */ /*GILLT_nxv4s16*//*Label 8558*/ GIMT_Encode4(415264),
     /* 414750 */ /*GILLT_nxv4s32*//*Label 8559*/ GIMT_Encode4(415290),
     /* 414754 */ /*GILLT_nxv8s1*//*Label 8560*/ GIMT_Encode4(415337),
     /* 414758 */ /*GILLT_nxv8s16*//*Label 8561*/ GIMT_Encode4(415363),
     /* 414762 */ /*GILLT_nxv16s1*//*Label 8562*/ GIMT_Encode4(415410),
     /* 414766 */ /*GILLT_nxv16s8*//*Label 8563*/ GIMT_Encode4(415436),
     /* 414770 */ // Label 8546: @414770
     /* 414770 */ GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(414824),
     /* 414775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 414781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414793 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(414808), // Rule ID 1888 //
     /* 414798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414801 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 414806 */     GIR_RootConstrainSelectedInstOperands,
     /* 414807 */     // GIR_Coverage, 1888,
     /* 414807 */     GIR_Done,
     /* 414808 */   // Label 8566: @414808
     /* 414808 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(414823), // Rule ID 5474 //
     /* 414813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414816 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 414816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 414821 */     GIR_RootConstrainSelectedInstOperands,
     /* 414822 */     // GIR_Coverage, 5474,
     /* 414822 */     GIR_Done,
     /* 414823 */   // Label 8567: @414823
     /* 414823 */   GIM_Reject,
     /* 414824 */ // Label 8565: @414824
     /* 414824 */ GIM_Reject,
     /* 414825 */ // Label 8547: @414825
     /* 414825 */ GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(414879),
     /* 414830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 414836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414848 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(414863), // Rule ID 1890 //
     /* 414853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414856 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 414856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 414861 */     GIR_RootConstrainSelectedInstOperands,
     /* 414862 */     // GIR_Coverage, 1890,
     /* 414862 */     GIR_Done,
     /* 414863 */   // Label 8569: @414863
     /* 414863 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(414878), // Rule ID 5476 //
     /* 414868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414871 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 414876 */     GIR_RootConstrainSelectedInstOperands,
     /* 414877 */     // GIR_Coverage, 5476,
     /* 414877 */     GIR_Done,
     /* 414878 */   // Label 8570: @414878
     /* 414878 */   GIM_Reject,
     /* 414879 */ // Label 8568: @414879
     /* 414879 */ GIM_Reject,
     /* 414880 */ // Label 8548: @414880
     /* 414880 */ GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(414934),
     /* 414885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414903 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(414918), // Rule ID 1886 //
     /* 414908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414911 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 414916 */     GIR_RootConstrainSelectedInstOperands,
     /* 414917 */     // GIR_Coverage, 1886,
     /* 414917 */     GIR_Done,
     /* 414918 */   // Label 8572: @414918
     /* 414918 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(414933), // Rule ID 5472 //
     /* 414923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414926 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 414931 */     GIR_RootConstrainSelectedInstOperands,
     /* 414932 */     // GIR_Coverage, 5472,
     /* 414932 */     GIR_Done,
     /* 414933 */   // Label 8573: @414933
     /* 414933 */   GIM_Reject,
     /* 414934 */ // Label 8571: @414934
     /* 414934 */ GIM_Reject,
     /* 414935 */ // Label 8549: @414935
     /* 414935 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(414989),
     /* 414940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414958 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(414973), // Rule ID 1889 //
     /* 414963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414966 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 414966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 414971 */     GIR_RootConstrainSelectedInstOperands,
     /* 414972 */     // GIR_Coverage, 1889,
     /* 414972 */     GIR_Done,
     /* 414973 */   // Label 8575: @414973
     /* 414973 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(414988), // Rule ID 5475 //
     /* 414978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414981 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 414986 */     GIR_RootConstrainSelectedInstOperands,
     /* 414987 */     // GIR_Coverage, 5475,
     /* 414987 */     GIR_Done,
     /* 414988 */   // Label 8576: @414988
     /* 414988 */   GIM_Reject,
     /* 414989 */ // Label 8574: @414989
     /* 414989 */ GIM_Reject,
     /* 414990 */ // Label 8550: @414990
     /* 414990 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(415023), // Rule ID 1884 //
     /* 414995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 415001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 415004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415016 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 415016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 415021 */   GIR_RootConstrainSelectedInstOperands,
     /* 415022 */   // GIR_Coverage, 1884,
     /* 415022 */   GIR_Done,
     /* 415023 */ // Label 8577: @415023
     /* 415023 */ GIM_Reject,
     /* 415024 */ // Label 8551: @415024
     /* 415024 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(415078),
     /* 415029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415047 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(415062), // Rule ID 1887 //
     /* 415052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415055 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 415055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 415060 */     GIR_RootConstrainSelectedInstOperands,
     /* 415061 */     // GIR_Coverage, 1887,
     /* 415061 */     GIR_Done,
     /* 415062 */   // Label 8579: @415062
     /* 415062 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(415077), // Rule ID 5473 //
     /* 415067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415070 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 415075 */     GIR_RootConstrainSelectedInstOperands,
     /* 415076 */     // GIR_Coverage, 5473,
     /* 415076 */     GIR_Done,
     /* 415077 */   // Label 8580: @415077
     /* 415077 */   GIM_Reject,
     /* 415078 */ // Label 8578: @415078
     /* 415078 */ GIM_Reject,
     /* 415079 */ // Label 8552: @415079
     /* 415079 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(415112), // Rule ID 1885 //
     /* 415084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 415093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415105 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 415105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 415110 */   GIR_RootConstrainSelectedInstOperands,
     /* 415111 */   // GIR_Coverage, 1885,
     /* 415111 */   GIR_Done,
     /* 415112 */ // Label 8581: @415112
     /* 415112 */ GIM_Reject,
     /* 415113 */ // Label 8553: @415113
     /* 415113 */ GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(415138), // Rule ID 8981 //
     /* 415118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 415124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 415127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415131 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 415131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 415136 */   GIR_RootConstrainSelectedInstOperands,
     /* 415137 */   // GIR_Coverage, 8981,
     /* 415137 */   GIR_Done,
     /* 415138 */ // Label 8582: @415138
     /* 415138 */ GIM_Reject,
     /* 415139 */ // Label 8554: @415139
     /* 415139 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(415164), // Rule ID 8943 //
     /* 415144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 415150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 415153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415157 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 415157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415162 */   GIR_RootConstrainSelectedInstOperands,
     /* 415163 */   // GIR_Coverage, 8943,
     /* 415163 */   GIR_Done,
     /* 415164 */ // Label 8583: @415164
     /* 415164 */ GIM_Reject,
     /* 415165 */ // Label 8555: @415165
     /* 415165 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(415190), // Rule ID 8944 //
     /* 415170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 415176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 415179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415183 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 415183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415188 */   GIR_RootConstrainSelectedInstOperands,
     /* 415189 */   // GIR_Coverage, 8944,
     /* 415189 */   GIR_Done,
     /* 415190 */ // Label 8584: @415190
     /* 415190 */ GIM_Reject,
     /* 415191 */ // Label 8556: @415191
     /* 415191 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(415237),
     /* 415196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 415199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 415202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415206 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(415221), // Rule ID 8939 //
     /* 415211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415214 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 415214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415219 */     GIR_RootConstrainSelectedInstOperands,
     /* 415220 */     // GIR_Coverage, 8939,
     /* 415220 */     GIR_Done,
     /* 415221 */   // Label 8586: @415221
     /* 415221 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(415236), // Rule ID 8945 //
     /* 415226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415229 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 415229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415234 */     GIR_RootConstrainSelectedInstOperands,
     /* 415235 */     // GIR_Coverage, 8945,
     /* 415235 */     GIR_Done,
     /* 415236 */   // Label 8587: @415236
     /* 415236 */   GIM_Reject,
     /* 415237 */ // Label 8585: @415237
     /* 415237 */ GIM_Reject,
     /* 415238 */ // Label 8557: @415238
     /* 415238 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(415263), // Rule ID 8980 //
     /* 415243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 415249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 415252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415256 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 415256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 415261 */   GIR_RootConstrainSelectedInstOperands,
     /* 415262 */   // GIR_Coverage, 8980,
     /* 415262 */   GIR_Done,
     /* 415263 */ // Label 8588: @415263
     /* 415263 */ GIM_Reject,
     /* 415264 */ // Label 8558: @415264
     /* 415264 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(415289), // Rule ID 8941 //
     /* 415269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 415275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 415278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415282 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 415282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415287 */   GIR_RootConstrainSelectedInstOperands,
     /* 415288 */   // GIR_Coverage, 8941,
     /* 415288 */   GIR_Done,
     /* 415289 */ // Label 8589: @415289
     /* 415289 */ GIM_Reject,
     /* 415290 */ // Label 8559: @415290
     /* 415290 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(415336),
     /* 415295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 415298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 415301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415305 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(415320), // Rule ID 8938 //
     /* 415310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415313 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 415313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415318 */     GIR_RootConstrainSelectedInstOperands,
     /* 415319 */     // GIR_Coverage, 8938,
     /* 415319 */     GIR_Done,
     /* 415320 */   // Label 8591: @415320
     /* 415320 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(415335), // Rule ID 8942 //
     /* 415325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415328 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 415328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415333 */     GIR_RootConstrainSelectedInstOperands,
     /* 415334 */     // GIR_Coverage, 8942,
     /* 415334 */     GIR_Done,
     /* 415335 */   // Label 8592: @415335
     /* 415335 */   GIM_Reject,
     /* 415336 */ // Label 8590: @415336
     /* 415336 */ GIM_Reject,
     /* 415337 */ // Label 8560: @415337
     /* 415337 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(415362), // Rule ID 8979 //
     /* 415342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 415348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 415351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415355 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 415355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 415360 */   GIR_RootConstrainSelectedInstOperands,
     /* 415361 */   // GIR_Coverage, 8979,
     /* 415361 */   GIR_Done,
     /* 415362 */ // Label 8593: @415362
     /* 415362 */ GIM_Reject,
     /* 415363 */ // Label 8561: @415363
     /* 415363 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(415409),
     /* 415368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 415371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 415374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415378 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(415393), // Rule ID 8937 //
     /* 415383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415386 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 415386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 415391 */     GIR_RootConstrainSelectedInstOperands,
     /* 415392 */     // GIR_Coverage, 8937,
     /* 415392 */     GIR_Done,
     /* 415393 */   // Label 8595: @415393
     /* 415393 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(415408), // Rule ID 8940 //
     /* 415398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415401 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 415401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 415406 */     GIR_RootConstrainSelectedInstOperands,
     /* 415407 */     // GIR_Coverage, 8940,
     /* 415407 */     GIR_Done,
     /* 415408 */   // Label 8596: @415408
     /* 415408 */   GIM_Reject,
     /* 415409 */ // Label 8594: @415409
     /* 415409 */ GIM_Reject,
     /* 415410 */ // Label 8562: @415410
     /* 415410 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(415435), // Rule ID 2406 //
     /* 415415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 415421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 415424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415428 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 415428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 415433 */   GIR_RootConstrainSelectedInstOperands,
     /* 415434 */   // GIR_Coverage, 2406,
     /* 415434 */   GIR_Done,
     /* 415435 */ // Label 8597: @415435
     /* 415435 */ GIM_Reject,
     /* 415436 */ // Label 8563: @415436
     /* 415436 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(415461), // Rule ID 8936 //
     /* 415441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 415447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 415450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415454 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 415454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 415459 */   GIR_RootConstrainSelectedInstOperands,
     /* 415460 */   // GIR_Coverage, 8936,
     /* 415460 */   GIR_Done,
     /* 415461 */ // Label 8598: @415461
     /* 415461 */ GIM_Reject,
     /* 415462 */ // Label 8564: @415462
     /* 415462 */ GIM_Reject,
     /* 415463 */ // Label 149: @415463
     /* 415463 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8617*/ GIMT_Encode4(416242),
     /* 415474 */ /*GILLT_v2s32*//*Label 8599*/ GIMT_Encode4(415550),
     /* 415478 */ /*GILLT_v2s64*//*Label 8600*/ GIMT_Encode4(415605),
     /* 415482 */ /*GILLT_v4s16*//*Label 8601*/ GIMT_Encode4(415660),
     /* 415486 */ /*GILLT_v4s32*//*Label 8602*/ GIMT_Encode4(415715),
     /* 415490 */ /*GILLT_v8s8*//*Label 8603*/ GIMT_Encode4(415770),
     /* 415494 */ /*GILLT_v8s16*//*Label 8604*/ GIMT_Encode4(415804),
     /* 415498 */ /*GILLT_v16s8*//*Label 8605*/ GIMT_Encode4(415859), GIMT_Encode4(0),
     /* 415506 */ /*GILLT_nxv2s1*//*Label 8606*/ GIMT_Encode4(415893),
     /* 415510 */ /*GILLT_nxv2s16*//*Label 8607*/ GIMT_Encode4(415919),
     /* 415514 */ /*GILLT_nxv2s32*//*Label 8608*/ GIMT_Encode4(415945),
     /* 415518 */ /*GILLT_nxv2s64*//*Label 8609*/ GIMT_Encode4(415971),
     /* 415522 */ /*GILLT_nxv4s1*//*Label 8610*/ GIMT_Encode4(416018),
     /* 415526 */ /*GILLT_nxv4s16*//*Label 8611*/ GIMT_Encode4(416044),
     /* 415530 */ /*GILLT_nxv4s32*//*Label 8612*/ GIMT_Encode4(416070),
     /* 415534 */ /*GILLT_nxv8s1*//*Label 8613*/ GIMT_Encode4(416117),
     /* 415538 */ /*GILLT_nxv8s16*//*Label 8614*/ GIMT_Encode4(416143),
     /* 415542 */ /*GILLT_nxv16s1*//*Label 8615*/ GIMT_Encode4(416190),
     /* 415546 */ /*GILLT_nxv16s8*//*Label 8616*/ GIMT_Encode4(416216),
     /* 415550 */ // Label 8599: @415550
     /* 415550 */ GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(415604),
     /* 415555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 415561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415573 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(415588), // Rule ID 1895 //
     /* 415578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415581 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 415581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 415586 */     GIR_RootConstrainSelectedInstOperands,
     /* 415587 */     // GIR_Coverage, 1895,
     /* 415587 */     GIR_Done,
     /* 415588 */   // Label 8619: @415588
     /* 415588 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(415603), // Rule ID 5479 //
     /* 415593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415596 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 415596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 415601 */     GIR_RootConstrainSelectedInstOperands,
     /* 415602 */     // GIR_Coverage, 5479,
     /* 415602 */     GIR_Done,
     /* 415603 */   // Label 8620: @415603
     /* 415603 */   GIM_Reject,
     /* 415604 */ // Label 8618: @415604
     /* 415604 */ GIM_Reject,
     /* 415605 */ // Label 8600: @415605
     /* 415605 */ GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(415659),
     /* 415610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 415613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 415616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415628 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(415643), // Rule ID 1897 //
     /* 415633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415636 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 415636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 415641 */     GIR_RootConstrainSelectedInstOperands,
     /* 415642 */     // GIR_Coverage, 1897,
     /* 415642 */     GIR_Done,
     /* 415643 */   // Label 8622: @415643
     /* 415643 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(415658), // Rule ID 5481 //
     /* 415648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415651 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 415651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 415656 */     GIR_RootConstrainSelectedInstOperands,
     /* 415657 */     // GIR_Coverage, 5481,
     /* 415657 */     GIR_Done,
     /* 415658 */   // Label 8623: @415658
     /* 415658 */   GIM_Reject,
     /* 415659 */ // Label 8621: @415659
     /* 415659 */ GIM_Reject,
     /* 415660 */ // Label 8601: @415660
     /* 415660 */ GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(415714),
     /* 415665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 415671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415683 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(415698), // Rule ID 1893 //
     /* 415688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415691 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 415691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 415696 */     GIR_RootConstrainSelectedInstOperands,
     /* 415697 */     // GIR_Coverage, 1893,
     /* 415697 */     GIR_Done,
     /* 415698 */   // Label 8625: @415698
     /* 415698 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(415713), // Rule ID 5477 //
     /* 415703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415706 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 415711 */     GIR_RootConstrainSelectedInstOperands,
     /* 415712 */     // GIR_Coverage, 5477,
     /* 415712 */     GIR_Done,
     /* 415713 */   // Label 8626: @415713
     /* 415713 */   GIM_Reject,
     /* 415714 */ // Label 8624: @415714
     /* 415714 */ GIM_Reject,
     /* 415715 */ // Label 8602: @415715
     /* 415715 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(415769),
     /* 415720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 415726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415738 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(415753), // Rule ID 1896 //
     /* 415743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415746 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 415746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 415751 */     GIR_RootConstrainSelectedInstOperands,
     /* 415752 */     // GIR_Coverage, 1896,
     /* 415752 */     GIR_Done,
     /* 415753 */   // Label 8628: @415753
     /* 415753 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(415768), // Rule ID 5480 //
     /* 415758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415761 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 415766 */     GIR_RootConstrainSelectedInstOperands,
     /* 415767 */     // GIR_Coverage, 5480,
     /* 415767 */     GIR_Done,
     /* 415768 */   // Label 8629: @415768
     /* 415768 */   GIM_Reject,
     /* 415769 */ // Label 8627: @415769
     /* 415769 */ GIM_Reject,
     /* 415770 */ // Label 8603: @415770
     /* 415770 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(415803), // Rule ID 1891 //
     /* 415775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 415781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 415784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415796 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 415796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 415801 */   GIR_RootConstrainSelectedInstOperands,
     /* 415802 */   // GIR_Coverage, 1891,
     /* 415802 */   GIR_Done,
     /* 415803 */ // Label 8630: @415803
     /* 415803 */ GIM_Reject,
     /* 415804 */ // Label 8604: @415804
     /* 415804 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(415858),
     /* 415809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415827 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(415842), // Rule ID 1894 //
     /* 415832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415835 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 415835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 415840 */     GIR_RootConstrainSelectedInstOperands,
     /* 415841 */     // GIR_Coverage, 1894,
     /* 415841 */     GIR_Done,
     /* 415842 */   // Label 8632: @415842
     /* 415842 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(415857), // Rule ID 5478 //
     /* 415847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415850 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 415855 */     GIR_RootConstrainSelectedInstOperands,
     /* 415856 */     // GIR_Coverage, 5478,
     /* 415856 */     GIR_Done,
     /* 415857 */   // Label 8633: @415857
     /* 415857 */   GIM_Reject,
     /* 415858 */ // Label 8631: @415858
     /* 415858 */ GIM_Reject,
     /* 415859 */ // Label 8605: @415859
     /* 415859 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(415892), // Rule ID 1892 //
     /* 415864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 415873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415885 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 415885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 415890 */   GIR_RootConstrainSelectedInstOperands,
     /* 415891 */   // GIR_Coverage, 1892,
     /* 415891 */   GIR_Done,
     /* 415892 */ // Label 8634: @415892
     /* 415892 */ GIM_Reject,
     /* 415893 */ // Label 8606: @415893
     /* 415893 */ GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(415918), // Rule ID 8984 //
     /* 415898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 415904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 415907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415911 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 415911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 415916 */   GIR_RootConstrainSelectedInstOperands,
     /* 415917 */   // GIR_Coverage, 8984,
     /* 415917 */   GIR_Done,
     /* 415918 */ // Label 8635: @415918
     /* 415918 */ GIM_Reject,
     /* 415919 */ // Label 8607: @415919
     /* 415919 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(415944), // Rule ID 8953 //
     /* 415924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 415930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 415933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415937 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 415937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415942 */   GIR_RootConstrainSelectedInstOperands,
     /* 415943 */   // GIR_Coverage, 8953,
     /* 415943 */   GIR_Done,
     /* 415944 */ // Label 8636: @415944
     /* 415944 */ GIM_Reject,
     /* 415945 */ // Label 8608: @415945
     /* 415945 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(415970), // Rule ID 8954 //
     /* 415950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 415956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 415959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415963 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 415963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415968 */   GIR_RootConstrainSelectedInstOperands,
     /* 415969 */   // GIR_Coverage, 8954,
     /* 415969 */   GIR_Done,
     /* 415970 */ // Label 8637: @415970
     /* 415970 */ GIM_Reject,
     /* 415971 */ // Label 8609: @415971
     /* 415971 */ GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(416017),
     /* 415976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 415979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 415982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415986 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(416001), // Rule ID 8949 //
     /* 415991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415994 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 415994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415999 */     GIR_RootConstrainSelectedInstOperands,
     /* 416000 */     // GIR_Coverage, 8949,
     /* 416000 */     GIR_Done,
     /* 416001 */   // Label 8639: @416001
     /* 416001 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(416016), // Rule ID 8955 //
     /* 416006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416009 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 416009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 416014 */     GIR_RootConstrainSelectedInstOperands,
     /* 416015 */     // GIR_Coverage, 8955,
     /* 416015 */     GIR_Done,
     /* 416016 */   // Label 8640: @416016
     /* 416016 */   GIM_Reject,
     /* 416017 */ // Label 8638: @416017
     /* 416017 */ GIM_Reject,
     /* 416018 */ // Label 8610: @416018
     /* 416018 */ GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(416043), // Rule ID 8983 //
     /* 416023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 416029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 416032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416036 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 416036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 416041 */   GIR_RootConstrainSelectedInstOperands,
     /* 416042 */   // GIR_Coverage, 8983,
     /* 416042 */   GIR_Done,
     /* 416043 */ // Label 8641: @416043
     /* 416043 */ GIM_Reject,
     /* 416044 */ // Label 8611: @416044
     /* 416044 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(416069), // Rule ID 8951 //
     /* 416049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 416055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 416058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416062 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 416062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416067 */   GIR_RootConstrainSelectedInstOperands,
     /* 416068 */   // GIR_Coverage, 8951,
     /* 416068 */   GIR_Done,
     /* 416069 */ // Label 8642: @416069
     /* 416069 */ GIM_Reject,
     /* 416070 */ // Label 8612: @416070
     /* 416070 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(416116),
     /* 416075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 416078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 416081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416085 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(416100), // Rule ID 8948 //
     /* 416090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416093 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 416093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416098 */     GIR_RootConstrainSelectedInstOperands,
     /* 416099 */     // GIR_Coverage, 8948,
     /* 416099 */     GIR_Done,
     /* 416100 */   // Label 8644: @416100
     /* 416100 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(416115), // Rule ID 8952 //
     /* 416105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416108 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 416108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416113 */     GIR_RootConstrainSelectedInstOperands,
     /* 416114 */     // GIR_Coverage, 8952,
     /* 416114 */     GIR_Done,
     /* 416115 */   // Label 8645: @416115
     /* 416115 */   GIM_Reject,
     /* 416116 */ // Label 8643: @416116
     /* 416116 */ GIM_Reject,
     /* 416117 */ // Label 8613: @416117
     /* 416117 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(416142), // Rule ID 8982 //
     /* 416122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 416128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 416131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416135 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 416135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 416140 */   GIR_RootConstrainSelectedInstOperands,
     /* 416141 */   // GIR_Coverage, 8982,
     /* 416141 */   GIR_Done,
     /* 416142 */ // Label 8646: @416142
     /* 416142 */ GIM_Reject,
     /* 416143 */ // Label 8614: @416143
     /* 416143 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(416189),
     /* 416148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 416151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 416154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416158 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(416173), // Rule ID 8947 //
     /* 416163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416166 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 416166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 416171 */     GIR_RootConstrainSelectedInstOperands,
     /* 416172 */     // GIR_Coverage, 8947,
     /* 416172 */     GIR_Done,
     /* 416173 */   // Label 8648: @416173
     /* 416173 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(416188), // Rule ID 8950 //
     /* 416178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416181 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 416181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 416186 */     GIR_RootConstrainSelectedInstOperands,
     /* 416187 */     // GIR_Coverage, 8950,
     /* 416187 */     GIR_Done,
     /* 416188 */   // Label 8649: @416188
     /* 416188 */   GIM_Reject,
     /* 416189 */ // Label 8647: @416189
     /* 416189 */ GIM_Reject,
     /* 416190 */ // Label 8615: @416190
     /* 416190 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(416215), // Rule ID 2410 //
     /* 416195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 416201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 416204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416208 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 416208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 416213 */   GIR_RootConstrainSelectedInstOperands,
     /* 416214 */   // GIR_Coverage, 2410,
     /* 416214 */   GIR_Done,
     /* 416215 */ // Label 8650: @416215
     /* 416215 */ GIM_Reject,
     /* 416216 */ // Label 8616: @416216
     /* 416216 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(416241), // Rule ID 8946 //
     /* 416221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 416227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 416230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416234 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 416234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 416239 */   GIR_RootConstrainSelectedInstOperands,
     /* 416240 */   // GIR_Coverage, 8946,
     /* 416240 */   GIR_Done,
     /* 416241 */ // Label 8651: @416241
     /* 416241 */ GIM_Reject,
     /* 416242 */ // Label 8617: @416242
     /* 416242 */ GIM_Reject,
     /* 416243 */ // Label 150: @416243
     /* 416243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8660*/ GIMT_Encode4(416940),
     /* 416254 */ /*GILLT_s64*//*Label 8652*/ GIMT_Encode4(416290), GIMT_Encode4(0),
     /* 416262 */ /*GILLT_v2s32*//*Label 8653*/ GIMT_Encode4(416401),
     /* 416266 */ /*GILLT_v2s64*//*Label 8654*/ GIMT_Encode4(416478),
     /* 416270 */ /*GILLT_v4s16*//*Label 8655*/ GIMT_Encode4(416555),
     /* 416274 */ /*GILLT_v4s32*//*Label 8656*/ GIMT_Encode4(416632),
     /* 416278 */ /*GILLT_v8s8*//*Label 8657*/ GIMT_Encode4(416709),
     /* 416282 */ /*GILLT_v8s16*//*Label 8658*/ GIMT_Encode4(416786),
     /* 416286 */ /*GILLT_v16s8*//*Label 8659*/ GIMT_Encode4(416863),
     /* 416290 */ // Label 8652: @416290
     /* 416290 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(416400),
     /* 416295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416306 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(416331), // Rule ID 5251 //
     /* 416311 */     // MIs[0] Operand 2
     /* 416311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 416322 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 416322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 416325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416329 */     GIR_RootConstrainSelectedInstOperands,
     /* 416330 */     // GIR_Coverage, 5251,
     /* 416330 */     GIR_EraseRootFromParent_Done,
     /* 416331 */   // Label 8662: @416331
     /* 416331 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(416365), // Rule ID 2120 //
     /* 416336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416339 */     // MIs[0] imm
     /* 416339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416351 */     // MIs[1] Operand 1
     /* 416351 */     // No operand predicates
     /* 416351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416353 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 416356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416363 */     GIR_RootConstrainSelectedInstOperands,
     /* 416364 */     // GIR_Coverage, 2120,
     /* 416364 */     GIR_EraseRootFromParent_Done,
     /* 416365 */   // Label 8663: @416365
     /* 416365 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(416399), // Rule ID 6301 //
     /* 416370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416373 */     // MIs[0] imm
     /* 416373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416385 */     // MIs[1] Operand 1
     /* 416385 */     // No operand predicates
     /* 416385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416387 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 416387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 416390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416397 */     GIR_RootConstrainSelectedInstOperands,
     /* 416398 */     // GIR_Coverage, 6301,
     /* 416398 */     GIR_EraseRootFromParent_Done,
     /* 416399 */   // Label 8664: @416399
     /* 416399 */   GIM_Reject,
     /* 416400 */ // Label 8661: @416400
     /* 416400 */ GIM_Reject,
     /* 416401 */ // Label 8653: @416401
     /* 416401 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(416477),
     /* 416406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416417 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(416442), // Rule ID 4892 //
     /* 416422 */     // MIs[0] Operand 2
     /* 416422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 416433 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 416433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 416436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416440 */     GIR_RootConstrainSelectedInstOperands,
     /* 416441 */     // GIR_Coverage, 4892,
     /* 416441 */     GIR_EraseRootFromParent_Done,
     /* 416442 */   // Label 8666: @416442
     /* 416442 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(416476), // Rule ID 2227 //
     /* 416447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416450 */     // MIs[0] imm
     /* 416450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 416462 */     // MIs[1] Operand 1
     /* 416462 */     // No operand predicates
     /* 416462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416464 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 416467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416474 */     GIR_RootConstrainSelectedInstOperands,
     /* 416475 */     // GIR_Coverage, 2227,
     /* 416475 */     GIR_EraseRootFromParent_Done,
     /* 416476 */   // Label 8667: @416476
     /* 416476 */   GIM_Reject,
     /* 416477 */ // Label 8665: @416477
     /* 416477 */ GIM_Reject,
     /* 416478 */ // Label 8654: @416478
     /* 416478 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(416554),
     /* 416483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416494 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(416519), // Rule ID 4896 //
     /* 416499 */     // MIs[0] Operand 2
     /* 416499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 416510 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 416510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 416513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416517 */     GIR_RootConstrainSelectedInstOperands,
     /* 416518 */     // GIR_Coverage, 4896,
     /* 416518 */     GIR_EraseRootFromParent_Done,
     /* 416519 */   // Label 8669: @416519
     /* 416519 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(416553), // Rule ID 2229 //
     /* 416524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416527 */     // MIs[0] imm
     /* 416527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416539 */     // MIs[1] Operand 1
     /* 416539 */     // No operand predicates
     /* 416539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416541 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 416544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416551 */     GIR_RootConstrainSelectedInstOperands,
     /* 416552 */     // GIR_Coverage, 2229,
     /* 416552 */     GIR_EraseRootFromParent_Done,
     /* 416553 */   // Label 8670: @416553
     /* 416553 */   GIM_Reject,
     /* 416554 */ // Label 8668: @416554
     /* 416554 */ GIM_Reject,
     /* 416555 */ // Label 8655: @416555
     /* 416555 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(416631),
     /* 416560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416571 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(416596), // Rule ID 4891 //
     /* 416576 */     // MIs[0] Operand 2
     /* 416576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 416587 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 416587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 416590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416594 */     GIR_RootConstrainSelectedInstOperands,
     /* 416595 */     // GIR_Coverage, 4891,
     /* 416595 */     GIR_EraseRootFromParent_Done,
     /* 416596 */   // Label 8672: @416596
     /* 416596 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(416630), // Rule ID 2225 //
     /* 416601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416604 */     // MIs[0] imm
     /* 416604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 416616 */     // MIs[1] Operand 1
     /* 416616 */     // No operand predicates
     /* 416616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416618 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 416621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416628 */     GIR_RootConstrainSelectedInstOperands,
     /* 416629 */     // GIR_Coverage, 2225,
     /* 416629 */     GIR_EraseRootFromParent_Done,
     /* 416630 */   // Label 8673: @416630
     /* 416630 */   GIM_Reject,
     /* 416631 */ // Label 8671: @416631
     /* 416631 */ GIM_Reject,
     /* 416632 */ // Label 8656: @416632
     /* 416632 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(416708),
     /* 416637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416648 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(416673), // Rule ID 4895 //
     /* 416653 */     // MIs[0] Operand 2
     /* 416653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 416664 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 416664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 416667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416671 */     GIR_RootConstrainSelectedInstOperands,
     /* 416672 */     // GIR_Coverage, 4895,
     /* 416672 */     GIR_EraseRootFromParent_Done,
     /* 416673 */   // Label 8675: @416673
     /* 416673 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(416707), // Rule ID 2228 //
     /* 416678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416681 */     // MIs[0] imm
     /* 416681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 416693 */     // MIs[1] Operand 1
     /* 416693 */     // No operand predicates
     /* 416693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416695 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 416698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416705 */     GIR_RootConstrainSelectedInstOperands,
     /* 416706 */     // GIR_Coverage, 2228,
     /* 416706 */     GIR_EraseRootFromParent_Done,
     /* 416707 */   // Label 8676: @416707
     /* 416707 */   GIM_Reject,
     /* 416708 */ // Label 8674: @416708
     /* 416708 */ GIM_Reject,
     /* 416709 */ // Label 8657: @416709
     /* 416709 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(416785),
     /* 416714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 416717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416725 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(416750), // Rule ID 4890 //
     /* 416730 */     // MIs[0] Operand 2
     /* 416730 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 416741 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 416741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 416744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416748 */     GIR_RootConstrainSelectedInstOperands,
     /* 416749 */     // GIR_Coverage, 4890,
     /* 416749 */     GIR_EraseRootFromParent_Done,
     /* 416750 */   // Label 8678: @416750
     /* 416750 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(416784), // Rule ID 2223 //
     /* 416755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416758 */     // MIs[0] imm
     /* 416758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 416770 */     // MIs[1] Operand 1
     /* 416770 */     // No operand predicates
     /* 416770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416772 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 416775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416782 */     GIR_RootConstrainSelectedInstOperands,
     /* 416783 */     // GIR_Coverage, 2223,
     /* 416783 */     GIR_EraseRootFromParent_Done,
     /* 416784 */   // Label 8679: @416784
     /* 416784 */   GIM_Reject,
     /* 416785 */ // Label 8677: @416785
     /* 416785 */ GIM_Reject,
     /* 416786 */ // Label 8658: @416786
     /* 416786 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(416862),
     /* 416791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416802 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(416827), // Rule ID 4894 //
     /* 416807 */     // MIs[0] Operand 2
     /* 416807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 416818 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 416818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 416821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416825 */     GIR_RootConstrainSelectedInstOperands,
     /* 416826 */     // GIR_Coverage, 4894,
     /* 416826 */     GIR_EraseRootFromParent_Done,
     /* 416827 */   // Label 8681: @416827
     /* 416827 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(416861), // Rule ID 2226 //
     /* 416832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416835 */     // MIs[0] imm
     /* 416835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 416847 */     // MIs[1] Operand 1
     /* 416847 */     // No operand predicates
     /* 416847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416849 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 416852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416859 */     GIR_RootConstrainSelectedInstOperands,
     /* 416860 */     // GIR_Coverage, 2226,
     /* 416860 */     GIR_EraseRootFromParent_Done,
     /* 416861 */   // Label 8682: @416861
     /* 416861 */   GIM_Reject,
     /* 416862 */ // Label 8680: @416862
     /* 416862 */ GIM_Reject,
     /* 416863 */ // Label 8659: @416863
     /* 416863 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(416939),
     /* 416868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 416871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416879 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(416904), // Rule ID 4893 //
     /* 416884 */     // MIs[0] Operand 2
     /* 416884 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 416895 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 416895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 416898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416902 */     GIR_RootConstrainSelectedInstOperands,
     /* 416903 */     // GIR_Coverage, 4893,
     /* 416903 */     GIR_EraseRootFromParent_Done,
     /* 416904 */   // Label 8684: @416904
     /* 416904 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(416938), // Rule ID 2224 //
     /* 416909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416912 */     // MIs[0] imm
     /* 416912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 416924 */     // MIs[1] Operand 1
     /* 416924 */     // No operand predicates
     /* 416924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416926 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 416929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416936 */     GIR_RootConstrainSelectedInstOperands,
     /* 416937 */     // GIR_Coverage, 2224,
     /* 416937 */     GIR_EraseRootFromParent_Done,
     /* 416938 */   // Label 8685: @416938
     /* 416938 */   GIM_Reject,
     /* 416939 */ // Label 8683: @416939
     /* 416939 */ GIM_Reject,
     /* 416940 */ // Label 8660: @416940
     /* 416940 */ GIM_Reject,
     /* 416941 */ // Label 151: @416941
     /* 416941 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8694*/ GIMT_Encode4(417396),
     /* 416952 */ /*GILLT_s64*//*Label 8686*/ GIMT_Encode4(416988), GIMT_Encode4(0),
     /* 416960 */ /*GILLT_v2s32*//*Label 8687*/ GIMT_Encode4(417074),
     /* 416964 */ /*GILLT_v2s64*//*Label 8688*/ GIMT_Encode4(417120),
     /* 416968 */ /*GILLT_v4s16*//*Label 8689*/ GIMT_Encode4(417166),
     /* 416972 */ /*GILLT_v4s32*//*Label 8690*/ GIMT_Encode4(417212),
     /* 416976 */ /*GILLT_v8s8*//*Label 8691*/ GIMT_Encode4(417258),
     /* 416980 */ /*GILLT_v8s16*//*Label 8692*/ GIMT_Encode4(417304),
     /* 416984 */ /*GILLT_v16s8*//*Label 8693*/ GIMT_Encode4(417350),
     /* 416988 */ // Label 8686: @416988
     /* 416988 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(417073),
     /* 416993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417004 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(417038), // Rule ID 2129 //
     /* 417009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417012 */     // MIs[0] imm
     /* 417012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417024 */     // MIs[1] Operand 1
     /* 417024 */     // No operand predicates
     /* 417024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417026 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 417029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417036 */     GIR_RootConstrainSelectedInstOperands,
     /* 417037 */     // GIR_Coverage, 2129,
     /* 417037 */     GIR_EraseRootFromParent_Done,
     /* 417038 */   // Label 8696: @417038
     /* 417038 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(417072), // Rule ID 6304 //
     /* 417043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417046 */     // MIs[0] imm
     /* 417046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417058 */     // MIs[1] Operand 1
     /* 417058 */     // No operand predicates
     /* 417058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417060 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 417060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 417063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417070 */     GIR_RootConstrainSelectedInstOperands,
     /* 417071 */     // GIR_Coverage, 6304,
     /* 417071 */     GIR_EraseRootFromParent_Done,
     /* 417072 */   // Label 8697: @417072
     /* 417072 */   GIM_Reject,
     /* 417073 */ // Label 8695: @417073
     /* 417073 */ GIM_Reject,
     /* 417074 */ // Label 8687: @417074
     /* 417074 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(417119), // Rule ID 2286 //
     /* 417079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417093 */   // MIs[0] imm
     /* 417093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417101 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 417105 */   // MIs[1] Operand 1
     /* 417105 */   // No operand predicates
     /* 417105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417107 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 417110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417112 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417114 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417117 */   GIR_RootConstrainSelectedInstOperands,
     /* 417118 */   // GIR_Coverage, 2286,
     /* 417118 */   GIR_EraseRootFromParent_Done,
     /* 417119 */ // Label 8698: @417119
     /* 417119 */ GIM_Reject,
     /* 417120 */ // Label 8688: @417120
     /* 417120 */ GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(417165), // Rule ID 2288 //
     /* 417125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417139 */   // MIs[0] imm
     /* 417139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417147 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417151 */   // MIs[1] Operand 1
     /* 417151 */   // No operand predicates
     /* 417151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417153 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 417156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417158 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417160 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417163 */   GIR_RootConstrainSelectedInstOperands,
     /* 417164 */   // GIR_Coverage, 2288,
     /* 417164 */   GIR_EraseRootFromParent_Done,
     /* 417165 */ // Label 8699: @417165
     /* 417165 */ GIM_Reject,
     /* 417166 */ // Label 8689: @417166
     /* 417166 */ GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(417211), // Rule ID 2284 //
     /* 417171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417185 */   // MIs[0] imm
     /* 417185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417193 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 417197 */   // MIs[1] Operand 1
     /* 417197 */   // No operand predicates
     /* 417197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417199 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 417202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417204 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417209 */   GIR_RootConstrainSelectedInstOperands,
     /* 417210 */   // GIR_Coverage, 2284,
     /* 417210 */   GIR_EraseRootFromParent_Done,
     /* 417211 */ // Label 8700: @417211
     /* 417211 */ GIM_Reject,
     /* 417212 */ // Label 8690: @417212
     /* 417212 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(417257), // Rule ID 2287 //
     /* 417217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417231 */   // MIs[0] imm
     /* 417231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417239 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 417243 */   // MIs[1] Operand 1
     /* 417243 */   // No operand predicates
     /* 417243 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417245 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 417248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417252 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417255 */   GIR_RootConstrainSelectedInstOperands,
     /* 417256 */   // GIR_Coverage, 2287,
     /* 417256 */   GIR_EraseRootFromParent_Done,
     /* 417257 */ // Label 8701: @417257
     /* 417257 */ GIM_Reject,
     /* 417258 */ // Label 8691: @417258
     /* 417258 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(417303), // Rule ID 2282 //
     /* 417263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417277 */   // MIs[0] imm
     /* 417277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417285 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 417289 */   // MIs[1] Operand 1
     /* 417289 */   // No operand predicates
     /* 417289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417291 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 417294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417296 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417298 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417301 */   GIR_RootConstrainSelectedInstOperands,
     /* 417302 */   // GIR_Coverage, 2282,
     /* 417302 */   GIR_EraseRootFromParent_Done,
     /* 417303 */ // Label 8702: @417303
     /* 417303 */ GIM_Reject,
     /* 417304 */ // Label 8692: @417304
     /* 417304 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(417349), // Rule ID 2285 //
     /* 417309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417323 */   // MIs[0] imm
     /* 417323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417331 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 417335 */   // MIs[1] Operand 1
     /* 417335 */   // No operand predicates
     /* 417335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417337 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 417340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417342 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417344 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417347 */   GIR_RootConstrainSelectedInstOperands,
     /* 417348 */   // GIR_Coverage, 2285,
     /* 417348 */   GIR_EraseRootFromParent_Done,
     /* 417349 */ // Label 8703: @417349
     /* 417349 */ GIM_Reject,
     /* 417350 */ // Label 8693: @417350
     /* 417350 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(417395), // Rule ID 2283 //
     /* 417355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417369 */   // MIs[0] imm
     /* 417369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417377 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 417381 */   // MIs[1] Operand 1
     /* 417381 */   // No operand predicates
     /* 417381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417383 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 417386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417388 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417390 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417393 */   GIR_RootConstrainSelectedInstOperands,
     /* 417394 */   // GIR_Coverage, 2283,
     /* 417394 */   GIR_EraseRootFromParent_Done,
     /* 417395 */ // Label 8704: @417395
     /* 417395 */ GIM_Reject,
     /* 417396 */ // Label 8694: @417396
     /* 417396 */ GIM_Reject,
     /* 417397 */ // Label 152: @417397
     /* 417397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8723*/ GIMT_Encode4(418176),
     /* 417408 */ /*GILLT_v2s32*//*Label 8705*/ GIMT_Encode4(417484),
     /* 417412 */ /*GILLT_v2s64*//*Label 8706*/ GIMT_Encode4(417539),
     /* 417416 */ /*GILLT_v4s16*//*Label 8707*/ GIMT_Encode4(417594),
     /* 417420 */ /*GILLT_v4s32*//*Label 8708*/ GIMT_Encode4(417649),
     /* 417424 */ /*GILLT_v8s8*//*Label 8709*/ GIMT_Encode4(417704),
     /* 417428 */ /*GILLT_v8s16*//*Label 8710*/ GIMT_Encode4(417738),
     /* 417432 */ /*GILLT_v16s8*//*Label 8711*/ GIMT_Encode4(417793), GIMT_Encode4(0),
     /* 417440 */ /*GILLT_nxv2s1*//*Label 8712*/ GIMT_Encode4(417827),
     /* 417444 */ /*GILLT_nxv2s16*//*Label 8713*/ GIMT_Encode4(417853),
     /* 417448 */ /*GILLT_nxv2s32*//*Label 8714*/ GIMT_Encode4(417879),
     /* 417452 */ /*GILLT_nxv2s64*//*Label 8715*/ GIMT_Encode4(417905),
     /* 417456 */ /*GILLT_nxv4s1*//*Label 8716*/ GIMT_Encode4(417952),
     /* 417460 */ /*GILLT_nxv4s16*//*Label 8717*/ GIMT_Encode4(417978),
     /* 417464 */ /*GILLT_nxv4s32*//*Label 8718*/ GIMT_Encode4(418004),
     /* 417468 */ /*GILLT_nxv8s1*//*Label 8719*/ GIMT_Encode4(418051),
     /* 417472 */ /*GILLT_nxv8s16*//*Label 8720*/ GIMT_Encode4(418077),
     /* 417476 */ /*GILLT_nxv16s1*//*Label 8721*/ GIMT_Encode4(418124),
     /* 417480 */ /*GILLT_nxv16s8*//*Label 8722*/ GIMT_Encode4(418150),
     /* 417484 */ // Label 8705: @417484
     /* 417484 */ GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(417538),
     /* 417489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 417495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417507 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(417522), // Rule ID 1902 //
     /* 417512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417515 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 417515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 417520 */     GIR_RootConstrainSelectedInstOperands,
     /* 417521 */     // GIR_Coverage, 1902,
     /* 417521 */     GIR_Done,
     /* 417522 */   // Label 8725: @417522
     /* 417522 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(417537), // Rule ID 5484 //
     /* 417527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417530 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 417530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 417535 */     GIR_RootConstrainSelectedInstOperands,
     /* 417536 */     // GIR_Coverage, 5484,
     /* 417536 */     GIR_Done,
     /* 417537 */   // Label 8726: @417537
     /* 417537 */   GIM_Reject,
     /* 417538 */ // Label 8724: @417538
     /* 417538 */ GIM_Reject,
     /* 417539 */ // Label 8706: @417539
     /* 417539 */ GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(417593),
     /* 417544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 417550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417562 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(417577), // Rule ID 1904 //
     /* 417567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417570 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 417570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 417575 */     GIR_RootConstrainSelectedInstOperands,
     /* 417576 */     // GIR_Coverage, 1904,
     /* 417576 */     GIR_Done,
     /* 417577 */   // Label 8728: @417577
     /* 417577 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(417592), // Rule ID 5486 //
     /* 417582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417585 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 417585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 417590 */     GIR_RootConstrainSelectedInstOperands,
     /* 417591 */     // GIR_Coverage, 5486,
     /* 417591 */     GIR_Done,
     /* 417592 */   // Label 8729: @417592
     /* 417592 */   GIM_Reject,
     /* 417593 */ // Label 8727: @417593
     /* 417593 */ GIM_Reject,
     /* 417594 */ // Label 8707: @417594
     /* 417594 */ GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(417648),
     /* 417599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417617 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(417632), // Rule ID 1900 //
     /* 417622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417625 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 417625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 417630 */     GIR_RootConstrainSelectedInstOperands,
     /* 417631 */     // GIR_Coverage, 1900,
     /* 417631 */     GIR_Done,
     /* 417632 */   // Label 8731: @417632
     /* 417632 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(417647), // Rule ID 5482 //
     /* 417637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417640 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 417640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 417645 */     GIR_RootConstrainSelectedInstOperands,
     /* 417646 */     // GIR_Coverage, 5482,
     /* 417646 */     GIR_Done,
     /* 417647 */   // Label 8732: @417647
     /* 417647 */   GIM_Reject,
     /* 417648 */ // Label 8730: @417648
     /* 417648 */ GIM_Reject,
     /* 417649 */ // Label 8708: @417649
     /* 417649 */ GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(417703),
     /* 417654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 417660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417672 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(417687), // Rule ID 1903 //
     /* 417677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417680 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 417680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 417685 */     GIR_RootConstrainSelectedInstOperands,
     /* 417686 */     // GIR_Coverage, 1903,
     /* 417686 */     GIR_Done,
     /* 417687 */   // Label 8734: @417687
     /* 417687 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(417702), // Rule ID 5485 //
     /* 417692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417695 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 417700 */     GIR_RootConstrainSelectedInstOperands,
     /* 417701 */     // GIR_Coverage, 5485,
     /* 417701 */     GIR_Done,
     /* 417702 */   // Label 8735: @417702
     /* 417702 */   GIM_Reject,
     /* 417703 */ // Label 8733: @417703
     /* 417703 */ GIM_Reject,
     /* 417704 */ // Label 8709: @417704
     /* 417704 */ GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(417737), // Rule ID 1898 //
     /* 417709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417730 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 417730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 417735 */   GIR_RootConstrainSelectedInstOperands,
     /* 417736 */   // GIR_Coverage, 1898,
     /* 417736 */   GIR_Done,
     /* 417737 */ // Label 8736: @417737
     /* 417737 */ GIM_Reject,
     /* 417738 */ // Label 8710: @417738
     /* 417738 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(417792),
     /* 417743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417761 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(417776), // Rule ID 1901 //
     /* 417766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417769 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 417769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 417774 */     GIR_RootConstrainSelectedInstOperands,
     /* 417775 */     // GIR_Coverage, 1901,
     /* 417775 */     GIR_Done,
     /* 417776 */   // Label 8738: @417776
     /* 417776 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(417791), // Rule ID 5483 //
     /* 417781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417784 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 417789 */     GIR_RootConstrainSelectedInstOperands,
     /* 417790 */     // GIR_Coverage, 5483,
     /* 417790 */     GIR_Done,
     /* 417791 */   // Label 8739: @417791
     /* 417791 */   GIM_Reject,
     /* 417792 */ // Label 8737: @417792
     /* 417792 */ GIM_Reject,
     /* 417793 */ // Label 8711: @417793
     /* 417793 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(417826), // Rule ID 1899 //
     /* 417798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417819 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 417819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 417824 */   GIR_RootConstrainSelectedInstOperands,
     /* 417825 */   // GIR_Coverage, 1899,
     /* 417825 */   GIR_Done,
     /* 417826 */ // Label 8740: @417826
     /* 417826 */ GIM_Reject,
     /* 417827 */ // Label 8712: @417827
     /* 417827 */ GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(417852), // Rule ID 3348 //
     /* 417832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 417838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 417841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417845 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 417845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 417850 */   GIR_RootConstrainSelectedInstOperands,
     /* 417851 */   // GIR_Coverage, 3348,
     /* 417851 */   GIR_Done,
     /* 417852 */ // Label 8741: @417852
     /* 417852 */ GIM_Reject,
     /* 417853 */ // Label 8713: @417853
     /* 417853 */ GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(417878), // Rule ID 2879 //
     /* 417858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 417864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 417867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417871 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 417871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417876 */   GIR_RootConstrainSelectedInstOperands,
     /* 417877 */   // GIR_Coverage, 2879,
     /* 417877 */   GIR_Done,
     /* 417878 */ // Label 8742: @417878
     /* 417878 */ GIM_Reject,
     /* 417879 */ // Label 8714: @417879
     /* 417879 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(417904), // Rule ID 2880 //
     /* 417884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 417890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 417893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417897 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 417897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417902 */   GIR_RootConstrainSelectedInstOperands,
     /* 417903 */   // GIR_Coverage, 2880,
     /* 417903 */   GIR_Done,
     /* 417904 */ // Label 8743: @417904
     /* 417904 */ GIM_Reject,
     /* 417905 */ // Label 8715: @417905
     /* 417905 */ GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(417951),
     /* 417910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 417913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 417916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417920 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(417935), // Rule ID 2875 //
     /* 417925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417928 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 417928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417933 */     GIR_RootConstrainSelectedInstOperands,
     /* 417934 */     // GIR_Coverage, 2875,
     /* 417934 */     GIR_Done,
     /* 417935 */   // Label 8745: @417935
     /* 417935 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(417950), // Rule ID 2881 //
     /* 417940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417943 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 417943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417948 */     GIR_RootConstrainSelectedInstOperands,
     /* 417949 */     // GIR_Coverage, 2881,
     /* 417949 */     GIR_Done,
     /* 417950 */   // Label 8746: @417950
     /* 417950 */   GIM_Reject,
     /* 417951 */ // Label 8744: @417951
     /* 417951 */ GIM_Reject,
     /* 417952 */ // Label 8716: @417952
     /* 417952 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(417977), // Rule ID 3347 //
     /* 417957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 417963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 417966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417970 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 417970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 417975 */   GIR_RootConstrainSelectedInstOperands,
     /* 417976 */   // GIR_Coverage, 3347,
     /* 417976 */   GIR_Done,
     /* 417977 */ // Label 8747: @417977
     /* 417977 */ GIM_Reject,
     /* 417978 */ // Label 8717: @417978
     /* 417978 */ GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(418003), // Rule ID 2877 //
     /* 417983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 417989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 417992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417996 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 417996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 418001 */   GIR_RootConstrainSelectedInstOperands,
     /* 418002 */   // GIR_Coverage, 2877,
     /* 418002 */   GIR_Done,
     /* 418003 */ // Label 8748: @418003
     /* 418003 */ GIM_Reject,
     /* 418004 */ // Label 8718: @418004
     /* 418004 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(418050),
     /* 418009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 418012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 418015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418019 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(418034), // Rule ID 2874 //
     /* 418024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418027 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 418027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 418032 */     GIR_RootConstrainSelectedInstOperands,
     /* 418033 */     // GIR_Coverage, 2874,
     /* 418033 */     GIR_Done,
     /* 418034 */   // Label 8750: @418034
     /* 418034 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(418049), // Rule ID 2878 //
     /* 418039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418042 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 418042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 418047 */     GIR_RootConstrainSelectedInstOperands,
     /* 418048 */     // GIR_Coverage, 2878,
     /* 418048 */     GIR_Done,
     /* 418049 */   // Label 8751: @418049
     /* 418049 */   GIM_Reject,
     /* 418050 */ // Label 8749: @418050
     /* 418050 */ GIM_Reject,
     /* 418051 */ // Label 8719: @418051
     /* 418051 */ GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(418076), // Rule ID 3346 //
     /* 418056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 418062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 418065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418069 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 418069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 418074 */   GIR_RootConstrainSelectedInstOperands,
     /* 418075 */   // GIR_Coverage, 3346,
     /* 418075 */   GIR_Done,
     /* 418076 */ // Label 8752: @418076
     /* 418076 */ GIM_Reject,
     /* 418077 */ // Label 8720: @418077
     /* 418077 */ GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(418123),
     /* 418082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 418085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 418088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418092 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(418107), // Rule ID 2873 //
     /* 418097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418100 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 418100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 418105 */     GIR_RootConstrainSelectedInstOperands,
     /* 418106 */     // GIR_Coverage, 2873,
     /* 418106 */     GIR_Done,
     /* 418107 */   // Label 8754: @418107
     /* 418107 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(418122), // Rule ID 2876 //
     /* 418112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418115 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 418115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 418120 */     GIR_RootConstrainSelectedInstOperands,
     /* 418121 */     // GIR_Coverage, 2876,
     /* 418121 */     GIR_Done,
     /* 418122 */   // Label 8755: @418122
     /* 418122 */   GIM_Reject,
     /* 418123 */ // Label 8753: @418123
     /* 418123 */ GIM_Reject,
     /* 418124 */ // Label 8721: @418124
     /* 418124 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(418149), // Rule ID 2398 //
     /* 418129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 418135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 418138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418142 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 418142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 418147 */   GIR_RootConstrainSelectedInstOperands,
     /* 418148 */   // GIR_Coverage, 2398,
     /* 418148 */   GIR_Done,
     /* 418149 */ // Label 8756: @418149
     /* 418149 */ GIM_Reject,
     /* 418150 */ // Label 8722: @418150
     /* 418150 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(418175), // Rule ID 2872 //
     /* 418155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 418161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 418164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418168 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 418168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 418173 */   GIR_RootConstrainSelectedInstOperands,
     /* 418174 */   // GIR_Coverage, 2872,
     /* 418174 */   GIR_Done,
     /* 418175 */ // Label 8757: @418175
     /* 418175 */ GIM_Reject,
     /* 418176 */ // Label 8723: @418176
     /* 418176 */ GIM_Reject,
     /* 418177 */ // Label 153: @418177
     /* 418177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8776*/ GIMT_Encode4(418956),
     /* 418188 */ /*GILLT_v2s32*//*Label 8758*/ GIMT_Encode4(418264),
     /* 418192 */ /*GILLT_v2s64*//*Label 8759*/ GIMT_Encode4(418319),
     /* 418196 */ /*GILLT_v4s16*//*Label 8760*/ GIMT_Encode4(418374),
     /* 418200 */ /*GILLT_v4s32*//*Label 8761*/ GIMT_Encode4(418429),
     /* 418204 */ /*GILLT_v8s8*//*Label 8762*/ GIMT_Encode4(418484),
     /* 418208 */ /*GILLT_v8s16*//*Label 8763*/ GIMT_Encode4(418518),
     /* 418212 */ /*GILLT_v16s8*//*Label 8764*/ GIMT_Encode4(418573), GIMT_Encode4(0),
     /* 418220 */ /*GILLT_nxv2s1*//*Label 8765*/ GIMT_Encode4(418607),
     /* 418224 */ /*GILLT_nxv2s16*//*Label 8766*/ GIMT_Encode4(418633),
     /* 418228 */ /*GILLT_nxv2s32*//*Label 8767*/ GIMT_Encode4(418659),
     /* 418232 */ /*GILLT_nxv2s64*//*Label 8768*/ GIMT_Encode4(418685),
     /* 418236 */ /*GILLT_nxv4s1*//*Label 8769*/ GIMT_Encode4(418732),
     /* 418240 */ /*GILLT_nxv4s16*//*Label 8770*/ GIMT_Encode4(418758),
     /* 418244 */ /*GILLT_nxv4s32*//*Label 8771*/ GIMT_Encode4(418784),
     /* 418248 */ /*GILLT_nxv8s1*//*Label 8772*/ GIMT_Encode4(418831),
     /* 418252 */ /*GILLT_nxv8s16*//*Label 8773*/ GIMT_Encode4(418857),
     /* 418256 */ /*GILLT_nxv16s1*//*Label 8774*/ GIMT_Encode4(418904),
     /* 418260 */ /*GILLT_nxv16s8*//*Label 8775*/ GIMT_Encode4(418930),
     /* 418264 */ // Label 8758: @418264
     /* 418264 */ GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(418318),
     /* 418269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 418275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418287 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(418302), // Rule ID 1909 //
     /* 418292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418295 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 418295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 418300 */     GIR_RootConstrainSelectedInstOperands,
     /* 418301 */     // GIR_Coverage, 1909,
     /* 418301 */     GIR_Done,
     /* 418302 */   // Label 8778: @418302
     /* 418302 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(418317), // Rule ID 5489 //
     /* 418307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418310 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 418310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 418315 */     GIR_RootConstrainSelectedInstOperands,
     /* 418316 */     // GIR_Coverage, 5489,
     /* 418316 */     GIR_Done,
     /* 418317 */   // Label 8779: @418317
     /* 418317 */   GIM_Reject,
     /* 418318 */ // Label 8777: @418318
     /* 418318 */ GIM_Reject,
     /* 418319 */ // Label 8759: @418319
     /* 418319 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(418373),
     /* 418324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 418330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418342 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(418357), // Rule ID 1911 //
     /* 418347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418350 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 418350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 418355 */     GIR_RootConstrainSelectedInstOperands,
     /* 418356 */     // GIR_Coverage, 1911,
     /* 418356 */     GIR_Done,
     /* 418357 */   // Label 8781: @418357
     /* 418357 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(418372), // Rule ID 5491 //
     /* 418362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418365 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 418365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 418370 */     GIR_RootConstrainSelectedInstOperands,
     /* 418371 */     // GIR_Coverage, 5491,
     /* 418371 */     GIR_Done,
     /* 418372 */   // Label 8782: @418372
     /* 418372 */   GIM_Reject,
     /* 418373 */ // Label 8780: @418373
     /* 418373 */ GIM_Reject,
     /* 418374 */ // Label 8760: @418374
     /* 418374 */ GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(418428),
     /* 418379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418397 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(418412), // Rule ID 1907 //
     /* 418402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418405 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 418405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 418410 */     GIR_RootConstrainSelectedInstOperands,
     /* 418411 */     // GIR_Coverage, 1907,
     /* 418411 */     GIR_Done,
     /* 418412 */   // Label 8784: @418412
     /* 418412 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(418427), // Rule ID 5487 //
     /* 418417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418420 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 418420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 418425 */     GIR_RootConstrainSelectedInstOperands,
     /* 418426 */     // GIR_Coverage, 5487,
     /* 418426 */     GIR_Done,
     /* 418427 */   // Label 8785: @418427
     /* 418427 */   GIM_Reject,
     /* 418428 */ // Label 8783: @418428
     /* 418428 */ GIM_Reject,
     /* 418429 */ // Label 8761: @418429
     /* 418429 */ GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(418483),
     /* 418434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418452 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(418467), // Rule ID 1910 //
     /* 418457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418460 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 418460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 418465 */     GIR_RootConstrainSelectedInstOperands,
     /* 418466 */     // GIR_Coverage, 1910,
     /* 418466 */     GIR_Done,
     /* 418467 */   // Label 8787: @418467
     /* 418467 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(418482), // Rule ID 5490 //
     /* 418472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418475 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 418475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 418480 */     GIR_RootConstrainSelectedInstOperands,
     /* 418481 */     // GIR_Coverage, 5490,
     /* 418481 */     GIR_Done,
     /* 418482 */   // Label 8788: @418482
     /* 418482 */   GIM_Reject,
     /* 418483 */ // Label 8786: @418483
     /* 418483 */ GIM_Reject,
     /* 418484 */ // Label 8762: @418484
     /* 418484 */ GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(418517), // Rule ID 1905 //
     /* 418489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418510 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 418510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 418515 */   GIR_RootConstrainSelectedInstOperands,
     /* 418516 */   // GIR_Coverage, 1905,
     /* 418516 */   GIR_Done,
     /* 418517 */ // Label 8789: @418517
     /* 418517 */ GIM_Reject,
     /* 418518 */ // Label 8763: @418518
     /* 418518 */ GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(418572),
     /* 418523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418541 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(418556), // Rule ID 1908 //
     /* 418546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418549 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 418549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 418554 */     GIR_RootConstrainSelectedInstOperands,
     /* 418555 */     // GIR_Coverage, 1908,
     /* 418555 */     GIR_Done,
     /* 418556 */   // Label 8791: @418556
     /* 418556 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(418571), // Rule ID 5488 //
     /* 418561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418564 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 418569 */     GIR_RootConstrainSelectedInstOperands,
     /* 418570 */     // GIR_Coverage, 5488,
     /* 418570 */     GIR_Done,
     /* 418571 */   // Label 8792: @418571
     /* 418571 */   GIM_Reject,
     /* 418572 */ // Label 8790: @418572
     /* 418572 */ GIM_Reject,
     /* 418573 */ // Label 8764: @418573
     /* 418573 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(418606), // Rule ID 1906 //
     /* 418578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418599 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 418599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 418604 */   GIR_RootConstrainSelectedInstOperands,
     /* 418605 */   // GIR_Coverage, 1906,
     /* 418605 */   GIR_Done,
     /* 418606 */ // Label 8793: @418606
     /* 418606 */ GIM_Reject,
     /* 418607 */ // Label 8765: @418607
     /* 418607 */ GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(418632), // Rule ID 8978 //
     /* 418612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 418618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 418621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418625 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 418625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 418630 */   GIR_RootConstrainSelectedInstOperands,
     /* 418631 */   // GIR_Coverage, 8978,
     /* 418631 */   GIR_Done,
     /* 418632 */ // Label 8794: @418632
     /* 418632 */ GIM_Reject,
     /* 418633 */ // Label 8766: @418633
     /* 418633 */ GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(418658), // Rule ID 8933 //
     /* 418638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 418644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 418647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418651 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 418651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418656 */   GIR_RootConstrainSelectedInstOperands,
     /* 418657 */   // GIR_Coverage, 8933,
     /* 418657 */   GIR_Done,
     /* 418658 */ // Label 8795: @418658
     /* 418658 */ GIM_Reject,
     /* 418659 */ // Label 8767: @418659
     /* 418659 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(418684), // Rule ID 8934 //
     /* 418664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 418670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 418673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418677 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 418677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418682 */   GIR_RootConstrainSelectedInstOperands,
     /* 418683 */   // GIR_Coverage, 8934,
     /* 418683 */   GIR_Done,
     /* 418684 */ // Label 8796: @418684
     /* 418684 */ GIM_Reject,
     /* 418685 */ // Label 8768: @418685
     /* 418685 */ GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(418731),
     /* 418690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 418693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 418696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418700 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(418715), // Rule ID 8929 //
     /* 418705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418708 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 418708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418713 */     GIR_RootConstrainSelectedInstOperands,
     /* 418714 */     // GIR_Coverage, 8929,
     /* 418714 */     GIR_Done,
     /* 418715 */   // Label 8798: @418715
     /* 418715 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(418730), // Rule ID 8935 //
     /* 418720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418723 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 418723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418728 */     GIR_RootConstrainSelectedInstOperands,
     /* 418729 */     // GIR_Coverage, 8935,
     /* 418729 */     GIR_Done,
     /* 418730 */   // Label 8799: @418730
     /* 418730 */   GIM_Reject,
     /* 418731 */ // Label 8797: @418731
     /* 418731 */ GIM_Reject,
     /* 418732 */ // Label 8769: @418732
     /* 418732 */ GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(418757), // Rule ID 8977 //
     /* 418737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 418743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 418746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418750 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 418750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 418755 */   GIR_RootConstrainSelectedInstOperands,
     /* 418756 */   // GIR_Coverage, 8977,
     /* 418756 */   GIR_Done,
     /* 418757 */ // Label 8800: @418757
     /* 418757 */ GIM_Reject,
     /* 418758 */ // Label 8770: @418758
     /* 418758 */ GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(418783), // Rule ID 8931 //
     /* 418763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 418769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 418772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418776 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 418776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418781 */   GIR_RootConstrainSelectedInstOperands,
     /* 418782 */   // GIR_Coverage, 8931,
     /* 418782 */   GIR_Done,
     /* 418783 */ // Label 8801: @418783
     /* 418783 */ GIM_Reject,
     /* 418784 */ // Label 8771: @418784
     /* 418784 */ GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(418830),
     /* 418789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 418792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 418795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418799 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(418814), // Rule ID 8928 //
     /* 418804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418807 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 418807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418812 */     GIR_RootConstrainSelectedInstOperands,
     /* 418813 */     // GIR_Coverage, 8928,
     /* 418813 */     GIR_Done,
     /* 418814 */   // Label 8803: @418814
     /* 418814 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(418829), // Rule ID 8932 //
     /* 418819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418822 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 418822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418827 */     GIR_RootConstrainSelectedInstOperands,
     /* 418828 */     // GIR_Coverage, 8932,
     /* 418828 */     GIR_Done,
     /* 418829 */   // Label 8804: @418829
     /* 418829 */   GIM_Reject,
     /* 418830 */ // Label 8802: @418830
     /* 418830 */ GIM_Reject,
     /* 418831 */ // Label 8772: @418831
     /* 418831 */ GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(418856), // Rule ID 8976 //
     /* 418836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 418842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 418845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418849 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 418849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 418854 */   GIR_RootConstrainSelectedInstOperands,
     /* 418855 */   // GIR_Coverage, 8976,
     /* 418855 */   GIR_Done,
     /* 418856 */ // Label 8805: @418856
     /* 418856 */ GIM_Reject,
     /* 418857 */ // Label 8773: @418857
     /* 418857 */ GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(418903),
     /* 418862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 418865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 418868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418872 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(418887), // Rule ID 8927 //
     /* 418877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418880 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 418880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 418885 */     GIR_RootConstrainSelectedInstOperands,
     /* 418886 */     // GIR_Coverage, 8927,
     /* 418886 */     GIR_Done,
     /* 418887 */   // Label 8807: @418887
     /* 418887 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(418902), // Rule ID 8930 //
     /* 418892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418895 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 418895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 418900 */     GIR_RootConstrainSelectedInstOperands,
     /* 418901 */     // GIR_Coverage, 8930,
     /* 418901 */     GIR_Done,
     /* 418902 */   // Label 8808: @418902
     /* 418902 */   GIM_Reject,
     /* 418903 */ // Label 8806: @418903
     /* 418903 */ GIM_Reject,
     /* 418904 */ // Label 8774: @418904
     /* 418904 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(418929), // Rule ID 2402 //
     /* 418909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 418915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 418918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418922 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 418922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 418927 */   GIR_RootConstrainSelectedInstOperands,
     /* 418928 */   // GIR_Coverage, 2402,
     /* 418928 */   GIR_Done,
     /* 418929 */ // Label 8809: @418929
     /* 418929 */ GIM_Reject,
     /* 418930 */ // Label 8775: @418930
     /* 418930 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(418955), // Rule ID 8926 //
     /* 418935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 418941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 418944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418948 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 418948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 418953 */   GIR_RootConstrainSelectedInstOperands,
     /* 418954 */   // GIR_Coverage, 8926,
     /* 418954 */   GIR_Done,
     /* 418955 */ // Label 8810: @418955
     /* 418955 */ GIM_Reject,
     /* 418956 */ // Label 8776: @418956
     /* 418956 */ GIM_Reject,
     /* 418957 */ // Label 154: @418957
     /* 418957 */ GIM_Reject,
     /* 418958 */ }; // Size: 418958 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
